
/*
 ***********************************************************************************************************************
 *
 *  Copyright (c) 2014-2018 Advanced Micro Devices, Inc. All Rights Reserved.
 *
 *  Permission is hereby granted, free of charge, to any person obtaining a copy
 *  of this software and associated documentation files (the "Software"), to deal
 *  in the Software without restriction, including without limitation the rights
 *  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 *  copies of the Software, and to permit persons to whom the Software is
 *  furnished to do so, subject to the following conditions:
 *
 *  The above copyright notice and this permission notice shall be included in all
 *  copies or substantial portions of the Software.
 *
 *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 *  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 *  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 *  SOFTWARE.
 *
 **********************************************************************************************************************/


// Do not edit this file by hand; generated via script from entry_points.txt

#ifndef __STRINGS_G_FUNC_TABLE_H__
#define __STRINGS_G_FUNC_TABLE_H__

#include "include/khronos/vulkan.h"
#include "include/khronos/vk_icd.h"

namespace vk
{

// This is a structure containing all known entry points in our driver. It is used to allow direct access to the
// function pointers from the dispatch table.
struct EntryPoints
{
    PFN_vkGetInstanceProcAddr vkGetInstanceProcAddr;
    PFN_vkGetDeviceProcAddr vkGetDeviceProcAddr;
    PFN_vkCreateInstance vkCreateInstance;
    PFN_vkEnumerateInstanceExtensionProperties vkEnumerateInstanceExtensionProperties;
    PFN_vkEnumerateInstanceLayerProperties vkEnumerateInstanceLayerProperties;
    PFN_vkEnumerateInstanceVersion vkEnumerateInstanceVersion;
#if VK_VERSION_1_0
    PFN_vkCreateDevice vkCreateDevice;
    PFN_vkDestroyInstance vkDestroyInstance;
    PFN_vkEnumerateDeviceExtensionProperties vkEnumerateDeviceExtensionProperties;
    PFN_vkEnumerateDeviceLayerProperties vkEnumerateDeviceLayerProperties;
    PFN_vkEnumeratePhysicalDevices vkEnumeratePhysicalDevices;
    PFN_vkGetPhysicalDeviceFeatures vkGetPhysicalDeviceFeatures;
    PFN_vkGetPhysicalDeviceFormatProperties vkGetPhysicalDeviceFormatProperties;
    PFN_vkGetPhysicalDeviceImageFormatProperties vkGetPhysicalDeviceImageFormatProperties;
    PFN_vkGetPhysicalDeviceMemoryProperties vkGetPhysicalDeviceMemoryProperties;
    PFN_vkGetPhysicalDeviceProperties vkGetPhysicalDeviceProperties;
    PFN_vkGetPhysicalDeviceQueueFamilyProperties vkGetPhysicalDeviceQueueFamilyProperties;
    PFN_vkGetPhysicalDeviceSparseImageFormatProperties vkGetPhysicalDeviceSparseImageFormatProperties;
    PFN_vkAllocateCommandBuffers vkAllocateCommandBuffers;
    PFN_vkAllocateDescriptorSets vkAllocateDescriptorSets;
    PFN_vkAllocateMemory vkAllocateMemory;
    PFN_vkBeginCommandBuffer vkBeginCommandBuffer;
    PFN_vkBindBufferMemory vkBindBufferMemory;
    PFN_vkBindImageMemory vkBindImageMemory;
    PFN_vkCmdBeginQuery vkCmdBeginQuery;
    PFN_vkCmdBeginRenderPass vkCmdBeginRenderPass;
    PFN_vkCmdBindDescriptorSets vkCmdBindDescriptorSets;
    PFN_vkCmdBindIndexBuffer vkCmdBindIndexBuffer;
    PFN_vkCmdBindPipeline vkCmdBindPipeline;
    PFN_vkCmdBindVertexBuffers vkCmdBindVertexBuffers;
    PFN_vkCmdBlitImage vkCmdBlitImage;
    PFN_vkCmdClearAttachments vkCmdClearAttachments;
    PFN_vkCmdClearColorImage vkCmdClearColorImage;
    PFN_vkCmdClearDepthStencilImage vkCmdClearDepthStencilImage;
    PFN_vkCmdCopyBuffer vkCmdCopyBuffer;
    PFN_vkCmdCopyBufferToImage vkCmdCopyBufferToImage;
    PFN_vkCmdCopyImage vkCmdCopyImage;
    PFN_vkCmdCopyImageToBuffer vkCmdCopyImageToBuffer;
    PFN_vkCmdCopyQueryPoolResults vkCmdCopyQueryPoolResults;
    PFN_vkCmdDispatch vkCmdDispatch;
    PFN_vkCmdDispatchIndirect vkCmdDispatchIndirect;
    PFN_vkCmdDraw vkCmdDraw;
    PFN_vkCmdDrawIndexed vkCmdDrawIndexed;
    PFN_vkCmdDrawIndexedIndirect vkCmdDrawIndexedIndirect;
    PFN_vkCmdDrawIndirect vkCmdDrawIndirect;
    PFN_vkCmdEndQuery vkCmdEndQuery;
    PFN_vkCmdEndRenderPass vkCmdEndRenderPass;
    PFN_vkCmdExecuteCommands vkCmdExecuteCommands;
    PFN_vkCmdFillBuffer vkCmdFillBuffer;
    PFN_vkCmdNextSubpass vkCmdNextSubpass;
    PFN_vkCmdPipelineBarrier vkCmdPipelineBarrier;
    PFN_vkCmdPushConstants vkCmdPushConstants;
    PFN_vkCmdResetEvent vkCmdResetEvent;
    PFN_vkCmdResetQueryPool vkCmdResetQueryPool;
    PFN_vkCmdResolveImage vkCmdResolveImage;
    PFN_vkCmdSetBlendConstants vkCmdSetBlendConstants;
    PFN_vkCmdSetDepthBias vkCmdSetDepthBias;
    PFN_vkCmdSetDepthBounds vkCmdSetDepthBounds;
    PFN_vkCmdSetEvent vkCmdSetEvent;
    PFN_vkCmdSetLineWidth vkCmdSetLineWidth;
    PFN_vkCmdSetScissor vkCmdSetScissor;
    PFN_vkCmdSetStencilCompareMask vkCmdSetStencilCompareMask;
    PFN_vkCmdSetStencilReference vkCmdSetStencilReference;
    PFN_vkCmdSetStencilWriteMask vkCmdSetStencilWriteMask;
    PFN_vkCmdSetViewport vkCmdSetViewport;
    PFN_vkCmdUpdateBuffer vkCmdUpdateBuffer;
    PFN_vkCmdWaitEvents vkCmdWaitEvents;
    PFN_vkCmdWriteTimestamp vkCmdWriteTimestamp;
    PFN_vkCreateBuffer vkCreateBuffer;
    PFN_vkCreateBufferView vkCreateBufferView;
    PFN_vkCreateCommandPool vkCreateCommandPool;
    PFN_vkCreateComputePipelines vkCreateComputePipelines;
    PFN_vkCreateDescriptorPool vkCreateDescriptorPool;
    PFN_vkCreateDescriptorSetLayout vkCreateDescriptorSetLayout;
    PFN_vkCreateEvent vkCreateEvent;
    PFN_vkCreateFence vkCreateFence;
    PFN_vkCreateFramebuffer vkCreateFramebuffer;
    PFN_vkCreateGraphicsPipelines vkCreateGraphicsPipelines;
    PFN_vkCreateImage vkCreateImage;
    PFN_vkCreateImageView vkCreateImageView;
    PFN_vkCreatePipelineCache vkCreatePipelineCache;
    PFN_vkCreatePipelineLayout vkCreatePipelineLayout;
    PFN_vkCreateQueryPool vkCreateQueryPool;
    PFN_vkCreateRenderPass vkCreateRenderPass;
    PFN_vkCreateSampler vkCreateSampler;
    PFN_vkCreateSemaphore vkCreateSemaphore;
    PFN_vkCreateShaderModule vkCreateShaderModule;
    PFN_vkDestroyBuffer vkDestroyBuffer;
    PFN_vkDestroyBufferView vkDestroyBufferView;
    PFN_vkDestroyCommandPool vkDestroyCommandPool;
    PFN_vkDestroyDescriptorPool vkDestroyDescriptorPool;
    PFN_vkDestroyDescriptorSetLayout vkDestroyDescriptorSetLayout;
    PFN_vkDestroyDevice vkDestroyDevice;
    PFN_vkDestroyEvent vkDestroyEvent;
    PFN_vkDestroyFence vkDestroyFence;
    PFN_vkDestroyFramebuffer vkDestroyFramebuffer;
    PFN_vkDestroyImage vkDestroyImage;
    PFN_vkDestroyImageView vkDestroyImageView;
    PFN_vkDestroyPipeline vkDestroyPipeline;
    PFN_vkDestroyPipelineCache vkDestroyPipelineCache;
    PFN_vkDestroyPipelineLayout vkDestroyPipelineLayout;
    PFN_vkDestroyQueryPool vkDestroyQueryPool;
    PFN_vkDestroyRenderPass vkDestroyRenderPass;
    PFN_vkDestroySampler vkDestroySampler;
    PFN_vkDestroySemaphore vkDestroySemaphore;
    PFN_vkDestroyShaderModule vkDestroyShaderModule;
    PFN_vkDeviceWaitIdle vkDeviceWaitIdle;
    PFN_vkEndCommandBuffer vkEndCommandBuffer;
    PFN_vkFlushMappedMemoryRanges vkFlushMappedMemoryRanges;
    PFN_vkFreeCommandBuffers vkFreeCommandBuffers;
    PFN_vkFreeDescriptorSets vkFreeDescriptorSets;
    PFN_vkFreeMemory vkFreeMemory;
    PFN_vkGetBufferMemoryRequirements vkGetBufferMemoryRequirements;
    PFN_vkGetDeviceMemoryCommitment vkGetDeviceMemoryCommitment;
    PFN_vkGetDeviceQueue vkGetDeviceQueue;
    PFN_vkGetEventStatus vkGetEventStatus;
    PFN_vkGetFenceStatus vkGetFenceStatus;
    PFN_vkGetImageMemoryRequirements vkGetImageMemoryRequirements;
    PFN_vkGetImageSparseMemoryRequirements vkGetImageSparseMemoryRequirements;
    PFN_vkGetImageSubresourceLayout vkGetImageSubresourceLayout;
    PFN_vkGetPipelineCacheData vkGetPipelineCacheData;
    PFN_vkGetQueryPoolResults vkGetQueryPoolResults;
    PFN_vkGetRenderAreaGranularity vkGetRenderAreaGranularity;
    PFN_vkInvalidateMappedMemoryRanges vkInvalidateMappedMemoryRanges;
    PFN_vkMapMemory vkMapMemory;
    PFN_vkMergePipelineCaches vkMergePipelineCaches;
    PFN_vkQueueBindSparse vkQueueBindSparse;
    PFN_vkQueueSubmit vkQueueSubmit;
    PFN_vkQueueWaitIdle vkQueueWaitIdle;
    PFN_vkResetCommandBuffer vkResetCommandBuffer;
    PFN_vkResetCommandPool vkResetCommandPool;
    PFN_vkResetDescriptorPool vkResetDescriptorPool;
    PFN_vkResetEvent vkResetEvent;
    PFN_vkResetFences vkResetFences;
    PFN_vkSetEvent vkSetEvent;
    PFN_vkUnmapMemory vkUnmapMemory;
    PFN_vkUpdateDescriptorSets vkUpdateDescriptorSets;
    PFN_vkWaitForFences vkWaitForFences;
#else
    PFN_vkVoidFunction reserved0;
    PFN_vkVoidFunction reserved1;
    PFN_vkVoidFunction reserved2;
    PFN_vkVoidFunction reserved3;
    PFN_vkVoidFunction reserved4;
    PFN_vkVoidFunction reserved5;
    PFN_vkVoidFunction reserved6;
    PFN_vkVoidFunction reserved7;
    PFN_vkVoidFunction reserved8;
    PFN_vkVoidFunction reserved9;
    PFN_vkVoidFunction reserved10;
    PFN_vkVoidFunction reserved11;
    PFN_vkVoidFunction reserved12;
    PFN_vkVoidFunction reserved13;
    PFN_vkVoidFunction reserved14;
    PFN_vkVoidFunction reserved15;
    PFN_vkVoidFunction reserved16;
    PFN_vkVoidFunction reserved17;
    PFN_vkVoidFunction reserved18;
    PFN_vkVoidFunction reserved19;
    PFN_vkVoidFunction reserved20;
    PFN_vkVoidFunction reserved21;
    PFN_vkVoidFunction reserved22;
    PFN_vkVoidFunction reserved23;
    PFN_vkVoidFunction reserved24;
    PFN_vkVoidFunction reserved25;
    PFN_vkVoidFunction reserved26;
    PFN_vkVoidFunction reserved27;
    PFN_vkVoidFunction reserved28;
    PFN_vkVoidFunction reserved29;
    PFN_vkVoidFunction reserved30;
    PFN_vkVoidFunction reserved31;
    PFN_vkVoidFunction reserved32;
    PFN_vkVoidFunction reserved33;
    PFN_vkVoidFunction reserved34;
    PFN_vkVoidFunction reserved35;
    PFN_vkVoidFunction reserved36;
    PFN_vkVoidFunction reserved37;
    PFN_vkVoidFunction reserved38;
    PFN_vkVoidFunction reserved39;
    PFN_vkVoidFunction reserved40;
    PFN_vkVoidFunction reserved41;
    PFN_vkVoidFunction reserved42;
    PFN_vkVoidFunction reserved43;
    PFN_vkVoidFunction reserved44;
    PFN_vkVoidFunction reserved45;
    PFN_vkVoidFunction reserved46;
    PFN_vkVoidFunction reserved47;
    PFN_vkVoidFunction reserved48;
    PFN_vkVoidFunction reserved49;
    PFN_vkVoidFunction reserved50;
    PFN_vkVoidFunction reserved51;
    PFN_vkVoidFunction reserved52;
    PFN_vkVoidFunction reserved53;
    PFN_vkVoidFunction reserved54;
    PFN_vkVoidFunction reserved55;
    PFN_vkVoidFunction reserved56;
    PFN_vkVoidFunction reserved57;
    PFN_vkVoidFunction reserved58;
    PFN_vkVoidFunction reserved59;
    PFN_vkVoidFunction reserved60;
    PFN_vkVoidFunction reserved61;
    PFN_vkVoidFunction reserved62;
    PFN_vkVoidFunction reserved63;
    PFN_vkVoidFunction reserved64;
    PFN_vkVoidFunction reserved65;
    PFN_vkVoidFunction reserved66;
    PFN_vkVoidFunction reserved67;
    PFN_vkVoidFunction reserved68;
    PFN_vkVoidFunction reserved69;
    PFN_vkVoidFunction reserved70;
    PFN_vkVoidFunction reserved71;
    PFN_vkVoidFunction reserved72;
    PFN_vkVoidFunction reserved73;
    PFN_vkVoidFunction reserved74;
    PFN_vkVoidFunction reserved75;
    PFN_vkVoidFunction reserved76;
    PFN_vkVoidFunction reserved77;
    PFN_vkVoidFunction reserved78;
    PFN_vkVoidFunction reserved79;
    PFN_vkVoidFunction reserved80;
    PFN_vkVoidFunction reserved81;
    PFN_vkVoidFunction reserved82;
    PFN_vkVoidFunction reserved83;
    PFN_vkVoidFunction reserved84;
    PFN_vkVoidFunction reserved85;
    PFN_vkVoidFunction reserved86;
    PFN_vkVoidFunction reserved87;
    PFN_vkVoidFunction reserved88;
    PFN_vkVoidFunction reserved89;
    PFN_vkVoidFunction reserved90;
    PFN_vkVoidFunction reserved91;
    PFN_vkVoidFunction reserved92;
    PFN_vkVoidFunction reserved93;
    PFN_vkVoidFunction reserved94;
    PFN_vkVoidFunction reserved95;
    PFN_vkVoidFunction reserved96;
    PFN_vkVoidFunction reserved97;
    PFN_vkVoidFunction reserved98;
    PFN_vkVoidFunction reserved99;
    PFN_vkVoidFunction reserved100;
    PFN_vkVoidFunction reserved101;
    PFN_vkVoidFunction reserved102;
    PFN_vkVoidFunction reserved103;
    PFN_vkVoidFunction reserved104;
    PFN_vkVoidFunction reserved105;
    PFN_vkVoidFunction reserved106;
    PFN_vkVoidFunction reserved107;
    PFN_vkVoidFunction reserved108;
    PFN_vkVoidFunction reserved109;
    PFN_vkVoidFunction reserved110;
    PFN_vkVoidFunction reserved111;
    PFN_vkVoidFunction reserved112;
    PFN_vkVoidFunction reserved113;
    PFN_vkVoidFunction reserved114;
    PFN_vkVoidFunction reserved115;
    PFN_vkVoidFunction reserved116;
    PFN_vkVoidFunction reserved117;
    PFN_vkVoidFunction reserved118;
    PFN_vkVoidFunction reserved119;
    PFN_vkVoidFunction reserved120;
    PFN_vkVoidFunction reserved121;
    PFN_vkVoidFunction reserved122;
    PFN_vkVoidFunction reserved123;
    PFN_vkVoidFunction reserved124;
    PFN_vkVoidFunction reserved125;
    PFN_vkVoidFunction reserved126;
    PFN_vkVoidFunction reserved127;
    PFN_vkVoidFunction reserved128;
    PFN_vkVoidFunction reserved129;
    PFN_vkVoidFunction reserved130;
    PFN_vkVoidFunction reserved131;
#endif
#if VK_VERSION_1_1
    PFN_vkEnumeratePhysicalDeviceGroups vkEnumeratePhysicalDeviceGroups;
    PFN_vkGetPhysicalDeviceExternalBufferProperties vkGetPhysicalDeviceExternalBufferProperties;
    PFN_vkGetPhysicalDeviceExternalFenceProperties vkGetPhysicalDeviceExternalFenceProperties;
    PFN_vkGetPhysicalDeviceExternalSemaphoreProperties vkGetPhysicalDeviceExternalSemaphoreProperties;
    PFN_vkGetPhysicalDeviceFeatures2 vkGetPhysicalDeviceFeatures2;
    PFN_vkGetPhysicalDeviceFormatProperties2 vkGetPhysicalDeviceFormatProperties2;
    PFN_vkGetPhysicalDeviceImageFormatProperties2 vkGetPhysicalDeviceImageFormatProperties2;
    PFN_vkGetPhysicalDeviceMemoryProperties2 vkGetPhysicalDeviceMemoryProperties2;
    PFN_vkGetPhysicalDeviceProperties2 vkGetPhysicalDeviceProperties2;
    PFN_vkGetPhysicalDeviceQueueFamilyProperties2 vkGetPhysicalDeviceQueueFamilyProperties2;
    PFN_vkGetPhysicalDeviceSparseImageFormatProperties2 vkGetPhysicalDeviceSparseImageFormatProperties2;
    PFN_vkBindBufferMemory2 vkBindBufferMemory2;
    PFN_vkBindImageMemory2 vkBindImageMemory2;
    PFN_vkCmdDispatchBase vkCmdDispatchBase;
    PFN_vkCmdSetDeviceMask vkCmdSetDeviceMask;
    PFN_vkCreateDescriptorUpdateTemplate vkCreateDescriptorUpdateTemplate;
    PFN_vkCreateSamplerYcbcrConversion vkCreateSamplerYcbcrConversion;
    PFN_vkDestroyDescriptorUpdateTemplate vkDestroyDescriptorUpdateTemplate;
    PFN_vkDestroySamplerYcbcrConversion vkDestroySamplerYcbcrConversion;
    PFN_vkGetBufferMemoryRequirements2 vkGetBufferMemoryRequirements2;
    PFN_vkGetDescriptorSetLayoutSupport vkGetDescriptorSetLayoutSupport;
    PFN_vkGetDeviceGroupPeerMemoryFeatures vkGetDeviceGroupPeerMemoryFeatures;
    PFN_vkGetDeviceQueue2 vkGetDeviceQueue2;
    PFN_vkGetImageMemoryRequirements2 vkGetImageMemoryRequirements2;
    PFN_vkGetImageSparseMemoryRequirements2 vkGetImageSparseMemoryRequirements2;
    PFN_vkTrimCommandPool vkTrimCommandPool;
    PFN_vkUpdateDescriptorSetWithTemplate vkUpdateDescriptorSetWithTemplate;
#else
    PFN_vkVoidFunction reserved132;
    PFN_vkVoidFunction reserved133;
    PFN_vkVoidFunction reserved134;
    PFN_vkVoidFunction reserved135;
    PFN_vkVoidFunction reserved136;
    PFN_vkVoidFunction reserved137;
    PFN_vkVoidFunction reserved138;
    PFN_vkVoidFunction reserved139;
    PFN_vkVoidFunction reserved140;
    PFN_vkVoidFunction reserved141;
    PFN_vkVoidFunction reserved142;
    PFN_vkVoidFunction reserved143;
    PFN_vkVoidFunction reserved144;
    PFN_vkVoidFunction reserved145;
    PFN_vkVoidFunction reserved146;
    PFN_vkVoidFunction reserved147;
    PFN_vkVoidFunction reserved148;
    PFN_vkVoidFunction reserved149;
    PFN_vkVoidFunction reserved150;
    PFN_vkVoidFunction reserved151;
    PFN_vkVoidFunction reserved152;
    PFN_vkVoidFunction reserved153;
    PFN_vkVoidFunction reserved154;
    PFN_vkVoidFunction reserved155;
    PFN_vkVoidFunction reserved156;
    PFN_vkVoidFunction reserved157;
    PFN_vkVoidFunction reserved158;
#endif
#if VK_KHR_device_group_creation
    PFN_vkEnumeratePhysicalDeviceGroupsKHR vkEnumeratePhysicalDeviceGroupsKHR;
#else
    PFN_vkVoidFunction reserved159;
#endif
#if VK_KHR_device_group
    PFN_vkGetDeviceGroupPeerMemoryFeaturesKHR vkGetDeviceGroupPeerMemoryFeaturesKHR;
    PFN_vkCmdSetDeviceMaskKHR vkCmdSetDeviceMaskKHR;
    PFN_vkCmdDispatchBaseKHR vkCmdDispatchBaseKHR;
#else
    PFN_vkVoidFunction reserved160;
    PFN_vkVoidFunction reserved161;
    PFN_vkVoidFunction reserved162;
#endif
#if VK_KHR_swapchain && (VK_VERSION_1_1 || VK_KHR_device_group)
    PFN_vkGetPhysicalDevicePresentRectanglesKHR vkGetPhysicalDevicePresentRectanglesKHR;
    PFN_vkGetDeviceGroupPresentCapabilitiesKHR vkGetDeviceGroupPresentCapabilitiesKHR;
    PFN_vkGetDeviceGroupSurfacePresentModesKHR vkGetDeviceGroupSurfacePresentModesKHR;
    PFN_vkAcquireNextImage2KHR vkAcquireNextImage2KHR;
#else
    PFN_vkVoidFunction reserved163;
    PFN_vkVoidFunction reserved164;
    PFN_vkVoidFunction reserved165;
    PFN_vkVoidFunction reserved166;
#endif
#if VK_KHR_bind_memory2
    PFN_vkBindBufferMemory2KHR vkBindBufferMemory2KHR;
    PFN_vkBindImageMemory2KHR vkBindImageMemory2KHR;
#else
    PFN_vkVoidFunction reserved167;
    PFN_vkVoidFunction reserved168;
#endif
#if VK_KHR_descriptor_update_template
    PFN_vkCreateDescriptorUpdateTemplateKHR vkCreateDescriptorUpdateTemplateKHR;
    PFN_vkDestroyDescriptorUpdateTemplateKHR vkDestroyDescriptorUpdateTemplateKHR;
    PFN_vkUpdateDescriptorSetWithTemplateKHR vkUpdateDescriptorSetWithTemplateKHR;
#else
    PFN_vkVoidFunction reserved169;
    PFN_vkVoidFunction reserved170;
    PFN_vkVoidFunction reserved171;
#endif
#if VK_KHR_external_memory_capabilities
    PFN_vkGetPhysicalDeviceExternalBufferPropertiesKHR vkGetPhysicalDeviceExternalBufferPropertiesKHR;
#else
    PFN_vkVoidFunction reserved172;
#endif
#if VK_KHR_external_memory_fd
    PFN_vkGetMemoryFdPropertiesKHR vkGetMemoryFdPropertiesKHR;
    PFN_vkGetMemoryFdKHR vkGetMemoryFdKHR;
#else
    PFN_vkVoidFunction reserved173;
    PFN_vkVoidFunction reserved174;
#endif
#if VK_KHR_external_semaphore_capabilities
    PFN_vkGetPhysicalDeviceExternalSemaphorePropertiesKHR vkGetPhysicalDeviceExternalSemaphorePropertiesKHR;
#else
    PFN_vkVoidFunction reserved175;
#endif
#if VK_KHR_external_semaphore_fd
    PFN_vkImportSemaphoreFdKHR vkImportSemaphoreFdKHR;
    PFN_vkGetSemaphoreFdKHR vkGetSemaphoreFdKHR;
#else
    PFN_vkVoidFunction reserved176;
    PFN_vkVoidFunction reserved177;
#endif
#if VK_KHR_maintenance1
    PFN_vkTrimCommandPoolKHR vkTrimCommandPoolKHR;
#else
    PFN_vkVoidFunction reserved178;
#endif
#if VK_KHR_maintenance3
    PFN_vkGetDescriptorSetLayoutSupportKHR vkGetDescriptorSetLayoutSupportKHR;
#else
    PFN_vkVoidFunction reserved179;
#endif
#if VK_KHR_surface
    PFN_vkDestroySurfaceKHR vkDestroySurfaceKHR;
    PFN_vkGetPhysicalDeviceSurfaceCapabilitiesKHR vkGetPhysicalDeviceSurfaceCapabilitiesKHR;
    PFN_vkGetPhysicalDeviceSurfaceFormatsKHR vkGetPhysicalDeviceSurfaceFormatsKHR;
    PFN_vkGetPhysicalDeviceSurfacePresentModesKHR vkGetPhysicalDeviceSurfacePresentModesKHR;
    PFN_vkGetPhysicalDeviceSurfaceSupportKHR vkGetPhysicalDeviceSurfaceSupportKHR;
#else
    PFN_vkVoidFunction reserved180;
    PFN_vkVoidFunction reserved181;
    PFN_vkVoidFunction reserved182;
    PFN_vkVoidFunction reserved183;
    PFN_vkVoidFunction reserved184;
#endif
#if VK_KHR_get_surface_capabilities2
    PFN_vkGetPhysicalDeviceSurfaceCapabilities2KHR vkGetPhysicalDeviceSurfaceCapabilities2KHR;
    PFN_vkGetPhysicalDeviceSurfaceFormats2KHR vkGetPhysicalDeviceSurfaceFormats2KHR;
#else
    PFN_vkVoidFunction reserved185;
    PFN_vkVoidFunction reserved186;
#endif
#if VK_KHR_xcb_surface
    PFN_vkCreateXcbSurfaceKHR vkCreateXcbSurfaceKHR;
    PFN_vkGetPhysicalDeviceXcbPresentationSupportKHR vkGetPhysicalDeviceXcbPresentationSupportKHR;
#else
    PFN_vkVoidFunction reserved187;
    PFN_vkVoidFunction reserved188;
#endif
#if VK_KHR_xlib_surface
    PFN_vkCreateXlibSurfaceKHR vkCreateXlibSurfaceKHR;
    PFN_vkGetPhysicalDeviceXlibPresentationSupportKHR vkGetPhysicalDeviceXlibPresentationSupportKHR;
#else
    PFN_vkVoidFunction reserved189;
    PFN_vkVoidFunction reserved190;
#endif
#if VK_KHR_wayland_surface
    PFN_vkCreateWaylandSurfaceKHR vkCreateWaylandSurfaceKHR;
    PFN_vkGetPhysicalDeviceWaylandPresentationSupportKHR vkGetPhysicalDeviceWaylandPresentationSupportKHR;
#else
    PFN_vkVoidFunction reserved191;
    PFN_vkVoidFunction reserved192;
#endif
#if VK_KHR_swapchain
    PFN_vkAcquireNextImageKHR vkAcquireNextImageKHR;
    PFN_vkCreateSwapchainKHR vkCreateSwapchainKHR;
    PFN_vkDestroySwapchainKHR vkDestroySwapchainKHR;
    PFN_vkGetSwapchainImagesKHR vkGetSwapchainImagesKHR;
    PFN_vkQueuePresentKHR vkQueuePresentKHR;
#else
    PFN_vkVoidFunction reserved193;
    PFN_vkVoidFunction reserved194;
    PFN_vkVoidFunction reserved195;
    PFN_vkVoidFunction reserved196;
    PFN_vkVoidFunction reserved197;
#endif
#if VK_AMD_draw_indirect_count
    PFN_vkCmdDrawIndexedIndirectCountAMD vkCmdDrawIndexedIndirectCountAMD;
    PFN_vkCmdDrawIndirectCountAMD vkCmdDrawIndirectCountAMD;
#else
    PFN_vkVoidFunction reserved198;
    PFN_vkVoidFunction reserved199;
#endif
#if VK_KHR_draw_indirect_count
    PFN_vkCmdDrawIndirectCountKHR vkCmdDrawIndirectCountKHR;
    PFN_vkCmdDrawIndexedIndirectCountKHR vkCmdDrawIndexedIndirectCountKHR;
#else
    PFN_vkVoidFunction reserved200;
    PFN_vkVoidFunction reserved201;
#endif
#if VK_AMD_shader_info
    PFN_vkGetShaderInfoAMD vkGetShaderInfoAMD;
#else
    PFN_vkVoidFunction reserved202;
#endif
#if VK_EXT_debug_marker
    PFN_vkCmdDebugMarkerBeginEXT vkCmdDebugMarkerBeginEXT;
    PFN_vkCmdDebugMarkerEndEXT vkCmdDebugMarkerEndEXT;
    PFN_vkCmdDebugMarkerInsertEXT vkCmdDebugMarkerInsertEXT;
    PFN_vkDebugMarkerSetObjectTagEXT vkDebugMarkerSetObjectTagEXT;
    PFN_vkDebugMarkerSetObjectNameEXT vkDebugMarkerSetObjectNameEXT;
#else
    PFN_vkVoidFunction reserved203;
    PFN_vkVoidFunction reserved204;
    PFN_vkVoidFunction reserved205;
    PFN_vkVoidFunction reserved206;
    PFN_vkVoidFunction reserved207;
#endif
#if VK_AMD_gpa_interface
    PFN_vkCreateGpaSessionAMD vkCreateGpaSessionAMD;
    PFN_vkDestroyGpaSessionAMD vkDestroyGpaSessionAMD;
    PFN_vkSetGpaDeviceClockModeAMD vkSetGpaDeviceClockModeAMD;
    PFN_vkCmdBeginGpaSessionAMD vkCmdBeginGpaSessionAMD;
    PFN_vkCmdEndGpaSessionAMD vkCmdEndGpaSessionAMD;
    PFN_vkCmdBeginGpaSampleAMD vkCmdBeginGpaSampleAMD;
    PFN_vkCmdEndGpaSampleAMD vkCmdEndGpaSampleAMD;
    PFN_vkGetGpaSessionStatusAMD vkGetGpaSessionStatusAMD;
    PFN_vkGetGpaSessionResultsAMD vkGetGpaSessionResultsAMD;
    PFN_vkResetGpaSessionAMD vkResetGpaSessionAMD;
    PFN_vkCmdCopyGpaSessionResultsAMD vkCmdCopyGpaSessionResultsAMD;
#else
    PFN_vkVoidFunction reserved208;
    PFN_vkVoidFunction reserved209;
    PFN_vkVoidFunction reserved210;
    PFN_vkVoidFunction reserved211;
    PFN_vkVoidFunction reserved212;
    PFN_vkVoidFunction reserved213;
    PFN_vkVoidFunction reserved214;
    PFN_vkVoidFunction reserved215;
    PFN_vkVoidFunction reserved216;
    PFN_vkVoidFunction reserved217;
    PFN_vkVoidFunction reserved218;
#endif
#if VK_KHR_get_memory_requirements2
    PFN_vkGetImageMemoryRequirements2KHR vkGetImageMemoryRequirements2KHR;
    PFN_vkGetBufferMemoryRequirements2KHR vkGetBufferMemoryRequirements2KHR;
    PFN_vkGetImageSparseMemoryRequirements2KHR vkGetImageSparseMemoryRequirements2KHR;
#else
    PFN_vkVoidFunction reserved219;
    PFN_vkVoidFunction reserved220;
    PFN_vkVoidFunction reserved221;
#endif
#if VK_EXT_sample_locations
    PFN_vkCmdSetSampleLocationsEXT vkCmdSetSampleLocationsEXT;
    PFN_vkGetPhysicalDeviceMultisamplePropertiesEXT vkGetPhysicalDeviceMultisamplePropertiesEXT;
#else
    PFN_vkVoidFunction reserved222;
    PFN_vkVoidFunction reserved223;
#endif
#if VK_KHR_external_fence_capabilities
    PFN_vkGetPhysicalDeviceExternalFencePropertiesKHR vkGetPhysicalDeviceExternalFencePropertiesKHR;
#else
    PFN_vkVoidFunction reserved224;
#endif
#if VK_KHR_external_fence_fd
    PFN_vkImportFenceFdKHR vkImportFenceFdKHR;
    PFN_vkGetFenceFdKHR vkGetFenceFdKHR;
#else
    PFN_vkVoidFunction reserved225;
    PFN_vkVoidFunction reserved226;
#endif
#if VK_AMD_buffer_marker
    PFN_vkCmdWriteBufferMarkerAMD vkCmdWriteBufferMarkerAMD;
#else
    PFN_vkVoidFunction reserved227;
#endif
#if VK_EXT_debug_report
    PFN_vkCreateDebugReportCallbackEXT vkCreateDebugReportCallbackEXT;
    PFN_vkDestroyDebugReportCallbackEXT vkDestroyDebugReportCallbackEXT;
    PFN_vkDebugReportMessageEXT vkDebugReportMessageEXT;
#else
    PFN_vkVoidFunction reserved228;
    PFN_vkVoidFunction reserved229;
    PFN_vkVoidFunction reserved230;
#endif
#if VK_EXT_external_memory_host
    PFN_vkGetMemoryHostPointerPropertiesEXT vkGetMemoryHostPointerPropertiesEXT;
#else
    PFN_vkVoidFunction reserved231;
#endif
#if VK_KHR_display
    PFN_vkGetPhysicalDeviceDisplayPropertiesKHR vkGetPhysicalDeviceDisplayPropertiesKHR;
    PFN_vkGetPhysicalDeviceDisplayPlanePropertiesKHR vkGetPhysicalDeviceDisplayPlanePropertiesKHR;
    PFN_vkGetDisplayPlaneSupportedDisplaysKHR vkGetDisplayPlaneSupportedDisplaysKHR;
    PFN_vkGetDisplayModePropertiesKHR vkGetDisplayModePropertiesKHR;
    PFN_vkCreateDisplayModeKHR vkCreateDisplayModeKHR;
    PFN_vkGetDisplayPlaneCapabilitiesKHR vkGetDisplayPlaneCapabilitiesKHR;
    PFN_vkCreateDisplayPlaneSurfaceKHR vkCreateDisplayPlaneSurfaceKHR;
#else
    PFN_vkVoidFunction reserved232;
    PFN_vkVoidFunction reserved233;
    PFN_vkVoidFunction reserved234;
    PFN_vkVoidFunction reserved235;
    PFN_vkVoidFunction reserved236;
    PFN_vkVoidFunction reserved237;
    PFN_vkVoidFunction reserved238;
#endif
#if VK_KHR_get_physical_device_properties2
    PFN_vkGetPhysicalDeviceFeatures2KHR vkGetPhysicalDeviceFeatures2KHR;
    PFN_vkGetPhysicalDeviceProperties2KHR vkGetPhysicalDeviceProperties2KHR;
    PFN_vkGetPhysicalDeviceFormatProperties2KHR vkGetPhysicalDeviceFormatProperties2KHR;
    PFN_vkGetPhysicalDeviceImageFormatProperties2KHR vkGetPhysicalDeviceImageFormatProperties2KHR;
    PFN_vkGetPhysicalDeviceQueueFamilyProperties2KHR vkGetPhysicalDeviceQueueFamilyProperties2KHR;
    PFN_vkGetPhysicalDeviceMemoryProperties2KHR vkGetPhysicalDeviceMemoryProperties2KHR;
    PFN_vkGetPhysicalDeviceSparseImageFormatProperties2KHR vkGetPhysicalDeviceSparseImageFormatProperties2KHR;
#else
    PFN_vkVoidFunction reserved239;
    PFN_vkVoidFunction reserved240;
    PFN_vkVoidFunction reserved241;
    PFN_vkVoidFunction reserved242;
    PFN_vkVoidFunction reserved243;
    PFN_vkVoidFunction reserved244;
    PFN_vkVoidFunction reserved245;
#endif
#if VK_EXT_direct_mode_display
    PFN_vkReleaseDisplayEXT vkReleaseDisplayEXT;
#else
    PFN_vkVoidFunction reserved246;
#endif
#if VK_EXT_acquire_xlib_display
    PFN_vkAcquireXlibDisplayEXT vkAcquireXlibDisplayEXT;
    PFN_vkGetRandROutputDisplayEXT vkGetRandROutputDisplayEXT;
#else
    PFN_vkVoidFunction reserved247;
    PFN_vkVoidFunction reserved248;
#endif
#if VK_KHR_get_display_properties2
    PFN_vkGetPhysicalDeviceDisplayProperties2KHR vkGetPhysicalDeviceDisplayProperties2KHR;
    PFN_vkGetPhysicalDeviceDisplayPlaneProperties2KHR vkGetPhysicalDeviceDisplayPlaneProperties2KHR;
    PFN_vkGetDisplayModeProperties2KHR vkGetDisplayModeProperties2KHR;
    PFN_vkGetDisplayPlaneCapabilities2KHR vkGetDisplayPlaneCapabilities2KHR;
#else
    PFN_vkVoidFunction reserved249;
    PFN_vkVoidFunction reserved250;
    PFN_vkVoidFunction reserved251;
    PFN_vkVoidFunction reserved252;
#endif
#if VK_KHR_create_renderpass2
    PFN_vkCreateRenderPass2KHR vkCreateRenderPass2KHR;
    PFN_vkCmdBeginRenderPass2KHR vkCmdBeginRenderPass2KHR;
    PFN_vkCmdNextSubpass2KHR vkCmdNextSubpass2KHR;
    PFN_vkCmdEndRenderPass2KHR vkCmdEndRenderPass2KHR;
#else
    PFN_vkVoidFunction reserved253;
    PFN_vkVoidFunction reserved254;
    PFN_vkVoidFunction reserved255;
    PFN_vkVoidFunction reserved256;
#endif
#if VK_EXT_debug_utils
    PFN_vkSetDebugUtilsObjectNameEXT vkSetDebugUtilsObjectNameEXT;
    PFN_vkSetDebugUtilsObjectTagEXT vkSetDebugUtilsObjectTagEXT;
    PFN_vkQueueBeginDebugUtilsLabelEXT vkQueueBeginDebugUtilsLabelEXT;
    PFN_vkQueueEndDebugUtilsLabelEXT vkQueueEndDebugUtilsLabelEXT;
    PFN_vkQueueInsertDebugUtilsLabelEXT vkQueueInsertDebugUtilsLabelEXT;
    PFN_vkCmdBeginDebugUtilsLabelEXT vkCmdBeginDebugUtilsLabelEXT;
    PFN_vkCmdEndDebugUtilsLabelEXT vkCmdEndDebugUtilsLabelEXT;
    PFN_vkCmdInsertDebugUtilsLabelEXT vkCmdInsertDebugUtilsLabelEXT;
    PFN_vkCreateDebugUtilsMessengerEXT vkCreateDebugUtilsMessengerEXT;
    PFN_vkDestroyDebugUtilsMessengerEXT vkDestroyDebugUtilsMessengerEXT;
    PFN_vkSubmitDebugUtilsMessageEXT vkSubmitDebugUtilsMessageEXT;
#else
    PFN_vkVoidFunction reserved257;
    PFN_vkVoidFunction reserved258;
    PFN_vkVoidFunction reserved259;
    PFN_vkVoidFunction reserved260;
    PFN_vkVoidFunction reserved261;
    PFN_vkVoidFunction reserved262;
    PFN_vkVoidFunction reserved263;
    PFN_vkVoidFunction reserved264;
    PFN_vkVoidFunction reserved265;
    PFN_vkVoidFunction reserved266;
    PFN_vkVoidFunction reserved267;
#endif
#if VK_EXT_display_surface_counter
    PFN_vkGetPhysicalDeviceSurfaceCapabilities2EXT vkGetPhysicalDeviceSurfaceCapabilities2EXT;
#else
    PFN_vkVoidFunction reserved268;
#endif
#if VK_EXT_transform_feedback
    PFN_vkCmdBindTransformFeedbackBuffersEXT vkCmdBindTransformFeedbackBuffersEXT;
    PFN_vkCmdBeginTransformFeedbackEXT vkCmdBeginTransformFeedbackEXT;
    PFN_vkCmdEndTransformFeedbackEXT vkCmdEndTransformFeedbackEXT;
    PFN_vkCmdBeginQueryIndexedEXT vkCmdBeginQueryIndexedEXT;
    PFN_vkCmdEndQueryIndexedEXT vkCmdEndQueryIndexedEXT;
    PFN_vkCmdDrawIndirectByteCountEXT vkCmdDrawIndirectByteCountEXT;
#else
    PFN_vkVoidFunction reserved269;
    PFN_vkVoidFunction reserved270;
    PFN_vkVoidFunction reserved271;
    PFN_vkVoidFunction reserved272;
    PFN_vkVoidFunction reserved273;
    PFN_vkVoidFunction reserved274;
#endif
#if VK_EXT_host_query_reset
    PFN_vkResetQueryPoolEXT vkResetQueryPoolEXT;
#else
    PFN_vkVoidFunction reserved275;
#endif
#if VK_EXT_buffer_device_address
    PFN_vkGetBufferDeviceAddressEXT vkGetBufferDeviceAddressEXT;
#else
    PFN_vkVoidFunction reserved276;
#endif
#if VK_EXT_hdr_metadata
    PFN_vkSetHdrMetadataEXT vkSetHdrMetadataEXT;
#else
    PFN_vkVoidFunction reserved277;
#endif
#if VK_EXT_calibrated_timestamps
    PFN_vkGetPhysicalDeviceCalibrateableTimeDomainsEXT vkGetPhysicalDeviceCalibrateableTimeDomainsEXT;
    PFN_vkGetCalibratedTimestampsEXT vkGetCalibratedTimestampsEXT;
#else
    PFN_vkVoidFunction reserved278;
    PFN_vkVoidFunction reserved279;
#endif
#if VK_KHR_pipeline_executable_properties
    PFN_vkGetPipelineExecutablePropertiesKHR vkGetPipelineExecutablePropertiesKHR;
    PFN_vkGetPipelineExecutableStatisticsKHR vkGetPipelineExecutableStatisticsKHR;
    PFN_vkGetPipelineExecutableInternalRepresentationsKHR vkGetPipelineExecutableInternalRepresentationsKHR;
#else
    PFN_vkVoidFunction reserved280;
    PFN_vkVoidFunction reserved281;
    PFN_vkVoidFunction reserved282;
#endif
#if VK_EXT_line_rasterization
    PFN_vkCmdSetLineStippleEXT vkCmdSetLineStippleEXT;
#else
    PFN_vkVoidFunction reserved283;
#endif
#if VK_KHR_timeline_semaphore
    PFN_vkGetSemaphoreCounterValueKHR vkGetSemaphoreCounterValueKHR;
    PFN_vkWaitSemaphoresKHR vkWaitSemaphoresKHR;
    PFN_vkSignalSemaphoreKHR vkSignalSemaphoreKHR;
#else
    PFN_vkVoidFunction reserved284;
    PFN_vkVoidFunction reserved285;
    PFN_vkVoidFunction reserved286;
#endif

};

};

#endif
