/*
 ***********************************************************************************************************************
 *
 *  Copyright (c) 2018-2019 Advanced Micro Devices, Inc. All Rights Reserved.
 *
 *  Permission is hereby granted, free of charge, to any person obtaining a copy
 *  of this software and associated documentation files (the "Software"), to deal
 *  in the Software without restriction, including without limitation the rights
 *  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 *  copies of the Software, and to permit persons to whom the Software is
 *  furnished to do so, subject to the following conditions:
 *
 *  The above copyright notice and this permission notice shall be included in all
 *  copies or substantial portions of the Software.
 *
 *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 *  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 *  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 *  SOFTWARE.
 *
 **********************************************************************************************************************/
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// WARNING!  WARNING!  WARNING!  WARNING!  WARNING!  WARNING!  WARNING!  WARNING!  WARNING!  WARNING!  WARNING!
//
// This code has been generated automatically. Do not hand-modify this code.
//
// When changes are needed, modify the tools generating this module in the tools\generate directory OR settings_xgl.json
//
// WARNING!  WARNING!  WARNING!  WARNING!  WARNING!  WARNING!  WARNING!  WARNING!  WARNING!  WARNING!  WARNING!
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "settings.h"
#include "palDevice.h"
#include "g_settings.h"
#include "palInlineFuncs.h"
#include "palHashMapImpl.h"

#include "devDriverServer.h"
#include "protocols/ddSettingsService.h"

using namespace DevDriver::SettingsURIService;


namespace vk
{

// =====================================================================================================================
// Initializes the settings structure to default values.
void VulkanSettingsLoader::SetupDefaults()
{
    // set setting variables to their default values...
    m_settings.renderPassNewEnable = true;
    m_settings.renderPassLogEnable = false;
#if defined(_WIN32)
    memset(m_settings.renderPassLogDirectory, 0, 512);
    strncpy(m_settings.renderPassLogDirectory, "VulkanRenderPasses\\", 512);
#elif (__unix__)
    memset(m_settings.renderPassLogDirectory, 0, 512);
    strncpy(m_settings.renderPassLogDirectory, "amdpal/", 512);
#endif
    m_settings.renderPassLogFlags = 0xffffffff;
    m_settings.renderPassForceWaitIdle = false;
    m_settings.renderPassForceCacheInputCoher = 0;
    m_settings.renderPassForceCacheOutputCoher = 0;
    m_settings.renderPassAsyncEventEnable = false;
    m_settings.cmdBufGpuEventMinAllocCount = 128;
    m_settings.useSharedCmdAllocator = true;
    m_settings.cmdAllocatorDataHeap = Pal::GpuHeapGartCacheable;
    m_settings.cmdAllocatorDataAllocSize = 2097152;
    m_settings.cmdAllocatorDataSubAllocSize = 65536;
    m_settings.cmdAllocatorEmbeddedHeap = Pal::GpuHeapGartUswc;
    m_settings.cmdAllocatorEmbeddedAllocSize = 0x20000;
    m_settings.cmdAllocatorEmbeddedSubAllocSize = 0x4000;
    m_settings.cmdAllocatorScratchHeap = Pal::GpuHeapInvisible;
    m_settings.cmdAllocatorScratchAllocSize = 0x20000;
    m_settings.cmdAllocatorScratchSubAllocSize = 0x4000;
    m_settings.pipelineLinkTimeOptMode = PipelineLinkTimeOptApiControlled;
    m_settings.pipelineFastCompileMode = PipelineFastCompileApiControlled;
    m_settings.pipelineBinningMode = PipelineBinningModeDefault;
    m_settings.pipelineUseProfileHashAsClientHash = false;
    m_settings.pipelineUseShaderHashAsProfileHash = false;
    memset(m_settings.pipelineProfileRuntimeFile, 0, 512);
    strncpy(m_settings.pipelineProfileRuntimeFile, "", 512);
    m_settings.pipelineProfileDbgPrintProfileMatch = false;
    m_settings.pipelineProfileIgnoresAppProfile = false;
    m_settings.pipelineProfileHaltOnParseFailure = false;
    m_settings.disableEmbedConstArrays = false;
    m_settings.enableUmdFramePacer = true;
    m_settings.enableFrtc = false;
    m_settings.enableTurboSync = false;
    m_settings.fullScreenFrameMetadataSupport = true;
    m_settings.useSdmaCompositingBlt = true;
    m_settings.enableMailboxPresentMode = false;
    m_settings.enableAcquireBeforeSignal = false;
    m_settings.ignoreSuboptimalSwapchainSize = false;
    m_settings.enablePipelineDump = false;
#if defined(_WIN32)
    memset(m_settings.pipelineDumpDir, 0, 256);
    strncpy(m_settings.pipelineDumpDir, "SpvPipeline", 256);
#elif (__unix__)
    memset(m_settings.pipelineDumpDir, 0, 256);
    strncpy(m_settings.pipelineDumpDir, "spvPipeline", 256);
#endif
    m_settings.enableLog = 0;
    memset(m_settings.logFileName, 0, 256);
    strncpy(m_settings.logFileName, "spvLogInfo", 256);
    m_settings.enableDebug = false;
    memset(m_settings.debugLogFileName, 0, 256);
    strncpy(m_settings.debugLogFileName, "debugLogInfo.txt", 256);
    m_settings.shaderReplaceMode = ShaderReplaceDisable;
#if defined(_WIN32)
    memset(m_settings.shaderReplaceDir, 0, 256);
    strncpy(m_settings.shaderReplaceDir, "ShaderReplace", 256);
#elif (__unix__)
    memset(m_settings.shaderReplaceDir, 0, 256);
    strncpy(m_settings.shaderReplaceDir, "ShaderReplace", 256);
#endif
    memset(m_settings.shaderReplacePipelineHashes, 0, 512);
    strncpy(m_settings.shaderReplacePipelineHashes, "", 512);
    m_settings.enableDropPipelineBinaryInst = false;
    m_settings.subgroupSize = 0;
    m_settings.vsWaveSize = 0;
    m_settings.tcsWaveSize = 0;
    m_settings.tesWaveSize = 0;
    m_settings.gsWaveSize = 0;
    m_settings.fsWaveSize = 0;
    m_settings.csWaveSize = 0;
    m_settings.enableNgg = 0xffffffff;
    m_settings.nggEnableGsUse = false;
    m_settings.nggForceNonPassthrough = false;
    m_settings.nggCompactionMode = NggCompactVertices;
    m_settings.nggAlwaysUsePrimShaderTable = true;
    m_settings.nggBackfaceExponent = 0;
    m_settings.nggSubgroupSizing = NggSubgroupAuto;
    m_settings.nggPrimsPerSubgroup = 256;
    m_settings.nggVertsPerSubgroup = 256;
    m_settings.nggEnableBackfaceCulling = false;
    m_settings.nggEnableFrustumCulling = false;
    m_settings.nggEnableBoxFilterCulling = false;
    m_settings.nggEnableSphereCulling = false;
    m_settings.nggEnableSmallPrimFilter = false;
    m_settings.nggEnableCullDistanceCulling = false;
    m_settings.enableForwardProgress = 0x0;
    m_settings.enableWgpMode = 0x0;
    m_settings.waveBreakSize = 0xf;
    m_settings.dropPipelineBinaryInstToken = 0;
    m_settings.dropPipelineBinaryInstSize = 1;
    m_settings.enableSpvPerfOptimal = false;
    m_settings.enableSpvValidation = false;
    m_settings.zeroInitIlRegs = false;
    m_settings.skipUnsupportedOpCode = false;
    m_settings.vsIrMode = 0;
    m_settings.tcsIrMode = 0;
    m_settings.tesIrMode = 0;
    m_settings.gsIrMode = 0;
    m_settings.fsIrMode = 0;
    m_settings.csIrMode = 0;
    memset(m_settings.llpcOptions, 0, 256);
    strncpy(m_settings.llpcOptions, "", 256);
    m_settings.shaderCacheMode = ShaderCacheEnableRuntimeOnly;
    m_settings.dropPipelineBinaryInstMask = 0xffffffff;
#if defined(_WIN32)
    m_settings.usePalPipelineCaching = true;
#elif (__unix__)
    m_settings.usePalPipelineCaching = false;
#endif
    m_settings.allowExternalPipelineCacheObject = true;
    memset(m_settings.pipelineCachingEnvironmentVariable, 0, 256);
    strncpy(m_settings.pipelineCachingEnvironmentVariable, "AMD_VK_USE_PIPELINE_CACHE", 256);
    m_settings.usePipelineCachingDefaultLocation = true;
#if defined(_WIN32)
    memset(m_settings.pipelineCachingDefaultLocation, 0, 256);
    strncpy(m_settings.pipelineCachingDefaultLocation, "\\AMD\\VkCache\\", 256);
#elif (__unix__)
    memset(m_settings.pipelineCachingDefaultLocation, 0, 256);
    strncpy(m_settings.pipelineCachingDefaultLocation, "/AMD/VkCache/", 256);
#endif
    m_settings.markPipelineCacheWithBuildTimestamp = true;
    m_settings.filterPipelineDumpByType = PipelineDumpFilterNone;
    m_settings.filterPipelineDumpByHash = 0x0;
    m_settings.dumpDuplicatePipelines = false;
    m_settings.dbgBarrierPostCmdEnable = 0x0;
    m_settings.dbgBarrierPostWaitPipePoint = 0x0;
    m_settings.dbgBarrierPostSignalPipePoint = 0x0;
    m_settings.dbgBarrierPostCacheSrcMask = 0x0;
    m_settings.dbgBarrierPostCacheDstMask = 0x0;
    m_settings.dbgBarrierPreCmdEnable = 0;
    m_settings.dbgBarrierPreWaitPipePoint = 0;
    m_settings.dbgBarrierPreSignalPipePoint = 0;
    m_settings.dbgBarrierPreCacheSrcMask = 0;
    m_settings.dbgBarrierPreCacheDstMask = 0;
    m_settings.vbTableInstanceRingSize = 1024;
    m_settings.resourceBarrierOptions = 35328;
    m_settings.barrierFilterOptions = 0x0;
    memset(m_settings.barrierFilterProfileFile, 0, 512);
    strncpy(m_settings.barrierFilterProfileFile, "", 512);
    m_settings.excessivePipelineCacheCountThreshold = 256;
    m_settings.enumPreferredDeviceIndex = 4294967295;
    m_settings.robustBufferAccess = FeatureDefault;
    m_settings.lenientInstanceFuncQuery = false;
    memset(m_settings.appProfileDumpDir, 0, 512);
    strncpy(m_settings.appProfileDumpDir, "", 512);
    m_settings.optEnablePrt = true;
    m_settings.asyncComputeQueueMaxWavesPerCu = 0;
    m_settings.asyncComputeQueueLimit = 0xffffffff;
    m_settings.limitSampleCounts = 0xffffffff;
    m_settings.memoryCustomDeviceAllocationCountLimit = 0;
    m_settings.memoryBaseAddrAlignment = 524288;
    m_settings.memoryBaseAddrAlignmentCpuVisibleWin32 = 131072;
    m_settings.memoryRemoteBackupHeapMinHeapSize = 0x1e0000000;
    m_settings.memoryAttachmentImageMemoryTypeMinHeapSize = 0xffffffffffffffff;
    m_settings.memoryPriorityDefault = 0x30;
    m_settings.memoryPriorityImageAny = 0x30;
    m_settings.memoryPriorityImageShaderRead = 0x30;
    m_settings.memoryPriorityImageShaderWrite = 0x30;
    m_settings.memoryPriorityImageColorTarget = 0x40;
    m_settings.memoryPriorityImageDepthStencil = 0x40;
    m_settings.heapBudgetRatioOfHeapSizeLocal = 95;
    m_settings.heapBudgetRatioOfHeapSizeInvisible = 95;
    m_settings.heapBudgetRatioOfHeapSizeNonlocal = 95;
    m_settings.isSparseUnmapBeforeDestroyEnabled = true;
    m_settings.transferGranularityUniversalOverride = 0x0;
    m_settings.transferGranularityComputeOverride = 0x0;
    m_settings.memoryDeviceOverallocationAllowed = false;
    m_settings.memoryDeviceOverallocationNonOverridable = false;
    m_settings.transferGranularityDmaOverride = 0x0;
    m_settings.forceAppProfileEnable = false;
    m_settings.forceAppProfileValue = 0;
    m_settings.preciseAnisoMode = DisablePreciseAnisoAfOnly;
    m_settings.useAnisoThreshold = false;
    m_settings.anisoThreshold = 0.25;
    m_settings.useFlipHint = false;
    m_settings.backgroundFullscreenPresent = 0x3ff;
    m_settings.backgroundFullscreenFailureDisableCount = 2;
    m_settings.backgroundFullscreenSuccessResetCount = 64;
    m_settings.backgroundFullscreenIgnorePresentErrors = false;
    m_settings.imageTilingOptMode = Pal::TilingOptMode::Balanced;
    m_settings.imageTilingPreference = Pal::ImageTilingPattern::Default;
    m_settings.enableFmaskBasedMsaaRead = true;
    m_settings.enableHighPriorityDescriptorMemory = false;
    m_settings.disableHtileBasedMsaaRead = false;
    m_settings.disableMsaaStencilShaderRead = false;
    m_settings.optImgMaskToApplyShaderReadUsageForTransferSrc = 0;
    m_settings.optImgMaskToApplyShaderWriteUsageForTransferDst = 0;
    m_settings.optOnlyEnableFP16ForGfx9Plus = true;
    m_settings.optColorTargetUsageDoesNotContainResolveLayout = false;
    m_settings.optRenderStateCacheEnable = 0xffffffff;
    m_settings.ignoreMutableFlag = false;
    m_settings.optimizeCmdbufMode = DisableOptimizeCmdbuf;
    m_settings.prefetchShaders = false;
    m_settings.dccBitsPerPixelThreshold = 4294967295;
    m_settings.forceDccForColorAttachments = false;
    m_settings.disableSmallSurfColorCompressionSize = 128;
    m_settings.enableGpuEventMultiSlot = false;
    m_settings.useAcqRelInterface = false;
    m_settings.enableSPP = true;
    m_settings.enableMlModelForWaveSize = false;
    m_settings.enableAsyncCompile = false;
    m_settings.disableSkipFceOptimization = false;
    m_settings.devModePipelineUriServicePostSizeLimit = 256;
    m_settings.devModeElfReplacementDirectoryEnable = false;
#if defined(_WIN32)
    memset(m_settings.devModeElfReplacementDirectory, 0, 512);
    strncpy(m_settings.devModeElfReplacementDirectory, "PipelineReplace", 512);
#elif (__unix__)
    memset(m_settings.devModeElfReplacementDirectory, 0, 512);
    strncpy(m_settings.devModeElfReplacementDirectory, "PipelineReplace", 512);
#endif
    m_settings.devModeShaderIsaDbEnable = true;
    m_settings.devModeQueueTimingEnable = true;
    m_settings.devModeSemaphoreQueueTimingEnable = true;
    m_settings.devModeSqttMarkerEnable = 0x16f;
    m_settings.devModeSqttForceDisable = false;
    m_settings.devModeSqttWaitIdle = false;
    m_settings.devModeSqttFlushAllQueues = true;
    m_settings.devModeSqttGpuMemoryLimit = 0;
    m_settings.devModeSqttFrameCount = 1;
    memset(m_settings.devModeSqttInternalUserEventPrefix, 0, 512);
    strncpy(m_settings.devModeSqttInternalUserEventPrefix, "[AMD] ", 512);
    m_settings.devModeSqttTraceBeginEndTagEnable = false;
    m_settings.devModeSqttTraceBeginTagValue = 0;
    m_settings.devModeSqttTraceEndTagValue = 0x0;
    m_settings.devModeSqttInstructionTraceEnable = false;
    m_settings.devModeSqttTargetApiPsoHash = 0;
    m_settings.devModeSqttForceBlockOnTraceEnd = false;
    m_settings.devModeSqttPrepareFrameCount = 4294967295;
    m_settings.overrideShaderParams = false;
    m_settings.overrideShaderHashUpper = 0x0;
    m_settings.overrideShaderHashLower = 0x0;
    m_settings.overrideShaderStage = 4;
    m_settings.overrideNumVGPRsAvailable = 0;
    m_settings.overrideWavesPerCu = 0;
    m_settings.overrideUserDataSpillThreshold = false;
    m_settings.overrideMaxLdsSpillDwords = 0;
    m_settings.overrideCsTgPerCu = 0;
    m_settings.overrideUsePbbPerCrc = PipelineBinningModeDefault;
    m_settings.overrideAllowReZ = false;
    m_settings.overrideWaveSize = WaveSizeAuto;
    m_settings.overrideWgpMode = WgpModeAuto;
    m_settings.overrideDisableLoopUnrolls = false;
    m_settings.overrideUseSiScheduler = false;
    m_settings.overrideReconfigWorkgroupLayout = false;
    m_settings.resourceProfileIgnoresAppProfile = false;
    m_settings.overrideResourceParams = false;
    m_settings.overrideResourceHashDimensions = 0x0;
    m_settings.overrideResourceHashCrc = 0x0;
    m_settings.overrideResourceDccOnOff = DccDefaultMode;
    m_settings.vulkanTexFilterQuality = TextureFilterOptimizationsEnabled;
    m_settings.appGpuID = 0;
    m_settings.numSettings = g_vulkanNumSettings;
}

// =====================================================================================================================
// Reads the setting from the OS adapter and sets the structure value when the setting values are found.
void VulkanSettingsLoader::ReadSettings()
{
    // read from the OS adapter for each individual setting
    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pRenderPassNewEnableStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.renderPassNewEnable);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pRenderPassLogEnableStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.renderPassLogEnable);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pRenderPassLogDirectoryStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Str,
                           &m_settings.renderPassLogDirectory,
                           512);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pRenderPassLogFlagsStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.renderPassLogFlags);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pRenderPassForceWaitIdleStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.renderPassForceWaitIdle);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pRenderPassForceCacheInputCoherStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.renderPassForceCacheInputCoher);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pRenderPassForceCacheOutputCoherStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.renderPassForceCacheOutputCoher);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pRenderPassAsyncEventEnableStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.renderPassAsyncEventEnable);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pCmdBufGpuEventMinAllocCountStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.cmdBufGpuEventMinAllocCount);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pUseSharedCmdAllocatorStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.useSharedCmdAllocator);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pCmdAllocatorDataHeapStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.cmdAllocatorDataHeap);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pCmdAllocatorDataAllocSizeStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.cmdAllocatorDataAllocSize);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pCmdAllocatorDataSubAllocSizeStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.cmdAllocatorDataSubAllocSize);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pCmdAllocatorEmbeddedHeapStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.cmdAllocatorEmbeddedHeap);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pCmdAllocatorEmbeddedAllocSizeStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.cmdAllocatorEmbeddedAllocSize);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pCmdAllocatorEmbeddedSubAllocSizeStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.cmdAllocatorEmbeddedSubAllocSize);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pCmdAllocatorScratchHeapStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.cmdAllocatorScratchHeap);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pCmdAllocatorScratchAllocSizeStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.cmdAllocatorScratchAllocSize);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pCmdAllocatorScratchSubAllocSizeStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.cmdAllocatorScratchSubAllocSize);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pPipelineLinkTimeOptModeStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.pipelineLinkTimeOptMode);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pPipelineFastCompileModeStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.pipelineFastCompileMode);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pPipelineBinningModeStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.pipelineBinningMode);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pPipelineUseProfileHashAsClientHashStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.pipelineUseProfileHashAsClientHash);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pPipelineUseShaderHashAsProfileHashStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.pipelineUseShaderHashAsProfileHash);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pPipelineProfileRuntimeFileStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Str,
                           &m_settings.pipelineProfileRuntimeFile,
                           512);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pPipelineProfileDbgPrintProfileMatchStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.pipelineProfileDbgPrintProfileMatch);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pPipelineProfileIgnoresAppProfileStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.pipelineProfileIgnoresAppProfile);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pPipelineProfileHaltOnParseFailureStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.pipelineProfileHaltOnParseFailure);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pDisableEmbedConstArraysStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.disableEmbedConstArrays);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pUmdFramePacerControlStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.enableUmdFramePacer);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pEnableFRTCStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.enableFrtc);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pEnableTurboSyncStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.enableTurboSync);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pFullscreenFrameMetadataSupportStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.fullScreenFrameMetadataSupport);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pUseSdmaCompositingBltStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.useSdmaCompositingBlt);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pEnableMailboxPresentModeStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.enableMailboxPresentMode);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pEnableAcquireBeforeSignalStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.enableAcquireBeforeSignal);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pIgnoreSuboptimalSwapchainSizeStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.ignoreSuboptimalSwapchainSize);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pEnablePipelineDumpStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.enablePipelineDump);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pPipelineDumpDirStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Str,
                           &m_settings.pipelineDumpDir,
                           256);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pEnableLogStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.enableLog);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pLogFileNameStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Str,
                           &m_settings.logFileName,
                           256);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pEnableDebugStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.enableDebug);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pDebugLogFileNameStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Str,
                           &m_settings.debugLogFileName,
                           256);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pShaderReplaceModeStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.shaderReplaceMode);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pShaderReplaceDirStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Str,
                           &m_settings.shaderReplaceDir,
                           256);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pShaderReplacePipelineHashesStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Str,
                           &m_settings.shaderReplacePipelineHashes,
                           512);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pEnableDropPipelineBinaryInstStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.enableDropPipelineBinaryInst);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pSubgroupSizeStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.subgroupSize);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pVsWaveSizeStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.vsWaveSize);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pTcsWaveSizeStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.tcsWaveSize);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pTesWaveSizeStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.tesWaveSize);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pGsWaveSizeStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.gsWaveSize);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pFsWaveSizeStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.fsWaveSize);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pCsWaveSizeStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.csWaveSize);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pEnableNggStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.enableNgg);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pNggEnableGsUseStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.nggEnableGsUse);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pNggForceNonPassthroughStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.nggForceNonPassthrough);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pNggCompactionModeStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.nggCompactionMode);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pNggAlwaysUsePrimShaderTableStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.nggAlwaysUsePrimShaderTable);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pNggBackfaceExponentStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.nggBackfaceExponent);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pNggSubgroupSizingStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.nggSubgroupSizing);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pNggPrimsPerSubgroupStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.nggPrimsPerSubgroup);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pNggVertsPerSubgroupStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.nggVertsPerSubgroup);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pNggEnableBackfaceCullingStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.nggEnableBackfaceCulling);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pNggEnableFrustumCullingStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.nggEnableFrustumCulling);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pNggEnableBoxFilterCullingStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.nggEnableBoxFilterCulling);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pNggEnableSphereCullingStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.nggEnableSphereCulling);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pNggEnableSmallPrimFilterStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.nggEnableSmallPrimFilter);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pNggEnableCullDistanceCullingStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.nggEnableCullDistanceCulling);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pEnableForwardProgressStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.enableForwardProgress);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pEnableWgpModeStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.enableWgpMode);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pWaveBreakSizeStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.waveBreakSize);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pDropPipelineBinaryInstTokenStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.dropPipelineBinaryInstToken);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pDropPipelineBinaryInstSizeStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.dropPipelineBinaryInstSize);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pEnableSpvPerfOptimalStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.enableSpvPerfOptimal);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pEnableSpvValidationStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.enableSpvValidation);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pZeroInitILRegsStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.zeroInitIlRegs);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pSkipUnsupportedOpCodeStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.skipUnsupportedOpCode);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pVsIrModeStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.vsIrMode);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pTcsIrModeStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.tcsIrMode);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pTesIrModeStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.tesIrMode);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pGsIrModeStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.gsIrMode);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pFsIrModeStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.fsIrMode);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pCsIrModeStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.csIrMode);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pLlpcOptionsStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Str,
                           &m_settings.llpcOptions,
                           256);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pShaderCacheModeStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.shaderCacheMode);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pDropPipelineBinaryInstMaskStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.dropPipelineBinaryInstMask);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pAllowVkPipelineCachingToDiskStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.usePalPipelineCaching);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pAllowExternalPipelineCacheObjectStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.allowExternalPipelineCacheObject);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pPipelineCachingEnvironmentVariableStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Str,
                           &m_settings.pipelineCachingEnvironmentVariable,
                           256);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pUsePipelineCachingDefaultLocationStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.usePipelineCachingDefaultLocation);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pPipelineCachingDefaultLocationStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Str,
                           &m_settings.pipelineCachingDefaultLocation,
                           256);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pMarkPipelineCacheWithBuildTimestampStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.markPipelineCacheWithBuildTimestamp);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pFilterPipelineDumpByTypeStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.filterPipelineDumpByType);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pFilterPipelineDumpByHashStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint64,
                           &m_settings.filterPipelineDumpByHash);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pDumpDuplicatePipelinesStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.dumpDuplicatePipelines);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pDbgBarrierPostCmdEnableStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.dbgBarrierPostCmdEnable);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pDbgBarrierPostWaitPipePointStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.dbgBarrierPostWaitPipePoint);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pDbgBarrierPostSignalPipePointStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.dbgBarrierPostSignalPipePoint);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pDbgBarrierPostCacheSrcMaskStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.dbgBarrierPostCacheSrcMask);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pDbgBarrierPostCacheDstMaskStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.dbgBarrierPostCacheDstMask);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pDbgBarrierPreCmdEnableStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.dbgBarrierPreCmdEnable);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pDbgBarrierPreWaitPipePointStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.dbgBarrierPreWaitPipePoint);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pDbgBarrierPreSignalPipePointStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.dbgBarrierPreSignalPipePoint);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pDbgBarrierPreCacheSrcMaskStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.dbgBarrierPreCacheSrcMask);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pDbgBarrierPreCacheDstMaskStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.dbgBarrierPreCacheDstMask);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pVertexBufferTableInstanceRingSizeStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.vbTableInstanceRingSize);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pResourceBarrierOptionsStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.resourceBarrierOptions);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pBarrierFilterOptionsStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.barrierFilterOptions);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pBarrierFilterProfileFileStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Str,
                           &m_settings.barrierFilterProfileFile,
                           512);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pExcessivePipelineCacheCountThresholdStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.excessivePipelineCacheCountThreshold);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pEnumPreferredDeviceIndexStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.enumPreferredDeviceIndex);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pRobustBufferAccessStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.robustBufferAccess);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pLenientInstanceFuncQueryStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.lenientInstanceFuncQuery);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pAppProfileDumpDirStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Str,
                           &m_settings.appProfileDumpDir,
                           512);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pOptEnablePrtStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.optEnablePrt);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pAsyncComputeQueueMaxWavesPerCuStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.asyncComputeQueueMaxWavesPerCu);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pAsyncComputeQueueLimitStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.asyncComputeQueueLimit);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pLimitSampleCountsStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.limitSampleCounts);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pMemoryCustomDeviceAllocationCountLimitStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.memoryCustomDeviceAllocationCountLimit);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pMemoryBaseAddrAlignmentStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.memoryBaseAddrAlignment);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pMemoryBaseAddrAlignmentCpuVisibleWin32Str,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.memoryBaseAddrAlignmentCpuVisibleWin32);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pMemoryRemoteBackupHeapMinHeapSizeStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint64,
                           &m_settings.memoryRemoteBackupHeapMinHeapSize);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pMemoryAttachmentImageMemoryTypeMinHeapSizeStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint64,
                           &m_settings.memoryAttachmentImageMemoryTypeMinHeapSize);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pMemoryPriorityDefaultStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.memoryPriorityDefault);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pMemoryPriorityImageAnyStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.memoryPriorityImageAny);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pMemoryPriorityImageShaderReadStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.memoryPriorityImageShaderRead);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pMemoryPriorityImageShaderWriteStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.memoryPriorityImageShaderWrite);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pMemoryPriorityImageColorTargetStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.memoryPriorityImageColorTarget);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pMemoryPriorityImageDepthStencilStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.memoryPriorityImageDepthStencil);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pHeapBudgetRatioOfHeapSizeLocalStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.heapBudgetRatioOfHeapSizeLocal);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pHeapBudgetRatioOfHeapSizeInvisibleStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.heapBudgetRatioOfHeapSizeInvisible);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pHeapBudgetRatioOfHeapSizeNonlocalStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.heapBudgetRatioOfHeapSizeNonlocal);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pIsSparseUnmapBeforeDestroyEnabledStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.isSparseUnmapBeforeDestroyEnabled);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pTransferGranularityUniversalOverrideStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.transferGranularityUniversalOverride);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pTransferGranularityComputeOverrideStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.transferGranularityComputeOverride);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pMemoryDeviceOverallocationAllowedStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.memoryDeviceOverallocationAllowed);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pMemoryDeviceOverallocationNonOverridableStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.memoryDeviceOverallocationNonOverridable);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pTransferGranularityDmaOverrideStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.transferGranularityDmaOverride);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pForceAppProfileEnableStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.forceAppProfileEnable);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pForceAppProfileValueStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.forceAppProfileValue);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pPreciseAnisoModeStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.preciseAnisoMode);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pUseAnisoThresholdStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.useAnisoThreshold);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pAnisoThresholdStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Float,
                           &m_settings.anisoThreshold);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pUseFlipHintStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.useFlipHint);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pBackgroundFullscreenPresentStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.backgroundFullscreenPresent);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pBackgroundFullscreenFailureDisableCountStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.backgroundFullscreenFailureDisableCount);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pBackgroundFullscreenSuccessResetCountStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.backgroundFullscreenSuccessResetCount);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pBackgroundFullscreenIgnorePresentErrorsStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.backgroundFullscreenIgnorePresentErrors);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pImageTilingOptModeStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.imageTilingOptMode);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pImageTilingPreferenceStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.imageTilingPreference);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pEnableFmaskBasedMsaaReadStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.enableFmaskBasedMsaaRead);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pEnableHighPriorityDescriptorMemoryStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.enableHighPriorityDescriptorMemory);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pDisableHtileBasedMsaaReadStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.disableHtileBasedMsaaRead);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pDisableMsaaStencilShaderReadStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.disableMsaaStencilShaderRead);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pTransferSrcUsageAsShaderReadMaskStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.optImgMaskToApplyShaderReadUsageForTransferSrc);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pTransferDstUsageAsShaderWriteMaskStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.optImgMaskToApplyShaderWriteUsageForTransferDst);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pOnlyEnableFP16ForGfx9PlusStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.optOnlyEnableFP16ForGfx9Plus);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pColorTargetUsageDoesNotContainResolveLayoutStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.optColorTargetUsageDoesNotContainResolveLayout);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pRenderStateCacheEnableStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.optRenderStateCacheEnable);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pIgnoreMutableFlagStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.ignoreMutableFlag);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pOptimizeCmdbufModeStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.optimizeCmdbufMode);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pPrefetchShadersStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.prefetchShaders);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pDccBitsPerPixelThresholdStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.dccBitsPerPixelThreshold);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pForceDccForColorAttachmentsStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.forceDccForColorAttachments);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pDisableSmallSurfColorCompressionSizeStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.disableSmallSurfColorCompressionSize);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pEnableGpuEventMultiSlotStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.enableGpuEventMultiSlot);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pUseAcqRelInterfaceStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.useAcqRelInterface);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pEnableSPPStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.enableSPP);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pEnableMlModelForWaveSizeStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.enableMlModelForWaveSize);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pEnableAsyncCompileStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.enableAsyncCompile);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pDisableSkipFceOptimizationStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.disableSkipFceOptimization);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pDevModePipelineUriServicePostSizeLimitStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.devModePipelineUriServicePostSizeLimit);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pDevModeElfReplacementDirectoryEnableStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.devModeElfReplacementDirectoryEnable);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pDevModeElfReplacementDirectoryStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Str,
                           &m_settings.devModeElfReplacementDirectory,
                           512);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pDevModeShaderIsaDbEnableStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.devModeShaderIsaDbEnable);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pDevModeQueueTimingEnableStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.devModeQueueTimingEnable);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pDevModeSemaphoreQueueTimingEnableStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.devModeSemaphoreQueueTimingEnable);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pDevModeSqttMarkerEnableStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.devModeSqttMarkerEnable);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pDevModeSqttForceDisableStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.devModeSqttForceDisable);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pDevModeSqttWaitIdleStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.devModeSqttWaitIdle);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pDevModeSqttFlushAllQueuesStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.devModeSqttFlushAllQueues);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pDevModeSqttGpuMemoryLimitStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.devModeSqttGpuMemoryLimit);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pDevModeSqttFrameCountStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.devModeSqttFrameCount);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pDevModeSqttInternalUserEventPrefixStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Str,
                           &m_settings.devModeSqttInternalUserEventPrefix,
                           512);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pDevModeSqttTraceBeginEndTagEnableStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.devModeSqttTraceBeginEndTagEnable);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pDevModeSqttTraceBeginTagValueStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint64,
                           &m_settings.devModeSqttTraceBeginTagValue);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pDevModeSqttTraceEndTagValueStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint64,
                           &m_settings.devModeSqttTraceEndTagValue);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pDevModeSqttInstructionTraceEnableStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.devModeSqttInstructionTraceEnable);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pDevModeSqttTargetApiPsoHashStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint64,
                           &m_settings.devModeSqttTargetApiPsoHash);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pDevModeSqttForceBlockOnTraceEndStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.devModeSqttForceBlockOnTraceEnd);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pDevModeSqttPrepareFrameCountStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.devModeSqttPrepareFrameCount);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pOverrideShaderParamsStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.overrideShaderParams);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pOverrideShaderHashUpperStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint64,
                           &m_settings.overrideShaderHashUpper);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pOverrideShaderHashLowerStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint64,
                           &m_settings.overrideShaderHashLower);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pOverrideShaderStageStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.overrideShaderStage);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pOverrideNumVGPRsAvailableStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.overrideNumVGPRsAvailable);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pOverrideWavesPerCuStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.overrideWavesPerCu);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pOverrideUserDataSpillThresholdStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.overrideUserDataSpillThreshold);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pOverrideMaxLdsSpillDwordsStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.overrideMaxLdsSpillDwords);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pOverrideCsTgPerCuStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.overrideCsTgPerCu);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pOverrideUsePbbPerCrcStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.overrideUsePbbPerCrc);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pOverrideAllowReZStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.overrideAllowReZ);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pOverrideWaveSizeStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.overrideWaveSize);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pOverrideWgpModeStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.overrideWgpMode);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pOverrideDisableLoopUnrollsStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.overrideDisableLoopUnrolls);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pOverrideUseSiSchedulerStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.overrideUseSiScheduler);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pOverrideReconfigWorkgroupLayoutStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.overrideReconfigWorkgroupLayout);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pResourceProfileIgnoresAppProfileStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.resourceProfileIgnoresAppProfile);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pOverrideResourceParamsStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Boolean,
                           &m_settings.overrideResourceParams);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pOverrideResourceHashDimensionsStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint64,
                           &m_settings.overrideResourceHashDimensions);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pOverrideResourceHashCrcStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint64,
                           &m_settings.overrideResourceHashCrc);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pOverrideResourceDccOnOffStr,
                           Pal::SettingScope::Driver,
                           Util::ValueType::Uint,
                           &m_settings.overrideResourceDccOnOff);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pVulkanTexFilterQualityStr,
                           Pal::SettingScope::Global,
                           Util::ValueType::Uint,
                           &m_settings.vulkanTexFilterQuality);


    static_cast<Pal::IDevice*>(m_pDevice)->ReadSetting(pAppGpuIDStr,
                           Pal::SettingScope::Global,
                           Util::ValueType::Uint,
                           &m_settings.appGpuID);



}

// =====================================================================================================================
// Initializes the SettingInfo hash map and array of setting hashes.
void VulkanSettingsLoader::InitSettingsInfo()
{
    SettingInfo info = {};

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.renderPassNewEnable;
    info.valueSize = sizeof(m_settings.renderPassNewEnable);
    m_settingsInfoMap.Insert(2409736061, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.renderPassLogEnable;
    info.valueSize = sizeof(m_settings.renderPassLogEnable);
    m_settingsInfoMap.Insert(3847355121, info);

    info.type      = SettingType::String;
    info.pValuePtr = &m_settings.renderPassLogDirectory;
    info.valueSize = sizeof(m_settings.renderPassLogDirectory);
    m_settingsInfoMap.Insert(2308918241, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.renderPassLogFlags;
    info.valueSize = sizeof(m_settings.renderPassLogFlags);
    m_settingsInfoMap.Insert(2841546813, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.renderPassForceWaitIdle;
    info.valueSize = sizeof(m_settings.renderPassForceWaitIdle);
    m_settingsInfoMap.Insert(2692943068, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.renderPassForceCacheInputCoher;
    info.valueSize = sizeof(m_settings.renderPassForceCacheInputCoher);
    m_settingsInfoMap.Insert(3512803342, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.renderPassForceCacheOutputCoher;
    info.valueSize = sizeof(m_settings.renderPassForceCacheOutputCoher);
    m_settingsInfoMap.Insert(4070286939, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.renderPassAsyncEventEnable;
    info.valueSize = sizeof(m_settings.renderPassAsyncEventEnable);
    m_settingsInfoMap.Insert(3421157755, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.cmdBufGpuEventMinAllocCount;
    info.valueSize = sizeof(m_settings.cmdBufGpuEventMinAllocCount);
    m_settingsInfoMap.Insert(1373972514, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.useSharedCmdAllocator;
    info.valueSize = sizeof(m_settings.useSharedCmdAllocator);
    m_settingsInfoMap.Insert(2695722952, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.cmdAllocatorDataHeap;
    info.valueSize = sizeof(m_settings.cmdAllocatorDataHeap);
    m_settingsInfoMap.Insert(1832694714, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.cmdAllocatorDataAllocSize;
    info.valueSize = sizeof(m_settings.cmdAllocatorDataAllocSize);
    m_settingsInfoMap.Insert(2667761104, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.cmdAllocatorDataSubAllocSize;
    info.valueSize = sizeof(m_settings.cmdAllocatorDataSubAllocSize);
    m_settingsInfoMap.Insert(4089588998, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.cmdAllocatorEmbeddedHeap;
    info.valueSize = sizeof(m_settings.cmdAllocatorEmbeddedHeap);
    m_settingsInfoMap.Insert(46174540, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.cmdAllocatorEmbeddedAllocSize;
    info.valueSize = sizeof(m_settings.cmdAllocatorEmbeddedAllocSize);
    m_settingsInfoMap.Insert(4049945662, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.cmdAllocatorEmbeddedSubAllocSize;
    info.valueSize = sizeof(m_settings.cmdAllocatorEmbeddedSubAllocSize);
    m_settingsInfoMap.Insert(1513127512, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.cmdAllocatorScratchHeap;
    info.valueSize = sizeof(m_settings.cmdAllocatorScratchHeap);
    m_settingsInfoMap.Insert(4153516452, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.cmdAllocatorScratchAllocSize;
    info.valueSize = sizeof(m_settings.cmdAllocatorScratchAllocSize);
    m_settingsInfoMap.Insert(3574029062, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.cmdAllocatorScratchSubAllocSize;
    info.valueSize = sizeof(m_settings.cmdAllocatorScratchSubAllocSize);
    m_settingsInfoMap.Insert(3402444848, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.pipelineLinkTimeOptMode;
    info.valueSize = sizeof(m_settings.pipelineLinkTimeOptMode);
    m_settingsInfoMap.Insert(3606461208, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.pipelineFastCompileMode;
    info.valueSize = sizeof(m_settings.pipelineFastCompileMode);
    m_settingsInfoMap.Insert(601804157, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.pipelineBinningMode;
    info.valueSize = sizeof(m_settings.pipelineBinningMode);
    m_settingsInfoMap.Insert(1967427837, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.pipelineUseProfileHashAsClientHash;
    info.valueSize = sizeof(m_settings.pipelineUseProfileHashAsClientHash);
    m_settingsInfoMap.Insert(3384165644, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.pipelineUseShaderHashAsProfileHash;
    info.valueSize = sizeof(m_settings.pipelineUseShaderHashAsProfileHash);
    m_settingsInfoMap.Insert(390173032, info);

    info.type      = SettingType::String;
    info.pValuePtr = &m_settings.pipelineProfileRuntimeFile;
    info.valueSize = sizeof(m_settings.pipelineProfileRuntimeFile);
    m_settingsInfoMap.Insert(1286473046, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.pipelineProfileDbgPrintProfileMatch;
    info.valueSize = sizeof(m_settings.pipelineProfileDbgPrintProfileMatch);
    m_settingsInfoMap.Insert(3578410736, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.pipelineProfileIgnoresAppProfile;
    info.valueSize = sizeof(m_settings.pipelineProfileIgnoresAppProfile);
    m_settingsInfoMap.Insert(284988527, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.pipelineProfileHaltOnParseFailure;
    info.valueSize = sizeof(m_settings.pipelineProfileHaltOnParseFailure);
    m_settingsInfoMap.Insert(2803779161, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.disableEmbedConstArrays;
    info.valueSize = sizeof(m_settings.disableEmbedConstArrays);
    m_settingsInfoMap.Insert(3897517765, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.enableUmdFramePacer;
    info.valueSize = sizeof(m_settings.enableUmdFramePacer);
    m_settingsInfoMap.Insert(2149178358, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.enableFrtc;
    info.valueSize = sizeof(m_settings.enableFrtc);
    m_settingsInfoMap.Insert(3273760519, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.enableTurboSync;
    info.valueSize = sizeof(m_settings.enableTurboSync);
    m_settingsInfoMap.Insert(1034024081, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.fullScreenFrameMetadataSupport;
    info.valueSize = sizeof(m_settings.fullScreenFrameMetadataSupport);
    m_settingsInfoMap.Insert(3683287271, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.useSdmaCompositingBlt;
    info.valueSize = sizeof(m_settings.useSdmaCompositingBlt);
    m_settingsInfoMap.Insert(1167844307, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.enableMailboxPresentMode;
    info.valueSize = sizeof(m_settings.enableMailboxPresentMode);
    m_settingsInfoMap.Insert(1772474034, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.enableAcquireBeforeSignal;
    info.valueSize = sizeof(m_settings.enableAcquireBeforeSignal);
    m_settingsInfoMap.Insert(129319645, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.ignoreSuboptimalSwapchainSize;
    info.valueSize = sizeof(m_settings.ignoreSuboptimalSwapchainSize);
    m_settingsInfoMap.Insert(1182231700, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.enablePipelineDump;
    info.valueSize = sizeof(m_settings.enablePipelineDump);
    m_settingsInfoMap.Insert(809818814, info);

    info.type      = SettingType::String;
    info.pValuePtr = &m_settings.pipelineDumpDir;
    info.valueSize = sizeof(m_settings.pipelineDumpDir);
    m_settingsInfoMap.Insert(989712612, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.enableLog;
    info.valueSize = sizeof(m_settings.enableLog);
    m_settingsInfoMap.Insert(4062912068, info);

    info.type      = SettingType::String;
    info.pValuePtr = &m_settings.logFileName;
    info.valueSize = sizeof(m_settings.logFileName);
    m_settingsInfoMap.Insert(1494398452, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.enableDebug;
    info.valueSize = sizeof(m_settings.enableDebug);
    m_settingsInfoMap.Insert(4049167417, info);

    info.type      = SettingType::String;
    info.pValuePtr = &m_settings.debugLogFileName;
    info.valueSize = sizeof(m_settings.debugLogFileName);
    m_settingsInfoMap.Insert(2699235047, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.shaderReplaceMode;
    info.valueSize = sizeof(m_settings.shaderReplaceMode);
    m_settingsInfoMap.Insert(3527127795, info);

    info.type      = SettingType::String;
    info.pValuePtr = &m_settings.shaderReplaceDir;
    info.valueSize = sizeof(m_settings.shaderReplaceDir);
    m_settingsInfoMap.Insert(3308298423, info);

    info.type      = SettingType::String;
    info.pValuePtr = &m_settings.shaderReplacePipelineHashes;
    info.valueSize = sizeof(m_settings.shaderReplacePipelineHashes);
    m_settingsInfoMap.Insert(907814690, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.enableDropPipelineBinaryInst;
    info.valueSize = sizeof(m_settings.enableDropPipelineBinaryInst);
    m_settingsInfoMap.Insert(3273095844, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.subgroupSize;
    info.valueSize = sizeof(m_settings.subgroupSize);
    m_settingsInfoMap.Insert(1216748277, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.vsWaveSize;
    info.valueSize = sizeof(m_settings.vsWaveSize);
    m_settingsInfoMap.Insert(2875804878, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.tcsWaveSize;
    info.valueSize = sizeof(m_settings.tcsWaveSize);
    m_settingsInfoMap.Insert(1234081121, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.tesWaveSize;
    info.valueSize = sizeof(m_settings.tesWaveSize);
    m_settingsInfoMap.Insert(3072096235, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.gsWaveSize;
    info.valueSize = sizeof(m_settings.gsWaveSize);
    m_settingsInfoMap.Insert(105228583, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.fsWaveSize;
    info.valueSize = sizeof(m_settings.fsWaveSize);
    m_settingsInfoMap.Insert(818064926, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.csWaveSize;
    info.valueSize = sizeof(m_settings.csWaveSize);
    m_settingsInfoMap.Insert(267990155, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.enableNgg;
    info.valueSize = sizeof(m_settings.enableNgg);
    m_settingsInfoMap.Insert(109876678, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.nggEnableGsUse;
    info.valueSize = sizeof(m_settings.nggEnableGsUse);
    m_settingsInfoMap.Insert(2612258605, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.nggForceNonPassthrough;
    info.valueSize = sizeof(m_settings.nggForceNonPassthrough);
    m_settingsInfoMap.Insert(1453958321, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.nggCompactionMode;
    info.valueSize = sizeof(m_settings.nggCompactionMode);
    m_settingsInfoMap.Insert(3742782005, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.nggAlwaysUsePrimShaderTable;
    info.valueSize = sizeof(m_settings.nggAlwaysUsePrimShaderTable);
    m_settingsInfoMap.Insert(1338799096, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.nggBackfaceExponent;
    info.valueSize = sizeof(m_settings.nggBackfaceExponent);
    m_settingsInfoMap.Insert(3043623194, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.nggSubgroupSizing;
    info.valueSize = sizeof(m_settings.nggSubgroupSizing);
    m_settingsInfoMap.Insert(2391406036, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.nggPrimsPerSubgroup;
    info.valueSize = sizeof(m_settings.nggPrimsPerSubgroup);
    m_settingsInfoMap.Insert(958458130, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.nggVertsPerSubgroup;
    info.valueSize = sizeof(m_settings.nggVertsPerSubgroup);
    m_settingsInfoMap.Insert(2005944793, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.nggEnableBackfaceCulling;
    info.valueSize = sizeof(m_settings.nggEnableBackfaceCulling);
    m_settingsInfoMap.Insert(3428907318, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.nggEnableFrustumCulling;
    info.valueSize = sizeof(m_settings.nggEnableFrustumCulling);
    m_settingsInfoMap.Insert(1220820826, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.nggEnableBoxFilterCulling;
    info.valueSize = sizeof(m_settings.nggEnableBoxFilterCulling);
    m_settingsInfoMap.Insert(1523650329, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.nggEnableSphereCulling;
    info.valueSize = sizeof(m_settings.nggEnableSphereCulling);
    m_settingsInfoMap.Insert(1275673699, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.nggEnableSmallPrimFilter;
    info.valueSize = sizeof(m_settings.nggEnableSmallPrimFilter);
    m_settingsInfoMap.Insert(2076615117, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.nggEnableCullDistanceCulling;
    info.valueSize = sizeof(m_settings.nggEnableCullDistanceCulling);
    m_settingsInfoMap.Insert(1789457237, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.enableForwardProgress;
    info.valueSize = sizeof(m_settings.enableForwardProgress);
    m_settingsInfoMap.Insert(3285317740, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.enableWgpMode;
    info.valueSize = sizeof(m_settings.enableWgpMode);
    m_settingsInfoMap.Insert(3525874863, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.waveBreakSize;
    info.valueSize = sizeof(m_settings.waveBreakSize);
    m_settingsInfoMap.Insert(668198610, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.dropPipelineBinaryInstToken;
    info.valueSize = sizeof(m_settings.dropPipelineBinaryInstToken);
    m_settingsInfoMap.Insert(1682931540, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.dropPipelineBinaryInstSize;
    info.valueSize = sizeof(m_settings.dropPipelineBinaryInstSize);
    m_settingsInfoMap.Insert(3265600022, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.enableSpvPerfOptimal;
    info.valueSize = sizeof(m_settings.enableSpvPerfOptimal);
    m_settingsInfoMap.Insert(892928116, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.enableSpvValidation;
    info.valueSize = sizeof(m_settings.enableSpvValidation);
    m_settingsInfoMap.Insert(2156135806, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.zeroInitIlRegs;
    info.valueSize = sizeof(m_settings.zeroInitIlRegs);
    m_settingsInfoMap.Insert(23712203, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.skipUnsupportedOpCode;
    info.valueSize = sizeof(m_settings.skipUnsupportedOpCode);
    m_settingsInfoMap.Insert(1161817703, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.vsIrMode;
    info.valueSize = sizeof(m_settings.vsIrMode);
    m_settingsInfoMap.Insert(2814660322, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.tcsIrMode;
    info.valueSize = sizeof(m_settings.tcsIrMode);
    m_settingsInfoMap.Insert(2483461757, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.tesIrMode;
    info.valueSize = sizeof(m_settings.tesIrMode);
    m_settingsInfoMap.Insert(2121496471, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.gsIrMode;
    info.valueSize = sizeof(m_settings.gsIrMode);
    m_settingsInfoMap.Insert(3407113011, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.fsIrMode;
    info.valueSize = sizeof(m_settings.fsIrMode);
    m_settingsInfoMap.Insert(1270580946, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.csIrMode;
    info.valueSize = sizeof(m_settings.csIrMode);
    m_settingsInfoMap.Insert(4067611319, info);

    info.type      = SettingType::String;
    info.pValuePtr = &m_settings.llpcOptions;
    info.valueSize = sizeof(m_settings.llpcOptions);
    m_settingsInfoMap.Insert(3508213626, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.shaderCacheMode;
    info.valueSize = sizeof(m_settings.shaderCacheMode);
    m_settingsInfoMap.Insert(1113140201, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.dropPipelineBinaryInstMask;
    info.valueSize = sizeof(m_settings.dropPipelineBinaryInstMask);
    m_settingsInfoMap.Insert(4084890811, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.usePalPipelineCaching;
    info.valueSize = sizeof(m_settings.usePalPipelineCaching);
    m_settingsInfoMap.Insert(1692817184, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.allowExternalPipelineCacheObject;
    info.valueSize = sizeof(m_settings.allowExternalPipelineCacheObject);
    m_settingsInfoMap.Insert(2565610768, info);

    info.type      = SettingType::String;
    info.pValuePtr = &m_settings.pipelineCachingEnvironmentVariable;
    info.valueSize = sizeof(m_settings.pipelineCachingEnvironmentVariable);
    m_settingsInfoMap.Insert(812278617, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.usePipelineCachingDefaultLocation;
    info.valueSize = sizeof(m_settings.usePipelineCachingDefaultLocation);
    m_settingsInfoMap.Insert(823134843, info);

    info.type      = SettingType::String;
    info.pValuePtr = &m_settings.pipelineCachingDefaultLocation;
    info.valueSize = sizeof(m_settings.pipelineCachingDefaultLocation);
    m_settingsInfoMap.Insert(3551643726, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.markPipelineCacheWithBuildTimestamp;
    info.valueSize = sizeof(m_settings.markPipelineCacheWithBuildTimestamp);
    m_settingsInfoMap.Insert(2279843108, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.filterPipelineDumpByType;
    info.valueSize = sizeof(m_settings.filterPipelineDumpByType);
    m_settingsInfoMap.Insert(3474328038, info);

    info.type      = SettingType::Uint64;
    info.pValuePtr = &m_settings.filterPipelineDumpByHash;
    info.valueSize = sizeof(m_settings.filterPipelineDumpByHash);
    m_settingsInfoMap.Insert(579619034, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.dumpDuplicatePipelines;
    info.valueSize = sizeof(m_settings.dumpDuplicatePipelines);
    m_settingsInfoMap.Insert(785467391, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.dbgBarrierPostCmdEnable;
    info.valueSize = sizeof(m_settings.dbgBarrierPostCmdEnable);
    m_settingsInfoMap.Insert(2908457448, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.dbgBarrierPostWaitPipePoint;
    info.valueSize = sizeof(m_settings.dbgBarrierPostWaitPipePoint);
    m_settingsInfoMap.Insert(156027798, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.dbgBarrierPostSignalPipePoint;
    info.valueSize = sizeof(m_settings.dbgBarrierPostSignalPipePoint);
    m_settingsInfoMap.Insert(895128045, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.dbgBarrierPostCacheSrcMask;
    info.valueSize = sizeof(m_settings.dbgBarrierPostCacheSrcMask);
    m_settingsInfoMap.Insert(1320062177, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.dbgBarrierPostCacheDstMask;
    info.valueSize = sizeof(m_settings.dbgBarrierPostCacheDstMask);
    m_settingsInfoMap.Insert(1231285864, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.dbgBarrierPreCmdEnable;
    info.valueSize = sizeof(m_settings.dbgBarrierPreCmdEnable);
    m_settingsInfoMap.Insert(160975439, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.dbgBarrierPreWaitPipePoint;
    info.valueSize = sizeof(m_settings.dbgBarrierPreWaitPipePoint);
    m_settingsInfoMap.Insert(3910150193, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.dbgBarrierPreSignalPipePoint;
    info.valueSize = sizeof(m_settings.dbgBarrierPreSignalPipePoint);
    m_settingsInfoMap.Insert(2760693190, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.dbgBarrierPreCacheSrcMask;
    info.valueSize = sizeof(m_settings.dbgBarrierPreCacheSrcMask);
    m_settingsInfoMap.Insert(1891812632, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.dbgBarrierPreCacheDstMask;
    info.valueSize = sizeof(m_settings.dbgBarrierPreCacheDstMask);
    m_settingsInfoMap.Insert(139905033, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.vbTableInstanceRingSize;
    info.valueSize = sizeof(m_settings.vbTableInstanceRingSize);
    m_settingsInfoMap.Insert(3498376063, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.resourceBarrierOptions;
    info.valueSize = sizeof(m_settings.resourceBarrierOptions);
    m_settingsInfoMap.Insert(2348416782, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.barrierFilterOptions;
    info.valueSize = sizeof(m_settings.barrierFilterOptions);
    m_settingsInfoMap.Insert(3752069724, info);

    info.type      = SettingType::String;
    info.pValuePtr = &m_settings.barrierFilterProfileFile;
    info.valueSize = sizeof(m_settings.barrierFilterProfileFile);
    m_settingsInfoMap.Insert(595912577, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.excessivePipelineCacheCountThreshold;
    info.valueSize = sizeof(m_settings.excessivePipelineCacheCountThreshold);
    m_settingsInfoMap.Insert(3723860598, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.enumPreferredDeviceIndex;
    info.valueSize = sizeof(m_settings.enumPreferredDeviceIndex);
    m_settingsInfoMap.Insert(3963167097, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.robustBufferAccess;
    info.valueSize = sizeof(m_settings.robustBufferAccess);
    m_settingsInfoMap.Insert(3274333888, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.lenientInstanceFuncQuery;
    info.valueSize = sizeof(m_settings.lenientInstanceFuncQuery);
    m_settingsInfoMap.Insert(3810474515, info);

    info.type      = SettingType::String;
    info.pValuePtr = &m_settings.appProfileDumpDir;
    info.valueSize = sizeof(m_settings.appProfileDumpDir);
    m_settingsInfoMap.Insert(3218751138, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.optEnablePrt;
    info.valueSize = sizeof(m_settings.optEnablePrt);
    m_settingsInfoMap.Insert(4176537453, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.asyncComputeQueueMaxWavesPerCu;
    info.valueSize = sizeof(m_settings.asyncComputeQueueMaxWavesPerCu);
    m_settingsInfoMap.Insert(2974072278, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.asyncComputeQueueLimit;
    info.valueSize = sizeof(m_settings.asyncComputeQueueLimit);
    m_settingsInfoMap.Insert(1555805922, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.limitSampleCounts;
    info.valueSize = sizeof(m_settings.limitSampleCounts);
    m_settingsInfoMap.Insert(1858209418, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.memoryCustomDeviceAllocationCountLimit;
    info.valueSize = sizeof(m_settings.memoryCustomDeviceAllocationCountLimit);
    m_settingsInfoMap.Insert(2849969415, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.memoryBaseAddrAlignment;
    info.valueSize = sizeof(m_settings.memoryBaseAddrAlignment);
    m_settingsInfoMap.Insert(2939407841, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.memoryBaseAddrAlignmentCpuVisibleWin32;
    info.valueSize = sizeof(m_settings.memoryBaseAddrAlignmentCpuVisibleWin32);
    m_settingsInfoMap.Insert(210525960, info);

    info.type      = SettingType::Uint64;
    info.pValuePtr = &m_settings.memoryRemoteBackupHeapMinHeapSize;
    info.valueSize = sizeof(m_settings.memoryRemoteBackupHeapMinHeapSize);
    m_settingsInfoMap.Insert(102739955, info);

    info.type      = SettingType::Uint64;
    info.pValuePtr = &m_settings.memoryAttachmentImageMemoryTypeMinHeapSize;
    info.valueSize = sizeof(m_settings.memoryAttachmentImageMemoryTypeMinHeapSize);
    m_settingsInfoMap.Insert(551580142, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.memoryPriorityDefault;
    info.valueSize = sizeof(m_settings.memoryPriorityDefault);
    m_settingsInfoMap.Insert(289279007, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.memoryPriorityImageAny;
    info.valueSize = sizeof(m_settings.memoryPriorityImageAny);
    m_settingsInfoMap.Insert(2321168839, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.memoryPriorityImageShaderRead;
    info.valueSize = sizeof(m_settings.memoryPriorityImageShaderRead);
    m_settingsInfoMap.Insert(287215626, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.memoryPriorityImageShaderWrite;
    info.valueSize = sizeof(m_settings.memoryPriorityImageShaderWrite);
    m_settingsInfoMap.Insert(3076300173, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.memoryPriorityImageColorTarget;
    info.valueSize = sizeof(m_settings.memoryPriorityImageColorTarget);
    m_settingsInfoMap.Insert(2285511511, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.memoryPriorityImageDepthStencil;
    info.valueSize = sizeof(m_settings.memoryPriorityImageDepthStencil);
    m_settingsInfoMap.Insert(659226412, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.heapBudgetRatioOfHeapSizeLocal;
    info.valueSize = sizeof(m_settings.heapBudgetRatioOfHeapSizeLocal);
    m_settingsInfoMap.Insert(2165343898, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.heapBudgetRatioOfHeapSizeInvisible;
    info.valueSize = sizeof(m_settings.heapBudgetRatioOfHeapSizeInvisible);
    m_settingsInfoMap.Insert(2093136090, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.heapBudgetRatioOfHeapSizeNonlocal;
    info.valueSize = sizeof(m_settings.heapBudgetRatioOfHeapSizeNonlocal);
    m_settingsInfoMap.Insert(4014618225, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.isSparseUnmapBeforeDestroyEnabled;
    info.valueSize = sizeof(m_settings.isSparseUnmapBeforeDestroyEnabled);
    m_settingsInfoMap.Insert(2340216420, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.transferGranularityUniversalOverride;
    info.valueSize = sizeof(m_settings.transferGranularityUniversalOverride);
    m_settingsInfoMap.Insert(1823255859, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.transferGranularityComputeOverride;
    info.valueSize = sizeof(m_settings.transferGranularityComputeOverride);
    m_settingsInfoMap.Insert(335561107, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.memoryDeviceOverallocationAllowed;
    info.valueSize = sizeof(m_settings.memoryDeviceOverallocationAllowed);
    m_settingsInfoMap.Insert(3284038896, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.memoryDeviceOverallocationNonOverridable;
    info.valueSize = sizeof(m_settings.memoryDeviceOverallocationNonOverridable);
    m_settingsInfoMap.Insert(567133396, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.transferGranularityDmaOverride;
    info.valueSize = sizeof(m_settings.transferGranularityDmaOverride);
    m_settingsInfoMap.Insert(2375478640, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.forceAppProfileEnable;
    info.valueSize = sizeof(m_settings.forceAppProfileEnable);
    m_settingsInfoMap.Insert(3513042023, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.forceAppProfileValue;
    info.valueSize = sizeof(m_settings.forceAppProfileValue);
    m_settingsInfoMap.Insert(2974380825, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.preciseAnisoMode;
    info.valueSize = sizeof(m_settings.preciseAnisoMode);
    m_settingsInfoMap.Insert(3851989621, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.useAnisoThreshold;
    info.valueSize = sizeof(m_settings.useAnisoThreshold);
    m_settingsInfoMap.Insert(1273651387, info);

    info.type      = SettingType::Float;
    info.pValuePtr = &m_settings.anisoThreshold;
    info.valueSize = sizeof(m_settings.anisoThreshold);
    m_settingsInfoMap.Insert(3416866970, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.useFlipHint;
    info.valueSize = sizeof(m_settings.useFlipHint);
    m_settingsInfoMap.Insert(396475294, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.backgroundFullscreenPresent;
    info.valueSize = sizeof(m_settings.backgroundFullscreenPresent);
    m_settingsInfoMap.Insert(1298749675, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.backgroundFullscreenFailureDisableCount;
    info.valueSize = sizeof(m_settings.backgroundFullscreenFailureDisableCount);
    m_settingsInfoMap.Insert(3304542337, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.backgroundFullscreenSuccessResetCount;
    info.valueSize = sizeof(m_settings.backgroundFullscreenSuccessResetCount);
    m_settingsInfoMap.Insert(253450729, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.backgroundFullscreenIgnorePresentErrors;
    info.valueSize = sizeof(m_settings.backgroundFullscreenIgnorePresentErrors);
    m_settingsInfoMap.Insert(3561218782, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.imageTilingOptMode;
    info.valueSize = sizeof(m_settings.imageTilingOptMode);
    m_settingsInfoMap.Insert(356081981, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.imageTilingPreference;
    info.valueSize = sizeof(m_settings.imageTilingPreference);
    m_settingsInfoMap.Insert(2294620896, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.enableFmaskBasedMsaaRead;
    info.valueSize = sizeof(m_settings.enableFmaskBasedMsaaRead);
    m_settingsInfoMap.Insert(4238889853, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.enableHighPriorityDescriptorMemory;
    info.valueSize = sizeof(m_settings.enableHighPriorityDescriptorMemory);
    m_settingsInfoMap.Insert(1370412112, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.disableHtileBasedMsaaRead;
    info.valueSize = sizeof(m_settings.disableHtileBasedMsaaRead);
    m_settingsInfoMap.Insert(2924066334, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.disableMsaaStencilShaderRead;
    info.valueSize = sizeof(m_settings.disableMsaaStencilShaderRead);
    m_settingsInfoMap.Insert(839875998, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.optImgMaskToApplyShaderReadUsageForTransferSrc;
    info.valueSize = sizeof(m_settings.optImgMaskToApplyShaderReadUsageForTransferSrc);
    m_settingsInfoMap.Insert(4254919194, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.optImgMaskToApplyShaderWriteUsageForTransferDst;
    info.valueSize = sizeof(m_settings.optImgMaskToApplyShaderWriteUsageForTransferDst);
    m_settingsInfoMap.Insert(3940320828, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.optOnlyEnableFP16ForGfx9Plus;
    info.valueSize = sizeof(m_settings.optOnlyEnableFP16ForGfx9Plus);
    m_settingsInfoMap.Insert(40567326, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.optColorTargetUsageDoesNotContainResolveLayout;
    info.valueSize = sizeof(m_settings.optColorTargetUsageDoesNotContainResolveLayout);
    m_settingsInfoMap.Insert(523539756, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.optRenderStateCacheEnable;
    info.valueSize = sizeof(m_settings.optRenderStateCacheEnable);
    m_settingsInfoMap.Insert(3107692587, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.ignoreMutableFlag;
    info.valueSize = sizeof(m_settings.ignoreMutableFlag);
    m_settingsInfoMap.Insert(669794809, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.optimizeCmdbufMode;
    info.valueSize = sizeof(m_settings.optimizeCmdbufMode);
    m_settingsInfoMap.Insert(3847566088, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.prefetchShaders;
    info.valueSize = sizeof(m_settings.prefetchShaders);
    m_settingsInfoMap.Insert(1791920096, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.dccBitsPerPixelThreshold;
    info.valueSize = sizeof(m_settings.dccBitsPerPixelThreshold);
    m_settingsInfoMap.Insert(2668340295, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.forceDccForColorAttachments;
    info.valueSize = sizeof(m_settings.forceDccForColorAttachments);
    m_settingsInfoMap.Insert(3046665474, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.disableSmallSurfColorCompressionSize;
    info.valueSize = sizeof(m_settings.disableSmallSurfColorCompressionSize);
    m_settingsInfoMap.Insert(2075204220, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.enableGpuEventMultiSlot;
    info.valueSize = sizeof(m_settings.enableGpuEventMultiSlot);
    m_settingsInfoMap.Insert(1407114949, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.useAcqRelInterface;
    info.valueSize = sizeof(m_settings.useAcqRelInterface);
    m_settingsInfoMap.Insert(587881749, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.enableSPP;
    info.valueSize = sizeof(m_settings.enableSPP);
    m_settingsInfoMap.Insert(2437981247, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.enableMlModelForWaveSize;
    info.valueSize = sizeof(m_settings.enableMlModelForWaveSize);
    m_settingsInfoMap.Insert(915258299, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.enableAsyncCompile;
    info.valueSize = sizeof(m_settings.enableAsyncCompile);
    m_settingsInfoMap.Insert(4064117211, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.disableSkipFceOptimization;
    info.valueSize = sizeof(m_settings.disableSkipFceOptimization);
    m_settingsInfoMap.Insert(3031646935, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.devModePipelineUriServicePostSizeLimit;
    info.valueSize = sizeof(m_settings.devModePipelineUriServicePostSizeLimit);
    m_settingsInfoMap.Insert(801344686, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.devModeElfReplacementDirectoryEnable;
    info.valueSize = sizeof(m_settings.devModeElfReplacementDirectoryEnable);
    m_settingsInfoMap.Insert(1051952064, info);

    info.type      = SettingType::String;
    info.pValuePtr = &m_settings.devModeElfReplacementDirectory;
    info.valueSize = sizeof(m_settings.devModeElfReplacementDirectory);
    m_settingsInfoMap.Insert(2986257399, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.devModeShaderIsaDbEnable;
    info.valueSize = sizeof(m_settings.devModeShaderIsaDbEnable);
    m_settingsInfoMap.Insert(3998535268, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.devModeQueueTimingEnable;
    info.valueSize = sizeof(m_settings.devModeQueueTimingEnable);
    m_settingsInfoMap.Insert(4267003511, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.devModeSemaphoreQueueTimingEnable;
    info.valueSize = sizeof(m_settings.devModeSemaphoreQueueTimingEnable);
    m_settingsInfoMap.Insert(1840915631, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.devModeSqttMarkerEnable;
    info.valueSize = sizeof(m_settings.devModeSqttMarkerEnable);
    m_settingsInfoMap.Insert(3758115926, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.devModeSqttForceDisable;
    info.valueSize = sizeof(m_settings.devModeSqttForceDisable);
    m_settingsInfoMap.Insert(1045260770, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.devModeSqttWaitIdle;
    info.valueSize = sizeof(m_settings.devModeSqttWaitIdle);
    m_settingsInfoMap.Insert(2301549408, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.devModeSqttFlushAllQueues;
    info.valueSize = sizeof(m_settings.devModeSqttFlushAllQueues);
    m_settingsInfoMap.Insert(4103072742, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.devModeSqttGpuMemoryLimit;
    info.valueSize = sizeof(m_settings.devModeSqttGpuMemoryLimit);
    m_settingsInfoMap.Insert(1724659923, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.devModeSqttFrameCount;
    info.valueSize = sizeof(m_settings.devModeSqttFrameCount);
    m_settingsInfoMap.Insert(1516028043, info);

    info.type      = SettingType::String;
    info.pValuePtr = &m_settings.devModeSqttInternalUserEventPrefix;
    info.valueSize = sizeof(m_settings.devModeSqttInternalUserEventPrefix);
    m_settingsInfoMap.Insert(2681226663, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.devModeSqttTraceBeginEndTagEnable;
    info.valueSize = sizeof(m_settings.devModeSqttTraceBeginEndTagEnable);
    m_settingsInfoMap.Insert(170815525, info);

    info.type      = SettingType::Uint64;
    info.pValuePtr = &m_settings.devModeSqttTraceBeginTagValue;
    info.valueSize = sizeof(m_settings.devModeSqttTraceBeginTagValue);
    m_settingsInfoMap.Insert(1843312060, info);

    info.type      = SettingType::Uint64;
    info.pValuePtr = &m_settings.devModeSqttTraceEndTagValue;
    info.valueSize = sizeof(m_settings.devModeSqttTraceEndTagValue);
    m_settingsInfoMap.Insert(1382482956, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.devModeSqttInstructionTraceEnable;
    info.valueSize = sizeof(m_settings.devModeSqttInstructionTraceEnable);
    m_settingsInfoMap.Insert(2498745445, info);

    info.type      = SettingType::Uint64;
    info.pValuePtr = &m_settings.devModeSqttTargetApiPsoHash;
    info.valueSize = sizeof(m_settings.devModeSqttTargetApiPsoHash);
    m_settingsInfoMap.Insert(3810870996, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.devModeSqttForceBlockOnTraceEnd;
    info.valueSize = sizeof(m_settings.devModeSqttForceBlockOnTraceEnd);
    m_settingsInfoMap.Insert(2293963252, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.devModeSqttPrepareFrameCount;
    info.valueSize = sizeof(m_settings.devModeSqttPrepareFrameCount);
    m_settingsInfoMap.Insert(1904450154, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.overrideShaderParams;
    info.valueSize = sizeof(m_settings.overrideShaderParams);
    m_settingsInfoMap.Insert(15225846, info);

    info.type      = SettingType::Uint64;
    info.pValuePtr = &m_settings.overrideShaderHashUpper;
    info.valueSize = sizeof(m_settings.overrideShaderHashUpper);
    m_settingsInfoMap.Insert(4034696060, info);

    info.type      = SettingType::Uint64;
    info.pValuePtr = &m_settings.overrideShaderHashLower;
    info.valueSize = sizeof(m_settings.overrideShaderHashLower);
    m_settingsInfoMap.Insert(951100197, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.overrideShaderStage;
    info.valueSize = sizeof(m_settings.overrideShaderStage);
    m_settingsInfoMap.Insert(205873806, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.overrideNumVGPRsAvailable;
    info.valueSize = sizeof(m_settings.overrideNumVGPRsAvailable);
    m_settingsInfoMap.Insert(1826717614, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.overrideWavesPerCu;
    info.valueSize = sizeof(m_settings.overrideWavesPerCu);
    m_settingsInfoMap.Insert(297810728, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.overrideUserDataSpillThreshold;
    info.valueSize = sizeof(m_settings.overrideUserDataSpillThreshold);
    m_settingsInfoMap.Insert(2769900547, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.overrideMaxLdsSpillDwords;
    info.valueSize = sizeof(m_settings.overrideMaxLdsSpillDwords);
    m_settingsInfoMap.Insert(1651396017, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.overrideCsTgPerCu;
    info.valueSize = sizeof(m_settings.overrideCsTgPerCu);
    m_settingsInfoMap.Insert(2898940541, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.overrideUsePbbPerCrc;
    info.valueSize = sizeof(m_settings.overrideUsePbbPerCrc);
    m_settingsInfoMap.Insert(2471901291, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.overrideAllowReZ;
    info.valueSize = sizeof(m_settings.overrideAllowReZ);
    m_settingsInfoMap.Insert(2596394967, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.overrideWaveSize;
    info.valueSize = sizeof(m_settings.overrideWaveSize);
    m_settingsInfoMap.Insert(311520325, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.overrideWgpMode;
    info.valueSize = sizeof(m_settings.overrideWgpMode);
    m_settingsInfoMap.Insert(4247168110, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.overrideDisableLoopUnrolls;
    info.valueSize = sizeof(m_settings.overrideDisableLoopUnrolls);
    m_settingsInfoMap.Insert(2077939830, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.overrideUseSiScheduler;
    info.valueSize = sizeof(m_settings.overrideUseSiScheduler);
    m_settingsInfoMap.Insert(995249705, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.overrideReconfigWorkgroupLayout;
    info.valueSize = sizeof(m_settings.overrideReconfigWorkgroupLayout);
    m_settingsInfoMap.Insert(3705509468, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.resourceProfileIgnoresAppProfile;
    info.valueSize = sizeof(m_settings.resourceProfileIgnoresAppProfile);
    m_settingsInfoMap.Insert(3259709197, info);

    info.type      = SettingType::Boolean;
    info.pValuePtr = &m_settings.overrideResourceParams;
    info.valueSize = sizeof(m_settings.overrideResourceParams);
    m_settingsInfoMap.Insert(2494222459, info);

    info.type      = SettingType::Uint64;
    info.pValuePtr = &m_settings.overrideResourceHashDimensions;
    info.valueSize = sizeof(m_settings.overrideResourceHashDimensions);
    m_settingsInfoMap.Insert(3988943396, info);

    info.type      = SettingType::Uint64;
    info.pValuePtr = &m_settings.overrideResourceHashCrc;
    info.valueSize = sizeof(m_settings.overrideResourceHashCrc);
    m_settingsInfoMap.Insert(1371163493, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.overrideResourceDccOnOff;
    info.valueSize = sizeof(m_settings.overrideResourceDccOnOff);
    m_settingsInfoMap.Insert(585965089, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.vulkanTexFilterQuality;
    info.valueSize = sizeof(m_settings.vulkanTexFilterQuality);
    m_settingsInfoMap.Insert(3719285346, info);

    info.type      = SettingType::Uint;
    info.pValuePtr = &m_settings.appGpuID;
    info.valueSize = sizeof(m_settings.appGpuID);
    m_settingsInfoMap.Insert(330166207, info);

}

// =====================================================================================================================
// Registers the core settings with the Developer Driver settings service.
void VulkanSettingsLoader::DevDriverRegister()
{
    auto* pDevDriverServer = static_cast<Pal::IPlatform*>(m_pPlatform)->GetDevDriverServer();
    if (pDevDriverServer != nullptr)
    {
        auto* pSettingsService = pDevDriverServer->GetSettingsService();
        if (pSettingsService != nullptr)
        {
            RegisteredComponent component = {};
            strncpy(&component.componentName[0], m_pComponentName, kMaxComponentNameStrLen);
            component.pPrivateData = static_cast<void*>(this);
            component.pSettingsHashes = &g_vulkanSettingHashList[0];
            component.numSettings = g_vulkanNumSettings;
            component.pfnGetValue = ISettingsLoader::GetValue;
            component.pfnSetValue = ISettingsLoader::SetValue;
            component.pSettingsData = &g_vulkanJsonData[0];
            component.settingsDataSize = sizeof(g_vulkanJsonData);
            component.settingsDataHash = 0;
            component.settingsDataHeader.isEncoded = false;
            component.settingsDataHeader.magicBufferId = 0;
            component.settingsDataHeader.magicBufferOffset = 0;

            pSettingsService->RegisterComponent(component);
        }
    }
}

} // vk