/*
 ***********************************************************************************************************************
 *
 *  Copyright (c) 2019 Advanced Micro Devices, Inc. All Rights Reserved.
 *
 *  Permission is hereby granted, free of charge, to any person obtaining a copy
 *  of this software and associated documentation files (the "Software"), to deal
 *  in the Software without restriction, including without limitation the rights
 *  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 *  copies of the Software, and to permit persons to whom the Software is
 *  furnished to do so, subject to the following conditions:
 *
 *  The above copyright notice and this permission notice shall be included in all
 *  copies or substantial portions of the Software.
 *
 *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 *  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 *  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 *  SOFTWARE.
 *
 **********************************************************************************************************************/

#pragma once

typedef union alloc_DEBUG_DATA                                   regalloc_DEBUG_DATA;
typedef union ATC_ATS_CNTL                                       regATC_ATS_CNTL;
typedef union ATC_ATS_DEFAULT_PAGE_LOW                           regATC_ATS_DEFAULT_PAGE_LOW;
typedef union ATC_ATS_FAULT_CNTL                                 regATC_ATS_FAULT_CNTL;
typedef union ATC_ATS_FAULT_STATUS_ADDR                          regATC_ATS_FAULT_STATUS_ADDR;
typedef union ATC_ATS_FAULT_STATUS_INFO                          regATC_ATS_FAULT_STATUS_INFO;
typedef union ATC_ATS_FAULT_STATUS_INFO2                         regATC_ATS_FAULT_STATUS_INFO2;
typedef union ATC_ATS_GFX_ATCL2_STATUS                           regATC_ATS_GFX_ATCL2_STATUS;
typedef union ATC_ATS_MMHUB_ATCL2_STATUS                         regATC_ATS_MMHUB_ATCL2_STATUS;
typedef union ATC_ATS_SDPPORT_CNTL                               regATC_ATS_SDPPORT_CNTL;
typedef union ATC_ATS_STATUS                                     regATC_ATS_STATUS;
typedef union ATC_ATS_VMID_SNAPSHOT_GFX_STAT                     regATC_ATS_VMID_SNAPSHOT_GFX_STAT;
typedef union ATC_ATS_VMID_SNAPSHOT_MMHUB_STAT                   regATC_ATS_VMID_SNAPSHOT_MMHUB_STAT;
typedef union ATC_ATS_VMID_STATUS                                regATC_ATS_VMID_STATUS;
typedef union ATC_L2_PERFCOUNTER0_CFG                            regATC_L2_PERFCOUNTER0_CFG;
typedef union ATC_L2_PERFCOUNTER1_CFG                            regATC_L2_PERFCOUNTER1_CFG;
typedef union ATC_L2_PERFCOUNTER_HI                              regATC_L2_PERFCOUNTER_HI;
typedef union ATC_L2_PERFCOUNTER_LO                              regATC_L2_PERFCOUNTER_LO;
typedef union ATC_L2_PERFCOUNTER_RSLT_CNTL                       regATC_L2_PERFCOUNTER_RSLT_CNTL;
typedef union ATC_PERFCOUNTER0_CFG                               regATC_PERFCOUNTER0_CFG;
typedef union ATC_PERFCOUNTER1_CFG                               regATC_PERFCOUNTER1_CFG;
typedef union ATC_PERFCOUNTER2_CFG                               regATC_PERFCOUNTER2_CFG;
typedef union ATC_PERFCOUNTER3_CFG                               regATC_PERFCOUNTER3_CFG;
typedef union ATC_PERFCOUNTER_HI                                 regATC_PERFCOUNTER_HI;
typedef union ATC_PERFCOUNTER_LO                                 regATC_PERFCOUNTER_LO;
typedef union ATC_PERFCOUNTER_RSLT_CNTL                          regATC_PERFCOUNTER_RSLT_CNTL;
typedef union ATC_TRANS_FAULT_RSPCNTRL                           regATC_TRANS_FAULT_RSPCNTRL;
typedef union ATC_VMID0_PASID_MAPPING                            regATC_VMID0_PASID_MAPPING;
typedef union ATC_VMID1_PASID_MAPPING                            regATC_VMID1_PASID_MAPPING;
typedef union ATC_VMID2_PASID_MAPPING                            regATC_VMID2_PASID_MAPPING;
typedef union ATC_VMID3_PASID_MAPPING                            regATC_VMID3_PASID_MAPPING;
typedef union ATC_VMID4_PASID_MAPPING                            regATC_VMID4_PASID_MAPPING;
typedef union ATC_VMID5_PASID_MAPPING                            regATC_VMID5_PASID_MAPPING;
typedef union ATC_VMID6_PASID_MAPPING                            regATC_VMID6_PASID_MAPPING;
typedef union ATC_VMID7_PASID_MAPPING                            regATC_VMID7_PASID_MAPPING;
typedef union ATC_VMID8_PASID_MAPPING                            regATC_VMID8_PASID_MAPPING;
typedef union ATC_VMID9_PASID_MAPPING                            regATC_VMID9_PASID_MAPPING;
typedef union ATC_VMID10_PASID_MAPPING                           regATC_VMID10_PASID_MAPPING;
typedef union ATC_VMID11_PASID_MAPPING                           regATC_VMID11_PASID_MAPPING;
typedef union ATC_VMID12_PASID_MAPPING                           regATC_VMID12_PASID_MAPPING;
typedef union ATC_VMID13_PASID_MAPPING                           regATC_VMID13_PASID_MAPPING;
typedef union ATC_VMID14_PASID_MAPPING                           regATC_VMID14_PASID_MAPPING;
typedef union ATC_VMID15_PASID_MAPPING                           regATC_VMID15_PASID_MAPPING;
typedef union ATC_VMID16_PASID_MAPPING                           regATC_VMID16_PASID_MAPPING;
typedef union ATC_VMID17_PASID_MAPPING                           regATC_VMID17_PASID_MAPPING;
typedef union ATC_VMID18_PASID_MAPPING                           regATC_VMID18_PASID_MAPPING;
typedef union ATC_VMID19_PASID_MAPPING                           regATC_VMID19_PASID_MAPPING;
typedef union ATC_VMID20_PASID_MAPPING                           regATC_VMID20_PASID_MAPPING;
typedef union ATC_VMID21_PASID_MAPPING                           regATC_VMID21_PASID_MAPPING;
typedef union ATC_VMID22_PASID_MAPPING                           regATC_VMID22_PASID_MAPPING;
typedef union ATC_VMID23_PASID_MAPPING                           regATC_VMID23_PASID_MAPPING;
typedef union ATC_VMID24_PASID_MAPPING                           regATC_VMID24_PASID_MAPPING;
typedef union ATC_VMID25_PASID_MAPPING                           regATC_VMID25_PASID_MAPPING;
typedef union ATC_VMID26_PASID_MAPPING                           regATC_VMID26_PASID_MAPPING;
typedef union ATC_VMID27_PASID_MAPPING                           regATC_VMID27_PASID_MAPPING;
typedef union ATC_VMID28_PASID_MAPPING                           regATC_VMID28_PASID_MAPPING;
typedef union ATC_VMID29_PASID_MAPPING                           regATC_VMID29_PASID_MAPPING;
typedef union ATC_VMID30_PASID_MAPPING                           regATC_VMID30_PASID_MAPPING;
typedef union ATC_VMID31_PASID_MAPPING                           regATC_VMID31_PASID_MAPPING;
typedef union ATC_VMID_PASID_MAPPING_UPDATE_STATUS               regATC_VMID_PASID_MAPPING_UPDATE_STATUS;
typedef union ATS_IH_CREDIT                                      regATS_IH_CREDIT;
typedef union BCI_DEBUG_READ                                     regBCI_DEBUG_READ;
typedef union CB_BLEND0_CONTROL                                  regCB_BLEND0_CONTROL;
typedef union CB_BLEND1_CONTROL                                  regCB_BLEND1_CONTROL;
typedef union CB_BLEND2_CONTROL                                  regCB_BLEND2_CONTROL;
typedef union CB_BLEND3_CONTROL                                  regCB_BLEND3_CONTROL;
typedef union CB_BLEND4_CONTROL                                  regCB_BLEND4_CONTROL;
typedef union CB_BLEND5_CONTROL                                  regCB_BLEND5_CONTROL;
typedef union CB_BLEND6_CONTROL                                  regCB_BLEND6_CONTROL;
typedef union CB_BLEND7_CONTROL                                  regCB_BLEND7_CONTROL;
typedef union CB_BLEND_ALPHA                                     regCB_BLEND_ALPHA;
typedef union CB_BLEND_BLUE                                      regCB_BLEND_BLUE;
typedef union CB_BLEND_GREEN                                     regCB_BLEND_GREEN;
typedef union CB_BLEND_RED                                       regCB_BLEND_RED;
typedef union CB_CACHE_EVICT_POINTS                              regCB_CACHE_EVICT_POINTS;
typedef union CB_CGTT_SCLK_CTRL                                  regCB_CGTT_SCLK_CTRL;
typedef union CB_COLOR0_ATTRIB                                   regCB_COLOR0_ATTRIB;
typedef union CB_COLOR0_ATTRIB2                                  regCB_COLOR0_ATTRIB2;
typedef union CB_COLOR0_ATTRIB3                                  regCB_COLOR0_ATTRIB3;
typedef union CB_COLOR0_BASE                                     regCB_COLOR0_BASE;
typedef union CB_COLOR0_BASE_EXT                                 regCB_COLOR0_BASE_EXT;
typedef union CB_COLOR0_CLEAR_WORD0                              regCB_COLOR0_CLEAR_WORD0;
typedef union CB_COLOR0_CLEAR_WORD1                              regCB_COLOR0_CLEAR_WORD1;
typedef union CB_COLOR0_CMASK                                    regCB_COLOR0_CMASK;
typedef union CB_COLOR0_CMASK_BASE_EXT                           regCB_COLOR0_CMASK_BASE_EXT;
typedef union CB_COLOR0_CMASK_SLICE                              regCB_COLOR0_CMASK_SLICE;
typedef union CB_COLOR0_DCC_BASE                                 regCB_COLOR0_DCC_BASE;
typedef union CB_COLOR0_DCC_BASE_EXT                             regCB_COLOR0_DCC_BASE_EXT;
typedef union CB_COLOR0_DCC_CONTROL                              regCB_COLOR0_DCC_CONTROL;
typedef union CB_COLOR0_FMASK                                    regCB_COLOR0_FMASK;
typedef union CB_COLOR0_FMASK_BASE_EXT                           regCB_COLOR0_FMASK_BASE_EXT;
typedef union CB_COLOR0_FMASK_SLICE                              regCB_COLOR0_FMASK_SLICE;
typedef union CB_COLOR0_INFO                                     regCB_COLOR0_INFO;
typedef union CB_COLOR0_PITCH                                    regCB_COLOR0_PITCH;
typedef union CB_COLOR0_SLICE                                    regCB_COLOR0_SLICE;
typedef union CB_COLOR0_VIEW                                     regCB_COLOR0_VIEW;
typedef union CB_COLOR1_ATTRIB                                   regCB_COLOR1_ATTRIB;
typedef union CB_COLOR1_ATTRIB2                                  regCB_COLOR1_ATTRIB2;
typedef union CB_COLOR1_ATTRIB3                                  regCB_COLOR1_ATTRIB3;
typedef union CB_COLOR1_BASE                                     regCB_COLOR1_BASE;
typedef union CB_COLOR1_BASE_EXT                                 regCB_COLOR1_BASE_EXT;
typedef union CB_COLOR1_CLEAR_WORD0                              regCB_COLOR1_CLEAR_WORD0;
typedef union CB_COLOR1_CLEAR_WORD1                              regCB_COLOR1_CLEAR_WORD1;
typedef union CB_COLOR1_CMASK                                    regCB_COLOR1_CMASK;
typedef union CB_COLOR1_CMASK_BASE_EXT                           regCB_COLOR1_CMASK_BASE_EXT;
typedef union CB_COLOR1_CMASK_SLICE                              regCB_COLOR1_CMASK_SLICE;
typedef union CB_COLOR1_DCC_BASE                                 regCB_COLOR1_DCC_BASE;
typedef union CB_COLOR1_DCC_BASE_EXT                             regCB_COLOR1_DCC_BASE_EXT;
typedef union CB_COLOR1_DCC_CONTROL                              regCB_COLOR1_DCC_CONTROL;
typedef union CB_COLOR1_FMASK                                    regCB_COLOR1_FMASK;
typedef union CB_COLOR1_FMASK_BASE_EXT                           regCB_COLOR1_FMASK_BASE_EXT;
typedef union CB_COLOR1_FMASK_SLICE                              regCB_COLOR1_FMASK_SLICE;
typedef union CB_COLOR1_INFO                                     regCB_COLOR1_INFO;
typedef union CB_COLOR1_PITCH                                    regCB_COLOR1_PITCH;
typedef union CB_COLOR1_SLICE                                    regCB_COLOR1_SLICE;
typedef union CB_COLOR1_VIEW                                     regCB_COLOR1_VIEW;
typedef union CB_COLOR2_ATTRIB                                   regCB_COLOR2_ATTRIB;
typedef union CB_COLOR2_ATTRIB2                                  regCB_COLOR2_ATTRIB2;
typedef union CB_COLOR2_ATTRIB3                                  regCB_COLOR2_ATTRIB3;
typedef union CB_COLOR2_BASE                                     regCB_COLOR2_BASE;
typedef union CB_COLOR2_BASE_EXT                                 regCB_COLOR2_BASE_EXT;
typedef union CB_COLOR2_CLEAR_WORD0                              regCB_COLOR2_CLEAR_WORD0;
typedef union CB_COLOR2_CLEAR_WORD1                              regCB_COLOR2_CLEAR_WORD1;
typedef union CB_COLOR2_CMASK                                    regCB_COLOR2_CMASK;
typedef union CB_COLOR2_CMASK_BASE_EXT                           regCB_COLOR2_CMASK_BASE_EXT;
typedef union CB_COLOR2_CMASK_SLICE                              regCB_COLOR2_CMASK_SLICE;
typedef union CB_COLOR2_DCC_BASE                                 regCB_COLOR2_DCC_BASE;
typedef union CB_COLOR2_DCC_BASE_EXT                             regCB_COLOR2_DCC_BASE_EXT;
typedef union CB_COLOR2_DCC_CONTROL                              regCB_COLOR2_DCC_CONTROL;
typedef union CB_COLOR2_FMASK                                    regCB_COLOR2_FMASK;
typedef union CB_COLOR2_FMASK_BASE_EXT                           regCB_COLOR2_FMASK_BASE_EXT;
typedef union CB_COLOR2_FMASK_SLICE                              regCB_COLOR2_FMASK_SLICE;
typedef union CB_COLOR2_INFO                                     regCB_COLOR2_INFO;
typedef union CB_COLOR2_PITCH                                    regCB_COLOR2_PITCH;
typedef union CB_COLOR2_SLICE                                    regCB_COLOR2_SLICE;
typedef union CB_COLOR2_VIEW                                     regCB_COLOR2_VIEW;
typedef union CB_COLOR3_ATTRIB                                   regCB_COLOR3_ATTRIB;
typedef union CB_COLOR3_ATTRIB2                                  regCB_COLOR3_ATTRIB2;
typedef union CB_COLOR3_ATTRIB3                                  regCB_COLOR3_ATTRIB3;
typedef union CB_COLOR3_BASE                                     regCB_COLOR3_BASE;
typedef union CB_COLOR3_BASE_EXT                                 regCB_COLOR3_BASE_EXT;
typedef union CB_COLOR3_CLEAR_WORD0                              regCB_COLOR3_CLEAR_WORD0;
typedef union CB_COLOR3_CLEAR_WORD1                              regCB_COLOR3_CLEAR_WORD1;
typedef union CB_COLOR3_CMASK                                    regCB_COLOR3_CMASK;
typedef union CB_COLOR3_CMASK_BASE_EXT                           regCB_COLOR3_CMASK_BASE_EXT;
typedef union CB_COLOR3_CMASK_SLICE                              regCB_COLOR3_CMASK_SLICE;
typedef union CB_COLOR3_DCC_BASE                                 regCB_COLOR3_DCC_BASE;
typedef union CB_COLOR3_DCC_BASE_EXT                             regCB_COLOR3_DCC_BASE_EXT;
typedef union CB_COLOR3_DCC_CONTROL                              regCB_COLOR3_DCC_CONTROL;
typedef union CB_COLOR3_FMASK                                    regCB_COLOR3_FMASK;
typedef union CB_COLOR3_FMASK_BASE_EXT                           regCB_COLOR3_FMASK_BASE_EXT;
typedef union CB_COLOR3_FMASK_SLICE                              regCB_COLOR3_FMASK_SLICE;
typedef union CB_COLOR3_INFO                                     regCB_COLOR3_INFO;
typedef union CB_COLOR3_PITCH                                    regCB_COLOR3_PITCH;
typedef union CB_COLOR3_SLICE                                    regCB_COLOR3_SLICE;
typedef union CB_COLOR3_VIEW                                     regCB_COLOR3_VIEW;
typedef union CB_COLOR4_ATTRIB                                   regCB_COLOR4_ATTRIB;
typedef union CB_COLOR4_ATTRIB2                                  regCB_COLOR4_ATTRIB2;
typedef union CB_COLOR4_ATTRIB3                                  regCB_COLOR4_ATTRIB3;
typedef union CB_COLOR4_BASE                                     regCB_COLOR4_BASE;
typedef union CB_COLOR4_BASE_EXT                                 regCB_COLOR4_BASE_EXT;
typedef union CB_COLOR4_CLEAR_WORD0                              regCB_COLOR4_CLEAR_WORD0;
typedef union CB_COLOR4_CLEAR_WORD1                              regCB_COLOR4_CLEAR_WORD1;
typedef union CB_COLOR4_CMASK                                    regCB_COLOR4_CMASK;
typedef union CB_COLOR4_CMASK_BASE_EXT                           regCB_COLOR4_CMASK_BASE_EXT;
typedef union CB_COLOR4_CMASK_SLICE                              regCB_COLOR4_CMASK_SLICE;
typedef union CB_COLOR4_DCC_BASE                                 regCB_COLOR4_DCC_BASE;
typedef union CB_COLOR4_DCC_BASE_EXT                             regCB_COLOR4_DCC_BASE_EXT;
typedef union CB_COLOR4_DCC_CONTROL                              regCB_COLOR4_DCC_CONTROL;
typedef union CB_COLOR4_FMASK                                    regCB_COLOR4_FMASK;
typedef union CB_COLOR4_FMASK_BASE_EXT                           regCB_COLOR4_FMASK_BASE_EXT;
typedef union CB_COLOR4_FMASK_SLICE                              regCB_COLOR4_FMASK_SLICE;
typedef union CB_COLOR4_INFO                                     regCB_COLOR4_INFO;
typedef union CB_COLOR4_PITCH                                    regCB_COLOR4_PITCH;
typedef union CB_COLOR4_SLICE                                    regCB_COLOR4_SLICE;
typedef union CB_COLOR4_VIEW                                     regCB_COLOR4_VIEW;
typedef union CB_COLOR5_ATTRIB                                   regCB_COLOR5_ATTRIB;
typedef union CB_COLOR5_ATTRIB2                                  regCB_COLOR5_ATTRIB2;
typedef union CB_COLOR5_ATTRIB3                                  regCB_COLOR5_ATTRIB3;
typedef union CB_COLOR5_BASE                                     regCB_COLOR5_BASE;
typedef union CB_COLOR5_BASE_EXT                                 regCB_COLOR5_BASE_EXT;
typedef union CB_COLOR5_CLEAR_WORD0                              regCB_COLOR5_CLEAR_WORD0;
typedef union CB_COLOR5_CLEAR_WORD1                              regCB_COLOR5_CLEAR_WORD1;
typedef union CB_COLOR5_CMASK                                    regCB_COLOR5_CMASK;
typedef union CB_COLOR5_CMASK_BASE_EXT                           regCB_COLOR5_CMASK_BASE_EXT;
typedef union CB_COLOR5_CMASK_SLICE                              regCB_COLOR5_CMASK_SLICE;
typedef union CB_COLOR5_DCC_BASE                                 regCB_COLOR5_DCC_BASE;
typedef union CB_COLOR5_DCC_BASE_EXT                             regCB_COLOR5_DCC_BASE_EXT;
typedef union CB_COLOR5_DCC_CONTROL                              regCB_COLOR5_DCC_CONTROL;
typedef union CB_COLOR5_FMASK                                    regCB_COLOR5_FMASK;
typedef union CB_COLOR5_FMASK_BASE_EXT                           regCB_COLOR5_FMASK_BASE_EXT;
typedef union CB_COLOR5_FMASK_SLICE                              regCB_COLOR5_FMASK_SLICE;
typedef union CB_COLOR5_INFO                                     regCB_COLOR5_INFO;
typedef union CB_COLOR5_PITCH                                    regCB_COLOR5_PITCH;
typedef union CB_COLOR5_SLICE                                    regCB_COLOR5_SLICE;
typedef union CB_COLOR5_VIEW                                     regCB_COLOR5_VIEW;
typedef union CB_COLOR6_ATTRIB                                   regCB_COLOR6_ATTRIB;
typedef union CB_COLOR6_ATTRIB2                                  regCB_COLOR6_ATTRIB2;
typedef union CB_COLOR6_ATTRIB3                                  regCB_COLOR6_ATTRIB3;
typedef union CB_COLOR6_BASE                                     regCB_COLOR6_BASE;
typedef union CB_COLOR6_BASE_EXT                                 regCB_COLOR6_BASE_EXT;
typedef union CB_COLOR6_CLEAR_WORD0                              regCB_COLOR6_CLEAR_WORD0;
typedef union CB_COLOR6_CLEAR_WORD1                              regCB_COLOR6_CLEAR_WORD1;
typedef union CB_COLOR6_CMASK                                    regCB_COLOR6_CMASK;
typedef union CB_COLOR6_CMASK_BASE_EXT                           regCB_COLOR6_CMASK_BASE_EXT;
typedef union CB_COLOR6_CMASK_SLICE                              regCB_COLOR6_CMASK_SLICE;
typedef union CB_COLOR6_DCC_BASE                                 regCB_COLOR6_DCC_BASE;
typedef union CB_COLOR6_DCC_BASE_EXT                             regCB_COLOR6_DCC_BASE_EXT;
typedef union CB_COLOR6_DCC_CONTROL                              regCB_COLOR6_DCC_CONTROL;
typedef union CB_COLOR6_FMASK                                    regCB_COLOR6_FMASK;
typedef union CB_COLOR6_FMASK_BASE_EXT                           regCB_COLOR6_FMASK_BASE_EXT;
typedef union CB_COLOR6_FMASK_SLICE                              regCB_COLOR6_FMASK_SLICE;
typedef union CB_COLOR6_INFO                                     regCB_COLOR6_INFO;
typedef union CB_COLOR6_PITCH                                    regCB_COLOR6_PITCH;
typedef union CB_COLOR6_SLICE                                    regCB_COLOR6_SLICE;
typedef union CB_COLOR6_VIEW                                     regCB_COLOR6_VIEW;
typedef union CB_COLOR7_ATTRIB                                   regCB_COLOR7_ATTRIB;
typedef union CB_COLOR7_ATTRIB2                                  regCB_COLOR7_ATTRIB2;
typedef union CB_COLOR7_ATTRIB3                                  regCB_COLOR7_ATTRIB3;
typedef union CB_COLOR7_BASE                                     regCB_COLOR7_BASE;
typedef union CB_COLOR7_BASE_EXT                                 regCB_COLOR7_BASE_EXT;
typedef union CB_COLOR7_CLEAR_WORD0                              regCB_COLOR7_CLEAR_WORD0;
typedef union CB_COLOR7_CLEAR_WORD1                              regCB_COLOR7_CLEAR_WORD1;
typedef union CB_COLOR7_CMASK                                    regCB_COLOR7_CMASK;
typedef union CB_COLOR7_CMASK_BASE_EXT                           regCB_COLOR7_CMASK_BASE_EXT;
typedef union CB_COLOR7_CMASK_SLICE                              regCB_COLOR7_CMASK_SLICE;
typedef union CB_COLOR7_DCC_BASE                                 regCB_COLOR7_DCC_BASE;
typedef union CB_COLOR7_DCC_BASE_EXT                             regCB_COLOR7_DCC_BASE_EXT;
typedef union CB_COLOR7_DCC_CONTROL                              regCB_COLOR7_DCC_CONTROL;
typedef union CB_COLOR7_FMASK                                    regCB_COLOR7_FMASK;
typedef union CB_COLOR7_FMASK_BASE_EXT                           regCB_COLOR7_FMASK_BASE_EXT;
typedef union CB_COLOR7_FMASK_SLICE                              regCB_COLOR7_FMASK_SLICE;
typedef union CB_COLOR7_INFO                                     regCB_COLOR7_INFO;
typedef union CB_COLOR7_PITCH                                    regCB_COLOR7_PITCH;
typedef union CB_COLOR7_SLICE                                    regCB_COLOR7_SLICE;
typedef union CB_COLOR7_VIEW                                     regCB_COLOR7_VIEW;
typedef union CB_COLOR_CONTROL                                   regCB_COLOR_CONTROL;
typedef union CB_COVERAGE_OUT_CONTROL                            regCB_COVERAGE_OUT_CONTROL;
typedef union CB_DCC_CONFIG                                      regCB_DCC_CONFIG;
typedef union CB_DCC_CONTROL                                     regCB_DCC_CONTROL;
typedef union CB_HW_CONTROL                                      regCB_HW_CONTROL;
typedef union CB_HW_CONTROL_1                                    regCB_HW_CONTROL_1;
typedef union CB_HW_CONTROL_2                                    regCB_HW_CONTROL_2;
typedef union CB_HW_CONTROL_3                                    regCB_HW_CONTROL_3;
typedef union CB_HW_CONTROL_4                                    regCB_HW_CONTROL_4;
typedef union CB_HW_MEM_ARBITER_RD                               regCB_HW_MEM_ARBITER_RD;
typedef union CB_HW_MEM_ARBITER_WR                               regCB_HW_MEM_ARBITER_WR;
typedef union CB_MRT0_EPITCH                                     regCB_MRT0_EPITCH;
typedef union CB_MRT1_EPITCH                                     regCB_MRT1_EPITCH;
typedef union CB_MRT2_EPITCH                                     regCB_MRT2_EPITCH;
typedef union CB_MRT3_EPITCH                                     regCB_MRT3_EPITCH;
typedef union CB_MRT4_EPITCH                                     regCB_MRT4_EPITCH;
typedef union CB_MRT5_EPITCH                                     regCB_MRT5_EPITCH;
typedef union CB_MRT6_EPITCH                                     regCB_MRT6_EPITCH;
typedef union CB_MRT7_EPITCH                                     regCB_MRT7_EPITCH;
typedef union CB_PERFCOUNTER0_HI                                 regCB_PERFCOUNTER0_HI;
typedef union CB_PERFCOUNTER0_LO                                 regCB_PERFCOUNTER0_LO;
typedef union CB_PERFCOUNTER0_SELECT                             regCB_PERFCOUNTER0_SELECT;
typedef union CB_PERFCOUNTER0_SELECT1                            regCB_PERFCOUNTER0_SELECT1;
typedef union CB_PERFCOUNTER1_HI                                 regCB_PERFCOUNTER1_HI;
typedef union CB_PERFCOUNTER1_LO                                 regCB_PERFCOUNTER1_LO;
typedef union CB_PERFCOUNTER1_SELECT                             regCB_PERFCOUNTER1_SELECT;
typedef union CB_PERFCOUNTER2_HI                                 regCB_PERFCOUNTER2_HI;
typedef union CB_PERFCOUNTER2_LO                                 regCB_PERFCOUNTER2_LO;
typedef union CB_PERFCOUNTER2_SELECT                             regCB_PERFCOUNTER2_SELECT;
typedef union CB_PERFCOUNTER3_HI                                 regCB_PERFCOUNTER3_HI;
typedef union CB_PERFCOUNTER3_LO                                 regCB_PERFCOUNTER3_LO;
typedef union CB_PERFCOUNTER3_SELECT                             regCB_PERFCOUNTER3_SELECT;
typedef union CB_PERFCOUNTER_FILTER                              regCB_PERFCOUNTER_FILTER;
typedef union CB_RMI_BC_GL2_CACHE_CONTROL                        regCB_RMI_BC_GL2_CACHE_CONTROL;
typedef union CB_RMI_GL2_CACHE_CONTROL                           regCB_RMI_GL2_CACHE_CONTROL;
typedef union CB_SHADER_MASK                                     regCB_SHADER_MASK;
typedef union CB_STUTTER_CONTROL_CMASK_RDLAT                     regCB_STUTTER_CONTROL_CMASK_RDLAT;
typedef union CB_STUTTER_CONTROL_COLOR_RDLAT                     regCB_STUTTER_CONTROL_COLOR_RDLAT;
typedef union CB_STUTTER_CONTROL_FMASK_RDLAT                     regCB_STUTTER_CONTROL_FMASK_RDLAT;
typedef union CB_TARGET_MASK                                     regCB_TARGET_MASK;
typedef union CC_RB_BACKEND_DISABLE                              regCC_RB_BACKEND_DISABLE;
typedef union CC_RB_DAISY_CHAIN                                  regCC_RB_DAISY_CHAIN;
typedef union CC_RB_REDUNDANCY                                   regCC_RB_REDUNDANCY;
typedef union CC_RMI_REDUNDANCY                                  regCC_RMI_REDUNDANCY;
typedef union CHA_PERFCOUNTER0_HI                                regCHA_PERFCOUNTER0_HI;
typedef union CHA_PERFCOUNTER0_LO                                regCHA_PERFCOUNTER0_LO;
typedef union CHA_PERFCOUNTER0_SELECT                            regCHA_PERFCOUNTER0_SELECT;
typedef union CHA_PERFCOUNTER0_SELECT1                           regCHA_PERFCOUNTER0_SELECT1;
typedef union CHA_PERFCOUNTER1_HI                                regCHA_PERFCOUNTER1_HI;
typedef union CHA_PERFCOUNTER1_LO                                regCHA_PERFCOUNTER1_LO;
typedef union CHA_PERFCOUNTER1_SELECT                            regCHA_PERFCOUNTER1_SELECT;
typedef union CHA_PERFCOUNTER2_HI                                regCHA_PERFCOUNTER2_HI;
typedef union CHA_PERFCOUNTER2_LO                                regCHA_PERFCOUNTER2_LO;
typedef union CHA_PERFCOUNTER2_SELECT                            regCHA_PERFCOUNTER2_SELECT;
typedef union CHA_PERFCOUNTER3_HI                                regCHA_PERFCOUNTER3_HI;
typedef union CHA_PERFCOUNTER3_LO                                regCHA_PERFCOUNTER3_LO;
typedef union CHA_PERFCOUNTER3_SELECT                            regCHA_PERFCOUNTER3_SELECT;
typedef union CHCG_PERFCOUNTER0_HI                               regCHCG_PERFCOUNTER0_HI;
typedef union CHCG_PERFCOUNTER0_LO                               regCHCG_PERFCOUNTER0_LO;
typedef union CHCG_PERFCOUNTER0_SELECT                           regCHCG_PERFCOUNTER0_SELECT;
typedef union CHCG_PERFCOUNTER0_SELECT1                          regCHCG_PERFCOUNTER0_SELECT1;
typedef union CHCG_PERFCOUNTER1_HI                               regCHCG_PERFCOUNTER1_HI;
typedef union CHCG_PERFCOUNTER1_LO                               regCHCG_PERFCOUNTER1_LO;
typedef union CHCG_PERFCOUNTER1_SELECT                           regCHCG_PERFCOUNTER1_SELECT;
typedef union CHCG_PERFCOUNTER2_HI                               regCHCG_PERFCOUNTER2_HI;
typedef union CHCG_PERFCOUNTER2_LO                               regCHCG_PERFCOUNTER2_LO;
typedef union CHCG_PERFCOUNTER2_SELECT                           regCHCG_PERFCOUNTER2_SELECT;
typedef union CHCG_PERFCOUNTER3_HI                               regCHCG_PERFCOUNTER3_HI;
typedef union CHCG_PERFCOUNTER3_LO                               regCHCG_PERFCOUNTER3_LO;
typedef union CHCG_PERFCOUNTER3_SELECT                           regCHCG_PERFCOUNTER3_SELECT;
typedef union CHC_PERFCOUNTER0_HI                                regCHC_PERFCOUNTER0_HI;
typedef union CHC_PERFCOUNTER0_LO                                regCHC_PERFCOUNTER0_LO;
typedef union CHC_PERFCOUNTER0_SELECT                            regCHC_PERFCOUNTER0_SELECT;
typedef union CHC_PERFCOUNTER0_SELECT1                           regCHC_PERFCOUNTER0_SELECT1;
typedef union CHC_PERFCOUNTER1_HI                                regCHC_PERFCOUNTER1_HI;
typedef union CHC_PERFCOUNTER1_LO                                regCHC_PERFCOUNTER1_LO;
typedef union CHC_PERFCOUNTER1_SELECT                            regCHC_PERFCOUNTER1_SELECT;
typedef union CHC_PERFCOUNTER2_HI                                regCHC_PERFCOUNTER2_HI;
typedef union CHC_PERFCOUNTER2_LO                                regCHC_PERFCOUNTER2_LO;
typedef union CHC_PERFCOUNTER2_SELECT                            regCHC_PERFCOUNTER2_SELECT;
typedef union CHC_PERFCOUNTER3_HI                                regCHC_PERFCOUNTER3_HI;
typedef union CHC_PERFCOUNTER3_LO                                regCHC_PERFCOUNTER3_LO;
typedef union CHC_PERFCOUNTER3_SELECT                            regCHC_PERFCOUNTER3_SELECT;
typedef union CH_ARB_CTRL                                        regCH_ARB_CTRL;
typedef union CH_ARB_STATUS                                      regCH_ARB_STATUS;
typedef union CH_DRAM_BURST_CTRL                                 regCH_DRAM_BURST_CTRL;
typedef union CH_DRAM_BURST_MASK                                 regCH_DRAM_BURST_MASK;
typedef union CH_PIPE_STEER                                      regCH_PIPE_STEER;
typedef union CH_VC5_ENABLE                                      regCH_VC5_ENABLE;
typedef union COHER_DEST_BASE_0                                  regCOHER_DEST_BASE_0;
typedef union COHER_DEST_BASE_1                                  regCOHER_DEST_BASE_1;
typedef union COHER_DEST_BASE_2                                  regCOHER_DEST_BASE_2;
typedef union COHER_DEST_BASE_3                                  regCOHER_DEST_BASE_3;
typedef union COHER_DEST_BASE_HI_0                               regCOHER_DEST_BASE_HI_0;
typedef union COHER_DEST_BASE_HI_1                               regCOHER_DEST_BASE_HI_1;
typedef union COHER_DEST_BASE_HI_2                               regCOHER_DEST_BASE_HI_2;
typedef union COHER_DEST_BASE_HI_3                               regCOHER_DEST_BASE_HI_3;
typedef union COMPUTE_DDID_INDEX                                 regCOMPUTE_DDID_INDEX;
typedef union COMPUTE_DESTINATION_EN_SE0                         regCOMPUTE_DESTINATION_EN_SE0;
typedef union COMPUTE_DESTINATION_EN_SE1                         regCOMPUTE_DESTINATION_EN_SE1;
typedef union COMPUTE_DESTINATION_EN_SE2                         regCOMPUTE_DESTINATION_EN_SE2;
typedef union COMPUTE_DESTINATION_EN_SE3                         regCOMPUTE_DESTINATION_EN_SE3;
typedef union COMPUTE_DIM_X                                      regCOMPUTE_DIM_X;
typedef union COMPUTE_DIM_Y                                      regCOMPUTE_DIM_Y;
typedef union COMPUTE_DIM_Z                                      regCOMPUTE_DIM_Z;
typedef union COMPUTE_DISPATCH_END                               regCOMPUTE_DISPATCH_END;
typedef union COMPUTE_DISPATCH_ID                                regCOMPUTE_DISPATCH_ID;
typedef union COMPUTE_DISPATCH_INITIATOR                         regCOMPUTE_DISPATCH_INITIATOR;
typedef union COMPUTE_DISPATCH_PKT_ADDR_HI                       regCOMPUTE_DISPATCH_PKT_ADDR_HI;
typedef union COMPUTE_DISPATCH_PKT_ADDR_LO                       regCOMPUTE_DISPATCH_PKT_ADDR_LO;
typedef union COMPUTE_DISPATCH_SCRATCH_BASE_HI                   regCOMPUTE_DISPATCH_SCRATCH_BASE_HI;
typedef union COMPUTE_DISPATCH_SCRATCH_BASE_LO                   regCOMPUTE_DISPATCH_SCRATCH_BASE_LO;
typedef union COMPUTE_DISPATCH_TUNNEL                            regCOMPUTE_DISPATCH_TUNNEL;
typedef union COMPUTE_MISC_RESERVED                              regCOMPUTE_MISC_RESERVED;
typedef union COMPUTE_NOWHERE                                    regCOMPUTE_NOWHERE;
typedef union COMPUTE_NUM_THREAD_X                               regCOMPUTE_NUM_THREAD_X;
typedef union COMPUTE_NUM_THREAD_Y                               regCOMPUTE_NUM_THREAD_Y;
typedef union COMPUTE_NUM_THREAD_Z                               regCOMPUTE_NUM_THREAD_Z;
typedef union COMPUTE_PERFCOUNT_ENABLE                           regCOMPUTE_PERFCOUNT_ENABLE;
typedef union COMPUTE_PGM_HI                                     regCOMPUTE_PGM_HI;
typedef union COMPUTE_PGM_LO                                     regCOMPUTE_PGM_LO;
typedef union COMPUTE_PGM_RSRC1                                  regCOMPUTE_PGM_RSRC1;
typedef union COMPUTE_PGM_RSRC2                                  regCOMPUTE_PGM_RSRC2;
typedef union COMPUTE_PGM_RSRC3                                  regCOMPUTE_PGM_RSRC3;
typedef union COMPUTE_PIPELINESTAT_ENABLE                        regCOMPUTE_PIPELINESTAT_ENABLE;
typedef union COMPUTE_PREF_PRI_ACCUM_0                           regCOMPUTE_PREF_PRI_ACCUM_0;
typedef union COMPUTE_PREF_PRI_ACCUM_1                           regCOMPUTE_PREF_PRI_ACCUM_1;
typedef union COMPUTE_PREF_PRI_ACCUM_2                           regCOMPUTE_PREF_PRI_ACCUM_2;
typedef union COMPUTE_PREF_PRI_ACCUM_3                           regCOMPUTE_PREF_PRI_ACCUM_3;
typedef union COMPUTE_RELAUNCH                                   regCOMPUTE_RELAUNCH;
typedef union COMPUTE_RELAUNCH2                                  regCOMPUTE_RELAUNCH2;
typedef union COMPUTE_REQ_CTRL                                   regCOMPUTE_REQ_CTRL;
typedef union COMPUTE_RESOURCE_LIMITS                            regCOMPUTE_RESOURCE_LIMITS;
typedef union COMPUTE_RESTART_X                                  regCOMPUTE_RESTART_X;
typedef union COMPUTE_RESTART_Y                                  regCOMPUTE_RESTART_Y;
typedef union COMPUTE_RESTART_Z                                  regCOMPUTE_RESTART_Z;
typedef union COMPUTE_SHADER_CHKSUM                              regCOMPUTE_SHADER_CHKSUM;
typedef union COMPUTE_START_X                                    regCOMPUTE_START_X;
typedef union COMPUTE_START_Y                                    regCOMPUTE_START_Y;
typedef union COMPUTE_START_Z                                    regCOMPUTE_START_Z;
typedef union COMPUTE_STATIC_THREAD_MGMT_SE0                     regCOMPUTE_STATIC_THREAD_MGMT_SE0;
typedef union COMPUTE_STATIC_THREAD_MGMT_SE1                     regCOMPUTE_STATIC_THREAD_MGMT_SE1;
typedef union COMPUTE_STATIC_THREAD_MGMT_SE2                     regCOMPUTE_STATIC_THREAD_MGMT_SE2;
typedef union COMPUTE_STATIC_THREAD_MGMT_SE3                     regCOMPUTE_STATIC_THREAD_MGMT_SE3;
typedef union COMPUTE_THREADGROUP_ID                             regCOMPUTE_THREADGROUP_ID;
typedef union COMPUTE_THREAD_TRACE_ENABLE                        regCOMPUTE_THREAD_TRACE_ENABLE;
typedef union COMPUTE_TMPRING_SIZE                               regCOMPUTE_TMPRING_SIZE;
typedef union COMPUTE_USER_ACCUM_0                               regCOMPUTE_USER_ACCUM_0;
typedef union COMPUTE_USER_ACCUM_1                               regCOMPUTE_USER_ACCUM_1;
typedef union COMPUTE_USER_ACCUM_2                               regCOMPUTE_USER_ACCUM_2;
typedef union COMPUTE_USER_ACCUM_3                               regCOMPUTE_USER_ACCUM_3;
typedef union COMPUTE_USER_DATA_0                                regCOMPUTE_USER_DATA_0;
typedef union COMPUTE_USER_DATA_1                                regCOMPUTE_USER_DATA_1;
typedef union COMPUTE_USER_DATA_2                                regCOMPUTE_USER_DATA_2;
typedef union COMPUTE_USER_DATA_3                                regCOMPUTE_USER_DATA_3;
typedef union COMPUTE_USER_DATA_4                                regCOMPUTE_USER_DATA_4;
typedef union COMPUTE_USER_DATA_5                                regCOMPUTE_USER_DATA_5;
typedef union COMPUTE_USER_DATA_6                                regCOMPUTE_USER_DATA_6;
typedef union COMPUTE_USER_DATA_7                                regCOMPUTE_USER_DATA_7;
typedef union COMPUTE_USER_DATA_8                                regCOMPUTE_USER_DATA_8;
typedef union COMPUTE_USER_DATA_9                                regCOMPUTE_USER_DATA_9;
typedef union COMPUTE_USER_DATA_10                               regCOMPUTE_USER_DATA_10;
typedef union COMPUTE_USER_DATA_11                               regCOMPUTE_USER_DATA_11;
typedef union COMPUTE_USER_DATA_12                               regCOMPUTE_USER_DATA_12;
typedef union COMPUTE_USER_DATA_13                               regCOMPUTE_USER_DATA_13;
typedef union COMPUTE_USER_DATA_14                               regCOMPUTE_USER_DATA_14;
typedef union COMPUTE_USER_DATA_15                               regCOMPUTE_USER_DATA_15;
typedef union COMPUTE_VMID                                       regCOMPUTE_VMID;
typedef union COMPUTE_WAVE_RESTORE_ADDR_HI                       regCOMPUTE_WAVE_RESTORE_ADDR_HI;
typedef union COMPUTE_WAVE_RESTORE_ADDR_LO                       regCOMPUTE_WAVE_RESTORE_ADDR_LO;
typedef union CPC_PERFCOUNTER0_HI                                regCPC_PERFCOUNTER0_HI;
typedef union CPC_PERFCOUNTER0_LO                                regCPC_PERFCOUNTER0_LO;
typedef union CPC_PERFCOUNTER0_SELECT                            regCPC_PERFCOUNTER0_SELECT;
typedef union CPC_PERFCOUNTER0_SELECT1                           regCPC_PERFCOUNTER0_SELECT1;
typedef union CPC_PERFCOUNTER1_HI                                regCPC_PERFCOUNTER1_HI;
typedef union CPC_PERFCOUNTER1_LO                                regCPC_PERFCOUNTER1_LO;
typedef union CPC_PERFCOUNTER1_SELECT                            regCPC_PERFCOUNTER1_SELECT;
typedef union CPF_PERFCOUNTER0_HI                                regCPF_PERFCOUNTER0_HI;
typedef union CPF_PERFCOUNTER0_LO                                regCPF_PERFCOUNTER0_LO;
typedef union CPF_PERFCOUNTER0_SELECT                            regCPF_PERFCOUNTER0_SELECT;
typedef union CPF_PERFCOUNTER0_SELECT1                           regCPF_PERFCOUNTER0_SELECT1;
typedef union CPF_PERFCOUNTER1_HI                                regCPF_PERFCOUNTER1_HI;
typedef union CPF_PERFCOUNTER1_LO                                regCPF_PERFCOUNTER1_LO;
typedef union CPF_PERFCOUNTER1_SELECT                            regCPF_PERFCOUNTER1_SELECT;
typedef union CPG_PERFCOUNTER0_HI                                regCPG_PERFCOUNTER0_HI;
typedef union CPG_PERFCOUNTER0_LO                                regCPG_PERFCOUNTER0_LO;
typedef union CPG_PERFCOUNTER0_SELECT                            regCPG_PERFCOUNTER0_SELECT;
typedef union CPG_PERFCOUNTER0_SELECT1                           regCPG_PERFCOUNTER0_SELECT1;
typedef union CPG_PERFCOUNTER1_HI                                regCPG_PERFCOUNTER1_HI;
typedef union CPG_PERFCOUNTER1_LO                                regCPG_PERFCOUNTER1_LO;
typedef union CPG_PERFCOUNTER1_SELECT                            regCPG_PERFCOUNTER1_SELECT;
typedef union CP_APPEND_ADDR_HI                                  regCP_APPEND_ADDR_HI;
typedef union CP_APPEND_ADDR_LO                                  regCP_APPEND_ADDR_LO;
typedef union CP_APPEND_CMD_ADDR_HI                              regCP_APPEND_CMD_ADDR_HI;
typedef union CP_APPEND_CMD_ADDR_LO                              regCP_APPEND_CMD_ADDR_LO;
typedef union CP_APPEND_DATA                                     regCP_APPEND_DATA;
typedef union CP_APPEND_DATA_HI                                  regCP_APPEND_DATA_HI;
typedef union CP_APPEND_DATA_LO                                  regCP_APPEND_DATA_LO;
typedef union CP_APPEND_DDID_CNT                                 regCP_APPEND_DDID_CNT;
typedef union CP_APPEND_LAST_CS_FENCE                            regCP_APPEND_LAST_CS_FENCE;
typedef union CP_APPEND_LAST_CS_FENCE_HI                         regCP_APPEND_LAST_CS_FENCE_HI;
typedef union CP_APPEND_LAST_CS_FENCE_LO                         regCP_APPEND_LAST_CS_FENCE_LO;
typedef union CP_APPEND_LAST_PS_FENCE                            regCP_APPEND_LAST_PS_FENCE;
typedef union CP_APPEND_LAST_PS_FENCE_HI                         regCP_APPEND_LAST_PS_FENCE_HI;
typedef union CP_APPEND_LAST_PS_FENCE_LO                         regCP_APPEND_LAST_PS_FENCE_LO;
typedef union CP_AQL_SMM_STATUS                                  regCP_AQL_SMM_STATUS;
typedef union CP_ATOMIC_PREOP_HI                                 regCP_ATOMIC_PREOP_HI;
typedef union CP_ATOMIC_PREOP_LO                                 regCP_ATOMIC_PREOP_LO;
typedef union CP_BUSY_STAT                                       regCP_BUSY_STAT;
typedef union CP_CEQ1_AVAIL                                      regCP_CEQ1_AVAIL;
typedef union CP_CEQ2_AVAIL                                      regCP_CEQ2_AVAIL;
typedef union CP_CE_COMPARE_COUNT                                regCP_CE_COMPARE_COUNT;
typedef union CP_CE_COMPLETION_STATUS                            regCP_CE_COMPLETION_STATUS;
typedef union CP_CE_COUNTER                                      regCP_CE_COUNTER;
typedef union CP_CE_CS_PARTITION_INDEX                           regCP_CE_CS_PARTITION_INDEX;
typedef union CP_CE_DB_BASE_HI                                   regCP_CE_DB_BASE_HI;
typedef union CP_CE_DB_BASE_LO                                   regCP_CE_DB_BASE_LO;
typedef union CP_CE_DB_BUFSZ                                     regCP_CE_DB_BUFSZ;
typedef union CP_CE_DB_CMD_BUFSZ                                 regCP_CE_DB_CMD_BUFSZ;
typedef union CP_CE_DE_COUNT                                     regCP_CE_DE_COUNT;
typedef union CP_CE_DOORBELL_CONTROL                             regCP_CE_DOORBELL_CONTROL;
typedef union CP_CE_HEADER_DUMP                                  regCP_CE_HEADER_DUMP;
typedef union CP_CE_IB1_BASE_HI                                  regCP_CE_IB1_BASE_HI;
typedef union CP_CE_IB1_BASE_LO                                  regCP_CE_IB1_BASE_LO;
typedef union CP_CE_IB1_BUFSZ                                    regCP_CE_IB1_BUFSZ;
typedef union CP_CE_IB1_CMD_BUFSZ                                regCP_CE_IB1_CMD_BUFSZ;
typedef union CP_CE_IB1_OFFSET                                   regCP_CE_IB1_OFFSET;
typedef union CP_CE_IB2_BASE_HI                                  regCP_CE_IB2_BASE_HI;
typedef union CP_CE_IB2_BASE_LO                                  regCP_CE_IB2_BASE_LO;
typedef union CP_CE_IB2_BUFSZ                                    regCP_CE_IB2_BUFSZ;
typedef union CP_CE_IB2_CMD_BUFSZ                                regCP_CE_IB2_CMD_BUFSZ;
typedef union CP_CE_IB2_OFFSET                                   regCP_CE_IB2_OFFSET;
typedef union CP_CE_IC_BASE_CNTL                                 regCP_CE_IC_BASE_CNTL;
typedef union CP_CE_IC_BASE_HI                                   regCP_CE_IC_BASE_HI;
typedef union CP_CE_IC_BASE_LO                                   regCP_CE_IC_BASE_LO;
typedef union CP_CE_IC_OP_CNTL                                   regCP_CE_IC_OP_CNTL;
typedef union CP_CE_INIT_BASE_HI                                 regCP_CE_INIT_BASE_HI;
typedef union CP_CE_INIT_BASE_LO                                 regCP_CE_INIT_BASE_LO;
typedef union CP_CE_INIT_BUFSZ                                   regCP_CE_INIT_BUFSZ;
typedef union CP_CE_INIT_CMD_BUFSZ                               regCP_CE_INIT_CMD_BUFSZ;
typedef union CP_CE_INSTR_PNTR                                   regCP_CE_INSTR_PNTR;
typedef union CP_CE_INTR_ROUTINE_START                           regCP_CE_INTR_ROUTINE_START;
typedef union CP_CE_JT_STAT                                      regCP_CE_JT_STAT;
typedef union CP_CE_METADATA_BASE_ADDR                           regCP_CE_METADATA_BASE_ADDR;
typedef union CP_CE_METADATA_BASE_ADDR_HI                        regCP_CE_METADATA_BASE_ADDR_HI;
typedef union CP_CE_PRGRM_CNTR_START                             regCP_CE_PRGRM_CNTR_START;
typedef union CP_CE_RB_OFFSET                                    regCP_CE_RB_OFFSET;
typedef union CP_CE_ROQ_DB_STAT                                  regCP_CE_ROQ_DB_STAT;
typedef union CP_CE_ROQ_IB1_STAT                                 regCP_CE_ROQ_IB1_STAT;
typedef union CP_CE_ROQ_IB2_STAT                                 regCP_CE_ROQ_IB2_STAT;
typedef union CP_CE_ROQ_RB_STAT                                  regCP_CE_ROQ_RB_STAT;
typedef union CP_CMD_DATA                                        regCP_CMD_DATA;
typedef union CP_CMD_INDEX                                       regCP_CMD_INDEX;
typedef union CP_CNTX_STAT                                       regCP_CNTX_STAT;
typedef union CP_COHER_BASE                                      regCP_COHER_BASE;
typedef union CP_COHER_BASE_HI                                   regCP_COHER_BASE_HI;
typedef union CP_COHER_CNTL                                      regCP_COHER_CNTL;
typedef union CP_COHER_SIZE                                      regCP_COHER_SIZE;
typedef union CP_COHER_SIZE_HI                                   regCP_COHER_SIZE_HI;
typedef union CP_COHER_START_DELAY                               regCP_COHER_START_DELAY;
typedef union CP_COHER_STATUS                                    regCP_COHER_STATUS;
typedef union CP_CONTEXT_CNTL                                    regCP_CONTEXT_CNTL;
typedef union CP_CSF_STAT                                        regCP_CSF_STAT;
typedef union CP_DB_BASE_HI                                      regCP_DB_BASE_HI;
typedef union CP_DB_BASE_LO                                      regCP_DB_BASE_LO;
typedef union CP_DB_BUFSZ                                        regCP_DB_BUFSZ;
typedef union CP_DB_CMD_BUFSZ                                    regCP_DB_CMD_BUFSZ;
typedef union CP_DDID_BASE_ADDR_HI                               regCP_DDID_BASE_ADDR_HI;
typedef union CP_DDID_BASE_ADDR_LO                               regCP_DDID_BASE_ADDR_LO;
typedef union CP_DDID_CNTL                                       regCP_DDID_CNTL;
typedef union CP_DEBUG_2                                         regCP_DEBUG_2;
typedef union CP_DEVICE_ID                                       regCP_DEVICE_ID;
typedef union CP_DE_CE_COUNT                                     regCP_DE_CE_COUNT;
typedef union CP_DE_DE_COUNT                                     regCP_DE_DE_COUNT;
typedef union CP_DE_LAST_INVAL_COUNT                             regCP_DE_LAST_INVAL_COUNT;
typedef union CP_DFY_ADDR_HI                                     regCP_DFY_ADDR_HI;
typedef union CP_DFY_ADDR_LO                                     regCP_DFY_ADDR_LO;
typedef union CP_DFY_CMD                                         regCP_DFY_CMD;
typedef union CP_DFY_CNTL                                        regCP_DFY_CNTL;
typedef union CP_DFY_DATA_0                                      regCP_DFY_DATA_0;
typedef union CP_DFY_DATA_1                                      regCP_DFY_DATA_1;
typedef union CP_DFY_DATA_2                                      regCP_DFY_DATA_2;
typedef union CP_DFY_DATA_3                                      regCP_DFY_DATA_3;
typedef union CP_DFY_DATA_4                                      regCP_DFY_DATA_4;
typedef union CP_DFY_DATA_5                                      regCP_DFY_DATA_5;
typedef union CP_DFY_DATA_6                                      regCP_DFY_DATA_6;
typedef union CP_DFY_DATA_7                                      regCP_DFY_DATA_7;
typedef union CP_DFY_DATA_8                                      regCP_DFY_DATA_8;
typedef union CP_DFY_DATA_9                                      regCP_DFY_DATA_9;
typedef union CP_DFY_DATA_10                                     regCP_DFY_DATA_10;
typedef union CP_DFY_DATA_11                                     regCP_DFY_DATA_11;
typedef union CP_DFY_DATA_12                                     regCP_DFY_DATA_12;
typedef union CP_DFY_DATA_13                                     regCP_DFY_DATA_13;
typedef union CP_DFY_DATA_14                                     regCP_DFY_DATA_14;
typedef union CP_DFY_DATA_15                                     regCP_DFY_DATA_15;
typedef union CP_DFY_STAT                                        regCP_DFY_STAT;
typedef union CP_DISPATCH_INDR_ADDR                              regCP_DISPATCH_INDR_ADDR;
typedef union CP_DISPATCH_INDR_ADDR_HI                           regCP_DISPATCH_INDR_ADDR_HI;
typedef union CP_DMA_CNTL                                        regCP_DMA_CNTL;
typedef union CP_DMA_ME_CMD_ADDR_HI                              regCP_DMA_ME_CMD_ADDR_HI;
typedef union CP_DMA_ME_CMD_ADDR_LO                              regCP_DMA_ME_CMD_ADDR_LO;
typedef union CP_DMA_ME_COMMAND                                  regCP_DMA_ME_COMMAND;
typedef union CP_DMA_ME_CONTROL                                  regCP_DMA_ME_CONTROL;
typedef union CP_DMA_ME_DST_ADDR                                 regCP_DMA_ME_DST_ADDR;
typedef union CP_DMA_ME_DST_ADDR_HI                              regCP_DMA_ME_DST_ADDR_HI;
typedef union CP_DMA_ME_SRC_ADDR                                 regCP_DMA_ME_SRC_ADDR;
typedef union CP_DMA_ME_SRC_ADDR_HI                              regCP_DMA_ME_SRC_ADDR_HI;
typedef union CP_DMA_PFP_CMD_ADDR_HI                             regCP_DMA_PFP_CMD_ADDR_HI;
typedef union CP_DMA_PFP_CMD_ADDR_LO                             regCP_DMA_PFP_CMD_ADDR_LO;
typedef union CP_DMA_PFP_COMMAND                                 regCP_DMA_PFP_COMMAND;
typedef union CP_DMA_PFP_CONTROL                                 regCP_DMA_PFP_CONTROL;
typedef union CP_DMA_PFP_DST_ADDR                                regCP_DMA_PFP_DST_ADDR;
typedef union CP_DMA_PFP_DST_ADDR_HI                             regCP_DMA_PFP_DST_ADDR_HI;
typedef union CP_DMA_PFP_SRC_ADDR                                regCP_DMA_PFP_SRC_ADDR;
typedef union CP_DMA_PFP_SRC_ADDR_HI                             regCP_DMA_PFP_SRC_ADDR_HI;
typedef union CP_DMA_PIO_COMMAND                                 regCP_DMA_PIO_COMMAND;
typedef union CP_DMA_READ_TAGS                                   regCP_DMA_READ_TAGS;
typedef union CP_DMA_WATCH0_ADDR_HI                              regCP_DMA_WATCH0_ADDR_HI;
typedef union CP_DMA_WATCH0_ADDR_LO                              regCP_DMA_WATCH0_ADDR_LO;
typedef union CP_DMA_WATCH0_CNTL                                 regCP_DMA_WATCH0_CNTL;
typedef union CP_DMA_WATCH0_MASK                                 regCP_DMA_WATCH0_MASK;
typedef union CP_DMA_WATCH1_ADDR_HI                              regCP_DMA_WATCH1_ADDR_HI;
typedef union CP_DMA_WATCH1_ADDR_LO                              regCP_DMA_WATCH1_ADDR_LO;
typedef union CP_DMA_WATCH1_CNTL                                 regCP_DMA_WATCH1_CNTL;
typedef union CP_DMA_WATCH1_MASK                                 regCP_DMA_WATCH1_MASK;
typedef union CP_DMA_WATCH2_ADDR_HI                              regCP_DMA_WATCH2_ADDR_HI;
typedef union CP_DMA_WATCH2_ADDR_LO                              regCP_DMA_WATCH2_ADDR_LO;
typedef union CP_DMA_WATCH2_CNTL                                 regCP_DMA_WATCH2_CNTL;
typedef union CP_DMA_WATCH2_MASK                                 regCP_DMA_WATCH2_MASK;
typedef union CP_DMA_WATCH3_ADDR_HI                              regCP_DMA_WATCH3_ADDR_HI;
typedef union CP_DMA_WATCH3_ADDR_LO                              regCP_DMA_WATCH3_ADDR_LO;
typedef union CP_DMA_WATCH3_CNTL                                 regCP_DMA_WATCH3_CNTL;
typedef union CP_DMA_WATCH3_MASK                                 regCP_DMA_WATCH3_MASK;
typedef union CP_DMA_WATCH_STAT                                  regCP_DMA_WATCH_STAT;
typedef union CP_DMA_WATCH_STAT_ADDR_HI                          regCP_DMA_WATCH_STAT_ADDR_HI;
typedef union CP_DMA_WATCH_STAT_ADDR_LO                          regCP_DMA_WATCH_STAT_ADDR_LO;
typedef union CP_DRAW_INDX_INDR_ADDR                             regCP_DRAW_INDX_INDR_ADDR;
typedef union CP_DRAW_INDX_INDR_ADDR_HI                          regCP_DRAW_INDX_INDR_ADDR_HI;
typedef union CP_DRAW_OBJECT                                     regCP_DRAW_OBJECT;
typedef union CP_DRAW_OBJECT_COUNTER                             regCP_DRAW_OBJECT_COUNTER;
typedef union CP_DRAW_WINDOW_CNTL                                regCP_DRAW_WINDOW_CNTL;
typedef union CP_DRAW_WINDOW_HI                                  regCP_DRAW_WINDOW_HI;
typedef union CP_DRAW_WINDOW_LO                                  regCP_DRAW_WINDOW_LO;
typedef union CP_DRAW_WINDOW_MASK_HI                             regCP_DRAW_WINDOW_MASK_HI;
typedef union CP_ECC_DMA_FIRST_OCCURRENCE                        regCP_ECC_DMA_FIRST_OCCURRENCE;
typedef union CP_ECC_FIRSTOCCURRENCE                             regCP_ECC_FIRSTOCCURRENCE;
typedef union CP_ECC_FIRSTOCCURRENCE_RING0                       regCP_ECC_FIRSTOCCURRENCE_RING0;
typedef union CP_ECC_FIRSTOCCURRENCE_RING1                       regCP_ECC_FIRSTOCCURRENCE_RING1;
typedef union CP_ECC_FIRSTOCCURRENCE_RING2                       regCP_ECC_FIRSTOCCURRENCE_RING2;
typedef union CP_EDC_FUE_CNTL                                    regCP_EDC_FUE_CNTL;
typedef union CP_EOPQ_WAIT_TIME                                  regCP_EOPQ_WAIT_TIME;
typedef union CP_EOP_DONE_ADDR_HI                                regCP_EOP_DONE_ADDR_HI;
typedef union CP_EOP_DONE_ADDR_LO                                regCP_EOP_DONE_ADDR_LO;
typedef union CP_EOP_DONE_CNTX_ID                                regCP_EOP_DONE_CNTX_ID;
typedef union CP_EOP_DONE_DATA_CNTL                              regCP_EOP_DONE_DATA_CNTL;
typedef union CP_EOP_DONE_DATA_HI                                regCP_EOP_DONE_DATA_HI;
typedef union CP_EOP_DONE_DATA_LO                                regCP_EOP_DONE_DATA_LO;
typedef union CP_EOP_DONE_DOORBELL                               regCP_EOP_DONE_DOORBELL;
typedef union CP_EOP_DONE_EVENT_CNTL                             regCP_EOP_DONE_EVENT_CNTL;
typedef union CP_EOP_LAST_FENCE_HI                               regCP_EOP_LAST_FENCE_HI;
typedef union CP_EOP_LAST_FENCE_LO                               regCP_EOP_LAST_FENCE_LO;
typedef union CP_FATAL_ERROR                                     regCP_FATAL_ERROR;
typedef union CP_FETCHER_SOURCE                                  regCP_FETCHER_SOURCE;
typedef union CP_GFX_DDID_DELTA_RPT_COUNT                        regCP_GFX_DDID_DELTA_RPT_COUNT;
typedef union CP_GFX_DDID_INFLIGHT_COUNT                         regCP_GFX_DDID_INFLIGHT_COUNT;
typedef union CP_GFX_DDID_RPTR                                   regCP_GFX_DDID_RPTR;
typedef union CP_GFX_DDID_WPTR                                   regCP_GFX_DDID_WPTR;
typedef union CP_GFX_ERROR                                       regCP_GFX_ERROR;
typedef union CP_GFX_HPD_CONTROL0                                regCP_GFX_HPD_CONTROL0;
typedef union CP_GFX_HPD_OSPRE_FENCE_ADDR_HI                     regCP_GFX_HPD_OSPRE_FENCE_ADDR_HI;
typedef union CP_GFX_HPD_OSPRE_FENCE_ADDR_LO                     regCP_GFX_HPD_OSPRE_FENCE_ADDR_LO;
typedef union CP_GFX_HPD_OSPRE_FENCE_DATA_HI                     regCP_GFX_HPD_OSPRE_FENCE_DATA_HI;
typedef union CP_GFX_HPD_OSPRE_FENCE_DATA_LO                     regCP_GFX_HPD_OSPRE_FENCE_DATA_LO;
typedef union CP_GFX_HPD_STATUS0                                 regCP_GFX_HPD_STATUS0;
typedef union CP_GFX_HQD_ACTIVE                                  regCP_GFX_HQD_ACTIVE;
typedef union CP_GFX_HQD_BASE                                    regCP_GFX_HQD_BASE;
typedef union CP_GFX_HQD_BASE_HI                                 regCP_GFX_HQD_BASE_HI;
typedef union CP_GFX_HQD_CE_BASE                                 regCP_GFX_HQD_CE_BASE;
typedef union CP_GFX_HQD_CE_BASE_HI                              regCP_GFX_HQD_CE_BASE_HI;
typedef union CP_GFX_HQD_CE_CNTL                                 regCP_GFX_HQD_CE_CNTL;
typedef union CP_GFX_HQD_CE_CSMD_RPTR                            regCP_GFX_HQD_CE_CSMD_RPTR;
typedef union CP_GFX_HQD_CE_OFFSET                               regCP_GFX_HQD_CE_OFFSET;
typedef union CP_GFX_HQD_CE_RPTR                                 regCP_GFX_HQD_CE_RPTR;
typedef union CP_GFX_HQD_CE_RPTR_ADDR                            regCP_GFX_HQD_CE_RPTR_ADDR;
typedef union CP_GFX_HQD_CE_RPTR_ADDR_HI                         regCP_GFX_HQD_CE_RPTR_ADDR_HI;
typedef union CP_GFX_HQD_CE_RPTR_WR                              regCP_GFX_HQD_CE_RPTR_WR;
typedef union CP_GFX_HQD_CE_WPTR                                 regCP_GFX_HQD_CE_WPTR;
typedef union CP_GFX_HQD_CE_WPTR_HI                              regCP_GFX_HQD_CE_WPTR_HI;
typedef union CP_GFX_HQD_CE_WPTR_POLL_ADDR_HI                    regCP_GFX_HQD_CE_WPTR_POLL_ADDR_HI;
typedef union CP_GFX_HQD_CE_WPTR_POLL_ADDR_LO                    regCP_GFX_HQD_CE_WPTR_POLL_ADDR_LO;
typedef union CP_GFX_HQD_CNTL                                    regCP_GFX_HQD_CNTL;
typedef union CP_GFX_HQD_CSMD_RPTR                               regCP_GFX_HQD_CSMD_RPTR;
typedef union CP_GFX_HQD_DEQUEUE_REQUEST                         regCP_GFX_HQD_DEQUEUE_REQUEST;
typedef union CP_GFX_HQD_HQ_CONTROL0                             regCP_GFX_HQD_HQ_CONTROL0;
typedef union CP_GFX_HQD_HQ_STATUS0                              regCP_GFX_HQD_HQ_STATUS0;
typedef union CP_GFX_HQD_MAPPED                                  regCP_GFX_HQD_MAPPED;
typedef union CP_GFX_HQD_OFFSET                                  regCP_GFX_HQD_OFFSET;
typedef union CP_GFX_HQD_QUANTUM                                 regCP_GFX_HQD_QUANTUM;
typedef union CP_GFX_HQD_QUEUE_PRIORITY                          regCP_GFX_HQD_QUEUE_PRIORITY;
typedef union CP_GFX_HQD_QUE_MGR_CONTROL                         regCP_GFX_HQD_QUE_MGR_CONTROL;
typedef union CP_GFX_HQD_RPTR                                    regCP_GFX_HQD_RPTR;
typedef union CP_GFX_HQD_RPTR_ADDR                               regCP_GFX_HQD_RPTR_ADDR;
typedef union CP_GFX_HQD_RPTR_ADDR_HI                            regCP_GFX_HQD_RPTR_ADDR_HI;
typedef union CP_GFX_HQD_VMID                                    regCP_GFX_HQD_VMID;
typedef union CP_GFX_HQD_WPTR                                    regCP_GFX_HQD_WPTR;
typedef union CP_GFX_HQD_WPTR_HI                                 regCP_GFX_HQD_WPTR_HI;
typedef union CP_GFX_INDEX_MUTEX                                 regCP_GFX_INDEX_MUTEX;
typedef union CP_GFX_MQD_BASE_ADDR                               regCP_GFX_MQD_BASE_ADDR;
typedef union CP_GFX_MQD_BASE_ADDR_HI                            regCP_GFX_MQD_BASE_ADDR_HI;
typedef union CP_GFX_MQD_CONTROL                                 regCP_GFX_MQD_CONTROL;
typedef union CP_GFX_QUEUE_INDEX                                 regCP_GFX_QUEUE_INDEX;
typedef union CP_GRBM_FREE_COUNT                                 regCP_GRBM_FREE_COUNT;
typedef union CP_HPD_MES_ROQ_OFFSETS                             regCP_HPD_MES_ROQ_OFFSETS;
typedef union CP_HPD_ROQ_OFFSETS                                 regCP_HPD_ROQ_OFFSETS;
typedef union CP_HPD_STATUS0                                     regCP_HPD_STATUS0;
typedef union CP_HPD_UTCL1_CNTL                                  regCP_HPD_UTCL1_CNTL;
typedef union CP_HPD_UTCL1_ERROR                                 regCP_HPD_UTCL1_ERROR;
typedef union CP_HPD_UTCL1_ERROR_ADDR                            regCP_HPD_UTCL1_ERROR_ADDR;
typedef union CP_HQD_ACTIVE                                      regCP_HQD_ACTIVE;
typedef union CP_HQD_AQL_CONTROL                                 regCP_HQD_AQL_CONTROL;
typedef union CP_HQD_ATOMIC0_PREOP_HI                            regCP_HQD_ATOMIC0_PREOP_HI;
typedef union CP_HQD_ATOMIC0_PREOP_LO                            regCP_HQD_ATOMIC0_PREOP_LO;
typedef union CP_HQD_ATOMIC1_PREOP_HI                            regCP_HQD_ATOMIC1_PREOP_HI;
typedef union CP_HQD_ATOMIC1_PREOP_LO                            regCP_HQD_ATOMIC1_PREOP_LO;
typedef union CP_HQD_CNTL_STACK_OFFSET                           regCP_HQD_CNTL_STACK_OFFSET;
typedef union CP_HQD_CNTL_STACK_SIZE                             regCP_HQD_CNTL_STACK_SIZE;
typedef union CP_HQD_CTX_SAVE_BASE_ADDR_HI                       regCP_HQD_CTX_SAVE_BASE_ADDR_HI;
typedef union CP_HQD_CTX_SAVE_BASE_ADDR_LO                       regCP_HQD_CTX_SAVE_BASE_ADDR_LO;
typedef union CP_HQD_CTX_SAVE_CONTROL                            regCP_HQD_CTX_SAVE_CONTROL;
typedef union CP_HQD_CTX_SAVE_SIZE                               regCP_HQD_CTX_SAVE_SIZE;
typedef union CP_HQD_DDID_DELTA_RPT_COUNT                        regCP_HQD_DDID_DELTA_RPT_COUNT;
typedef union CP_HQD_DDID_INFLIGHT_COUNT                         regCP_HQD_DDID_INFLIGHT_COUNT;
typedef union CP_HQD_DDID_RPTR                                   regCP_HQD_DDID_RPTR;
typedef union CP_HQD_DDID_WPTR                                   regCP_HQD_DDID_WPTR;
typedef union CP_HQD_DEQUEUE_REQUEST                             regCP_HQD_DEQUEUE_REQUEST;
typedef union CP_HQD_DEQUEUE_STATUS                              regCP_HQD_DEQUEUE_STATUS;
typedef union CP_HQD_DMA_OFFLOAD                                 regCP_HQD_DMA_OFFLOAD;
typedef union CP_HQD_EOP_BASE_ADDR                               regCP_HQD_EOP_BASE_ADDR;
typedef union CP_HQD_EOP_BASE_ADDR_HI                            regCP_HQD_EOP_BASE_ADDR_HI;
typedef union CP_HQD_EOP_CONTROL                                 regCP_HQD_EOP_CONTROL;
typedef union CP_HQD_EOP_EVENTS                                  regCP_HQD_EOP_EVENTS;
typedef union CP_HQD_EOP_RPTR                                    regCP_HQD_EOP_RPTR;
typedef union CP_HQD_EOP_WPTR                                    regCP_HQD_EOP_WPTR;
typedef union CP_HQD_EOP_WPTR_MEM                                regCP_HQD_EOP_WPTR_MEM;
typedef union CP_HQD_ERROR                                       regCP_HQD_ERROR;
typedef union CP_HQD_GFX_CONTROL                                 regCP_HQD_GFX_CONTROL;
typedef union CP_HQD_GFX_STATUS                                  regCP_HQD_GFX_STATUS;
typedef union CP_HQD_HQ_CONTROL0                                 regCP_HQD_HQ_CONTROL0;
typedef union CP_HQD_HQ_CONTROL1                                 regCP_HQD_HQ_CONTROL1;
typedef union CP_HQD_HQ_SCHEDULER0                               regCP_HQD_HQ_SCHEDULER0;
typedef union CP_HQD_HQ_SCHEDULER1                               regCP_HQD_HQ_SCHEDULER1;
typedef union CP_HQD_HQ_STATUS0                                  regCP_HQD_HQ_STATUS0;
typedef union CP_HQD_HQ_STATUS1                                  regCP_HQD_HQ_STATUS1;
typedef union CP_HQD_IB_BASE_ADDR                                regCP_HQD_IB_BASE_ADDR;
typedef union CP_HQD_IB_BASE_ADDR_HI                             regCP_HQD_IB_BASE_ADDR_HI;
typedef union CP_HQD_IB_CONTROL                                  regCP_HQD_IB_CONTROL;
typedef union CP_HQD_IB_RPTR                                     regCP_HQD_IB_RPTR;
typedef union CP_HQD_IQ_RPTR                                     regCP_HQD_IQ_RPTR;
typedef union CP_HQD_IQ_TIMER                                    regCP_HQD_IQ_TIMER;
typedef union CP_HQD_MSG_TYPE                                    regCP_HQD_MSG_TYPE;
typedef union CP_HQD_OFFLOAD                                     regCP_HQD_OFFLOAD;
typedef union CP_HQD_PERSISTENT_STATE                            regCP_HQD_PERSISTENT_STATE;
typedef union CP_HQD_PIPE_PRIORITY                               regCP_HQD_PIPE_PRIORITY;
typedef union CP_HQD_PQ_BASE                                     regCP_HQD_PQ_BASE;
typedef union CP_HQD_PQ_BASE_HI                                  regCP_HQD_PQ_BASE_HI;
typedef union CP_HQD_PQ_CONTROL                                  regCP_HQD_PQ_CONTROL;
typedef union CP_HQD_PQ_DOORBELL_CONTROL                         regCP_HQD_PQ_DOORBELL_CONTROL;
typedef union CP_HQD_PQ_RPTR                                     regCP_HQD_PQ_RPTR;
typedef union CP_HQD_PQ_RPTR_REPORT_ADDR                         regCP_HQD_PQ_RPTR_REPORT_ADDR;
typedef union CP_HQD_PQ_RPTR_REPORT_ADDR_HI                      regCP_HQD_PQ_RPTR_REPORT_ADDR_HI;
typedef union CP_HQD_PQ_WPTR_HI                                  regCP_HQD_PQ_WPTR_HI;
typedef union CP_HQD_PQ_WPTR_LO                                  regCP_HQD_PQ_WPTR_LO;
typedef union CP_HQD_PQ_WPTR_POLL_ADDR                           regCP_HQD_PQ_WPTR_POLL_ADDR;
typedef union CP_HQD_PQ_WPTR_POLL_ADDR_HI                        regCP_HQD_PQ_WPTR_POLL_ADDR_HI;
typedef union CP_HQD_QUANTUM                                     regCP_HQD_QUANTUM;
typedef union CP_HQD_QUEUE_PRIORITY                              regCP_HQD_QUEUE_PRIORITY;
typedef union CP_HQD_SEMA_CMD                                    regCP_HQD_SEMA_CMD;
typedef union CP_HQD_SUSPEND_CNTL_STACK_DW_CNT                   regCP_HQD_SUSPEND_CNTL_STACK_DW_CNT;
typedef union CP_HQD_SUSPEND_CNTL_STACK_OFFSET                   regCP_HQD_SUSPEND_CNTL_STACK_OFFSET;
typedef union CP_HQD_SUSPEND_WG_STATE_OFFSET                     regCP_HQD_SUSPEND_WG_STATE_OFFSET;
typedef union CP_HQD_VMID                                        regCP_HQD_VMID;
typedef union CP_HQD_WG_STATE_OFFSET                             regCP_HQD_WG_STATE_OFFSET;
typedef union CP_IB1_BASE_HI                                     regCP_IB1_BASE_HI;
typedef union CP_IB1_BASE_LO                                     regCP_IB1_BASE_LO;
typedef union CP_IB1_BUFSZ                                       regCP_IB1_BUFSZ;
typedef union CP_IB1_CMD_BUFSZ                                   regCP_IB1_CMD_BUFSZ;
typedef union CP_IB1_OFFSET                                      regCP_IB1_OFFSET;
typedef union CP_IB1_PREAMBLE_BEGIN                              regCP_IB1_PREAMBLE_BEGIN;
typedef union CP_IB1_PREAMBLE_END                                regCP_IB1_PREAMBLE_END;
typedef union CP_IB2_BASE_HI                                     regCP_IB2_BASE_HI;
typedef union CP_IB2_BASE_LO                                     regCP_IB2_BASE_LO;
typedef union CP_IB2_BUFSZ                                       regCP_IB2_BUFSZ;
typedef union CP_IB2_CMD_BUFSZ                                   regCP_IB2_CMD_BUFSZ;
typedef union CP_IB2_OFFSET                                      regCP_IB2_OFFSET;
typedef union CP_IB2_PREAMBLE_BEGIN                              regCP_IB2_PREAMBLE_BEGIN;
typedef union CP_IB2_PREAMBLE_END                                regCP_IB2_PREAMBLE_END;
typedef union CP_INDEX_BASE_ADDR                                 regCP_INDEX_BASE_ADDR;
typedef union CP_INDEX_BASE_ADDR_HI                              regCP_INDEX_BASE_ADDR_HI;
typedef union CP_INDEX_TYPE                                      regCP_INDEX_TYPE;
typedef union CP_INT_CNTL                                        regCP_INT_CNTL;
typedef union CP_INT_CNTL_RING0                                  regCP_INT_CNTL_RING0;
typedef union CP_INT_CNTL_RING1                                  regCP_INT_CNTL_RING1;
typedef union CP_INT_CNTL_RING2                                  regCP_INT_CNTL_RING2;
typedef union CP_INT_STATUS                                      regCP_INT_STATUS;
typedef union CP_INT_STATUS_RING0                                regCP_INT_STATUS_RING0;
typedef union CP_INT_STATUS_RING1                                regCP_INT_STATUS_RING1;
typedef union CP_INT_STATUS_RING2                                regCP_INT_STATUS_RING2;
typedef union CP_INT_STAT_DEBUG                                  regCP_INT_STAT_DEBUG;
typedef union CP_IQ_WAIT_TIME1                                   regCP_IQ_WAIT_TIME1;
typedef union CP_IQ_WAIT_TIME2                                   regCP_IQ_WAIT_TIME2;
typedef union CP_IQ_WAIT_TIME3                                   regCP_IQ_WAIT_TIME3;
typedef union CP_MAX_CONTEXT                                     regCP_MAX_CONTEXT;
typedef union CP_ME0_PIPE0_PRIORITY                              regCP_ME0_PIPE0_PRIORITY;
typedef union CP_ME0_PIPE0_VMID                                  regCP_ME0_PIPE0_VMID;
typedef union CP_ME0_PIPE1_PRIORITY                              regCP_ME0_PIPE1_PRIORITY;
typedef union CP_ME0_PIPE1_VMID                                  regCP_ME0_PIPE1_VMID;
typedef union CP_ME0_PIPE2_PRIORITY                              regCP_ME0_PIPE2_PRIORITY;
typedef union CP_ME0_PIPE_PRIORITY_CNTS                          regCP_ME0_PIPE_PRIORITY_CNTS;
typedef union CP_ME1_INT_STAT_DEBUG                              regCP_ME1_INT_STAT_DEBUG;
typedef union CP_ME1_PIPE0_INT_CNTL                              regCP_ME1_PIPE0_INT_CNTL;
typedef union CP_ME1_PIPE0_INT_STATUS                            regCP_ME1_PIPE0_INT_STATUS;
typedef union CP_ME1_PIPE0_PRIORITY                              regCP_ME1_PIPE0_PRIORITY;
typedef union CP_ME1_PIPE1_INT_CNTL                              regCP_ME1_PIPE1_INT_CNTL;
typedef union CP_ME1_PIPE1_INT_STATUS                            regCP_ME1_PIPE1_INT_STATUS;
typedef union CP_ME1_PIPE1_PRIORITY                              regCP_ME1_PIPE1_PRIORITY;
typedef union CP_ME1_PIPE2_INT_CNTL                              regCP_ME1_PIPE2_INT_CNTL;
typedef union CP_ME1_PIPE2_INT_STATUS                            regCP_ME1_PIPE2_INT_STATUS;
typedef union CP_ME1_PIPE2_PRIORITY                              regCP_ME1_PIPE2_PRIORITY;
typedef union CP_ME1_PIPE3_INT_CNTL                              regCP_ME1_PIPE3_INT_CNTL;
typedef union CP_ME1_PIPE3_INT_STATUS                            regCP_ME1_PIPE3_INT_STATUS;
typedef union CP_ME1_PIPE3_PRIORITY                              regCP_ME1_PIPE3_PRIORITY;
typedef union CP_ME1_PIPE_PRIORITY_CNTS                          regCP_ME1_PIPE_PRIORITY_CNTS;
typedef union CP_ME2_INT_STAT_DEBUG                              regCP_ME2_INT_STAT_DEBUG;
typedef union CP_ME2_PIPE0_INT_CNTL                              regCP_ME2_PIPE0_INT_CNTL;
typedef union CP_ME2_PIPE0_INT_STATUS                            regCP_ME2_PIPE0_INT_STATUS;
typedef union CP_ME2_PIPE0_PRIORITY                              regCP_ME2_PIPE0_PRIORITY;
typedef union CP_ME2_PIPE1_INT_CNTL                              regCP_ME2_PIPE1_INT_CNTL;
typedef union CP_ME2_PIPE1_INT_STATUS                            regCP_ME2_PIPE1_INT_STATUS;
typedef union CP_ME2_PIPE1_PRIORITY                              regCP_ME2_PIPE1_PRIORITY;
typedef union CP_ME2_PIPE2_INT_CNTL                              regCP_ME2_PIPE2_INT_CNTL;
typedef union CP_ME2_PIPE2_INT_STATUS                            regCP_ME2_PIPE2_INT_STATUS;
typedef union CP_ME2_PIPE2_PRIORITY                              regCP_ME2_PIPE2_PRIORITY;
typedef union CP_ME2_PIPE3_INT_CNTL                              regCP_ME2_PIPE3_INT_CNTL;
typedef union CP_ME2_PIPE3_INT_STATUS                            regCP_ME2_PIPE3_INT_STATUS;
typedef union CP_ME2_PIPE3_PRIORITY                              regCP_ME2_PIPE3_PRIORITY;
typedef union CP_ME2_PIPE_PRIORITY_CNTS                          regCP_ME2_PIPE_PRIORITY_CNTS;
typedef union CP_MEC1_F32_INTERRUPT                              regCP_MEC1_F32_INTERRUPT;
typedef union CP_MEC1_F32_INT_DIS                                regCP_MEC1_F32_INT_DIS;
typedef union CP_MEC1_INSTR_PNTR                                 regCP_MEC1_INSTR_PNTR;
typedef union CP_MEC1_INTR_ROUTINE_START                         regCP_MEC1_INTR_ROUTINE_START;
typedef union CP_MEC1_PRGRM_CNTR_START                           regCP_MEC1_PRGRM_CNTR_START;
typedef union CP_MEC2_F32_INTERRUPT                              regCP_MEC2_F32_INTERRUPT;
typedef union CP_MEC2_F32_INT_DIS                                regCP_MEC2_F32_INT_DIS;
typedef union CP_MEC2_INSTR_PNTR                                 regCP_MEC2_INSTR_PNTR;
typedef union CP_MEC2_INTR_ROUTINE_START                         regCP_MEC2_INTR_ROUTINE_START;
typedef union CP_MEC2_PRGRM_CNTR_START                           regCP_MEC2_PRGRM_CNTR_START;
typedef union CP_MEC_CNTL                                        regCP_MEC_CNTL;
typedef union CP_MEC_DOORBELL_RANGE_LOWER                        regCP_MEC_DOORBELL_RANGE_LOWER;
typedef union CP_MEC_DOORBELL_RANGE_UPPER                        regCP_MEC_DOORBELL_RANGE_UPPER;
typedef union CP_MEC_JT_STAT                                     regCP_MEC_JT_STAT;
typedef union CP_MEC_ME1_HEADER_DUMP                             regCP_MEC_ME1_HEADER_DUMP;
typedef union CP_MEC_ME2_HEADER_DUMP                             regCP_MEC_ME2_HEADER_DUMP;
typedef union CP_MEM_SLP_CNTL                                    regCP_MEM_SLP_CNTL;
typedef union CP_MEQ_AVAIL                                       regCP_MEQ_AVAIL;
typedef union CP_MEQ_STAT                                        regCP_MEQ_STAT;
typedef union CP_MEQ_STQ_THRESHOLD                               regCP_MEQ_STQ_THRESHOLD;
typedef union CP_MEQ_THRESHOLDS                                  regCP_MEQ_THRESHOLDS;
typedef union CP_MES_CNTL                                        regCP_MES_CNTL;
typedef union CP_MES_DCSR                                        regCP_MES_DCSR;
typedef union CP_MES_DC_BASE_CNTL                                regCP_MES_DC_BASE_CNTL;
typedef union CP_MES_DC_BASE_HI                                  regCP_MES_DC_BASE_HI;
typedef union CP_MES_DC_BASE_LO                                  regCP_MES_DC_BASE_LO;
typedef union CP_MES_DC_OP_CNTL                                  regCP_MES_DC_OP_CNTL;
typedef union CP_MES_DMCONTROL                                   regCP_MES_DMCONTROL;
typedef union CP_MES_DMINFO                                      regCP_MES_DMINFO;
typedef union CP_MES_DM_INDEX_ADDR                               regCP_MES_DM_INDEX_ADDR;
typedef union CP_MES_DM_INDEX_DATA                               regCP_MES_DM_INDEX_DATA;
typedef union CP_MES_DOORBELL_CONTROL1                           regCP_MES_DOORBELL_CONTROL1;
typedef union CP_MES_DOORBELL_CONTROL2                           regCP_MES_DOORBELL_CONTROL2;
typedef union CP_MES_DOORBELL_CONTROL3                           regCP_MES_DOORBELL_CONTROL3;
typedef union CP_MES_DOORBELL_CONTROL4                           regCP_MES_DOORBELL_CONTROL4;
typedef union CP_MES_DOORBELL_CONTROL5                           regCP_MES_DOORBELL_CONTROL5;
typedef union CP_MES_DOORBELL_CONTROL6                           regCP_MES_DOORBELL_CONTROL6;
typedef union CP_MES_DPC_HIGH                                    regCP_MES_DPC_HIGH;
typedef union CP_MES_DPC_LOW                                     regCP_MES_DPC_LOW;
typedef union CP_MES_DSCRATCH_HIGH                               regCP_MES_DSCRATCH_HIGH;
typedef union CP_MES_DSCRATCH_LOW                                regCP_MES_DSCRATCH_LOW;
typedef union CP_MES_GP0_HI                                      regCP_MES_GP0_HI;
typedef union CP_MES_GP0_LO                                      regCP_MES_GP0_LO;
typedef union CP_MES_GP1_HI                                      regCP_MES_GP1_HI;
typedef union CP_MES_GP1_LO                                      regCP_MES_GP1_LO;
typedef union CP_MES_GP2_HI                                      regCP_MES_GP2_HI;
typedef union CP_MES_GP2_LO                                      regCP_MES_GP2_LO;
typedef union CP_MES_GP3_HI                                      regCP_MES_GP3_HI;
typedef union CP_MES_GP3_LO                                      regCP_MES_GP3_LO;
typedef union CP_MES_GP4_HI                                      regCP_MES_GP4_HI;
typedef union CP_MES_GP4_LO                                      regCP_MES_GP4_LO;
typedef union CP_MES_GP5_HI                                      regCP_MES_GP5_HI;
typedef union CP_MES_GP5_LO                                      regCP_MES_GP5_LO;
typedef union CP_MES_GP6_HI                                      regCP_MES_GP6_HI;
typedef union CP_MES_GP6_LO                                      regCP_MES_GP6_LO;
typedef union CP_MES_GP7_HI                                      regCP_MES_GP7_HI;
typedef union CP_MES_GP7_LO                                      regCP_MES_GP7_LO;
typedef union CP_MES_GP8_HI                                      regCP_MES_GP8_HI;
typedef union CP_MES_GP8_LO                                      regCP_MES_GP8_LO;
typedef union CP_MES_GP9_HI                                      regCP_MES_GP9_HI;
typedef union CP_MES_GP9_LO                                      regCP_MES_GP9_LO;
typedef union CP_MES_HEADER_DUMP                                 regCP_MES_HEADER_DUMP;
typedef union CP_MES_IC_BASE_CNTL                                regCP_MES_IC_BASE_CNTL;
typedef union CP_MES_IC_BASE_HI                                  regCP_MES_IC_BASE_HI;
typedef union CP_MES_IC_BASE_LO                                  regCP_MES_IC_BASE_LO;
typedef union CP_MES_IC_OP_CNTL                                  regCP_MES_IC_OP_CNTL;
typedef union CP_MES_INSTR_PNTR                                  regCP_MES_INSTR_PNTR;
typedef union CP_MES_INTERRUPT                                   regCP_MES_INTERRUPT;
typedef union CP_MES_INTR_ROUTINE_START                          regCP_MES_INTR_ROUTINE_START;
typedef union CP_MES_LOCAL_APERTURE                              regCP_MES_LOCAL_APERTURE;
typedef union CP_MES_LOCAL_BASE0_HI                              regCP_MES_LOCAL_BASE0_HI;
typedef union CP_MES_LOCAL_BASE0_LO                              regCP_MES_LOCAL_BASE0_LO;
typedef union CP_MES_LOCAL_MASK0_HI                              regCP_MES_LOCAL_MASK0_HI;
typedef union CP_MES_LOCAL_MASK0_LO                              regCP_MES_LOCAL_MASK0_LO;
typedef union CP_MES_MARCHID_HI                                  regCP_MES_MARCHID_HI;
typedef union CP_MES_MARCHID_LO                                  regCP_MES_MARCHID_LO;
typedef union CP_MES_MBADADDR_HI                                 regCP_MES_MBADADDR_HI;
typedef union CP_MES_MBADADDR_LO                                 regCP_MES_MBADADDR_LO;
typedef union CP_MES_MCAUSE_HI                                   regCP_MES_MCAUSE_HI;
typedef union CP_MES_MCAUSE_LO                                   regCP_MES_MCAUSE_LO;
typedef union CP_MES_MCYCLE_HI                                   regCP_MES_MCYCLE_HI;
typedef union CP_MES_MCYCLE_LO                                   regCP_MES_MCYCLE_LO;
typedef union CP_MES_MDBASE_HI                                   regCP_MES_MDBASE_HI;
typedef union CP_MES_MDBASE_LO                                   regCP_MES_MDBASE_LO;
typedef union CP_MES_MDBOUND_HI                                  regCP_MES_MDBOUND_HI;
typedef union CP_MES_MDBOUND_LO                                  regCP_MES_MDBOUND_LO;
typedef union CP_MES_MEPC_HI                                     regCP_MES_MEPC_HI;
typedef union CP_MES_MEPC_LO                                     regCP_MES_MEPC_LO;
typedef union CP_MES_MHARTID_HI                                  regCP_MES_MHARTID_HI;
typedef union CP_MES_MHARTID_LO                                  regCP_MES_MHARTID_LO;
typedef union CP_MES_MIBASE_HI                                   regCP_MES_MIBASE_HI;
typedef union CP_MES_MIBASE_LO                                   regCP_MES_MIBASE_LO;
typedef union CP_MES_MIBOUND_HI                                  regCP_MES_MIBOUND_HI;
typedef union CP_MES_MIBOUND_LO                                  regCP_MES_MIBOUND_LO;
typedef union CP_MES_MIE_HI                                      regCP_MES_MIE_HI;
typedef union CP_MES_MIE_LO                                      regCP_MES_MIE_LO;
typedef union CP_MES_MIMPID_HI                                   regCP_MES_MIMPID_HI;
typedef union CP_MES_MIMPID_LO                                   regCP_MES_MIMPID_LO;
typedef union CP_MES_MINSTRET_HI                                 regCP_MES_MINSTRET_HI;
typedef union CP_MES_MINSTRET_LO                                 regCP_MES_MINSTRET_LO;
typedef union CP_MES_MIP_HI                                      regCP_MES_MIP_HI;
typedef union CP_MES_MIP_LO                                      regCP_MES_MIP_LO;
typedef union CP_MES_MISA_HI                                     regCP_MES_MISA_HI;
typedef union CP_MES_MISA_LO                                     regCP_MES_MISA_LO;
typedef union CP_MES_MSCRATCH_HI                                 regCP_MES_MSCRATCH_HI;
typedef union CP_MES_MSCRATCH_LO                                 regCP_MES_MSCRATCH_LO;
typedef union CP_MES_MSTATUS_HI                                  regCP_MES_MSTATUS_HI;
typedef union CP_MES_MSTATUS_LO                                  regCP_MES_MSTATUS_LO;
typedef union CP_MES_MTIMECMP_HI                                 regCP_MES_MTIMECMP_HI;
typedef union CP_MES_MTIMECMP_LO                                 regCP_MES_MTIMECMP_LO;
typedef union CP_MES_MTIME_HI                                    regCP_MES_MTIME_HI;
typedef union CP_MES_MTIME_LO                                    regCP_MES_MTIME_LO;
typedef union CP_MES_MTVEC_HI                                    regCP_MES_MTVEC_HI;
typedef union CP_MES_MTVEC_LO                                    regCP_MES_MTVEC_LO;
typedef union CP_MES_MVENDORID_HI                                regCP_MES_MVENDORID_HI;
typedef union CP_MES_MVENDORID_LO                                regCP_MES_MVENDORID_LO;
typedef union CP_MES_PERFCOUNT_CNTL                              regCP_MES_PERFCOUNT_CNTL;
typedef union CP_MES_PIPE0_PRIORITY                              regCP_MES_PIPE0_PRIORITY;
typedef union CP_MES_PIPE1_PRIORITY                              regCP_MES_PIPE1_PRIORITY;
typedef union CP_MES_PIPE2_PRIORITY                              regCP_MES_PIPE2_PRIORITY;
typedef union CP_MES_PIPE3_PRIORITY                              regCP_MES_PIPE3_PRIORITY;
typedef union CP_MES_PIPE_PRIORITY_CNTS                          regCP_MES_PIPE_PRIORITY_CNTS;
typedef union CP_MES_PRGRM_CNTR_START                            regCP_MES_PRGRM_CNTR_START;
typedef union CP_MES_PROCESS_QUANTUM_PIPE0                       regCP_MES_PROCESS_QUANTUM_PIPE0;
typedef union CP_MES_PROCESS_QUANTUM_PIPE1                       regCP_MES_PROCESS_QUANTUM_PIPE1;
typedef union CP_MES_SCRATCH_DATA                                regCP_MES_SCRATCH_DATA;
typedef union CP_MES_SCRATCH_INDEX                               regCP_MES_SCRATCH_INDEX;
typedef union CP_MES_SETHALTNOTIFICATION                         regCP_MES_SETHALTNOTIFICATION;
typedef union CP_MES_TDATA1_HIGH                                 regCP_MES_TDATA1_HIGH;
typedef union CP_MES_TDATA1_LOW                                  regCP_MES_TDATA1_LOW;
typedef union CP_MES_TDATA2_HIGH                                 regCP_MES_TDATA2_HIGH;
typedef union CP_MES_TDATA2_LOW                                  regCP_MES_TDATA2_LOW;
typedef union CP_MES_TDATA3_HIH                                  regCP_MES_TDATA3_HIH;
typedef union CP_MES_TDATA3_LOW                                  regCP_MES_TDATA3_LOW;
typedef union CP_MES_TSELCT_HIGH                                 regCP_MES_TSELCT_HIGH;
typedef union CP_MES_TSELCT_LOW                                  regCP_MES_TSELCT_LOW;
typedef union CP_ME_ATOMIC_PREOP_HI                              regCP_ME_ATOMIC_PREOP_HI;
typedef union CP_ME_ATOMIC_PREOP_LO                              regCP_ME_ATOMIC_PREOP_LO;
typedef union CP_ME_CNTL                                         regCP_ME_CNTL;
typedef union CP_ME_COHER_BASE                                   regCP_ME_COHER_BASE;
typedef union CP_ME_COHER_BASE_HI                                regCP_ME_COHER_BASE_HI;
typedef union CP_ME_COHER_CNTL                                   regCP_ME_COHER_CNTL;
typedef union CP_ME_COHER_SIZE                                   regCP_ME_COHER_SIZE;
typedef union CP_ME_COHER_SIZE_HI                                regCP_ME_COHER_SIZE_HI;
typedef union CP_ME_COHER_STATUS                                 regCP_ME_COHER_STATUS;
typedef union CP_ME_HEADER_DUMP                                  regCP_ME_HEADER_DUMP;
typedef union CP_ME_IC_BASE_CNTL                                 regCP_ME_IC_BASE_CNTL;
typedef union CP_ME_IC_BASE_HI                                   regCP_ME_IC_BASE_HI;
typedef union CP_ME_IC_BASE_LO                                   regCP_ME_IC_BASE_LO;
typedef union CP_ME_IC_OP_CNTL                                   regCP_ME_IC_OP_CNTL;
typedef union CP_ME_INSTR_PNTR                                   regCP_ME_INSTR_PNTR;
typedef union CP_ME_INTR_ROUTINE_START                           regCP_ME_INTR_ROUTINE_START;
typedef union CP_ME_MC_RADDR_HI                                  regCP_ME_MC_RADDR_HI;
typedef union CP_ME_MC_RADDR_LO                                  regCP_ME_MC_RADDR_LO;
typedef union CP_ME_MC_WADDR_HI                                  regCP_ME_MC_WADDR_HI;
typedef union CP_ME_MC_WADDR_LO                                  regCP_ME_MC_WADDR_LO;
typedef union CP_ME_MC_WDATA_HI                                  regCP_ME_MC_WDATA_HI;
typedef union CP_ME_MC_WDATA_LO                                  regCP_ME_MC_WDATA_LO;
typedef union CP_ME_PREEMPTION                                   regCP_ME_PREEMPTION;
typedef union CP_ME_PRGRM_CNTR_START                             regCP_ME_PRGRM_CNTR_START;
typedef union CP_ME_RAM_DATA                                     regCP_ME_RAM_DATA;
typedef union CP_ME_RAM_RADDR                                    regCP_ME_RAM_RADDR;
typedef union CP_ME_RAM_WADDR                                    regCP_ME_RAM_WADDR;
typedef union CP_MQD_BASE_ADDR                                   regCP_MQD_BASE_ADDR;
typedef union CP_MQD_BASE_ADDR_HI                                regCP_MQD_BASE_ADDR_HI;
typedef union CP_MQD_CONTROL                                     regCP_MQD_CONTROL;
typedef union CP_NUM_PRIM_NEEDED_COUNT0_HI                       regCP_NUM_PRIM_NEEDED_COUNT0_HI;
typedef union CP_NUM_PRIM_NEEDED_COUNT0_LO                       regCP_NUM_PRIM_NEEDED_COUNT0_LO;
typedef union CP_NUM_PRIM_NEEDED_COUNT1_HI                       regCP_NUM_PRIM_NEEDED_COUNT1_HI;
typedef union CP_NUM_PRIM_NEEDED_COUNT1_LO                       regCP_NUM_PRIM_NEEDED_COUNT1_LO;
typedef union CP_NUM_PRIM_NEEDED_COUNT2_HI                       regCP_NUM_PRIM_NEEDED_COUNT2_HI;
typedef union CP_NUM_PRIM_NEEDED_COUNT2_LO                       regCP_NUM_PRIM_NEEDED_COUNT2_LO;
typedef union CP_NUM_PRIM_NEEDED_COUNT3_HI                       regCP_NUM_PRIM_NEEDED_COUNT3_HI;
typedef union CP_NUM_PRIM_NEEDED_COUNT3_LO                       regCP_NUM_PRIM_NEEDED_COUNT3_LO;
typedef union CP_NUM_PRIM_WRITTEN_COUNT0_HI                      regCP_NUM_PRIM_WRITTEN_COUNT0_HI;
typedef union CP_NUM_PRIM_WRITTEN_COUNT0_LO                      regCP_NUM_PRIM_WRITTEN_COUNT0_LO;
typedef union CP_NUM_PRIM_WRITTEN_COUNT1_HI                      regCP_NUM_PRIM_WRITTEN_COUNT1_HI;
typedef union CP_NUM_PRIM_WRITTEN_COUNT1_LO                      regCP_NUM_PRIM_WRITTEN_COUNT1_LO;
typedef union CP_NUM_PRIM_WRITTEN_COUNT2_HI                      regCP_NUM_PRIM_WRITTEN_COUNT2_HI;
typedef union CP_NUM_PRIM_WRITTEN_COUNT2_LO                      regCP_NUM_PRIM_WRITTEN_COUNT2_LO;
typedef union CP_NUM_PRIM_WRITTEN_COUNT3_HI                      regCP_NUM_PRIM_WRITTEN_COUNT3_HI;
typedef union CP_NUM_PRIM_WRITTEN_COUNT3_LO                      regCP_NUM_PRIM_WRITTEN_COUNT3_LO;
typedef union CP_PA_CINVOC_COUNT_HI                              regCP_PA_CINVOC_COUNT_HI;
typedef union CP_PA_CINVOC_COUNT_LO                              regCP_PA_CINVOC_COUNT_LO;
typedef union CP_PA_CPRIM_COUNT_HI                               regCP_PA_CPRIM_COUNT_HI;
typedef union CP_PA_CPRIM_COUNT_LO                               regCP_PA_CPRIM_COUNT_LO;
typedef union CP_PERFMON_CNTL                                    regCP_PERFMON_CNTL;
typedef union CP_PERFMON_CNTX_CNTL                               regCP_PERFMON_CNTX_CNTL;
typedef union CP_PFP_ATOMIC_PREOP_HI                             regCP_PFP_ATOMIC_PREOP_HI;
typedef union CP_PFP_ATOMIC_PREOP_LO                             regCP_PFP_ATOMIC_PREOP_LO;
typedef union CP_PFP_COMPLETION_STATUS                           regCP_PFP_COMPLETION_STATUS;
typedef union CP_PFP_F32_INTERRUPT                               regCP_PFP_F32_INTERRUPT;
typedef union CP_PFP_HEADER_DUMP                                 regCP_PFP_HEADER_DUMP;
typedef union CP_PFP_IB_CONTROL                                  regCP_PFP_IB_CONTROL;
typedef union CP_PFP_IC_BASE_CNTL                                regCP_PFP_IC_BASE_CNTL;
typedef union CP_PFP_IC_BASE_HI                                  regCP_PFP_IC_BASE_HI;
typedef union CP_PFP_IC_BASE_LO                                  regCP_PFP_IC_BASE_LO;
typedef union CP_PFP_IC_OP_CNTL                                  regCP_PFP_IC_OP_CNTL;
typedef union CP_PFP_INSTR_PNTR                                  regCP_PFP_INSTR_PNTR;
typedef union CP_PFP_INTR_ROUTINE_START                          regCP_PFP_INTR_ROUTINE_START;
typedef union CP_PFP_JT_STAT                                     regCP_PFP_JT_STAT;
typedef union CP_PFP_LOAD_CONTROL                                regCP_PFP_LOAD_CONTROL;
typedef union CP_PFP_METADATA_BASE_ADDR                          regCP_PFP_METADATA_BASE_ADDR;
typedef union CP_PFP_METADATA_BASE_ADDR_HI                       regCP_PFP_METADATA_BASE_ADDR_HI;
typedef union CP_PFP_PRGRM_CNTR_START                            regCP_PFP_PRGRM_CNTR_START;
typedef union CP_PIPEID                                          regCP_PIPEID;
typedef union CP_PIPE_STATS_ADDR_HI                              regCP_PIPE_STATS_ADDR_HI;
typedef union CP_PIPE_STATS_ADDR_LO                              regCP_PIPE_STATS_ADDR_LO;
typedef union CP_PIPE_STATS_CONTROL                              regCP_PIPE_STATS_CONTROL;
typedef union CP_PIPE_STATS_DOORBELL                             regCP_PIPE_STATS_DOORBELL;
typedef union CP_PQ_STATUS                                       regCP_PQ_STATUS;
typedef union CP_PQ_WPTR_POLL_CNTL                               regCP_PQ_WPTR_POLL_CNTL;
typedef union CP_PQ_WPTR_POLL_CNTL1                              regCP_PQ_WPTR_POLL_CNTL1;
typedef union CP_PRED_NOT_VISIBLE                                regCP_PRED_NOT_VISIBLE;
typedef union CP_PROCESS_QUANTUM                                 regCP_PROCESS_QUANTUM;
typedef union CP_PRT_LOD_STATS_CNTL0                             regCP_PRT_LOD_STATS_CNTL0;
typedef union CP_PRT_LOD_STATS_CNTL1                             regCP_PRT_LOD_STATS_CNTL1;
typedef union CP_PRT_LOD_STATS_CNTL2                             regCP_PRT_LOD_STATS_CNTL2;
typedef union CP_PRT_LOD_STATS_CNTL3                             regCP_PRT_LOD_STATS_CNTL3;
typedef union CP_PWR_CNTL                                        regCP_PWR_CNTL;
typedef union CP_QUEUE_THRESHOLDS                                regCP_QUEUE_THRESHOLDS;
typedef union CP_RB0_ACTIVE                                      regCP_RB0_ACTIVE;
typedef union CP_RB0_BASE                                        regCP_RB0_BASE;
typedef union CP_RB0_BASE_HI                                     regCP_RB0_BASE_HI;
typedef union CP_RB0_BUFSZ_MASK                                  regCP_RB0_BUFSZ_MASK;
typedef union CP_RB0_CNTL                                        regCP_RB0_CNTL;
typedef union CP_RB0_RPTR                                        regCP_RB0_RPTR;
typedef union CP_RB0_RPTR_ADDR                                   regCP_RB0_RPTR_ADDR;
typedef union CP_RB0_RPTR_ADDR_HI                                regCP_RB0_RPTR_ADDR_HI;
typedef union CP_RB0_WPTR                                        regCP_RB0_WPTR;
typedef union CP_RB0_WPTR_HI                                     regCP_RB0_WPTR_HI;
typedef union CP_RB1_ACTIVE                                      regCP_RB1_ACTIVE;
typedef union CP_RB1_BASE                                        regCP_RB1_BASE;
typedef union CP_RB1_BASE_HI                                     regCP_RB1_BASE_HI;
typedef union CP_RB1_BUFSZ_MASK                                  regCP_RB1_BUFSZ_MASK;
typedef union CP_RB1_CNTL                                        regCP_RB1_CNTL;
typedef union CP_RB1_RPTR                                        regCP_RB1_RPTR;
typedef union CP_RB1_RPTR_ADDR                                   regCP_RB1_RPTR_ADDR;
typedef union CP_RB1_RPTR_ADDR_HI                                regCP_RB1_RPTR_ADDR_HI;
typedef union CP_RB1_WPTR                                        regCP_RB1_WPTR;
typedef union CP_RB1_WPTR_HI                                     regCP_RB1_WPTR_HI;
typedef union CP_RB2_BASE                                        regCP_RB2_BASE;
typedef union CP_RB2_CNTL                                        regCP_RB2_CNTL;
typedef union CP_RB2_RPTR                                        regCP_RB2_RPTR;
typedef union CP_RB2_RPTR_ADDR                                   regCP_RB2_RPTR_ADDR;
typedef union CP_RB2_RPTR_ADDR_HI                                regCP_RB2_RPTR_ADDR_HI;
typedef union CP_RB2_WPTR                                        regCP_RB2_WPTR;
typedef union CP_RB_ACTIVE                                       regCP_RB_ACTIVE;
typedef union CP_RB_BASE                                         regCP_RB_BASE;
typedef union CP_RB_BUFSZ_MASK                                   regCP_RB_BUFSZ_MASK;
typedef union CP_RB_CNTL                                         regCP_RB_CNTL;
typedef union CP_RB_DOORBELL_CLEAR                               regCP_RB_DOORBELL_CLEAR;
typedef union CP_RB_DOORBELL_CONTROL                             regCP_RB_DOORBELL_CONTROL;
typedef union CP_RB_DOORBELL_CONTROL_SCH_0                       regCP_RB_DOORBELL_CONTROL_SCH_0;
typedef union CP_RB_DOORBELL_CONTROL_SCH_1                       regCP_RB_DOORBELL_CONTROL_SCH_1;
typedef union CP_RB_DOORBELL_CONTROL_SCH_2                       regCP_RB_DOORBELL_CONTROL_SCH_2;
typedef union CP_RB_DOORBELL_CONTROL_SCH_3                       regCP_RB_DOORBELL_CONTROL_SCH_3;
typedef union CP_RB_DOORBELL_CONTROL_SCH_4                       regCP_RB_DOORBELL_CONTROL_SCH_4;
typedef union CP_RB_DOORBELL_CONTROL_SCH_5                       regCP_RB_DOORBELL_CONTROL_SCH_5;
typedef union CP_RB_DOORBELL_CONTROL_SCH_6                       regCP_RB_DOORBELL_CONTROL_SCH_6;
typedef union CP_RB_DOORBELL_CONTROL_SCH_7                       regCP_RB_DOORBELL_CONTROL_SCH_7;
typedef union CP_RB_DOORBELL_RANGE_LOWER                         regCP_RB_DOORBELL_RANGE_LOWER;
typedef union CP_RB_DOORBELL_RANGE_UPPER                         regCP_RB_DOORBELL_RANGE_UPPER;
typedef union CP_RB_OFFSET                                       regCP_RB_OFFSET;
typedef union CP_RB_RPTR                                         regCP_RB_RPTR;
typedef union CP_RB_RPTR_ADDR                                    regCP_RB_RPTR_ADDR;
typedef union CP_RB_RPTR_ADDR_HI                                 regCP_RB_RPTR_ADDR_HI;
typedef union CP_RB_RPTR_WR                                      regCP_RB_RPTR_WR;
typedef union CP_RB_STATUS                                       regCP_RB_STATUS;
typedef union CP_RB_VMID                                         regCP_RB_VMID;
typedef union CP_RB_WPTR                                         regCP_RB_WPTR;
typedef union CP_RB_WPTR_DELAY                                   regCP_RB_WPTR_DELAY;
typedef union CP_RB_WPTR_HI                                      regCP_RB_WPTR_HI;
typedef union CP_RB_WPTR_POLL_ADDR_HI                            regCP_RB_WPTR_POLL_ADDR_HI;
typedef union CP_RB_WPTR_POLL_ADDR_LO                            regCP_RB_WPTR_POLL_ADDR_LO;
typedef union CP_RB_WPTR_POLL_CNTL                               regCP_RB_WPTR_POLL_CNTL;
typedef union CP_RING0_PRIORITY                                  regCP_RING0_PRIORITY;
typedef union CP_RING1_PRIORITY                                  regCP_RING1_PRIORITY;
typedef union CP_RING2_PRIORITY                                  regCP_RING2_PRIORITY;
typedef union CP_RINGID                                          regCP_RINGID;
typedef union CP_RING_PRIORITY_CNTS                              regCP_RING_PRIORITY_CNTS;
typedef union CP_ROQ1_THRESHOLDS                                 regCP_ROQ1_THRESHOLDS;
typedef union CP_ROQ2_AVAIL                                      regCP_ROQ2_AVAIL;
typedef union CP_ROQ2_THRESHOLDS                                 regCP_ROQ2_THRESHOLDS;
typedef union CP_ROQ3_THRESHOLDS                                 regCP_ROQ3_THRESHOLDS;
typedef union CP_ROQ_AVAIL                                       regCP_ROQ_AVAIL;
typedef union CP_ROQ_DB_STAT                                     regCP_ROQ_DB_STAT;
typedef union CP_ROQ_IB1_STAT                                    regCP_ROQ_IB1_STAT;
typedef union CP_ROQ_IB2_STAT                                    regCP_ROQ_IB2_STAT;
typedef union CP_ROQ_RB_STAT                                     regCP_ROQ_RB_STAT;
typedef union CP_ROQ_THRESHOLDS                                  regCP_ROQ_THRESHOLDS;
typedef union CP_SAMPLE_STATUS                                   regCP_SAMPLE_STATUS;
typedef union CP_SCRATCH_DATA                                    regCP_SCRATCH_DATA;
typedef union CP_SCRATCH_INDEX                                   regCP_SCRATCH_INDEX;
typedef union CP_SC_PSINVOC_COUNT0_HI                            regCP_SC_PSINVOC_COUNT0_HI;
typedef union CP_SC_PSINVOC_COUNT0_LO                            regCP_SC_PSINVOC_COUNT0_LO;
typedef union CP_SC_PSINVOC_COUNT1_HI                            regCP_SC_PSINVOC_COUNT1_HI;
typedef union CP_SC_PSINVOC_COUNT1_LO                            regCP_SC_PSINVOC_COUNT1_LO;
typedef union CP_SD_CNTL                                         regCP_SD_CNTL;
typedef union CP_SEM_DOORBELL                                    regCP_SEM_DOORBELL;
typedef union CP_SEM_WAIT_TIMER                                  regCP_SEM_WAIT_TIMER;
typedef union CP_SIG_SEM_ADDR_HI                                 regCP_SIG_SEM_ADDR_HI;
typedef union CP_SIG_SEM_ADDR_LO                                 regCP_SIG_SEM_ADDR_LO;
typedef union CP_SOFT_RESET_CNTL                                 regCP_SOFT_RESET_CNTL;
typedef union CP_STALLED_STAT1                                   regCP_STALLED_STAT1;
typedef union CP_STALLED_STAT2                                   regCP_STALLED_STAT2;
typedef union CP_STALLED_STAT3                                   regCP_STALLED_STAT3;
typedef union CP_STAT                                            regCP_STAT;
typedef union CP_STQ_AVAIL                                       regCP_STQ_AVAIL;
typedef union CP_STQ_STAT                                        regCP_STQ_STAT;
typedef union CP_STQ_THRESHOLDS                                  regCP_STQ_THRESHOLDS;
typedef union CP_STQ_WR_STAT                                     regCP_STQ_WR_STAT;
typedef union CP_STREAM_OUT_ADDR_HI                              regCP_STREAM_OUT_ADDR_HI;
typedef union CP_STREAM_OUT_ADDR_LO                              regCP_STREAM_OUT_ADDR_LO;
typedef union CP_STREAM_OUT_CONTROL                              regCP_STREAM_OUT_CONTROL;
typedef union CP_STREAM_OUT_DOORBELL                             regCP_STREAM_OUT_DOORBELL;
typedef union CP_STRMOUT_CNTL                                    regCP_STRMOUT_CNTL;
typedef union CP_ST_BASE_HI                                      regCP_ST_BASE_HI;
typedef union CP_ST_BASE_LO                                      regCP_ST_BASE_LO;
typedef union CP_ST_BUFSZ                                        regCP_ST_BUFSZ;
typedef union CP_ST_CMD_BUFSZ                                    regCP_ST_CMD_BUFSZ;
typedef union CP_SUSPEND_CNTL                                    regCP_SUSPEND_CNTL;
typedef union CP_SUSPEND_RESUME_REQ                              regCP_SUSPEND_RESUME_REQ;
typedef union CP_VGT_CSINVOC_COUNT_HI                            regCP_VGT_CSINVOC_COUNT_HI;
typedef union CP_VGT_CSINVOC_COUNT_LO                            regCP_VGT_CSINVOC_COUNT_LO;
typedef union CP_VGT_DSINVOC_COUNT_HI                            regCP_VGT_DSINVOC_COUNT_HI;
typedef union CP_VGT_DSINVOC_COUNT_LO                            regCP_VGT_DSINVOC_COUNT_LO;
typedef union CP_VGT_GSINVOC_COUNT_HI                            regCP_VGT_GSINVOC_COUNT_HI;
typedef union CP_VGT_GSINVOC_COUNT_LO                            regCP_VGT_GSINVOC_COUNT_LO;
typedef union CP_VGT_GSPRIM_COUNT_HI                             regCP_VGT_GSPRIM_COUNT_HI;
typedef union CP_VGT_GSPRIM_COUNT_LO                             regCP_VGT_GSPRIM_COUNT_LO;
typedef union CP_VGT_HSINVOC_COUNT_HI                            regCP_VGT_HSINVOC_COUNT_HI;
typedef union CP_VGT_HSINVOC_COUNT_LO                            regCP_VGT_HSINVOC_COUNT_LO;
typedef union CP_VGT_IAPRIM_COUNT_HI                             regCP_VGT_IAPRIM_COUNT_HI;
typedef union CP_VGT_IAPRIM_COUNT_LO                             regCP_VGT_IAPRIM_COUNT_LO;
typedef union CP_VGT_IAVERT_COUNT_HI                             regCP_VGT_IAVERT_COUNT_HI;
typedef union CP_VGT_IAVERT_COUNT_LO                             regCP_VGT_IAVERT_COUNT_LO;
typedef union CP_VGT_VSINVOC_COUNT_HI                            regCP_VGT_VSINVOC_COUNT_HI;
typedef union CP_VGT_VSINVOC_COUNT_LO                            regCP_VGT_VSINVOC_COUNT_LO;
typedef union CP_VIRT_STATUS                                     regCP_VIRT_STATUS;
typedef union CP_VMID                                            regCP_VMID;
typedef union CP_VMID_PREEMPT                                    regCP_VMID_PREEMPT;
typedef union CP_VMID_RESET                                      regCP_VMID_RESET;
typedef union CP_VMID_STATUS                                     regCP_VMID_STATUS;
typedef union CP_WAIT_REG_MEM_TIMEOUT                            regCP_WAIT_REG_MEM_TIMEOUT;
typedef union CP_WAIT_SEM_ADDR_HI                                regCP_WAIT_SEM_ADDR_HI;
typedef union CP_WAIT_SEM_ADDR_LO                                regCP_WAIT_SEM_ADDR_LO;
typedef union CSPRIV_CONNECT                                     regCSPRIV_CONNECT;
typedef union CS_COPY_STATE                                      regCS_COPY_STATE;
typedef union DB_ALPHA_TO_MASK                                   regDB_ALPHA_TO_MASK;
typedef union DB_CGTT_CLK_CTRL_0                                 regDB_CGTT_CLK_CTRL_0;
typedef union DB_COUNT_CONTROL                                   regDB_COUNT_CONTROL;
typedef union DB_CREDIT_LIMIT                                    regDB_CREDIT_LIMIT;
typedef union DB_DEBUG                                           regDB_DEBUG;
typedef union DB_DEBUG2                                          regDB_DEBUG2;
typedef union DB_DEBUG3                                          regDB_DEBUG3;
typedef union DB_DEBUG4                                          regDB_DEBUG4;
typedef union DB_DEPTH_BOUNDS_MAX                                regDB_DEPTH_BOUNDS_MAX;
typedef union DB_DEPTH_BOUNDS_MIN                                regDB_DEPTH_BOUNDS_MIN;
typedef union DB_DEPTH_CLEAR                                     regDB_DEPTH_CLEAR;
typedef union DB_DEPTH_CONTROL                                   regDB_DEPTH_CONTROL;
typedef union DB_DEPTH_SIZE                                      regDB_DEPTH_SIZE;
typedef union DB_DEPTH_SIZE_XY                                   regDB_DEPTH_SIZE_XY;
typedef union DB_DEPTH_VIEW                                      regDB_DEPTH_VIEW;
typedef union DB_DFSM_CONFIG                                     regDB_DFSM_CONFIG;
typedef union DB_DFSM_CONTROL                                    regDB_DFSM_CONTROL;
typedef union DB_DFSM_FLUSH_AUX_EVENT                            regDB_DFSM_FLUSH_AUX_EVENT;
typedef union DB_DFSM_FLUSH_ENABLE                               regDB_DFSM_FLUSH_ENABLE;
typedef union DB_DFSM_PRIMS_IN_FLIGHT                            regDB_DFSM_PRIMS_IN_FLIGHT;
typedef union DB_DFSM_TILES_IN_FLIGHT                            regDB_DFSM_TILES_IN_FLIGHT;
typedef union DB_DFSM_WATCHDOG                                   regDB_DFSM_WATCHDOG;
typedef union DB_DFSM_WATERMARK                                  regDB_DFSM_WATERMARK;
typedef union DB_EQAA                                            regDB_EQAA;
typedef union DB_EQUAD_STUTTER_CONTROL                           regDB_EQUAD_STUTTER_CONTROL;
typedef union DB_ETILE_STUTTER_CONTROL                           regDB_ETILE_STUTTER_CONTROL;
typedef union DB_EXCEPTION_CONTROL                               regDB_EXCEPTION_CONTROL;
typedef union DB_FGCG_INTERFACES_CLK_CTRL                        regDB_FGCG_INTERFACES_CLK_CTRL;
typedef union DB_FGCG_SRAMS_CLK_CTRL                             regDB_FGCG_SRAMS_CLK_CTRL;
typedef union DB_FIFO_DEPTH1                                     regDB_FIFO_DEPTH1;
typedef union DB_FIFO_DEPTH2                                     regDB_FIFO_DEPTH2;
typedef union DB_FIFO_DEPTH3                                     regDB_FIFO_DEPTH3;
typedef union DB_FREE_CACHELINES                                 regDB_FREE_CACHELINES;
typedef union DB_HTILE_DATA_BASE                                 regDB_HTILE_DATA_BASE;
typedef union DB_HTILE_DATA_BASE_HI                              regDB_HTILE_DATA_BASE_HI;
typedef union DB_HTILE_SURFACE                                   regDB_HTILE_SURFACE;
typedef union DB_LAST_OF_BURST_CONFIG                            regDB_LAST_OF_BURST_CONFIG;
typedef union DB_LQUAD_STUTTER_CONTROL                           regDB_LQUAD_STUTTER_CONTROL;
typedef union DB_LTILE_STUTTER_CONTROL                           regDB_LTILE_STUTTER_CONTROL;
typedef union DB_MEM_ARB_WATERMARKS                              regDB_MEM_ARB_WATERMARKS;
typedef union DB_OCCLUSION_COUNT0_HI                             regDB_OCCLUSION_COUNT0_HI;
typedef union DB_OCCLUSION_COUNT0_LOW                            regDB_OCCLUSION_COUNT0_LOW;
typedef union DB_OCCLUSION_COUNT1_HI                             regDB_OCCLUSION_COUNT1_HI;
typedef union DB_OCCLUSION_COUNT1_LOW                            regDB_OCCLUSION_COUNT1_LOW;
typedef union DB_OCCLUSION_COUNT2_HI                             regDB_OCCLUSION_COUNT2_HI;
typedef union DB_OCCLUSION_COUNT2_LOW                            regDB_OCCLUSION_COUNT2_LOW;
typedef union DB_OCCLUSION_COUNT3_HI                             regDB_OCCLUSION_COUNT3_HI;
typedef union DB_OCCLUSION_COUNT3_LOW                            regDB_OCCLUSION_COUNT3_LOW;
typedef union DB_PERFCOUNTER0_HI                                 regDB_PERFCOUNTER0_HI;
typedef union DB_PERFCOUNTER0_LO                                 regDB_PERFCOUNTER0_LO;
typedef union DB_PERFCOUNTER0_SELECT                             regDB_PERFCOUNTER0_SELECT;
typedef union DB_PERFCOUNTER0_SELECT1                            regDB_PERFCOUNTER0_SELECT1;
typedef union DB_PERFCOUNTER1_HI                                 regDB_PERFCOUNTER1_HI;
typedef union DB_PERFCOUNTER1_LO                                 regDB_PERFCOUNTER1_LO;
typedef union DB_PERFCOUNTER1_SELECT                             regDB_PERFCOUNTER1_SELECT;
typedef union DB_PERFCOUNTER1_SELECT1                            regDB_PERFCOUNTER1_SELECT1;
typedef union DB_PERFCOUNTER2_HI                                 regDB_PERFCOUNTER2_HI;
typedef union DB_PERFCOUNTER2_LO                                 regDB_PERFCOUNTER2_LO;
typedef union DB_PERFCOUNTER2_SELECT                             regDB_PERFCOUNTER2_SELECT;
typedef union DB_PERFCOUNTER3_HI                                 regDB_PERFCOUNTER3_HI;
typedef union DB_PERFCOUNTER3_LO                                 regDB_PERFCOUNTER3_LO;
typedef union DB_PERFCOUNTER3_SELECT                             regDB_PERFCOUNTER3_SELECT;
typedef union DB_PRELOAD_CONTROL                                 regDB_PRELOAD_CONTROL;
typedef union DB_READ_DEBUG_3                                    regDB_READ_DEBUG_3;
typedef union DB_READ_DEBUG_4                                    regDB_READ_DEBUG_4;
typedef union DB_READ_DEBUG_5                                    regDB_READ_DEBUG_5;
typedef union DB_READ_DEBUG_6                                    regDB_READ_DEBUG_6;
typedef union DB_READ_DEBUG_7                                    regDB_READ_DEBUG_7;
typedef union DB_READ_DEBUG_8                                    regDB_READ_DEBUG_8;
typedef union DB_READ_DEBUG_9                                    regDB_READ_DEBUG_9;
typedef union DB_READ_DEBUG_A                                    regDB_READ_DEBUG_A;
typedef union DB_READ_DEBUG_B                                    regDB_READ_DEBUG_B;
typedef union DB_READ_DEBUG_C                                    regDB_READ_DEBUG_C;
typedef union DB_READ_DEBUG_D                                    regDB_READ_DEBUG_D;
typedef union DB_READ_DEBUG_E                                    regDB_READ_DEBUG_E;
typedef union DB_READ_DEBUG_F                                    regDB_READ_DEBUG_F;
typedef union DB_RENDER_CONTROL                                  regDB_RENDER_CONTROL;
typedef union DB_RENDER_OVERRIDE                                 regDB_RENDER_OVERRIDE;
typedef union DB_RENDER_OVERRIDE2                                regDB_RENDER_OVERRIDE2;
typedef union DB_RESERVED_REG_1                                  regDB_RESERVED_REG_1;
typedef union DB_RESERVED_REG_2                                  regDB_RESERVED_REG_2;
typedef union DB_RESERVED_REG_3                                  regDB_RESERVED_REG_3;
typedef union DB_RING_CONTROL                                    regDB_RING_CONTROL;
typedef union DB_RMI_BC_GL2_CACHE_CONTROL                        regDB_RMI_BC_GL2_CACHE_CONTROL;
typedef union DB_RMI_CACHE_POLICY                                regDB_RMI_CACHE_POLICY;
typedef union DB_RMI_L2_CACHE_CONTROL                            regDB_RMI_L2_CACHE_CONTROL;
typedef union DB_SHADER_CONTROL                                  regDB_SHADER_CONTROL;
typedef union DB_SRESULTS_COMPARE_STATE0                         regDB_SRESULTS_COMPARE_STATE0;
typedef union DB_SRESULTS_COMPARE_STATE1                         regDB_SRESULTS_COMPARE_STATE1;
typedef union DB_STENCILREFMASK                                  regDB_STENCILREFMASK;
typedef union DB_STENCILREFMASK_BF                               regDB_STENCILREFMASK_BF;
typedef union DB_STENCIL_CLEAR                                   regDB_STENCIL_CLEAR;
typedef union DB_STENCIL_CONTROL                                 regDB_STENCIL_CONTROL;
typedef union DB_STENCIL_INFO                                    regDB_STENCIL_INFO;
typedef union DB_STENCIL_INFO2                                   regDB_STENCIL_INFO2;
typedef union DB_STENCIL_READ_BASE                               regDB_STENCIL_READ_BASE;
typedef union DB_STENCIL_READ_BASE_HI                            regDB_STENCIL_READ_BASE_HI;
typedef union DB_STENCIL_WRITE_BASE                              regDB_STENCIL_WRITE_BASE;
typedef union DB_STENCIL_WRITE_BASE_HI                           regDB_STENCIL_WRITE_BASE_HI;
typedef union DB_SUBTILE_CONTROL                                 regDB_SUBTILE_CONTROL;
typedef union DB_WATERMARKS                                      regDB_WATERMARKS;
typedef union DB_ZPASS_COUNT_HI                                  regDB_ZPASS_COUNT_HI;
typedef union DB_ZPASS_COUNT_LOW                                 regDB_ZPASS_COUNT_LOW;
typedef union DB_Z_INFO                                          regDB_Z_INFO;
typedef union DB_Z_INFO2                                         regDB_Z_INFO2;
typedef union DB_Z_READ_BASE                                     regDB_Z_READ_BASE;
typedef union DB_Z_READ_BASE_HI                                  regDB_Z_READ_BASE_HI;
typedef union DB_Z_WRITE_BASE                                    regDB_Z_WRITE_BASE;
typedef union DB_Z_WRITE_BASE_HI                                 regDB_Z_WRITE_BASE_HI;
typedef union DEBUG_DATA                                         regDEBUG_DATA;
typedef union DEBUG_INDEX                                        regDEBUG_INDEX;
typedef union FORCE_SYMCLK_DISABLE                               regFORCE_SYMCLK_DISABLE;
typedef union GB_ADDR_CONFIG                                     regGB_ADDR_CONFIG;
typedef union GB_ADDR_CONFIG_READ                                regGB_ADDR_CONFIG_READ;
typedef union GB_BACKEND_MAP                                     regGB_BACKEND_MAP;
typedef union GB_EDC_MODE                                        regGB_EDC_MODE;
typedef union GB_GPU_ID                                          regGB_GPU_ID;
typedef union GB_MACROTILE_MODE0                                 regGB_MACROTILE_MODE0;
typedef union GB_MACROTILE_MODE1                                 regGB_MACROTILE_MODE1;
typedef union GB_MACROTILE_MODE2                                 regGB_MACROTILE_MODE2;
typedef union GB_MACROTILE_MODE3                                 regGB_MACROTILE_MODE3;
typedef union GB_MACROTILE_MODE4                                 regGB_MACROTILE_MODE4;
typedef union GB_MACROTILE_MODE5                                 regGB_MACROTILE_MODE5;
typedef union GB_MACROTILE_MODE6                                 regGB_MACROTILE_MODE6;
typedef union GB_MACROTILE_MODE7                                 regGB_MACROTILE_MODE7;
typedef union GB_MACROTILE_MODE8                                 regGB_MACROTILE_MODE8;
typedef union GB_MACROTILE_MODE9                                 regGB_MACROTILE_MODE9;
typedef union GB_MACROTILE_MODE10                                regGB_MACROTILE_MODE10;
typedef union GB_MACROTILE_MODE11                                regGB_MACROTILE_MODE11;
typedef union GB_MACROTILE_MODE12                                regGB_MACROTILE_MODE12;
typedef union GB_MACROTILE_MODE13                                regGB_MACROTILE_MODE13;
typedef union GB_MACROTILE_MODE14                                regGB_MACROTILE_MODE14;
typedef union GB_MACROTILE_MODE15                                regGB_MACROTILE_MODE15;
typedef union GB_TILE_MODE0                                      regGB_TILE_MODE0;
typedef union GB_TILE_MODE1                                      regGB_TILE_MODE1;
typedef union GB_TILE_MODE2                                      regGB_TILE_MODE2;
typedef union GB_TILE_MODE3                                      regGB_TILE_MODE3;
typedef union GB_TILE_MODE4                                      regGB_TILE_MODE4;
typedef union GB_TILE_MODE5                                      regGB_TILE_MODE5;
typedef union GB_TILE_MODE6                                      regGB_TILE_MODE6;
typedef union GB_TILE_MODE7                                      regGB_TILE_MODE7;
typedef union GB_TILE_MODE8                                      regGB_TILE_MODE8;
typedef union GB_TILE_MODE9                                      regGB_TILE_MODE9;
typedef union GB_TILE_MODE10                                     regGB_TILE_MODE10;
typedef union GB_TILE_MODE11                                     regGB_TILE_MODE11;
typedef union GB_TILE_MODE12                                     regGB_TILE_MODE12;
typedef union GB_TILE_MODE13                                     regGB_TILE_MODE13;
typedef union GB_TILE_MODE14                                     regGB_TILE_MODE14;
typedef union GB_TILE_MODE15                                     regGB_TILE_MODE15;
typedef union GB_TILE_MODE16                                     regGB_TILE_MODE16;
typedef union GB_TILE_MODE17                                     regGB_TILE_MODE17;
typedef union GB_TILE_MODE18                                     regGB_TILE_MODE18;
typedef union GB_TILE_MODE19                                     regGB_TILE_MODE19;
typedef union GB_TILE_MODE20                                     regGB_TILE_MODE20;
typedef union GB_TILE_MODE21                                     regGB_TILE_MODE21;
typedef union GB_TILE_MODE22                                     regGB_TILE_MODE22;
typedef union GB_TILE_MODE23                                     regGB_TILE_MODE23;
typedef union GB_TILE_MODE24                                     regGB_TILE_MODE24;
typedef union GB_TILE_MODE25                                     regGB_TILE_MODE25;
typedef union GB_TILE_MODE26                                     regGB_TILE_MODE26;
typedef union GB_TILE_MODE27                                     regGB_TILE_MODE27;
typedef union GB_TILE_MODE28                                     regGB_TILE_MODE28;
typedef union GB_TILE_MODE29                                     regGB_TILE_MODE29;
typedef union GB_TILE_MODE30                                     regGB_TILE_MODE30;
typedef union GB_TILE_MODE31                                     regGB_TILE_MODE31;
typedef union GCEA_PERFCOUNTER0_CFG                              regGCEA_PERFCOUNTER0_CFG;
typedef union GCEA_PERFCOUNTER1_CFG                              regGCEA_PERFCOUNTER1_CFG;
typedef union GCEA_PERFCOUNTER2_HI                               regGCEA_PERFCOUNTER2_HI;
typedef union GCEA_PERFCOUNTER2_LO                               regGCEA_PERFCOUNTER2_LO;
typedef union GCEA_PERFCOUNTER2_MODE                             regGCEA_PERFCOUNTER2_MODE;
typedef union GCEA_PERFCOUNTER2_SELECT                           regGCEA_PERFCOUNTER2_SELECT;
typedef union GCEA_PERFCOUNTER2_SELECT1                          regGCEA_PERFCOUNTER2_SELECT1;
typedef union GCEA_PERFCOUNTER_HI                                regGCEA_PERFCOUNTER_HI;
typedef union GCEA_PERFCOUNTER_LO                                regGCEA_PERFCOUNTER_LO;
typedef union GCEA_PERFCOUNTER_RSLT_CNTL                         regGCEA_PERFCOUNTER_RSLT_CNTL;
typedef union GCMC_MEM_POWER_LS                                  regGCMC_MEM_POWER_LS;
typedef union GCMC_SHARED_ACTIVE_FCN_ID                          regGCMC_SHARED_ACTIVE_FCN_ID;
typedef union GCMC_SHARED_VIRT_RESET_REQ                         regGCMC_SHARED_VIRT_RESET_REQ;
typedef union GCMC_SHARED_VIRT_RESET_REQ2                        regGCMC_SHARED_VIRT_RESET_REQ2;
typedef union GCMC_VM_AGP_BASE                                   regGCMC_VM_AGP_BASE;
typedef union GCMC_VM_AGP_BOT                                    regGCMC_VM_AGP_BOT;
typedef union GCMC_VM_AGP_TOP                                    regGCMC_VM_AGP_TOP;
typedef union GCMC_VM_APT_CNTL                                   regGCMC_VM_APT_CNTL;
typedef union GCMC_VM_CACHEABLE_DRAM_ADDRESS_END                 regGCMC_VM_CACHEABLE_DRAM_ADDRESS_END;
typedef union GCMC_VM_CACHEABLE_DRAM_ADDRESS_START               regGCMC_VM_CACHEABLE_DRAM_ADDRESS_START;
typedef union GCMC_VM_FB_LOCATION_BASE                           regGCMC_VM_FB_LOCATION_BASE;
typedef union GCMC_VM_FB_LOCATION_TOP                            regGCMC_VM_FB_LOCATION_TOP;
typedef union GCMC_VM_FB_OFFSET                                  regGCMC_VM_FB_OFFSET;
typedef union GCMC_VM_FB_SIZE_OFFSET_VF0                         regGCMC_VM_FB_SIZE_OFFSET_VF0;
typedef union GCMC_VM_FB_SIZE_OFFSET_VF1                         regGCMC_VM_FB_SIZE_OFFSET_VF1;
typedef union GCMC_VM_FB_SIZE_OFFSET_VF2                         regGCMC_VM_FB_SIZE_OFFSET_VF2;
typedef union GCMC_VM_FB_SIZE_OFFSET_VF3                         regGCMC_VM_FB_SIZE_OFFSET_VF3;
typedef union GCMC_VM_FB_SIZE_OFFSET_VF4                         regGCMC_VM_FB_SIZE_OFFSET_VF4;
typedef union GCMC_VM_FB_SIZE_OFFSET_VF5                         regGCMC_VM_FB_SIZE_OFFSET_VF5;
typedef union GCMC_VM_FB_SIZE_OFFSET_VF6                         regGCMC_VM_FB_SIZE_OFFSET_VF6;
typedef union GCMC_VM_FB_SIZE_OFFSET_VF7                         regGCMC_VM_FB_SIZE_OFFSET_VF7;
typedef union GCMC_VM_FB_SIZE_OFFSET_VF8                         regGCMC_VM_FB_SIZE_OFFSET_VF8;
typedef union GCMC_VM_FB_SIZE_OFFSET_VF9                         regGCMC_VM_FB_SIZE_OFFSET_VF9;
typedef union GCMC_VM_FB_SIZE_OFFSET_VF10                        regGCMC_VM_FB_SIZE_OFFSET_VF10;
typedef union GCMC_VM_FB_SIZE_OFFSET_VF11                        regGCMC_VM_FB_SIZE_OFFSET_VF11;
typedef union GCMC_VM_FB_SIZE_OFFSET_VF12                        regGCMC_VM_FB_SIZE_OFFSET_VF12;
typedef union GCMC_VM_FB_SIZE_OFFSET_VF13                        regGCMC_VM_FB_SIZE_OFFSET_VF13;
typedef union GCMC_VM_FB_SIZE_OFFSET_VF14                        regGCMC_VM_FB_SIZE_OFFSET_VF14;
typedef union GCMC_VM_FB_SIZE_OFFSET_VF15                        regGCMC_VM_FB_SIZE_OFFSET_VF15;
typedef union GCMC_VM_FB_SIZE_OFFSET_VF16                        regGCMC_VM_FB_SIZE_OFFSET_VF16;
typedef union GCMC_VM_FB_SIZE_OFFSET_VF17                        regGCMC_VM_FB_SIZE_OFFSET_VF17;
typedef union GCMC_VM_FB_SIZE_OFFSET_VF18                        regGCMC_VM_FB_SIZE_OFFSET_VF18;
typedef union GCMC_VM_FB_SIZE_OFFSET_VF19                        regGCMC_VM_FB_SIZE_OFFSET_VF19;
typedef union GCMC_VM_FB_SIZE_OFFSET_VF20                        regGCMC_VM_FB_SIZE_OFFSET_VF20;
typedef union GCMC_VM_FB_SIZE_OFFSET_VF21                        regGCMC_VM_FB_SIZE_OFFSET_VF21;
typedef union GCMC_VM_FB_SIZE_OFFSET_VF22                        regGCMC_VM_FB_SIZE_OFFSET_VF22;
typedef union GCMC_VM_FB_SIZE_OFFSET_VF23                        regGCMC_VM_FB_SIZE_OFFSET_VF23;
typedef union GCMC_VM_FB_SIZE_OFFSET_VF24                        regGCMC_VM_FB_SIZE_OFFSET_VF24;
typedef union GCMC_VM_FB_SIZE_OFFSET_VF25                        regGCMC_VM_FB_SIZE_OFFSET_VF25;
typedef union GCMC_VM_FB_SIZE_OFFSET_VF26                        regGCMC_VM_FB_SIZE_OFFSET_VF26;
typedef union GCMC_VM_FB_SIZE_OFFSET_VF27                        regGCMC_VM_FB_SIZE_OFFSET_VF27;
typedef union GCMC_VM_FB_SIZE_OFFSET_VF28                        regGCMC_VM_FB_SIZE_OFFSET_VF28;
typedef union GCMC_VM_FB_SIZE_OFFSET_VF29                        regGCMC_VM_FB_SIZE_OFFSET_VF29;
typedef union GCMC_VM_FB_SIZE_OFFSET_VF30                        regGCMC_VM_FB_SIZE_OFFSET_VF30;
typedef union GCMC_VM_FB_SIZE_OFFSET_VF31                        regGCMC_VM_FB_SIZE_OFFSET_VF31;
typedef union GCMC_VM_L2_PERFCOUNTER0_CFG                        regGCMC_VM_L2_PERFCOUNTER0_CFG;
typedef union GCMC_VM_L2_PERFCOUNTER1_CFG                        regGCMC_VM_L2_PERFCOUNTER1_CFG;
typedef union GCMC_VM_L2_PERFCOUNTER2_CFG                        regGCMC_VM_L2_PERFCOUNTER2_CFG;
typedef union GCMC_VM_L2_PERFCOUNTER3_CFG                        regGCMC_VM_L2_PERFCOUNTER3_CFG;
typedef union GCMC_VM_L2_PERFCOUNTER4_CFG                        regGCMC_VM_L2_PERFCOUNTER4_CFG;
typedef union GCMC_VM_L2_PERFCOUNTER5_CFG                        regGCMC_VM_L2_PERFCOUNTER5_CFG;
typedef union GCMC_VM_L2_PERFCOUNTER6_CFG                        regGCMC_VM_L2_PERFCOUNTER6_CFG;
typedef union GCMC_VM_L2_PERFCOUNTER7_CFG                        regGCMC_VM_L2_PERFCOUNTER7_CFG;
typedef union GCMC_VM_L2_PERFCOUNTER_HI                          regGCMC_VM_L2_PERFCOUNTER_HI;
typedef union GCMC_VM_L2_PERFCOUNTER_LO                          regGCMC_VM_L2_PERFCOUNTER_LO;
typedef union GCMC_VM_L2_PERFCOUNTER_RSLT_CNTL                   regGCMC_VM_L2_PERFCOUNTER_RSLT_CNTL;
typedef union GCMC_VM_LOCAL_HBM_ADDRESS_END                      regGCMC_VM_LOCAL_HBM_ADDRESS_END;
typedef union GCMC_VM_LOCAL_HBM_ADDRESS_LOCK_CNTL                regGCMC_VM_LOCAL_HBM_ADDRESS_LOCK_CNTL;
typedef union GCMC_VM_LOCAL_HBM_ADDRESS_START                    regGCMC_VM_LOCAL_HBM_ADDRESS_START;
typedef union GCMC_VM_MARC_BASE_HI_0                             regGCMC_VM_MARC_BASE_HI_0;
typedef union GCMC_VM_MARC_BASE_HI_1                             regGCMC_VM_MARC_BASE_HI_1;
typedef union GCMC_VM_MARC_BASE_HI_2                             regGCMC_VM_MARC_BASE_HI_2;
typedef union GCMC_VM_MARC_BASE_HI_3                             regGCMC_VM_MARC_BASE_HI_3;
typedef union GCMC_VM_MARC_BASE_LO_0                             regGCMC_VM_MARC_BASE_LO_0;
typedef union GCMC_VM_MARC_BASE_LO_1                             regGCMC_VM_MARC_BASE_LO_1;
typedef union GCMC_VM_MARC_BASE_LO_2                             regGCMC_VM_MARC_BASE_LO_2;
typedef union GCMC_VM_MARC_BASE_LO_3                             regGCMC_VM_MARC_BASE_LO_3;
typedef union GCMC_VM_MARC_LEN_HI_0                              regGCMC_VM_MARC_LEN_HI_0;
typedef union GCMC_VM_MARC_LEN_HI_1                              regGCMC_VM_MARC_LEN_HI_1;
typedef union GCMC_VM_MARC_LEN_HI_2                              regGCMC_VM_MARC_LEN_HI_2;
typedef union GCMC_VM_MARC_LEN_HI_3                              regGCMC_VM_MARC_LEN_HI_3;
typedef union GCMC_VM_MARC_LEN_LO_0                              regGCMC_VM_MARC_LEN_LO_0;
typedef union GCMC_VM_MARC_LEN_LO_1                              regGCMC_VM_MARC_LEN_LO_1;
typedef union GCMC_VM_MARC_LEN_LO_2                              regGCMC_VM_MARC_LEN_LO_2;
typedef union GCMC_VM_MARC_LEN_LO_3                              regGCMC_VM_MARC_LEN_LO_3;
typedef union GCMC_VM_MARC_RELOC_HI_0                            regGCMC_VM_MARC_RELOC_HI_0;
typedef union GCMC_VM_MARC_RELOC_HI_1                            regGCMC_VM_MARC_RELOC_HI_1;
typedef union GCMC_VM_MARC_RELOC_HI_2                            regGCMC_VM_MARC_RELOC_HI_2;
typedef union GCMC_VM_MARC_RELOC_HI_3                            regGCMC_VM_MARC_RELOC_HI_3;
typedef union GCMC_VM_MARC_RELOC_LO_0                            regGCMC_VM_MARC_RELOC_LO_0;
typedef union GCMC_VM_MARC_RELOC_LO_1                            regGCMC_VM_MARC_RELOC_LO_1;
typedef union GCMC_VM_MARC_RELOC_LO_2                            regGCMC_VM_MARC_RELOC_LO_2;
typedef union GCMC_VM_MARC_RELOC_LO_3                            regGCMC_VM_MARC_RELOC_LO_3;
typedef union GCMC_VM_MX_L1_TLB_CNTL                             regGCMC_VM_MX_L1_TLB_CNTL;
typedef union GCMC_VM_NB_LOWER_TOP_OF_DRAM2                      regGCMC_VM_NB_LOWER_TOP_OF_DRAM2;
typedef union GCMC_VM_NB_MMIOBASE                                regGCMC_VM_NB_MMIOBASE;
typedef union GCMC_VM_NB_MMIOLIMIT                               regGCMC_VM_NB_MMIOLIMIT;
typedef union GCMC_VM_NB_PCI_ARB                                 regGCMC_VM_NB_PCI_ARB;
typedef union GCMC_VM_NB_PCI_CTRL                                regGCMC_VM_NB_PCI_CTRL;
typedef union GCMC_VM_NB_TOP_OF_DRAM_SLOT1                       regGCMC_VM_NB_TOP_OF_DRAM_SLOT1;
typedef union GCMC_VM_NB_UPPER_TOP_OF_DRAM2                      regGCMC_VM_NB_UPPER_TOP_OF_DRAM2;
typedef union GCMC_VM_STEERING                                   regGCMC_VM_STEERING;
typedef union GCMC_VM_SYSTEM_APERTURE_DEFAULT_ADDR_LSB           regGCMC_VM_SYSTEM_APERTURE_DEFAULT_ADDR_LSB;
typedef union GCMC_VM_SYSTEM_APERTURE_DEFAULT_ADDR_MSB           regGCMC_VM_SYSTEM_APERTURE_DEFAULT_ADDR_MSB;
typedef union GCMC_VM_SYSTEM_APERTURE_HIGH_ADDR                  regGCMC_VM_SYSTEM_APERTURE_HIGH_ADDR;
typedef union GCMC_VM_SYSTEM_APERTURE_LOW_ADDR                   regGCMC_VM_SYSTEM_APERTURE_LOW_ADDR;
typedef union GCRD_SA_TARGETS_DISABLE                            regGCRD_SA_TARGETS_DISABLE;
typedef union GCR_CGTT_SCLK_CTRL                                 regGCR_CGTT_SCLK_CTRL;
typedef union GCR_CMD_STATUS                                     regGCR_CMD_STATUS;
typedef union GCR_GENERAL_CNTL                                   regGCR_GENERAL_CNTL;
typedef union GCR_PERFCOUNTER0_HI                                regGCR_PERFCOUNTER0_HI;
typedef union GCR_PERFCOUNTER0_LO                                regGCR_PERFCOUNTER0_LO;
typedef union GCR_PERFCOUNTER0_SELECT                            regGCR_PERFCOUNTER0_SELECT;
typedef union GCR_PERFCOUNTER0_SELECT1                           regGCR_PERFCOUNTER0_SELECT1;
typedef union GCR_PERFCOUNTER1_HI                                regGCR_PERFCOUNTER1_HI;
typedef union GCR_PERFCOUNTER1_LO                                regGCR_PERFCOUNTER1_LO;
typedef union GCR_PERFCOUNTER1_SELECT                            regGCR_PERFCOUNTER1_SELECT;
typedef union GCR_PIO_CNTL                                       regGCR_PIO_CNTL;
typedef union GCR_PIO_DATA                                       regGCR_PIO_DATA;
typedef union GCR_SPARE                                          regGCR_SPARE;
typedef union GCR_TARGET_DISABLE                                 regGCR_TARGET_DISABLE;
typedef union GCUTCL2_CGTT_CLK_CTRL                              regGCUTCL2_CGTT_CLK_CTRL;
typedef union GCVML2_PERFCOUNTER2_0_HI                           regGCVML2_PERFCOUNTER2_0_HI;
typedef union GCVML2_PERFCOUNTER2_0_LO                           regGCVML2_PERFCOUNTER2_0_LO;
typedef union GCVML2_PERFCOUNTER2_0_MODE                         regGCVML2_PERFCOUNTER2_0_MODE;
typedef union GCVML2_PERFCOUNTER2_0_SELECT                       regGCVML2_PERFCOUNTER2_0_SELECT;
typedef union GCVML2_PERFCOUNTER2_0_SELECT1                      regGCVML2_PERFCOUNTER2_0_SELECT1;
typedef union GCVML2_PERFCOUNTER2_1_HI                           regGCVML2_PERFCOUNTER2_1_HI;
typedef union GCVML2_PERFCOUNTER2_1_LO                           regGCVML2_PERFCOUNTER2_1_LO;
typedef union GCVML2_PERFCOUNTER2_1_MODE                         regGCVML2_PERFCOUNTER2_1_MODE;
typedef union GCVML2_PERFCOUNTER2_1_SELECT                       regGCVML2_PERFCOUNTER2_1_SELECT;
typedef union GCVML2_PERFCOUNTER2_1_SELECT1                      regGCVML2_PERFCOUNTER2_1_SELECT1;
typedef union GCVML2_WALKER_MACRO_THROTTLE_FETCH_LIMIT           regGCVML2_WALKER_MACRO_THROTTLE_FETCH_LIMIT;
typedef union GCVML2_WALKER_MACRO_THROTTLE_TIME                  regGCVML2_WALKER_MACRO_THROTTLE_TIME;
typedef union GCVML2_WALKER_MICRO_THROTTLE_FETCH_LIMIT           regGCVML2_WALKER_MICRO_THROTTLE_FETCH_LIMIT;
typedef union GCVML2_WALKER_MICRO_THROTTLE_TIME                  regGCVML2_WALKER_MICRO_THROTTLE_TIME;
typedef union GC_ATC_L2_PERFCOUNTER0_CFG                         regGC_ATC_L2_PERFCOUNTER0_CFG;
typedef union GC_ATC_L2_PERFCOUNTER1_CFG                         regGC_ATC_L2_PERFCOUNTER1_CFG;
typedef union GC_ATC_L2_PERFCOUNTER2_HI                          regGC_ATC_L2_PERFCOUNTER2_HI;
typedef union GC_ATC_L2_PERFCOUNTER2_LO                          regGC_ATC_L2_PERFCOUNTER2_LO;
typedef union GC_ATC_L2_PERFCOUNTER2_MODE                        regGC_ATC_L2_PERFCOUNTER2_MODE;
typedef union GC_ATC_L2_PERFCOUNTER2_SELECT                      regGC_ATC_L2_PERFCOUNTER2_SELECT;
typedef union GC_ATC_L2_PERFCOUNTER2_SELECT1                     regGC_ATC_L2_PERFCOUNTER2_SELECT1;
typedef union GC_ATC_L2_PERFCOUNTER_HI                           regGC_ATC_L2_PERFCOUNTER_HI;
typedef union GC_ATC_L2_PERFCOUNTER_LO                           regGC_ATC_L2_PERFCOUNTER_LO;
typedef union GC_ATC_L2_PERFCOUNTER_RSLT_CNTL                    regGC_ATC_L2_PERFCOUNTER_RSLT_CNTL;
typedef union GC_CAC_ACC_BCI0                                    regGC_CAC_ACC_BCI0;
typedef union GC_CAC_ACC_BCI1                                    regGC_CAC_ACC_BCI1;
typedef union GC_CAC_ACC_CB0                                     regGC_CAC_ACC_CB0;
typedef union GC_CAC_ACC_CB1                                     regGC_CAC_ACC_CB1;
typedef union GC_CAC_ACC_CB2                                     regGC_CAC_ACC_CB2;
typedef union GC_CAC_ACC_CB3                                     regGC_CAC_ACC_CB3;
typedef union GC_CAC_ACC_CBR0                                    regGC_CAC_ACC_CBR0;
typedef union GC_CAC_ACC_CBR1                                    regGC_CAC_ACC_CBR1;
typedef union GC_CAC_ACC_CBR2                                    regGC_CAC_ACC_CBR2;
typedef union GC_CAC_ACC_CBR3                                    regGC_CAC_ACC_CBR3;
typedef union GC_CAC_ACC_CP0                                     regGC_CAC_ACC_CP0;
typedef union GC_CAC_ACC_CP1                                     regGC_CAC_ACC_CP1;
typedef union GC_CAC_ACC_CP2                                     regGC_CAC_ACC_CP2;
typedef union GC_CAC_ACC_CU0                                     regGC_CAC_ACC_CU0;
typedef union GC_CAC_ACC_CU1                                     regGC_CAC_ACC_CU1;
typedef union GC_CAC_ACC_CU2                                     regGC_CAC_ACC_CU2;
typedef union GC_CAC_ACC_CU3                                     regGC_CAC_ACC_CU3;
typedef union GC_CAC_ACC_CU4                                     regGC_CAC_ACC_CU4;
typedef union GC_CAC_ACC_CU5                                     regGC_CAC_ACC_CU5;
typedef union GC_CAC_ACC_CU6                                     regGC_CAC_ACC_CU6;
typedef union GC_CAC_ACC_CU7                                     regGC_CAC_ACC_CU7;
typedef union GC_CAC_ACC_CU8                                     regGC_CAC_ACC_CU8;
typedef union GC_CAC_ACC_CU9                                     regGC_CAC_ACC_CU9;
typedef union GC_CAC_ACC_CU10                                    regGC_CAC_ACC_CU10;
typedef union GC_CAC_ACC_CU11                                    regGC_CAC_ACC_CU11;
typedef union GC_CAC_ACC_CU12                                    regGC_CAC_ACC_CU12;
typedef union GC_CAC_ACC_CU13                                    regGC_CAC_ACC_CU13;
typedef union GC_CAC_ACC_CU14                                    regGC_CAC_ACC_CU14;
typedef union GC_CAC_ACC_CU15                                    regGC_CAC_ACC_CU15;
typedef union GC_CAC_ACC_DB0                                     regGC_CAC_ACC_DB0;
typedef union GC_CAC_ACC_DB1                                     regGC_CAC_ACC_DB1;
typedef union GC_CAC_ACC_DB2                                     regGC_CAC_ACC_DB2;
typedef union GC_CAC_ACC_DB3                                     regGC_CAC_ACC_DB3;
typedef union GC_CAC_ACC_DBR0                                    regGC_CAC_ACC_DBR0;
typedef union GC_CAC_ACC_DBR1                                    regGC_CAC_ACC_DBR1;
typedef union GC_CAC_ACC_DBR2                                    regGC_CAC_ACC_DBR2;
typedef union GC_CAC_ACC_DBR3                                    regGC_CAC_ACC_DBR3;
typedef union GC_CAC_ACC_EA0                                     regGC_CAC_ACC_EA0;
typedef union GC_CAC_ACC_EA1                                     regGC_CAC_ACC_EA1;
typedef union GC_CAC_ACC_EA2                                     regGC_CAC_ACC_EA2;
typedef union GC_CAC_ACC_EA3                                     regGC_CAC_ACC_EA3;
typedef union GC_CAC_ACC_EA4                                     regGC_CAC_ACC_EA4;
typedef union GC_CAC_ACC_EA5                                     regGC_CAC_ACC_EA5;
typedef union GC_CAC_ACC_GDS0                                    regGC_CAC_ACC_GDS0;
typedef union GC_CAC_ACC_GDS1                                    regGC_CAC_ACC_GDS1;
typedef union GC_CAC_ACC_GDS2                                    regGC_CAC_ACC_GDS2;
typedef union GC_CAC_ACC_GDS3                                    regGC_CAC_ACC_GDS3;
typedef union GC_CAC_ACC_IA0                                     regGC_CAC_ACC_IA0;
typedef union GC_CAC_ACC_LDS0                                    regGC_CAC_ACC_LDS0;
typedef union GC_CAC_ACC_LDS1                                    regGC_CAC_ACC_LDS1;
typedef union GC_CAC_ACC_LDS2                                    regGC_CAC_ACC_LDS2;
typedef union GC_CAC_ACC_LDS3                                    regGC_CAC_ACC_LDS3;
typedef union GC_CAC_ACC_PA0                                     regGC_CAC_ACC_PA0;
typedef union GC_CAC_ACC_PA1                                     regGC_CAC_ACC_PA1;
typedef union GC_CAC_ACC_PC0                                     regGC_CAC_ACC_PC0;
typedef union GC_CAC_ACC_PG0                                     regGC_CAC_ACC_PG0;
typedef union GC_CAC_ACC_RMI0                                    regGC_CAC_ACC_RMI0;
typedef union GC_CAC_ACC_SC0                                     regGC_CAC_ACC_SC0;
typedef union GC_CAC_ACC_SPI0                                    regGC_CAC_ACC_SPI0;
typedef union GC_CAC_ACC_SPI1                                    regGC_CAC_ACC_SPI1;
typedef union GC_CAC_ACC_SPI2                                    regGC_CAC_ACC_SPI2;
typedef union GC_CAC_ACC_SPI3                                    regGC_CAC_ACC_SPI3;
typedef union GC_CAC_ACC_SPI4                                    regGC_CAC_ACC_SPI4;
typedef union GC_CAC_ACC_SPI5                                    regGC_CAC_ACC_SPI5;
typedef union GC_CAC_ACC_SQ0_LOWER                               regGC_CAC_ACC_SQ0_LOWER;
typedef union GC_CAC_ACC_SQ0_UPPER                               regGC_CAC_ACC_SQ0_UPPER;
typedef union GC_CAC_ACC_SQ1_LOWER                               regGC_CAC_ACC_SQ1_LOWER;
typedef union GC_CAC_ACC_SQ1_UPPER                               regGC_CAC_ACC_SQ1_UPPER;
typedef union GC_CAC_ACC_SQ2_LOWER                               regGC_CAC_ACC_SQ2_LOWER;
typedef union GC_CAC_ACC_SQ2_UPPER                               regGC_CAC_ACC_SQ2_UPPER;
typedef union GC_CAC_ACC_SQ3_LOWER                               regGC_CAC_ACC_SQ3_LOWER;
typedef union GC_CAC_ACC_SQ3_UPPER                               regGC_CAC_ACC_SQ3_UPPER;
typedef union GC_CAC_ACC_SQ4_LOWER                               regGC_CAC_ACC_SQ4_LOWER;
typedef union GC_CAC_ACC_SQ4_UPPER                               regGC_CAC_ACC_SQ4_UPPER;
typedef union GC_CAC_ACC_SQ5_LOWER                               regGC_CAC_ACC_SQ5_LOWER;
typedef union GC_CAC_ACC_SQ5_UPPER                               regGC_CAC_ACC_SQ5_UPPER;
typedef union GC_CAC_ACC_SQ6_LOWER                               regGC_CAC_ACC_SQ6_LOWER;
typedef union GC_CAC_ACC_SQ6_UPPER                               regGC_CAC_ACC_SQ6_UPPER;
typedef union GC_CAC_ACC_SQ7_LOWER                               regGC_CAC_ACC_SQ7_LOWER;
typedef union GC_CAC_ACC_SQ7_UPPER                               regGC_CAC_ACC_SQ7_UPPER;
typedef union GC_CAC_ACC_SQ8_LOWER                               regGC_CAC_ACC_SQ8_LOWER;
typedef union GC_CAC_ACC_SQ8_UPPER                               regGC_CAC_ACC_SQ8_UPPER;
typedef union GC_CAC_ACC_SX0                                     regGC_CAC_ACC_SX0;
typedef union GC_CAC_ACC_SXRB0                                   regGC_CAC_ACC_SXRB0;
typedef union GC_CAC_ACC_SXRB1                                   regGC_CAC_ACC_SXRB1;
typedef union GC_CAC_ACC_TA0                                     regGC_CAC_ACC_TA0;
typedef union GC_CAC_ACC_TCC0                                    regGC_CAC_ACC_TCC0;
typedef union GC_CAC_ACC_TCC1                                    regGC_CAC_ACC_TCC1;
typedef union GC_CAC_ACC_TCC2                                    regGC_CAC_ACC_TCC2;
typedef union GC_CAC_ACC_TCC3                                    regGC_CAC_ACC_TCC3;
typedef union GC_CAC_ACC_TCC4                                    regGC_CAC_ACC_TCC4;
typedef union GC_CAC_ACC_TCP0                                    regGC_CAC_ACC_TCP0;
typedef union GC_CAC_ACC_TCP1                                    regGC_CAC_ACC_TCP1;
typedef union GC_CAC_ACC_TCP2                                    regGC_CAC_ACC_TCP2;
typedef union GC_CAC_ACC_TCP3                                    regGC_CAC_ACC_TCP3;
typedef union GC_CAC_ACC_TCP4                                    regGC_CAC_ACC_TCP4;
typedef union GC_CAC_ACC_TD0                                     regGC_CAC_ACC_TD0;
typedef union GC_CAC_ACC_TD1                                     regGC_CAC_ACC_TD1;
typedef union GC_CAC_ACC_TD2                                     regGC_CAC_ACC_TD2;
typedef union GC_CAC_ACC_TD3                                     regGC_CAC_ACC_TD3;
typedef union GC_CAC_ACC_TD4                                     regGC_CAC_ACC_TD4;
typedef union GC_CAC_ACC_TD5                                     regGC_CAC_ACC_TD5;
typedef union GC_CAC_ACC_UTCL2_ATCL20                            regGC_CAC_ACC_UTCL2_ATCL20;
typedef union GC_CAC_ACC_UTCL2_ATCL21                            regGC_CAC_ACC_UTCL2_ATCL21;
typedef union GC_CAC_ACC_UTCL2_ATCL22                            regGC_CAC_ACC_UTCL2_ATCL22;
typedef union GC_CAC_ACC_UTCL2_ATCL23                            regGC_CAC_ACC_UTCL2_ATCL23;
typedef union GC_CAC_ACC_UTCL2_ATCL24                            regGC_CAC_ACC_UTCL2_ATCL24;
typedef union GC_CAC_ACC_UTCL2_ROUTER0                           regGC_CAC_ACC_UTCL2_ROUTER0;
typedef union GC_CAC_ACC_UTCL2_ROUTER1                           regGC_CAC_ACC_UTCL2_ROUTER1;
typedef union GC_CAC_ACC_UTCL2_ROUTER2                           regGC_CAC_ACC_UTCL2_ROUTER2;
typedef union GC_CAC_ACC_UTCL2_ROUTER3                           regGC_CAC_ACC_UTCL2_ROUTER3;
typedef union GC_CAC_ACC_UTCL2_ROUTER4                           regGC_CAC_ACC_UTCL2_ROUTER4;
typedef union GC_CAC_ACC_UTCL2_ROUTER5                           regGC_CAC_ACC_UTCL2_ROUTER5;
typedef union GC_CAC_ACC_UTCL2_ROUTER6                           regGC_CAC_ACC_UTCL2_ROUTER6;
typedef union GC_CAC_ACC_UTCL2_ROUTER7                           regGC_CAC_ACC_UTCL2_ROUTER7;
typedef union GC_CAC_ACC_UTCL2_ROUTER8                           regGC_CAC_ACC_UTCL2_ROUTER8;
typedef union GC_CAC_ACC_UTCL2_ROUTER9                           regGC_CAC_ACC_UTCL2_ROUTER9;
typedef union GC_CAC_ACC_UTCL2_VML20                             regGC_CAC_ACC_UTCL2_VML20;
typedef union GC_CAC_ACC_UTCL2_VML21                             regGC_CAC_ACC_UTCL2_VML21;
typedef union GC_CAC_ACC_UTCL2_VML22                             regGC_CAC_ACC_UTCL2_VML22;
typedef union GC_CAC_ACC_UTCL2_VML23                             regGC_CAC_ACC_UTCL2_VML23;
typedef union GC_CAC_ACC_UTCL2_VML24                             regGC_CAC_ACC_UTCL2_VML24;
typedef union GC_CAC_ACC_UTCL2_WALKER0                           regGC_CAC_ACC_UTCL2_WALKER0;
typedef union GC_CAC_ACC_UTCL2_WALKER1                           regGC_CAC_ACC_UTCL2_WALKER1;
typedef union GC_CAC_ACC_UTCL2_WALKER2                           regGC_CAC_ACC_UTCL2_WALKER2;
typedef union GC_CAC_ACC_UTCL2_WALKER3                           regGC_CAC_ACC_UTCL2_WALKER3;
typedef union GC_CAC_ACC_UTCL2_WALKER4                           regGC_CAC_ACC_UTCL2_WALKER4;
typedef union GC_CAC_ACC_VGT0                                    regGC_CAC_ACC_VGT0;
typedef union GC_CAC_ACC_VGT1                                    regGC_CAC_ACC_VGT1;
typedef union GC_CAC_ACC_VGT2                                    regGC_CAC_ACC_VGT2;
typedef union GC_CAC_ACC_WD0                                     regGC_CAC_ACC_WD0;
typedef union GC_CAC_AGGR_LOWER                                  regGC_CAC_AGGR_LOWER;
typedef union GC_CAC_AGGR_UPPER                                  regGC_CAC_AGGR_UPPER;
typedef union GC_CAC_CGTT_CLK_CTRL                               regGC_CAC_CGTT_CLK_CTRL;
typedef union GC_CAC_CNTL                                        regGC_CAC_CNTL;
typedef union GC_CAC_CTRL_1                                      regGC_CAC_CTRL_1;
typedef union GC_CAC_CTRL_2                                      regGC_CAC_CTRL_2;
typedef union GC_CAC_INDEX_AUTO_INCR_EN                          regGC_CAC_INDEX_AUTO_INCR_EN;
typedef union GC_CAC_IND_DATA                                    regGC_CAC_IND_DATA;
typedef union GC_CAC_IND_INDEX                                   regGC_CAC_IND_INDEX;
typedef union GC_CAC_OVRD_BCI                                    regGC_CAC_OVRD_BCI;
typedef union GC_CAC_OVRD_CB                                     regGC_CAC_OVRD_CB;
typedef union GC_CAC_OVRD_CBR                                    regGC_CAC_OVRD_CBR;
typedef union GC_CAC_OVRD_CP                                     regGC_CAC_OVRD_CP;
typedef union GC_CAC_OVRD_CU                                     regGC_CAC_OVRD_CU;
typedef union GC_CAC_OVRD_DB                                     regGC_CAC_OVRD_DB;
typedef union GC_CAC_OVRD_DBR                                    regGC_CAC_OVRD_DBR;
typedef union GC_CAC_OVRD_EA                                     regGC_CAC_OVRD_EA;
typedef union GC_CAC_OVRD_GDS                                    regGC_CAC_OVRD_GDS;
typedef union GC_CAC_OVRD_IA                                     regGC_CAC_OVRD_IA;
typedef union GC_CAC_OVRD_LDS                                    regGC_CAC_OVRD_LDS;
typedef union GC_CAC_OVRD_PA                                     regGC_CAC_OVRD_PA;
typedef union GC_CAC_OVRD_PC                                     regGC_CAC_OVRD_PC;
typedef union GC_CAC_OVRD_PG                                     regGC_CAC_OVRD_PG;
typedef union GC_CAC_OVRD_RMI                                    regGC_CAC_OVRD_RMI;
typedef union GC_CAC_OVRD_SC                                     regGC_CAC_OVRD_SC;
typedef union GC_CAC_OVRD_SPI                                    regGC_CAC_OVRD_SPI;
typedef union GC_CAC_OVRD_SQ                                     regGC_CAC_OVRD_SQ;
typedef union GC_CAC_OVRD_SX                                     regGC_CAC_OVRD_SX;
typedef union GC_CAC_OVRD_SXRB                                   regGC_CAC_OVRD_SXRB;
typedef union GC_CAC_OVRD_TA                                     regGC_CAC_OVRD_TA;
typedef union GC_CAC_OVRD_TCC                                    regGC_CAC_OVRD_TCC;
typedef union GC_CAC_OVRD_TCP                                    regGC_CAC_OVRD_TCP;
typedef union GC_CAC_OVRD_TD                                     regGC_CAC_OVRD_TD;
typedef union GC_CAC_OVRD_UTCL2_ATCL2                            regGC_CAC_OVRD_UTCL2_ATCL2;
typedef union GC_CAC_OVRD_UTCL2_ROUTER                           regGC_CAC_OVRD_UTCL2_ROUTER;
typedef union GC_CAC_OVRD_UTCL2_VML2                             regGC_CAC_OVRD_UTCL2_VML2;
typedef union GC_CAC_OVRD_UTCL2_WALKER                           regGC_CAC_OVRD_UTCL2_WALKER;
typedef union GC_CAC_OVRD_VGT                                    regGC_CAC_OVRD_VGT;
typedef union GC_CAC_OVRD_WD                                     regGC_CAC_OVRD_WD;
typedef union GC_CAC_OVR_SEL                                     regGC_CAC_OVR_SEL;
typedef union GC_CAC_OVR_VAL                                     regGC_CAC_OVR_VAL;
typedef union GC_CAC_PG_AGGR_LOWER                               regGC_CAC_PG_AGGR_LOWER;
typedef union GC_CAC_PG_AGGR_UPPER                               regGC_CAC_PG_AGGR_UPPER;
typedef union GC_CAC_SOFT_CTRL                                   regGC_CAC_SOFT_CTRL;
typedef union GC_CAC_WEIGHT_BCI_0                                regGC_CAC_WEIGHT_BCI_0;
typedef union GC_CAC_WEIGHT_CBR_0                                regGC_CAC_WEIGHT_CBR_0;
typedef union GC_CAC_WEIGHT_CBR_1                                regGC_CAC_WEIGHT_CBR_1;
typedef union GC_CAC_WEIGHT_CB_0                                 regGC_CAC_WEIGHT_CB_0;
typedef union GC_CAC_WEIGHT_CB_1                                 regGC_CAC_WEIGHT_CB_1;
typedef union GC_CAC_WEIGHT_CP_0                                 regGC_CAC_WEIGHT_CP_0;
typedef union GC_CAC_WEIGHT_CP_1                                 regGC_CAC_WEIGHT_CP_1;
typedef union GC_CAC_WEIGHT_CU_0                                 regGC_CAC_WEIGHT_CU_0;
typedef union GC_CAC_WEIGHT_CU_1                                 regGC_CAC_WEIGHT_CU_1;
typedef union GC_CAC_WEIGHT_CU_2                                 regGC_CAC_WEIGHT_CU_2;
typedef union GC_CAC_WEIGHT_CU_3                                 regGC_CAC_WEIGHT_CU_3;
typedef union GC_CAC_WEIGHT_CU_4                                 regGC_CAC_WEIGHT_CU_4;
typedef union GC_CAC_WEIGHT_CU_5                                 regGC_CAC_WEIGHT_CU_5;
typedef union GC_CAC_WEIGHT_CU_6                                 regGC_CAC_WEIGHT_CU_6;
typedef union GC_CAC_WEIGHT_CU_7                                 regGC_CAC_WEIGHT_CU_7;
typedef union GC_CAC_WEIGHT_DBR_0                                regGC_CAC_WEIGHT_DBR_0;
typedef union GC_CAC_WEIGHT_DBR_1                                regGC_CAC_WEIGHT_DBR_1;
typedef union GC_CAC_WEIGHT_DB_0                                 regGC_CAC_WEIGHT_DB_0;
typedef union GC_CAC_WEIGHT_DB_1                                 regGC_CAC_WEIGHT_DB_1;
typedef union GC_CAC_WEIGHT_EA_0                                 regGC_CAC_WEIGHT_EA_0;
typedef union GC_CAC_WEIGHT_EA_1                                 regGC_CAC_WEIGHT_EA_1;
typedef union GC_CAC_WEIGHT_EA_2                                 regGC_CAC_WEIGHT_EA_2;
typedef union GC_CAC_WEIGHT_IA_0                                 regGC_CAC_WEIGHT_IA_0;
typedef union GC_CAC_WEIGHT_LDS_0                                regGC_CAC_WEIGHT_LDS_0;
typedef union GC_CAC_WEIGHT_LDS_1                                regGC_CAC_WEIGHT_LDS_1;
typedef union GC_CAC_WEIGHT_PA_0                                 regGC_CAC_WEIGHT_PA_0;
typedef union GC_CAC_WEIGHT_PC_0                                 regGC_CAC_WEIGHT_PC_0;
typedef union GC_CAC_WEIGHT_PG_0                                 regGC_CAC_WEIGHT_PG_0;
typedef union GC_CAC_WEIGHT_RMI_0                                regGC_CAC_WEIGHT_RMI_0;
typedef union GC_CAC_WEIGHT_SC_0                                 regGC_CAC_WEIGHT_SC_0;
typedef union GC_CAC_WEIGHT_SPI_0                                regGC_CAC_WEIGHT_SPI_0;
typedef union GC_CAC_WEIGHT_SPI_1                                regGC_CAC_WEIGHT_SPI_1;
typedef union GC_CAC_WEIGHT_SPI_2                                regGC_CAC_WEIGHT_SPI_2;
typedef union GC_CAC_WEIGHT_SQ_0                                 regGC_CAC_WEIGHT_SQ_0;
typedef union GC_CAC_WEIGHT_SQ_1                                 regGC_CAC_WEIGHT_SQ_1;
typedef union GC_CAC_WEIGHT_SQ_2                                 regGC_CAC_WEIGHT_SQ_2;
typedef union GC_CAC_WEIGHT_SQ_3                                 regGC_CAC_WEIGHT_SQ_3;
typedef union GC_CAC_WEIGHT_SQ_4                                 regGC_CAC_WEIGHT_SQ_4;
typedef union GC_CAC_WEIGHT_SXRB_0                               regGC_CAC_WEIGHT_SXRB_0;
typedef union GC_CAC_WEIGHT_SX_0                                 regGC_CAC_WEIGHT_SX_0;
typedef union GC_CAC_WEIGHT_TA_0                                 regGC_CAC_WEIGHT_TA_0;
typedef union GC_CAC_WEIGHT_TD_0                                 regGC_CAC_WEIGHT_TD_0;
typedef union GC_CAC_WEIGHT_TD_1                                 regGC_CAC_WEIGHT_TD_1;
typedef union GC_CAC_WEIGHT_TD_2                                 regGC_CAC_WEIGHT_TD_2;
typedef union GC_CAC_WEIGHT_UTCL2_ATCL2_0                        regGC_CAC_WEIGHT_UTCL2_ATCL2_0;
typedef union GC_CAC_WEIGHT_UTCL2_ATCL2_1                        regGC_CAC_WEIGHT_UTCL2_ATCL2_1;
typedef union GC_CAC_WEIGHT_UTCL2_ATCL2_2                        regGC_CAC_WEIGHT_UTCL2_ATCL2_2;
typedef union GC_CAC_WEIGHT_UTCL2_ROUTER_0                       regGC_CAC_WEIGHT_UTCL2_ROUTER_0;
typedef union GC_CAC_WEIGHT_UTCL2_ROUTER_1                       regGC_CAC_WEIGHT_UTCL2_ROUTER_1;
typedef union GC_CAC_WEIGHT_UTCL2_ROUTER_2                       regGC_CAC_WEIGHT_UTCL2_ROUTER_2;
typedef union GC_CAC_WEIGHT_UTCL2_ROUTER_3                       regGC_CAC_WEIGHT_UTCL2_ROUTER_3;
typedef union GC_CAC_WEIGHT_UTCL2_ROUTER_4                       regGC_CAC_WEIGHT_UTCL2_ROUTER_4;
typedef union GC_CAC_WEIGHT_UTCL2_VML2_0                         regGC_CAC_WEIGHT_UTCL2_VML2_0;
typedef union GC_CAC_WEIGHT_UTCL2_VML2_1                         regGC_CAC_WEIGHT_UTCL2_VML2_1;
typedef union GC_CAC_WEIGHT_UTCL2_VML2_2                         regGC_CAC_WEIGHT_UTCL2_VML2_2;
typedef union GC_CAC_WEIGHT_UTCL2_WALKER_0                       regGC_CAC_WEIGHT_UTCL2_WALKER_0;
typedef union GC_CAC_WEIGHT_UTCL2_WALKER_1                       regGC_CAC_WEIGHT_UTCL2_WALKER_1;
typedef union GC_CAC_WEIGHT_UTCL2_WALKER_2                       regGC_CAC_WEIGHT_UTCL2_WALKER_2;
typedef union GC_CAC_WEIGHT_VGT_0                                regGC_CAC_WEIGHT_VGT_0;
typedef union GC_CAC_WEIGHT_VGT_1                                regGC_CAC_WEIGHT_VGT_1;
typedef union GC_CAC_WEIGHT_WD_0                                 regGC_CAC_WEIGHT_WD_0;
typedef union GC_DIDT_CTRL0                                      regGC_DIDT_CTRL0;
typedef union GC_DIDT_CTRL1                                      regGC_DIDT_CTRL1;
typedef union GC_DIDT_CTRL2                                      regGC_DIDT_CTRL2;
typedef union GC_DIDT_DROOP_CTRL                                 regGC_DIDT_DROOP_CTRL;
typedef union GC_DIDT_DROOP_CTRL1                                regGC_DIDT_DROOP_CTRL1;
typedef union GC_DIDT_WEIGHT                                     regGC_DIDT_WEIGHT;
typedef union GC_DIDT_WEIGHT_1                                   regGC_DIDT_WEIGHT_1;
typedef union GC_EDC_CTRL                                        regGC_EDC_CTRL;
typedef union GC_EDC_DROOP_CTRL                                  regGC_EDC_DROOP_CTRL;
typedef union GC_EDC_OVERFLOW                                    regGC_EDC_OVERFLOW;
typedef union GC_EDC_PERF_COUNTER                                regGC_EDC_PERF_COUNTER;
typedef union GC_EDC_ROLLING_POWER_DELTA                         regGC_EDC_ROLLING_POWER_DELTA;
typedef union GC_EDC_STATUS                                      regGC_EDC_STATUS;
typedef union GC_EDC_THRESHOLD                                   regGC_EDC_THRESHOLD;
typedef union GC_IH_COOKIE_0_PTR                                 regGC_IH_COOKIE_0_PTR;
typedef union GC_THROTTLE_CTRL                                   regGC_THROTTLE_CTRL;
typedef union GC_THROTTLE_CTRL1                                  regGC_THROTTLE_CTRL1;
typedef union GC_THROTTLE_STATUS                                 regGC_THROTTLE_STATUS;
typedef union GC_USER_PRIM_CONFIG                                regGC_USER_PRIM_CONFIG;
typedef union GC_USER_RB_BACKEND_DISABLE                         regGC_USER_RB_BACKEND_DISABLE;
typedef union GC_USER_RB_REDUNDANCY                              regGC_USER_RB_REDUNDANCY;
typedef union GC_USER_RMI_REDUNDANCY                             regGC_USER_RMI_REDUNDANCY;
typedef union GC_USER_SHADER_ARRAY_CONFIG                        regGC_USER_SHADER_ARRAY_CONFIG;
typedef union GC_USER_SHADER_RATE_CONFIG                         regGC_USER_SHADER_RATE_CONFIG;
typedef union GDS_PERFCOUNTER0_HI                                regGDS_PERFCOUNTER0_HI;
typedef union GDS_PERFCOUNTER0_LO                                regGDS_PERFCOUNTER0_LO;
typedef union GDS_PERFCOUNTER0_SELECT                            regGDS_PERFCOUNTER0_SELECT;
typedef union GDS_PERFCOUNTER0_SELECT1                           regGDS_PERFCOUNTER0_SELECT1;
typedef union GDS_PERFCOUNTER1_HI                                regGDS_PERFCOUNTER1_HI;
typedef union GDS_PERFCOUNTER1_LO                                regGDS_PERFCOUNTER1_LO;
typedef union GDS_PERFCOUNTER1_SELECT                            regGDS_PERFCOUNTER1_SELECT;
typedef union GDS_PERFCOUNTER2_HI                                regGDS_PERFCOUNTER2_HI;
typedef union GDS_PERFCOUNTER2_LO                                regGDS_PERFCOUNTER2_LO;
typedef union GDS_PERFCOUNTER2_SELECT                            regGDS_PERFCOUNTER2_SELECT;
typedef union GDS_PERFCOUNTER3_HI                                regGDS_PERFCOUNTER3_HI;
typedef union GDS_PERFCOUNTER3_LO                                regGDS_PERFCOUNTER3_LO;
typedef union GDS_PERFCOUNTER3_SELECT                            regGDS_PERFCOUNTER3_SELECT;
typedef union GE_CNTL                                            regGE_CNTL;
typedef union GE_DMA_FIRST_INDEX                                 regGE_DMA_FIRST_INDEX;
typedef union GE_FAST_CLKS                                       regGE_FAST_CLKS;
typedef union GE_INDX_OFFSET                                     regGE_INDX_OFFSET;
typedef union GE_MAX_OUTPUT_PER_SUBGROUP                         regGE_MAX_OUTPUT_PER_SUBGROUP;
typedef union GE_MAX_VTX_INDX                                    regGE_MAX_VTX_INDX;
typedef union GE_MIN_VTX_INDX                                    regGE_MIN_VTX_INDX;
typedef union GE_MULTI_PRIM_IB_RESET_EN                          regGE_MULTI_PRIM_IB_RESET_EN;
typedef union GE_NGG_SUBGRP_CNTL                                 regGE_NGG_SUBGRP_CNTL;
typedef union GE_PC_ALLOC                                        regGE_PC_ALLOC;
typedef union GE_PC_CNTL                                         regGE_PC_CNTL;
typedef union GE_PERFCOUNTER0_HI                                 regGE_PERFCOUNTER0_HI;
typedef union GE_PERFCOUNTER0_LO                                 regGE_PERFCOUNTER0_LO;
typedef union GE_PERFCOUNTER0_SELECT                             regGE_PERFCOUNTER0_SELECT;
typedef union GE_PERFCOUNTER0_SELECT1                            regGE_PERFCOUNTER0_SELECT1;
typedef union GE_PERFCOUNTER1_HI                                 regGE_PERFCOUNTER1_HI;
typedef union GE_PERFCOUNTER1_LO                                 regGE_PERFCOUNTER1_LO;
typedef union GE_PERFCOUNTER1_SELECT                             regGE_PERFCOUNTER1_SELECT;
typedef union GE_PERFCOUNTER1_SELECT1                            regGE_PERFCOUNTER1_SELECT1;
typedef union GE_PERFCOUNTER2_HI                                 regGE_PERFCOUNTER2_HI;
typedef union GE_PERFCOUNTER2_LO                                 regGE_PERFCOUNTER2_LO;
typedef union GE_PERFCOUNTER2_SELECT                             regGE_PERFCOUNTER2_SELECT;
typedef union GE_PERFCOUNTER2_SELECT1                            regGE_PERFCOUNTER2_SELECT1;
typedef union GE_PERFCOUNTER3_HI                                 regGE_PERFCOUNTER3_HI;
typedef union GE_PERFCOUNTER3_LO                                 regGE_PERFCOUNTER3_LO;
typedef union GE_PERFCOUNTER3_SELECT                             regGE_PERFCOUNTER3_SELECT;
typedef union GE_PERFCOUNTER3_SELECT1                            regGE_PERFCOUNTER3_SELECT1;
typedef union GE_PERFCOUNTER4_HI                                 regGE_PERFCOUNTER4_HI;
typedef union GE_PERFCOUNTER4_LO                                 regGE_PERFCOUNTER4_LO;
typedef union GE_PERFCOUNTER4_SELECT                             regGE_PERFCOUNTER4_SELECT;
typedef union GE_PERFCOUNTER5_HI                                 regGE_PERFCOUNTER5_HI;
typedef union GE_PERFCOUNTER5_LO                                 regGE_PERFCOUNTER5_LO;
typedef union GE_PERFCOUNTER5_SELECT                             regGE_PERFCOUNTER5_SELECT;
typedef union GE_PERFCOUNTER6_HI                                 regGE_PERFCOUNTER6_HI;
typedef union GE_PERFCOUNTER6_LO                                 regGE_PERFCOUNTER6_LO;
typedef union GE_PERFCOUNTER6_SELECT                             regGE_PERFCOUNTER6_SELECT;
typedef union GE_PERFCOUNTER7_HI                                 regGE_PERFCOUNTER7_HI;
typedef union GE_PERFCOUNTER7_LO                                 regGE_PERFCOUNTER7_LO;
typedef union GE_PERFCOUNTER7_SELECT                             regGE_PERFCOUNTER7_SELECT;
typedef union GE_PERFCOUNTER8_HI                                 regGE_PERFCOUNTER8_HI;
typedef union GE_PERFCOUNTER8_LO                                 regGE_PERFCOUNTER8_LO;
typedef union GE_PERFCOUNTER8_SELECT                             regGE_PERFCOUNTER8_SELECT;
typedef union GE_PERFCOUNTER9_HI                                 regGE_PERFCOUNTER9_HI;
typedef union GE_PERFCOUNTER9_LO                                 regGE_PERFCOUNTER9_LO;
typedef union GE_PERFCOUNTER9_SELECT                             regGE_PERFCOUNTER9_SELECT;
typedef union GE_PERFCOUNTER10_HI                                regGE_PERFCOUNTER10_HI;
typedef union GE_PERFCOUNTER10_LO                                regGE_PERFCOUNTER10_LO;
typedef union GE_PERFCOUNTER10_SELECT                            regGE_PERFCOUNTER10_SELECT;
typedef union GE_PERFCOUNTER11_HI                                regGE_PERFCOUNTER11_HI;
typedef union GE_PERFCOUNTER11_LO                                regGE_PERFCOUNTER11_LO;
typedef union GE_PERFCOUNTER11_SELECT                            regGE_PERFCOUNTER11_SELECT;
typedef union GE_PRIV_CONTROL                                    regGE_PRIV_CONTROL;
typedef union GE_STATUS                                          regGE_STATUS;
typedef union GE_STEREO_CNTL                                     regGE_STEREO_CNTL;
typedef union GE_USER_VGPR1                                      regGE_USER_VGPR1;
typedef union GE_USER_VGPR2                                      regGE_USER_VGPR2;
typedef union GE_USER_VGPR3                                      regGE_USER_VGPR3;
typedef union GE_USER_VGPR_EN                                    regGE_USER_VGPR_EN;
typedef union GFX_COPY_STATE                                     regGFX_COPY_STATE;
typedef union GFX_GAP_PWROK                                      regGFX_GAP_PWROK;
typedef union GFX_PIPE_CONTROL                                   regGFX_PIPE_CONTROL;
typedef union GFX_PIPE_PRIORITY                                  regGFX_PIPE_PRIORITY;
typedef union GL1A_PERFCOUNTER0_HI                               regGL1A_PERFCOUNTER0_HI;
typedef union GL1A_PERFCOUNTER0_LO                               regGL1A_PERFCOUNTER0_LO;
typedef union GL1A_PERFCOUNTER0_SELECT                           regGL1A_PERFCOUNTER0_SELECT;
typedef union GL1A_PERFCOUNTER0_SELECT1                          regGL1A_PERFCOUNTER0_SELECT1;
typedef union GL1A_PERFCOUNTER1_HI                               regGL1A_PERFCOUNTER1_HI;
typedef union GL1A_PERFCOUNTER1_LO                               regGL1A_PERFCOUNTER1_LO;
typedef union GL1A_PERFCOUNTER1_SELECT                           regGL1A_PERFCOUNTER1_SELECT;
typedef union GL1A_PERFCOUNTER2_HI                               regGL1A_PERFCOUNTER2_HI;
typedef union GL1A_PERFCOUNTER2_LO                               regGL1A_PERFCOUNTER2_LO;
typedef union GL1A_PERFCOUNTER2_SELECT                           regGL1A_PERFCOUNTER2_SELECT;
typedef union GL1A_PERFCOUNTER3_HI                               regGL1A_PERFCOUNTER3_HI;
typedef union GL1A_PERFCOUNTER3_LO                               regGL1A_PERFCOUNTER3_LO;
typedef union GL1A_PERFCOUNTER3_SELECT                           regGL1A_PERFCOUNTER3_SELECT;
typedef union GL1C_PERFCOUNTER0_HI                               regGL1C_PERFCOUNTER0_HI;
typedef union GL1C_PERFCOUNTER0_LO                               regGL1C_PERFCOUNTER0_LO;
typedef union GL1C_PERFCOUNTER0_SELECT                           regGL1C_PERFCOUNTER0_SELECT;
typedef union GL1C_PERFCOUNTER0_SELECT1                          regGL1C_PERFCOUNTER0_SELECT1;
typedef union GL1C_PERFCOUNTER1_HI                               regGL1C_PERFCOUNTER1_HI;
typedef union GL1C_PERFCOUNTER1_LO                               regGL1C_PERFCOUNTER1_LO;
typedef union GL1C_PERFCOUNTER1_SELECT                           regGL1C_PERFCOUNTER1_SELECT;
typedef union GL1C_PERFCOUNTER2_HI                               regGL1C_PERFCOUNTER2_HI;
typedef union GL1C_PERFCOUNTER2_LO                               regGL1C_PERFCOUNTER2_LO;
typedef union GL1C_PERFCOUNTER2_SELECT                           regGL1C_PERFCOUNTER2_SELECT;
typedef union GL1C_PERFCOUNTER3_HI                               regGL1C_PERFCOUNTER3_HI;
typedef union GL1C_PERFCOUNTER3_LO                               regGL1C_PERFCOUNTER3_LO;
typedef union GL1C_PERFCOUNTER3_SELECT                           regGL1C_PERFCOUNTER3_SELECT;
typedef union GL1_ARB_CTRL                                       regGL1_ARB_CTRL;
typedef union GL1_ARB_STATUS                                     regGL1_ARB_STATUS;
typedef union GL1_DRAM_BURST_CTRL                                regGL1_DRAM_BURST_CTRL;
typedef union GL1_DRAM_BURST_MASK                                regGL1_DRAM_BURST_MASK;
typedef union GL1_PIPE_STEER                                     regGL1_PIPE_STEER;
typedef union GL2A_PERFCOUNTER0_HI                               regGL2A_PERFCOUNTER0_HI;
typedef union GL2A_PERFCOUNTER0_LO                               regGL2A_PERFCOUNTER0_LO;
typedef union GL2A_PERFCOUNTER0_SELECT                           regGL2A_PERFCOUNTER0_SELECT;
typedef union GL2A_PERFCOUNTER0_SELECT1                          regGL2A_PERFCOUNTER0_SELECT1;
typedef union GL2A_PERFCOUNTER1_HI                               regGL2A_PERFCOUNTER1_HI;
typedef union GL2A_PERFCOUNTER1_LO                               regGL2A_PERFCOUNTER1_LO;
typedef union GL2A_PERFCOUNTER1_SELECT                           regGL2A_PERFCOUNTER1_SELECT;
typedef union GL2A_PERFCOUNTER1_SELECT1                          regGL2A_PERFCOUNTER1_SELECT1;
typedef union GL2A_PERFCOUNTER2_HI                               regGL2A_PERFCOUNTER2_HI;
typedef union GL2A_PERFCOUNTER2_LO                               regGL2A_PERFCOUNTER2_LO;
typedef union GL2A_PERFCOUNTER2_SELECT                           regGL2A_PERFCOUNTER2_SELECT;
typedef union GL2A_PERFCOUNTER3_HI                               regGL2A_PERFCOUNTER3_HI;
typedef union GL2A_PERFCOUNTER3_LO                               regGL2A_PERFCOUNTER3_LO;
typedef union GL2A_PERFCOUNTER3_SELECT                           regGL2A_PERFCOUNTER3_SELECT;
typedef union GL2C_PERFCOUNTER0_HI                               regGL2C_PERFCOUNTER0_HI;
typedef union GL2C_PERFCOUNTER0_LO                               regGL2C_PERFCOUNTER0_LO;
typedef union GL2C_PERFCOUNTER0_SELECT                           regGL2C_PERFCOUNTER0_SELECT;
typedef union GL2C_PERFCOUNTER0_SELECT1                          regGL2C_PERFCOUNTER0_SELECT1;
typedef union GL2C_PERFCOUNTER1_HI                               regGL2C_PERFCOUNTER1_HI;
typedef union GL2C_PERFCOUNTER1_LO                               regGL2C_PERFCOUNTER1_LO;
typedef union GL2C_PERFCOUNTER1_SELECT                           regGL2C_PERFCOUNTER1_SELECT;
typedef union GL2C_PERFCOUNTER1_SELECT1                          regGL2C_PERFCOUNTER1_SELECT1;
typedef union GL2C_PERFCOUNTER2_HI                               regGL2C_PERFCOUNTER2_HI;
typedef union GL2C_PERFCOUNTER2_LO                               regGL2C_PERFCOUNTER2_LO;
typedef union GL2C_PERFCOUNTER2_SELECT                           regGL2C_PERFCOUNTER2_SELECT;
typedef union GL2C_PERFCOUNTER3_HI                               regGL2C_PERFCOUNTER3_HI;
typedef union GL2C_PERFCOUNTER3_LO                               regGL2C_PERFCOUNTER3_LO;
typedef union GL2C_PERFCOUNTER3_SELECT                           regGL2C_PERFCOUNTER3_SELECT;
typedef union GL2_PIPE_STEER_0                                   regGL2_PIPE_STEER_0;
typedef union GL2_PIPE_STEER_1                                   regGL2_PIPE_STEER_1;
typedef union GRBM_CAM_DATA                                      regGRBM_CAM_DATA;
typedef union GRBM_CAM_DATA_UPPER                                regGRBM_CAM_DATA_UPPER;
typedef union GRBM_CAM_INDEX                                     regGRBM_CAM_INDEX;
typedef union GRBM_CGTT_CLK_CNTL                                 regGRBM_CGTT_CLK_CNTL;
typedef union GRBM_CHICKEN_BITS                                  regGRBM_CHICKEN_BITS;
typedef union GRBM_CHIP_REVISION                                 regGRBM_CHIP_REVISION;
typedef union GRBM_CNTL                                          regGRBM_CNTL;
typedef union GRBM_DEBUG_DATA                                    regGRBM_DEBUG_DATA;
typedef union GRBM_DSM_BYPASS                                    regGRBM_DSM_BYPASS;
typedef union GRBM_FENCE_RANGE0                                  regGRBM_FENCE_RANGE0;
typedef union GRBM_FENCE_RANGE1                                  regGRBM_FENCE_RANGE1;
typedef union GRBM_GFX_CLKEN_CNTL                                regGRBM_GFX_CLKEN_CNTL;
typedef union GRBM_GFX_CNTL                                      regGRBM_GFX_CNTL;
typedef union GRBM_GFX_CNTL_SR_DATA                              regGRBM_GFX_CNTL_SR_DATA;
typedef union GRBM_GFX_CNTL_SR_SELECT                            regGRBM_GFX_CNTL_SR_SELECT;
typedef union GRBM_GFX_INDEX                                     regGRBM_GFX_INDEX;
typedef union GRBM_GFX_INDEX_SR_DATA                             regGRBM_GFX_INDEX_SR_DATA;
typedef union GRBM_GFX_INDEX_SR_SELECT                           regGRBM_GFX_INDEX_SR_SELECT;
typedef union GRBM_HYP_CAM_DATA                                  regGRBM_HYP_CAM_DATA;
typedef union GRBM_HYP_CAM_DATA_UPPER                            regGRBM_HYP_CAM_DATA_UPPER;
typedef union GRBM_HYP_CAM_INDEX                                 regGRBM_HYP_CAM_INDEX;
typedef union GRBM_IH_CREDIT                                     regGRBM_IH_CREDIT;
typedef union GRBM_INT_CNTL                                      regGRBM_INT_CNTL;
typedef union GRBM_IOV_ERROR                                     regGRBM_IOV_ERROR;
typedef union GRBM_IOV_READ_ERROR                                regGRBM_IOV_READ_ERROR;
typedef union GRBM_NOWHERE                                       regGRBM_NOWHERE;
typedef union GRBM_PERFCOUNTER0_HI                               regGRBM_PERFCOUNTER0_HI;
typedef union GRBM_PERFCOUNTER0_LO                               regGRBM_PERFCOUNTER0_LO;
typedef union GRBM_PERFCOUNTER0_SELECT                           regGRBM_PERFCOUNTER0_SELECT;
typedef union GRBM_PERFCOUNTER0_SELECT_HI                        regGRBM_PERFCOUNTER0_SELECT_HI;
typedef union GRBM_PERFCOUNTER1_HI                               regGRBM_PERFCOUNTER1_HI;
typedef union GRBM_PERFCOUNTER1_LO                               regGRBM_PERFCOUNTER1_LO;
typedef union GRBM_PERFCOUNTER1_SELECT                           regGRBM_PERFCOUNTER1_SELECT;
typedef union GRBM_PERFCOUNTER1_SELECT_HI                        regGRBM_PERFCOUNTER1_SELECT_HI;
typedef union GRBM_PM_CNTL                                       regGRBM_PM_CNTL;
typedef union GRBM_PWR_CNTL                                      regGRBM_PWR_CNTL;
typedef union GRBM_PWR_CNTL2                                     regGRBM_PWR_CNTL2;
typedef union GRBM_READ_ERROR                                    regGRBM_READ_ERROR;
typedef union GRBM_READ_ERROR2                                   regGRBM_READ_ERROR2;
typedef union GRBM_SCRATCH_REG0                                  regGRBM_SCRATCH_REG0;
typedef union GRBM_SCRATCH_REG1                                  regGRBM_SCRATCH_REG1;
typedef union GRBM_SCRATCH_REG2                                  regGRBM_SCRATCH_REG2;
typedef union GRBM_SCRATCH_REG3                                  regGRBM_SCRATCH_REG3;
typedef union GRBM_SCRATCH_REG4                                  regGRBM_SCRATCH_REG4;
typedef union GRBM_SCRATCH_REG5                                  regGRBM_SCRATCH_REG5;
typedef union GRBM_SCRATCH_REG6                                  regGRBM_SCRATCH_REG6;
typedef union GRBM_SCRATCH_REG7                                  regGRBM_SCRATCH_REG7;
typedef union GRBM_SE0_PERFCOUNTER_HI                            regGRBM_SE0_PERFCOUNTER_HI;
typedef union GRBM_SE0_PERFCOUNTER_LO                            regGRBM_SE0_PERFCOUNTER_LO;
typedef union GRBM_SE0_PERFCOUNTER_SELECT                        regGRBM_SE0_PERFCOUNTER_SELECT;
typedef union GRBM_SE1_PERFCOUNTER_HI                            regGRBM_SE1_PERFCOUNTER_HI;
typedef union GRBM_SE1_PERFCOUNTER_LO                            regGRBM_SE1_PERFCOUNTER_LO;
typedef union GRBM_SE1_PERFCOUNTER_SELECT                        regGRBM_SE1_PERFCOUNTER_SELECT;
typedef union GRBM_SE2_PERFCOUNTER_HI                            regGRBM_SE2_PERFCOUNTER_HI;
typedef union GRBM_SE2_PERFCOUNTER_LO                            regGRBM_SE2_PERFCOUNTER_LO;
typedef union GRBM_SE2_PERFCOUNTER_SELECT                        regGRBM_SE2_PERFCOUNTER_SELECT;
typedef union GRBM_SE3_PERFCOUNTER_HI                            regGRBM_SE3_PERFCOUNTER_HI;
typedef union GRBM_SE3_PERFCOUNTER_LO                            regGRBM_SE3_PERFCOUNTER_LO;
typedef union GRBM_SE3_PERFCOUNTER_SELECT                        regGRBM_SE3_PERFCOUNTER_SELECT;
typedef union GRBM_SKEW_CNTL                                     regGRBM_SKEW_CNTL;
typedef union GRBM_SOFT_RESET                                    regGRBM_SOFT_RESET;
typedef union GRBM_STATUS                                        regGRBM_STATUS;
typedef union GRBM_STATUS2                                       regGRBM_STATUS2;
typedef union GRBM_STATUS3                                       regGRBM_STATUS3;
typedef union GRBM_STATUS_SE0                                    regGRBM_STATUS_SE0;
typedef union GRBM_STATUS_SE1                                    regGRBM_STATUS_SE1;
typedef union GRBM_STATUS_SE2                                    regGRBM_STATUS_SE2;
typedef union GRBM_STATUS_SE3                                    regGRBM_STATUS_SE3;
typedef union GRBM_TRAP_ADDR                                     regGRBM_TRAP_ADDR;
typedef union GRBM_TRAP_ADDR_MSK                                 regGRBM_TRAP_ADDR_MSK;
typedef union GRBM_TRAP_OP                                       regGRBM_TRAP_OP;
typedef union GRBM_TRAP_WD                                       regGRBM_TRAP_WD;
typedef union GRBM_TRAP_WD_MSK                                   regGRBM_TRAP_WD_MSK;
typedef union GRBM_UTCL2_INVAL_RANGE_END                         regGRBM_UTCL2_INVAL_RANGE_END;
typedef union GRBM_UTCL2_INVAL_RANGE_START                       regGRBM_UTCL2_INVAL_RANGE_START;
typedef union GRBM_WAIT_IDLE_CLOCKS                              regGRBM_WAIT_IDLE_CLOCKS;
typedef union GRBM_WRITE_ERROR                                   regGRBM_WRITE_ERROR;
typedef union GSL_SOURCE_SELECT                                  regGSL_SOURCE_SELECT;
typedef union GUS_PERFCOUNTER0_CFG                               regGUS_PERFCOUNTER0_CFG;
typedef union GUS_PERFCOUNTER1_CFG                               regGUS_PERFCOUNTER1_CFG;
typedef union GUS_PERFCOUNTER2_HI                                regGUS_PERFCOUNTER2_HI;
typedef union GUS_PERFCOUNTER2_LO                                regGUS_PERFCOUNTER2_LO;
typedef union GUS_PERFCOUNTER2_MODE                              regGUS_PERFCOUNTER2_MODE;
typedef union GUS_PERFCOUNTER2_SELECT                            regGUS_PERFCOUNTER2_SELECT;
typedef union GUS_PERFCOUNTER2_SELECT1                           regGUS_PERFCOUNTER2_SELECT1;
typedef union GUS_PERFCOUNTER_HI                                 regGUS_PERFCOUNTER_HI;
typedef union GUS_PERFCOUNTER_LO                                 regGUS_PERFCOUNTER_LO;
typedef union GUS_PERFCOUNTER_RSLT_CNTL                          regGUS_PERFCOUNTER_RSLT_CNTL;
typedef union gws_DEBUG_DATA                                     reggws_DEBUG_DATA;
typedef union IA_CNTL_STATUS                                     regIA_CNTL_STATUS;
typedef union IA_DEBUG_DATA                                      regIA_DEBUG_DATA;
typedef union IA_DEBUG_REG0                                      regIA_DEBUG_REG0;
typedef union IA_DEBUG_REG1                                      regIA_DEBUG_REG1;
typedef union IA_DEBUG_REG9                                      regIA_DEBUG_REG9;
typedef union IA_DEBUG_REG10                                     regIA_DEBUG_REG10;
typedef union IA_DEBUG_REG11                                     regIA_DEBUG_REG11;
typedef union IA_DEBUG_REG12                                     regIA_DEBUG_REG12;
typedef union IA_DEBUG_REG13                                     regIA_DEBUG_REG13;
typedef union IA_DEBUG_REG14                                     regIA_DEBUG_REG14;
typedef union IA_DEBUG_REG15                                     regIA_DEBUG_REG15;
typedef union IA_DEBUG_REG16                                     regIA_DEBUG_REG16;
typedef union IA_ENHANCE                                         regIA_ENHANCE;
typedef union IA_MULTI_VGT_PARAM                                 regIA_MULTI_VGT_PARAM;
typedef union IA_MULTI_VGT_PARAM_BC                              regIA_MULTI_VGT_PARAM_BC;
typedef union IA_MULTI_VGT_PARAM_PIPED                           regIA_MULTI_VGT_PARAM_PIPED;
typedef union IA_PERFCOUNTER0_HI                                 regIA_PERFCOUNTER0_HI;
typedef union IA_PERFCOUNTER0_LO                                 regIA_PERFCOUNTER0_LO;
typedef union IA_PERFCOUNTER0_SELECT                             regIA_PERFCOUNTER0_SELECT;
typedef union IA_PERFCOUNTER0_SELECT1                            regIA_PERFCOUNTER0_SELECT1;
typedef union IA_PERFCOUNTER1_HI                                 regIA_PERFCOUNTER1_HI;
typedef union IA_PERFCOUNTER1_LO                                 regIA_PERFCOUNTER1_LO;
typedef union IA_PERFCOUNTER1_SELECT                             regIA_PERFCOUNTER1_SELECT;
typedef union IA_PERFCOUNTER2_HI                                 regIA_PERFCOUNTER2_HI;
typedef union IA_PERFCOUNTER2_LO                                 regIA_PERFCOUNTER2_LO;
typedef union IA_PERFCOUNTER2_SELECT                             regIA_PERFCOUNTER2_SELECT;
typedef union IA_PERFCOUNTER3_HI                                 regIA_PERFCOUNTER3_HI;
typedef union IA_PERFCOUNTER3_LO                                 regIA_PERFCOUNTER3_LO;
typedef union IA_PERFCOUNTER3_SELECT                             regIA_PERFCOUNTER3_SELECT;
typedef union IA_UTCL1_CNTL                                      regIA_UTCL1_CNTL;
typedef union IA_UTCL1_STATUS                                    regIA_UTCL1_STATUS;
typedef union IA_UTCL1_STATUS_2                                  regIA_UTCL1_STATUS_2;
typedef union LDS_CONFIG                                         regLDS_CONFIG;
typedef union MC_MEM_POWER_LS                                    regMC_MEM_POWER_LS;
typedef union MC_SHARED_ACTIVE_FCN_ID                            regMC_SHARED_ACTIVE_FCN_ID;
typedef union MC_SHARED_VIRT_RESET_REQ                           regMC_SHARED_VIRT_RESET_REQ;
typedef union MC_VM_AGP_BASE                                     regMC_VM_AGP_BASE;
typedef union MC_VM_AGP_BOT                                      regMC_VM_AGP_BOT;
typedef union MC_VM_AGP_TOP                                      regMC_VM_AGP_TOP;
typedef union MC_VM_APT_CNTL                                     regMC_VM_APT_CNTL;
typedef union MC_VM_CACHEABLE_DRAM_ADDRESS_END                   regMC_VM_CACHEABLE_DRAM_ADDRESS_END;
typedef union MC_VM_CACHEABLE_DRAM_ADDRESS_START                 regMC_VM_CACHEABLE_DRAM_ADDRESS_START;
typedef union MC_VM_FB_LOCATION_BASE                             regMC_VM_FB_LOCATION_BASE;
typedef union MC_VM_FB_LOCATION_TOP                              regMC_VM_FB_LOCATION_TOP;
typedef union MC_VM_FB_OFFSET                                    regMC_VM_FB_OFFSET;
typedef union MC_VM_FB_SIZE_OFFSET_VF0                           regMC_VM_FB_SIZE_OFFSET_VF0;
typedef union MC_VM_FB_SIZE_OFFSET_VF1                           regMC_VM_FB_SIZE_OFFSET_VF1;
typedef union MC_VM_FB_SIZE_OFFSET_VF2                           regMC_VM_FB_SIZE_OFFSET_VF2;
typedef union MC_VM_FB_SIZE_OFFSET_VF3                           regMC_VM_FB_SIZE_OFFSET_VF3;
typedef union MC_VM_FB_SIZE_OFFSET_VF4                           regMC_VM_FB_SIZE_OFFSET_VF4;
typedef union MC_VM_FB_SIZE_OFFSET_VF5                           regMC_VM_FB_SIZE_OFFSET_VF5;
typedef union MC_VM_FB_SIZE_OFFSET_VF6                           regMC_VM_FB_SIZE_OFFSET_VF6;
typedef union MC_VM_FB_SIZE_OFFSET_VF7                           regMC_VM_FB_SIZE_OFFSET_VF7;
typedef union MC_VM_FB_SIZE_OFFSET_VF8                           regMC_VM_FB_SIZE_OFFSET_VF8;
typedef union MC_VM_FB_SIZE_OFFSET_VF9                           regMC_VM_FB_SIZE_OFFSET_VF9;
typedef union MC_VM_FB_SIZE_OFFSET_VF10                          regMC_VM_FB_SIZE_OFFSET_VF10;
typedef union MC_VM_FB_SIZE_OFFSET_VF11                          regMC_VM_FB_SIZE_OFFSET_VF11;
typedef union MC_VM_FB_SIZE_OFFSET_VF12                          regMC_VM_FB_SIZE_OFFSET_VF12;
typedef union MC_VM_FB_SIZE_OFFSET_VF13                          regMC_VM_FB_SIZE_OFFSET_VF13;
typedef union MC_VM_FB_SIZE_OFFSET_VF14                          regMC_VM_FB_SIZE_OFFSET_VF14;
typedef union MC_VM_FB_SIZE_OFFSET_VF15                          regMC_VM_FB_SIZE_OFFSET_VF15;
typedef union MC_VM_L2_PERFCOUNTER0_CFG                          regMC_VM_L2_PERFCOUNTER0_CFG;
typedef union MC_VM_L2_PERFCOUNTER1_CFG                          regMC_VM_L2_PERFCOUNTER1_CFG;
typedef union MC_VM_L2_PERFCOUNTER2_CFG                          regMC_VM_L2_PERFCOUNTER2_CFG;
typedef union MC_VM_L2_PERFCOUNTER3_CFG                          regMC_VM_L2_PERFCOUNTER3_CFG;
typedef union MC_VM_L2_PERFCOUNTER4_CFG                          regMC_VM_L2_PERFCOUNTER4_CFG;
typedef union MC_VM_L2_PERFCOUNTER5_CFG                          regMC_VM_L2_PERFCOUNTER5_CFG;
typedef union MC_VM_L2_PERFCOUNTER6_CFG                          regMC_VM_L2_PERFCOUNTER6_CFG;
typedef union MC_VM_L2_PERFCOUNTER7_CFG                          regMC_VM_L2_PERFCOUNTER7_CFG;
typedef union MC_VM_L2_PERFCOUNTER_HI                            regMC_VM_L2_PERFCOUNTER_HI;
typedef union MC_VM_L2_PERFCOUNTER_LO                            regMC_VM_L2_PERFCOUNTER_LO;
typedef union MC_VM_L2_PERFCOUNTER_RSLT_CNTL                     regMC_VM_L2_PERFCOUNTER_RSLT_CNTL;
typedef union MC_VM_LOCAL_HBM_ADDRESS_END                        regMC_VM_LOCAL_HBM_ADDRESS_END;
typedef union MC_VM_LOCAL_HBM_ADDRESS_LOCK_CNTL                  regMC_VM_LOCAL_HBM_ADDRESS_LOCK_CNTL;
typedef union MC_VM_LOCAL_HBM_ADDRESS_START                      regMC_VM_LOCAL_HBM_ADDRESS_START;
typedef union MC_VM_MARC_BASE_HI_0                               regMC_VM_MARC_BASE_HI_0;
typedef union MC_VM_MARC_BASE_HI_1                               regMC_VM_MARC_BASE_HI_1;
typedef union MC_VM_MARC_BASE_HI_2                               regMC_VM_MARC_BASE_HI_2;
typedef union MC_VM_MARC_BASE_HI_3                               regMC_VM_MARC_BASE_HI_3;
typedef union MC_VM_MARC_BASE_LO_0                               regMC_VM_MARC_BASE_LO_0;
typedef union MC_VM_MARC_BASE_LO_1                               regMC_VM_MARC_BASE_LO_1;
typedef union MC_VM_MARC_BASE_LO_2                               regMC_VM_MARC_BASE_LO_2;
typedef union MC_VM_MARC_BASE_LO_3                               regMC_VM_MARC_BASE_LO_3;
typedef union MC_VM_MARC_LEN_HI_0                                regMC_VM_MARC_LEN_HI_0;
typedef union MC_VM_MARC_LEN_HI_1                                regMC_VM_MARC_LEN_HI_1;
typedef union MC_VM_MARC_LEN_HI_2                                regMC_VM_MARC_LEN_HI_2;
typedef union MC_VM_MARC_LEN_HI_3                                regMC_VM_MARC_LEN_HI_3;
typedef union MC_VM_MARC_LEN_LO_0                                regMC_VM_MARC_LEN_LO_0;
typedef union MC_VM_MARC_LEN_LO_1                                regMC_VM_MARC_LEN_LO_1;
typedef union MC_VM_MARC_LEN_LO_2                                regMC_VM_MARC_LEN_LO_2;
typedef union MC_VM_MARC_LEN_LO_3                                regMC_VM_MARC_LEN_LO_3;
typedef union MC_VM_MARC_RELOC_HI_0                              regMC_VM_MARC_RELOC_HI_0;
typedef union MC_VM_MARC_RELOC_HI_1                              regMC_VM_MARC_RELOC_HI_1;
typedef union MC_VM_MARC_RELOC_HI_2                              regMC_VM_MARC_RELOC_HI_2;
typedef union MC_VM_MARC_RELOC_HI_3                              regMC_VM_MARC_RELOC_HI_3;
typedef union MC_VM_MARC_RELOC_LO_0                              regMC_VM_MARC_RELOC_LO_0;
typedef union MC_VM_MARC_RELOC_LO_1                              regMC_VM_MARC_RELOC_LO_1;
typedef union MC_VM_MARC_RELOC_LO_2                              regMC_VM_MARC_RELOC_LO_2;
typedef union MC_VM_MARC_RELOC_LO_3                              regMC_VM_MARC_RELOC_LO_3;
typedef union MC_VM_MX_L1_TLB_CNTL                               regMC_VM_MX_L1_TLB_CNTL;
typedef union MC_VM_NB_LOWER_TOP_OF_DRAM2                        regMC_VM_NB_LOWER_TOP_OF_DRAM2;
typedef union MC_VM_NB_MMIOBASE                                  regMC_VM_NB_MMIOBASE;
typedef union MC_VM_NB_MMIOLIMIT                                 regMC_VM_NB_MMIOLIMIT;
typedef union MC_VM_NB_PCI_ARB                                   regMC_VM_NB_PCI_ARB;
typedef union MC_VM_NB_PCI_CTRL                                  regMC_VM_NB_PCI_CTRL;
typedef union MC_VM_NB_TOP_OF_DRAM_SLOT1                         regMC_VM_NB_TOP_OF_DRAM_SLOT1;
typedef union MC_VM_NB_UPPER_TOP_OF_DRAM2                        regMC_VM_NB_UPPER_TOP_OF_DRAM2;
typedef union MC_VM_STEERING                                     regMC_VM_STEERING;
typedef union MC_VM_SYSTEM_APERTURE_DEFAULT_ADDR_LSB             regMC_VM_SYSTEM_APERTURE_DEFAULT_ADDR_LSB;
typedef union MC_VM_SYSTEM_APERTURE_DEFAULT_ADDR_MSB             regMC_VM_SYSTEM_APERTURE_DEFAULT_ADDR_MSB;
typedef union MC_VM_SYSTEM_APERTURE_HIGH_ADDR                    regMC_VM_SYSTEM_APERTURE_HIGH_ADDR;
typedef union MC_VM_SYSTEM_APERTURE_LOW_ADDR                     regMC_VM_SYSTEM_APERTURE_LOW_ADDR;
typedef union MC_VM_XGMI_GPUIOV_ENABLE                           regMC_VM_XGMI_GPUIOV_ENABLE;
typedef union MC_VM_XGMI_LFB_CNTL                                regMC_VM_XGMI_LFB_CNTL;
typedef union MC_VM_XGMI_LFB_SIZE                                regMC_VM_XGMI_LFB_SIZE;
typedef union oa_wc0_DEBUG_DATA                                  regoa_wc0_DEBUG_DATA;
typedef union oa_wc1_DEBUG_DATA                                  regoa_wc1_DEBUG_DATA;
typedef union ord_app_DEBUG_DATA                                 regord_app_DEBUG_DATA;
typedef union PA_CL_CLIP_CNTL                                    regPA_CL_CLIP_CNTL;
typedef union PA_CL_CNTL_STATUS                                  regPA_CL_CNTL_STATUS;
typedef union PA_CL_ENHANCE                                      regPA_CL_ENHANCE;
typedef union PA_CL_GB_HORZ_CLIP_ADJ                             regPA_CL_GB_HORZ_CLIP_ADJ;
typedef union PA_CL_GB_HORZ_DISC_ADJ                             regPA_CL_GB_HORZ_DISC_ADJ;
typedef union PA_CL_GB_VERT_CLIP_ADJ                             regPA_CL_GB_VERT_CLIP_ADJ;
typedef union PA_CL_GB_VERT_DISC_ADJ                             regPA_CL_GB_VERT_DISC_ADJ;
typedef union PA_CL_NANINF_CNTL                                  regPA_CL_NANINF_CNTL;
typedef union PA_CL_NGG_CNTL                                     regPA_CL_NGG_CNTL;
typedef union PA_CL_POINT_CULL_RAD                               regPA_CL_POINT_CULL_RAD;
typedef union PA_CL_POINT_SIZE                                   regPA_CL_POINT_SIZE;
typedef union PA_CL_POINT_X_RAD                                  regPA_CL_POINT_X_RAD;
typedef union PA_CL_POINT_Y_RAD                                  regPA_CL_POINT_Y_RAD;
typedef union PA_CL_PROG_NEAR_CLIP_Z                             regPA_CL_PROG_NEAR_CLIP_Z;
typedef union PA_CL_RESET_DEBUG                                  regPA_CL_RESET_DEBUG;
typedef union PA_CL_UCP_0_W                                      regPA_CL_UCP_0_W;
typedef union PA_CL_UCP_0_X                                      regPA_CL_UCP_0_X;
typedef union PA_CL_UCP_0_Y                                      regPA_CL_UCP_0_Y;
typedef union PA_CL_UCP_0_Z                                      regPA_CL_UCP_0_Z;
typedef union PA_CL_UCP_1_W                                      regPA_CL_UCP_1_W;
typedef union PA_CL_UCP_1_X                                      regPA_CL_UCP_1_X;
typedef union PA_CL_UCP_1_Y                                      regPA_CL_UCP_1_Y;
typedef union PA_CL_UCP_1_Z                                      regPA_CL_UCP_1_Z;
typedef union PA_CL_UCP_2_W                                      regPA_CL_UCP_2_W;
typedef union PA_CL_UCP_2_X                                      regPA_CL_UCP_2_X;
typedef union PA_CL_UCP_2_Y                                      regPA_CL_UCP_2_Y;
typedef union PA_CL_UCP_2_Z                                      regPA_CL_UCP_2_Z;
typedef union PA_CL_UCP_3_W                                      regPA_CL_UCP_3_W;
typedef union PA_CL_UCP_3_X                                      regPA_CL_UCP_3_X;
typedef union PA_CL_UCP_3_Y                                      regPA_CL_UCP_3_Y;
typedef union PA_CL_UCP_3_Z                                      regPA_CL_UCP_3_Z;
typedef union PA_CL_UCP_4_W                                      regPA_CL_UCP_4_W;
typedef union PA_CL_UCP_4_X                                      regPA_CL_UCP_4_X;
typedef union PA_CL_UCP_4_Y                                      regPA_CL_UCP_4_Y;
typedef union PA_CL_UCP_4_Z                                      regPA_CL_UCP_4_Z;
typedef union PA_CL_UCP_5_W                                      regPA_CL_UCP_5_W;
typedef union PA_CL_UCP_5_X                                      regPA_CL_UCP_5_X;
typedef union PA_CL_UCP_5_Y                                      regPA_CL_UCP_5_Y;
typedef union PA_CL_UCP_5_Z                                      regPA_CL_UCP_5_Z;
typedef union PA_CL_VPORT_XOFFSET                                regPA_CL_VPORT_XOFFSET;
typedef union PA_CL_VPORT_XOFFSET_1                              regPA_CL_VPORT_XOFFSET_1;
typedef union PA_CL_VPORT_XOFFSET_2                              regPA_CL_VPORT_XOFFSET_2;
typedef union PA_CL_VPORT_XOFFSET_3                              regPA_CL_VPORT_XOFFSET_3;
typedef union PA_CL_VPORT_XOFFSET_4                              regPA_CL_VPORT_XOFFSET_4;
typedef union PA_CL_VPORT_XOFFSET_5                              regPA_CL_VPORT_XOFFSET_5;
typedef union PA_CL_VPORT_XOFFSET_6                              regPA_CL_VPORT_XOFFSET_6;
typedef union PA_CL_VPORT_XOFFSET_7                              regPA_CL_VPORT_XOFFSET_7;
typedef union PA_CL_VPORT_XOFFSET_8                              regPA_CL_VPORT_XOFFSET_8;
typedef union PA_CL_VPORT_XOFFSET_9                              regPA_CL_VPORT_XOFFSET_9;
typedef union PA_CL_VPORT_XOFFSET_10                             regPA_CL_VPORT_XOFFSET_10;
typedef union PA_CL_VPORT_XOFFSET_11                             regPA_CL_VPORT_XOFFSET_11;
typedef union PA_CL_VPORT_XOFFSET_12                             regPA_CL_VPORT_XOFFSET_12;
typedef union PA_CL_VPORT_XOFFSET_13                             regPA_CL_VPORT_XOFFSET_13;
typedef union PA_CL_VPORT_XOFFSET_14                             regPA_CL_VPORT_XOFFSET_14;
typedef union PA_CL_VPORT_XOFFSET_15                             regPA_CL_VPORT_XOFFSET_15;
typedef union PA_CL_VPORT_XSCALE                                 regPA_CL_VPORT_XSCALE;
typedef union PA_CL_VPORT_XSCALE_1                               regPA_CL_VPORT_XSCALE_1;
typedef union PA_CL_VPORT_XSCALE_2                               regPA_CL_VPORT_XSCALE_2;
typedef union PA_CL_VPORT_XSCALE_3                               regPA_CL_VPORT_XSCALE_3;
typedef union PA_CL_VPORT_XSCALE_4                               regPA_CL_VPORT_XSCALE_4;
typedef union PA_CL_VPORT_XSCALE_5                               regPA_CL_VPORT_XSCALE_5;
typedef union PA_CL_VPORT_XSCALE_6                               regPA_CL_VPORT_XSCALE_6;
typedef union PA_CL_VPORT_XSCALE_7                               regPA_CL_VPORT_XSCALE_7;
typedef union PA_CL_VPORT_XSCALE_8                               regPA_CL_VPORT_XSCALE_8;
typedef union PA_CL_VPORT_XSCALE_9                               regPA_CL_VPORT_XSCALE_9;
typedef union PA_CL_VPORT_XSCALE_10                              regPA_CL_VPORT_XSCALE_10;
typedef union PA_CL_VPORT_XSCALE_11                              regPA_CL_VPORT_XSCALE_11;
typedef union PA_CL_VPORT_XSCALE_12                              regPA_CL_VPORT_XSCALE_12;
typedef union PA_CL_VPORT_XSCALE_13                              regPA_CL_VPORT_XSCALE_13;
typedef union PA_CL_VPORT_XSCALE_14                              regPA_CL_VPORT_XSCALE_14;
typedef union PA_CL_VPORT_XSCALE_15                              regPA_CL_VPORT_XSCALE_15;
typedef union PA_CL_VPORT_YOFFSET                                regPA_CL_VPORT_YOFFSET;
typedef union PA_CL_VPORT_YOFFSET_1                              regPA_CL_VPORT_YOFFSET_1;
typedef union PA_CL_VPORT_YOFFSET_2                              regPA_CL_VPORT_YOFFSET_2;
typedef union PA_CL_VPORT_YOFFSET_3                              regPA_CL_VPORT_YOFFSET_3;
typedef union PA_CL_VPORT_YOFFSET_4                              regPA_CL_VPORT_YOFFSET_4;
typedef union PA_CL_VPORT_YOFFSET_5                              regPA_CL_VPORT_YOFFSET_5;
typedef union PA_CL_VPORT_YOFFSET_6                              regPA_CL_VPORT_YOFFSET_6;
typedef union PA_CL_VPORT_YOFFSET_7                              regPA_CL_VPORT_YOFFSET_7;
typedef union PA_CL_VPORT_YOFFSET_8                              regPA_CL_VPORT_YOFFSET_8;
typedef union PA_CL_VPORT_YOFFSET_9                              regPA_CL_VPORT_YOFFSET_9;
typedef union PA_CL_VPORT_YOFFSET_10                             regPA_CL_VPORT_YOFFSET_10;
typedef union PA_CL_VPORT_YOFFSET_11                             regPA_CL_VPORT_YOFFSET_11;
typedef union PA_CL_VPORT_YOFFSET_12                             regPA_CL_VPORT_YOFFSET_12;
typedef union PA_CL_VPORT_YOFFSET_13                             regPA_CL_VPORT_YOFFSET_13;
typedef union PA_CL_VPORT_YOFFSET_14                             regPA_CL_VPORT_YOFFSET_14;
typedef union PA_CL_VPORT_YOFFSET_15                             regPA_CL_VPORT_YOFFSET_15;
typedef union PA_CL_VPORT_YSCALE                                 regPA_CL_VPORT_YSCALE;
typedef union PA_CL_VPORT_YSCALE_1                               regPA_CL_VPORT_YSCALE_1;
typedef union PA_CL_VPORT_YSCALE_2                               regPA_CL_VPORT_YSCALE_2;
typedef union PA_CL_VPORT_YSCALE_3                               regPA_CL_VPORT_YSCALE_3;
typedef union PA_CL_VPORT_YSCALE_4                               regPA_CL_VPORT_YSCALE_4;
typedef union PA_CL_VPORT_YSCALE_5                               regPA_CL_VPORT_YSCALE_5;
typedef union PA_CL_VPORT_YSCALE_6                               regPA_CL_VPORT_YSCALE_6;
typedef union PA_CL_VPORT_YSCALE_7                               regPA_CL_VPORT_YSCALE_7;
typedef union PA_CL_VPORT_YSCALE_8                               regPA_CL_VPORT_YSCALE_8;
typedef union PA_CL_VPORT_YSCALE_9                               regPA_CL_VPORT_YSCALE_9;
typedef union PA_CL_VPORT_YSCALE_10                              regPA_CL_VPORT_YSCALE_10;
typedef union PA_CL_VPORT_YSCALE_11                              regPA_CL_VPORT_YSCALE_11;
typedef union PA_CL_VPORT_YSCALE_12                              regPA_CL_VPORT_YSCALE_12;
typedef union PA_CL_VPORT_YSCALE_13                              regPA_CL_VPORT_YSCALE_13;
typedef union PA_CL_VPORT_YSCALE_14                              regPA_CL_VPORT_YSCALE_14;
typedef union PA_CL_VPORT_YSCALE_15                              regPA_CL_VPORT_YSCALE_15;
typedef union PA_CL_VPORT_ZOFFSET                                regPA_CL_VPORT_ZOFFSET;
typedef union PA_CL_VPORT_ZOFFSET_1                              regPA_CL_VPORT_ZOFFSET_1;
typedef union PA_CL_VPORT_ZOFFSET_2                              regPA_CL_VPORT_ZOFFSET_2;
typedef union PA_CL_VPORT_ZOFFSET_3                              regPA_CL_VPORT_ZOFFSET_3;
typedef union PA_CL_VPORT_ZOFFSET_4                              regPA_CL_VPORT_ZOFFSET_4;
typedef union PA_CL_VPORT_ZOFFSET_5                              regPA_CL_VPORT_ZOFFSET_5;
typedef union PA_CL_VPORT_ZOFFSET_6                              regPA_CL_VPORT_ZOFFSET_6;
typedef union PA_CL_VPORT_ZOFFSET_7                              regPA_CL_VPORT_ZOFFSET_7;
typedef union PA_CL_VPORT_ZOFFSET_8                              regPA_CL_VPORT_ZOFFSET_8;
typedef union PA_CL_VPORT_ZOFFSET_9                              regPA_CL_VPORT_ZOFFSET_9;
typedef union PA_CL_VPORT_ZOFFSET_10                             regPA_CL_VPORT_ZOFFSET_10;
typedef union PA_CL_VPORT_ZOFFSET_11                             regPA_CL_VPORT_ZOFFSET_11;
typedef union PA_CL_VPORT_ZOFFSET_12                             regPA_CL_VPORT_ZOFFSET_12;
typedef union PA_CL_VPORT_ZOFFSET_13                             regPA_CL_VPORT_ZOFFSET_13;
typedef union PA_CL_VPORT_ZOFFSET_14                             regPA_CL_VPORT_ZOFFSET_14;
typedef union PA_CL_VPORT_ZOFFSET_15                             regPA_CL_VPORT_ZOFFSET_15;
typedef union PA_CL_VPORT_ZSCALE                                 regPA_CL_VPORT_ZSCALE;
typedef union PA_CL_VPORT_ZSCALE_1                               regPA_CL_VPORT_ZSCALE_1;
typedef union PA_CL_VPORT_ZSCALE_2                               regPA_CL_VPORT_ZSCALE_2;
typedef union PA_CL_VPORT_ZSCALE_3                               regPA_CL_VPORT_ZSCALE_3;
typedef union PA_CL_VPORT_ZSCALE_4                               regPA_CL_VPORT_ZSCALE_4;
typedef union PA_CL_VPORT_ZSCALE_5                               regPA_CL_VPORT_ZSCALE_5;
typedef union PA_CL_VPORT_ZSCALE_6                               regPA_CL_VPORT_ZSCALE_6;
typedef union PA_CL_VPORT_ZSCALE_7                               regPA_CL_VPORT_ZSCALE_7;
typedef union PA_CL_VPORT_ZSCALE_8                               regPA_CL_VPORT_ZSCALE_8;
typedef union PA_CL_VPORT_ZSCALE_9                               regPA_CL_VPORT_ZSCALE_9;
typedef union PA_CL_VPORT_ZSCALE_10                              regPA_CL_VPORT_ZSCALE_10;
typedef union PA_CL_VPORT_ZSCALE_11                              regPA_CL_VPORT_ZSCALE_11;
typedef union PA_CL_VPORT_ZSCALE_12                              regPA_CL_VPORT_ZSCALE_12;
typedef union PA_CL_VPORT_ZSCALE_13                              regPA_CL_VPORT_ZSCALE_13;
typedef union PA_CL_VPORT_ZSCALE_14                              regPA_CL_VPORT_ZSCALE_14;
typedef union PA_CL_VPORT_ZSCALE_15                              regPA_CL_VPORT_ZSCALE_15;
typedef union PA_CL_VS_OUT_CNTL                                  regPA_CL_VS_OUT_CNTL;
typedef union PA_CL_VTE_CNTL                                     regPA_CL_VTE_CNTL;
typedef union PA_DEBUG00_0                                       regPA_DEBUG00_0;
typedef union PA_DEBUG00_1                                       regPA_DEBUG00_1;
typedef union PA_DEBUG01_0                                       regPA_DEBUG01_0;
typedef union PA_DEBUG01_1                                       regPA_DEBUG01_1;
typedef union PA_DEBUG02_0                                       regPA_DEBUG02_0;
typedef union PA_DEBUG02_1                                       regPA_DEBUG02_1;
typedef union PA_DEBUG03_0                                       regPA_DEBUG03_0;
typedef union PA_DEBUG03_1                                       regPA_DEBUG03_1;
typedef union PA_DEBUG04_0                                       regPA_DEBUG04_0;
typedef union PA_DEBUG04_1                                       regPA_DEBUG04_1;
typedef union PA_DEBUG05_0                                       regPA_DEBUG05_0;
typedef union PA_DEBUG05_1                                       regPA_DEBUG05_1;
typedef union PA_DEBUG06_0                                       regPA_DEBUG06_0;
typedef union PA_DEBUG06_1                                       regPA_DEBUG06_1;
typedef union PA_DEBUG07_0                                       regPA_DEBUG07_0;
typedef union PA_DEBUG07_1                                       regPA_DEBUG07_1;
typedef union PA_DEBUG08_0                                       regPA_DEBUG08_0;
typedef union PA_DEBUG08_1                                       regPA_DEBUG08_1;
typedef union PA_DEBUG09_0                                       regPA_DEBUG09_0;
typedef union PA_DEBUG09_1                                       regPA_DEBUG09_1;
typedef union PA_DEBUG10_0                                       regPA_DEBUG10_0;
typedef union PA_DEBUG10_1                                       regPA_DEBUG10_1;
typedef union PA_DEBUG11_0                                       regPA_DEBUG11_0;
typedef union PA_DEBUG11_1                                       regPA_DEBUG11_1;
typedef union PA_DEBUG12_0                                       regPA_DEBUG12_0;
typedef union PA_DEBUG12_1                                       regPA_DEBUG12_1;
typedef union PA_DEBUG13_0                                       regPA_DEBUG13_0;
typedef union PA_DEBUG13_1                                       regPA_DEBUG13_1;
typedef union PA_DEBUG14_0                                       regPA_DEBUG14_0;
typedef union PA_DEBUG14_1                                       regPA_DEBUG14_1;
typedef union PA_DEBUG15_0                                       regPA_DEBUG15_0;
typedef union PA_DEBUG15_1                                       regPA_DEBUG15_1;
typedef union PA_DEBUG16_0                                       regPA_DEBUG16_0;
typedef union PA_DEBUG16_1                                       regPA_DEBUG16_1;
typedef union PA_DEBUG17_0                                       regPA_DEBUG17_0;
typedef union PA_DEBUG17_1                                       regPA_DEBUG17_1;
typedef union PA_DEBUG18_0                                       regPA_DEBUG18_0;
typedef union PA_DEBUG18_1                                       regPA_DEBUG18_1;
typedef union PA_DEBUG19_0                                       regPA_DEBUG19_0;
typedef union PA_DEBUG19_1                                       regPA_DEBUG19_1;
typedef union PA_DEBUG20_0                                       regPA_DEBUG20_0;
typedef union PA_DEBUG20_1                                       regPA_DEBUG20_1;
typedef union PA_DEBUG21_0                                       regPA_DEBUG21_0;
typedef union PA_DEBUG21_1                                       regPA_DEBUG21_1;
typedef union PA_DEBUG22_0                                       regPA_DEBUG22_0;
typedef union PA_DEBUG22_1                                       regPA_DEBUG22_1;
typedef union PA_DEBUG23_0                                       regPA_DEBUG23_0;
typedef union PA_DEBUG24_0                                       regPA_DEBUG24_0;
typedef union PA_DEBUG25_0                                       regPA_DEBUG25_0;
typedef union PA_DEBUG26_0                                       regPA_DEBUG26_0;
typedef union PA_DEBUG27_0                                       regPA_DEBUG27_0;
typedef union PA_DEBUG28_0                                       regPA_DEBUG28_0;
typedef union PA_DEBUG29_0                                       regPA_DEBUG29_0;
typedef union PA_DEBUG30_0                                       regPA_DEBUG30_0;
typedef union PA_DEBUG31_0                                       regPA_DEBUG31_0;
typedef union PA_DEBUG32_0                                       regPA_DEBUG32_0;
typedef union PA_DEBUG33_0                                       regPA_DEBUG33_0;
typedef union PA_DEBUG34_0                                       regPA_DEBUG34_0;
typedef union PA_DEBUG34_1                                       regPA_DEBUG34_1;
typedef union PA_DEBUG35_0                                       regPA_DEBUG35_0;
typedef union PA_DEBUG35_1                                       regPA_DEBUG35_1;
typedef union PA_DEBUG36_0                                       regPA_DEBUG36_0;
typedef union PA_DEBUG36_1                                       regPA_DEBUG36_1;
typedef union PA_DEBUG37_0                                       regPA_DEBUG37_0;
typedef union PA_DEBUG37_1                                       regPA_DEBUG37_1;
typedef union PA_DEBUG38_0                                       regPA_DEBUG38_0;
typedef union PA_DEBUG38_1                                       regPA_DEBUG38_1;
typedef union PA_DEBUG39_0                                       regPA_DEBUG39_0;
typedef union PA_DEBUG39_1                                       regPA_DEBUG39_1;
typedef union PA_DEBUG40_0                                       regPA_DEBUG40_0;
typedef union PA_DEBUG40_1                                       regPA_DEBUG40_1;
typedef union PA_DEBUG41_0                                       regPA_DEBUG41_0;
typedef union PA_DEBUG41_1                                       regPA_DEBUG41_1;
typedef union PA_DEBUG42_0                                       regPA_DEBUG42_0;
typedef union PA_DEBUG42_1                                       regPA_DEBUG42_1;
typedef union PA_DEBUG43_0                                       regPA_DEBUG43_0;
typedef union PA_DEBUG43_1                                       regPA_DEBUG43_1;
typedef union PA_DEBUG44_0                                       regPA_DEBUG44_0;
typedef union PA_DEBUG44_1                                       regPA_DEBUG44_1;
typedef union PA_DEBUG45_0                                       regPA_DEBUG45_0;
typedef union PA_DEBUG45_1                                       regPA_DEBUG45_1;
typedef union PA_DEBUG46_0                                       regPA_DEBUG46_0;
typedef union PA_DEBUG46_1                                       regPA_DEBUG46_1;
typedef union PA_DEBUG47_0                                       regPA_DEBUG47_0;
typedef union PA_DEBUG47_1                                       regPA_DEBUG47_1;
typedef union PA_DEBUG48_0                                       regPA_DEBUG48_0;
typedef union PA_DEBUG48_1                                       regPA_DEBUG48_1;
typedef union PA_DEBUG49_0                                       regPA_DEBUG49_0;
typedef union PA_DEBUG49_1                                       regPA_DEBUG49_1;
typedef union PA_DEBUG50_0                                       regPA_DEBUG50_0;
typedef union PA_DEBUG50_1                                       regPA_DEBUG50_1;
typedef union PA_DEBUG51_0                                       regPA_DEBUG51_0;
typedef union PA_DEBUG52_0                                       regPA_DEBUG52_0;
typedef union PA_DEBUG53_0                                       regPA_DEBUG53_0;
typedef union PA_DEBUG54_0                                       regPA_DEBUG54_0;
typedef union PA_DEBUG55_0                                       regPA_DEBUG55_0;
typedef union PA_PH_ENHANCE                                      regPA_PH_ENHANCE;
typedef union PA_PH_INTERFACE_FIFO_SIZE                          regPA_PH_INTERFACE_FIFO_SIZE;
typedef union PA_PH_PERFCOUNTER0_HI                              regPA_PH_PERFCOUNTER0_HI;
typedef union PA_PH_PERFCOUNTER0_LO                              regPA_PH_PERFCOUNTER0_LO;
typedef union PA_PH_PERFCOUNTER0_SELECT                          regPA_PH_PERFCOUNTER0_SELECT;
typedef union PA_PH_PERFCOUNTER0_SELECT1                         regPA_PH_PERFCOUNTER0_SELECT1;
typedef union PA_PH_PERFCOUNTER1_HI                              regPA_PH_PERFCOUNTER1_HI;
typedef union PA_PH_PERFCOUNTER1_LO                              regPA_PH_PERFCOUNTER1_LO;
typedef union PA_PH_PERFCOUNTER1_SELECT                          regPA_PH_PERFCOUNTER1_SELECT;
typedef union PA_PH_PERFCOUNTER1_SELECT1                         regPA_PH_PERFCOUNTER1_SELECT1;
typedef union PA_PH_PERFCOUNTER2_HI                              regPA_PH_PERFCOUNTER2_HI;
typedef union PA_PH_PERFCOUNTER2_LO                              regPA_PH_PERFCOUNTER2_LO;
typedef union PA_PH_PERFCOUNTER2_SELECT                          regPA_PH_PERFCOUNTER2_SELECT;
typedef union PA_PH_PERFCOUNTER2_SELECT1                         regPA_PH_PERFCOUNTER2_SELECT1;
typedef union PA_PH_PERFCOUNTER3_HI                              regPA_PH_PERFCOUNTER3_HI;
typedef union PA_PH_PERFCOUNTER3_LO                              regPA_PH_PERFCOUNTER3_LO;
typedef union PA_PH_PERFCOUNTER3_SELECT                          regPA_PH_PERFCOUNTER3_SELECT;
typedef union PA_PH_PERFCOUNTER3_SELECT1                         regPA_PH_PERFCOUNTER3_SELECT1;
typedef union PA_PH_PERFCOUNTER4_HI                              regPA_PH_PERFCOUNTER4_HI;
typedef union PA_PH_PERFCOUNTER4_LO                              regPA_PH_PERFCOUNTER4_LO;
typedef union PA_PH_PERFCOUNTER4_SELECT                          regPA_PH_PERFCOUNTER4_SELECT;
typedef union PA_PH_PERFCOUNTER5_HI                              regPA_PH_PERFCOUNTER5_HI;
typedef union PA_PH_PERFCOUNTER5_LO                              regPA_PH_PERFCOUNTER5_LO;
typedef union PA_PH_PERFCOUNTER5_SELECT                          regPA_PH_PERFCOUNTER5_SELECT;
typedef union PA_PH_PERFCOUNTER6_HI                              regPA_PH_PERFCOUNTER6_HI;
typedef union PA_PH_PERFCOUNTER6_LO                              regPA_PH_PERFCOUNTER6_LO;
typedef union PA_PH_PERFCOUNTER6_SELECT                          regPA_PH_PERFCOUNTER6_SELECT;
typedef union PA_PH_PERFCOUNTER7_HI                              regPA_PH_PERFCOUNTER7_HI;
typedef union PA_PH_PERFCOUNTER7_LO                              regPA_PH_PERFCOUNTER7_LO;
typedef union PA_PH_PERFCOUNTER7_SELECT                          regPA_PH_PERFCOUNTER7_SELECT;
typedef union PA_SC_AA_CONFIG                                    regPA_SC_AA_CONFIG;
typedef union PA_SC_AA_MASK_X0Y0_X1Y0                            regPA_SC_AA_MASK_X0Y0_X1Y0;
typedef union PA_SC_AA_MASK_X0Y1_X1Y1                            regPA_SC_AA_MASK_X0Y1_X1Y1;
typedef union PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0                  regPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0;
typedef union PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1                  regPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1;
typedef union PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2                  regPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2;
typedef union PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3                  regPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3;
typedef union PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0                  regPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0;
typedef union PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1                  regPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1;
typedef union PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2                  regPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2;
typedef union PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3                  regPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3;
typedef union PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0                  regPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0;
typedef union PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1                  regPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1;
typedef union PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2                  regPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2;
typedef union PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3                  regPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3;
typedef union PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0                  regPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0;
typedef union PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1                  regPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1;
typedef union PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2                  regPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2;
typedef union PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3                  regPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3;
typedef union PA_SC_BC_WAVE_BREAK                                regPA_SC_BC_WAVE_BREAK;
typedef union PA_SC_BINNER_CNTL_0                                regPA_SC_BINNER_CNTL_0;
typedef union PA_SC_BINNER_CNTL_1                                regPA_SC_BINNER_CNTL_1;
typedef union PA_SC_BINNER_CNTL_OVERRIDE                         regPA_SC_BINNER_CNTL_OVERRIDE;
typedef union PA_SC_BINNER_EVENT_CNTL_0                          regPA_SC_BINNER_EVENT_CNTL_0;
typedef union PA_SC_BINNER_EVENT_CNTL_1                          regPA_SC_BINNER_EVENT_CNTL_1;
typedef union PA_SC_BINNER_EVENT_CNTL_2                          regPA_SC_BINNER_EVENT_CNTL_2;
typedef union PA_SC_BINNER_EVENT_CNTL_3                          regPA_SC_BINNER_EVENT_CNTL_3;
typedef union PA_SC_BINNER_PERF_CNTL_0                           regPA_SC_BINNER_PERF_CNTL_0;
typedef union PA_SC_BINNER_PERF_CNTL_1                           regPA_SC_BINNER_PERF_CNTL_1;
typedef union PA_SC_BINNER_PERF_CNTL_2                           regPA_SC_BINNER_PERF_CNTL_2;
typedef union PA_SC_BINNER_PERF_CNTL_3                           regPA_SC_BINNER_PERF_CNTL_3;
typedef union PA_SC_BINNER_TIMEOUT_COUNTER                       regPA_SC_BINNER_TIMEOUT_COUNTER;
typedef union PA_SC_CENTROID_PRIORITY_0                          regPA_SC_CENTROID_PRIORITY_0;
typedef union PA_SC_CENTROID_PRIORITY_1                          regPA_SC_CENTROID_PRIORITY_1;
typedef union PA_SC_CLIPRECT_0_BR                                regPA_SC_CLIPRECT_0_BR;
typedef union PA_SC_CLIPRECT_0_TL                                regPA_SC_CLIPRECT_0_TL;
typedef union PA_SC_CLIPRECT_1_BR                                regPA_SC_CLIPRECT_1_BR;
typedef union PA_SC_CLIPRECT_1_TL                                regPA_SC_CLIPRECT_1_TL;
typedef union PA_SC_CLIPRECT_2_BR                                regPA_SC_CLIPRECT_2_BR;
typedef union PA_SC_CLIPRECT_2_TL                                regPA_SC_CLIPRECT_2_TL;
typedef union PA_SC_CLIPRECT_3_BR                                regPA_SC_CLIPRECT_3_BR;
typedef union PA_SC_CLIPRECT_3_TL                                regPA_SC_CLIPRECT_3_TL;
typedef union PA_SC_CLIPRECT_RULE                                regPA_SC_CLIPRECT_RULE;
typedef union PA_SC_CONSERVATIVE_RASTERIZATION_CNTL              regPA_SC_CONSERVATIVE_RASTERIZATION_CNTL;
typedef union PA_SC_DEBUG_DATA                                   regPA_SC_DEBUG_DATA;
typedef union PA_SC_DSM_CNTL                                     regPA_SC_DSM_CNTL;
typedef union PA_SC_EDGERULE                                     regPA_SC_EDGERULE;
typedef union PA_SC_ENHANCE                                      regPA_SC_ENHANCE;
typedef union PA_SC_ENHANCE_1                                    regPA_SC_ENHANCE_1;
typedef union PA_SC_ENHANCE_2                                    regPA_SC_ENHANCE_2;
typedef union PA_SC_ENHANCE_INTERNAL                             regPA_SC_ENHANCE_INTERNAL;
typedef union PA_SC_FIFO_DEPTH_CNTL                              regPA_SC_FIFO_DEPTH_CNTL;
typedef union PA_SC_FIFO_SIZE                                    regPA_SC_FIFO_SIZE;
typedef union PA_SC_FORCE_EOV_MAX_CNTS                           regPA_SC_FORCE_EOV_MAX_CNTS;
typedef union PA_SC_GENERIC_SCISSOR_BR                           regPA_SC_GENERIC_SCISSOR_BR;
typedef union PA_SC_GENERIC_SCISSOR_TL                           regPA_SC_GENERIC_SCISSOR_TL;
typedef union PA_SC_HP3D_TRAP_SCREEN_COUNT                       regPA_SC_HP3D_TRAP_SCREEN_COUNT;
typedef union PA_SC_HP3D_TRAP_SCREEN_H                           regPA_SC_HP3D_TRAP_SCREEN_H;
typedef union PA_SC_HP3D_TRAP_SCREEN_HV_EN                       regPA_SC_HP3D_TRAP_SCREEN_HV_EN;
typedef union PA_SC_HP3D_TRAP_SCREEN_HV_LOCK                     regPA_SC_HP3D_TRAP_SCREEN_HV_LOCK;
typedef union PA_SC_HP3D_TRAP_SCREEN_OCCURRENCE                  regPA_SC_HP3D_TRAP_SCREEN_OCCURRENCE;
typedef union PA_SC_HP3D_TRAP_SCREEN_V                           regPA_SC_HP3D_TRAP_SCREEN_V;
typedef union PA_SC_IF_FIFO_SIZE                                 regPA_SC_IF_FIFO_SIZE;
typedef union PA_SC_LINE_CNTL                                    regPA_SC_LINE_CNTL;
typedef union PA_SC_LINE_STIPPLE                                 regPA_SC_LINE_STIPPLE;
typedef union PA_SC_LINE_STIPPLE_STATE                           regPA_SC_LINE_STIPPLE_STATE;
typedef union PA_SC_MODE_CNTL_0                                  regPA_SC_MODE_CNTL_0;
typedef union PA_SC_MODE_CNTL_1                                  regPA_SC_MODE_CNTL_1;
typedef union PA_SC_NGG_MODE_CNTL                                regPA_SC_NGG_MODE_CNTL;
typedef union PA_SC_P3D_TRAP_SCREEN_COUNT                        regPA_SC_P3D_TRAP_SCREEN_COUNT;
typedef union PA_SC_P3D_TRAP_SCREEN_H                            regPA_SC_P3D_TRAP_SCREEN_H;
typedef union PA_SC_P3D_TRAP_SCREEN_HV_EN                        regPA_SC_P3D_TRAP_SCREEN_HV_EN;
typedef union PA_SC_P3D_TRAP_SCREEN_HV_LOCK                      regPA_SC_P3D_TRAP_SCREEN_HV_LOCK;
typedef union PA_SC_P3D_TRAP_SCREEN_OCCURRENCE                   regPA_SC_P3D_TRAP_SCREEN_OCCURRENCE;
typedef union PA_SC_P3D_TRAP_SCREEN_V                            regPA_SC_P3D_TRAP_SCREEN_V;
typedef union PA_SC_PBB_OVERRIDE_FLAG                            regPA_SC_PBB_OVERRIDE_FLAG;
typedef union PA_SC_PERFCOUNTER0_HI                              regPA_SC_PERFCOUNTER0_HI;
typedef union PA_SC_PERFCOUNTER0_LO                              regPA_SC_PERFCOUNTER0_LO;
typedef union PA_SC_PERFCOUNTER0_SELECT                          regPA_SC_PERFCOUNTER0_SELECT;
typedef union PA_SC_PERFCOUNTER0_SELECT1                         regPA_SC_PERFCOUNTER0_SELECT1;
typedef union PA_SC_PERFCOUNTER1_HI                              regPA_SC_PERFCOUNTER1_HI;
typedef union PA_SC_PERFCOUNTER1_LO                              regPA_SC_PERFCOUNTER1_LO;
typedef union PA_SC_PERFCOUNTER1_SELECT                          regPA_SC_PERFCOUNTER1_SELECT;
typedef union PA_SC_PERFCOUNTER2_HI                              regPA_SC_PERFCOUNTER2_HI;
typedef union PA_SC_PERFCOUNTER2_LO                              regPA_SC_PERFCOUNTER2_LO;
typedef union PA_SC_PERFCOUNTER2_SELECT                          regPA_SC_PERFCOUNTER2_SELECT;
typedef union PA_SC_PERFCOUNTER3_HI                              regPA_SC_PERFCOUNTER3_HI;
typedef union PA_SC_PERFCOUNTER3_LO                              regPA_SC_PERFCOUNTER3_LO;
typedef union PA_SC_PERFCOUNTER3_SELECT                          regPA_SC_PERFCOUNTER3_SELECT;
typedef union PA_SC_PERFCOUNTER4_HI                              regPA_SC_PERFCOUNTER4_HI;
typedef union PA_SC_PERFCOUNTER4_LO                              regPA_SC_PERFCOUNTER4_LO;
typedef union PA_SC_PERFCOUNTER4_SELECT                          regPA_SC_PERFCOUNTER4_SELECT;
typedef union PA_SC_PERFCOUNTER5_HI                              regPA_SC_PERFCOUNTER5_HI;
typedef union PA_SC_PERFCOUNTER5_LO                              regPA_SC_PERFCOUNTER5_LO;
typedef union PA_SC_PERFCOUNTER5_SELECT                          regPA_SC_PERFCOUNTER5_SELECT;
typedef union PA_SC_PERFCOUNTER6_HI                              regPA_SC_PERFCOUNTER6_HI;
typedef union PA_SC_PERFCOUNTER6_LO                              regPA_SC_PERFCOUNTER6_LO;
typedef union PA_SC_PERFCOUNTER6_SELECT                          regPA_SC_PERFCOUNTER6_SELECT;
typedef union PA_SC_PERFCOUNTER7_HI                              regPA_SC_PERFCOUNTER7_HI;
typedef union PA_SC_PERFCOUNTER7_LO                              regPA_SC_PERFCOUNTER7_LO;
typedef union PA_SC_PERFCOUNTER7_SELECT                          regPA_SC_PERFCOUNTER7_SELECT;
typedef union PA_SC_PKR_WAVE_TABLE_CNTL                          regPA_SC_PKR_WAVE_TABLE_CNTL;
typedef union PA_SC_RASTER_CONFIG                                regPA_SC_RASTER_CONFIG;
typedef union PA_SC_RASTER_CONFIG_1                              regPA_SC_RASTER_CONFIG_1;
typedef union PA_SC_SCREEN_SCISSOR_BR                            regPA_SC_SCREEN_SCISSOR_BR;
typedef union PA_SC_SCREEN_SCISSOR_TL                            regPA_SC_SCREEN_SCISSOR_TL;
typedef union PA_SC_SHADER_CONTROL                               regPA_SC_SHADER_CONTROL;
typedef union PA_SC_TILE_STEERING_CREST_OVERRIDE                 regPA_SC_TILE_STEERING_CREST_OVERRIDE;
typedef union PA_SC_TILE_STEERING_OVERRIDE                       regPA_SC_TILE_STEERING_OVERRIDE;
typedef union PA_SC_TRAP_SCREEN_COUNT                            regPA_SC_TRAP_SCREEN_COUNT;
typedef union PA_SC_TRAP_SCREEN_H                                regPA_SC_TRAP_SCREEN_H;
typedef union PA_SC_TRAP_SCREEN_HV_EN                            regPA_SC_TRAP_SCREEN_HV_EN;
typedef union PA_SC_TRAP_SCREEN_HV_LOCK                          regPA_SC_TRAP_SCREEN_HV_LOCK;
typedef union PA_SC_TRAP_SCREEN_OCCURRENCE                       regPA_SC_TRAP_SCREEN_OCCURRENCE;
typedef union PA_SC_TRAP_SCREEN_V                                regPA_SC_TRAP_SCREEN_V;
typedef union PA_SC_VPORT_SCISSOR_0_BR                           regPA_SC_VPORT_SCISSOR_0_BR;
typedef union PA_SC_VPORT_SCISSOR_0_TL                           regPA_SC_VPORT_SCISSOR_0_TL;
typedef union PA_SC_VPORT_SCISSOR_1_BR                           regPA_SC_VPORT_SCISSOR_1_BR;
typedef union PA_SC_VPORT_SCISSOR_1_TL                           regPA_SC_VPORT_SCISSOR_1_TL;
typedef union PA_SC_VPORT_SCISSOR_2_BR                           regPA_SC_VPORT_SCISSOR_2_BR;
typedef union PA_SC_VPORT_SCISSOR_2_TL                           regPA_SC_VPORT_SCISSOR_2_TL;
typedef union PA_SC_VPORT_SCISSOR_3_BR                           regPA_SC_VPORT_SCISSOR_3_BR;
typedef union PA_SC_VPORT_SCISSOR_3_TL                           regPA_SC_VPORT_SCISSOR_3_TL;
typedef union PA_SC_VPORT_SCISSOR_4_BR                           regPA_SC_VPORT_SCISSOR_4_BR;
typedef union PA_SC_VPORT_SCISSOR_4_TL                           regPA_SC_VPORT_SCISSOR_4_TL;
typedef union PA_SC_VPORT_SCISSOR_5_BR                           regPA_SC_VPORT_SCISSOR_5_BR;
typedef union PA_SC_VPORT_SCISSOR_5_TL                           regPA_SC_VPORT_SCISSOR_5_TL;
typedef union PA_SC_VPORT_SCISSOR_6_BR                           regPA_SC_VPORT_SCISSOR_6_BR;
typedef union PA_SC_VPORT_SCISSOR_6_TL                           regPA_SC_VPORT_SCISSOR_6_TL;
typedef union PA_SC_VPORT_SCISSOR_7_BR                           regPA_SC_VPORT_SCISSOR_7_BR;
typedef union PA_SC_VPORT_SCISSOR_7_TL                           regPA_SC_VPORT_SCISSOR_7_TL;
typedef union PA_SC_VPORT_SCISSOR_8_BR                           regPA_SC_VPORT_SCISSOR_8_BR;
typedef union PA_SC_VPORT_SCISSOR_8_TL                           regPA_SC_VPORT_SCISSOR_8_TL;
typedef union PA_SC_VPORT_SCISSOR_9_BR                           regPA_SC_VPORT_SCISSOR_9_BR;
typedef union PA_SC_VPORT_SCISSOR_9_TL                           regPA_SC_VPORT_SCISSOR_9_TL;
typedef union PA_SC_VPORT_SCISSOR_10_BR                          regPA_SC_VPORT_SCISSOR_10_BR;
typedef union PA_SC_VPORT_SCISSOR_10_TL                          regPA_SC_VPORT_SCISSOR_10_TL;
typedef union PA_SC_VPORT_SCISSOR_11_BR                          regPA_SC_VPORT_SCISSOR_11_BR;
typedef union PA_SC_VPORT_SCISSOR_11_TL                          regPA_SC_VPORT_SCISSOR_11_TL;
typedef union PA_SC_VPORT_SCISSOR_12_BR                          regPA_SC_VPORT_SCISSOR_12_BR;
typedef union PA_SC_VPORT_SCISSOR_12_TL                          regPA_SC_VPORT_SCISSOR_12_TL;
typedef union PA_SC_VPORT_SCISSOR_13_BR                          regPA_SC_VPORT_SCISSOR_13_BR;
typedef union PA_SC_VPORT_SCISSOR_13_TL                          regPA_SC_VPORT_SCISSOR_13_TL;
typedef union PA_SC_VPORT_SCISSOR_14_BR                          regPA_SC_VPORT_SCISSOR_14_BR;
typedef union PA_SC_VPORT_SCISSOR_14_TL                          regPA_SC_VPORT_SCISSOR_14_TL;
typedef union PA_SC_VPORT_SCISSOR_15_BR                          regPA_SC_VPORT_SCISSOR_15_BR;
typedef union PA_SC_VPORT_SCISSOR_15_TL                          regPA_SC_VPORT_SCISSOR_15_TL;
typedef union PA_SC_VPORT_ZMAX_0                                 regPA_SC_VPORT_ZMAX_0;
typedef union PA_SC_VPORT_ZMAX_1                                 regPA_SC_VPORT_ZMAX_1;
typedef union PA_SC_VPORT_ZMAX_2                                 regPA_SC_VPORT_ZMAX_2;
typedef union PA_SC_VPORT_ZMAX_3                                 regPA_SC_VPORT_ZMAX_3;
typedef union PA_SC_VPORT_ZMAX_4                                 regPA_SC_VPORT_ZMAX_4;
typedef union PA_SC_VPORT_ZMAX_5                                 regPA_SC_VPORT_ZMAX_5;
typedef union PA_SC_VPORT_ZMAX_6                                 regPA_SC_VPORT_ZMAX_6;
typedef union PA_SC_VPORT_ZMAX_7                                 regPA_SC_VPORT_ZMAX_7;
typedef union PA_SC_VPORT_ZMAX_8                                 regPA_SC_VPORT_ZMAX_8;
typedef union PA_SC_VPORT_ZMAX_9                                 regPA_SC_VPORT_ZMAX_9;
typedef union PA_SC_VPORT_ZMAX_10                                regPA_SC_VPORT_ZMAX_10;
typedef union PA_SC_VPORT_ZMAX_11                                regPA_SC_VPORT_ZMAX_11;
typedef union PA_SC_VPORT_ZMAX_12                                regPA_SC_VPORT_ZMAX_12;
typedef union PA_SC_VPORT_ZMAX_13                                regPA_SC_VPORT_ZMAX_13;
typedef union PA_SC_VPORT_ZMAX_14                                regPA_SC_VPORT_ZMAX_14;
typedef union PA_SC_VPORT_ZMAX_15                                regPA_SC_VPORT_ZMAX_15;
typedef union PA_SC_VPORT_ZMIN_0                                 regPA_SC_VPORT_ZMIN_0;
typedef union PA_SC_VPORT_ZMIN_1                                 regPA_SC_VPORT_ZMIN_1;
typedef union PA_SC_VPORT_ZMIN_2                                 regPA_SC_VPORT_ZMIN_2;
typedef union PA_SC_VPORT_ZMIN_3                                 regPA_SC_VPORT_ZMIN_3;
typedef union PA_SC_VPORT_ZMIN_4                                 regPA_SC_VPORT_ZMIN_4;
typedef union PA_SC_VPORT_ZMIN_5                                 regPA_SC_VPORT_ZMIN_5;
typedef union PA_SC_VPORT_ZMIN_6                                 regPA_SC_VPORT_ZMIN_6;
typedef union PA_SC_VPORT_ZMIN_7                                 regPA_SC_VPORT_ZMIN_7;
typedef union PA_SC_VPORT_ZMIN_8                                 regPA_SC_VPORT_ZMIN_8;
typedef union PA_SC_VPORT_ZMIN_9                                 regPA_SC_VPORT_ZMIN_9;
typedef union PA_SC_VPORT_ZMIN_10                                regPA_SC_VPORT_ZMIN_10;
typedef union PA_SC_VPORT_ZMIN_11                                regPA_SC_VPORT_ZMIN_11;
typedef union PA_SC_VPORT_ZMIN_12                                regPA_SC_VPORT_ZMIN_12;
typedef union PA_SC_VPORT_ZMIN_13                                regPA_SC_VPORT_ZMIN_13;
typedef union PA_SC_VPORT_ZMIN_14                                regPA_SC_VPORT_ZMIN_14;
typedef union PA_SC_VPORT_ZMIN_15                                regPA_SC_VPORT_ZMIN_15;
typedef union PA_SC_WINDOW_OFFSET                                regPA_SC_WINDOW_OFFSET;
typedef union PA_SC_WINDOW_SCISSOR_BR                            regPA_SC_WINDOW_SCISSOR_BR;
typedef union PA_SC_WINDOW_SCISSOR_TL                            regPA_SC_WINDOW_SCISSOR_TL;
typedef union PA_SIDEBAND_REQUEST_DELAYS                         regPA_SIDEBAND_REQUEST_DELAYS;
typedef union PA_STATE_STEREO_X                                  regPA_STATE_STEREO_X;
typedef union PA_STEREO_CNTL                                     regPA_STEREO_CNTL;
typedef union PA_SU_CNTL_STATUS                                  regPA_SU_CNTL_STATUS;
typedef union PA_SU_DEBUG_DATA                                   regPA_SU_DEBUG_DATA;
typedef union PA_SU_HARDWARE_SCREEN_OFFSET                       regPA_SU_HARDWARE_SCREEN_OFFSET;
typedef union PA_SU_LINE_CNTL                                    regPA_SU_LINE_CNTL;
typedef union PA_SU_LINE_STIPPLE_CNTL                            regPA_SU_LINE_STIPPLE_CNTL;
typedef union PA_SU_LINE_STIPPLE_SCALE                           regPA_SU_LINE_STIPPLE_SCALE;
typedef union PA_SU_LINE_STIPPLE_VALUE                           regPA_SU_LINE_STIPPLE_VALUE;
typedef union PA_SU_OVER_RASTERIZATION_CNTL                      regPA_SU_OVER_RASTERIZATION_CNTL;
typedef union PA_SU_PERFCOUNTER0_HI                              regPA_SU_PERFCOUNTER0_HI;
typedef union PA_SU_PERFCOUNTER0_LO                              regPA_SU_PERFCOUNTER0_LO;
typedef union PA_SU_PERFCOUNTER0_SELECT                          regPA_SU_PERFCOUNTER0_SELECT;
typedef union PA_SU_PERFCOUNTER0_SELECT1                         regPA_SU_PERFCOUNTER0_SELECT1;
typedef union PA_SU_PERFCOUNTER1_HI                              regPA_SU_PERFCOUNTER1_HI;
typedef union PA_SU_PERFCOUNTER1_LO                              regPA_SU_PERFCOUNTER1_LO;
typedef union PA_SU_PERFCOUNTER1_SELECT                          regPA_SU_PERFCOUNTER1_SELECT;
typedef union PA_SU_PERFCOUNTER1_SELECT1                         regPA_SU_PERFCOUNTER1_SELECT1;
typedef union PA_SU_PERFCOUNTER2_HI                              regPA_SU_PERFCOUNTER2_HI;
typedef union PA_SU_PERFCOUNTER2_LO                              regPA_SU_PERFCOUNTER2_LO;
typedef union PA_SU_PERFCOUNTER2_SELECT                          regPA_SU_PERFCOUNTER2_SELECT;
typedef union PA_SU_PERFCOUNTER2_SELECT1                         regPA_SU_PERFCOUNTER2_SELECT1;
typedef union PA_SU_PERFCOUNTER3_HI                              regPA_SU_PERFCOUNTER3_HI;
typedef union PA_SU_PERFCOUNTER3_LO                              regPA_SU_PERFCOUNTER3_LO;
typedef union PA_SU_PERFCOUNTER3_SELECT                          regPA_SU_PERFCOUNTER3_SELECT;
typedef union PA_SU_PERFCOUNTER3_SELECT1                         regPA_SU_PERFCOUNTER3_SELECT1;
typedef union PA_SU_POINT_MINMAX                                 regPA_SU_POINT_MINMAX;
typedef union PA_SU_POINT_SIZE                                   regPA_SU_POINT_SIZE;
typedef union PA_SU_POLY_OFFSET_BACK_OFFSET                      regPA_SU_POLY_OFFSET_BACK_OFFSET;
typedef union PA_SU_POLY_OFFSET_BACK_SCALE                       regPA_SU_POLY_OFFSET_BACK_SCALE;
typedef union PA_SU_POLY_OFFSET_CLAMP                            regPA_SU_POLY_OFFSET_CLAMP;
typedef union PA_SU_POLY_OFFSET_DB_FMT_CNTL                      regPA_SU_POLY_OFFSET_DB_FMT_CNTL;
typedef union PA_SU_POLY_OFFSET_FRONT_OFFSET                     regPA_SU_POLY_OFFSET_FRONT_OFFSET;
typedef union PA_SU_POLY_OFFSET_FRONT_SCALE                      regPA_SU_POLY_OFFSET_FRONT_SCALE;
typedef union PA_SU_PRIM_FILTER_CNTL                             regPA_SU_PRIM_FILTER_CNTL;
typedef union PA_SU_SC_MODE_CNTL                                 regPA_SU_SC_MODE_CNTL;
typedef union PA_SU_SMALL_PRIM_FILTER_CNTL                       regPA_SU_SMALL_PRIM_FILTER_CNTL;
typedef union PA_SU_VTX_CNTL                                     regPA_SU_VTX_CNTL;
typedef union PA_UTCL1_CNTL1                                     regPA_UTCL1_CNTL1;
typedef union PA_UTCL1_CNTL2                                     regPA_UTCL1_CNTL2;
typedef union PMM_GENERAL_CNTL                                   regPMM_GENERAL_CNTL;
typedef union port_a_addr                                        regport_a_addr;
typedef union port_a_data_hi                                     regport_a_data_hi;
typedef union port_a_data_lo                                     regport_a_data_lo;
typedef union port_b_addr                                        regport_b_addr;
typedef union port_b_data_hi                                     regport_b_data_hi;
typedef union port_b_data_lo                                     regport_b_data_lo;
typedef union port_c_addr                                        regport_c_addr;
typedef union port_c_data_hi                                     regport_c_data_hi;
typedef union port_c_data_lo                                     regport_c_data_lo;
typedef union port_d_addr                                        regport_d_addr;
typedef union port_d_data_hi                                     regport_d_data_hi;
typedef union port_d_data_lo                                     regport_d_data_lo;
typedef union PWROK_REFCLK_GAP_CYCLES                            regPWROK_REFCLK_GAP_CYCLES;
typedef union PWR_OVERRIDE                                       regPWR_OVERRIDE;
typedef union rbuf_DEBUG_DATA                                    regrbuf_DEBUG_DATA;
typedef union RLC_PERFCOUNTER0_HI                                regRLC_PERFCOUNTER0_HI;
typedef union RLC_PERFCOUNTER0_LO                                regRLC_PERFCOUNTER0_LO;
typedef union RLC_PERFCOUNTER0_SELECT                            regRLC_PERFCOUNTER0_SELECT;
typedef union RLC_PERFCOUNTER1_HI                                regRLC_PERFCOUNTER1_HI;
typedef union RLC_PERFCOUNTER1_LO                                regRLC_PERFCOUNTER1_LO;
typedef union RLC_PERFCOUNTER1_SELECT                            regRLC_PERFCOUNTER1_SELECT;
typedef union RLC_PERFMON_CLK_CNTL                               regRLC_PERFMON_CLK_CNTL;
typedef union RLC_PERFMON_CNTL                                   regRLC_PERFMON_CNTL;
typedef union RLC_SPM_ACCUM_CTRL                                 regRLC_SPM_ACCUM_CTRL;
typedef union RLC_SPM_ACCUM_CTRLRAM_ADDR                         regRLC_SPM_ACCUM_CTRLRAM_ADDR;
typedef union RLC_SPM_ACCUM_CTRLRAM_DATA                         regRLC_SPM_ACCUM_CTRLRAM_DATA;
typedef union RLC_SPM_ACCUM_DATARAM_ADDR                         regRLC_SPM_ACCUM_DATARAM_ADDR;
typedef union RLC_SPM_ACCUM_DATARAM_DATA                         regRLC_SPM_ACCUM_DATARAM_DATA;
typedef union RLC_SPM_ACCUM_DATARAM_WRCOUNT                      regRLC_SPM_ACCUM_DATARAM_WRCOUNT;
typedef union RLC_SPM_ACCUM_MODE                                 regRLC_SPM_ACCUM_MODE;
typedef union RLC_SPM_ACCUM_SAMPLES_REQUESTED                    regRLC_SPM_ACCUM_SAMPLES_REQUESTED;
typedef union RLC_SPM_ACCUM_STATUS                               regRLC_SPM_ACCUM_STATUS;
typedef union RLC_SPM_ACCUM_THRESHOLD                            regRLC_SPM_ACCUM_THRESHOLD;
typedef union RLC_SPM_CBR0_PERFMON_SAMPLE_DELAY                  regRLC_SPM_CBR0_PERFMON_SAMPLE_DELAY;
typedef union RLC_SPM_CBR1_PERFMON_SAMPLE_DELAY                  regRLC_SPM_CBR1_PERFMON_SAMPLE_DELAY;
typedef union RLC_SPM_CB_PERFMON_SAMPLE_DELAY                    regRLC_SPM_CB_PERFMON_SAMPLE_DELAY;
typedef union RLC_SPM_CPC_PERFMON_SAMPLE_DELAY                   regRLC_SPM_CPC_PERFMON_SAMPLE_DELAY;
typedef union RLC_SPM_CPF_PERFMON_SAMPLE_DELAY                   regRLC_SPM_CPF_PERFMON_SAMPLE_DELAY;
typedef union RLC_SPM_CPG_PERFMON_SAMPLE_DELAY                   regRLC_SPM_CPG_PERFMON_SAMPLE_DELAY;
typedef union RLC_SPM_DBR0_PERFMON_SAMPLE_DELAY                  regRLC_SPM_DBR0_PERFMON_SAMPLE_DELAY;
typedef union RLC_SPM_DBR1_PERFMON_SAMPLE_DELAY                  regRLC_SPM_DBR1_PERFMON_SAMPLE_DELAY;
typedef union RLC_SPM_DB_PERFMON_SAMPLE_DELAY                    regRLC_SPM_DB_PERFMON_SAMPLE_DELAY;
typedef union RLC_SPM_DEBUG                                      regRLC_SPM_DEBUG;
typedef union RLC_SPM_DEBUG_SELECT                               regRLC_SPM_DEBUG_SELECT;
typedef union RLC_SPM_DESER_START_SKEW                           regRLC_SPM_DESER_START_SKEW;
typedef union RLC_SPM_GDS_PERFMON_SAMPLE_DELAY                   regRLC_SPM_GDS_PERFMON_SAMPLE_DELAY;
typedef union RLC_SPM_GLB_SAMPLEDELAY_IND_ADDR                   regRLC_SPM_GLB_SAMPLEDELAY_IND_ADDR;
typedef union RLC_SPM_GLB_SAMPLEDELAY_IND_DATA                   regRLC_SPM_GLB_SAMPLEDELAY_IND_DATA;
typedef union RLC_SPM_GLOBALS_MUXSEL_SKEW                        regRLC_SPM_GLOBALS_MUXSEL_SKEW;
typedef union RLC_SPM_GLOBALS_SAMPLE_SKEW                        regRLC_SPM_GLOBALS_SAMPLE_SKEW;
typedef union RLC_SPM_GLOBAL_MUXSEL_ADDR                         regRLC_SPM_GLOBAL_MUXSEL_ADDR;
typedef union RLC_SPM_GLOBAL_MUXSEL_DATA                         regRLC_SPM_GLOBAL_MUXSEL_DATA;
typedef union RLC_SPM_IA_PERFMON_SAMPLE_DELAY                    regRLC_SPM_IA_PERFMON_SAMPLE_DELAY;
typedef union RLC_SPM_INT_CNTL                                   regRLC_SPM_INT_CNTL;
typedef union RLC_SPM_INT_INFO_1                                 regRLC_SPM_INT_INFO_1;
typedef union RLC_SPM_INT_INFO_2                                 regRLC_SPM_INT_INFO_2;
typedef union RLC_SPM_INT_STATUS                                 regRLC_SPM_INT_STATUS;
typedef union RLC_SPM_MC_CNTL                                    regRLC_SPM_MC_CNTL;
typedef union RLC_SPM_PA_PERFMON_SAMPLE_DELAY                    regRLC_SPM_PA_PERFMON_SAMPLE_DELAY;
typedef union RLC_SPM_PERFMON_CNTL                               regRLC_SPM_PERFMON_CNTL;
typedef union RLC_SPM_PERFMON_GLB_SEGMENT_SIZE                   regRLC_SPM_PERFMON_GLB_SEGMENT_SIZE;
typedef union RLC_SPM_PERFMON_RING_BASE_HI                       regRLC_SPM_PERFMON_RING_BASE_HI;
typedef union RLC_SPM_PERFMON_RING_BASE_LO                       regRLC_SPM_PERFMON_RING_BASE_LO;
typedef union RLC_SPM_PERFMON_RING_SIZE                          regRLC_SPM_PERFMON_RING_SIZE;
typedef union RLC_SPM_PERFMON_SAMPLE_DELAY_MAX                   regRLC_SPM_PERFMON_SAMPLE_DELAY_MAX;
typedef union RLC_SPM_PERFMON_SE3TO0_SEGMENT_SIZE                regRLC_SPM_PERFMON_SE3TO0_SEGMENT_SIZE;
typedef union RLC_SPM_PERFMON_SEGMENT_SIZE                       regRLC_SPM_PERFMON_SEGMENT_SIZE;
typedef union RLC_SPM_RING_RDPTR                                 regRLC_SPM_RING_RDPTR;
typedef union RLC_SPM_RING_WRPTR                                 regRLC_SPM_RING_WRPTR;
typedef union RLC_SPM_RMI_PERFMON_SAMPLE_DELAY                   regRLC_SPM_RMI_PERFMON_SAMPLE_DELAY;
typedef union RLC_SPM_SAMPLE_CNT                                 regRLC_SPM_SAMPLE_CNT;
typedef union RLC_SPM_SC_PERFMON_SAMPLE_DELAY                    regRLC_SPM_SC_PERFMON_SAMPLE_DELAY;
typedef union RLC_SPM_SEGMENT_THRESHOLD                          regRLC_SPM_SEGMENT_THRESHOLD;
typedef union RLC_SPM_SE_MUXSEL_ADDR                             regRLC_SPM_SE_MUXSEL_ADDR;
typedef union RLC_SPM_SE_MUXSEL_DATA                             regRLC_SPM_SE_MUXSEL_DATA;
typedef union RLC_SPM_SE_MUXSEL_SKEW                             regRLC_SPM_SE_MUXSEL_SKEW;
typedef union RLC_SPM_SE_SAMPLEDELAY_IND_ADDR                    regRLC_SPM_SE_SAMPLEDELAY_IND_ADDR;
typedef union RLC_SPM_SE_SAMPLEDELAY_IND_DATA                    regRLC_SPM_SE_SAMPLEDELAY_IND_DATA;
typedef union RLC_SPM_SE_SAMPLE_SKEW                             regRLC_SPM_SE_SAMPLE_SKEW;
typedef union RLC_SPM_SPI_PERFMON_SAMPLE_DELAY                   regRLC_SPM_SPI_PERFMON_SAMPLE_DELAY;
typedef union RLC_SPM_SQG_PERFMON_SAMPLE_DELAY                   regRLC_SPM_SQG_PERFMON_SAMPLE_DELAY;
typedef union RLC_SPM_SX_PERFMON_SAMPLE_DELAY                    regRLC_SPM_SX_PERFMON_SAMPLE_DELAY;
typedef union RLC_SPM_TA_PERFMON_SAMPLE_DELAY                    regRLC_SPM_TA_PERFMON_SAMPLE_DELAY;
typedef union RLC_SPM_TCA_PERFMON_SAMPLE_DELAY                   regRLC_SPM_TCA_PERFMON_SAMPLE_DELAY;
typedef union RLC_SPM_TCC_PERFMON_SAMPLE_DELAY                   regRLC_SPM_TCC_PERFMON_SAMPLE_DELAY;
typedef union RLC_SPM_TCP_PERFMON_SAMPLE_DELAY                   regRLC_SPM_TCP_PERFMON_SAMPLE_DELAY;
typedef union RLC_SPM_TD_PERFMON_SAMPLE_DELAY                    regRLC_SPM_TD_PERFMON_SAMPLE_DELAY;
typedef union RLC_SPM_THREAD_TRACE_CTRL                          regRLC_SPM_THREAD_TRACE_CTRL;
typedef union RLC_SPM_UTCL1_CNTL                                 regRLC_SPM_UTCL1_CNTL;
typedef union RLC_SPM_UTCL1_ERROR_1                              regRLC_SPM_UTCL1_ERROR_1;
typedef union RLC_SPM_UTCL1_ERROR_2                              regRLC_SPM_UTCL1_ERROR_2;
typedef union RLC_SPM_VGT_PERFMON_SAMPLE_DELAY                   regRLC_SPM_VGT_PERFMON_SAMPLE_DELAY;
typedef union RLC_SPM_VIRT_CTRL                                  regRLC_SPM_VIRT_CTRL;
typedef union RLC_SPM_VIRT_STATUS                                regRLC_SPM_VIRT_STATUS;
typedef union RMI_CGTT_SCLK_CTRL                                 regRMI_CGTT_SCLK_CTRL;
typedef union RMI_CLOCK_CNTRL                                    regRMI_CLOCK_CNTRL;
typedef union RMI_DEMUX_CNTL                                     regRMI_DEMUX_CNTL;
typedef union RMI_GENERAL_CNTL                                   regRMI_GENERAL_CNTL;
typedef union RMI_GENERAL_CNTL1                                  regRMI_GENERAL_CNTL1;
typedef union RMI_GENERAL_STATUS                                 regRMI_GENERAL_STATUS;
typedef union RMI_PERFCOUNTER0_HI                                regRMI_PERFCOUNTER0_HI;
typedef union RMI_PERFCOUNTER0_LO                                regRMI_PERFCOUNTER0_LO;
typedef union RMI_PERFCOUNTER0_SELECT                            regRMI_PERFCOUNTER0_SELECT;
typedef union RMI_PERFCOUNTER0_SELECT1                           regRMI_PERFCOUNTER0_SELECT1;
typedef union RMI_PERFCOUNTER1_HI                                regRMI_PERFCOUNTER1_HI;
typedef union RMI_PERFCOUNTER1_LO                                regRMI_PERFCOUNTER1_LO;
typedef union RMI_PERFCOUNTER1_SELECT                            regRMI_PERFCOUNTER1_SELECT;
typedef union RMI_PERFCOUNTER2_HI                                regRMI_PERFCOUNTER2_HI;
typedef union RMI_PERFCOUNTER2_LO                                regRMI_PERFCOUNTER2_LO;
typedef union RMI_PERFCOUNTER2_SELECT                            regRMI_PERFCOUNTER2_SELECT;
typedef union RMI_PERFCOUNTER2_SELECT1                           regRMI_PERFCOUNTER2_SELECT1;
typedef union RMI_PERFCOUNTER3_HI                                regRMI_PERFCOUNTER3_HI;
typedef union RMI_PERFCOUNTER3_LO                                regRMI_PERFCOUNTER3_LO;
typedef union RMI_PERFCOUNTER3_SELECT                            regRMI_PERFCOUNTER3_SELECT;
typedef union RMI_PERF_COUNTER_CNTL                              regRMI_PERF_COUNTER_CNTL;
typedef union RMI_PROBE_POP_LOGIC_CNTL                           regRMI_PROBE_POP_LOGIC_CNTL;
typedef union RMI_RB_GLX_CID_MAP                                 regRMI_RB_GLX_CID_MAP;
typedef union RMI_SCOREBOARD_CNTL                                regRMI_SCOREBOARD_CNTL;
typedef union RMI_SCOREBOARD_STATUS0                             regRMI_SCOREBOARD_STATUS0;
typedef union RMI_SCOREBOARD_STATUS1                             regRMI_SCOREBOARD_STATUS1;
typedef union RMI_SCOREBOARD_STATUS2                             regRMI_SCOREBOARD_STATUS2;
typedef union RMI_SPARE                                          regRMI_SPARE;
typedef union RMI_SPARE_1                                        regRMI_SPARE_1;
typedef union RMI_SPARE_2                                        regRMI_SPARE_2;
typedef union RMI_SUBBLOCK_STATUS0                               regRMI_SUBBLOCK_STATUS0;
typedef union RMI_SUBBLOCK_STATUS1                               regRMI_SUBBLOCK_STATUS1;
typedef union RMI_SUBBLOCK_STATUS2                               regRMI_SUBBLOCK_STATUS2;
typedef union RMI_SUBBLOCK_STATUS3                               regRMI_SUBBLOCK_STATUS3;
typedef union RMI_TCIW_FORMATTER0_CNTL                           regRMI_TCIW_FORMATTER0_CNTL;
typedef union RMI_TCIW_FORMATTER1_CNTL                           regRMI_TCIW_FORMATTER1_CNTL;
typedef union RMI_UTCL1_CNTL1                                    regRMI_UTCL1_CNTL1;
typedef union RMI_UTCL1_CNTL2                                    regRMI_UTCL1_CNTL2;
typedef union RMI_UTCL1_STATUS                                   regRMI_UTCL1_STATUS;
typedef union RMI_UTC_XNACK_N_MISC_CNTL                          regRMI_UTC_XNACK_N_MISC_CNTL;
typedef union RMI_XBAR_ARBITER_CONFIG                            regRMI_XBAR_ARBITER_CONFIG;
typedef union RMI_XBAR_ARBITER_CONFIG_1                          regRMI_XBAR_ARBITER_CONFIG_1;
typedef union RMI_XBAR_CONFIG                                    regRMI_XBAR_CONFIG;
typedef union RMI_XNACK_DEBUG                                    regRMI_XNACK_DEBUG;
typedef union RPB_ARB_CNTL                                       regRPB_ARB_CNTL;
typedef union RPB_ARB_CNTL2                                      regRPB_ARB_CNTL2;
typedef union RPB_ATS_CNTL                                       regRPB_ATS_CNTL;
typedef union RPB_ATS_CNTL2                                      regRPB_ATS_CNTL2;
typedef union RPB_BIF_CNTL                                       regRPB_BIF_CNTL;
typedef union RPB_BIF_CNTL2                                      regRPB_BIF_CNTL2;
typedef union RPB_BLOCKLEVEL_CONF                                regRPB_BLOCKLEVEL_CONF;
typedef union RPB_CID_QUEUE_EX                                   regRPB_CID_QUEUE_EX;
typedef union RPB_CID_QUEUE_EX_DATA                              regRPB_CID_QUEUE_EX_DATA;
typedef union RPB_CID_QUEUE_RD                                   regRPB_CID_QUEUE_RD;
typedef union RPB_CID_QUEUE_WR                                   regRPB_CID_QUEUE_WR;
typedef union RPB_DEINTRLV_COMBINE_CNTL                          regRPB_DEINTRLV_COMBINE_CNTL;
typedef union RPB_DF_SDPPORT_CNTL                                regRPB_DF_SDPPORT_CNTL;
typedef union RPB_EA_QUEUE_WR                                    regRPB_EA_QUEUE_WR;
typedef union RPB_EFF_CNTL                                       regRPB_EFF_CNTL;
typedef union RPB_PASSPW_CONF                                    regRPB_PASSPW_CONF;
typedef union RPB_PERFCOUNTER0_CFG                               regRPB_PERFCOUNTER0_CFG;
typedef union RPB_PERFCOUNTER1_CFG                               regRPB_PERFCOUNTER1_CFG;
typedef union RPB_PERFCOUNTER2_CFG                               regRPB_PERFCOUNTER2_CFG;
typedef union RPB_PERFCOUNTER3_CFG                               regRPB_PERFCOUNTER3_CFG;
typedef union RPB_PERFCOUNTER_HI                                 regRPB_PERFCOUNTER_HI;
typedef union RPB_PERFCOUNTER_LO                                 regRPB_PERFCOUNTER_LO;
typedef union RPB_PERFCOUNTER_RSLT_CNTL                          regRPB_PERFCOUNTER_RSLT_CNTL;
typedef union RPB_PERF_COUNTER_CNTL                              regRPB_PERF_COUNTER_CNTL;
typedef union RPB_RD_QUEUE_CNTL                                  regRPB_RD_QUEUE_CNTL;
typedef union RPB_RD_QUEUE_CNTL2                                 regRPB_RD_QUEUE_CNTL2;
typedef union RPB_RD_SWITCH_CNTL                                 regRPB_RD_SWITCH_CNTL;
typedef union RPB_SDPPORT_CNTL                                   regRPB_SDPPORT_CNTL;
typedef union RPB_SWITCH_CNTL2                                   regRPB_SWITCH_CNTL2;
typedef union RPB_TAG_CONF                                       regRPB_TAG_CONF;
typedef union RPB_VC_SWITCH_RDWR                                 regRPB_VC_SWITCH_RDWR;
typedef union RPB_WR_QUEUE_CNTL                                  regRPB_WR_QUEUE_CNTL;
typedef union RPB_WR_QUEUE_CNTL2                                 regRPB_WR_QUEUE_CNTL2;
typedef union RPB_WR_SWITCH_CNTL                                 regRPB_WR_SWITCH_CNTL;
typedef union SCRATCH_ADDR                                       regSCRATCH_ADDR;
typedef union SCRATCH_REG0                                       regSCRATCH_REG0;
typedef union SCRATCH_REG1                                       regSCRATCH_REG1;
typedef union SCRATCH_REG2                                       regSCRATCH_REG2;
typedef union SCRATCH_REG3                                       regSCRATCH_REG3;
typedef union SCRATCH_REG4                                       regSCRATCH_REG4;
typedef union SCRATCH_REG5                                       regSCRATCH_REG5;
typedef union SCRATCH_REG6                                       regSCRATCH_REG6;
typedef union SCRATCH_REG7                                       regSCRATCH_REG7;
typedef union SCRATCH_REGISTER0                                  regSCRATCH_REGISTER0;
typedef union SCRATCH_REGISTER1                                  regSCRATCH_REGISTER1;
typedef union SCRATCH_REGISTER2                                  regSCRATCH_REGISTER2;
typedef union SCRATCH_REGISTER3                                  regSCRATCH_REGISTER3;
typedef union SCRATCH_REGISTER4                                  regSCRATCH_REGISTER4;
typedef union SCRATCH_REGISTER5                                  regSCRATCH_REGISTER5;
typedef union SCRATCH_REGISTER6                                  regSCRATCH_REGISTER6;
typedef union SCRATCH_REGISTER7                                  regSCRATCH_REGISTER7;
typedef union SCRATCH_UMSK                                       regSCRATCH_UMSK;
typedef union SDMA0_PERFCOUNTER0_HI                              regSDMA0_PERFCOUNTER0_HI;
typedef union SDMA0_PERFCOUNTER0_LO                              regSDMA0_PERFCOUNTER0_LO;
typedef union SDMA0_PERFCOUNTER0_RESULT                          regSDMA0_PERFCOUNTER0_RESULT;
typedef union SDMA0_PERFCOUNTER0_SELECT                          regSDMA0_PERFCOUNTER0_SELECT;
typedef union SDMA0_PERFCOUNTER0_SELECT1                         regSDMA0_PERFCOUNTER0_SELECT1;
typedef union SDMA0_PERFCOUNTER1_HI                              regSDMA0_PERFCOUNTER1_HI;
typedef union SDMA0_PERFCOUNTER1_LO                              regSDMA0_PERFCOUNTER1_LO;
typedef union SDMA0_PERFCOUNTER1_RESULT                          regSDMA0_PERFCOUNTER1_RESULT;
typedef union SDMA0_PERFCOUNTER1_SELECT                          regSDMA0_PERFCOUNTER1_SELECT;
typedef union SDMA0_PERFCOUNTER1_SELECT1                         regSDMA0_PERFCOUNTER1_SELECT1;
typedef union SDMA0_PERFCOUNTER_TAG_DELAY_RANGE                  regSDMA0_PERFCOUNTER_TAG_DELAY_RANGE;
typedef union SDMA0_PERFMON_CNTL                                 regSDMA0_PERFMON_CNTL;
typedef union SDMA1_PERFCOUNTER0_HI                              regSDMA1_PERFCOUNTER0_HI;
typedef union SDMA1_PERFCOUNTER0_LO                              regSDMA1_PERFCOUNTER0_LO;
typedef union SDMA1_PERFCOUNTER0_RESULT                          regSDMA1_PERFCOUNTER0_RESULT;
typedef union SDMA1_PERFCOUNTER0_SELECT                          regSDMA1_PERFCOUNTER0_SELECT;
typedef union SDMA1_PERFCOUNTER0_SELECT1                         regSDMA1_PERFCOUNTER0_SELECT1;
typedef union SDMA1_PERFCOUNTER1_HI                              regSDMA1_PERFCOUNTER1_HI;
typedef union SDMA1_PERFCOUNTER1_LO                              regSDMA1_PERFCOUNTER1_LO;
typedef union SDMA1_PERFCOUNTER1_RESULT                          regSDMA1_PERFCOUNTER1_RESULT;
typedef union SDMA1_PERFCOUNTER1_SELECT                          regSDMA1_PERFCOUNTER1_SELECT;
typedef union SDMA1_PERFCOUNTER1_SELECT1                         regSDMA1_PERFCOUNTER1_SELECT1;
typedef union SDMA1_PERFCOUNTER_TAG_DELAY_RANGE                  regSDMA1_PERFCOUNTER_TAG_DELAY_RANGE;
typedef union SDMA1_PERFMON_CNTL                                 regSDMA1_PERFMON_CNTL;
typedef union SDMA_PGFSM_CONFIG                                  regSDMA_PGFSM_CONFIG;
typedef union SDMA_PGFSM_READ                                    regSDMA_PGFSM_READ;
typedef union SDMA_PGFSM_WRITE                                   regSDMA_PGFSM_WRITE;
typedef union SDMA_POWER_GATING                                  regSDMA_POWER_GATING;
typedef union SH_MEM_BASES                                       regSH_MEM_BASES;
typedef union SH_MEM_CONFIG                                      regSH_MEM_CONFIG;
typedef union SOCCLK_CGTT_BLK_CTRL_REG                           regSOCCLK_CGTT_BLK_CTRL_REG;
typedef union SOC_GAP_PWROK                                      regSOC_GAP_PWROK;
typedef union SPIS_DEBUG_READ                                    regSPIS_DEBUG_READ;
typedef union SPI_ARB_CNTL_0                                     regSPI_ARB_CNTL_0;
typedef union SPI_ARB_CYCLES_0                                   regSPI_ARB_CYCLES_0;
typedef union SPI_ARB_CYCLES_1                                   regSPI_ARB_CYCLES_1;
typedef union SPI_ARB_PRIORITY                                   regSPI_ARB_PRIORITY;
typedef union SPI_BARYC_CNTL                                     regSPI_BARYC_CNTL;
typedef union spi_clk_gate0                                      regspi_clk_gate0;
typedef union spi_clk_gate1                                      regspi_clk_gate1;
typedef union spi_clk_gate2                                      regspi_clk_gate2;
typedef union spi_clk_gate3                                      regspi_clk_gate3;
typedef union SPI_COMPUTE_QUEUE_RESET                            regSPI_COMPUTE_QUEUE_RESET;
typedef union SPI_COMPUTE_WF_CTX_SAVE                            regSPI_COMPUTE_WF_CTX_SAVE;
typedef union SPI_CONFIG_CNTL                                    regSPI_CONFIG_CNTL;
typedef union SPI_CONFIG_CNTL_1                                  regSPI_CONFIG_CNTL_1;
typedef union SPI_CONFIG_CNTL_1_REMAP                            regSPI_CONFIG_CNTL_1_REMAP;
typedef union SPI_CONFIG_CNTL_2                                  regSPI_CONFIG_CNTL_2;
typedef union SPI_CONFIG_CNTL_2_REMAP                            regSPI_CONFIG_CNTL_2_REMAP;
typedef union SPI_CONFIG_CNTL_REMAP                              regSPI_CONFIG_CNTL_REMAP;
typedef union SPI_CONFIG_PS_CU_EN                                regSPI_CONFIG_PS_CU_EN;
typedef union SPI_CSQ_WF_ACTIVE_COUNT_0                          regSPI_CSQ_WF_ACTIVE_COUNT_0;
typedef union SPI_CSQ_WF_ACTIVE_COUNT_1                          regSPI_CSQ_WF_ACTIVE_COUNT_1;
typedef union SPI_CSQ_WF_ACTIVE_COUNT_2                          regSPI_CSQ_WF_ACTIVE_COUNT_2;
typedef union SPI_CSQ_WF_ACTIVE_COUNT_3                          regSPI_CSQ_WF_ACTIVE_COUNT_3;
typedef union SPI_CSQ_WF_ACTIVE_COUNT_4                          regSPI_CSQ_WF_ACTIVE_COUNT_4;
typedef union SPI_CSQ_WF_ACTIVE_COUNT_5                          regSPI_CSQ_WF_ACTIVE_COUNT_5;
typedef union SPI_CSQ_WF_ACTIVE_COUNT_6                          regSPI_CSQ_WF_ACTIVE_COUNT_6;
typedef union SPI_CSQ_WF_ACTIVE_COUNT_7                          regSPI_CSQ_WF_ACTIVE_COUNT_7;
typedef union SPI_CSQ_WF_ACTIVE_STATUS                           regSPI_CSQ_WF_ACTIVE_STATUS;
typedef union spi_cs_ctl0                                        regspi_cs_ctl0;
typedef union spi_cs_ctl1                                        regspi_cs_ctl1;
typedef union spi_cs_ctl2                                        regspi_cs_ctl2;
typedef union spi_cs_ctl_gfx0                                    regspi_cs_ctl_gfx0;
typedef union spi_cs_ctl_gfx1                                    regspi_cs_ctl_gfx1;
typedef union spi_cs_ctl_gfx2                                    regspi_cs_ctl_gfx2;
typedef union spi_cs_wave_ctl                                    regspi_cs_wave_ctl;
typedef union spi_cs_wave_gfx_ctl                                regspi_cs_wave_gfx_ctl;
typedef union SPI_DEBUG_CNTL_2                                   regSPI_DEBUG_CNTL_2;
typedef union SPI_DEBUG_READ                                     regSPI_DEBUG_READ;
typedef union SPI_DSM_CNTL                                       regSPI_DSM_CNTL;
typedef union SPI_DSM_CNTL2                                      regSPI_DSM_CNTL2;
typedef union SPI_EDC_CNT                                        regSPI_EDC_CNT;
typedef union spi_es_wave_ctl0                                   regspi_es_wave_ctl0;
typedef union spi_es_wave_ctl1                                   regspi_es_wave_ctl1;
typedef union spi_es_wave_ctl2                                   regspi_es_wave_ctl2;
typedef union SPI_FEATURE_CTRL                                   regSPI_FEATURE_CTRL;
typedef union SPI_GFX_CNTL                                       regSPI_GFX_CNTL;
typedef union spi_gfx_tmp_ring_mgr                               regspi_gfx_tmp_ring_mgr;
typedef union spi_gs_wave_ctl0                                   regspi_gs_wave_ctl0;
typedef union spi_gs_wave_ctl1                                   regspi_gs_wave_ctl1;
typedef union spi_gs_wave_ctl2                                   regspi_gs_wave_ctl2;
typedef union spi_hs_wave_ctl0                                   regspi_hs_wave_ctl0;
typedef union spi_hs_wave_ctl1                                   regspi_hs_wave_ctl1;
typedef union spi_hs_wave_ctl2                                   regspi_hs_wave_ctl2;
typedef union SPI_INTERP_CONTROL_0                               regSPI_INTERP_CONTROL_0;
typedef union SPI_LB_CTR_CTRL                                    regSPI_LB_CTR_CTRL;
typedef union SPI_LB_CU_MASK                                     regSPI_LB_CU_MASK;
typedef union SPI_LB_DATA_PERCU_WAVE_CS                          regSPI_LB_DATA_PERCU_WAVE_CS;
typedef union SPI_LB_DATA_PERCU_WAVE_HSGS                        regSPI_LB_DATA_PERCU_WAVE_HSGS;
typedef union SPI_LB_DATA_PERCU_WAVE_VSPS                        regSPI_LB_DATA_PERCU_WAVE_VSPS;
typedef union SPI_LB_DATA_PERWGP_WAVE_CS                         regSPI_LB_DATA_PERWGP_WAVE_CS;
typedef union SPI_LB_DATA_PERWGP_WAVE_HSGS                       regSPI_LB_DATA_PERWGP_WAVE_HSGS;
typedef union SPI_LB_DATA_PERWGP_WAVE_VSPS                       regSPI_LB_DATA_PERWGP_WAVE_VSPS;
typedef union SPI_LB_DATA_REG                                    regSPI_LB_DATA_REG;
typedef union SPI_LB_DATA_WAVES                                  regSPI_LB_DATA_WAVES;
typedef union SPI_LB_WGP_MASK                                    regSPI_LB_WGP_MASK;
typedef union spi_lds_wr_ctl0                                    regspi_lds_wr_ctl0;
typedef union spi_lds_wr_ctl1                                    regspi_lds_wr_ctl1;
typedef union spi_ls_wave_ctl0                                   regspi_ls_wave_ctl0;
typedef union spi_ls_wave_ctl1                                   regspi_ls_wave_ctl1;
typedef union spi_ls_wave_ctl2                                   regspi_ls_wave_ctl2;
typedef union spi_offchip_lds_mgr0                               regspi_offchip_lds_mgr0;
typedef union spi_offchip_lds_mgr1                               regspi_offchip_lds_mgr1;
typedef union SPI_P0_TRAP_SCREEN_GPR_MIN                         regSPI_P0_TRAP_SCREEN_GPR_MIN;
typedef union SPI_P0_TRAP_SCREEN_PSBA_HI                         regSPI_P0_TRAP_SCREEN_PSBA_HI;
typedef union SPI_P0_TRAP_SCREEN_PSBA_LO                         regSPI_P0_TRAP_SCREEN_PSBA_LO;
typedef union SPI_P0_TRAP_SCREEN_PSMA_HI                         regSPI_P0_TRAP_SCREEN_PSMA_HI;
typedef union SPI_P0_TRAP_SCREEN_PSMA_LO                         regSPI_P0_TRAP_SCREEN_PSMA_LO;
typedef union SPI_P1_TRAP_SCREEN_GPR_MIN                         regSPI_P1_TRAP_SCREEN_GPR_MIN;
typedef union SPI_P1_TRAP_SCREEN_PSBA_HI                         regSPI_P1_TRAP_SCREEN_PSBA_HI;
typedef union SPI_P1_TRAP_SCREEN_PSBA_LO                         regSPI_P1_TRAP_SCREEN_PSBA_LO;
typedef union SPI_P1_TRAP_SCREEN_PSMA_HI                         regSPI_P1_TRAP_SCREEN_PSMA_HI;
typedef union SPI_P1_TRAP_SCREEN_PSMA_LO                         regSPI_P1_TRAP_SCREEN_PSMA_LO;
typedef union spi_pc_dealloc_ctl0                                regspi_pc_dealloc_ctl0;
typedef union spi_pc_dealloc_ctl1                                regspi_pc_dealloc_ctl1;
typedef union spi_pc_dealloc_ctl2                                regspi_pc_dealloc_ctl2;
typedef union spi_pc_dealloc_ctl3                                regspi_pc_dealloc_ctl3;
typedef union spi_pc_dealloc_ctl4                                regspi_pc_dealloc_ctl4;
typedef union spi_pc_dealloc_ctl5                                regspi_pc_dealloc_ctl5;
typedef union SPI_PERFCOUNTER0_HI                                regSPI_PERFCOUNTER0_HI;
typedef union SPI_PERFCOUNTER0_LO                                regSPI_PERFCOUNTER0_LO;
typedef union SPI_PERFCOUNTER0_SELECT                            regSPI_PERFCOUNTER0_SELECT;
typedef union SPI_PERFCOUNTER0_SELECT1                           regSPI_PERFCOUNTER0_SELECT1;
typedef union SPI_PERFCOUNTER1_HI                                regSPI_PERFCOUNTER1_HI;
typedef union SPI_PERFCOUNTER1_LO                                regSPI_PERFCOUNTER1_LO;
typedef union SPI_PERFCOUNTER1_SELECT                            regSPI_PERFCOUNTER1_SELECT;
typedef union SPI_PERFCOUNTER1_SELECT1                           regSPI_PERFCOUNTER1_SELECT1;
typedef union SPI_PERFCOUNTER2_HI                                regSPI_PERFCOUNTER2_HI;
typedef union SPI_PERFCOUNTER2_LO                                regSPI_PERFCOUNTER2_LO;
typedef union SPI_PERFCOUNTER2_SELECT                            regSPI_PERFCOUNTER2_SELECT;
typedef union SPI_PERFCOUNTER2_SELECT1                           regSPI_PERFCOUNTER2_SELECT1;
typedef union SPI_PERFCOUNTER3_HI                                regSPI_PERFCOUNTER3_HI;
typedef union SPI_PERFCOUNTER3_LO                                regSPI_PERFCOUNTER3_LO;
typedef union SPI_PERFCOUNTER3_SELECT                            regSPI_PERFCOUNTER3_SELECT;
typedef union SPI_PERFCOUNTER3_SELECT1                           regSPI_PERFCOUNTER3_SELECT1;
typedef union SPI_PERFCOUNTER4_HI                                regSPI_PERFCOUNTER4_HI;
typedef union SPI_PERFCOUNTER4_LO                                regSPI_PERFCOUNTER4_LO;
typedef union SPI_PERFCOUNTER4_SELECT                            regSPI_PERFCOUNTER4_SELECT;
typedef union SPI_PERFCOUNTER5_HI                                regSPI_PERFCOUNTER5_HI;
typedef union SPI_PERFCOUNTER5_LO                                regSPI_PERFCOUNTER5_LO;
typedef union SPI_PERFCOUNTER5_SELECT                            regSPI_PERFCOUNTER5_SELECT;
typedef union SPI_PERFCOUNTER_BINS                               regSPI_PERFCOUNTER_BINS;
typedef union SPI_PG_ENABLE_STATIC_CU_MASK                       regSPI_PG_ENABLE_STATIC_CU_MASK;
typedef union SPI_PG_ENABLE_STATIC_WGP_MASK                      regSPI_PG_ENABLE_STATIC_WGP_MASK;
typedef union SPI_PQEV_CTRL                                      regSPI_PQEV_CTRL;
typedef union spi_ps_ctl0_0                                      regspi_ps_ctl0_0;
typedef union spi_ps_ctl0_1                                      regspi_ps_ctl0_1;
typedef union spi_ps_ctl0_2                                      regspi_ps_ctl0_2;
typedef union spi_ps_ctl0_3                                      regspi_ps_ctl0_3;
typedef union spi_ps_ctl0_4                                      regspi_ps_ctl0_4;
typedef union spi_ps_ctl1_0                                      regspi_ps_ctl1_0;
typedef union spi_ps_ctl1_1                                      regspi_ps_ctl1_1;
typedef union spi_ps_ctl1_2                                      regspi_ps_ctl1_2;
typedef union spi_ps_ctl1_3                                      regspi_ps_ctl1_3;
typedef union spi_ps_ctl1_4                                      regspi_ps_ctl1_4;
typedef union spi_ps_ctl1_5                                      regspi_ps_ctl1_5;
typedef union spi_ps_ctl1_6                                      regspi_ps_ctl1_6;
typedef union SPI_PS_INPUT_ADDR                                  regSPI_PS_INPUT_ADDR;
typedef union SPI_PS_INPUT_CNTL_0                                regSPI_PS_INPUT_CNTL_0;
typedef union SPI_PS_INPUT_CNTL_1                                regSPI_PS_INPUT_CNTL_1;
typedef union SPI_PS_INPUT_CNTL_2                                regSPI_PS_INPUT_CNTL_2;
typedef union SPI_PS_INPUT_CNTL_3                                regSPI_PS_INPUT_CNTL_3;
typedef union SPI_PS_INPUT_CNTL_4                                regSPI_PS_INPUT_CNTL_4;
typedef union SPI_PS_INPUT_CNTL_5                                regSPI_PS_INPUT_CNTL_5;
typedef union SPI_PS_INPUT_CNTL_6                                regSPI_PS_INPUT_CNTL_6;
typedef union SPI_PS_INPUT_CNTL_7                                regSPI_PS_INPUT_CNTL_7;
typedef union SPI_PS_INPUT_CNTL_8                                regSPI_PS_INPUT_CNTL_8;
typedef union SPI_PS_INPUT_CNTL_9                                regSPI_PS_INPUT_CNTL_9;
typedef union SPI_PS_INPUT_CNTL_10                               regSPI_PS_INPUT_CNTL_10;
typedef union SPI_PS_INPUT_CNTL_11                               regSPI_PS_INPUT_CNTL_11;
typedef union SPI_PS_INPUT_CNTL_12                               regSPI_PS_INPUT_CNTL_12;
typedef union SPI_PS_INPUT_CNTL_13                               regSPI_PS_INPUT_CNTL_13;
typedef union SPI_PS_INPUT_CNTL_14                               regSPI_PS_INPUT_CNTL_14;
typedef union SPI_PS_INPUT_CNTL_15                               regSPI_PS_INPUT_CNTL_15;
typedef union SPI_PS_INPUT_CNTL_16                               regSPI_PS_INPUT_CNTL_16;
typedef union SPI_PS_INPUT_CNTL_17                               regSPI_PS_INPUT_CNTL_17;
typedef union SPI_PS_INPUT_CNTL_18                               regSPI_PS_INPUT_CNTL_18;
typedef union SPI_PS_INPUT_CNTL_19                               regSPI_PS_INPUT_CNTL_19;
typedef union SPI_PS_INPUT_CNTL_20                               regSPI_PS_INPUT_CNTL_20;
typedef union SPI_PS_INPUT_CNTL_21                               regSPI_PS_INPUT_CNTL_21;
typedef union SPI_PS_INPUT_CNTL_22                               regSPI_PS_INPUT_CNTL_22;
typedef union SPI_PS_INPUT_CNTL_23                               regSPI_PS_INPUT_CNTL_23;
typedef union SPI_PS_INPUT_CNTL_24                               regSPI_PS_INPUT_CNTL_24;
typedef union SPI_PS_INPUT_CNTL_25                               regSPI_PS_INPUT_CNTL_25;
typedef union SPI_PS_INPUT_CNTL_26                               regSPI_PS_INPUT_CNTL_26;
typedef union SPI_PS_INPUT_CNTL_27                               regSPI_PS_INPUT_CNTL_27;
typedef union SPI_PS_INPUT_CNTL_28                               regSPI_PS_INPUT_CNTL_28;
typedef union SPI_PS_INPUT_CNTL_29                               regSPI_PS_INPUT_CNTL_29;
typedef union SPI_PS_INPUT_CNTL_30                               regSPI_PS_INPUT_CNTL_30;
typedef union SPI_PS_INPUT_CNTL_31                               regSPI_PS_INPUT_CNTL_31;
typedef union SPI_PS_INPUT_ENA                                   regSPI_PS_INPUT_ENA;
typedef union SPI_PS_IN_CONTROL                                  regSPI_PS_IN_CONTROL;
typedef union SPI_PS_MAX_WAVE_ID                                 regSPI_PS_MAX_WAVE_ID;
typedef union SPI_RESET_DEBUG                                    regSPI_RESET_DEBUG;
typedef union spi_resource_alloc0                                regspi_resource_alloc0;
typedef union spi_resource_alloc1                                regspi_resource_alloc1;
typedef union spi_resource_alloc2                                regspi_resource_alloc2;
typedef union spi_resource_alloc3                                regspi_resource_alloc3;
typedef union spi_resource_alloc4                                regspi_resource_alloc4;
typedef union spi_resource_alloc5                                regspi_resource_alloc5;
typedef union spi_resource_alloc6                                regspi_resource_alloc6;
typedef union spi_resource_alloc7                                regspi_resource_alloc7;
typedef union spi_resource_alloc8                                regspi_resource_alloc8;
typedef union spi_resource_alloc9                                regspi_resource_alloc9;
typedef union spi_resource_alloc10                               regspi_resource_alloc10;
typedef union SPI_RESOURCE_RESERVE_CU_0                          regSPI_RESOURCE_RESERVE_CU_0;
typedef union SPI_RESOURCE_RESERVE_CU_1                          regSPI_RESOURCE_RESERVE_CU_1;
typedef union SPI_RESOURCE_RESERVE_CU_2                          regSPI_RESOURCE_RESERVE_CU_2;
typedef union SPI_RESOURCE_RESERVE_CU_3                          regSPI_RESOURCE_RESERVE_CU_3;
typedef union SPI_RESOURCE_RESERVE_CU_4                          regSPI_RESOURCE_RESERVE_CU_4;
typedef union SPI_RESOURCE_RESERVE_CU_5                          regSPI_RESOURCE_RESERVE_CU_5;
typedef union SPI_RESOURCE_RESERVE_CU_6                          regSPI_RESOURCE_RESERVE_CU_6;
typedef union SPI_RESOURCE_RESERVE_CU_7                          regSPI_RESOURCE_RESERVE_CU_7;
typedef union SPI_RESOURCE_RESERVE_CU_8                          regSPI_RESOURCE_RESERVE_CU_8;
typedef union SPI_RESOURCE_RESERVE_CU_9                          regSPI_RESOURCE_RESERVE_CU_9;
typedef union SPI_RESOURCE_RESERVE_CU_10                         regSPI_RESOURCE_RESERVE_CU_10;
typedef union SPI_RESOURCE_RESERVE_CU_11                         regSPI_RESOURCE_RESERVE_CU_11;
typedef union SPI_RESOURCE_RESERVE_CU_12                         regSPI_RESOURCE_RESERVE_CU_12;
typedef union SPI_RESOURCE_RESERVE_CU_13                         regSPI_RESOURCE_RESERVE_CU_13;
typedef union SPI_RESOURCE_RESERVE_CU_14                         regSPI_RESOURCE_RESERVE_CU_14;
typedef union SPI_RESOURCE_RESERVE_CU_15                         regSPI_RESOURCE_RESERVE_CU_15;
typedef union SPI_RESOURCE_RESERVE_EN_CU_0                       regSPI_RESOURCE_RESERVE_EN_CU_0;
typedef union SPI_RESOURCE_RESERVE_EN_CU_1                       regSPI_RESOURCE_RESERVE_EN_CU_1;
typedef union SPI_RESOURCE_RESERVE_EN_CU_2                       regSPI_RESOURCE_RESERVE_EN_CU_2;
typedef union SPI_RESOURCE_RESERVE_EN_CU_3                       regSPI_RESOURCE_RESERVE_EN_CU_3;
typedef union SPI_RESOURCE_RESERVE_EN_CU_4                       regSPI_RESOURCE_RESERVE_EN_CU_4;
typedef union SPI_RESOURCE_RESERVE_EN_CU_5                       regSPI_RESOURCE_RESERVE_EN_CU_5;
typedef union SPI_RESOURCE_RESERVE_EN_CU_6                       regSPI_RESOURCE_RESERVE_EN_CU_6;
typedef union SPI_RESOURCE_RESERVE_EN_CU_7                       regSPI_RESOURCE_RESERVE_EN_CU_7;
typedef union SPI_RESOURCE_RESERVE_EN_CU_8                       regSPI_RESOURCE_RESERVE_EN_CU_8;
typedef union SPI_RESOURCE_RESERVE_EN_CU_9                       regSPI_RESOURCE_RESERVE_EN_CU_9;
typedef union SPI_RESOURCE_RESERVE_EN_CU_10                      regSPI_RESOURCE_RESERVE_EN_CU_10;
typedef union SPI_RESOURCE_RESERVE_EN_CU_11                      regSPI_RESOURCE_RESERVE_EN_CU_11;
typedef union SPI_RESOURCE_RESERVE_EN_CU_12                      regSPI_RESOURCE_RESERVE_EN_CU_12;
typedef union SPI_RESOURCE_RESERVE_EN_CU_13                      regSPI_RESOURCE_RESERVE_EN_CU_13;
typedef union SPI_RESOURCE_RESERVE_EN_CU_14                      regSPI_RESOURCE_RESERVE_EN_CU_14;
typedef union SPI_RESOURCE_RESERVE_EN_CU_15                      regSPI_RESOURCE_RESERVE_EN_CU_15;
typedef union SPI_SHADER_COL_FORMAT                              regSPI_SHADER_COL_FORMAT;
typedef union SPI_SHADER_IDX_FORMAT                              regSPI_SHADER_IDX_FORMAT;
typedef union SPI_SHADER_LATE_ALLOC_VS                           regSPI_SHADER_LATE_ALLOC_VS;
typedef union SPI_SHADER_PGM_CHKSUM_GS                           regSPI_SHADER_PGM_CHKSUM_GS;
typedef union SPI_SHADER_PGM_CHKSUM_HS                           regSPI_SHADER_PGM_CHKSUM_HS;
typedef union SPI_SHADER_PGM_CHKSUM_PS                           regSPI_SHADER_PGM_CHKSUM_PS;
typedef union SPI_SHADER_PGM_CHKSUM_VS                           regSPI_SHADER_PGM_CHKSUM_VS;
typedef union SPI_SHADER_PGM_HI_ES                               regSPI_SHADER_PGM_HI_ES;
typedef union SPI_SHADER_PGM_HI_ES_GS                            regSPI_SHADER_PGM_HI_ES_GS;
typedef union SPI_SHADER_PGM_HI_GS                               regSPI_SHADER_PGM_HI_GS;
typedef union SPI_SHADER_PGM_HI_HS                               regSPI_SHADER_PGM_HI_HS;
typedef union SPI_SHADER_PGM_HI_LS                               regSPI_SHADER_PGM_HI_LS;
typedef union SPI_SHADER_PGM_HI_LS_HS                            regSPI_SHADER_PGM_HI_LS_HS;
typedef union SPI_SHADER_PGM_HI_PS                               regSPI_SHADER_PGM_HI_PS;
typedef union SPI_SHADER_PGM_HI_VS                               regSPI_SHADER_PGM_HI_VS;
typedef union SPI_SHADER_PGM_LO_ES                               regSPI_SHADER_PGM_LO_ES;
typedef union SPI_SHADER_PGM_LO_ES_GS                            regSPI_SHADER_PGM_LO_ES_GS;
typedef union SPI_SHADER_PGM_LO_GS                               regSPI_SHADER_PGM_LO_GS;
typedef union SPI_SHADER_PGM_LO_HS                               regSPI_SHADER_PGM_LO_HS;
typedef union SPI_SHADER_PGM_LO_LS                               regSPI_SHADER_PGM_LO_LS;
typedef union SPI_SHADER_PGM_LO_LS_HS                            regSPI_SHADER_PGM_LO_LS_HS;
typedef union SPI_SHADER_PGM_LO_PS                               regSPI_SHADER_PGM_LO_PS;
typedef union SPI_SHADER_PGM_LO_VS                               regSPI_SHADER_PGM_LO_VS;
typedef union SPI_SHADER_PGM_RSRC1_ES                            regSPI_SHADER_PGM_RSRC1_ES;
typedef union SPI_SHADER_PGM_RSRC1_GS                            regSPI_SHADER_PGM_RSRC1_GS;
typedef union SPI_SHADER_PGM_RSRC1_HS                            regSPI_SHADER_PGM_RSRC1_HS;
typedef union SPI_SHADER_PGM_RSRC1_LS                            regSPI_SHADER_PGM_RSRC1_LS;
typedef union SPI_SHADER_PGM_RSRC1_PS                            regSPI_SHADER_PGM_RSRC1_PS;
typedef union SPI_SHADER_PGM_RSRC1_VS                            regSPI_SHADER_PGM_RSRC1_VS;
typedef union SPI_SHADER_PGM_RSRC2_ES                            regSPI_SHADER_PGM_RSRC2_ES;
typedef union SPI_SHADER_PGM_RSRC2_ES_GS                         regSPI_SHADER_PGM_RSRC2_ES_GS;
typedef union SPI_SHADER_PGM_RSRC2_ES_VS                         regSPI_SHADER_PGM_RSRC2_ES_VS;
typedef union SPI_SHADER_PGM_RSRC2_GS                            regSPI_SHADER_PGM_RSRC2_GS;
typedef union SPI_SHADER_PGM_RSRC2_GS_VS                         regSPI_SHADER_PGM_RSRC2_GS_VS;
typedef union SPI_SHADER_PGM_RSRC2_HS                            regSPI_SHADER_PGM_RSRC2_HS;
typedef union SPI_SHADER_PGM_RSRC2_LS                            regSPI_SHADER_PGM_RSRC2_LS;
typedef union SPI_SHADER_PGM_RSRC2_LS_ES                         regSPI_SHADER_PGM_RSRC2_LS_ES;
typedef union SPI_SHADER_PGM_RSRC2_LS_HS                         regSPI_SHADER_PGM_RSRC2_LS_HS;
typedef union SPI_SHADER_PGM_RSRC2_LS_VS                         regSPI_SHADER_PGM_RSRC2_LS_VS;
typedef union SPI_SHADER_PGM_RSRC2_PS                            regSPI_SHADER_PGM_RSRC2_PS;
typedef union SPI_SHADER_PGM_RSRC2_VS                            regSPI_SHADER_PGM_RSRC2_VS;
typedef union SPI_SHADER_PGM_RSRC3_ES                            regSPI_SHADER_PGM_RSRC3_ES;
typedef union SPI_SHADER_PGM_RSRC3_GS                            regSPI_SHADER_PGM_RSRC3_GS;
typedef union SPI_SHADER_PGM_RSRC3_HS                            regSPI_SHADER_PGM_RSRC3_HS;
typedef union SPI_SHADER_PGM_RSRC3_LS                            regSPI_SHADER_PGM_RSRC3_LS;
typedef union SPI_SHADER_PGM_RSRC3_PS                            regSPI_SHADER_PGM_RSRC3_PS;
typedef union SPI_SHADER_PGM_RSRC3_VS                            regSPI_SHADER_PGM_RSRC3_VS;
typedef union SPI_SHADER_PGM_RSRC4_GS                            regSPI_SHADER_PGM_RSRC4_GS;
typedef union SPI_SHADER_PGM_RSRC4_HS                            regSPI_SHADER_PGM_RSRC4_HS;
typedef union SPI_SHADER_PGM_RSRC4_PS                            regSPI_SHADER_PGM_RSRC4_PS;
typedef union SPI_SHADER_PGM_RSRC4_VS                            regSPI_SHADER_PGM_RSRC4_VS;
typedef union SPI_SHADER_POS_FORMAT                              regSPI_SHADER_POS_FORMAT;
typedef union SPI_SHADER_PREF_PRI_ACCUM_ESGS_0                   regSPI_SHADER_PREF_PRI_ACCUM_ESGS_0;
typedef union SPI_SHADER_PREF_PRI_ACCUM_ESGS_1                   regSPI_SHADER_PREF_PRI_ACCUM_ESGS_1;
typedef union SPI_SHADER_PREF_PRI_ACCUM_ESGS_2                   regSPI_SHADER_PREF_PRI_ACCUM_ESGS_2;
typedef union SPI_SHADER_PREF_PRI_ACCUM_ESGS_3                   regSPI_SHADER_PREF_PRI_ACCUM_ESGS_3;
typedef union SPI_SHADER_PREF_PRI_ACCUM_LSHS_0                   regSPI_SHADER_PREF_PRI_ACCUM_LSHS_0;
typedef union SPI_SHADER_PREF_PRI_ACCUM_LSHS_1                   regSPI_SHADER_PREF_PRI_ACCUM_LSHS_1;
typedef union SPI_SHADER_PREF_PRI_ACCUM_LSHS_2                   regSPI_SHADER_PREF_PRI_ACCUM_LSHS_2;
typedef union SPI_SHADER_PREF_PRI_ACCUM_LSHS_3                   regSPI_SHADER_PREF_PRI_ACCUM_LSHS_3;
typedef union SPI_SHADER_PREF_PRI_ACCUM_PS_0                     regSPI_SHADER_PREF_PRI_ACCUM_PS_0;
typedef union SPI_SHADER_PREF_PRI_ACCUM_PS_1                     regSPI_SHADER_PREF_PRI_ACCUM_PS_1;
typedef union SPI_SHADER_PREF_PRI_ACCUM_PS_2                     regSPI_SHADER_PREF_PRI_ACCUM_PS_2;
typedef union SPI_SHADER_PREF_PRI_ACCUM_PS_3                     regSPI_SHADER_PREF_PRI_ACCUM_PS_3;
typedef union SPI_SHADER_PREF_PRI_ACCUM_VS_0                     regSPI_SHADER_PREF_PRI_ACCUM_VS_0;
typedef union SPI_SHADER_PREF_PRI_ACCUM_VS_1                     regSPI_SHADER_PREF_PRI_ACCUM_VS_1;
typedef union SPI_SHADER_PREF_PRI_ACCUM_VS_2                     regSPI_SHADER_PREF_PRI_ACCUM_VS_2;
typedef union SPI_SHADER_PREF_PRI_ACCUM_VS_3                     regSPI_SHADER_PREF_PRI_ACCUM_VS_3;
typedef union SPI_SHADER_PREF_PRI_CNTR_CTRL_ESGS                 regSPI_SHADER_PREF_PRI_CNTR_CTRL_ESGS;
typedef union SPI_SHADER_PREF_PRI_CNTR_CTRL_LSHS                 regSPI_SHADER_PREF_PRI_CNTR_CTRL_LSHS;
typedef union SPI_SHADER_PREF_PRI_CNTR_CTRL_PS                   regSPI_SHADER_PREF_PRI_CNTR_CTRL_PS;
typedef union SPI_SHADER_PREF_PRI_CNTR_CTRL_VS                   regSPI_SHADER_PREF_PRI_CNTR_CTRL_VS;
typedef union SPI_SHADER_REQ_CTRL_ESGS                           regSPI_SHADER_REQ_CTRL_ESGS;
typedef union SPI_SHADER_REQ_CTRL_LSHS                           regSPI_SHADER_REQ_CTRL_LSHS;
typedef union SPI_SHADER_REQ_CTRL_PS                             regSPI_SHADER_REQ_CTRL_PS;
typedef union SPI_SHADER_REQ_CTRL_VS                             regSPI_SHADER_REQ_CTRL_VS;
typedef union SPI_SHADER_RSRC_LIMIT_CTRL                         regSPI_SHADER_RSRC_LIMIT_CTRL;
typedef union SPI_SHADER_USER_ACCUM_ESGS_0                       regSPI_SHADER_USER_ACCUM_ESGS_0;
typedef union SPI_SHADER_USER_ACCUM_ESGS_1                       regSPI_SHADER_USER_ACCUM_ESGS_1;
typedef union SPI_SHADER_USER_ACCUM_ESGS_2                       regSPI_SHADER_USER_ACCUM_ESGS_2;
typedef union SPI_SHADER_USER_ACCUM_ESGS_3                       regSPI_SHADER_USER_ACCUM_ESGS_3;
typedef union SPI_SHADER_USER_ACCUM_LSHS_0                       regSPI_SHADER_USER_ACCUM_LSHS_0;
typedef union SPI_SHADER_USER_ACCUM_LSHS_1                       regSPI_SHADER_USER_ACCUM_LSHS_1;
typedef union SPI_SHADER_USER_ACCUM_LSHS_2                       regSPI_SHADER_USER_ACCUM_LSHS_2;
typedef union SPI_SHADER_USER_ACCUM_LSHS_3                       regSPI_SHADER_USER_ACCUM_LSHS_3;
typedef union SPI_SHADER_USER_ACCUM_PS_0                         regSPI_SHADER_USER_ACCUM_PS_0;
typedef union SPI_SHADER_USER_ACCUM_PS_1                         regSPI_SHADER_USER_ACCUM_PS_1;
typedef union SPI_SHADER_USER_ACCUM_PS_2                         regSPI_SHADER_USER_ACCUM_PS_2;
typedef union SPI_SHADER_USER_ACCUM_PS_3                         regSPI_SHADER_USER_ACCUM_PS_3;
typedef union SPI_SHADER_USER_ACCUM_VS_0                         regSPI_SHADER_USER_ACCUM_VS_0;
typedef union SPI_SHADER_USER_ACCUM_VS_1                         regSPI_SHADER_USER_ACCUM_VS_1;
typedef union SPI_SHADER_USER_ACCUM_VS_2                         regSPI_SHADER_USER_ACCUM_VS_2;
typedef union SPI_SHADER_USER_ACCUM_VS_3                         regSPI_SHADER_USER_ACCUM_VS_3;
typedef union SPI_SHADER_USER_DATA_ADDR_HI_GS                    regSPI_SHADER_USER_DATA_ADDR_HI_GS;
typedef union SPI_SHADER_USER_DATA_ADDR_HI_HS                    regSPI_SHADER_USER_DATA_ADDR_HI_HS;
typedef union SPI_SHADER_USER_DATA_ADDR_LO_GS                    regSPI_SHADER_USER_DATA_ADDR_LO_GS;
typedef union SPI_SHADER_USER_DATA_ADDR_LO_HS                    regSPI_SHADER_USER_DATA_ADDR_LO_HS;
typedef union SPI_SHADER_USER_DATA_COMMON_0                      regSPI_SHADER_USER_DATA_COMMON_0;
typedef union SPI_SHADER_USER_DATA_COMMON_1                      regSPI_SHADER_USER_DATA_COMMON_1;
typedef union SPI_SHADER_USER_DATA_COMMON_2                      regSPI_SHADER_USER_DATA_COMMON_2;
typedef union SPI_SHADER_USER_DATA_COMMON_3                      regSPI_SHADER_USER_DATA_COMMON_3;
typedef union SPI_SHADER_USER_DATA_COMMON_4                      regSPI_SHADER_USER_DATA_COMMON_4;
typedef union SPI_SHADER_USER_DATA_COMMON_5                      regSPI_SHADER_USER_DATA_COMMON_5;
typedef union SPI_SHADER_USER_DATA_COMMON_6                      regSPI_SHADER_USER_DATA_COMMON_6;
typedef union SPI_SHADER_USER_DATA_COMMON_7                      regSPI_SHADER_USER_DATA_COMMON_7;
typedef union SPI_SHADER_USER_DATA_COMMON_8                      regSPI_SHADER_USER_DATA_COMMON_8;
typedef union SPI_SHADER_USER_DATA_COMMON_9                      regSPI_SHADER_USER_DATA_COMMON_9;
typedef union SPI_SHADER_USER_DATA_COMMON_10                     regSPI_SHADER_USER_DATA_COMMON_10;
typedef union SPI_SHADER_USER_DATA_COMMON_11                     regSPI_SHADER_USER_DATA_COMMON_11;
typedef union SPI_SHADER_USER_DATA_COMMON_12                     regSPI_SHADER_USER_DATA_COMMON_12;
typedef union SPI_SHADER_USER_DATA_COMMON_13                     regSPI_SHADER_USER_DATA_COMMON_13;
typedef union SPI_SHADER_USER_DATA_COMMON_14                     regSPI_SHADER_USER_DATA_COMMON_14;
typedef union SPI_SHADER_USER_DATA_COMMON_15                     regSPI_SHADER_USER_DATA_COMMON_15;
typedef union SPI_SHADER_USER_DATA_COMMON_16                     regSPI_SHADER_USER_DATA_COMMON_16;
typedef union SPI_SHADER_USER_DATA_COMMON_17                     regSPI_SHADER_USER_DATA_COMMON_17;
typedef union SPI_SHADER_USER_DATA_COMMON_18                     regSPI_SHADER_USER_DATA_COMMON_18;
typedef union SPI_SHADER_USER_DATA_COMMON_19                     regSPI_SHADER_USER_DATA_COMMON_19;
typedef union SPI_SHADER_USER_DATA_COMMON_20                     regSPI_SHADER_USER_DATA_COMMON_20;
typedef union SPI_SHADER_USER_DATA_COMMON_21                     regSPI_SHADER_USER_DATA_COMMON_21;
typedef union SPI_SHADER_USER_DATA_COMMON_22                     regSPI_SHADER_USER_DATA_COMMON_22;
typedef union SPI_SHADER_USER_DATA_COMMON_23                     regSPI_SHADER_USER_DATA_COMMON_23;
typedef union SPI_SHADER_USER_DATA_COMMON_24                     regSPI_SHADER_USER_DATA_COMMON_24;
typedef union SPI_SHADER_USER_DATA_COMMON_25                     regSPI_SHADER_USER_DATA_COMMON_25;
typedef union SPI_SHADER_USER_DATA_COMMON_26                     regSPI_SHADER_USER_DATA_COMMON_26;
typedef union SPI_SHADER_USER_DATA_COMMON_27                     regSPI_SHADER_USER_DATA_COMMON_27;
typedef union SPI_SHADER_USER_DATA_COMMON_28                     regSPI_SHADER_USER_DATA_COMMON_28;
typedef union SPI_SHADER_USER_DATA_COMMON_29                     regSPI_SHADER_USER_DATA_COMMON_29;
typedef union SPI_SHADER_USER_DATA_COMMON_30                     regSPI_SHADER_USER_DATA_COMMON_30;
typedef union SPI_SHADER_USER_DATA_COMMON_31                     regSPI_SHADER_USER_DATA_COMMON_31;
typedef union SPI_SHADER_USER_DATA_ES_0                          regSPI_SHADER_USER_DATA_ES_0;
typedef union SPI_SHADER_USER_DATA_ES_1                          regSPI_SHADER_USER_DATA_ES_1;
typedef union SPI_SHADER_USER_DATA_ES_2                          regSPI_SHADER_USER_DATA_ES_2;
typedef union SPI_SHADER_USER_DATA_ES_3                          regSPI_SHADER_USER_DATA_ES_3;
typedef union SPI_SHADER_USER_DATA_ES_4                          regSPI_SHADER_USER_DATA_ES_4;
typedef union SPI_SHADER_USER_DATA_ES_5                          regSPI_SHADER_USER_DATA_ES_5;
typedef union SPI_SHADER_USER_DATA_ES_6                          regSPI_SHADER_USER_DATA_ES_6;
typedef union SPI_SHADER_USER_DATA_ES_7                          regSPI_SHADER_USER_DATA_ES_7;
typedef union SPI_SHADER_USER_DATA_ES_8                          regSPI_SHADER_USER_DATA_ES_8;
typedef union SPI_SHADER_USER_DATA_ES_9                          regSPI_SHADER_USER_DATA_ES_9;
typedef union SPI_SHADER_USER_DATA_ES_10                         regSPI_SHADER_USER_DATA_ES_10;
typedef union SPI_SHADER_USER_DATA_ES_11                         regSPI_SHADER_USER_DATA_ES_11;
typedef union SPI_SHADER_USER_DATA_ES_12                         regSPI_SHADER_USER_DATA_ES_12;
typedef union SPI_SHADER_USER_DATA_ES_13                         regSPI_SHADER_USER_DATA_ES_13;
typedef union SPI_SHADER_USER_DATA_ES_14                         regSPI_SHADER_USER_DATA_ES_14;
typedef union SPI_SHADER_USER_DATA_ES_15                         regSPI_SHADER_USER_DATA_ES_15;
typedef union SPI_SHADER_USER_DATA_ES_16                         regSPI_SHADER_USER_DATA_ES_16;
typedef union SPI_SHADER_USER_DATA_ES_17                         regSPI_SHADER_USER_DATA_ES_17;
typedef union SPI_SHADER_USER_DATA_ES_18                         regSPI_SHADER_USER_DATA_ES_18;
typedef union SPI_SHADER_USER_DATA_ES_19                         regSPI_SHADER_USER_DATA_ES_19;
typedef union SPI_SHADER_USER_DATA_ES_20                         regSPI_SHADER_USER_DATA_ES_20;
typedef union SPI_SHADER_USER_DATA_ES_21                         regSPI_SHADER_USER_DATA_ES_21;
typedef union SPI_SHADER_USER_DATA_ES_22                         regSPI_SHADER_USER_DATA_ES_22;
typedef union SPI_SHADER_USER_DATA_ES_23                         regSPI_SHADER_USER_DATA_ES_23;
typedef union SPI_SHADER_USER_DATA_ES_24                         regSPI_SHADER_USER_DATA_ES_24;
typedef union SPI_SHADER_USER_DATA_ES_25                         regSPI_SHADER_USER_DATA_ES_25;
typedef union SPI_SHADER_USER_DATA_ES_26                         regSPI_SHADER_USER_DATA_ES_26;
typedef union SPI_SHADER_USER_DATA_ES_27                         regSPI_SHADER_USER_DATA_ES_27;
typedef union SPI_SHADER_USER_DATA_ES_28                         regSPI_SHADER_USER_DATA_ES_28;
typedef union SPI_SHADER_USER_DATA_ES_29                         regSPI_SHADER_USER_DATA_ES_29;
typedef union SPI_SHADER_USER_DATA_ES_30                         regSPI_SHADER_USER_DATA_ES_30;
typedef union SPI_SHADER_USER_DATA_ES_31                         regSPI_SHADER_USER_DATA_ES_31;
typedef union SPI_SHADER_USER_DATA_GS_0                          regSPI_SHADER_USER_DATA_GS_0;
typedef union SPI_SHADER_USER_DATA_GS_1                          regSPI_SHADER_USER_DATA_GS_1;
typedef union SPI_SHADER_USER_DATA_GS_2                          regSPI_SHADER_USER_DATA_GS_2;
typedef union SPI_SHADER_USER_DATA_GS_3                          regSPI_SHADER_USER_DATA_GS_3;
typedef union SPI_SHADER_USER_DATA_GS_4                          regSPI_SHADER_USER_DATA_GS_4;
typedef union SPI_SHADER_USER_DATA_GS_5                          regSPI_SHADER_USER_DATA_GS_5;
typedef union SPI_SHADER_USER_DATA_GS_6                          regSPI_SHADER_USER_DATA_GS_6;
typedef union SPI_SHADER_USER_DATA_GS_7                          regSPI_SHADER_USER_DATA_GS_7;
typedef union SPI_SHADER_USER_DATA_GS_8                          regSPI_SHADER_USER_DATA_GS_8;
typedef union SPI_SHADER_USER_DATA_GS_9                          regSPI_SHADER_USER_DATA_GS_9;
typedef union SPI_SHADER_USER_DATA_GS_10                         regSPI_SHADER_USER_DATA_GS_10;
typedef union SPI_SHADER_USER_DATA_GS_11                         regSPI_SHADER_USER_DATA_GS_11;
typedef union SPI_SHADER_USER_DATA_GS_12                         regSPI_SHADER_USER_DATA_GS_12;
typedef union SPI_SHADER_USER_DATA_GS_13                         regSPI_SHADER_USER_DATA_GS_13;
typedef union SPI_SHADER_USER_DATA_GS_14                         regSPI_SHADER_USER_DATA_GS_14;
typedef union SPI_SHADER_USER_DATA_GS_15                         regSPI_SHADER_USER_DATA_GS_15;
typedef union SPI_SHADER_USER_DATA_GS_16                         regSPI_SHADER_USER_DATA_GS_16;
typedef union SPI_SHADER_USER_DATA_GS_17                         regSPI_SHADER_USER_DATA_GS_17;
typedef union SPI_SHADER_USER_DATA_GS_18                         regSPI_SHADER_USER_DATA_GS_18;
typedef union SPI_SHADER_USER_DATA_GS_19                         regSPI_SHADER_USER_DATA_GS_19;
typedef union SPI_SHADER_USER_DATA_GS_20                         regSPI_SHADER_USER_DATA_GS_20;
typedef union SPI_SHADER_USER_DATA_GS_21                         regSPI_SHADER_USER_DATA_GS_21;
typedef union SPI_SHADER_USER_DATA_GS_22                         regSPI_SHADER_USER_DATA_GS_22;
typedef union SPI_SHADER_USER_DATA_GS_23                         regSPI_SHADER_USER_DATA_GS_23;
typedef union SPI_SHADER_USER_DATA_GS_24                         regSPI_SHADER_USER_DATA_GS_24;
typedef union SPI_SHADER_USER_DATA_GS_25                         regSPI_SHADER_USER_DATA_GS_25;
typedef union SPI_SHADER_USER_DATA_GS_26                         regSPI_SHADER_USER_DATA_GS_26;
typedef union SPI_SHADER_USER_DATA_GS_27                         regSPI_SHADER_USER_DATA_GS_27;
typedef union SPI_SHADER_USER_DATA_GS_28                         regSPI_SHADER_USER_DATA_GS_28;
typedef union SPI_SHADER_USER_DATA_GS_29                         regSPI_SHADER_USER_DATA_GS_29;
typedef union SPI_SHADER_USER_DATA_GS_30                         regSPI_SHADER_USER_DATA_GS_30;
typedef union SPI_SHADER_USER_DATA_GS_31                         regSPI_SHADER_USER_DATA_GS_31;
typedef union SPI_SHADER_USER_DATA_HS_0                          regSPI_SHADER_USER_DATA_HS_0;
typedef union SPI_SHADER_USER_DATA_HS_1                          regSPI_SHADER_USER_DATA_HS_1;
typedef union SPI_SHADER_USER_DATA_HS_2                          regSPI_SHADER_USER_DATA_HS_2;
typedef union SPI_SHADER_USER_DATA_HS_3                          regSPI_SHADER_USER_DATA_HS_3;
typedef union SPI_SHADER_USER_DATA_HS_4                          regSPI_SHADER_USER_DATA_HS_4;
typedef union SPI_SHADER_USER_DATA_HS_5                          regSPI_SHADER_USER_DATA_HS_5;
typedef union SPI_SHADER_USER_DATA_HS_6                          regSPI_SHADER_USER_DATA_HS_6;
typedef union SPI_SHADER_USER_DATA_HS_7                          regSPI_SHADER_USER_DATA_HS_7;
typedef union SPI_SHADER_USER_DATA_HS_8                          regSPI_SHADER_USER_DATA_HS_8;
typedef union SPI_SHADER_USER_DATA_HS_9                          regSPI_SHADER_USER_DATA_HS_9;
typedef union SPI_SHADER_USER_DATA_HS_10                         regSPI_SHADER_USER_DATA_HS_10;
typedef union SPI_SHADER_USER_DATA_HS_11                         regSPI_SHADER_USER_DATA_HS_11;
typedef union SPI_SHADER_USER_DATA_HS_12                         regSPI_SHADER_USER_DATA_HS_12;
typedef union SPI_SHADER_USER_DATA_HS_13                         regSPI_SHADER_USER_DATA_HS_13;
typedef union SPI_SHADER_USER_DATA_HS_14                         regSPI_SHADER_USER_DATA_HS_14;
typedef union SPI_SHADER_USER_DATA_HS_15                         regSPI_SHADER_USER_DATA_HS_15;
typedef union SPI_SHADER_USER_DATA_HS_16                         regSPI_SHADER_USER_DATA_HS_16;
typedef union SPI_SHADER_USER_DATA_HS_17                         regSPI_SHADER_USER_DATA_HS_17;
typedef union SPI_SHADER_USER_DATA_HS_18                         regSPI_SHADER_USER_DATA_HS_18;
typedef union SPI_SHADER_USER_DATA_HS_19                         regSPI_SHADER_USER_DATA_HS_19;
typedef union SPI_SHADER_USER_DATA_HS_20                         regSPI_SHADER_USER_DATA_HS_20;
typedef union SPI_SHADER_USER_DATA_HS_21                         regSPI_SHADER_USER_DATA_HS_21;
typedef union SPI_SHADER_USER_DATA_HS_22                         regSPI_SHADER_USER_DATA_HS_22;
typedef union SPI_SHADER_USER_DATA_HS_23                         regSPI_SHADER_USER_DATA_HS_23;
typedef union SPI_SHADER_USER_DATA_HS_24                         regSPI_SHADER_USER_DATA_HS_24;
typedef union SPI_SHADER_USER_DATA_HS_25                         regSPI_SHADER_USER_DATA_HS_25;
typedef union SPI_SHADER_USER_DATA_HS_26                         regSPI_SHADER_USER_DATA_HS_26;
typedef union SPI_SHADER_USER_DATA_HS_27                         regSPI_SHADER_USER_DATA_HS_27;
typedef union SPI_SHADER_USER_DATA_HS_28                         regSPI_SHADER_USER_DATA_HS_28;
typedef union SPI_SHADER_USER_DATA_HS_29                         regSPI_SHADER_USER_DATA_HS_29;
typedef union SPI_SHADER_USER_DATA_HS_30                         regSPI_SHADER_USER_DATA_HS_30;
typedef union SPI_SHADER_USER_DATA_HS_31                         regSPI_SHADER_USER_DATA_HS_31;
typedef union SPI_SHADER_USER_DATA_LS_0                          regSPI_SHADER_USER_DATA_LS_0;
typedef union SPI_SHADER_USER_DATA_LS_1                          regSPI_SHADER_USER_DATA_LS_1;
typedef union SPI_SHADER_USER_DATA_LS_2                          regSPI_SHADER_USER_DATA_LS_2;
typedef union SPI_SHADER_USER_DATA_LS_3                          regSPI_SHADER_USER_DATA_LS_3;
typedef union SPI_SHADER_USER_DATA_LS_4                          regSPI_SHADER_USER_DATA_LS_4;
typedef union SPI_SHADER_USER_DATA_LS_5                          regSPI_SHADER_USER_DATA_LS_5;
typedef union SPI_SHADER_USER_DATA_LS_6                          regSPI_SHADER_USER_DATA_LS_6;
typedef union SPI_SHADER_USER_DATA_LS_7                          regSPI_SHADER_USER_DATA_LS_7;
typedef union SPI_SHADER_USER_DATA_LS_8                          regSPI_SHADER_USER_DATA_LS_8;
typedef union SPI_SHADER_USER_DATA_LS_9                          regSPI_SHADER_USER_DATA_LS_9;
typedef union SPI_SHADER_USER_DATA_LS_10                         regSPI_SHADER_USER_DATA_LS_10;
typedef union SPI_SHADER_USER_DATA_LS_11                         regSPI_SHADER_USER_DATA_LS_11;
typedef union SPI_SHADER_USER_DATA_LS_12                         regSPI_SHADER_USER_DATA_LS_12;
typedef union SPI_SHADER_USER_DATA_LS_13                         regSPI_SHADER_USER_DATA_LS_13;
typedef union SPI_SHADER_USER_DATA_LS_14                         regSPI_SHADER_USER_DATA_LS_14;
typedef union SPI_SHADER_USER_DATA_LS_15                         regSPI_SHADER_USER_DATA_LS_15;
typedef union SPI_SHADER_USER_DATA_LS_16                         regSPI_SHADER_USER_DATA_LS_16;
typedef union SPI_SHADER_USER_DATA_LS_17                         regSPI_SHADER_USER_DATA_LS_17;
typedef union SPI_SHADER_USER_DATA_LS_18                         regSPI_SHADER_USER_DATA_LS_18;
typedef union SPI_SHADER_USER_DATA_LS_19                         regSPI_SHADER_USER_DATA_LS_19;
typedef union SPI_SHADER_USER_DATA_LS_20                         regSPI_SHADER_USER_DATA_LS_20;
typedef union SPI_SHADER_USER_DATA_LS_21                         regSPI_SHADER_USER_DATA_LS_21;
typedef union SPI_SHADER_USER_DATA_LS_22                         regSPI_SHADER_USER_DATA_LS_22;
typedef union SPI_SHADER_USER_DATA_LS_23                         regSPI_SHADER_USER_DATA_LS_23;
typedef union SPI_SHADER_USER_DATA_LS_24                         regSPI_SHADER_USER_DATA_LS_24;
typedef union SPI_SHADER_USER_DATA_LS_25                         regSPI_SHADER_USER_DATA_LS_25;
typedef union SPI_SHADER_USER_DATA_LS_26                         regSPI_SHADER_USER_DATA_LS_26;
typedef union SPI_SHADER_USER_DATA_LS_27                         regSPI_SHADER_USER_DATA_LS_27;
typedef union SPI_SHADER_USER_DATA_LS_28                         regSPI_SHADER_USER_DATA_LS_28;
typedef union SPI_SHADER_USER_DATA_LS_29                         regSPI_SHADER_USER_DATA_LS_29;
typedef union SPI_SHADER_USER_DATA_LS_30                         regSPI_SHADER_USER_DATA_LS_30;
typedef union SPI_SHADER_USER_DATA_LS_31                         regSPI_SHADER_USER_DATA_LS_31;
typedef union SPI_SHADER_USER_DATA_PS_0                          regSPI_SHADER_USER_DATA_PS_0;
typedef union SPI_SHADER_USER_DATA_PS_1                          regSPI_SHADER_USER_DATA_PS_1;
typedef union SPI_SHADER_USER_DATA_PS_2                          regSPI_SHADER_USER_DATA_PS_2;
typedef union SPI_SHADER_USER_DATA_PS_3                          regSPI_SHADER_USER_DATA_PS_3;
typedef union SPI_SHADER_USER_DATA_PS_4                          regSPI_SHADER_USER_DATA_PS_4;
typedef union SPI_SHADER_USER_DATA_PS_5                          regSPI_SHADER_USER_DATA_PS_5;
typedef union SPI_SHADER_USER_DATA_PS_6                          regSPI_SHADER_USER_DATA_PS_6;
typedef union SPI_SHADER_USER_DATA_PS_7                          regSPI_SHADER_USER_DATA_PS_7;
typedef union SPI_SHADER_USER_DATA_PS_8                          regSPI_SHADER_USER_DATA_PS_8;
typedef union SPI_SHADER_USER_DATA_PS_9                          regSPI_SHADER_USER_DATA_PS_9;
typedef union SPI_SHADER_USER_DATA_PS_10                         regSPI_SHADER_USER_DATA_PS_10;
typedef union SPI_SHADER_USER_DATA_PS_11                         regSPI_SHADER_USER_DATA_PS_11;
typedef union SPI_SHADER_USER_DATA_PS_12                         regSPI_SHADER_USER_DATA_PS_12;
typedef union SPI_SHADER_USER_DATA_PS_13                         regSPI_SHADER_USER_DATA_PS_13;
typedef union SPI_SHADER_USER_DATA_PS_14                         regSPI_SHADER_USER_DATA_PS_14;
typedef union SPI_SHADER_USER_DATA_PS_15                         regSPI_SHADER_USER_DATA_PS_15;
typedef union SPI_SHADER_USER_DATA_PS_16                         regSPI_SHADER_USER_DATA_PS_16;
typedef union SPI_SHADER_USER_DATA_PS_17                         regSPI_SHADER_USER_DATA_PS_17;
typedef union SPI_SHADER_USER_DATA_PS_18                         regSPI_SHADER_USER_DATA_PS_18;
typedef union SPI_SHADER_USER_DATA_PS_19                         regSPI_SHADER_USER_DATA_PS_19;
typedef union SPI_SHADER_USER_DATA_PS_20                         regSPI_SHADER_USER_DATA_PS_20;
typedef union SPI_SHADER_USER_DATA_PS_21                         regSPI_SHADER_USER_DATA_PS_21;
typedef union SPI_SHADER_USER_DATA_PS_22                         regSPI_SHADER_USER_DATA_PS_22;
typedef union SPI_SHADER_USER_DATA_PS_23                         regSPI_SHADER_USER_DATA_PS_23;
typedef union SPI_SHADER_USER_DATA_PS_24                         regSPI_SHADER_USER_DATA_PS_24;
typedef union SPI_SHADER_USER_DATA_PS_25                         regSPI_SHADER_USER_DATA_PS_25;
typedef union SPI_SHADER_USER_DATA_PS_26                         regSPI_SHADER_USER_DATA_PS_26;
typedef union SPI_SHADER_USER_DATA_PS_27                         regSPI_SHADER_USER_DATA_PS_27;
typedef union SPI_SHADER_USER_DATA_PS_28                         regSPI_SHADER_USER_DATA_PS_28;
typedef union SPI_SHADER_USER_DATA_PS_29                         regSPI_SHADER_USER_DATA_PS_29;
typedef union SPI_SHADER_USER_DATA_PS_30                         regSPI_SHADER_USER_DATA_PS_30;
typedef union SPI_SHADER_USER_DATA_PS_31                         regSPI_SHADER_USER_DATA_PS_31;
typedef union SPI_SHADER_USER_DATA_VS_0                          regSPI_SHADER_USER_DATA_VS_0;
typedef union SPI_SHADER_USER_DATA_VS_1                          regSPI_SHADER_USER_DATA_VS_1;
typedef union SPI_SHADER_USER_DATA_VS_2                          regSPI_SHADER_USER_DATA_VS_2;
typedef union SPI_SHADER_USER_DATA_VS_3                          regSPI_SHADER_USER_DATA_VS_3;
typedef union SPI_SHADER_USER_DATA_VS_4                          regSPI_SHADER_USER_DATA_VS_4;
typedef union SPI_SHADER_USER_DATA_VS_5                          regSPI_SHADER_USER_DATA_VS_5;
typedef union SPI_SHADER_USER_DATA_VS_6                          regSPI_SHADER_USER_DATA_VS_6;
typedef union SPI_SHADER_USER_DATA_VS_7                          regSPI_SHADER_USER_DATA_VS_7;
typedef union SPI_SHADER_USER_DATA_VS_8                          regSPI_SHADER_USER_DATA_VS_8;
typedef union SPI_SHADER_USER_DATA_VS_9                          regSPI_SHADER_USER_DATA_VS_9;
typedef union SPI_SHADER_USER_DATA_VS_10                         regSPI_SHADER_USER_DATA_VS_10;
typedef union SPI_SHADER_USER_DATA_VS_11                         regSPI_SHADER_USER_DATA_VS_11;
typedef union SPI_SHADER_USER_DATA_VS_12                         regSPI_SHADER_USER_DATA_VS_12;
typedef union SPI_SHADER_USER_DATA_VS_13                         regSPI_SHADER_USER_DATA_VS_13;
typedef union SPI_SHADER_USER_DATA_VS_14                         regSPI_SHADER_USER_DATA_VS_14;
typedef union SPI_SHADER_USER_DATA_VS_15                         regSPI_SHADER_USER_DATA_VS_15;
typedef union SPI_SHADER_USER_DATA_VS_16                         regSPI_SHADER_USER_DATA_VS_16;
typedef union SPI_SHADER_USER_DATA_VS_17                         regSPI_SHADER_USER_DATA_VS_17;
typedef union SPI_SHADER_USER_DATA_VS_18                         regSPI_SHADER_USER_DATA_VS_18;
typedef union SPI_SHADER_USER_DATA_VS_19                         regSPI_SHADER_USER_DATA_VS_19;
typedef union SPI_SHADER_USER_DATA_VS_20                         regSPI_SHADER_USER_DATA_VS_20;
typedef union SPI_SHADER_USER_DATA_VS_21                         regSPI_SHADER_USER_DATA_VS_21;
typedef union SPI_SHADER_USER_DATA_VS_22                         regSPI_SHADER_USER_DATA_VS_22;
typedef union SPI_SHADER_USER_DATA_VS_23                         regSPI_SHADER_USER_DATA_VS_23;
typedef union SPI_SHADER_USER_DATA_VS_24                         regSPI_SHADER_USER_DATA_VS_24;
typedef union SPI_SHADER_USER_DATA_VS_25                         regSPI_SHADER_USER_DATA_VS_25;
typedef union SPI_SHADER_USER_DATA_VS_26                         regSPI_SHADER_USER_DATA_VS_26;
typedef union SPI_SHADER_USER_DATA_VS_27                         regSPI_SHADER_USER_DATA_VS_27;
typedef union SPI_SHADER_USER_DATA_VS_28                         regSPI_SHADER_USER_DATA_VS_28;
typedef union SPI_SHADER_USER_DATA_VS_29                         regSPI_SHADER_USER_DATA_VS_29;
typedef union SPI_SHADER_USER_DATA_VS_30                         regSPI_SHADER_USER_DATA_VS_30;
typedef union SPI_SHADER_USER_DATA_VS_31                         regSPI_SHADER_USER_DATA_VS_31;
typedef union SPI_SHADER_Z_FORMAT                                regSPI_SHADER_Z_FORMAT;
typedef union SPI_START_PHASE                                    regSPI_START_PHASE;
typedef union SPI_SX_EXPORT_BUFFER_SIZES                         regSPI_SX_EXPORT_BUFFER_SIZES;
typedef union SPI_SX_SCOREBOARD_BUFFER_SIZES                     regSPI_SX_SCOREBOARD_BUFFER_SIZES;
typedef union SPI_SYS_COMPUTE                                    regSPI_SYS_COMPUTE;
typedef union SPI_SYS_WIF_CNTL                                   regSPI_SYS_WIF_CNTL;
typedef union SPI_TMPRING_SIZE                                   regSPI_TMPRING_SIZE;
typedef union SPI_USER_ACCUM_VMID_CNTL                           regSPI_USER_ACCUM_VMID_CNTL;
typedef union SPI_VS_OUT_CONFIG                                  regSPI_VS_OUT_CONFIG;
typedef union spi_vs_wave_ctl0                                   regspi_vs_wave_ctl0;
typedef union spi_vs_wave_ctl1                                   regspi_vs_wave_ctl1;
typedef union spi_vs_wave_ctl2                                   regspi_vs_wave_ctl2;
typedef union SPI_WAVE_LIMIT_CNTL                                regSPI_WAVE_LIMIT_CNTL;
typedef union SPI_WAVE_LIMIT_CNTL_REMAP                          regSPI_WAVE_LIMIT_CNTL_REMAP;
typedef union SPI_WCL_PIPE_PERCENT_CS0                           regSPI_WCL_PIPE_PERCENT_CS0;
typedef union SPI_WCL_PIPE_PERCENT_CS1                           regSPI_WCL_PIPE_PERCENT_CS1;
typedef union SPI_WCL_PIPE_PERCENT_CS2                           regSPI_WCL_PIPE_PERCENT_CS2;
typedef union SPI_WCL_PIPE_PERCENT_CS3                           regSPI_WCL_PIPE_PERCENT_CS3;
typedef union SPI_WCL_PIPE_PERCENT_CS4                           regSPI_WCL_PIPE_PERCENT_CS4;
typedef union SPI_WCL_PIPE_PERCENT_CS5                           regSPI_WCL_PIPE_PERCENT_CS5;
typedef union SPI_WCL_PIPE_PERCENT_CS6                           regSPI_WCL_PIPE_PERCENT_CS6;
typedef union SPI_WCL_PIPE_PERCENT_CS7                           regSPI_WCL_PIPE_PERCENT_CS7;
typedef union SPI_WCL_PIPE_PERCENT_GFX                           regSPI_WCL_PIPE_PERCENT_GFX;
typedef union SPI_WCL_PIPE_PERCENT_HP3D                          regSPI_WCL_PIPE_PERCENT_HP3D;
typedef union SPI_WF_LIFETIME_CNTL                               regSPI_WF_LIFETIME_CNTL;
typedef union SPI_WF_LIFETIME_DEBUG                              regSPI_WF_LIFETIME_DEBUG;
typedef union SPI_WF_LIFETIME_LIMIT_0                            regSPI_WF_LIFETIME_LIMIT_0;
typedef union SPI_WF_LIFETIME_LIMIT_1                            regSPI_WF_LIFETIME_LIMIT_1;
typedef union SPI_WF_LIFETIME_LIMIT_2                            regSPI_WF_LIFETIME_LIMIT_2;
typedef union SPI_WF_LIFETIME_LIMIT_3                            regSPI_WF_LIFETIME_LIMIT_3;
typedef union SPI_WF_LIFETIME_LIMIT_4                            regSPI_WF_LIFETIME_LIMIT_4;
typedef union SPI_WF_LIFETIME_LIMIT_5                            regSPI_WF_LIFETIME_LIMIT_5;
typedef union SPI_WF_LIFETIME_LIMIT_6                            regSPI_WF_LIFETIME_LIMIT_6;
typedef union SPI_WF_LIFETIME_LIMIT_7                            regSPI_WF_LIFETIME_LIMIT_7;
typedef union SPI_WF_LIFETIME_LIMIT_8                            regSPI_WF_LIFETIME_LIMIT_8;
typedef union SPI_WF_LIFETIME_LIMIT_9                            regSPI_WF_LIFETIME_LIMIT_9;
typedef union SPI_WF_LIFETIME_STATUS_0                           regSPI_WF_LIFETIME_STATUS_0;
typedef union SPI_WF_LIFETIME_STATUS_1                           regSPI_WF_LIFETIME_STATUS_1;
typedef union SPI_WF_LIFETIME_STATUS_2                           regSPI_WF_LIFETIME_STATUS_2;
typedef union SPI_WF_LIFETIME_STATUS_3                           regSPI_WF_LIFETIME_STATUS_3;
typedef union SPI_WF_LIFETIME_STATUS_4                           regSPI_WF_LIFETIME_STATUS_4;
typedef union SPI_WF_LIFETIME_STATUS_5                           regSPI_WF_LIFETIME_STATUS_5;
typedef union SPI_WF_LIFETIME_STATUS_6                           regSPI_WF_LIFETIME_STATUS_6;
typedef union SPI_WF_LIFETIME_STATUS_7                           regSPI_WF_LIFETIME_STATUS_7;
typedef union SPI_WF_LIFETIME_STATUS_8                           regSPI_WF_LIFETIME_STATUS_8;
typedef union SPI_WF_LIFETIME_STATUS_9                           regSPI_WF_LIFETIME_STATUS_9;
typedef union SPI_WF_LIFETIME_STATUS_10                          regSPI_WF_LIFETIME_STATUS_10;
typedef union SPI_WF_LIFETIME_STATUS_11                          regSPI_WF_LIFETIME_STATUS_11;
typedef union SPI_WF_LIFETIME_STATUS_12                          regSPI_WF_LIFETIME_STATUS_12;
typedef union SPI_WF_LIFETIME_STATUS_13                          regSPI_WF_LIFETIME_STATUS_13;
typedef union SPI_WF_LIFETIME_STATUS_14                          regSPI_WF_LIFETIME_STATUS_14;
typedef union SPI_WF_LIFETIME_STATUS_15                          regSPI_WF_LIFETIME_STATUS_15;
typedef union SPI_WF_LIFETIME_STATUS_16                          regSPI_WF_LIFETIME_STATUS_16;
typedef union SPI_WF_LIFETIME_STATUS_17                          regSPI_WF_LIFETIME_STATUS_17;
typedef union SPI_WF_LIFETIME_STATUS_18                          regSPI_WF_LIFETIME_STATUS_18;
typedef union SPI_WF_LIFETIME_STATUS_19                          regSPI_WF_LIFETIME_STATUS_19;
typedef union SPI_WF_LIFETIME_STATUS_20                          regSPI_WF_LIFETIME_STATUS_20;
typedef union SP_CONFIG                                          regSP_CONFIG;
typedef union SQC_CACHES                                         regSQC_CACHES;
typedef union SQC_CONFIG                                         regSQC_CONFIG;
typedef union SQC_DCACHE_UTCL0_CNTL1                             regSQC_DCACHE_UTCL0_CNTL1;
typedef union SQC_DCACHE_UTCL0_CNTL2                             regSQC_DCACHE_UTCL0_CNTL2;
typedef union SQC_DCACHE_UTCL0_STATUS                            regSQC_DCACHE_UTCL0_STATUS;
typedef union SQC_DCACHE_UTCL1_CNTL1                             regSQC_DCACHE_UTCL1_CNTL1;
typedef union SQC_DCACHE_UTCL1_CNTL2                             regSQC_DCACHE_UTCL1_CNTL2;
typedef union SQC_DCACHE_UTCL1_STATUS                            regSQC_DCACHE_UTCL1_STATUS;
typedef union SQC_DSM_CNTL                                       regSQC_DSM_CNTL;
typedef union SQC_DSM_CNTL2                                      regSQC_DSM_CNTL2;
typedef union SQC_DSM_CNTL2A                                     regSQC_DSM_CNTL2A;
typedef union SQC_DSM_CNTL2B                                     regSQC_DSM_CNTL2B;
typedef union SQC_DSM_CNTLA                                      regSQC_DSM_CNTLA;
typedef union SQC_DSM_CNTLB                                      regSQC_DSM_CNTLB;
typedef union SQC_EDC_CNT                                        regSQC_EDC_CNT;
typedef union SQC_EDC_CNT2                                       regSQC_EDC_CNT2;
typedef union SQC_EDC_CNT3                                       regSQC_EDC_CNT3;
typedef union SQC_EDC_FUE_CNTL                                   regSQC_EDC_FUE_CNTL;
typedef union SQC_ICACHE_UTCL0_CNTL1                             regSQC_ICACHE_UTCL0_CNTL1;
typedef union SQC_ICACHE_UTCL0_CNTL2                             regSQC_ICACHE_UTCL0_CNTL2;
typedef union SQC_ICACHE_UTCL0_STATUS                            regSQC_ICACHE_UTCL0_STATUS;
typedef union SQC_ICACHE_UTCL1_CNTL1                             regSQC_ICACHE_UTCL1_CNTL1;
typedef union SQC_ICACHE_UTCL1_CNTL2                             regSQC_ICACHE_UTCL1_CNTL2;
typedef union SQC_ICACHE_UTCL1_STATUS                            regSQC_ICACHE_UTCL1_STATUS;
typedef union SQC_MISC_CONFIG                                    regSQC_MISC_CONFIG;
typedef union SQC_WRITEBACK                                      regSQC_WRITEBACK;
typedef union SQG_CONFIG                                         regSQG_CONFIG;
typedef union SQG_STATUS                                         regSQG_STATUS;
typedef union SQG_UTCL0_CNTL1                                    regSQG_UTCL0_CNTL1;
typedef union SQG_UTCL0_CNTL2                                    regSQG_UTCL0_CNTL2;
typedef union SQG_UTCL0_STATUS                                   regSQG_UTCL0_STATUS;
typedef union SQ_ALU_CLK_CTRL                                    regSQ_ALU_CLK_CTRL;
typedef union SQ_ARB_CONFIG                                      regSQ_ARB_CONFIG;
typedef union SQ_BUF_RSRC_WORD0                                  regSQ_BUF_RSRC_WORD0;
typedef union SQ_BUF_RSRC_WORD1                                  regSQ_BUF_RSRC_WORD1;
typedef union SQ_BUF_RSRC_WORD2                                  regSQ_BUF_RSRC_WORD2;
typedef union SQ_BUF_RSRC_WORD3                                  regSQ_BUF_RSRC_WORD3;
typedef union SQ_CMD                                             regSQ_CMD;
typedef union SQ_CMD_TIMESTAMP                                   regSQ_CMD_TIMESTAMP;
typedef union SQ_CONFIG                                          regSQ_CONFIG;
typedef union SQ_DEBUG_CTRL_LOCAL                                regSQ_DEBUG_CTRL_LOCAL;
typedef union SQ_DEBUG_STS_GLOBAL                                regSQ_DEBUG_STS_GLOBAL;
typedef union SQ_DEBUG_STS_LOCAL                                 regSQ_DEBUG_STS_LOCAL;
typedef union SQ_DSM_CNTL                                        regSQ_DSM_CNTL;
typedef union SQ_DSM_CNTL2                                       regSQ_DSM_CNTL2;
typedef union SQ_DS_0                                            regSQ_DS_0;
typedef union SQ_DS_1                                            regSQ_DS_1;
typedef union SQ_EDC_CNT                                         regSQ_EDC_CNT;
typedef union SQ_EDC_DED_CNT                                     regSQ_EDC_DED_CNT;
typedef union SQ_EDC_FUE_CNTL                                    regSQ_EDC_FUE_CNTL;
typedef union SQ_EDC_INFO                                        regSQ_EDC_INFO;
typedef union SQ_EDC_SEC_CNT                                     regSQ_EDC_SEC_CNT;
typedef union SQ_EXP_0                                           regSQ_EXP_0;
typedef union SQ_EXP_1                                           regSQ_EXP_1;
typedef union SQ_FIFO_SIZES                                      regSQ_FIFO_SIZES;
typedef union SQ_FLAT_0                                          regSQ_FLAT_0;
typedef union SQ_FLAT_1                                          regSQ_FLAT_1;
typedef union SQ_FLAT_SCRATCH_WORD0                              regSQ_FLAT_SCRATCH_WORD0;
typedef union SQ_FLAT_SCRATCH_WORD1                              regSQ_FLAT_SCRATCH_WORD1;
typedef union SQ_GLBL_0                                          regSQ_GLBL_0;
typedef union SQ_GLBL_1                                          regSQ_GLBL_1;
typedef union SQ_IMG_RSRC_WORD0                                  regSQ_IMG_RSRC_WORD0;
typedef union SQ_IMG_RSRC_WORD1                                  regSQ_IMG_RSRC_WORD1;
typedef union SQ_IMG_RSRC_WORD2                                  regSQ_IMG_RSRC_WORD2;
typedef union SQ_IMG_RSRC_WORD3                                  regSQ_IMG_RSRC_WORD3;
typedef union SQ_IMG_RSRC_WORD4                                  regSQ_IMG_RSRC_WORD4;
typedef union SQ_IMG_RSRC_WORD5                                  regSQ_IMG_RSRC_WORD5;
typedef union SQ_IMG_RSRC_WORD6                                  regSQ_IMG_RSRC_WORD6;
typedef union SQ_IMG_RSRC_WORD7                                  regSQ_IMG_RSRC_WORD7;
typedef union SQ_IMG_SAMP_WORD0                                  regSQ_IMG_SAMP_WORD0;
typedef union SQ_IMG_SAMP_WORD1                                  regSQ_IMG_SAMP_WORD1;
typedef union SQ_IMG_SAMP_WORD2                                  regSQ_IMG_SAMP_WORD2;
typedef union SQ_IMG_SAMP_WORD3                                  regSQ_IMG_SAMP_WORD3;
typedef union SQ_IND_DATA                                        regSQ_IND_DATA;
typedef union SQ_IND_INDEX                                       regSQ_IND_INDEX;
typedef union SQ_INST                                            regSQ_INST;
typedef union SQ_INTERRUPT_AUTO_MASK                             regSQ_INTERRUPT_AUTO_MASK;
typedef union SQ_INTERRUPT_MSG_CTRL                              regSQ_INTERRUPT_MSG_CTRL;
typedef union SQ_INTERRUPT_WORD_AUTO_CTXID                       regSQ_INTERRUPT_WORD_AUTO_CTXID;
typedef union SQ_INTERRUPT_WORD_AUTO_HI                          regSQ_INTERRUPT_WORD_AUTO_HI;
typedef union SQ_INTERRUPT_WORD_AUTO_LO                          regSQ_INTERRUPT_WORD_AUTO_LO;
typedef union SQ_INTERRUPT_WORD_CMN_CTXID                        regSQ_INTERRUPT_WORD_CMN_CTXID;
typedef union SQ_INTERRUPT_WORD_CMN_HI                           regSQ_INTERRUPT_WORD_CMN_HI;
typedef union SQ_INTERRUPT_WORD_WAVE_CTXID                       regSQ_INTERRUPT_WORD_WAVE_CTXID;
typedef union SQ_INTERRUPT_WORD_WAVE_HI                          regSQ_INTERRUPT_WORD_WAVE_HI;
typedef union SQ_INTERRUPT_WORD_WAVE_LO                          regSQ_INTERRUPT_WORD_WAVE_LO;
typedef union SQ_LB_CTR0_CU                                      regSQ_LB_CTR0_CU;
typedef union SQ_LB_CTR1_CU                                      regSQ_LB_CTR1_CU;
typedef union SQ_LB_CTR2_CU                                      regSQ_LB_CTR2_CU;
typedef union SQ_LB_CTR3_CU                                      regSQ_LB_CTR3_CU;
typedef union SQ_LB_CTR_CTRL                                     regSQ_LB_CTR_CTRL;
typedef union SQ_LB_CTR_SEL                                      regSQ_LB_CTR_SEL;
typedef union SQ_LB_CTR_SEL0                                     regSQ_LB_CTR_SEL0;
typedef union SQ_LB_CTR_SEL1                                     regSQ_LB_CTR_SEL1;
typedef union SQ_LB_DATA0                                        regSQ_LB_DATA0;
typedef union SQ_LB_DATA1                                        regSQ_LB_DATA1;
typedef union SQ_LB_DATA2                                        regSQ_LB_DATA2;
typedef union SQ_LB_DATA3                                        regSQ_LB_DATA3;
typedef union SQ_LDS_CLK_CTRL                                    regSQ_LDS_CLK_CTRL;
typedef union SQ_M0_GPR_IDX_WORD                                 regSQ_M0_GPR_IDX_WORD;
typedef union SQ_MIMG_0                                          regSQ_MIMG_0;
typedef union SQ_MIMG_1                                          regSQ_MIMG_1;
typedef union SQ_MTBUF_0                                         regSQ_MTBUF_0;
typedef union SQ_MTBUF_1                                         regSQ_MTBUF_1;
typedef union SQ_MUBUF_0                                         regSQ_MUBUF_0;
typedef union SQ_MUBUF_1                                         regSQ_MUBUF_1;
typedef union SQ_PERFCOUNTER0_HI                                 regSQ_PERFCOUNTER0_HI;
typedef union SQ_PERFCOUNTER0_LO                                 regSQ_PERFCOUNTER0_LO;
typedef union SQ_PERFCOUNTER0_SELECT                             regSQ_PERFCOUNTER0_SELECT;
typedef union SQ_PERFCOUNTER1_HI                                 regSQ_PERFCOUNTER1_HI;
typedef union SQ_PERFCOUNTER1_LO                                 regSQ_PERFCOUNTER1_LO;
typedef union SQ_PERFCOUNTER1_SELECT                             regSQ_PERFCOUNTER1_SELECT;
typedef union SQ_PERFCOUNTER2_HI                                 regSQ_PERFCOUNTER2_HI;
typedef union SQ_PERFCOUNTER2_LO                                 regSQ_PERFCOUNTER2_LO;
typedef union SQ_PERFCOUNTER2_SELECT                             regSQ_PERFCOUNTER2_SELECT;
typedef union SQ_PERFCOUNTER3_HI                                 regSQ_PERFCOUNTER3_HI;
typedef union SQ_PERFCOUNTER3_LO                                 regSQ_PERFCOUNTER3_LO;
typedef union SQ_PERFCOUNTER3_SELECT                             regSQ_PERFCOUNTER3_SELECT;
typedef union SQ_PERFCOUNTER4_HI                                 regSQ_PERFCOUNTER4_HI;
typedef union SQ_PERFCOUNTER4_LO                                 regSQ_PERFCOUNTER4_LO;
typedef union SQ_PERFCOUNTER4_SELECT                             regSQ_PERFCOUNTER4_SELECT;
typedef union SQ_PERFCOUNTER5_HI                                 regSQ_PERFCOUNTER5_HI;
typedef union SQ_PERFCOUNTER5_LO                                 regSQ_PERFCOUNTER5_LO;
typedef union SQ_PERFCOUNTER5_SELECT                             regSQ_PERFCOUNTER5_SELECT;
typedef union SQ_PERFCOUNTER6_HI                                 regSQ_PERFCOUNTER6_HI;
typedef union SQ_PERFCOUNTER6_LO                                 regSQ_PERFCOUNTER6_LO;
typedef union SQ_PERFCOUNTER6_SELECT                             regSQ_PERFCOUNTER6_SELECT;
typedef union SQ_PERFCOUNTER7_HI                                 regSQ_PERFCOUNTER7_HI;
typedef union SQ_PERFCOUNTER7_LO                                 regSQ_PERFCOUNTER7_LO;
typedef union SQ_PERFCOUNTER7_SELECT                             regSQ_PERFCOUNTER7_SELECT;
typedef union SQ_PERFCOUNTER8_HI                                 regSQ_PERFCOUNTER8_HI;
typedef union SQ_PERFCOUNTER8_LO                                 regSQ_PERFCOUNTER8_LO;
typedef union SQ_PERFCOUNTER8_SELECT                             regSQ_PERFCOUNTER8_SELECT;
typedef union SQ_PERFCOUNTER9_HI                                 regSQ_PERFCOUNTER9_HI;
typedef union SQ_PERFCOUNTER9_LO                                 regSQ_PERFCOUNTER9_LO;
typedef union SQ_PERFCOUNTER9_SELECT                             regSQ_PERFCOUNTER9_SELECT;
typedef union SQ_PERFCOUNTER10_HI                                regSQ_PERFCOUNTER10_HI;
typedef union SQ_PERFCOUNTER10_LO                                regSQ_PERFCOUNTER10_LO;
typedef union SQ_PERFCOUNTER10_SELECT                            regSQ_PERFCOUNTER10_SELECT;
typedef union SQ_PERFCOUNTER11_HI                                regSQ_PERFCOUNTER11_HI;
typedef union SQ_PERFCOUNTER11_LO                                regSQ_PERFCOUNTER11_LO;
typedef union SQ_PERFCOUNTER11_SELECT                            regSQ_PERFCOUNTER11_SELECT;
typedef union SQ_PERFCOUNTER12_HI                                regSQ_PERFCOUNTER12_HI;
typedef union SQ_PERFCOUNTER12_LO                                regSQ_PERFCOUNTER12_LO;
typedef union SQ_PERFCOUNTER12_SELECT                            regSQ_PERFCOUNTER12_SELECT;
typedef union SQ_PERFCOUNTER13_HI                                regSQ_PERFCOUNTER13_HI;
typedef union SQ_PERFCOUNTER13_LO                                regSQ_PERFCOUNTER13_LO;
typedef union SQ_PERFCOUNTER13_SELECT                            regSQ_PERFCOUNTER13_SELECT;
typedef union SQ_PERFCOUNTER14_HI                                regSQ_PERFCOUNTER14_HI;
typedef union SQ_PERFCOUNTER14_LO                                regSQ_PERFCOUNTER14_LO;
typedef union SQ_PERFCOUNTER14_SELECT                            regSQ_PERFCOUNTER14_SELECT;
typedef union SQ_PERFCOUNTER15_HI                                regSQ_PERFCOUNTER15_HI;
typedef union SQ_PERFCOUNTER15_LO                                regSQ_PERFCOUNTER15_LO;
typedef union SQ_PERFCOUNTER15_SELECT                            regSQ_PERFCOUNTER15_SELECT;
typedef union SQ_PERFCOUNTER_CTRL                                regSQ_PERFCOUNTER_CTRL;
typedef union SQ_PERFCOUNTER_CTRL2                               regSQ_PERFCOUNTER_CTRL2;
typedef union SQ_PERFCOUNTER_MASK                                regSQ_PERFCOUNTER_MASK;
typedef union SQ_POWER_THROTTLE                                  regSQ_POWER_THROTTLE;
typedef union SQ_POWER_THROTTLE2                                 regSQ_POWER_THROTTLE2;
typedef union SQ_RANDOM_WAVE_PRI                                 regSQ_RANDOM_WAVE_PRI;
typedef union SQ_REG_CREDITS                                     regSQ_REG_CREDITS;
typedef union SQ_REG_TIMESTAMP                                   regSQ_REG_TIMESTAMP;
typedef union SQ_RUNTIME_CONFIG                                  regSQ_RUNTIME_CONFIG;
typedef union SQ_SCRATCH_0                                       regSQ_SCRATCH_0;
typedef union SQ_SCRATCH_1                                       regSQ_SCRATCH_1;
typedef union SQ_SHADER_TBA_HI                                   regSQ_SHADER_TBA_HI;
typedef union SQ_SHADER_TBA_LO                                   regSQ_SHADER_TBA_LO;
typedef union SQ_SHADER_TMA_HI                                   regSQ_SHADER_TMA_HI;
typedef union SQ_SHADER_TMA_LO                                   regSQ_SHADER_TMA_LO;
typedef union SQ_SMEM_0                                          regSQ_SMEM_0;
typedef union SQ_SMEM_1                                          regSQ_SMEM_1;
typedef union SQ_SOP1                                            regSQ_SOP1;
typedef union SQ_SOP2                                            regSQ_SOP2;
typedef union SQ_SOPC                                            regSQ_SOPC;
typedef union SQ_SOPK                                            regSQ_SOPK;
typedef union SQ_SOPP                                            regSQ_SOPP;
typedef union SQ_TEX_CLK_CTRL                                    regSQ_TEX_CLK_CTRL;
typedef union SQ_THREAD_TRACE_BASE                               regSQ_THREAD_TRACE_BASE;
typedef union SQ_THREAD_TRACE_BASE2                              regSQ_THREAD_TRACE_BASE2;
typedef union SQ_THREAD_TRACE_BUF0_BASE                          regSQ_THREAD_TRACE_BUF0_BASE;
typedef union SQ_THREAD_TRACE_BUF0_SIZE                          regSQ_THREAD_TRACE_BUF0_SIZE;
typedef union SQ_THREAD_TRACE_BUF1_BASE                          regSQ_THREAD_TRACE_BUF1_BASE;
typedef union SQ_THREAD_TRACE_BUF1_SIZE                          regSQ_THREAD_TRACE_BUF1_SIZE;
typedef union SQ_THREAD_TRACE_CNTR                               regSQ_THREAD_TRACE_CNTR;
typedef union SQ_THREAD_TRACE_CTRL                               regSQ_THREAD_TRACE_CTRL;
typedef union SQ_THREAD_TRACE_DROPPED_CNTR                       regSQ_THREAD_TRACE_DROPPED_CNTR;
typedef union SQ_THREAD_TRACE_FINISH_DONE_DEBUG                  regSQ_THREAD_TRACE_FINISH_DONE_DEBUG;
typedef union SQ_THREAD_TRACE_GFX_DRAW_CNTR                      regSQ_THREAD_TRACE_GFX_DRAW_CNTR;
typedef union SQ_THREAD_TRACE_GFX_MARKER_CNTR                    regSQ_THREAD_TRACE_GFX_MARKER_CNTR;
typedef union SQ_THREAD_TRACE_HIWATER                            regSQ_THREAD_TRACE_HIWATER;
typedef union SQ_THREAD_TRACE_HP3D_DRAW_CNTR                     regSQ_THREAD_TRACE_HP3D_DRAW_CNTR;
typedef union SQ_THREAD_TRACE_HP3D_MARKER_CNTR                   regSQ_THREAD_TRACE_HP3D_MARKER_CNTR;
typedef union SQ_THREAD_TRACE_MASK                               regSQ_THREAD_TRACE_MASK;
typedef union SQ_THREAD_TRACE_MODE                               regSQ_THREAD_TRACE_MODE;
typedef union SQ_THREAD_TRACE_PERF_MASK                          regSQ_THREAD_TRACE_PERF_MASK;
typedef union SQ_THREAD_TRACE_SIZE                               regSQ_THREAD_TRACE_SIZE;
typedef union SQ_THREAD_TRACE_STATUS                             regSQ_THREAD_TRACE_STATUS;
typedef union SQ_THREAD_TRACE_TOKEN_MASK                         regSQ_THREAD_TRACE_TOKEN_MASK;
typedef union SQ_THREAD_TRACE_TOKEN_MASK2                        regSQ_THREAD_TRACE_TOKEN_MASK2;
typedef union SQ_THREAD_TRACE_USERDATA_0                         regSQ_THREAD_TRACE_USERDATA_0;
typedef union SQ_THREAD_TRACE_USERDATA_1                         regSQ_THREAD_TRACE_USERDATA_1;
typedef union SQ_THREAD_TRACE_USERDATA_2                         regSQ_THREAD_TRACE_USERDATA_2;
typedef union SQ_THREAD_TRACE_USERDATA_3                         regSQ_THREAD_TRACE_USERDATA_3;
typedef union SQ_THREAD_TRACE_USERDATA_4                         regSQ_THREAD_TRACE_USERDATA_4;
typedef union SQ_THREAD_TRACE_USERDATA_5                         regSQ_THREAD_TRACE_USERDATA_5;
typedef union SQ_THREAD_TRACE_USERDATA_6                         regSQ_THREAD_TRACE_USERDATA_6;
typedef union SQ_THREAD_TRACE_USERDATA_7                         regSQ_THREAD_TRACE_USERDATA_7;
typedef union SQ_THREAD_TRACE_WORD_CMN                           regSQ_THREAD_TRACE_WORD_CMN;
typedef union SQ_THREAD_TRACE_WORD_EVENT                         regSQ_THREAD_TRACE_WORD_EVENT;
typedef union SQ_THREAD_TRACE_WORD_INST                          regSQ_THREAD_TRACE_WORD_INST;
typedef union SQ_THREAD_TRACE_WORD_INST_PC_1_OF_2                regSQ_THREAD_TRACE_WORD_INST_PC_1_OF_2;
typedef union SQ_THREAD_TRACE_WORD_INST_PC_2_OF_2                regSQ_THREAD_TRACE_WORD_INST_PC_2_OF_2;
typedef union SQ_THREAD_TRACE_WORD_INST_USERDATA_1_OF_2          regSQ_THREAD_TRACE_WORD_INST_USERDATA_1_OF_2;
typedef union SQ_THREAD_TRACE_WORD_INST_USERDATA_2_OF_2          regSQ_THREAD_TRACE_WORD_INST_USERDATA_2_OF_2;
typedef union SQ_THREAD_TRACE_WORD_ISSUE                         regSQ_THREAD_TRACE_WORD_ISSUE;
typedef union SQ_THREAD_TRACE_WORD_MISC                          regSQ_THREAD_TRACE_WORD_MISC;
typedef union SQ_THREAD_TRACE_WORD_PERF_1_OF_2                   regSQ_THREAD_TRACE_WORD_PERF_1_OF_2;
typedef union SQ_THREAD_TRACE_WORD_PERF_2_OF_2                   regSQ_THREAD_TRACE_WORD_PERF_2_OF_2;
typedef union SQ_THREAD_TRACE_WORD_REG_1_OF_2                    regSQ_THREAD_TRACE_WORD_REG_1_OF_2;
typedef union SQ_THREAD_TRACE_WORD_REG_2_OF_2                    regSQ_THREAD_TRACE_WORD_REG_2_OF_2;
typedef union SQ_THREAD_TRACE_WORD_REG_CS_1_OF_2                 regSQ_THREAD_TRACE_WORD_REG_CS_1_OF_2;
typedef union SQ_THREAD_TRACE_WORD_REG_CS_2_OF_2                 regSQ_THREAD_TRACE_WORD_REG_CS_2_OF_2;
typedef union SQ_THREAD_TRACE_WORD_TIMESTAMP_1_OF_2              regSQ_THREAD_TRACE_WORD_TIMESTAMP_1_OF_2;
typedef union SQ_THREAD_TRACE_WORD_TIMESTAMP_2_OF_2              regSQ_THREAD_TRACE_WORD_TIMESTAMP_2_OF_2;
typedef union SQ_THREAD_TRACE_WORD_WAVE                          regSQ_THREAD_TRACE_WORD_WAVE;
typedef union SQ_THREAD_TRACE_WORD_WAVE_START                    regSQ_THREAD_TRACE_WORD_WAVE_START;
typedef union SQ_THREAD_TRACE_WPTR                               regSQ_THREAD_TRACE_WPTR;
typedef union SQ_TIME_HI                                         regSQ_TIME_HI;
typedef union SQ_TIME_LO                                         regSQ_TIME_LO;
typedef union SQ_UTCL1_CNTL1                                     regSQ_UTCL1_CNTL1;
typedef union SQ_UTCL1_CNTL2                                     regSQ_UTCL1_CNTL2;
typedef union SQ_UTCL1_STATUS                                    regSQ_UTCL1_STATUS;
typedef union SQ_VINTRP                                          regSQ_VINTRP;
typedef union SQ_VOP1                                            regSQ_VOP1;
typedef union SQ_VOP2                                            regSQ_VOP2;
typedef union SQ_VOP3P_0                                         regSQ_VOP3P_0;
typedef union SQ_VOP3P_1                                         regSQ_VOP3P_1;
typedef union SQ_VOP3_0                                          regSQ_VOP3_0;
typedef union SQ_VOP3_0_SDST_ENC                                 regSQ_VOP3_0_SDST_ENC;
typedef union SQ_VOP3_1                                          regSQ_VOP3_1;
typedef union SQ_VOPC                                            regSQ_VOPC;
typedef union SQ_VOP_DPP                                         regSQ_VOP_DPP;
typedef union SQ_VOP_SDWA                                        regSQ_VOP_SDWA;
typedef union SQ_VOP_SDWA_SDST_ENC                               regSQ_VOP_SDWA_SDST_ENC;
typedef union SQ_WATCH0_ADDR_H                                   regSQ_WATCH0_ADDR_H;
typedef union SQ_WATCH0_ADDR_L                                   regSQ_WATCH0_ADDR_L;
typedef union SQ_WATCH0_CNTL                                     regSQ_WATCH0_CNTL;
typedef union SQ_WATCH1_ADDR_H                                   regSQ_WATCH1_ADDR_H;
typedef union SQ_WATCH1_ADDR_L                                   regSQ_WATCH1_ADDR_L;
typedef union SQ_WATCH1_CNTL                                     regSQ_WATCH1_CNTL;
typedef union SQ_WATCH2_ADDR_H                                   regSQ_WATCH2_ADDR_H;
typedef union SQ_WATCH2_ADDR_L                                   regSQ_WATCH2_ADDR_L;
typedef union SQ_WATCH2_CNTL                                     regSQ_WATCH2_CNTL;
typedef union SQ_WATCH3_ADDR_H                                   regSQ_WATCH3_ADDR_H;
typedef union SQ_WATCH3_ADDR_L                                   regSQ_WATCH3_ADDR_L;
typedef union SQ_WATCH3_CNTL                                     regSQ_WATCH3_CNTL;
typedef union SQ_WREXEC_EXEC_HI                                  regSQ_WREXEC_EXEC_HI;
typedef union SQ_WREXEC_EXEC_LO                                  regSQ_WREXEC_EXEC_LO;
typedef union SX_BLEND_OPT_CONTROL                               regSX_BLEND_OPT_CONTROL;
typedef union SX_BLEND_OPT_EPSILON                               regSX_BLEND_OPT_EPSILON;
typedef union SX_DEBUG_1                                         regSX_DEBUG_1;
typedef union SX_MRT0_BLEND_OPT                                  regSX_MRT0_BLEND_OPT;
typedef union SX_MRT1_BLEND_OPT                                  regSX_MRT1_BLEND_OPT;
typedef union SX_MRT2_BLEND_OPT                                  regSX_MRT2_BLEND_OPT;
typedef union SX_MRT3_BLEND_OPT                                  regSX_MRT3_BLEND_OPT;
typedef union SX_MRT4_BLEND_OPT                                  regSX_MRT4_BLEND_OPT;
typedef union SX_MRT5_BLEND_OPT                                  regSX_MRT5_BLEND_OPT;
typedef union SX_MRT6_BLEND_OPT                                  regSX_MRT6_BLEND_OPT;
typedef union SX_MRT7_BLEND_OPT                                  regSX_MRT7_BLEND_OPT;
typedef union SX_PERFCOUNTER0_HI                                 regSX_PERFCOUNTER0_HI;
typedef union SX_PERFCOUNTER0_LO                                 regSX_PERFCOUNTER0_LO;
typedef union SX_PERFCOUNTER0_SELECT                             regSX_PERFCOUNTER0_SELECT;
typedef union SX_PERFCOUNTER0_SELECT1                            regSX_PERFCOUNTER0_SELECT1;
typedef union SX_PERFCOUNTER1_HI                                 regSX_PERFCOUNTER1_HI;
typedef union SX_PERFCOUNTER1_LO                                 regSX_PERFCOUNTER1_LO;
typedef union SX_PERFCOUNTER1_SELECT                             regSX_PERFCOUNTER1_SELECT;
typedef union SX_PERFCOUNTER1_SELECT1                            regSX_PERFCOUNTER1_SELECT1;
typedef union SX_PERFCOUNTER2_HI                                 regSX_PERFCOUNTER2_HI;
typedef union SX_PERFCOUNTER2_LO                                 regSX_PERFCOUNTER2_LO;
typedef union SX_PERFCOUNTER2_SELECT                             regSX_PERFCOUNTER2_SELECT;
typedef union SX_PERFCOUNTER3_HI                                 regSX_PERFCOUNTER3_HI;
typedef union SX_PERFCOUNTER3_LO                                 regSX_PERFCOUNTER3_LO;
typedef union SX_PERFCOUNTER3_SELECT                             regSX_PERFCOUNTER3_SELECT;
typedef union SX_PS_DOWNCONVERT                                  regSX_PS_DOWNCONVERT;
typedef union TA_BC_BASE_ADDR                                    regTA_BC_BASE_ADDR;
typedef union TA_BC_BASE_ADDR_HI                                 regTA_BC_BASE_ADDR_HI;
typedef union TA_CGTT_CTRL                                       regTA_CGTT_CTRL;
typedef union TA_CNTL                                            regTA_CNTL;
typedef union TA_CNTL_AUX                                        regTA_CNTL_AUX;
typedef union TA_CS_BC_BASE_ADDR                                 regTA_CS_BC_BASE_ADDR;
typedef union TA_CS_BC_BASE_ADDR_HI                              regTA_CS_BC_BASE_ADDR_HI;
typedef union TA_DEBUG_DATA                                      regTA_DEBUG_DATA;
typedef union TA_DEBUG_INDEX                                     regTA_DEBUG_INDEX;
typedef union TA_DSM_CNTL                                        regTA_DSM_CNTL;
typedef union TA_DSM_CNTL2                                       regTA_DSM_CNTL2;
typedef union TA_EDC_CNT                                         regTA_EDC_CNT;
typedef union TA_PERFCOUNTER0_HI                                 regTA_PERFCOUNTER0_HI;
typedef union TA_PERFCOUNTER0_LO                                 regTA_PERFCOUNTER0_LO;
typedef union TA_PERFCOUNTER0_SELECT                             regTA_PERFCOUNTER0_SELECT;
typedef union TA_PERFCOUNTER0_SELECT1                            regTA_PERFCOUNTER0_SELECT1;
typedef union TA_PERFCOUNTER1_HI                                 regTA_PERFCOUNTER1_HI;
typedef union TA_PERFCOUNTER1_LO                                 regTA_PERFCOUNTER1_LO;
typedef union TA_PERFCOUNTER1_SELECT                             regTA_PERFCOUNTER1_SELECT;
typedef union TA_POWER_CNTL                                      regTA_POWER_CNTL;
typedef union TA_RESERVED_010C                                   regTA_RESERVED_010C;
typedef union TA_SCRATCH                                         regTA_SCRATCH;
typedef union TA_STATUS                                          regTA_STATUS;
typedef union TCA_PERFCOUNTER0_HI                                regTCA_PERFCOUNTER0_HI;
typedef union TCA_PERFCOUNTER0_LO                                regTCA_PERFCOUNTER0_LO;
typedef union TCA_PERFCOUNTER0_SELECT                            regTCA_PERFCOUNTER0_SELECT;
typedef union TCA_PERFCOUNTER0_SELECT1                           regTCA_PERFCOUNTER0_SELECT1;
typedef union TCA_PERFCOUNTER1_HI                                regTCA_PERFCOUNTER1_HI;
typedef union TCA_PERFCOUNTER1_LO                                regTCA_PERFCOUNTER1_LO;
typedef union TCA_PERFCOUNTER1_SELECT                            regTCA_PERFCOUNTER1_SELECT;
typedef union TCA_PERFCOUNTER1_SELECT1                           regTCA_PERFCOUNTER1_SELECT1;
typedef union TCA_PERFCOUNTER2_HI                                regTCA_PERFCOUNTER2_HI;
typedef union TCA_PERFCOUNTER2_LO                                regTCA_PERFCOUNTER2_LO;
typedef union TCA_PERFCOUNTER2_SELECT                            regTCA_PERFCOUNTER2_SELECT;
typedef union TCA_PERFCOUNTER3_HI                                regTCA_PERFCOUNTER3_HI;
typedef union TCA_PERFCOUNTER3_LO                                regTCA_PERFCOUNTER3_LO;
typedef union TCA_PERFCOUNTER3_SELECT                            regTCA_PERFCOUNTER3_SELECT;
typedef union TCC_PERFCOUNTER0_HI                                regTCC_PERFCOUNTER0_HI;
typedef union TCC_PERFCOUNTER0_LO                                regTCC_PERFCOUNTER0_LO;
typedef union TCC_PERFCOUNTER0_SELECT                            regTCC_PERFCOUNTER0_SELECT;
typedef union TCC_PERFCOUNTER0_SELECT1                           regTCC_PERFCOUNTER0_SELECT1;
typedef union TCC_PERFCOUNTER1_HI                                regTCC_PERFCOUNTER1_HI;
typedef union TCC_PERFCOUNTER1_LO                                regTCC_PERFCOUNTER1_LO;
typedef union TCC_PERFCOUNTER1_SELECT                            regTCC_PERFCOUNTER1_SELECT;
typedef union TCC_PERFCOUNTER1_SELECT1                           regTCC_PERFCOUNTER1_SELECT1;
typedef union TCC_PERFCOUNTER2_HI                                regTCC_PERFCOUNTER2_HI;
typedef union TCC_PERFCOUNTER2_LO                                regTCC_PERFCOUNTER2_LO;
typedef union TCC_PERFCOUNTER2_SELECT                            regTCC_PERFCOUNTER2_SELECT;
typedef union TCC_PERFCOUNTER3_HI                                regTCC_PERFCOUNTER3_HI;
typedef union TCC_PERFCOUNTER3_LO                                regTCC_PERFCOUNTER3_LO;
typedef union TCC_PERFCOUNTER3_SELECT                            regTCC_PERFCOUNTER3_SELECT;
typedef union TCI_CNTL_1                                         regTCI_CNTL_1;
typedef union TCI_CNTL_2                                         regTCI_CNTL_2;
typedef union TCI_DSM_CNTL                                       regTCI_DSM_CNTL;
typedef union TCI_DSM_CNTL2                                      regTCI_DSM_CNTL2;
typedef union TCI_EDC_CNT                                        regTCI_EDC_CNT;
typedef union TCI_STATUS                                         regTCI_STATUS;
typedef union TCP_PERFCOUNTER0_HI                                regTCP_PERFCOUNTER0_HI;
typedef union TCP_PERFCOUNTER0_LO                                regTCP_PERFCOUNTER0_LO;
typedef union TCP_PERFCOUNTER0_SELECT                            regTCP_PERFCOUNTER0_SELECT;
typedef union TCP_PERFCOUNTER0_SELECT1                           regTCP_PERFCOUNTER0_SELECT1;
typedef union TCP_PERFCOUNTER1_HI                                regTCP_PERFCOUNTER1_HI;
typedef union TCP_PERFCOUNTER1_LO                                regTCP_PERFCOUNTER1_LO;
typedef union TCP_PERFCOUNTER1_SELECT                            regTCP_PERFCOUNTER1_SELECT;
typedef union TCP_PERFCOUNTER1_SELECT1                           regTCP_PERFCOUNTER1_SELECT1;
typedef union TCP_PERFCOUNTER2_HI                                regTCP_PERFCOUNTER2_HI;
typedef union TCP_PERFCOUNTER2_LO                                regTCP_PERFCOUNTER2_LO;
typedef union TCP_PERFCOUNTER2_SELECT                            regTCP_PERFCOUNTER2_SELECT;
typedef union TCP_PERFCOUNTER3_HI                                regTCP_PERFCOUNTER3_HI;
typedef union TCP_PERFCOUNTER3_LO                                regTCP_PERFCOUNTER3_LO;
typedef union TCP_PERFCOUNTER3_SELECT                            regTCP_PERFCOUNTER3_SELECT;
typedef union TCP_PERFCOUNTER_FILTER                             regTCP_PERFCOUNTER_FILTER;
typedef union TCP_PERFCOUNTER_FILTER2                            regTCP_PERFCOUNTER_FILTER2;
typedef union TCP_PERFCOUNTER_FILTER_EN                          regTCP_PERFCOUNTER_FILTER_EN;
typedef union TC_CFG_L1_LOAD_POLICY0                             regTC_CFG_L1_LOAD_POLICY0;
typedef union TC_CFG_L1_LOAD_POLICY1                             regTC_CFG_L1_LOAD_POLICY1;
typedef union TC_CFG_L1_STORE_POLICY                             regTC_CFG_L1_STORE_POLICY;
typedef union TC_CFG_L1_VOLATILE                                 regTC_CFG_L1_VOLATILE;
typedef union TC_CFG_L2_ATOMIC_POLICY                            regTC_CFG_L2_ATOMIC_POLICY;
typedef union TC_CFG_L2_LOAD_POLICY0                             regTC_CFG_L2_LOAD_POLICY0;
typedef union TC_CFG_L2_LOAD_POLICY1                             regTC_CFG_L2_LOAD_POLICY1;
typedef union TC_CFG_L2_STORE_POLICY0                            regTC_CFG_L2_STORE_POLICY0;
typedef union TC_CFG_L2_STORE_POLICY1                            regTC_CFG_L2_STORE_POLICY1;
typedef union TC_CFG_L2_VOLATILE                                 regTC_CFG_L2_VOLATILE;
typedef union TD_CGTT_CTRL                                       regTD_CGTT_CTRL;
typedef union TD_CNTL                                            regTD_CNTL;
typedef union TD_DEBUG_DATA                                      regTD_DEBUG_DATA;
typedef union TD_DEBUG_INDEX                                     regTD_DEBUG_INDEX;
typedef union TD_DSM_CNTL                                        regTD_DSM_CNTL;
typedef union TD_DSM_CNTL2                                       regTD_DSM_CNTL2;
typedef union TD_EDC_CNT                                         regTD_EDC_CNT;
typedef union TD_PERFCOUNTER0_HI                                 regTD_PERFCOUNTER0_HI;
typedef union TD_PERFCOUNTER0_LO                                 regTD_PERFCOUNTER0_LO;
typedef union TD_PERFCOUNTER0_SELECT                             regTD_PERFCOUNTER0_SELECT;
typedef union TD_PERFCOUNTER0_SELECT1                            regTD_PERFCOUNTER0_SELECT1;
typedef union TD_PERFCOUNTER1_HI                                 regTD_PERFCOUNTER1_HI;
typedef union TD_PERFCOUNTER1_LO                                 regTD_PERFCOUNTER1_LO;
typedef union TD_PERFCOUNTER1_SELECT                             regTD_PERFCOUNTER1_SELECT;
typedef union TD_POWER_CNTL                                      regTD_POWER_CNTL;
typedef union TD_SCRATCH                                         regTD_SCRATCH;
typedef union TD_STATUS                                          regTD_STATUS;
typedef union UMCCH0_PerfMonCtl1                                 regUMCCH0_PerfMonCtl1;
typedef union UMCCH0_PerfMonCtl2                                 regUMCCH0_PerfMonCtl2;
typedef union UMCCH0_PerfMonCtl3                                 regUMCCH0_PerfMonCtl3;
typedef union UMCCH0_PerfMonCtl4                                 regUMCCH0_PerfMonCtl4;
typedef union UMCCH0_PerfMonCtl5                                 regUMCCH0_PerfMonCtl5;
typedef union UMCCH0_PerfMonCtlClk                               regUMCCH0_PerfMonCtlClk;
typedef union UMCCH0_PerfMonCtr1_Hi                              regUMCCH0_PerfMonCtr1_Hi;
typedef union UMCCH0_PerfMonCtr1_Lo                              regUMCCH0_PerfMonCtr1_Lo;
typedef union UMCCH0_PerfMonCtr2_Hi                              regUMCCH0_PerfMonCtr2_Hi;
typedef union UMCCH0_PerfMonCtr2_Lo                              regUMCCH0_PerfMonCtr2_Lo;
typedef union UMCCH0_PerfMonCtr3_Hi                              regUMCCH0_PerfMonCtr3_Hi;
typedef union UMCCH0_PerfMonCtr3_Lo                              regUMCCH0_PerfMonCtr3_Lo;
typedef union UMCCH0_PerfMonCtr4_Hi                              regUMCCH0_PerfMonCtr4_Hi;
typedef union UMCCH0_PerfMonCtr4_Lo                              regUMCCH0_PerfMonCtr4_Lo;
typedef union UMCCH0_PerfMonCtr5_Hi                              regUMCCH0_PerfMonCtr5_Hi;
typedef union UMCCH0_PerfMonCtr5_Lo                              regUMCCH0_PerfMonCtr5_Lo;
typedef union UMCCH0_PerfMonCtrClk_Hi                            regUMCCH0_PerfMonCtrClk_Hi;
typedef union UMCCH0_PerfMonCtrClk_Lo                            regUMCCH0_PerfMonCtrClk_Lo;
typedef union UMCCH1_PerfMonCtl1                                 regUMCCH1_PerfMonCtl1;
typedef union UMCCH1_PerfMonCtl2                                 regUMCCH1_PerfMonCtl2;
typedef union UMCCH1_PerfMonCtl3                                 regUMCCH1_PerfMonCtl3;
typedef union UMCCH1_PerfMonCtl4                                 regUMCCH1_PerfMonCtl4;
typedef union UMCCH1_PerfMonCtl5                                 regUMCCH1_PerfMonCtl5;
typedef union UMCCH1_PerfMonCtlClk                               regUMCCH1_PerfMonCtlClk;
typedef union UMCCH1_PerfMonCtr1_Hi                              regUMCCH1_PerfMonCtr1_Hi;
typedef union UMCCH1_PerfMonCtr1_Lo                              regUMCCH1_PerfMonCtr1_Lo;
typedef union UMCCH1_PerfMonCtr2_Hi                              regUMCCH1_PerfMonCtr2_Hi;
typedef union UMCCH1_PerfMonCtr2_Lo                              regUMCCH1_PerfMonCtr2_Lo;
typedef union UMCCH1_PerfMonCtr3_Hi                              regUMCCH1_PerfMonCtr3_Hi;
typedef union UMCCH1_PerfMonCtr3_Lo                              regUMCCH1_PerfMonCtr3_Lo;
typedef union UMCCH1_PerfMonCtr4_Hi                              regUMCCH1_PerfMonCtr4_Hi;
typedef union UMCCH1_PerfMonCtr4_Lo                              regUMCCH1_PerfMonCtr4_Lo;
typedef union UMCCH1_PerfMonCtr5_Hi                              regUMCCH1_PerfMonCtr5_Hi;
typedef union UMCCH1_PerfMonCtr5_Lo                              regUMCCH1_PerfMonCtr5_Lo;
typedef union UMCCH1_PerfMonCtrClk_Hi                            regUMCCH1_PerfMonCtrClk_Hi;
typedef union UMCCH1_PerfMonCtrClk_Lo                            regUMCCH1_PerfMonCtrClk_Lo;
typedef union UMCCH2_PerfMonCtl1                                 regUMCCH2_PerfMonCtl1;
typedef union UMCCH2_PerfMonCtl2                                 regUMCCH2_PerfMonCtl2;
typedef union UMCCH2_PerfMonCtl3                                 regUMCCH2_PerfMonCtl3;
typedef union UMCCH2_PerfMonCtl4                                 regUMCCH2_PerfMonCtl4;
typedef union UMCCH2_PerfMonCtl5                                 regUMCCH2_PerfMonCtl5;
typedef union UMCCH2_PerfMonCtlClk                               regUMCCH2_PerfMonCtlClk;
typedef union UMCCH2_PerfMonCtr1_Hi                              regUMCCH2_PerfMonCtr1_Hi;
typedef union UMCCH2_PerfMonCtr1_Lo                              regUMCCH2_PerfMonCtr1_Lo;
typedef union UMCCH2_PerfMonCtr2_Hi                              regUMCCH2_PerfMonCtr2_Hi;
typedef union UMCCH2_PerfMonCtr2_Lo                              regUMCCH2_PerfMonCtr2_Lo;
typedef union UMCCH2_PerfMonCtr3_Hi                              regUMCCH2_PerfMonCtr3_Hi;
typedef union UMCCH2_PerfMonCtr3_Lo                              regUMCCH2_PerfMonCtr3_Lo;
typedef union UMCCH2_PerfMonCtr4_Hi                              regUMCCH2_PerfMonCtr4_Hi;
typedef union UMCCH2_PerfMonCtr4_Lo                              regUMCCH2_PerfMonCtr4_Lo;
typedef union UMCCH2_PerfMonCtr5_Hi                              regUMCCH2_PerfMonCtr5_Hi;
typedef union UMCCH2_PerfMonCtr5_Lo                              regUMCCH2_PerfMonCtr5_Lo;
typedef union UMCCH2_PerfMonCtrClk_Hi                            regUMCCH2_PerfMonCtrClk_Hi;
typedef union UMCCH2_PerfMonCtrClk_Lo                            regUMCCH2_PerfMonCtrClk_Lo;
typedef union UMCCH3_PerfMonCtl1                                 regUMCCH3_PerfMonCtl1;
typedef union UMCCH3_PerfMonCtl2                                 regUMCCH3_PerfMonCtl2;
typedef union UMCCH3_PerfMonCtl3                                 regUMCCH3_PerfMonCtl3;
typedef union UMCCH3_PerfMonCtl4                                 regUMCCH3_PerfMonCtl4;
typedef union UMCCH3_PerfMonCtl5                                 regUMCCH3_PerfMonCtl5;
typedef union UMCCH3_PerfMonCtlClk                               regUMCCH3_PerfMonCtlClk;
typedef union UMCCH3_PerfMonCtr1_Hi                              regUMCCH3_PerfMonCtr1_Hi;
typedef union UMCCH3_PerfMonCtr1_Lo                              regUMCCH3_PerfMonCtr1_Lo;
typedef union UMCCH3_PerfMonCtr2_Hi                              regUMCCH3_PerfMonCtr2_Hi;
typedef union UMCCH3_PerfMonCtr2_Lo                              regUMCCH3_PerfMonCtr2_Lo;
typedef union UMCCH3_PerfMonCtr3_Hi                              regUMCCH3_PerfMonCtr3_Hi;
typedef union UMCCH3_PerfMonCtr3_Lo                              regUMCCH3_PerfMonCtr3_Lo;
typedef union UMCCH3_PerfMonCtr4_Hi                              regUMCCH3_PerfMonCtr4_Hi;
typedef union UMCCH3_PerfMonCtr4_Lo                              regUMCCH3_PerfMonCtr4_Lo;
typedef union UMCCH3_PerfMonCtr5_Hi                              regUMCCH3_PerfMonCtr5_Hi;
typedef union UMCCH3_PerfMonCtr5_Lo                              regUMCCH3_PerfMonCtr5_Lo;
typedef union UMCCH3_PerfMonCtrClk_Hi                            regUMCCH3_PerfMonCtrClk_Hi;
typedef union UMCCH3_PerfMonCtrClk_Lo                            regUMCCH3_PerfMonCtrClk_Lo;
typedef union UMCCH4_PerfMonCtl1                                 regUMCCH4_PerfMonCtl1;
typedef union UMCCH4_PerfMonCtl2                                 regUMCCH4_PerfMonCtl2;
typedef union UMCCH4_PerfMonCtl3                                 regUMCCH4_PerfMonCtl3;
typedef union UMCCH4_PerfMonCtl4                                 regUMCCH4_PerfMonCtl4;
typedef union UMCCH4_PerfMonCtl5                                 regUMCCH4_PerfMonCtl5;
typedef union UMCCH4_PerfMonCtlClk                               regUMCCH4_PerfMonCtlClk;
typedef union UMCCH4_PerfMonCtr1_Hi                              regUMCCH4_PerfMonCtr1_Hi;
typedef union UMCCH4_PerfMonCtr1_Lo                              regUMCCH4_PerfMonCtr1_Lo;
typedef union UMCCH4_PerfMonCtr2_Hi                              regUMCCH4_PerfMonCtr2_Hi;
typedef union UMCCH4_PerfMonCtr2_Lo                              regUMCCH4_PerfMonCtr2_Lo;
typedef union UMCCH4_PerfMonCtr3_Hi                              regUMCCH4_PerfMonCtr3_Hi;
typedef union UMCCH4_PerfMonCtr3_Lo                              regUMCCH4_PerfMonCtr3_Lo;
typedef union UMCCH4_PerfMonCtr4_Hi                              regUMCCH4_PerfMonCtr4_Hi;
typedef union UMCCH4_PerfMonCtr4_Lo                              regUMCCH4_PerfMonCtr4_Lo;
typedef union UMCCH4_PerfMonCtr5_Hi                              regUMCCH4_PerfMonCtr5_Hi;
typedef union UMCCH4_PerfMonCtr5_Lo                              regUMCCH4_PerfMonCtr5_Lo;
typedef union UMCCH4_PerfMonCtrClk_Hi                            regUMCCH4_PerfMonCtrClk_Hi;
typedef union UMCCH4_PerfMonCtrClk_Lo                            regUMCCH4_PerfMonCtrClk_Lo;
typedef union UMCCH5_PerfMonCtl1                                 regUMCCH5_PerfMonCtl1;
typedef union UMCCH5_PerfMonCtl2                                 regUMCCH5_PerfMonCtl2;
typedef union UMCCH5_PerfMonCtl3                                 regUMCCH5_PerfMonCtl3;
typedef union UMCCH5_PerfMonCtl4                                 regUMCCH5_PerfMonCtl4;
typedef union UMCCH5_PerfMonCtl5                                 regUMCCH5_PerfMonCtl5;
typedef union UMCCH5_PerfMonCtlClk                               regUMCCH5_PerfMonCtlClk;
typedef union UMCCH5_PerfMonCtr1_Hi                              regUMCCH5_PerfMonCtr1_Hi;
typedef union UMCCH5_PerfMonCtr1_Lo                              regUMCCH5_PerfMonCtr1_Lo;
typedef union UMCCH5_PerfMonCtr2_Hi                              regUMCCH5_PerfMonCtr2_Hi;
typedef union UMCCH5_PerfMonCtr2_Lo                              regUMCCH5_PerfMonCtr2_Lo;
typedef union UMCCH5_PerfMonCtr3_Hi                              regUMCCH5_PerfMonCtr3_Hi;
typedef union UMCCH5_PerfMonCtr3_Lo                              regUMCCH5_PerfMonCtr3_Lo;
typedef union UMCCH5_PerfMonCtr4_Hi                              regUMCCH5_PerfMonCtr4_Hi;
typedef union UMCCH5_PerfMonCtr4_Lo                              regUMCCH5_PerfMonCtr4_Lo;
typedef union UMCCH5_PerfMonCtr5_Hi                              regUMCCH5_PerfMonCtr5_Hi;
typedef union UMCCH5_PerfMonCtr5_Lo                              regUMCCH5_PerfMonCtr5_Lo;
typedef union UMCCH5_PerfMonCtrClk_Hi                            regUMCCH5_PerfMonCtrClk_Hi;
typedef union UMCCH5_PerfMonCtrClk_Lo                            regUMCCH5_PerfMonCtrClk_Lo;
typedef union UMCCH6_PerfMonCtl1                                 regUMCCH6_PerfMonCtl1;
typedef union UMCCH6_PerfMonCtl2                                 regUMCCH6_PerfMonCtl2;
typedef union UMCCH6_PerfMonCtl3                                 regUMCCH6_PerfMonCtl3;
typedef union UMCCH6_PerfMonCtl4                                 regUMCCH6_PerfMonCtl4;
typedef union UMCCH6_PerfMonCtl5                                 regUMCCH6_PerfMonCtl5;
typedef union UMCCH6_PerfMonCtlClk                               regUMCCH6_PerfMonCtlClk;
typedef union UMCCH6_PerfMonCtr1_Hi                              regUMCCH6_PerfMonCtr1_Hi;
typedef union UMCCH6_PerfMonCtr1_Lo                              regUMCCH6_PerfMonCtr1_Lo;
typedef union UMCCH6_PerfMonCtr2_Hi                              regUMCCH6_PerfMonCtr2_Hi;
typedef union UMCCH6_PerfMonCtr2_Lo                              regUMCCH6_PerfMonCtr2_Lo;
typedef union UMCCH6_PerfMonCtr3_Hi                              regUMCCH6_PerfMonCtr3_Hi;
typedef union UMCCH6_PerfMonCtr3_Lo                              regUMCCH6_PerfMonCtr3_Lo;
typedef union UMCCH6_PerfMonCtr4_Hi                              regUMCCH6_PerfMonCtr4_Hi;
typedef union UMCCH6_PerfMonCtr4_Lo                              regUMCCH6_PerfMonCtr4_Lo;
typedef union UMCCH6_PerfMonCtr5_Hi                              regUMCCH6_PerfMonCtr5_Hi;
typedef union UMCCH6_PerfMonCtr5_Lo                              regUMCCH6_PerfMonCtr5_Lo;
typedef union UMCCH6_PerfMonCtrClk_Hi                            regUMCCH6_PerfMonCtrClk_Hi;
typedef union UMCCH6_PerfMonCtrClk_Lo                            regUMCCH6_PerfMonCtrClk_Lo;
typedef union UMCCH7_PerfMonCtl1                                 regUMCCH7_PerfMonCtl1;
typedef union UMCCH7_PerfMonCtl2                                 regUMCCH7_PerfMonCtl2;
typedef union UMCCH7_PerfMonCtl3                                 regUMCCH7_PerfMonCtl3;
typedef union UMCCH7_PerfMonCtl4                                 regUMCCH7_PerfMonCtl4;
typedef union UMCCH7_PerfMonCtl5                                 regUMCCH7_PerfMonCtl5;
typedef union UMCCH7_PerfMonCtlClk                               regUMCCH7_PerfMonCtlClk;
typedef union UMCCH7_PerfMonCtr1_Hi                              regUMCCH7_PerfMonCtr1_Hi;
typedef union UMCCH7_PerfMonCtr1_Lo                              regUMCCH7_PerfMonCtr1_Lo;
typedef union UMCCH7_PerfMonCtr2_Hi                              regUMCCH7_PerfMonCtr2_Hi;
typedef union UMCCH7_PerfMonCtr2_Lo                              regUMCCH7_PerfMonCtr2_Lo;
typedef union UMCCH7_PerfMonCtr3_Hi                              regUMCCH7_PerfMonCtr3_Hi;
typedef union UMCCH7_PerfMonCtr3_Lo                              regUMCCH7_PerfMonCtr3_Lo;
typedef union UMCCH7_PerfMonCtr4_Hi                              regUMCCH7_PerfMonCtr4_Hi;
typedef union UMCCH7_PerfMonCtr4_Lo                              regUMCCH7_PerfMonCtr4_Lo;
typedef union UMCCH7_PerfMonCtr5_Hi                              regUMCCH7_PerfMonCtr5_Hi;
typedef union UMCCH7_PerfMonCtr5_Lo                              regUMCCH7_PerfMonCtr5_Lo;
typedef union UMCCH7_PerfMonCtrClk_Hi                            regUMCCH7_PerfMonCtrClk_Hi;
typedef union UMCCH7_PerfMonCtrClk_Lo                            regUMCCH7_PerfMonCtrClk_Lo;
typedef union UMCCH8_PerfMonCtl1                                 regUMCCH8_PerfMonCtl1;
typedef union UMCCH8_PerfMonCtl2                                 regUMCCH8_PerfMonCtl2;
typedef union UMCCH8_PerfMonCtl3                                 regUMCCH8_PerfMonCtl3;
typedef union UMCCH8_PerfMonCtl4                                 regUMCCH8_PerfMonCtl4;
typedef union UMCCH8_PerfMonCtl5                                 regUMCCH8_PerfMonCtl5;
typedef union UMCCH8_PerfMonCtlClk                               regUMCCH8_PerfMonCtlClk;
typedef union UMCCH8_PerfMonCtr1_Hi                              regUMCCH8_PerfMonCtr1_Hi;
typedef union UMCCH8_PerfMonCtr1_Lo                              regUMCCH8_PerfMonCtr1_Lo;
typedef union UMCCH8_PerfMonCtr2_Hi                              regUMCCH8_PerfMonCtr2_Hi;
typedef union UMCCH8_PerfMonCtr2_Lo                              regUMCCH8_PerfMonCtr2_Lo;
typedef union UMCCH8_PerfMonCtr3_Hi                              regUMCCH8_PerfMonCtr3_Hi;
typedef union UMCCH8_PerfMonCtr3_Lo                              regUMCCH8_PerfMonCtr3_Lo;
typedef union UMCCH8_PerfMonCtr4_Hi                              regUMCCH8_PerfMonCtr4_Hi;
typedef union UMCCH8_PerfMonCtr4_Lo                              regUMCCH8_PerfMonCtr4_Lo;
typedef union UMCCH8_PerfMonCtr5_Hi                              regUMCCH8_PerfMonCtr5_Hi;
typedef union UMCCH8_PerfMonCtr5_Lo                              regUMCCH8_PerfMonCtr5_Lo;
typedef union UMCCH8_PerfMonCtrClk_Hi                            regUMCCH8_PerfMonCtrClk_Hi;
typedef union UMCCH8_PerfMonCtrClk_Lo                            regUMCCH8_PerfMonCtrClk_Lo;
typedef union UMCCH9_PerfMonCtl1                                 regUMCCH9_PerfMonCtl1;
typedef union UMCCH9_PerfMonCtl2                                 regUMCCH9_PerfMonCtl2;
typedef union UMCCH9_PerfMonCtl3                                 regUMCCH9_PerfMonCtl3;
typedef union UMCCH9_PerfMonCtl4                                 regUMCCH9_PerfMonCtl4;
typedef union UMCCH9_PerfMonCtl5                                 regUMCCH9_PerfMonCtl5;
typedef union UMCCH9_PerfMonCtlClk                               regUMCCH9_PerfMonCtlClk;
typedef union UMCCH9_PerfMonCtr1_Hi                              regUMCCH9_PerfMonCtr1_Hi;
typedef union UMCCH9_PerfMonCtr1_Lo                              regUMCCH9_PerfMonCtr1_Lo;
typedef union UMCCH9_PerfMonCtr2_Hi                              regUMCCH9_PerfMonCtr2_Hi;
typedef union UMCCH9_PerfMonCtr2_Lo                              regUMCCH9_PerfMonCtr2_Lo;
typedef union UMCCH9_PerfMonCtr3_Hi                              regUMCCH9_PerfMonCtr3_Hi;
typedef union UMCCH9_PerfMonCtr3_Lo                              regUMCCH9_PerfMonCtr3_Lo;
typedef union UMCCH9_PerfMonCtr4_Hi                              regUMCCH9_PerfMonCtr4_Hi;
typedef union UMCCH9_PerfMonCtr4_Lo                              regUMCCH9_PerfMonCtr4_Lo;
typedef union UMCCH9_PerfMonCtr5_Hi                              regUMCCH9_PerfMonCtr5_Hi;
typedef union UMCCH9_PerfMonCtr5_Lo                              regUMCCH9_PerfMonCtr5_Lo;
typedef union UMCCH9_PerfMonCtrClk_Hi                            regUMCCH9_PerfMonCtrClk_Hi;
typedef union UMCCH9_PerfMonCtrClk_Lo                            regUMCCH9_PerfMonCtrClk_Lo;
typedef union UMCCH10_PerfMonCtl1                                regUMCCH10_PerfMonCtl1;
typedef union UMCCH10_PerfMonCtl2                                regUMCCH10_PerfMonCtl2;
typedef union UMCCH10_PerfMonCtl3                                regUMCCH10_PerfMonCtl3;
typedef union UMCCH10_PerfMonCtl4                                regUMCCH10_PerfMonCtl4;
typedef union UMCCH10_PerfMonCtl5                                regUMCCH10_PerfMonCtl5;
typedef union UMCCH10_PerfMonCtlClk                              regUMCCH10_PerfMonCtlClk;
typedef union UMCCH10_PerfMonCtr1_Hi                             regUMCCH10_PerfMonCtr1_Hi;
typedef union UMCCH10_PerfMonCtr1_Lo                             regUMCCH10_PerfMonCtr1_Lo;
typedef union UMCCH10_PerfMonCtr2_Hi                             regUMCCH10_PerfMonCtr2_Hi;
typedef union UMCCH10_PerfMonCtr2_Lo                             regUMCCH10_PerfMonCtr2_Lo;
typedef union UMCCH10_PerfMonCtr3_Hi                             regUMCCH10_PerfMonCtr3_Hi;
typedef union UMCCH10_PerfMonCtr3_Lo                             regUMCCH10_PerfMonCtr3_Lo;
typedef union UMCCH10_PerfMonCtr4_Hi                             regUMCCH10_PerfMonCtr4_Hi;
typedef union UMCCH10_PerfMonCtr4_Lo                             regUMCCH10_PerfMonCtr4_Lo;
typedef union UMCCH10_PerfMonCtr5_Hi                             regUMCCH10_PerfMonCtr5_Hi;
typedef union UMCCH10_PerfMonCtr5_Lo                             regUMCCH10_PerfMonCtr5_Lo;
typedef union UMCCH10_PerfMonCtrClk_Hi                           regUMCCH10_PerfMonCtrClk_Hi;
typedef union UMCCH10_PerfMonCtrClk_Lo                           regUMCCH10_PerfMonCtrClk_Lo;
typedef union UMCCH11_PerfMonCtl1                                regUMCCH11_PerfMonCtl1;
typedef union UMCCH11_PerfMonCtl2                                regUMCCH11_PerfMonCtl2;
typedef union UMCCH11_PerfMonCtl3                                regUMCCH11_PerfMonCtl3;
typedef union UMCCH11_PerfMonCtl4                                regUMCCH11_PerfMonCtl4;
typedef union UMCCH11_PerfMonCtl5                                regUMCCH11_PerfMonCtl5;
typedef union UMCCH11_PerfMonCtlClk                              regUMCCH11_PerfMonCtlClk;
typedef union UMCCH11_PerfMonCtr1_Hi                             regUMCCH11_PerfMonCtr1_Hi;
typedef union UMCCH11_PerfMonCtr1_Lo                             regUMCCH11_PerfMonCtr1_Lo;
typedef union UMCCH11_PerfMonCtr2_Hi                             regUMCCH11_PerfMonCtr2_Hi;
typedef union UMCCH11_PerfMonCtr2_Lo                             regUMCCH11_PerfMonCtr2_Lo;
typedef union UMCCH11_PerfMonCtr3_Hi                             regUMCCH11_PerfMonCtr3_Hi;
typedef union UMCCH11_PerfMonCtr3_Lo                             regUMCCH11_PerfMonCtr3_Lo;
typedef union UMCCH11_PerfMonCtr4_Hi                             regUMCCH11_PerfMonCtr4_Hi;
typedef union UMCCH11_PerfMonCtr4_Lo                             regUMCCH11_PerfMonCtr4_Lo;
typedef union UMCCH11_PerfMonCtr5_Hi                             regUMCCH11_PerfMonCtr5_Hi;
typedef union UMCCH11_PerfMonCtr5_Lo                             regUMCCH11_PerfMonCtr5_Lo;
typedef union UMCCH11_PerfMonCtrClk_Hi                           regUMCCH11_PerfMonCtrClk_Hi;
typedef union UMCCH11_PerfMonCtrClk_Lo                           regUMCCH11_PerfMonCtrClk_Lo;
typedef union UMCCH12_PerfMonCtl1                                regUMCCH12_PerfMonCtl1;
typedef union UMCCH12_PerfMonCtl2                                regUMCCH12_PerfMonCtl2;
typedef union UMCCH12_PerfMonCtl3                                regUMCCH12_PerfMonCtl3;
typedef union UMCCH12_PerfMonCtl4                                regUMCCH12_PerfMonCtl4;
typedef union UMCCH12_PerfMonCtl5                                regUMCCH12_PerfMonCtl5;
typedef union UMCCH12_PerfMonCtlClk                              regUMCCH12_PerfMonCtlClk;
typedef union UMCCH12_PerfMonCtr1_Hi                             regUMCCH12_PerfMonCtr1_Hi;
typedef union UMCCH12_PerfMonCtr1_Lo                             regUMCCH12_PerfMonCtr1_Lo;
typedef union UMCCH12_PerfMonCtr2_Hi                             regUMCCH12_PerfMonCtr2_Hi;
typedef union UMCCH12_PerfMonCtr2_Lo                             regUMCCH12_PerfMonCtr2_Lo;
typedef union UMCCH12_PerfMonCtr3_Hi                             regUMCCH12_PerfMonCtr3_Hi;
typedef union UMCCH12_PerfMonCtr3_Lo                             regUMCCH12_PerfMonCtr3_Lo;
typedef union UMCCH12_PerfMonCtr4_Hi                             regUMCCH12_PerfMonCtr4_Hi;
typedef union UMCCH12_PerfMonCtr4_Lo                             regUMCCH12_PerfMonCtr4_Lo;
typedef union UMCCH12_PerfMonCtr5_Hi                             regUMCCH12_PerfMonCtr5_Hi;
typedef union UMCCH12_PerfMonCtr5_Lo                             regUMCCH12_PerfMonCtr5_Lo;
typedef union UMCCH12_PerfMonCtrClk_Hi                           regUMCCH12_PerfMonCtrClk_Hi;
typedef union UMCCH12_PerfMonCtrClk_Lo                           regUMCCH12_PerfMonCtrClk_Lo;
typedef union UMCCH13_PerfMonCtl1                                regUMCCH13_PerfMonCtl1;
typedef union UMCCH13_PerfMonCtl2                                regUMCCH13_PerfMonCtl2;
typedef union UMCCH13_PerfMonCtl3                                regUMCCH13_PerfMonCtl3;
typedef union UMCCH13_PerfMonCtl4                                regUMCCH13_PerfMonCtl4;
typedef union UMCCH13_PerfMonCtl5                                regUMCCH13_PerfMonCtl5;
typedef union UMCCH13_PerfMonCtlClk                              regUMCCH13_PerfMonCtlClk;
typedef union UMCCH13_PerfMonCtr1_Hi                             regUMCCH13_PerfMonCtr1_Hi;
typedef union UMCCH13_PerfMonCtr1_Lo                             regUMCCH13_PerfMonCtr1_Lo;
typedef union UMCCH13_PerfMonCtr2_Hi                             regUMCCH13_PerfMonCtr2_Hi;
typedef union UMCCH13_PerfMonCtr2_Lo                             regUMCCH13_PerfMonCtr2_Lo;
typedef union UMCCH13_PerfMonCtr3_Hi                             regUMCCH13_PerfMonCtr3_Hi;
typedef union UMCCH13_PerfMonCtr3_Lo                             regUMCCH13_PerfMonCtr3_Lo;
typedef union UMCCH13_PerfMonCtr4_Hi                             regUMCCH13_PerfMonCtr4_Hi;
typedef union UMCCH13_PerfMonCtr4_Lo                             regUMCCH13_PerfMonCtr4_Lo;
typedef union UMCCH13_PerfMonCtr5_Hi                             regUMCCH13_PerfMonCtr5_Hi;
typedef union UMCCH13_PerfMonCtr5_Lo                             regUMCCH13_PerfMonCtr5_Lo;
typedef union UMCCH13_PerfMonCtrClk_Hi                           regUMCCH13_PerfMonCtrClk_Hi;
typedef union UMCCH13_PerfMonCtrClk_Lo                           regUMCCH13_PerfMonCtrClk_Lo;
typedef union UMCCH14_PerfMonCtl1                                regUMCCH14_PerfMonCtl1;
typedef union UMCCH14_PerfMonCtl2                                regUMCCH14_PerfMonCtl2;
typedef union UMCCH14_PerfMonCtl3                                regUMCCH14_PerfMonCtl3;
typedef union UMCCH14_PerfMonCtl4                                regUMCCH14_PerfMonCtl4;
typedef union UMCCH14_PerfMonCtl5                                regUMCCH14_PerfMonCtl5;
typedef union UMCCH14_PerfMonCtlClk                              regUMCCH14_PerfMonCtlClk;
typedef union UMCCH14_PerfMonCtr1_Hi                             regUMCCH14_PerfMonCtr1_Hi;
typedef union UMCCH14_PerfMonCtr1_Lo                             regUMCCH14_PerfMonCtr1_Lo;
typedef union UMCCH14_PerfMonCtr2_Hi                             regUMCCH14_PerfMonCtr2_Hi;
typedef union UMCCH14_PerfMonCtr2_Lo                             regUMCCH14_PerfMonCtr2_Lo;
typedef union UMCCH14_PerfMonCtr3_Hi                             regUMCCH14_PerfMonCtr3_Hi;
typedef union UMCCH14_PerfMonCtr3_Lo                             regUMCCH14_PerfMonCtr3_Lo;
typedef union UMCCH14_PerfMonCtr4_Hi                             regUMCCH14_PerfMonCtr4_Hi;
typedef union UMCCH14_PerfMonCtr4_Lo                             regUMCCH14_PerfMonCtr4_Lo;
typedef union UMCCH14_PerfMonCtr5_Hi                             regUMCCH14_PerfMonCtr5_Hi;
typedef union UMCCH14_PerfMonCtr5_Lo                             regUMCCH14_PerfMonCtr5_Lo;
typedef union UMCCH14_PerfMonCtrClk_Hi                           regUMCCH14_PerfMonCtrClk_Hi;
typedef union UMCCH14_PerfMonCtrClk_Lo                           regUMCCH14_PerfMonCtrClk_Lo;
typedef union UMCCH15_PerfMonCtl1                                regUMCCH15_PerfMonCtl1;
typedef union UMCCH15_PerfMonCtl2                                regUMCCH15_PerfMonCtl2;
typedef union UMCCH15_PerfMonCtl3                                regUMCCH15_PerfMonCtl3;
typedef union UMCCH15_PerfMonCtl4                                regUMCCH15_PerfMonCtl4;
typedef union UMCCH15_PerfMonCtl5                                regUMCCH15_PerfMonCtl5;
typedef union UMCCH15_PerfMonCtlClk                              regUMCCH15_PerfMonCtlClk;
typedef union UMCCH15_PerfMonCtr1_Hi                             regUMCCH15_PerfMonCtr1_Hi;
typedef union UMCCH15_PerfMonCtr1_Lo                             regUMCCH15_PerfMonCtr1_Lo;
typedef union UMCCH15_PerfMonCtr2_Hi                             regUMCCH15_PerfMonCtr2_Hi;
typedef union UMCCH15_PerfMonCtr2_Lo                             regUMCCH15_PerfMonCtr2_Lo;
typedef union UMCCH15_PerfMonCtr3_Hi                             regUMCCH15_PerfMonCtr3_Hi;
typedef union UMCCH15_PerfMonCtr3_Lo                             regUMCCH15_PerfMonCtr3_Lo;
typedef union UMCCH15_PerfMonCtr4_Hi                             regUMCCH15_PerfMonCtr4_Hi;
typedef union UMCCH15_PerfMonCtr4_Lo                             regUMCCH15_PerfMonCtr4_Lo;
typedef union UMCCH15_PerfMonCtr5_Hi                             regUMCCH15_PerfMonCtr5_Hi;
typedef union UMCCH15_PerfMonCtr5_Lo                             regUMCCH15_PerfMonCtr5_Lo;
typedef union UMCCH15_PerfMonCtrClk_Hi                           regUMCCH15_PerfMonCtrClk_Hi;
typedef union UMCCH15_PerfMonCtrClk_Lo                           regUMCCH15_PerfMonCtrClk_Lo;
typedef union UMCCH16_PerfMonCtl1                                regUMCCH16_PerfMonCtl1;
typedef union UMCCH16_PerfMonCtl2                                regUMCCH16_PerfMonCtl2;
typedef union UMCCH16_PerfMonCtl3                                regUMCCH16_PerfMonCtl3;
typedef union UMCCH16_PerfMonCtl4                                regUMCCH16_PerfMonCtl4;
typedef union UMCCH16_PerfMonCtl5                                regUMCCH16_PerfMonCtl5;
typedef union UMCCH16_PerfMonCtlClk                              regUMCCH16_PerfMonCtlClk;
typedef union UMCCH16_PerfMonCtr1_Hi                             regUMCCH16_PerfMonCtr1_Hi;
typedef union UMCCH16_PerfMonCtr1_Lo                             regUMCCH16_PerfMonCtr1_Lo;
typedef union UMCCH16_PerfMonCtr2_Hi                             regUMCCH16_PerfMonCtr2_Hi;
typedef union UMCCH16_PerfMonCtr2_Lo                             regUMCCH16_PerfMonCtr2_Lo;
typedef union UMCCH16_PerfMonCtr3_Hi                             regUMCCH16_PerfMonCtr3_Hi;
typedef union UMCCH16_PerfMonCtr3_Lo                             regUMCCH16_PerfMonCtr3_Lo;
typedef union UMCCH16_PerfMonCtr4_Hi                             regUMCCH16_PerfMonCtr4_Hi;
typedef union UMCCH16_PerfMonCtr4_Lo                             regUMCCH16_PerfMonCtr4_Lo;
typedef union UMCCH16_PerfMonCtr5_Hi                             regUMCCH16_PerfMonCtr5_Hi;
typedef union UMCCH16_PerfMonCtr5_Lo                             regUMCCH16_PerfMonCtr5_Lo;
typedef union UMCCH16_PerfMonCtrClk_Hi                           regUMCCH16_PerfMonCtrClk_Hi;
typedef union UMCCH16_PerfMonCtrClk_Lo                           regUMCCH16_PerfMonCtrClk_Lo;
typedef union UMCCH17_PerfMonCtl1                                regUMCCH17_PerfMonCtl1;
typedef union UMCCH17_PerfMonCtl2                                regUMCCH17_PerfMonCtl2;
typedef union UMCCH17_PerfMonCtl3                                regUMCCH17_PerfMonCtl3;
typedef union UMCCH17_PerfMonCtl4                                regUMCCH17_PerfMonCtl4;
typedef union UMCCH17_PerfMonCtl5                                regUMCCH17_PerfMonCtl5;
typedef union UMCCH17_PerfMonCtlClk                              regUMCCH17_PerfMonCtlClk;
typedef union UMCCH17_PerfMonCtr1_Hi                             regUMCCH17_PerfMonCtr1_Hi;
typedef union UMCCH17_PerfMonCtr1_Lo                             regUMCCH17_PerfMonCtr1_Lo;
typedef union UMCCH17_PerfMonCtr2_Hi                             regUMCCH17_PerfMonCtr2_Hi;
typedef union UMCCH17_PerfMonCtr2_Lo                             regUMCCH17_PerfMonCtr2_Lo;
typedef union UMCCH17_PerfMonCtr3_Hi                             regUMCCH17_PerfMonCtr3_Hi;
typedef union UMCCH17_PerfMonCtr3_Lo                             regUMCCH17_PerfMonCtr3_Lo;
typedef union UMCCH17_PerfMonCtr4_Hi                             regUMCCH17_PerfMonCtr4_Hi;
typedef union UMCCH17_PerfMonCtr4_Lo                             regUMCCH17_PerfMonCtr4_Lo;
typedef union UMCCH17_PerfMonCtr5_Hi                             regUMCCH17_PerfMonCtr5_Hi;
typedef union UMCCH17_PerfMonCtr5_Lo                             regUMCCH17_PerfMonCtr5_Lo;
typedef union UMCCH17_PerfMonCtrClk_Hi                           regUMCCH17_PerfMonCtrClk_Hi;
typedef union UMCCH17_PerfMonCtrClk_Lo                           regUMCCH17_PerfMonCtrClk_Lo;
typedef union UMCCH18_PerfMonCtl1                                regUMCCH18_PerfMonCtl1;
typedef union UMCCH18_PerfMonCtl2                                regUMCCH18_PerfMonCtl2;
typedef union UMCCH18_PerfMonCtl3                                regUMCCH18_PerfMonCtl3;
typedef union UMCCH18_PerfMonCtl4                                regUMCCH18_PerfMonCtl4;
typedef union UMCCH18_PerfMonCtl5                                regUMCCH18_PerfMonCtl5;
typedef union UMCCH18_PerfMonCtlClk                              regUMCCH18_PerfMonCtlClk;
typedef union UMCCH18_PerfMonCtr1_Hi                             regUMCCH18_PerfMonCtr1_Hi;
typedef union UMCCH18_PerfMonCtr1_Lo                             regUMCCH18_PerfMonCtr1_Lo;
typedef union UMCCH18_PerfMonCtr2_Hi                             regUMCCH18_PerfMonCtr2_Hi;
typedef union UMCCH18_PerfMonCtr2_Lo                             regUMCCH18_PerfMonCtr2_Lo;
typedef union UMCCH18_PerfMonCtr3_Hi                             regUMCCH18_PerfMonCtr3_Hi;
typedef union UMCCH18_PerfMonCtr3_Lo                             regUMCCH18_PerfMonCtr3_Lo;
typedef union UMCCH18_PerfMonCtr4_Hi                             regUMCCH18_PerfMonCtr4_Hi;
typedef union UMCCH18_PerfMonCtr4_Lo                             regUMCCH18_PerfMonCtr4_Lo;
typedef union UMCCH18_PerfMonCtr5_Hi                             regUMCCH18_PerfMonCtr5_Hi;
typedef union UMCCH18_PerfMonCtr5_Lo                             regUMCCH18_PerfMonCtr5_Lo;
typedef union UMCCH18_PerfMonCtrClk_Hi                           regUMCCH18_PerfMonCtrClk_Hi;
typedef union UMCCH18_PerfMonCtrClk_Lo                           regUMCCH18_PerfMonCtrClk_Lo;
typedef union UMCCH19_PerfMonCtl1                                regUMCCH19_PerfMonCtl1;
typedef union UMCCH19_PerfMonCtl2                                regUMCCH19_PerfMonCtl2;
typedef union UMCCH19_PerfMonCtl3                                regUMCCH19_PerfMonCtl3;
typedef union UMCCH19_PerfMonCtl4                                regUMCCH19_PerfMonCtl4;
typedef union UMCCH19_PerfMonCtl5                                regUMCCH19_PerfMonCtl5;
typedef union UMCCH19_PerfMonCtlClk                              regUMCCH19_PerfMonCtlClk;
typedef union UMCCH19_PerfMonCtr1_Hi                             regUMCCH19_PerfMonCtr1_Hi;
typedef union UMCCH19_PerfMonCtr1_Lo                             regUMCCH19_PerfMonCtr1_Lo;
typedef union UMCCH19_PerfMonCtr2_Hi                             regUMCCH19_PerfMonCtr2_Hi;
typedef union UMCCH19_PerfMonCtr2_Lo                             regUMCCH19_PerfMonCtr2_Lo;
typedef union UMCCH19_PerfMonCtr3_Hi                             regUMCCH19_PerfMonCtr3_Hi;
typedef union UMCCH19_PerfMonCtr3_Lo                             regUMCCH19_PerfMonCtr3_Lo;
typedef union UMCCH19_PerfMonCtr4_Hi                             regUMCCH19_PerfMonCtr4_Hi;
typedef union UMCCH19_PerfMonCtr4_Lo                             regUMCCH19_PerfMonCtr4_Lo;
typedef union UMCCH19_PerfMonCtr5_Hi                             regUMCCH19_PerfMonCtr5_Hi;
typedef union UMCCH19_PerfMonCtr5_Lo                             regUMCCH19_PerfMonCtr5_Lo;
typedef union UMCCH19_PerfMonCtrClk_Hi                           regUMCCH19_PerfMonCtrClk_Hi;
typedef union UMCCH19_PerfMonCtrClk_Lo                           regUMCCH19_PerfMonCtrClk_Lo;
typedef union UMCCH20_PerfMonCtl1                                regUMCCH20_PerfMonCtl1;
typedef union UMCCH20_PerfMonCtl2                                regUMCCH20_PerfMonCtl2;
typedef union UMCCH20_PerfMonCtl3                                regUMCCH20_PerfMonCtl3;
typedef union UMCCH20_PerfMonCtl4                                regUMCCH20_PerfMonCtl4;
typedef union UMCCH20_PerfMonCtl5                                regUMCCH20_PerfMonCtl5;
typedef union UMCCH20_PerfMonCtlClk                              regUMCCH20_PerfMonCtlClk;
typedef union UMCCH20_PerfMonCtr1_Hi                             regUMCCH20_PerfMonCtr1_Hi;
typedef union UMCCH20_PerfMonCtr1_Lo                             regUMCCH20_PerfMonCtr1_Lo;
typedef union UMCCH20_PerfMonCtr2_Hi                             regUMCCH20_PerfMonCtr2_Hi;
typedef union UMCCH20_PerfMonCtr2_Lo                             regUMCCH20_PerfMonCtr2_Lo;
typedef union UMCCH20_PerfMonCtr3_Hi                             regUMCCH20_PerfMonCtr3_Hi;
typedef union UMCCH20_PerfMonCtr3_Lo                             regUMCCH20_PerfMonCtr3_Lo;
typedef union UMCCH20_PerfMonCtr4_Hi                             regUMCCH20_PerfMonCtr4_Hi;
typedef union UMCCH20_PerfMonCtr4_Lo                             regUMCCH20_PerfMonCtr4_Lo;
typedef union UMCCH20_PerfMonCtr5_Hi                             regUMCCH20_PerfMonCtr5_Hi;
typedef union UMCCH20_PerfMonCtr5_Lo                             regUMCCH20_PerfMonCtr5_Lo;
typedef union UMCCH20_PerfMonCtrClk_Hi                           regUMCCH20_PerfMonCtrClk_Hi;
typedef union UMCCH20_PerfMonCtrClk_Lo                           regUMCCH20_PerfMonCtrClk_Lo;
typedef union UMCCH21_PerfMonCtl1                                regUMCCH21_PerfMonCtl1;
typedef union UMCCH21_PerfMonCtl2                                regUMCCH21_PerfMonCtl2;
typedef union UMCCH21_PerfMonCtl3                                regUMCCH21_PerfMonCtl3;
typedef union UMCCH21_PerfMonCtl4                                regUMCCH21_PerfMonCtl4;
typedef union UMCCH21_PerfMonCtl5                                regUMCCH21_PerfMonCtl5;
typedef union UMCCH21_PerfMonCtlClk                              regUMCCH21_PerfMonCtlClk;
typedef union UMCCH21_PerfMonCtr1_Hi                             regUMCCH21_PerfMonCtr1_Hi;
typedef union UMCCH21_PerfMonCtr1_Lo                             regUMCCH21_PerfMonCtr1_Lo;
typedef union UMCCH21_PerfMonCtr2_Hi                             regUMCCH21_PerfMonCtr2_Hi;
typedef union UMCCH21_PerfMonCtr2_Lo                             regUMCCH21_PerfMonCtr2_Lo;
typedef union UMCCH21_PerfMonCtr3_Hi                             regUMCCH21_PerfMonCtr3_Hi;
typedef union UMCCH21_PerfMonCtr3_Lo                             regUMCCH21_PerfMonCtr3_Lo;
typedef union UMCCH21_PerfMonCtr4_Hi                             regUMCCH21_PerfMonCtr4_Hi;
typedef union UMCCH21_PerfMonCtr4_Lo                             regUMCCH21_PerfMonCtr4_Lo;
typedef union UMCCH21_PerfMonCtr5_Hi                             regUMCCH21_PerfMonCtr5_Hi;
typedef union UMCCH21_PerfMonCtr5_Lo                             regUMCCH21_PerfMonCtr5_Lo;
typedef union UMCCH21_PerfMonCtrClk_Hi                           regUMCCH21_PerfMonCtrClk_Hi;
typedef union UMCCH21_PerfMonCtrClk_Lo                           regUMCCH21_PerfMonCtrClk_Lo;
typedef union UMCCH22_PerfMonCtl1                                regUMCCH22_PerfMonCtl1;
typedef union UMCCH22_PerfMonCtl2                                regUMCCH22_PerfMonCtl2;
typedef union UMCCH22_PerfMonCtl3                                regUMCCH22_PerfMonCtl3;
typedef union UMCCH22_PerfMonCtl4                                regUMCCH22_PerfMonCtl4;
typedef union UMCCH22_PerfMonCtl5                                regUMCCH22_PerfMonCtl5;
typedef union UMCCH22_PerfMonCtlClk                              regUMCCH22_PerfMonCtlClk;
typedef union UMCCH22_PerfMonCtr1_Hi                             regUMCCH22_PerfMonCtr1_Hi;
typedef union UMCCH22_PerfMonCtr1_Lo                             regUMCCH22_PerfMonCtr1_Lo;
typedef union UMCCH22_PerfMonCtr2_Hi                             regUMCCH22_PerfMonCtr2_Hi;
typedef union UMCCH22_PerfMonCtr2_Lo                             regUMCCH22_PerfMonCtr2_Lo;
typedef union UMCCH22_PerfMonCtr3_Hi                             regUMCCH22_PerfMonCtr3_Hi;
typedef union UMCCH22_PerfMonCtr3_Lo                             regUMCCH22_PerfMonCtr3_Lo;
typedef union UMCCH22_PerfMonCtr4_Hi                             regUMCCH22_PerfMonCtr4_Hi;
typedef union UMCCH22_PerfMonCtr4_Lo                             regUMCCH22_PerfMonCtr4_Lo;
typedef union UMCCH22_PerfMonCtr5_Hi                             regUMCCH22_PerfMonCtr5_Hi;
typedef union UMCCH22_PerfMonCtr5_Lo                             regUMCCH22_PerfMonCtr5_Lo;
typedef union UMCCH22_PerfMonCtrClk_Hi                           regUMCCH22_PerfMonCtrClk_Hi;
typedef union UMCCH22_PerfMonCtrClk_Lo                           regUMCCH22_PerfMonCtrClk_Lo;
typedef union UMCCH23_PerfMonCtl1                                regUMCCH23_PerfMonCtl1;
typedef union UMCCH23_PerfMonCtl2                                regUMCCH23_PerfMonCtl2;
typedef union UMCCH23_PerfMonCtl3                                regUMCCH23_PerfMonCtl3;
typedef union UMCCH23_PerfMonCtl4                                regUMCCH23_PerfMonCtl4;
typedef union UMCCH23_PerfMonCtl5                                regUMCCH23_PerfMonCtl5;
typedef union UMCCH23_PerfMonCtlClk                              regUMCCH23_PerfMonCtlClk;
typedef union UMCCH23_PerfMonCtr1_Hi                             regUMCCH23_PerfMonCtr1_Hi;
typedef union UMCCH23_PerfMonCtr1_Lo                             regUMCCH23_PerfMonCtr1_Lo;
typedef union UMCCH23_PerfMonCtr2_Hi                             regUMCCH23_PerfMonCtr2_Hi;
typedef union UMCCH23_PerfMonCtr2_Lo                             regUMCCH23_PerfMonCtr2_Lo;
typedef union UMCCH23_PerfMonCtr3_Hi                             regUMCCH23_PerfMonCtr3_Hi;
typedef union UMCCH23_PerfMonCtr3_Lo                             regUMCCH23_PerfMonCtr3_Lo;
typedef union UMCCH23_PerfMonCtr4_Hi                             regUMCCH23_PerfMonCtr4_Hi;
typedef union UMCCH23_PerfMonCtr4_Lo                             regUMCCH23_PerfMonCtr4_Lo;
typedef union UMCCH23_PerfMonCtr5_Hi                             regUMCCH23_PerfMonCtr5_Hi;
typedef union UMCCH23_PerfMonCtr5_Lo                             regUMCCH23_PerfMonCtr5_Lo;
typedef union UMCCH23_PerfMonCtrClk_Hi                           regUMCCH23_PerfMonCtrClk_Hi;
typedef union UMCCH23_PerfMonCtrClk_Lo                           regUMCCH23_PerfMonCtrClk_Lo;
typedef union UMCCH24_PerfMonCtl1                                regUMCCH24_PerfMonCtl1;
typedef union UMCCH24_PerfMonCtl2                                regUMCCH24_PerfMonCtl2;
typedef union UMCCH24_PerfMonCtl3                                regUMCCH24_PerfMonCtl3;
typedef union UMCCH24_PerfMonCtl4                                regUMCCH24_PerfMonCtl4;
typedef union UMCCH24_PerfMonCtl5                                regUMCCH24_PerfMonCtl5;
typedef union UMCCH24_PerfMonCtlClk                              regUMCCH24_PerfMonCtlClk;
typedef union UMCCH24_PerfMonCtr1_Hi                             regUMCCH24_PerfMonCtr1_Hi;
typedef union UMCCH24_PerfMonCtr1_Lo                             regUMCCH24_PerfMonCtr1_Lo;
typedef union UMCCH24_PerfMonCtr2_Hi                             regUMCCH24_PerfMonCtr2_Hi;
typedef union UMCCH24_PerfMonCtr2_Lo                             regUMCCH24_PerfMonCtr2_Lo;
typedef union UMCCH24_PerfMonCtr3_Hi                             regUMCCH24_PerfMonCtr3_Hi;
typedef union UMCCH24_PerfMonCtr3_Lo                             regUMCCH24_PerfMonCtr3_Lo;
typedef union UMCCH24_PerfMonCtr4_Hi                             regUMCCH24_PerfMonCtr4_Hi;
typedef union UMCCH24_PerfMonCtr4_Lo                             regUMCCH24_PerfMonCtr4_Lo;
typedef union UMCCH24_PerfMonCtr5_Hi                             regUMCCH24_PerfMonCtr5_Hi;
typedef union UMCCH24_PerfMonCtr5_Lo                             regUMCCH24_PerfMonCtr5_Lo;
typedef union UMCCH24_PerfMonCtrClk_Hi                           regUMCCH24_PerfMonCtrClk_Hi;
typedef union UMCCH24_PerfMonCtrClk_Lo                           regUMCCH24_PerfMonCtrClk_Lo;
typedef union UMCCH25_PerfMonCtl1                                regUMCCH25_PerfMonCtl1;
typedef union UMCCH25_PerfMonCtl2                                regUMCCH25_PerfMonCtl2;
typedef union UMCCH25_PerfMonCtl3                                regUMCCH25_PerfMonCtl3;
typedef union UMCCH25_PerfMonCtl4                                regUMCCH25_PerfMonCtl4;
typedef union UMCCH25_PerfMonCtl5                                regUMCCH25_PerfMonCtl5;
typedef union UMCCH25_PerfMonCtlClk                              regUMCCH25_PerfMonCtlClk;
typedef union UMCCH25_PerfMonCtr1_Hi                             regUMCCH25_PerfMonCtr1_Hi;
typedef union UMCCH25_PerfMonCtr1_Lo                             regUMCCH25_PerfMonCtr1_Lo;
typedef union UMCCH25_PerfMonCtr2_Hi                             regUMCCH25_PerfMonCtr2_Hi;
typedef union UMCCH25_PerfMonCtr2_Lo                             regUMCCH25_PerfMonCtr2_Lo;
typedef union UMCCH25_PerfMonCtr3_Hi                             regUMCCH25_PerfMonCtr3_Hi;
typedef union UMCCH25_PerfMonCtr3_Lo                             regUMCCH25_PerfMonCtr3_Lo;
typedef union UMCCH25_PerfMonCtr4_Hi                             regUMCCH25_PerfMonCtr4_Hi;
typedef union UMCCH25_PerfMonCtr4_Lo                             regUMCCH25_PerfMonCtr4_Lo;
typedef union UMCCH25_PerfMonCtr5_Hi                             regUMCCH25_PerfMonCtr5_Hi;
typedef union UMCCH25_PerfMonCtr5_Lo                             regUMCCH25_PerfMonCtr5_Lo;
typedef union UMCCH25_PerfMonCtrClk_Hi                           regUMCCH25_PerfMonCtrClk_Hi;
typedef union UMCCH25_PerfMonCtrClk_Lo                           regUMCCH25_PerfMonCtrClk_Lo;
typedef union UMCCH26_PerfMonCtl1                                regUMCCH26_PerfMonCtl1;
typedef union UMCCH26_PerfMonCtl2                                regUMCCH26_PerfMonCtl2;
typedef union UMCCH26_PerfMonCtl3                                regUMCCH26_PerfMonCtl3;
typedef union UMCCH26_PerfMonCtl4                                regUMCCH26_PerfMonCtl4;
typedef union UMCCH26_PerfMonCtl5                                regUMCCH26_PerfMonCtl5;
typedef union UMCCH26_PerfMonCtlClk                              regUMCCH26_PerfMonCtlClk;
typedef union UMCCH26_PerfMonCtr1_Hi                             regUMCCH26_PerfMonCtr1_Hi;
typedef union UMCCH26_PerfMonCtr1_Lo                             regUMCCH26_PerfMonCtr1_Lo;
typedef union UMCCH26_PerfMonCtr2_Hi                             regUMCCH26_PerfMonCtr2_Hi;
typedef union UMCCH26_PerfMonCtr2_Lo                             regUMCCH26_PerfMonCtr2_Lo;
typedef union UMCCH26_PerfMonCtr3_Hi                             regUMCCH26_PerfMonCtr3_Hi;
typedef union UMCCH26_PerfMonCtr3_Lo                             regUMCCH26_PerfMonCtr3_Lo;
typedef union UMCCH26_PerfMonCtr4_Hi                             regUMCCH26_PerfMonCtr4_Hi;
typedef union UMCCH26_PerfMonCtr4_Lo                             regUMCCH26_PerfMonCtr4_Lo;
typedef union UMCCH26_PerfMonCtr5_Hi                             regUMCCH26_PerfMonCtr5_Hi;
typedef union UMCCH26_PerfMonCtr5_Lo                             regUMCCH26_PerfMonCtr5_Lo;
typedef union UMCCH26_PerfMonCtrClk_Hi                           regUMCCH26_PerfMonCtrClk_Hi;
typedef union UMCCH26_PerfMonCtrClk_Lo                           regUMCCH26_PerfMonCtrClk_Lo;
typedef union UMCCH27_PerfMonCtl1                                regUMCCH27_PerfMonCtl1;
typedef union UMCCH27_PerfMonCtl2                                regUMCCH27_PerfMonCtl2;
typedef union UMCCH27_PerfMonCtl3                                regUMCCH27_PerfMonCtl3;
typedef union UMCCH27_PerfMonCtl4                                regUMCCH27_PerfMonCtl4;
typedef union UMCCH27_PerfMonCtl5                                regUMCCH27_PerfMonCtl5;
typedef union UMCCH27_PerfMonCtlClk                              regUMCCH27_PerfMonCtlClk;
typedef union UMCCH27_PerfMonCtr1_Hi                             regUMCCH27_PerfMonCtr1_Hi;
typedef union UMCCH27_PerfMonCtr1_Lo                             regUMCCH27_PerfMonCtr1_Lo;
typedef union UMCCH27_PerfMonCtr2_Hi                             regUMCCH27_PerfMonCtr2_Hi;
typedef union UMCCH27_PerfMonCtr2_Lo                             regUMCCH27_PerfMonCtr2_Lo;
typedef union UMCCH27_PerfMonCtr3_Hi                             regUMCCH27_PerfMonCtr3_Hi;
typedef union UMCCH27_PerfMonCtr3_Lo                             regUMCCH27_PerfMonCtr3_Lo;
typedef union UMCCH27_PerfMonCtr4_Hi                             regUMCCH27_PerfMonCtr4_Hi;
typedef union UMCCH27_PerfMonCtr4_Lo                             regUMCCH27_PerfMonCtr4_Lo;
typedef union UMCCH27_PerfMonCtr5_Hi                             regUMCCH27_PerfMonCtr5_Hi;
typedef union UMCCH27_PerfMonCtr5_Lo                             regUMCCH27_PerfMonCtr5_Lo;
typedef union UMCCH27_PerfMonCtrClk_Hi                           regUMCCH27_PerfMonCtrClk_Hi;
typedef union UMCCH27_PerfMonCtrClk_Lo                           regUMCCH27_PerfMonCtrClk_Lo;
typedef union UMCCH28_PerfMonCtl1                                regUMCCH28_PerfMonCtl1;
typedef union UMCCH28_PerfMonCtl2                                regUMCCH28_PerfMonCtl2;
typedef union UMCCH28_PerfMonCtl3                                regUMCCH28_PerfMonCtl3;
typedef union UMCCH28_PerfMonCtl4                                regUMCCH28_PerfMonCtl4;
typedef union UMCCH28_PerfMonCtl5                                regUMCCH28_PerfMonCtl5;
typedef union UMCCH28_PerfMonCtlClk                              regUMCCH28_PerfMonCtlClk;
typedef union UMCCH28_PerfMonCtr1_Hi                             regUMCCH28_PerfMonCtr1_Hi;
typedef union UMCCH28_PerfMonCtr1_Lo                             regUMCCH28_PerfMonCtr1_Lo;
typedef union UMCCH28_PerfMonCtr2_Hi                             regUMCCH28_PerfMonCtr2_Hi;
typedef union UMCCH28_PerfMonCtr2_Lo                             regUMCCH28_PerfMonCtr2_Lo;
typedef union UMCCH28_PerfMonCtr3_Hi                             regUMCCH28_PerfMonCtr3_Hi;
typedef union UMCCH28_PerfMonCtr3_Lo                             regUMCCH28_PerfMonCtr3_Lo;
typedef union UMCCH28_PerfMonCtr4_Hi                             regUMCCH28_PerfMonCtr4_Hi;
typedef union UMCCH28_PerfMonCtr4_Lo                             regUMCCH28_PerfMonCtr4_Lo;
typedef union UMCCH28_PerfMonCtr5_Hi                             regUMCCH28_PerfMonCtr5_Hi;
typedef union UMCCH28_PerfMonCtr5_Lo                             regUMCCH28_PerfMonCtr5_Lo;
typedef union UMCCH28_PerfMonCtrClk_Hi                           regUMCCH28_PerfMonCtrClk_Hi;
typedef union UMCCH28_PerfMonCtrClk_Lo                           regUMCCH28_PerfMonCtrClk_Lo;
typedef union UMCCH29_PerfMonCtl1                                regUMCCH29_PerfMonCtl1;
typedef union UMCCH29_PerfMonCtl2                                regUMCCH29_PerfMonCtl2;
typedef union UMCCH29_PerfMonCtl3                                regUMCCH29_PerfMonCtl3;
typedef union UMCCH29_PerfMonCtl4                                regUMCCH29_PerfMonCtl4;
typedef union UMCCH29_PerfMonCtl5                                regUMCCH29_PerfMonCtl5;
typedef union UMCCH29_PerfMonCtlClk                              regUMCCH29_PerfMonCtlClk;
typedef union UMCCH29_PerfMonCtr1_Hi                             regUMCCH29_PerfMonCtr1_Hi;
typedef union UMCCH29_PerfMonCtr1_Lo                             regUMCCH29_PerfMonCtr1_Lo;
typedef union UMCCH29_PerfMonCtr2_Hi                             regUMCCH29_PerfMonCtr2_Hi;
typedef union UMCCH29_PerfMonCtr2_Lo                             regUMCCH29_PerfMonCtr2_Lo;
typedef union UMCCH29_PerfMonCtr3_Hi                             regUMCCH29_PerfMonCtr3_Hi;
typedef union UMCCH29_PerfMonCtr3_Lo                             regUMCCH29_PerfMonCtr3_Lo;
typedef union UMCCH29_PerfMonCtr4_Hi                             regUMCCH29_PerfMonCtr4_Hi;
typedef union UMCCH29_PerfMonCtr4_Lo                             regUMCCH29_PerfMonCtr4_Lo;
typedef union UMCCH29_PerfMonCtr5_Hi                             regUMCCH29_PerfMonCtr5_Hi;
typedef union UMCCH29_PerfMonCtr5_Lo                             regUMCCH29_PerfMonCtr5_Lo;
typedef union UMCCH29_PerfMonCtrClk_Hi                           regUMCCH29_PerfMonCtrClk_Hi;
typedef union UMCCH29_PerfMonCtrClk_Lo                           regUMCCH29_PerfMonCtrClk_Lo;
typedef union UMCCH30_PerfMonCtl1                                regUMCCH30_PerfMonCtl1;
typedef union UMCCH30_PerfMonCtl2                                regUMCCH30_PerfMonCtl2;
typedef union UMCCH30_PerfMonCtl3                                regUMCCH30_PerfMonCtl3;
typedef union UMCCH30_PerfMonCtl4                                regUMCCH30_PerfMonCtl4;
typedef union UMCCH30_PerfMonCtl5                                regUMCCH30_PerfMonCtl5;
typedef union UMCCH30_PerfMonCtlClk                              regUMCCH30_PerfMonCtlClk;
typedef union UMCCH30_PerfMonCtr1_Hi                             regUMCCH30_PerfMonCtr1_Hi;
typedef union UMCCH30_PerfMonCtr1_Lo                             regUMCCH30_PerfMonCtr1_Lo;
typedef union UMCCH30_PerfMonCtr2_Hi                             regUMCCH30_PerfMonCtr2_Hi;
typedef union UMCCH30_PerfMonCtr2_Lo                             regUMCCH30_PerfMonCtr2_Lo;
typedef union UMCCH30_PerfMonCtr3_Hi                             regUMCCH30_PerfMonCtr3_Hi;
typedef union UMCCH30_PerfMonCtr3_Lo                             regUMCCH30_PerfMonCtr3_Lo;
typedef union UMCCH30_PerfMonCtr4_Hi                             regUMCCH30_PerfMonCtr4_Hi;
typedef union UMCCH30_PerfMonCtr4_Lo                             regUMCCH30_PerfMonCtr4_Lo;
typedef union UMCCH30_PerfMonCtr5_Hi                             regUMCCH30_PerfMonCtr5_Hi;
typedef union UMCCH30_PerfMonCtr5_Lo                             regUMCCH30_PerfMonCtr5_Lo;
typedef union UMCCH30_PerfMonCtrClk_Hi                           regUMCCH30_PerfMonCtrClk_Hi;
typedef union UMCCH30_PerfMonCtrClk_Lo                           regUMCCH30_PerfMonCtrClk_Lo;
typedef union UMCCH31_PerfMonCtl1                                regUMCCH31_PerfMonCtl1;
typedef union UMCCH31_PerfMonCtl2                                regUMCCH31_PerfMonCtl2;
typedef union UMCCH31_PerfMonCtl3                                regUMCCH31_PerfMonCtl3;
typedef union UMCCH31_PerfMonCtl4                                regUMCCH31_PerfMonCtl4;
typedef union UMCCH31_PerfMonCtl5                                regUMCCH31_PerfMonCtl5;
typedef union UMCCH31_PerfMonCtlClk                              regUMCCH31_PerfMonCtlClk;
typedef union UMCCH31_PerfMonCtr1_Hi                             regUMCCH31_PerfMonCtr1_Hi;
typedef union UMCCH31_PerfMonCtr1_Lo                             regUMCCH31_PerfMonCtr1_Lo;
typedef union UMCCH31_PerfMonCtr2_Hi                             regUMCCH31_PerfMonCtr2_Hi;
typedef union UMCCH31_PerfMonCtr2_Lo                             regUMCCH31_PerfMonCtr2_Lo;
typedef union UMCCH31_PerfMonCtr3_Hi                             regUMCCH31_PerfMonCtr3_Hi;
typedef union UMCCH31_PerfMonCtr3_Lo                             regUMCCH31_PerfMonCtr3_Lo;
typedef union UMCCH31_PerfMonCtr4_Hi                             regUMCCH31_PerfMonCtr4_Hi;
typedef union UMCCH31_PerfMonCtr4_Lo                             regUMCCH31_PerfMonCtr4_Lo;
typedef union UMCCH31_PerfMonCtr5_Hi                             regUMCCH31_PerfMonCtr5_Hi;
typedef union UMCCH31_PerfMonCtr5_Lo                             regUMCCH31_PerfMonCtr5_Lo;
typedef union UMCCH31_PerfMonCtrClk_Hi                           regUMCCH31_PerfMonCtrClk_Hi;
typedef union UMCCH31_PerfMonCtrClk_Lo                           regUMCCH31_PerfMonCtrClk_Lo;
typedef union UTCL1_ALOG                                         regUTCL1_ALOG;
typedef union UTCL1_CGTT_CLK_CTRL                                regUTCL1_CGTT_CLK_CTRL;
typedef union UTCL1_CTRL                                         regUTCL1_CTRL;
typedef union UTCL1_PERFCOUNTER0_HI                              regUTCL1_PERFCOUNTER0_HI;
typedef union UTCL1_PERFCOUNTER0_LO                              regUTCL1_PERFCOUNTER0_LO;
typedef union UTCL1_PERFCOUNTER0_SELECT                          regUTCL1_PERFCOUNTER0_SELECT;
typedef union UTCL1_PERFCOUNTER1_HI                              regUTCL1_PERFCOUNTER1_HI;
typedef union UTCL1_PERFCOUNTER1_LO                              regUTCL1_PERFCOUNTER1_LO;
typedef union UTCL1_PERFCOUNTER1_SELECT                          regUTCL1_PERFCOUNTER1_SELECT;
typedef union UTCL1_UTCL0_INVREQ_DISABLE                         regUTCL1_UTCL0_INVREQ_DISABLE;
typedef union UTCL2_CGTT_CLK_CTRL                                regUTCL2_CGTT_CLK_CTRL;
typedef union VGT_CACHE_INVALIDATION                             regVGT_CACHE_INVALIDATION;
typedef union VGT_CNTL_STATUS                                    regVGT_CNTL_STATUS;
typedef union VGT_DEBUG_DATA                                     regVGT_DEBUG_DATA;
typedef union VGT_DEBUG_REG0                                     regVGT_DEBUG_REG0;
typedef union VGT_DEBUG_REG1                                     regVGT_DEBUG_REG1;
typedef union VGT_DEBUG_REG2                                     regVGT_DEBUG_REG2;
typedef union VGT_DEBUG_REG4                                     regVGT_DEBUG_REG4;
typedef union VGT_DEBUG_REG5                                     regVGT_DEBUG_REG5;
typedef union VGT_DEBUG_REG7                                     regVGT_DEBUG_REG7;
typedef union VGT_DEBUG_REG9                                     regVGT_DEBUG_REG9;
typedef union VGT_DEBUG_REG10                                    regVGT_DEBUG_REG10;
typedef union VGT_DEBUG_REG11                                    regVGT_DEBUG_REG11;
typedef union VGT_DEBUG_REG12                                    regVGT_DEBUG_REG12;
typedef union VGT_DEBUG_REG13                                    regVGT_DEBUG_REG13;
typedef union VGT_DEBUG_REG14                                    regVGT_DEBUG_REG14;
typedef union VGT_DEBUG_REG15                                    regVGT_DEBUG_REG15;
typedef union VGT_DEBUG_REG16                                    regVGT_DEBUG_REG16;
typedef union VGT_DEBUG_REG23                                    regVGT_DEBUG_REG23;
typedef union VGT_DEBUG_REG30                                    regVGT_DEBUG_REG30;
typedef union VGT_DEBUG_REG32                                    regVGT_DEBUG_REG32;
typedef union VGT_DEBUG_REG35                                    regVGT_DEBUG_REG35;
typedef union VGT_DISPATCH_DRAW_INDEX                            regVGT_DISPATCH_DRAW_INDEX;
typedef union VGT_DMA_BASE                                       regVGT_DMA_BASE;
typedef union VGT_DMA_BASE_HI                                    regVGT_DMA_BASE_HI;
typedef union VGT_DMA_CONTROL                                    regVGT_DMA_CONTROL;
typedef union VGT_DMA_DATA_FIFO_DEPTH                            regVGT_DMA_DATA_FIFO_DEPTH;
typedef union VGT_DMA_EVENT_INITIATOR                            regVGT_DMA_EVENT_INITIATOR;
typedef union VGT_DMA_INDEX_TYPE                                 regVGT_DMA_INDEX_TYPE;
typedef union VGT_DMA_LS_HS_CONFIG                               regVGT_DMA_LS_HS_CONFIG;
typedef union VGT_DMA_MAX_SIZE                                   regVGT_DMA_MAX_SIZE;
typedef union VGT_DMA_NUM_INSTANCES                              regVGT_DMA_NUM_INSTANCES;
typedef union VGT_DMA_PRIMITIVE_TYPE                             regVGT_DMA_PRIMITIVE_TYPE;
typedef union VGT_DMA_REQ_FIFO_DEPTH                             regVGT_DMA_REQ_FIFO_DEPTH;
typedef union VGT_DMA_SIZE                                       regVGT_DMA_SIZE;
typedef union VGT_DRAW_INITIATOR                                 regVGT_DRAW_INITIATOR;
typedef union VGT_DRAW_INIT_FIFO_DEPTH                           regVGT_DRAW_INIT_FIFO_DEPTH;
typedef union VGT_DRAW_PAYLOAD_CNTL                              regVGT_DRAW_PAYLOAD_CNTL;
typedef union VGT_ENHANCE                                        regVGT_ENHANCE;
typedef union VGT_ESGS_RING_ITEMSIZE                             regVGT_ESGS_RING_ITEMSIZE;
typedef union VGT_ESGS_RING_SIZE                                 regVGT_ESGS_RING_SIZE;
typedef union VGT_ESGS_RING_SIZE_UMD                             regVGT_ESGS_RING_SIZE_UMD;
typedef union VGT_ES_PER_GS                                      regVGT_ES_PER_GS;
typedef union VGT_EVENT_ADDRESS_REG                              regVGT_EVENT_ADDRESS_REG;
typedef union VGT_EVENT_INITIATOR                                regVGT_EVENT_INITIATOR;
typedef union VGT_FIFO_DEPTHS                                    regVGT_FIFO_DEPTHS;
typedef union VGT_GROUP_DECR                                     regVGT_GROUP_DECR;
typedef union VGT_GROUP_FIRST_DECR                               regVGT_GROUP_FIRST_DECR;
typedef union VGT_GROUP_PRIM_TYPE                                regVGT_GROUP_PRIM_TYPE;
typedef union VGT_GROUP_VECT_0_CNTL                              regVGT_GROUP_VECT_0_CNTL;
typedef union VGT_GROUP_VECT_0_FMT_CNTL                          regVGT_GROUP_VECT_0_FMT_CNTL;
typedef union VGT_GROUP_VECT_1_CNTL                              regVGT_GROUP_VECT_1_CNTL;
typedef union VGT_GROUP_VECT_1_FMT_CNTL                          regVGT_GROUP_VECT_1_FMT_CNTL;
typedef union VGT_GSVS_RING_ITEMSIZE                             regVGT_GSVS_RING_ITEMSIZE;
typedef union VGT_GSVS_RING_OFFSET_1                             regVGT_GSVS_RING_OFFSET_1;
typedef union VGT_GSVS_RING_OFFSET_2                             regVGT_GSVS_RING_OFFSET_2;
typedef union VGT_GSVS_RING_OFFSET_3                             regVGT_GSVS_RING_OFFSET_3;
typedef union VGT_GSVS_RING_SIZE                                 regVGT_GSVS_RING_SIZE;
typedef union VGT_GSVS_RING_SIZE_UMD                             regVGT_GSVS_RING_SIZE_UMD;
typedef union VGT_GS_INSTANCE_CNT                                regVGT_GS_INSTANCE_CNT;
typedef union VGT_GS_MAX_PRIMS_PER_SUBGROUP                      regVGT_GS_MAX_PRIMS_PER_SUBGROUP;
typedef union VGT_GS_MAX_VERT_OUT                                regVGT_GS_MAX_VERT_OUT;
typedef union VGT_GS_MAX_WAVE_ID                                 regVGT_GS_MAX_WAVE_ID;
typedef union VGT_GS_MODE                                        regVGT_GS_MODE;
typedef union VGT_GS_ONCHIP_CNTL                                 regVGT_GS_ONCHIP_CNTL;
typedef union VGT_GS_OUT_PRIM_TYPE                               regVGT_GS_OUT_PRIM_TYPE;
typedef union VGT_GS_PER_ES                                      regVGT_GS_PER_ES;
typedef union VGT_GS_PER_VS                                      regVGT_GS_PER_VS;
typedef union VGT_GS_VERTEX_REUSE                                regVGT_GS_VERTEX_REUSE;
typedef union VGT_GS_VERT_ITEMSIZE                               regVGT_GS_VERT_ITEMSIZE;
typedef union VGT_GS_VERT_ITEMSIZE_1                             regVGT_GS_VERT_ITEMSIZE_1;
typedef union VGT_GS_VERT_ITEMSIZE_2                             regVGT_GS_VERT_ITEMSIZE_2;
typedef union VGT_GS_VERT_ITEMSIZE_3                             regVGT_GS_VERT_ITEMSIZE_3;
typedef union VGT_HOS_CNTL                                       regVGT_HOS_CNTL;
typedef union VGT_HOS_MAX_TESS_LEVEL                             regVGT_HOS_MAX_TESS_LEVEL;
typedef union VGT_HOS_MIN_TESS_LEVEL                             regVGT_HOS_MIN_TESS_LEVEL;
typedef union VGT_HOS_REUSE_DEPTH                                regVGT_HOS_REUSE_DEPTH;
typedef union VGT_HS_OFFCHIP_PARAM                               regVGT_HS_OFFCHIP_PARAM;
typedef union VGT_HS_OFFCHIP_PARAM_UMD                           regVGT_HS_OFFCHIP_PARAM_UMD;
typedef union VGT_IMMED_DATA                                     regVGT_IMMED_DATA;
typedef union VGT_INDEX_TYPE                                     regVGT_INDEX_TYPE;
typedef union VGT_INDX_OFFSET                                    regVGT_INDX_OFFSET;
typedef union VGT_INSTANCE_BASE_ID                               regVGT_INSTANCE_BASE_ID;
typedef union VGT_INSTANCE_STEP_RATE_0                           regVGT_INSTANCE_STEP_RATE_0;
typedef union VGT_INSTANCE_STEP_RATE_1                           regVGT_INSTANCE_STEP_RATE_1;
typedef union VGT_LAST_COPY_STATE                                regVGT_LAST_COPY_STATE;
typedef union VGT_LS_HS_CONFIG                                   regVGT_LS_HS_CONFIG;
typedef union VGT_MAX_VTX_INDX                                   regVGT_MAX_VTX_INDX;
typedef union VGT_MC_LAT_CNTL                                    regVGT_MC_LAT_CNTL;
typedef union VGT_MIN_VTX_INDX                                   regVGT_MIN_VTX_INDX;
typedef union VGT_MULTI_PRIM_IB_RESET_EN                         regVGT_MULTI_PRIM_IB_RESET_EN;
typedef union VGT_MULTI_PRIM_IB_RESET_INDX                       regVGT_MULTI_PRIM_IB_RESET_INDX;
typedef union VGT_NUM_INDICES                                    regVGT_NUM_INDICES;
typedef union VGT_NUM_INSTANCES                                  regVGT_NUM_INSTANCES;
typedef union VGT_OUTPUT_PATH_CNTL                               regVGT_OUTPUT_PATH_CNTL;
typedef union VGT_OUT_DEALLOC_CNTL                               regVGT_OUT_DEALLOC_CNTL;
typedef union VGT_PERFCOUNTER0_HI                                regVGT_PERFCOUNTER0_HI;
typedef union VGT_PERFCOUNTER0_LO                                regVGT_PERFCOUNTER0_LO;
typedef union VGT_PERFCOUNTER0_SELECT                            regVGT_PERFCOUNTER0_SELECT;
typedef union VGT_PERFCOUNTER0_SELECT1                           regVGT_PERFCOUNTER0_SELECT1;
typedef union VGT_PERFCOUNTER1_HI                                regVGT_PERFCOUNTER1_HI;
typedef union VGT_PERFCOUNTER1_LO                                regVGT_PERFCOUNTER1_LO;
typedef union VGT_PERFCOUNTER1_SELECT                            regVGT_PERFCOUNTER1_SELECT;
typedef union VGT_PERFCOUNTER1_SELECT1                           regVGT_PERFCOUNTER1_SELECT1;
typedef union VGT_PERFCOUNTER2_HI                                regVGT_PERFCOUNTER2_HI;
typedef union VGT_PERFCOUNTER2_LO                                regVGT_PERFCOUNTER2_LO;
typedef union VGT_PERFCOUNTER2_SELECT                            regVGT_PERFCOUNTER2_SELECT;
typedef union VGT_PERFCOUNTER3_HI                                regVGT_PERFCOUNTER3_HI;
typedef union VGT_PERFCOUNTER3_LO                                regVGT_PERFCOUNTER3_LO;
typedef union VGT_PERFCOUNTER3_SELECT                            regVGT_PERFCOUNTER3_SELECT;
typedef union VGT_PERFCOUNTER_SEID_MASK                          regVGT_PERFCOUNTER_SEID_MASK;
typedef union VGT_PRIMITIVEID_EN                                 regVGT_PRIMITIVEID_EN;
typedef union VGT_PRIMITIVEID_RESET                              regVGT_PRIMITIVEID_RESET;
typedef union VGT_PRIMITIVE_TYPE                                 regVGT_PRIMITIVE_TYPE;
typedef union VGT_RESET_DEBUG                                    regVGT_RESET_DEBUG;
typedef union VGT_REUSE_OFF                                      regVGT_REUSE_OFF;
typedef union VGT_SHADER_STAGES_EN                               regVGT_SHADER_STAGES_EN;
typedef union VGT_STRMOUT_BUFFER_CONFIG                          regVGT_STRMOUT_BUFFER_CONFIG;
typedef union VGT_STRMOUT_BUFFER_FILLED_SIZE_0                   regVGT_STRMOUT_BUFFER_FILLED_SIZE_0;
typedef union VGT_STRMOUT_BUFFER_FILLED_SIZE_1                   regVGT_STRMOUT_BUFFER_FILLED_SIZE_1;
typedef union VGT_STRMOUT_BUFFER_FILLED_SIZE_2                   regVGT_STRMOUT_BUFFER_FILLED_SIZE_2;
typedef union VGT_STRMOUT_BUFFER_FILLED_SIZE_3                   regVGT_STRMOUT_BUFFER_FILLED_SIZE_3;
typedef union VGT_STRMOUT_BUFFER_OFFSET_0                        regVGT_STRMOUT_BUFFER_OFFSET_0;
typedef union VGT_STRMOUT_BUFFER_OFFSET_1                        regVGT_STRMOUT_BUFFER_OFFSET_1;
typedef union VGT_STRMOUT_BUFFER_OFFSET_2                        regVGT_STRMOUT_BUFFER_OFFSET_2;
typedef union VGT_STRMOUT_BUFFER_OFFSET_3                        regVGT_STRMOUT_BUFFER_OFFSET_3;
typedef union VGT_STRMOUT_BUFFER_SIZE_0                          regVGT_STRMOUT_BUFFER_SIZE_0;
typedef union VGT_STRMOUT_BUFFER_SIZE_1                          regVGT_STRMOUT_BUFFER_SIZE_1;
typedef union VGT_STRMOUT_BUFFER_SIZE_2                          regVGT_STRMOUT_BUFFER_SIZE_2;
typedef union VGT_STRMOUT_BUFFER_SIZE_3                          regVGT_STRMOUT_BUFFER_SIZE_3;
typedef union VGT_STRMOUT_CONFIG                                 regVGT_STRMOUT_CONFIG;
typedef union VGT_STRMOUT_DELAY                                  regVGT_STRMOUT_DELAY;
typedef union VGT_STRMOUT_DRAW_OPAQUE_BUFFER_FILLED_SIZE         regVGT_STRMOUT_DRAW_OPAQUE_BUFFER_FILLED_SIZE;
typedef union VGT_STRMOUT_DRAW_OPAQUE_OFFSET                     regVGT_STRMOUT_DRAW_OPAQUE_OFFSET;
typedef union VGT_STRMOUT_DRAW_OPAQUE_VERTEX_STRIDE              regVGT_STRMOUT_DRAW_OPAQUE_VERTEX_STRIDE;
typedef union VGT_STRMOUT_VTX_STRIDE_0                           regVGT_STRMOUT_VTX_STRIDE_0;
typedef union VGT_STRMOUT_VTX_STRIDE_1                           regVGT_STRMOUT_VTX_STRIDE_1;
typedef union VGT_STRMOUT_VTX_STRIDE_2                           regVGT_STRMOUT_VTX_STRIDE_2;
typedef union VGT_STRMOUT_VTX_STRIDE_3                           regVGT_STRMOUT_VTX_STRIDE_3;
typedef union VGT_SYS_CONFIG                                     regVGT_SYS_CONFIG;
typedef union VGT_TESS_DISTRIBUTION                              regVGT_TESS_DISTRIBUTION;
typedef union VGT_TF_MEMORY_BASE                                 regVGT_TF_MEMORY_BASE;
typedef union VGT_TF_MEMORY_BASE_HI                              regVGT_TF_MEMORY_BASE_HI;
typedef union VGT_TF_MEMORY_BASE_HI_UMD                          regVGT_TF_MEMORY_BASE_HI_UMD;
typedef union VGT_TF_MEMORY_BASE_UMD                             regVGT_TF_MEMORY_BASE_UMD;
typedef union VGT_TF_PARAM                                       regVGT_TF_PARAM;
typedef union VGT_TF_RING_SIZE                                   regVGT_TF_RING_SIZE;
typedef union VGT_TF_RING_SIZE_UMD                               regVGT_TF_RING_SIZE_UMD;
typedef union VGT_VERTEX_REUSE_BLOCK_CNTL                        regVGT_VERTEX_REUSE_BLOCK_CNTL;
typedef union VGT_VS_MAX_WAVE_ID                                 regVGT_VS_MAX_WAVE_ID;
typedef union VGT_VTX_CNT_EN                                     regVGT_VTX_CNT_EN;
typedef union VGT_VTX_VECT_EJECT_REG                             regVGT_VTX_VECT_EJECT_REG;
typedef union VML2_MEM_ECC_CNTL                                  regVML2_MEM_ECC_CNTL;
typedef union VML2_MEM_ECC_INDEX                                 regVML2_MEM_ECC_INDEX;
typedef union VML2_WALKER_MEM_ECC_CNTL                           regVML2_WALKER_MEM_ECC_CNTL;
typedef union VML2_WALKER_MEM_ECC_INDEX                          regVML2_WALKER_MEM_ECC_INDEX;
typedef union wbuf_DEBUG_DATA                                    regwbuf_DEBUG_DATA;
typedef union WD_BUF_RESOURCE_1                                  regWD_BUF_RESOURCE_1;
typedef union WD_BUF_RESOURCE_2                                  regWD_BUF_RESOURCE_2;
typedef union WD_CNTL_SB_BUF_BASE                                regWD_CNTL_SB_BUF_BASE;
typedef union WD_CNTL_SB_BUF_BASE_HI                             regWD_CNTL_SB_BUF_BASE_HI;
typedef union WD_CNTL_STATUS                                     regWD_CNTL_STATUS;
typedef union WD_DEBUG_DATA                                      regWD_DEBUG_DATA;
typedef union WD_DEBUG_REG0                                      regWD_DEBUG_REG0;
typedef union WD_DEBUG_REG1                                      regWD_DEBUG_REG1;
typedef union WD_DEBUG_REG2                                      regWD_DEBUG_REG2;
typedef union WD_DEBUG_REG3                                      regWD_DEBUG_REG3;
typedef union WD_DEBUG_REG5                                      regWD_DEBUG_REG5;
typedef union WD_DEBUG_REG7                                      regWD_DEBUG_REG7;
typedef union WD_DEBUG_REG9                                      regWD_DEBUG_REG9;
typedef union WD_DEBUG_REG14                                     regWD_DEBUG_REG14;
typedef union WD_DEBUG_REG15                                     regWD_DEBUG_REG15;
typedef union WD_DEBUG_REG16                                     regWD_DEBUG_REG16;
typedef union WD_DEBUG_REG17                                     regWD_DEBUG_REG17;
typedef union WD_DEBUG_REG18                                     regWD_DEBUG_REG18;
typedef union WD_DEBUG_REG19                                     regWD_DEBUG_REG19;
typedef union WD_DEBUG_REG20                                     regWD_DEBUG_REG20;
typedef union WD_DEBUG_REG21                                     regWD_DEBUG_REG21;
typedef union WD_DEBUG_REG22                                     regWD_DEBUG_REG22;
typedef union WD_ENHANCE                                         regWD_ENHANCE;
typedef union WD_INDEX_BUF_BASE                                  regWD_INDEX_BUF_BASE;
typedef union WD_INDEX_BUF_BASE_HI                               regWD_INDEX_BUF_BASE_HI;
typedef union WD_PERFCOUNTER0_HI                                 regWD_PERFCOUNTER0_HI;
typedef union WD_PERFCOUNTER0_LO                                 regWD_PERFCOUNTER0_LO;
typedef union WD_PERFCOUNTER0_SELECT                             regWD_PERFCOUNTER0_SELECT;
typedef union WD_PERFCOUNTER1_HI                                 regWD_PERFCOUNTER1_HI;
typedef union WD_PERFCOUNTER1_LO                                 regWD_PERFCOUNTER1_LO;
typedef union WD_PERFCOUNTER1_SELECT                             regWD_PERFCOUNTER1_SELECT;
typedef union WD_PERFCOUNTER2_HI                                 regWD_PERFCOUNTER2_HI;
typedef union WD_PERFCOUNTER2_LO                                 regWD_PERFCOUNTER2_LO;
typedef union WD_PERFCOUNTER2_SELECT                             regWD_PERFCOUNTER2_SELECT;
typedef union WD_PERFCOUNTER3_HI                                 regWD_PERFCOUNTER3_HI;
typedef union WD_PERFCOUNTER3_LO                                 regWD_PERFCOUNTER3_LO;
typedef union WD_PERFCOUNTER3_SELECT                             regWD_PERFCOUNTER3_SELECT;
typedef union WD_POS_BUF_BASE                                    regWD_POS_BUF_BASE;
typedef union WD_POS_BUF_BASE_HI                                 regWD_POS_BUF_BASE_HI;
typedef union WD_QOS                                             regWD_QOS;
typedef union WD_UTCL1_CNTL                                      regWD_UTCL1_CNTL;
typedef union WD_UTCL1_STATUS                                    regWD_UTCL1_STATUS;
