/*
 ***********************************************************************************************************************
 *
 *  Copyright (c) 2019 Advanced Micro Devices, Inc. All Rights Reserved.
 *
 *  Permission is hereby granted, free of charge, to any person obtaining a copy
 *  of this software and associated documentation files (the "Software"), to deal
 *  in the Software without restriction, including without limitation the rights
 *  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 *  copies of the Software, and to permit persons to whom the Software is
 *  furnished to do so, subject to the following conditions:
 *
 *  The above copyright notice and this permission notice shall be included in all
 *  copies or substantial portions of the Software.
 *
 *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 *  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 *  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 *  SOFTWARE.
 *
 **********************************************************************************************************************/

#pragma once

constexpr unsigned int mmCB_BLEND0_CONTROL                                = 0xA1E0;
constexpr unsigned int mmCB_BLEND1_CONTROL                                = 0xA1E1;
constexpr unsigned int mmCB_BLEND2_CONTROL                                = 0xA1E2;
constexpr unsigned int mmCB_BLEND3_CONTROL                                = 0xA1E3;
constexpr unsigned int mmCB_BLEND4_CONTROL                                = 0xA1E4;
constexpr unsigned int mmCB_BLEND5_CONTROL                                = 0xA1E5;
constexpr unsigned int mmCB_BLEND6_CONTROL                                = 0xA1E6;
constexpr unsigned int mmCB_BLEND7_CONTROL                                = 0xA1E7;
constexpr unsigned int mmCB_BLEND_ALPHA                                   = 0xA108;
constexpr unsigned int mmCB_BLEND_BLUE                                    = 0xA107;
constexpr unsigned int mmCB_BLEND_GREEN                                   = 0xA106;
constexpr unsigned int mmCB_BLEND_RED                                     = 0xA105;
constexpr unsigned int mmCB_CGTT_SCLK_CTRL                                = 0xF0A8;
constexpr unsigned int mmCB_COLOR0_ATTRIB                                 = 0xA31D;
constexpr unsigned int mmCB_COLOR0_BASE                                   = 0xA318;
constexpr unsigned int mmCB_COLOR0_CLEAR_WORD0                            = 0xA323;
constexpr unsigned int mmCB_COLOR0_CLEAR_WORD1                            = 0xA324;
constexpr unsigned int mmCB_COLOR0_CMASK                                  = 0xA31F;
constexpr unsigned int mmCB_COLOR0_DCC_BASE                               = 0xA325;
constexpr unsigned int mmCB_COLOR0_DCC_CONTROL                            = 0xA31E;
constexpr unsigned int mmCB_COLOR0_FMASK                                  = 0xA321;
constexpr unsigned int mmCB_COLOR0_INFO                                   = 0xA31C;
constexpr unsigned int mmCB_COLOR0_VIEW                                   = 0xA31B;
constexpr unsigned int mmCB_COLOR1_ATTRIB                                 = 0xA32C;
constexpr unsigned int mmCB_COLOR1_BASE                                   = 0xA327;
constexpr unsigned int mmCB_COLOR1_CLEAR_WORD0                            = 0xA332;
constexpr unsigned int mmCB_COLOR1_CLEAR_WORD1                            = 0xA333;
constexpr unsigned int mmCB_COLOR1_CMASK                                  = 0xA32E;
constexpr unsigned int mmCB_COLOR1_DCC_BASE                               = 0xA334;
constexpr unsigned int mmCB_COLOR1_DCC_CONTROL                            = 0xA32D;
constexpr unsigned int mmCB_COLOR1_FMASK                                  = 0xA330;
constexpr unsigned int mmCB_COLOR1_INFO                                   = 0xA32B;
constexpr unsigned int mmCB_COLOR1_VIEW                                   = 0xA32A;
constexpr unsigned int mmCB_COLOR2_ATTRIB                                 = 0xA33B;
constexpr unsigned int mmCB_COLOR2_BASE                                   = 0xA336;
constexpr unsigned int mmCB_COLOR2_CLEAR_WORD0                            = 0xA341;
constexpr unsigned int mmCB_COLOR2_CLEAR_WORD1                            = 0xA342;
constexpr unsigned int mmCB_COLOR2_CMASK                                  = 0xA33D;
constexpr unsigned int mmCB_COLOR2_DCC_BASE                               = 0xA343;
constexpr unsigned int mmCB_COLOR2_DCC_CONTROL                            = 0xA33C;
constexpr unsigned int mmCB_COLOR2_FMASK                                  = 0xA33F;
constexpr unsigned int mmCB_COLOR2_INFO                                   = 0xA33A;
constexpr unsigned int mmCB_COLOR2_VIEW                                   = 0xA339;
constexpr unsigned int mmCB_COLOR3_ATTRIB                                 = 0xA34A;
constexpr unsigned int mmCB_COLOR3_BASE                                   = 0xA345;
constexpr unsigned int mmCB_COLOR3_CLEAR_WORD0                            = 0xA350;
constexpr unsigned int mmCB_COLOR3_CLEAR_WORD1                            = 0xA351;
constexpr unsigned int mmCB_COLOR3_CMASK                                  = 0xA34C;
constexpr unsigned int mmCB_COLOR3_DCC_BASE                               = 0xA352;
constexpr unsigned int mmCB_COLOR3_DCC_CONTROL                            = 0xA34B;
constexpr unsigned int mmCB_COLOR3_FMASK                                  = 0xA34E;
constexpr unsigned int mmCB_COLOR3_INFO                                   = 0xA349;
constexpr unsigned int mmCB_COLOR3_VIEW                                   = 0xA348;
constexpr unsigned int mmCB_COLOR4_ATTRIB                                 = 0xA359;
constexpr unsigned int mmCB_COLOR4_BASE                                   = 0xA354;
constexpr unsigned int mmCB_COLOR4_CLEAR_WORD0                            = 0xA35F;
constexpr unsigned int mmCB_COLOR4_CLEAR_WORD1                            = 0xA360;
constexpr unsigned int mmCB_COLOR4_CMASK                                  = 0xA35B;
constexpr unsigned int mmCB_COLOR4_DCC_BASE                               = 0xA361;
constexpr unsigned int mmCB_COLOR4_DCC_CONTROL                            = 0xA35A;
constexpr unsigned int mmCB_COLOR4_FMASK                                  = 0xA35D;
constexpr unsigned int mmCB_COLOR4_INFO                                   = 0xA358;
constexpr unsigned int mmCB_COLOR4_VIEW                                   = 0xA357;
constexpr unsigned int mmCB_COLOR5_ATTRIB                                 = 0xA368;
constexpr unsigned int mmCB_COLOR5_BASE                                   = 0xA363;
constexpr unsigned int mmCB_COLOR5_CLEAR_WORD0                            = 0xA36E;
constexpr unsigned int mmCB_COLOR5_CLEAR_WORD1                            = 0xA36F;
constexpr unsigned int mmCB_COLOR5_CMASK                                  = 0xA36A;
constexpr unsigned int mmCB_COLOR5_DCC_BASE                               = 0xA370;
constexpr unsigned int mmCB_COLOR5_DCC_CONTROL                            = 0xA369;
constexpr unsigned int mmCB_COLOR5_FMASK                                  = 0xA36C;
constexpr unsigned int mmCB_COLOR5_INFO                                   = 0xA367;
constexpr unsigned int mmCB_COLOR5_VIEW                                   = 0xA366;
constexpr unsigned int mmCB_COLOR6_ATTRIB                                 = 0xA377;
constexpr unsigned int mmCB_COLOR6_BASE                                   = 0xA372;
constexpr unsigned int mmCB_COLOR6_CLEAR_WORD0                            = 0xA37D;
constexpr unsigned int mmCB_COLOR6_CLEAR_WORD1                            = 0xA37E;
constexpr unsigned int mmCB_COLOR6_CMASK                                  = 0xA379;
constexpr unsigned int mmCB_COLOR6_DCC_BASE                               = 0xA37F;
constexpr unsigned int mmCB_COLOR6_DCC_CONTROL                            = 0xA378;
constexpr unsigned int mmCB_COLOR6_FMASK                                  = 0xA37B;
constexpr unsigned int mmCB_COLOR6_INFO                                   = 0xA376;
constexpr unsigned int mmCB_COLOR6_VIEW                                   = 0xA375;
constexpr unsigned int mmCB_COLOR7_ATTRIB                                 = 0xA386;
constexpr unsigned int mmCB_COLOR7_BASE                                   = 0xA381;
constexpr unsigned int mmCB_COLOR7_CLEAR_WORD0                            = 0xA38C;
constexpr unsigned int mmCB_COLOR7_CLEAR_WORD1                            = 0xA38D;
constexpr unsigned int mmCB_COLOR7_CMASK                                  = 0xA388;
constexpr unsigned int mmCB_COLOR7_DCC_BASE                               = 0xA38E;
constexpr unsigned int mmCB_COLOR7_DCC_CONTROL                            = 0xA387;
constexpr unsigned int mmCB_COLOR7_FMASK                                  = 0xA38A;
constexpr unsigned int mmCB_COLOR7_INFO                                   = 0xA385;
constexpr unsigned int mmCB_COLOR7_VIEW                                   = 0xA384;
constexpr unsigned int mmCB_COLOR_CONTROL                                 = 0xA202;
constexpr unsigned int mmCB_DCC_CONTROL                                   = 0xA109;
constexpr unsigned int mmCB_HW_CONTROL_3                                  = 0x2683;
constexpr unsigned int mmCB_PERFCOUNTER0_HI                               = 0xD407;
constexpr unsigned int mmCB_PERFCOUNTER0_LO                               = 0xD406;
constexpr unsigned int mmCB_PERFCOUNTER0_SELECT                           = 0xDC01;
constexpr unsigned int mmCB_PERFCOUNTER0_SELECT1                          = 0xDC02;
constexpr unsigned int mmCB_PERFCOUNTER1_HI                               = 0xD409;
constexpr unsigned int mmCB_PERFCOUNTER1_LO                               = 0xD408;
constexpr unsigned int mmCB_PERFCOUNTER1_SELECT                           = 0xDC03;
constexpr unsigned int mmCB_PERFCOUNTER2_HI                               = 0xD40B;
constexpr unsigned int mmCB_PERFCOUNTER2_LO                               = 0xD40A;
constexpr unsigned int mmCB_PERFCOUNTER2_SELECT                           = 0xDC04;
constexpr unsigned int mmCB_PERFCOUNTER3_HI                               = 0xD40D;
constexpr unsigned int mmCB_PERFCOUNTER3_LO                               = 0xD40C;
constexpr unsigned int mmCB_PERFCOUNTER3_SELECT                           = 0xDC05;
constexpr unsigned int mmCB_PERFCOUNTER_FILTER                            = 0xDC00;
constexpr unsigned int mmCB_SHADER_MASK                                   = 0xA08F;
constexpr unsigned int mmCB_TARGET_MASK                                   = 0xA08E;
constexpr unsigned int mmCOHER_DEST_BASE_0                                = 0xA092;
constexpr unsigned int mmCOHER_DEST_BASE_1                                = 0xA093;
constexpr unsigned int mmCOHER_DEST_BASE_2                                = 0xA07E;
constexpr unsigned int mmCOHER_DEST_BASE_3                                = 0xA07F;
constexpr unsigned int mmCOHER_DEST_BASE_HI_0                             = 0xA07A;
constexpr unsigned int mmCOHER_DEST_BASE_HI_1                             = 0xA07B;
constexpr unsigned int mmCOHER_DEST_BASE_HI_2                             = 0xA07C;
constexpr unsigned int mmCOHER_DEST_BASE_HI_3                             = 0xA07D;
constexpr unsigned int mmCOMPUTE_DIM_X                                    = 0x2E01;
constexpr unsigned int mmCOMPUTE_DIM_Y                                    = 0x2E02;
constexpr unsigned int mmCOMPUTE_DIM_Z                                    = 0x2E03;
constexpr unsigned int mmCOMPUTE_DISPATCH_ID                              = 0x2E20;
constexpr unsigned int mmCOMPUTE_DISPATCH_INITIATOR                       = 0x2E00;
constexpr unsigned int mmCOMPUTE_DISPATCH_PKT_ADDR_HI                     = 0x2E0F;
constexpr unsigned int mmCOMPUTE_DISPATCH_PKT_ADDR_LO                     = 0x2E0E;
constexpr unsigned int mmCOMPUTE_DISPATCH_SCRATCH_BASE_HI                 = 0x2E11;
constexpr unsigned int mmCOMPUTE_DISPATCH_SCRATCH_BASE_LO                 = 0x2E10;
constexpr unsigned int mmCOMPUTE_MISC_RESERVED                            = 0x2E1F;
constexpr unsigned int mmCOMPUTE_NOWHERE                                  = 0x2E7F;
constexpr unsigned int mmCOMPUTE_NUM_THREAD_X                             = 0x2E07;
constexpr unsigned int mmCOMPUTE_NUM_THREAD_Y                             = 0x2E08;
constexpr unsigned int mmCOMPUTE_NUM_THREAD_Z                             = 0x2E09;
constexpr unsigned int mmCOMPUTE_PERFCOUNT_ENABLE                         = 0x2E0B;
constexpr unsigned int mmCOMPUTE_PGM_HI                                   = 0x2E0D;
constexpr unsigned int mmCOMPUTE_PGM_LO                                   = 0x2E0C;
constexpr unsigned int mmCOMPUTE_PGM_RSRC1                                = 0x2E12;
constexpr unsigned int mmCOMPUTE_PGM_RSRC2                                = 0x2E13;
constexpr unsigned int mmCOMPUTE_PIPELINESTAT_ENABLE                      = 0x2E0A;
constexpr unsigned int mmCOMPUTE_RESOURCE_LIMITS                          = 0x2E15;
constexpr unsigned int mmCOMPUTE_RESTART_X                                = 0x2E1B;
constexpr unsigned int mmCOMPUTE_RESTART_Y                                = 0x2E1C;
constexpr unsigned int mmCOMPUTE_RESTART_Z                                = 0x2E1D;
constexpr unsigned int mmCOMPUTE_START_X                                  = 0x2E04;
constexpr unsigned int mmCOMPUTE_START_Y                                  = 0x2E05;
constexpr unsigned int mmCOMPUTE_START_Z                                  = 0x2E06;
constexpr unsigned int mmCOMPUTE_STATIC_THREAD_MGMT_SE0                   = 0x2E16;
constexpr unsigned int mmCOMPUTE_STATIC_THREAD_MGMT_SE1                   = 0x2E17;
constexpr unsigned int mmCOMPUTE_STATIC_THREAD_MGMT_SE2                   = 0x2E19;
constexpr unsigned int mmCOMPUTE_STATIC_THREAD_MGMT_SE3                   = 0x2E1A;
constexpr unsigned int mmCOMPUTE_THREADGROUP_ID                           = 0x2E21;
constexpr unsigned int mmCOMPUTE_THREAD_TRACE_ENABLE                      = 0x2E1E;
constexpr unsigned int mmCOMPUTE_TMPRING_SIZE                             = 0x2E18;
constexpr unsigned int mmCOMPUTE_USER_DATA_0                              = 0x2E40;
constexpr unsigned int mmCOMPUTE_USER_DATA_1                              = 0x2E41;
constexpr unsigned int mmCOMPUTE_USER_DATA_2                              = 0x2E42;
constexpr unsigned int mmCOMPUTE_USER_DATA_3                              = 0x2E43;
constexpr unsigned int mmCOMPUTE_USER_DATA_4                              = 0x2E44;
constexpr unsigned int mmCOMPUTE_USER_DATA_5                              = 0x2E45;
constexpr unsigned int mmCOMPUTE_USER_DATA_6                              = 0x2E46;
constexpr unsigned int mmCOMPUTE_USER_DATA_7                              = 0x2E47;
constexpr unsigned int mmCOMPUTE_USER_DATA_8                              = 0x2E48;
constexpr unsigned int mmCOMPUTE_USER_DATA_9                              = 0x2E49;
constexpr unsigned int mmCOMPUTE_USER_DATA_10                             = 0x2E4A;
constexpr unsigned int mmCOMPUTE_USER_DATA_11                             = 0x2E4B;
constexpr unsigned int mmCOMPUTE_USER_DATA_12                             = 0x2E4C;
constexpr unsigned int mmCOMPUTE_USER_DATA_13                             = 0x2E4D;
constexpr unsigned int mmCOMPUTE_USER_DATA_14                             = 0x2E4E;
constexpr unsigned int mmCOMPUTE_USER_DATA_15                             = 0x2E4F;
constexpr unsigned int mmCOMPUTE_VMID                                     = 0x2E14;
constexpr unsigned int mmCPC_PERFCOUNTER0_HI                              = 0xD007;
constexpr unsigned int mmCPC_PERFCOUNTER0_LO                              = 0xD006;
constexpr unsigned int mmCPC_PERFCOUNTER0_SELECT                          = 0xD809;
constexpr unsigned int mmCPC_PERFCOUNTER0_SELECT1                         = 0xD804;
constexpr unsigned int mmCPC_PERFCOUNTER1_HI                              = 0xD005;
constexpr unsigned int mmCPC_PERFCOUNTER1_LO                              = 0xD004;
constexpr unsigned int mmCPC_PERFCOUNTER1_SELECT                          = 0xD803;
constexpr unsigned int mmCPF_PERFCOUNTER0_HI                              = 0xD00B;
constexpr unsigned int mmCPF_PERFCOUNTER0_LO                              = 0xD00A;
constexpr unsigned int mmCPF_PERFCOUNTER0_SELECT                          = 0xD807;
constexpr unsigned int mmCPF_PERFCOUNTER0_SELECT1                         = 0xD806;
constexpr unsigned int mmCPF_PERFCOUNTER1_HI                              = 0xD009;
constexpr unsigned int mmCPF_PERFCOUNTER1_LO                              = 0xD008;
constexpr unsigned int mmCPF_PERFCOUNTER1_SELECT                          = 0xD805;
constexpr unsigned int mmCPG_PERFCOUNTER0_HI                              = 0xD003;
constexpr unsigned int mmCPG_PERFCOUNTER0_LO                              = 0xD002;
constexpr unsigned int mmCPG_PERFCOUNTER0_SELECT                          = 0xD802;
constexpr unsigned int mmCPG_PERFCOUNTER0_SELECT1                         = 0xD801;
constexpr unsigned int mmCPG_PERFCOUNTER1_HI                              = 0xD001;
constexpr unsigned int mmCPG_PERFCOUNTER1_LO                              = 0xD000;
constexpr unsigned int mmCPG_PERFCOUNTER1_SELECT                          = 0xD800;
constexpr unsigned int mmCP_COHER_BASE                                    = 0xC07E;
constexpr unsigned int mmCP_COHER_BASE_HI                                 = 0xC079;
constexpr unsigned int mmCP_COHER_CNTL                                    = 0xC07C;
constexpr unsigned int mmCP_COHER_SIZE                                    = 0xC07D;
constexpr unsigned int mmCP_COHER_SIZE_HI                                 = 0xC08C;
constexpr unsigned int mmCP_COHER_START_DELAY                             = 0xC07B;
constexpr unsigned int mmCP_COHER_STATUS                                  = 0xC07F;
constexpr unsigned int mmCP_ME_COHER_BASE                                 = 0xC101;
constexpr unsigned int mmCP_ME_COHER_BASE_HI                              = 0xC102;
constexpr unsigned int mmCP_ME_COHER_CNTL                                 = 0xC0FE;
constexpr unsigned int mmCP_ME_COHER_SIZE                                 = 0xC0FF;
constexpr unsigned int mmCP_ME_COHER_SIZE_HI                              = 0xC100;
constexpr unsigned int mmCP_ME_COHER_STATUS                               = 0xC103;
constexpr unsigned int mmCP_NUM_PRIM_NEEDED_COUNT0_HI                     = 0xC00B;
constexpr unsigned int mmCP_NUM_PRIM_NEEDED_COUNT0_LO                     = 0xC00A;
constexpr unsigned int mmCP_NUM_PRIM_NEEDED_COUNT1_HI                     = 0xC00F;
constexpr unsigned int mmCP_NUM_PRIM_NEEDED_COUNT1_LO                     = 0xC00E;
constexpr unsigned int mmCP_NUM_PRIM_NEEDED_COUNT2_HI                     = 0xC013;
constexpr unsigned int mmCP_NUM_PRIM_NEEDED_COUNT2_LO                     = 0xC012;
constexpr unsigned int mmCP_NUM_PRIM_NEEDED_COUNT3_HI                     = 0xC017;
constexpr unsigned int mmCP_NUM_PRIM_NEEDED_COUNT3_LO                     = 0xC016;
constexpr unsigned int mmCP_NUM_PRIM_WRITTEN_COUNT0_HI                    = 0xC009;
constexpr unsigned int mmCP_NUM_PRIM_WRITTEN_COUNT0_LO                    = 0xC008;
constexpr unsigned int mmCP_NUM_PRIM_WRITTEN_COUNT1_HI                    = 0xC00D;
constexpr unsigned int mmCP_NUM_PRIM_WRITTEN_COUNT1_LO                    = 0xC00C;
constexpr unsigned int mmCP_NUM_PRIM_WRITTEN_COUNT2_HI                    = 0xC011;
constexpr unsigned int mmCP_NUM_PRIM_WRITTEN_COUNT2_LO                    = 0xC010;
constexpr unsigned int mmCP_NUM_PRIM_WRITTEN_COUNT3_HI                    = 0xC015;
constexpr unsigned int mmCP_NUM_PRIM_WRITTEN_COUNT3_LO                    = 0xC014;
constexpr unsigned int mmCP_PERFMON_CNTL                                  = 0xD808;
constexpr unsigned int mmCP_PERFMON_CNTX_CNTL                             = 0xA0D8;
constexpr unsigned int mmCP_SC_PSINVOC_COUNT0_HI                          = 0xC02D;
constexpr unsigned int mmCP_SC_PSINVOC_COUNT0_LO                          = 0xC02C;
constexpr unsigned int mmCP_SC_PSINVOC_COUNT1_HI                          = 0xC02F;
constexpr unsigned int mmCP_SC_PSINVOC_COUNT1_LO                          = 0xC02E;
constexpr unsigned int mmCP_STRMOUT_CNTL                                  = 0xC03F;
constexpr unsigned int mmCP_VGT_CSINVOC_COUNT_HI                          = 0xC031;
constexpr unsigned int mmCP_VGT_CSINVOC_COUNT_LO                          = 0xC030;
constexpr unsigned int mmCP_VGT_DSINVOC_COUNT_HI                          = 0xC027;
constexpr unsigned int mmCP_VGT_DSINVOC_COUNT_LO                          = 0xC026;
constexpr unsigned int mmCP_VGT_GSINVOC_COUNT_HI                          = 0xC023;
constexpr unsigned int mmCP_VGT_GSINVOC_COUNT_LO                          = 0xC022;
constexpr unsigned int mmCP_VGT_GSPRIM_COUNT_HI                           = 0xC01F;
constexpr unsigned int mmCP_VGT_GSPRIM_COUNT_LO                           = 0xC01E;
constexpr unsigned int mmCP_VGT_HSINVOC_COUNT_HI                          = 0xC025;
constexpr unsigned int mmCP_VGT_HSINVOC_COUNT_LO                          = 0xC024;
constexpr unsigned int mmCP_VGT_IAPRIM_COUNT_HI                           = 0xC01D;
constexpr unsigned int mmCP_VGT_IAPRIM_COUNT_LO                           = 0xC01C;
constexpr unsigned int mmCP_VGT_IAVERT_COUNT_HI                           = 0xC01B;
constexpr unsigned int mmCP_VGT_IAVERT_COUNT_LO                           = 0xC01A;
constexpr unsigned int mmCP_VGT_VSINVOC_COUNT_HI                          = 0xC021;
constexpr unsigned int mmCP_VGT_VSINVOC_COUNT_LO                          = 0xC020;
constexpr unsigned int mmDB_ALPHA_TO_MASK                                 = 0xA2DC;
constexpr unsigned int mmDB_CGTT_CLK_CTRL_0                               = 0xF0A4;
constexpr unsigned int mmDB_COUNT_CONTROL                                 = 0xA001;
constexpr unsigned int mmDB_CREDIT_LIMIT                                  = 0x2614;
constexpr unsigned int mmDB_DEPTH_BOUNDS_MAX                              = 0xA009;
constexpr unsigned int mmDB_DEPTH_BOUNDS_MIN                              = 0xA008;
constexpr unsigned int mmDB_DEPTH_CLEAR                                   = 0xA00B;
constexpr unsigned int mmDB_DEPTH_CONTROL                                 = 0xA200;
constexpr unsigned int mmDB_DEPTH_VIEW                                    = 0xA002;
constexpr unsigned int mmDB_EQAA                                          = 0xA201;
constexpr unsigned int mmDB_FIFO_DEPTH1                                   = 0x2618;
constexpr unsigned int mmDB_FIFO_DEPTH2                                   = 0x2619;
constexpr unsigned int mmDB_FREE_CACHELINES                               = 0x2617;
constexpr unsigned int mmDB_HTILE_DATA_BASE                               = 0xA005;
constexpr unsigned int mmDB_HTILE_SURFACE                                 = 0xA2AF;
constexpr unsigned int mmDB_MEM_ARB_WATERMARKS                            = 0x261C;
constexpr unsigned int mmDB_OCCLUSION_COUNT0_HI                           = 0xC3C1;
constexpr unsigned int mmDB_OCCLUSION_COUNT0_LOW                          = 0xC3C0;
constexpr unsigned int mmDB_OCCLUSION_COUNT1_HI                           = 0xC3C3;
constexpr unsigned int mmDB_OCCLUSION_COUNT1_LOW                          = 0xC3C2;
constexpr unsigned int mmDB_OCCLUSION_COUNT2_HI                           = 0xC3C5;
constexpr unsigned int mmDB_OCCLUSION_COUNT2_LOW                          = 0xC3C4;
constexpr unsigned int mmDB_OCCLUSION_COUNT3_HI                           = 0xC3C7;
constexpr unsigned int mmDB_OCCLUSION_COUNT3_LOW                          = 0xC3C6;
constexpr unsigned int mmDB_PERFCOUNTER0_HI                               = 0xD441;
constexpr unsigned int mmDB_PERFCOUNTER0_LO                               = 0xD440;
constexpr unsigned int mmDB_PERFCOUNTER0_SELECT                           = 0xDC40;
constexpr unsigned int mmDB_PERFCOUNTER0_SELECT1                          = 0xDC41;
constexpr unsigned int mmDB_PERFCOUNTER1_HI                               = 0xD443;
constexpr unsigned int mmDB_PERFCOUNTER1_LO                               = 0xD442;
constexpr unsigned int mmDB_PERFCOUNTER1_SELECT                           = 0xDC42;
constexpr unsigned int mmDB_PERFCOUNTER1_SELECT1                          = 0xDC43;
constexpr unsigned int mmDB_PERFCOUNTER2_HI                               = 0xD445;
constexpr unsigned int mmDB_PERFCOUNTER2_LO                               = 0xD444;
constexpr unsigned int mmDB_PERFCOUNTER2_SELECT                           = 0xDC44;
constexpr unsigned int mmDB_PERFCOUNTER3_HI                               = 0xD447;
constexpr unsigned int mmDB_PERFCOUNTER3_LO                               = 0xD446;
constexpr unsigned int mmDB_PERFCOUNTER3_SELECT                           = 0xDC46;
constexpr unsigned int mmDB_PRELOAD_CONTROL                               = 0xA2B2;
constexpr unsigned int mmDB_RENDER_CONTROL                                = 0xA000;
constexpr unsigned int mmDB_RENDER_OVERRIDE                               = 0xA003;
constexpr unsigned int mmDB_RENDER_OVERRIDE2                              = 0xA004;
constexpr unsigned int mmDB_RING_CONTROL                                  = 0x261B;
constexpr unsigned int mmDB_SHADER_CONTROL                                = 0xA203;
constexpr unsigned int mmDB_SRESULTS_COMPARE_STATE0                       = 0xA2B0;
constexpr unsigned int mmDB_SRESULTS_COMPARE_STATE1                       = 0xA2B1;
constexpr unsigned int mmDB_STENCILREFMASK                                = 0xA10C;
constexpr unsigned int mmDB_STENCILREFMASK_BF                             = 0xA10D;
constexpr unsigned int mmDB_STENCIL_CLEAR                                 = 0xA00A;
constexpr unsigned int mmDB_STENCIL_CONTROL                               = 0xA10B;
constexpr unsigned int mmDB_SUBTILE_CONTROL                               = 0x2616;
constexpr unsigned int mmDB_WATERMARKS                                    = 0x2615;
constexpr unsigned int mmDB_ZPASS_COUNT_HI                                = 0xC3FF;
constexpr unsigned int mmDB_ZPASS_COUNT_LOW                               = 0xC3FE;
constexpr unsigned int mmDB_Z_WRITE_BASE                                  = 0xA014;
constexpr unsigned int mmGB_ADDR_CONFIG                                   = 0x263E;
constexpr unsigned int mmGB_ADDR_CONFIG_READ                              = 0x2642;
constexpr unsigned int mmGDS_PERFCOUNTER0_HI                              = 0xD281;
constexpr unsigned int mmGDS_PERFCOUNTER0_LO                              = 0xD280;
constexpr unsigned int mmGDS_PERFCOUNTER0_SELECT                          = 0xDA80;
constexpr unsigned int mmGDS_PERFCOUNTER0_SELECT1                         = 0xDA84;
constexpr unsigned int mmGDS_PERFCOUNTER1_HI                              = 0xD283;
constexpr unsigned int mmGDS_PERFCOUNTER1_LO                              = 0xD282;
constexpr unsigned int mmGDS_PERFCOUNTER1_SELECT                          = 0xDA81;
constexpr unsigned int mmGDS_PERFCOUNTER2_HI                              = 0xD285;
constexpr unsigned int mmGDS_PERFCOUNTER2_LO                              = 0xD284;
constexpr unsigned int mmGDS_PERFCOUNTER2_SELECT                          = 0xDA82;
constexpr unsigned int mmGDS_PERFCOUNTER3_HI                              = 0xD287;
constexpr unsigned int mmGDS_PERFCOUNTER3_LO                              = 0xD286;
constexpr unsigned int mmGDS_PERFCOUNTER3_SELECT                          = 0xDA83;
constexpr unsigned int mmGRBM_GFX_INDEX                                   = 0xC200;
constexpr unsigned int mmGRBM_GFX_INDEX_SR_DATA                           = 0xFA01;
constexpr unsigned int mmGRBM_GFX_INDEX_SR_SELECT                         = 0xFA00;
constexpr unsigned int mmGRBM_PERFCOUNTER0_HI                             = 0xD041;
constexpr unsigned int mmGRBM_PERFCOUNTER0_LO                             = 0xD040;
constexpr unsigned int mmGRBM_PERFCOUNTER0_SELECT                         = 0xD840;
constexpr unsigned int mmGRBM_PERFCOUNTER1_HI                             = 0xD044;
constexpr unsigned int mmGRBM_PERFCOUNTER1_LO                             = 0xD043;
constexpr unsigned int mmGRBM_PERFCOUNTER1_SELECT                         = 0xD841;
constexpr unsigned int mmGRBM_SE0_PERFCOUNTER_HI                          = 0xD046;
constexpr unsigned int mmGRBM_SE0_PERFCOUNTER_LO                          = 0xD045;
constexpr unsigned int mmGRBM_SE0_PERFCOUNTER_SELECT                      = 0xD842;
constexpr unsigned int mmGRBM_SE1_PERFCOUNTER_HI                          = 0xD048;
constexpr unsigned int mmGRBM_SE1_PERFCOUNTER_LO                          = 0xD047;
constexpr unsigned int mmGRBM_SE1_PERFCOUNTER_SELECT                      = 0xD843;
constexpr unsigned int mmGRBM_SE2_PERFCOUNTER_HI                          = 0xD04A;
constexpr unsigned int mmGRBM_SE2_PERFCOUNTER_LO                          = 0xD049;
constexpr unsigned int mmGRBM_SE2_PERFCOUNTER_SELECT                      = 0xD844;
constexpr unsigned int mmGRBM_SE3_PERFCOUNTER_HI                          = 0xD04C;
constexpr unsigned int mmGRBM_SE3_PERFCOUNTER_LO                          = 0xD04B;
constexpr unsigned int mmGRBM_SE3_PERFCOUNTER_SELECT                      = 0xD845;
constexpr unsigned int mmIA_ENHANCE                                       = 0xA29C;
constexpr unsigned int mmIA_UTCL1_CNTL                                    = 0x2246;
constexpr unsigned int mmIA_UTCL1_STATUS                                  = 0x2247;
constexpr unsigned int mmPA_CL_CLIP_CNTL                                  = 0xA204;
constexpr unsigned int mmPA_CL_CNTL_STATUS                                = 0x2284;
constexpr unsigned int mmPA_CL_ENHANCE                                    = 0x2285;
constexpr unsigned int mmPA_CL_GB_HORZ_CLIP_ADJ                           = 0xA2FC;
constexpr unsigned int mmPA_CL_GB_HORZ_DISC_ADJ                           = 0xA2FD;
constexpr unsigned int mmPA_CL_GB_VERT_CLIP_ADJ                           = 0xA2FA;
constexpr unsigned int mmPA_CL_GB_VERT_DISC_ADJ                           = 0xA2FB;
constexpr unsigned int mmPA_CL_NANINF_CNTL                                = 0xA208;
constexpr unsigned int mmPA_CL_NGG_CNTL                                   = 0xA20E;
constexpr unsigned int mmPA_CL_POINT_CULL_RAD                             = 0xA1F8;
constexpr unsigned int mmPA_CL_POINT_SIZE                                 = 0xA1F7;
constexpr unsigned int mmPA_CL_POINT_X_RAD                                = 0xA1F5;
constexpr unsigned int mmPA_CL_POINT_Y_RAD                                = 0xA1F6;
constexpr unsigned int mmPA_CL_UCP_0_W                                    = 0xA172;
constexpr unsigned int mmPA_CL_UCP_0_X                                    = 0xA16F;
constexpr unsigned int mmPA_CL_UCP_0_Y                                    = 0xA170;
constexpr unsigned int mmPA_CL_UCP_0_Z                                    = 0xA171;
constexpr unsigned int mmPA_CL_UCP_1_W                                    = 0xA176;
constexpr unsigned int mmPA_CL_UCP_1_X                                    = 0xA173;
constexpr unsigned int mmPA_CL_UCP_1_Y                                    = 0xA174;
constexpr unsigned int mmPA_CL_UCP_1_Z                                    = 0xA175;
constexpr unsigned int mmPA_CL_UCP_2_W                                    = 0xA17A;
constexpr unsigned int mmPA_CL_UCP_2_X                                    = 0xA177;
constexpr unsigned int mmPA_CL_UCP_2_Y                                    = 0xA178;
constexpr unsigned int mmPA_CL_UCP_2_Z                                    = 0xA179;
constexpr unsigned int mmPA_CL_UCP_3_W                                    = 0xA17E;
constexpr unsigned int mmPA_CL_UCP_3_X                                    = 0xA17B;
constexpr unsigned int mmPA_CL_UCP_3_Y                                    = 0xA17C;
constexpr unsigned int mmPA_CL_UCP_3_Z                                    = 0xA17D;
constexpr unsigned int mmPA_CL_UCP_4_W                                    = 0xA182;
constexpr unsigned int mmPA_CL_UCP_4_X                                    = 0xA17F;
constexpr unsigned int mmPA_CL_UCP_4_Y                                    = 0xA180;
constexpr unsigned int mmPA_CL_UCP_4_Z                                    = 0xA181;
constexpr unsigned int mmPA_CL_UCP_5_W                                    = 0xA186;
constexpr unsigned int mmPA_CL_UCP_5_X                                    = 0xA183;
constexpr unsigned int mmPA_CL_UCP_5_Y                                    = 0xA184;
constexpr unsigned int mmPA_CL_UCP_5_Z                                    = 0xA185;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET                              = 0xA110;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_1                            = 0xA116;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_2                            = 0xA11C;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_3                            = 0xA122;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_4                            = 0xA128;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_5                            = 0xA12E;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_6                            = 0xA134;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_7                            = 0xA13A;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_8                            = 0xA140;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_9                            = 0xA146;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_10                           = 0xA14C;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_11                           = 0xA152;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_12                           = 0xA158;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_13                           = 0xA15E;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_14                           = 0xA164;
constexpr unsigned int mmPA_CL_VPORT_XOFFSET_15                           = 0xA16A;
constexpr unsigned int mmPA_CL_VPORT_XSCALE                               = 0xA10F;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_1                             = 0xA115;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_2                             = 0xA11B;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_3                             = 0xA121;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_4                             = 0xA127;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_5                             = 0xA12D;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_6                             = 0xA133;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_7                             = 0xA139;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_8                             = 0xA13F;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_9                             = 0xA145;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_10                            = 0xA14B;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_11                            = 0xA151;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_12                            = 0xA157;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_13                            = 0xA15D;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_14                            = 0xA163;
constexpr unsigned int mmPA_CL_VPORT_XSCALE_15                            = 0xA169;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET                              = 0xA112;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_1                            = 0xA118;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_2                            = 0xA11E;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_3                            = 0xA124;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_4                            = 0xA12A;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_5                            = 0xA130;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_6                            = 0xA136;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_7                            = 0xA13C;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_8                            = 0xA142;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_9                            = 0xA148;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_10                           = 0xA14E;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_11                           = 0xA154;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_12                           = 0xA15A;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_13                           = 0xA160;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_14                           = 0xA166;
constexpr unsigned int mmPA_CL_VPORT_YOFFSET_15                           = 0xA16C;
constexpr unsigned int mmPA_CL_VPORT_YSCALE                               = 0xA111;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_1                             = 0xA117;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_2                             = 0xA11D;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_3                             = 0xA123;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_4                             = 0xA129;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_5                             = 0xA12F;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_6                             = 0xA135;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_7                             = 0xA13B;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_8                             = 0xA141;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_9                             = 0xA147;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_10                            = 0xA14D;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_11                            = 0xA153;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_12                            = 0xA159;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_13                            = 0xA15F;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_14                            = 0xA165;
constexpr unsigned int mmPA_CL_VPORT_YSCALE_15                            = 0xA16B;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET                              = 0xA114;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_1                            = 0xA11A;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_2                            = 0xA120;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_3                            = 0xA126;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_4                            = 0xA12C;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_5                            = 0xA132;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_6                            = 0xA138;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_7                            = 0xA13E;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_8                            = 0xA144;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_9                            = 0xA14A;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_10                           = 0xA150;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_11                           = 0xA156;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_12                           = 0xA15C;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_13                           = 0xA162;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_14                           = 0xA168;
constexpr unsigned int mmPA_CL_VPORT_ZOFFSET_15                           = 0xA16E;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE                               = 0xA113;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_1                             = 0xA119;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_2                             = 0xA11F;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_3                             = 0xA125;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_4                             = 0xA12B;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_5                             = 0xA131;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_6                             = 0xA137;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_7                             = 0xA13D;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_8                             = 0xA143;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_9                             = 0xA149;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_10                            = 0xA14F;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_11                            = 0xA155;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_12                            = 0xA15B;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_13                            = 0xA161;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_14                            = 0xA167;
constexpr unsigned int mmPA_CL_VPORT_ZSCALE_15                            = 0xA16D;
constexpr unsigned int mmPA_CL_VS_OUT_CNTL                                = 0xA207;
constexpr unsigned int mmPA_CL_VTE_CNTL                                   = 0xA206;
constexpr unsigned int mmPA_SC_AA_CONFIG                                  = 0xA2F8;
constexpr unsigned int mmPA_SC_AA_MASK_X0Y0_X1Y0                          = 0xA30E;
constexpr unsigned int mmPA_SC_AA_MASK_X0Y1_X1Y1                          = 0xA30F;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0                = 0xA2FE;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1                = 0xA2FF;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2                = 0xA300;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3                = 0xA301;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0                = 0xA306;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1                = 0xA307;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2                = 0xA308;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3                = 0xA309;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0                = 0xA302;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1                = 0xA303;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2                = 0xA304;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3                = 0xA305;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0                = 0xA30A;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1                = 0xA30B;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2                = 0xA30C;
constexpr unsigned int mmPA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3                = 0xA30D;
constexpr unsigned int mmPA_SC_BINNER_CNTL_0                              = 0xA311;
constexpr unsigned int mmPA_SC_BINNER_CNTL_1                              = 0xA312;
constexpr unsigned int mmPA_SC_BINNER_EVENT_CNTL_0                        = 0x22CC;
constexpr unsigned int mmPA_SC_BINNER_EVENT_CNTL_1                        = 0x22CD;
constexpr unsigned int mmPA_SC_BINNER_EVENT_CNTL_2                        = 0x22CE;
constexpr unsigned int mmPA_SC_BINNER_EVENT_CNTL_3                        = 0x22CF;
constexpr unsigned int mmPA_SC_BINNER_PERF_CNTL_0                         = 0x22D1;
constexpr unsigned int mmPA_SC_BINNER_PERF_CNTL_1                         = 0x22D2;
constexpr unsigned int mmPA_SC_BINNER_PERF_CNTL_2                         = 0x22D3;
constexpr unsigned int mmPA_SC_BINNER_PERF_CNTL_3                         = 0x22D4;
constexpr unsigned int mmPA_SC_BINNER_TIMEOUT_COUNTER                     = 0x22D0;
constexpr unsigned int mmPA_SC_CENTROID_PRIORITY_0                        = 0xA2F5;
constexpr unsigned int mmPA_SC_CENTROID_PRIORITY_1                        = 0xA2F6;
constexpr unsigned int mmPA_SC_CLIPRECT_0_BR                              = 0xA085;
constexpr unsigned int mmPA_SC_CLIPRECT_0_TL                              = 0xA084;
constexpr unsigned int mmPA_SC_CLIPRECT_1_BR                              = 0xA087;
constexpr unsigned int mmPA_SC_CLIPRECT_1_TL                              = 0xA086;
constexpr unsigned int mmPA_SC_CLIPRECT_2_BR                              = 0xA089;
constexpr unsigned int mmPA_SC_CLIPRECT_2_TL                              = 0xA088;
constexpr unsigned int mmPA_SC_CLIPRECT_3_BR                              = 0xA08B;
constexpr unsigned int mmPA_SC_CLIPRECT_3_TL                              = 0xA08A;
constexpr unsigned int mmPA_SC_CLIPRECT_RULE                              = 0xA083;
constexpr unsigned int mmPA_SC_CONSERVATIVE_RASTERIZATION_CNTL            = 0xA313;
constexpr unsigned int mmPA_SC_DSM_CNTL                                   = 0x22FE;
constexpr unsigned int mmPA_SC_EDGERULE                                   = 0xA08C;
constexpr unsigned int mmPA_SC_ENHANCE                                    = 0x22FC;
constexpr unsigned int mmPA_SC_ENHANCE_1                                  = 0x22FD;
constexpr unsigned int mmPA_SC_FIFO_DEPTH_CNTL                            = 0x2295;
constexpr unsigned int mmPA_SC_FIFO_SIZE                                  = 0x22F3;
constexpr unsigned int mmPA_SC_FORCE_EOV_MAX_CNTS                         = 0x22C9;
constexpr unsigned int mmPA_SC_GENERIC_SCISSOR_BR                         = 0xA091;
constexpr unsigned int mmPA_SC_GENERIC_SCISSOR_TL                         = 0xA090;
constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_COUNT                     = 0xC2AC;
constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_H                         = 0xC2A9;
constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_HV_EN                     = 0xC2A8;
constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_HV_LOCK                   = 0x22C1;
constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_OCCURRENCE                = 0xC2AB;
constexpr unsigned int mmPA_SC_HP3D_TRAP_SCREEN_V                         = 0xC2AA;
constexpr unsigned int mmPA_SC_IF_FIFO_SIZE                               = 0x22F5;
constexpr unsigned int mmPA_SC_LINE_CNTL                                  = 0xA2F7;
constexpr unsigned int mmPA_SC_LINE_STIPPLE                               = 0xA283;
constexpr unsigned int mmPA_SC_LINE_STIPPLE_STATE                         = 0xC281;
constexpr unsigned int mmPA_SC_MODE_CNTL_0                                = 0xA292;
constexpr unsigned int mmPA_SC_MODE_CNTL_1                                = 0xA293;
constexpr unsigned int mmPA_SC_NGG_MODE_CNTL                              = 0xA314;
constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_COUNT                      = 0xC2A4;
constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_H                          = 0xC2A1;
constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_HV_EN                      = 0xC2A0;
constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_HV_LOCK                    = 0x22C0;
constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_OCCURRENCE                 = 0xC2A3;
constexpr unsigned int mmPA_SC_P3D_TRAP_SCREEN_V                          = 0xC2A2;
constexpr unsigned int mmPA_SC_PERFCOUNTER0_HI                            = 0xD141;
constexpr unsigned int mmPA_SC_PERFCOUNTER0_LO                            = 0xD140;
constexpr unsigned int mmPA_SC_PERFCOUNTER0_SELECT                        = 0xD940;
constexpr unsigned int mmPA_SC_PERFCOUNTER0_SELECT1                       = 0xD941;
constexpr unsigned int mmPA_SC_PERFCOUNTER1_HI                            = 0xD143;
constexpr unsigned int mmPA_SC_PERFCOUNTER1_LO                            = 0xD142;
constexpr unsigned int mmPA_SC_PERFCOUNTER1_SELECT                        = 0xD942;
constexpr unsigned int mmPA_SC_PERFCOUNTER2_HI                            = 0xD145;
constexpr unsigned int mmPA_SC_PERFCOUNTER2_LO                            = 0xD144;
constexpr unsigned int mmPA_SC_PERFCOUNTER2_SELECT                        = 0xD943;
constexpr unsigned int mmPA_SC_PERFCOUNTER3_HI                            = 0xD147;
constexpr unsigned int mmPA_SC_PERFCOUNTER3_LO                            = 0xD146;
constexpr unsigned int mmPA_SC_PERFCOUNTER3_SELECT                        = 0xD944;
constexpr unsigned int mmPA_SC_PERFCOUNTER4_HI                            = 0xD149;
constexpr unsigned int mmPA_SC_PERFCOUNTER4_LO                            = 0xD148;
constexpr unsigned int mmPA_SC_PERFCOUNTER4_SELECT                        = 0xD945;
constexpr unsigned int mmPA_SC_PERFCOUNTER5_HI                            = 0xD14B;
constexpr unsigned int mmPA_SC_PERFCOUNTER5_LO                            = 0xD14A;
constexpr unsigned int mmPA_SC_PERFCOUNTER5_SELECT                        = 0xD946;
constexpr unsigned int mmPA_SC_PERFCOUNTER6_HI                            = 0xD14D;
constexpr unsigned int mmPA_SC_PERFCOUNTER6_LO                            = 0xD14C;
constexpr unsigned int mmPA_SC_PERFCOUNTER6_SELECT                        = 0xD947;
constexpr unsigned int mmPA_SC_PERFCOUNTER7_HI                            = 0xD14F;
constexpr unsigned int mmPA_SC_PERFCOUNTER7_LO                            = 0xD14E;
constexpr unsigned int mmPA_SC_PERFCOUNTER7_SELECT                        = 0xD948;
constexpr unsigned int mmPA_SC_PKR_WAVE_TABLE_CNTL                        = 0x22F8;
constexpr unsigned int mmPA_SC_RASTER_CONFIG                              = 0xA0D4;
constexpr unsigned int mmPA_SC_RASTER_CONFIG_1                            = 0xA0D5;
constexpr unsigned int mmPA_SC_SCREEN_SCISSOR_BR                          = 0xA00D;
constexpr unsigned int mmPA_SC_SCREEN_SCISSOR_TL                          = 0xA00C;
constexpr unsigned int mmPA_SC_SHADER_CONTROL                             = 0xA310;
constexpr unsigned int mmPA_SC_TILE_STEERING_CREST_OVERRIDE               = 0x22FF;
constexpr unsigned int mmPA_SC_TILE_STEERING_OVERRIDE                     = 0xA0D7;
constexpr unsigned int mmPA_SC_TRAP_SCREEN_COUNT                          = 0xC2B4;
constexpr unsigned int mmPA_SC_TRAP_SCREEN_H                              = 0xC2B1;
constexpr unsigned int mmPA_SC_TRAP_SCREEN_HV_EN                          = 0xC2B0;
constexpr unsigned int mmPA_SC_TRAP_SCREEN_HV_LOCK                        = 0x22C2;
constexpr unsigned int mmPA_SC_TRAP_SCREEN_OCCURRENCE                     = 0xC2B3;
constexpr unsigned int mmPA_SC_TRAP_SCREEN_V                              = 0xC2B2;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_0_BR                         = 0xA095;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_0_TL                         = 0xA094;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_1_BR                         = 0xA097;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_1_TL                         = 0xA096;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_2_BR                         = 0xA099;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_2_TL                         = 0xA098;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_3_BR                         = 0xA09B;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_3_TL                         = 0xA09A;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_4_BR                         = 0xA09D;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_4_TL                         = 0xA09C;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_5_BR                         = 0xA09F;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_5_TL                         = 0xA09E;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_6_BR                         = 0xA0A1;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_6_TL                         = 0xA0A0;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_7_BR                         = 0xA0A3;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_7_TL                         = 0xA0A2;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_8_BR                         = 0xA0A5;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_8_TL                         = 0xA0A4;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_9_BR                         = 0xA0A7;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_9_TL                         = 0xA0A6;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_10_BR                        = 0xA0A9;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_10_TL                        = 0xA0A8;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_11_BR                        = 0xA0AB;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_11_TL                        = 0xA0AA;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_12_BR                        = 0xA0AD;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_12_TL                        = 0xA0AC;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_13_BR                        = 0xA0AF;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_13_TL                        = 0xA0AE;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_14_BR                        = 0xA0B1;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_14_TL                        = 0xA0B0;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_15_BR                        = 0xA0B3;
constexpr unsigned int mmPA_SC_VPORT_SCISSOR_15_TL                        = 0xA0B2;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_0                               = 0xA0B5;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_1                               = 0xA0B7;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_2                               = 0xA0B9;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_3                               = 0xA0BB;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_4                               = 0xA0BD;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_5                               = 0xA0BF;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_6                               = 0xA0C1;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_7                               = 0xA0C3;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_8                               = 0xA0C5;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_9                               = 0xA0C7;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_10                              = 0xA0C9;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_11                              = 0xA0CB;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_12                              = 0xA0CD;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_13                              = 0xA0CF;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_14                              = 0xA0D1;
constexpr unsigned int mmPA_SC_VPORT_ZMAX_15                              = 0xA0D3;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_0                               = 0xA0B4;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_1                               = 0xA0B6;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_2                               = 0xA0B8;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_3                               = 0xA0BA;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_4                               = 0xA0BC;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_5                               = 0xA0BE;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_6                               = 0xA0C0;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_7                               = 0xA0C2;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_8                               = 0xA0C4;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_9                               = 0xA0C6;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_10                              = 0xA0C8;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_11                              = 0xA0CA;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_12                              = 0xA0CC;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_13                              = 0xA0CE;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_14                              = 0xA0D0;
constexpr unsigned int mmPA_SC_VPORT_ZMIN_15                              = 0xA0D2;
constexpr unsigned int mmPA_SC_WINDOW_OFFSET                              = 0xA080;
constexpr unsigned int mmPA_SC_WINDOW_SCISSOR_BR                          = 0xA082;
constexpr unsigned int mmPA_SC_WINDOW_SCISSOR_TL                          = 0xA081;
constexpr unsigned int mmPA_SIDEBAND_REQUEST_DELAYS                       = 0x22FB;
constexpr unsigned int mmPA_SU_CNTL_STATUS                                = 0x2294;
constexpr unsigned int mmPA_SU_HARDWARE_SCREEN_OFFSET                     = 0xA08D;
constexpr unsigned int mmPA_SU_LINE_CNTL                                  = 0xA282;
constexpr unsigned int mmPA_SU_LINE_STIPPLE_CNTL                          = 0xA209;
constexpr unsigned int mmPA_SU_LINE_STIPPLE_SCALE                         = 0xA20A;
constexpr unsigned int mmPA_SU_LINE_STIPPLE_VALUE                         = 0xC280;
constexpr unsigned int mmPA_SU_OVER_RASTERIZATION_CNTL                    = 0xA20F;
constexpr unsigned int mmPA_SU_PERFCOUNTER0_HI                            = 0xD101;
constexpr unsigned int mmPA_SU_PERFCOUNTER0_LO                            = 0xD100;
constexpr unsigned int mmPA_SU_PERFCOUNTER0_SELECT                        = 0xD900;
constexpr unsigned int mmPA_SU_PERFCOUNTER0_SELECT1                       = 0xD901;
constexpr unsigned int mmPA_SU_PERFCOUNTER1_HI                            = 0xD103;
constexpr unsigned int mmPA_SU_PERFCOUNTER1_LO                            = 0xD102;
constexpr unsigned int mmPA_SU_PERFCOUNTER1_SELECT                        = 0xD902;
constexpr unsigned int mmPA_SU_PERFCOUNTER1_SELECT1                       = 0xD903;
constexpr unsigned int mmPA_SU_PERFCOUNTER2_HI                            = 0xD105;
constexpr unsigned int mmPA_SU_PERFCOUNTER2_LO                            = 0xD104;
constexpr unsigned int mmPA_SU_PERFCOUNTER2_SELECT                        = 0xD904;
constexpr unsigned int mmPA_SU_PERFCOUNTER3_HI                            = 0xD107;
constexpr unsigned int mmPA_SU_PERFCOUNTER3_LO                            = 0xD106;
constexpr unsigned int mmPA_SU_POINT_MINMAX                               = 0xA281;
constexpr unsigned int mmPA_SU_POINT_SIZE                                 = 0xA280;
constexpr unsigned int mmPA_SU_POLY_OFFSET_BACK_OFFSET                    = 0xA2E3;
constexpr unsigned int mmPA_SU_POLY_OFFSET_BACK_SCALE                     = 0xA2E2;
constexpr unsigned int mmPA_SU_POLY_OFFSET_CLAMP                          = 0xA2DF;
constexpr unsigned int mmPA_SU_POLY_OFFSET_DB_FMT_CNTL                    = 0xA2DE;
constexpr unsigned int mmPA_SU_POLY_OFFSET_FRONT_OFFSET                   = 0xA2E1;
constexpr unsigned int mmPA_SU_POLY_OFFSET_FRONT_SCALE                    = 0xA2E0;
constexpr unsigned int mmPA_SU_PRIM_FILTER_CNTL                           = 0xA20B;
constexpr unsigned int mmPA_SU_SC_MODE_CNTL                               = 0xA205;
constexpr unsigned int mmPA_SU_SMALL_PRIM_FILTER_CNTL                     = 0xA20C;
constexpr unsigned int mmPA_SU_VTX_CNTL                                   = 0xA2F9;
constexpr unsigned int mmRLC_PERFCOUNTER0_HI                              = 0xD481;
constexpr unsigned int mmRLC_PERFCOUNTER0_LO                              = 0xD480;
constexpr unsigned int mmRLC_PERFCOUNTER0_SELECT                          = 0xDCC1;
constexpr unsigned int mmRLC_PERFCOUNTER1_HI                              = 0xD483;
constexpr unsigned int mmRLC_PERFCOUNTER1_LO                              = 0xD482;
constexpr unsigned int mmRLC_PERFCOUNTER1_SELECT                          = 0xDCC2;
constexpr unsigned int mmRLC_PERFMON_CNTL                                 = 0xDCC0;
constexpr unsigned int mmRLC_SPM_INT_CNTL                                 = 0xEC72;
constexpr unsigned int mmRLC_SPM_INT_STATUS                               = 0xEC73;
constexpr unsigned int mmRLC_SPM_MC_CNTL                                  = 0xEC71;
constexpr unsigned int mmRLC_SPM_PERFMON_CNTL                             = 0xDC80;
constexpr unsigned int mmRLC_SPM_PERFMON_RING_BASE_HI                     = 0xDC82;
constexpr unsigned int mmRLC_SPM_PERFMON_RING_BASE_LO                     = 0xDC81;
constexpr unsigned int mmRLC_SPM_PERFMON_RING_SIZE                        = 0xDC83;
constexpr unsigned int mmRLC_SPM_PERFMON_SEGMENT_SIZE                     = 0xDC84;
constexpr unsigned int mmRLC_SPM_UTCL1_CNTL                               = 0xECB5;
constexpr unsigned int mmRLC_SPM_UTCL1_ERROR_1                            = 0xECBC;
constexpr unsigned int mmRLC_SPM_UTCL1_ERROR_2                            = 0xECBD;
constexpr unsigned int mmRMI_PERFCOUNTER0_HI                              = 0xD4C1;
constexpr unsigned int mmRMI_PERFCOUNTER0_LO                              = 0xD4C0;
constexpr unsigned int mmRMI_PERFCOUNTER0_SELECT                          = 0xDD00;
constexpr unsigned int mmRMI_PERFCOUNTER0_SELECT1                         = 0xDD01;
constexpr unsigned int mmRMI_PERFCOUNTER1_HI                              = 0xD4C3;
constexpr unsigned int mmRMI_PERFCOUNTER1_LO                              = 0xD4C2;
constexpr unsigned int mmRMI_PERFCOUNTER1_SELECT                          = 0xDD02;
constexpr unsigned int mmRMI_PERFCOUNTER2_HI                              = 0xD4C5;
constexpr unsigned int mmRMI_PERFCOUNTER2_LO                              = 0xD4C4;
constexpr unsigned int mmRMI_PERFCOUNTER2_SELECT                          = 0xDD03;
constexpr unsigned int mmRMI_PERFCOUNTER2_SELECT1                         = 0xDD04;
constexpr unsigned int mmRMI_PERFCOUNTER3_HI                              = 0xD4C7;
constexpr unsigned int mmRMI_PERFCOUNTER3_LO                              = 0xD4C6;
constexpr unsigned int mmRMI_PERFCOUNTER3_SELECT                          = 0xDD05;
constexpr unsigned int mmRMI_PERF_COUNTER_CNTL                            = 0xDD06;
constexpr unsigned int mmSPI_ARB_CNTL_0                                   = 0x31FD;
constexpr unsigned int mmSPI_ARB_CYCLES_0                                 = 0x31C1;
constexpr unsigned int mmSPI_ARB_CYCLES_1                                 = 0x31C2;
constexpr unsigned int mmSPI_ARB_PRIORITY                                 = 0x31C0;
constexpr unsigned int mmSPI_BARYC_CNTL                                   = 0xA1B8;
constexpr unsigned int mmSPI_COMPUTE_QUEUE_RESET                          = 0x31DB;
constexpr unsigned int mmSPI_COMPUTE_WF_CTX_SAVE                          = 0x31FC;
constexpr unsigned int mmSPI_CSQ_WF_ACTIVE_COUNT_0                        = 0x24DC;
constexpr unsigned int mmSPI_CSQ_WF_ACTIVE_COUNT_1                        = 0x24DD;
constexpr unsigned int mmSPI_CSQ_WF_ACTIVE_COUNT_2                        = 0x24DE;
constexpr unsigned int mmSPI_CSQ_WF_ACTIVE_COUNT_3                        = 0x24DF;
constexpr unsigned int mmSPI_CSQ_WF_ACTIVE_STATUS                         = 0x24DB;
constexpr unsigned int mmSPI_DSM_CNTL                                     = 0x2443;
constexpr unsigned int mmSPI_DSM_CNTL2                                    = 0x2444;
constexpr unsigned int mmSPI_EDC_CNT                                      = 0x2445;
constexpr unsigned int mmSPI_GDS_CREDITS                                  = 0x24D8;
constexpr unsigned int mmSPI_GFX_CNTL                                     = 0x243C;
constexpr unsigned int mmSPI_INTERP_CONTROL_0                             = 0xA1B5;
constexpr unsigned int mmSPI_LB_CTR_CTRL                                  = 0x24D4;
constexpr unsigned int mmSPI_LB_DATA_REG                                  = 0x24D6;
constexpr unsigned int mmSPI_LB_DATA_WAVES                                = 0x24E4;
constexpr unsigned int mmSPI_P0_TRAP_SCREEN_GPR_MIN                       = 0x24F0;
constexpr unsigned int mmSPI_P0_TRAP_SCREEN_PSBA_HI                       = 0x24ED;
constexpr unsigned int mmSPI_P0_TRAP_SCREEN_PSBA_LO                       = 0x24EC;
constexpr unsigned int mmSPI_P0_TRAP_SCREEN_PSMA_HI                       = 0x24EF;
constexpr unsigned int mmSPI_P0_TRAP_SCREEN_PSMA_LO                       = 0x24EE;
constexpr unsigned int mmSPI_P1_TRAP_SCREEN_GPR_MIN                       = 0x24F5;
constexpr unsigned int mmSPI_P1_TRAP_SCREEN_PSBA_HI                       = 0x24F2;
constexpr unsigned int mmSPI_P1_TRAP_SCREEN_PSBA_LO                       = 0x24F1;
constexpr unsigned int mmSPI_P1_TRAP_SCREEN_PSMA_HI                       = 0x24F4;
constexpr unsigned int mmSPI_P1_TRAP_SCREEN_PSMA_LO                       = 0x24F3;
constexpr unsigned int mmSPI_PERFCOUNTER0_HI                              = 0xD180;
constexpr unsigned int mmSPI_PERFCOUNTER0_LO                              = 0xD181;
constexpr unsigned int mmSPI_PERFCOUNTER0_SELECT                          = 0xD980;
constexpr unsigned int mmSPI_PERFCOUNTER0_SELECT1                         = 0xD984;
constexpr unsigned int mmSPI_PERFCOUNTER1_HI                              = 0xD182;
constexpr unsigned int mmSPI_PERFCOUNTER1_LO                              = 0xD183;
constexpr unsigned int mmSPI_PERFCOUNTER1_SELECT                          = 0xD981;
constexpr unsigned int mmSPI_PERFCOUNTER1_SELECT1                         = 0xD985;
constexpr unsigned int mmSPI_PERFCOUNTER2_HI                              = 0xD184;
constexpr unsigned int mmSPI_PERFCOUNTER2_LO                              = 0xD185;
constexpr unsigned int mmSPI_PERFCOUNTER2_SELECT                          = 0xD982;
constexpr unsigned int mmSPI_PERFCOUNTER2_SELECT1                         = 0xD986;
constexpr unsigned int mmSPI_PERFCOUNTER3_HI                              = 0xD186;
constexpr unsigned int mmSPI_PERFCOUNTER3_LO                              = 0xD187;
constexpr unsigned int mmSPI_PERFCOUNTER3_SELECT                          = 0xD983;
constexpr unsigned int mmSPI_PERFCOUNTER3_SELECT1                         = 0xD987;
constexpr unsigned int mmSPI_PERFCOUNTER4_HI                              = 0xD188;
constexpr unsigned int mmSPI_PERFCOUNTER4_LO                              = 0xD189;
constexpr unsigned int mmSPI_PERFCOUNTER4_SELECT                          = 0xD988;
constexpr unsigned int mmSPI_PERFCOUNTER5_HI                              = 0xD18A;
constexpr unsigned int mmSPI_PERFCOUNTER5_LO                              = 0xD18B;
constexpr unsigned int mmSPI_PERFCOUNTER5_SELECT                          = 0xD989;
constexpr unsigned int mmSPI_PERFCOUNTER_BINS                             = 0xD98A;
constexpr unsigned int mmSPI_PS_INPUT_ADDR                                = 0xA1B4;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_0                              = 0xA191;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_1                              = 0xA192;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_2                              = 0xA193;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_3                              = 0xA194;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_4                              = 0xA195;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_5                              = 0xA196;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_6                              = 0xA197;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_7                              = 0xA198;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_8                              = 0xA199;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_9                              = 0xA19A;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_10                             = 0xA19B;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_11                             = 0xA19C;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_12                             = 0xA19D;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_13                             = 0xA19E;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_14                             = 0xA19F;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_15                             = 0xA1A0;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_16                             = 0xA1A1;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_17                             = 0xA1A2;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_18                             = 0xA1A3;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_19                             = 0xA1A4;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_20                             = 0xA1A5;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_21                             = 0xA1A6;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_22                             = 0xA1A7;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_23                             = 0xA1A8;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_24                             = 0xA1A9;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_25                             = 0xA1AA;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_26                             = 0xA1AB;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_27                             = 0xA1AC;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_28                             = 0xA1AD;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_29                             = 0xA1AE;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_30                             = 0xA1AF;
constexpr unsigned int mmSPI_PS_INPUT_CNTL_31                             = 0xA1B0;
constexpr unsigned int mmSPI_PS_INPUT_ENA                                 = 0xA1B3;
constexpr unsigned int mmSPI_PS_IN_CONTROL                                = 0xA1B6;
constexpr unsigned int mmSPI_PS_MAX_WAVE_ID                               = 0x243A;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_0                        = 0x31DC;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_1                        = 0x31DD;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_2                        = 0x31DE;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_3                        = 0x31DF;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_4                        = 0x31E0;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_5                        = 0x31E1;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_0                     = 0x31E6;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_1                     = 0x31E7;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_2                     = 0x31E8;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_3                     = 0x31E9;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_4                     = 0x31EA;
constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_5                     = 0x31EB;
constexpr unsigned int mmSPI_SHADER_COL_FORMAT                            = 0xA1C5;
constexpr unsigned int mmSPI_SHADER_LATE_ALLOC_VS                         = 0x2C47;
constexpr unsigned int mmSPI_SHADER_PGM_HI_GS                             = 0x2C89;
constexpr unsigned int mmSPI_SHADER_PGM_HI_HS                             = 0x2D09;
constexpr unsigned int mmSPI_SHADER_PGM_HI_PS                             = 0x2C09;
constexpr unsigned int mmSPI_SHADER_PGM_HI_VS                             = 0x2C49;
constexpr unsigned int mmSPI_SHADER_PGM_LO_GS                             = 0x2C88;
constexpr unsigned int mmSPI_SHADER_PGM_LO_HS                             = 0x2D08;
constexpr unsigned int mmSPI_SHADER_PGM_LO_PS                             = 0x2C08;
constexpr unsigned int mmSPI_SHADER_PGM_LO_VS                             = 0x2C48;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC1_GS                          = 0x2C8A;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC1_HS                          = 0x2D0A;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC1_PS                          = 0x2C0A;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC1_VS                          = 0x2C4A;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_GS                          = 0x2C8B;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_HS                          = 0x2D0B;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_PS                          = 0x2C0B;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_VS                          = 0x2C4B;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC3_GS                          = 0x2C87;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC3_HS                          = 0x2D07;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC3_PS                          = 0x2C07;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC3_VS                          = 0x2C46;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC4_GS                          = 0x2C81;
constexpr unsigned int mmSPI_SHADER_PGM_RSRC4_HS                          = 0x2D01;
constexpr unsigned int mmSPI_SHADER_POS_FORMAT                            = 0xA1C3;
constexpr unsigned int mmSPI_SHADER_USER_DATA_ADDR_HI_GS                  = 0x2C83;
constexpr unsigned int mmSPI_SHADER_USER_DATA_ADDR_HI_HS                  = 0x2D03;
constexpr unsigned int mmSPI_SHADER_USER_DATA_ADDR_LO_GS                  = 0x2C82;
constexpr unsigned int mmSPI_SHADER_USER_DATA_ADDR_LO_HS                  = 0x2D02;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_0                        = 0x2C0C;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_1                        = 0x2C0D;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_2                        = 0x2C0E;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_3                        = 0x2C0F;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_4                        = 0x2C10;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_5                        = 0x2C11;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_6                        = 0x2C12;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_7                        = 0x2C13;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_8                        = 0x2C14;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_9                        = 0x2C15;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_10                       = 0x2C16;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_11                       = 0x2C17;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_12                       = 0x2C18;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_13                       = 0x2C19;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_14                       = 0x2C1A;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_15                       = 0x2C1B;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_16                       = 0x2C1C;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_17                       = 0x2C1D;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_18                       = 0x2C1E;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_19                       = 0x2C1F;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_20                       = 0x2C20;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_21                       = 0x2C21;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_22                       = 0x2C22;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_23                       = 0x2C23;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_24                       = 0x2C24;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_25                       = 0x2C25;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_26                       = 0x2C26;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_27                       = 0x2C27;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_28                       = 0x2C28;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_29                       = 0x2C29;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_30                       = 0x2C2A;
constexpr unsigned int mmSPI_SHADER_USER_DATA_PS_31                       = 0x2C2B;
constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_0                        = 0x2C4C;
constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_1                        = 0x2C4D;
constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_2                        = 0x2C4E;
constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_3                        = 0x2C4F;
constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_4                        = 0x2C50;
constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_5                        = 0x2C51;
constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_6                        = 0x2C52;
constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_7                        = 0x2C53;
constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_8                        = 0x2C54;
constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_9                        = 0x2C55;
constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_10                       = 0x2C56;
constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_11                       = 0x2C57;
constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_12                       = 0x2C58;
constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_13                       = 0x2C59;
constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_14                       = 0x2C5A;
constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_15                       = 0x2C5B;
constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_16                       = 0x2C5C;
constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_17                       = 0x2C5D;
constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_18                       = 0x2C5E;
constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_19                       = 0x2C5F;
constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_20                       = 0x2C60;
constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_21                       = 0x2C61;
constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_22                       = 0x2C62;
constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_23                       = 0x2C63;
constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_24                       = 0x2C64;
constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_25                       = 0x2C65;
constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_26                       = 0x2C66;
constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_27                       = 0x2C67;
constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_28                       = 0x2C68;
constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_29                       = 0x2C69;
constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_30                       = 0x2C6A;
constexpr unsigned int mmSPI_SHADER_USER_DATA_VS_31                       = 0x2C6B;
constexpr unsigned int mmSPI_SHADER_Z_FORMAT                              = 0xA1C4;
constexpr unsigned int mmSPI_START_PHASE                                  = 0x243B;
constexpr unsigned int mmSPI_SX_EXPORT_BUFFER_SIZES                       = 0x24D9;
constexpr unsigned int mmSPI_SX_SCOREBOARD_BUFFER_SIZES                   = 0x24DA;
constexpr unsigned int mmSPI_TMPRING_SIZE                                 = 0xA1BA;
constexpr unsigned int mmSPI_VS_OUT_CONFIG                                = 0xA1B1;
constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS0                         = 0x31C9;
constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS1                         = 0x31CA;
constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS2                         = 0x31CB;
constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS3                         = 0x31CC;
constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_GFX                         = 0x31C7;
constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_HP3D                        = 0x31C8;
constexpr unsigned int mmSPI_WF_LIFETIME_CNTL                             = 0x24AA;
constexpr unsigned int mmSPI_WF_LIFETIME_LIMIT_0                          = 0x24AB;
constexpr unsigned int mmSPI_WF_LIFETIME_LIMIT_2                          = 0x24AD;
constexpr unsigned int mmSPI_WF_LIFETIME_LIMIT_3                          = 0x24AE;
constexpr unsigned int mmSPI_WF_LIFETIME_LIMIT_4                          = 0x24AF;
constexpr unsigned int mmSPI_WF_LIFETIME_LIMIT_5                          = 0x24B0;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_0                         = 0x24B5;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_1                         = 0x24B6;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_2                         = 0x24B7;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_4                         = 0x24B9;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_6                         = 0x24BB;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_7                         = 0x24BC;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_8                         = 0x24BD;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_9                         = 0x24BE;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_11                        = 0x24C0;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_13                        = 0x24C2;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_14                        = 0x24C3;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_15                        = 0x24C4;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_16                        = 0x24C5;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_17                        = 0x24C6;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_18                        = 0x24C7;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_19                        = 0x24C8;
constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_20                        = 0x24C9;
constexpr unsigned int mmSQ_ALU_CLK_CTRL                                  = 0xF08E;
constexpr unsigned int mmSQ_CMD                                           = 0x237B;
constexpr unsigned int mmSQ_CONFIG                                        = 0x2300;
constexpr unsigned int mmSQ_DSM_CNTL                                      = 0x2306;
constexpr unsigned int mmSQ_DSM_CNTL2                                     = 0x2307;
constexpr unsigned int mmSQ_EDC_CNT                                       = 0x23A6;
constexpr unsigned int mmSQ_EDC_FUE_CNTL                                  = 0x23A7;
constexpr unsigned int mmSQ_FIFO_SIZES                                    = 0x2305;
constexpr unsigned int mmSQ_IND_DATA                                      = 0x2379;
constexpr unsigned int mmSQ_IND_INDEX                                     = 0x2378;
constexpr unsigned int mmSQ_LB_CTR_CTRL                                   = 0x2398;
constexpr unsigned int mmSQ_LB_DATA0                                      = 0x2399;
constexpr unsigned int mmSQ_LB_DATA1                                      = 0x239A;
constexpr unsigned int mmSQ_LB_DATA2                                      = 0x239B;
constexpr unsigned int mmSQ_LB_DATA3                                      = 0x239C;
constexpr unsigned int mmSQ_LDS_CLK_CTRL                                  = 0xF090;
constexpr unsigned int mmSQ_PERFCOUNTER0_HI                               = 0xD1C1;
constexpr unsigned int mmSQ_PERFCOUNTER0_LO                               = 0xD1C0;
constexpr unsigned int mmSQ_PERFCOUNTER0_SELECT                           = 0xD9C0;
constexpr unsigned int mmSQ_PERFCOUNTER1_HI                               = 0xD1C3;
constexpr unsigned int mmSQ_PERFCOUNTER1_LO                               = 0xD1C2;
constexpr unsigned int mmSQ_PERFCOUNTER1_SELECT                           = 0xD9C1;
constexpr unsigned int mmSQ_PERFCOUNTER2_HI                               = 0xD1C5;
constexpr unsigned int mmSQ_PERFCOUNTER2_LO                               = 0xD1C4;
constexpr unsigned int mmSQ_PERFCOUNTER2_SELECT                           = 0xD9C2;
constexpr unsigned int mmSQ_PERFCOUNTER3_HI                               = 0xD1C7;
constexpr unsigned int mmSQ_PERFCOUNTER3_LO                               = 0xD1C6;
constexpr unsigned int mmSQ_PERFCOUNTER3_SELECT                           = 0xD9C3;
constexpr unsigned int mmSQ_PERFCOUNTER4_HI                               = 0xD1C9;
constexpr unsigned int mmSQ_PERFCOUNTER4_LO                               = 0xD1C8;
constexpr unsigned int mmSQ_PERFCOUNTER4_SELECT                           = 0xD9C4;
constexpr unsigned int mmSQ_PERFCOUNTER5_HI                               = 0xD1CB;
constexpr unsigned int mmSQ_PERFCOUNTER5_LO                               = 0xD1CA;
constexpr unsigned int mmSQ_PERFCOUNTER5_SELECT                           = 0xD9C5;
constexpr unsigned int mmSQ_PERFCOUNTER6_HI                               = 0xD1CD;
constexpr unsigned int mmSQ_PERFCOUNTER6_LO                               = 0xD1CC;
constexpr unsigned int mmSQ_PERFCOUNTER6_SELECT                           = 0xD9C6;
constexpr unsigned int mmSQ_PERFCOUNTER7_HI                               = 0xD1CF;
constexpr unsigned int mmSQ_PERFCOUNTER7_LO                               = 0xD1CE;
constexpr unsigned int mmSQ_PERFCOUNTER7_SELECT                           = 0xD9C7;
constexpr unsigned int mmSQ_PERFCOUNTER8_HI                               = 0xD1D1;
constexpr unsigned int mmSQ_PERFCOUNTER8_LO                               = 0xD1D0;
constexpr unsigned int mmSQ_PERFCOUNTER8_SELECT                           = 0xD9C8;
constexpr unsigned int mmSQ_PERFCOUNTER9_HI                               = 0xD1D3;
constexpr unsigned int mmSQ_PERFCOUNTER9_LO                               = 0xD1D2;
constexpr unsigned int mmSQ_PERFCOUNTER9_SELECT                           = 0xD9C9;
constexpr unsigned int mmSQ_PERFCOUNTER10_HI                              = 0xD1D5;
constexpr unsigned int mmSQ_PERFCOUNTER10_LO                              = 0xD1D4;
constexpr unsigned int mmSQ_PERFCOUNTER10_SELECT                          = 0xD9CA;
constexpr unsigned int mmSQ_PERFCOUNTER11_HI                              = 0xD1D7;
constexpr unsigned int mmSQ_PERFCOUNTER11_LO                              = 0xD1D6;
constexpr unsigned int mmSQ_PERFCOUNTER11_SELECT                          = 0xD9CB;
constexpr unsigned int mmSQ_PERFCOUNTER12_HI                              = 0xD1D9;
constexpr unsigned int mmSQ_PERFCOUNTER12_LO                              = 0xD1D8;
constexpr unsigned int mmSQ_PERFCOUNTER12_SELECT                          = 0xD9CC;
constexpr unsigned int mmSQ_PERFCOUNTER13_HI                              = 0xD1DB;
constexpr unsigned int mmSQ_PERFCOUNTER13_LO                              = 0xD1DA;
constexpr unsigned int mmSQ_PERFCOUNTER13_SELECT                          = 0xD9CD;
constexpr unsigned int mmSQ_PERFCOUNTER14_HI                              = 0xD1DD;
constexpr unsigned int mmSQ_PERFCOUNTER14_LO                              = 0xD1DC;
constexpr unsigned int mmSQ_PERFCOUNTER14_SELECT                          = 0xD9CE;
constexpr unsigned int mmSQ_PERFCOUNTER15_HI                              = 0xD1DF;
constexpr unsigned int mmSQ_PERFCOUNTER15_LO                              = 0xD1DE;
constexpr unsigned int mmSQ_PERFCOUNTER15_SELECT                          = 0xD9CF;
constexpr unsigned int mmSQ_PERFCOUNTER_CTRL                              = 0xD9E0;
constexpr unsigned int mmSQ_PERFCOUNTER_CTRL2                             = 0xD9E2;
constexpr unsigned int mmSQ_RANDOM_WAVE_PRI                               = 0x2303;
constexpr unsigned int mmSQ_RUNTIME_CONFIG                                = 0x2308;
constexpr unsigned int mmSQ_TEX_CLK_CTRL                                  = 0xF08F;
constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_0                       = 0xC340;
constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_1                       = 0xC341;
constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_2                       = 0xC342;
constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_3                       = 0xC343;
constexpr unsigned int mmSQ_TIME_HI                                       = 0x237C;
constexpr unsigned int mmSQ_TIME_LO                                       = 0x237D;
constexpr unsigned int mmSQ_WREXEC_EXEC_HI                                = 0x23B1;
constexpr unsigned int mmSQ_WREXEC_EXEC_LO                                = 0x23B1;
constexpr unsigned int mmSX_BLEND_OPT_CONTROL                             = 0xA1D7;
constexpr unsigned int mmSX_BLEND_OPT_EPSILON                             = 0xA1D6;
constexpr unsigned int mmSX_MRT0_BLEND_OPT                                = 0xA1D8;
constexpr unsigned int mmSX_MRT1_BLEND_OPT                                = 0xA1D9;
constexpr unsigned int mmSX_MRT2_BLEND_OPT                                = 0xA1DA;
constexpr unsigned int mmSX_MRT3_BLEND_OPT                                = 0xA1DB;
constexpr unsigned int mmSX_MRT4_BLEND_OPT                                = 0xA1DC;
constexpr unsigned int mmSX_MRT5_BLEND_OPT                                = 0xA1DD;
constexpr unsigned int mmSX_MRT6_BLEND_OPT                                = 0xA1DE;
constexpr unsigned int mmSX_MRT7_BLEND_OPT                                = 0xA1DF;
constexpr unsigned int mmSX_PERFCOUNTER0_HI                               = 0xD241;
constexpr unsigned int mmSX_PERFCOUNTER0_LO                               = 0xD240;
constexpr unsigned int mmSX_PERFCOUNTER0_SELECT                           = 0xDA40;
constexpr unsigned int mmSX_PERFCOUNTER0_SELECT1                          = 0xDA44;
constexpr unsigned int mmSX_PERFCOUNTER1_HI                               = 0xD243;
constexpr unsigned int mmSX_PERFCOUNTER1_LO                               = 0xD242;
constexpr unsigned int mmSX_PERFCOUNTER1_SELECT                           = 0xDA41;
constexpr unsigned int mmSX_PERFCOUNTER1_SELECT1                          = 0xDA45;
constexpr unsigned int mmSX_PERFCOUNTER2_HI                               = 0xD245;
constexpr unsigned int mmSX_PERFCOUNTER2_LO                               = 0xD244;
constexpr unsigned int mmSX_PERFCOUNTER2_SELECT                           = 0xDA42;
constexpr unsigned int mmSX_PERFCOUNTER3_HI                               = 0xD247;
constexpr unsigned int mmSX_PERFCOUNTER3_LO                               = 0xD246;
constexpr unsigned int mmSX_PERFCOUNTER3_SELECT                           = 0xDA43;
constexpr unsigned int mmSX_PS_DOWNCONVERT                                = 0xA1D5;
constexpr unsigned int mmTA_BC_BASE_ADDR                                  = 0xA020;
constexpr unsigned int mmTA_BC_BASE_ADDR_HI                               = 0xA021;
constexpr unsigned int mmTA_CGTT_CTRL                                     = 0xF09D;
constexpr unsigned int mmTA_CNTL                                          = 0x2541;
constexpr unsigned int mmTA_CNTL_AUX                                      = 0x2542;
constexpr unsigned int mmTA_CS_BC_BASE_ADDR                               = 0xC380;
constexpr unsigned int mmTA_CS_BC_BASE_ADDR_HI                            = 0xC381;
constexpr unsigned int mmTA_PERFCOUNTER0_HI                               = 0xD2C1;
constexpr unsigned int mmTA_PERFCOUNTER0_LO                               = 0xD2C0;
constexpr unsigned int mmTA_PERFCOUNTER0_SELECT                           = 0xDAC0;
constexpr unsigned int mmTA_PERFCOUNTER0_SELECT1                          = 0xDAC1;
constexpr unsigned int mmTA_PERFCOUNTER1_HI                               = 0xD2C3;
constexpr unsigned int mmTA_PERFCOUNTER1_LO                               = 0xD2C2;
constexpr unsigned int mmTA_PERFCOUNTER1_SELECT                           = 0xDAC2;
constexpr unsigned int mmTA_RESERVED_010C                                 = 0x2543;
constexpr unsigned int mmTA_SCRATCH                                       = 0x2564;
constexpr unsigned int mmTA_STATUS                                        = 0x2548;
constexpr unsigned int mmTCP_PERFCOUNTER0_HI                              = 0xD341;
constexpr unsigned int mmTCP_PERFCOUNTER0_LO                              = 0xD340;
constexpr unsigned int mmTCP_PERFCOUNTER0_SELECT                          = 0xDB40;
constexpr unsigned int mmTCP_PERFCOUNTER0_SELECT1                         = 0xDB41;
constexpr unsigned int mmTCP_PERFCOUNTER1_HI                              = 0xD343;
constexpr unsigned int mmTCP_PERFCOUNTER1_LO                              = 0xD342;
constexpr unsigned int mmTCP_PERFCOUNTER1_SELECT                          = 0xDB42;
constexpr unsigned int mmTCP_PERFCOUNTER1_SELECT1                         = 0xDB43;
constexpr unsigned int mmTCP_PERFCOUNTER2_HI                              = 0xD345;
constexpr unsigned int mmTCP_PERFCOUNTER2_LO                              = 0xD344;
constexpr unsigned int mmTCP_PERFCOUNTER3_HI                              = 0xD347;
constexpr unsigned int mmTCP_PERFCOUNTER3_LO                              = 0xD346;
constexpr unsigned int mmTCP_PERFCOUNTER_FILTER                           = 0x32B9;
constexpr unsigned int mmTCP_PERFCOUNTER_FILTER_EN                        = 0x32BA;
constexpr unsigned int mmTD_PERFCOUNTER0_HI                               = 0xD301;
constexpr unsigned int mmTD_PERFCOUNTER0_LO                               = 0xD300;
constexpr unsigned int mmTD_PERFCOUNTER0_SELECT                           = 0xDB00;
constexpr unsigned int mmTD_PERFCOUNTER0_SELECT1                          = 0xDB01;
constexpr unsigned int mmTD_PERFCOUNTER1_HI                               = 0xD303;
constexpr unsigned int mmTD_PERFCOUNTER1_LO                               = 0xD302;
constexpr unsigned int mmTD_PERFCOUNTER1_SELECT                           = 0xDB02;
constexpr unsigned int mmVGT_DMA_BASE                                     = 0xA1FA;
constexpr unsigned int mmVGT_DMA_BASE_HI                                  = 0xA1F9;
constexpr unsigned int mmVGT_DMA_CONTROL                                  = 0x2272;
constexpr unsigned int mmVGT_DMA_DATA_FIFO_DEPTH                          = 0x222D;
constexpr unsigned int mmVGT_DMA_EVENT_INITIATOR                          = 0xA2E7;
constexpr unsigned int mmVGT_DMA_INDEX_TYPE                               = 0xA29F;
constexpr unsigned int mmVGT_DMA_LS_HS_CONFIG                             = 0x2273;
constexpr unsigned int mmVGT_DMA_MAX_SIZE                                 = 0xA29E;
constexpr unsigned int mmVGT_DMA_NUM_INSTANCES                            = 0xA2A2;
constexpr unsigned int mmVGT_DMA_PRIMITIVE_TYPE                           = 0x2271;
constexpr unsigned int mmVGT_DMA_REQ_FIFO_DEPTH                           = 0x222E;
constexpr unsigned int mmVGT_DMA_SIZE                                     = 0xA29D;
constexpr unsigned int mmVGT_DRAW_INITIATOR                               = 0xA1FC;
constexpr unsigned int mmVGT_DRAW_INIT_FIFO_DEPTH                         = 0x222F;
constexpr unsigned int mmVGT_DRAW_PAYLOAD_CNTL                            = 0xA2A6;
constexpr unsigned int mmVGT_ENHANCE                                      = 0xA294;
constexpr unsigned int mmVGT_ESGS_RING_ITEMSIZE                           = 0xA2AB;
constexpr unsigned int mmVGT_ES_PER_GS                                    = 0xA296;
constexpr unsigned int mmVGT_EVENT_ADDRESS_REG                            = 0xA1FE;
constexpr unsigned int mmVGT_EVENT_INITIATOR                              = 0xA2A4;
constexpr unsigned int mmVGT_FIFO_DEPTHS                                  = 0x2234;
constexpr unsigned int mmVGT_GROUP_DECR                                   = 0xA28B;
constexpr unsigned int mmVGT_GROUP_FIRST_DECR                             = 0xA28A;
constexpr unsigned int mmVGT_GROUP_PRIM_TYPE                              = 0xA289;
constexpr unsigned int mmVGT_GROUP_VECT_0_CNTL                            = 0xA28C;
constexpr unsigned int mmVGT_GROUP_VECT_0_FMT_CNTL                        = 0xA28E;
constexpr unsigned int mmVGT_GROUP_VECT_1_CNTL                            = 0xA28D;
constexpr unsigned int mmVGT_GROUP_VECT_1_FMT_CNTL                        = 0xA28F;
constexpr unsigned int mmVGT_GSVS_RING_ITEMSIZE                           = 0xA2AC;
constexpr unsigned int mmVGT_GSVS_RING_OFFSET_1                           = 0xA298;
constexpr unsigned int mmVGT_GSVS_RING_OFFSET_2                           = 0xA299;
constexpr unsigned int mmVGT_GSVS_RING_OFFSET_3                           = 0xA29A;
constexpr unsigned int mmVGT_GS_INSTANCE_CNT                              = 0xA2E4;
constexpr unsigned int mmVGT_GS_MAX_VERT_OUT                              = 0xA2CE;
constexpr unsigned int mmVGT_GS_MAX_WAVE_ID                               = 0x2269;
constexpr unsigned int mmVGT_GS_MODE                                      = 0xA290;
constexpr unsigned int mmVGT_GS_ONCHIP_CNTL                               = 0xA291;
constexpr unsigned int mmVGT_GS_OUT_PRIM_TYPE                             = 0xA29B;
constexpr unsigned int mmVGT_GS_PER_ES                                    = 0xA295;
constexpr unsigned int mmVGT_GS_PER_VS                                    = 0xA297;
constexpr unsigned int mmVGT_GS_VERTEX_REUSE                              = 0x2235;
constexpr unsigned int mmVGT_GS_VERT_ITEMSIZE                             = 0xA2D7;
constexpr unsigned int mmVGT_GS_VERT_ITEMSIZE_1                           = 0xA2D8;
constexpr unsigned int mmVGT_GS_VERT_ITEMSIZE_2                           = 0xA2D9;
constexpr unsigned int mmVGT_GS_VERT_ITEMSIZE_3                           = 0xA2DA;
constexpr unsigned int mmVGT_HOS_CNTL                                     = 0xA285;
constexpr unsigned int mmVGT_HOS_MAX_TESS_LEVEL                           = 0xA286;
constexpr unsigned int mmVGT_HOS_MIN_TESS_LEVEL                           = 0xA287;
constexpr unsigned int mmVGT_HOS_REUSE_DEPTH                              = 0xA288;
constexpr unsigned int mmVGT_IMMED_DATA                                   = 0xA1FD;
constexpr unsigned int mmVGT_INDEX_TYPE                                   = 0xC243;
constexpr unsigned int mmVGT_INSTANCE_BASE_ID                             = 0xC25A;
constexpr unsigned int mmVGT_INSTANCE_STEP_RATE_0                         = 0xA2A8;
constexpr unsigned int mmVGT_INSTANCE_STEP_RATE_1                         = 0xA2A9;
constexpr unsigned int mmVGT_LAST_COPY_STATE                              = 0x2230;
constexpr unsigned int mmVGT_LS_HS_CONFIG                                 = 0xA2D6;
constexpr unsigned int mmVGT_MC_LAT_CNTL                                  = 0x2236;
constexpr unsigned int mmVGT_MULTI_PRIM_IB_RESET_INDX                     = 0xA103;
constexpr unsigned int mmVGT_NUM_INDICES                                  = 0xC24C;
constexpr unsigned int mmVGT_NUM_INSTANCES                                = 0xC24D;
constexpr unsigned int mmVGT_OUTPUT_PATH_CNTL                             = 0xA284;
constexpr unsigned int mmVGT_OUT_DEALLOC_CNTL                             = 0xA317;
constexpr unsigned int mmVGT_PRIMITIVEID_EN                               = 0xA2A1;
constexpr unsigned int mmVGT_PRIMITIVEID_RESET                            = 0xA2A3;
constexpr unsigned int mmVGT_PRIMITIVE_TYPE                               = 0xC242;
constexpr unsigned int mmVGT_REUSE_OFF                                    = 0xA2AD;
constexpr unsigned int mmVGT_SHADER_STAGES_EN                             = 0xA2D5;
constexpr unsigned int mmVGT_STRMOUT_BUFFER_CONFIG                        = 0xA2E6;
constexpr unsigned int mmVGT_STRMOUT_BUFFER_FILLED_SIZE_0                 = 0xC244;
constexpr unsigned int mmVGT_STRMOUT_BUFFER_FILLED_SIZE_1                 = 0xC245;
constexpr unsigned int mmVGT_STRMOUT_BUFFER_FILLED_SIZE_2                 = 0xC246;
constexpr unsigned int mmVGT_STRMOUT_BUFFER_FILLED_SIZE_3                 = 0xC247;
constexpr unsigned int mmVGT_STRMOUT_BUFFER_OFFSET_0                      = 0xA2B7;
constexpr unsigned int mmVGT_STRMOUT_BUFFER_OFFSET_1                      = 0xA2BB;
constexpr unsigned int mmVGT_STRMOUT_BUFFER_OFFSET_2                      = 0xA2BF;
constexpr unsigned int mmVGT_STRMOUT_BUFFER_OFFSET_3                      = 0xA2C3;
constexpr unsigned int mmVGT_STRMOUT_BUFFER_SIZE_0                        = 0xA2B4;
constexpr unsigned int mmVGT_STRMOUT_BUFFER_SIZE_1                        = 0xA2B8;
constexpr unsigned int mmVGT_STRMOUT_BUFFER_SIZE_2                        = 0xA2BC;
constexpr unsigned int mmVGT_STRMOUT_BUFFER_SIZE_3                        = 0xA2C0;
constexpr unsigned int mmVGT_STRMOUT_CONFIG                               = 0xA2E5;
constexpr unsigned int mmVGT_STRMOUT_DRAW_OPAQUE_BUFFER_FILLED_SIZE       = 0xA2CB;
constexpr unsigned int mmVGT_STRMOUT_DRAW_OPAQUE_OFFSET                   = 0xA2CA;
constexpr unsigned int mmVGT_STRMOUT_DRAW_OPAQUE_VERTEX_STRIDE            = 0xA2CC;
constexpr unsigned int mmVGT_STRMOUT_VTX_STRIDE_0                         = 0xA2B5;
constexpr unsigned int mmVGT_STRMOUT_VTX_STRIDE_1                         = 0xA2B9;
constexpr unsigned int mmVGT_STRMOUT_VTX_STRIDE_2                         = 0xA2BD;
constexpr unsigned int mmVGT_STRMOUT_VTX_STRIDE_3                         = 0xA2C1;
constexpr unsigned int mmVGT_SYS_CONFIG                                   = 0x2263;
constexpr unsigned int mmVGT_TESS_DISTRIBUTION                            = 0xA2D4;
constexpr unsigned int mmVGT_TF_PARAM                                     = 0xA2DB;
constexpr unsigned int mmVGT_VERTEX_REUSE_BLOCK_CNTL                      = 0xA316;
constexpr unsigned int mmVGT_VS_MAX_WAVE_ID                               = 0x2268;
constexpr unsigned int mmVGT_VTX_CNT_EN                                   = 0xA2AE;
constexpr unsigned int mmVGT_VTX_VECT_EJECT_REG                           = 0x222C;
constexpr unsigned int mmWD_BUF_RESOURCE_1                                = 0x2276;
constexpr unsigned int mmWD_BUF_RESOURCE_2                                = 0x2277;
constexpr unsigned int mmWD_CNTL_SB_BUF_BASE                              = 0xC254;
constexpr unsigned int mmWD_CNTL_SB_BUF_BASE_HI                           = 0xC255;
constexpr unsigned int mmWD_CNTL_STATUS                                   = 0x223F;
constexpr unsigned int mmWD_ENHANCE                                       = 0xA2A0;
constexpr unsigned int mmWD_INDEX_BUF_BASE                                = 0xC256;
constexpr unsigned int mmWD_INDEX_BUF_BASE_HI                             = 0xC257;
constexpr unsigned int mmWD_POS_BUF_BASE                                  = 0xC252;
constexpr unsigned int mmWD_POS_BUF_BASE_HI                               = 0xC253;
constexpr unsigned int mmWD_QOS                                           = 0x2242;
constexpr unsigned int mmWD_UTCL1_CNTL                                    = 0x2243;
constexpr unsigned int mmWD_UTCL1_STATUS                                  = 0x2244;

namespace Apu09_1xPlus
{
    constexpr unsigned int mmSPI_SHADER_PGM_CHKSUM_GS                         = 0x2C80;
    constexpr unsigned int mmSPI_SHADER_PGM_CHKSUM_HS                         = 0x2D00;
    constexpr unsigned int mmSPI_SHADER_PGM_CHKSUM_PS                         = 0x2C06;
    constexpr unsigned int mmSPI_SHADER_PGM_CHKSUM_VS                         = 0x2C45;
} // namespace Apu09_1xPlus

namespace Core
{
    constexpr unsigned int mmDB_DFSM_CONFIG                                   = 0x2630;
    constexpr unsigned int mmDB_DFSM_FLUSH_AUX_EVENT                          = 0x2636;
    constexpr unsigned int mmDB_DFSM_FLUSH_ENABLE                             = 0x2635;
    constexpr unsigned int mmDB_DFSM_PRIMS_IN_FLIGHT                          = 0x2633;
    constexpr unsigned int mmDB_DFSM_TILES_IN_FLIGHT                          = 0x2632;
    constexpr unsigned int mmDB_DFSM_WATCHDOG                                 = 0x2634;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_6                        = 0x31E2;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_7                        = 0x31E3;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_6                     = 0x31EC;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_7                     = 0x31ED;
    constexpr unsigned int mmSPI_WF_LIFETIME_LIMIT_1                          = 0x24AC;
    constexpr unsigned int mmUMCCH0_PerfMonCtl1                               = 0x14341;
    constexpr unsigned int mmUMCCH0_PerfMonCtl2                               = 0x14342;
    constexpr unsigned int mmUMCCH0_PerfMonCtl3                               = 0x14343;
    constexpr unsigned int mmUMCCH0_PerfMonCtl4                               = 0x14344;
    constexpr unsigned int mmUMCCH0_PerfMonCtl5                               = 0x14345;
    constexpr unsigned int mmUMCCH0_PerfMonCtlClk                             = 0x14340;
    constexpr unsigned int mmUMCCH0_PerfMonCtr1_Hi                            = 0x1434B;
    constexpr unsigned int mmUMCCH0_PerfMonCtr1_Lo                            = 0x1434A;
    constexpr unsigned int mmUMCCH0_PerfMonCtr2_Hi                            = 0x1434D;
    constexpr unsigned int mmUMCCH0_PerfMonCtr2_Lo                            = 0x1434C;
    constexpr unsigned int mmUMCCH0_PerfMonCtr3_Hi                            = 0x1434F;
    constexpr unsigned int mmUMCCH0_PerfMonCtr3_Lo                            = 0x1434E;
    constexpr unsigned int mmUMCCH0_PerfMonCtr4_Hi                            = 0x14351;
    constexpr unsigned int mmUMCCH0_PerfMonCtr4_Lo                            = 0x14350;
    constexpr unsigned int mmUMCCH0_PerfMonCtr5_Hi                            = 0x14353;
    constexpr unsigned int mmUMCCH0_PerfMonCtr5_Lo                            = 0x14352;
    constexpr unsigned int mmUMCCH0_PerfMonCtrClk_Hi                          = 0x14349;
    constexpr unsigned int mmUMCCH0_PerfMonCtrClk_Lo                          = 0x14348;
} // namespace Core

namespace Gfx09
{
    constexpr unsigned int mmATC_L2_PERFCOUNTER0_CFG                          = 0xDD40;
    constexpr unsigned int mmATC_L2_PERFCOUNTER1_CFG                          = 0xDD41;
    constexpr unsigned int mmATC_L2_PERFCOUNTER_HI                            = 0xD501;
    constexpr unsigned int mmATC_L2_PERFCOUNTER_LO                            = 0xD500;
    constexpr unsigned int mmATC_L2_PERFCOUNTER_RSLT_CNTL                     = 0xDD42;
    constexpr unsigned int mmATC_PERFCOUNTER0_CFG                             = 0x0C3E;
    constexpr unsigned int mmATC_PERFCOUNTER1_CFG                             = 0x0C3F;
    constexpr unsigned int mmATC_PERFCOUNTER2_CFG                             = 0x0C40;
    constexpr unsigned int mmATC_PERFCOUNTER3_CFG                             = 0x0C41;
    constexpr unsigned int mmATC_PERFCOUNTER_HI                               = 0x0C44;
    constexpr unsigned int mmATC_PERFCOUNTER_LO                               = 0x0C43;
    constexpr unsigned int mmATC_PERFCOUNTER_RSLT_CNTL                        = 0x0C42;
    constexpr unsigned int mmCB_COLOR0_ATTRIB2                                = 0xA31A;
    constexpr unsigned int mmCB_COLOR0_BASE_EXT                               = 0xA319;
    constexpr unsigned int mmCB_COLOR0_CMASK_BASE_EXT                         = 0xA320;
    constexpr unsigned int mmCB_COLOR0_DCC_BASE_EXT                           = 0xA326;
    constexpr unsigned int mmCB_COLOR0_FMASK_BASE_EXT                         = 0xA322;
    constexpr unsigned int mmCB_COLOR1_ATTRIB2                                = 0xA329;
    constexpr unsigned int mmCB_COLOR1_BASE_EXT                               = 0xA328;
    constexpr unsigned int mmCB_COLOR1_CMASK_BASE_EXT                         = 0xA32F;
    constexpr unsigned int mmCB_COLOR1_DCC_BASE_EXT                           = 0xA335;
    constexpr unsigned int mmCB_COLOR1_FMASK_BASE_EXT                         = 0xA331;
    constexpr unsigned int mmCB_COLOR2_ATTRIB2                                = 0xA338;
    constexpr unsigned int mmCB_COLOR2_BASE_EXT                               = 0xA337;
    constexpr unsigned int mmCB_COLOR2_CMASK_BASE_EXT                         = 0xA33E;
    constexpr unsigned int mmCB_COLOR2_DCC_BASE_EXT                           = 0xA344;
    constexpr unsigned int mmCB_COLOR2_FMASK_BASE_EXT                         = 0xA340;
    constexpr unsigned int mmCB_COLOR3_ATTRIB2                                = 0xA347;
    constexpr unsigned int mmCB_COLOR3_BASE_EXT                               = 0xA346;
    constexpr unsigned int mmCB_COLOR3_CMASK_BASE_EXT                         = 0xA34D;
    constexpr unsigned int mmCB_COLOR3_DCC_BASE_EXT                           = 0xA353;
    constexpr unsigned int mmCB_COLOR3_FMASK_BASE_EXT                         = 0xA34F;
    constexpr unsigned int mmCB_COLOR4_ATTRIB2                                = 0xA356;
    constexpr unsigned int mmCB_COLOR4_BASE_EXT                               = 0xA355;
    constexpr unsigned int mmCB_COLOR4_CMASK_BASE_EXT                         = 0xA35C;
    constexpr unsigned int mmCB_COLOR4_DCC_BASE_EXT                           = 0xA362;
    constexpr unsigned int mmCB_COLOR4_FMASK_BASE_EXT                         = 0xA35E;
    constexpr unsigned int mmCB_COLOR5_ATTRIB2                                = 0xA365;
    constexpr unsigned int mmCB_COLOR5_BASE_EXT                               = 0xA364;
    constexpr unsigned int mmCB_COLOR5_CMASK_BASE_EXT                         = 0xA36B;
    constexpr unsigned int mmCB_COLOR5_DCC_BASE_EXT                           = 0xA371;
    constexpr unsigned int mmCB_COLOR5_FMASK_BASE_EXT                         = 0xA36D;
    constexpr unsigned int mmCB_COLOR6_ATTRIB2                                = 0xA374;
    constexpr unsigned int mmCB_COLOR6_BASE_EXT                               = 0xA373;
    constexpr unsigned int mmCB_COLOR6_CMASK_BASE_EXT                         = 0xA37A;
    constexpr unsigned int mmCB_COLOR6_DCC_BASE_EXT                           = 0xA380;
    constexpr unsigned int mmCB_COLOR6_FMASK_BASE_EXT                         = 0xA37C;
    constexpr unsigned int mmCB_COLOR7_ATTRIB2                                = 0xA383;
    constexpr unsigned int mmCB_COLOR7_BASE_EXT                               = 0xA382;
    constexpr unsigned int mmCB_COLOR7_CMASK_BASE_EXT                         = 0xA389;
    constexpr unsigned int mmCB_COLOR7_DCC_BASE_EXT                           = 0xA38F;
    constexpr unsigned int mmCB_COLOR7_FMASK_BASE_EXT                         = 0xA38B;
    constexpr unsigned int mmCB_DCC_CONFIG                                    = 0x2688;
    constexpr unsigned int mmCB_HW_CONTROL                                    = 0x2680;
    constexpr unsigned int mmCB_HW_CONTROL_1                                  = 0x2681;
    constexpr unsigned int mmCB_HW_CONTROL_2                                  = 0x2682;
    constexpr unsigned int mmCB_HW_MEM_ARBITER_RD                             = 0x2686;
    constexpr unsigned int mmCB_HW_MEM_ARBITER_WR                             = 0x2687;
    constexpr unsigned int mmCB_MRT0_EPITCH                                   = 0xA1E8;
    constexpr unsigned int mmCB_MRT1_EPITCH                                   = 0xA1E9;
    constexpr unsigned int mmCB_MRT2_EPITCH                                   = 0xA1EA;
    constexpr unsigned int mmCB_MRT3_EPITCH                                   = 0xA1EB;
    constexpr unsigned int mmCB_MRT4_EPITCH                                   = 0xA1EC;
    constexpr unsigned int mmCB_MRT5_EPITCH                                   = 0xA1ED;
    constexpr unsigned int mmCB_MRT6_EPITCH                                   = 0xA1EE;
    constexpr unsigned int mmCB_MRT7_EPITCH                                   = 0xA1EF;
    constexpr unsigned int mmCOMPUTE_RELAUNCH                                 = 0x2E22;
    constexpr unsigned int mmCOMPUTE_WAVE_RESTORE_ADDR_HI                     = 0x2E24;
    constexpr unsigned int mmCOMPUTE_WAVE_RESTORE_ADDR_LO                     = 0x2E23;
    constexpr unsigned int mmDB_DEPTH_SIZE                                    = 0xA007;
    constexpr unsigned int mmDB_DFSM_CONTROL                                  = 0xA018;
    constexpr unsigned int mmDB_DFSM_WATERMARK                                = 0x2631;
    constexpr unsigned int mmDB_EXCEPTION_CONTROL                             = 0x261A;
    constexpr unsigned int mmDB_HTILE_DATA_BASE_HI                            = 0xA006;
    constexpr unsigned int mmDB_RMI_CACHE_POLICY                              = 0x261E;
    constexpr unsigned int mmDB_STENCIL_INFO                                  = 0xA00F;
    constexpr unsigned int mmDB_STENCIL_INFO2                                 = 0xA01B;
    constexpr unsigned int mmDB_STENCIL_READ_BASE                             = 0xA012;
    constexpr unsigned int mmDB_STENCIL_READ_BASE_HI                          = 0xA013;
    constexpr unsigned int mmDB_STENCIL_WRITE_BASE                            = 0xA016;
    constexpr unsigned int mmDB_STENCIL_WRITE_BASE_HI                         = 0xA017;
    constexpr unsigned int mmDB_Z_INFO                                        = 0xA00E;
    constexpr unsigned int mmDB_Z_INFO2                                       = 0xA01A;
    constexpr unsigned int mmDB_Z_READ_BASE                                   = 0xA010;
    constexpr unsigned int mmDB_Z_READ_BASE_HI                                = 0xA011;
    constexpr unsigned int mmDB_Z_WRITE_BASE_HI                               = 0xA015;
    constexpr unsigned int mmIA_CNTL_STATUS                                   = 0x2237;
    constexpr unsigned int mmIA_MULTI_VGT_PARAM                               = 0xC258;
    constexpr unsigned int mmIA_PERFCOUNTER0_HI                               = 0xD089;
    constexpr unsigned int mmIA_PERFCOUNTER0_LO                               = 0xD088;
    constexpr unsigned int mmIA_PERFCOUNTER0_SELECT                           = 0xD884;
    constexpr unsigned int mmIA_PERFCOUNTER0_SELECT1                          = 0xD888;
    constexpr unsigned int mmIA_PERFCOUNTER1_HI                               = 0xD08B;
    constexpr unsigned int mmIA_PERFCOUNTER1_LO                               = 0xD08A;
    constexpr unsigned int mmIA_PERFCOUNTER1_SELECT                           = 0xD885;
    constexpr unsigned int mmIA_PERFCOUNTER2_HI                               = 0xD08D;
    constexpr unsigned int mmIA_PERFCOUNTER2_LO                               = 0xD08C;
    constexpr unsigned int mmIA_PERFCOUNTER2_SELECT                           = 0xD886;
    constexpr unsigned int mmIA_PERFCOUNTER3_HI                               = 0xD08F;
    constexpr unsigned int mmIA_PERFCOUNTER3_LO                               = 0xD08E;
    constexpr unsigned int mmIA_PERFCOUNTER3_SELECT                           = 0xD887;
    constexpr unsigned int mmMC_VM_L2_PERFCOUNTER0_CFG                        = 0xDD4C;
    constexpr unsigned int mmMC_VM_L2_PERFCOUNTER1_CFG                        = 0xDD4D;
    constexpr unsigned int mmMC_VM_L2_PERFCOUNTER2_CFG                        = 0xDD4E;
    constexpr unsigned int mmMC_VM_L2_PERFCOUNTER3_CFG                        = 0xDD4F;
    constexpr unsigned int mmMC_VM_L2_PERFCOUNTER4_CFG                        = 0xDD50;
    constexpr unsigned int mmMC_VM_L2_PERFCOUNTER5_CFG                        = 0xDD51;
    constexpr unsigned int mmMC_VM_L2_PERFCOUNTER6_CFG                        = 0xDD52;
    constexpr unsigned int mmMC_VM_L2_PERFCOUNTER7_CFG                        = 0xDD53;
    constexpr unsigned int mmMC_VM_L2_PERFCOUNTER_HI                          = 0xD509;
    constexpr unsigned int mmMC_VM_L2_PERFCOUNTER_LO                          = 0xD508;
    constexpr unsigned int mmMC_VM_L2_PERFCOUNTER_RSLT_CNTL                   = 0xDD54;
    constexpr unsigned int mmPA_SU_PERFCOUNTER3_SELECT                        = 0xD905;
    constexpr unsigned int mmPA_UTCL1_CNTL1                                   = 0x22F9;
    constexpr unsigned int mmPA_UTCL1_CNTL2                                   = 0x22FA;
    constexpr unsigned int mmRLC_PERFMON_CLK_CNTL                             = 0xDCBF;
    constexpr unsigned int mmRLC_SPM_CB_PERFMON_SAMPLE_DELAY                  = 0xDC8A;
    constexpr unsigned int mmRLC_SPM_CPC_PERFMON_SAMPLE_DELAY                 = 0xDC88;
    constexpr unsigned int mmRLC_SPM_CPF_PERFMON_SAMPLE_DELAY                 = 0xDC89;
    constexpr unsigned int mmRLC_SPM_CPG_PERFMON_SAMPLE_DELAY                 = 0xDC87;
    constexpr unsigned int mmRLC_SPM_DB_PERFMON_SAMPLE_DELAY                  = 0xDC8B;
    constexpr unsigned int mmRLC_SPM_GDS_PERFMON_SAMPLE_DELAY                 = 0xDC8D;
    constexpr unsigned int mmRLC_SPM_GLOBAL_MUXSEL_ADDR                       = 0xDC9B;
    constexpr unsigned int mmRLC_SPM_GLOBAL_MUXSEL_DATA                       = 0xDC9C;
    constexpr unsigned int mmRLC_SPM_IA_PERFMON_SAMPLE_DELAY                  = 0xDC8E;
    constexpr unsigned int mmRLC_SPM_PA_PERFMON_SAMPLE_DELAY                  = 0xDC8C;
    constexpr unsigned int mmRLC_SPM_RING_RDPTR                               = 0xDC9D;
    constexpr unsigned int mmRLC_SPM_RMI_PERFMON_SAMPLE_DELAY                 = 0xDCA3;
    constexpr unsigned int mmRLC_SPM_SC_PERFMON_SAMPLE_DELAY                  = 0xDC90;
    constexpr unsigned int mmRLC_SPM_SEGMENT_THRESHOLD                        = 0xDC9E;
    constexpr unsigned int mmRLC_SPM_SE_MUXSEL_ADDR                           = 0xDC85;
    constexpr unsigned int mmRLC_SPM_SE_MUXSEL_DATA                           = 0xDC86;
    constexpr unsigned int mmRLC_SPM_SPI_PERFMON_SAMPLE_DELAY                 = 0xDC97;
    constexpr unsigned int mmRLC_SPM_SQG_PERFMON_SAMPLE_DELAY                 = 0xDC98;
    constexpr unsigned int mmRLC_SPM_SX_PERFMON_SAMPLE_DELAY                  = 0xDC9A;
    constexpr unsigned int mmRLC_SPM_TA_PERFMON_SAMPLE_DELAY                  = 0xDC94;
    constexpr unsigned int mmRLC_SPM_TCA_PERFMON_SAMPLE_DELAY                 = 0xDC92;
    constexpr unsigned int mmRLC_SPM_TCC_PERFMON_SAMPLE_DELAY                 = 0xDC91;
    constexpr unsigned int mmRLC_SPM_TCP_PERFMON_SAMPLE_DELAY                 = 0xDC93;
    constexpr unsigned int mmRLC_SPM_TD_PERFMON_SAMPLE_DELAY                  = 0xDC95;
    constexpr unsigned int mmRLC_SPM_VGT_PERFMON_SAMPLE_DELAY                 = 0xDC96;
    constexpr unsigned int mmSDMA0_PERFCOUNTER0_RESULT                        = 0x12B8;
    constexpr unsigned int mmSDMA0_PERFCOUNTER1_RESULT                        = 0x12B9;
    constexpr unsigned int mmSDMA0_PERFCOUNTER_TAG_DELAY_RANGE                = 0x12BA;
    constexpr unsigned int mmSDMA0_PERFMON_CNTL                               = 0x12B7;
    constexpr unsigned int mmSPI_CONFIG_CNTL                                  = 0xC440;
    constexpr unsigned int mmSPI_CONFIG_CNTL_1                                = 0xC441;
    constexpr unsigned int mmSPI_CONFIG_CNTL_2                                = 0xC442;
    constexpr unsigned int mmSPI_CONFIG_PS_CU_EN                              = 0x2452;
    constexpr unsigned int mmSPI_CSQ_WF_ACTIVE_COUNT_4                        = 0x24E0;
    constexpr unsigned int mmSPI_CSQ_WF_ACTIVE_COUNT_5                        = 0x24E1;
    constexpr unsigned int mmSPI_CSQ_WF_ACTIVE_COUNT_6                        = 0x24E2;
    constexpr unsigned int mmSPI_CSQ_WF_ACTIVE_COUNT_7                        = 0x24E3;
    constexpr unsigned int mmSPI_LB_CU_MASK                                   = 0x24D5;
    constexpr unsigned int mmSPI_LB_DATA_PERCU_WAVE_CS                        = 0x24E7;
    constexpr unsigned int mmSPI_LB_DATA_PERCU_WAVE_HSGS                      = 0x24E5;
    constexpr unsigned int mmSPI_LB_DATA_PERCU_WAVE_VSPS                      = 0x24E6;
    constexpr unsigned int mmSPI_PG_ENABLE_STATIC_CU_MASK                     = 0x24D7;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_8                        = 0x31E4;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_9                        = 0x31E5;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_10                       = 0x31F0;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_11                       = 0x31F1;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_12                       = 0x31F4;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_13                       = 0x31F5;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_14                       = 0x31F6;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_15                       = 0x31F7;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_8                     = 0x31EE;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_9                     = 0x31EF;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_10                    = 0x31F2;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_11                    = 0x31F3;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_12                    = 0x31F8;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_13                    = 0x31F9;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_14                    = 0x31FA;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_15                    = 0x31FB;
    constexpr unsigned int mmSPI_SHADER_PGM_HI_ES                             = 0x2C85;
    constexpr unsigned int mmSPI_SHADER_PGM_HI_LS                             = 0x2D05;
    constexpr unsigned int mmSPI_SHADER_PGM_LO_ES                             = 0x2C84;
    constexpr unsigned int mmSPI_SHADER_PGM_LO_LS                             = 0x2D04;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_GS_VS                       = 0x2C7C;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_COMMON_0                    = 0x2D4C;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_COMMON_1                    = 0x2D4D;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_COMMON_2                    = 0x2D4E;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_COMMON_3                    = 0x2D4F;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_COMMON_4                    = 0x2D50;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_COMMON_5                    = 0x2D51;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_COMMON_6                    = 0x2D52;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_COMMON_7                    = 0x2D53;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_COMMON_8                    = 0x2D54;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_COMMON_9                    = 0x2D55;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_COMMON_10                   = 0x2D56;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_COMMON_11                   = 0x2D57;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_COMMON_12                   = 0x2D58;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_COMMON_13                   = 0x2D59;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_COMMON_14                   = 0x2D5A;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_COMMON_15                   = 0x2D5B;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_COMMON_16                   = 0x2D5C;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_COMMON_17                   = 0x2D5D;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_COMMON_18                   = 0x2D5E;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_COMMON_19                   = 0x2D5F;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_COMMON_20                   = 0x2D60;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_COMMON_21                   = 0x2D61;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_COMMON_22                   = 0x2D62;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_COMMON_23                   = 0x2D63;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_COMMON_24                   = 0x2D64;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_COMMON_25                   = 0x2D65;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_COMMON_26                   = 0x2D66;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_COMMON_27                   = 0x2D67;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_COMMON_28                   = 0x2D68;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_COMMON_29                   = 0x2D69;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_COMMON_30                   = 0x2D6A;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_COMMON_31                   = 0x2D6B;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_0                        = 0x2CCC;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_1                        = 0x2CCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_2                        = 0x2CCE;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_3                        = 0x2CCF;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_4                        = 0x2CD0;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_5                        = 0x2CD1;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_6                        = 0x2CD2;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_7                        = 0x2CD3;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_8                        = 0x2CD4;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_9                        = 0x2CD5;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_10                       = 0x2CD6;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_11                       = 0x2CD7;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_12                       = 0x2CD8;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_13                       = 0x2CD9;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_14                       = 0x2CDA;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_15                       = 0x2CDB;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_16                       = 0x2CDC;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_17                       = 0x2CDD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_18                       = 0x2CDE;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_19                       = 0x2CDF;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_20                       = 0x2CE0;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_21                       = 0x2CE1;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_22                       = 0x2CE2;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_23                       = 0x2CE3;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_24                       = 0x2CE4;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_25                       = 0x2CE5;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_26                       = 0x2CE6;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_27                       = 0x2CE7;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_28                       = 0x2CE8;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_29                       = 0x2CE9;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_30                       = 0x2CEA;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_31                       = 0x2CEB;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_0                        = 0x2D0C;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_1                        = 0x2D0D;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_2                        = 0x2D0E;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_3                        = 0x2D0F;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_4                        = 0x2D10;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_5                        = 0x2D11;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_6                        = 0x2D12;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_7                        = 0x2D13;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_8                        = 0x2D14;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_9                        = 0x2D15;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_10                       = 0x2D16;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_11                       = 0x2D17;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_12                       = 0x2D18;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_13                       = 0x2D19;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_14                       = 0x2D1A;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_15                       = 0x2D1B;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_16                       = 0x2D1C;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_17                       = 0x2D1D;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_18                       = 0x2D1E;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_19                       = 0x2D1F;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_20                       = 0x2D20;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_21                       = 0x2D21;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_22                       = 0x2D22;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_23                       = 0x2D23;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_24                       = 0x2D24;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_25                       = 0x2D25;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_26                       = 0x2D26;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_27                       = 0x2D27;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_28                       = 0x2D28;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_29                       = 0x2D29;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_30                       = 0x2D2A;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_31                       = 0x2D2B;
    constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS4                         = 0x31CD;
    constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS5                         = 0x31CE;
    constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS6                         = 0x31CF;
    constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS7                         = 0x31D0;
    constexpr unsigned int mmSPI_WF_LIFETIME_LIMIT_6                          = 0x24B1;
    constexpr unsigned int mmSPI_WF_LIFETIME_LIMIT_7                          = 0x24B2;
    constexpr unsigned int mmSPI_WF_LIFETIME_LIMIT_8                          = 0x24B3;
    constexpr unsigned int mmSPI_WF_LIFETIME_LIMIT_9                          = 0x24B4;
    constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_3                         = 0x24B8;
    constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_5                         = 0x24BA;
    constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_10                        = 0x24BF;
    constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_12                        = 0x24C1;
    constexpr unsigned int mmSQ_BUF_RSRC_WORD0                                = 0x23C0;
    constexpr unsigned int mmSQ_BUF_RSRC_WORD1                                = 0x23C1;
    constexpr unsigned int mmSQ_BUF_RSRC_WORD2                                = 0x23C2;
    constexpr unsigned int mmSQ_BUF_RSRC_WORD3                                = 0x23C3;
    constexpr unsigned int mmSQ_CMD_TIMESTAMP                                 = 0x2375;
    constexpr unsigned int mmSQ_DS_0                                          = 0x237F;
    constexpr unsigned int mmSQ_DS_1                                          = 0x237F;
    constexpr unsigned int mmSQ_EDC_DED_CNT                                   = 0x23A4;
    constexpr unsigned int mmSQ_EDC_INFO                                      = 0x23A5;
    constexpr unsigned int mmSQ_EDC_SEC_CNT                                   = 0x23A3;
    constexpr unsigned int mmSQ_EXP_0                                         = 0x237F;
    constexpr unsigned int mmSQ_EXP_1                                         = 0x237F;
    constexpr unsigned int mmSQ_FLAT_0                                        = 0x237F;
    constexpr unsigned int mmSQ_FLAT_1                                        = 0x237F;
    constexpr unsigned int mmSQ_FLAT_SCRATCH_WORD0                            = 0x23D0;
    constexpr unsigned int mmSQ_FLAT_SCRATCH_WORD1                            = 0x23D1;
    constexpr unsigned int mmSQ_GLBL_0                                        = 0x237F;
    constexpr unsigned int mmSQ_GLBL_1                                        = 0x237F;
    constexpr unsigned int mmSQ_IMG_RSRC_WORD0                                = 0x23C4;
    constexpr unsigned int mmSQ_IMG_RSRC_WORD1                                = 0x23C5;
    constexpr unsigned int mmSQ_IMG_RSRC_WORD2                                = 0x23C6;
    constexpr unsigned int mmSQ_IMG_RSRC_WORD3                                = 0x23C7;
    constexpr unsigned int mmSQ_IMG_RSRC_WORD4                                = 0x23C8;
    constexpr unsigned int mmSQ_IMG_RSRC_WORD5                                = 0x23C9;
    constexpr unsigned int mmSQ_IMG_RSRC_WORD6                                = 0x23CA;
    constexpr unsigned int mmSQ_IMG_RSRC_WORD7                                = 0x23CB;
    constexpr unsigned int mmSQ_IMG_SAMP_WORD0                                = 0x23CC;
    constexpr unsigned int mmSQ_IMG_SAMP_WORD1                                = 0x23CD;
    constexpr unsigned int mmSQ_IMG_SAMP_WORD2                                = 0x23CE;
    constexpr unsigned int mmSQ_IMG_SAMP_WORD3                                = 0x23CF;
    constexpr unsigned int mmSQ_INST                                          = 0x237F;
    constexpr unsigned int mmSQ_INTERRUPT_AUTO_MASK                           = 0x2314;
    constexpr unsigned int mmSQ_INTERRUPT_MSG_CTRL                            = 0x2315;
    constexpr unsigned int mmSQ_LB_CTR0_CU                                    = 0x239E;
    constexpr unsigned int mmSQ_LB_CTR1_CU                                    = 0x239F;
    constexpr unsigned int mmSQ_LB_CTR2_CU                                    = 0x23A0;
    constexpr unsigned int mmSQ_LB_CTR3_CU                                    = 0x23A1;
    constexpr unsigned int mmSQ_LB_CTR_SEL                                    = 0x239D;
    constexpr unsigned int mmSQ_M0_GPR_IDX_WORD                               = 0x23D2;
    constexpr unsigned int mmSQ_MIMG_0                                        = 0x237F;
    constexpr unsigned int mmSQ_MIMG_1                                        = 0x237F;
    constexpr unsigned int mmSQ_MTBUF_0                                       = 0x237F;
    constexpr unsigned int mmSQ_MTBUF_1                                       = 0x237F;
    constexpr unsigned int mmSQ_MUBUF_0                                       = 0x237F;
    constexpr unsigned int mmSQ_MUBUF_1                                       = 0x237F;
    constexpr unsigned int mmSQ_PERFCOUNTER_MASK                              = 0xD9E1;
    constexpr unsigned int mmSQ_POWER_THROTTLE                                = 0xF091;
    constexpr unsigned int mmSQ_POWER_THROTTLE2                               = 0xF092;
    constexpr unsigned int mmSQ_REG_CREDITS                                   = 0x2304;
    constexpr unsigned int mmSQ_REG_TIMESTAMP                                 = 0x2374;
    constexpr unsigned int mmSQ_SCRATCH_0                                     = 0x237F;
    constexpr unsigned int mmSQ_SCRATCH_1                                     = 0x237F;
    constexpr unsigned int mmSQ_SHADER_TBA_HI                                 = 0x231D;
    constexpr unsigned int mmSQ_SHADER_TBA_LO                                 = 0x231C;
    constexpr unsigned int mmSQ_SHADER_TMA_HI                                 = 0x231F;
    constexpr unsigned int mmSQ_SHADER_TMA_LO                                 = 0x231E;
    constexpr unsigned int mmSQ_SMEM_0                                        = 0x237F;
    constexpr unsigned int mmSQ_SMEM_1                                        = 0x237F;
    constexpr unsigned int mmSQ_SOP1                                          = 0x237F;
    constexpr unsigned int mmSQ_SOP2                                          = 0x237F;
    constexpr unsigned int mmSQ_SOPC                                          = 0x237F;
    constexpr unsigned int mmSQ_SOPK                                          = 0x237F;
    constexpr unsigned int mmSQ_SOPP                                          = 0x237F;
    constexpr unsigned int mmSQ_THREAD_TRACE_BASE                             = 0xC330;
    constexpr unsigned int mmSQ_THREAD_TRACE_BASE2                            = 0xC337;
    constexpr unsigned int mmSQ_THREAD_TRACE_CNTR                             = 0xC33C;
    constexpr unsigned int mmSQ_THREAD_TRACE_CTRL                             = 0xC335;
    constexpr unsigned int mmSQ_THREAD_TRACE_HIWATER                          = 0xC33B;
    constexpr unsigned int mmSQ_THREAD_TRACE_MASK                             = 0xC332;
    constexpr unsigned int mmSQ_THREAD_TRACE_MODE                             = 0xC336;
    constexpr unsigned int mmSQ_THREAD_TRACE_PERF_MASK                        = 0xC334;
    constexpr unsigned int mmSQ_THREAD_TRACE_SIZE                             = 0xC331;
    constexpr unsigned int mmSQ_THREAD_TRACE_STATUS                           = 0xC33A;
    constexpr unsigned int mmSQ_THREAD_TRACE_TOKEN_MASK                       = 0xC333;
    constexpr unsigned int mmSQ_THREAD_TRACE_TOKEN_MASK2                      = 0xC338;
    constexpr unsigned int mmSQ_THREAD_TRACE_WORD_CMN                         = 0x23B0;
    constexpr unsigned int mmSQ_THREAD_TRACE_WORD_EVENT                       = 0x23B0;
    constexpr unsigned int mmSQ_THREAD_TRACE_WORD_INST                        = 0x23B0;
    constexpr unsigned int mmSQ_THREAD_TRACE_WORD_INST_PC_1_OF_2              = 0x23B0;
    constexpr unsigned int mmSQ_THREAD_TRACE_WORD_INST_PC_2_OF_2              = 0x23B1;
    constexpr unsigned int mmSQ_THREAD_TRACE_WORD_INST_USERDATA_1_OF_2        = 0x23B0;
    constexpr unsigned int mmSQ_THREAD_TRACE_WORD_INST_USERDATA_2_OF_2        = 0x23B1;
    constexpr unsigned int mmSQ_THREAD_TRACE_WORD_ISSUE                       = 0x23B0;
    constexpr unsigned int mmSQ_THREAD_TRACE_WORD_MISC                        = 0x23B0;
    constexpr unsigned int mmSQ_THREAD_TRACE_WORD_PERF_1_OF_2                 = 0x23B0;
    constexpr unsigned int mmSQ_THREAD_TRACE_WORD_PERF_2_OF_2                 = 0x23B1;
    constexpr unsigned int mmSQ_THREAD_TRACE_WORD_REG_1_OF_2                  = 0x23B0;
    constexpr unsigned int mmSQ_THREAD_TRACE_WORD_REG_2_OF_2                  = 0x23B0;
    constexpr unsigned int mmSQ_THREAD_TRACE_WORD_REG_CS_1_OF_2               = 0x23B0;
    constexpr unsigned int mmSQ_THREAD_TRACE_WORD_REG_CS_2_OF_2               = 0x23B0;
    constexpr unsigned int mmSQ_THREAD_TRACE_WORD_TIMESTAMP_1_OF_2            = 0x23B0;
    constexpr unsigned int mmSQ_THREAD_TRACE_WORD_TIMESTAMP_2_OF_2            = 0x23B1;
    constexpr unsigned int mmSQ_THREAD_TRACE_WORD_WAVE                        = 0x23B0;
    constexpr unsigned int mmSQ_THREAD_TRACE_WORD_WAVE_START                  = 0x23B0;
    constexpr unsigned int mmSQ_THREAD_TRACE_WPTR                             = 0xC339;
    constexpr unsigned int mmSQ_UTCL1_CNTL1                                   = 0x2317;
    constexpr unsigned int mmSQ_UTCL1_CNTL2                                   = 0x2318;
    constexpr unsigned int mmSQ_UTCL1_STATUS                                  = 0x2319;
    constexpr unsigned int mmSQ_VINTRP                                        = 0x237F;
    constexpr unsigned int mmSQ_VOP1                                          = 0x237F;
    constexpr unsigned int mmSQ_VOP2                                          = 0x237F;
    constexpr unsigned int mmSQ_VOP3P_0                                       = 0x237F;
    constexpr unsigned int mmSQ_VOP3P_1                                       = 0x237F;
    constexpr unsigned int mmSQ_VOP3_0                                        = 0x237F;
    constexpr unsigned int mmSQ_VOP3_0_SDST_ENC                               = 0x237F;
    constexpr unsigned int mmSQ_VOP3_1                                        = 0x237F;
    constexpr unsigned int mmSQ_VOPC                                          = 0x237F;
    constexpr unsigned int mmSQ_VOP_DPP                                       = 0x237F;
    constexpr unsigned int mmSQ_VOP_SDWA                                      = 0x237F;
    constexpr unsigned int mmSQ_VOP_SDWA_SDST_ENC                             = 0x237F;
    constexpr unsigned int mmTCA_PERFCOUNTER0_HI                              = 0xD391;
    constexpr unsigned int mmTCA_PERFCOUNTER0_LO                              = 0xD390;
    constexpr unsigned int mmTCA_PERFCOUNTER0_SELECT                          = 0xDB90;
    constexpr unsigned int mmTCA_PERFCOUNTER0_SELECT1                         = 0xDB91;
    constexpr unsigned int mmTCA_PERFCOUNTER1_HI                              = 0xD393;
    constexpr unsigned int mmTCA_PERFCOUNTER1_LO                              = 0xD392;
    constexpr unsigned int mmTCA_PERFCOUNTER1_SELECT                          = 0xDB92;
    constexpr unsigned int mmTCA_PERFCOUNTER1_SELECT1                         = 0xDB93;
    constexpr unsigned int mmTCA_PERFCOUNTER2_HI                              = 0xD395;
    constexpr unsigned int mmTCA_PERFCOUNTER2_LO                              = 0xD394;
    constexpr unsigned int mmTCA_PERFCOUNTER2_SELECT                          = 0xDB94;
    constexpr unsigned int mmTCA_PERFCOUNTER3_HI                              = 0xD397;
    constexpr unsigned int mmTCA_PERFCOUNTER3_LO                              = 0xD396;
    constexpr unsigned int mmTCA_PERFCOUNTER3_SELECT                          = 0xDB95;
    constexpr unsigned int mmTCC_PERFCOUNTER0_HI                              = 0xD381;
    constexpr unsigned int mmTCC_PERFCOUNTER0_LO                              = 0xD380;
    constexpr unsigned int mmTCC_PERFCOUNTER0_SELECT                          = 0xDB80;
    constexpr unsigned int mmTCC_PERFCOUNTER0_SELECT1                         = 0xDB81;
    constexpr unsigned int mmTCC_PERFCOUNTER1_HI                              = 0xD383;
    constexpr unsigned int mmTCC_PERFCOUNTER1_LO                              = 0xD382;
    constexpr unsigned int mmTCC_PERFCOUNTER1_SELECT                          = 0xDB82;
    constexpr unsigned int mmTCC_PERFCOUNTER1_SELECT1                         = 0xDB83;
    constexpr unsigned int mmTCC_PERFCOUNTER2_HI                              = 0xD385;
    constexpr unsigned int mmTCC_PERFCOUNTER2_LO                              = 0xD384;
    constexpr unsigned int mmTCC_PERFCOUNTER2_SELECT                          = 0xDB84;
    constexpr unsigned int mmTCC_PERFCOUNTER3_HI                              = 0xD387;
    constexpr unsigned int mmTCC_PERFCOUNTER3_LO                              = 0xD386;
    constexpr unsigned int mmTCC_PERFCOUNTER3_SELECT                          = 0xDB85;
    constexpr unsigned int mmTCP_PERFCOUNTER2_SELECT                          = 0xDB44;
    constexpr unsigned int mmTCP_PERFCOUNTER3_SELECT                          = 0xDB45;
    constexpr unsigned int mmVGT_CACHE_INVALIDATION                           = 0x2231;
    constexpr unsigned int mmVGT_CNTL_STATUS                                  = 0x223C;
    constexpr unsigned int mmVGT_DISPATCH_DRAW_INDEX                          = 0xA2DD;
    constexpr unsigned int mmVGT_GSVS_RING_SIZE                               = 0xC241;
    constexpr unsigned int mmVGT_GS_MAX_PRIMS_PER_SUBGROUP                    = 0xA2A5;
    constexpr unsigned int mmVGT_HS_OFFCHIP_PARAM                             = 0xC24F;
    constexpr unsigned int mmVGT_INDX_OFFSET                                  = 0xC24A;
    constexpr unsigned int mmVGT_MAX_VTX_INDX                                 = 0xC248;
    constexpr unsigned int mmVGT_MIN_VTX_INDX                                 = 0xC249;
    constexpr unsigned int mmVGT_MULTI_PRIM_IB_RESET_EN                       = 0xC24B;
    constexpr unsigned int mmVGT_PERFCOUNTER0_HI                              = 0xD091;
    constexpr unsigned int mmVGT_PERFCOUNTER0_LO                              = 0xD090;
    constexpr unsigned int mmVGT_PERFCOUNTER0_SELECT                          = 0xD88C;
    constexpr unsigned int mmVGT_PERFCOUNTER0_SELECT1                         = 0xD890;
    constexpr unsigned int mmVGT_PERFCOUNTER1_HI                              = 0xD093;
    constexpr unsigned int mmVGT_PERFCOUNTER1_LO                              = 0xD092;
    constexpr unsigned int mmVGT_PERFCOUNTER1_SELECT                          = 0xD88D;
    constexpr unsigned int mmVGT_PERFCOUNTER1_SELECT1                         = 0xD891;
    constexpr unsigned int mmVGT_PERFCOUNTER2_HI                              = 0xD095;
    constexpr unsigned int mmVGT_PERFCOUNTER2_LO                              = 0xD094;
    constexpr unsigned int mmVGT_PERFCOUNTER2_SELECT                          = 0xD88E;
    constexpr unsigned int mmVGT_PERFCOUNTER3_HI                              = 0xD097;
    constexpr unsigned int mmVGT_PERFCOUNTER3_LO                              = 0xD096;
    constexpr unsigned int mmVGT_PERFCOUNTER3_SELECT                          = 0xD88F;
    constexpr unsigned int mmVGT_PERFCOUNTER_SEID_MASK                        = 0xD894;
    constexpr unsigned int mmVGT_STRMOUT_DELAY                                = 0x2233;
    constexpr unsigned int mmVGT_TF_MEMORY_BASE                               = 0xC250;
    constexpr unsigned int mmVGT_TF_MEMORY_BASE_HI                            = 0xC251;
    constexpr unsigned int mmVGT_TF_RING_SIZE                                 = 0xC24E;
    constexpr unsigned int mmWD_PERFCOUNTER0_HI                               = 0xD081;
    constexpr unsigned int mmWD_PERFCOUNTER0_LO                               = 0xD080;
    constexpr unsigned int mmWD_PERFCOUNTER0_SELECT                           = 0xD880;
    constexpr unsigned int mmWD_PERFCOUNTER1_HI                               = 0xD083;
    constexpr unsigned int mmWD_PERFCOUNTER1_LO                               = 0xD082;
    constexpr unsigned int mmWD_PERFCOUNTER1_SELECT                           = 0xD881;
    constexpr unsigned int mmWD_PERFCOUNTER2_HI                               = 0xD085;
    constexpr unsigned int mmWD_PERFCOUNTER2_LO                               = 0xD084;
    constexpr unsigned int mmWD_PERFCOUNTER2_SELECT                           = 0xD882;
    constexpr unsigned int mmWD_PERFCOUNTER3_HI                               = 0xD087;
    constexpr unsigned int mmWD_PERFCOUNTER3_LO                               = 0xD086;
    constexpr unsigned int mmWD_PERFCOUNTER3_SELECT                           = 0xD883;
} // namespace Gfx09

namespace Gfx09_0
{
    constexpr unsigned int mmGCEA_PERFCOUNTER0_CFG                            = 0x2AF9;
    constexpr unsigned int mmGCEA_PERFCOUNTER1_CFG                            = 0x2AFA;
    constexpr unsigned int mmGCEA_PERFCOUNTER_HI                              = 0x2AF8;
    constexpr unsigned int mmGCEA_PERFCOUNTER_LO                              = 0x2AF7;
    constexpr unsigned int mmGCEA_PERFCOUNTER_RSLT_CNTL                       = 0x2AFB;
} // namespace Gfx09_0

namespace Gfx09_1x
{
    constexpr unsigned int mmCOMPUTE_SHADER_CHKSUM                            = 0x2E25;
    constexpr unsigned int mmGCEA_PERFCOUNTER0_CFG                            = 0x2AFE;
    constexpr unsigned int mmGCEA_PERFCOUNTER1_CFG                            = 0x2AFF;
    constexpr unsigned int mmGCEA_PERFCOUNTER_HI                              = 0x2AFD;
    constexpr unsigned int mmGCEA_PERFCOUNTER_LO                              = 0x2AFC;
    constexpr unsigned int mmGCEA_PERFCOUNTER_RSLT_CNTL                       = 0x2700;
    constexpr unsigned int mmIA_MULTI_VGT_PARAM_BC                            = 0xA2AA;
    constexpr unsigned int mmRLC_SPM_PERFMON_SAMPLE_DELAY_MAX                 = 0xDCA4;
    constexpr unsigned int mmSPI_WAVE_LIMIT_CNTL                              = 0xC443;
} // namespace Gfx09_1x

namespace Gfx09_1xPlus
{
    constexpr unsigned int mmCOMPUTE_DISPATCH_END                             = 0x2E7E;
    constexpr unsigned int mmPA_CL_PROG_NEAR_CLIP_Z                           = 0xA187;
} // namespace Gfx09_1xPlus

namespace Gfx10
{
    constexpr unsigned int mmCB_CACHE_EVICT_POINTS                            = 0x268E;
    constexpr unsigned int mmCB_COLOR0_ATTRIB2                                = 0xA3B0;
    constexpr unsigned int mmCB_COLOR0_ATTRIB3                                = 0xA3B8;
    constexpr unsigned int mmCB_COLOR0_BASE_EXT                               = 0xA390;
    constexpr unsigned int mmCB_COLOR0_CMASK_BASE_EXT                         = 0xA398;
    constexpr unsigned int mmCB_COLOR0_DCC_BASE_EXT                           = 0xA3A8;
    constexpr unsigned int mmCB_COLOR0_FMASK_BASE_EXT                         = 0xA3A0;
    constexpr unsigned int mmCB_COLOR1_ATTRIB2                                = 0xA3B1;
    constexpr unsigned int mmCB_COLOR1_ATTRIB3                                = 0xA3B9;
    constexpr unsigned int mmCB_COLOR1_BASE_EXT                               = 0xA391;
    constexpr unsigned int mmCB_COLOR1_CMASK_BASE_EXT                         = 0xA399;
    constexpr unsigned int mmCB_COLOR1_DCC_BASE_EXT                           = 0xA3A9;
    constexpr unsigned int mmCB_COLOR1_FMASK_BASE_EXT                         = 0xA3A1;
    constexpr unsigned int mmCB_COLOR2_ATTRIB2                                = 0xA3B2;
    constexpr unsigned int mmCB_COLOR2_ATTRIB3                                = 0xA3BA;
    constexpr unsigned int mmCB_COLOR2_BASE_EXT                               = 0xA392;
    constexpr unsigned int mmCB_COLOR2_CMASK_BASE_EXT                         = 0xA39A;
    constexpr unsigned int mmCB_COLOR2_DCC_BASE_EXT                           = 0xA3AA;
    constexpr unsigned int mmCB_COLOR2_FMASK_BASE_EXT                         = 0xA3A2;
    constexpr unsigned int mmCB_COLOR3_ATTRIB2                                = 0xA3B3;
    constexpr unsigned int mmCB_COLOR3_ATTRIB3                                = 0xA3BB;
    constexpr unsigned int mmCB_COLOR3_BASE_EXT                               = 0xA393;
    constexpr unsigned int mmCB_COLOR3_CMASK_BASE_EXT                         = 0xA39B;
    constexpr unsigned int mmCB_COLOR3_DCC_BASE_EXT                           = 0xA3AB;
    constexpr unsigned int mmCB_COLOR3_FMASK_BASE_EXT                         = 0xA3A3;
    constexpr unsigned int mmCB_COLOR4_ATTRIB2                                = 0xA3B4;
    constexpr unsigned int mmCB_COLOR4_ATTRIB3                                = 0xA3BC;
    constexpr unsigned int mmCB_COLOR4_BASE_EXT                               = 0xA394;
    constexpr unsigned int mmCB_COLOR4_CMASK_BASE_EXT                         = 0xA39C;
    constexpr unsigned int mmCB_COLOR4_DCC_BASE_EXT                           = 0xA3AC;
    constexpr unsigned int mmCB_COLOR4_FMASK_BASE_EXT                         = 0xA3A4;
    constexpr unsigned int mmCB_COLOR5_ATTRIB2                                = 0xA3B5;
    constexpr unsigned int mmCB_COLOR5_ATTRIB3                                = 0xA3BD;
    constexpr unsigned int mmCB_COLOR5_BASE_EXT                               = 0xA395;
    constexpr unsigned int mmCB_COLOR5_CMASK_BASE_EXT                         = 0xA39D;
    constexpr unsigned int mmCB_COLOR5_DCC_BASE_EXT                           = 0xA3AD;
    constexpr unsigned int mmCB_COLOR5_FMASK_BASE_EXT                         = 0xA3A5;
    constexpr unsigned int mmCB_COLOR6_ATTRIB2                                = 0xA3B6;
    constexpr unsigned int mmCB_COLOR6_ATTRIB3                                = 0xA3BE;
    constexpr unsigned int mmCB_COLOR6_BASE_EXT                               = 0xA396;
    constexpr unsigned int mmCB_COLOR6_CMASK_BASE_EXT                         = 0xA39E;
    constexpr unsigned int mmCB_COLOR6_DCC_BASE_EXT                           = 0xA3AE;
    constexpr unsigned int mmCB_COLOR6_FMASK_BASE_EXT                         = 0xA3A6;
    constexpr unsigned int mmCB_COLOR7_ATTRIB2                                = 0xA3B7;
    constexpr unsigned int mmCB_COLOR7_ATTRIB3                                = 0xA3BF;
    constexpr unsigned int mmCB_COLOR7_BASE_EXT                               = 0xA397;
    constexpr unsigned int mmCB_COLOR7_CMASK_BASE_EXT                         = 0xA39F;
    constexpr unsigned int mmCB_COLOR7_DCC_BASE_EXT                           = 0xA3AF;
    constexpr unsigned int mmCB_COLOR7_FMASK_BASE_EXT                         = 0xA3A7;
    constexpr unsigned int mmCB_COVERAGE_OUT_CONTROL                          = 0xA10A;
    constexpr unsigned int mmCB_DCC_CONFIG                                    = 0x2687;
    constexpr unsigned int mmCB_HW_CONTROL                                    = 0x2684;
    constexpr unsigned int mmCB_HW_CONTROL_1                                  = 0x2685;
    constexpr unsigned int mmCB_HW_CONTROL_2                                  = 0x2686;
    constexpr unsigned int mmCB_HW_CONTROL_4                                  = 0x2682;
    constexpr unsigned int mmCB_HW_MEM_ARBITER_RD                             = 0x2688;
    constexpr unsigned int mmCB_HW_MEM_ARBITER_WR                             = 0x2689;
    constexpr unsigned int mmCB_RMI_GL2_CACHE_CONTROL                         = 0xA104;
    constexpr unsigned int mmCB_STUTTER_CONTROL_CMASK_RDLAT                   = 0x268B;
    constexpr unsigned int mmCB_STUTTER_CONTROL_COLOR_RDLAT                   = 0x268D;
    constexpr unsigned int mmCB_STUTTER_CONTROL_FMASK_RDLAT                   = 0x268C;
    constexpr unsigned int mmCHA_PERFCOUNTER0_HI                              = 0xD601;
    constexpr unsigned int mmCHA_PERFCOUNTER0_LO                              = 0xD600;
    constexpr unsigned int mmCHA_PERFCOUNTER0_SELECT                          = 0xDDE0;
    constexpr unsigned int mmCHA_PERFCOUNTER0_SELECT1                         = 0xDDE1;
    constexpr unsigned int mmCHA_PERFCOUNTER1_HI                              = 0xD603;
    constexpr unsigned int mmCHA_PERFCOUNTER1_LO                              = 0xD602;
    constexpr unsigned int mmCHA_PERFCOUNTER1_SELECT                          = 0xDDE2;
    constexpr unsigned int mmCHA_PERFCOUNTER2_HI                              = 0xD605;
    constexpr unsigned int mmCHA_PERFCOUNTER2_LO                              = 0xD604;
    constexpr unsigned int mmCHA_PERFCOUNTER2_SELECT                          = 0xDDE3;
    constexpr unsigned int mmCHA_PERFCOUNTER3_HI                              = 0xD607;
    constexpr unsigned int mmCHA_PERFCOUNTER3_LO                              = 0xD606;
    constexpr unsigned int mmCHA_PERFCOUNTER3_SELECT                          = 0xDDE4;
    constexpr unsigned int mmCHC_PERFCOUNTER0_HI                              = 0xD3C1;
    constexpr unsigned int mmCHC_PERFCOUNTER0_LO                              = 0xD3C0;
    constexpr unsigned int mmCHC_PERFCOUNTER0_SELECT                          = 0xDBC0;
    constexpr unsigned int mmCHC_PERFCOUNTER0_SELECT1                         = 0xDBC1;
    constexpr unsigned int mmCHC_PERFCOUNTER1_HI                              = 0xD3C3;
    constexpr unsigned int mmCHC_PERFCOUNTER1_LO                              = 0xD3C2;
    constexpr unsigned int mmCHC_PERFCOUNTER1_SELECT                          = 0xDBC2;
    constexpr unsigned int mmCHC_PERFCOUNTER2_HI                              = 0xD3C5;
    constexpr unsigned int mmCHC_PERFCOUNTER2_LO                              = 0xD3C4;
    constexpr unsigned int mmCHC_PERFCOUNTER2_SELECT                          = 0xDBC3;
    constexpr unsigned int mmCHC_PERFCOUNTER3_HI                              = 0xD3C7;
    constexpr unsigned int mmCHC_PERFCOUNTER3_LO                              = 0xD3C6;
    constexpr unsigned int mmCHC_PERFCOUNTER3_SELECT                          = 0xDBC4;
    constexpr unsigned int mmCOMPUTE_DDID_INDEX                               = 0x2E29;
    constexpr unsigned int mmCOMPUTE_DESTINATION_EN_SE0                       = 0x2E16;
    constexpr unsigned int mmCOMPUTE_DESTINATION_EN_SE1                       = 0x2E17;
    constexpr unsigned int mmCOMPUTE_DESTINATION_EN_SE2                       = 0x2E19;
    constexpr unsigned int mmCOMPUTE_DESTINATION_EN_SE3                       = 0x2E1A;
    constexpr unsigned int mmCOMPUTE_DISPATCH_TUNNEL                          = 0x2E7D;
    constexpr unsigned int mmCOMPUTE_PGM_RSRC3                                = 0x2E28;
    constexpr unsigned int mmCOMPUTE_RELAUNCH                                 = 0x2E2B;
    constexpr unsigned int mmCOMPUTE_RELAUNCH2                                = 0x2E2E;
    constexpr unsigned int mmCOMPUTE_REQ_CTRL                                 = 0x2E22;
    constexpr unsigned int mmCOMPUTE_SHADER_CHKSUM                            = 0x2E2A;
    constexpr unsigned int mmCOMPUTE_USER_ACCUM_0                             = 0x2E24;
    constexpr unsigned int mmCOMPUTE_USER_ACCUM_1                             = 0x2E25;
    constexpr unsigned int mmCOMPUTE_USER_ACCUM_2                             = 0x2E26;
    constexpr unsigned int mmCOMPUTE_USER_ACCUM_3                             = 0x2E27;
    constexpr unsigned int mmCOMPUTE_WAVE_RESTORE_ADDR_HI                     = 0x2E2D;
    constexpr unsigned int mmCOMPUTE_WAVE_RESTORE_ADDR_LO                     = 0x2E2C;
    constexpr unsigned int mmDB_DEPTH_SIZE_XY                                 = 0xA007;
    constexpr unsigned int mmDB_EQUAD_STUTTER_CONTROL                         = 0x2612;
    constexpr unsigned int mmDB_ETILE_STUTTER_CONTROL                         = 0x2610;
    constexpr unsigned int mmDB_EXCEPTION_CONTROL                             = 0x261F;
    constexpr unsigned int mmDB_FGCG_INTERFACES_CLK_CTRL                      = 0x2638;
    constexpr unsigned int mmDB_FGCG_SRAMS_CLK_CTRL                           = 0x2637;
    constexpr unsigned int mmDB_FIFO_DEPTH3                                   = 0x261D;
    constexpr unsigned int mmDB_HTILE_DATA_BASE_HI                            = 0xA01E;
    constexpr unsigned int mmDB_LAST_OF_BURST_CONFIG                          = 0x261A;
    constexpr unsigned int mmDB_LQUAD_STUTTER_CONTROL                         = 0x2613;
    constexpr unsigned int mmDB_LTILE_STUTTER_CONTROL                         = 0x2611;
    constexpr unsigned int mmDB_RMI_L2_CACHE_CONTROL                          = 0xA01F;
    constexpr unsigned int mmDB_STENCIL_INFO                                  = 0xA011;
    constexpr unsigned int mmDB_STENCIL_READ_BASE                             = 0xA013;
    constexpr unsigned int mmDB_STENCIL_READ_BASE_HI                          = 0xA01B;
    constexpr unsigned int mmDB_STENCIL_WRITE_BASE                            = 0xA015;
    constexpr unsigned int mmDB_STENCIL_WRITE_BASE_HI                         = 0xA01D;
    constexpr unsigned int mmDB_Z_INFO                                        = 0xA010;
    constexpr unsigned int mmDB_Z_READ_BASE                                   = 0xA012;
    constexpr unsigned int mmDB_Z_READ_BASE_HI                                = 0xA01A;
    constexpr unsigned int mmDB_Z_WRITE_BASE_HI                               = 0xA01C;
    constexpr unsigned int mmGCEA_PERFCOUNTER2_HI                             = 0xD261;
    constexpr unsigned int mmGCEA_PERFCOUNTER2_LO                             = 0xD260;
    constexpr unsigned int mmGCEA_PERFCOUNTER2_MODE                           = 0xDA02;
    constexpr unsigned int mmGCEA_PERFCOUNTER2_SELECT                         = 0xDA00;
    constexpr unsigned int mmGCEA_PERFCOUNTER2_SELECT1                        = 0xDA01;
    constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER0_CFG                      = 0xDD2C;
    constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER1_CFG                      = 0xDD2D;
    constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER2_CFG                      = 0xDD2E;
    constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER3_CFG                      = 0xDD2F;
    constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER4_CFG                      = 0xDD30;
    constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER5_CFG                      = 0xDD31;
    constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER6_CFG                      = 0xDD32;
    constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER7_CFG                      = 0xDD33;
    constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER_HI                        = 0xD4E9;
    constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER_LO                        = 0xD4E8;
    constexpr unsigned int mmGCMC_VM_L2_PERFCOUNTER_RSLT_CNTL                 = 0xDD34;
    constexpr unsigned int mmGCR_PERFCOUNTER0_HI                              = 0xD521;
    constexpr unsigned int mmGCR_PERFCOUNTER0_LO                              = 0xD520;
    constexpr unsigned int mmGCR_PERFCOUNTER0_SELECT                          = 0xDD60;
    constexpr unsigned int mmGCR_PERFCOUNTER0_SELECT1                         = 0xDD61;
    constexpr unsigned int mmGCR_PERFCOUNTER1_HI                              = 0xD523;
    constexpr unsigned int mmGCR_PERFCOUNTER1_LO                              = 0xD522;
    constexpr unsigned int mmGCR_PERFCOUNTER1_SELECT                          = 0xDD62;
    constexpr unsigned int mmGCVML2_PERFCOUNTER2_0_HI                         = 0xD4FA;
    constexpr unsigned int mmGCVML2_PERFCOUNTER2_0_LO                         = 0xD4F8;
    constexpr unsigned int mmGCVML2_PERFCOUNTER2_0_MODE                       = 0xDD40;
    constexpr unsigned int mmGCVML2_PERFCOUNTER2_0_SELECT                     = 0xDD3C;
    constexpr unsigned int mmGCVML2_PERFCOUNTER2_0_SELECT1                    = 0xDD3E;
    constexpr unsigned int mmGCVML2_PERFCOUNTER2_1_HI                         = 0xD4FB;
    constexpr unsigned int mmGCVML2_PERFCOUNTER2_1_LO                         = 0xD4F9;
    constexpr unsigned int mmGCVML2_PERFCOUNTER2_1_MODE                       = 0xDD41;
    constexpr unsigned int mmGCVML2_PERFCOUNTER2_1_SELECT                     = 0xDD3D;
    constexpr unsigned int mmGCVML2_PERFCOUNTER2_1_SELECT1                    = 0xDD3F;
    constexpr unsigned int mmGE_CNTL                                          = 0xC25B;
    constexpr unsigned int mmGE_DMA_FIRST_INDEX                               = 0xC251;
    constexpr unsigned int mmGE_INDX_OFFSET                                   = 0xC24A;
    constexpr unsigned int mmGE_MAX_OUTPUT_PER_SUBGROUP                       = 0xA1FF;
    constexpr unsigned int mmGE_MAX_VTX_INDX                                  = 0xC259;
    constexpr unsigned int mmGE_MIN_VTX_INDX                                  = 0xC249;
    constexpr unsigned int mmGE_MULTI_PRIM_IB_RESET_EN                        = 0xC24B;
    constexpr unsigned int mmGE_NGG_SUBGRP_CNTL                               = 0xA2D3;
    constexpr unsigned int mmGE_PC_ALLOC                                      = 0xC260;
    constexpr unsigned int mmGE_PC_CNTL                                       = 0x2245;
    constexpr unsigned int mmGE_PRIV_CONTROL                                  = 0x2264;
    constexpr unsigned int mmGE_STATUS                                        = 0x2265;
    constexpr unsigned int mmGE_STEREO_CNTL                                   = 0xC25F;
    constexpr unsigned int mmGE_USER_VGPR1                                    = 0xC25C;
    constexpr unsigned int mmGE_USER_VGPR2                                    = 0xC25D;
    constexpr unsigned int mmGE_USER_VGPR3                                    = 0xC25E;
    constexpr unsigned int mmGE_USER_VGPR_EN                                  = 0xC262;
    constexpr unsigned int mmGL1A_PERFCOUNTER0_HI                             = 0xD5C1;
    constexpr unsigned int mmGL1A_PERFCOUNTER0_LO                             = 0xD5C0;
    constexpr unsigned int mmGL1A_PERFCOUNTER0_SELECT                         = 0xDDC0;
    constexpr unsigned int mmGL1A_PERFCOUNTER0_SELECT1                        = 0xDDC1;
    constexpr unsigned int mmGL1A_PERFCOUNTER1_HI                             = 0xD5C3;
    constexpr unsigned int mmGL1A_PERFCOUNTER1_LO                             = 0xD5C2;
    constexpr unsigned int mmGL1A_PERFCOUNTER1_SELECT                         = 0xDDC2;
    constexpr unsigned int mmGL1A_PERFCOUNTER2_HI                             = 0xD5C5;
    constexpr unsigned int mmGL1A_PERFCOUNTER2_LO                             = 0xD5C4;
    constexpr unsigned int mmGL1A_PERFCOUNTER2_SELECT                         = 0xDDC3;
    constexpr unsigned int mmGL1A_PERFCOUNTER3_HI                             = 0xD5C7;
    constexpr unsigned int mmGL1A_PERFCOUNTER3_LO                             = 0xD5C6;
    constexpr unsigned int mmGL1A_PERFCOUNTER3_SELECT                         = 0xDDC4;
    constexpr unsigned int mmGL1C_PERFCOUNTER0_HI                             = 0xD3A1;
    constexpr unsigned int mmGL1C_PERFCOUNTER0_LO                             = 0xD3A0;
    constexpr unsigned int mmGL1C_PERFCOUNTER0_SELECT                         = 0xDBA0;
    constexpr unsigned int mmGL1C_PERFCOUNTER0_SELECT1                        = 0xDBA1;
    constexpr unsigned int mmGL1C_PERFCOUNTER1_HI                             = 0xD3A3;
    constexpr unsigned int mmGL1C_PERFCOUNTER1_LO                             = 0xD3A2;
    constexpr unsigned int mmGL1C_PERFCOUNTER1_SELECT                         = 0xDBA2;
    constexpr unsigned int mmGL1C_PERFCOUNTER2_HI                             = 0xD3A5;
    constexpr unsigned int mmGL1C_PERFCOUNTER2_LO                             = 0xD3A4;
    constexpr unsigned int mmGL1C_PERFCOUNTER2_SELECT                         = 0xDBA3;
    constexpr unsigned int mmGL1C_PERFCOUNTER3_HI                             = 0xD3A7;
    constexpr unsigned int mmGL1C_PERFCOUNTER3_LO                             = 0xD3A6;
    constexpr unsigned int mmGL1C_PERFCOUNTER3_SELECT                         = 0xDBA4;
    constexpr unsigned int mmGL2A_PERFCOUNTER0_HI                             = 0xD391;
    constexpr unsigned int mmGL2A_PERFCOUNTER0_LO                             = 0xD390;
    constexpr unsigned int mmGL2A_PERFCOUNTER0_SELECT                         = 0xDB90;
    constexpr unsigned int mmGL2A_PERFCOUNTER0_SELECT1                        = 0xDB91;
    constexpr unsigned int mmGL2A_PERFCOUNTER1_HI                             = 0xD393;
    constexpr unsigned int mmGL2A_PERFCOUNTER1_LO                             = 0xD392;
    constexpr unsigned int mmGL2A_PERFCOUNTER1_SELECT                         = 0xDB92;
    constexpr unsigned int mmGL2A_PERFCOUNTER1_SELECT1                        = 0xDB93;
    constexpr unsigned int mmGL2A_PERFCOUNTER2_HI                             = 0xD395;
    constexpr unsigned int mmGL2A_PERFCOUNTER2_LO                             = 0xD394;
    constexpr unsigned int mmGL2A_PERFCOUNTER2_SELECT                         = 0xDB94;
    constexpr unsigned int mmGL2A_PERFCOUNTER3_HI                             = 0xD397;
    constexpr unsigned int mmGL2A_PERFCOUNTER3_LO                             = 0xD396;
    constexpr unsigned int mmGL2A_PERFCOUNTER3_SELECT                         = 0xDB95;
    constexpr unsigned int mmGL2C_PERFCOUNTER0_HI                             = 0xD381;
    constexpr unsigned int mmGL2C_PERFCOUNTER0_LO                             = 0xD380;
    constexpr unsigned int mmGL2C_PERFCOUNTER0_SELECT                         = 0xDB80;
    constexpr unsigned int mmGL2C_PERFCOUNTER0_SELECT1                        = 0xDB81;
    constexpr unsigned int mmGL2C_PERFCOUNTER1_HI                             = 0xD383;
    constexpr unsigned int mmGL2C_PERFCOUNTER1_LO                             = 0xD382;
    constexpr unsigned int mmGL2C_PERFCOUNTER1_SELECT                         = 0xDB82;
    constexpr unsigned int mmGL2C_PERFCOUNTER1_SELECT1                        = 0xDB83;
    constexpr unsigned int mmGL2C_PERFCOUNTER2_HI                             = 0xD385;
    constexpr unsigned int mmGL2C_PERFCOUNTER2_LO                             = 0xD384;
    constexpr unsigned int mmGL2C_PERFCOUNTER2_SELECT                         = 0xDB84;
    constexpr unsigned int mmGL2C_PERFCOUNTER3_HI                             = 0xD387;
    constexpr unsigned int mmGL2C_PERFCOUNTER3_LO                             = 0xD386;
    constexpr unsigned int mmGL2C_PERFCOUNTER3_SELECT                         = 0xDB85;
    constexpr unsigned int mmGRBM_PERFCOUNTER0_SELECT_HI                      = 0xD84D;
    constexpr unsigned int mmGRBM_PERFCOUNTER1_SELECT_HI                      = 0xD84E;
    constexpr unsigned int mmIA_MULTI_VGT_PARAM                               = 0xA2AA;
    constexpr unsigned int mmIA_MULTI_VGT_PARAM_PIPED                         = 0xC258;
    constexpr unsigned int mmIA_UTCL1_STATUS_2                                = 0x2237;
    constexpr unsigned int mmPA_PH_ENHANCE                                    = 0x22E1;
    constexpr unsigned int mmPA_PH_INTERFACE_FIFO_SIZE                        = 0x22E0;
    constexpr unsigned int mmPA_PH_PERFCOUNTER0_HI                            = 0xD581;
    constexpr unsigned int mmPA_PH_PERFCOUNTER0_LO                            = 0xD580;
    constexpr unsigned int mmPA_PH_PERFCOUNTER0_SELECT                        = 0xDD80;
    constexpr unsigned int mmPA_PH_PERFCOUNTER0_SELECT1                       = 0xDD81;
    constexpr unsigned int mmPA_PH_PERFCOUNTER1_HI                            = 0xD583;
    constexpr unsigned int mmPA_PH_PERFCOUNTER1_LO                            = 0xD582;
    constexpr unsigned int mmPA_PH_PERFCOUNTER1_SELECT                        = 0xDD82;
    constexpr unsigned int mmPA_PH_PERFCOUNTER1_SELECT1                       = 0xDD90;
    constexpr unsigned int mmPA_PH_PERFCOUNTER2_HI                            = 0xD585;
    constexpr unsigned int mmPA_PH_PERFCOUNTER2_LO                            = 0xD584;
    constexpr unsigned int mmPA_PH_PERFCOUNTER2_SELECT                        = 0xDD83;
    constexpr unsigned int mmPA_PH_PERFCOUNTER2_SELECT1                       = 0xDD91;
    constexpr unsigned int mmPA_PH_PERFCOUNTER3_HI                            = 0xD587;
    constexpr unsigned int mmPA_PH_PERFCOUNTER3_LO                            = 0xD586;
    constexpr unsigned int mmPA_PH_PERFCOUNTER3_SELECT                        = 0xDD84;
    constexpr unsigned int mmPA_PH_PERFCOUNTER3_SELECT1                       = 0xDD92;
    constexpr unsigned int mmPA_PH_PERFCOUNTER4_HI                            = 0xD589;
    constexpr unsigned int mmPA_PH_PERFCOUNTER4_LO                            = 0xD588;
    constexpr unsigned int mmPA_PH_PERFCOUNTER4_SELECT                        = 0xDD85;
    constexpr unsigned int mmPA_PH_PERFCOUNTER5_HI                            = 0xD58B;
    constexpr unsigned int mmPA_PH_PERFCOUNTER5_LO                            = 0xD58A;
    constexpr unsigned int mmPA_PH_PERFCOUNTER5_SELECT                        = 0xDD86;
    constexpr unsigned int mmPA_PH_PERFCOUNTER6_HI                            = 0xD58D;
    constexpr unsigned int mmPA_PH_PERFCOUNTER6_LO                            = 0xD58C;
    constexpr unsigned int mmPA_PH_PERFCOUNTER6_SELECT                        = 0xDD87;
    constexpr unsigned int mmPA_PH_PERFCOUNTER7_HI                            = 0xD58F;
    constexpr unsigned int mmPA_PH_PERFCOUNTER7_LO                            = 0xD58E;
    constexpr unsigned int mmPA_PH_PERFCOUNTER7_SELECT                        = 0xDD88;
    constexpr unsigned int mmPA_SC_BC_WAVE_BREAK                              = 0x22E4;
    constexpr unsigned int mmPA_SC_BINNER_CNTL_OVERRIDE                       = 0x22DE;
    constexpr unsigned int mmPA_SC_ENHANCE_2                                  = 0x22DC;
    constexpr unsigned int mmPA_SC_PBB_OVERRIDE_FLAG                          = 0x22DF;
    constexpr unsigned int mmPA_STATE_STEREO_X                                = 0xA211;
    constexpr unsigned int mmPA_STEREO_CNTL                                   = 0xA210;
    constexpr unsigned int mmPA_SU_PERFCOUNTER2_SELECT1                       = 0xD905;
    constexpr unsigned int mmPA_SU_PERFCOUNTER3_SELECT                        = 0xD906;
    constexpr unsigned int mmPA_SU_PERFCOUNTER3_SELECT1                       = 0xD907;
    constexpr unsigned int mmRLC_PERFMON_CLK_CNTL                             = 0xDCE4;
    constexpr unsigned int mmRLC_SPM_ACCUM_CTRL                               = 0xDC9A;
    constexpr unsigned int mmRLC_SPM_ACCUM_CTRLRAM_ADDR                       = 0xDC97;
    constexpr unsigned int mmRLC_SPM_ACCUM_CTRLRAM_DATA                       = 0xDC98;
    constexpr unsigned int mmRLC_SPM_ACCUM_DATARAM_ADDR                       = 0xDC95;
    constexpr unsigned int mmRLC_SPM_ACCUM_DATARAM_DATA                       = 0xDC96;
    constexpr unsigned int mmRLC_SPM_ACCUM_DATARAM_WRCOUNT                    = 0xDC9E;
    constexpr unsigned int mmRLC_SPM_ACCUM_MODE                               = 0xDC9B;
    constexpr unsigned int mmRLC_SPM_ACCUM_SAMPLES_REQUESTED                  = 0xDC9D;
    constexpr unsigned int mmRLC_SPM_ACCUM_STATUS                             = 0xDC99;
    constexpr unsigned int mmRLC_SPM_ACCUM_THRESHOLD                          = 0xDC9C;
    constexpr unsigned int mmRLC_SPM_DESER_START_SKEW                         = 0xDC8B;
    constexpr unsigned int mmRLC_SPM_GLB_SAMPLEDELAY_IND_ADDR                 = 0xDC90;
    constexpr unsigned int mmRLC_SPM_GLB_SAMPLEDELAY_IND_DATA                 = 0xDC91;
    constexpr unsigned int mmRLC_SPM_GLOBALS_MUXSEL_SKEW                      = 0xDC8D;
    constexpr unsigned int mmRLC_SPM_GLOBALS_SAMPLE_SKEW                      = 0xDC8C;
    constexpr unsigned int mmRLC_SPM_GLOBAL_MUXSEL_ADDR                       = 0xDC89;
    constexpr unsigned int mmRLC_SPM_GLOBAL_MUXSEL_DATA                       = 0xDC8A;
    constexpr unsigned int mmRLC_SPM_INT_INFO_1                               = 0xEC6F;
    constexpr unsigned int mmRLC_SPM_INT_INFO_2                               = 0xEC70;
    constexpr unsigned int mmRLC_SPM_PERFMON_GLB_SEGMENT_SIZE                 = 0xDCA0;
    constexpr unsigned int mmRLC_SPM_PERFMON_SE3TO0_SEGMENT_SIZE              = 0xDC9F;
    constexpr unsigned int mmRLC_SPM_RING_RDPTR                               = 0xDC85;
    constexpr unsigned int mmRLC_SPM_RING_WRPTR                               = 0xDC94;
    constexpr unsigned int mmRLC_SPM_SAMPLE_CNT                               = 0xED25;
    constexpr unsigned int mmRLC_SPM_SEGMENT_THRESHOLD                        = 0xDC86;
    constexpr unsigned int mmRLC_SPM_SE_MUXSEL_ADDR                           = 0xDC87;
    constexpr unsigned int mmRLC_SPM_SE_MUXSEL_DATA                           = 0xDC88;
    constexpr unsigned int mmRLC_SPM_SE_MUXSEL_SKEW                           = 0xDC8F;
    constexpr unsigned int mmRLC_SPM_SE_SAMPLEDELAY_IND_ADDR                  = 0xDC92;
    constexpr unsigned int mmRLC_SPM_SE_SAMPLEDELAY_IND_DATA                  = 0xDC93;
    constexpr unsigned int mmRLC_SPM_SE_SAMPLE_SKEW                           = 0xDC8E;
    constexpr unsigned int mmRLC_SPM_THREAD_TRACE_CTRL                        = 0xEDE6;
    constexpr unsigned int mmRLC_SPM_VIRT_CTRL                                = 0xDCA1;
    constexpr unsigned int mmRLC_SPM_VIRT_STATUS                              = 0xDCA3;
    constexpr unsigned int mmRPB_PERFCOUNTER0_CFG                             = 0x0CEB;
    constexpr unsigned int mmRPB_PERFCOUNTER1_CFG                             = 0x0CEC;
    constexpr unsigned int mmRPB_PERFCOUNTER2_CFG                             = 0x0CED;
    constexpr unsigned int mmRPB_PERFCOUNTER3_CFG                             = 0x0CEE;
    constexpr unsigned int mmRPB_PERFCOUNTER_HI                               = 0x0CEA;
    constexpr unsigned int mmRPB_PERFCOUNTER_LO                               = 0x0CE9;
    constexpr unsigned int mmRPB_PERFCOUNTER_RSLT_CNTL                        = 0x0CEF;
    constexpr unsigned int mmSPI_FEATURE_CTRL                                 = 0x31FE;
    constexpr unsigned int mmSPI_LB_DATA_PERWGP_WAVE_CS                       = 0x24E7;
    constexpr unsigned int mmSPI_LB_DATA_PERWGP_WAVE_HSGS                     = 0x24E5;
    constexpr unsigned int mmSPI_LB_DATA_PERWGP_WAVE_VSPS                     = 0x24E6;
    constexpr unsigned int mmSPI_LB_WGP_MASK                                  = 0x24D5;
    constexpr unsigned int mmSPI_PG_ENABLE_STATIC_WGP_MASK                    = 0x24D7;
    constexpr unsigned int mmSPI_PQEV_CTRL                                    = 0x2720;
    constexpr unsigned int mmSPI_SHADER_IDX_FORMAT                            = 0xA1C2;
    constexpr unsigned int mmSPI_SHADER_PGM_HI_ES                             = 0x2CC9;
    constexpr unsigned int mmSPI_SHADER_PGM_HI_ES_GS                          = 0x2C85;
    constexpr unsigned int mmSPI_SHADER_PGM_HI_LS                             = 0x2D49;
    constexpr unsigned int mmSPI_SHADER_PGM_HI_LS_HS                          = 0x2D05;
    constexpr unsigned int mmSPI_SHADER_PGM_LO_ES                             = 0x2CC8;
    constexpr unsigned int mmSPI_SHADER_PGM_LO_ES_GS                          = 0x2C84;
    constexpr unsigned int mmSPI_SHADER_PGM_LO_LS                             = 0x2D48;
    constexpr unsigned int mmSPI_SHADER_PGM_LO_LS_HS                          = 0x2D04;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_GS_VS                       = 0x2C7B;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC4_PS                          = 0x2C01;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC4_VS                          = 0x2C41;
    constexpr unsigned int mmSPI_SHADER_REQ_CTRL_ESGS                         = 0x2CB0;
    constexpr unsigned int mmSPI_SHADER_REQ_CTRL_LSHS                         = 0x2D30;
    constexpr unsigned int mmSPI_SHADER_REQ_CTRL_PS                           = 0x2C30;
    constexpr unsigned int mmSPI_SHADER_REQ_CTRL_VS                           = 0x2C70;
    constexpr unsigned int mmSPI_SHADER_RSRC_LIMIT_CTRL                       = 0x31FF;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_ESGS_0                     = 0x2CB2;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_ESGS_1                     = 0x2CB3;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_ESGS_2                     = 0x2CB4;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_ESGS_3                     = 0x2CB5;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_LSHS_0                     = 0x2D32;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_LSHS_1                     = 0x2D33;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_LSHS_2                     = 0x2D34;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_LSHS_3                     = 0x2D35;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_PS_0                       = 0x2C32;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_PS_1                       = 0x2C33;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_PS_2                       = 0x2C34;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_PS_3                       = 0x2C35;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_VS_0                       = 0x2C72;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_VS_1                       = 0x2C73;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_VS_2                       = 0x2C74;
    constexpr unsigned int mmSPI_SHADER_USER_ACCUM_VS_3                       = 0x2C75;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_0                        = 0x2C8C;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_1                        = 0x2C8D;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_2                        = 0x2C8E;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_3                        = 0x2C8F;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_4                        = 0x2C90;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_5                        = 0x2C91;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_6                        = 0x2C92;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_7                        = 0x2C93;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_8                        = 0x2C94;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_9                        = 0x2C95;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_10                       = 0x2C96;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_11                       = 0x2C97;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_12                       = 0x2C98;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_13                       = 0x2C99;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_14                       = 0x2C9A;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_15                       = 0x2C9B;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_16                       = 0x2C9C;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_17                       = 0x2C9D;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_18                       = 0x2C9E;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_19                       = 0x2C9F;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_20                       = 0x2CA0;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_21                       = 0x2CA1;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_22                       = 0x2CA2;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_23                       = 0x2CA3;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_24                       = 0x2CA4;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_25                       = 0x2CA5;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_26                       = 0x2CA6;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_27                       = 0x2CA7;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_28                       = 0x2CA8;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_29                       = 0x2CA9;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_30                       = 0x2CAA;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_GS_31                       = 0x2CAB;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_0                        = 0x2D0C;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_1                        = 0x2D0D;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_2                        = 0x2D0E;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_3                        = 0x2D0F;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_4                        = 0x2D10;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_5                        = 0x2D11;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_6                        = 0x2D12;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_7                        = 0x2D13;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_8                        = 0x2D14;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_9                        = 0x2D15;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_10                       = 0x2D16;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_11                       = 0x2D17;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_12                       = 0x2D18;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_13                       = 0x2D19;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_14                       = 0x2D1A;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_15                       = 0x2D1B;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_16                       = 0x2D1C;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_17                       = 0x2D1D;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_18                       = 0x2D1E;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_19                       = 0x2D1F;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_20                       = 0x2D20;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_21                       = 0x2D21;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_22                       = 0x2D22;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_23                       = 0x2D23;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_24                       = 0x2D24;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_25                       = 0x2D25;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_26                       = 0x2D26;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_27                       = 0x2D27;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_28                       = 0x2D28;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_29                       = 0x2D29;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_30                       = 0x2D2A;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_HS_31                       = 0x2D2B;
    constexpr unsigned int mmSQ_ARB_CONFIG                                    = 0x230C;
    constexpr unsigned int mmSQ_LB_CTR_SEL0                                   = 0x239D;
    constexpr unsigned int mmSQ_LB_CTR_SEL1                                   = 0x239E;
    constexpr unsigned int mmSQ_THREAD_TRACE_BUF0_BASE                        = 0x2340;
    constexpr unsigned int mmSQ_THREAD_TRACE_BUF0_SIZE                        = 0x2341;
    constexpr unsigned int mmSQ_THREAD_TRACE_BUF1_BASE                        = 0x2342;
    constexpr unsigned int mmSQ_THREAD_TRACE_BUF1_SIZE                        = 0x2343;
    constexpr unsigned int mmSQ_THREAD_TRACE_CTRL                             = 0x2347;
    constexpr unsigned int mmSQ_THREAD_TRACE_DROPPED_CNTR                     = 0x2349;
    constexpr unsigned int mmSQ_THREAD_TRACE_GFX_DRAW_CNTR                    = 0x234B;
    constexpr unsigned int mmSQ_THREAD_TRACE_GFX_MARKER_CNTR                  = 0x234C;
    constexpr unsigned int mmSQ_THREAD_TRACE_HP3D_DRAW_CNTR                   = 0x234D;
    constexpr unsigned int mmSQ_THREAD_TRACE_HP3D_MARKER_CNTR                 = 0x234E;
    constexpr unsigned int mmSQ_THREAD_TRACE_MASK                             = 0x2345;
    constexpr unsigned int mmSQ_THREAD_TRACE_STATUS                           = 0x2348;
    constexpr unsigned int mmSQ_THREAD_TRACE_TOKEN_MASK                       = 0x2346;
    constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_4                       = 0xC344;
    constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_5                       = 0xC345;
    constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_6                       = 0xC346;
    constexpr unsigned int mmSQ_THREAD_TRACE_USERDATA_7                       = 0xC347;
    constexpr unsigned int mmSQ_THREAD_TRACE_WPTR                             = 0x2344;
    constexpr unsigned int mmSQ_WATCH0_ADDR_H                                 = 0x2330;
    constexpr unsigned int mmSQ_WATCH0_ADDR_L                                 = 0x2331;
    constexpr unsigned int mmSQ_WATCH0_CNTL                                   = 0x2332;
    constexpr unsigned int mmSQ_WATCH1_ADDR_H                                 = 0x2333;
    constexpr unsigned int mmSQ_WATCH1_ADDR_L                                 = 0x2334;
    constexpr unsigned int mmSQ_WATCH1_CNTL                                   = 0x2335;
    constexpr unsigned int mmSQ_WATCH2_ADDR_H                                 = 0x2336;
    constexpr unsigned int mmSQ_WATCH2_ADDR_L                                 = 0x2337;
    constexpr unsigned int mmSQ_WATCH2_CNTL                                   = 0x2338;
    constexpr unsigned int mmSQ_WATCH3_ADDR_H                                 = 0x2339;
    constexpr unsigned int mmSQ_WATCH3_ADDR_L                                 = 0x233A;
    constexpr unsigned int mmSQ_WATCH3_CNTL                                   = 0x233B;
    constexpr unsigned int mmTA_POWER_CNTL                                    = 0x2540;
    constexpr unsigned int mmTCP_PERFCOUNTER_FILTER2                          = 0x32BB;
    constexpr unsigned int mmUTCL1_PERFCOUNTER0_HI                            = 0xD51D;
    constexpr unsigned int mmUTCL1_PERFCOUNTER0_LO                            = 0xD51C;
    constexpr unsigned int mmUTCL1_PERFCOUNTER0_SELECT                        = 0xDD63;
    constexpr unsigned int mmUTCL1_PERFCOUNTER1_HI                            = 0xD51F;
    constexpr unsigned int mmUTCL1_PERFCOUNTER1_LO                            = 0xD51E;
    constexpr unsigned int mmUTCL1_PERFCOUNTER1_SELECT                        = 0xDD64;
    constexpr unsigned int mmVGT_INDX_OFFSET                                  = 0xA102;
    constexpr unsigned int mmVGT_MAX_VTX_INDX                                 = 0xA100;
    constexpr unsigned int mmVGT_MIN_VTX_INDX                                 = 0xA101;
    constexpr unsigned int mmVGT_MULTI_PRIM_IB_RESET_EN                       = 0xA2A5;
    constexpr unsigned int mmVGT_STRMOUT_DELAY                                = 0x2275;
} // namespace Gfx10

namespace Gfx101
{
    constexpr unsigned int mmATC_PERFCOUNTER0_CFG                             = 0x0C1E;
    constexpr unsigned int mmATC_PERFCOUNTER1_CFG                             = 0x0C1F;
    constexpr unsigned int mmATC_PERFCOUNTER2_CFG                             = 0x0C20;
    constexpr unsigned int mmATC_PERFCOUNTER3_CFG                             = 0x0C21;
    constexpr unsigned int mmATC_PERFCOUNTER_HI                               = 0x0C24;
    constexpr unsigned int mmATC_PERFCOUNTER_LO                               = 0x0C23;
    constexpr unsigned int mmATC_PERFCOUNTER_RSLT_CNTL                        = 0x0C22;
    constexpr unsigned int mmCHCG_PERFCOUNTER0_HI                             = 0xD3C9;
    constexpr unsigned int mmCHCG_PERFCOUNTER0_LO                             = 0xD3C8;
    constexpr unsigned int mmCHCG_PERFCOUNTER0_SELECT                         = 0xDBC6;
    constexpr unsigned int mmCHCG_PERFCOUNTER0_SELECT1                        = 0xDBC7;
    constexpr unsigned int mmCHCG_PERFCOUNTER1_HI                             = 0xD3CB;
    constexpr unsigned int mmCHCG_PERFCOUNTER1_LO                             = 0xD3CA;
    constexpr unsigned int mmCHCG_PERFCOUNTER1_SELECT                         = 0xDBC8;
    constexpr unsigned int mmCHCG_PERFCOUNTER2_HI                             = 0xD3CD;
    constexpr unsigned int mmCHCG_PERFCOUNTER2_LO                             = 0xD3CC;
    constexpr unsigned int mmCHCG_PERFCOUNTER2_SELECT                         = 0xDBC9;
    constexpr unsigned int mmCHCG_PERFCOUNTER3_HI                             = 0xD3CF;
    constexpr unsigned int mmCHCG_PERFCOUNTER3_LO                             = 0xD3CE;
    constexpr unsigned int mmCHCG_PERFCOUNTER3_SELECT                         = 0xDBCA;
    constexpr unsigned int mmGCEA_PERFCOUNTER0_CFG                            = 0x2706;
    constexpr unsigned int mmGCEA_PERFCOUNTER1_CFG                            = 0x2707;
    constexpr unsigned int mmGCEA_PERFCOUNTER_HI                              = 0x2705;
    constexpr unsigned int mmGCEA_PERFCOUNTER_LO                              = 0x2704;
    constexpr unsigned int mmGCEA_PERFCOUNTER_RSLT_CNTL                       = 0x2708;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER0_CFG                       = 0xDD20;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER1_CFG                       = 0xDD21;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER2_HI                        = 0xD4FD;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER2_LO                        = 0xD4FC;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER2_MODE                      = 0xDD4E;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER2_SELECT                    = 0xDD4C;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER2_SELECT1                   = 0xDD4D;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER_HI                         = 0xD4E1;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER_LO                         = 0xD4E0;
    constexpr unsigned int mmGC_ATC_L2_PERFCOUNTER_RSLT_CNTL                  = 0xDD22;
    constexpr unsigned int mmGE_FAST_CLKS                                     = 0x2248;
    constexpr unsigned int mmGE_PERFCOUNTER0_HI                               = 0xD081;
    constexpr unsigned int mmGE_PERFCOUNTER0_LO                               = 0xD080;
    constexpr unsigned int mmGE_PERFCOUNTER0_SELECT                           = 0xD880;
    constexpr unsigned int mmGE_PERFCOUNTER0_SELECT1                          = 0xD881;
    constexpr unsigned int mmGE_PERFCOUNTER1_HI                               = 0xD083;
    constexpr unsigned int mmGE_PERFCOUNTER1_LO                               = 0xD082;
    constexpr unsigned int mmGE_PERFCOUNTER1_SELECT                           = 0xD882;
    constexpr unsigned int mmGE_PERFCOUNTER1_SELECT1                          = 0xD883;
    constexpr unsigned int mmGE_PERFCOUNTER2_HI                               = 0xD085;
    constexpr unsigned int mmGE_PERFCOUNTER2_LO                               = 0xD084;
    constexpr unsigned int mmGE_PERFCOUNTER2_SELECT                           = 0xD884;
    constexpr unsigned int mmGE_PERFCOUNTER2_SELECT1                          = 0xD885;
    constexpr unsigned int mmGE_PERFCOUNTER3_HI                               = 0xD087;
    constexpr unsigned int mmGE_PERFCOUNTER3_LO                               = 0xD086;
    constexpr unsigned int mmGE_PERFCOUNTER3_SELECT                           = 0xD886;
    constexpr unsigned int mmGE_PERFCOUNTER3_SELECT1                          = 0xD887;
    constexpr unsigned int mmGE_PERFCOUNTER4_HI                               = 0xD089;
    constexpr unsigned int mmGE_PERFCOUNTER4_LO                               = 0xD088;
    constexpr unsigned int mmGE_PERFCOUNTER4_SELECT                           = 0xD888;
    constexpr unsigned int mmGE_PERFCOUNTER5_HI                               = 0xD08B;
    constexpr unsigned int mmGE_PERFCOUNTER5_LO                               = 0xD08A;
    constexpr unsigned int mmGE_PERFCOUNTER5_SELECT                           = 0xD88A;
    constexpr unsigned int mmGE_PERFCOUNTER6_HI                               = 0xD08D;
    constexpr unsigned int mmGE_PERFCOUNTER6_LO                               = 0xD08C;
    constexpr unsigned int mmGE_PERFCOUNTER6_SELECT                           = 0xD88C;
    constexpr unsigned int mmGE_PERFCOUNTER7_HI                               = 0xD08F;
    constexpr unsigned int mmGE_PERFCOUNTER7_LO                               = 0xD08E;
    constexpr unsigned int mmGE_PERFCOUNTER7_SELECT                           = 0xD88E;
    constexpr unsigned int mmGE_PERFCOUNTER8_HI                               = 0xD091;
    constexpr unsigned int mmGE_PERFCOUNTER8_LO                               = 0xD090;
    constexpr unsigned int mmGE_PERFCOUNTER8_SELECT                           = 0xD890;
    constexpr unsigned int mmGE_PERFCOUNTER9_HI                               = 0xD093;
    constexpr unsigned int mmGE_PERFCOUNTER9_LO                               = 0xD092;
    constexpr unsigned int mmGE_PERFCOUNTER9_SELECT                           = 0xD892;
    constexpr unsigned int mmGE_PERFCOUNTER10_HI                              = 0xD095;
    constexpr unsigned int mmGE_PERFCOUNTER10_LO                              = 0xD094;
    constexpr unsigned int mmGE_PERFCOUNTER10_SELECT                          = 0xD894;
    constexpr unsigned int mmGE_PERFCOUNTER11_HI                              = 0xD097;
    constexpr unsigned int mmGE_PERFCOUNTER11_LO                              = 0xD096;
    constexpr unsigned int mmGE_PERFCOUNTER11_SELECT                          = 0xD896;
    constexpr unsigned int mmGUS_PERFCOUNTER0_CFG                             = 0xCC40;
    constexpr unsigned int mmGUS_PERFCOUNTER1_CFG                             = 0xCC41;
    constexpr unsigned int mmGUS_PERFCOUNTER2_HI                              = 0xD641;
    constexpr unsigned int mmGUS_PERFCOUNTER2_LO                              = 0xD640;
    constexpr unsigned int mmGUS_PERFCOUNTER2_MODE                            = 0xDE02;
    constexpr unsigned int mmGUS_PERFCOUNTER2_SELECT                          = 0xDE00;
    constexpr unsigned int mmGUS_PERFCOUNTER2_SELECT1                         = 0xDE01;
    constexpr unsigned int mmGUS_PERFCOUNTER_HI                               = 0xCC3F;
    constexpr unsigned int mmGUS_PERFCOUNTER_LO                               = 0xCC3E;
    constexpr unsigned int mmGUS_PERFCOUNTER_RSLT_CNTL                        = 0xCC42;
    constexpr unsigned int mmRPB_PERF_COUNTER_CNTL                            = 0x0CE2;
    constexpr unsigned int mmSPI_CONFIG_CNTL                                  = 0x2440;
    constexpr unsigned int mmSPI_CONFIG_CNTL_1                                = 0x244F;
    constexpr unsigned int mmSPI_CONFIG_CNTL_1_REMAP                          = 0xC441;
    constexpr unsigned int mmSPI_CONFIG_CNTL_2                                = 0x244E;
    constexpr unsigned int mmSPI_CONFIG_CNTL_2_REMAP                          = 0xC442;
    constexpr unsigned int mmSPI_CONFIG_CNTL_REMAP                            = 0xC440;
    constexpr unsigned int mmSPI_CSQ_WF_ACTIVE_COUNT_4                        = 0x24E0;
    constexpr unsigned int mmSPI_CSQ_WF_ACTIVE_COUNT_5                        = 0x24E1;
    constexpr unsigned int mmSPI_CSQ_WF_ACTIVE_COUNT_6                        = 0x24E2;
    constexpr unsigned int mmSPI_CSQ_WF_ACTIVE_COUNT_7                        = 0x24E3;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_8                        = 0x31E4;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_9                        = 0x31E5;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_10                       = 0x31F0;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_11                       = 0x31F1;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_12                       = 0x31F4;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_13                       = 0x31F5;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_14                       = 0x31F6;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_CU_15                       = 0x31F7;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_8                     = 0x31EE;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_9                     = 0x31EF;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_10                    = 0x31F2;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_11                    = 0x31F3;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_12                    = 0x31F8;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_13                    = 0x31F9;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_14                    = 0x31FA;
    constexpr unsigned int mmSPI_RESOURCE_RESERVE_EN_CU_15                    = 0x31FB;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC1_ES                          = 0x2CCA;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC1_LS                          = 0x2D4A;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_ES                          = 0x2CCB;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_ES_GS                       = 0x2CBC;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_ES_VS                       = 0x2C7C;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_LS                          = 0x2D4B;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_LS_ES                       = 0x2CFD;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_LS_HS                       = 0x2D3D;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC2_LS_VS                       = 0x2C7D;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC3_ES                          = 0x2CC7;
    constexpr unsigned int mmSPI_SHADER_PGM_RSRC3_LS                          = 0x2D47;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_0                        = 0x2CCC;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_1                        = 0x2CCD;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_2                        = 0x2CCE;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_3                        = 0x2CCF;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_4                        = 0x2CD0;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_5                        = 0x2CD1;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_6                        = 0x2CD2;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_7                        = 0x2CD3;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_8                        = 0x2CD4;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_9                        = 0x2CD5;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_10                       = 0x2CD6;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_11                       = 0x2CD7;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_12                       = 0x2CD8;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_13                       = 0x2CD9;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_14                       = 0x2CDA;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_ES_15                       = 0x2CDB;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_0                        = 0x2D4C;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_1                        = 0x2D4D;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_2                        = 0x2D4E;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_3                        = 0x2D4F;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_4                        = 0x2D50;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_5                        = 0x2D51;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_6                        = 0x2D52;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_7                        = 0x2D53;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_8                        = 0x2D54;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_9                        = 0x2D55;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_10                       = 0x2D56;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_11                       = 0x2D57;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_12                       = 0x2D58;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_13                       = 0x2D59;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_14                       = 0x2D5A;
    constexpr unsigned int mmSPI_SHADER_USER_DATA_LS_15                       = 0x2D5B;
    constexpr unsigned int mmSPI_SYS_COMPUTE                                  = 0x2721;
    constexpr unsigned int mmSPI_SYS_WIF_CNTL                                 = 0x2722;
    constexpr unsigned int mmSPI_USER_ACCUM_VMID_CNTL                         = 0x243F;
    constexpr unsigned int mmSPI_WAVE_LIMIT_CNTL                              = 0x244D;
    constexpr unsigned int mmSPI_WAVE_LIMIT_CNTL_REMAP                        = 0xC443;
    constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS4                         = 0x31CD;
    constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS5                         = 0x31CE;
    constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS6                         = 0x31CF;
    constexpr unsigned int mmSPI_WCL_PIPE_PERCENT_CS7                         = 0x31D0;
    constexpr unsigned int mmSPI_WF_LIFETIME_LIMIT_6                          = 0x24B1;
    constexpr unsigned int mmSPI_WF_LIFETIME_LIMIT_7                          = 0x24B2;
    constexpr unsigned int mmSPI_WF_LIFETIME_LIMIT_8                          = 0x24B3;
    constexpr unsigned int mmSPI_WF_LIFETIME_LIMIT_9                          = 0x24B4;
    constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_3                         = 0x24B8;
    constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_5                         = 0x24BA;
    constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_10                        = 0x24BF;
    constexpr unsigned int mmSPI_WF_LIFETIME_STATUS_12                        = 0x24C1;
    constexpr unsigned int mmSQ_INTERRUPT_AUTO_MASK                           = 0x2314;
    constexpr unsigned int mmSQ_INTERRUPT_MSG_CTRL                            = 0x2315;
    constexpr unsigned int mmSQ_SHADER_TBA_HI                                 = 0x231D;
    constexpr unsigned int mmSQ_SHADER_TBA_LO                                 = 0x231C;
    constexpr unsigned int mmSQ_SHADER_TMA_HI                                 = 0x231F;
    constexpr unsigned int mmSQ_SHADER_TMA_LO                                 = 0x231E;
    constexpr unsigned int mmTCP_PERFCOUNTER2_SELECT                          = 0xDB44;
    constexpr unsigned int mmTCP_PERFCOUNTER3_SELECT                          = 0xDB45;
    constexpr unsigned int mmUMCCH1_PerfMonCtl1                               = 0x14B41;
    constexpr unsigned int mmUMCCH1_PerfMonCtl2                               = 0x14B42;
    constexpr unsigned int mmUMCCH1_PerfMonCtl3                               = 0x14B43;
    constexpr unsigned int mmUMCCH1_PerfMonCtl4                               = 0x14B44;
    constexpr unsigned int mmUMCCH1_PerfMonCtl5                               = 0x14B45;
    constexpr unsigned int mmUMCCH1_PerfMonCtlClk                             = 0x14B40;
    constexpr unsigned int mmUMCCH1_PerfMonCtr1_Hi                            = 0x14B4B;
    constexpr unsigned int mmUMCCH1_PerfMonCtr1_Lo                            = 0x14B4A;
    constexpr unsigned int mmUMCCH1_PerfMonCtr2_Hi                            = 0x14B4D;
    constexpr unsigned int mmUMCCH1_PerfMonCtr2_Lo                            = 0x14B4C;
    constexpr unsigned int mmUMCCH1_PerfMonCtr3_Hi                            = 0x14B4F;
    constexpr unsigned int mmUMCCH1_PerfMonCtr3_Lo                            = 0x14B4E;
    constexpr unsigned int mmUMCCH1_PerfMonCtr4_Hi                            = 0x14B51;
    constexpr unsigned int mmUMCCH1_PerfMonCtr4_Lo                            = 0x14B50;
    constexpr unsigned int mmUMCCH1_PerfMonCtr5_Hi                            = 0x14B53;
    constexpr unsigned int mmUMCCH1_PerfMonCtr5_Lo                            = 0x14B52;
    constexpr unsigned int mmUMCCH1_PerfMonCtrClk_Hi                          = 0x14B49;
    constexpr unsigned int mmUMCCH1_PerfMonCtrClk_Lo                          = 0x14B48;
    constexpr unsigned int mmUMCCH3_PerfMonCtl1                               = 0x54B41;
    constexpr unsigned int mmUMCCH3_PerfMonCtl2                               = 0x54B42;
    constexpr unsigned int mmUMCCH3_PerfMonCtl3                               = 0x54B43;
    constexpr unsigned int mmUMCCH3_PerfMonCtl4                               = 0x54B44;
    constexpr unsigned int mmUMCCH3_PerfMonCtl5                               = 0x54B45;
    constexpr unsigned int mmUMCCH3_PerfMonCtlClk                             = 0x54B40;
    constexpr unsigned int mmUMCCH3_PerfMonCtr1_Hi                            = 0x54B4B;
    constexpr unsigned int mmUMCCH3_PerfMonCtr1_Lo                            = 0x54B4A;
    constexpr unsigned int mmUMCCH3_PerfMonCtr2_Hi                            = 0x54B4D;
    constexpr unsigned int mmUMCCH3_PerfMonCtr2_Lo                            = 0x54B4C;
    constexpr unsigned int mmUMCCH3_PerfMonCtr3_Hi                            = 0x54B4F;
    constexpr unsigned int mmUMCCH3_PerfMonCtr3_Lo                            = 0x54B4E;
    constexpr unsigned int mmUMCCH3_PerfMonCtr4_Hi                            = 0x54B51;
    constexpr unsigned int mmUMCCH3_PerfMonCtr4_Lo                            = 0x54B50;
    constexpr unsigned int mmUMCCH3_PerfMonCtr5_Hi                            = 0x54B53;
    constexpr unsigned int mmUMCCH3_PerfMonCtr5_Lo                            = 0x54B52;
    constexpr unsigned int mmUMCCH3_PerfMonCtrClk_Hi                          = 0x54B49;
    constexpr unsigned int mmUMCCH3_PerfMonCtrClk_Lo                          = 0x54B48;
    constexpr unsigned int mmUMCCH5_PerfMonCtl1                               = 0x94B41;
    constexpr unsigned int mmUMCCH5_PerfMonCtl2                               = 0x94B42;
    constexpr unsigned int mmUMCCH5_PerfMonCtl3                               = 0x94B43;
    constexpr unsigned int mmUMCCH5_PerfMonCtl4                               = 0x94B44;
    constexpr unsigned int mmUMCCH5_PerfMonCtl5                               = 0x94B45;
    constexpr unsigned int mmUMCCH5_PerfMonCtlClk                             = 0x94B40;
    constexpr unsigned int mmUMCCH5_PerfMonCtr1_Hi                            = 0x94B4B;
    constexpr unsigned int mmUMCCH5_PerfMonCtr1_Lo                            = 0x94B4A;
    constexpr unsigned int mmUMCCH5_PerfMonCtr2_Hi                            = 0x94B4D;
    constexpr unsigned int mmUMCCH5_PerfMonCtr2_Lo                            = 0x94B4C;
    constexpr unsigned int mmUMCCH5_PerfMonCtr3_Hi                            = 0x94B4F;
    constexpr unsigned int mmUMCCH5_PerfMonCtr3_Lo                            = 0x94B4E;
    constexpr unsigned int mmUMCCH5_PerfMonCtr4_Hi                            = 0x94B51;
    constexpr unsigned int mmUMCCH5_PerfMonCtr4_Lo                            = 0x94B50;
    constexpr unsigned int mmUMCCH5_PerfMonCtr5_Hi                            = 0x94B53;
    constexpr unsigned int mmUMCCH5_PerfMonCtr5_Lo                            = 0x94B52;
    constexpr unsigned int mmUMCCH5_PerfMonCtrClk_Hi                          = 0x94B49;
    constexpr unsigned int mmUMCCH5_PerfMonCtrClk_Lo                          = 0x94B48;
    constexpr unsigned int mmUMCCH7_PerfMonCtl1                               = 0xD4B41;
    constexpr unsigned int mmUMCCH7_PerfMonCtl2                               = 0xD4B42;
    constexpr unsigned int mmUMCCH7_PerfMonCtl3                               = 0xD4B43;
    constexpr unsigned int mmUMCCH7_PerfMonCtl4                               = 0xD4B44;
    constexpr unsigned int mmUMCCH7_PerfMonCtl5                               = 0xD4B45;
    constexpr unsigned int mmUMCCH7_PerfMonCtlClk                             = 0xD4B40;
    constexpr unsigned int mmUMCCH7_PerfMonCtr1_Hi                            = 0xD4B4B;
    constexpr unsigned int mmUMCCH7_PerfMonCtr1_Lo                            = 0xD4B4A;
    constexpr unsigned int mmUMCCH7_PerfMonCtr2_Hi                            = 0xD4B4D;
    constexpr unsigned int mmUMCCH7_PerfMonCtr2_Lo                            = 0xD4B4C;
    constexpr unsigned int mmUMCCH7_PerfMonCtr3_Hi                            = 0xD4B4F;
    constexpr unsigned int mmUMCCH7_PerfMonCtr3_Lo                            = 0xD4B4E;
    constexpr unsigned int mmUMCCH7_PerfMonCtr4_Hi                            = 0xD4B51;
    constexpr unsigned int mmUMCCH7_PerfMonCtr4_Lo                            = 0xD4B50;
    constexpr unsigned int mmUMCCH7_PerfMonCtr5_Hi                            = 0xD4B53;
    constexpr unsigned int mmUMCCH7_PerfMonCtr5_Lo                            = 0xD4B52;
    constexpr unsigned int mmUMCCH7_PerfMonCtrClk_Hi                          = 0xD4B49;
    constexpr unsigned int mmUMCCH7_PerfMonCtrClk_Lo                          = 0xD4B48;
    constexpr unsigned int mmUMCCH9_PerfMonCtl1                               = 0x114B41;
    constexpr unsigned int mmUMCCH9_PerfMonCtl2                               = 0x114B42;
    constexpr unsigned int mmUMCCH9_PerfMonCtl3                               = 0x114B43;
    constexpr unsigned int mmUMCCH9_PerfMonCtl4                               = 0x114B44;
    constexpr unsigned int mmUMCCH9_PerfMonCtl5                               = 0x114B45;
    constexpr unsigned int mmUMCCH9_PerfMonCtlClk                             = 0x114B40;
    constexpr unsigned int mmUMCCH9_PerfMonCtr1_Hi                            = 0x114B4B;
    constexpr unsigned int mmUMCCH9_PerfMonCtr1_Lo                            = 0x114B4A;
    constexpr unsigned int mmUMCCH9_PerfMonCtr2_Hi                            = 0x114B4D;
    constexpr unsigned int mmUMCCH9_PerfMonCtr2_Lo                            = 0x114B4C;
    constexpr unsigned int mmUMCCH9_PerfMonCtr3_Hi                            = 0x114B4F;
    constexpr unsigned int mmUMCCH9_PerfMonCtr3_Lo                            = 0x114B4E;
    constexpr unsigned int mmUMCCH9_PerfMonCtr4_Hi                            = 0x114B51;
    constexpr unsigned int mmUMCCH9_PerfMonCtr4_Lo                            = 0x114B50;
    constexpr unsigned int mmUMCCH9_PerfMonCtr5_Hi                            = 0x114B53;
    constexpr unsigned int mmUMCCH9_PerfMonCtr5_Lo                            = 0x114B52;
    constexpr unsigned int mmUMCCH9_PerfMonCtrClk_Hi                          = 0x114B49;
    constexpr unsigned int mmUMCCH9_PerfMonCtrClk_Lo                          = 0x114B48;
    constexpr unsigned int mmUMCCH11_PerfMonCtl1                              = 0x154B41;
    constexpr unsigned int mmUMCCH11_PerfMonCtl2                              = 0x154B42;
    constexpr unsigned int mmUMCCH11_PerfMonCtl3                              = 0x154B43;
    constexpr unsigned int mmUMCCH11_PerfMonCtl4                              = 0x154B44;
    constexpr unsigned int mmUMCCH11_PerfMonCtl5                              = 0x154B45;
    constexpr unsigned int mmUMCCH11_PerfMonCtlClk                            = 0x154B40;
    constexpr unsigned int mmUMCCH11_PerfMonCtr1_Hi                           = 0x154B4B;
    constexpr unsigned int mmUMCCH11_PerfMonCtr1_Lo                           = 0x154B4A;
    constexpr unsigned int mmUMCCH11_PerfMonCtr2_Hi                           = 0x154B4D;
    constexpr unsigned int mmUMCCH11_PerfMonCtr2_Lo                           = 0x154B4C;
    constexpr unsigned int mmUMCCH11_PerfMonCtr3_Hi                           = 0x154B4F;
    constexpr unsigned int mmUMCCH11_PerfMonCtr3_Lo                           = 0x154B4E;
    constexpr unsigned int mmUMCCH11_PerfMonCtr4_Hi                           = 0x154B51;
    constexpr unsigned int mmUMCCH11_PerfMonCtr4_Lo                           = 0x154B50;
    constexpr unsigned int mmUMCCH11_PerfMonCtr5_Hi                           = 0x154B53;
    constexpr unsigned int mmUMCCH11_PerfMonCtr5_Lo                           = 0x154B52;
    constexpr unsigned int mmUMCCH11_PerfMonCtrClk_Hi                         = 0x154B49;
    constexpr unsigned int mmUMCCH11_PerfMonCtrClk_Lo                         = 0x154B48;
    constexpr unsigned int mmUMCCH13_PerfMonCtl1                              = 0x194B41;
    constexpr unsigned int mmUMCCH13_PerfMonCtl2                              = 0x194B42;
    constexpr unsigned int mmUMCCH13_PerfMonCtl3                              = 0x194B43;
    constexpr unsigned int mmUMCCH13_PerfMonCtl4                              = 0x194B44;
    constexpr unsigned int mmUMCCH13_PerfMonCtl5                              = 0x194B45;
    constexpr unsigned int mmUMCCH13_PerfMonCtlClk                            = 0x194B40;
    constexpr unsigned int mmUMCCH13_PerfMonCtr1_Hi                           = 0x194B4B;
    constexpr unsigned int mmUMCCH13_PerfMonCtr1_Lo                           = 0x194B4A;
    constexpr unsigned int mmUMCCH13_PerfMonCtr2_Hi                           = 0x194B4D;
    constexpr unsigned int mmUMCCH13_PerfMonCtr2_Lo                           = 0x194B4C;
    constexpr unsigned int mmUMCCH13_PerfMonCtr3_Hi                           = 0x194B4F;
    constexpr unsigned int mmUMCCH13_PerfMonCtr3_Lo                           = 0x194B4E;
    constexpr unsigned int mmUMCCH13_PerfMonCtr4_Hi                           = 0x194B51;
    constexpr unsigned int mmUMCCH13_PerfMonCtr4_Lo                           = 0x194B50;
    constexpr unsigned int mmUMCCH13_PerfMonCtr5_Hi                           = 0x194B53;
    constexpr unsigned int mmUMCCH13_PerfMonCtr5_Lo                           = 0x194B52;
    constexpr unsigned int mmUMCCH13_PerfMonCtrClk_Hi                         = 0x194B49;
    constexpr unsigned int mmUMCCH13_PerfMonCtrClk_Lo                         = 0x194B48;
    constexpr unsigned int mmUMCCH15_PerfMonCtl1                              = 0x1D4B41;
    constexpr unsigned int mmUMCCH15_PerfMonCtl2                              = 0x1D4B42;
    constexpr unsigned int mmUMCCH15_PerfMonCtl3                              = 0x1D4B43;
    constexpr unsigned int mmUMCCH15_PerfMonCtl4                              = 0x1D4B44;
    constexpr unsigned int mmUMCCH15_PerfMonCtl5                              = 0x1D4B45;
    constexpr unsigned int mmUMCCH15_PerfMonCtlClk                            = 0x1D4B40;
    constexpr unsigned int mmUMCCH15_PerfMonCtr1_Hi                           = 0x1D4B4B;
    constexpr unsigned int mmUMCCH15_PerfMonCtr1_Lo                           = 0x1D4B4A;
    constexpr unsigned int mmUMCCH15_PerfMonCtr2_Hi                           = 0x1D4B4D;
    constexpr unsigned int mmUMCCH15_PerfMonCtr2_Lo                           = 0x1D4B4C;
    constexpr unsigned int mmUMCCH15_PerfMonCtr3_Hi                           = 0x1D4B4F;
    constexpr unsigned int mmUMCCH15_PerfMonCtr3_Lo                           = 0x1D4B4E;
    constexpr unsigned int mmUMCCH15_PerfMonCtr4_Hi                           = 0x1D4B51;
    constexpr unsigned int mmUMCCH15_PerfMonCtr4_Lo                           = 0x1D4B50;
    constexpr unsigned int mmUMCCH15_PerfMonCtr5_Hi                           = 0x1D4B53;
    constexpr unsigned int mmUMCCH15_PerfMonCtr5_Lo                           = 0x1D4B52;
    constexpr unsigned int mmUMCCH15_PerfMonCtrClk_Hi                         = 0x1D4B49;
    constexpr unsigned int mmUMCCH15_PerfMonCtrClk_Lo                         = 0x1D4B48;
    constexpr unsigned int mmVGT_CACHE_INVALIDATION                           = 0x2231;
    constexpr unsigned int mmVGT_CNTL_STATUS                                  = 0x223C;
    constexpr unsigned int mmVGT_DISPATCH_DRAW_INDEX                          = 0xA2DD;
    constexpr unsigned int mmVGT_ESGS_RING_SIZE                               = 0x2232;
    constexpr unsigned int mmVGT_ESGS_RING_SIZE_UMD                           = 0xC240;
    constexpr unsigned int mmVGT_GSVS_RING_SIZE                               = 0x2233;
    constexpr unsigned int mmVGT_GSVS_RING_SIZE_UMD                           = 0xC241;
    constexpr unsigned int mmVGT_HS_OFFCHIP_PARAM                             = 0x226C;
    constexpr unsigned int mmVGT_HS_OFFCHIP_PARAM_UMD                         = 0xC24F;
    constexpr unsigned int mmVGT_TF_MEMORY_BASE                               = 0x226E;
    constexpr unsigned int mmVGT_TF_MEMORY_BASE_HI                            = 0x2278;
    constexpr unsigned int mmVGT_TF_MEMORY_BASE_HI_UMD                        = 0xC261;
    constexpr unsigned int mmVGT_TF_MEMORY_BASE_UMD                           = 0xC250;
    constexpr unsigned int mmVGT_TF_RING_SIZE                                 = 0x2262;
    constexpr unsigned int mmVGT_TF_RING_SIZE_UMD                             = 0xC24E;
} // namespace Gfx101

namespace Gfx10Core
{
    constexpr unsigned int mmCB_COLOR0_CMASK_SLICE                            = 0xA320;
    constexpr unsigned int mmCB_COLOR0_FMASK_SLICE                            = 0xA322;
    constexpr unsigned int mmCB_COLOR0_PITCH                                  = 0xA319;
    constexpr unsigned int mmCB_COLOR0_SLICE                                  = 0xA31A;
    constexpr unsigned int mmCB_COLOR1_CMASK_SLICE                            = 0xA32F;
    constexpr unsigned int mmCB_COLOR1_FMASK_SLICE                            = 0xA331;
    constexpr unsigned int mmCB_COLOR1_PITCH                                  = 0xA328;
    constexpr unsigned int mmCB_COLOR1_SLICE                                  = 0xA329;
    constexpr unsigned int mmCB_COLOR2_CMASK_SLICE                            = 0xA33E;
    constexpr unsigned int mmCB_COLOR2_FMASK_SLICE                            = 0xA340;
    constexpr unsigned int mmCB_COLOR2_PITCH                                  = 0xA337;
    constexpr unsigned int mmCB_COLOR2_SLICE                                  = 0xA338;
    constexpr unsigned int mmCB_COLOR3_CMASK_SLICE                            = 0xA34D;
    constexpr unsigned int mmCB_COLOR3_FMASK_SLICE                            = 0xA34F;
    constexpr unsigned int mmCB_COLOR3_PITCH                                  = 0xA346;
    constexpr unsigned int mmCB_COLOR3_SLICE                                  = 0xA347;
    constexpr unsigned int mmCB_COLOR4_CMASK_SLICE                            = 0xA35C;
    constexpr unsigned int mmCB_COLOR4_FMASK_SLICE                            = 0xA35E;
    constexpr unsigned int mmCB_COLOR4_PITCH                                  = 0xA355;
    constexpr unsigned int mmCB_COLOR4_SLICE                                  = 0xA356;
    constexpr unsigned int mmCB_COLOR5_CMASK_SLICE                            = 0xA36B;
    constexpr unsigned int mmCB_COLOR5_FMASK_SLICE                            = 0xA36D;
    constexpr unsigned int mmCB_COLOR5_PITCH                                  = 0xA364;
    constexpr unsigned int mmCB_COLOR5_SLICE                                  = 0xA365;
    constexpr unsigned int mmCB_COLOR6_CMASK_SLICE                            = 0xA37A;
    constexpr unsigned int mmCB_COLOR6_FMASK_SLICE                            = 0xA37C;
    constexpr unsigned int mmCB_COLOR6_PITCH                                  = 0xA373;
    constexpr unsigned int mmCB_COLOR6_SLICE                                  = 0xA374;
    constexpr unsigned int mmCB_COLOR7_CMASK_SLICE                            = 0xA389;
    constexpr unsigned int mmCB_COLOR7_FMASK_SLICE                            = 0xA38B;
    constexpr unsigned int mmCB_COLOR7_PITCH                                  = 0xA382;
    constexpr unsigned int mmCB_COLOR7_SLICE                                  = 0xA383;
    constexpr unsigned int mmCB_RMI_BC_GL2_CACHE_CONTROL                      = 0x268A;
    constexpr unsigned int mmDB_DFSM_CONTROL                                  = 0xA00E;
    constexpr unsigned int mmDB_RMI_BC_GL2_CACHE_CONTROL                      = 0x261E;
    constexpr unsigned int mmPA_SC_ENHANCE_INTERNAL                           = 0x22DD;
    constexpr unsigned int mmUMCCH2_PerfMonCtl1                               = 0x54341;
    constexpr unsigned int mmUMCCH2_PerfMonCtl2                               = 0x54342;
    constexpr unsigned int mmUMCCH2_PerfMonCtl3                               = 0x54343;
    constexpr unsigned int mmUMCCH2_PerfMonCtl4                               = 0x54344;
    constexpr unsigned int mmUMCCH2_PerfMonCtl5                               = 0x54345;
    constexpr unsigned int mmUMCCH2_PerfMonCtlClk                             = 0x54340;
    constexpr unsigned int mmUMCCH2_PerfMonCtr1_Hi                            = 0x5434B;
    constexpr unsigned int mmUMCCH2_PerfMonCtr1_Lo                            = 0x5434A;
    constexpr unsigned int mmUMCCH2_PerfMonCtr2_Hi                            = 0x5434D;
    constexpr unsigned int mmUMCCH2_PerfMonCtr2_Lo                            = 0x5434C;
    constexpr unsigned int mmUMCCH2_PerfMonCtr3_Hi                            = 0x5434F;
    constexpr unsigned int mmUMCCH2_PerfMonCtr3_Lo                            = 0x5434E;
    constexpr unsigned int mmUMCCH2_PerfMonCtr4_Hi                            = 0x54351;
    constexpr unsigned int mmUMCCH2_PerfMonCtr4_Lo                            = 0x54350;
    constexpr unsigned int mmUMCCH2_PerfMonCtr5_Hi                            = 0x54353;
    constexpr unsigned int mmUMCCH2_PerfMonCtr5_Lo                            = 0x54352;
    constexpr unsigned int mmUMCCH2_PerfMonCtrClk_Hi                          = 0x54349;
    constexpr unsigned int mmUMCCH2_PerfMonCtrClk_Lo                          = 0x54348;
    constexpr unsigned int mmUMCCH4_PerfMonCtl1                               = 0x94341;
    constexpr unsigned int mmUMCCH4_PerfMonCtl2                               = 0x94342;
    constexpr unsigned int mmUMCCH4_PerfMonCtl3                               = 0x94343;
    constexpr unsigned int mmUMCCH4_PerfMonCtl4                               = 0x94344;
    constexpr unsigned int mmUMCCH4_PerfMonCtl5                               = 0x94345;
    constexpr unsigned int mmUMCCH4_PerfMonCtlClk                             = 0x94340;
    constexpr unsigned int mmUMCCH4_PerfMonCtr1_Hi                            = 0x9434B;
    constexpr unsigned int mmUMCCH4_PerfMonCtr1_Lo                            = 0x9434A;
    constexpr unsigned int mmUMCCH4_PerfMonCtr2_Hi                            = 0x9434D;
    constexpr unsigned int mmUMCCH4_PerfMonCtr2_Lo                            = 0x9434C;
    constexpr unsigned int mmUMCCH4_PerfMonCtr3_Hi                            = 0x9434F;
    constexpr unsigned int mmUMCCH4_PerfMonCtr3_Lo                            = 0x9434E;
    constexpr unsigned int mmUMCCH4_PerfMonCtr4_Hi                            = 0x94351;
    constexpr unsigned int mmUMCCH4_PerfMonCtr4_Lo                            = 0x94350;
    constexpr unsigned int mmUMCCH4_PerfMonCtr5_Hi                            = 0x94353;
    constexpr unsigned int mmUMCCH4_PerfMonCtr5_Lo                            = 0x94352;
    constexpr unsigned int mmUMCCH4_PerfMonCtrClk_Hi                          = 0x94349;
    constexpr unsigned int mmUMCCH4_PerfMonCtrClk_Lo                          = 0x94348;
    constexpr unsigned int mmUMCCH6_PerfMonCtl1                               = 0xD4341;
    constexpr unsigned int mmUMCCH6_PerfMonCtl2                               = 0xD4342;
    constexpr unsigned int mmUMCCH6_PerfMonCtl3                               = 0xD4343;
    constexpr unsigned int mmUMCCH6_PerfMonCtl4                               = 0xD4344;
    constexpr unsigned int mmUMCCH6_PerfMonCtl5                               = 0xD4345;
    constexpr unsigned int mmUMCCH6_PerfMonCtlClk                             = 0xD4340;
    constexpr unsigned int mmUMCCH6_PerfMonCtr1_Hi                            = 0xD434B;
    constexpr unsigned int mmUMCCH6_PerfMonCtr1_Lo                            = 0xD434A;
    constexpr unsigned int mmUMCCH6_PerfMonCtr2_Hi                            = 0xD434D;
    constexpr unsigned int mmUMCCH6_PerfMonCtr2_Lo                            = 0xD434C;
    constexpr unsigned int mmUMCCH6_PerfMonCtr3_Hi                            = 0xD434F;
    constexpr unsigned int mmUMCCH6_PerfMonCtr3_Lo                            = 0xD434E;
    constexpr unsigned int mmUMCCH6_PerfMonCtr4_Hi                            = 0xD4351;
    constexpr unsigned int mmUMCCH6_PerfMonCtr4_Lo                            = 0xD4350;
    constexpr unsigned int mmUMCCH6_PerfMonCtr5_Hi                            = 0xD4353;
    constexpr unsigned int mmUMCCH6_PerfMonCtr5_Lo                            = 0xD4352;
    constexpr unsigned int mmUMCCH6_PerfMonCtrClk_Hi                          = 0xD4349;
    constexpr unsigned int mmUMCCH6_PerfMonCtrClk_Lo                          = 0xD4348;
    constexpr unsigned int mmUMCCH8_PerfMonCtl1                               = 0x114341;
    constexpr unsigned int mmUMCCH8_PerfMonCtl2                               = 0x114342;
    constexpr unsigned int mmUMCCH8_PerfMonCtl3                               = 0x114343;
    constexpr unsigned int mmUMCCH8_PerfMonCtl4                               = 0x114344;
    constexpr unsigned int mmUMCCH8_PerfMonCtl5                               = 0x114345;
    constexpr unsigned int mmUMCCH8_PerfMonCtlClk                             = 0x114340;
    constexpr unsigned int mmUMCCH8_PerfMonCtr1_Hi                            = 0x11434B;
    constexpr unsigned int mmUMCCH8_PerfMonCtr1_Lo                            = 0x11434A;
    constexpr unsigned int mmUMCCH8_PerfMonCtr2_Hi                            = 0x11434D;
    constexpr unsigned int mmUMCCH8_PerfMonCtr2_Lo                            = 0x11434C;
    constexpr unsigned int mmUMCCH8_PerfMonCtr3_Hi                            = 0x11434F;
    constexpr unsigned int mmUMCCH8_PerfMonCtr3_Lo                            = 0x11434E;
    constexpr unsigned int mmUMCCH8_PerfMonCtr4_Hi                            = 0x114351;
    constexpr unsigned int mmUMCCH8_PerfMonCtr4_Lo                            = 0x114350;
    constexpr unsigned int mmUMCCH8_PerfMonCtr5_Hi                            = 0x114353;
    constexpr unsigned int mmUMCCH8_PerfMonCtr5_Lo                            = 0x114352;
    constexpr unsigned int mmUMCCH8_PerfMonCtrClk_Hi                          = 0x114349;
    constexpr unsigned int mmUMCCH8_PerfMonCtrClk_Lo                          = 0x114348;
    constexpr unsigned int mmUMCCH10_PerfMonCtl1                              = 0x154341;
    constexpr unsigned int mmUMCCH10_PerfMonCtl2                              = 0x154342;
    constexpr unsigned int mmUMCCH10_PerfMonCtl3                              = 0x154343;
    constexpr unsigned int mmUMCCH10_PerfMonCtl4                              = 0x154344;
    constexpr unsigned int mmUMCCH10_PerfMonCtl5                              = 0x154345;
    constexpr unsigned int mmUMCCH10_PerfMonCtlClk                            = 0x154340;
    constexpr unsigned int mmUMCCH10_PerfMonCtr1_Hi                           = 0x15434B;
    constexpr unsigned int mmUMCCH10_PerfMonCtr1_Lo                           = 0x15434A;
    constexpr unsigned int mmUMCCH10_PerfMonCtr2_Hi                           = 0x15434D;
    constexpr unsigned int mmUMCCH10_PerfMonCtr2_Lo                           = 0x15434C;
    constexpr unsigned int mmUMCCH10_PerfMonCtr3_Hi                           = 0x15434F;
    constexpr unsigned int mmUMCCH10_PerfMonCtr3_Lo                           = 0x15434E;
    constexpr unsigned int mmUMCCH10_PerfMonCtr4_Hi                           = 0x154351;
    constexpr unsigned int mmUMCCH10_PerfMonCtr4_Lo                           = 0x154350;
    constexpr unsigned int mmUMCCH10_PerfMonCtr5_Hi                           = 0x154353;
    constexpr unsigned int mmUMCCH10_PerfMonCtr5_Lo                           = 0x154352;
    constexpr unsigned int mmUMCCH10_PerfMonCtrClk_Hi                         = 0x154349;
    constexpr unsigned int mmUMCCH10_PerfMonCtrClk_Lo                         = 0x154348;
    constexpr unsigned int mmUMCCH12_PerfMonCtl1                              = 0x194341;
    constexpr unsigned int mmUMCCH12_PerfMonCtl2                              = 0x194342;
    constexpr unsigned int mmUMCCH12_PerfMonCtl3                              = 0x194343;
    constexpr unsigned int mmUMCCH12_PerfMonCtl4                              = 0x194344;
    constexpr unsigned int mmUMCCH12_PerfMonCtl5                              = 0x194345;
    constexpr unsigned int mmUMCCH12_PerfMonCtlClk                            = 0x194340;
    constexpr unsigned int mmUMCCH12_PerfMonCtr1_Hi                           = 0x19434B;
    constexpr unsigned int mmUMCCH12_PerfMonCtr1_Lo                           = 0x19434A;
    constexpr unsigned int mmUMCCH12_PerfMonCtr2_Hi                           = 0x19434D;
    constexpr unsigned int mmUMCCH12_PerfMonCtr2_Lo                           = 0x19434C;
    constexpr unsigned int mmUMCCH12_PerfMonCtr3_Hi                           = 0x19434F;
    constexpr unsigned int mmUMCCH12_PerfMonCtr3_Lo                           = 0x19434E;
    constexpr unsigned int mmUMCCH12_PerfMonCtr4_Hi                           = 0x194351;
    constexpr unsigned int mmUMCCH12_PerfMonCtr4_Lo                           = 0x194350;
    constexpr unsigned int mmUMCCH12_PerfMonCtr5_Hi                           = 0x194353;
    constexpr unsigned int mmUMCCH12_PerfMonCtr5_Lo                           = 0x194352;
    constexpr unsigned int mmUMCCH12_PerfMonCtrClk_Hi                         = 0x194349;
    constexpr unsigned int mmUMCCH12_PerfMonCtrClk_Lo                         = 0x194348;
    constexpr unsigned int mmUMCCH14_PerfMonCtl1                              = 0x1D4341;
    constexpr unsigned int mmUMCCH14_PerfMonCtl2                              = 0x1D4342;
    constexpr unsigned int mmUMCCH14_PerfMonCtl3                              = 0x1D4343;
    constexpr unsigned int mmUMCCH14_PerfMonCtl4                              = 0x1D4344;
    constexpr unsigned int mmUMCCH14_PerfMonCtl5                              = 0x1D4345;
    constexpr unsigned int mmUMCCH14_PerfMonCtlClk                            = 0x1D4340;
    constexpr unsigned int mmUMCCH14_PerfMonCtr1_Hi                           = 0x1D434B;
    constexpr unsigned int mmUMCCH14_PerfMonCtr1_Lo                           = 0x1D434A;
    constexpr unsigned int mmUMCCH14_PerfMonCtr2_Hi                           = 0x1D434D;
    constexpr unsigned int mmUMCCH14_PerfMonCtr2_Lo                           = 0x1D434C;
    constexpr unsigned int mmUMCCH14_PerfMonCtr3_Hi                           = 0x1D434F;
    constexpr unsigned int mmUMCCH14_PerfMonCtr3_Lo                           = 0x1D434E;
    constexpr unsigned int mmUMCCH14_PerfMonCtr4_Hi                           = 0x1D4351;
    constexpr unsigned int mmUMCCH14_PerfMonCtr4_Lo                           = 0x1D4350;
    constexpr unsigned int mmUMCCH14_PerfMonCtr5_Hi                           = 0x1D4353;
    constexpr unsigned int mmUMCCH14_PerfMonCtr5_Lo                           = 0x1D4352;
    constexpr unsigned int mmUMCCH14_PerfMonCtrClk_Hi                         = 0x1D4349;
    constexpr unsigned int mmUMCCH14_PerfMonCtrClk_Lo                         = 0x1D4348;
} // namespace Gfx10Core

namespace Nv10
{
    constexpr unsigned int mmDB_RESERVED_REG_1                                = 0xA016;
    constexpr unsigned int mmDB_RESERVED_REG_2                                = 0xA00F;
    constexpr unsigned int mmDB_RESERVED_REG_3                                = 0xA017;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi0                         = 0x7511;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi1                         = 0x7515;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi2                         = 0x7519;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi3                         = 0x751D;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi4                         = 0x7621;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi5                         = 0x7623;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi6                         = 0x7625;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi7                         = 0x7627;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo0                         = 0x7510;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo1                         = 0x7514;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo2                         = 0x7518;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo3                         = 0x751C;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo4                         = 0x7620;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo5                         = 0x7622;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo6                         = 0x7624;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo7                         = 0x7626;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi0                         = 0x7513;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi1                         = 0x7517;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi2                         = 0x751B;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi3                         = 0x751F;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi4                         = 0x75E5;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi5                         = 0x75E7;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi6                         = 0x75E9;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi7                         = 0x75EB;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo0                         = 0x7512;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo1                         = 0x7516;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo2                         = 0x751A;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo3                         = 0x751E;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo4                         = 0x75E4;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo5                         = 0x75E6;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo6                         = 0x75E8;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo7                         = 0x75EA;
    constexpr unsigned int mmMP1_SMN_FPS_CNT                                  = 0x162C4;
    constexpr unsigned int mmPerfMonCtl1                                      = 0x14341;
    constexpr unsigned int mmPerfMonCtl2                                      = 0x14342;
    constexpr unsigned int mmPerfMonCtl3                                      = 0x14343;
    constexpr unsigned int mmPerfMonCtl4                                      = 0x14344;
    constexpr unsigned int mmPerfMonCtl5                                      = 0x14345;
    constexpr unsigned int mmPerfMonCtlClk                                    = 0x14340;
    constexpr unsigned int mmPerfMonCtr1_Hi                                   = 0x1434B;
    constexpr unsigned int mmPerfMonCtr1_Lo                                   = 0x1434A;
    constexpr unsigned int mmPerfMonCtr2_Hi                                   = 0x1434D;
    constexpr unsigned int mmPerfMonCtr2_Lo                                   = 0x1434C;
    constexpr unsigned int mmPerfMonCtr3_Hi                                   = 0x1434F;
    constexpr unsigned int mmPerfMonCtr3_Lo                                   = 0x1434E;
    constexpr unsigned int mmPerfMonCtr4_Hi                                   = 0x14351;
    constexpr unsigned int mmPerfMonCtr4_Lo                                   = 0x14350;
    constexpr unsigned int mmPerfMonCtr5_Hi                                   = 0x14353;
    constexpr unsigned int mmPerfMonCtr5_Lo                                   = 0x14352;
    constexpr unsigned int mmPerfMonCtrClk_Hi                                 = 0x14349;
    constexpr unsigned int mmPerfMonCtrClk_Lo                                 = 0x14348;
    constexpr unsigned int mmSPI_SHADER_PREF_PRI_CNTR_CTRL_ESGS               = 0x2CB1;
    constexpr unsigned int mmSPI_SHADER_PREF_PRI_CNTR_CTRL_LSHS               = 0x2D31;
    constexpr unsigned int mmSPI_SHADER_PREF_PRI_CNTR_CTRL_PS                 = 0x2C31;
    constexpr unsigned int mmSPI_SHADER_PREF_PRI_CNTR_CTRL_VS                 = 0x2C71;
} // namespace Nv10

namespace Oss50
{
    constexpr unsigned int mmSDMA0_PERFCOUNTER0_HI                            = 0x12CB;
    constexpr unsigned int mmSDMA0_PERFCOUNTER0_LO                            = 0x12CA;
    constexpr unsigned int mmSDMA0_PERFCOUNTER0_RESULT                        = 0x12B8;
    constexpr unsigned int mmSDMA0_PERFCOUNTER0_SELECT                        = 0x12C8;
    constexpr unsigned int mmSDMA0_PERFCOUNTER0_SELECT1                       = 0x12C9;
    constexpr unsigned int mmSDMA0_PERFCOUNTER1_HI                            = 0x12CF;
    constexpr unsigned int mmSDMA0_PERFCOUNTER1_LO                            = 0x12CE;
    constexpr unsigned int mmSDMA0_PERFCOUNTER1_RESULT                        = 0x12B9;
    constexpr unsigned int mmSDMA0_PERFCOUNTER1_SELECT                        = 0x12CC;
    constexpr unsigned int mmSDMA0_PERFCOUNTER1_SELECT1                       = 0x12CD;
    constexpr unsigned int mmSDMA0_PERFCOUNTER_TAG_DELAY_RANGE                = 0x12BA;
    constexpr unsigned int mmSDMA0_PERFMON_CNTL                               = 0x12B7;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_HI                            = 0x18CB;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_LO                            = 0x18CA;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_RESULT                        = 0x18B8;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_SELECT                        = 0x18C8;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_SELECT1                       = 0x18C9;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_HI                            = 0x18CF;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_LO                            = 0x18CE;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_RESULT                        = 0x18B9;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_SELECT                        = 0x18CC;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_SELECT1                       = 0x18CD;
    constexpr unsigned int mmSDMA1_PERFCOUNTER_TAG_DELAY_RANGE                = 0x18BA;
    constexpr unsigned int mmSDMA1_PERFMON_CNTL                               = 0x18B7;
} // namespace Oss50

namespace Raven
{
    constexpr unsigned int mmUMCCH1_PerfMonCtl1                               = 0x54341;
    constexpr unsigned int mmUMCCH1_PerfMonCtl2                               = 0x54342;
    constexpr unsigned int mmUMCCH1_PerfMonCtl3                               = 0x54343;
    constexpr unsigned int mmUMCCH1_PerfMonCtl4                               = 0x54344;
    constexpr unsigned int mmUMCCH1_PerfMonCtl5                               = 0x54345;
    constexpr unsigned int mmUMCCH1_PerfMonCtlClk                             = 0x54340;
    constexpr unsigned int mmUMCCH1_PerfMonCtr1_Hi                            = 0x5434B;
    constexpr unsigned int mmUMCCH1_PerfMonCtr1_Lo                            = 0x5434A;
    constexpr unsigned int mmUMCCH1_PerfMonCtr2_Hi                            = 0x5434D;
    constexpr unsigned int mmUMCCH1_PerfMonCtr2_Lo                            = 0x5434C;
    constexpr unsigned int mmUMCCH1_PerfMonCtr3_Hi                            = 0x5434F;
    constexpr unsigned int mmUMCCH1_PerfMonCtr3_Lo                            = 0x5434E;
    constexpr unsigned int mmUMCCH1_PerfMonCtr4_Hi                            = 0x54351;
    constexpr unsigned int mmUMCCH1_PerfMonCtr4_Lo                            = 0x54350;
    constexpr unsigned int mmUMCCH1_PerfMonCtr5_Hi                            = 0x54353;
    constexpr unsigned int mmUMCCH1_PerfMonCtr5_Lo                            = 0x54352;
    constexpr unsigned int mmUMCCH1_PerfMonCtrClk_Hi                          = 0x54349;
    constexpr unsigned int mmUMCCH1_PerfMonCtrClk_Lo                          = 0x54348;
} // namespace Raven

namespace Rv1x
{
    constexpr unsigned int mmMP1_SMN_FPS_CNT                                  = 0x162C5;
    constexpr unsigned int mmRPB_PERFCOUNTER0_CFG                             = 0x0D03;
    constexpr unsigned int mmRPB_PERFCOUNTER1_CFG                             = 0x0D04;
    constexpr unsigned int mmRPB_PERFCOUNTER2_CFG                             = 0x0D05;
    constexpr unsigned int mmRPB_PERFCOUNTER3_CFG                             = 0x0D06;
    constexpr unsigned int mmRPB_PERFCOUNTER_HI                               = 0x0D02;
    constexpr unsigned int mmRPB_PERFCOUNTER_LO                               = 0x0D01;
    constexpr unsigned int mmRPB_PERFCOUNTER_RSLT_CNTL                        = 0x0D07;
    constexpr unsigned int mmRPB_PERF_COUNTER_CNTL                            = 0x0CFA;
} // namespace Rv1x

namespace Rv2x
{
    constexpr unsigned int mmMP1_SMN_FPS_CNT                                  = 0x162C5;
    constexpr unsigned int mmRLC_SPM_ACCUM_CTRL                               = 0xDCAA;
    constexpr unsigned int mmRLC_SPM_ACCUM_CTRLRAM_ADDR                       = 0xDCA7;
    constexpr unsigned int mmRLC_SPM_ACCUM_CTRLRAM_DATA                       = 0xDCA8;
    constexpr unsigned int mmRLC_SPM_ACCUM_DATARAM_ADDR                       = 0xDCA5;
    constexpr unsigned int mmRLC_SPM_ACCUM_DATARAM_DATA                       = 0xDCA6;
    constexpr unsigned int mmRLC_SPM_ACCUM_DATARAM_WRCOUNT                    = 0xDCAE;
    constexpr unsigned int mmRLC_SPM_ACCUM_MODE                               = 0xDCAB;
    constexpr unsigned int mmRLC_SPM_ACCUM_SAMPLES_REQUESTED                  = 0xDCAD;
    constexpr unsigned int mmRLC_SPM_ACCUM_STATUS                             = 0xDCA9;
    constexpr unsigned int mmRLC_SPM_ACCUM_THRESHOLD                          = 0xDCAC;
    constexpr unsigned int mmRPB_PERFCOUNTER0_CFG                             = 0x0D03;
    constexpr unsigned int mmRPB_PERFCOUNTER1_CFG                             = 0x0D04;
    constexpr unsigned int mmRPB_PERFCOUNTER2_CFG                             = 0x0D05;
    constexpr unsigned int mmRPB_PERFCOUNTER3_CFG                             = 0x0D06;
    constexpr unsigned int mmRPB_PERFCOUNTER_HI                               = 0x0D02;
    constexpr unsigned int mmRPB_PERFCOUNTER_LO                               = 0x0D01;
    constexpr unsigned int mmRPB_PERFCOUNTER_RSLT_CNTL                        = 0x0D07;
    constexpr unsigned int mmRPB_PERF_COUNTER_CNTL                            = 0x0CFA;
} // namespace Rv2x

namespace Vega
{
    constexpr unsigned int mmRPB_PERFCOUNTER0_CFG                             = 0x0D03;
    constexpr unsigned int mmRPB_PERFCOUNTER1_CFG                             = 0x0D04;
    constexpr unsigned int mmRPB_PERFCOUNTER2_CFG                             = 0x0D05;
    constexpr unsigned int mmRPB_PERFCOUNTER3_CFG                             = 0x0D06;
    constexpr unsigned int mmRPB_PERFCOUNTER_HI                               = 0x0D02;
    constexpr unsigned int mmRPB_PERFCOUNTER_LO                               = 0x0D01;
    constexpr unsigned int mmRPB_PERFCOUNTER_RSLT_CNTL                        = 0x0D07;
    constexpr unsigned int mmRPB_PERF_COUNTER_CNTL                            = 0x0CFA;
    constexpr unsigned int mmSDMA1_PERFCOUNTER0_RESULT                        = 0x14B8;
    constexpr unsigned int mmSDMA1_PERFCOUNTER1_RESULT                        = 0x14B9;
    constexpr unsigned int mmSDMA1_PERFCOUNTER_TAG_DELAY_RANGE                = 0x14BA;
    constexpr unsigned int mmSDMA1_PERFMON_CNTL                               = 0x14B7;
    constexpr unsigned int mmUMCCH1_PerfMonCtl1                               = 0x14B41;
    constexpr unsigned int mmUMCCH1_PerfMonCtl2                               = 0x14B42;
    constexpr unsigned int mmUMCCH1_PerfMonCtl3                               = 0x14B43;
    constexpr unsigned int mmUMCCH1_PerfMonCtl4                               = 0x14B44;
    constexpr unsigned int mmUMCCH1_PerfMonCtl5                               = 0x14B45;
    constexpr unsigned int mmUMCCH1_PerfMonCtlClk                             = 0x14B40;
    constexpr unsigned int mmUMCCH1_PerfMonCtr1_Hi                            = 0x14B4B;
    constexpr unsigned int mmUMCCH1_PerfMonCtr1_Lo                            = 0x14B4A;
    constexpr unsigned int mmUMCCH1_PerfMonCtr2_Hi                            = 0x14B4D;
    constexpr unsigned int mmUMCCH1_PerfMonCtr2_Lo                            = 0x14B4C;
    constexpr unsigned int mmUMCCH1_PerfMonCtr3_Hi                            = 0x14B4F;
    constexpr unsigned int mmUMCCH1_PerfMonCtr3_Lo                            = 0x14B4E;
    constexpr unsigned int mmUMCCH1_PerfMonCtr4_Hi                            = 0x14B51;
    constexpr unsigned int mmUMCCH1_PerfMonCtr4_Lo                            = 0x14B50;
    constexpr unsigned int mmUMCCH1_PerfMonCtr5_Hi                            = 0x14B53;
    constexpr unsigned int mmUMCCH1_PerfMonCtr5_Lo                            = 0x14B52;
    constexpr unsigned int mmUMCCH1_PerfMonCtrClk_Hi                          = 0x14B49;
    constexpr unsigned int mmUMCCH1_PerfMonCtrClk_Lo                          = 0x14B48;
    constexpr unsigned int mmUMCCH2_PerfMonCtl1                               = 0x15341;
    constexpr unsigned int mmUMCCH2_PerfMonCtl2                               = 0x15342;
    constexpr unsigned int mmUMCCH2_PerfMonCtl3                               = 0x15343;
    constexpr unsigned int mmUMCCH2_PerfMonCtl4                               = 0x15344;
    constexpr unsigned int mmUMCCH2_PerfMonCtl5                               = 0x15345;
    constexpr unsigned int mmUMCCH2_PerfMonCtlClk                             = 0x15340;
    constexpr unsigned int mmUMCCH2_PerfMonCtr1_Hi                            = 0x1534B;
    constexpr unsigned int mmUMCCH2_PerfMonCtr1_Lo                            = 0x1534A;
    constexpr unsigned int mmUMCCH2_PerfMonCtr2_Hi                            = 0x1534D;
    constexpr unsigned int mmUMCCH2_PerfMonCtr2_Lo                            = 0x1534C;
    constexpr unsigned int mmUMCCH2_PerfMonCtr3_Hi                            = 0x1534F;
    constexpr unsigned int mmUMCCH2_PerfMonCtr3_Lo                            = 0x1534E;
    constexpr unsigned int mmUMCCH2_PerfMonCtr4_Hi                            = 0x15351;
    constexpr unsigned int mmUMCCH2_PerfMonCtr4_Lo                            = 0x15350;
    constexpr unsigned int mmUMCCH2_PerfMonCtr5_Hi                            = 0x15353;
    constexpr unsigned int mmUMCCH2_PerfMonCtr5_Lo                            = 0x15352;
    constexpr unsigned int mmUMCCH2_PerfMonCtrClk_Hi                          = 0x15349;
    constexpr unsigned int mmUMCCH2_PerfMonCtrClk_Lo                          = 0x15348;
    constexpr unsigned int mmUMCCH3_PerfMonCtl1                               = 0x15B41;
    constexpr unsigned int mmUMCCH3_PerfMonCtl2                               = 0x15B42;
    constexpr unsigned int mmUMCCH3_PerfMonCtl3                               = 0x15B43;
    constexpr unsigned int mmUMCCH3_PerfMonCtl4                               = 0x15B44;
    constexpr unsigned int mmUMCCH3_PerfMonCtl5                               = 0x15B45;
    constexpr unsigned int mmUMCCH3_PerfMonCtlClk                             = 0x15B40;
    constexpr unsigned int mmUMCCH3_PerfMonCtr1_Hi                            = 0x15B4B;
    constexpr unsigned int mmUMCCH3_PerfMonCtr1_Lo                            = 0x15B4A;
    constexpr unsigned int mmUMCCH3_PerfMonCtr2_Hi                            = 0x15B4D;
    constexpr unsigned int mmUMCCH3_PerfMonCtr2_Lo                            = 0x15B4C;
    constexpr unsigned int mmUMCCH3_PerfMonCtr3_Hi                            = 0x15B4F;
    constexpr unsigned int mmUMCCH3_PerfMonCtr3_Lo                            = 0x15B4E;
    constexpr unsigned int mmUMCCH3_PerfMonCtr4_Hi                            = 0x15B51;
    constexpr unsigned int mmUMCCH3_PerfMonCtr4_Lo                            = 0x15B50;
    constexpr unsigned int mmUMCCH3_PerfMonCtr5_Hi                            = 0x15B53;
    constexpr unsigned int mmUMCCH3_PerfMonCtr5_Lo                            = 0x15B52;
    constexpr unsigned int mmUMCCH3_PerfMonCtrClk_Hi                          = 0x15B49;
    constexpr unsigned int mmUMCCH3_PerfMonCtrClk_Lo                          = 0x15B48;
    constexpr unsigned int mmUMCCH4_PerfMonCtl1                               = 0x54341;
    constexpr unsigned int mmUMCCH4_PerfMonCtl2                               = 0x54342;
    constexpr unsigned int mmUMCCH4_PerfMonCtl3                               = 0x54343;
    constexpr unsigned int mmUMCCH4_PerfMonCtl4                               = 0x54344;
    constexpr unsigned int mmUMCCH4_PerfMonCtl5                               = 0x54345;
    constexpr unsigned int mmUMCCH4_PerfMonCtlClk                             = 0x54340;
    constexpr unsigned int mmUMCCH4_PerfMonCtr1_Hi                            = 0x5434B;
    constexpr unsigned int mmUMCCH4_PerfMonCtr1_Lo                            = 0x5434A;
    constexpr unsigned int mmUMCCH4_PerfMonCtr2_Hi                            = 0x5434D;
    constexpr unsigned int mmUMCCH4_PerfMonCtr2_Lo                            = 0x5434C;
    constexpr unsigned int mmUMCCH4_PerfMonCtr3_Hi                            = 0x5434F;
    constexpr unsigned int mmUMCCH4_PerfMonCtr3_Lo                            = 0x5434E;
    constexpr unsigned int mmUMCCH4_PerfMonCtr4_Hi                            = 0x54351;
    constexpr unsigned int mmUMCCH4_PerfMonCtr4_Lo                            = 0x54350;
    constexpr unsigned int mmUMCCH4_PerfMonCtr5_Hi                            = 0x54353;
    constexpr unsigned int mmUMCCH4_PerfMonCtr5_Lo                            = 0x54352;
    constexpr unsigned int mmUMCCH4_PerfMonCtrClk_Hi                          = 0x54349;
    constexpr unsigned int mmUMCCH4_PerfMonCtrClk_Lo                          = 0x54348;
    constexpr unsigned int mmUMCCH5_PerfMonCtl1                               = 0x54B41;
    constexpr unsigned int mmUMCCH5_PerfMonCtl2                               = 0x54B42;
    constexpr unsigned int mmUMCCH5_PerfMonCtl3                               = 0x54B43;
    constexpr unsigned int mmUMCCH5_PerfMonCtl4                               = 0x54B44;
    constexpr unsigned int mmUMCCH5_PerfMonCtl5                               = 0x54B45;
    constexpr unsigned int mmUMCCH5_PerfMonCtlClk                             = 0x54B40;
    constexpr unsigned int mmUMCCH5_PerfMonCtr1_Hi                            = 0x54B4B;
    constexpr unsigned int mmUMCCH5_PerfMonCtr1_Lo                            = 0x54B4A;
    constexpr unsigned int mmUMCCH5_PerfMonCtr2_Hi                            = 0x54B4D;
    constexpr unsigned int mmUMCCH5_PerfMonCtr2_Lo                            = 0x54B4C;
    constexpr unsigned int mmUMCCH5_PerfMonCtr3_Hi                            = 0x54B4F;
    constexpr unsigned int mmUMCCH5_PerfMonCtr3_Lo                            = 0x54B4E;
    constexpr unsigned int mmUMCCH5_PerfMonCtr4_Hi                            = 0x54B51;
    constexpr unsigned int mmUMCCH5_PerfMonCtr4_Lo                            = 0x54B50;
    constexpr unsigned int mmUMCCH5_PerfMonCtr5_Hi                            = 0x54B53;
    constexpr unsigned int mmUMCCH5_PerfMonCtr5_Lo                            = 0x54B52;
    constexpr unsigned int mmUMCCH5_PerfMonCtrClk_Hi                          = 0x54B49;
    constexpr unsigned int mmUMCCH5_PerfMonCtrClk_Lo                          = 0x54B48;
    constexpr unsigned int mmUMCCH6_PerfMonCtl1                               = 0x55341;
    constexpr unsigned int mmUMCCH6_PerfMonCtl2                               = 0x55342;
    constexpr unsigned int mmUMCCH6_PerfMonCtl3                               = 0x55343;
    constexpr unsigned int mmUMCCH6_PerfMonCtl4                               = 0x55344;
    constexpr unsigned int mmUMCCH6_PerfMonCtl5                               = 0x55345;
    constexpr unsigned int mmUMCCH6_PerfMonCtlClk                             = 0x55340;
    constexpr unsigned int mmUMCCH6_PerfMonCtr1_Hi                            = 0x5534B;
    constexpr unsigned int mmUMCCH6_PerfMonCtr1_Lo                            = 0x5534A;
    constexpr unsigned int mmUMCCH6_PerfMonCtr2_Hi                            = 0x5534D;
    constexpr unsigned int mmUMCCH6_PerfMonCtr2_Lo                            = 0x5534C;
    constexpr unsigned int mmUMCCH6_PerfMonCtr3_Hi                            = 0x5534F;
    constexpr unsigned int mmUMCCH6_PerfMonCtr3_Lo                            = 0x5534E;
    constexpr unsigned int mmUMCCH6_PerfMonCtr4_Hi                            = 0x55351;
    constexpr unsigned int mmUMCCH6_PerfMonCtr4_Lo                            = 0x55350;
    constexpr unsigned int mmUMCCH6_PerfMonCtr5_Hi                            = 0x55353;
    constexpr unsigned int mmUMCCH6_PerfMonCtr5_Lo                            = 0x55352;
    constexpr unsigned int mmUMCCH6_PerfMonCtrClk_Hi                          = 0x55349;
    constexpr unsigned int mmUMCCH6_PerfMonCtrClk_Lo                          = 0x55348;
    constexpr unsigned int mmUMCCH7_PerfMonCtl1                               = 0x55B41;
    constexpr unsigned int mmUMCCH7_PerfMonCtl2                               = 0x55B42;
    constexpr unsigned int mmUMCCH7_PerfMonCtl3                               = 0x55B43;
    constexpr unsigned int mmUMCCH7_PerfMonCtl4                               = 0x55B44;
    constexpr unsigned int mmUMCCH7_PerfMonCtl5                               = 0x55B45;
    constexpr unsigned int mmUMCCH7_PerfMonCtlClk                             = 0x55B40;
    constexpr unsigned int mmUMCCH7_PerfMonCtr1_Hi                            = 0x55B4B;
    constexpr unsigned int mmUMCCH7_PerfMonCtr1_Lo                            = 0x55B4A;
    constexpr unsigned int mmUMCCH7_PerfMonCtr2_Hi                            = 0x55B4D;
    constexpr unsigned int mmUMCCH7_PerfMonCtr2_Lo                            = 0x55B4C;
    constexpr unsigned int mmUMCCH7_PerfMonCtr3_Hi                            = 0x55B4F;
    constexpr unsigned int mmUMCCH7_PerfMonCtr3_Lo                            = 0x55B4E;
    constexpr unsigned int mmUMCCH7_PerfMonCtr4_Hi                            = 0x55B51;
    constexpr unsigned int mmUMCCH7_PerfMonCtr4_Lo                            = 0x55B50;
    constexpr unsigned int mmUMCCH7_PerfMonCtr5_Hi                            = 0x55B53;
    constexpr unsigned int mmUMCCH7_PerfMonCtr5_Lo                            = 0x55B52;
    constexpr unsigned int mmUMCCH7_PerfMonCtrClk_Hi                          = 0x55B49;
    constexpr unsigned int mmUMCCH7_PerfMonCtrClk_Lo                          = 0x55B48;
} // namespace Vega

namespace Vg10
{
    constexpr unsigned int mmRLC_SPM_CBR0_PERFMON_SAMPLE_DELAY                = 0xDCA1;
    constexpr unsigned int mmRLC_SPM_CBR1_PERFMON_SAMPLE_DELAY                = 0xDCA2;
    constexpr unsigned int mmRLC_SPM_DBR0_PERFMON_SAMPLE_DELAY                = 0xDC9F;
    constexpr unsigned int mmRLC_SPM_DBR1_PERFMON_SAMPLE_DELAY                = 0xDCA0;
    constexpr unsigned int mmUMCCH8_PerfMonCtl1                               = 0x94341;
    constexpr unsigned int mmUMCCH8_PerfMonCtl2                               = 0x94342;
    constexpr unsigned int mmUMCCH8_PerfMonCtl3                               = 0x94343;
    constexpr unsigned int mmUMCCH8_PerfMonCtl4                               = 0x94344;
    constexpr unsigned int mmUMCCH8_PerfMonCtl5                               = 0x94345;
    constexpr unsigned int mmUMCCH8_PerfMonCtlClk                             = 0x94340;
    constexpr unsigned int mmUMCCH8_PerfMonCtr1_Hi                            = 0x9434B;
    constexpr unsigned int mmUMCCH8_PerfMonCtr1_Lo                            = 0x9434A;
    constexpr unsigned int mmUMCCH8_PerfMonCtr2_Hi                            = 0x9434D;
    constexpr unsigned int mmUMCCH8_PerfMonCtr2_Lo                            = 0x9434C;
    constexpr unsigned int mmUMCCH8_PerfMonCtr3_Hi                            = 0x9434F;
    constexpr unsigned int mmUMCCH8_PerfMonCtr3_Lo                            = 0x9434E;
    constexpr unsigned int mmUMCCH8_PerfMonCtr4_Hi                            = 0x94351;
    constexpr unsigned int mmUMCCH8_PerfMonCtr4_Lo                            = 0x94350;
    constexpr unsigned int mmUMCCH8_PerfMonCtr5_Hi                            = 0x94353;
    constexpr unsigned int mmUMCCH8_PerfMonCtr5_Lo                            = 0x94352;
    constexpr unsigned int mmUMCCH8_PerfMonCtrClk_Hi                          = 0x94349;
    constexpr unsigned int mmUMCCH8_PerfMonCtrClk_Lo                          = 0x94348;
    constexpr unsigned int mmUMCCH9_PerfMonCtl1                               = 0x94B41;
    constexpr unsigned int mmUMCCH9_PerfMonCtl2                               = 0x94B42;
    constexpr unsigned int mmUMCCH9_PerfMonCtl3                               = 0x94B43;
    constexpr unsigned int mmUMCCH9_PerfMonCtl4                               = 0x94B44;
    constexpr unsigned int mmUMCCH9_PerfMonCtl5                               = 0x94B45;
    constexpr unsigned int mmUMCCH9_PerfMonCtlClk                             = 0x94B40;
    constexpr unsigned int mmUMCCH9_PerfMonCtr1_Hi                            = 0x94B4B;
    constexpr unsigned int mmUMCCH9_PerfMonCtr1_Lo                            = 0x94B4A;
    constexpr unsigned int mmUMCCH9_PerfMonCtr2_Hi                            = 0x94B4D;
    constexpr unsigned int mmUMCCH9_PerfMonCtr2_Lo                            = 0x94B4C;
    constexpr unsigned int mmUMCCH9_PerfMonCtr3_Hi                            = 0x94B4F;
    constexpr unsigned int mmUMCCH9_PerfMonCtr3_Lo                            = 0x94B4E;
    constexpr unsigned int mmUMCCH9_PerfMonCtr4_Hi                            = 0x94B51;
    constexpr unsigned int mmUMCCH9_PerfMonCtr4_Lo                            = 0x94B50;
    constexpr unsigned int mmUMCCH9_PerfMonCtr5_Hi                            = 0x94B53;
    constexpr unsigned int mmUMCCH9_PerfMonCtr5_Lo                            = 0x94B52;
    constexpr unsigned int mmUMCCH9_PerfMonCtrClk_Hi                          = 0x94B49;
    constexpr unsigned int mmUMCCH9_PerfMonCtrClk_Lo                          = 0x94B48;
    constexpr unsigned int mmUMCCH10_PerfMonCtl1                              = 0x95341;
    constexpr unsigned int mmUMCCH10_PerfMonCtl2                              = 0x95342;
    constexpr unsigned int mmUMCCH10_PerfMonCtl3                              = 0x95343;
    constexpr unsigned int mmUMCCH10_PerfMonCtl4                              = 0x95344;
    constexpr unsigned int mmUMCCH10_PerfMonCtl5                              = 0x95345;
    constexpr unsigned int mmUMCCH10_PerfMonCtlClk                            = 0x95340;
    constexpr unsigned int mmUMCCH10_PerfMonCtr1_Hi                           = 0x9534B;
    constexpr unsigned int mmUMCCH10_PerfMonCtr1_Lo                           = 0x9534A;
    constexpr unsigned int mmUMCCH10_PerfMonCtr2_Hi                           = 0x9534D;
    constexpr unsigned int mmUMCCH10_PerfMonCtr2_Lo                           = 0x9534C;
    constexpr unsigned int mmUMCCH10_PerfMonCtr3_Hi                           = 0x9534F;
    constexpr unsigned int mmUMCCH10_PerfMonCtr3_Lo                           = 0x9534E;
    constexpr unsigned int mmUMCCH10_PerfMonCtr4_Hi                           = 0x95351;
    constexpr unsigned int mmUMCCH10_PerfMonCtr4_Lo                           = 0x95350;
    constexpr unsigned int mmUMCCH10_PerfMonCtr5_Hi                           = 0x95353;
    constexpr unsigned int mmUMCCH10_PerfMonCtr5_Lo                           = 0x95352;
    constexpr unsigned int mmUMCCH10_PerfMonCtrClk_Hi                         = 0x95349;
    constexpr unsigned int mmUMCCH10_PerfMonCtrClk_Lo                         = 0x95348;
    constexpr unsigned int mmUMCCH11_PerfMonCtl1                              = 0x95B41;
    constexpr unsigned int mmUMCCH11_PerfMonCtl2                              = 0x95B42;
    constexpr unsigned int mmUMCCH11_PerfMonCtl3                              = 0x95B43;
    constexpr unsigned int mmUMCCH11_PerfMonCtl4                              = 0x95B44;
    constexpr unsigned int mmUMCCH11_PerfMonCtl5                              = 0x95B45;
    constexpr unsigned int mmUMCCH11_PerfMonCtlClk                            = 0x95B40;
    constexpr unsigned int mmUMCCH11_PerfMonCtr1_Hi                           = 0x95B4B;
    constexpr unsigned int mmUMCCH11_PerfMonCtr1_Lo                           = 0x95B4A;
    constexpr unsigned int mmUMCCH11_PerfMonCtr2_Hi                           = 0x95B4D;
    constexpr unsigned int mmUMCCH11_PerfMonCtr2_Lo                           = 0x95B4C;
    constexpr unsigned int mmUMCCH11_PerfMonCtr3_Hi                           = 0x95B4F;
    constexpr unsigned int mmUMCCH11_PerfMonCtr3_Lo                           = 0x95B4E;
    constexpr unsigned int mmUMCCH11_PerfMonCtr4_Hi                           = 0x95B51;
    constexpr unsigned int mmUMCCH11_PerfMonCtr4_Lo                           = 0x95B50;
    constexpr unsigned int mmUMCCH11_PerfMonCtr5_Hi                           = 0x95B53;
    constexpr unsigned int mmUMCCH11_PerfMonCtr5_Lo                           = 0x95B52;
    constexpr unsigned int mmUMCCH11_PerfMonCtrClk_Hi                         = 0x95B49;
    constexpr unsigned int mmUMCCH11_PerfMonCtrClk_Lo                         = 0x95B48;
    constexpr unsigned int mmUMCCH12_PerfMonCtl1                              = 0xD4341;
    constexpr unsigned int mmUMCCH12_PerfMonCtl2                              = 0xD4342;
    constexpr unsigned int mmUMCCH12_PerfMonCtl3                              = 0xD4343;
    constexpr unsigned int mmUMCCH12_PerfMonCtl4                              = 0xD4344;
    constexpr unsigned int mmUMCCH12_PerfMonCtl5                              = 0xD4345;
    constexpr unsigned int mmUMCCH12_PerfMonCtlClk                            = 0xD4340;
    constexpr unsigned int mmUMCCH12_PerfMonCtr1_Hi                           = 0xD434B;
    constexpr unsigned int mmUMCCH12_PerfMonCtr1_Lo                           = 0xD434A;
    constexpr unsigned int mmUMCCH12_PerfMonCtr2_Hi                           = 0xD434D;
    constexpr unsigned int mmUMCCH12_PerfMonCtr2_Lo                           = 0xD434C;
    constexpr unsigned int mmUMCCH12_PerfMonCtr3_Hi                           = 0xD434F;
    constexpr unsigned int mmUMCCH12_PerfMonCtr3_Lo                           = 0xD434E;
    constexpr unsigned int mmUMCCH12_PerfMonCtr4_Hi                           = 0xD4351;
    constexpr unsigned int mmUMCCH12_PerfMonCtr4_Lo                           = 0xD4350;
    constexpr unsigned int mmUMCCH12_PerfMonCtr5_Hi                           = 0xD4353;
    constexpr unsigned int mmUMCCH12_PerfMonCtr5_Lo                           = 0xD4352;
    constexpr unsigned int mmUMCCH12_PerfMonCtrClk_Hi                         = 0xD4349;
    constexpr unsigned int mmUMCCH12_PerfMonCtrClk_Lo                         = 0xD4348;
    constexpr unsigned int mmUMCCH13_PerfMonCtl1                              = 0xD4B41;
    constexpr unsigned int mmUMCCH13_PerfMonCtl2                              = 0xD4B42;
    constexpr unsigned int mmUMCCH13_PerfMonCtl3                              = 0xD4B43;
    constexpr unsigned int mmUMCCH13_PerfMonCtl4                              = 0xD4B44;
    constexpr unsigned int mmUMCCH13_PerfMonCtl5                              = 0xD4B45;
    constexpr unsigned int mmUMCCH13_PerfMonCtlClk                            = 0xD4B40;
    constexpr unsigned int mmUMCCH13_PerfMonCtr1_Hi                           = 0xD4B4B;
    constexpr unsigned int mmUMCCH13_PerfMonCtr1_Lo                           = 0xD4B4A;
    constexpr unsigned int mmUMCCH13_PerfMonCtr2_Hi                           = 0xD4B4D;
    constexpr unsigned int mmUMCCH13_PerfMonCtr2_Lo                           = 0xD4B4C;
    constexpr unsigned int mmUMCCH13_PerfMonCtr3_Hi                           = 0xD4B4F;
    constexpr unsigned int mmUMCCH13_PerfMonCtr3_Lo                           = 0xD4B4E;
    constexpr unsigned int mmUMCCH13_PerfMonCtr4_Hi                           = 0xD4B51;
    constexpr unsigned int mmUMCCH13_PerfMonCtr4_Lo                           = 0xD4B50;
    constexpr unsigned int mmUMCCH13_PerfMonCtr5_Hi                           = 0xD4B53;
    constexpr unsigned int mmUMCCH13_PerfMonCtr5_Lo                           = 0xD4B52;
    constexpr unsigned int mmUMCCH13_PerfMonCtrClk_Hi                         = 0xD4B49;
    constexpr unsigned int mmUMCCH13_PerfMonCtrClk_Lo                         = 0xD4B48;
    constexpr unsigned int mmUMCCH14_PerfMonCtl1                              = 0xD5341;
    constexpr unsigned int mmUMCCH14_PerfMonCtl2                              = 0xD5342;
    constexpr unsigned int mmUMCCH14_PerfMonCtl3                              = 0xD5343;
    constexpr unsigned int mmUMCCH14_PerfMonCtl4                              = 0xD5344;
    constexpr unsigned int mmUMCCH14_PerfMonCtl5                              = 0xD5345;
    constexpr unsigned int mmUMCCH14_PerfMonCtlClk                            = 0xD5340;
    constexpr unsigned int mmUMCCH14_PerfMonCtr1_Hi                           = 0xD534B;
    constexpr unsigned int mmUMCCH14_PerfMonCtr1_Lo                           = 0xD534A;
    constexpr unsigned int mmUMCCH14_PerfMonCtr2_Hi                           = 0xD534D;
    constexpr unsigned int mmUMCCH14_PerfMonCtr2_Lo                           = 0xD534C;
    constexpr unsigned int mmUMCCH14_PerfMonCtr3_Hi                           = 0xD534F;
    constexpr unsigned int mmUMCCH14_PerfMonCtr3_Lo                           = 0xD534E;
    constexpr unsigned int mmUMCCH14_PerfMonCtr4_Hi                           = 0xD5351;
    constexpr unsigned int mmUMCCH14_PerfMonCtr4_Lo                           = 0xD5350;
    constexpr unsigned int mmUMCCH14_PerfMonCtr5_Hi                           = 0xD5353;
    constexpr unsigned int mmUMCCH14_PerfMonCtr5_Lo                           = 0xD5352;
    constexpr unsigned int mmUMCCH14_PerfMonCtrClk_Hi                         = 0xD5349;
    constexpr unsigned int mmUMCCH14_PerfMonCtrClk_Lo                         = 0xD5348;
    constexpr unsigned int mmUMCCH15_PerfMonCtl1                              = 0xD5B41;
    constexpr unsigned int mmUMCCH15_PerfMonCtl2                              = 0xD5B42;
    constexpr unsigned int mmUMCCH15_PerfMonCtl3                              = 0xD5B43;
    constexpr unsigned int mmUMCCH15_PerfMonCtl4                              = 0xD5B44;
    constexpr unsigned int mmUMCCH15_PerfMonCtl5                              = 0xD5B45;
    constexpr unsigned int mmUMCCH15_PerfMonCtlClk                            = 0xD5B40;
    constexpr unsigned int mmUMCCH15_PerfMonCtr1_Hi                           = 0xD5B4B;
    constexpr unsigned int mmUMCCH15_PerfMonCtr1_Lo                           = 0xD5B4A;
    constexpr unsigned int mmUMCCH15_PerfMonCtr2_Hi                           = 0xD5B4D;
    constexpr unsigned int mmUMCCH15_PerfMonCtr2_Lo                           = 0xD5B4C;
    constexpr unsigned int mmUMCCH15_PerfMonCtr3_Hi                           = 0xD5B4F;
    constexpr unsigned int mmUMCCH15_PerfMonCtr3_Lo                           = 0xD5B4E;
    constexpr unsigned int mmUMCCH15_PerfMonCtr4_Hi                           = 0xD5B51;
    constexpr unsigned int mmUMCCH15_PerfMonCtr4_Lo                           = 0xD5B50;
    constexpr unsigned int mmUMCCH15_PerfMonCtr5_Hi                           = 0xD5B53;
    constexpr unsigned int mmUMCCH15_PerfMonCtr5_Lo                           = 0xD5B52;
    constexpr unsigned int mmUMCCH15_PerfMonCtrClk_Hi                         = 0xD5B49;
    constexpr unsigned int mmUMCCH15_PerfMonCtrClk_Lo                         = 0xD5B48;
} // namespace Vg10

namespace Vg10_Vg12
{
    constexpr unsigned int mmMP1_SMN_FPS_CNT                                  = 0x162C4;
} // namespace Vg10_Vg12

namespace Vg12
{
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi0                         = 0x7511;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi1                         = 0x7515;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi2                         = 0x7519;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi3                         = 0x751D;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi4                         = 0x7621;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi5                         = 0x7623;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi6                         = 0x7625;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlHi7                         = 0x7627;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo0                         = 0x7510;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo1                         = 0x7514;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo2                         = 0x7518;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo3                         = 0x751C;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo4                         = 0x7620;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo5                         = 0x7622;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo6                         = 0x7624;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtlLo7                         = 0x7626;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi0                         = 0x7513;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi1                         = 0x7517;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi2                         = 0x751B;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi3                         = 0x751F;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi4                         = 0x75E5;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi5                         = 0x75E7;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi6                         = 0x75E9;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrHi7                         = 0x75EB;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo0                         = 0x7512;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo1                         = 0x7516;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo2                         = 0x751A;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo3                         = 0x751E;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo4                         = 0x75E4;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo5                         = 0x75E6;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo6                         = 0x75E8;
    constexpr unsigned int mmDF_PIE_AON_PerfMonCtrLo7                         = 0x75EA;
    constexpr unsigned int mmPA_SC_ENHANCE_2                                  = 0x22DC;
    constexpr unsigned int mmPA_STATE_STEREO_X                                = 0xC2B5;
    constexpr unsigned int mmPA_STEREO_CNTL                                   = 0xA210;
    constexpr unsigned int mmPerfMonCtl1                                      = 0x14341;
    constexpr unsigned int mmPerfMonCtl2                                      = 0x14342;
    constexpr unsigned int mmPerfMonCtl3                                      = 0x14343;
    constexpr unsigned int mmPerfMonCtl4                                      = 0x14344;
    constexpr unsigned int mmPerfMonCtl5                                      = 0x14345;
    constexpr unsigned int mmPerfMonCtlClk                                    = 0x14340;
    constexpr unsigned int mmPerfMonCtr1_Hi                                   = 0x1434B;
    constexpr unsigned int mmPerfMonCtr1_Lo                                   = 0x1434A;
    constexpr unsigned int mmPerfMonCtr2_Hi                                   = 0x1434D;
    constexpr unsigned int mmPerfMonCtr2_Lo                                   = 0x1434C;
    constexpr unsigned int mmPerfMonCtr3_Hi                                   = 0x1434F;
    constexpr unsigned int mmPerfMonCtr3_Lo                                   = 0x1434E;
    constexpr unsigned int mmPerfMonCtr4_Hi                                   = 0x14351;
    constexpr unsigned int mmPerfMonCtr4_Lo                                   = 0x14350;
    constexpr unsigned int mmPerfMonCtr5_Hi                                   = 0x14353;
    constexpr unsigned int mmPerfMonCtr5_Lo                                   = 0x14352;
    constexpr unsigned int mmPerfMonCtrClk_Hi                                 = 0x14349;
    constexpr unsigned int mmPerfMonCtrClk_Lo                                 = 0x14348;
    constexpr unsigned int mmXDMA_SLV_FLIP_PENDING                            = 0x348C;
} // namespace Vg12

namespace Vg20
{
    constexpr unsigned int mmMP1_SMN_FPS_CNT                                  = 0x162C5;
    constexpr unsigned int mmPA_SC_ENHANCE_2                                  = 0x22DC;
    constexpr unsigned int mmPA_STATE_STEREO_X                                = 0xC2B5;
    constexpr unsigned int mmPA_STEREO_CNTL                                   = 0xA210;
    constexpr unsigned int mmRLC_SPM_CBR0_PERFMON_SAMPLE_DELAY                = 0xDCA1;
    constexpr unsigned int mmRLC_SPM_CBR1_PERFMON_SAMPLE_DELAY                = 0xDCA2;
    constexpr unsigned int mmRLC_SPM_DBR0_PERFMON_SAMPLE_DELAY                = 0xDC9F;
    constexpr unsigned int mmRLC_SPM_DBR1_PERFMON_SAMPLE_DELAY                = 0xDCA0;
    constexpr unsigned int mmTA_DSM_CNTL                                      = 0x2584;
    constexpr unsigned int mmTA_DSM_CNTL2                                     = 0x2585;
    constexpr unsigned int mmTA_EDC_CNT                                       = 0x2586;
    constexpr unsigned int mmUMCCH8_PerfMonCtl1                               = 0x94341;
    constexpr unsigned int mmUMCCH8_PerfMonCtl2                               = 0x94342;
    constexpr unsigned int mmUMCCH8_PerfMonCtl3                               = 0x94343;
    constexpr unsigned int mmUMCCH8_PerfMonCtl4                               = 0x94344;
    constexpr unsigned int mmUMCCH8_PerfMonCtl5                               = 0x94345;
    constexpr unsigned int mmUMCCH8_PerfMonCtlClk                             = 0x94340;
    constexpr unsigned int mmUMCCH8_PerfMonCtr1_Hi                            = 0x9434B;
    constexpr unsigned int mmUMCCH8_PerfMonCtr1_Lo                            = 0x9434A;
    constexpr unsigned int mmUMCCH8_PerfMonCtr2_Hi                            = 0x9434D;
    constexpr unsigned int mmUMCCH8_PerfMonCtr2_Lo                            = 0x9434C;
    constexpr unsigned int mmUMCCH8_PerfMonCtr3_Hi                            = 0x9434F;
    constexpr unsigned int mmUMCCH8_PerfMonCtr3_Lo                            = 0x9434E;
    constexpr unsigned int mmUMCCH8_PerfMonCtr4_Hi                            = 0x94351;
    constexpr unsigned int mmUMCCH8_PerfMonCtr4_Lo                            = 0x94350;
    constexpr unsigned int mmUMCCH8_PerfMonCtr5_Hi                            = 0x94353;
    constexpr unsigned int mmUMCCH8_PerfMonCtr5_Lo                            = 0x94352;
    constexpr unsigned int mmUMCCH8_PerfMonCtrClk_Hi                          = 0x94349;
    constexpr unsigned int mmUMCCH8_PerfMonCtrClk_Lo                          = 0x94348;
    constexpr unsigned int mmUMCCH9_PerfMonCtl1                               = 0x94B41;
    constexpr unsigned int mmUMCCH9_PerfMonCtl2                               = 0x94B42;
    constexpr unsigned int mmUMCCH9_PerfMonCtl3                               = 0x94B43;
    constexpr unsigned int mmUMCCH9_PerfMonCtl4                               = 0x94B44;
    constexpr unsigned int mmUMCCH9_PerfMonCtl5                               = 0x94B45;
    constexpr unsigned int mmUMCCH9_PerfMonCtlClk                             = 0x94B40;
    constexpr unsigned int mmUMCCH9_PerfMonCtr1_Hi                            = 0x94B4B;
    constexpr unsigned int mmUMCCH9_PerfMonCtr1_Lo                            = 0x94B4A;
    constexpr unsigned int mmUMCCH9_PerfMonCtr2_Hi                            = 0x94B4D;
    constexpr unsigned int mmUMCCH9_PerfMonCtr2_Lo                            = 0x94B4C;
    constexpr unsigned int mmUMCCH9_PerfMonCtr3_Hi                            = 0x94B4F;
    constexpr unsigned int mmUMCCH9_PerfMonCtr3_Lo                            = 0x94B4E;
    constexpr unsigned int mmUMCCH9_PerfMonCtr4_Hi                            = 0x94B51;
    constexpr unsigned int mmUMCCH9_PerfMonCtr4_Lo                            = 0x94B50;
    constexpr unsigned int mmUMCCH9_PerfMonCtr5_Hi                            = 0x94B53;
    constexpr unsigned int mmUMCCH9_PerfMonCtr5_Lo                            = 0x94B52;
    constexpr unsigned int mmUMCCH9_PerfMonCtrClk_Hi                          = 0x94B49;
    constexpr unsigned int mmUMCCH9_PerfMonCtrClk_Lo                          = 0x94B48;
    constexpr unsigned int mmUMCCH10_PerfMonCtl1                              = 0x95341;
    constexpr unsigned int mmUMCCH10_PerfMonCtl2                              = 0x95342;
    constexpr unsigned int mmUMCCH10_PerfMonCtl3                              = 0x95343;
    constexpr unsigned int mmUMCCH10_PerfMonCtl4                              = 0x95344;
    constexpr unsigned int mmUMCCH10_PerfMonCtl5                              = 0x95345;
    constexpr unsigned int mmUMCCH10_PerfMonCtlClk                            = 0x95340;
    constexpr unsigned int mmUMCCH10_PerfMonCtr1_Hi                           = 0x9534B;
    constexpr unsigned int mmUMCCH10_PerfMonCtr1_Lo                           = 0x9534A;
    constexpr unsigned int mmUMCCH10_PerfMonCtr2_Hi                           = 0x9534D;
    constexpr unsigned int mmUMCCH10_PerfMonCtr2_Lo                           = 0x9534C;
    constexpr unsigned int mmUMCCH10_PerfMonCtr3_Hi                           = 0x9534F;
    constexpr unsigned int mmUMCCH10_PerfMonCtr3_Lo                           = 0x9534E;
    constexpr unsigned int mmUMCCH10_PerfMonCtr4_Hi                           = 0x95351;
    constexpr unsigned int mmUMCCH10_PerfMonCtr4_Lo                           = 0x95350;
    constexpr unsigned int mmUMCCH10_PerfMonCtr5_Hi                           = 0x95353;
    constexpr unsigned int mmUMCCH10_PerfMonCtr5_Lo                           = 0x95352;
    constexpr unsigned int mmUMCCH10_PerfMonCtrClk_Hi                         = 0x95349;
    constexpr unsigned int mmUMCCH10_PerfMonCtrClk_Lo                         = 0x95348;
    constexpr unsigned int mmUMCCH11_PerfMonCtl1                              = 0x95B41;
    constexpr unsigned int mmUMCCH11_PerfMonCtl2                              = 0x95B42;
    constexpr unsigned int mmUMCCH11_PerfMonCtl3                              = 0x95B43;
    constexpr unsigned int mmUMCCH11_PerfMonCtl4                              = 0x95B44;
    constexpr unsigned int mmUMCCH11_PerfMonCtl5                              = 0x95B45;
    constexpr unsigned int mmUMCCH11_PerfMonCtlClk                            = 0x95B40;
    constexpr unsigned int mmUMCCH11_PerfMonCtr1_Hi                           = 0x95B4B;
    constexpr unsigned int mmUMCCH11_PerfMonCtr1_Lo                           = 0x95B4A;
    constexpr unsigned int mmUMCCH11_PerfMonCtr2_Hi                           = 0x95B4D;
    constexpr unsigned int mmUMCCH11_PerfMonCtr2_Lo                           = 0x95B4C;
    constexpr unsigned int mmUMCCH11_PerfMonCtr3_Hi                           = 0x95B4F;
    constexpr unsigned int mmUMCCH11_PerfMonCtr3_Lo                           = 0x95B4E;
    constexpr unsigned int mmUMCCH11_PerfMonCtr4_Hi                           = 0x95B51;
    constexpr unsigned int mmUMCCH11_PerfMonCtr4_Lo                           = 0x95B50;
    constexpr unsigned int mmUMCCH11_PerfMonCtr5_Hi                           = 0x95B53;
    constexpr unsigned int mmUMCCH11_PerfMonCtr5_Lo                           = 0x95B52;
    constexpr unsigned int mmUMCCH11_PerfMonCtrClk_Hi                         = 0x95B49;
    constexpr unsigned int mmUMCCH11_PerfMonCtrClk_Lo                         = 0x95B48;
    constexpr unsigned int mmUMCCH12_PerfMonCtl1                              = 0xD4341;
    constexpr unsigned int mmUMCCH12_PerfMonCtl2                              = 0xD4342;
    constexpr unsigned int mmUMCCH12_PerfMonCtl3                              = 0xD4343;
    constexpr unsigned int mmUMCCH12_PerfMonCtl4                              = 0xD4344;
    constexpr unsigned int mmUMCCH12_PerfMonCtl5                              = 0xD4345;
    constexpr unsigned int mmUMCCH12_PerfMonCtlClk                            = 0xD4340;
    constexpr unsigned int mmUMCCH12_PerfMonCtr1_Hi                           = 0xD434B;
    constexpr unsigned int mmUMCCH12_PerfMonCtr1_Lo                           = 0xD434A;
    constexpr unsigned int mmUMCCH12_PerfMonCtr2_Hi                           = 0xD434D;
    constexpr unsigned int mmUMCCH12_PerfMonCtr2_Lo                           = 0xD434C;
    constexpr unsigned int mmUMCCH12_PerfMonCtr3_Hi                           = 0xD434F;
    constexpr unsigned int mmUMCCH12_PerfMonCtr3_Lo                           = 0xD434E;
    constexpr unsigned int mmUMCCH12_PerfMonCtr4_Hi                           = 0xD4351;
    constexpr unsigned int mmUMCCH12_PerfMonCtr4_Lo                           = 0xD4350;
    constexpr unsigned int mmUMCCH12_PerfMonCtr5_Hi                           = 0xD4353;
    constexpr unsigned int mmUMCCH12_PerfMonCtr5_Lo                           = 0xD4352;
    constexpr unsigned int mmUMCCH12_PerfMonCtrClk_Hi                         = 0xD4349;
    constexpr unsigned int mmUMCCH12_PerfMonCtrClk_Lo                         = 0xD4348;
    constexpr unsigned int mmUMCCH13_PerfMonCtl1                              = 0xD4B41;
    constexpr unsigned int mmUMCCH13_PerfMonCtl2                              = 0xD4B42;
    constexpr unsigned int mmUMCCH13_PerfMonCtl3                              = 0xD4B43;
    constexpr unsigned int mmUMCCH13_PerfMonCtl4                              = 0xD4B44;
    constexpr unsigned int mmUMCCH13_PerfMonCtl5                              = 0xD4B45;
    constexpr unsigned int mmUMCCH13_PerfMonCtlClk                            = 0xD4B40;
    constexpr unsigned int mmUMCCH13_PerfMonCtr1_Hi                           = 0xD4B4B;
    constexpr unsigned int mmUMCCH13_PerfMonCtr1_Lo                           = 0xD4B4A;
    constexpr unsigned int mmUMCCH13_PerfMonCtr2_Hi                           = 0xD4B4D;
    constexpr unsigned int mmUMCCH13_PerfMonCtr2_Lo                           = 0xD4B4C;
    constexpr unsigned int mmUMCCH13_PerfMonCtr3_Hi                           = 0xD4B4F;
    constexpr unsigned int mmUMCCH13_PerfMonCtr3_Lo                           = 0xD4B4E;
    constexpr unsigned int mmUMCCH13_PerfMonCtr4_Hi                           = 0xD4B51;
    constexpr unsigned int mmUMCCH13_PerfMonCtr4_Lo                           = 0xD4B50;
    constexpr unsigned int mmUMCCH13_PerfMonCtr5_Hi                           = 0xD4B53;
    constexpr unsigned int mmUMCCH13_PerfMonCtr5_Lo                           = 0xD4B52;
    constexpr unsigned int mmUMCCH13_PerfMonCtrClk_Hi                         = 0xD4B49;
    constexpr unsigned int mmUMCCH13_PerfMonCtrClk_Lo                         = 0xD4B48;
    constexpr unsigned int mmUMCCH14_PerfMonCtl1                              = 0xD5341;
    constexpr unsigned int mmUMCCH14_PerfMonCtl2                              = 0xD5342;
    constexpr unsigned int mmUMCCH14_PerfMonCtl3                              = 0xD5343;
    constexpr unsigned int mmUMCCH14_PerfMonCtl4                              = 0xD5344;
    constexpr unsigned int mmUMCCH14_PerfMonCtl5                              = 0xD5345;
    constexpr unsigned int mmUMCCH14_PerfMonCtlClk                            = 0xD5340;
    constexpr unsigned int mmUMCCH14_PerfMonCtr1_Hi                           = 0xD534B;
    constexpr unsigned int mmUMCCH14_PerfMonCtr1_Lo                           = 0xD534A;
    constexpr unsigned int mmUMCCH14_PerfMonCtr2_Hi                           = 0xD534D;
    constexpr unsigned int mmUMCCH14_PerfMonCtr2_Lo                           = 0xD534C;
    constexpr unsigned int mmUMCCH14_PerfMonCtr3_Hi                           = 0xD534F;
    constexpr unsigned int mmUMCCH14_PerfMonCtr3_Lo                           = 0xD534E;
    constexpr unsigned int mmUMCCH14_PerfMonCtr4_Hi                           = 0xD5351;
    constexpr unsigned int mmUMCCH14_PerfMonCtr4_Lo                           = 0xD5350;
    constexpr unsigned int mmUMCCH14_PerfMonCtr5_Hi                           = 0xD5353;
    constexpr unsigned int mmUMCCH14_PerfMonCtr5_Lo                           = 0xD5352;
    constexpr unsigned int mmUMCCH14_PerfMonCtrClk_Hi                         = 0xD5349;
    constexpr unsigned int mmUMCCH14_PerfMonCtrClk_Lo                         = 0xD5348;
    constexpr unsigned int mmUMCCH15_PerfMonCtl1                              = 0xD5B41;
    constexpr unsigned int mmUMCCH15_PerfMonCtl2                              = 0xD5B42;
    constexpr unsigned int mmUMCCH15_PerfMonCtl3                              = 0xD5B43;
    constexpr unsigned int mmUMCCH15_PerfMonCtl4                              = 0xD5B44;
    constexpr unsigned int mmUMCCH15_PerfMonCtl5                              = 0xD5B45;
    constexpr unsigned int mmUMCCH15_PerfMonCtlClk                            = 0xD5B40;
    constexpr unsigned int mmUMCCH15_PerfMonCtr1_Hi                           = 0xD5B4B;
    constexpr unsigned int mmUMCCH15_PerfMonCtr1_Lo                           = 0xD5B4A;
    constexpr unsigned int mmUMCCH15_PerfMonCtr2_Hi                           = 0xD5B4D;
    constexpr unsigned int mmUMCCH15_PerfMonCtr2_Lo                           = 0xD5B4C;
    constexpr unsigned int mmUMCCH15_PerfMonCtr3_Hi                           = 0xD5B4F;
    constexpr unsigned int mmUMCCH15_PerfMonCtr3_Lo                           = 0xD5B4E;
    constexpr unsigned int mmUMCCH15_PerfMonCtr4_Hi                           = 0xD5B51;
    constexpr unsigned int mmUMCCH15_PerfMonCtr4_Lo                           = 0xD5B50;
    constexpr unsigned int mmUMCCH15_PerfMonCtr5_Hi                           = 0xD5B53;
    constexpr unsigned int mmUMCCH15_PerfMonCtr5_Lo                           = 0xD5B52;
    constexpr unsigned int mmUMCCH15_PerfMonCtrClk_Hi                         = 0xD5B49;
    constexpr unsigned int mmUMCCH15_PerfMonCtrClk_Lo                         = 0xD5B48;
    constexpr unsigned int mmUMCCH16_PerfMonCtl1                              = 0x114341;
    constexpr unsigned int mmUMCCH16_PerfMonCtl2                              = 0x114342;
    constexpr unsigned int mmUMCCH16_PerfMonCtl3                              = 0x114343;
    constexpr unsigned int mmUMCCH16_PerfMonCtl4                              = 0x114344;
    constexpr unsigned int mmUMCCH16_PerfMonCtl5                              = 0x114345;
    constexpr unsigned int mmUMCCH16_PerfMonCtlClk                            = 0x114340;
    constexpr unsigned int mmUMCCH16_PerfMonCtr1_Hi                           = 0x11434B;
    constexpr unsigned int mmUMCCH16_PerfMonCtr1_Lo                           = 0x11434A;
    constexpr unsigned int mmUMCCH16_PerfMonCtr2_Hi                           = 0x11434D;
    constexpr unsigned int mmUMCCH16_PerfMonCtr2_Lo                           = 0x11434C;
    constexpr unsigned int mmUMCCH16_PerfMonCtr3_Hi                           = 0x11434F;
    constexpr unsigned int mmUMCCH16_PerfMonCtr3_Lo                           = 0x11434E;
    constexpr unsigned int mmUMCCH16_PerfMonCtr4_Hi                           = 0x114351;
    constexpr unsigned int mmUMCCH16_PerfMonCtr4_Lo                           = 0x114350;
    constexpr unsigned int mmUMCCH16_PerfMonCtr5_Hi                           = 0x114353;
    constexpr unsigned int mmUMCCH16_PerfMonCtr5_Lo                           = 0x114352;
    constexpr unsigned int mmUMCCH16_PerfMonCtrClk_Hi                         = 0x114349;
    constexpr unsigned int mmUMCCH16_PerfMonCtrClk_Lo                         = 0x114348;
    constexpr unsigned int mmUMCCH17_PerfMonCtl1                              = 0x114B41;
    constexpr unsigned int mmUMCCH17_PerfMonCtl2                              = 0x114B42;
    constexpr unsigned int mmUMCCH17_PerfMonCtl3                              = 0x114B43;
    constexpr unsigned int mmUMCCH17_PerfMonCtl4                              = 0x114B44;
    constexpr unsigned int mmUMCCH17_PerfMonCtl5                              = 0x114B45;
    constexpr unsigned int mmUMCCH17_PerfMonCtlClk                            = 0x114B40;
    constexpr unsigned int mmUMCCH17_PerfMonCtr1_Hi                           = 0x114B4B;
    constexpr unsigned int mmUMCCH17_PerfMonCtr1_Lo                           = 0x114B4A;
    constexpr unsigned int mmUMCCH17_PerfMonCtr2_Hi                           = 0x114B4D;
    constexpr unsigned int mmUMCCH17_PerfMonCtr2_Lo                           = 0x114B4C;
    constexpr unsigned int mmUMCCH17_PerfMonCtr3_Hi                           = 0x114B4F;
    constexpr unsigned int mmUMCCH17_PerfMonCtr3_Lo                           = 0x114B4E;
    constexpr unsigned int mmUMCCH17_PerfMonCtr4_Hi                           = 0x114B51;
    constexpr unsigned int mmUMCCH17_PerfMonCtr4_Lo                           = 0x114B50;
    constexpr unsigned int mmUMCCH17_PerfMonCtr5_Hi                           = 0x114B53;
    constexpr unsigned int mmUMCCH17_PerfMonCtr5_Lo                           = 0x114B52;
    constexpr unsigned int mmUMCCH17_PerfMonCtrClk_Hi                         = 0x114B49;
    constexpr unsigned int mmUMCCH17_PerfMonCtrClk_Lo                         = 0x114B48;
    constexpr unsigned int mmUMCCH18_PerfMonCtl1                              = 0x115341;
    constexpr unsigned int mmUMCCH18_PerfMonCtl2                              = 0x115342;
    constexpr unsigned int mmUMCCH18_PerfMonCtl3                              = 0x115343;
    constexpr unsigned int mmUMCCH18_PerfMonCtl4                              = 0x115344;
    constexpr unsigned int mmUMCCH18_PerfMonCtl5                              = 0x115345;
    constexpr unsigned int mmUMCCH18_PerfMonCtlClk                            = 0x115340;
    constexpr unsigned int mmUMCCH18_PerfMonCtr1_Hi                           = 0x11534B;
    constexpr unsigned int mmUMCCH18_PerfMonCtr1_Lo                           = 0x11534A;
    constexpr unsigned int mmUMCCH18_PerfMonCtr2_Hi                           = 0x11534D;
    constexpr unsigned int mmUMCCH18_PerfMonCtr2_Lo                           = 0x11534C;
    constexpr unsigned int mmUMCCH18_PerfMonCtr3_Hi                           = 0x11534F;
    constexpr unsigned int mmUMCCH18_PerfMonCtr3_Lo                           = 0x11534E;
    constexpr unsigned int mmUMCCH18_PerfMonCtr4_Hi                           = 0x115351;
    constexpr unsigned int mmUMCCH18_PerfMonCtr4_Lo                           = 0x115350;
    constexpr unsigned int mmUMCCH18_PerfMonCtr5_Hi                           = 0x115353;
    constexpr unsigned int mmUMCCH18_PerfMonCtr5_Lo                           = 0x115352;
    constexpr unsigned int mmUMCCH18_PerfMonCtrClk_Hi                         = 0x115349;
    constexpr unsigned int mmUMCCH18_PerfMonCtrClk_Lo                         = 0x115348;
    constexpr unsigned int mmUMCCH19_PerfMonCtl1                              = 0x115B41;
    constexpr unsigned int mmUMCCH19_PerfMonCtl2                              = 0x115B42;
    constexpr unsigned int mmUMCCH19_PerfMonCtl3                              = 0x115B43;
    constexpr unsigned int mmUMCCH19_PerfMonCtl4                              = 0x115B44;
    constexpr unsigned int mmUMCCH19_PerfMonCtl5                              = 0x115B45;
    constexpr unsigned int mmUMCCH19_PerfMonCtlClk                            = 0x115B40;
    constexpr unsigned int mmUMCCH19_PerfMonCtr1_Hi                           = 0x115B4B;
    constexpr unsigned int mmUMCCH19_PerfMonCtr1_Lo                           = 0x115B4A;
    constexpr unsigned int mmUMCCH19_PerfMonCtr2_Hi                           = 0x115B4D;
    constexpr unsigned int mmUMCCH19_PerfMonCtr2_Lo                           = 0x115B4C;
    constexpr unsigned int mmUMCCH19_PerfMonCtr3_Hi                           = 0x115B4F;
    constexpr unsigned int mmUMCCH19_PerfMonCtr3_Lo                           = 0x115B4E;
    constexpr unsigned int mmUMCCH19_PerfMonCtr4_Hi                           = 0x115B51;
    constexpr unsigned int mmUMCCH19_PerfMonCtr4_Lo                           = 0x115B50;
    constexpr unsigned int mmUMCCH19_PerfMonCtr5_Hi                           = 0x115B53;
    constexpr unsigned int mmUMCCH19_PerfMonCtr5_Lo                           = 0x115B52;
    constexpr unsigned int mmUMCCH19_PerfMonCtrClk_Hi                         = 0x115B49;
    constexpr unsigned int mmUMCCH19_PerfMonCtrClk_Lo                         = 0x115B48;
    constexpr unsigned int mmUMCCH20_PerfMonCtl1                              = 0x154341;
    constexpr unsigned int mmUMCCH20_PerfMonCtl2                              = 0x154342;
    constexpr unsigned int mmUMCCH20_PerfMonCtl3                              = 0x154343;
    constexpr unsigned int mmUMCCH20_PerfMonCtl4                              = 0x154344;
    constexpr unsigned int mmUMCCH20_PerfMonCtl5                              = 0x154345;
    constexpr unsigned int mmUMCCH20_PerfMonCtlClk                            = 0x154340;
    constexpr unsigned int mmUMCCH20_PerfMonCtr1_Hi                           = 0x15434B;
    constexpr unsigned int mmUMCCH20_PerfMonCtr1_Lo                           = 0x15434A;
    constexpr unsigned int mmUMCCH20_PerfMonCtr2_Hi                           = 0x15434D;
    constexpr unsigned int mmUMCCH20_PerfMonCtr2_Lo                           = 0x15434C;
    constexpr unsigned int mmUMCCH20_PerfMonCtr3_Hi                           = 0x15434F;
    constexpr unsigned int mmUMCCH20_PerfMonCtr3_Lo                           = 0x15434E;
    constexpr unsigned int mmUMCCH20_PerfMonCtr4_Hi                           = 0x154351;
    constexpr unsigned int mmUMCCH20_PerfMonCtr4_Lo                           = 0x154350;
    constexpr unsigned int mmUMCCH20_PerfMonCtr5_Hi                           = 0x154353;
    constexpr unsigned int mmUMCCH20_PerfMonCtr5_Lo                           = 0x154352;
    constexpr unsigned int mmUMCCH20_PerfMonCtrClk_Hi                         = 0x154349;
    constexpr unsigned int mmUMCCH20_PerfMonCtrClk_Lo                         = 0x154348;
    constexpr unsigned int mmUMCCH21_PerfMonCtl1                              = 0x154B41;
    constexpr unsigned int mmUMCCH21_PerfMonCtl2                              = 0x154B42;
    constexpr unsigned int mmUMCCH21_PerfMonCtl3                              = 0x154B43;
    constexpr unsigned int mmUMCCH21_PerfMonCtl4                              = 0x154B44;
    constexpr unsigned int mmUMCCH21_PerfMonCtl5                              = 0x154B45;
    constexpr unsigned int mmUMCCH21_PerfMonCtlClk                            = 0x154B40;
    constexpr unsigned int mmUMCCH21_PerfMonCtr1_Hi                           = 0x154B4B;
    constexpr unsigned int mmUMCCH21_PerfMonCtr1_Lo                           = 0x154B4A;
    constexpr unsigned int mmUMCCH21_PerfMonCtr2_Hi                           = 0x154B4D;
    constexpr unsigned int mmUMCCH21_PerfMonCtr2_Lo                           = 0x154B4C;
    constexpr unsigned int mmUMCCH21_PerfMonCtr3_Hi                           = 0x154B4F;
    constexpr unsigned int mmUMCCH21_PerfMonCtr3_Lo                           = 0x154B4E;
    constexpr unsigned int mmUMCCH21_PerfMonCtr4_Hi                           = 0x154B51;
    constexpr unsigned int mmUMCCH21_PerfMonCtr4_Lo                           = 0x154B50;
    constexpr unsigned int mmUMCCH21_PerfMonCtr5_Hi                           = 0x154B53;
    constexpr unsigned int mmUMCCH21_PerfMonCtr5_Lo                           = 0x154B52;
    constexpr unsigned int mmUMCCH21_PerfMonCtrClk_Hi                         = 0x154B49;
    constexpr unsigned int mmUMCCH21_PerfMonCtrClk_Lo                         = 0x154B48;
    constexpr unsigned int mmUMCCH22_PerfMonCtl1                              = 0x155341;
    constexpr unsigned int mmUMCCH22_PerfMonCtl2                              = 0x155342;
    constexpr unsigned int mmUMCCH22_PerfMonCtl3                              = 0x155343;
    constexpr unsigned int mmUMCCH22_PerfMonCtl4                              = 0x155344;
    constexpr unsigned int mmUMCCH22_PerfMonCtl5                              = 0x155345;
    constexpr unsigned int mmUMCCH22_PerfMonCtlClk                            = 0x155340;
    constexpr unsigned int mmUMCCH22_PerfMonCtr1_Hi                           = 0x15534B;
    constexpr unsigned int mmUMCCH22_PerfMonCtr1_Lo                           = 0x15534A;
    constexpr unsigned int mmUMCCH22_PerfMonCtr2_Hi                           = 0x15534D;
    constexpr unsigned int mmUMCCH22_PerfMonCtr2_Lo                           = 0x15534C;
    constexpr unsigned int mmUMCCH22_PerfMonCtr3_Hi                           = 0x15534F;
    constexpr unsigned int mmUMCCH22_PerfMonCtr3_Lo                           = 0x15534E;
    constexpr unsigned int mmUMCCH22_PerfMonCtr4_Hi                           = 0x155351;
    constexpr unsigned int mmUMCCH22_PerfMonCtr4_Lo                           = 0x155350;
    constexpr unsigned int mmUMCCH22_PerfMonCtr5_Hi                           = 0x155353;
    constexpr unsigned int mmUMCCH22_PerfMonCtr5_Lo                           = 0x155352;
    constexpr unsigned int mmUMCCH22_PerfMonCtrClk_Hi                         = 0x155349;
    constexpr unsigned int mmUMCCH22_PerfMonCtrClk_Lo                         = 0x155348;
    constexpr unsigned int mmUMCCH23_PerfMonCtl1                              = 0x155B41;
    constexpr unsigned int mmUMCCH23_PerfMonCtl2                              = 0x155B42;
    constexpr unsigned int mmUMCCH23_PerfMonCtl3                              = 0x155B43;
    constexpr unsigned int mmUMCCH23_PerfMonCtl4                              = 0x155B44;
    constexpr unsigned int mmUMCCH23_PerfMonCtl5                              = 0x155B45;
    constexpr unsigned int mmUMCCH23_PerfMonCtlClk                            = 0x155B40;
    constexpr unsigned int mmUMCCH23_PerfMonCtr1_Hi                           = 0x155B4B;
    constexpr unsigned int mmUMCCH23_PerfMonCtr1_Lo                           = 0x155B4A;
    constexpr unsigned int mmUMCCH23_PerfMonCtr2_Hi                           = 0x155B4D;
    constexpr unsigned int mmUMCCH23_PerfMonCtr2_Lo                           = 0x155B4C;
    constexpr unsigned int mmUMCCH23_PerfMonCtr3_Hi                           = 0x155B4F;
    constexpr unsigned int mmUMCCH23_PerfMonCtr3_Lo                           = 0x155B4E;
    constexpr unsigned int mmUMCCH23_PerfMonCtr4_Hi                           = 0x155B51;
    constexpr unsigned int mmUMCCH23_PerfMonCtr4_Lo                           = 0x155B50;
    constexpr unsigned int mmUMCCH23_PerfMonCtr5_Hi                           = 0x155B53;
    constexpr unsigned int mmUMCCH23_PerfMonCtr5_Lo                           = 0x155B52;
    constexpr unsigned int mmUMCCH23_PerfMonCtrClk_Hi                         = 0x155B49;
    constexpr unsigned int mmUMCCH23_PerfMonCtrClk_Lo                         = 0x155B48;
    constexpr unsigned int mmUMCCH24_PerfMonCtl1                              = 0x194341;
    constexpr unsigned int mmUMCCH24_PerfMonCtl2                              = 0x194342;
    constexpr unsigned int mmUMCCH24_PerfMonCtl3                              = 0x194343;
    constexpr unsigned int mmUMCCH24_PerfMonCtl4                              = 0x194344;
    constexpr unsigned int mmUMCCH24_PerfMonCtl5                              = 0x194345;
    constexpr unsigned int mmUMCCH24_PerfMonCtlClk                            = 0x194340;
    constexpr unsigned int mmUMCCH24_PerfMonCtr1_Hi                           = 0x19434B;
    constexpr unsigned int mmUMCCH24_PerfMonCtr1_Lo                           = 0x19434A;
    constexpr unsigned int mmUMCCH24_PerfMonCtr2_Hi                           = 0x19434D;
    constexpr unsigned int mmUMCCH24_PerfMonCtr2_Lo                           = 0x19434C;
    constexpr unsigned int mmUMCCH24_PerfMonCtr3_Hi                           = 0x19434F;
    constexpr unsigned int mmUMCCH24_PerfMonCtr3_Lo                           = 0x19434E;
    constexpr unsigned int mmUMCCH24_PerfMonCtr4_Hi                           = 0x194351;
    constexpr unsigned int mmUMCCH24_PerfMonCtr4_Lo                           = 0x194350;
    constexpr unsigned int mmUMCCH24_PerfMonCtr5_Hi                           = 0x194353;
    constexpr unsigned int mmUMCCH24_PerfMonCtr5_Lo                           = 0x194352;
    constexpr unsigned int mmUMCCH24_PerfMonCtrClk_Hi                         = 0x194349;
    constexpr unsigned int mmUMCCH24_PerfMonCtrClk_Lo                         = 0x194348;
    constexpr unsigned int mmUMCCH25_PerfMonCtl1                              = 0x194B41;
    constexpr unsigned int mmUMCCH25_PerfMonCtl2                              = 0x194B42;
    constexpr unsigned int mmUMCCH25_PerfMonCtl3                              = 0x194B43;
    constexpr unsigned int mmUMCCH25_PerfMonCtl4                              = 0x194B44;
    constexpr unsigned int mmUMCCH25_PerfMonCtl5                              = 0x194B45;
    constexpr unsigned int mmUMCCH25_PerfMonCtlClk                            = 0x194B40;
    constexpr unsigned int mmUMCCH25_PerfMonCtr1_Hi                           = 0x194B4B;
    constexpr unsigned int mmUMCCH25_PerfMonCtr1_Lo                           = 0x194B4A;
    constexpr unsigned int mmUMCCH25_PerfMonCtr2_Hi                           = 0x194B4D;
    constexpr unsigned int mmUMCCH25_PerfMonCtr2_Lo                           = 0x194B4C;
    constexpr unsigned int mmUMCCH25_PerfMonCtr3_Hi                           = 0x194B4F;
    constexpr unsigned int mmUMCCH25_PerfMonCtr3_Lo                           = 0x194B4E;
    constexpr unsigned int mmUMCCH25_PerfMonCtr4_Hi                           = 0x194B51;
    constexpr unsigned int mmUMCCH25_PerfMonCtr4_Lo                           = 0x194B50;
    constexpr unsigned int mmUMCCH25_PerfMonCtr5_Hi                           = 0x194B53;
    constexpr unsigned int mmUMCCH25_PerfMonCtr5_Lo                           = 0x194B52;
    constexpr unsigned int mmUMCCH25_PerfMonCtrClk_Hi                         = 0x194B49;
    constexpr unsigned int mmUMCCH25_PerfMonCtrClk_Lo                         = 0x194B48;
    constexpr unsigned int mmUMCCH26_PerfMonCtl1                              = 0x195341;
    constexpr unsigned int mmUMCCH26_PerfMonCtl2                              = 0x195342;
    constexpr unsigned int mmUMCCH26_PerfMonCtl3                              = 0x195343;
    constexpr unsigned int mmUMCCH26_PerfMonCtl4                              = 0x195344;
    constexpr unsigned int mmUMCCH26_PerfMonCtl5                              = 0x195345;
    constexpr unsigned int mmUMCCH26_PerfMonCtlClk                            = 0x195340;
    constexpr unsigned int mmUMCCH26_PerfMonCtr1_Hi                           = 0x19534B;
    constexpr unsigned int mmUMCCH26_PerfMonCtr1_Lo                           = 0x19534A;
    constexpr unsigned int mmUMCCH26_PerfMonCtr2_Hi                           = 0x19534D;
    constexpr unsigned int mmUMCCH26_PerfMonCtr2_Lo                           = 0x19534C;
    constexpr unsigned int mmUMCCH26_PerfMonCtr3_Hi                           = 0x19534F;
    constexpr unsigned int mmUMCCH26_PerfMonCtr3_Lo                           = 0x19534E;
    constexpr unsigned int mmUMCCH26_PerfMonCtr4_Hi                           = 0x195351;
    constexpr unsigned int mmUMCCH26_PerfMonCtr4_Lo                           = 0x195350;
    constexpr unsigned int mmUMCCH26_PerfMonCtr5_Hi                           = 0x195353;
    constexpr unsigned int mmUMCCH26_PerfMonCtr5_Lo                           = 0x195352;
    constexpr unsigned int mmUMCCH26_PerfMonCtrClk_Hi                         = 0x195349;
    constexpr unsigned int mmUMCCH26_PerfMonCtrClk_Lo                         = 0x195348;
    constexpr unsigned int mmUMCCH27_PerfMonCtl1                              = 0x195B41;
    constexpr unsigned int mmUMCCH27_PerfMonCtl2                              = 0x195B42;
    constexpr unsigned int mmUMCCH27_PerfMonCtl3                              = 0x195B43;
    constexpr unsigned int mmUMCCH27_PerfMonCtl4                              = 0x195B44;
    constexpr unsigned int mmUMCCH27_PerfMonCtl5                              = 0x195B45;
    constexpr unsigned int mmUMCCH27_PerfMonCtlClk                            = 0x195B40;
    constexpr unsigned int mmUMCCH27_PerfMonCtr1_Hi                           = 0x195B4B;
    constexpr unsigned int mmUMCCH27_PerfMonCtr1_Lo                           = 0x195B4A;
    constexpr unsigned int mmUMCCH27_PerfMonCtr2_Hi                           = 0x195B4D;
    constexpr unsigned int mmUMCCH27_PerfMonCtr2_Lo                           = 0x195B4C;
    constexpr unsigned int mmUMCCH27_PerfMonCtr3_Hi                           = 0x195B4F;
    constexpr unsigned int mmUMCCH27_PerfMonCtr3_Lo                           = 0x195B4E;
    constexpr unsigned int mmUMCCH27_PerfMonCtr4_Hi                           = 0x195B51;
    constexpr unsigned int mmUMCCH27_PerfMonCtr4_Lo                           = 0x195B50;
    constexpr unsigned int mmUMCCH27_PerfMonCtr5_Hi                           = 0x195B53;
    constexpr unsigned int mmUMCCH27_PerfMonCtr5_Lo                           = 0x195B52;
    constexpr unsigned int mmUMCCH27_PerfMonCtrClk_Hi                         = 0x195B49;
    constexpr unsigned int mmUMCCH27_PerfMonCtrClk_Lo                         = 0x195B48;
    constexpr unsigned int mmUMCCH28_PerfMonCtl1                              = 0x1D4341;
    constexpr unsigned int mmUMCCH28_PerfMonCtl2                              = 0x1D4342;
    constexpr unsigned int mmUMCCH28_PerfMonCtl3                              = 0x1D4343;
    constexpr unsigned int mmUMCCH28_PerfMonCtl4                              = 0x1D4344;
    constexpr unsigned int mmUMCCH28_PerfMonCtl5                              = 0x1D4345;
    constexpr unsigned int mmUMCCH28_PerfMonCtlClk                            = 0x1D4340;
    constexpr unsigned int mmUMCCH28_PerfMonCtr1_Hi                           = 0x1D434B;
    constexpr unsigned int mmUMCCH28_PerfMonCtr1_Lo                           = 0x1D434A;
    constexpr unsigned int mmUMCCH28_PerfMonCtr2_Hi                           = 0x1D434D;
    constexpr unsigned int mmUMCCH28_PerfMonCtr2_Lo                           = 0x1D434C;
    constexpr unsigned int mmUMCCH28_PerfMonCtr3_Hi                           = 0x1D434F;
    constexpr unsigned int mmUMCCH28_PerfMonCtr3_Lo                           = 0x1D434E;
    constexpr unsigned int mmUMCCH28_PerfMonCtr4_Hi                           = 0x1D4351;
    constexpr unsigned int mmUMCCH28_PerfMonCtr4_Lo                           = 0x1D4350;
    constexpr unsigned int mmUMCCH28_PerfMonCtr5_Hi                           = 0x1D4353;
    constexpr unsigned int mmUMCCH28_PerfMonCtr5_Lo                           = 0x1D4352;
    constexpr unsigned int mmUMCCH28_PerfMonCtrClk_Hi                         = 0x1D4349;
    constexpr unsigned int mmUMCCH28_PerfMonCtrClk_Lo                         = 0x1D4348;
    constexpr unsigned int mmUMCCH29_PerfMonCtl1                              = 0x1D4B41;
    constexpr unsigned int mmUMCCH29_PerfMonCtl2                              = 0x1D4B42;
    constexpr unsigned int mmUMCCH29_PerfMonCtl3                              = 0x1D4B43;
    constexpr unsigned int mmUMCCH29_PerfMonCtl4                              = 0x1D4B44;
    constexpr unsigned int mmUMCCH29_PerfMonCtl5                              = 0x1D4B45;
    constexpr unsigned int mmUMCCH29_PerfMonCtlClk                            = 0x1D4B40;
    constexpr unsigned int mmUMCCH29_PerfMonCtr1_Hi                           = 0x1D4B4B;
    constexpr unsigned int mmUMCCH29_PerfMonCtr1_Lo                           = 0x1D4B4A;
    constexpr unsigned int mmUMCCH29_PerfMonCtr2_Hi                           = 0x1D4B4D;
    constexpr unsigned int mmUMCCH29_PerfMonCtr2_Lo                           = 0x1D4B4C;
    constexpr unsigned int mmUMCCH29_PerfMonCtr3_Hi                           = 0x1D4B4F;
    constexpr unsigned int mmUMCCH29_PerfMonCtr3_Lo                           = 0x1D4B4E;
    constexpr unsigned int mmUMCCH29_PerfMonCtr4_Hi                           = 0x1D4B51;
    constexpr unsigned int mmUMCCH29_PerfMonCtr4_Lo                           = 0x1D4B50;
    constexpr unsigned int mmUMCCH29_PerfMonCtr5_Hi                           = 0x1D4B53;
    constexpr unsigned int mmUMCCH29_PerfMonCtr5_Lo                           = 0x1D4B52;
    constexpr unsigned int mmUMCCH29_PerfMonCtrClk_Hi                         = 0x1D4B49;
    constexpr unsigned int mmUMCCH29_PerfMonCtrClk_Lo                         = 0x1D4B48;
    constexpr unsigned int mmUMCCH30_PerfMonCtl1                              = 0x1D5341;
    constexpr unsigned int mmUMCCH30_PerfMonCtl2                              = 0x1D5342;
    constexpr unsigned int mmUMCCH30_PerfMonCtl3                              = 0x1D5343;
    constexpr unsigned int mmUMCCH30_PerfMonCtl4                              = 0x1D5344;
    constexpr unsigned int mmUMCCH30_PerfMonCtl5                              = 0x1D5345;
    constexpr unsigned int mmUMCCH30_PerfMonCtlClk                            = 0x1D5340;
    constexpr unsigned int mmUMCCH30_PerfMonCtr1_Hi                           = 0x1D534B;
    constexpr unsigned int mmUMCCH30_PerfMonCtr1_Lo                           = 0x1D534A;
    constexpr unsigned int mmUMCCH30_PerfMonCtr2_Hi                           = 0x1D534D;
    constexpr unsigned int mmUMCCH30_PerfMonCtr2_Lo                           = 0x1D534C;
    constexpr unsigned int mmUMCCH30_PerfMonCtr3_Hi                           = 0x1D534F;
    constexpr unsigned int mmUMCCH30_PerfMonCtr3_Lo                           = 0x1D534E;
    constexpr unsigned int mmUMCCH30_PerfMonCtr4_Hi                           = 0x1D5351;
    constexpr unsigned int mmUMCCH30_PerfMonCtr4_Lo                           = 0x1D5350;
    constexpr unsigned int mmUMCCH30_PerfMonCtr5_Hi                           = 0x1D5353;
    constexpr unsigned int mmUMCCH30_PerfMonCtr5_Lo                           = 0x1D5352;
    constexpr unsigned int mmUMCCH30_PerfMonCtrClk_Hi                         = 0x1D5349;
    constexpr unsigned int mmUMCCH30_PerfMonCtrClk_Lo                         = 0x1D5348;
    constexpr unsigned int mmUMCCH31_PerfMonCtl1                              = 0x1D5B41;
    constexpr unsigned int mmUMCCH31_PerfMonCtl2                              = 0x1D5B42;
    constexpr unsigned int mmUMCCH31_PerfMonCtl3                              = 0x1D5B43;
    constexpr unsigned int mmUMCCH31_PerfMonCtl4                              = 0x1D5B44;
    constexpr unsigned int mmUMCCH31_PerfMonCtl5                              = 0x1D5B45;
    constexpr unsigned int mmUMCCH31_PerfMonCtlClk                            = 0x1D5B40;
    constexpr unsigned int mmUMCCH31_PerfMonCtr1_Hi                           = 0x1D5B4B;
    constexpr unsigned int mmUMCCH31_PerfMonCtr1_Lo                           = 0x1D5B4A;
    constexpr unsigned int mmUMCCH31_PerfMonCtr2_Hi                           = 0x1D5B4D;
    constexpr unsigned int mmUMCCH31_PerfMonCtr2_Lo                           = 0x1D5B4C;
    constexpr unsigned int mmUMCCH31_PerfMonCtr3_Hi                           = 0x1D5B4F;
    constexpr unsigned int mmUMCCH31_PerfMonCtr3_Lo                           = 0x1D5B4E;
    constexpr unsigned int mmUMCCH31_PerfMonCtr4_Hi                           = 0x1D5B51;
    constexpr unsigned int mmUMCCH31_PerfMonCtr4_Lo                           = 0x1D5B50;
    constexpr unsigned int mmUMCCH31_PerfMonCtr5_Hi                           = 0x1D5B53;
    constexpr unsigned int mmUMCCH31_PerfMonCtr5_Lo                           = 0x1D5B52;
    constexpr unsigned int mmUMCCH31_PerfMonCtrClk_Hi                         = 0x1D5B49;
    constexpr unsigned int mmUMCCH31_PerfMonCtrClk_Lo                         = 0x1D5B48;
} // namespace Vg20

