/*
 ***********************************************************************************************************************
 *
 *  Copyright (c) 2019 Advanced Micro Devices, Inc. All Rights Reserved.
 *
 *  Permission is hereby granted, free of charge, to any person obtaining a copy
 *  of this software and associated documentation files (the "Software"), to deal
 *  in the Software without restriction, including without limitation the rights
 *  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 *  copies of the Software, and to permit persons to whom the Software is
 *  furnished to do so, subject to the following conditions:
 *
 *  The above copyright notice and this permission notice shall be included in all
 *  copies or substantial portions of the Software.
 *
 *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 *  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 *  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 *  SOFTWARE.
 *
 **********************************************************************************************************************/

#pragma once

constexpr unsigned int ATC_PERFCOUNTER0_CFG__CLEAR__SHIFT                 = 0x0000001d;
constexpr unsigned int ATC_PERFCOUNTER0_CFG__ENABLE__SHIFT                = 0x0000001c;
constexpr unsigned int ATC_PERFCOUNTER0_CFG__PERF_MODE__SHIFT             = 0x00000018;
constexpr unsigned int ATC_PERFCOUNTER0_CFG__PERF_SEL_END__SHIFT          = 0x00000008;
constexpr unsigned int ATC_PERFCOUNTER0_CFG__PERF_SEL__SHIFT              = 0x00000000;
constexpr unsigned int ATC_PERFCOUNTER1_CFG__CLEAR__SHIFT                 = 0x0000001d;
constexpr unsigned int ATC_PERFCOUNTER1_CFG__ENABLE__SHIFT                = 0x0000001c;
constexpr unsigned int ATC_PERFCOUNTER1_CFG__PERF_MODE__SHIFT             = 0x00000018;
constexpr unsigned int ATC_PERFCOUNTER1_CFG__PERF_SEL_END__SHIFT          = 0x00000008;
constexpr unsigned int ATC_PERFCOUNTER1_CFG__PERF_SEL__SHIFT              = 0x00000000;
constexpr unsigned int ATC_PERFCOUNTER2_CFG__CLEAR__SHIFT                 = 0x0000001d;
constexpr unsigned int ATC_PERFCOUNTER2_CFG__ENABLE__SHIFT                = 0x0000001c;
constexpr unsigned int ATC_PERFCOUNTER2_CFG__PERF_MODE__SHIFT             = 0x00000018;
constexpr unsigned int ATC_PERFCOUNTER2_CFG__PERF_SEL_END__SHIFT          = 0x00000008;
constexpr unsigned int ATC_PERFCOUNTER2_CFG__PERF_SEL__SHIFT              = 0x00000000;
constexpr unsigned int ATC_PERFCOUNTER3_CFG__CLEAR__SHIFT                 = 0x0000001d;
constexpr unsigned int ATC_PERFCOUNTER3_CFG__ENABLE__SHIFT                = 0x0000001c;
constexpr unsigned int ATC_PERFCOUNTER3_CFG__PERF_MODE__SHIFT             = 0x00000018;
constexpr unsigned int ATC_PERFCOUNTER3_CFG__PERF_SEL_END__SHIFT          = 0x00000008;
constexpr unsigned int ATC_PERFCOUNTER3_CFG__PERF_SEL__SHIFT              = 0x00000000;
constexpr unsigned int ATC_PERFCOUNTER_HI__COMPARE_VALUE__SHIFT           = 0x00000010;
constexpr unsigned int ATC_PERFCOUNTER_HI__COUNTER_HI__SHIFT              = 0x00000000;
constexpr unsigned int ATC_PERFCOUNTER_LO__COUNTER_LO__SHIFT              = 0x00000000;
constexpr unsigned int ATC_PERFCOUNTER_RSLT_CNTL__CLEAR_ALL__SHIFT        = 0x00000019;
constexpr unsigned int ATC_PERFCOUNTER_RSLT_CNTL__ENABLE_ANY__SHIFT       = 0x00000018;
constexpr unsigned int ATC_PERFCOUNTER_RSLT_CNTL__PERF_COUNTER_SELECT__SHIFT = 0x00000000;
constexpr unsigned int ATC_PERFCOUNTER_RSLT_CNTL__START_TRIGGER__SHIFT    = 0x00000008;
constexpr unsigned int ATC_PERFCOUNTER_RSLT_CNTL__STOP_ALL_ON_SATURATE__SHIFT = 0x0000001a;
constexpr unsigned int ATC_PERFCOUNTER_RSLT_CNTL__STOP_TRIGGER__SHIFT     = 0x00000010;
constexpr unsigned int CB_BLEND0_CONTROL__ALPHA_COMB_FCN__SHIFT           = 0x00000015;
constexpr unsigned int CB_BLEND0_CONTROL__ALPHA_DESTBLEND__SHIFT          = 0x00000018;
constexpr unsigned int CB_BLEND0_CONTROL__ALPHA_SRCBLEND__SHIFT           = 0x00000010;
constexpr unsigned int CB_BLEND0_CONTROL__COLOR_COMB_FCN__SHIFT           = 0x00000005;
constexpr unsigned int CB_BLEND0_CONTROL__COLOR_DESTBLEND__SHIFT          = 0x00000008;
constexpr unsigned int CB_BLEND0_CONTROL__COLOR_SRCBLEND__SHIFT           = 0x00000000;
constexpr unsigned int CB_BLEND0_CONTROL__DISABLE_ROP3__SHIFT             = 0x0000001f;
constexpr unsigned int CB_BLEND0_CONTROL__ENABLE__SHIFT                   = 0x0000001e;
constexpr unsigned int CB_BLEND0_CONTROL__SEPARATE_ALPHA_BLEND__SHIFT     = 0x0000001d;
constexpr unsigned int CB_BLEND1_CONTROL__ALPHA_COMB_FCN__SHIFT           = 0x00000015;
constexpr unsigned int CB_BLEND1_CONTROL__ALPHA_DESTBLEND__SHIFT          = 0x00000018;
constexpr unsigned int CB_BLEND1_CONTROL__ALPHA_SRCBLEND__SHIFT           = 0x00000010;
constexpr unsigned int CB_BLEND1_CONTROL__COLOR_COMB_FCN__SHIFT           = 0x00000005;
constexpr unsigned int CB_BLEND1_CONTROL__COLOR_DESTBLEND__SHIFT          = 0x00000008;
constexpr unsigned int CB_BLEND1_CONTROL__COLOR_SRCBLEND__SHIFT           = 0x00000000;
constexpr unsigned int CB_BLEND1_CONTROL__DISABLE_ROP3__SHIFT             = 0x0000001f;
constexpr unsigned int CB_BLEND1_CONTROL__ENABLE__SHIFT                   = 0x0000001e;
constexpr unsigned int CB_BLEND1_CONTROL__SEPARATE_ALPHA_BLEND__SHIFT     = 0x0000001d;
constexpr unsigned int CB_BLEND2_CONTROL__ALPHA_COMB_FCN__SHIFT           = 0x00000015;
constexpr unsigned int CB_BLEND2_CONTROL__ALPHA_DESTBLEND__SHIFT          = 0x00000018;
constexpr unsigned int CB_BLEND2_CONTROL__ALPHA_SRCBLEND__SHIFT           = 0x00000010;
constexpr unsigned int CB_BLEND2_CONTROL__COLOR_COMB_FCN__SHIFT           = 0x00000005;
constexpr unsigned int CB_BLEND2_CONTROL__COLOR_DESTBLEND__SHIFT          = 0x00000008;
constexpr unsigned int CB_BLEND2_CONTROL__COLOR_SRCBLEND__SHIFT           = 0x00000000;
constexpr unsigned int CB_BLEND2_CONTROL__DISABLE_ROP3__SHIFT             = 0x0000001f;
constexpr unsigned int CB_BLEND2_CONTROL__ENABLE__SHIFT                   = 0x0000001e;
constexpr unsigned int CB_BLEND2_CONTROL__SEPARATE_ALPHA_BLEND__SHIFT     = 0x0000001d;
constexpr unsigned int CB_BLEND3_CONTROL__ALPHA_COMB_FCN__SHIFT           = 0x00000015;
constexpr unsigned int CB_BLEND3_CONTROL__ALPHA_DESTBLEND__SHIFT          = 0x00000018;
constexpr unsigned int CB_BLEND3_CONTROL__ALPHA_SRCBLEND__SHIFT           = 0x00000010;
constexpr unsigned int CB_BLEND3_CONTROL__COLOR_COMB_FCN__SHIFT           = 0x00000005;
constexpr unsigned int CB_BLEND3_CONTROL__COLOR_DESTBLEND__SHIFT          = 0x00000008;
constexpr unsigned int CB_BLEND3_CONTROL__COLOR_SRCBLEND__SHIFT           = 0x00000000;
constexpr unsigned int CB_BLEND3_CONTROL__DISABLE_ROP3__SHIFT             = 0x0000001f;
constexpr unsigned int CB_BLEND3_CONTROL__ENABLE__SHIFT                   = 0x0000001e;
constexpr unsigned int CB_BLEND3_CONTROL__SEPARATE_ALPHA_BLEND__SHIFT     = 0x0000001d;
constexpr unsigned int CB_BLEND4_CONTROL__ALPHA_COMB_FCN__SHIFT           = 0x00000015;
constexpr unsigned int CB_BLEND4_CONTROL__ALPHA_DESTBLEND__SHIFT          = 0x00000018;
constexpr unsigned int CB_BLEND4_CONTROL__ALPHA_SRCBLEND__SHIFT           = 0x00000010;
constexpr unsigned int CB_BLEND4_CONTROL__COLOR_COMB_FCN__SHIFT           = 0x00000005;
constexpr unsigned int CB_BLEND4_CONTROL__COLOR_DESTBLEND__SHIFT          = 0x00000008;
constexpr unsigned int CB_BLEND4_CONTROL__COLOR_SRCBLEND__SHIFT           = 0x00000000;
constexpr unsigned int CB_BLEND4_CONTROL__DISABLE_ROP3__SHIFT             = 0x0000001f;
constexpr unsigned int CB_BLEND4_CONTROL__ENABLE__SHIFT                   = 0x0000001e;
constexpr unsigned int CB_BLEND4_CONTROL__SEPARATE_ALPHA_BLEND__SHIFT     = 0x0000001d;
constexpr unsigned int CB_BLEND5_CONTROL__ALPHA_COMB_FCN__SHIFT           = 0x00000015;
constexpr unsigned int CB_BLEND5_CONTROL__ALPHA_DESTBLEND__SHIFT          = 0x00000018;
constexpr unsigned int CB_BLEND5_CONTROL__ALPHA_SRCBLEND__SHIFT           = 0x00000010;
constexpr unsigned int CB_BLEND5_CONTROL__COLOR_COMB_FCN__SHIFT           = 0x00000005;
constexpr unsigned int CB_BLEND5_CONTROL__COLOR_DESTBLEND__SHIFT          = 0x00000008;
constexpr unsigned int CB_BLEND5_CONTROL__COLOR_SRCBLEND__SHIFT           = 0x00000000;
constexpr unsigned int CB_BLEND5_CONTROL__DISABLE_ROP3__SHIFT             = 0x0000001f;
constexpr unsigned int CB_BLEND5_CONTROL__ENABLE__SHIFT                   = 0x0000001e;
constexpr unsigned int CB_BLEND5_CONTROL__SEPARATE_ALPHA_BLEND__SHIFT     = 0x0000001d;
constexpr unsigned int CB_BLEND6_CONTROL__ALPHA_COMB_FCN__SHIFT           = 0x00000015;
constexpr unsigned int CB_BLEND6_CONTROL__ALPHA_DESTBLEND__SHIFT          = 0x00000018;
constexpr unsigned int CB_BLEND6_CONTROL__ALPHA_SRCBLEND__SHIFT           = 0x00000010;
constexpr unsigned int CB_BLEND6_CONTROL__COLOR_COMB_FCN__SHIFT           = 0x00000005;
constexpr unsigned int CB_BLEND6_CONTROL__COLOR_DESTBLEND__SHIFT          = 0x00000008;
constexpr unsigned int CB_BLEND6_CONTROL__COLOR_SRCBLEND__SHIFT           = 0x00000000;
constexpr unsigned int CB_BLEND6_CONTROL__DISABLE_ROP3__SHIFT             = 0x0000001f;
constexpr unsigned int CB_BLEND6_CONTROL__ENABLE__SHIFT                   = 0x0000001e;
constexpr unsigned int CB_BLEND6_CONTROL__SEPARATE_ALPHA_BLEND__SHIFT     = 0x0000001d;
constexpr unsigned int CB_BLEND7_CONTROL__ALPHA_COMB_FCN__SHIFT           = 0x00000015;
constexpr unsigned int CB_BLEND7_CONTROL__ALPHA_DESTBLEND__SHIFT          = 0x00000018;
constexpr unsigned int CB_BLEND7_CONTROL__ALPHA_SRCBLEND__SHIFT           = 0x00000010;
constexpr unsigned int CB_BLEND7_CONTROL__COLOR_COMB_FCN__SHIFT           = 0x00000005;
constexpr unsigned int CB_BLEND7_CONTROL__COLOR_DESTBLEND__SHIFT          = 0x00000008;
constexpr unsigned int CB_BLEND7_CONTROL__COLOR_SRCBLEND__SHIFT           = 0x00000000;
constexpr unsigned int CB_BLEND7_CONTROL__DISABLE_ROP3__SHIFT             = 0x0000001f;
constexpr unsigned int CB_BLEND7_CONTROL__ENABLE__SHIFT                   = 0x0000001e;
constexpr unsigned int CB_BLEND7_CONTROL__SEPARATE_ALPHA_BLEND__SHIFT     = 0x0000001d;
constexpr unsigned int CB_BLEND_ALPHA__BLEND_ALPHA__SHIFT                 = 0x00000000;
constexpr unsigned int CB_BLEND_BLUE__BLEND_BLUE__SHIFT                   = 0x00000000;
constexpr unsigned int CB_BLEND_GREEN__BLEND_GREEN__SHIFT                 = 0x00000000;
constexpr unsigned int CB_BLEND_RED__BLEND_RED__SHIFT                     = 0x00000000;
constexpr unsigned int CB_CGTT_SCLK_CTRL__OFF_HYSTERESIS__SHIFT           = 0x00000004;
constexpr unsigned int CB_CGTT_SCLK_CTRL__ON_DELAY__SHIFT                 = 0x00000000;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_OVERRIDE0__SHIFT           = 0x0000001f;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_OVERRIDE1__SHIFT           = 0x0000001e;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_OVERRIDE2__SHIFT           = 0x0000001d;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_OVERRIDE3__SHIFT           = 0x0000001c;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_OVERRIDE4__SHIFT           = 0x0000001b;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_OVERRIDE5__SHIFT           = 0x0000001a;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_OVERRIDE6__SHIFT           = 0x00000019;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_OVERRIDE7__SHIFT           = 0x00000018;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE0__SHIFT     = 0x00000017;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE1__SHIFT     = 0x00000016;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE2__SHIFT     = 0x00000015;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE3__SHIFT     = 0x00000014;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE4__SHIFT     = 0x00000013;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE5__SHIFT     = 0x00000012;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE6__SHIFT     = 0x00000011;
constexpr unsigned int CB_CGTT_SCLK_CTRL__SOFT_STALL_OVERRIDE7__SHIFT     = 0x00000010;
constexpr unsigned int CB_COLOR0_ATTRIB2__MAX_MIP__SHIFT                  = 0x0000001c;
constexpr unsigned int CB_COLOR0_ATTRIB2__MIP0_HEIGHT__SHIFT              = 0x00000000;
constexpr unsigned int CB_COLOR0_ATTRIB2__MIP0_WIDTH__SHIFT               = 0x0000000e;
constexpr unsigned int CB_COLOR0_BASE_EXT__BASE_256B__SHIFT               = 0x00000000;
constexpr unsigned int CB_COLOR0_BASE__BASE_256B__SHIFT                   = 0x00000000;
constexpr unsigned int CB_COLOR0_CLEAR_WORD0__CLEAR_WORD0__SHIFT          = 0x00000000;
constexpr unsigned int CB_COLOR0_CLEAR_WORD1__CLEAR_WORD1__SHIFT          = 0x00000000;
constexpr unsigned int CB_COLOR0_CMASK_BASE_EXT__BASE_256B__SHIFT         = 0x00000000;
constexpr unsigned int CB_COLOR0_CMASK__BASE_256B__SHIFT                  = 0x00000000;
constexpr unsigned int CB_COLOR0_DCC_BASE_EXT__BASE_256B__SHIFT           = 0x00000000;
constexpr unsigned int CB_COLOR0_DCC_BASE__BASE_256B__SHIFT               = 0x00000000;
constexpr unsigned int CB_COLOR0_DCC_CONTROL__COLOR_TRANSFORM__SHIFT      = 0x00000007;
constexpr unsigned int CB_COLOR0_DCC_CONTROL__INDEPENDENT_64B_BLOCKS__SHIFT = 0x00000009;
constexpr unsigned int CB_COLOR0_DCC_CONTROL__KEY_CLEAR_ENABLE__SHIFT     = 0x00000001;
constexpr unsigned int CB_COLOR0_DCC_CONTROL__LOSSY_ALPHA_PRECISION__SHIFT = 0x0000000e;
constexpr unsigned int CB_COLOR0_DCC_CONTROL__LOSSY_RGB_PRECISION__SHIFT  = 0x0000000a;
constexpr unsigned int CB_COLOR0_DCC_CONTROL__MAX_COMPRESSED_BLOCK_SIZE__SHIFT = 0x00000005;
constexpr unsigned int CB_COLOR0_DCC_CONTROL__MAX_UNCOMPRESSED_BLOCK_SIZE__SHIFT = 0x00000002;
constexpr unsigned int CB_COLOR0_DCC_CONTROL__MIN_COMPRESSED_BLOCK_SIZE__SHIFT = 0x00000004;
constexpr unsigned int CB_COLOR0_DCC_CONTROL__OVERWRITE_COMBINER_DISABLE__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR0_FMASK_BASE_EXT__BASE_256B__SHIFT         = 0x00000000;
constexpr unsigned int CB_COLOR0_FMASK__BASE_256B__SHIFT                  = 0x00000000;
constexpr unsigned int CB_COLOR0_INFO__BLEND_BYPASS__SHIFT                = 0x00000010;
constexpr unsigned int CB_COLOR0_INFO__BLEND_CLAMP__SHIFT                 = 0x0000000f;
constexpr unsigned int CB_COLOR0_INFO__BLEND_OPT_DISCARD_PIXEL__SHIFT     = 0x00000017;
constexpr unsigned int CB_COLOR0_INFO__BLEND_OPT_DONT_RD_DST__SHIFT       = 0x00000014;
constexpr unsigned int CB_COLOR0_INFO__CMASK_ADDR_TYPE__SHIFT             = 0x0000001d;
constexpr unsigned int CB_COLOR0_INFO__COMPRESSION__SHIFT                 = 0x0000000e;
constexpr unsigned int CB_COLOR0_INFO__COMP_SWAP__SHIFT                   = 0x0000000b;
constexpr unsigned int CB_COLOR0_INFO__DCC_ENABLE__SHIFT                  = 0x0000001c;
constexpr unsigned int CB_COLOR0_INFO__ENDIAN__SHIFT                      = 0x00000000;
constexpr unsigned int CB_COLOR0_INFO__FAST_CLEAR__SHIFT                  = 0x0000000d;
constexpr unsigned int CB_COLOR0_INFO__FMASK_COMPRESSION_DISABLE__SHIFT   = 0x0000001a;
constexpr unsigned int CB_COLOR0_INFO__FMASK_COMPRESS_1FRAG_ONLY__SHIFT   = 0x0000001b;
constexpr unsigned int CB_COLOR0_INFO__FORMAT__SHIFT                      = 0x00000002;
constexpr unsigned int CB_COLOR0_INFO__NUMBER_TYPE__SHIFT                 = 0x00000008;
constexpr unsigned int CB_COLOR0_INFO__ROUND_MODE__SHIFT                  = 0x00000012;
constexpr unsigned int CB_COLOR0_INFO__SIMPLE_FLOAT__SHIFT                = 0x00000011;
constexpr unsigned int CB_COLOR0_VIEW__SLICE_MAX__SHIFT                   = 0x0000000d;
constexpr unsigned int CB_COLOR0_VIEW__SLICE_START__SHIFT                 = 0x00000000;
constexpr unsigned int CB_COLOR1_ATTRIB2__MAX_MIP__SHIFT                  = 0x0000001c;
constexpr unsigned int CB_COLOR1_ATTRIB2__MIP0_HEIGHT__SHIFT              = 0x00000000;
constexpr unsigned int CB_COLOR1_ATTRIB2__MIP0_WIDTH__SHIFT               = 0x0000000e;
constexpr unsigned int CB_COLOR1_BASE_EXT__BASE_256B__SHIFT               = 0x00000000;
constexpr unsigned int CB_COLOR1_BASE__BASE_256B__SHIFT                   = 0x00000000;
constexpr unsigned int CB_COLOR1_CLEAR_WORD0__CLEAR_WORD0__SHIFT          = 0x00000000;
constexpr unsigned int CB_COLOR1_CLEAR_WORD1__CLEAR_WORD1__SHIFT          = 0x00000000;
constexpr unsigned int CB_COLOR1_CMASK_BASE_EXT__BASE_256B__SHIFT         = 0x00000000;
constexpr unsigned int CB_COLOR1_CMASK__BASE_256B__SHIFT                  = 0x00000000;
constexpr unsigned int CB_COLOR1_DCC_BASE_EXT__BASE_256B__SHIFT           = 0x00000000;
constexpr unsigned int CB_COLOR1_DCC_BASE__BASE_256B__SHIFT               = 0x00000000;
constexpr unsigned int CB_COLOR1_DCC_CONTROL__COLOR_TRANSFORM__SHIFT      = 0x00000007;
constexpr unsigned int CB_COLOR1_DCC_CONTROL__INDEPENDENT_64B_BLOCKS__SHIFT = 0x00000009;
constexpr unsigned int CB_COLOR1_DCC_CONTROL__KEY_CLEAR_ENABLE__SHIFT     = 0x00000001;
constexpr unsigned int CB_COLOR1_DCC_CONTROL__LOSSY_ALPHA_PRECISION__SHIFT = 0x0000000e;
constexpr unsigned int CB_COLOR1_DCC_CONTROL__LOSSY_RGB_PRECISION__SHIFT  = 0x0000000a;
constexpr unsigned int CB_COLOR1_DCC_CONTROL__MAX_COMPRESSED_BLOCK_SIZE__SHIFT = 0x00000005;
constexpr unsigned int CB_COLOR1_DCC_CONTROL__MAX_UNCOMPRESSED_BLOCK_SIZE__SHIFT = 0x00000002;
constexpr unsigned int CB_COLOR1_DCC_CONTROL__MIN_COMPRESSED_BLOCK_SIZE__SHIFT = 0x00000004;
constexpr unsigned int CB_COLOR1_DCC_CONTROL__OVERWRITE_COMBINER_DISABLE__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR1_FMASK_BASE_EXT__BASE_256B__SHIFT         = 0x00000000;
constexpr unsigned int CB_COLOR1_FMASK__BASE_256B__SHIFT                  = 0x00000000;
constexpr unsigned int CB_COLOR1_INFO__BLEND_BYPASS__SHIFT                = 0x00000010;
constexpr unsigned int CB_COLOR1_INFO__BLEND_CLAMP__SHIFT                 = 0x0000000f;
constexpr unsigned int CB_COLOR1_INFO__BLEND_OPT_DISCARD_PIXEL__SHIFT     = 0x00000017;
constexpr unsigned int CB_COLOR1_INFO__BLEND_OPT_DONT_RD_DST__SHIFT       = 0x00000014;
constexpr unsigned int CB_COLOR1_INFO__CMASK_ADDR_TYPE__SHIFT             = 0x0000001d;
constexpr unsigned int CB_COLOR1_INFO__COMPRESSION__SHIFT                 = 0x0000000e;
constexpr unsigned int CB_COLOR1_INFO__COMP_SWAP__SHIFT                   = 0x0000000b;
constexpr unsigned int CB_COLOR1_INFO__DCC_ENABLE__SHIFT                  = 0x0000001c;
constexpr unsigned int CB_COLOR1_INFO__ENDIAN__SHIFT                      = 0x00000000;
constexpr unsigned int CB_COLOR1_INFO__FAST_CLEAR__SHIFT                  = 0x0000000d;
constexpr unsigned int CB_COLOR1_INFO__FMASK_COMPRESSION_DISABLE__SHIFT   = 0x0000001a;
constexpr unsigned int CB_COLOR1_INFO__FMASK_COMPRESS_1FRAG_ONLY__SHIFT   = 0x0000001b;
constexpr unsigned int CB_COLOR1_INFO__FORMAT__SHIFT                      = 0x00000002;
constexpr unsigned int CB_COLOR1_INFO__NUMBER_TYPE__SHIFT                 = 0x00000008;
constexpr unsigned int CB_COLOR1_INFO__ROUND_MODE__SHIFT                  = 0x00000012;
constexpr unsigned int CB_COLOR1_INFO__SIMPLE_FLOAT__SHIFT                = 0x00000011;
constexpr unsigned int CB_COLOR1_VIEW__SLICE_MAX__SHIFT                   = 0x0000000d;
constexpr unsigned int CB_COLOR1_VIEW__SLICE_START__SHIFT                 = 0x00000000;
constexpr unsigned int CB_COLOR2_ATTRIB2__MAX_MIP__SHIFT                  = 0x0000001c;
constexpr unsigned int CB_COLOR2_ATTRIB2__MIP0_HEIGHT__SHIFT              = 0x00000000;
constexpr unsigned int CB_COLOR2_ATTRIB2__MIP0_WIDTH__SHIFT               = 0x0000000e;
constexpr unsigned int CB_COLOR2_BASE_EXT__BASE_256B__SHIFT               = 0x00000000;
constexpr unsigned int CB_COLOR2_BASE__BASE_256B__SHIFT                   = 0x00000000;
constexpr unsigned int CB_COLOR2_CLEAR_WORD0__CLEAR_WORD0__SHIFT          = 0x00000000;
constexpr unsigned int CB_COLOR2_CLEAR_WORD1__CLEAR_WORD1__SHIFT          = 0x00000000;
constexpr unsigned int CB_COLOR2_CMASK_BASE_EXT__BASE_256B__SHIFT         = 0x00000000;
constexpr unsigned int CB_COLOR2_CMASK__BASE_256B__SHIFT                  = 0x00000000;
constexpr unsigned int CB_COLOR2_DCC_BASE_EXT__BASE_256B__SHIFT           = 0x00000000;
constexpr unsigned int CB_COLOR2_DCC_BASE__BASE_256B__SHIFT               = 0x00000000;
constexpr unsigned int CB_COLOR2_DCC_CONTROL__COLOR_TRANSFORM__SHIFT      = 0x00000007;
constexpr unsigned int CB_COLOR2_DCC_CONTROL__INDEPENDENT_64B_BLOCKS__SHIFT = 0x00000009;
constexpr unsigned int CB_COLOR2_DCC_CONTROL__KEY_CLEAR_ENABLE__SHIFT     = 0x00000001;
constexpr unsigned int CB_COLOR2_DCC_CONTROL__LOSSY_ALPHA_PRECISION__SHIFT = 0x0000000e;
constexpr unsigned int CB_COLOR2_DCC_CONTROL__LOSSY_RGB_PRECISION__SHIFT  = 0x0000000a;
constexpr unsigned int CB_COLOR2_DCC_CONTROL__MAX_COMPRESSED_BLOCK_SIZE__SHIFT = 0x00000005;
constexpr unsigned int CB_COLOR2_DCC_CONTROL__MAX_UNCOMPRESSED_BLOCK_SIZE__SHIFT = 0x00000002;
constexpr unsigned int CB_COLOR2_DCC_CONTROL__MIN_COMPRESSED_BLOCK_SIZE__SHIFT = 0x00000004;
constexpr unsigned int CB_COLOR2_DCC_CONTROL__OVERWRITE_COMBINER_DISABLE__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR2_FMASK_BASE_EXT__BASE_256B__SHIFT         = 0x00000000;
constexpr unsigned int CB_COLOR2_FMASK__BASE_256B__SHIFT                  = 0x00000000;
constexpr unsigned int CB_COLOR2_INFO__BLEND_BYPASS__SHIFT                = 0x00000010;
constexpr unsigned int CB_COLOR2_INFO__BLEND_CLAMP__SHIFT                 = 0x0000000f;
constexpr unsigned int CB_COLOR2_INFO__BLEND_OPT_DISCARD_PIXEL__SHIFT     = 0x00000017;
constexpr unsigned int CB_COLOR2_INFO__BLEND_OPT_DONT_RD_DST__SHIFT       = 0x00000014;
constexpr unsigned int CB_COLOR2_INFO__CMASK_ADDR_TYPE__SHIFT             = 0x0000001d;
constexpr unsigned int CB_COLOR2_INFO__COMPRESSION__SHIFT                 = 0x0000000e;
constexpr unsigned int CB_COLOR2_INFO__COMP_SWAP__SHIFT                   = 0x0000000b;
constexpr unsigned int CB_COLOR2_INFO__DCC_ENABLE__SHIFT                  = 0x0000001c;
constexpr unsigned int CB_COLOR2_INFO__ENDIAN__SHIFT                      = 0x00000000;
constexpr unsigned int CB_COLOR2_INFO__FAST_CLEAR__SHIFT                  = 0x0000000d;
constexpr unsigned int CB_COLOR2_INFO__FMASK_COMPRESSION_DISABLE__SHIFT   = 0x0000001a;
constexpr unsigned int CB_COLOR2_INFO__FMASK_COMPRESS_1FRAG_ONLY__SHIFT   = 0x0000001b;
constexpr unsigned int CB_COLOR2_INFO__FORMAT__SHIFT                      = 0x00000002;
constexpr unsigned int CB_COLOR2_INFO__NUMBER_TYPE__SHIFT                 = 0x00000008;
constexpr unsigned int CB_COLOR2_INFO__ROUND_MODE__SHIFT                  = 0x00000012;
constexpr unsigned int CB_COLOR2_INFO__SIMPLE_FLOAT__SHIFT                = 0x00000011;
constexpr unsigned int CB_COLOR2_VIEW__SLICE_MAX__SHIFT                   = 0x0000000d;
constexpr unsigned int CB_COLOR2_VIEW__SLICE_START__SHIFT                 = 0x00000000;
constexpr unsigned int CB_COLOR3_ATTRIB2__MAX_MIP__SHIFT                  = 0x0000001c;
constexpr unsigned int CB_COLOR3_ATTRIB2__MIP0_HEIGHT__SHIFT              = 0x00000000;
constexpr unsigned int CB_COLOR3_ATTRIB2__MIP0_WIDTH__SHIFT               = 0x0000000e;
constexpr unsigned int CB_COLOR3_BASE_EXT__BASE_256B__SHIFT               = 0x00000000;
constexpr unsigned int CB_COLOR3_BASE__BASE_256B__SHIFT                   = 0x00000000;
constexpr unsigned int CB_COLOR3_CLEAR_WORD0__CLEAR_WORD0__SHIFT          = 0x00000000;
constexpr unsigned int CB_COLOR3_CLEAR_WORD1__CLEAR_WORD1__SHIFT          = 0x00000000;
constexpr unsigned int CB_COLOR3_CMASK_BASE_EXT__BASE_256B__SHIFT         = 0x00000000;
constexpr unsigned int CB_COLOR3_CMASK__BASE_256B__SHIFT                  = 0x00000000;
constexpr unsigned int CB_COLOR3_DCC_BASE_EXT__BASE_256B__SHIFT           = 0x00000000;
constexpr unsigned int CB_COLOR3_DCC_BASE__BASE_256B__SHIFT               = 0x00000000;
constexpr unsigned int CB_COLOR3_DCC_CONTROL__COLOR_TRANSFORM__SHIFT      = 0x00000007;
constexpr unsigned int CB_COLOR3_DCC_CONTROL__INDEPENDENT_64B_BLOCKS__SHIFT = 0x00000009;
constexpr unsigned int CB_COLOR3_DCC_CONTROL__KEY_CLEAR_ENABLE__SHIFT     = 0x00000001;
constexpr unsigned int CB_COLOR3_DCC_CONTROL__LOSSY_ALPHA_PRECISION__SHIFT = 0x0000000e;
constexpr unsigned int CB_COLOR3_DCC_CONTROL__LOSSY_RGB_PRECISION__SHIFT  = 0x0000000a;
constexpr unsigned int CB_COLOR3_DCC_CONTROL__MAX_COMPRESSED_BLOCK_SIZE__SHIFT = 0x00000005;
constexpr unsigned int CB_COLOR3_DCC_CONTROL__MAX_UNCOMPRESSED_BLOCK_SIZE__SHIFT = 0x00000002;
constexpr unsigned int CB_COLOR3_DCC_CONTROL__MIN_COMPRESSED_BLOCK_SIZE__SHIFT = 0x00000004;
constexpr unsigned int CB_COLOR3_DCC_CONTROL__OVERWRITE_COMBINER_DISABLE__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR3_FMASK_BASE_EXT__BASE_256B__SHIFT         = 0x00000000;
constexpr unsigned int CB_COLOR3_FMASK__BASE_256B__SHIFT                  = 0x00000000;
constexpr unsigned int CB_COLOR3_INFO__BLEND_BYPASS__SHIFT                = 0x00000010;
constexpr unsigned int CB_COLOR3_INFO__BLEND_CLAMP__SHIFT                 = 0x0000000f;
constexpr unsigned int CB_COLOR3_INFO__BLEND_OPT_DISCARD_PIXEL__SHIFT     = 0x00000017;
constexpr unsigned int CB_COLOR3_INFO__BLEND_OPT_DONT_RD_DST__SHIFT       = 0x00000014;
constexpr unsigned int CB_COLOR3_INFO__CMASK_ADDR_TYPE__SHIFT             = 0x0000001d;
constexpr unsigned int CB_COLOR3_INFO__COMPRESSION__SHIFT                 = 0x0000000e;
constexpr unsigned int CB_COLOR3_INFO__COMP_SWAP__SHIFT                   = 0x0000000b;
constexpr unsigned int CB_COLOR3_INFO__DCC_ENABLE__SHIFT                  = 0x0000001c;
constexpr unsigned int CB_COLOR3_INFO__ENDIAN__SHIFT                      = 0x00000000;
constexpr unsigned int CB_COLOR3_INFO__FAST_CLEAR__SHIFT                  = 0x0000000d;
constexpr unsigned int CB_COLOR3_INFO__FMASK_COMPRESSION_DISABLE__SHIFT   = 0x0000001a;
constexpr unsigned int CB_COLOR3_INFO__FMASK_COMPRESS_1FRAG_ONLY__SHIFT   = 0x0000001b;
constexpr unsigned int CB_COLOR3_INFO__FORMAT__SHIFT                      = 0x00000002;
constexpr unsigned int CB_COLOR3_INFO__NUMBER_TYPE__SHIFT                 = 0x00000008;
constexpr unsigned int CB_COLOR3_INFO__ROUND_MODE__SHIFT                  = 0x00000012;
constexpr unsigned int CB_COLOR3_INFO__SIMPLE_FLOAT__SHIFT                = 0x00000011;
constexpr unsigned int CB_COLOR3_VIEW__SLICE_MAX__SHIFT                   = 0x0000000d;
constexpr unsigned int CB_COLOR3_VIEW__SLICE_START__SHIFT                 = 0x00000000;
constexpr unsigned int CB_COLOR4_ATTRIB2__MAX_MIP__SHIFT                  = 0x0000001c;
constexpr unsigned int CB_COLOR4_ATTRIB2__MIP0_HEIGHT__SHIFT              = 0x00000000;
constexpr unsigned int CB_COLOR4_ATTRIB2__MIP0_WIDTH__SHIFT               = 0x0000000e;
constexpr unsigned int CB_COLOR4_BASE_EXT__BASE_256B__SHIFT               = 0x00000000;
constexpr unsigned int CB_COLOR4_BASE__BASE_256B__SHIFT                   = 0x00000000;
constexpr unsigned int CB_COLOR4_CLEAR_WORD0__CLEAR_WORD0__SHIFT          = 0x00000000;
constexpr unsigned int CB_COLOR4_CLEAR_WORD1__CLEAR_WORD1__SHIFT          = 0x00000000;
constexpr unsigned int CB_COLOR4_CMASK_BASE_EXT__BASE_256B__SHIFT         = 0x00000000;
constexpr unsigned int CB_COLOR4_CMASK__BASE_256B__SHIFT                  = 0x00000000;
constexpr unsigned int CB_COLOR4_DCC_BASE_EXT__BASE_256B__SHIFT           = 0x00000000;
constexpr unsigned int CB_COLOR4_DCC_BASE__BASE_256B__SHIFT               = 0x00000000;
constexpr unsigned int CB_COLOR4_DCC_CONTROL__COLOR_TRANSFORM__SHIFT      = 0x00000007;
constexpr unsigned int CB_COLOR4_DCC_CONTROL__INDEPENDENT_64B_BLOCKS__SHIFT = 0x00000009;
constexpr unsigned int CB_COLOR4_DCC_CONTROL__KEY_CLEAR_ENABLE__SHIFT     = 0x00000001;
constexpr unsigned int CB_COLOR4_DCC_CONTROL__LOSSY_ALPHA_PRECISION__SHIFT = 0x0000000e;
constexpr unsigned int CB_COLOR4_DCC_CONTROL__LOSSY_RGB_PRECISION__SHIFT  = 0x0000000a;
constexpr unsigned int CB_COLOR4_DCC_CONTROL__MAX_COMPRESSED_BLOCK_SIZE__SHIFT = 0x00000005;
constexpr unsigned int CB_COLOR4_DCC_CONTROL__MAX_UNCOMPRESSED_BLOCK_SIZE__SHIFT = 0x00000002;
constexpr unsigned int CB_COLOR4_DCC_CONTROL__MIN_COMPRESSED_BLOCK_SIZE__SHIFT = 0x00000004;
constexpr unsigned int CB_COLOR4_DCC_CONTROL__OVERWRITE_COMBINER_DISABLE__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR4_FMASK_BASE_EXT__BASE_256B__SHIFT         = 0x00000000;
constexpr unsigned int CB_COLOR4_FMASK__BASE_256B__SHIFT                  = 0x00000000;
constexpr unsigned int CB_COLOR4_INFO__BLEND_BYPASS__SHIFT                = 0x00000010;
constexpr unsigned int CB_COLOR4_INFO__BLEND_CLAMP__SHIFT                 = 0x0000000f;
constexpr unsigned int CB_COLOR4_INFO__BLEND_OPT_DISCARD_PIXEL__SHIFT     = 0x00000017;
constexpr unsigned int CB_COLOR4_INFO__BLEND_OPT_DONT_RD_DST__SHIFT       = 0x00000014;
constexpr unsigned int CB_COLOR4_INFO__CMASK_ADDR_TYPE__SHIFT             = 0x0000001d;
constexpr unsigned int CB_COLOR4_INFO__COMPRESSION__SHIFT                 = 0x0000000e;
constexpr unsigned int CB_COLOR4_INFO__COMP_SWAP__SHIFT                   = 0x0000000b;
constexpr unsigned int CB_COLOR4_INFO__DCC_ENABLE__SHIFT                  = 0x0000001c;
constexpr unsigned int CB_COLOR4_INFO__ENDIAN__SHIFT                      = 0x00000000;
constexpr unsigned int CB_COLOR4_INFO__FAST_CLEAR__SHIFT                  = 0x0000000d;
constexpr unsigned int CB_COLOR4_INFO__FMASK_COMPRESSION_DISABLE__SHIFT   = 0x0000001a;
constexpr unsigned int CB_COLOR4_INFO__FMASK_COMPRESS_1FRAG_ONLY__SHIFT   = 0x0000001b;
constexpr unsigned int CB_COLOR4_INFO__FORMAT__SHIFT                      = 0x00000002;
constexpr unsigned int CB_COLOR4_INFO__NUMBER_TYPE__SHIFT                 = 0x00000008;
constexpr unsigned int CB_COLOR4_INFO__ROUND_MODE__SHIFT                  = 0x00000012;
constexpr unsigned int CB_COLOR4_INFO__SIMPLE_FLOAT__SHIFT                = 0x00000011;
constexpr unsigned int CB_COLOR4_VIEW__SLICE_MAX__SHIFT                   = 0x0000000d;
constexpr unsigned int CB_COLOR4_VIEW__SLICE_START__SHIFT                 = 0x00000000;
constexpr unsigned int CB_COLOR5_ATTRIB2__MAX_MIP__SHIFT                  = 0x0000001c;
constexpr unsigned int CB_COLOR5_ATTRIB2__MIP0_HEIGHT__SHIFT              = 0x00000000;
constexpr unsigned int CB_COLOR5_ATTRIB2__MIP0_WIDTH__SHIFT               = 0x0000000e;
constexpr unsigned int CB_COLOR5_BASE_EXT__BASE_256B__SHIFT               = 0x00000000;
constexpr unsigned int CB_COLOR5_BASE__BASE_256B__SHIFT                   = 0x00000000;
constexpr unsigned int CB_COLOR5_CLEAR_WORD0__CLEAR_WORD0__SHIFT          = 0x00000000;
constexpr unsigned int CB_COLOR5_CLEAR_WORD1__CLEAR_WORD1__SHIFT          = 0x00000000;
constexpr unsigned int CB_COLOR5_CMASK_BASE_EXT__BASE_256B__SHIFT         = 0x00000000;
constexpr unsigned int CB_COLOR5_CMASK__BASE_256B__SHIFT                  = 0x00000000;
constexpr unsigned int CB_COLOR5_DCC_BASE_EXT__BASE_256B__SHIFT           = 0x00000000;
constexpr unsigned int CB_COLOR5_DCC_BASE__BASE_256B__SHIFT               = 0x00000000;
constexpr unsigned int CB_COLOR5_DCC_CONTROL__COLOR_TRANSFORM__SHIFT      = 0x00000007;
constexpr unsigned int CB_COLOR5_DCC_CONTROL__INDEPENDENT_64B_BLOCKS__SHIFT = 0x00000009;
constexpr unsigned int CB_COLOR5_DCC_CONTROL__KEY_CLEAR_ENABLE__SHIFT     = 0x00000001;
constexpr unsigned int CB_COLOR5_DCC_CONTROL__LOSSY_ALPHA_PRECISION__SHIFT = 0x0000000e;
constexpr unsigned int CB_COLOR5_DCC_CONTROL__LOSSY_RGB_PRECISION__SHIFT  = 0x0000000a;
constexpr unsigned int CB_COLOR5_DCC_CONTROL__MAX_COMPRESSED_BLOCK_SIZE__SHIFT = 0x00000005;
constexpr unsigned int CB_COLOR5_DCC_CONTROL__MAX_UNCOMPRESSED_BLOCK_SIZE__SHIFT = 0x00000002;
constexpr unsigned int CB_COLOR5_DCC_CONTROL__MIN_COMPRESSED_BLOCK_SIZE__SHIFT = 0x00000004;
constexpr unsigned int CB_COLOR5_DCC_CONTROL__OVERWRITE_COMBINER_DISABLE__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR5_FMASK_BASE_EXT__BASE_256B__SHIFT         = 0x00000000;
constexpr unsigned int CB_COLOR5_FMASK__BASE_256B__SHIFT                  = 0x00000000;
constexpr unsigned int CB_COLOR5_INFO__BLEND_BYPASS__SHIFT                = 0x00000010;
constexpr unsigned int CB_COLOR5_INFO__BLEND_CLAMP__SHIFT                 = 0x0000000f;
constexpr unsigned int CB_COLOR5_INFO__BLEND_OPT_DISCARD_PIXEL__SHIFT     = 0x00000017;
constexpr unsigned int CB_COLOR5_INFO__BLEND_OPT_DONT_RD_DST__SHIFT       = 0x00000014;
constexpr unsigned int CB_COLOR5_INFO__CMASK_ADDR_TYPE__SHIFT             = 0x0000001d;
constexpr unsigned int CB_COLOR5_INFO__COMPRESSION__SHIFT                 = 0x0000000e;
constexpr unsigned int CB_COLOR5_INFO__COMP_SWAP__SHIFT                   = 0x0000000b;
constexpr unsigned int CB_COLOR5_INFO__DCC_ENABLE__SHIFT                  = 0x0000001c;
constexpr unsigned int CB_COLOR5_INFO__ENDIAN__SHIFT                      = 0x00000000;
constexpr unsigned int CB_COLOR5_INFO__FAST_CLEAR__SHIFT                  = 0x0000000d;
constexpr unsigned int CB_COLOR5_INFO__FMASK_COMPRESSION_DISABLE__SHIFT   = 0x0000001a;
constexpr unsigned int CB_COLOR5_INFO__FMASK_COMPRESS_1FRAG_ONLY__SHIFT   = 0x0000001b;
constexpr unsigned int CB_COLOR5_INFO__FORMAT__SHIFT                      = 0x00000002;
constexpr unsigned int CB_COLOR5_INFO__NUMBER_TYPE__SHIFT                 = 0x00000008;
constexpr unsigned int CB_COLOR5_INFO__ROUND_MODE__SHIFT                  = 0x00000012;
constexpr unsigned int CB_COLOR5_INFO__SIMPLE_FLOAT__SHIFT                = 0x00000011;
constexpr unsigned int CB_COLOR5_VIEW__SLICE_MAX__SHIFT                   = 0x0000000d;
constexpr unsigned int CB_COLOR5_VIEW__SLICE_START__SHIFT                 = 0x00000000;
constexpr unsigned int CB_COLOR6_ATTRIB2__MAX_MIP__SHIFT                  = 0x0000001c;
constexpr unsigned int CB_COLOR6_ATTRIB2__MIP0_HEIGHT__SHIFT              = 0x00000000;
constexpr unsigned int CB_COLOR6_ATTRIB2__MIP0_WIDTH__SHIFT               = 0x0000000e;
constexpr unsigned int CB_COLOR6_BASE_EXT__BASE_256B__SHIFT               = 0x00000000;
constexpr unsigned int CB_COLOR6_BASE__BASE_256B__SHIFT                   = 0x00000000;
constexpr unsigned int CB_COLOR6_CLEAR_WORD0__CLEAR_WORD0__SHIFT          = 0x00000000;
constexpr unsigned int CB_COLOR6_CLEAR_WORD1__CLEAR_WORD1__SHIFT          = 0x00000000;
constexpr unsigned int CB_COLOR6_CMASK_BASE_EXT__BASE_256B__SHIFT         = 0x00000000;
constexpr unsigned int CB_COLOR6_CMASK__BASE_256B__SHIFT                  = 0x00000000;
constexpr unsigned int CB_COLOR6_DCC_BASE_EXT__BASE_256B__SHIFT           = 0x00000000;
constexpr unsigned int CB_COLOR6_DCC_BASE__BASE_256B__SHIFT               = 0x00000000;
constexpr unsigned int CB_COLOR6_DCC_CONTROL__COLOR_TRANSFORM__SHIFT      = 0x00000007;
constexpr unsigned int CB_COLOR6_DCC_CONTROL__INDEPENDENT_64B_BLOCKS__SHIFT = 0x00000009;
constexpr unsigned int CB_COLOR6_DCC_CONTROL__KEY_CLEAR_ENABLE__SHIFT     = 0x00000001;
constexpr unsigned int CB_COLOR6_DCC_CONTROL__LOSSY_ALPHA_PRECISION__SHIFT = 0x0000000e;
constexpr unsigned int CB_COLOR6_DCC_CONTROL__LOSSY_RGB_PRECISION__SHIFT  = 0x0000000a;
constexpr unsigned int CB_COLOR6_DCC_CONTROL__MAX_COMPRESSED_BLOCK_SIZE__SHIFT = 0x00000005;
constexpr unsigned int CB_COLOR6_DCC_CONTROL__MAX_UNCOMPRESSED_BLOCK_SIZE__SHIFT = 0x00000002;
constexpr unsigned int CB_COLOR6_DCC_CONTROL__MIN_COMPRESSED_BLOCK_SIZE__SHIFT = 0x00000004;
constexpr unsigned int CB_COLOR6_DCC_CONTROL__OVERWRITE_COMBINER_DISABLE__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR6_FMASK_BASE_EXT__BASE_256B__SHIFT         = 0x00000000;
constexpr unsigned int CB_COLOR6_FMASK__BASE_256B__SHIFT                  = 0x00000000;
constexpr unsigned int CB_COLOR6_INFO__BLEND_BYPASS__SHIFT                = 0x00000010;
constexpr unsigned int CB_COLOR6_INFO__BLEND_CLAMP__SHIFT                 = 0x0000000f;
constexpr unsigned int CB_COLOR6_INFO__BLEND_OPT_DISCARD_PIXEL__SHIFT     = 0x00000017;
constexpr unsigned int CB_COLOR6_INFO__BLEND_OPT_DONT_RD_DST__SHIFT       = 0x00000014;
constexpr unsigned int CB_COLOR6_INFO__CMASK_ADDR_TYPE__SHIFT             = 0x0000001d;
constexpr unsigned int CB_COLOR6_INFO__COMPRESSION__SHIFT                 = 0x0000000e;
constexpr unsigned int CB_COLOR6_INFO__COMP_SWAP__SHIFT                   = 0x0000000b;
constexpr unsigned int CB_COLOR6_INFO__DCC_ENABLE__SHIFT                  = 0x0000001c;
constexpr unsigned int CB_COLOR6_INFO__ENDIAN__SHIFT                      = 0x00000000;
constexpr unsigned int CB_COLOR6_INFO__FAST_CLEAR__SHIFT                  = 0x0000000d;
constexpr unsigned int CB_COLOR6_INFO__FMASK_COMPRESSION_DISABLE__SHIFT   = 0x0000001a;
constexpr unsigned int CB_COLOR6_INFO__FMASK_COMPRESS_1FRAG_ONLY__SHIFT   = 0x0000001b;
constexpr unsigned int CB_COLOR6_INFO__FORMAT__SHIFT                      = 0x00000002;
constexpr unsigned int CB_COLOR6_INFO__NUMBER_TYPE__SHIFT                 = 0x00000008;
constexpr unsigned int CB_COLOR6_INFO__ROUND_MODE__SHIFT                  = 0x00000012;
constexpr unsigned int CB_COLOR6_INFO__SIMPLE_FLOAT__SHIFT                = 0x00000011;
constexpr unsigned int CB_COLOR6_VIEW__SLICE_MAX__SHIFT                   = 0x0000000d;
constexpr unsigned int CB_COLOR6_VIEW__SLICE_START__SHIFT                 = 0x00000000;
constexpr unsigned int CB_COLOR7_ATTRIB2__MAX_MIP__SHIFT                  = 0x0000001c;
constexpr unsigned int CB_COLOR7_ATTRIB2__MIP0_HEIGHT__SHIFT              = 0x00000000;
constexpr unsigned int CB_COLOR7_ATTRIB2__MIP0_WIDTH__SHIFT               = 0x0000000e;
constexpr unsigned int CB_COLOR7_BASE_EXT__BASE_256B__SHIFT               = 0x00000000;
constexpr unsigned int CB_COLOR7_BASE__BASE_256B__SHIFT                   = 0x00000000;
constexpr unsigned int CB_COLOR7_CLEAR_WORD0__CLEAR_WORD0__SHIFT          = 0x00000000;
constexpr unsigned int CB_COLOR7_CLEAR_WORD1__CLEAR_WORD1__SHIFT          = 0x00000000;
constexpr unsigned int CB_COLOR7_CMASK_BASE_EXT__BASE_256B__SHIFT         = 0x00000000;
constexpr unsigned int CB_COLOR7_CMASK__BASE_256B__SHIFT                  = 0x00000000;
constexpr unsigned int CB_COLOR7_DCC_BASE_EXT__BASE_256B__SHIFT           = 0x00000000;
constexpr unsigned int CB_COLOR7_DCC_BASE__BASE_256B__SHIFT               = 0x00000000;
constexpr unsigned int CB_COLOR7_DCC_CONTROL__COLOR_TRANSFORM__SHIFT      = 0x00000007;
constexpr unsigned int CB_COLOR7_DCC_CONTROL__INDEPENDENT_64B_BLOCKS__SHIFT = 0x00000009;
constexpr unsigned int CB_COLOR7_DCC_CONTROL__KEY_CLEAR_ENABLE__SHIFT     = 0x00000001;
constexpr unsigned int CB_COLOR7_DCC_CONTROL__LOSSY_ALPHA_PRECISION__SHIFT = 0x0000000e;
constexpr unsigned int CB_COLOR7_DCC_CONTROL__LOSSY_RGB_PRECISION__SHIFT  = 0x0000000a;
constexpr unsigned int CB_COLOR7_DCC_CONTROL__MAX_COMPRESSED_BLOCK_SIZE__SHIFT = 0x00000005;
constexpr unsigned int CB_COLOR7_DCC_CONTROL__MAX_UNCOMPRESSED_BLOCK_SIZE__SHIFT = 0x00000002;
constexpr unsigned int CB_COLOR7_DCC_CONTROL__MIN_COMPRESSED_BLOCK_SIZE__SHIFT = 0x00000004;
constexpr unsigned int CB_COLOR7_DCC_CONTROL__OVERWRITE_COMBINER_DISABLE__SHIFT = 0x00000000;
constexpr unsigned int CB_COLOR7_FMASK_BASE_EXT__BASE_256B__SHIFT         = 0x00000000;
constexpr unsigned int CB_COLOR7_FMASK__BASE_256B__SHIFT                  = 0x00000000;
constexpr unsigned int CB_COLOR7_INFO__BLEND_BYPASS__SHIFT                = 0x00000010;
constexpr unsigned int CB_COLOR7_INFO__BLEND_CLAMP__SHIFT                 = 0x0000000f;
constexpr unsigned int CB_COLOR7_INFO__BLEND_OPT_DISCARD_PIXEL__SHIFT     = 0x00000017;
constexpr unsigned int CB_COLOR7_INFO__BLEND_OPT_DONT_RD_DST__SHIFT       = 0x00000014;
constexpr unsigned int CB_COLOR7_INFO__CMASK_ADDR_TYPE__SHIFT             = 0x0000001d;
constexpr unsigned int CB_COLOR7_INFO__COMPRESSION__SHIFT                 = 0x0000000e;
constexpr unsigned int CB_COLOR7_INFO__COMP_SWAP__SHIFT                   = 0x0000000b;
constexpr unsigned int CB_COLOR7_INFO__DCC_ENABLE__SHIFT                  = 0x0000001c;
constexpr unsigned int CB_COLOR7_INFO__ENDIAN__SHIFT                      = 0x00000000;
constexpr unsigned int CB_COLOR7_INFO__FAST_CLEAR__SHIFT                  = 0x0000000d;
constexpr unsigned int CB_COLOR7_INFO__FMASK_COMPRESSION_DISABLE__SHIFT   = 0x0000001a;
constexpr unsigned int CB_COLOR7_INFO__FMASK_COMPRESS_1FRAG_ONLY__SHIFT   = 0x0000001b;
constexpr unsigned int CB_COLOR7_INFO__FORMAT__SHIFT                      = 0x00000002;
constexpr unsigned int CB_COLOR7_INFO__NUMBER_TYPE__SHIFT                 = 0x00000008;
constexpr unsigned int CB_COLOR7_INFO__ROUND_MODE__SHIFT                  = 0x00000012;
constexpr unsigned int CB_COLOR7_INFO__SIMPLE_FLOAT__SHIFT                = 0x00000011;
constexpr unsigned int CB_COLOR7_VIEW__SLICE_MAX__SHIFT                   = 0x0000000d;
constexpr unsigned int CB_COLOR7_VIEW__SLICE_START__SHIFT                 = 0x00000000;
constexpr unsigned int CB_COLOR_CONTROL__DEGAMMA_ENABLE__SHIFT            = 0x00000003;
constexpr unsigned int CB_COLOR_CONTROL__DISABLE_DUAL_QUAD__SHIFT         = 0x00000000;
constexpr unsigned int CB_COLOR_CONTROL__MODE__SHIFT                      = 0x00000004;
constexpr unsigned int CB_COLOR_CONTROL__ROP3__SHIFT                      = 0x00000010;
constexpr unsigned int CB_DCC_CONFIG__FC_RDLAT_KEYID_FIFO_DEPTH__SHIFT    = 0x00000008;
constexpr unsigned int CB_DCC_CONFIG__OVERWRITE_COMBINER_CC_POP_DISABLE__SHIFT = 0x00000006;
constexpr unsigned int CB_DCC_CONFIG__OVERWRITE_COMBINER_DEPTH__SHIFT     = 0x00000000;
constexpr unsigned int CB_DCC_CONFIG__OVERWRITE_COMBINER_DISABLE__SHIFT   = 0x00000005;
constexpr unsigned int CB_DCC_CONFIG__READ_RETURN_SKID_FIFO_DEPTH__SHIFT  = 0x00000010;
constexpr unsigned int CB_DCC_CONTROL__OVERWRITE_COMBINER_DISABLE__SHIFT  = 0x00000000;
constexpr unsigned int CB_DCC_CONTROL__OVERWRITE_COMBINER_WATERMARK__SHIFT = 0x00000002;
constexpr unsigned int CB_HW_CONTROL_1__CM_CACHE_NUM_TAGS__SHIFT          = 0x00000000;
constexpr unsigned int CB_HW_CONTROL_1__FC_CACHE_NUM_TAGS__SHIFT          = 0x00000005;
constexpr unsigned int CB_HW_CONTROL_2__CC_EVEN_ODD_FIFO_DEPTH__SHIFT     = 0x00000000;
constexpr unsigned int CB_HW_CONTROL_2__DRR_ASSUMED_FIFO_DEPTH_DIV8__SHIFT = 0x00000018;
constexpr unsigned int CB_HW_CONTROL_2__FC_RDLAT_QUAD_FIFO_DEPTH__SHIFT   = 0x0000000f;
constexpr unsigned int CB_HW_CONTROL_2__FC_RDLAT_TILE_FIFO_DEPTH__SHIFT   = 0x00000008;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_BLENDER_CLOCK_GATING__SHIFT = 0x0000001a;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_CC_CACHE_OVWR_STATUS_ACCUM__SHIFT = 0x00000005;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_CC_CACHE_PANIC_GATING__SHIFT = 0x00000007;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_CMASK_LAST_QUAD_INSERTION__SHIFT = 0x0000000b;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_EARLY_WRACKS_CC__SHIFT    = 0x00000011;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_EARLY_WRACKS_CM__SHIFT    = 0x00000014;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_EARLY_WRACKS_DC__SHIFT    = 0x00000013;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_EARLY_WRACKS_FC__SHIFT    = 0x00000012;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_FAST_CLEAR_FETCH_OPT__SHIFT = 0x00000002;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_NACK_COLOR_RD_WR_OPT__SHIFT = 0x00000019;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_NACK_PROCESSING_CC__SHIFT = 0x00000015;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_NACK_PROCESSING_CM__SHIFT = 0x00000018;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_NACK_PROCESSING_DC__SHIFT = 0x00000017;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_NACK_PROCESSING_FC__SHIFT = 0x00000016;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_OC_FIXES_OF_BUG_522542__SHIFT = 0x0000000e;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_OVERWRITE_COMBINER_CAM_CLR__SHIFT = 0x00000004;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_QUAD_MARKER_DROP_STOP__SHIFT = 0x00000003;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_ROP3_FIXES_OF_BUG_511967__SHIFT = 0x0000000c;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_ROP3_FIXES_OF_BUG_520657__SHIFT = 0x0000000d;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_SHADER_BLEND_OPTS__SHIFT  = 0x0000000a;
constexpr unsigned int CB_HW_CONTROL_3__DISABLE_SLOW_MODE_EMPTY_HALF_QUAD_KILL__SHIFT = 0x00000000;
constexpr unsigned int CB_HW_CONTROL_3__FORCE_RMI_CLKEN_HIGH__SHIFT       = 0x00000010;
constexpr unsigned int CB_HW_CONTROL_3__FORCE_RMI_LAST_HIGH__SHIFT        = 0x0000000f;
constexpr unsigned int CB_HW_CONTROL_3__RAM_ADDRESS_CONFLICTS_DISALLOWED__SHIFT = 0x00000001;
constexpr unsigned int CB_HW_CONTROL_3__SPLIT_ALL_FAST_MODE_TRANSFERS__SHIFT = 0x00000009;
constexpr unsigned int CB_HW_CONTROL__DISABLE_BLEND_OPT_BYPASS__SHIFT     = 0x00000019;
constexpr unsigned int CB_HW_CONTROL__DISABLE_BLEND_OPT_DISCARD_PIXEL__SHIFT = 0x0000001a;
constexpr unsigned int CB_HW_CONTROL__DISABLE_BLEND_OPT_DONT_RD_DST__SHIFT = 0x00000018;
constexpr unsigned int CB_HW_CONTROL__DISABLE_BLEND_OPT_RESULT_EQ_DEST__SHIFT = 0x00000015;
constexpr unsigned int CB_HW_CONTROL__DISABLE_BLEND_OPT_WHEN_DISABLED_SRCALPHA_IS_USED__SHIFT = 0x0000001b;
constexpr unsigned int CB_HW_CONTROL__DISABLE_CC_IB_SERIALIZER_STATE_OPT__SHIFT = 0x0000001e;
constexpr unsigned int CB_HW_CONTROL__DISABLE_FULL_WRITE_MASK__SHIFT      = 0x00000016;
constexpr unsigned int CB_HW_CONTROL__DISABLE_PIXEL_IN_QUAD_FIX_FOR_LINEAR_SURFACE__SHIFT = 0x0000001f;
constexpr unsigned int CB_HW_CONTROL__DISABLE_RESOLVE_OPT_FOR_SINGLE_FRAG__SHIFT = 0x00000017;
constexpr unsigned int CB_HW_CONTROL__FORCE_ALWAYS_TOGGLE__SHIFT          = 0x00000014;
constexpr unsigned int CB_HW_CONTROL__FORCE_NEEDS_DST__SHIFT              = 0x00000013;
constexpr unsigned int CB_HW_CONTROL__PRIORITIZE_FC_EVICT_OVER_FOP_RD_ON_BANK_CONFLICT__SHIFT = 0x0000001d;
constexpr unsigned int CB_HW_CONTROL__PRIORITIZE_FC_WR_OVER_FC_RD_ON_CMASK_CONFLICT__SHIFT = 0x0000001c;
constexpr unsigned int CB_HW_MEM_ARBITER_RD__BREAK_GROUP_AGE__SHIFT       = 0x00000006;
constexpr unsigned int CB_HW_MEM_ARBITER_RD__IGNORE_URGENT_AGE__SHIFT     = 0x00000002;
constexpr unsigned int CB_HW_MEM_ARBITER_RD__MODE__SHIFT                  = 0x00000000;
constexpr unsigned int CB_HW_MEM_ARBITER_RD__SCALE_AGE__SHIFT             = 0x00000017;
constexpr unsigned int CB_HW_MEM_ARBITER_RD__SCALE_WEIGHT__SHIFT          = 0x0000001a;
constexpr unsigned int CB_HW_MEM_ARBITER_RD__SEND_LASTS_WITHIN_GROUPS__SHIFT = 0x0000001d;
constexpr unsigned int CB_HW_MEM_ARBITER_RD__WEIGHT_CC__SHIFT             = 0x0000000a;
constexpr unsigned int CB_HW_MEM_ARBITER_RD__WEIGHT_CM__SHIFT             = 0x0000000e;
constexpr unsigned int CB_HW_MEM_ARBITER_RD__WEIGHT_DC__SHIFT             = 0x00000010;
constexpr unsigned int CB_HW_MEM_ARBITER_RD__WEIGHT_DECAY_NOREQS__SHIFT   = 0x00000014;
constexpr unsigned int CB_HW_MEM_ARBITER_RD__WEIGHT_DECAY_REQS__SHIFT     = 0x00000012;
constexpr unsigned int CB_HW_MEM_ARBITER_RD__WEIGHT_FC__SHIFT             = 0x0000000c;
constexpr unsigned int CB_HW_MEM_ARBITER_RD__WEIGHT_IGNORE_NUM_TIDS__SHIFT = 0x00000016;
constexpr unsigned int CB_HW_MEM_ARBITER_WR__BREAK_GROUP_AGE__SHIFT       = 0x00000006;
constexpr unsigned int CB_HW_MEM_ARBITER_WR__IGNORE_URGENT_AGE__SHIFT     = 0x00000002;
constexpr unsigned int CB_HW_MEM_ARBITER_WR__MODE__SHIFT                  = 0x00000000;
constexpr unsigned int CB_HW_MEM_ARBITER_WR__SCALE_AGE__SHIFT             = 0x00000017;
constexpr unsigned int CB_HW_MEM_ARBITER_WR__SCALE_WEIGHT__SHIFT          = 0x0000001a;
constexpr unsigned int CB_HW_MEM_ARBITER_WR__SEND_LASTS_WITHIN_GROUPS__SHIFT = 0x0000001d;
constexpr unsigned int CB_HW_MEM_ARBITER_WR__WEIGHT_CC__SHIFT             = 0x0000000a;
constexpr unsigned int CB_HW_MEM_ARBITER_WR__WEIGHT_CM__SHIFT             = 0x0000000e;
constexpr unsigned int CB_HW_MEM_ARBITER_WR__WEIGHT_DC__SHIFT             = 0x00000010;
constexpr unsigned int CB_HW_MEM_ARBITER_WR__WEIGHT_DECAY_NOREQS__SHIFT   = 0x00000014;
constexpr unsigned int CB_HW_MEM_ARBITER_WR__WEIGHT_DECAY_REQS__SHIFT     = 0x00000012;
constexpr unsigned int CB_HW_MEM_ARBITER_WR__WEIGHT_FC__SHIFT             = 0x0000000c;
constexpr unsigned int CB_HW_MEM_ARBITER_WR__WEIGHT_IGNORE_BYTE_MASK__SHIFT = 0x00000016;
constexpr unsigned int CB_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
constexpr unsigned int CB_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int CB_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT         = 0x0000001c;
constexpr unsigned int CB_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT         = 0x00000018;
constexpr unsigned int CB_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT          = 0x00000000;
constexpr unsigned int CB_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT          = 0x0000000a;
constexpr unsigned int CB_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT           = 0x00000014;
constexpr unsigned int CB_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT          = 0x00000018;
constexpr unsigned int CB_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int CB_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT           = 0x0000000a;
constexpr unsigned int CB_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int CB_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
constexpr unsigned int CB_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int CB_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int CB_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int CB_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
constexpr unsigned int CB_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int CB_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int CB_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int CB_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
constexpr unsigned int CB_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int CB_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int CB_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int CB_PERFCOUNTER_FILTER__CLEAR_FILTER_ENABLE__SHIFT  = 0x0000000a;
constexpr unsigned int CB_PERFCOUNTER_FILTER__CLEAR_FILTER_SEL__SHIFT     = 0x0000000b;
constexpr unsigned int CB_PERFCOUNTER_FILTER__FORMAT_FILTER_ENABLE__SHIFT = 0x00000004;
constexpr unsigned int CB_PERFCOUNTER_FILTER__FORMAT_FILTER_SEL__SHIFT    = 0x00000005;
constexpr unsigned int CB_PERFCOUNTER_FILTER__MRT_FILTER_ENABLE__SHIFT    = 0x0000000c;
constexpr unsigned int CB_PERFCOUNTER_FILTER__MRT_FILTER_SEL__SHIFT       = 0x0000000d;
constexpr unsigned int CB_PERFCOUNTER_FILTER__NUM_FRAGMENTS_FILTER_ENABLE__SHIFT = 0x00000015;
constexpr unsigned int CB_PERFCOUNTER_FILTER__NUM_FRAGMENTS_FILTER_SEL__SHIFT = 0x00000016;
constexpr unsigned int CB_PERFCOUNTER_FILTER__NUM_SAMPLES_FILTER_ENABLE__SHIFT = 0x00000011;
constexpr unsigned int CB_PERFCOUNTER_FILTER__NUM_SAMPLES_FILTER_SEL__SHIFT = 0x00000012;
constexpr unsigned int CB_PERFCOUNTER_FILTER__OP_FILTER_ENABLE__SHIFT     = 0x00000000;
constexpr unsigned int CB_PERFCOUNTER_FILTER__OP_FILTER_SEL__SHIFT        = 0x00000001;
constexpr unsigned int CB_SHADER_MASK__OUTPUT0_ENABLE__SHIFT              = 0x00000000;
constexpr unsigned int CB_SHADER_MASK__OUTPUT1_ENABLE__SHIFT              = 0x00000004;
constexpr unsigned int CB_SHADER_MASK__OUTPUT2_ENABLE__SHIFT              = 0x00000008;
constexpr unsigned int CB_SHADER_MASK__OUTPUT3_ENABLE__SHIFT              = 0x0000000c;
constexpr unsigned int CB_SHADER_MASK__OUTPUT4_ENABLE__SHIFT              = 0x00000010;
constexpr unsigned int CB_SHADER_MASK__OUTPUT5_ENABLE__SHIFT              = 0x00000014;
constexpr unsigned int CB_SHADER_MASK__OUTPUT6_ENABLE__SHIFT              = 0x00000018;
constexpr unsigned int CB_SHADER_MASK__OUTPUT7_ENABLE__SHIFT              = 0x0000001c;
constexpr unsigned int CB_TARGET_MASK__TARGET0_ENABLE__SHIFT              = 0x00000000;
constexpr unsigned int CB_TARGET_MASK__TARGET1_ENABLE__SHIFT              = 0x00000004;
constexpr unsigned int CB_TARGET_MASK__TARGET2_ENABLE__SHIFT              = 0x00000008;
constexpr unsigned int CB_TARGET_MASK__TARGET3_ENABLE__SHIFT              = 0x0000000c;
constexpr unsigned int CB_TARGET_MASK__TARGET4_ENABLE__SHIFT              = 0x00000010;
constexpr unsigned int CB_TARGET_MASK__TARGET5_ENABLE__SHIFT              = 0x00000014;
constexpr unsigned int CB_TARGET_MASK__TARGET6_ENABLE__SHIFT              = 0x00000018;
constexpr unsigned int CB_TARGET_MASK__TARGET7_ENABLE__SHIFT              = 0x0000001c;
constexpr unsigned int COHER_DEST_BASE_0__DEST_BASE_256B__SHIFT           = 0x00000000;
constexpr unsigned int COHER_DEST_BASE_1__DEST_BASE_256B__SHIFT           = 0x00000000;
constexpr unsigned int COHER_DEST_BASE_2__DEST_BASE_256B__SHIFT           = 0x00000000;
constexpr unsigned int COHER_DEST_BASE_3__DEST_BASE_256B__SHIFT           = 0x00000000;
constexpr unsigned int COHER_DEST_BASE_HI_0__DEST_BASE_HI_256B__SHIFT     = 0x00000000;
constexpr unsigned int COHER_DEST_BASE_HI_1__DEST_BASE_HI_256B__SHIFT     = 0x00000000;
constexpr unsigned int COHER_DEST_BASE_HI_2__DEST_BASE_HI_256B__SHIFT     = 0x00000000;
constexpr unsigned int COHER_DEST_BASE_HI_3__DEST_BASE_HI_256B__SHIFT     = 0x00000000;
constexpr unsigned int COMPUTE_DIM_X__SIZE__SHIFT                         = 0x00000000;
constexpr unsigned int COMPUTE_DIM_Y__SIZE__SHIFT                         = 0x00000000;
constexpr unsigned int COMPUTE_DIM_Z__SIZE__SHIFT                         = 0x00000000;
constexpr unsigned int COMPUTE_DISPATCH_ID__DISPATCH_ID__SHIFT            = 0x00000000;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__COMPUTE_SHADER_EN__SHIFT = 0x00000000;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__FORCE_START_AT_000__SHIFT = 0x00000002;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__ORDERED_APPEND_ENBL__SHIFT = 0x00000003;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__ORDERED_APPEND_MODE__SHIFT = 0x00000004;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__ORDER_MODE__SHIFT      = 0x00000006;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__PARTIAL_TG_EN__SHIFT   = 0x00000001;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__RESERVED__SHIFT        = 0x0000000c;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__RESTORE__SHIFT         = 0x0000000e;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__SCALAR_L1_INV_VOL__SHIFT = 0x0000000a;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__USE_THREAD_DIMENSIONS__SHIFT = 0x00000005;
constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__VECTOR_L1_INV_VOL__SHIFT = 0x0000000b;
constexpr unsigned int COMPUTE_DISPATCH_PKT_ADDR_HI__DATA__SHIFT          = 0x00000000;
constexpr unsigned int COMPUTE_DISPATCH_PKT_ADDR_LO__DATA__SHIFT          = 0x00000000;
constexpr unsigned int COMPUTE_DISPATCH_SCRATCH_BASE_HI__DATA__SHIFT      = 0x00000000;
constexpr unsigned int COMPUTE_DISPATCH_SCRATCH_BASE_LO__DATA__SHIFT      = 0x00000000;
constexpr unsigned int COMPUTE_MISC_RESERVED__RESERVED2__SHIFT            = 0x00000002;
constexpr unsigned int COMPUTE_MISC_RESERVED__RESERVED3__SHIFT            = 0x00000003;
constexpr unsigned int COMPUTE_MISC_RESERVED__RESERVED4__SHIFT            = 0x00000004;
constexpr unsigned int COMPUTE_MISC_RESERVED__SEND_SEID__SHIFT            = 0x00000000;
constexpr unsigned int COMPUTE_MISC_RESERVED__WAVE_ID_BASE__SHIFT         = 0x00000005;
constexpr unsigned int COMPUTE_NOWHERE__DATA__SHIFT                       = 0x00000000;
constexpr unsigned int COMPUTE_NUM_THREAD_X__NUM_THREAD_FULL__SHIFT       = 0x00000000;
constexpr unsigned int COMPUTE_NUM_THREAD_X__NUM_THREAD_PARTIAL__SHIFT    = 0x00000010;
constexpr unsigned int COMPUTE_NUM_THREAD_Y__NUM_THREAD_FULL__SHIFT       = 0x00000000;
constexpr unsigned int COMPUTE_NUM_THREAD_Y__NUM_THREAD_PARTIAL__SHIFT    = 0x00000010;
constexpr unsigned int COMPUTE_NUM_THREAD_Z__NUM_THREAD_FULL__SHIFT       = 0x00000000;
constexpr unsigned int COMPUTE_NUM_THREAD_Z__NUM_THREAD_PARTIAL__SHIFT    = 0x00000010;
constexpr unsigned int COMPUTE_PERFCOUNT_ENABLE__PERFCOUNT_ENABLE__SHIFT  = 0x00000000;
constexpr unsigned int COMPUTE_PGM_HI__DATA__SHIFT                        = 0x00000000;
constexpr unsigned int COMPUTE_PGM_LO__DATA__SHIFT                        = 0x00000000;
constexpr unsigned int COMPUTE_PGM_RSRC1__BULKY__SHIFT                    = 0x00000018;
constexpr unsigned int COMPUTE_PGM_RSRC1__CDBG_USER__SHIFT                = 0x00000019;
constexpr unsigned int COMPUTE_PGM_RSRC1__DEBUG_MODE__SHIFT               = 0x00000016;
constexpr unsigned int COMPUTE_PGM_RSRC1__DX10_CLAMP__SHIFT               = 0x00000015;
constexpr unsigned int COMPUTE_PGM_RSRC1__FLOAT_MODE__SHIFT               = 0x0000000c;
constexpr unsigned int COMPUTE_PGM_RSRC1__FP16_OVFL__SHIFT                = 0x0000001a;
constexpr unsigned int COMPUTE_PGM_RSRC1__IEEE_MODE__SHIFT                = 0x00000017;
constexpr unsigned int COMPUTE_PGM_RSRC1__PRIORITY__SHIFT                 = 0x0000000a;
constexpr unsigned int COMPUTE_PGM_RSRC1__PRIV__SHIFT                     = 0x00000014;
constexpr unsigned int COMPUTE_PGM_RSRC1__SGPRS__SHIFT                    = 0x00000006;
constexpr unsigned int COMPUTE_PGM_RSRC1__VGPRS__SHIFT                    = 0x00000000;
constexpr unsigned int COMPUTE_PGM_RSRC2__EXCP_EN_MSB__SHIFT              = 0x0000000d;
constexpr unsigned int COMPUTE_PGM_RSRC2__EXCP_EN__SHIFT                  = 0x00000018;
constexpr unsigned int COMPUTE_PGM_RSRC2__LDS_SIZE__SHIFT                 = 0x0000000f;
constexpr unsigned int COMPUTE_PGM_RSRC2__SCRATCH_EN__SHIFT               = 0x00000000;
constexpr unsigned int COMPUTE_PGM_RSRC2__TGID_X_EN__SHIFT                = 0x00000007;
constexpr unsigned int COMPUTE_PGM_RSRC2__TGID_Y_EN__SHIFT                = 0x00000008;
constexpr unsigned int COMPUTE_PGM_RSRC2__TGID_Z_EN__SHIFT                = 0x00000009;
constexpr unsigned int COMPUTE_PGM_RSRC2__TG_SIZE_EN__SHIFT               = 0x0000000a;
constexpr unsigned int COMPUTE_PGM_RSRC2__TIDIG_COMP_CNT__SHIFT           = 0x0000000b;
constexpr unsigned int COMPUTE_PGM_RSRC2__TRAP_PRESENT__SHIFT             = 0x00000006;
constexpr unsigned int COMPUTE_PGM_RSRC2__USER_SGPR__SHIFT                = 0x00000001;
constexpr unsigned int COMPUTE_PIPELINESTAT_ENABLE__PIPELINESTAT_ENABLE__SHIFT = 0x00000000;
constexpr unsigned int COMPUTE_RELAUNCH__IS_EVENT__SHIFT                  = 0x0000001e;
constexpr unsigned int COMPUTE_RELAUNCH__IS_STATE__SHIFT                  = 0x0000001f;
constexpr unsigned int COMPUTE_RELAUNCH__PAYLOAD__SHIFT                   = 0x00000000;
constexpr unsigned int COMPUTE_RESOURCE_LIMITS__CU_GROUP_COUNT__SHIFT     = 0x00000018;
constexpr unsigned int COMPUTE_RESOURCE_LIMITS__FORCE_SIMD_DIST__SHIFT    = 0x00000017;
constexpr unsigned int COMPUTE_RESOURCE_LIMITS__LOCK_THRESHOLD__SHIFT     = 0x00000010;
constexpr unsigned int COMPUTE_RESOURCE_LIMITS__SIMD_DEST_CNTL__SHIFT     = 0x00000016;
constexpr unsigned int COMPUTE_RESOURCE_LIMITS__TG_PER_CU__SHIFT          = 0x0000000c;
constexpr unsigned int COMPUTE_RESOURCE_LIMITS__WAVES_PER_SH__SHIFT       = 0x00000000;
constexpr unsigned int COMPUTE_RESTART_X__RESTART__SHIFT                  = 0x00000000;
constexpr unsigned int COMPUTE_RESTART_Y__RESTART__SHIFT                  = 0x00000000;
constexpr unsigned int COMPUTE_RESTART_Z__RESTART__SHIFT                  = 0x00000000;
constexpr unsigned int COMPUTE_START_X__START__SHIFT                      = 0x00000000;
constexpr unsigned int COMPUTE_START_Y__START__SHIFT                      = 0x00000000;
constexpr unsigned int COMPUTE_START_Z__START__SHIFT                      = 0x00000000;
constexpr unsigned int COMPUTE_THREADGROUP_ID__THREADGROUP_ID__SHIFT      = 0x00000000;
constexpr unsigned int COMPUTE_THREAD_TRACE_ENABLE__THREAD_TRACE_ENABLE__SHIFT = 0x00000000;
constexpr unsigned int COMPUTE_TMPRING_SIZE__WAVESIZE__SHIFT              = 0x0000000c;
constexpr unsigned int COMPUTE_TMPRING_SIZE__WAVES__SHIFT                 = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_0__DATA__SHIFT                   = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_1__DATA__SHIFT                   = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_2__DATA__SHIFT                   = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_3__DATA__SHIFT                   = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_4__DATA__SHIFT                   = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_5__DATA__SHIFT                   = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_6__DATA__SHIFT                   = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_7__DATA__SHIFT                   = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_8__DATA__SHIFT                   = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_9__DATA__SHIFT                   = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_10__DATA__SHIFT                  = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_11__DATA__SHIFT                  = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_12__DATA__SHIFT                  = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_13__DATA__SHIFT                  = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_14__DATA__SHIFT                  = 0x00000000;
constexpr unsigned int COMPUTE_USER_DATA_15__DATA__SHIFT                  = 0x00000000;
constexpr unsigned int COMPUTE_VMID__DATA__SHIFT                          = 0x00000000;
constexpr unsigned int COMPUTE_WAVE_RESTORE_ADDR_HI__ADDR__SHIFT          = 0x00000000;
constexpr unsigned int COMPUTE_WAVE_RESTORE_ADDR_LO__ADDR__SHIFT          = 0x00000000;
constexpr unsigned int CPC_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int CPC_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int CPC_PERFCOUNTER0_SELECT1__CNTR_MODE2__SHIFT        = 0x0000001c;
constexpr unsigned int CPC_PERFCOUNTER0_SELECT1__CNTR_MODE3__SHIFT        = 0x00000018;
constexpr unsigned int CPC_PERFCOUNTER0_SELECT__CNTR_MODE0__SHIFT         = 0x0000001c;
constexpr unsigned int CPC_PERFCOUNTER0_SELECT__CNTR_MODE1__SHIFT         = 0x00000018;
constexpr unsigned int CPC_PERFCOUNTER0_SELECT__SPM_MODE__SHIFT           = 0x00000014;
constexpr unsigned int CPC_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int CPC_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int CPC_PERFCOUNTER1_SELECT__CNTR_MODE0__SHIFT         = 0x0000001c;
constexpr unsigned int CPC_PERFCOUNTER1_SELECT__CNTR_MODE1__SHIFT         = 0x00000018;
constexpr unsigned int CPC_PERFCOUNTER1_SELECT__SPM_MODE__SHIFT           = 0x00000014;
constexpr unsigned int CPF_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int CPF_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int CPF_PERFCOUNTER0_SELECT1__CNTR_MODE2__SHIFT        = 0x0000001c;
constexpr unsigned int CPF_PERFCOUNTER0_SELECT1__CNTR_MODE3__SHIFT        = 0x00000018;
constexpr unsigned int CPF_PERFCOUNTER0_SELECT__CNTR_MODE0__SHIFT         = 0x0000001c;
constexpr unsigned int CPF_PERFCOUNTER0_SELECT__CNTR_MODE1__SHIFT         = 0x00000018;
constexpr unsigned int CPF_PERFCOUNTER0_SELECT__SPM_MODE__SHIFT           = 0x00000014;
constexpr unsigned int CPF_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int CPF_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int CPF_PERFCOUNTER1_SELECT__CNTR_MODE0__SHIFT         = 0x0000001c;
constexpr unsigned int CPF_PERFCOUNTER1_SELECT__CNTR_MODE1__SHIFT         = 0x00000018;
constexpr unsigned int CPF_PERFCOUNTER1_SELECT__SPM_MODE__SHIFT           = 0x00000014;
constexpr unsigned int CPG_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int CPG_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int CPG_PERFCOUNTER0_SELECT1__CNTR_MODE2__SHIFT        = 0x0000001c;
constexpr unsigned int CPG_PERFCOUNTER0_SELECT1__CNTR_MODE3__SHIFT        = 0x00000018;
constexpr unsigned int CPG_PERFCOUNTER0_SELECT__CNTR_MODE0__SHIFT         = 0x0000001c;
constexpr unsigned int CPG_PERFCOUNTER0_SELECT__CNTR_MODE1__SHIFT         = 0x00000018;
constexpr unsigned int CPG_PERFCOUNTER0_SELECT__SPM_MODE__SHIFT           = 0x00000014;
constexpr unsigned int CPG_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int CPG_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int CPG_PERFCOUNTER1_SELECT__CNTR_MODE0__SHIFT         = 0x0000001c;
constexpr unsigned int CPG_PERFCOUNTER1_SELECT__CNTR_MODE1__SHIFT         = 0x00000018;
constexpr unsigned int CPG_PERFCOUNTER1_SELECT__SPM_MODE__SHIFT           = 0x00000014;
constexpr unsigned int CP_COHER_BASE_HI__COHER_BASE_HI_256B__SHIFT        = 0x00000000;
constexpr unsigned int CP_COHER_BASE__COHER_BASE_256B__SHIFT              = 0x00000000;
constexpr unsigned int CP_COHER_CNTL__CB_ACTION_ENA__SHIFT                = 0x00000019;
constexpr unsigned int CP_COHER_CNTL__DB_ACTION_ENA__SHIFT                = 0x0000001a;
constexpr unsigned int CP_COHER_CNTL__SH_ICACHE_ACTION_ENA__SHIFT         = 0x0000001d;
constexpr unsigned int CP_COHER_CNTL__SH_KCACHE_ACTION_ENA__SHIFT         = 0x0000001b;
constexpr unsigned int CP_COHER_CNTL__SH_KCACHE_VOL_ACTION_ENA__SHIFT     = 0x0000001c;
constexpr unsigned int CP_COHER_CNTL__SH_KCACHE_WB_ACTION_ENA__SHIFT      = 0x0000001e;
constexpr unsigned int CP_COHER_CNTL__TCL1_ACTION_ENA__SHIFT              = 0x00000016;
constexpr unsigned int CP_COHER_CNTL__TCL1_VOL_ACTION_ENA__SHIFT          = 0x0000000f;
constexpr unsigned int CP_COHER_CNTL__TC_ACTION_ENA__SHIFT                = 0x00000017;
constexpr unsigned int CP_COHER_CNTL__TC_INV_METADATA_ACTION_ENA__SHIFT   = 0x00000005;
constexpr unsigned int CP_COHER_CNTL__TC_NC_ACTION_ENA__SHIFT             = 0x00000003;
constexpr unsigned int CP_COHER_CNTL__TC_WB_ACTION_ENA__SHIFT             = 0x00000012;
constexpr unsigned int CP_COHER_CNTL__TC_WC_ACTION_ENA__SHIFT             = 0x00000004;
constexpr unsigned int CP_COHER_SIZE_HI__COHER_SIZE_HI_256B__SHIFT        = 0x00000000;
constexpr unsigned int CP_COHER_SIZE__COHER_SIZE_256B__SHIFT              = 0x00000000;
constexpr unsigned int CP_COHER_START_DELAY__START_DELAY_COUNT__SHIFT     = 0x00000000;
constexpr unsigned int CP_COHER_STATUS__MEID__SHIFT                       = 0x00000018;
constexpr unsigned int CP_COHER_STATUS__STATUS__SHIFT                     = 0x0000001f;
constexpr unsigned int CP_ME_COHER_BASE_HI__COHER_BASE_HI_256B__SHIFT     = 0x00000000;
constexpr unsigned int CP_ME_COHER_BASE__COHER_BASE_256B__SHIFT           = 0x00000000;
constexpr unsigned int CP_ME_COHER_CNTL__CB0_DEST_BASE_ENA__SHIFT         = 0x00000006;
constexpr unsigned int CP_ME_COHER_CNTL__CB1_DEST_BASE_ENA__SHIFT         = 0x00000007;
constexpr unsigned int CP_ME_COHER_CNTL__CB2_DEST_BASE_ENA__SHIFT         = 0x00000008;
constexpr unsigned int CP_ME_COHER_CNTL__CB3_DEST_BASE_ENA__SHIFT         = 0x00000009;
constexpr unsigned int CP_ME_COHER_CNTL__CB4_DEST_BASE_ENA__SHIFT         = 0x0000000a;
constexpr unsigned int CP_ME_COHER_CNTL__CB5_DEST_BASE_ENA__SHIFT         = 0x0000000b;
constexpr unsigned int CP_ME_COHER_CNTL__CB6_DEST_BASE_ENA__SHIFT         = 0x0000000c;
constexpr unsigned int CP_ME_COHER_CNTL__CB7_DEST_BASE_ENA__SHIFT         = 0x0000000d;
constexpr unsigned int CP_ME_COHER_CNTL__DB_DEST_BASE_ENA__SHIFT          = 0x0000000e;
constexpr unsigned int CP_ME_COHER_CNTL__DEST_BASE_0_ENA__SHIFT           = 0x00000000;
constexpr unsigned int CP_ME_COHER_CNTL__DEST_BASE_1_ENA__SHIFT           = 0x00000001;
constexpr unsigned int CP_ME_COHER_CNTL__DEST_BASE_2_ENA__SHIFT           = 0x00000013;
constexpr unsigned int CP_ME_COHER_CNTL__DEST_BASE_3_ENA__SHIFT           = 0x00000015;
constexpr unsigned int CP_ME_COHER_SIZE_HI__COHER_SIZE_HI_256B__SHIFT     = 0x00000000;
constexpr unsigned int CP_ME_COHER_SIZE__COHER_SIZE_256B__SHIFT           = 0x00000000;
constexpr unsigned int CP_ME_COHER_STATUS__MATCHING_GFX_CNTX__SHIFT       = 0x00000000;
constexpr unsigned int CP_ME_COHER_STATUS__STATUS__SHIFT                  = 0x0000001f;
constexpr unsigned int CP_NUM_PRIM_NEEDED_COUNT0_HI__NUM_PRIM_NEEDED_CNT0_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_NUM_PRIM_NEEDED_COUNT0_LO__NUM_PRIM_NEEDED_CNT0_LO__SHIFT = 0x00000000;
constexpr unsigned int CP_NUM_PRIM_NEEDED_COUNT1_HI__NUM_PRIM_NEEDED_CNT1_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_NUM_PRIM_NEEDED_COUNT1_LO__NUM_PRIM_NEEDED_CNT1_LO__SHIFT = 0x00000000;
constexpr unsigned int CP_NUM_PRIM_NEEDED_COUNT2_HI__NUM_PRIM_NEEDED_CNT2_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_NUM_PRIM_NEEDED_COUNT2_LO__NUM_PRIM_NEEDED_CNT2_LO__SHIFT = 0x00000000;
constexpr unsigned int CP_NUM_PRIM_NEEDED_COUNT3_HI__NUM_PRIM_NEEDED_CNT3_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_NUM_PRIM_NEEDED_COUNT3_LO__NUM_PRIM_NEEDED_CNT3_LO__SHIFT = 0x00000000;
constexpr unsigned int CP_NUM_PRIM_WRITTEN_COUNT0_HI__NUM_PRIM_WRITTEN_CNT0_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_NUM_PRIM_WRITTEN_COUNT0_LO__NUM_PRIM_WRITTEN_CNT0_LO__SHIFT = 0x00000000;
constexpr unsigned int CP_NUM_PRIM_WRITTEN_COUNT1_HI__NUM_PRIM_WRITTEN_CNT1_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_NUM_PRIM_WRITTEN_COUNT1_LO__NUM_PRIM_WRITTEN_CNT1_LO__SHIFT = 0x00000000;
constexpr unsigned int CP_NUM_PRIM_WRITTEN_COUNT2_HI__NUM_PRIM_WRITTEN_CNT2_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_NUM_PRIM_WRITTEN_COUNT2_LO__NUM_PRIM_WRITTEN_CNT2_LO__SHIFT = 0x00000000;
constexpr unsigned int CP_NUM_PRIM_WRITTEN_COUNT3_HI__NUM_PRIM_WRITTEN_CNT3_HI__SHIFT = 0x00000000;
constexpr unsigned int CP_NUM_PRIM_WRITTEN_COUNT3_LO__NUM_PRIM_WRITTEN_CNT3_LO__SHIFT = 0x00000000;
constexpr unsigned int CP_PERFMON_CNTL__PERFMON_ENABLE_MODE__SHIFT        = 0x00000008;
constexpr unsigned int CP_PERFMON_CNTL__PERFMON_SAMPLE_ENABLE__SHIFT      = 0x0000000a;
constexpr unsigned int CP_PERFMON_CNTL__PERFMON_STATE__SHIFT              = 0x00000000;
constexpr unsigned int CP_PERFMON_CNTL__SPM_PERFMON_STATE__SHIFT          = 0x00000004;
constexpr unsigned int CP_PERFMON_CNTX_CNTL__PERFMON_ENABLE__SHIFT        = 0x0000001f;
constexpr unsigned int CP_SC_PSINVOC_COUNT0_HI__PSINVOC_COUNT0_HI__SHIFT  = 0x00000000;
constexpr unsigned int CP_SC_PSINVOC_COUNT0_LO__PSINVOC_COUNT0_LO__SHIFT  = 0x00000000;
constexpr unsigned int CP_SC_PSINVOC_COUNT1_HI__OBSOLETE__SHIFT           = 0x00000000;
constexpr unsigned int CP_SC_PSINVOC_COUNT1_LO__OBSOLETE__SHIFT           = 0x00000000;
constexpr unsigned int CP_STRMOUT_CNTL__OFFSET_UPDATE_DONE__SHIFT         = 0x00000000;
constexpr unsigned int CP_VGT_CSINVOC_COUNT_HI__CSINVOC_COUNT_HI__SHIFT   = 0x00000000;
constexpr unsigned int CP_VGT_CSINVOC_COUNT_LO__CSINVOC_COUNT_LO__SHIFT   = 0x00000000;
constexpr unsigned int CP_VGT_DSINVOC_COUNT_HI__DSINVOC_COUNT_HI__SHIFT   = 0x00000000;
constexpr unsigned int CP_VGT_DSINVOC_COUNT_LO__DSINVOC_COUNT_LO__SHIFT   = 0x00000000;
constexpr unsigned int CP_VGT_GSINVOC_COUNT_HI__GSINVOC_COUNT_HI__SHIFT   = 0x00000000;
constexpr unsigned int CP_VGT_GSINVOC_COUNT_LO__GSINVOC_COUNT_LO__SHIFT   = 0x00000000;
constexpr unsigned int CP_VGT_GSPRIM_COUNT_HI__GSPRIM_COUNT_HI__SHIFT     = 0x00000000;
constexpr unsigned int CP_VGT_GSPRIM_COUNT_LO__GSPRIM_COUNT_LO__SHIFT     = 0x00000000;
constexpr unsigned int CP_VGT_HSINVOC_COUNT_HI__HSINVOC_COUNT_HI__SHIFT   = 0x00000000;
constexpr unsigned int CP_VGT_HSINVOC_COUNT_LO__HSINVOC_COUNT_LO__SHIFT   = 0x00000000;
constexpr unsigned int CP_VGT_IAPRIM_COUNT_HI__IAPRIM_COUNT_HI__SHIFT     = 0x00000000;
constexpr unsigned int CP_VGT_IAPRIM_COUNT_LO__IAPRIM_COUNT_LO__SHIFT     = 0x00000000;
constexpr unsigned int CP_VGT_IAVERT_COUNT_HI__IAVERT_COUNT_HI__SHIFT     = 0x00000000;
constexpr unsigned int CP_VGT_IAVERT_COUNT_LO__IAVERT_COUNT_LO__SHIFT     = 0x00000000;
constexpr unsigned int CP_VGT_VSINVOC_COUNT_HI__VSINVOC_COUNT_HI__SHIFT   = 0x00000000;
constexpr unsigned int CP_VGT_VSINVOC_COUNT_LO__VSINVOC_COUNT_LO__SHIFT   = 0x00000000;
constexpr unsigned int DB_ALPHA_TO_MASK__ALPHA_TO_MASK_ENABLE__SHIFT      = 0x00000000;
constexpr unsigned int DB_ALPHA_TO_MASK__ALPHA_TO_MASK_OFFSET0__SHIFT     = 0x00000008;
constexpr unsigned int DB_ALPHA_TO_MASK__ALPHA_TO_MASK_OFFSET1__SHIFT     = 0x0000000a;
constexpr unsigned int DB_ALPHA_TO_MASK__ALPHA_TO_MASK_OFFSET2__SHIFT     = 0x0000000c;
constexpr unsigned int DB_ALPHA_TO_MASK__ALPHA_TO_MASK_OFFSET3__SHIFT     = 0x0000000e;
constexpr unsigned int DB_ALPHA_TO_MASK__OFFSET_ROUND__SHIFT              = 0x00000010;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__OFF_HYSTERESIS__SHIFT          = 0x00000004;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__ON_DELAY__SHIFT                = 0x00000000;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__RESERVED__SHIFT                = 0x0000000c;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_OVERRIDE0__SHIFT          = 0x0000001f;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_OVERRIDE1__SHIFT          = 0x0000001e;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_OVERRIDE2__SHIFT          = 0x0000001d;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_OVERRIDE3__SHIFT          = 0x0000001c;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_OVERRIDE4__SHIFT          = 0x0000001b;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_OVERRIDE5__SHIFT          = 0x0000001a;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_OVERRIDE6__SHIFT          = 0x00000019;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_OVERRIDE7__SHIFT          = 0x00000018;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_STALL_OVERRIDE0__SHIFT    = 0x00000017;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_STALL_OVERRIDE1__SHIFT    = 0x00000016;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_STALL_OVERRIDE2__SHIFT    = 0x00000015;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_STALL_OVERRIDE3__SHIFT    = 0x00000014;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_STALL_OVERRIDE4__SHIFT    = 0x00000013;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_STALL_OVERRIDE5__SHIFT    = 0x00000012;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_STALL_OVERRIDE6__SHIFT    = 0x00000011;
constexpr unsigned int DB_CGTT_CLK_CTRL_0__SOFT_STALL_OVERRIDE7__SHIFT    = 0x00000010;
constexpr unsigned int DB_COUNT_CONTROL__DBFAIL_ENABLE__SHIFT             = 0x00000014;
constexpr unsigned int DB_COUNT_CONTROL__PERFECT_ZPASS_COUNTS__SHIFT      = 0x00000001;
constexpr unsigned int DB_COUNT_CONTROL__SAMPLE_RATE__SHIFT               = 0x00000004;
constexpr unsigned int DB_COUNT_CONTROL__SFAIL_ENABLE__SHIFT              = 0x00000010;
constexpr unsigned int DB_COUNT_CONTROL__SLICE_EVEN_ENABLE__SHIFT         = 0x00000018;
constexpr unsigned int DB_COUNT_CONTROL__SLICE_ODD_ENABLE__SHIFT          = 0x0000001c;
constexpr unsigned int DB_COUNT_CONTROL__ZFAIL_ENABLE__SHIFT              = 0x0000000c;
constexpr unsigned int DB_COUNT_CONTROL__ZPASS_ENABLE__SHIFT              = 0x00000008;
constexpr unsigned int DB_COUNT_CONTROL__ZPASS_INCREMENT_DISABLE__SHIFT   = 0x00000000;
constexpr unsigned int DB_CREDIT_LIMIT__DB_CB_LQUAD_CREDITS__SHIFT        = 0x0000000a;
constexpr unsigned int DB_CREDIT_LIMIT__DB_CB_TILE_CREDITS__SHIFT         = 0x00000018;
constexpr unsigned int DB_CREDIT_LIMIT__DB_SC_QUAD_CREDITS__SHIFT         = 0x00000005;
constexpr unsigned int DB_CREDIT_LIMIT__DB_SC_TILE_CREDITS__SHIFT         = 0x00000000;
constexpr unsigned int DB_DEPTH_BOUNDS_MAX__MAX__SHIFT                    = 0x00000000;
constexpr unsigned int DB_DEPTH_BOUNDS_MIN__MIN__SHIFT                    = 0x00000000;
constexpr unsigned int DB_DEPTH_CLEAR__DEPTH_CLEAR__SHIFT                 = 0x00000000;
constexpr unsigned int DB_DEPTH_CONTROL__BACKFACE_ENABLE__SHIFT           = 0x00000007;
constexpr unsigned int DB_DEPTH_CONTROL__DEPTH_BOUNDS_ENABLE__SHIFT       = 0x00000003;
constexpr unsigned int DB_DEPTH_CONTROL__DISABLE_COLOR_WRITES_ON_DEPTH_PASS__SHIFT = 0x0000001f;
constexpr unsigned int DB_DEPTH_CONTROL__ENABLE_COLOR_WRITES_ON_DEPTH_FAIL__SHIFT = 0x0000001e;
constexpr unsigned int DB_DEPTH_CONTROL__STENCILFUNC_BF__SHIFT            = 0x00000014;
constexpr unsigned int DB_DEPTH_CONTROL__STENCILFUNC__SHIFT               = 0x00000008;
constexpr unsigned int DB_DEPTH_CONTROL__STENCIL_ENABLE__SHIFT            = 0x00000000;
constexpr unsigned int DB_DEPTH_CONTROL__ZFUNC__SHIFT                     = 0x00000004;
constexpr unsigned int DB_DEPTH_CONTROL__Z_ENABLE__SHIFT                  = 0x00000001;
constexpr unsigned int DB_DEPTH_CONTROL__Z_WRITE_ENABLE__SHIFT            = 0x00000002;
constexpr unsigned int DB_DEPTH_VIEW__MIPID__SHIFT                        = 0x0000001a;
constexpr unsigned int DB_DEPTH_VIEW__SLICE_MAX__SHIFT                    = 0x0000000d;
constexpr unsigned int DB_DEPTH_VIEW__SLICE_START__SHIFT                  = 0x00000000;
constexpr unsigned int DB_DEPTH_VIEW__STENCIL_READ_ONLY__SHIFT            = 0x00000019;
constexpr unsigned int DB_DEPTH_VIEW__Z_READ_ONLY__SHIFT                  = 0x00000018;
constexpr unsigned int DB_EQAA__ALPHA_TO_MASK_EQAA_DISABLE__SHIFT         = 0x00000015;
constexpr unsigned int DB_EQAA__ALPHA_TO_MASK_NUM_SAMPLES__SHIFT          = 0x0000000c;
constexpr unsigned int DB_EQAA__ENABLE_POSTZ_OVERRASTERIZATION__SHIFT     = 0x0000001b;
constexpr unsigned int DB_EQAA__HIGH_QUALITY_INTERSECTIONS__SHIFT         = 0x00000010;
constexpr unsigned int DB_EQAA__INCOHERENT_EQAA_READS__SHIFT              = 0x00000011;
constexpr unsigned int DB_EQAA__INTERPOLATE_COMP_Z__SHIFT                 = 0x00000012;
constexpr unsigned int DB_EQAA__INTERPOLATE_SRC_Z__SHIFT                  = 0x00000013;
constexpr unsigned int DB_EQAA__MASK_EXPORT_NUM_SAMPLES__SHIFT            = 0x00000008;
constexpr unsigned int DB_EQAA__MAX_ANCHOR_SAMPLES__SHIFT                 = 0x00000000;
constexpr unsigned int DB_EQAA__OVERRASTERIZATION_AMOUNT__SHIFT           = 0x00000018;
constexpr unsigned int DB_EQAA__PS_ITER_SAMPLES__SHIFT                    = 0x00000004;
constexpr unsigned int DB_EQAA__STATIC_ANCHOR_ASSOCIATIONS__SHIFT         = 0x00000014;
constexpr unsigned int DB_EXCEPTION_CONTROL__EARLY_Z_PANIC_DISABLE__SHIFT = 0x00000000;
constexpr unsigned int DB_EXCEPTION_CONTROL__LATE_Z_PANIC_DISABLE__SHIFT  = 0x00000001;
constexpr unsigned int DB_EXCEPTION_CONTROL__RE_Z_PANIC_DISABLE__SHIFT    = 0x00000002;
constexpr unsigned int DB_FIFO_DEPTH2__EQUAD_FIFO_DEPTH__SHIFT            = 0x00000000;
constexpr unsigned int DB_FIFO_DEPTH2__ETILE_OP_FIFO_DEPTH__SHIFT         = 0x00000008;
constexpr unsigned int DB_FIFO_DEPTH2__LTILE_OP_FIFO_DEPTH__SHIFT         = 0x00000019;
constexpr unsigned int DB_FREE_CACHELINES__FREE_DTILE_DEPTH__SHIFT        = 0x00000000;
constexpr unsigned int DB_HTILE_DATA_BASE_HI__BASE_HI__SHIFT              = 0x00000000;
constexpr unsigned int DB_HTILE_DATA_BASE__BASE_256B__SHIFT               = 0x00000000;
constexpr unsigned int DB_HTILE_SURFACE__DST_OUTSIDE_ZERO_TO_ONE__SHIFT   = 0x00000010;
constexpr unsigned int DB_HTILE_SURFACE__FULL_CACHE__SHIFT                = 0x00000001;
constexpr unsigned int DB_HTILE_SURFACE__PIPE_ALIGNED__SHIFT              = 0x00000012;
constexpr unsigned int DB_MEM_ARB_WATERMARKS__CLIENT0_WATERMARK__SHIFT    = 0x00000000;
constexpr unsigned int DB_MEM_ARB_WATERMARKS__CLIENT1_WATERMARK__SHIFT    = 0x00000008;
constexpr unsigned int DB_MEM_ARB_WATERMARKS__CLIENT2_WATERMARK__SHIFT    = 0x00000010;
constexpr unsigned int DB_MEM_ARB_WATERMARKS__CLIENT3_WATERMARK__SHIFT    = 0x00000018;
constexpr unsigned int DB_OCCLUSION_COUNT0_HI__COUNT_HI__SHIFT            = 0x00000000;
constexpr unsigned int DB_OCCLUSION_COUNT0_LOW__COUNT_LOW__SHIFT          = 0x00000000;
constexpr unsigned int DB_OCCLUSION_COUNT1_HI__COUNT_HI__SHIFT            = 0x00000000;
constexpr unsigned int DB_OCCLUSION_COUNT1_LOW__COUNT_LOW__SHIFT          = 0x00000000;
constexpr unsigned int DB_OCCLUSION_COUNT2_HI__COUNT_HI__SHIFT            = 0x00000000;
constexpr unsigned int DB_OCCLUSION_COUNT2_LOW__COUNT_LOW__SHIFT          = 0x00000000;
constexpr unsigned int DB_OCCLUSION_COUNT3_HI__COUNT_HI__SHIFT            = 0x00000000;
constexpr unsigned int DB_OCCLUSION_COUNT3_LOW__COUNT_LOW__SHIFT          = 0x00000000;
constexpr unsigned int DB_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
constexpr unsigned int DB_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int DB_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT         = 0x0000001c;
constexpr unsigned int DB_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT         = 0x00000018;
constexpr unsigned int DB_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT          = 0x00000000;
constexpr unsigned int DB_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT          = 0x0000000a;
constexpr unsigned int DB_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT           = 0x00000014;
constexpr unsigned int DB_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT          = 0x00000018;
constexpr unsigned int DB_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int DB_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT           = 0x0000000a;
constexpr unsigned int DB_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int DB_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
constexpr unsigned int DB_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int DB_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT         = 0x0000001c;
constexpr unsigned int DB_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT         = 0x00000018;
constexpr unsigned int DB_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT          = 0x00000000;
constexpr unsigned int DB_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT          = 0x0000000a;
constexpr unsigned int DB_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT           = 0x00000014;
constexpr unsigned int DB_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT          = 0x00000018;
constexpr unsigned int DB_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int DB_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT           = 0x0000000a;
constexpr unsigned int DB_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int DB_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
constexpr unsigned int DB_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int DB_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT           = 0x00000014;
constexpr unsigned int DB_PERFCOUNTER2_SELECT__PERF_MODE1__SHIFT          = 0x00000018;
constexpr unsigned int DB_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int DB_PERFCOUNTER2_SELECT__PERF_SEL1__SHIFT           = 0x0000000a;
constexpr unsigned int DB_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int DB_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
constexpr unsigned int DB_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int DB_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT           = 0x00000014;
constexpr unsigned int DB_PERFCOUNTER3_SELECT__PERF_MODE1__SHIFT          = 0x00000018;
constexpr unsigned int DB_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int DB_PERFCOUNTER3_SELECT__PERF_SEL1__SHIFT           = 0x0000000a;
constexpr unsigned int DB_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int DB_PRELOAD_CONTROL__MAX_X__SHIFT                   = 0x00000010;
constexpr unsigned int DB_PRELOAD_CONTROL__MAX_Y__SHIFT                   = 0x00000018;
constexpr unsigned int DB_PRELOAD_CONTROL__START_X__SHIFT                 = 0x00000000;
constexpr unsigned int DB_PRELOAD_CONTROL__START_Y__SHIFT                 = 0x00000008;
constexpr unsigned int DB_RENDER_CONTROL__COPY_CENTROID__SHIFT            = 0x00000007;
constexpr unsigned int DB_RENDER_CONTROL__COPY_SAMPLE__SHIFT              = 0x00000008;
constexpr unsigned int DB_RENDER_CONTROL__DECOMPRESS_ENABLE__SHIFT        = 0x0000000c;
constexpr unsigned int DB_RENDER_CONTROL__DEPTH_CLEAR_ENABLE__SHIFT       = 0x00000000;
constexpr unsigned int DB_RENDER_CONTROL__DEPTH_COMPRESS_DISABLE__SHIFT   = 0x00000006;
constexpr unsigned int DB_RENDER_CONTROL__DEPTH_COPY__SHIFT               = 0x00000002;
constexpr unsigned int DB_RENDER_CONTROL__RESUMMARIZE_ENABLE__SHIFT       = 0x00000004;
constexpr unsigned int DB_RENDER_CONTROL__STENCIL_CLEAR_ENABLE__SHIFT     = 0x00000001;
constexpr unsigned int DB_RENDER_CONTROL__STENCIL_COMPRESS_DISABLE__SHIFT = 0x00000005;
constexpr unsigned int DB_RENDER_CONTROL__STENCIL_COPY__SHIFT             = 0x00000003;
constexpr unsigned int DB_RENDER_OVERRIDE2__ALLOW_PARTIAL_RES_HIER_KILL__SHIFT = 0x00000019;
constexpr unsigned int DB_RENDER_OVERRIDE2__DECOMPRESS_Z_ON_FLUSH__SHIFT  = 0x00000008;
constexpr unsigned int DB_RENDER_OVERRIDE2__DEPTH_BOUNDS_HIER_DEPTH_DISABLE__SHIFT = 0x0000000a;
constexpr unsigned int DB_RENDER_OVERRIDE2__DISABLE_COLOR_ON_VALIDATION__SHIFT = 0x00000007;
constexpr unsigned int DB_RENDER_OVERRIDE2__DISABLE_FAST_PASS__SHIFT      = 0x00000017;
constexpr unsigned int DB_RENDER_OVERRIDE2__DISABLE_REG_SNOOP__SHIFT      = 0x00000009;
constexpr unsigned int DB_RENDER_OVERRIDE2__DISABLE_SMEM_EXPCLEAR_OPTIMIZATION__SHIFT = 0x00000006;
constexpr unsigned int DB_RENDER_OVERRIDE2__DISABLE_ZMASK_EXPCLEAR_OPTIMIZATION__SHIFT = 0x00000005;
constexpr unsigned int DB_RENDER_OVERRIDE2__HIS_SFUNC_BF__SHIFT           = 0x00000012;
constexpr unsigned int DB_RENDER_OVERRIDE2__HIS_SFUNC_FF__SHIFT           = 0x0000000f;
constexpr unsigned int DB_RENDER_OVERRIDE2__HIZ_ZFUNC__SHIFT              = 0x0000000c;
constexpr unsigned int DB_RENDER_OVERRIDE2__PARTIAL_SQUAD_LAUNCH_CONTROL__SHIFT = 0x00000000;
constexpr unsigned int DB_RENDER_OVERRIDE2__PARTIAL_SQUAD_LAUNCH_COUNTDOWN__SHIFT = 0x00000002;
constexpr unsigned int DB_RENDER_OVERRIDE2__PRESERVE_SRESULTS__SHIFT      = 0x00000016;
constexpr unsigned int DB_RENDER_OVERRIDE2__PRESERVE_ZRANGE__SHIFT        = 0x00000015;
constexpr unsigned int DB_RENDER_OVERRIDE2__SEPARATE_HIZS_FUNC_ENABLE__SHIFT = 0x0000000b;
constexpr unsigned int DB_RENDER_OVERRIDE__DISABLE_FULLY_COVERED__SHIFT   = 0x00000012;
constexpr unsigned int DB_RENDER_OVERRIDE__DISABLE_TILE_RATE_TILES__SHIFT = 0x0000001a;
constexpr unsigned int DB_RENDER_OVERRIDE__DISABLE_VIEWPORT_CLAMP__SHIFT  = 0x00000010;
constexpr unsigned int DB_RENDER_OVERRIDE__FAST_STENCIL_DISABLE__SHIFT    = 0x00000008;
constexpr unsigned int DB_RENDER_OVERRIDE__FAST_Z_DISABLE__SHIFT          = 0x00000007;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_COLOR_KILL__SHIFT        = 0x0000000a;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_FULL_Z_RANGE__SHIFT      = 0x0000000d;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_HIS_ENABLE0__SHIFT       = 0x00000002;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_HIS_ENABLE1__SHIFT       = 0x00000004;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_HIZ_ENABLE__SHIFT        = 0x00000000;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_QC_SMASK_CONFLICT__SHIFT = 0x0000000f;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_SHADER_Z_ORDER__SHIFT    = 0x00000006;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_STENCIL_DIRTY__SHIFT     = 0x0000001c;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_STENCIL_READ__SHIFT      = 0x0000000c;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_STENCIL_VALID__SHIFT     = 0x0000001e;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_Z_DIRTY__SHIFT           = 0x0000001b;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_Z_LIMIT_SUMM__SHIFT      = 0x00000013;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_Z_READ__SHIFT            = 0x0000000b;
constexpr unsigned int DB_RENDER_OVERRIDE__FORCE_Z_VALID__SHIFT           = 0x0000001d;
constexpr unsigned int DB_RENDER_OVERRIDE__IGNORE_SC_ZRANGE__SHIFT        = 0x00000011;
constexpr unsigned int DB_RENDER_OVERRIDE__MAX_TILES_IN_DTT__SHIFT        = 0x00000015;
constexpr unsigned int DB_RENDER_OVERRIDE__NOOP_CULL_DISABLE__SHIFT       = 0x00000009;
constexpr unsigned int DB_RENDER_OVERRIDE__PRESERVE_COMPRESSION__SHIFT    = 0x0000001f;
constexpr unsigned int DB_RING_CONTROL__COUNTER_CONTROL__SHIFT            = 0x00000000;
constexpr unsigned int DB_SHADER_CONTROL__ALPHA_TO_MASK_DISABLE__SHIFT    = 0x0000000b;
constexpr unsigned int DB_SHADER_CONTROL__CONSERVATIVE_Z_EXPORT__SHIFT    = 0x0000000d;
constexpr unsigned int DB_SHADER_CONTROL__COVERAGE_TO_MASK_ENABLE__SHIFT  = 0x00000007;
constexpr unsigned int DB_SHADER_CONTROL__DEPTH_BEFORE_SHADER__SHIFT      = 0x0000000c;
constexpr unsigned int DB_SHADER_CONTROL__DUAL_QUAD_DISABLE__SHIFT        = 0x0000000f;
constexpr unsigned int DB_SHADER_CONTROL__EXEC_IF_OVERLAPPED__SHIFT       = 0x00000011;
constexpr unsigned int DB_SHADER_CONTROL__EXEC_ON_HIER_FAIL__SHIFT        = 0x00000009;
constexpr unsigned int DB_SHADER_CONTROL__EXEC_ON_NOOP__SHIFT             = 0x0000000a;
constexpr unsigned int DB_SHADER_CONTROL__KILL_ENABLE__SHIFT              = 0x00000006;
constexpr unsigned int DB_SHADER_CONTROL__MASK_EXPORT_ENABLE__SHIFT       = 0x00000008;
constexpr unsigned int DB_SHADER_CONTROL__POPS_OVERLAP_NUM_SAMPLES__SHIFT = 0x00000014;
constexpr unsigned int DB_SHADER_CONTROL__PRIMITIVE_ORDERED_PIXEL_SHADER__SHIFT = 0x00000010;
constexpr unsigned int DB_SHADER_CONTROL__STENCIL_OP_VAL_EXPORT_ENABLE__SHIFT = 0x00000002;
constexpr unsigned int DB_SHADER_CONTROL__STENCIL_TEST_VAL_EXPORT_ENABLE__SHIFT = 0x00000001;
constexpr unsigned int DB_SHADER_CONTROL__Z_EXPORT_ENABLE__SHIFT          = 0x00000000;
constexpr unsigned int DB_SHADER_CONTROL__Z_ORDER__SHIFT                  = 0x00000004;
constexpr unsigned int DB_SRESULTS_COMPARE_STATE0__COMPAREFUNC0__SHIFT    = 0x00000000;
constexpr unsigned int DB_SRESULTS_COMPARE_STATE0__COMPAREMASK0__SHIFT    = 0x0000000c;
constexpr unsigned int DB_SRESULTS_COMPARE_STATE0__COMPAREVALUE0__SHIFT   = 0x00000004;
constexpr unsigned int DB_SRESULTS_COMPARE_STATE0__ENABLE0__SHIFT         = 0x00000018;
constexpr unsigned int DB_SRESULTS_COMPARE_STATE1__COMPAREFUNC1__SHIFT    = 0x00000000;
constexpr unsigned int DB_SRESULTS_COMPARE_STATE1__COMPAREMASK1__SHIFT    = 0x0000000c;
constexpr unsigned int DB_SRESULTS_COMPARE_STATE1__COMPAREVALUE1__SHIFT   = 0x00000004;
constexpr unsigned int DB_SRESULTS_COMPARE_STATE1__ENABLE1__SHIFT         = 0x00000018;
constexpr unsigned int DB_STENCILREFMASK_BF__STENCILMASK_BF__SHIFT        = 0x00000008;
constexpr unsigned int DB_STENCILREFMASK_BF__STENCILOPVAL_BF__SHIFT       = 0x00000018;
constexpr unsigned int DB_STENCILREFMASK_BF__STENCILTESTVAL_BF__SHIFT     = 0x00000000;
constexpr unsigned int DB_STENCILREFMASK_BF__STENCILWRITEMASK_BF__SHIFT   = 0x00000010;
constexpr unsigned int DB_STENCILREFMASK__STENCILMASK__SHIFT              = 0x00000008;
constexpr unsigned int DB_STENCILREFMASK__STENCILOPVAL__SHIFT             = 0x00000018;
constexpr unsigned int DB_STENCILREFMASK__STENCILTESTVAL__SHIFT           = 0x00000000;
constexpr unsigned int DB_STENCILREFMASK__STENCILWRITEMASK__SHIFT         = 0x00000010;
constexpr unsigned int DB_STENCIL_CLEAR__CLEAR__SHIFT                     = 0x00000000;
constexpr unsigned int DB_STENCIL_CONTROL__STENCILFAIL_BF__SHIFT          = 0x0000000c;
constexpr unsigned int DB_STENCIL_CONTROL__STENCILFAIL__SHIFT             = 0x00000000;
constexpr unsigned int DB_STENCIL_CONTROL__STENCILZFAIL_BF__SHIFT         = 0x00000014;
constexpr unsigned int DB_STENCIL_CONTROL__STENCILZFAIL__SHIFT            = 0x00000008;
constexpr unsigned int DB_STENCIL_CONTROL__STENCILZPASS_BF__SHIFT         = 0x00000010;
constexpr unsigned int DB_STENCIL_CONTROL__STENCILZPASS__SHIFT            = 0x00000004;
constexpr unsigned int DB_STENCIL_INFO__ALLOW_EXPCLEAR__SHIFT             = 0x0000001b;
constexpr unsigned int DB_STENCIL_INFO__FORMAT__SHIFT                     = 0x00000000;
constexpr unsigned int DB_STENCIL_INFO__PARTIALLY_RESIDENT__SHIFT         = 0x0000000c;
constexpr unsigned int DB_STENCIL_INFO__SW_MODE__SHIFT                    = 0x00000004;
constexpr unsigned int DB_STENCIL_INFO__TILE_STENCIL_DISABLE__SHIFT       = 0x0000001d;
constexpr unsigned int DB_STENCIL_READ_BASE_HI__BASE_HI__SHIFT            = 0x00000000;
constexpr unsigned int DB_STENCIL_READ_BASE__BASE_256B__SHIFT             = 0x00000000;
constexpr unsigned int DB_STENCIL_WRITE_BASE_HI__BASE_HI__SHIFT           = 0x00000000;
constexpr unsigned int DB_STENCIL_WRITE_BASE__BASE_256B__SHIFT            = 0x00000000;
constexpr unsigned int DB_SUBTILE_CONTROL__MSAA1_X__SHIFT                 = 0x00000000;
constexpr unsigned int DB_SUBTILE_CONTROL__MSAA1_Y__SHIFT                 = 0x00000002;
constexpr unsigned int DB_SUBTILE_CONTROL__MSAA2_X__SHIFT                 = 0x00000004;
constexpr unsigned int DB_SUBTILE_CONTROL__MSAA2_Y__SHIFT                 = 0x00000006;
constexpr unsigned int DB_SUBTILE_CONTROL__MSAA4_X__SHIFT                 = 0x00000008;
constexpr unsigned int DB_SUBTILE_CONTROL__MSAA4_Y__SHIFT                 = 0x0000000a;
constexpr unsigned int DB_SUBTILE_CONTROL__MSAA8_X__SHIFT                 = 0x0000000c;
constexpr unsigned int DB_SUBTILE_CONTROL__MSAA8_Y__SHIFT                 = 0x0000000e;
constexpr unsigned int DB_SUBTILE_CONTROL__MSAA16_X__SHIFT                = 0x00000010;
constexpr unsigned int DB_SUBTILE_CONTROL__MSAA16_Y__SHIFT                = 0x00000012;
constexpr unsigned int DB_WATERMARKS__DEPTH_FREE__SHIFT                   = 0x00000000;
constexpr unsigned int DB_ZPASS_COUNT_HI__COUNT_HI__SHIFT                 = 0x00000000;
constexpr unsigned int DB_ZPASS_COUNT_LOW__COUNT_LOW__SHIFT               = 0x00000000;
constexpr unsigned int DB_Z_INFO__ALLOW_EXPCLEAR__SHIFT                   = 0x0000001b;
constexpr unsigned int DB_Z_INFO__DECOMPRESS_ON_N_ZPLANES__SHIFT          = 0x00000017;
constexpr unsigned int DB_Z_INFO__FORMAT__SHIFT                           = 0x00000000;
constexpr unsigned int DB_Z_INFO__MAXMIP__SHIFT                           = 0x00000010;
constexpr unsigned int DB_Z_INFO__NUM_SAMPLES__SHIFT                      = 0x00000002;
constexpr unsigned int DB_Z_INFO__PARTIALLY_RESIDENT__SHIFT               = 0x0000000c;
constexpr unsigned int DB_Z_INFO__READ_SIZE__SHIFT                        = 0x0000001c;
constexpr unsigned int DB_Z_INFO__SW_MODE__SHIFT                          = 0x00000004;
constexpr unsigned int DB_Z_INFO__TILE_SURFACE_ENABLE__SHIFT              = 0x0000001d;
constexpr unsigned int DB_Z_INFO__ZRANGE_PRECISION__SHIFT                 = 0x0000001f;
constexpr unsigned int DB_Z_READ_BASE_HI__BASE_HI__SHIFT                  = 0x00000000;
constexpr unsigned int DB_Z_READ_BASE__BASE_256B__SHIFT                   = 0x00000000;
constexpr unsigned int DB_Z_WRITE_BASE_HI__BASE_HI__SHIFT                 = 0x00000000;
constexpr unsigned int DB_Z_WRITE_BASE__BASE_256B__SHIFT                  = 0x00000000;
constexpr unsigned int GB_ADDR_CONFIG_READ__MAX_COMPRESSED_FRAGS__SHIFT   = 0x00000006;
constexpr unsigned int GB_ADDR_CONFIG_READ__NUM_PIPES__SHIFT              = 0x00000000;
constexpr unsigned int GB_ADDR_CONFIG_READ__NUM_RB_PER_SE__SHIFT          = 0x0000001a;
constexpr unsigned int GB_ADDR_CONFIG_READ__NUM_SHADER_ENGINES__SHIFT     = 0x00000013;
constexpr unsigned int GB_ADDR_CONFIG_READ__PIPE_INTERLEAVE_SIZE__SHIFT   = 0x00000003;
constexpr unsigned int GB_ADDR_CONFIG__MAX_COMPRESSED_FRAGS__SHIFT        = 0x00000006;
constexpr unsigned int GB_ADDR_CONFIG__NUM_PIPES__SHIFT                   = 0x00000000;
constexpr unsigned int GB_ADDR_CONFIG__NUM_RB_PER_SE__SHIFT               = 0x0000001a;
constexpr unsigned int GB_ADDR_CONFIG__NUM_SHADER_ENGINES__SHIFT          = 0x00000013;
constexpr unsigned int GB_ADDR_CONFIG__PIPE_INTERLEAVE_SIZE__SHIFT        = 0x00000003;
constexpr unsigned int GCEA_PERFCOUNTER0_CFG__CLEAR__SHIFT                = 0x0000001d;
constexpr unsigned int GCEA_PERFCOUNTER0_CFG__ENABLE__SHIFT               = 0x0000001c;
constexpr unsigned int GCEA_PERFCOUNTER0_CFG__PERF_MODE__SHIFT            = 0x00000018;
constexpr unsigned int GCEA_PERFCOUNTER0_CFG__PERF_SEL_END__SHIFT         = 0x00000008;
constexpr unsigned int GCEA_PERFCOUNTER0_CFG__PERF_SEL__SHIFT             = 0x00000000;
constexpr unsigned int GCEA_PERFCOUNTER1_CFG__CLEAR__SHIFT                = 0x0000001d;
constexpr unsigned int GCEA_PERFCOUNTER1_CFG__ENABLE__SHIFT               = 0x0000001c;
constexpr unsigned int GCEA_PERFCOUNTER1_CFG__PERF_MODE__SHIFT            = 0x00000018;
constexpr unsigned int GCEA_PERFCOUNTER1_CFG__PERF_SEL_END__SHIFT         = 0x00000008;
constexpr unsigned int GCEA_PERFCOUNTER1_CFG__PERF_SEL__SHIFT             = 0x00000000;
constexpr unsigned int GCEA_PERFCOUNTER_HI__COMPARE_VALUE__SHIFT          = 0x00000010;
constexpr unsigned int GCEA_PERFCOUNTER_HI__COUNTER_HI__SHIFT             = 0x00000000;
constexpr unsigned int GCEA_PERFCOUNTER_LO__COUNTER_LO__SHIFT             = 0x00000000;
constexpr unsigned int GCEA_PERFCOUNTER_RSLT_CNTL__CLEAR_ALL__SHIFT       = 0x00000019;
constexpr unsigned int GCEA_PERFCOUNTER_RSLT_CNTL__ENABLE_ANY__SHIFT      = 0x00000018;
constexpr unsigned int GCEA_PERFCOUNTER_RSLT_CNTL__PERF_COUNTER_SELECT__SHIFT = 0x00000000;
constexpr unsigned int GCEA_PERFCOUNTER_RSLT_CNTL__START_TRIGGER__SHIFT   = 0x00000008;
constexpr unsigned int GCEA_PERFCOUNTER_RSLT_CNTL__STOP_ALL_ON_SATURATE__SHIFT = 0x0000001a;
constexpr unsigned int GCEA_PERFCOUNTER_RSLT_CNTL__STOP_TRIGGER__SHIFT    = 0x00000010;
constexpr unsigned int GDS_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int GDS_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int GDS_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
constexpr unsigned int GDS_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int GDS_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int GDS_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
constexpr unsigned int GDS_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int GDS_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int GDS_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
constexpr unsigned int GDS_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int GDS_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int GDS_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
constexpr unsigned int GRBM_GFX_INDEX_SR_DATA__INSTANCE_BROADCAST_WRITES__SHIFT = 0x0000001e;
constexpr unsigned int GRBM_GFX_INDEX_SR_DATA__INSTANCE_INDEX__SHIFT      = 0x00000000;
constexpr unsigned int GRBM_GFX_INDEX_SR_DATA__SE_BROADCAST_WRITES__SHIFT = 0x0000001f;
constexpr unsigned int GRBM_GFX_INDEX_SR_DATA__SE_INDEX__SHIFT            = 0x00000010;
constexpr unsigned int GRBM_GFX_INDEX_SR_SELECT__INDEX__SHIFT             = 0x00000000;
constexpr unsigned int GRBM_GFX_INDEX__INSTANCE_BROADCAST_WRITES__SHIFT   = 0x0000001e;
constexpr unsigned int GRBM_GFX_INDEX__INSTANCE_INDEX__SHIFT              = 0x00000000;
constexpr unsigned int GRBM_GFX_INDEX__SE_BROADCAST_WRITES__SHIFT         = 0x0000001f;
constexpr unsigned int GRBM_GFX_INDEX__SE_INDEX__SHIFT                    = 0x00000010;
constexpr unsigned int GRBM_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT        = 0x00000000;
constexpr unsigned int GRBM_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT        = 0x00000000;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__BCI_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000019;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__CB_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000015;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__CB_CLEAN_USER_DEFINED_MASK__SHIFT = 0x0000000b;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__CP_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000016;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__DB_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000014;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__DB_CLEAN_USER_DEFINED_MASK__SHIFT = 0x0000000a;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__EA_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001e;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__GDS_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000018;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__GRBM_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000013;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__PA_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000012;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT          = 0x00000000;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__RLC_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001a;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__RMI_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001f;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__SC_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000011;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__SPI_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000010;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__SX_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000e;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__TA_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000d;
constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__UTCL2_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001d;
constexpr unsigned int GRBM_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT        = 0x00000000;
constexpr unsigned int GRBM_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT        = 0x00000000;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__BCI_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000019;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__CB_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000015;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__CB_CLEAN_USER_DEFINED_MASK__SHIFT = 0x0000000b;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__CP_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000016;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__DB_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000014;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__DB_CLEAN_USER_DEFINED_MASK__SHIFT = 0x0000000a;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__EA_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001e;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__GDS_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000018;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__GRBM_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000013;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__PA_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000012;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT          = 0x00000000;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__RLC_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001a;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__RMI_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001f;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__SC_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000011;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__SPI_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000010;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__SX_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000e;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__TA_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000d;
constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__UTCL2_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001d;
constexpr unsigned int GRBM_SE0_PERFCOUNTER_HI__PERFCOUNTER_HI__SHIFT     = 0x00000000;
constexpr unsigned int GRBM_SE0_PERFCOUNTER_LO__PERFCOUNTER_LO__SHIFT     = 0x00000000;
constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__BCI_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000015;
constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__CB_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000012;
constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__CB_CLEAN_USER_DEFINED_MASK__SHIFT = 0x0000000b;
constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__DB_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000011;
constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__DB_CLEAN_USER_DEFINED_MASK__SHIFT = 0x0000000a;
constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__PA_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000014;
constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__PERF_SEL__SHIFT       = 0x00000000;
constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__RMI_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000016;
constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__SC_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000010;
constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__SPI_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000f;
constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__SX_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000d;
constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__TA_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000c;
constexpr unsigned int GRBM_SE1_PERFCOUNTER_HI__PERFCOUNTER_HI__SHIFT     = 0x00000000;
constexpr unsigned int GRBM_SE1_PERFCOUNTER_LO__PERFCOUNTER_LO__SHIFT     = 0x00000000;
constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__BCI_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000015;
constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__CB_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000012;
constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__CB_CLEAN_USER_DEFINED_MASK__SHIFT = 0x0000000b;
constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__DB_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000011;
constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__DB_CLEAN_USER_DEFINED_MASK__SHIFT = 0x0000000a;
constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__PA_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000014;
constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__PERF_SEL__SHIFT       = 0x00000000;
constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__RMI_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000016;
constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__SC_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000010;
constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__SPI_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000f;
constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__SX_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000d;
constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__TA_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000c;
constexpr unsigned int GRBM_SE2_PERFCOUNTER_HI__PERFCOUNTER_HI__SHIFT     = 0x00000000;
constexpr unsigned int GRBM_SE2_PERFCOUNTER_LO__PERFCOUNTER_LO__SHIFT     = 0x00000000;
constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__BCI_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000015;
constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__CB_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000012;
constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__CB_CLEAN_USER_DEFINED_MASK__SHIFT = 0x0000000b;
constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__DB_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000011;
constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__DB_CLEAN_USER_DEFINED_MASK__SHIFT = 0x0000000a;
constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__PA_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000014;
constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__PERF_SEL__SHIFT       = 0x00000000;
constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__RMI_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000016;
constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__SC_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000010;
constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__SPI_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000f;
constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__SX_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000d;
constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__TA_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000c;
constexpr unsigned int GRBM_SE3_PERFCOUNTER_HI__PERFCOUNTER_HI__SHIFT     = 0x00000000;
constexpr unsigned int GRBM_SE3_PERFCOUNTER_LO__PERFCOUNTER_LO__SHIFT     = 0x00000000;
constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__BCI_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000015;
constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__CB_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000012;
constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__CB_CLEAN_USER_DEFINED_MASK__SHIFT = 0x0000000b;
constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__DB_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000011;
constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__DB_CLEAN_USER_DEFINED_MASK__SHIFT = 0x0000000a;
constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__PA_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000014;
constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__PERF_SEL__SHIFT       = 0x00000000;
constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__RMI_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000016;
constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__SC_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000010;
constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__SPI_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000f;
constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__SX_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000d;
constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__TA_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000c;
constexpr unsigned int IA_ENHANCE__MISC__SHIFT                            = 0x00000000;
constexpr unsigned int IA_MULTI_VGT_PARAM__PARTIAL_ES_WAVE_ON__SHIFT      = 0x00000012;
constexpr unsigned int IA_MULTI_VGT_PARAM__PARTIAL_VS_WAVE_ON__SHIFT      = 0x00000010;
constexpr unsigned int IA_MULTI_VGT_PARAM__PRIMGROUP_SIZE__SHIFT          = 0x00000000;
constexpr unsigned int IA_MULTI_VGT_PARAM__SWITCH_ON_EOI__SHIFT           = 0x00000013;
constexpr unsigned int IA_MULTI_VGT_PARAM__SWITCH_ON_EOP__SHIFT           = 0x00000011;
constexpr unsigned int IA_MULTI_VGT_PARAM__WD_SWITCH_ON_EOP__SHIFT        = 0x00000014;
constexpr unsigned int IA_UTCL1_CNTL__BYPASS__SHIFT                       = 0x00000019;
constexpr unsigned int IA_UTCL1_CNTL__DROP_MODE__SHIFT                    = 0x00000018;
constexpr unsigned int IA_UTCL1_CNTL__FORCE_SNOOP__SHIFT                  = 0x0000001c;
constexpr unsigned int IA_UTCL1_CNTL__FRAG_LIMIT_MODE__SHIFT              = 0x0000001b;
constexpr unsigned int IA_UTCL1_CNTL__INVALIDATE__SHIFT                   = 0x0000001a;
constexpr unsigned int IA_UTCL1_CNTL__VMID_RESET_MODE__SHIFT              = 0x00000017;
constexpr unsigned int IA_UTCL1_CNTL__XNACK_REDO_TIMER_CNT__SHIFT         = 0x00000000;
constexpr unsigned int IA_UTCL1_STATUS__FAULT_DETECTED__SHIFT             = 0x00000000;
constexpr unsigned int IA_UTCL1_STATUS__FAULT_UTCL1ID__SHIFT              = 0x00000008;
constexpr unsigned int IA_UTCL1_STATUS__PRT_DETECTED__SHIFT               = 0x00000002;
constexpr unsigned int IA_UTCL1_STATUS__PRT_UTCL1ID__SHIFT                = 0x00000018;
constexpr unsigned int IA_UTCL1_STATUS__RETRY_DETECTED__SHIFT             = 0x00000001;
constexpr unsigned int IA_UTCL1_STATUS__RETRY_UTCL1ID__SHIFT              = 0x00000010;
constexpr unsigned int PA_CL_CLIP_CNTL__BOUNDARY_EDGE_FLAG_ENA__SHIFT     = 0x00000012;
constexpr unsigned int PA_CL_CLIP_CNTL__CLIP_DISABLE__SHIFT               = 0x00000010;
constexpr unsigned int PA_CL_CLIP_CNTL__DIS_CLIP_ERR_DETECT__SHIFT        = 0x00000014;
constexpr unsigned int PA_CL_CLIP_CNTL__DX_CLIP_SPACE_DEF__SHIFT          = 0x00000013;
constexpr unsigned int PA_CL_CLIP_CNTL__DX_LINEAR_ATTR_CLIP_ENA__SHIFT    = 0x00000018;
constexpr unsigned int PA_CL_CLIP_CNTL__DX_RASTERIZATION_KILL__SHIFT      = 0x00000016;
constexpr unsigned int PA_CL_CLIP_CNTL__PS_UCP_MODE__SHIFT                = 0x0000000e;
constexpr unsigned int PA_CL_CLIP_CNTL__PS_UCP_Y_SCALE_NEG__SHIFT         = 0x0000000d;
constexpr unsigned int PA_CL_CLIP_CNTL__UCP_CULL_ONLY_ENA__SHIFT          = 0x00000011;
constexpr unsigned int PA_CL_CLIP_CNTL__UCP_ENA_0__SHIFT                  = 0x00000000;
constexpr unsigned int PA_CL_CLIP_CNTL__UCP_ENA_1__SHIFT                  = 0x00000001;
constexpr unsigned int PA_CL_CLIP_CNTL__UCP_ENA_2__SHIFT                  = 0x00000002;
constexpr unsigned int PA_CL_CLIP_CNTL__UCP_ENA_3__SHIFT                  = 0x00000003;
constexpr unsigned int PA_CL_CLIP_CNTL__UCP_ENA_4__SHIFT                  = 0x00000004;
constexpr unsigned int PA_CL_CLIP_CNTL__UCP_ENA_5__SHIFT                  = 0x00000005;
constexpr unsigned int PA_CL_CLIP_CNTL__VTE_VPORT_PROVOKE_DISABLE__SHIFT  = 0x00000019;
constexpr unsigned int PA_CL_CLIP_CNTL__VTX_KILL_OR__SHIFT                = 0x00000015;
constexpr unsigned int PA_CL_CLIP_CNTL__ZCLIP_FAR_DISABLE__SHIFT          = 0x0000001b;
constexpr unsigned int PA_CL_CLIP_CNTL__ZCLIP_NEAR_DISABLE__SHIFT         = 0x0000001a;
constexpr unsigned int PA_CL_ENHANCE__CLIPPED_PRIM_SEQ_STALL__SHIFT       = 0x00000003;
constexpr unsigned int PA_CL_ENHANCE__CLIP_VTX_REORDER_ENA__SHIFT         = 0x00000000;
constexpr unsigned int PA_CL_ENHANCE__ECO_SPARE0__SHIFT                   = 0x0000001f;
constexpr unsigned int PA_CL_ENHANCE__ECO_SPARE1__SHIFT                   = 0x0000001e;
constexpr unsigned int PA_CL_ENHANCE__ECO_SPARE2__SHIFT                   = 0x0000001d;
constexpr unsigned int PA_CL_ENHANCE__ECO_SPARE3__SHIFT                   = 0x0000001c;
constexpr unsigned int PA_CL_ENHANCE__IGNORE_PIPELINE_RESET__SHIFT        = 0x00000006;
constexpr unsigned int PA_CL_ENHANCE__KILL_INNER_EDGE_FLAGS__SHIFT        = 0x00000007;
constexpr unsigned int PA_CL_ENHANCE__NGG_BYPASS_PRIM_FILTER__SHIFT       = 0x0000000b;
constexpr unsigned int PA_CL_ENHANCE__NGG_PA_TO_ALL_SC__SHIFT             = 0x00000008;
constexpr unsigned int PA_CL_ENHANCE__NGG_PRIM_INDICES_FIFO_DEPTH__SHIFT  = 0x0000000e;
constexpr unsigned int PA_CL_ENHANCE__NGG_SIDEBAND_MEMORY_DEPTH__SHIFT    = 0x0000000c;
constexpr unsigned int PA_CL_ENHANCE__NUM_CLIP_SEQ__SHIFT                 = 0x00000001;
constexpr unsigned int PA_CL_ENHANCE__TC_LATENCY_TIME_STAMP_RESOLUTION__SHIFT = 0x00000009;
constexpr unsigned int PA_CL_ENHANCE__VE_NAN_PROC_DISABLE__SHIFT          = 0x00000004;
constexpr unsigned int PA_CL_ENHANCE__XTRA_DEBUG_REG_SEL__SHIFT           = 0x00000005;
constexpr unsigned int PA_CL_GB_HORZ_CLIP_ADJ__DATA_REGISTER__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_GB_HORZ_DISC_ADJ__DATA_REGISTER__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_GB_VERT_CLIP_ADJ__DATA_REGISTER__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_GB_VERT_DISC_ADJ__DATA_REGISTER__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_NANINF_CNTL__VS_CLIP_DIST_INF_DISCARD__SHIFT = 0x0000000e;
constexpr unsigned int PA_CL_NANINF_CNTL__VS_W_INF_RETAIN__SHIFT          = 0x0000000d;
constexpr unsigned int PA_CL_NANINF_CNTL__VS_W_NAN_TO_INF__SHIFT          = 0x0000000c;
constexpr unsigned int PA_CL_NANINF_CNTL__VS_XY_INF_RETAIN__SHIFT         = 0x00000009;
constexpr unsigned int PA_CL_NANINF_CNTL__VS_XY_NAN_TO_INF__SHIFT         = 0x00000008;
constexpr unsigned int PA_CL_NANINF_CNTL__VS_Z_INF_RETAIN__SHIFT          = 0x0000000b;
constexpr unsigned int PA_CL_NANINF_CNTL__VS_Z_NAN_TO_INF__SHIFT          = 0x0000000a;
constexpr unsigned int PA_CL_NANINF_CNTL__VTE_0XNANINF_IS_0__SHIFT        = 0x00000003;
constexpr unsigned int PA_CL_NANINF_CNTL__VTE_NO_OUTPUT_NEG_0__SHIFT      = 0x00000014;
constexpr unsigned int PA_CL_NANINF_CNTL__VTE_W_INF_DISCARD__SHIFT        = 0x00000002;
constexpr unsigned int PA_CL_NANINF_CNTL__VTE_W_NAN_RETAIN__SHIFT         = 0x00000006;
constexpr unsigned int PA_CL_NANINF_CNTL__VTE_W_RECIP_NAN_IS_0__SHIFT     = 0x00000007;
constexpr unsigned int PA_CL_NANINF_CNTL__VTE_XY_INF_DISCARD__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_NANINF_CNTL__VTE_XY_NAN_RETAIN__SHIFT        = 0x00000004;
constexpr unsigned int PA_CL_NANINF_CNTL__VTE_Z_INF_DISCARD__SHIFT        = 0x00000001;
constexpr unsigned int PA_CL_NANINF_CNTL__VTE_Z_NAN_RETAIN__SHIFT         = 0x00000005;
constexpr unsigned int PA_CL_NGG_CNTL__INDEX_BUF_EDGE_FLAG_ENA__SHIFT     = 0x00000001;
constexpr unsigned int PA_CL_NGG_CNTL__VERTEX_REUSE_OFF__SHIFT            = 0x00000000;
constexpr unsigned int PA_CL_POINT_CULL_RAD__DATA_REGISTER__SHIFT         = 0x00000000;
constexpr unsigned int PA_CL_POINT_SIZE__DATA_REGISTER__SHIFT             = 0x00000000;
constexpr unsigned int PA_CL_POINT_X_RAD__DATA_REGISTER__SHIFT            = 0x00000000;
constexpr unsigned int PA_CL_POINT_Y_RAD__DATA_REGISTER__SHIFT            = 0x00000000;
constexpr unsigned int PA_CL_UCP_0_W__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_UCP_0_X__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_UCP_0_Y__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_UCP_0_Z__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_UCP_1_W__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_UCP_1_X__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_UCP_1_Y__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_UCP_1_Z__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_UCP_2_W__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_UCP_2_X__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_UCP_2_Y__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_UCP_2_Z__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_UCP_3_W__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_UCP_3_X__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_UCP_3_Y__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_UCP_3_Z__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_UCP_4_W__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_UCP_4_X__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_UCP_4_Y__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_UCP_4_Z__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_UCP_5_W__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_UCP_5_X__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_UCP_5_Y__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_UCP_5_Z__DATA_REGISTER__SHIFT                = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET_1__VPORT_XOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET_2__VPORT_XOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET_3__VPORT_XOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET_4__VPORT_XOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET_5__VPORT_XOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET_6__VPORT_XOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET_7__VPORT_XOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET_8__VPORT_XOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET_9__VPORT_XOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET_10__VPORT_XOFFSET__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET_11__VPORT_XOFFSET__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET_12__VPORT_XOFFSET__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET_13__VPORT_XOFFSET__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET_14__VPORT_XOFFSET__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET_15__VPORT_XOFFSET__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XOFFSET__VPORT_XOFFSET__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE_1__VPORT_XSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE_2__VPORT_XSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE_3__VPORT_XSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE_4__VPORT_XSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE_5__VPORT_XSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE_6__VPORT_XSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE_7__VPORT_XSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE_8__VPORT_XSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE_9__VPORT_XSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE_10__VPORT_XSCALE__SHIFT         = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE_11__VPORT_XSCALE__SHIFT         = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE_12__VPORT_XSCALE__SHIFT         = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE_13__VPORT_XSCALE__SHIFT         = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE_14__VPORT_XSCALE__SHIFT         = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE_15__VPORT_XSCALE__SHIFT         = 0x00000000;
constexpr unsigned int PA_CL_VPORT_XSCALE__VPORT_XSCALE__SHIFT            = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET_1__VPORT_YOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET_2__VPORT_YOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET_3__VPORT_YOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET_4__VPORT_YOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET_5__VPORT_YOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET_6__VPORT_YOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET_7__VPORT_YOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET_8__VPORT_YOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET_9__VPORT_YOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET_10__VPORT_YOFFSET__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET_11__VPORT_YOFFSET__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET_12__VPORT_YOFFSET__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET_13__VPORT_YOFFSET__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET_14__VPORT_YOFFSET__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET_15__VPORT_YOFFSET__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YOFFSET__VPORT_YOFFSET__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE_1__VPORT_YSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE_2__VPORT_YSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE_3__VPORT_YSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE_4__VPORT_YSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE_5__VPORT_YSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE_6__VPORT_YSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE_7__VPORT_YSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE_8__VPORT_YSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE_9__VPORT_YSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE_10__VPORT_YSCALE__SHIFT         = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE_11__VPORT_YSCALE__SHIFT         = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE_12__VPORT_YSCALE__SHIFT         = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE_13__VPORT_YSCALE__SHIFT         = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE_14__VPORT_YSCALE__SHIFT         = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE_15__VPORT_YSCALE__SHIFT         = 0x00000000;
constexpr unsigned int PA_CL_VPORT_YSCALE__VPORT_YSCALE__SHIFT            = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_1__VPORT_ZOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_2__VPORT_ZOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_3__VPORT_ZOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_4__VPORT_ZOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_5__VPORT_ZOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_6__VPORT_ZOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_7__VPORT_ZOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_8__VPORT_ZOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_9__VPORT_ZOFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_10__VPORT_ZOFFSET__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_11__VPORT_ZOFFSET__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_12__VPORT_ZOFFSET__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_13__VPORT_ZOFFSET__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_14__VPORT_ZOFFSET__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET_15__VPORT_ZOFFSET__SHIFT       = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZOFFSET__VPORT_ZOFFSET__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE_1__VPORT_ZSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE_2__VPORT_ZSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE_3__VPORT_ZSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE_4__VPORT_ZSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE_5__VPORT_ZSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE_6__VPORT_ZSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE_7__VPORT_ZSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE_8__VPORT_ZSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE_9__VPORT_ZSCALE__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE_10__VPORT_ZSCALE__SHIFT         = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE_11__VPORT_ZSCALE__SHIFT         = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE_12__VPORT_ZSCALE__SHIFT         = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE_13__VPORT_ZSCALE__SHIFT         = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE_14__VPORT_ZSCALE__SHIFT         = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE_15__VPORT_ZSCALE__SHIFT         = 0x00000000;
constexpr unsigned int PA_CL_VPORT_ZSCALE__VPORT_ZSCALE__SHIFT            = 0x00000000;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CLIP_DIST_ENA_0__SHIFT          = 0x00000000;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CLIP_DIST_ENA_1__SHIFT          = 0x00000001;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CLIP_DIST_ENA_2__SHIFT          = 0x00000002;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CLIP_DIST_ENA_3__SHIFT          = 0x00000003;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CLIP_DIST_ENA_4__SHIFT          = 0x00000004;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CLIP_DIST_ENA_5__SHIFT          = 0x00000005;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CLIP_DIST_ENA_6__SHIFT          = 0x00000006;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CLIP_DIST_ENA_7__SHIFT          = 0x00000007;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CULL_DIST_ENA_0__SHIFT          = 0x00000008;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CULL_DIST_ENA_1__SHIFT          = 0x00000009;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CULL_DIST_ENA_2__SHIFT          = 0x0000000a;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CULL_DIST_ENA_3__SHIFT          = 0x0000000b;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CULL_DIST_ENA_4__SHIFT          = 0x0000000c;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CULL_DIST_ENA_5__SHIFT          = 0x0000000d;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CULL_DIST_ENA_6__SHIFT          = 0x0000000e;
constexpr unsigned int PA_CL_VS_OUT_CNTL__CULL_DIST_ENA_7__SHIFT          = 0x0000000f;
constexpr unsigned int PA_CL_VS_OUT_CNTL__USE_VTX_EDGE_FLAG__SHIFT        = 0x00000011;
constexpr unsigned int PA_CL_VS_OUT_CNTL__USE_VTX_GS_CUT_FLAG__SHIFT      = 0x00000019;
constexpr unsigned int PA_CL_VS_OUT_CNTL__USE_VTX_KILL_FLAG__SHIFT        = 0x00000014;
constexpr unsigned int PA_CL_VS_OUT_CNTL__USE_VTX_POINT_SIZE__SHIFT       = 0x00000010;
constexpr unsigned int PA_CL_VS_OUT_CNTL__USE_VTX_RENDER_TARGET_INDX__SHIFT = 0x00000012;
constexpr unsigned int PA_CL_VS_OUT_CNTL__USE_VTX_VIEWPORT_INDX__SHIFT    = 0x00000013;
constexpr unsigned int PA_CL_VS_OUT_CNTL__VS_OUT_CCDIST0_VEC_ENA__SHIFT   = 0x00000016;
constexpr unsigned int PA_CL_VS_OUT_CNTL__VS_OUT_CCDIST1_VEC_ENA__SHIFT   = 0x00000017;
constexpr unsigned int PA_CL_VS_OUT_CNTL__VS_OUT_MISC_SIDE_BUS_ENA__SHIFT = 0x00000018;
constexpr unsigned int PA_CL_VS_OUT_CNTL__VS_OUT_MISC_VEC_ENA__SHIFT      = 0x00000015;
constexpr unsigned int PA_CL_VTE_CNTL__PERFCOUNTER_REF__SHIFT             = 0x0000000b;
constexpr unsigned int PA_CL_VTE_CNTL__VPORT_X_OFFSET_ENA__SHIFT          = 0x00000001;
constexpr unsigned int PA_CL_VTE_CNTL__VPORT_X_SCALE_ENA__SHIFT           = 0x00000000;
constexpr unsigned int PA_CL_VTE_CNTL__VPORT_Y_OFFSET_ENA__SHIFT          = 0x00000003;
constexpr unsigned int PA_CL_VTE_CNTL__VPORT_Y_SCALE_ENA__SHIFT           = 0x00000002;
constexpr unsigned int PA_CL_VTE_CNTL__VPORT_Z_OFFSET_ENA__SHIFT          = 0x00000005;
constexpr unsigned int PA_CL_VTE_CNTL__VPORT_Z_SCALE_ENA__SHIFT           = 0x00000004;
constexpr unsigned int PA_CL_VTE_CNTL__VTX_W0_FMT__SHIFT                  = 0x0000000a;
constexpr unsigned int PA_CL_VTE_CNTL__VTX_XY_FMT__SHIFT                  = 0x00000008;
constexpr unsigned int PA_CL_VTE_CNTL__VTX_Z_FMT__SHIFT                   = 0x00000009;
constexpr unsigned int PA_SC_AA_CONFIG__AA_MASK_CENTROID_DTMN__SHIFT      = 0x00000004;
constexpr unsigned int PA_SC_AA_CONFIG__COVERAGE_TO_SHADER_SELECT__SHIFT  = 0x0000001a;
constexpr unsigned int PA_SC_AA_CONFIG__DETAIL_TO_EXPOSED_MODE__SHIFT     = 0x00000018;
constexpr unsigned int PA_SC_AA_CONFIG__MAX_SAMPLE_DIST__SHIFT            = 0x0000000d;
constexpr unsigned int PA_SC_AA_CONFIG__MSAA_EXPOSED_SAMPLES__SHIFT       = 0x00000014;
constexpr unsigned int PA_SC_AA_CONFIG__MSAA_NUM_SAMPLES__SHIFT           = 0x00000000;
constexpr unsigned int PA_SC_AA_MASK_X0Y0_X1Y0__AA_MASK_X0Y0__SHIFT       = 0x00000000;
constexpr unsigned int PA_SC_AA_MASK_X0Y0_X1Y0__AA_MASK_X1Y0__SHIFT       = 0x00000010;
constexpr unsigned int PA_SC_AA_MASK_X0Y1_X1Y1__AA_MASK_X0Y1__SHIFT       = 0x00000000;
constexpr unsigned int PA_SC_AA_MASK_X0Y1_X1Y1__AA_MASK_X1Y1__SHIFT       = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0__S0_X__SHIFT     = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0__S0_Y__SHIFT     = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0__S1_X__SHIFT     = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0__S1_Y__SHIFT     = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0__S2_X__SHIFT     = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0__S2_Y__SHIFT     = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0__S3_X__SHIFT     = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_0__S3_Y__SHIFT     = 0x0000001c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1__S4_X__SHIFT     = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1__S4_Y__SHIFT     = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1__S5_X__SHIFT     = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1__S5_Y__SHIFT     = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1__S6_X__SHIFT     = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1__S6_Y__SHIFT     = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1__S7_X__SHIFT     = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_1__S7_Y__SHIFT     = 0x0000001c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2__S8_X__SHIFT     = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2__S8_Y__SHIFT     = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2__S9_X__SHIFT     = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2__S9_Y__SHIFT     = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2__S10_X__SHIFT    = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2__S10_Y__SHIFT    = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2__S11_X__SHIFT    = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_2__S11_Y__SHIFT    = 0x0000001c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3__S12_X__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3__S12_Y__SHIFT    = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3__S13_X__SHIFT    = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3__S13_Y__SHIFT    = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3__S14_X__SHIFT    = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3__S14_Y__SHIFT    = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3__S15_X__SHIFT    = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y0_3__S15_Y__SHIFT    = 0x0000001c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0__S0_X__SHIFT     = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0__S0_Y__SHIFT     = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0__S1_X__SHIFT     = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0__S1_Y__SHIFT     = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0__S2_X__SHIFT     = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0__S2_Y__SHIFT     = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0__S3_X__SHIFT     = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_0__S3_Y__SHIFT     = 0x0000001c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1__S4_X__SHIFT     = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1__S4_Y__SHIFT     = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1__S5_X__SHIFT     = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1__S5_Y__SHIFT     = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1__S6_X__SHIFT     = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1__S6_Y__SHIFT     = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1__S7_X__SHIFT     = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_1__S7_Y__SHIFT     = 0x0000001c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2__S8_X__SHIFT     = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2__S8_Y__SHIFT     = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2__S9_X__SHIFT     = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2__S9_Y__SHIFT     = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2__S10_X__SHIFT    = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2__S10_Y__SHIFT    = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2__S11_X__SHIFT    = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_2__S11_Y__SHIFT    = 0x0000001c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3__S12_X__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3__S12_Y__SHIFT    = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3__S13_X__SHIFT    = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3__S13_Y__SHIFT    = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3__S14_X__SHIFT    = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3__S14_Y__SHIFT    = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3__S15_X__SHIFT    = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X0Y1_3__S15_Y__SHIFT    = 0x0000001c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0__S0_X__SHIFT     = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0__S0_Y__SHIFT     = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0__S1_X__SHIFT     = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0__S1_Y__SHIFT     = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0__S2_X__SHIFT     = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0__S2_Y__SHIFT     = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0__S3_X__SHIFT     = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_0__S3_Y__SHIFT     = 0x0000001c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1__S4_X__SHIFT     = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1__S4_Y__SHIFT     = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1__S5_X__SHIFT     = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1__S5_Y__SHIFT     = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1__S6_X__SHIFT     = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1__S6_Y__SHIFT     = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1__S7_X__SHIFT     = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_1__S7_Y__SHIFT     = 0x0000001c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2__S8_X__SHIFT     = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2__S8_Y__SHIFT     = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2__S9_X__SHIFT     = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2__S9_Y__SHIFT     = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2__S10_X__SHIFT    = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2__S10_Y__SHIFT    = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2__S11_X__SHIFT    = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_2__S11_Y__SHIFT    = 0x0000001c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3__S12_X__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3__S12_Y__SHIFT    = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3__S13_X__SHIFT    = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3__S13_Y__SHIFT    = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3__S14_X__SHIFT    = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3__S14_Y__SHIFT    = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3__S15_X__SHIFT    = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y0_3__S15_Y__SHIFT    = 0x0000001c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0__S0_X__SHIFT     = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0__S0_Y__SHIFT     = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0__S1_X__SHIFT     = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0__S1_Y__SHIFT     = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0__S2_X__SHIFT     = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0__S2_Y__SHIFT     = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0__S3_X__SHIFT     = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_0__S3_Y__SHIFT     = 0x0000001c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1__S4_X__SHIFT     = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1__S4_Y__SHIFT     = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1__S5_X__SHIFT     = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1__S5_Y__SHIFT     = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1__S6_X__SHIFT     = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1__S6_Y__SHIFT     = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1__S7_X__SHIFT     = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_1__S7_Y__SHIFT     = 0x0000001c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2__S8_X__SHIFT     = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2__S8_Y__SHIFT     = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2__S9_X__SHIFT     = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2__S9_Y__SHIFT     = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2__S10_X__SHIFT    = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2__S10_Y__SHIFT    = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2__S11_X__SHIFT    = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_2__S11_Y__SHIFT    = 0x0000001c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3__S12_X__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3__S12_Y__SHIFT    = 0x00000004;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3__S13_X__SHIFT    = 0x00000008;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3__S13_Y__SHIFT    = 0x0000000c;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3__S14_X__SHIFT    = 0x00000010;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3__S14_Y__SHIFT    = 0x00000014;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3__S15_X__SHIFT    = 0x00000018;
constexpr unsigned int PA_SC_AA_SAMPLE_LOCS_PIXEL_X1Y1_3__S15_Y__SHIFT    = 0x0000001c;
constexpr unsigned int PA_SC_BINNER_CNTL_0__BINNING_MODE__SHIFT           = 0x00000000;
constexpr unsigned int PA_SC_BINNER_CNTL_0__BIN_SIZE_X_EXTEND__SHIFT      = 0x00000004;
constexpr unsigned int PA_SC_BINNER_CNTL_0__BIN_SIZE_X__SHIFT             = 0x00000002;
constexpr unsigned int PA_SC_BINNER_CNTL_0__BIN_SIZE_Y_EXTEND__SHIFT      = 0x00000007;
constexpr unsigned int PA_SC_BINNER_CNTL_0__BIN_SIZE_Y__SHIFT             = 0x00000003;
constexpr unsigned int PA_SC_BINNER_CNTL_0__CONTEXT_STATES_PER_BIN__SHIFT = 0x0000000a;
constexpr unsigned int PA_SC_BINNER_CNTL_0__DISABLE_START_OF_PRIM__SHIFT  = 0x00000012;
constexpr unsigned int PA_SC_BINNER_CNTL_0__FPOVS_PER_BATCH__SHIFT        = 0x00000013;
constexpr unsigned int PA_SC_BINNER_CNTL_0__OPTIMAL_BIN_SELECTION__SHIFT  = 0x0000001b;
constexpr unsigned int PA_SC_BINNER_CNTL_0__PERSISTENT_STATES_PER_BIN__SHIFT = 0x0000000d;
constexpr unsigned int PA_SC_BINNER_CNTL_1__MAX_ALLOC_COUNT__SHIFT        = 0x00000000;
constexpr unsigned int PA_SC_BINNER_CNTL_1__MAX_PRIM_PER_BATCH__SHIFT     = 0x00000010;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__BREAK_BATCH__SHIFT      = 0x0000001c;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__CACHE_FLUSH_TS__SHIFT   = 0x00000008;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__CACHE_FLUSH__SHIFT      = 0x0000000c;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__CONTEXT_DONE__SHIFT     = 0x0000000a;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__CS_PARTIAL_FLUSH__SHIFT = 0x0000000e;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__END_OF_PIPE_IB_END__SHIFT = 0x00000018;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__END_OF_PIPE_INCR_DE__SHIFT = 0x00000016;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__RESERVED_0__SHIFT       = 0x00000000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__RESERVED_9__SHIFT       = 0x00000012;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__RST_PIX_CNT__SHIFT      = 0x0000001a;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__SAMPLE_STREAMOUTSTATS1__SHIFT = 0x00000002;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__SAMPLE_STREAMOUTSTATS2__SHIFT = 0x00000004;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__SAMPLE_STREAMOUTSTATS3__SHIFT = 0x00000006;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__VGT_STREAMOUT_RESET__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__VGT_STREAMOUT_SYNC__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_0__VS_PARTIAL_FLUSH__SHIFT = 0x0000001e;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__CACHE_FLUSH_AND_INV_EVENT__SHIFT = 0x0000000c;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__CACHE_FLUSH_AND_INV_TS_EVENT__SHIFT = 0x00000008;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__FLUSH_DFSM__SHIFT       = 0x00000004;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__FLUSH_ES_OUTPUT__SHIFT  = 0x00000018;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__FLUSH_HS_OUTPUT__SHIFT  = 0x00000002;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__PERFCOUNTER_SAMPLE__SHIFT = 0x00000016;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__PERFCOUNTER_START__SHIFT = 0x0000000e;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__PERFCOUNTER_STOP__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__PIPELINESTAT_START__SHIFT = 0x00000012;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__PIPELINESTAT_STOP__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__PS_PARTIAL_FLUSH__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__RESET_TO_LOWEST_VGT__SHIFT = 0x00000006;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__SAMPLE_PIPELINESTAT__SHIFT = 0x0000001c;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__SO_VGTSTREAMOUT_FLUSH__SHIFT = 0x0000001e;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__ZPASS_DONE__SHIFT       = 0x0000000a;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__BLOCK_CONTEXT_DONE__SHIFT = 0x00000004;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__BOTTOM_OF_PIPE_TS__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__CS_DONE__SHIFT          = 0x0000001e;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__DB_CACHE_FLUSH_AND_INV__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__FLUSH_AND_INV_CB_DATA_TS__SHIFT = 0x0000001a;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__FLUSH_AND_INV_CB_META__SHIFT = 0x0000001c;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__FLUSH_AND_INV_DB_DATA_TS__SHIFT = 0x00000016;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__FLUSH_AND_INV_DB_META__SHIFT = 0x00000018;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__RESET_VTX_CNT__SHIFT    = 0x00000002;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__SAMPLE_STREAMOUTSTATS__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__SC_SEND_DB_VPZ__SHIFT   = 0x0000000e;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__SQ_NON_EVENT__SHIFT     = 0x0000000c;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__TGID_ROLLOVER__SHIFT    = 0x0000000a;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__VGT_FLUSH__SHIFT        = 0x00000008;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__CONTEXT_SUSPEND__SHIFT  = 0x00000016;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__ENABLE_LEGACY_PIPELINE__SHIFT = 0x0000001c;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__ENABLE_NGG_PIPELINE__SHIFT = 0x0000001a;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__FLUSH_AND_INV_CB_PIXEL_DATA__SHIFT = 0x00000002;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__OFFCHIP_HS_DEALLOC__SHIFT = 0x00000018;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__PIXEL_PIPE_STAT_CONTROL__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__PIXEL_PIPE_STAT_DUMP__SHIFT = 0x00000012;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__PIXEL_PIPE_STAT_RESET__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__PS_DONE__SHIFT          = 0x00000000;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__THREAD_TRACE_FINISH__SHIFT = 0x0000000e;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__THREAD_TRACE_MARKER__SHIFT = 0x0000000a;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__THREAD_TRACE_START__SHIFT = 0x00000006;
constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__THREAD_TRACE_STOP__SHIFT = 0x00000008;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_0__BATCH_HIST_NUM_CONTEXT_THRESHOLD__SHIFT = 0x00000017;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_0__BATCH_HIST_NUM_PRIMS_THRESHOLD__SHIFT = 0x0000000a;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_0__BIN_HIST_NUM_CONTEXT_THRESHOLD__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_0__BIN_HIST_NUM_PRIMS_THRESHOLD__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_1__BATCH_HIST_NUM_PERSISTENT_STATE_THRESHOLD__SHIFT = 0x00000005;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_1__BATCH_HIST_NUM_TRIV_REJECTED_PRIMS_THRESHOLD__SHIFT = 0x0000000a;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_1__BIN_HIST_NUM_PERSISTENT_STATE_THRESHOLD__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_2__BATCH_HIST_NUM_COLUMNS_PER_ROW_THRESHOLD__SHIFT = 0x0000000b;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_2__BATCH_HIST_NUM_ROWS_PER_PRIM_THRESHOLD__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_BINNER_PERF_CNTL_3__BATCH_HIST_NUM_PS_WAVE_BREAKS_THRESHOLD__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_BINNER_TIMEOUT_COUNTER__THRESHOLD__SHIFT     = 0x00000000;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_0__DISTANCE_0__SHIFT       = 0x00000000;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_0__DISTANCE_1__SHIFT       = 0x00000004;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_0__DISTANCE_2__SHIFT       = 0x00000008;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_0__DISTANCE_3__SHIFT       = 0x0000000c;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_0__DISTANCE_4__SHIFT       = 0x00000010;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_0__DISTANCE_5__SHIFT       = 0x00000014;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_0__DISTANCE_6__SHIFT       = 0x00000018;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_0__DISTANCE_7__SHIFT       = 0x0000001c;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_1__DISTANCE_8__SHIFT       = 0x00000000;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_1__DISTANCE_9__SHIFT       = 0x00000004;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_1__DISTANCE_10__SHIFT      = 0x00000008;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_1__DISTANCE_11__SHIFT      = 0x0000000c;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_1__DISTANCE_12__SHIFT      = 0x00000010;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_1__DISTANCE_13__SHIFT      = 0x00000014;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_1__DISTANCE_14__SHIFT      = 0x00000018;
constexpr unsigned int PA_SC_CENTROID_PRIORITY_1__DISTANCE_15__SHIFT      = 0x0000001c;
constexpr unsigned int PA_SC_CLIPRECT_0_BR__BR_X__SHIFT                   = 0x00000000;
constexpr unsigned int PA_SC_CLIPRECT_0_BR__BR_Y__SHIFT                   = 0x00000010;
constexpr unsigned int PA_SC_CLIPRECT_0_TL__TL_X__SHIFT                   = 0x00000000;
constexpr unsigned int PA_SC_CLIPRECT_0_TL__TL_Y__SHIFT                   = 0x00000010;
constexpr unsigned int PA_SC_CLIPRECT_1_BR__BR_X__SHIFT                   = 0x00000000;
constexpr unsigned int PA_SC_CLIPRECT_1_BR__BR_Y__SHIFT                   = 0x00000010;
constexpr unsigned int PA_SC_CLIPRECT_1_TL__TL_X__SHIFT                   = 0x00000000;
constexpr unsigned int PA_SC_CLIPRECT_1_TL__TL_Y__SHIFT                   = 0x00000010;
constexpr unsigned int PA_SC_CLIPRECT_2_BR__BR_X__SHIFT                   = 0x00000000;
constexpr unsigned int PA_SC_CLIPRECT_2_BR__BR_Y__SHIFT                   = 0x00000010;
constexpr unsigned int PA_SC_CLIPRECT_2_TL__TL_X__SHIFT                   = 0x00000000;
constexpr unsigned int PA_SC_CLIPRECT_2_TL__TL_Y__SHIFT                   = 0x00000010;
constexpr unsigned int PA_SC_CLIPRECT_3_BR__BR_X__SHIFT                   = 0x00000000;
constexpr unsigned int PA_SC_CLIPRECT_3_BR__BR_Y__SHIFT                   = 0x00000010;
constexpr unsigned int PA_SC_CLIPRECT_3_TL__TL_X__SHIFT                   = 0x00000000;
constexpr unsigned int PA_SC_CLIPRECT_3_TL__TL_Y__SHIFT                   = 0x00000010;
constexpr unsigned int PA_SC_CLIPRECT_RULE__CLIP_RULE__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__CENTROID_SAMPLE_OVERRIDE__SHIFT = 0x00000018;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__COVERAGE_AA_MASK_ENABLE__SHIFT = 0x00000015;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__DEGENERATE_OVERRIDE_INNER_TO_NORMAL_DISABLE__SHIFT = 0x0000000f;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__INNER_UNCERTAINTY_EDGERULE_OVERRIDE__SHIFT = 0x00000013;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__NULL_SQUAD_AA_MASK_ENABLE__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__OUTER_UNCERTAINTY_EDGERULE_OVERRIDE__SHIFT = 0x00000012;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__OVERRIDE_OVER_RAST_INNER_TO_NORMAL__SHIFT = 0x0000000d;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__OVERRIDE_UNDER_RAST_INNER_TO_NORMAL__SHIFT = 0x0000000e;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__OVER_RAST_ENABLE__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__OVER_RAST_SAMPLE_SELECT__SHIFT = 0x00000001;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__PBB_UNCERTAINTY_REGION_ENABLE__SHIFT = 0x0000000a;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__POSTZ_AA_MASK_ENABLE__SHIFT = 0x00000017;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__PREZ_AA_MASK_ENABLE__SHIFT = 0x00000016;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__UNCERTAINTY_REGION_MODE__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__UNDER_RAST_ENABLE__SHIFT = 0x00000005;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__UNDER_RAST_SAMPLE_SELECT__SHIFT = 0x00000006;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__ZMM_TRI_EXTENT__SHIFT = 0x0000000b;
constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__ZMM_TRI_OFFSET__SHIFT = 0x0000000c;
constexpr unsigned int PA_SC_DSM_CNTL__FORCE_EOV_REZ_0__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_DSM_CNTL__FORCE_EOV_REZ_1__SHIFT             = 0x00000001;
constexpr unsigned int PA_SC_EDGERULE__ER_LINE_BT__SHIFT                  = 0x0000001c;
constexpr unsigned int PA_SC_EDGERULE__ER_LINE_LR__SHIFT                  = 0x0000000c;
constexpr unsigned int PA_SC_EDGERULE__ER_LINE_RL__SHIFT                  = 0x00000012;
constexpr unsigned int PA_SC_EDGERULE__ER_LINE_TB__SHIFT                  = 0x00000018;
constexpr unsigned int PA_SC_EDGERULE__ER_POINT__SHIFT                    = 0x00000004;
constexpr unsigned int PA_SC_EDGERULE__ER_RECT__SHIFT                     = 0x00000008;
constexpr unsigned int PA_SC_EDGERULE__ER_TRI__SHIFT                      = 0x00000000;
constexpr unsigned int PA_SC_ENHANCE_1__BYPASS_PBB__SHIFT                 = 0x00000004;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_PACKER_ODC_ENHANCE__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_PBB_BINNING_CLK_OPTIMIZATION__SHIFT = 0x00000016;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_PBB_CLK_OPTIMIZATION__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_PBB_SCISSOR_CLK_OPTIMIZATION__SHIFT = 0x00000015;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_PBB_SCISSOR_OPT__SHIFT    = 0x0000000a;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_SC_BINNING__SHIFT         = 0x00000003;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_SC_DB_TILE_INTF_FINE_CLOCK_GATE__SHIFT = 0x0000000e;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_SC_PIPELINE_RESET_LEGACY_MODE_TRANSITION__SHIFT = 0x0000000f;
constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_SC_PROCESS_RESET_PBB__SHIFT = 0x00000009;
constexpr unsigned int PA_SC_ENHANCE_1__ECO_SPARE0__SHIFT                 = 0x00000005;
constexpr unsigned int PA_SC_ENHANCE_1__ECO_SPARE1__SHIFT                 = 0x00000006;
constexpr unsigned int PA_SC_ENHANCE_1__ECO_SPARE2__SHIFT                 = 0x00000007;
constexpr unsigned int PA_SC_ENHANCE_1__ECO_SPARE3__SHIFT                 = 0x00000008;
constexpr unsigned int PA_SC_ENHANCE_1__OPTIMAL_BIN_SELECTION__SHIFT      = 0x00000012;
constexpr unsigned int PA_SC_ENHANCE_1__REALIGN_DQUADS_OVERRIDE_ENABLE__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_ENHANCE_1__REALIGN_DQUADS_OVERRIDE__SHIFT    = 0x00000001;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_AA_MASK_FULL_FIX__SHIFT     = 0x00000002;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_DUALGRAD_PERF_OPTIMIZATION__SHIFT = 0x00000007;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_EOP_LINE_STIPPLE_RESET__SHIFT = 0x0000001a;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_EOV_ALL_CTRL_ONLY_COMBINATIONS__SHIFT = 0x0000000c;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_OOO_NO_EOPG_SKEW_DESIRED_FIFO_IS_CURRENT_FIFO__SHIFT = 0x00000017;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_OUT_OF_ORDER_DESIRED_FIFO_EMPTY_SWITCHING__SHIFT = 0x00000013;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_OUT_OF_ORDER_EMPTY_SWITCHING_HYSTERYSIS__SHIFT = 0x00000015;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_OUT_OF_ORDER_EOP_SYNC_NULL_PRIMS_LAST__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_OUT_OF_ORDER_PA_SC_GUIDANCE__SHIFT = 0x0000000e;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_OUT_OF_ORDER_SELECTED_FIFO_EMPTY_SWITCHING__SHIFT = 0x00000014;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_OUT_OF_ORDER_THRESHOLD_SWITCHING__SHIFT = 0x00000011;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_PA_SC_GUIDANCE__SHIFT       = 0x0000000b;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_SCISSOR_FIX__SHIFT          = 0x00000005;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_SC_DB_TILE_FIX__SHIFT       = 0x00000001;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_SC_PROCESS_RESET_PRIM__SHIFT = 0x00000008;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_SC_PROCESS_RESET_SUPERTILE__SHIFT = 0x00000009;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_SC_PROCESS_RESET_TILE__SHIFT = 0x0000000a;
constexpr unsigned int PA_SC_ENHANCE__DISABLE_VPZ_EOP_LINE_STIPPLE_RESET__SHIFT = 0x0000001b;
constexpr unsigned int PA_SC_ENHANCE__ENABLE_1XMSAA_SAMPLE_LOCATIONS__SHIFT = 0x00000003;
constexpr unsigned int PA_SC_ENHANCE__ENABLE_1XMSAA_SAMPLE_LOC_CENTROID__SHIFT = 0x00000004;
constexpr unsigned int PA_SC_ENHANCE__ENABLE_MULTICYCLE_BUBBLE_FREEZE__SHIFT = 0x0000000d;
constexpr unsigned int PA_SC_ENHANCE__ENABLE_OUT_OF_ORDER_DESIRED_FIFO_IS_NEXT_FEID__SHIFT = 0x00000016;
constexpr unsigned int PA_SC_ENHANCE__ENABLE_OUT_OF_ORDER_POLY_MODE__SHIFT = 0x0000000f;
constexpr unsigned int PA_SC_ENHANCE__ENABLE_OUT_OF_ORDER_THRESHOLD_SWITCH_AT_EOPG_ONLY__SHIFT = 0x00000012;
constexpr unsigned int PA_SC_ENHANCE__ENABLE_PA_SC_OUT_OF_ORDER__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_ENHANCE__IOO_DISABLE_SCAN_UNSELECTED_FIFOS_FOR_DUAL_GFX_RING_CHANGE__SHIFT = 0x0000001c;
constexpr unsigned int PA_SC_ENHANCE__OOO_DISABLE_EOPG_SKEW_THRESHOLD_SWITCHING__SHIFT = 0x00000019;
constexpr unsigned int PA_SC_ENHANCE__OOO_DISABLE_EOP_ON_FIRST_LIVE_PRIM_HIT__SHIFT = 0x00000018;
constexpr unsigned int PA_SC_ENHANCE__OOO_USE_ABSOLUTE_FIFO_COUNT_IN_THRESHOLD_SWITCHING__SHIFT = 0x0000001d;
constexpr unsigned int PA_SC_ENHANCE__SEND_UNLIT_STILES_TO_PACKER__SHIFT  = 0x00000006;
constexpr unsigned int PA_SC_FIFO_DEPTH_CNTL__DEPTH__SHIFT                = 0x00000000;
constexpr unsigned int PA_SC_FIFO_SIZE__SC_BACKEND_PRIM_FIFO_SIZE__SHIFT  = 0x00000006;
constexpr unsigned int PA_SC_FIFO_SIZE__SC_EARLYZ_TILE_FIFO_SIZE__SHIFT   = 0x00000015;
constexpr unsigned int PA_SC_FIFO_SIZE__SC_FRONTEND_PRIM_FIFO_SIZE__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_FIFO_SIZE__SC_HIZ_TILE_FIFO_SIZE__SHIFT      = 0x0000000f;
constexpr unsigned int PA_SC_FORCE_EOV_MAX_CNTS__FORCE_EOV_MAX_CLK_CNT__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_FORCE_EOV_MAX_CNTS__FORCE_EOV_MAX_REZ_CNT__SHIFT = 0x00000010;
constexpr unsigned int PA_SC_GENERIC_SCISSOR_BR__BR_X__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_GENERIC_SCISSOR_BR__BR_Y__SHIFT              = 0x00000010;
constexpr unsigned int PA_SC_GENERIC_SCISSOR_TL__TL_X__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_GENERIC_SCISSOR_TL__TL_Y__SHIFT              = 0x00000010;
constexpr unsigned int PA_SC_GENERIC_SCISSOR_TL__WINDOW_OFFSET_DISABLE__SHIFT = 0x0000001f;
constexpr unsigned int PA_SC_HP3D_TRAP_SCREEN_COUNT__COUNT__SHIFT         = 0x00000000;
constexpr unsigned int PA_SC_HP3D_TRAP_SCREEN_HV_EN__ENABLE_HV_PRE_SHADER__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_HP3D_TRAP_SCREEN_HV_EN__FORCE_PRE_SHADER_ALL_PIXELS__SHIFT = 0x00000001;
constexpr unsigned int PA_SC_HP3D_TRAP_SCREEN_HV_LOCK__DISABLE_NON_PRIV_WRITES__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_HP3D_TRAP_SCREEN_H__X_COORD__SHIFT           = 0x00000000;
constexpr unsigned int PA_SC_HP3D_TRAP_SCREEN_OCCURRENCE__COUNT__SHIFT    = 0x00000000;
constexpr unsigned int PA_SC_HP3D_TRAP_SCREEN_V__Y_COORD__SHIFT           = 0x00000000;
constexpr unsigned int PA_SC_IF_FIFO_SIZE__SC_BCI_IF_FIFO_SIZE__SHIFT     = 0x00000012;
constexpr unsigned int PA_SC_IF_FIFO_SIZE__SC_DB_QUAD_IF_FIFO_SIZE__SHIFT = 0x00000006;
constexpr unsigned int PA_SC_IF_FIFO_SIZE__SC_DB_TILE_IF_FIFO_SIZE__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_IF_FIFO_SIZE__SC_SPI_IF_FIFO_SIZE__SHIFT     = 0x0000000c;
constexpr unsigned int PA_SC_LINE_CNTL__DX10_DIAMOND_TEST_ENA__SHIFT      = 0x0000000c;
constexpr unsigned int PA_SC_LINE_CNTL__EXPAND_LINE_WIDTH__SHIFT          = 0x00000009;
constexpr unsigned int PA_SC_LINE_CNTL__LAST_PIXEL__SHIFT                 = 0x0000000a;
constexpr unsigned int PA_SC_LINE_CNTL__PERPENDICULAR_ENDCAP_ENA__SHIFT   = 0x0000000b;
constexpr unsigned int PA_SC_LINE_STIPPLE_STATE__CURRENT_COUNT__SHIFT     = 0x00000008;
constexpr unsigned int PA_SC_LINE_STIPPLE_STATE__CURRENT_PTR__SHIFT       = 0x00000000;
constexpr unsigned int PA_SC_LINE_STIPPLE__AUTO_RESET_CNTL__SHIFT         = 0x0000001d;
constexpr unsigned int PA_SC_LINE_STIPPLE__LINE_PATTERN__SHIFT            = 0x00000000;
constexpr unsigned int PA_SC_LINE_STIPPLE__PATTERN_BIT_ORDER__SHIFT       = 0x0000001c;
constexpr unsigned int PA_SC_LINE_STIPPLE__REPEAT_COUNT__SHIFT            = 0x00000010;
constexpr unsigned int PA_SC_MODE_CNTL_0__COARSE_TILE_STARTS_ON_EVEN_RB__SHIFT = 0x00000006;
constexpr unsigned int PA_SC_MODE_CNTL_0__LINE_STIPPLE_ENABLE__SHIFT      = 0x00000002;
constexpr unsigned int PA_SC_MODE_CNTL_0__MSAA_ENABLE__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_MODE_CNTL_0__SEND_UNLIT_STILES_TO_PKR__SHIFT = 0x00000003;
constexpr unsigned int PA_SC_MODE_CNTL_0__VPORT_SCISSOR_ENABLE__SHIFT     = 0x00000001;
constexpr unsigned int PA_SC_MODE_CNTL_1__FORCE_EOV_CNTDWN_ENABLE__SHIFT  = 0x00000019;
constexpr unsigned int PA_SC_MODE_CNTL_1__FORCE_EOV_REZ_ENABLE__SHIFT     = 0x0000001a;
constexpr unsigned int PA_SC_MODE_CNTL_1__GPU_ID_OVERRIDE_ENABLE__SHIFT   = 0x00000013;
constexpr unsigned int PA_SC_MODE_CNTL_1__GPU_ID_OVERRIDE__SHIFT          = 0x00000014;
constexpr unsigned int PA_SC_MODE_CNTL_1__KILL_PIX_POST_DETAIL_MASK__SHIFT = 0x0000000f;
constexpr unsigned int PA_SC_MODE_CNTL_1__KILL_PIX_POST_HI_Z__SHIFT       = 0x0000000e;
constexpr unsigned int PA_SC_MODE_CNTL_1__MULTI_GPU_PRIM_DISCARD_ENABLE__SHIFT = 0x00000018;
constexpr unsigned int PA_SC_MODE_CNTL_1__MULTI_GPU_SUPERTILE_ENABLE__SHIFT = 0x00000012;
constexpr unsigned int PA_SC_MODE_CNTL_1__MULTI_SHADER_ENGINE_PRIM_DISCARD_ENABLE__SHIFT = 0x00000011;
constexpr unsigned int PA_SC_MODE_CNTL_1__OUT_OF_ORDER_PRIMITIVE_ENABLE__SHIFT = 0x0000001b;
constexpr unsigned int PA_SC_MODE_CNTL_1__OUT_OF_ORDER_WATER_MARK__SHIFT  = 0x0000001c;
constexpr unsigned int PA_SC_MODE_CNTL_1__PS_ITER_SAMPLE__SHIFT           = 0x00000010;
constexpr unsigned int PA_SC_MODE_CNTL_1__SUPERTILE_WALK_ORDER_ENABLE__SHIFT = 0x00000007;
constexpr unsigned int PA_SC_MODE_CNTL_1__TILE_COVER_DISABLE__SHIFT       = 0x00000009;
constexpr unsigned int PA_SC_MODE_CNTL_1__TILE_COVER_NO_SCISSOR__SHIFT    = 0x0000000a;
constexpr unsigned int PA_SC_MODE_CNTL_1__TILE_WALK_ORDER_ENABLE__SHIFT   = 0x00000008;
constexpr unsigned int PA_SC_MODE_CNTL_1__WALK_ALIGN8_PRIM_FITS_ST__SHIFT = 0x00000002;
constexpr unsigned int PA_SC_MODE_CNTL_1__WALK_ALIGNMENT__SHIFT           = 0x00000001;
constexpr unsigned int PA_SC_MODE_CNTL_1__WALK_FENCE_ENABLE__SHIFT        = 0x00000003;
constexpr unsigned int PA_SC_MODE_CNTL_1__WALK_FENCE_SIZE__SHIFT          = 0x00000004;
constexpr unsigned int PA_SC_MODE_CNTL_1__WALK_SIZE__SHIFT                = 0x00000000;
constexpr unsigned int PA_SC_MODE_CNTL_1__ZMM_LINE_EXTENT__SHIFT          = 0x0000000b;
constexpr unsigned int PA_SC_MODE_CNTL_1__ZMM_LINE_OFFSET__SHIFT          = 0x0000000c;
constexpr unsigned int PA_SC_MODE_CNTL_1__ZMM_RECT_EXTENT__SHIFT          = 0x0000000d;
constexpr unsigned int PA_SC_NGG_MODE_CNTL__MAX_DEALLOCS_IN_WAVE__SHIFT   = 0x00000000;
constexpr unsigned int PA_SC_P3D_TRAP_SCREEN_COUNT__COUNT__SHIFT          = 0x00000000;
constexpr unsigned int PA_SC_P3D_TRAP_SCREEN_HV_EN__ENABLE_HV_PRE_SHADER__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_P3D_TRAP_SCREEN_HV_EN__FORCE_PRE_SHADER_ALL_PIXELS__SHIFT = 0x00000001;
constexpr unsigned int PA_SC_P3D_TRAP_SCREEN_HV_LOCK__DISABLE_NON_PRIV_WRITES__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_P3D_TRAP_SCREEN_H__X_COORD__SHIFT            = 0x00000000;
constexpr unsigned int PA_SC_P3D_TRAP_SCREEN_OCCURRENCE__COUNT__SHIFT     = 0x00000000;
constexpr unsigned int PA_SC_P3D_TRAP_SCREEN_V__Y_COORD__SHIFT            = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT       = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT       = 0x0000000a;
constexpr unsigned int PA_SC_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT        = 0x00000014;
constexpr unsigned int PA_SC_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT        = 0x0000000a;
constexpr unsigned int PA_SC_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER4_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER4_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER4_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER5_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER5_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER5_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER6_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER6_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER6_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER7_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER7_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int PA_SC_PERFCOUNTER7_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int PA_SC_PKR_WAVE_TABLE_CNTL__SIZE__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_RASTER_CONFIG_1__SE_PAIR_MAP__SHIFT          = 0x00000000;
constexpr unsigned int PA_SC_RASTER_CONFIG_1__SE_PAIR_XSEL__SHIFT         = 0x00000002;
constexpr unsigned int PA_SC_RASTER_CONFIG__PKR_MAP__SHIFT                = 0x00000008;
constexpr unsigned int PA_SC_RASTER_CONFIG__PKR_XSEL2__SHIFT              = 0x0000000e;
constexpr unsigned int PA_SC_RASTER_CONFIG__PKR_XSEL__SHIFT               = 0x0000000a;
constexpr unsigned int PA_SC_RASTER_CONFIG__PKR_YSEL__SHIFT               = 0x0000000c;
constexpr unsigned int PA_SC_RASTER_CONFIG__RB_MAP_PKR0__SHIFT            = 0x00000000;
constexpr unsigned int PA_SC_RASTER_CONFIG__RB_MAP_PKR1__SHIFT            = 0x00000002;
constexpr unsigned int PA_SC_RASTER_CONFIG__RB_XSEL2__SHIFT               = 0x00000004;
constexpr unsigned int PA_SC_RASTER_CONFIG__RB_XSEL__SHIFT                = 0x00000006;
constexpr unsigned int PA_SC_RASTER_CONFIG__RB_YSEL__SHIFT                = 0x00000007;
constexpr unsigned int PA_SC_RASTER_CONFIG__SC_MAP__SHIFT                 = 0x00000010;
constexpr unsigned int PA_SC_RASTER_CONFIG__SC_XSEL__SHIFT                = 0x00000012;
constexpr unsigned int PA_SC_RASTER_CONFIG__SC_YSEL__SHIFT                = 0x00000014;
constexpr unsigned int PA_SC_RASTER_CONFIG__SE_MAP__SHIFT                 = 0x00000018;
constexpr unsigned int PA_SC_RASTER_CONFIG__SE_XSEL__SHIFT                = 0x0000001a;
constexpr unsigned int PA_SC_SCREEN_SCISSOR_BR__BR_X__SHIFT               = 0x00000000;
constexpr unsigned int PA_SC_SCREEN_SCISSOR_BR__BR_Y__SHIFT               = 0x00000010;
constexpr unsigned int PA_SC_SCREEN_SCISSOR_TL__TL_X__SHIFT               = 0x00000000;
constexpr unsigned int PA_SC_SCREEN_SCISSOR_TL__TL_Y__SHIFT               = 0x00000010;
constexpr unsigned int PA_SC_SHADER_CONTROL__REALIGN_DQUADS_AFTER_N_WAVES__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_TILE_STEERING_CREST_OVERRIDE__ONE_RB_MODE_ENABLE__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_TILE_STEERING_CREST_OVERRIDE__RB_SELECT__SHIFT = 0x00000005;
constexpr unsigned int PA_SC_TILE_STEERING_CREST_OVERRIDE__SE_SELECT__SHIFT = 0x00000001;
constexpr unsigned int PA_SC_TILE_STEERING_OVERRIDE__ENABLE__SHIFT        = 0x00000000;
constexpr unsigned int PA_SC_TRAP_SCREEN_COUNT__COUNT__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_TRAP_SCREEN_HV_EN__ENABLE_HV_PRE_SHADER__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_TRAP_SCREEN_HV_EN__FORCE_PRE_SHADER_ALL_PIXELS__SHIFT = 0x00000001;
constexpr unsigned int PA_SC_TRAP_SCREEN_HV_LOCK__DISABLE_NON_PRIV_WRITES__SHIFT = 0x00000000;
constexpr unsigned int PA_SC_TRAP_SCREEN_H__X_COORD__SHIFT                = 0x00000000;
constexpr unsigned int PA_SC_TRAP_SCREEN_OCCURRENCE__COUNT__SHIFT         = 0x00000000;
constexpr unsigned int PA_SC_TRAP_SCREEN_V__Y_COORD__SHIFT                = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_0_BR__BR_X__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_0_BR__BR_Y__SHIFT              = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_0_TL__TL_X__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_0_TL__TL_Y__SHIFT              = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_0_TL__WINDOW_OFFSET_DISABLE__SHIFT = 0x0000001f;
constexpr unsigned int PA_SC_VPORT_SCISSOR_1_BR__BR_X__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_1_BR__BR_Y__SHIFT              = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_1_TL__TL_X__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_1_TL__TL_Y__SHIFT              = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_1_TL__WINDOW_OFFSET_DISABLE__SHIFT = 0x0000001f;
constexpr unsigned int PA_SC_VPORT_SCISSOR_2_BR__BR_X__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_2_BR__BR_Y__SHIFT              = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_2_TL__TL_X__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_2_TL__TL_Y__SHIFT              = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_2_TL__WINDOW_OFFSET_DISABLE__SHIFT = 0x0000001f;
constexpr unsigned int PA_SC_VPORT_SCISSOR_3_BR__BR_X__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_3_BR__BR_Y__SHIFT              = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_3_TL__TL_X__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_3_TL__TL_Y__SHIFT              = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_3_TL__WINDOW_OFFSET_DISABLE__SHIFT = 0x0000001f;
constexpr unsigned int PA_SC_VPORT_SCISSOR_4_BR__BR_X__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_4_BR__BR_Y__SHIFT              = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_4_TL__TL_X__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_4_TL__TL_Y__SHIFT              = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_4_TL__WINDOW_OFFSET_DISABLE__SHIFT = 0x0000001f;
constexpr unsigned int PA_SC_VPORT_SCISSOR_5_BR__BR_X__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_5_BR__BR_Y__SHIFT              = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_5_TL__TL_X__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_5_TL__TL_Y__SHIFT              = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_5_TL__WINDOW_OFFSET_DISABLE__SHIFT = 0x0000001f;
constexpr unsigned int PA_SC_VPORT_SCISSOR_6_BR__BR_X__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_6_BR__BR_Y__SHIFT              = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_6_TL__TL_X__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_6_TL__TL_Y__SHIFT              = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_6_TL__WINDOW_OFFSET_DISABLE__SHIFT = 0x0000001f;
constexpr unsigned int PA_SC_VPORT_SCISSOR_7_BR__BR_X__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_7_BR__BR_Y__SHIFT              = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_7_TL__TL_X__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_7_TL__TL_Y__SHIFT              = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_7_TL__WINDOW_OFFSET_DISABLE__SHIFT = 0x0000001f;
constexpr unsigned int PA_SC_VPORT_SCISSOR_8_BR__BR_X__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_8_BR__BR_Y__SHIFT              = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_8_TL__TL_X__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_8_TL__TL_Y__SHIFT              = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_8_TL__WINDOW_OFFSET_DISABLE__SHIFT = 0x0000001f;
constexpr unsigned int PA_SC_VPORT_SCISSOR_9_BR__BR_X__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_9_BR__BR_Y__SHIFT              = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_9_TL__TL_X__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_9_TL__TL_Y__SHIFT              = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_9_TL__WINDOW_OFFSET_DISABLE__SHIFT = 0x0000001f;
constexpr unsigned int PA_SC_VPORT_SCISSOR_10_BR__BR_X__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_10_BR__BR_Y__SHIFT             = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_10_TL__TL_X__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_10_TL__TL_Y__SHIFT             = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_10_TL__WINDOW_OFFSET_DISABLE__SHIFT = 0x0000001f;
constexpr unsigned int PA_SC_VPORT_SCISSOR_11_BR__BR_X__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_11_BR__BR_Y__SHIFT             = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_11_TL__TL_X__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_11_TL__TL_Y__SHIFT             = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_11_TL__WINDOW_OFFSET_DISABLE__SHIFT = 0x0000001f;
constexpr unsigned int PA_SC_VPORT_SCISSOR_12_BR__BR_X__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_12_BR__BR_Y__SHIFT             = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_12_TL__TL_X__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_12_TL__TL_Y__SHIFT             = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_12_TL__WINDOW_OFFSET_DISABLE__SHIFT = 0x0000001f;
constexpr unsigned int PA_SC_VPORT_SCISSOR_13_BR__BR_X__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_13_BR__BR_Y__SHIFT             = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_13_TL__TL_X__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_13_TL__TL_Y__SHIFT             = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_13_TL__WINDOW_OFFSET_DISABLE__SHIFT = 0x0000001f;
constexpr unsigned int PA_SC_VPORT_SCISSOR_14_BR__BR_X__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_14_BR__BR_Y__SHIFT             = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_14_TL__TL_X__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_14_TL__TL_Y__SHIFT             = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_14_TL__WINDOW_OFFSET_DISABLE__SHIFT = 0x0000001f;
constexpr unsigned int PA_SC_VPORT_SCISSOR_15_BR__BR_X__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_15_BR__BR_Y__SHIFT             = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_15_TL__TL_X__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VPORT_SCISSOR_15_TL__TL_Y__SHIFT             = 0x00000010;
constexpr unsigned int PA_SC_VPORT_SCISSOR_15_TL__WINDOW_OFFSET_DISABLE__SHIFT = 0x0000001f;
constexpr unsigned int PA_SC_VPORT_ZMAX_0__VPORT_ZMAX__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMAX_1__VPORT_ZMAX__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMAX_2__VPORT_ZMAX__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMAX_3__VPORT_ZMAX__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMAX_4__VPORT_ZMAX__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMAX_5__VPORT_ZMAX__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMAX_6__VPORT_ZMAX__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMAX_7__VPORT_ZMAX__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMAX_8__VPORT_ZMAX__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMAX_9__VPORT_ZMAX__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMAX_10__VPORT_ZMAX__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMAX_11__VPORT_ZMAX__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMAX_12__VPORT_ZMAX__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMAX_13__VPORT_ZMAX__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMAX_14__VPORT_ZMAX__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMAX_15__VPORT_ZMAX__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_0__VPORT_ZMIN__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_1__VPORT_ZMIN__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_2__VPORT_ZMIN__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_3__VPORT_ZMIN__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_4__VPORT_ZMIN__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_5__VPORT_ZMIN__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_6__VPORT_ZMIN__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_7__VPORT_ZMIN__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_8__VPORT_ZMIN__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_9__VPORT_ZMIN__SHIFT              = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_10__VPORT_ZMIN__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_11__VPORT_ZMIN__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_12__VPORT_ZMIN__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_13__VPORT_ZMIN__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_14__VPORT_ZMIN__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_VPORT_ZMIN_15__VPORT_ZMIN__SHIFT             = 0x00000000;
constexpr unsigned int PA_SC_WINDOW_OFFSET__WINDOW_X_OFFSET__SHIFT        = 0x00000000;
constexpr unsigned int PA_SC_WINDOW_OFFSET__WINDOW_Y_OFFSET__SHIFT        = 0x00000010;
constexpr unsigned int PA_SC_WINDOW_SCISSOR_BR__BR_X__SHIFT               = 0x00000000;
constexpr unsigned int PA_SC_WINDOW_SCISSOR_BR__BR_Y__SHIFT               = 0x00000010;
constexpr unsigned int PA_SC_WINDOW_SCISSOR_TL__TL_X__SHIFT               = 0x00000000;
constexpr unsigned int PA_SC_WINDOW_SCISSOR_TL__TL_Y__SHIFT               = 0x00000010;
constexpr unsigned int PA_SC_WINDOW_SCISSOR_TL__WINDOW_OFFSET_DISABLE__SHIFT = 0x0000001f;
constexpr unsigned int PA_SIDEBAND_REQUEST_DELAYS__INITIAL_DELAY__SHIFT   = 0x00000010;
constexpr unsigned int PA_SIDEBAND_REQUEST_DELAYS__RETRY_DELAY__SHIFT     = 0x00000000;
constexpr unsigned int PA_SU_CNTL_STATUS__SU_BUSY__SHIFT                  = 0x0000001f;
constexpr unsigned int PA_SU_HARDWARE_SCREEN_OFFSET__HW_SCREEN_OFFSET_X__SHIFT = 0x00000000;
constexpr unsigned int PA_SU_HARDWARE_SCREEN_OFFSET__HW_SCREEN_OFFSET_Y__SHIFT = 0x00000010;
constexpr unsigned int PA_SU_LINE_CNTL__WIDTH__SHIFT                      = 0x00000000;
constexpr unsigned int PA_SU_LINE_STIPPLE_CNTL__DIAMOND_ADJUST__SHIFT     = 0x00000004;
constexpr unsigned int PA_SU_LINE_STIPPLE_CNTL__EXPAND_FULL_LENGTH__SHIFT = 0x00000002;
constexpr unsigned int PA_SU_LINE_STIPPLE_CNTL__FRACTIONAL_ACCUM__SHIFT   = 0x00000003;
constexpr unsigned int PA_SU_LINE_STIPPLE_CNTL__LINE_STIPPLE_RESET__SHIFT = 0x00000000;
constexpr unsigned int PA_SU_LINE_STIPPLE_SCALE__LINE_STIPPLE_SCALE__SHIFT = 0x00000000;
constexpr unsigned int PA_SU_LINE_STIPPLE_VALUE__LINE_STIPPLE_VALUE__SHIFT = 0x00000000;
constexpr unsigned int PA_SU_OVER_RASTERIZATION_CNTL__DISCARD_0_AREA_LINES__SHIFT = 0x00000001;
constexpr unsigned int PA_SU_OVER_RASTERIZATION_CNTL__DISCARD_0_AREA_POINTS__SHIFT = 0x00000002;
constexpr unsigned int PA_SU_OVER_RASTERIZATION_CNTL__DISCARD_0_AREA_RECTANGLES__SHIFT = 0x00000003;
constexpr unsigned int PA_SU_OVER_RASTERIZATION_CNTL__DISCARD_0_AREA_TRIANGLES__SHIFT = 0x00000000;
constexpr unsigned int PA_SU_OVER_RASTERIZATION_CNTL__USE_PROVOKING_ZW__SHIFT = 0x00000004;
constexpr unsigned int PA_SU_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int PA_SU_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int PA_SU_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT       = 0x00000000;
constexpr unsigned int PA_SU_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT       = 0x0000000a;
constexpr unsigned int PA_SU_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT        = 0x00000014;
constexpr unsigned int PA_SU_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT        = 0x0000000a;
constexpr unsigned int PA_SU_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int PA_SU_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int PA_SU_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int PA_SU_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT       = 0x00000000;
constexpr unsigned int PA_SU_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT       = 0x0000000a;
constexpr unsigned int PA_SU_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT        = 0x00000014;
constexpr unsigned int PA_SU_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT        = 0x0000000a;
constexpr unsigned int PA_SU_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int PA_SU_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int PA_SU_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int PA_SU_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT        = 0x00000014;
constexpr unsigned int PA_SU_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int PA_SU_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
constexpr unsigned int PA_SU_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
constexpr unsigned int PA_SU_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT        = 0x00000014;
constexpr unsigned int PA_SU_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT         = 0x00000000;
constexpr unsigned int PA_SU_POINT_MINMAX__MAX_SIZE__SHIFT                = 0x00000010;
constexpr unsigned int PA_SU_POINT_MINMAX__MIN_SIZE__SHIFT                = 0x00000000;
constexpr unsigned int PA_SU_POINT_SIZE__HEIGHT__SHIFT                    = 0x00000000;
constexpr unsigned int PA_SU_POINT_SIZE__WIDTH__SHIFT                     = 0x00000010;
constexpr unsigned int PA_SU_POLY_OFFSET_BACK_OFFSET__OFFSET__SHIFT       = 0x00000000;
constexpr unsigned int PA_SU_POLY_OFFSET_BACK_SCALE__SCALE__SHIFT         = 0x00000000;
constexpr unsigned int PA_SU_POLY_OFFSET_CLAMP__CLAMP__SHIFT              = 0x00000000;
constexpr unsigned int PA_SU_POLY_OFFSET_DB_FMT_CNTL__POLY_OFFSET_DB_IS_FLOAT_FMT__SHIFT = 0x00000008;
constexpr unsigned int PA_SU_POLY_OFFSET_DB_FMT_CNTL__POLY_OFFSET_NEG_NUM_DB_BITS__SHIFT = 0x00000000;
constexpr unsigned int PA_SU_POLY_OFFSET_FRONT_OFFSET__OFFSET__SHIFT      = 0x00000000;
constexpr unsigned int PA_SU_POLY_OFFSET_FRONT_SCALE__SCALE__SHIFT        = 0x00000000;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__LINE_EXPAND_ENA__SHIFT     = 0x00000005;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__LINE_FILTER_DISABLE__SHIFT = 0x00000001;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__POINT_EXPAND_ENA__SHIFT    = 0x00000006;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__POINT_FILTER_DISABLE__SHIFT = 0x00000002;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__PRIM_EXPAND_CONSTANT__SHIFT = 0x00000008;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__RECTANGLE_EXPAND_ENA__SHIFT = 0x00000007;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__RECTANGLE_FILTER_DISABLE__SHIFT = 0x00000003;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__TRIANGLE_EXPAND_ENA__SHIFT = 0x00000004;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__TRIANGLE_FILTER_DISABLE__SHIFT = 0x00000000;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__XMAX_RIGHT_EXCLUSION__SHIFT = 0x0000001e;
constexpr unsigned int PA_SU_PRIM_FILTER_CNTL__YMAX_BOTTOM_EXCLUSION__SHIFT = 0x0000001f;
constexpr unsigned int PA_SU_SC_MODE_CNTL__CULL_BACK__SHIFT               = 0x00000001;
constexpr unsigned int PA_SU_SC_MODE_CNTL__CULL_FRONT__SHIFT              = 0x00000000;
constexpr unsigned int PA_SU_SC_MODE_CNTL__FACE__SHIFT                    = 0x00000002;
constexpr unsigned int PA_SU_SC_MODE_CNTL__MULTI_PRIM_IB_ENA__SHIFT       = 0x00000015;
constexpr unsigned int PA_SU_SC_MODE_CNTL__NEW_QUAD_DECOMPOSITION__SHIFT  = 0x00000017;
constexpr unsigned int PA_SU_SC_MODE_CNTL__PERSP_CORR_DIS__SHIFT          = 0x00000014;
constexpr unsigned int PA_SU_SC_MODE_CNTL__POLYMODE_BACK_PTYPE__SHIFT     = 0x00000008;
constexpr unsigned int PA_SU_SC_MODE_CNTL__POLYMODE_FRONT_PTYPE__SHIFT    = 0x00000005;
constexpr unsigned int PA_SU_SC_MODE_CNTL__POLY_MODE__SHIFT               = 0x00000003;
constexpr unsigned int PA_SU_SC_MODE_CNTL__POLY_OFFSET_BACK_ENABLE__SHIFT = 0x0000000c;
constexpr unsigned int PA_SU_SC_MODE_CNTL__POLY_OFFSET_FRONT_ENABLE__SHIFT = 0x0000000b;
constexpr unsigned int PA_SU_SC_MODE_CNTL__POLY_OFFSET_PARA_ENABLE__SHIFT = 0x0000000d;
constexpr unsigned int PA_SU_SC_MODE_CNTL__PROVOKING_VTX_LAST__SHIFT      = 0x00000013;
constexpr unsigned int PA_SU_SC_MODE_CNTL__RIGHT_TRIANGLE_ALTERNATE_GRADIENT_REF__SHIFT = 0x00000016;
constexpr unsigned int PA_SU_SC_MODE_CNTL__VTX_WINDOW_OFFSET_ENABLE__SHIFT = 0x00000010;
constexpr unsigned int PA_SU_SMALL_PRIM_FILTER_CNTL__LINE_FILTER_DISABLE__SHIFT = 0x00000002;
constexpr unsigned int PA_SU_SMALL_PRIM_FILTER_CNTL__POINT_FILTER_DISABLE__SHIFT = 0x00000003;
constexpr unsigned int PA_SU_SMALL_PRIM_FILTER_CNTL__RECTANGLE_FILTER_DISABLE__SHIFT = 0x00000004;
constexpr unsigned int PA_SU_SMALL_PRIM_FILTER_CNTL__SMALL_PRIM_FILTER_ENABLE__SHIFT = 0x00000000;
constexpr unsigned int PA_SU_SMALL_PRIM_FILTER_CNTL__TRIANGLE_FILTER_DISABLE__SHIFT = 0x00000001;
constexpr unsigned int PA_SU_VTX_CNTL__PIX_CENTER__SHIFT                  = 0x00000000;
constexpr unsigned int PA_SU_VTX_CNTL__QUANT_MODE__SHIFT                  = 0x00000003;
constexpr unsigned int PA_SU_VTX_CNTL__ROUND_MODE__SHIFT                  = 0x00000001;
constexpr unsigned int RLC_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int RLC_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int RLC_PERFCOUNTER0_SELECT__PERFCOUNTER_SELECT__SHIFT = 0x00000000;
constexpr unsigned int RLC_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int RLC_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int RLC_PERFCOUNTER1_SELECT__PERFCOUNTER_SELECT__SHIFT = 0x00000000;
constexpr unsigned int RLC_PERFMON_CLK_CNTL__PERFMON_CLOCK_STATE__SHIFT   = 0x00000000;
constexpr unsigned int RLC_PERFMON_CNTL__PERFMON_SAMPLE_ENABLE__SHIFT     = 0x0000000a;
constexpr unsigned int RLC_PERFMON_CNTL__PERFMON_STATE__SHIFT             = 0x00000000;
constexpr unsigned int RLC_SPM_GLOBAL_MUXSEL_ADDR__PERFMON_SEL_ADDR__SHIFT = 0x00000000;
constexpr unsigned int RLC_SPM_GLOBAL_MUXSEL_DATA__PERFMON_SEL_DATA__SHIFT = 0x00000000;
constexpr unsigned int RLC_SPM_INT_CNTL__RESERVED__SHIFT                  = 0x00000001;
constexpr unsigned int RLC_SPM_INT_CNTL__RLC_SPM_INT_CNTL__SHIFT          = 0x00000000;
constexpr unsigned int RLC_SPM_INT_STATUS__RESERVED__SHIFT                = 0x00000001;
constexpr unsigned int RLC_SPM_INT_STATUS__RLC_SPM_INT_STATUS__SHIFT      = 0x00000000;
constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_POLICY__SHIFT             = 0x00000004;
constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_VMID__SHIFT               = 0x00000000;
constexpr unsigned int RLC_SPM_PERFMON_CNTL__PERFMON_RING_MODE__SHIFT     = 0x0000000c;
constexpr unsigned int RLC_SPM_PERFMON_CNTL__PERFMON_SAMPLE_INTERVAL__SHIFT = 0x00000010;
constexpr unsigned int RLC_SPM_PERFMON_CNTL__RESERVED__SHIFT              = 0x0000000e;
constexpr unsigned int RLC_SPM_PERFMON_RING_BASE_HI__RESERVED__SHIFT      = 0x00000010;
constexpr unsigned int RLC_SPM_PERFMON_RING_BASE_HI__RING_BASE_HI__SHIFT  = 0x00000000;
constexpr unsigned int RLC_SPM_PERFMON_RING_BASE_LO__RING_BASE_LO__SHIFT  = 0x00000000;
constexpr unsigned int RLC_SPM_PERFMON_RING_SIZE__RING_BASE_SIZE__SHIFT   = 0x00000000;
constexpr unsigned int RLC_SPM_PERFMON_SEGMENT_SIZE__GLOBAL_NUM_LINE__SHIFT = 0x0000000b;
constexpr unsigned int RLC_SPM_PERFMON_SEGMENT_SIZE__PERFMON_SEGMENT_SIZE__SHIFT = 0x00000000;
constexpr unsigned int RLC_SPM_PERFMON_SEGMENT_SIZE__RESERVED1__SHIFT     = 0x00000008;
constexpr unsigned int RLC_SPM_PERFMON_SEGMENT_SIZE__RESERVED__SHIFT      = 0x0000001f;
constexpr unsigned int RLC_SPM_PERFMON_SEGMENT_SIZE__SE0_NUM_LINE__SHIFT  = 0x00000010;
constexpr unsigned int RLC_SPM_PERFMON_SEGMENT_SIZE__SE1_NUM_LINE__SHIFT  = 0x00000015;
constexpr unsigned int RLC_SPM_PERFMON_SEGMENT_SIZE__SE2_NUM_LINE__SHIFT  = 0x0000001a;
constexpr unsigned int RLC_SPM_RING_RDPTR__PERFMON_RING_RDPTR__SHIFT      = 0x00000000;
constexpr unsigned int RLC_SPM_SEGMENT_THRESHOLD__NUM_SEGMENT_THRESHOLD__SHIFT = 0x00000000;
constexpr unsigned int RLC_SPM_SE_MUXSEL_ADDR__PERFMON_SEL_ADDR__SHIFT    = 0x00000000;
constexpr unsigned int RLC_SPM_SE_MUXSEL_DATA__PERFMON_SEL_DATA__SHIFT    = 0x00000000;
constexpr unsigned int RLC_SPM_UTCL1_CNTL__BYPASS__SHIFT                  = 0x00000019;
constexpr unsigned int RLC_SPM_UTCL1_CNTL__DROP_MODE__SHIFT               = 0x00000018;
constexpr unsigned int RLC_SPM_UTCL1_CNTL__FORCE_SNOOP__SHIFT             = 0x0000001c;
constexpr unsigned int RLC_SPM_UTCL1_CNTL__FRAG_LIMIT_MODE__SHIFT         = 0x0000001b;
constexpr unsigned int RLC_SPM_UTCL1_CNTL__INVALIDATE__SHIFT              = 0x0000001a;
constexpr unsigned int RLC_SPM_UTCL1_CNTL__RESERVED__SHIFT                = 0x0000001e;
constexpr unsigned int RLC_SPM_UTCL1_CNTL__XNACK_REDO_TIMER_CNT__SHIFT    = 0x00000000;
constexpr unsigned int RLC_SPM_UTCL1_ERROR_1__Translated_ReqErrorAddr_MSB__SHIFT = 0x00000006;
constexpr unsigned int RLC_SPM_UTCL1_ERROR_1__Translated_ReqErrorVmid__SHIFT = 0x00000002;
constexpr unsigned int RLC_SPM_UTCL1_ERROR_1__Translated_ReqError__SHIFT  = 0x00000000;
constexpr unsigned int RLC_SPM_UTCL1_ERROR_2__Translated_ReqErrorAddr_LSB__SHIFT = 0x00000000;
constexpr unsigned int RMI_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int RMI_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int RMI_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT        = 0x0000001c;
constexpr unsigned int RMI_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT        = 0x00000018;
constexpr unsigned int RMI_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
constexpr unsigned int RMI_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
constexpr unsigned int RMI_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
constexpr unsigned int RMI_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT         = 0x00000018;
constexpr unsigned int RMI_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int RMI_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
constexpr unsigned int RMI_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int RMI_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int RMI_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int RMI_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int RMI_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int RMI_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int RMI_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int RMI_PERFCOUNTER2_SELECT1__PERF_MODE2__SHIFT        = 0x0000001c;
constexpr unsigned int RMI_PERFCOUNTER2_SELECT1__PERF_MODE3__SHIFT        = 0x00000018;
constexpr unsigned int RMI_PERFCOUNTER2_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
constexpr unsigned int RMI_PERFCOUNTER2_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
constexpr unsigned int RMI_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
constexpr unsigned int RMI_PERFCOUNTER2_SELECT__PERF_MODE1__SHIFT         = 0x00000018;
constexpr unsigned int RMI_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int RMI_PERFCOUNTER2_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
constexpr unsigned int RMI_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int RMI_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int RMI_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int RMI_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int RMI_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__EVENT_BASED_PERF_EN_SEL__SHIFT = 0x00000002;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__PERF_CNTR_SPM_SEL__SHIFT    = 0x0000001a;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__PERF_COUNTER_BURST_LENGTH_THRESHOLD__SHIFT = 0x00000013;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__PERF_COUNTER_CID__SHIFT     = 0x0000000a;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__PERF_COUNTER_VMID__SHIFT    = 0x0000000e;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__PERF_EVENT_WINDOW_MASK0__SHIFT = 0x00000006;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__PERF_SOFT_RESET__SHIFT      = 0x00000019;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__TC_PERF_EN_SEL__SHIFT       = 0x00000004;
constexpr unsigned int RMI_PERF_COUNTER_CNTL__TRANS_BASED_PERF_EN_SEL__SHIFT = 0x00000000;
constexpr unsigned int RPB_PERFCOUNTER0_CFG__CLEAR__SHIFT                 = 0x0000001d;
constexpr unsigned int RPB_PERFCOUNTER0_CFG__ENABLE__SHIFT                = 0x0000001c;
constexpr unsigned int RPB_PERFCOUNTER0_CFG__PERF_MODE__SHIFT             = 0x00000018;
constexpr unsigned int RPB_PERFCOUNTER0_CFG__PERF_SEL_END__SHIFT          = 0x00000008;
constexpr unsigned int RPB_PERFCOUNTER0_CFG__PERF_SEL__SHIFT              = 0x00000000;
constexpr unsigned int RPB_PERFCOUNTER1_CFG__CLEAR__SHIFT                 = 0x0000001d;
constexpr unsigned int RPB_PERFCOUNTER1_CFG__ENABLE__SHIFT                = 0x0000001c;
constexpr unsigned int RPB_PERFCOUNTER1_CFG__PERF_MODE__SHIFT             = 0x00000018;
constexpr unsigned int RPB_PERFCOUNTER1_CFG__PERF_SEL_END__SHIFT          = 0x00000008;
constexpr unsigned int RPB_PERFCOUNTER1_CFG__PERF_SEL__SHIFT              = 0x00000000;
constexpr unsigned int RPB_PERFCOUNTER2_CFG__CLEAR__SHIFT                 = 0x0000001d;
constexpr unsigned int RPB_PERFCOUNTER2_CFG__ENABLE__SHIFT                = 0x0000001c;
constexpr unsigned int RPB_PERFCOUNTER2_CFG__PERF_MODE__SHIFT             = 0x00000018;
constexpr unsigned int RPB_PERFCOUNTER2_CFG__PERF_SEL_END__SHIFT          = 0x00000008;
constexpr unsigned int RPB_PERFCOUNTER2_CFG__PERF_SEL__SHIFT              = 0x00000000;
constexpr unsigned int RPB_PERFCOUNTER3_CFG__CLEAR__SHIFT                 = 0x0000001d;
constexpr unsigned int RPB_PERFCOUNTER3_CFG__ENABLE__SHIFT                = 0x0000001c;
constexpr unsigned int RPB_PERFCOUNTER3_CFG__PERF_MODE__SHIFT             = 0x00000018;
constexpr unsigned int RPB_PERFCOUNTER3_CFG__PERF_SEL_END__SHIFT          = 0x00000008;
constexpr unsigned int RPB_PERFCOUNTER3_CFG__PERF_SEL__SHIFT              = 0x00000000;
constexpr unsigned int RPB_PERFCOUNTER_HI__COMPARE_VALUE__SHIFT           = 0x00000010;
constexpr unsigned int RPB_PERFCOUNTER_HI__COUNTER_HI__SHIFT              = 0x00000000;
constexpr unsigned int RPB_PERFCOUNTER_LO__COUNTER_LO__SHIFT              = 0x00000000;
constexpr unsigned int RPB_PERFCOUNTER_RSLT_CNTL__CLEAR_ALL__SHIFT        = 0x00000019;
constexpr unsigned int RPB_PERFCOUNTER_RSLT_CNTL__ENABLE_ANY__SHIFT       = 0x00000018;
constexpr unsigned int RPB_PERFCOUNTER_RSLT_CNTL__PERF_COUNTER_SELECT__SHIFT = 0x00000000;
constexpr unsigned int RPB_PERFCOUNTER_RSLT_CNTL__START_TRIGGER__SHIFT    = 0x00000008;
constexpr unsigned int RPB_PERFCOUNTER_RSLT_CNTL__STOP_ALL_ON_SATURATE__SHIFT = 0x0000001a;
constexpr unsigned int RPB_PERFCOUNTER_RSLT_CNTL__STOP_TRIGGER__SHIFT     = 0x00000010;
constexpr unsigned int RPB_PERF_COUNTER_CNTL__PERF_COUNTER_SELECT__SHIFT  = 0x00000000;
constexpr unsigned int SPI_ARB_CNTL_0__EXP_ARB_COL_WT__SHIFT              = 0x00000000;
constexpr unsigned int SPI_ARB_CNTL_0__EXP_ARB_GDS_WT__SHIFT              = 0x00000008;
constexpr unsigned int SPI_ARB_CNTL_0__EXP_ARB_POS_WT__SHIFT              = 0x00000004;
constexpr unsigned int SPI_ARB_CYCLES_0__TS0_DURATION__SHIFT              = 0x00000000;
constexpr unsigned int SPI_ARB_CYCLES_0__TS1_DURATION__SHIFT              = 0x00000010;
constexpr unsigned int SPI_ARB_CYCLES_1__TS2_DURATION__SHIFT              = 0x00000000;
constexpr unsigned int SPI_ARB_CYCLES_1__TS3_DURATION__SHIFT              = 0x00000010;
constexpr unsigned int SPI_ARB_PRIORITY__PIPE_ORDER_TS0__SHIFT            = 0x00000000;
constexpr unsigned int SPI_ARB_PRIORITY__PIPE_ORDER_TS1__SHIFT            = 0x00000003;
constexpr unsigned int SPI_ARB_PRIORITY__PIPE_ORDER_TS2__SHIFT            = 0x00000006;
constexpr unsigned int SPI_ARB_PRIORITY__PIPE_ORDER_TS3__SHIFT            = 0x00000009;
constexpr unsigned int SPI_ARB_PRIORITY__TS0_DUR_MULT__SHIFT              = 0x0000000c;
constexpr unsigned int SPI_ARB_PRIORITY__TS1_DUR_MULT__SHIFT              = 0x0000000e;
constexpr unsigned int SPI_ARB_PRIORITY__TS2_DUR_MULT__SHIFT              = 0x00000010;
constexpr unsigned int SPI_ARB_PRIORITY__TS3_DUR_MULT__SHIFT              = 0x00000012;
constexpr unsigned int SPI_BARYC_CNTL__FRONT_FACE_ALL_BITS__SHIFT         = 0x00000018;
constexpr unsigned int SPI_BARYC_CNTL__LINEAR_CENTER_CNTL__SHIFT          = 0x00000008;
constexpr unsigned int SPI_BARYC_CNTL__LINEAR_CENTROID_CNTL__SHIFT        = 0x0000000c;
constexpr unsigned int SPI_BARYC_CNTL__PERSP_CENTER_CNTL__SHIFT           = 0x00000000;
constexpr unsigned int SPI_BARYC_CNTL__PERSP_CENTROID_CNTL__SHIFT         = 0x00000004;
constexpr unsigned int SPI_BARYC_CNTL__POS_FLOAT_LOCATION__SHIFT          = 0x00000010;
constexpr unsigned int SPI_BARYC_CNTL__POS_FLOAT_ULC__SHIFT               = 0x00000014;
constexpr unsigned int SPI_COMPUTE_QUEUE_RESET__RESET__SHIFT              = 0x00000000;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE__DONE_INTERRUPT_EN__SHIFT  = 0x00000002;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE__GDS_INTERRUPT_EN__SHIFT   = 0x00000001;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE__GDS_REQ_BUSY__SHIFT       = 0x0000001e;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE__INITIATE__SHIFT           = 0x00000000;
constexpr unsigned int SPI_COMPUTE_WF_CTX_SAVE__SAVE_BUSY__SHIFT          = 0x0000001f;
constexpr unsigned int SPI_CONFIG_CNTL_1__CRC_SIMD_ID_WADDR_DISABLE__SHIFT = 0x00000008;
constexpr unsigned int SPI_CONFIG_CNTL_1__CSC_PWR_SAVE_DISABLE__SHIFT     = 0x0000000e;
constexpr unsigned int SPI_CONFIG_CNTL_1__CSG_PWR_SAVE_DISABLE__SHIFT     = 0x0000000f;
constexpr unsigned int SPI_CONFIG_CNTL_1__INTERP_ONE_PRIM_PER_ROW__SHIFT  = 0x00000004;
constexpr unsigned int SPI_CONFIG_CNTL_1__LBPW_CU_CHK_CNT__SHIFT          = 0x0000000a;
constexpr unsigned int SPI_CONFIG_CNTL_1__LBPW_CU_CHK_MODE__SHIFT         = 0x00000009;
constexpr unsigned int SPI_CONFIG_CNTL_1__PC_LIMIT_STRICT__SHIFT          = 0x00000007;
constexpr unsigned int SPI_CONFIG_CNTL_1__VTX_DONE_DELAY__SHIFT           = 0x00000000;
constexpr unsigned int SPI_CONFIG_CNTL_2__CONTEXT_SAVE_WAIT_GDS_GRANT_CYCLE_OVHD__SHIFT = 0x00000004;
constexpr unsigned int SPI_CONFIG_CNTL_2__CONTEXT_SAVE_WAIT_GDS_REQUEST_CYCLE_OVHD__SHIFT = 0x00000000;
constexpr unsigned int SPI_CONFIG_CNTL__ALLOC_ARB_LRU_ENA__SHIFT          = 0x0000001c;
constexpr unsigned int SPI_CONFIG_CNTL__ENABLE_SQG_BOP_EVENTS__SHIFT      = 0x00000019;
constexpr unsigned int SPI_CONFIG_CNTL__ENABLE_SQG_TOP_EVENTS__SHIFT      = 0x00000018;
constexpr unsigned int SPI_CONFIG_CNTL__EXP_ARB_LRU_ENA__SHIFT            = 0x0000001d;
constexpr unsigned int SPI_CONFIG_CNTL__EXP_PRIORITY_ORDER__SHIFT         = 0x00000015;
constexpr unsigned int SPI_CONFIG_CNTL__GPR_WRITE_PRIORITY__SHIFT         = 0x00000000;
constexpr unsigned int SPI_CONFIG_CNTL__PS_PKR_PRIORITY_CNTL__SHIFT       = 0x0000001e;
constexpr unsigned int SPI_CONFIG_CNTL__TTRACE_STALL_ALL__SHIFT           = 0x0000001b;
constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_0__COUNT__SHIFT            = 0x00000000;
constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_0__EVENTS__SHIFT           = 0x00000010;
constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_1__COUNT__SHIFT            = 0x00000000;
constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_1__EVENTS__SHIFT           = 0x00000010;
constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_2__COUNT__SHIFT            = 0x00000000;
constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_2__EVENTS__SHIFT           = 0x00000010;
constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_3__COUNT__SHIFT            = 0x00000000;
constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_3__EVENTS__SHIFT           = 0x00000010;
constexpr unsigned int SPI_CSQ_WF_ACTIVE_STATUS__ACTIVE__SHIFT            = 0x00000000;
constexpr unsigned int SPI_DSM_CNTL2__SPI_SR_MEM_ENABLE_ERROR_INJECT__SHIFT = 0x00000000;
constexpr unsigned int SPI_DSM_CNTL2__SPI_SR_MEM_SELECT_INJECT_DELAY__SHIFT = 0x00000002;
constexpr unsigned int SPI_DSM_CNTL__SPI_SR_MEM_DSM_IRRITATOR_DATA__SHIFT = 0x00000000;
constexpr unsigned int SPI_DSM_CNTL__SPI_SR_MEM_ENABLE_SINGLE_WRITE__SHIFT = 0x00000002;
constexpr unsigned int SPI_EDC_CNT__SPI_SR_MEM_SED_COUNT__SHIFT           = 0x00000000;
constexpr unsigned int SPI_GDS_CREDITS__DS_CMD_CREDITS__SHIFT             = 0x00000008;
constexpr unsigned int SPI_GDS_CREDITS__DS_DATA_CREDITS__SHIFT            = 0x00000000;
constexpr unsigned int SPI_GFX_CNTL__RESET_COUNTS__SHIFT                  = 0x00000000;
constexpr unsigned int SPI_INTERP_CONTROL_0__FLAT_SHADE_ENA__SHIFT        = 0x00000000;
constexpr unsigned int SPI_INTERP_CONTROL_0__PNT_SPRITE_ENA__SHIFT        = 0x00000001;
constexpr unsigned int SPI_INTERP_CONTROL_0__PNT_SPRITE_OVRD_W__SHIFT     = 0x0000000b;
constexpr unsigned int SPI_INTERP_CONTROL_0__PNT_SPRITE_OVRD_X__SHIFT     = 0x00000002;
constexpr unsigned int SPI_INTERP_CONTROL_0__PNT_SPRITE_OVRD_Y__SHIFT     = 0x00000005;
constexpr unsigned int SPI_INTERP_CONTROL_0__PNT_SPRITE_OVRD_Z__SHIFT     = 0x00000008;
constexpr unsigned int SPI_INTERP_CONTROL_0__PNT_SPRITE_TOP_1__SHIFT      = 0x0000000e;
constexpr unsigned int SPI_LB_CTR_CTRL__CLEAR_ON_READ__SHIFT              = 0x00000003;
constexpr unsigned int SPI_LB_CTR_CTRL__LOAD__SHIFT                       = 0x00000000;
constexpr unsigned int SPI_LB_CTR_CTRL__RESET_COUNTS__SHIFT               = 0x00000004;
constexpr unsigned int SPI_LB_CTR_CTRL__WAVES_SELECT__SHIFT               = 0x00000001;
constexpr unsigned int SPI_LB_DATA_REG__CNT_DATA__SHIFT                   = 0x00000000;
constexpr unsigned int SPI_LB_DATA_WAVES__COUNT0__SHIFT                   = 0x00000000;
constexpr unsigned int SPI_LB_DATA_WAVES__COUNT1__SHIFT                   = 0x00000010;
constexpr unsigned int SPI_P0_TRAP_SCREEN_GPR_MIN__SGPR_MIN__SHIFT        = 0x00000006;
constexpr unsigned int SPI_P0_TRAP_SCREEN_GPR_MIN__VGPR_MIN__SHIFT        = 0x00000000;
constexpr unsigned int SPI_P0_TRAP_SCREEN_PSBA_HI__MEM_BASE__SHIFT        = 0x00000000;
constexpr unsigned int SPI_P0_TRAP_SCREEN_PSBA_LO__MEM_BASE__SHIFT        = 0x00000000;
constexpr unsigned int SPI_P0_TRAP_SCREEN_PSMA_HI__MEM_BASE__SHIFT        = 0x00000000;
constexpr unsigned int SPI_P0_TRAP_SCREEN_PSMA_LO__MEM_BASE__SHIFT        = 0x00000000;
constexpr unsigned int SPI_P1_TRAP_SCREEN_GPR_MIN__SGPR_MIN__SHIFT        = 0x00000006;
constexpr unsigned int SPI_P1_TRAP_SCREEN_GPR_MIN__VGPR_MIN__SHIFT        = 0x00000000;
constexpr unsigned int SPI_P1_TRAP_SCREEN_PSBA_HI__MEM_BASE__SHIFT        = 0x00000000;
constexpr unsigned int SPI_P1_TRAP_SCREEN_PSBA_LO__MEM_BASE__SHIFT        = 0x00000000;
constexpr unsigned int SPI_P1_TRAP_SCREEN_PSMA_HI__MEM_BASE__SHIFT        = 0x00000000;
constexpr unsigned int SPI_P1_TRAP_SCREEN_PSMA_LO__MEM_BASE__SHIFT        = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT        = 0x0000001c;
constexpr unsigned int SPI_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT        = 0x00000018;
constexpr unsigned int SPI_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
constexpr unsigned int SPI_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
constexpr unsigned int SPI_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT         = 0x00000018;
constexpr unsigned int SPI_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int SPI_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
constexpr unsigned int SPI_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT        = 0x0000001c;
constexpr unsigned int SPI_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT        = 0x00000018;
constexpr unsigned int SPI_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
constexpr unsigned int SPI_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
constexpr unsigned int SPI_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT         = 0x00000018;
constexpr unsigned int SPI_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int SPI_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
constexpr unsigned int SPI_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER2_SELECT1__PERF_MODE2__SHIFT        = 0x0000001c;
constexpr unsigned int SPI_PERFCOUNTER2_SELECT1__PERF_MODE3__SHIFT        = 0x00000018;
constexpr unsigned int SPI_PERFCOUNTER2_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER2_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
constexpr unsigned int SPI_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
constexpr unsigned int SPI_PERFCOUNTER2_SELECT__PERF_MODE1__SHIFT         = 0x00000018;
constexpr unsigned int SPI_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int SPI_PERFCOUNTER2_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
constexpr unsigned int SPI_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER3_SELECT1__PERF_MODE2__SHIFT        = 0x0000001c;
constexpr unsigned int SPI_PERFCOUNTER3_SELECT1__PERF_MODE3__SHIFT        = 0x00000018;
constexpr unsigned int SPI_PERFCOUNTER3_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER3_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
constexpr unsigned int SPI_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
constexpr unsigned int SPI_PERFCOUNTER3_SELECT__PERF_MODE1__SHIFT         = 0x00000018;
constexpr unsigned int SPI_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int SPI_PERFCOUNTER3_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
constexpr unsigned int SPI_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER4_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER4_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER4_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER5_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER5_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER5_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER_BINS__BIN0_MAX__SHIFT              = 0x00000004;
constexpr unsigned int SPI_PERFCOUNTER_BINS__BIN0_MIN__SHIFT              = 0x00000000;
constexpr unsigned int SPI_PERFCOUNTER_BINS__BIN1_MAX__SHIFT              = 0x0000000c;
constexpr unsigned int SPI_PERFCOUNTER_BINS__BIN1_MIN__SHIFT              = 0x00000008;
constexpr unsigned int SPI_PERFCOUNTER_BINS__BIN2_MAX__SHIFT              = 0x00000014;
constexpr unsigned int SPI_PERFCOUNTER_BINS__BIN2_MIN__SHIFT              = 0x00000010;
constexpr unsigned int SPI_PERFCOUNTER_BINS__BIN3_MAX__SHIFT              = 0x0000001c;
constexpr unsigned int SPI_PERFCOUNTER_BINS__BIN3_MIN__SHIFT              = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_ADDR__ANCILLARY_ENA__SHIFT            = 0x0000000d;
constexpr unsigned int SPI_PS_INPUT_ADDR__FRONT_FACE_ENA__SHIFT           = 0x0000000c;
constexpr unsigned int SPI_PS_INPUT_ADDR__LINEAR_CENTER_ENA__SHIFT        = 0x00000005;
constexpr unsigned int SPI_PS_INPUT_ADDR__LINEAR_CENTROID_ENA__SHIFT      = 0x00000006;
constexpr unsigned int SPI_PS_INPUT_ADDR__LINEAR_SAMPLE_ENA__SHIFT        = 0x00000004;
constexpr unsigned int SPI_PS_INPUT_ADDR__LINE_STIPPLE_TEX_ENA__SHIFT     = 0x00000007;
constexpr unsigned int SPI_PS_INPUT_ADDR__PERSP_CENTER_ENA__SHIFT         = 0x00000001;
constexpr unsigned int SPI_PS_INPUT_ADDR__PERSP_CENTROID_ENA__SHIFT       = 0x00000002;
constexpr unsigned int SPI_PS_INPUT_ADDR__PERSP_PULL_MODEL_ENA__SHIFT     = 0x00000003;
constexpr unsigned int SPI_PS_INPUT_ADDR__PERSP_SAMPLE_ENA__SHIFT         = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_ADDR__POS_FIXED_PT_ENA__SHIFT         = 0x0000000f;
constexpr unsigned int SPI_PS_INPUT_ADDR__POS_W_FLOAT_ENA__SHIFT          = 0x0000000b;
constexpr unsigned int SPI_PS_INPUT_ADDR__POS_X_FLOAT_ENA__SHIFT          = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_ADDR__POS_Y_FLOAT_ENA__SHIFT          = 0x00000009;
constexpr unsigned int SPI_PS_INPUT_ADDR__POS_Z_FLOAT_ENA__SHIFT          = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_ADDR__SAMPLE_COVERAGE_ENA__SHIFT      = 0x0000000e;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__ATTR0_VALID__SHIFT            = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__ATTR1_VALID__SHIFT            = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__CYL_WRAP__SHIFT               = 0x0000000d;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__DEFAULT_VAL_ATTR1__SHIFT      = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__DEFAULT_VAL__SHIFT            = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__DUP__SHIFT                    = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__FLAT_SHADE__SHIFT             = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__FP16_INTERP_MODE__SHIFT       = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__OFFSET__SHIFT                 = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__PT_SPRITE_TEX_ATTR1__SHIFT    = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__PT_SPRITE_TEX__SHIFT          = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_0__USE_DEFAULT_ATTR1__SHIFT      = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__ATTR0_VALID__SHIFT            = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__ATTR1_VALID__SHIFT            = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__CYL_WRAP__SHIFT               = 0x0000000d;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__DEFAULT_VAL_ATTR1__SHIFT      = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__DEFAULT_VAL__SHIFT            = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__DUP__SHIFT                    = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__FLAT_SHADE__SHIFT             = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__FP16_INTERP_MODE__SHIFT       = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__OFFSET__SHIFT                 = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__PT_SPRITE_TEX_ATTR1__SHIFT    = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__PT_SPRITE_TEX__SHIFT          = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_1__USE_DEFAULT_ATTR1__SHIFT      = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__ATTR0_VALID__SHIFT            = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__ATTR1_VALID__SHIFT            = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__CYL_WRAP__SHIFT               = 0x0000000d;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__DEFAULT_VAL_ATTR1__SHIFT      = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__DEFAULT_VAL__SHIFT            = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__DUP__SHIFT                    = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__FLAT_SHADE__SHIFT             = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__FP16_INTERP_MODE__SHIFT       = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__OFFSET__SHIFT                 = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__PT_SPRITE_TEX_ATTR1__SHIFT    = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__PT_SPRITE_TEX__SHIFT          = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_2__USE_DEFAULT_ATTR1__SHIFT      = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__ATTR0_VALID__SHIFT            = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__ATTR1_VALID__SHIFT            = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__CYL_WRAP__SHIFT               = 0x0000000d;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__DEFAULT_VAL_ATTR1__SHIFT      = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__DEFAULT_VAL__SHIFT            = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__DUP__SHIFT                    = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__FLAT_SHADE__SHIFT             = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__FP16_INTERP_MODE__SHIFT       = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__OFFSET__SHIFT                 = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__PT_SPRITE_TEX_ATTR1__SHIFT    = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__PT_SPRITE_TEX__SHIFT          = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_3__USE_DEFAULT_ATTR1__SHIFT      = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__ATTR0_VALID__SHIFT            = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__ATTR1_VALID__SHIFT            = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__CYL_WRAP__SHIFT               = 0x0000000d;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__DEFAULT_VAL_ATTR1__SHIFT      = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__DEFAULT_VAL__SHIFT            = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__DUP__SHIFT                    = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__FLAT_SHADE__SHIFT             = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__FP16_INTERP_MODE__SHIFT       = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__OFFSET__SHIFT                 = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__PT_SPRITE_TEX_ATTR1__SHIFT    = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__PT_SPRITE_TEX__SHIFT          = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_4__USE_DEFAULT_ATTR1__SHIFT      = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__ATTR0_VALID__SHIFT            = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__ATTR1_VALID__SHIFT            = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__CYL_WRAP__SHIFT               = 0x0000000d;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__DEFAULT_VAL_ATTR1__SHIFT      = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__DEFAULT_VAL__SHIFT            = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__DUP__SHIFT                    = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__FLAT_SHADE__SHIFT             = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__FP16_INTERP_MODE__SHIFT       = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__OFFSET__SHIFT                 = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__PT_SPRITE_TEX_ATTR1__SHIFT    = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__PT_SPRITE_TEX__SHIFT          = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_5__USE_DEFAULT_ATTR1__SHIFT      = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__ATTR0_VALID__SHIFT            = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__ATTR1_VALID__SHIFT            = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__CYL_WRAP__SHIFT               = 0x0000000d;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__DEFAULT_VAL_ATTR1__SHIFT      = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__DEFAULT_VAL__SHIFT            = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__DUP__SHIFT                    = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__FLAT_SHADE__SHIFT             = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__FP16_INTERP_MODE__SHIFT       = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__OFFSET__SHIFT                 = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__PT_SPRITE_TEX_ATTR1__SHIFT    = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__PT_SPRITE_TEX__SHIFT          = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_6__USE_DEFAULT_ATTR1__SHIFT      = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__ATTR0_VALID__SHIFT            = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__ATTR1_VALID__SHIFT            = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__CYL_WRAP__SHIFT               = 0x0000000d;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__DEFAULT_VAL_ATTR1__SHIFT      = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__DEFAULT_VAL__SHIFT            = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__DUP__SHIFT                    = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__FLAT_SHADE__SHIFT             = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__FP16_INTERP_MODE__SHIFT       = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__OFFSET__SHIFT                 = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__PT_SPRITE_TEX_ATTR1__SHIFT    = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__PT_SPRITE_TEX__SHIFT          = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_7__USE_DEFAULT_ATTR1__SHIFT      = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__ATTR0_VALID__SHIFT            = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__ATTR1_VALID__SHIFT            = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__CYL_WRAP__SHIFT               = 0x0000000d;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__DEFAULT_VAL_ATTR1__SHIFT      = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__DEFAULT_VAL__SHIFT            = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__DUP__SHIFT                    = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__FLAT_SHADE__SHIFT             = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__FP16_INTERP_MODE__SHIFT       = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__OFFSET__SHIFT                 = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__PT_SPRITE_TEX_ATTR1__SHIFT    = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__PT_SPRITE_TEX__SHIFT          = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_8__USE_DEFAULT_ATTR1__SHIFT      = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__ATTR0_VALID__SHIFT            = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__ATTR1_VALID__SHIFT            = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__CYL_WRAP__SHIFT               = 0x0000000d;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__DEFAULT_VAL_ATTR1__SHIFT      = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__DEFAULT_VAL__SHIFT            = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__DUP__SHIFT                    = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__FLAT_SHADE__SHIFT             = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__FP16_INTERP_MODE__SHIFT       = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__OFFSET__SHIFT                 = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__PT_SPRITE_TEX_ATTR1__SHIFT    = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__PT_SPRITE_TEX__SHIFT          = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_9__USE_DEFAULT_ATTR1__SHIFT      = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__ATTR0_VALID__SHIFT           = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__ATTR1_VALID__SHIFT           = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__CYL_WRAP__SHIFT              = 0x0000000d;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__DEFAULT_VAL_ATTR1__SHIFT     = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__DEFAULT_VAL__SHIFT           = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__DUP__SHIFT                   = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__FLAT_SHADE__SHIFT            = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__FP16_INTERP_MODE__SHIFT      = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__PT_SPRITE_TEX_ATTR1__SHIFT   = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__PT_SPRITE_TEX__SHIFT         = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_10__USE_DEFAULT_ATTR1__SHIFT     = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__ATTR0_VALID__SHIFT           = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__ATTR1_VALID__SHIFT           = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__CYL_WRAP__SHIFT              = 0x0000000d;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__DEFAULT_VAL_ATTR1__SHIFT     = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__DEFAULT_VAL__SHIFT           = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__DUP__SHIFT                   = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__FLAT_SHADE__SHIFT            = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__FP16_INTERP_MODE__SHIFT      = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__PT_SPRITE_TEX_ATTR1__SHIFT   = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__PT_SPRITE_TEX__SHIFT         = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_11__USE_DEFAULT_ATTR1__SHIFT     = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__ATTR0_VALID__SHIFT           = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__ATTR1_VALID__SHIFT           = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__CYL_WRAP__SHIFT              = 0x0000000d;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__DEFAULT_VAL_ATTR1__SHIFT     = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__DEFAULT_VAL__SHIFT           = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__DUP__SHIFT                   = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__FLAT_SHADE__SHIFT            = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__FP16_INTERP_MODE__SHIFT      = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__PT_SPRITE_TEX_ATTR1__SHIFT   = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__PT_SPRITE_TEX__SHIFT         = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_12__USE_DEFAULT_ATTR1__SHIFT     = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__ATTR0_VALID__SHIFT           = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__ATTR1_VALID__SHIFT           = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__CYL_WRAP__SHIFT              = 0x0000000d;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__DEFAULT_VAL_ATTR1__SHIFT     = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__DEFAULT_VAL__SHIFT           = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__DUP__SHIFT                   = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__FLAT_SHADE__SHIFT            = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__FP16_INTERP_MODE__SHIFT      = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__PT_SPRITE_TEX_ATTR1__SHIFT   = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__PT_SPRITE_TEX__SHIFT         = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_13__USE_DEFAULT_ATTR1__SHIFT     = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__ATTR0_VALID__SHIFT           = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__ATTR1_VALID__SHIFT           = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__CYL_WRAP__SHIFT              = 0x0000000d;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__DEFAULT_VAL_ATTR1__SHIFT     = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__DEFAULT_VAL__SHIFT           = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__DUP__SHIFT                   = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__FLAT_SHADE__SHIFT            = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__FP16_INTERP_MODE__SHIFT      = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__PT_SPRITE_TEX_ATTR1__SHIFT   = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__PT_SPRITE_TEX__SHIFT         = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_14__USE_DEFAULT_ATTR1__SHIFT     = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__ATTR0_VALID__SHIFT           = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__ATTR1_VALID__SHIFT           = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__CYL_WRAP__SHIFT              = 0x0000000d;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__DEFAULT_VAL_ATTR1__SHIFT     = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__DEFAULT_VAL__SHIFT           = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__DUP__SHIFT                   = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__FLAT_SHADE__SHIFT            = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__FP16_INTERP_MODE__SHIFT      = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__PT_SPRITE_TEX_ATTR1__SHIFT   = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__PT_SPRITE_TEX__SHIFT         = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_15__USE_DEFAULT_ATTR1__SHIFT     = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__ATTR0_VALID__SHIFT           = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__ATTR1_VALID__SHIFT           = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__CYL_WRAP__SHIFT              = 0x0000000d;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__DEFAULT_VAL_ATTR1__SHIFT     = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__DEFAULT_VAL__SHIFT           = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__DUP__SHIFT                   = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__FLAT_SHADE__SHIFT            = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__FP16_INTERP_MODE__SHIFT      = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__PT_SPRITE_TEX_ATTR1__SHIFT   = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__PT_SPRITE_TEX__SHIFT         = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_16__USE_DEFAULT_ATTR1__SHIFT     = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__ATTR0_VALID__SHIFT           = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__ATTR1_VALID__SHIFT           = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__CYL_WRAP__SHIFT              = 0x0000000d;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__DEFAULT_VAL_ATTR1__SHIFT     = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__DEFAULT_VAL__SHIFT           = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__DUP__SHIFT                   = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__FLAT_SHADE__SHIFT            = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__FP16_INTERP_MODE__SHIFT      = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__PT_SPRITE_TEX_ATTR1__SHIFT   = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__PT_SPRITE_TEX__SHIFT         = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_17__USE_DEFAULT_ATTR1__SHIFT     = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__ATTR0_VALID__SHIFT           = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__ATTR1_VALID__SHIFT           = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__CYL_WRAP__SHIFT              = 0x0000000d;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__DEFAULT_VAL_ATTR1__SHIFT     = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__DEFAULT_VAL__SHIFT           = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__DUP__SHIFT                   = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__FLAT_SHADE__SHIFT            = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__FP16_INTERP_MODE__SHIFT      = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__PT_SPRITE_TEX_ATTR1__SHIFT   = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__PT_SPRITE_TEX__SHIFT         = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_18__USE_DEFAULT_ATTR1__SHIFT     = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__ATTR0_VALID__SHIFT           = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__ATTR1_VALID__SHIFT           = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__CYL_WRAP__SHIFT              = 0x0000000d;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__DEFAULT_VAL_ATTR1__SHIFT     = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__DEFAULT_VAL__SHIFT           = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__DUP__SHIFT                   = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__FLAT_SHADE__SHIFT            = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__FP16_INTERP_MODE__SHIFT      = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__PT_SPRITE_TEX_ATTR1__SHIFT   = 0x00000017;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__PT_SPRITE_TEX__SHIFT         = 0x00000011;
constexpr unsigned int SPI_PS_INPUT_CNTL_19__USE_DEFAULT_ATTR1__SHIFT     = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__ATTR0_VALID__SHIFT           = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__ATTR1_VALID__SHIFT           = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__DEFAULT_VAL_ATTR1__SHIFT     = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__DEFAULT_VAL__SHIFT           = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__DUP__SHIFT                   = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__FLAT_SHADE__SHIFT            = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__FP16_INTERP_MODE__SHIFT      = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_20__USE_DEFAULT_ATTR1__SHIFT     = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__ATTR0_VALID__SHIFT           = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__ATTR1_VALID__SHIFT           = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__DEFAULT_VAL_ATTR1__SHIFT     = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__DEFAULT_VAL__SHIFT           = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__DUP__SHIFT                   = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__FLAT_SHADE__SHIFT            = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__FP16_INTERP_MODE__SHIFT      = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_21__USE_DEFAULT_ATTR1__SHIFT     = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__ATTR0_VALID__SHIFT           = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__ATTR1_VALID__SHIFT           = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__DEFAULT_VAL_ATTR1__SHIFT     = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__DEFAULT_VAL__SHIFT           = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__DUP__SHIFT                   = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__FLAT_SHADE__SHIFT            = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__FP16_INTERP_MODE__SHIFT      = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_22__USE_DEFAULT_ATTR1__SHIFT     = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__ATTR0_VALID__SHIFT           = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__ATTR1_VALID__SHIFT           = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__DEFAULT_VAL_ATTR1__SHIFT     = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__DEFAULT_VAL__SHIFT           = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__DUP__SHIFT                   = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__FLAT_SHADE__SHIFT            = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__FP16_INTERP_MODE__SHIFT      = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_23__USE_DEFAULT_ATTR1__SHIFT     = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__ATTR0_VALID__SHIFT           = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__ATTR1_VALID__SHIFT           = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__DEFAULT_VAL_ATTR1__SHIFT     = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__DEFAULT_VAL__SHIFT           = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__DUP__SHIFT                   = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__FLAT_SHADE__SHIFT            = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__FP16_INTERP_MODE__SHIFT      = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_24__USE_DEFAULT_ATTR1__SHIFT     = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__ATTR0_VALID__SHIFT           = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__ATTR1_VALID__SHIFT           = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__DEFAULT_VAL_ATTR1__SHIFT     = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__DEFAULT_VAL__SHIFT           = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__DUP__SHIFT                   = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__FLAT_SHADE__SHIFT            = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__FP16_INTERP_MODE__SHIFT      = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_25__USE_DEFAULT_ATTR1__SHIFT     = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__ATTR0_VALID__SHIFT           = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__ATTR1_VALID__SHIFT           = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__DEFAULT_VAL_ATTR1__SHIFT     = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__DEFAULT_VAL__SHIFT           = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__DUP__SHIFT                   = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__FLAT_SHADE__SHIFT            = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__FP16_INTERP_MODE__SHIFT      = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_26__USE_DEFAULT_ATTR1__SHIFT     = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__ATTR0_VALID__SHIFT           = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__ATTR1_VALID__SHIFT           = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__DEFAULT_VAL_ATTR1__SHIFT     = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__DEFAULT_VAL__SHIFT           = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__DUP__SHIFT                   = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__FLAT_SHADE__SHIFT            = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__FP16_INTERP_MODE__SHIFT      = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_27__USE_DEFAULT_ATTR1__SHIFT     = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__ATTR0_VALID__SHIFT           = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__ATTR1_VALID__SHIFT           = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__DEFAULT_VAL_ATTR1__SHIFT     = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__DEFAULT_VAL__SHIFT           = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__DUP__SHIFT                   = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__FLAT_SHADE__SHIFT            = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__FP16_INTERP_MODE__SHIFT      = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_28__USE_DEFAULT_ATTR1__SHIFT     = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__ATTR0_VALID__SHIFT           = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__ATTR1_VALID__SHIFT           = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__DEFAULT_VAL_ATTR1__SHIFT     = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__DEFAULT_VAL__SHIFT           = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__DUP__SHIFT                   = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__FLAT_SHADE__SHIFT            = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__FP16_INTERP_MODE__SHIFT      = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_29__USE_DEFAULT_ATTR1__SHIFT     = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__ATTR0_VALID__SHIFT           = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__ATTR1_VALID__SHIFT           = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__DEFAULT_VAL_ATTR1__SHIFT     = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__DEFAULT_VAL__SHIFT           = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__DUP__SHIFT                   = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__FLAT_SHADE__SHIFT            = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__FP16_INTERP_MODE__SHIFT      = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_30__USE_DEFAULT_ATTR1__SHIFT     = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__ATTR0_VALID__SHIFT           = 0x00000018;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__ATTR1_VALID__SHIFT           = 0x00000019;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__DEFAULT_VAL_ATTR1__SHIFT     = 0x00000015;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__DEFAULT_VAL__SHIFT           = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__DUP__SHIFT                   = 0x00000012;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__FLAT_SHADE__SHIFT            = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__FP16_INTERP_MODE__SHIFT      = 0x00000013;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_CNTL_31__USE_DEFAULT_ATTR1__SHIFT     = 0x00000014;
constexpr unsigned int SPI_PS_INPUT_ENA__ANCILLARY_ENA__SHIFT             = 0x0000000d;
constexpr unsigned int SPI_PS_INPUT_ENA__FRONT_FACE_ENA__SHIFT            = 0x0000000c;
constexpr unsigned int SPI_PS_INPUT_ENA__LINEAR_CENTER_ENA__SHIFT         = 0x00000005;
constexpr unsigned int SPI_PS_INPUT_ENA__LINEAR_CENTROID_ENA__SHIFT       = 0x00000006;
constexpr unsigned int SPI_PS_INPUT_ENA__LINEAR_SAMPLE_ENA__SHIFT         = 0x00000004;
constexpr unsigned int SPI_PS_INPUT_ENA__LINE_STIPPLE_TEX_ENA__SHIFT      = 0x00000007;
constexpr unsigned int SPI_PS_INPUT_ENA__PERSP_CENTER_ENA__SHIFT          = 0x00000001;
constexpr unsigned int SPI_PS_INPUT_ENA__PERSP_CENTROID_ENA__SHIFT        = 0x00000002;
constexpr unsigned int SPI_PS_INPUT_ENA__PERSP_PULL_MODEL_ENA__SHIFT      = 0x00000003;
constexpr unsigned int SPI_PS_INPUT_ENA__PERSP_SAMPLE_ENA__SHIFT          = 0x00000000;
constexpr unsigned int SPI_PS_INPUT_ENA__POS_FIXED_PT_ENA__SHIFT          = 0x0000000f;
constexpr unsigned int SPI_PS_INPUT_ENA__POS_W_FLOAT_ENA__SHIFT           = 0x0000000b;
constexpr unsigned int SPI_PS_INPUT_ENA__POS_X_FLOAT_ENA__SHIFT           = 0x00000008;
constexpr unsigned int SPI_PS_INPUT_ENA__POS_Y_FLOAT_ENA__SHIFT           = 0x00000009;
constexpr unsigned int SPI_PS_INPUT_ENA__POS_Z_FLOAT_ENA__SHIFT           = 0x0000000a;
constexpr unsigned int SPI_PS_INPUT_ENA__SAMPLE_COVERAGE_ENA__SHIFT       = 0x0000000e;
constexpr unsigned int SPI_PS_IN_CONTROL__BC_OPTIMIZE_DISABLE__SHIFT      = 0x0000000e;
constexpr unsigned int SPI_PS_IN_CONTROL__LATE_PC_DEALLOC__SHIFT          = 0x00000008;
constexpr unsigned int SPI_PS_IN_CONTROL__NUM_INTERP__SHIFT               = 0x00000000;
constexpr unsigned int SPI_PS_IN_CONTROL__OFFCHIP_PARAM_EN__SHIFT         = 0x00000007;
constexpr unsigned int SPI_PS_IN_CONTROL__PARAM_GEN__SHIFT                = 0x00000006;
constexpr unsigned int SPI_PS_MAX_WAVE_ID__MAX_COLLISION_WAVE_ID__SHIFT   = 0x00000010;
constexpr unsigned int SPI_PS_MAX_WAVE_ID__MAX_WAVE_ID__SHIFT             = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_0__BARRIERS__SHIFT         = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_0__LDS__SHIFT              = 0x00000008;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_0__SGPR__SHIFT             = 0x00000004;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_0__VGPR__SHIFT             = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_0__WAVES__SHIFT            = 0x0000000c;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_1__BARRIERS__SHIFT         = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_1__LDS__SHIFT              = 0x00000008;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_1__SGPR__SHIFT             = 0x00000004;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_1__VGPR__SHIFT             = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_1__WAVES__SHIFT            = 0x0000000c;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_2__BARRIERS__SHIFT         = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_2__LDS__SHIFT              = 0x00000008;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_2__SGPR__SHIFT             = 0x00000004;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_2__VGPR__SHIFT             = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_2__WAVES__SHIFT            = 0x0000000c;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_3__BARRIERS__SHIFT         = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_3__LDS__SHIFT              = 0x00000008;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_3__SGPR__SHIFT             = 0x00000004;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_3__VGPR__SHIFT             = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_3__WAVES__SHIFT            = 0x0000000c;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_4__BARRIERS__SHIFT         = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_4__LDS__SHIFT              = 0x00000008;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_4__SGPR__SHIFT             = 0x00000004;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_4__VGPR__SHIFT             = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_4__WAVES__SHIFT            = 0x0000000c;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_5__BARRIERS__SHIFT         = 0x0000000f;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_5__LDS__SHIFT              = 0x00000008;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_5__SGPR__SHIFT             = 0x00000004;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_5__VGPR__SHIFT             = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_CU_5__WAVES__SHIFT            = 0x0000000c;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_0__EN__SHIFT            = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_0__QUEUE_MASK__SHIFT    = 0x00000010;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_0__TYPE_MASK__SHIFT     = 0x00000001;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_1__EN__SHIFT            = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_1__QUEUE_MASK__SHIFT    = 0x00000010;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_1__TYPE_MASK__SHIFT     = 0x00000001;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_2__EN__SHIFT            = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_2__QUEUE_MASK__SHIFT    = 0x00000010;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_2__TYPE_MASK__SHIFT     = 0x00000001;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_3__EN__SHIFT            = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_3__QUEUE_MASK__SHIFT    = 0x00000010;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_3__TYPE_MASK__SHIFT     = 0x00000001;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_4__EN__SHIFT            = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_4__QUEUE_MASK__SHIFT    = 0x00000010;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_4__TYPE_MASK__SHIFT     = 0x00000001;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_5__EN__SHIFT            = 0x00000000;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_5__QUEUE_MASK__SHIFT    = 0x00000010;
constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_5__TYPE_MASK__SHIFT     = 0x00000001;
constexpr unsigned int SPI_SHADER_COL_FORMAT__COL0_EXPORT_FORMAT__SHIFT   = 0x00000000;
constexpr unsigned int SPI_SHADER_COL_FORMAT__COL1_EXPORT_FORMAT__SHIFT   = 0x00000004;
constexpr unsigned int SPI_SHADER_COL_FORMAT__COL2_EXPORT_FORMAT__SHIFT   = 0x00000008;
constexpr unsigned int SPI_SHADER_COL_FORMAT__COL3_EXPORT_FORMAT__SHIFT   = 0x0000000c;
constexpr unsigned int SPI_SHADER_COL_FORMAT__COL4_EXPORT_FORMAT__SHIFT   = 0x00000010;
constexpr unsigned int SPI_SHADER_COL_FORMAT__COL5_EXPORT_FORMAT__SHIFT   = 0x00000014;
constexpr unsigned int SPI_SHADER_COL_FORMAT__COL6_EXPORT_FORMAT__SHIFT   = 0x00000018;
constexpr unsigned int SPI_SHADER_COL_FORMAT__COL7_EXPORT_FORMAT__SHIFT   = 0x0000001c;
constexpr unsigned int SPI_SHADER_LATE_ALLOC_VS__LIMIT__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_HI_ES__MEM_BASE__SHIFT              = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_HI_GS__MEM_BASE__SHIFT              = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_HI_HS__MEM_BASE__SHIFT              = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_HI_LS__MEM_BASE__SHIFT              = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_HI_PS__MEM_BASE__SHIFT              = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_HI_VS__MEM_BASE__SHIFT              = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_LO_ES__MEM_BASE__SHIFT              = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_LO_GS__MEM_BASE__SHIFT              = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_LO_HS__MEM_BASE__SHIFT              = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_LO_LS__MEM_BASE__SHIFT              = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_LO_PS__MEM_BASE__SHIFT              = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_LO_VS__MEM_BASE__SHIFT              = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__CDBG_USER__SHIFT          = 0x0000001c;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__CU_GROUP_ENABLE__SHIFT    = 0x00000018;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__DEBUG_MODE__SHIFT         = 0x00000016;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__DX10_CLAMP__SHIFT         = 0x00000015;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__FLOAT_MODE__SHIFT         = 0x0000000c;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__FP16_OVFL__SHIFT          = 0x0000001f;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__GS_VGPR_COMP_CNT__SHIFT   = 0x0000001d;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__IEEE_MODE__SHIFT          = 0x00000017;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__PRIORITY__SHIFT           = 0x0000000a;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__PRIV__SHIFT               = 0x00000014;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__SGPRS__SHIFT              = 0x00000006;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__VGPRS__SHIFT              = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__CDBG_USER__SHIFT          = 0x0000001b;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__DEBUG_MODE__SHIFT         = 0x00000016;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__DX10_CLAMP__SHIFT         = 0x00000015;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__FLOAT_MODE__SHIFT         = 0x0000000c;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__FP16_OVFL__SHIFT          = 0x0000001e;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__IEEE_MODE__SHIFT          = 0x00000017;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__LS_VGPR_COMP_CNT__SHIFT   = 0x0000001c;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__PRIORITY__SHIFT           = 0x0000000a;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__PRIV__SHIFT               = 0x00000014;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__SGPRS__SHIFT              = 0x00000006;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__VGPRS__SHIFT              = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__CDBG_USER__SHIFT          = 0x0000001c;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__CU_GROUP_DISABLE__SHIFT   = 0x00000018;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__DEBUG_MODE__SHIFT         = 0x00000016;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__DX10_CLAMP__SHIFT         = 0x00000015;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__FLOAT_MODE__SHIFT         = 0x0000000c;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__FP16_OVFL__SHIFT          = 0x0000001d;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__IEEE_MODE__SHIFT          = 0x00000017;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__PRIORITY__SHIFT           = 0x0000000a;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__PRIV__SHIFT               = 0x00000014;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__SGPRS__SHIFT              = 0x00000006;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__VGPRS__SHIFT              = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_VS__CDBG_USER__SHIFT          = 0x0000001e;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_VS__CU_GROUP_ENABLE__SHIFT    = 0x0000001a;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_VS__DEBUG_MODE__SHIFT         = 0x00000016;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_VS__DX10_CLAMP__SHIFT         = 0x00000015;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_VS__FLOAT_MODE__SHIFT         = 0x0000000c;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_VS__FP16_OVFL__SHIFT          = 0x0000001f;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_VS__IEEE_MODE__SHIFT          = 0x00000017;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_VS__PRIORITY__SHIFT           = 0x0000000a;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_VS__PRIV__SHIFT               = 0x00000014;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_VS__SGPRS__SHIFT              = 0x00000006;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_VS__VGPRS__SHIFT              = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC1_VS__VGPR_COMP_CNT__SHIFT      = 0x00000018;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS_VS__EXCP_EN__SHIFT         = 0x00000007;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS_VS__LDS_SIZE__SHIFT        = 0x00000013;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS_VS__OC_LDS_EN__SHIFT       = 0x00000012;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS_VS__SCRATCH_EN__SHIFT      = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS_VS__SKIP_USGPR0__SHIFT     = 0x0000001b;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS_VS__TRAP_PRESENT__SHIFT    = 0x00000006;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS_VS__USER_SGPR_MSB__SHIFT   = 0x0000001c;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS_VS__USER_SGPR__SHIFT       = 0x00000001;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS_VS__VGPR_COMP_CNT__SHIFT   = 0x00000010;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__ES_VGPR_COMP_CNT__SHIFT   = 0x00000010;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__EXCP_EN__SHIFT            = 0x00000007;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__LDS_SIZE__SHIFT           = 0x00000013;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__OC_LDS_EN__SHIFT          = 0x00000012;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__SCRATCH_EN__SHIFT         = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__TRAP_PRESENT__SHIFT       = 0x00000006;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__USER_SGPR__SHIFT          = 0x00000001;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__SCRATCH_EN__SHIFT         = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__TRAP_PRESENT__SHIFT       = 0x00000006;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__USER_SGPR__SHIFT          = 0x00000001;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__EXCP_EN__SHIFT            = 0x00000010;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__EXTRA_LDS_SIZE__SHIFT     = 0x00000008;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__LOAD_COLLISION_WAVEID__SHIFT = 0x00000019;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__LOAD_INTRAWAVE_COLLISION__SHIFT = 0x0000001a;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__SCRATCH_EN__SHIFT         = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__TRAP_PRESENT__SHIFT       = 0x00000006;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__USER_SGPR__SHIFT          = 0x00000001;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__WAVE_CNT_EN__SHIFT        = 0x00000007;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__EXCP_EN__SHIFT            = 0x0000000d;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__OC_LDS_EN__SHIFT          = 0x00000007;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__PC_BASE_EN__SHIFT         = 0x00000016;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__SCRATCH_EN__SHIFT         = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__SO_BASE0_EN__SHIFT        = 0x00000008;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__SO_BASE1_EN__SHIFT        = 0x00000009;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__SO_BASE2_EN__SHIFT        = 0x0000000a;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__SO_BASE3_EN__SHIFT        = 0x0000000b;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__SO_EN__SHIFT              = 0x0000000c;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__TRAP_PRESENT__SHIFT       = 0x00000006;
constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__USER_SGPR__SHIFT          = 0x00000001;
constexpr unsigned int SPI_SHADER_PGM_RSRC3_GS__CU_EN__SHIFT              = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC3_GS__LOCK_LOW_THRESHOLD__SHIFT = 0x00000016;
constexpr unsigned int SPI_SHADER_PGM_RSRC3_GS__WAVE_LIMIT__SHIFT         = 0x00000010;
constexpr unsigned int SPI_SHADER_PGM_RSRC3_HS__CU_EN__SHIFT              = 0x00000010;
constexpr unsigned int SPI_SHADER_PGM_RSRC3_HS__LOCK_LOW_THRESHOLD__SHIFT = 0x00000006;
constexpr unsigned int SPI_SHADER_PGM_RSRC3_HS__WAVE_LIMIT__SHIFT         = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC3_PS__CU_EN__SHIFT              = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC3_PS__LOCK_LOW_THRESHOLD__SHIFT = 0x00000016;
constexpr unsigned int SPI_SHADER_PGM_RSRC3_PS__WAVE_LIMIT__SHIFT         = 0x00000010;
constexpr unsigned int SPI_SHADER_PGM_RSRC3_VS__CU_EN__SHIFT              = 0x00000000;
constexpr unsigned int SPI_SHADER_PGM_RSRC3_VS__LOCK_LOW_THRESHOLD__SHIFT = 0x00000016;
constexpr unsigned int SPI_SHADER_PGM_RSRC3_VS__WAVE_LIMIT__SHIFT         = 0x00000010;
constexpr unsigned int SPI_SHADER_POS_FORMAT__POS0_EXPORT_FORMAT__SHIFT   = 0x00000000;
constexpr unsigned int SPI_SHADER_POS_FORMAT__POS1_EXPORT_FORMAT__SHIFT   = 0x00000004;
constexpr unsigned int SPI_SHADER_POS_FORMAT__POS2_EXPORT_FORMAT__SHIFT   = 0x00000008;
constexpr unsigned int SPI_SHADER_POS_FORMAT__POS3_EXPORT_FORMAT__SHIFT   = 0x0000000c;
constexpr unsigned int SPI_SHADER_USER_DATA_ADDR_HI_GS__MEM_BASE__SHIFT   = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_ADDR_HI_HS__MEM_BASE__SHIFT   = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_ADDR_LO_GS__MEM_BASE__SHIFT   = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_ADDR_LO_HS__MEM_BASE__SHIFT   = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_0__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_1__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_2__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_3__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_4__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_5__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_6__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_7__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_8__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_9__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_10__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_11__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_12__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_13__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_14__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_15__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_16__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_17__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_18__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_19__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_20__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_21__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_22__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_23__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_24__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_25__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_26__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_27__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_28__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_29__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_30__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_PS_31__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_0__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_1__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_2__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_3__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_4__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_5__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_6__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_7__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_8__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_9__DATA__SHIFT             = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_10__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_11__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_12__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_13__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_14__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_15__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_16__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_17__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_18__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_19__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_20__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_21__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_22__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_23__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_24__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_25__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_26__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_27__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_28__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_29__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_30__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_USER_DATA_VS_31__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SPI_SHADER_Z_FORMAT__Z_EXPORT_FORMAT__SHIFT        = 0x00000000;
constexpr unsigned int SPI_SX_EXPORT_BUFFER_SIZES__COLOR_BUFFER_SIZE__SHIFT = 0x00000000;
constexpr unsigned int SPI_SX_EXPORT_BUFFER_SIZES__POSITION_BUFFER_SIZE__SHIFT = 0x00000010;
constexpr unsigned int SPI_SX_SCOREBOARD_BUFFER_SIZES__COLOR_SCOREBOARD_SIZE__SHIFT = 0x00000000;
constexpr unsigned int SPI_SX_SCOREBOARD_BUFFER_SIZES__POSITION_SCOREBOARD_SIZE__SHIFT = 0x00000010;
constexpr unsigned int SPI_TMPRING_SIZE__WAVESIZE__SHIFT                  = 0x0000000c;
constexpr unsigned int SPI_TMPRING_SIZE__WAVES__SHIFT                     = 0x00000000;
constexpr unsigned int SPI_VS_OUT_CONFIG__VS_EXPORT_COUNT__SHIFT          = 0x00000001;
constexpr unsigned int SPI_VS_OUT_CONFIG__VS_HALF_PACK__SHIFT             = 0x00000006;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS0__VALUE__SHIFT             = 0x00000000;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS1__VALUE__SHIFT             = 0x00000000;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS2__VALUE__SHIFT             = 0x00000000;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS3__VALUE__SHIFT             = 0x00000000;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_GFX__GS_GRP_VALUE__SHIFT      = 0x00000016;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_GFX__HS_GRP_VALUE__SHIFT      = 0x0000000c;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_GFX__VALUE__SHIFT             = 0x00000000;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_HP3D__GS_GRP_VALUE__SHIFT     = 0x00000016;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_HP3D__HS_GRP_VALUE__SHIFT     = 0x0000000c;
constexpr unsigned int SPI_WCL_PIPE_PERCENT_HP3D__VALUE__SHIFT            = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_CNTL__EN__SHIFT                    = 0x00000004;
constexpr unsigned int SPI_WF_LIFETIME_CNTL__SAMPLE_PERIOD__SHIFT         = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_LIMIT_0__EN_WARN__SHIFT            = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_LIMIT_0__MAX_CNT__SHIFT            = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_LIMIT_2__EN_WARN__SHIFT            = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_LIMIT_2__MAX_CNT__SHIFT            = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_LIMIT_3__EN_WARN__SHIFT            = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_LIMIT_3__MAX_CNT__SHIFT            = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_LIMIT_4__EN_WARN__SHIFT            = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_LIMIT_4__MAX_CNT__SHIFT            = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_LIMIT_5__EN_WARN__SHIFT            = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_LIMIT_5__MAX_CNT__SHIFT            = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_0__INT_SENT__SHIFT          = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_0__MAX_CNT__SHIFT           = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_1__INT_SENT__SHIFT          = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_1__MAX_CNT__SHIFT           = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_2__INT_SENT__SHIFT          = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_2__MAX_CNT__SHIFT           = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_4__INT_SENT__SHIFT          = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_4__MAX_CNT__SHIFT           = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_6__INT_SENT__SHIFT          = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_6__MAX_CNT__SHIFT           = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_7__INT_SENT__SHIFT          = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_7__MAX_CNT__SHIFT           = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_8__INT_SENT__SHIFT          = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_8__MAX_CNT__SHIFT           = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_9__INT_SENT__SHIFT          = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_9__MAX_CNT__SHIFT           = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_11__INT_SENT__SHIFT         = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_11__MAX_CNT__SHIFT          = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_13__INT_SENT__SHIFT         = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_13__MAX_CNT__SHIFT          = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_14__INT_SENT__SHIFT         = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_14__MAX_CNT__SHIFT          = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_15__INT_SENT__SHIFT         = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_15__MAX_CNT__SHIFT          = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_16__INT_SENT__SHIFT         = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_16__MAX_CNT__SHIFT          = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_17__INT_SENT__SHIFT         = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_17__MAX_CNT__SHIFT          = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_18__INT_SENT__SHIFT         = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_18__MAX_CNT__SHIFT          = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_19__INT_SENT__SHIFT         = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_19__MAX_CNT__SHIFT          = 0x00000000;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_20__INT_SENT__SHIFT         = 0x0000001f;
constexpr unsigned int SPI_WF_LIFETIME_STATUS_20__MAX_CNT__SHIFT          = 0x00000000;
constexpr unsigned int SQ_CMD__CHECK_VMID__SHIFT                          = 0x00000007;
constexpr unsigned int SQ_CMD__CMD__SHIFT                                 = 0x00000000;
constexpr unsigned int SQ_CMD__DATA__SHIFT                                = 0x00000008;
constexpr unsigned int SQ_CMD__MODE__SHIFT                                = 0x00000004;
constexpr unsigned int SQ_CMD__QUEUE_ID__SHIFT                            = 0x00000018;
constexpr unsigned int SQ_CMD__VM_ID__SHIFT                               = 0x0000001c;
constexpr unsigned int SQ_CMD__WAVE_ID__SHIFT                             = 0x00000010;
constexpr unsigned int SQ_CONFIG__DISABLE_SP_REDUNDANT_THREAD_GATING__SHIFT = 0x0000001d;
constexpr unsigned int SQ_CONFIG__ENABLE_HIPRIO_ON_EXP_RDY_VS__SHIFT      = 0x00000012;
constexpr unsigned int SQ_CONFIG__PRIO_VAL_ON_EXP_RDY_VS__SHIFT           = 0x00000013;
constexpr unsigned int SQ_DSM_CNTL2__LDS_D_ENABLE_ERROR_INJECT__SHIFT     = 0x00000003;
constexpr unsigned int SQ_DSM_CNTL2__LDS_D_SELECT_INJECT_DELAY__SHIFT     = 0x00000005;
constexpr unsigned int SQ_DSM_CNTL2__LDS_INJECT_DELAY__SHIFT              = 0x0000000e;
constexpr unsigned int SQ_DSM_CNTL2__LDS_I_ENABLE_ERROR_INJECT__SHIFT     = 0x00000006;
constexpr unsigned int SQ_DSM_CNTL2__LDS_I_SELECT_INJECT_DELAY__SHIFT     = 0x00000008;
constexpr unsigned int SQ_DSM_CNTL2__SGPR_ENABLE_ERROR_INJECT__SHIFT      = 0x00000000;
constexpr unsigned int SQ_DSM_CNTL2__SGPR_SELECT_INJECT_DELAY__SHIFT      = 0x00000002;
constexpr unsigned int SQ_DSM_CNTL2__SP_ENABLE_ERROR_INJECT__SHIFT        = 0x00000009;
constexpr unsigned int SQ_DSM_CNTL2__SP_INJECT_DELAY__SHIFT               = 0x00000014;
constexpr unsigned int SQ_DSM_CNTL2__SP_SELECT_INJECT_DELAY__SHIFT        = 0x0000000b;
constexpr unsigned int SQ_DSM_CNTL2__SQ_INJECT_DELAY__SHIFT               = 0x0000001a;
constexpr unsigned int SQ_DSM_CNTL__LDS_ENABLE_SINGLE_WRITE01__SHIFT      = 0x00000012;
constexpr unsigned int SQ_DSM_CNTL__LDS_ENABLE_SINGLE_WRITE23__SHIFT      = 0x00000015;
constexpr unsigned int SQ_DSM_CNTL__SEL_DSM_LDS_IRRITATOR_DATA0__SHIFT    = 0x00000010;
constexpr unsigned int SQ_DSM_CNTL__SEL_DSM_LDS_IRRITATOR_DATA1__SHIFT    = 0x00000011;
constexpr unsigned int SQ_DSM_CNTL__SEL_DSM_LDS_IRRITATOR_DATA2__SHIFT    = 0x00000013;
constexpr unsigned int SQ_DSM_CNTL__SEL_DSM_LDS_IRRITATOR_DATA3__SHIFT    = 0x00000014;
constexpr unsigned int SQ_DSM_CNTL__SEL_DSM_SGPR_IRRITATOR_DATA0__SHIFT   = 0x00000008;
constexpr unsigned int SQ_DSM_CNTL__SEL_DSM_SGPR_IRRITATOR_DATA1__SHIFT   = 0x00000009;
constexpr unsigned int SQ_DSM_CNTL__SEL_DSM_SP_IRRITATOR_DATA0__SHIFT     = 0x00000018;
constexpr unsigned int SQ_DSM_CNTL__SEL_DSM_SP_IRRITATOR_DATA1__SHIFT     = 0x00000019;
constexpr unsigned int SQ_DSM_CNTL__SGPR_ENABLE_SINGLE_WRITE__SHIFT       = 0x0000000a;
constexpr unsigned int SQ_DSM_CNTL__SPI_BACKPRESSURE_0__SHIFT             = 0x00000002;
constexpr unsigned int SQ_DSM_CNTL__SPI_BACKPRESSURE_1__SHIFT             = 0x00000003;
constexpr unsigned int SQ_DSM_CNTL__SP_ENABLE_SINGLE_WRITE__SHIFT         = 0x0000001a;
constexpr unsigned int SQ_DSM_CNTL__WAVEFRONT_STALL_0__SHIFT              = 0x00000000;
constexpr unsigned int SQ_DSM_CNTL__WAVEFRONT_STALL_1__SHIFT              = 0x00000001;
constexpr unsigned int SQ_EDC_CNT__LDS_D_DED_COUNT__SHIFT                 = 0x00000002;
constexpr unsigned int SQ_EDC_CNT__LDS_D_SEC_COUNT__SHIFT                 = 0x00000000;
constexpr unsigned int SQ_EDC_CNT__LDS_I_DED_COUNT__SHIFT                 = 0x00000006;
constexpr unsigned int SQ_EDC_CNT__LDS_I_SEC_COUNT__SHIFT                 = 0x00000004;
constexpr unsigned int SQ_EDC_CNT__SGPR_DED_COUNT__SHIFT                  = 0x0000000a;
constexpr unsigned int SQ_EDC_CNT__SGPR_SEC_COUNT__SHIFT                  = 0x00000008;
constexpr unsigned int SQ_EDC_CNT__VGPR0_DED_COUNT__SHIFT                 = 0x0000000e;
constexpr unsigned int SQ_EDC_CNT__VGPR0_SEC_COUNT__SHIFT                 = 0x0000000c;
constexpr unsigned int SQ_EDC_CNT__VGPR1_DED_COUNT__SHIFT                 = 0x00000012;
constexpr unsigned int SQ_EDC_CNT__VGPR1_SEC_COUNT__SHIFT                 = 0x00000010;
constexpr unsigned int SQ_EDC_CNT__VGPR2_DED_COUNT__SHIFT                 = 0x00000016;
constexpr unsigned int SQ_EDC_CNT__VGPR2_SEC_COUNT__SHIFT                 = 0x00000014;
constexpr unsigned int SQ_EDC_CNT__VGPR3_DED_COUNT__SHIFT                 = 0x0000001a;
constexpr unsigned int SQ_EDC_CNT__VGPR3_SEC_COUNT__SHIFT                 = 0x00000018;
constexpr unsigned int SQ_EDC_FUE_CNTL__BLOCK_FUE_FLAGS__SHIFT            = 0x00000000;
constexpr unsigned int SQ_EDC_FUE_CNTL__FUE_INTERRUPT_ENABLES__SHIFT      = 0x00000010;
constexpr unsigned int SQ_FIFO_SIZES__INTERRUPT_FIFO_SIZE__SHIFT          = 0x00000000;
constexpr unsigned int SQ_FIFO_SIZES__TTRACE_FIFO_SIZE__SHIFT             = 0x00000008;
constexpr unsigned int SQ_FIFO_SIZES__VMEM_DATA_FIFO_SIZE__SHIFT          = 0x00000012;
constexpr unsigned int SQ_IND_DATA__DATA__SHIFT                           = 0x00000000;
constexpr unsigned int SQ_IND_INDEX__INDEX__SHIFT                         = 0x00000010;
constexpr unsigned int SQ_IND_INDEX__WAVE_ID__SHIFT                       = 0x00000000;
constexpr unsigned int SQ_INTERRUPT_AUTO_MASK__MASK__SHIFT                = 0x00000000;
constexpr unsigned int SQ_INTERRUPT_MSG_CTRL__STALL__SHIFT                = 0x00000000;
constexpr unsigned int SQ_LB_CTR_CTRL__CLEAR__SHIFT                       = 0x00000002;
constexpr unsigned int SQ_LB_CTR_CTRL__LOAD__SHIFT                        = 0x00000001;
constexpr unsigned int SQ_LB_CTR_CTRL__START__SHIFT                       = 0x00000000;
constexpr unsigned int SQ_LB_DATA0__DATA__SHIFT                           = 0x00000000;
constexpr unsigned int SQ_LB_DATA1__DATA__SHIFT                           = 0x00000000;
constexpr unsigned int SQ_LB_DATA2__DATA__SHIFT                           = 0x00000000;
constexpr unsigned int SQ_LB_DATA3__DATA__SHIFT                           = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER0_SELECT__SPM_MODE__SHIFT            = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER1_SELECT__SPM_MODE__SHIFT            = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER2_SELECT__SPM_MODE__SHIFT            = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER3_SELECT__SPM_MODE__SHIFT            = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER4_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER4_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER4_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER4_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER4_SELECT__SPM_MODE__SHIFT            = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER5_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER5_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER5_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER5_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER5_SELECT__SPM_MODE__SHIFT            = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER6_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER6_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER6_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER6_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER6_SELECT__SPM_MODE__SHIFT            = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER7_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER7_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER7_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER7_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER7_SELECT__SPM_MODE__SHIFT            = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER8_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER8_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER8_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER8_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER8_SELECT__SPM_MODE__SHIFT            = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER9_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER9_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER9_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER9_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER9_SELECT__SPM_MODE__SHIFT            = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER10_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER10_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER10_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER10_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER10_SELECT__SPM_MODE__SHIFT           = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER11_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER11_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER11_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER11_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER11_SELECT__SPM_MODE__SHIFT           = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER12_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER12_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER12_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER12_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER12_SELECT__SPM_MODE__SHIFT           = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER13_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER13_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER13_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER13_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER13_SELECT__SPM_MODE__SHIFT           = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER14_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER14_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER14_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER14_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER14_SELECT__SPM_MODE__SHIFT           = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER15_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER15_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER15_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int SQ_PERFCOUNTER15_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER15_SELECT__SPM_MODE__SHIFT           = 0x00000014;
constexpr unsigned int SQ_PERFCOUNTER_CTRL2__FORCE_EN__SHIFT              = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER_CTRL__CNTR_RATE__SHIFT              = 0x00000008;
constexpr unsigned int SQ_PERFCOUNTER_CTRL__CS_EN__SHIFT                  = 0x00000006;
constexpr unsigned int SQ_PERFCOUNTER_CTRL__DISABLE_FLUSH__SHIFT          = 0x0000000d;
constexpr unsigned int SQ_PERFCOUNTER_CTRL__ES_EN__SHIFT                  = 0x00000003;
constexpr unsigned int SQ_PERFCOUNTER_CTRL__GS_EN__SHIFT                  = 0x00000002;
constexpr unsigned int SQ_PERFCOUNTER_CTRL__HS_EN__SHIFT                  = 0x00000004;
constexpr unsigned int SQ_PERFCOUNTER_CTRL__LS_EN__SHIFT                  = 0x00000005;
constexpr unsigned int SQ_PERFCOUNTER_CTRL__PS_EN__SHIFT                  = 0x00000000;
constexpr unsigned int SQ_PERFCOUNTER_CTRL__VS_EN__SHIFT                  = 0x00000001;
constexpr unsigned int SQ_RANDOM_WAVE_PRI__RET__SHIFT                     = 0x00000000;
constexpr unsigned int SQ_RANDOM_WAVE_PRI__RNG__SHIFT                     = 0x0000000a;
constexpr unsigned int SQ_RANDOM_WAVE_PRI__RUI__SHIFT                     = 0x00000007;
constexpr unsigned int SQ_SHADER_TBA_HI__ADDR_HI__SHIFT                   = 0x00000000;
constexpr unsigned int SQ_SHADER_TBA_LO__ADDR_LO__SHIFT                   = 0x00000000;
constexpr unsigned int SQ_SHADER_TMA_HI__ADDR_HI__SHIFT                   = 0x00000000;
constexpr unsigned int SQ_SHADER_TMA_LO__ADDR_LO__SHIFT                   = 0x00000000;
constexpr unsigned int SQ_THREAD_TRACE_STATUS__FINISH_PENDING__SHIFT      = 0x00000000;
constexpr unsigned int SQ_THREAD_TRACE_USERDATA_0__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SQ_THREAD_TRACE_USERDATA_1__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SQ_THREAD_TRACE_USERDATA_2__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SQ_THREAD_TRACE_USERDATA_3__DATA__SHIFT            = 0x00000000;
constexpr unsigned int SQ_TIME_HI__TIME__SHIFT                            = 0x00000000;
constexpr unsigned int SQ_TIME_LO__TIME__SHIFT                            = 0x00000000;
constexpr unsigned int SQ_WAVE_EXEC_HI__EXEC_HI__SHIFT                    = 0x00000000;
constexpr unsigned int SQ_WAVE_EXEC_LO__EXEC_LO__SHIFT                    = 0x00000000;
constexpr unsigned int SQ_WAVE_FLUSH_IB__UNUSED__SHIFT                    = 0x00000000;
constexpr unsigned int SQ_WAVE_GPR_ALLOC__VGPR_BASE__SHIFT                = 0x00000000;
constexpr unsigned int SQ_WAVE_GPR_ALLOC__VGPR_SIZE__SHIFT                = 0x00000008;
constexpr unsigned int SQ_WAVE_LDS_ALLOC__LDS_BASE__SHIFT                 = 0x00000000;
constexpr unsigned int SQ_WAVE_LDS_ALLOC__LDS_SIZE__SHIFT                 = 0x0000000c;
constexpr unsigned int SQ_WAVE_M0__M0__SHIFT                              = 0x00000000;
constexpr unsigned int SQ_WAVE_MODE__DX10_CLAMP__SHIFT                    = 0x00000008;
constexpr unsigned int SQ_WAVE_MODE__EXCP_EN__SHIFT                       = 0x0000000c;
constexpr unsigned int SQ_WAVE_MODE__FP16_OVFL__SHIFT                     = 0x00000017;
constexpr unsigned int SQ_WAVE_MODE__FP_DENORM__SHIFT                     = 0x00000004;
constexpr unsigned int SQ_WAVE_MODE__FP_ROUND__SHIFT                      = 0x00000000;
constexpr unsigned int SQ_WAVE_MODE__IEEE__SHIFT                          = 0x00000009;
constexpr unsigned int SQ_WAVE_MODE__LOD_CLAMPED__SHIFT                   = 0x0000000a;
constexpr unsigned int SQ_WAVE_PC_HI__PC_HI__SHIFT                        = 0x00000000;
constexpr unsigned int SQ_WAVE_PC_LO__PC_LO__SHIFT                        = 0x00000000;
constexpr unsigned int SQ_WAVE_STATUS__COND_DBG_SYS__SHIFT                = 0x00000015;
constexpr unsigned int SQ_WAVE_STATUS__COND_DBG_USER__SHIFT               = 0x00000014;
constexpr unsigned int SQ_WAVE_STATUS__ECC_ERR__SHIFT                     = 0x00000011;
constexpr unsigned int SQ_WAVE_STATUS__EXECZ__SHIFT                       = 0x00000009;
constexpr unsigned int SQ_WAVE_STATUS__EXPORT_RDY__SHIFT                  = 0x00000008;
constexpr unsigned int SQ_WAVE_STATUS__FATAL_HALT__SHIFT                  = 0x00000017;
constexpr unsigned int SQ_WAVE_STATUS__HALT__SHIFT                        = 0x0000000d;
constexpr unsigned int SQ_WAVE_STATUS__IN_BARRIER__SHIFT                  = 0x0000000c;
constexpr unsigned int SQ_WAVE_STATUS__IN_TG__SHIFT                       = 0x0000000b;
constexpr unsigned int SQ_WAVE_STATUS__MUST_EXPORT__SHIFT                 = 0x0000001b;
constexpr unsigned int SQ_WAVE_STATUS__PERF_EN__SHIFT                     = 0x00000013;
constexpr unsigned int SQ_WAVE_STATUS__PRIV__SHIFT                        = 0x00000005;
constexpr unsigned int SQ_WAVE_STATUS__SCC__SHIFT                         = 0x00000000;
constexpr unsigned int SQ_WAVE_STATUS__SKIP_EXPORT__SHIFT                 = 0x00000012;
constexpr unsigned int SQ_WAVE_STATUS__SPI_PRIO__SHIFT                    = 0x00000001;
constexpr unsigned int SQ_WAVE_STATUS__TRAP_EN__SHIFT                     = 0x00000006;
constexpr unsigned int SQ_WAVE_STATUS__TRAP__SHIFT                        = 0x0000000e;
constexpr unsigned int SQ_WAVE_STATUS__TTRACE_EN__SHIFT                   = 0x00000007;
constexpr unsigned int SQ_WAVE_STATUS__USER_PRIO__SHIFT                   = 0x00000003;
constexpr unsigned int SQ_WAVE_STATUS__VALID__SHIFT                       = 0x00000010;
constexpr unsigned int SQ_WAVE_STATUS__VCCZ__SHIFT                        = 0x0000000a;
constexpr unsigned int SQ_WAVE_TRAPSTS__DP_RATE__SHIFT                    = 0x0000001d;
constexpr unsigned int SQ_WAVE_TRAPSTS__EXCP_CYCLE__SHIFT                 = 0x00000010;
constexpr unsigned int SQ_WAVE_TRAPSTS__EXCP_HI__SHIFT                    = 0x0000000c;
constexpr unsigned int SQ_WAVE_TRAPSTS__EXCP__SHIFT                       = 0x00000000;
constexpr unsigned int SQ_WAVE_TRAPSTS__ILLEGAL_INST__SHIFT               = 0x0000000b;
constexpr unsigned int SQ_WAVE_TRAPSTS__SAVECTX__SHIFT                    = 0x0000000a;
constexpr unsigned int SQ_WAVE_TTMP0__DATA__SHIFT                         = 0x00000000;
constexpr unsigned int SQ_WAVE_TTMP1__DATA__SHIFT                         = 0x00000000;
constexpr unsigned int SQ_WAVE_TTMP2__DATA__SHIFT                         = 0x00000000;
constexpr unsigned int SQ_WAVE_TTMP3__DATA__SHIFT                         = 0x00000000;
constexpr unsigned int SQ_WAVE_TTMP4__DATA__SHIFT                         = 0x00000000;
constexpr unsigned int SQ_WAVE_TTMP5__DATA__SHIFT                         = 0x00000000;
constexpr unsigned int SQ_WAVE_TTMP6__DATA__SHIFT                         = 0x00000000;
constexpr unsigned int SQ_WAVE_TTMP7__DATA__SHIFT                         = 0x00000000;
constexpr unsigned int SQ_WAVE_TTMP8__DATA__SHIFT                         = 0x00000000;
constexpr unsigned int SQ_WAVE_TTMP9__DATA__SHIFT                         = 0x00000000;
constexpr unsigned int SQ_WAVE_TTMP10__DATA__SHIFT                        = 0x00000000;
constexpr unsigned int SQ_WAVE_TTMP11__DATA__SHIFT                        = 0x00000000;
constexpr unsigned int SQ_WAVE_TTMP12__DATA__SHIFT                        = 0x00000000;
constexpr unsigned int SQ_WAVE_TTMP13__DATA__SHIFT                        = 0x00000000;
constexpr unsigned int SQ_WAVE_TTMP14__DATA__SHIFT                        = 0x00000000;
constexpr unsigned int SQ_WAVE_TTMP15__DATA__SHIFT                        = 0x00000000;
constexpr unsigned int SQ_WREXEC_EXEC_HI__ADDR_HI__SHIFT                  = 0x00000000;
constexpr unsigned int SQ_WREXEC_EXEC_HI__FIRST_WAVE__SHIFT               = 0x0000001a;
constexpr unsigned int SQ_WREXEC_EXEC_HI__MSB__SHIFT                      = 0x0000001f;
constexpr unsigned int SQ_WREXEC_EXEC_HI__MTYPE__SHIFT                    = 0x0000001c;
constexpr unsigned int SQ_WREXEC_EXEC_LO__ADDR_LO__SHIFT                  = 0x00000000;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT0_ALPHA_OPT_DISABLE__SHIFT = 0x00000001;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT0_COLOR_OPT_DISABLE__SHIFT = 0x00000000;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT1_ALPHA_OPT_DISABLE__SHIFT = 0x00000005;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT1_COLOR_OPT_DISABLE__SHIFT = 0x00000004;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT2_ALPHA_OPT_DISABLE__SHIFT = 0x00000009;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT2_COLOR_OPT_DISABLE__SHIFT = 0x00000008;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT3_ALPHA_OPT_DISABLE__SHIFT = 0x0000000d;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT3_COLOR_OPT_DISABLE__SHIFT = 0x0000000c;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT4_ALPHA_OPT_DISABLE__SHIFT = 0x00000011;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT4_COLOR_OPT_DISABLE__SHIFT = 0x00000010;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT5_ALPHA_OPT_DISABLE__SHIFT = 0x00000015;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT5_COLOR_OPT_DISABLE__SHIFT = 0x00000014;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT6_ALPHA_OPT_DISABLE__SHIFT = 0x00000019;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT6_COLOR_OPT_DISABLE__SHIFT = 0x00000018;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT7_ALPHA_OPT_DISABLE__SHIFT = 0x0000001d;
constexpr unsigned int SX_BLEND_OPT_CONTROL__MRT7_COLOR_OPT_DISABLE__SHIFT = 0x0000001c;
constexpr unsigned int SX_BLEND_OPT_CONTROL__PIXEN_ZERO_OPT_DISABLE__SHIFT = 0x0000001f;
constexpr unsigned int SX_BLEND_OPT_EPSILON__MRT0_EPSILON__SHIFT          = 0x00000000;
constexpr unsigned int SX_BLEND_OPT_EPSILON__MRT1_EPSILON__SHIFT          = 0x00000004;
constexpr unsigned int SX_BLEND_OPT_EPSILON__MRT2_EPSILON__SHIFT          = 0x00000008;
constexpr unsigned int SX_BLEND_OPT_EPSILON__MRT3_EPSILON__SHIFT          = 0x0000000c;
constexpr unsigned int SX_BLEND_OPT_EPSILON__MRT4_EPSILON__SHIFT          = 0x00000010;
constexpr unsigned int SX_BLEND_OPT_EPSILON__MRT5_EPSILON__SHIFT          = 0x00000014;
constexpr unsigned int SX_BLEND_OPT_EPSILON__MRT6_EPSILON__SHIFT          = 0x00000018;
constexpr unsigned int SX_BLEND_OPT_EPSILON__MRT7_EPSILON__SHIFT          = 0x0000001c;
constexpr unsigned int SX_MRT0_BLEND_OPT__ALPHA_COMB_FCN__SHIFT           = 0x00000018;
constexpr unsigned int SX_MRT0_BLEND_OPT__ALPHA_DST_OPT__SHIFT            = 0x00000014;
constexpr unsigned int SX_MRT0_BLEND_OPT__ALPHA_SRC_OPT__SHIFT            = 0x00000010;
constexpr unsigned int SX_MRT0_BLEND_OPT__COLOR_COMB_FCN__SHIFT           = 0x00000008;
constexpr unsigned int SX_MRT0_BLEND_OPT__COLOR_DST_OPT__SHIFT            = 0x00000004;
constexpr unsigned int SX_MRT0_BLEND_OPT__COLOR_SRC_OPT__SHIFT            = 0x00000000;
constexpr unsigned int SX_MRT1_BLEND_OPT__ALPHA_COMB_FCN__SHIFT           = 0x00000018;
constexpr unsigned int SX_MRT1_BLEND_OPT__ALPHA_DST_OPT__SHIFT            = 0x00000014;
constexpr unsigned int SX_MRT1_BLEND_OPT__ALPHA_SRC_OPT__SHIFT            = 0x00000010;
constexpr unsigned int SX_MRT1_BLEND_OPT__COLOR_COMB_FCN__SHIFT           = 0x00000008;
constexpr unsigned int SX_MRT1_BLEND_OPT__COLOR_DST_OPT__SHIFT            = 0x00000004;
constexpr unsigned int SX_MRT1_BLEND_OPT__COLOR_SRC_OPT__SHIFT            = 0x00000000;
constexpr unsigned int SX_MRT2_BLEND_OPT__ALPHA_COMB_FCN__SHIFT           = 0x00000018;
constexpr unsigned int SX_MRT2_BLEND_OPT__ALPHA_DST_OPT__SHIFT            = 0x00000014;
constexpr unsigned int SX_MRT2_BLEND_OPT__ALPHA_SRC_OPT__SHIFT            = 0x00000010;
constexpr unsigned int SX_MRT2_BLEND_OPT__COLOR_COMB_FCN__SHIFT           = 0x00000008;
constexpr unsigned int SX_MRT2_BLEND_OPT__COLOR_DST_OPT__SHIFT            = 0x00000004;
constexpr unsigned int SX_MRT2_BLEND_OPT__COLOR_SRC_OPT__SHIFT            = 0x00000000;
constexpr unsigned int SX_MRT3_BLEND_OPT__ALPHA_COMB_FCN__SHIFT           = 0x00000018;
constexpr unsigned int SX_MRT3_BLEND_OPT__ALPHA_DST_OPT__SHIFT            = 0x00000014;
constexpr unsigned int SX_MRT3_BLEND_OPT__ALPHA_SRC_OPT__SHIFT            = 0x00000010;
constexpr unsigned int SX_MRT3_BLEND_OPT__COLOR_COMB_FCN__SHIFT           = 0x00000008;
constexpr unsigned int SX_MRT3_BLEND_OPT__COLOR_DST_OPT__SHIFT            = 0x00000004;
constexpr unsigned int SX_MRT3_BLEND_OPT__COLOR_SRC_OPT__SHIFT            = 0x00000000;
constexpr unsigned int SX_MRT4_BLEND_OPT__ALPHA_COMB_FCN__SHIFT           = 0x00000018;
constexpr unsigned int SX_MRT4_BLEND_OPT__ALPHA_DST_OPT__SHIFT            = 0x00000014;
constexpr unsigned int SX_MRT4_BLEND_OPT__ALPHA_SRC_OPT__SHIFT            = 0x00000010;
constexpr unsigned int SX_MRT4_BLEND_OPT__COLOR_COMB_FCN__SHIFT           = 0x00000008;
constexpr unsigned int SX_MRT4_BLEND_OPT__COLOR_DST_OPT__SHIFT            = 0x00000004;
constexpr unsigned int SX_MRT4_BLEND_OPT__COLOR_SRC_OPT__SHIFT            = 0x00000000;
constexpr unsigned int SX_MRT5_BLEND_OPT__ALPHA_COMB_FCN__SHIFT           = 0x00000018;
constexpr unsigned int SX_MRT5_BLEND_OPT__ALPHA_DST_OPT__SHIFT            = 0x00000014;
constexpr unsigned int SX_MRT5_BLEND_OPT__ALPHA_SRC_OPT__SHIFT            = 0x00000010;
constexpr unsigned int SX_MRT5_BLEND_OPT__COLOR_COMB_FCN__SHIFT           = 0x00000008;
constexpr unsigned int SX_MRT5_BLEND_OPT__COLOR_DST_OPT__SHIFT            = 0x00000004;
constexpr unsigned int SX_MRT5_BLEND_OPT__COLOR_SRC_OPT__SHIFT            = 0x00000000;
constexpr unsigned int SX_MRT6_BLEND_OPT__ALPHA_COMB_FCN__SHIFT           = 0x00000018;
constexpr unsigned int SX_MRT6_BLEND_OPT__ALPHA_DST_OPT__SHIFT            = 0x00000014;
constexpr unsigned int SX_MRT6_BLEND_OPT__ALPHA_SRC_OPT__SHIFT            = 0x00000010;
constexpr unsigned int SX_MRT6_BLEND_OPT__COLOR_COMB_FCN__SHIFT           = 0x00000008;
constexpr unsigned int SX_MRT6_BLEND_OPT__COLOR_DST_OPT__SHIFT            = 0x00000004;
constexpr unsigned int SX_MRT6_BLEND_OPT__COLOR_SRC_OPT__SHIFT            = 0x00000000;
constexpr unsigned int SX_MRT7_BLEND_OPT__ALPHA_COMB_FCN__SHIFT           = 0x00000018;
constexpr unsigned int SX_MRT7_BLEND_OPT__ALPHA_DST_OPT__SHIFT            = 0x00000014;
constexpr unsigned int SX_MRT7_BLEND_OPT__ALPHA_SRC_OPT__SHIFT            = 0x00000010;
constexpr unsigned int SX_MRT7_BLEND_OPT__COLOR_COMB_FCN__SHIFT           = 0x00000008;
constexpr unsigned int SX_MRT7_BLEND_OPT__COLOR_DST_OPT__SHIFT            = 0x00000004;
constexpr unsigned int SX_MRT7_BLEND_OPT__COLOR_SRC_OPT__SHIFT            = 0x00000000;
constexpr unsigned int SX_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
constexpr unsigned int SX_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int SX_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT           = 0x00000014;
constexpr unsigned int SX_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
constexpr unsigned int SX_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int SX_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT           = 0x00000014;
constexpr unsigned int SX_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
constexpr unsigned int SX_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int SX_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT           = 0x00000014;
constexpr unsigned int SX_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
constexpr unsigned int SX_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int SX_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT           = 0x00000014;
constexpr unsigned int SX_PS_DOWNCONVERT__MRT0__SHIFT                     = 0x00000000;
constexpr unsigned int SX_PS_DOWNCONVERT__MRT1__SHIFT                     = 0x00000004;
constexpr unsigned int SX_PS_DOWNCONVERT__MRT2__SHIFT                     = 0x00000008;
constexpr unsigned int SX_PS_DOWNCONVERT__MRT3__SHIFT                     = 0x0000000c;
constexpr unsigned int SX_PS_DOWNCONVERT__MRT4__SHIFT                     = 0x00000010;
constexpr unsigned int SX_PS_DOWNCONVERT__MRT5__SHIFT                     = 0x00000014;
constexpr unsigned int SX_PS_DOWNCONVERT__MRT6__SHIFT                     = 0x00000018;
constexpr unsigned int SX_PS_DOWNCONVERT__MRT7__SHIFT                     = 0x0000001c;
constexpr unsigned int TA_BC_BASE_ADDR_HI__ADDRESS__SHIFT                 = 0x00000000;
constexpr unsigned int TA_BC_BASE_ADDR__ADDRESS__SHIFT                    = 0x00000000;
constexpr unsigned int TA_CGTT_CTRL__OFF_HYSTERESIS__SHIFT                = 0x00000004;
constexpr unsigned int TA_CGTT_CTRL__ON_DELAY__SHIFT                      = 0x00000000;
constexpr unsigned int TA_CGTT_CTRL__SOFT_OVERRIDE0__SHIFT                = 0x0000001f;
constexpr unsigned int TA_CGTT_CTRL__SOFT_OVERRIDE1__SHIFT                = 0x0000001e;
constexpr unsigned int TA_CGTT_CTRL__SOFT_OVERRIDE2__SHIFT                = 0x0000001d;
constexpr unsigned int TA_CGTT_CTRL__SOFT_OVERRIDE3__SHIFT                = 0x0000001c;
constexpr unsigned int TA_CGTT_CTRL__SOFT_OVERRIDE4__SHIFT                = 0x0000001b;
constexpr unsigned int TA_CGTT_CTRL__SOFT_OVERRIDE5__SHIFT                = 0x0000001a;
constexpr unsigned int TA_CGTT_CTRL__SOFT_OVERRIDE6__SHIFT                = 0x00000019;
constexpr unsigned int TA_CGTT_CTRL__SOFT_OVERRIDE7__SHIFT                = 0x00000018;
constexpr unsigned int TA_CGTT_CTRL__SOFT_STALL_OVERRIDE0__SHIFT          = 0x00000017;
constexpr unsigned int TA_CGTT_CTRL__SOFT_STALL_OVERRIDE1__SHIFT          = 0x00000016;
constexpr unsigned int TA_CGTT_CTRL__SOFT_STALL_OVERRIDE2__SHIFT          = 0x00000015;
constexpr unsigned int TA_CGTT_CTRL__SOFT_STALL_OVERRIDE3__SHIFT          = 0x00000014;
constexpr unsigned int TA_CGTT_CTRL__SOFT_STALL_OVERRIDE4__SHIFT          = 0x00000013;
constexpr unsigned int TA_CGTT_CTRL__SOFT_STALL_OVERRIDE5__SHIFT          = 0x00000012;
constexpr unsigned int TA_CGTT_CTRL__SOFT_STALL_OVERRIDE6__SHIFT          = 0x00000011;
constexpr unsigned int TA_CGTT_CTRL__SOFT_STALL_OVERRIDE7__SHIFT          = 0x00000010;
constexpr unsigned int TA_CNTL_AUX__ANISO_ERROR_FP_VBIAS__SHIFT           = 0x0000000c;
constexpr unsigned int TA_CNTL_AUX__ANISO_HALF_THRESH__SHIFT              = 0x0000000a;
constexpr unsigned int TA_CNTL_AUX__ANISO_RATIO_LUT__SHIFT                = 0x00000011;
constexpr unsigned int TA_CNTL_AUX__ANISO_STEP_ORDER__SHIFT               = 0x0000000d;
constexpr unsigned int TA_CNTL_AUX__ANISO_STEP__SHIFT                     = 0x0000000e;
constexpr unsigned int TA_CNTL_AUX__ANISO_TAP__SHIFT                      = 0x00000012;
constexpr unsigned int TA_CNTL_AUX__ANISO_WEIGHT_MODE__SHIFT              = 0x00000010;
constexpr unsigned int TA_CNTL_AUX__ARRAY_ROUND_MODE__SHIFT               = 0x0000001e;
constexpr unsigned int TA_CNTL_AUX__CUBEMAP_SLICE_CLAMP__SHIFT            = 0x0000001c;
constexpr unsigned int TA_CNTL_AUX__DETERMINISM_DFMT_NFMT_DISABLE__SHIFT  = 0x0000001a;
constexpr unsigned int TA_CNTL_AUX__DETERMINISM_MISC_DISABLE__SHIFT       = 0x00000016;
constexpr unsigned int TA_CNTL_AUX__DETERMINISM_OPCODE_STRICT_DISABLE__SHIFT = 0x00000015;
constexpr unsigned int TA_CNTL_AUX__DETERMINISM_RESERVED_DISABLE__SHIFT   = 0x00000014;
constexpr unsigned int TA_CNTL_AUX__DETERMINISM_SAMPLER_MSAA_DISABLE__SHIFT = 0x00000018;
constexpr unsigned int TA_CNTL_AUX__DETERMINISM_SAMPLE_C_DFMT_DISABLE__SHIFT = 0x00000017;
constexpr unsigned int TA_CNTL_AUX__DETERMINISM_WRITEOP_READFMT_DISABLE__SHIFT = 0x00000019;
constexpr unsigned int TA_CNTL_AUX__DISABLE_DWORD_X2_COALESCE__SHIFT      = 0x0000001b;
constexpr unsigned int TA_CNTL_AUX__DISABLE_GATHER4_BC_SWIZZLE__SHIFT     = 0x00000007;
constexpr unsigned int TA_CNTL_AUX__GATHERH_DST_SEL__SHIFT                = 0x00000006;
constexpr unsigned int TA_CNTL_AUX__MINMAG_UNNORM__SHIFT                  = 0x0000000f;
constexpr unsigned int TA_CNTL_AUX__SCOAL_DSWIZZLE_N__SHIFT               = 0x00000000;
constexpr unsigned int TA_CNTL_AUX__TFAULT_EN_OVERRIDE__SHIFT             = 0x00000005;
constexpr unsigned int TA_CNTL_AUX__TRUNC_SMALL_NEG__SHIFT                = 0x0000001d;
constexpr unsigned int TA_CNTL__ALIGNER_CREDIT__SHIFT                     = 0x00000010;
constexpr unsigned int TA_CNTL__TD_FIFO_CREDIT__SHIFT                     = 0x00000016;
constexpr unsigned int TA_CS_BC_BASE_ADDR_HI__ADDRESS__SHIFT              = 0x00000000;
constexpr unsigned int TA_CS_BC_BASE_ADDR__ADDRESS__SHIFT                 = 0x00000000;
constexpr unsigned int TA_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
constexpr unsigned int TA_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int TA_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT         = 0x0000001c;
constexpr unsigned int TA_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT         = 0x00000018;
constexpr unsigned int TA_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT          = 0x00000000;
constexpr unsigned int TA_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT          = 0x0000000a;
constexpr unsigned int TA_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT           = 0x00000014;
constexpr unsigned int TA_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT          = 0x00000018;
constexpr unsigned int TA_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int TA_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT           = 0x0000000a;
constexpr unsigned int TA_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int TA_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
constexpr unsigned int TA_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int TA_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT           = 0x00000014;
constexpr unsigned int TA_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int TA_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int TA_RESERVED_010C__Unused__SHIFT                    = 0x00000000;
constexpr unsigned int TA_SCRATCH__SCRATCH__SHIFT                         = 0x00000000;
constexpr unsigned int TA_STATUS__AL_BUSY__SHIFT                          = 0x0000001e;
constexpr unsigned int TA_STATUS__BUSY__SHIFT                             = 0x0000001f;
constexpr unsigned int TA_STATUS__FA_BUSY__SHIFT                          = 0x0000001d;
constexpr unsigned int TA_STATUS__FA_LFIFO_EMPTYB__SHIFT                  = 0x00000015;
constexpr unsigned int TA_STATUS__FA_PFIFO_EMPTYB__SHIFT                  = 0x00000014;
constexpr unsigned int TA_STATUS__FA_SFIFO_EMPTYB__SHIFT                  = 0x00000016;
constexpr unsigned int TA_STATUS__FG_BUSY__SHIFT                          = 0x00000019;
constexpr unsigned int TA_STATUS__FG_LFIFO_EMPTYB__SHIFT                  = 0x0000000d;
constexpr unsigned int TA_STATUS__FG_PFIFO_EMPTYB__SHIFT                  = 0x0000000c;
constexpr unsigned int TA_STATUS__FG_SFIFO_EMPTYB__SHIFT                  = 0x0000000e;
constexpr unsigned int TA_STATUS__FL_BUSY__SHIFT                          = 0x0000001b;
constexpr unsigned int TA_STATUS__FL_LFIFO_EMPTYB__SHIFT                  = 0x00000011;
constexpr unsigned int TA_STATUS__FL_PFIFO_EMPTYB__SHIFT                  = 0x00000010;
constexpr unsigned int TA_STATUS__FL_SFIFO_EMPTYB__SHIFT                  = 0x00000012;
constexpr unsigned int TA_STATUS__IN_BUSY__SHIFT                          = 0x00000018;
constexpr unsigned int TA_STATUS__LA_BUSY__SHIFT                          = 0x0000001a;
constexpr unsigned int TA_STATUS__TA_BUSY__SHIFT                          = 0x0000001c;
constexpr unsigned int TCP_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT        = 0x0000001c;
constexpr unsigned int TCP_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT        = 0x00000018;
constexpr unsigned int TCP_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
constexpr unsigned int TCP_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
constexpr unsigned int TCP_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT         = 0x00000018;
constexpr unsigned int TCP_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int TCP_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
constexpr unsigned int TCP_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT        = 0x0000001c;
constexpr unsigned int TCP_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT        = 0x00000018;
constexpr unsigned int TCP_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
constexpr unsigned int TCP_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
constexpr unsigned int TCP_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT         = 0x00000018;
constexpr unsigned int TCP_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int TCP_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
constexpr unsigned int TCP_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
constexpr unsigned int TCP_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int TCP_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
constexpr unsigned int TCP_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
constexpr unsigned int TCP_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT           = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__BUFFER__SHIFT           = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__DATA_FORMAT__SHIFT      = 0x00000003;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__DIM__SHIFT              = 0x00000002;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__FLAT__SHIFT             = 0x00000001;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__NUM_FORMAT__SHIFT       = 0x00000004;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__NUM_SAMPLES__SHIFT      = 0x00000006;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__OPCODE_TYPE__SHIFT      = 0x00000007;
constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__SW_MODE__SHIFT          = 0x00000005;
constexpr unsigned int TCP_PERFCOUNTER_FILTER__BUFFER__SHIFT              = 0x00000000;
constexpr unsigned int TCP_PERFCOUNTER_FILTER__DATA_FORMAT__SHIFT         = 0x00000005;
constexpr unsigned int TCP_PERFCOUNTER_FILTER__DIM__SHIFT                 = 0x00000002;
constexpr unsigned int TCP_PERFCOUNTER_FILTER__FLAT__SHIFT                = 0x00000001;
constexpr unsigned int TD_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
constexpr unsigned int TD_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int TD_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT         = 0x0000001c;
constexpr unsigned int TD_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT         = 0x00000018;
constexpr unsigned int TD_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT          = 0x00000000;
constexpr unsigned int TD_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT          = 0x0000000a;
constexpr unsigned int TD_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT           = 0x00000014;
constexpr unsigned int TD_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT          = 0x00000018;
constexpr unsigned int TD_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int TD_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT           = 0x0000000a;
constexpr unsigned int TD_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int TD_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
constexpr unsigned int TD_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
constexpr unsigned int TD_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT           = 0x00000014;
constexpr unsigned int TD_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
constexpr unsigned int TD_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT            = 0x00000000;
constexpr unsigned int VGT_CACHE_INVALIDATION__AUTO_INVLD_EN__SHIFT       = 0x00000006;
constexpr unsigned int VGT_CACHE_INVALIDATION__CACHE_INVALIDATION__SHIFT  = 0x00000000;
constexpr unsigned int VGT_CACHE_INVALIDATION__DIS_INSTANCING_OPT__SHIFT  = 0x00000004;
constexpr unsigned int VGT_CACHE_INVALIDATION__DIS_RANGE_FULL_INVLD__SHIFT = 0x0000000b;
constexpr unsigned int VGT_CACHE_INVALIDATION__ENABLE_PING_PONG_EOI__SHIFT = 0x0000001d;
constexpr unsigned int VGT_CACHE_INVALIDATION__ENABLE_PING_PONG__SHIFT    = 0x00000015;
constexpr unsigned int VGT_CACHE_INVALIDATION__EN_WAVE_MERGE__SHIFT       = 0x0000001c;
constexpr unsigned int VGT_CACHE_INVALIDATION__ES_LIMIT__SHIFT            = 0x00000010;
constexpr unsigned int VGT_CACHE_INVALIDATION__GS_LATE_ALLOC_EN__SHIFT    = 0x0000000c;
constexpr unsigned int VGT_CACHE_INVALIDATION__OPT_FLOW_CNTL_1__SHIFT     = 0x00000016;
constexpr unsigned int VGT_CACHE_INVALIDATION__OPT_FLOW_CNTL_2__SHIFT     = 0x00000019;
constexpr unsigned int VGT_CACHE_INVALIDATION__STREAMOUT_FULL_FLUSH__SHIFT = 0x0000000d;
constexpr unsigned int VGT_CACHE_INVALIDATION__USE_GS_DONE__SHIFT         = 0x00000009;
constexpr unsigned int VGT_CACHE_INVALIDATION__VS_NO_EXTRA_BUFFER__SHIFT  = 0x00000005;
constexpr unsigned int VGT_DMA_BASE_HI__BASE_ADDR__SHIFT                  = 0x00000000;
constexpr unsigned int VGT_DMA_BASE__BASE_ADDR__SHIFT                     = 0x00000000;
constexpr unsigned int VGT_DMA_CONTROL__IA_SWITCH_ON_EOP__SHIFT           = 0x00000011;
constexpr unsigned int VGT_DMA_CONTROL__PRIMGROUP_SIZE__SHIFT             = 0x00000000;
constexpr unsigned int VGT_DMA_CONTROL__SWITCH_ON_EOI__SHIFT              = 0x00000013;
constexpr unsigned int VGT_DMA_CONTROL__WD_SWITCH_ON_EOP__SHIFT           = 0x00000014;
constexpr unsigned int VGT_DMA_DATA_FIFO_DEPTH__DMA_DATA_FIFO_DEPTH__SHIFT = 0x00000000;
constexpr unsigned int VGT_DMA_EVENT_INITIATOR__ADDRESS_HI__SHIFT         = 0x0000000a;
constexpr unsigned int VGT_DMA_EVENT_INITIATOR__EVENT_TYPE__SHIFT         = 0x00000000;
constexpr unsigned int VGT_DMA_EVENT_INITIATOR__EXTENDED_EVENT__SHIFT     = 0x0000001b;
constexpr unsigned int VGT_DMA_INDEX_TYPE__BUF_TYPE__SHIFT                = 0x00000004;
constexpr unsigned int VGT_DMA_INDEX_TYPE__INDEX_TYPE__SHIFT              = 0x00000000;
constexpr unsigned int VGT_DMA_INDEX_TYPE__NOT_EOP__SHIFT                 = 0x00000009;
constexpr unsigned int VGT_DMA_INDEX_TYPE__RDREQ_POLICY__SHIFT            = 0x00000006;
constexpr unsigned int VGT_DMA_INDEX_TYPE__REQ_PATH__SHIFT                = 0x0000000a;
constexpr unsigned int VGT_DMA_INDEX_TYPE__SWAP_MODE__SHIFT               = 0x00000002;
constexpr unsigned int VGT_DMA_LS_HS_CONFIG__HS_NUM_INPUT_CP__SHIFT       = 0x00000008;
constexpr unsigned int VGT_DMA_MAX_SIZE__MAX_SIZE__SHIFT                  = 0x00000000;
constexpr unsigned int VGT_DMA_NUM_INSTANCES__NUM_INSTANCES__SHIFT        = 0x00000000;
constexpr unsigned int VGT_DMA_PRIMITIVE_TYPE__PRIM_TYPE__SHIFT           = 0x00000000;
constexpr unsigned int VGT_DMA_REQ_FIFO_DEPTH__DMA_REQ_FIFO_DEPTH__SHIFT  = 0x00000000;
constexpr unsigned int VGT_DMA_SIZE__NUM_INDICES__SHIFT                   = 0x00000000;
constexpr unsigned int VGT_DRAW_INITIATOR__MAJOR_MODE__SHIFT              = 0x00000002;
constexpr unsigned int VGT_DRAW_INITIATOR__NOT_EOP__SHIFT                 = 0x00000005;
constexpr unsigned int VGT_DRAW_INITIATOR__REG_RT_INDEX__SHIFT            = 0x0000001d;
constexpr unsigned int VGT_DRAW_INITIATOR__SOURCE_SELECT__SHIFT           = 0x00000000;
constexpr unsigned int VGT_DRAW_INITIATOR__SPRITE_EN_R6XX__SHIFT          = 0x00000004;
constexpr unsigned int VGT_DRAW_INITIATOR__USE_OPAQUE__SHIFT              = 0x00000006;
constexpr unsigned int VGT_DRAW_INIT_FIFO_DEPTH__DRAW_INIT_FIFO_DEPTH__SHIFT = 0x00000000;
constexpr unsigned int VGT_DRAW_PAYLOAD_CNTL__EN_REG_RT_INDEX__SHIFT      = 0x00000001;
constexpr unsigned int VGT_ENHANCE__MISC__SHIFT                           = 0x00000000;
constexpr unsigned int VGT_ESGS_RING_ITEMSIZE__ITEMSIZE__SHIFT            = 0x00000000;
constexpr unsigned int VGT_ES_PER_GS__ES_PER_GS__SHIFT                    = 0x00000000;
constexpr unsigned int VGT_EVENT_ADDRESS_REG__ADDRESS_LOW__SHIFT          = 0x00000000;
constexpr unsigned int VGT_EVENT_INITIATOR__ADDRESS_HI__SHIFT             = 0x0000000a;
constexpr unsigned int VGT_EVENT_INITIATOR__EVENT_TYPE__SHIFT             = 0x00000000;
constexpr unsigned int VGT_EVENT_INITIATOR__EXTENDED_EVENT__SHIFT         = 0x0000001b;
constexpr unsigned int VGT_FIFO_DEPTHS__CLIPP_FIFO_DEPTH__SHIFT           = 0x00000008;
constexpr unsigned int VGT_FIFO_DEPTHS__RESERVED_0__SHIFT                 = 0x00000007;
constexpr unsigned int VGT_FIFO_DEPTHS__VS_DEALLOC_TBL_DEPTH__SHIFT       = 0x00000000;
constexpr unsigned int VGT_GROUP_DECR__DECR__SHIFT                        = 0x00000000;
constexpr unsigned int VGT_GROUP_FIRST_DECR__FIRST_DECR__SHIFT            = 0x00000000;
constexpr unsigned int VGT_GROUP_PRIM_TYPE__PRIM_ORDER__SHIFT             = 0x00000010;
constexpr unsigned int VGT_GROUP_PRIM_TYPE__PRIM_TYPE__SHIFT              = 0x00000000;
constexpr unsigned int VGT_GROUP_PRIM_TYPE__RETAIN_ORDER__SHIFT           = 0x0000000e;
constexpr unsigned int VGT_GROUP_PRIM_TYPE__RETAIN_QUADS__SHIFT           = 0x0000000f;
constexpr unsigned int VGT_GROUP_VECT_0_CNTL__COMP_W_EN__SHIFT            = 0x00000003;
constexpr unsigned int VGT_GROUP_VECT_0_CNTL__COMP_X_EN__SHIFT            = 0x00000000;
constexpr unsigned int VGT_GROUP_VECT_0_CNTL__COMP_Y_EN__SHIFT            = 0x00000001;
constexpr unsigned int VGT_GROUP_VECT_0_CNTL__COMP_Z_EN__SHIFT            = 0x00000002;
constexpr unsigned int VGT_GROUP_VECT_0_CNTL__SHIFT__SHIFT                = 0x00000010;
constexpr unsigned int VGT_GROUP_VECT_0_CNTL__STRIDE__SHIFT               = 0x00000008;
constexpr unsigned int VGT_GROUP_VECT_0_FMT_CNTL__W_CONV__SHIFT           = 0x00000018;
constexpr unsigned int VGT_GROUP_VECT_0_FMT_CNTL__W_OFFSET__SHIFT         = 0x0000001c;
constexpr unsigned int VGT_GROUP_VECT_0_FMT_CNTL__X_CONV__SHIFT           = 0x00000000;
constexpr unsigned int VGT_GROUP_VECT_0_FMT_CNTL__X_OFFSET__SHIFT         = 0x00000004;
constexpr unsigned int VGT_GROUP_VECT_0_FMT_CNTL__Y_CONV__SHIFT           = 0x00000008;
constexpr unsigned int VGT_GROUP_VECT_0_FMT_CNTL__Y_OFFSET__SHIFT         = 0x0000000c;
constexpr unsigned int VGT_GROUP_VECT_0_FMT_CNTL__Z_CONV__SHIFT           = 0x00000010;
constexpr unsigned int VGT_GROUP_VECT_0_FMT_CNTL__Z_OFFSET__SHIFT         = 0x00000014;
constexpr unsigned int VGT_GROUP_VECT_1_CNTL__COMP_W_EN__SHIFT            = 0x00000003;
constexpr unsigned int VGT_GROUP_VECT_1_CNTL__COMP_X_EN__SHIFT            = 0x00000000;
constexpr unsigned int VGT_GROUP_VECT_1_CNTL__COMP_Y_EN__SHIFT            = 0x00000001;
constexpr unsigned int VGT_GROUP_VECT_1_CNTL__COMP_Z_EN__SHIFT            = 0x00000002;
constexpr unsigned int VGT_GROUP_VECT_1_CNTL__SHIFT__SHIFT                = 0x00000010;
constexpr unsigned int VGT_GROUP_VECT_1_CNTL__STRIDE__SHIFT               = 0x00000008;
constexpr unsigned int VGT_GROUP_VECT_1_FMT_CNTL__W_CONV__SHIFT           = 0x00000018;
constexpr unsigned int VGT_GROUP_VECT_1_FMT_CNTL__W_OFFSET__SHIFT         = 0x0000001c;
constexpr unsigned int VGT_GROUP_VECT_1_FMT_CNTL__X_CONV__SHIFT           = 0x00000000;
constexpr unsigned int VGT_GROUP_VECT_1_FMT_CNTL__X_OFFSET__SHIFT         = 0x00000004;
constexpr unsigned int VGT_GROUP_VECT_1_FMT_CNTL__Y_CONV__SHIFT           = 0x00000008;
constexpr unsigned int VGT_GROUP_VECT_1_FMT_CNTL__Y_OFFSET__SHIFT         = 0x0000000c;
constexpr unsigned int VGT_GROUP_VECT_1_FMT_CNTL__Z_CONV__SHIFT           = 0x00000010;
constexpr unsigned int VGT_GROUP_VECT_1_FMT_CNTL__Z_OFFSET__SHIFT         = 0x00000014;
constexpr unsigned int VGT_GSVS_RING_ITEMSIZE__ITEMSIZE__SHIFT            = 0x00000000;
constexpr unsigned int VGT_GSVS_RING_OFFSET_1__OFFSET__SHIFT              = 0x00000000;
constexpr unsigned int VGT_GSVS_RING_OFFSET_2__OFFSET__SHIFT              = 0x00000000;
constexpr unsigned int VGT_GSVS_RING_OFFSET_3__OFFSET__SHIFT              = 0x00000000;
constexpr unsigned int VGT_GSVS_RING_SIZE__MEM_SIZE__SHIFT                = 0x00000000;
constexpr unsigned int VGT_GS_INSTANCE_CNT__CNT__SHIFT                    = 0x00000002;
constexpr unsigned int VGT_GS_INSTANCE_CNT__ENABLE__SHIFT                 = 0x00000000;
constexpr unsigned int VGT_GS_MAX_VERT_OUT__MAX_VERT_OUT__SHIFT           = 0x00000000;
constexpr unsigned int VGT_GS_MAX_WAVE_ID__MAX_WAVE_ID__SHIFT             = 0x00000000;
constexpr unsigned int VGT_GS_MODE__CUT_MODE__SHIFT                       = 0x00000004;
constexpr unsigned int VGT_GS_MODE__ES_PASSTHRU__SHIFT                    = 0x0000000d;
constexpr unsigned int VGT_GS_MODE__ES_WRITE_OPTIMIZE__SHIFT              = 0x00000013;
constexpr unsigned int VGT_GS_MODE__GS_C_PACK_EN__SHIFT                   = 0x0000000b;
constexpr unsigned int VGT_GS_MODE__GS_WRITE_OPTIMIZE__SHIFT              = 0x00000014;
constexpr unsigned int VGT_GS_MODE__MODE__SHIFT                           = 0x00000000;
constexpr unsigned int VGT_GS_MODE__ONCHIP__SHIFT                         = 0x00000015;
constexpr unsigned int VGT_GS_MODE__PARTIAL_THD_AT_EOI__SHIFT             = 0x00000011;
constexpr unsigned int VGT_GS_MODE__RESERVED_0__SHIFT                     = 0x00000003;
constexpr unsigned int VGT_GS_MODE__RESERVED_1__SHIFT                     = 0x00000006;
constexpr unsigned int VGT_GS_MODE__RESERVED_2__SHIFT                     = 0x0000000c;
constexpr unsigned int VGT_GS_MODE__SUPPRESS_CUTS__SHIFT                  = 0x00000012;
constexpr unsigned int VGT_GS_ONCHIP_CNTL__ES_VERTS_PER_SUBGRP__SHIFT     = 0x00000000;
constexpr unsigned int VGT_GS_ONCHIP_CNTL__GS_INST_PRIMS_IN_SUBGRP__SHIFT = 0x00000016;
constexpr unsigned int VGT_GS_ONCHIP_CNTL__GS_PRIMS_PER_SUBGRP__SHIFT     = 0x0000000b;
constexpr unsigned int VGT_GS_OUT_PRIM_TYPE__OUTPRIM_TYPE_1__SHIFT        = 0x00000008;
constexpr unsigned int VGT_GS_OUT_PRIM_TYPE__OUTPRIM_TYPE_2__SHIFT        = 0x00000010;
constexpr unsigned int VGT_GS_OUT_PRIM_TYPE__OUTPRIM_TYPE_3__SHIFT        = 0x00000016;
constexpr unsigned int VGT_GS_OUT_PRIM_TYPE__OUTPRIM_TYPE__SHIFT          = 0x00000000;
constexpr unsigned int VGT_GS_OUT_PRIM_TYPE__UNIQUE_TYPE_PER_STREAM__SHIFT = 0x0000001f;
constexpr unsigned int VGT_GS_PER_ES__GS_PER_ES__SHIFT                    = 0x00000000;
constexpr unsigned int VGT_GS_PER_VS__GS_PER_VS__SHIFT                    = 0x00000000;
constexpr unsigned int VGT_GS_VERTEX_REUSE__VERT_REUSE__SHIFT             = 0x00000000;
constexpr unsigned int VGT_GS_VERT_ITEMSIZE_1__ITEMSIZE__SHIFT            = 0x00000000;
constexpr unsigned int VGT_GS_VERT_ITEMSIZE_2__ITEMSIZE__SHIFT            = 0x00000000;
constexpr unsigned int VGT_GS_VERT_ITEMSIZE_3__ITEMSIZE__SHIFT            = 0x00000000;
constexpr unsigned int VGT_GS_VERT_ITEMSIZE__ITEMSIZE__SHIFT              = 0x00000000;
constexpr unsigned int VGT_HOS_CNTL__TESS_MODE__SHIFT                     = 0x00000000;
constexpr unsigned int VGT_HOS_MAX_TESS_LEVEL__MAX_TESS__SHIFT            = 0x00000000;
constexpr unsigned int VGT_HOS_MIN_TESS_LEVEL__MIN_TESS__SHIFT            = 0x00000000;
constexpr unsigned int VGT_HOS_REUSE_DEPTH__REUSE_DEPTH__SHIFT            = 0x00000000;
constexpr unsigned int VGT_HS_OFFCHIP_PARAM__OFFCHIP_BUFFERING__SHIFT     = 0x00000000;
constexpr unsigned int VGT_IMMED_DATA__DATA__SHIFT                        = 0x00000000;
constexpr unsigned int VGT_INDEX_TYPE__INDEX_TYPE__SHIFT                  = 0x00000000;
constexpr unsigned int VGT_INDX_OFFSET__INDX_OFFSET__SHIFT                = 0x00000000;
constexpr unsigned int VGT_INSTANCE_BASE_ID__INSTANCE_BASE_ID__SHIFT      = 0x00000000;
constexpr unsigned int VGT_INSTANCE_STEP_RATE_0__STEP_RATE__SHIFT         = 0x00000000;
constexpr unsigned int VGT_INSTANCE_STEP_RATE_1__STEP_RATE__SHIFT         = 0x00000000;
constexpr unsigned int VGT_LAST_COPY_STATE__DST_STATE_ID__SHIFT           = 0x00000010;
constexpr unsigned int VGT_LAST_COPY_STATE__SRC_STATE_ID__SHIFT           = 0x00000000;
constexpr unsigned int VGT_LS_HS_CONFIG__HS_NUM_INPUT_CP__SHIFT           = 0x00000008;
constexpr unsigned int VGT_LS_HS_CONFIG__HS_NUM_OUTPUT_CP__SHIFT          = 0x0000000e;
constexpr unsigned int VGT_LS_HS_CONFIG__NUM_PATCHES__SHIFT               = 0x00000000;
constexpr unsigned int VGT_MAX_VTX_INDX__MAX_INDX__SHIFT                  = 0x00000000;
constexpr unsigned int VGT_MC_LAT_CNTL__MC_TIME_STAMP_RES__SHIFT          = 0x00000000;
constexpr unsigned int VGT_MIN_VTX_INDX__MIN_INDX__SHIFT                  = 0x00000000;
constexpr unsigned int VGT_MULTI_PRIM_IB_RESET_EN__MATCH_ALL_BITS__SHIFT  = 0x00000001;
constexpr unsigned int VGT_MULTI_PRIM_IB_RESET_EN__RESET_EN__SHIFT        = 0x00000000;
constexpr unsigned int VGT_MULTI_PRIM_IB_RESET_INDX__RESET_INDX__SHIFT    = 0x00000000;
constexpr unsigned int VGT_NUM_INDICES__NUM_INDICES__SHIFT                = 0x00000000;
constexpr unsigned int VGT_NUM_INSTANCES__NUM_INSTANCES__SHIFT            = 0x00000000;
constexpr unsigned int VGT_OUTPUT_PATH_CNTL__PATH_SELECT__SHIFT           = 0x00000000;
constexpr unsigned int VGT_OUT_DEALLOC_CNTL__DEALLOC_DIST__SHIFT          = 0x00000000;
constexpr unsigned int VGT_PRIMITIVEID_EN__DISABLE_RESET_ON_EOI__SHIFT    = 0x00000001;
constexpr unsigned int VGT_PRIMITIVEID_EN__NGG_DISABLE_PROVOK_REUSE__SHIFT = 0x00000002;
constexpr unsigned int VGT_PRIMITIVEID_EN__PRIMITIVEID_EN__SHIFT          = 0x00000000;
constexpr unsigned int VGT_PRIMITIVEID_RESET__VALUE__SHIFT                = 0x00000000;
constexpr unsigned int VGT_PRIMITIVE_TYPE__PRIM_TYPE__SHIFT               = 0x00000000;
constexpr unsigned int VGT_REUSE_OFF__REUSE_OFF__SHIFT                    = 0x00000000;
constexpr unsigned int VGT_SHADER_STAGES_EN__ES_EN__SHIFT                 = 0x00000003;
constexpr unsigned int VGT_SHADER_STAGES_EN__GS_EN__SHIFT                 = 0x00000005;
constexpr unsigned int VGT_SHADER_STAGES_EN__GS_FAST_LAUNCH__SHIFT        = 0x00000013;
constexpr unsigned int VGT_SHADER_STAGES_EN__HS_EN__SHIFT                 = 0x00000002;
constexpr unsigned int VGT_SHADER_STAGES_EN__LS_EN__SHIFT                 = 0x00000000;
constexpr unsigned int VGT_SHADER_STAGES_EN__MAX_PRIMGRP_IN_WAVE__SHIFT   = 0x0000000f;
constexpr unsigned int VGT_SHADER_STAGES_EN__ORDERED_ID_MODE__SHIFT       = 0x0000000e;
constexpr unsigned int VGT_SHADER_STAGES_EN__PRIMGEN_EN__SHIFT            = 0x0000000d;
constexpr unsigned int VGT_SHADER_STAGES_EN__VS_EN__SHIFT                 = 0x00000006;
constexpr unsigned int VGT_SHADER_STAGES_EN__VS_WAVE_ID_EN__SHIFT         = 0x0000000c;
constexpr unsigned int VGT_STRMOUT_BUFFER_CONFIG__STREAM_0_BUFFER_EN__SHIFT = 0x00000000;
constexpr unsigned int VGT_STRMOUT_BUFFER_CONFIG__STREAM_1_BUFFER_EN__SHIFT = 0x00000004;
constexpr unsigned int VGT_STRMOUT_BUFFER_CONFIG__STREAM_2_BUFFER_EN__SHIFT = 0x00000008;
constexpr unsigned int VGT_STRMOUT_BUFFER_CONFIG__STREAM_3_BUFFER_EN__SHIFT = 0x0000000c;
constexpr unsigned int VGT_STRMOUT_BUFFER_FILLED_SIZE_0__SIZE__SHIFT      = 0x00000000;
constexpr unsigned int VGT_STRMOUT_BUFFER_FILLED_SIZE_1__SIZE__SHIFT      = 0x00000000;
constexpr unsigned int VGT_STRMOUT_BUFFER_FILLED_SIZE_2__SIZE__SHIFT      = 0x00000000;
constexpr unsigned int VGT_STRMOUT_BUFFER_FILLED_SIZE_3__SIZE__SHIFT      = 0x00000000;
constexpr unsigned int VGT_STRMOUT_BUFFER_OFFSET_0__OFFSET__SHIFT         = 0x00000000;
constexpr unsigned int VGT_STRMOUT_BUFFER_OFFSET_1__OFFSET__SHIFT         = 0x00000000;
constexpr unsigned int VGT_STRMOUT_BUFFER_OFFSET_2__OFFSET__SHIFT         = 0x00000000;
constexpr unsigned int VGT_STRMOUT_BUFFER_OFFSET_3__OFFSET__SHIFT         = 0x00000000;
constexpr unsigned int VGT_STRMOUT_BUFFER_SIZE_0__SIZE__SHIFT             = 0x00000000;
constexpr unsigned int VGT_STRMOUT_BUFFER_SIZE_1__SIZE__SHIFT             = 0x00000000;
constexpr unsigned int VGT_STRMOUT_BUFFER_SIZE_2__SIZE__SHIFT             = 0x00000000;
constexpr unsigned int VGT_STRMOUT_BUFFER_SIZE_3__SIZE__SHIFT             = 0x00000000;
constexpr unsigned int VGT_STRMOUT_CONFIG__EN_PRIMS_NEEDED_CNT__SHIFT     = 0x00000007;
constexpr unsigned int VGT_STRMOUT_CONFIG__RAST_STREAM_MASK__SHIFT        = 0x00000008;
constexpr unsigned int VGT_STRMOUT_CONFIG__RAST_STREAM__SHIFT             = 0x00000004;
constexpr unsigned int VGT_STRMOUT_CONFIG__STREAMOUT_0_EN__SHIFT          = 0x00000000;
constexpr unsigned int VGT_STRMOUT_CONFIG__STREAMOUT_1_EN__SHIFT          = 0x00000001;
constexpr unsigned int VGT_STRMOUT_CONFIG__STREAMOUT_2_EN__SHIFT          = 0x00000002;
constexpr unsigned int VGT_STRMOUT_CONFIG__STREAMOUT_3_EN__SHIFT          = 0x00000003;
constexpr unsigned int VGT_STRMOUT_CONFIG__USE_RAST_STREAM_MASK__SHIFT    = 0x0000001f;
constexpr unsigned int VGT_STRMOUT_DELAY__SE0_WD_DELAY__SHIFT             = 0x00000008;
constexpr unsigned int VGT_STRMOUT_DELAY__SE1_WD_DELAY__SHIFT             = 0x0000000b;
constexpr unsigned int VGT_STRMOUT_DELAY__SE2_WD_DELAY__SHIFT             = 0x0000000e;
constexpr unsigned int VGT_STRMOUT_DELAY__SE3_WD_DELAY__SHIFT             = 0x00000011;
constexpr unsigned int VGT_STRMOUT_DELAY__SKIP_DELAY__SHIFT               = 0x00000000;
constexpr unsigned int VGT_STRMOUT_DRAW_OPAQUE_BUFFER_FILLED_SIZE__SIZE__SHIFT = 0x00000000;
constexpr unsigned int VGT_STRMOUT_DRAW_OPAQUE_OFFSET__OFFSET__SHIFT      = 0x00000000;
constexpr unsigned int VGT_STRMOUT_DRAW_OPAQUE_VERTEX_STRIDE__VERTEX_STRIDE__SHIFT = 0x00000000;
constexpr unsigned int VGT_STRMOUT_VTX_STRIDE_0__STRIDE__SHIFT            = 0x00000000;
constexpr unsigned int VGT_STRMOUT_VTX_STRIDE_1__STRIDE__SHIFT            = 0x00000000;
constexpr unsigned int VGT_STRMOUT_VTX_STRIDE_2__STRIDE__SHIFT            = 0x00000000;
constexpr unsigned int VGT_STRMOUT_VTX_STRIDE_3__STRIDE__SHIFT            = 0x00000000;
constexpr unsigned int VGT_SYS_CONFIG__ADC_EVENT_FILTER_DISABLE__SHIFT    = 0x00000007;
constexpr unsigned int VGT_SYS_CONFIG__DUAL_CORE_EN__SHIFT                = 0x00000000;
constexpr unsigned int VGT_SYS_CONFIG__MAX_LS_HS_THDGRP__SHIFT            = 0x00000001;
constexpr unsigned int VGT_TESS_DISTRIBUTION__ACCUM_ISOLINE__SHIFT        = 0x00000000;
constexpr unsigned int VGT_TESS_DISTRIBUTION__ACCUM_QUAD__SHIFT           = 0x00000010;
constexpr unsigned int VGT_TESS_DISTRIBUTION__ACCUM_TRI__SHIFT            = 0x00000008;
constexpr unsigned int VGT_TESS_DISTRIBUTION__DONUT_SPLIT__SHIFT          = 0x00000018;
constexpr unsigned int VGT_TESS_DISTRIBUTION__TRAP_SPLIT__SHIFT           = 0x0000001d;
constexpr unsigned int VGT_TF_MEMORY_BASE_HI__BASE_HI__SHIFT              = 0x00000000;
constexpr unsigned int VGT_TF_MEMORY_BASE__BASE__SHIFT                    = 0x00000000;
constexpr unsigned int VGT_TF_PARAM__DEPRECATED__SHIFT                    = 0x00000009;
constexpr unsigned int VGT_TF_PARAM__DISABLE_DONUTS__SHIFT                = 0x0000000e;
constexpr unsigned int VGT_TF_PARAM__DISTRIBUTION_MODE__SHIFT             = 0x00000011;
constexpr unsigned int VGT_TF_PARAM__PARTITIONING__SHIFT                  = 0x00000002;
constexpr unsigned int VGT_TF_PARAM__RDREQ_POLICY__SHIFT                  = 0x0000000f;
constexpr unsigned int VGT_TF_PARAM__RESERVED_REDUC_AXIS__SHIFT           = 0x00000008;
constexpr unsigned int VGT_TF_PARAM__TOPOLOGY__SHIFT                      = 0x00000005;
constexpr unsigned int VGT_TF_PARAM__TYPE__SHIFT                          = 0x00000000;
constexpr unsigned int VGT_TF_RING_SIZE__SIZE__SHIFT                      = 0x00000000;
constexpr unsigned int VGT_VERTEX_REUSE_BLOCK_CNTL__VTX_REUSE_DEPTH__SHIFT = 0x00000000;
constexpr unsigned int VGT_VS_MAX_WAVE_ID__MAX_WAVE_ID__SHIFT             = 0x00000000;
constexpr unsigned int VGT_VTX_CNT_EN__VTX_CNT_EN__SHIFT                  = 0x00000000;
constexpr unsigned int VGT_VTX_VECT_EJECT_REG__PRIM_COUNT__SHIFT          = 0x00000000;
constexpr unsigned int WD_BUF_RESOURCE_1__INDEX_BUF_SIZE__SHIFT           = 0x00000010;
constexpr unsigned int WD_BUF_RESOURCE_1__POS_BUF_SIZE__SHIFT             = 0x00000000;
constexpr unsigned int WD_BUF_RESOURCE_2__ADDR_MODE__SHIFT                = 0x0000000f;
constexpr unsigned int WD_BUF_RESOURCE_2__CNTL_SB_BUF_SIZE__SHIFT         = 0x00000010;
constexpr unsigned int WD_BUF_RESOURCE_2__PARAM_BUF_SIZE__SHIFT           = 0x00000000;
constexpr unsigned int WD_CNTL_SB_BUF_BASE_HI__BASE_HI__SHIFT             = 0x00000000;
constexpr unsigned int WD_CNTL_SB_BUF_BASE__BASE__SHIFT                   = 0x00000000;
constexpr unsigned int WD_ENHANCE__MISC__SHIFT                            = 0x00000000;
constexpr unsigned int WD_INDEX_BUF_BASE_HI__BASE_HI__SHIFT               = 0x00000000;
constexpr unsigned int WD_INDEX_BUF_BASE__BASE__SHIFT                     = 0x00000000;
constexpr unsigned int WD_POS_BUF_BASE_HI__BASE_HI__SHIFT                 = 0x00000000;
constexpr unsigned int WD_POS_BUF_BASE__BASE__SHIFT                       = 0x00000000;
constexpr unsigned int WD_QOS__DRAW_STALL__SHIFT                          = 0x00000000;
constexpr unsigned int WD_UTCL1_CNTL__BYPASS__SHIFT                       = 0x00000019;
constexpr unsigned int WD_UTCL1_CNTL__DROP_MODE__SHIFT                    = 0x00000018;
constexpr unsigned int WD_UTCL1_CNTL__FORCE_SNOOP__SHIFT                  = 0x0000001c;
constexpr unsigned int WD_UTCL1_CNTL__FRAG_LIMIT_MODE__SHIFT              = 0x0000001b;
constexpr unsigned int WD_UTCL1_CNTL__INVALIDATE__SHIFT                   = 0x0000001a;
constexpr unsigned int WD_UTCL1_CNTL__VMID_RESET_MODE__SHIFT              = 0x00000017;
constexpr unsigned int WD_UTCL1_CNTL__XNACK_REDO_TIMER_CNT__SHIFT         = 0x00000000;
constexpr unsigned int WD_UTCL1_STATUS__FAULT_DETECTED__SHIFT             = 0x00000000;
constexpr unsigned int WD_UTCL1_STATUS__FAULT_UTCL1ID__SHIFT              = 0x00000008;
constexpr unsigned int WD_UTCL1_STATUS__PRT_DETECTED__SHIFT               = 0x00000002;
constexpr unsigned int WD_UTCL1_STATUS__PRT_UTCL1ID__SHIFT                = 0x00000018;
constexpr unsigned int WD_UTCL1_STATUS__RETRY_DETECTED__SHIFT             = 0x00000001;
constexpr unsigned int WD_UTCL1_STATUS__RETRY_UTCL1ID__SHIFT              = 0x00000010;

namespace Apu09_1xPlus
{
    constexpr unsigned int RLC_SPM_ACCUM_CTRLRAM_ADDR__addr__SHIFT            = 0x00000000;
    constexpr unsigned int RLC_SPM_ACCUM_CTRLRAM_DATA__data__SHIFT            = 0x00000000;
    constexpr unsigned int RLC_SPM_ACCUM_CTRLRAM_DATA__RESERVED__SHIFT        = 0x00000008;
    constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeRearmAccum__SHIFT        = 0x00000002;
    constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeResetPerfMonitors__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeStartAccumulation__SHIFT = 0x00000001;
    constexpr unsigned int RLC_SPM_ACCUM_DATARAM_ADDR__addr__SHIFT            = 0x00000000;
    constexpr unsigned int RLC_SPM_ACCUM_DATARAM_ADDR__RESERVED__SHIFT        = 0x00000007;
    constexpr unsigned int RLC_SPM_ACCUM_DATARAM_DATA__data__SHIFT            = 0x00000000;
    constexpr unsigned int RLC_SPM_ACCUM_DATARAM_WRCOUNT__DataRamWrCount__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_ACCUM_DATARAM_WRCOUNT__RESERVED__SHIFT     = 0x00000013;
    constexpr unsigned int RLC_SPM_ACCUM_MODE__EnableAccum__SHIFT             = 0x00000000;
    constexpr unsigned int RLC_SPM_ACCUM_SAMPLES_REQUESTED__SamplesRequested__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_ACCUM_STATUS__AccumArmed__SHIFT            = 0x0000000b;
    constexpr unsigned int RLC_SPM_ACCUM_STATUS__AccumDone__SHIFT             = 0x00000008;
    constexpr unsigned int RLC_SPM_ACCUM_STATUS__AccumOverflow__SHIFT         = 0x0000000a;
    constexpr unsigned int RLC_SPM_ACCUM_STATUS__AllFifosEmpty__SHIFT         = 0x0000000e;
    constexpr unsigned int RLC_SPM_ACCUM_STATUS__FinalSequenceInProgress__SHIFT = 0x0000000d;
    constexpr unsigned int RLC_SPM_ACCUM_STATUS__FSMIsIdle__SHIFT             = 0x0000000f;
    constexpr unsigned int RLC_SPM_ACCUM_STATUS__NumbSamplesCompleted__SHIFT  = 0x00000000;
    constexpr unsigned int RLC_SPM_ACCUM_STATUS__SequenceInProgress__SHIFT    = 0x0000000c;
    constexpr unsigned int RLC_SPM_ACCUM_STATUS__SpmDone__SHIFT               = 0x00000009;
    constexpr unsigned int RLC_SPM_ACCUM_THRESHOLD__Threshold__SHIFT          = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_CHKSUM_GS__CHECKSUM__SHIFT          = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_CHKSUM_HS__CHECKSUM__SHIFT          = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_CHKSUM_PS__CHECKSUM__SHIFT          = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_CHKSUM_VS__CHECKSUM__SHIFT          = 0x00000000;
} // namespace Apu09_1xPlus

namespace Core
{
    constexpr unsigned int CB_COLOR0_ATTRIB__FORCE_DST_ALPHA_1__SHIFT         = 0x00000011;
    constexpr unsigned int CB_COLOR0_ATTRIB__NUM_FRAGMENTS__SHIFT             = 0x0000000f;
    constexpr unsigned int CB_COLOR0_ATTRIB__NUM_SAMPLES__SHIFT               = 0x0000000c;
    constexpr unsigned int CB_COLOR1_ATTRIB__FORCE_DST_ALPHA_1__SHIFT         = 0x00000011;
    constexpr unsigned int CB_COLOR1_ATTRIB__NUM_FRAGMENTS__SHIFT             = 0x0000000f;
    constexpr unsigned int CB_COLOR1_ATTRIB__NUM_SAMPLES__SHIFT               = 0x0000000c;
    constexpr unsigned int CB_COLOR2_ATTRIB__FORCE_DST_ALPHA_1__SHIFT         = 0x00000011;
    constexpr unsigned int CB_COLOR2_ATTRIB__NUM_FRAGMENTS__SHIFT             = 0x0000000f;
    constexpr unsigned int CB_COLOR2_ATTRIB__NUM_SAMPLES__SHIFT               = 0x0000000c;
    constexpr unsigned int CB_COLOR3_ATTRIB__FORCE_DST_ALPHA_1__SHIFT         = 0x00000011;
    constexpr unsigned int CB_COLOR3_ATTRIB__NUM_FRAGMENTS__SHIFT             = 0x0000000f;
    constexpr unsigned int CB_COLOR3_ATTRIB__NUM_SAMPLES__SHIFT               = 0x0000000c;
    constexpr unsigned int CB_COLOR4_ATTRIB__FORCE_DST_ALPHA_1__SHIFT         = 0x00000011;
    constexpr unsigned int CB_COLOR4_ATTRIB__NUM_FRAGMENTS__SHIFT             = 0x0000000f;
    constexpr unsigned int CB_COLOR4_ATTRIB__NUM_SAMPLES__SHIFT               = 0x0000000c;
    constexpr unsigned int CB_COLOR5_ATTRIB__FORCE_DST_ALPHA_1__SHIFT         = 0x00000011;
    constexpr unsigned int CB_COLOR5_ATTRIB__NUM_FRAGMENTS__SHIFT             = 0x0000000f;
    constexpr unsigned int CB_COLOR5_ATTRIB__NUM_SAMPLES__SHIFT               = 0x0000000c;
    constexpr unsigned int CB_COLOR6_ATTRIB__FORCE_DST_ALPHA_1__SHIFT         = 0x00000011;
    constexpr unsigned int CB_COLOR6_ATTRIB__NUM_FRAGMENTS__SHIFT             = 0x0000000f;
    constexpr unsigned int CB_COLOR6_ATTRIB__NUM_SAMPLES__SHIFT               = 0x0000000c;
    constexpr unsigned int CB_COLOR7_ATTRIB__FORCE_DST_ALPHA_1__SHIFT         = 0x00000011;
    constexpr unsigned int CB_COLOR7_ATTRIB__NUM_FRAGMENTS__SHIFT             = 0x0000000f;
    constexpr unsigned int CB_COLOR7_ATTRIB__NUM_SAMPLES__SHIFT               = 0x0000000c;
    constexpr unsigned int CB_HW_CONTROL__DISABLE_INTNORM_LE11BPC_CLAMPING__SHIFT = 0x00000012;
    constexpr unsigned int DB_DFSM_CONFIG__BYPASS_DFSM__SHIFT                 = 0x00000000;
    constexpr unsigned int DB_DFSM_CONFIG__DISABLE_POPS__SHIFT                = 0x00000002;
    constexpr unsigned int DB_DFSM_CONFIG__DISABLE_PUNCHOUT__SHIFT            = 0x00000001;
    constexpr unsigned int DB_DFSM_CONFIG__FORCE_FLUSH__SHIFT                 = 0x00000003;
    constexpr unsigned int DB_DFSM_CONTROL__DISALLOW_OVERFLOW__SHIFT          = 0x00000003;
    constexpr unsigned int DB_DFSM_CONTROL__POPS_DRAIN_PS_ON_OVERLAP__SHIFT   = 0x00000002;
    constexpr unsigned int DB_DFSM_CONTROL__PUNCHOUT_MODE__SHIFT              = 0x00000000;
    constexpr unsigned int DB_DFSM_FLUSH_AUX_EVENT__EVENT_A__SHIFT            = 0x00000000;
    constexpr unsigned int DB_DFSM_FLUSH_AUX_EVENT__EVENT_B__SHIFT            = 0x00000008;
    constexpr unsigned int DB_DFSM_FLUSH_AUX_EVENT__EVENT_C__SHIFT            = 0x00000010;
    constexpr unsigned int DB_DFSM_FLUSH_AUX_EVENT__EVENT_D__SHIFT            = 0x00000018;
    constexpr unsigned int DB_DFSM_FLUSH_ENABLE__AUX_EVENTS__SHIFT            = 0x0000001c;
    constexpr unsigned int DB_DFSM_FLUSH_ENABLE__AUX_FORCE_PASSTHRU__SHIFT    = 0x00000018;
    constexpr unsigned int DB_DFSM_FLUSH_ENABLE__PRIMARY_EVENTS__SHIFT        = 0x00000000;
    constexpr unsigned int DB_DFSM_PRIMS_IN_FLIGHT__HIGH_WATERMARK__SHIFT     = 0x00000000;
    constexpr unsigned int DB_DFSM_TILES_IN_FLIGHT__HIGH_WATERMARK__SHIFT     = 0x00000000;
    constexpr unsigned int DB_DFSM_WATCHDOG__TIMER_TARGET__SHIFT              = 0x00000000;
    constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_FORCE_SOP_ALL_EVENTS__SHIFT = 0x00000013;
    constexpr unsigned int PA_SC_ENHANCE_1__ENABLE_DFSM_FLUSH_EVENT_TO_FLUSH_POPS_CAM__SHIFT = 0x0000000b;
    constexpr unsigned int PA_SC_MODE_CNTL_0__ALTERNATE_RBS_PER_TILE__SHIFT   = 0x00000005;
    constexpr unsigned int PA_SC_SHADER_CONTROL__LOAD_COLLISION_WAVEID__SHIFT = 0x00000002;
    constexpr unsigned int PA_SC_SHADER_CONTROL__LOAD_INTRAWAVE_COLLISION__SHIFT = 0x00000003;
    constexpr unsigned int PA_SC_TILE_STEERING_OVERRIDE__NUM_RB_PER_SE__SHIFT = 0x00000005;
    constexpr unsigned int PA_SC_TILE_STEERING_OVERRIDE__NUM_SE__SHIFT        = 0x00000001;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_6__BARRIERS__SHIFT         = 0x0000000f;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_6__LDS__SHIFT              = 0x00000008;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_6__SGPR__SHIFT             = 0x00000004;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_6__VGPR__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_6__WAVES__SHIFT            = 0x0000000c;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_7__BARRIERS__SHIFT         = 0x0000000f;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_7__LDS__SHIFT              = 0x00000008;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_7__SGPR__SHIFT             = 0x00000004;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_7__VGPR__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_7__WAVES__SHIFT            = 0x0000000c;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_6__EN__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_6__QUEUE_MASK__SHIFT    = 0x00000010;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_6__TYPE_MASK__SHIFT     = 0x00000001;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_7__EN__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_7__QUEUE_MASK__SHIFT    = 0x00000010;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_7__TYPE_MASK__SHIFT     = 0x00000001;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_1__EN_WARN__SHIFT            = 0x0000001f;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_1__MAX_CNT__SHIFT            = 0x00000000;
    constexpr unsigned int SQ_WAVE_GPR_ALLOC__SGPR_BASE__SHIFT                = 0x00000010;
    constexpr unsigned int SQ_WAVE_GPR_ALLOC__SGPR_SIZE__SHIFT                = 0x00000018;
    constexpr unsigned int SQ_WAVE_IB_STS__EXP_CNT__SHIFT                     = 0x00000004;
    constexpr unsigned int SQ_WAVE_IB_STS__LGKM_CNT__SHIFT                    = 0x00000008;
    constexpr unsigned int SQ_WAVE_IB_STS__VALU_CNT__SHIFT                    = 0x0000000c;
    constexpr unsigned int SQ_WAVE_IB_STS__VM_CNT_HI__SHIFT                   = 0x00000016;
    constexpr unsigned int SQ_WAVE_IB_STS__VM_CNT__SHIFT                      = 0x00000000;
    constexpr unsigned int SQ_WAVE_INST_DW0__INST_DW0__SHIFT                  = 0x00000000;
    constexpr unsigned int SQ_WAVE_MODE__DEBUG_EN__SHIFT                      = 0x0000000b;
} // namespace Core

namespace Gfx09
{
    constexpr unsigned int ATC_L2_PERFCOUNTER0_CFG__CLEAR__SHIFT              = 0x0000001d;
    constexpr unsigned int ATC_L2_PERFCOUNTER0_CFG__ENABLE__SHIFT             = 0x0000001c;
    constexpr unsigned int ATC_L2_PERFCOUNTER0_CFG__PERF_MODE__SHIFT          = 0x00000018;
    constexpr unsigned int ATC_L2_PERFCOUNTER0_CFG__PERF_SEL_END__SHIFT       = 0x00000008;
    constexpr unsigned int ATC_L2_PERFCOUNTER0_CFG__PERF_SEL__SHIFT           = 0x00000000;
    constexpr unsigned int ATC_L2_PERFCOUNTER1_CFG__CLEAR__SHIFT              = 0x0000001d;
    constexpr unsigned int ATC_L2_PERFCOUNTER1_CFG__ENABLE__SHIFT             = 0x0000001c;
    constexpr unsigned int ATC_L2_PERFCOUNTER1_CFG__PERF_MODE__SHIFT          = 0x00000018;
    constexpr unsigned int ATC_L2_PERFCOUNTER1_CFG__PERF_SEL_END__SHIFT       = 0x00000008;
    constexpr unsigned int ATC_L2_PERFCOUNTER1_CFG__PERF_SEL__SHIFT           = 0x00000000;
    constexpr unsigned int ATC_L2_PERFCOUNTER_HI__COMPARE_VALUE__SHIFT        = 0x00000010;
    constexpr unsigned int ATC_L2_PERFCOUNTER_HI__COUNTER_HI__SHIFT           = 0x00000000;
    constexpr unsigned int ATC_L2_PERFCOUNTER_LO__COUNTER_LO__SHIFT           = 0x00000000;
    constexpr unsigned int ATC_L2_PERFCOUNTER_RSLT_CNTL__CLEAR_ALL__SHIFT     = 0x00000019;
    constexpr unsigned int ATC_L2_PERFCOUNTER_RSLT_CNTL__ENABLE_ANY__SHIFT    = 0x00000018;
    constexpr unsigned int ATC_L2_PERFCOUNTER_RSLT_CNTL__PERF_COUNTER_SELECT__SHIFT = 0x00000000;
    constexpr unsigned int ATC_L2_PERFCOUNTER_RSLT_CNTL__START_TRIGGER__SHIFT = 0x00000008;
    constexpr unsigned int ATC_L2_PERFCOUNTER_RSLT_CNTL__STOP_ALL_ON_SATURATE__SHIFT = 0x0000001a;
    constexpr unsigned int ATC_L2_PERFCOUNTER_RSLT_CNTL__STOP_TRIGGER__SHIFT  = 0x00000010;
    constexpr unsigned int CB_COLOR0_ATTRIB__COLOR_SW_MODE__SHIFT             = 0x00000012;
    constexpr unsigned int CB_COLOR0_ATTRIB__FMASK_SW_MODE__SHIFT             = 0x00000017;
    constexpr unsigned int CB_COLOR0_ATTRIB__META_LINEAR__SHIFT               = 0x0000000b;
    constexpr unsigned int CB_COLOR0_ATTRIB__MIP0_DEPTH__SHIFT                = 0x00000000;
    constexpr unsigned int CB_COLOR0_ATTRIB__PIPE_ALIGNED__SHIFT              = 0x0000001f;
    constexpr unsigned int CB_COLOR0_ATTRIB__RB_ALIGNED__SHIFT                = 0x0000001e;
    constexpr unsigned int CB_COLOR0_ATTRIB__RESOURCE_TYPE__SHIFT             = 0x0000001c;
    constexpr unsigned int CB_COLOR0_VIEW__MIP_LEVEL__SHIFT                   = 0x00000018;
    constexpr unsigned int CB_COLOR1_ATTRIB__COLOR_SW_MODE__SHIFT             = 0x00000012;
    constexpr unsigned int CB_COLOR1_ATTRIB__FMASK_SW_MODE__SHIFT             = 0x00000017;
    constexpr unsigned int CB_COLOR1_ATTRIB__META_LINEAR__SHIFT               = 0x0000000b;
    constexpr unsigned int CB_COLOR1_ATTRIB__MIP0_DEPTH__SHIFT                = 0x00000000;
    constexpr unsigned int CB_COLOR1_ATTRIB__PIPE_ALIGNED__SHIFT              = 0x0000001f;
    constexpr unsigned int CB_COLOR1_ATTRIB__RB_ALIGNED__SHIFT                = 0x0000001e;
    constexpr unsigned int CB_COLOR1_ATTRIB__RESOURCE_TYPE__SHIFT             = 0x0000001c;
    constexpr unsigned int CB_COLOR1_VIEW__MIP_LEVEL__SHIFT                   = 0x00000018;
    constexpr unsigned int CB_COLOR2_ATTRIB__COLOR_SW_MODE__SHIFT             = 0x00000012;
    constexpr unsigned int CB_COLOR2_ATTRIB__FMASK_SW_MODE__SHIFT             = 0x00000017;
    constexpr unsigned int CB_COLOR2_ATTRIB__META_LINEAR__SHIFT               = 0x0000000b;
    constexpr unsigned int CB_COLOR2_ATTRIB__MIP0_DEPTH__SHIFT                = 0x00000000;
    constexpr unsigned int CB_COLOR2_ATTRIB__PIPE_ALIGNED__SHIFT              = 0x0000001f;
    constexpr unsigned int CB_COLOR2_ATTRIB__RB_ALIGNED__SHIFT                = 0x0000001e;
    constexpr unsigned int CB_COLOR2_ATTRIB__RESOURCE_TYPE__SHIFT             = 0x0000001c;
    constexpr unsigned int CB_COLOR2_VIEW__MIP_LEVEL__SHIFT                   = 0x00000018;
    constexpr unsigned int CB_COLOR3_ATTRIB__COLOR_SW_MODE__SHIFT             = 0x00000012;
    constexpr unsigned int CB_COLOR3_ATTRIB__FMASK_SW_MODE__SHIFT             = 0x00000017;
    constexpr unsigned int CB_COLOR3_ATTRIB__META_LINEAR__SHIFT               = 0x0000000b;
    constexpr unsigned int CB_COLOR3_ATTRIB__MIP0_DEPTH__SHIFT                = 0x00000000;
    constexpr unsigned int CB_COLOR3_ATTRIB__PIPE_ALIGNED__SHIFT              = 0x0000001f;
    constexpr unsigned int CB_COLOR3_ATTRIB__RB_ALIGNED__SHIFT                = 0x0000001e;
    constexpr unsigned int CB_COLOR3_ATTRIB__RESOURCE_TYPE__SHIFT             = 0x0000001c;
    constexpr unsigned int CB_COLOR3_VIEW__MIP_LEVEL__SHIFT                   = 0x00000018;
    constexpr unsigned int CB_COLOR4_ATTRIB__COLOR_SW_MODE__SHIFT             = 0x00000012;
    constexpr unsigned int CB_COLOR4_ATTRIB__FMASK_SW_MODE__SHIFT             = 0x00000017;
    constexpr unsigned int CB_COLOR4_ATTRIB__META_LINEAR__SHIFT               = 0x0000000b;
    constexpr unsigned int CB_COLOR4_ATTRIB__MIP0_DEPTH__SHIFT                = 0x00000000;
    constexpr unsigned int CB_COLOR4_ATTRIB__PIPE_ALIGNED__SHIFT              = 0x0000001f;
    constexpr unsigned int CB_COLOR4_ATTRIB__RB_ALIGNED__SHIFT                = 0x0000001e;
    constexpr unsigned int CB_COLOR4_ATTRIB__RESOURCE_TYPE__SHIFT             = 0x0000001c;
    constexpr unsigned int CB_COLOR4_VIEW__MIP_LEVEL__SHIFT                   = 0x00000018;
    constexpr unsigned int CB_COLOR5_ATTRIB__COLOR_SW_MODE__SHIFT             = 0x00000012;
    constexpr unsigned int CB_COLOR5_ATTRIB__FMASK_SW_MODE__SHIFT             = 0x00000017;
    constexpr unsigned int CB_COLOR5_ATTRIB__META_LINEAR__SHIFT               = 0x0000000b;
    constexpr unsigned int CB_COLOR5_ATTRIB__MIP0_DEPTH__SHIFT                = 0x00000000;
    constexpr unsigned int CB_COLOR5_ATTRIB__PIPE_ALIGNED__SHIFT              = 0x0000001f;
    constexpr unsigned int CB_COLOR5_ATTRIB__RB_ALIGNED__SHIFT                = 0x0000001e;
    constexpr unsigned int CB_COLOR5_ATTRIB__RESOURCE_TYPE__SHIFT             = 0x0000001c;
    constexpr unsigned int CB_COLOR5_VIEW__MIP_LEVEL__SHIFT                   = 0x00000018;
    constexpr unsigned int CB_COLOR6_ATTRIB__COLOR_SW_MODE__SHIFT             = 0x00000012;
    constexpr unsigned int CB_COLOR6_ATTRIB__FMASK_SW_MODE__SHIFT             = 0x00000017;
    constexpr unsigned int CB_COLOR6_ATTRIB__META_LINEAR__SHIFT               = 0x0000000b;
    constexpr unsigned int CB_COLOR6_ATTRIB__MIP0_DEPTH__SHIFT                = 0x00000000;
    constexpr unsigned int CB_COLOR6_ATTRIB__PIPE_ALIGNED__SHIFT              = 0x0000001f;
    constexpr unsigned int CB_COLOR6_ATTRIB__RB_ALIGNED__SHIFT                = 0x0000001e;
    constexpr unsigned int CB_COLOR6_ATTRIB__RESOURCE_TYPE__SHIFT             = 0x0000001c;
    constexpr unsigned int CB_COLOR6_VIEW__MIP_LEVEL__SHIFT                   = 0x00000018;
    constexpr unsigned int CB_COLOR7_ATTRIB__COLOR_SW_MODE__SHIFT             = 0x00000012;
    constexpr unsigned int CB_COLOR7_ATTRIB__FMASK_SW_MODE__SHIFT             = 0x00000017;
    constexpr unsigned int CB_COLOR7_ATTRIB__META_LINEAR__SHIFT               = 0x0000000b;
    constexpr unsigned int CB_COLOR7_ATTRIB__MIP0_DEPTH__SHIFT                = 0x00000000;
    constexpr unsigned int CB_COLOR7_ATTRIB__PIPE_ALIGNED__SHIFT              = 0x0000001f;
    constexpr unsigned int CB_COLOR7_ATTRIB__RB_ALIGNED__SHIFT                = 0x0000001e;
    constexpr unsigned int CB_COLOR7_ATTRIB__RESOURCE_TYPE__SHIFT             = 0x0000001c;
    constexpr unsigned int CB_COLOR7_VIEW__MIP_LEVEL__SHIFT                   = 0x00000018;
    constexpr unsigned int CB_DCC_CONFIG__DCC_CACHE_EVICT_POINT__SHIFT        = 0x00000018;
    constexpr unsigned int CB_DCC_CONFIG__DCC_CACHE_NUM_TAGS__SHIFT           = 0x0000001c;
    constexpr unsigned int CB_DCC_CONTROL__OVERWRITE_COMBINER_MRT_SHARING_DISABLE__SHIFT = 0x00000001;
    constexpr unsigned int CB_HW_CONTROL_1__CC_CACHE_NUM_TAGS__SHIFT          = 0x0000000b;
    constexpr unsigned int CB_HW_CONTROL_1__CM_TILE_FIFO_DEPTH__SHIFT         = 0x00000011;
    constexpr unsigned int CB_HW_CONTROL_1__RMI_CREDITS__SHIFT                = 0x0000001a;
    constexpr unsigned int CB_HW_CONTROL_2__CHICKEN_BITS__SHIFT               = 0x0000001c;
    constexpr unsigned int CB_HW_CONTROL_3__COLOR_CACHE_PREFETCH_NUM_CLS__SHIFT = 0x0000001c;
    constexpr unsigned int CB_HW_CONTROL_3__DISABLE_CC_CACHE_OVWR_KEY_MOD__SHIFT = 0x00000006;
    constexpr unsigned int CB_HW_CONTROL_3__DISABLE_OVERWRITE_COMBINER_TARGET_MASK_VALIDATION__SHIFT = 0x00000008;
    constexpr unsigned int CB_HW_CONTROL__ALLOW_MRT_WITH_DUAL_SOURCE__SHIFT   = 0x00000010;
    constexpr unsigned int CB_HW_CONTROL__CC_CACHE_EVICT_POINT__SHIFT         = 0x0000000c;
    constexpr unsigned int CB_HW_CONTROL__CM_CACHE_EVICT_POINT__SHIFT         = 0x00000000;
    constexpr unsigned int CB_HW_CONTROL__FC_CACHE_EVICT_POINT__SHIFT         = 0x00000006;
    constexpr unsigned int CB_MRT0_EPITCH__EPITCH__SHIFT                      = 0x00000000;
    constexpr unsigned int CB_MRT1_EPITCH__EPITCH__SHIFT                      = 0x00000000;
    constexpr unsigned int CB_MRT2_EPITCH__EPITCH__SHIFT                      = 0x00000000;
    constexpr unsigned int CB_MRT3_EPITCH__EPITCH__SHIFT                      = 0x00000000;
    constexpr unsigned int CB_MRT4_EPITCH__EPITCH__SHIFT                      = 0x00000000;
    constexpr unsigned int CB_MRT5_EPITCH__EPITCH__SHIFT                      = 0x00000000;
    constexpr unsigned int CB_MRT6_EPITCH__EPITCH__SHIFT                      = 0x00000000;
    constexpr unsigned int CB_MRT7_EPITCH__EPITCH__SHIFT                      = 0x00000000;
    constexpr unsigned int COMPUTE_PGM_RSRC2__SKIP_USGPR0__SHIFT              = 0x0000001f;
    constexpr unsigned int COMPUTE_RESOURCE_LIMITS__SIMD_DISABLE__SHIFT       = 0x0000001b;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE0__SH0_CU_EN__SHIFT   = 0x00000000;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE0__SH1_CU_EN__SHIFT   = 0x00000010;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE1__SH0_CU_EN__SHIFT   = 0x00000000;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE1__SH1_CU_EN__SHIFT   = 0x00000010;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE2__SH0_CU_EN__SHIFT   = 0x00000000;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE2__SH1_CU_EN__SHIFT   = 0x00000010;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE3__SH0_CU_EN__SHIFT   = 0x00000000;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE3__SH1_CU_EN__SHIFT   = 0x00000010;
    constexpr unsigned int CPC_PERFCOUNTER0_SELECT1__CNTR_SEL2__SHIFT         = 0x00000000;
    constexpr unsigned int CPC_PERFCOUNTER0_SELECT1__CNTR_SEL3__SHIFT         = 0x0000000a;
    constexpr unsigned int CPC_PERFCOUNTER0_SELECT__CNTR_SEL0__SHIFT          = 0x00000000;
    constexpr unsigned int CPC_PERFCOUNTER0_SELECT__CNTR_SEL1__SHIFT          = 0x0000000a;
    constexpr unsigned int CPC_PERFCOUNTER1_SELECT__CNTR_SEL0__SHIFT          = 0x00000000;
    constexpr unsigned int CPC_PERFCOUNTER1_SELECT__CNTR_SEL1__SHIFT          = 0x0000000a;
    constexpr unsigned int CPF_PERFCOUNTER0_SELECT1__CNTR_SEL2__SHIFT         = 0x00000000;
    constexpr unsigned int CPF_PERFCOUNTER0_SELECT1__CNTR_SEL3__SHIFT         = 0x0000000a;
    constexpr unsigned int CPF_PERFCOUNTER0_SELECT__CNTR_SEL0__SHIFT          = 0x00000000;
    constexpr unsigned int CPF_PERFCOUNTER0_SELECT__CNTR_SEL1__SHIFT          = 0x0000000a;
    constexpr unsigned int CPF_PERFCOUNTER1_SELECT__CNTR_SEL0__SHIFT          = 0x00000000;
    constexpr unsigned int CPF_PERFCOUNTER1_SELECT__CNTR_SEL1__SHIFT          = 0x0000000a;
    constexpr unsigned int CPG_PERFCOUNTER0_SELECT1__CNTR_SEL2__SHIFT         = 0x00000000;
    constexpr unsigned int CPG_PERFCOUNTER0_SELECT1__CNTR_SEL3__SHIFT         = 0x0000000a;
    constexpr unsigned int CPG_PERFCOUNTER0_SELECT__CNTR_SEL0__SHIFT          = 0x00000000;
    constexpr unsigned int CPG_PERFCOUNTER0_SELECT__CNTR_SEL1__SHIFT          = 0x0000000a;
    constexpr unsigned int CPG_PERFCOUNTER1_SELECT__CNTR_SEL0__SHIFT          = 0x00000000;
    constexpr unsigned int CPG_PERFCOUNTER1_SELECT__CNTR_SEL1__SHIFT          = 0x0000000a;
    constexpr unsigned int DB_DEPTH_SIZE__X_MAX__SHIFT                        = 0x00000000;
    constexpr unsigned int DB_DEPTH_SIZE__Y_MAX__SHIFT                        = 0x00000010;
    constexpr unsigned int DB_DFSM_CONFIG__MIDDLE_PIPE_MAX_DEPTH__SHIFT       = 0x00000008;
    constexpr unsigned int DB_DFSM_PRIMS_IN_FLIGHT__HARD_LIMIT__SHIFT         = 0x00000010;
    constexpr unsigned int DB_DFSM_TILES_IN_FLIGHT__HARD_LIMIT__SHIFT         = 0x00000010;
    constexpr unsigned int DB_DFSM_WATERMARK__DFSM_HIGH_WATERMARK__SHIFT      = 0x00000000;
    constexpr unsigned int DB_DFSM_WATERMARK__POPS_HIGH_WATERMARK__SHIFT      = 0x00000010;
    constexpr unsigned int DB_FIFO_DEPTH1__DB_RMI_RDREQ_CREDITS__SHIFT        = 0x00000000;
    constexpr unsigned int DB_FIFO_DEPTH1__DB_RMI_WRREQ_CREDITS__SHIFT        = 0x00000005;
    constexpr unsigned int DB_FIFO_DEPTH1__LTILE_PROBE_FIFO_DEPTH__SHIFT      = 0x00000015;
    constexpr unsigned int DB_FIFO_DEPTH1__MCC_DEPTH__SHIFT                   = 0x0000000a;
    constexpr unsigned int DB_FIFO_DEPTH1__QC_DEPTH__SHIFT                    = 0x00000010;
    constexpr unsigned int DB_FIFO_DEPTH2__LQUAD_FIFO_DEPTH__SHIFT            = 0x0000000f;
    constexpr unsigned int DB_FREE_CACHELINES__FREE_HTILE_DEPTH__SHIFT        = 0x00000014;
    constexpr unsigned int DB_FREE_CACHELINES__FREE_PLANE_DEPTH__SHIFT        = 0x00000007;
    constexpr unsigned int DB_FREE_CACHELINES__FREE_Z_DEPTH__SHIFT            = 0x0000000e;
    constexpr unsigned int DB_FREE_CACHELINES__QUAD_READ_REQS__SHIFT          = 0x00000018;
    constexpr unsigned int DB_HTILE_SURFACE__HTILE_USES_PRELOAD_WIN__SHIFT    = 0x00000002;
    constexpr unsigned int DB_HTILE_SURFACE__PREFETCH_HEIGHT__SHIFT           = 0x0000000a;
    constexpr unsigned int DB_HTILE_SURFACE__PREFETCH_WIDTH__SHIFT            = 0x00000004;
    constexpr unsigned int DB_HTILE_SURFACE__PRELOAD__SHIFT                   = 0x00000003;
    constexpr unsigned int DB_HTILE_SURFACE__RB_ALIGNED__SHIFT                = 0x00000013;
    constexpr unsigned int DB_RMI_CACHE_POLICY__CC_RD__SHIFT                  = 0x00000010;
    constexpr unsigned int DB_RMI_CACHE_POLICY__CC_WR__SHIFT                  = 0x00000018;
    constexpr unsigned int DB_RMI_CACHE_POLICY__CMASK_RD__SHIFT               = 0x00000012;
    constexpr unsigned int DB_RMI_CACHE_POLICY__CMASK_WR__SHIFT               = 0x0000001a;
    constexpr unsigned int DB_RMI_CACHE_POLICY__DCC_RD__SHIFT                 = 0x00000013;
    constexpr unsigned int DB_RMI_CACHE_POLICY__DCC_WR__SHIFT                 = 0x0000001b;
    constexpr unsigned int DB_RMI_CACHE_POLICY__FMASK_RD__SHIFT               = 0x00000011;
    constexpr unsigned int DB_RMI_CACHE_POLICY__FMASK_WR__SHIFT               = 0x00000019;
    constexpr unsigned int DB_RMI_CACHE_POLICY__HTILE_RD__SHIFT               = 0x00000002;
    constexpr unsigned int DB_RMI_CACHE_POLICY__HTILE_WR__SHIFT               = 0x0000000a;
    constexpr unsigned int DB_RMI_CACHE_POLICY__S_RD__SHIFT                   = 0x00000001;
    constexpr unsigned int DB_RMI_CACHE_POLICY__S_WR__SHIFT                   = 0x00000009;
    constexpr unsigned int DB_RMI_CACHE_POLICY__ZPCPSD_WR__SHIFT              = 0x0000000b;
    constexpr unsigned int DB_RMI_CACHE_POLICY__Z_RD__SHIFT                   = 0x00000000;
    constexpr unsigned int DB_RMI_CACHE_POLICY__Z_WR__SHIFT                   = 0x00000008;
    constexpr unsigned int DB_STENCIL_INFO2__EPITCH__SHIFT                    = 0x00000000;
    constexpr unsigned int DB_STENCIL_INFO__CLEAR_DISALLOWED__SHIFT           = 0x0000001e;
    constexpr unsigned int DB_STENCIL_INFO__FAULT_BEHAVIOR__SHIFT             = 0x0000000d;
    constexpr unsigned int DB_STENCIL_INFO__ITERATE_FLUSH__SHIFT              = 0x0000000f;
    constexpr unsigned int DB_WATERMARKS__AUTO_FLUSH_HTILE__SHIFT             = 0x0000001e;
    constexpr unsigned int DB_WATERMARKS__AUTO_FLUSH_QUAD__SHIFT              = 0x0000001f;
    constexpr unsigned int DB_WATERMARKS__DEPTH_CACHELINE_FREE__SHIFT         = 0x00000014;
    constexpr unsigned int DB_WATERMARKS__DEPTH_FLUSH__SHIFT                  = 0x00000005;
    constexpr unsigned int DB_WATERMARKS__DEPTH_PENDING_FREE__SHIFT           = 0x0000000f;
    constexpr unsigned int DB_WATERMARKS__FORCE_SUMMARIZE__SHIFT              = 0x0000000b;
    constexpr unsigned int DB_Z_INFO2__EPITCH__SHIFT                          = 0x00000000;
    constexpr unsigned int DB_Z_INFO__CLEAR_DISALLOWED__SHIFT                 = 0x0000001e;
    constexpr unsigned int DB_Z_INFO__FAULT_BEHAVIOR__SHIFT                   = 0x0000000d;
    constexpr unsigned int DB_Z_INFO__ITERATE_FLUSH__SHIFT                    = 0x0000000f;
    constexpr unsigned int GB_ADDR_CONFIG_READ__BANK_INTERLEAVE_SIZE__SHIFT   = 0x00000008;
    constexpr unsigned int GB_ADDR_CONFIG_READ__MULTI_GPU_TILE_SIZE__SHIFT    = 0x00000018;
    constexpr unsigned int GB_ADDR_CONFIG_READ__NUM_BANKS__SHIFT              = 0x0000000c;
    constexpr unsigned int GB_ADDR_CONFIG_READ__NUM_GPUS__SHIFT               = 0x00000015;
    constexpr unsigned int GB_ADDR_CONFIG_READ__NUM_LOWER_PIPES__SHIFT        = 0x0000001e;
    constexpr unsigned int GB_ADDR_CONFIG_READ__ROW_SIZE__SHIFT               = 0x0000001c;
    constexpr unsigned int GB_ADDR_CONFIG_READ__SE_ENABLE__SHIFT              = 0x0000001f;
    constexpr unsigned int GB_ADDR_CONFIG_READ__SHADER_ENGINE_TILE_SIZE__SHIFT = 0x00000010;
    constexpr unsigned int GB_ADDR_CONFIG__BANK_INTERLEAVE_SIZE__SHIFT        = 0x00000008;
    constexpr unsigned int GB_ADDR_CONFIG__MULTI_GPU_TILE_SIZE__SHIFT         = 0x00000018;
    constexpr unsigned int GB_ADDR_CONFIG__NUM_BANKS__SHIFT                   = 0x0000000c;
    constexpr unsigned int GB_ADDR_CONFIG__NUM_GPUS__SHIFT                    = 0x00000015;
    constexpr unsigned int GB_ADDR_CONFIG__NUM_LOWER_PIPES__SHIFT             = 0x0000001e;
    constexpr unsigned int GB_ADDR_CONFIG__ROW_SIZE__SHIFT                    = 0x0000001c;
    constexpr unsigned int GB_ADDR_CONFIG__SE_ENABLE__SHIFT                   = 0x0000001f;
    constexpr unsigned int GB_ADDR_CONFIG__SHADER_ENGINE_TILE_SIZE__SHIFT     = 0x00000010;
    constexpr unsigned int GRBM_GFX_INDEX_SR_DATA__SH_BROADCAST_WRITES__SHIFT = 0x0000001d;
    constexpr unsigned int GRBM_GFX_INDEX_SR_DATA__SH_INDEX__SHIFT            = 0x00000008;
    constexpr unsigned int GRBM_GFX_INDEX__SH_BROADCAST_WRITES__SHIFT         = 0x0000001d;
    constexpr unsigned int GRBM_GFX_INDEX__SH_INDEX__SHIFT                    = 0x00000008;
    constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__IA_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000017;
    constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__TC_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001b;
    constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__VGT_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000c;
    constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__WD_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001c;
    constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__IA_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000017;
    constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__TC_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001b;
    constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__VGT_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000000c;
    constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__WD_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001c;
    constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__VGT_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000013;
    constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__VGT_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000013;
    constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__VGT_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000013;
    constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__VGT_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000013;
    constexpr unsigned int IA_CNTL_STATUS__IA_ADC_BUSY__SHIFT                 = 0x00000004;
    constexpr unsigned int IA_CNTL_STATUS__IA_BUSY__SHIFT                     = 0x00000000;
    constexpr unsigned int IA_CNTL_STATUS__IA_DMA_BUSY__SHIFT                 = 0x00000001;
    constexpr unsigned int IA_CNTL_STATUS__IA_DMA_REQ_BUSY__SHIFT             = 0x00000002;
    constexpr unsigned int IA_CNTL_STATUS__IA_GRP_BUSY__SHIFT                 = 0x00000003;
    constexpr unsigned int IA_MULTI_VGT_PARAM__EN_INST_OPT_ADV__SHIFT         = 0x00000016;
    constexpr unsigned int IA_MULTI_VGT_PARAM__EN_INST_OPT_BASIC__SHIFT       = 0x00000015;
    constexpr unsigned int IA_MULTI_VGT_PARAM__HW_USE_ONLY__SHIFT             = 0x00000017;
    constexpr unsigned int IA_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
    constexpr unsigned int IA_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
    constexpr unsigned int IA_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT         = 0x0000001c;
    constexpr unsigned int IA_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT         = 0x00000018;
    constexpr unsigned int IA_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT          = 0x00000000;
    constexpr unsigned int IA_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT          = 0x0000000a;
    constexpr unsigned int IA_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT           = 0x00000014;
    constexpr unsigned int IA_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT          = 0x00000018;
    constexpr unsigned int IA_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
    constexpr unsigned int IA_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT           = 0x0000000a;
    constexpr unsigned int IA_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT            = 0x00000000;
    constexpr unsigned int IA_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
    constexpr unsigned int IA_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
    constexpr unsigned int IA_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
    constexpr unsigned int IA_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT            = 0x00000000;
    constexpr unsigned int IA_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
    constexpr unsigned int IA_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
    constexpr unsigned int IA_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
    constexpr unsigned int IA_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT            = 0x00000000;
    constexpr unsigned int IA_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
    constexpr unsigned int IA_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
    constexpr unsigned int IA_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
    constexpr unsigned int IA_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT            = 0x00000000;
    constexpr unsigned int IA_UTCL1_CNTL__FORCE_SD_VMID_DIRTY__SHIFT          = 0x0000001d;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER0_CFG__CLEAR__SHIFT            = 0x0000001d;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER0_CFG__ENABLE__SHIFT           = 0x0000001c;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER0_CFG__PERF_MODE__SHIFT        = 0x00000018;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER0_CFG__PERF_SEL_END__SHIFT     = 0x00000008;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER0_CFG__PERF_SEL__SHIFT         = 0x00000000;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER1_CFG__CLEAR__SHIFT            = 0x0000001d;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER1_CFG__ENABLE__SHIFT           = 0x0000001c;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER1_CFG__PERF_MODE__SHIFT        = 0x00000018;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER1_CFG__PERF_SEL_END__SHIFT     = 0x00000008;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER1_CFG__PERF_SEL__SHIFT         = 0x00000000;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER2_CFG__CLEAR__SHIFT            = 0x0000001d;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER2_CFG__ENABLE__SHIFT           = 0x0000001c;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER2_CFG__PERF_MODE__SHIFT        = 0x00000018;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER2_CFG__PERF_SEL_END__SHIFT     = 0x00000008;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER2_CFG__PERF_SEL__SHIFT         = 0x00000000;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER3_CFG__CLEAR__SHIFT            = 0x0000001d;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER3_CFG__ENABLE__SHIFT           = 0x0000001c;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER3_CFG__PERF_MODE__SHIFT        = 0x00000018;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER3_CFG__PERF_SEL_END__SHIFT     = 0x00000008;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER3_CFG__PERF_SEL__SHIFT         = 0x00000000;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER4_CFG__CLEAR__SHIFT            = 0x0000001d;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER4_CFG__ENABLE__SHIFT           = 0x0000001c;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER4_CFG__PERF_MODE__SHIFT        = 0x00000018;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER4_CFG__PERF_SEL_END__SHIFT     = 0x00000008;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER4_CFG__PERF_SEL__SHIFT         = 0x00000000;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER5_CFG__CLEAR__SHIFT            = 0x0000001d;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER5_CFG__ENABLE__SHIFT           = 0x0000001c;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER5_CFG__PERF_MODE__SHIFT        = 0x00000018;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER5_CFG__PERF_SEL_END__SHIFT     = 0x00000008;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER5_CFG__PERF_SEL__SHIFT         = 0x00000000;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER6_CFG__CLEAR__SHIFT            = 0x0000001d;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER6_CFG__ENABLE__SHIFT           = 0x0000001c;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER6_CFG__PERF_MODE__SHIFT        = 0x00000018;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER6_CFG__PERF_SEL_END__SHIFT     = 0x00000008;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER6_CFG__PERF_SEL__SHIFT         = 0x00000000;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER7_CFG__CLEAR__SHIFT            = 0x0000001d;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER7_CFG__ENABLE__SHIFT           = 0x0000001c;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER7_CFG__PERF_MODE__SHIFT        = 0x00000018;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER7_CFG__PERF_SEL_END__SHIFT     = 0x00000008;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER7_CFG__PERF_SEL__SHIFT         = 0x00000000;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER_HI__COMPARE_VALUE__SHIFT      = 0x00000010;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER_HI__COUNTER_HI__SHIFT         = 0x00000000;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER_LO__COUNTER_LO__SHIFT         = 0x00000000;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER_RSLT_CNTL__CLEAR_ALL__SHIFT   = 0x00000019;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER_RSLT_CNTL__ENABLE_ANY__SHIFT  = 0x00000018;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER_RSLT_CNTL__PERF_COUNTER_SELECT__SHIFT = 0x00000000;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER_RSLT_CNTL__START_TRIGGER__SHIFT = 0x00000008;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER_RSLT_CNTL__STOP_ALL_ON_SATURATE__SHIFT = 0x0000001a;
    constexpr unsigned int MC_VM_L2_PERFCOUNTER_RSLT_CNTL__STOP_TRIGGER__SHIFT = 0x00000010;
    constexpr unsigned int MP1_SMN_FPS_CNT__COUNT__SHIFT                      = 0x00000000;
    constexpr unsigned int PA_CL_CNTL_STATUS__UTC_FAULT_DETECTED__SHIFT       = 0x00000000;
    constexpr unsigned int PA_CL_CNTL_STATUS__UTC_PRT_DETECTED__SHIFT         = 0x00000002;
    constexpr unsigned int PA_CL_CNTL_STATUS__UTC_RETRY_DETECTED__SHIFT       = 0x00000001;
    constexpr unsigned int PA_CL_VS_OUT_CNTL__USE_VTX_LINE_WIDTH__SHIFT       = 0x0000001a;
    constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__FLUSH_GS_OUTPUT__SHIFT  = 0x0000001a;
    constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__CS_CONTEXT_DONE__SHIFT  = 0x00000006;
    constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__FLUSH_SX_TS__SHIFT      = 0x00000012;
    constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__RESERVED_63__SHIFT      = 0x0000001e;
    constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__SX_CB_RAT_ACK_REQUEST__SHIFT = 0x00000004;
    constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__THREAD_TRACE_FLUSH__SHIFT = 0x0000000c;
    constexpr unsigned int PA_SC_ENHANCE_1__ALLOW_SCALE_LINE_WIDTH_PAD_WITH_BINNING__SHIFT = 0x00000011;
    constexpr unsigned int PA_SC_ENHANCE_1__DEBUG_PIXEL_PICKER_XY_UNPACK__SHIFT = 0x0000000c;
    constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_PACKER_GRAD_FDCE_ENHANCE__SHIFT = 0x0000000d;
    constexpr unsigned int PA_SC_MODE_CNTL_0__SCALE_LINE_WIDTH_PAD__SHIFT     = 0x00000004;
    constexpr unsigned int PA_SC_RASTER_CONFIG_1__SE_PAIR_YSEL__SHIFT         = 0x00000005;
    constexpr unsigned int PA_SC_RASTER_CONFIG__SE_YSEL__SHIFT                = 0x0000001d;
    constexpr unsigned int PA_UTCL1_CNTL1__CLIENTID__SHIFT                    = 0x00000007;
    constexpr unsigned int PA_UTCL1_CNTL1__ENABLE_LFIFO_PRI_ARB__SHIFT        = 0x00000012;
    constexpr unsigned int PA_UTCL1_CNTL1__ENABLE_PUSH_LFIFO__SHIFT           = 0x00000011;
    constexpr unsigned int PA_UTCL1_CNTL1__FORCE_4K_L2_RESP__SHIFT            = 0x00000000;
    constexpr unsigned int PA_UTCL1_CNTL1__FORCE_IN_ORDER__SHIFT              = 0x0000001b;
    constexpr unsigned int PA_UTCL1_CNTL1__FORCE_MISS__SHIFT                  = 0x0000001a;
    constexpr unsigned int PA_UTCL1_CNTL1__GPUVM_64K_DEFAULT__SHIFT           = 0x00000001;
    constexpr unsigned int PA_UTCL1_CNTL1__GPUVM_PERM_MODE__SHIFT             = 0x00000002;
    constexpr unsigned int PA_UTCL1_CNTL1__INVALIDATE_ALL_VMID__SHIFT         = 0x00000019;
    constexpr unsigned int PA_UTCL1_CNTL1__REDUCE_CACHE_SIZE_BY_2__SHIFT      = 0x0000001e;
    constexpr unsigned int PA_UTCL1_CNTL1__REDUCE_FIFO_DEPTH_BY_2__SHIFT      = 0x0000001c;
    constexpr unsigned int PA_UTCL1_CNTL1__REG_INV_ALL_VMID__SHIFT            = 0x00000017;
    constexpr unsigned int PA_UTCL1_CNTL1__REG_INV_TOGGLE__SHIFT              = 0x00000018;
    constexpr unsigned int PA_UTCL1_CNTL1__REG_INV_VMID__SHIFT                = 0x00000013;
    constexpr unsigned int PA_UTCL1_CNTL1__RESP_FAULT_MODE__SHIFT             = 0x00000005;
    constexpr unsigned int PA_UTCL1_CNTL1__RESP_MODE__SHIFT                   = 0x00000003;
    constexpr unsigned int PA_UTCL1_CNTL1__SPARE__SHIFT                       = 0x00000010;
    constexpr unsigned int PA_UTCL1_CNTL2__ENABLE_PERF_EVENT_RD_WR__SHIFT     = 0x00000012;
    constexpr unsigned int PA_UTCL1_CNTL2__ENABLE_PERF_EVENT_VMID__SHIFT      = 0x00000014;
    constexpr unsigned int PA_UTCL1_CNTL2__ENABLE_SHOOTDOWN_OPT__SHIFT        = 0x0000000d;
    constexpr unsigned int PA_UTCL1_CNTL2__FORCE_FRAG_2M_TO_64K__SHIFT        = 0x0000001a;
    constexpr unsigned int PA_UTCL1_CNTL2__FORCE_GPUVM_INV_ACK__SHIFT         = 0x0000000f;
    constexpr unsigned int PA_UTCL1_CNTL2__FORCE_SNOOP__SHIFT                 = 0x0000000e;
    constexpr unsigned int PA_UTCL1_CNTL2__GPUVM_INV_MODE__SHIFT              = 0x0000000c;
    constexpr unsigned int PA_UTCL1_CNTL2__LINE_VALID__SHIFT                  = 0x0000000a;
    constexpr unsigned int PA_UTCL1_CNTL2__MTYPE_OVRD_DIS__SHIFT              = 0x00000009;
    constexpr unsigned int PA_UTCL1_CNTL2__PERF_EVENT_RD_WR__SHIFT            = 0x00000013;
    constexpr unsigned int PA_UTCL1_CNTL2__PERF_EVENT_VMID__SHIFT             = 0x00000015;
    constexpr unsigned int PA_UTCL1_CNTL2__RESERVED__SHIFT                    = 0x0000001b;
    constexpr unsigned int PA_UTCL1_CNTL2__SPARE1__SHIFT                      = 0x00000000;
    constexpr unsigned int PA_UTCL1_CNTL2__SPARE2__SHIFT                      = 0x00000008;
    constexpr unsigned int PA_UTCL1_CNTL2__SPARE3__SHIFT                      = 0x0000000b;
    constexpr unsigned int PA_UTCL1_CNTL2__SPARE4__SHIFT                      = 0x00000010;
    constexpr unsigned int PA_UTCL1_CNTL2__SPARE5__SHIFT                      = 0x00000019;
    constexpr unsigned int RLC_SPM_CB_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_CB_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT   = 0x00000008;
    constexpr unsigned int RLC_SPM_CPC_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_CPC_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT  = 0x00000008;
    constexpr unsigned int RLC_SPM_CPF_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_CPF_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT  = 0x00000008;
    constexpr unsigned int RLC_SPM_CPG_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_CPG_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT  = 0x00000008;
    constexpr unsigned int RLC_SPM_DB_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_DB_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT   = 0x00000008;
    constexpr unsigned int RLC_SPM_GDS_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_GDS_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT  = 0x00000008;
    constexpr unsigned int RLC_SPM_IA_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_IA_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT   = 0x00000008;
    constexpr unsigned int RLC_SPM_MC_CNTL__RESERVED__SHIFT                   = 0x0000000a;
    constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_FED__SHIFT                = 0x00000006;
    constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_MTYPE_OVER__SHIFT         = 0x00000007;
    constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_MTYPE__SHIFT              = 0x00000008;
    constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_PERF_CNTR__SHIFT          = 0x00000005;
    constexpr unsigned int RLC_SPM_PA_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_PA_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT   = 0x00000008;
    constexpr unsigned int RLC_SPM_RMI_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_RMI_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT  = 0x00000008;
    constexpr unsigned int RLC_SPM_SC_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_SC_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT   = 0x00000008;
    constexpr unsigned int RLC_SPM_SPI_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_SPI_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT  = 0x00000008;
    constexpr unsigned int RLC_SPM_SQG_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_SQG_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT  = 0x00000008;
    constexpr unsigned int RLC_SPM_SX_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_SX_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT   = 0x00000008;
    constexpr unsigned int RLC_SPM_TA_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_TA_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT   = 0x00000008;
    constexpr unsigned int RLC_SPM_TCA_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_TCA_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT  = 0x00000008;
    constexpr unsigned int RLC_SPM_TCC_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_TCC_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT  = 0x00000008;
    constexpr unsigned int RLC_SPM_TCP_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_TCP_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT  = 0x00000008;
    constexpr unsigned int RLC_SPM_TD_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_TD_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT   = 0x00000008;
    constexpr unsigned int RLC_SPM_UTCL1_CNTL__FORCE_SD_VMID_DIRTY__SHIFT     = 0x0000001d;
    constexpr unsigned int RLC_SPM_VGT_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_VGT_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT  = 0x00000008;
    constexpr unsigned int SDMA0_PERFCOUNTER0_RESULT__PERF_COUNT__SHIFT       = 0x00000000;
    constexpr unsigned int SDMA0_PERFCOUNTER1_RESULT__PERF_COUNT__SHIFT       = 0x00000000;
    constexpr unsigned int SDMA0_PERFCOUNTER_TAG_DELAY_RANGE__RANGE_HIGH__SHIFT = 0x0000000e;
    constexpr unsigned int SDMA0_PERFCOUNTER_TAG_DELAY_RANGE__RANGE_LOW__SHIFT = 0x00000000;
    constexpr unsigned int SDMA0_PERFCOUNTER_TAG_DELAY_RANGE__SELECT_RW__SHIFT = 0x0000001c;
    constexpr unsigned int SDMA0_PERFMON_CNTL__PERF_CLEAR0__SHIFT             = 0x00000001;
    constexpr unsigned int SDMA0_PERFMON_CNTL__PERF_CLEAR1__SHIFT             = 0x0000000b;
    constexpr unsigned int SDMA0_PERFMON_CNTL__PERF_ENABLE0__SHIFT            = 0x00000000;
    constexpr unsigned int SDMA0_PERFMON_CNTL__PERF_ENABLE1__SHIFT            = 0x0000000a;
    constexpr unsigned int SDMA0_PERFMON_CNTL__PERF_SEL0__SHIFT               = 0x00000002;
    constexpr unsigned int SDMA0_PERFMON_CNTL__PERF_SEL1__SHIFT               = 0x0000000c;
    constexpr unsigned int SPI_CONFIG_CNTL_1__BATON_RESET_DISABLE__SHIFT      = 0x00000005;
    constexpr unsigned int SPI_CONFIG_CNTL_1__PC_LIMIT_ENABLE__SHIFT          = 0x00000006;
    constexpr unsigned int SPI_CONFIG_CNTL_1__PC_LIMIT_SIZE__SHIFT            = 0x00000010;
    constexpr unsigned int SPI_CONFIG_CNTL__RSRC_MGMT_RESET__SHIFT            = 0x0000001a;
    constexpr unsigned int SPI_CONFIG_PS_CU_EN__ENABLE__SHIFT                 = 0x00000000;
    constexpr unsigned int SPI_CONFIG_PS_CU_EN__PKR0_CU_EN__SHIFT             = 0x00000001;
    constexpr unsigned int SPI_CONFIG_PS_CU_EN__PKR1_CU_EN__SHIFT             = 0x00000010;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_4__COUNT__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_4__EVENTS__SHIFT           = 0x00000010;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_5__COUNT__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_5__EVENTS__SHIFT           = 0x00000010;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_6__COUNT__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_6__EVENTS__SHIFT           = 0x00000010;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_7__COUNT__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_7__EVENTS__SHIFT           = 0x00000010;
    constexpr unsigned int SPI_DSM_CNTL2__SPI_SR_MEM_INJECT_DELAY__SHIFT      = 0x00000004;
    constexpr unsigned int SPI_DSM_CNTL2__UNUSED__SHIFT                       = 0x0000000a;
    constexpr unsigned int SPI_DSM_CNTL__UNUSED__SHIFT                        = 0x00000003;
    constexpr unsigned int SPI_GDS_CREDITS__UNUSED__SHIFT                     = 0x00000010;
    constexpr unsigned int SPI_LB_CU_MASK__CU_MASK__SHIFT                     = 0x00000000;
    constexpr unsigned int SPI_LB_DATA_PERCU_WAVE_CS__ACTIVE__SHIFT           = 0x00000000;
    constexpr unsigned int SPI_LB_DATA_PERCU_WAVE_HSGS__CU_USED_GS__SHIFT     = 0x00000010;
    constexpr unsigned int SPI_LB_DATA_PERCU_WAVE_HSGS__CU_USED_HS__SHIFT     = 0x00000000;
    constexpr unsigned int SPI_LB_DATA_PERCU_WAVE_VSPS__CU_USED_PS__SHIFT     = 0x00000010;
    constexpr unsigned int SPI_LB_DATA_PERCU_WAVE_VSPS__CU_USED_VS__SHIFT     = 0x00000000;
    constexpr unsigned int SPI_PG_ENABLE_STATIC_CU_MASK__CU_MASK__SHIFT       = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_8__BARRIERS__SHIFT         = 0x0000000f;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_8__LDS__SHIFT              = 0x00000008;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_8__SGPR__SHIFT             = 0x00000004;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_8__VGPR__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_8__WAVES__SHIFT            = 0x0000000c;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_9__BARRIERS__SHIFT         = 0x0000000f;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_9__LDS__SHIFT              = 0x00000008;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_9__SGPR__SHIFT             = 0x00000004;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_9__VGPR__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_9__WAVES__SHIFT            = 0x0000000c;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_10__BARRIERS__SHIFT        = 0x0000000f;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_10__LDS__SHIFT             = 0x00000008;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_10__SGPR__SHIFT            = 0x00000004;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_10__VGPR__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_10__WAVES__SHIFT           = 0x0000000c;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_11__BARRIERS__SHIFT        = 0x0000000f;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_11__LDS__SHIFT             = 0x00000008;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_11__SGPR__SHIFT            = 0x00000004;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_11__VGPR__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_11__WAVES__SHIFT           = 0x0000000c;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_12__BARRIERS__SHIFT        = 0x0000000f;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_12__LDS__SHIFT             = 0x00000008;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_12__SGPR__SHIFT            = 0x00000004;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_12__VGPR__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_12__WAVES__SHIFT           = 0x0000000c;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_13__BARRIERS__SHIFT        = 0x0000000f;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_13__LDS__SHIFT             = 0x00000008;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_13__SGPR__SHIFT            = 0x00000004;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_13__VGPR__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_13__WAVES__SHIFT           = 0x0000000c;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_14__BARRIERS__SHIFT        = 0x0000000f;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_14__LDS__SHIFT             = 0x00000008;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_14__SGPR__SHIFT            = 0x00000004;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_14__VGPR__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_14__WAVES__SHIFT           = 0x0000000c;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_15__BARRIERS__SHIFT        = 0x0000000f;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_15__LDS__SHIFT             = 0x00000008;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_15__SGPR__SHIFT            = 0x00000004;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_15__VGPR__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_15__WAVES__SHIFT           = 0x0000000c;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_0__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_1__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_2__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_3__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_4__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_5__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_6__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_7__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_8__EN__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_8__QUEUE_MASK__SHIFT    = 0x00000010;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_8__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_8__TYPE_MASK__SHIFT     = 0x00000001;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_9__EN__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_9__QUEUE_MASK__SHIFT    = 0x00000010;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_9__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_9__TYPE_MASK__SHIFT     = 0x00000001;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_10__EN__SHIFT           = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_10__QUEUE_MASK__SHIFT   = 0x00000010;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_10__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_10__TYPE_MASK__SHIFT    = 0x00000001;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_11__EN__SHIFT           = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_11__QUEUE_MASK__SHIFT   = 0x00000010;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_11__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_11__TYPE_MASK__SHIFT    = 0x00000001;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_12__EN__SHIFT           = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_12__QUEUE_MASK__SHIFT   = 0x00000010;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_12__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_12__TYPE_MASK__SHIFT    = 0x00000001;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_13__EN__SHIFT           = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_13__QUEUE_MASK__SHIFT   = 0x00000010;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_13__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_13__TYPE_MASK__SHIFT    = 0x00000001;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_14__EN__SHIFT           = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_14__QUEUE_MASK__SHIFT   = 0x00000010;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_14__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_14__TYPE_MASK__SHIFT    = 0x00000001;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_15__EN__SHIFT           = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_15__QUEUE_MASK__SHIFT   = 0x00000010;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_15__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_15__TYPE_MASK__SHIFT    = 0x00000001;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__SKIP_USGPR0__SHIFT        = 0x0000001b;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__USER_SGPR_MSB__SHIFT      = 0x0000001c;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__EXCP_EN__SHIFT            = 0x00000007;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__LDS_SIZE__SHIFT           = 0x00000010;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__SKIP_USGPR0__SHIFT        = 0x0000001b;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__USER_SGPR_MSB__SHIFT      = 0x0000001c;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__SKIP_USGPR0__SHIFT        = 0x0000001b;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__USER_SGPR_MSB__SHIFT      = 0x0000001c;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__DISPATCH_DRAW_EN__SHIFT   = 0x00000018;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__SKIP_USGPR0__SHIFT        = 0x0000001b;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__USER_SGPR_MSB__SHIFT      = 0x0000001c;
    constexpr unsigned int SPI_SHADER_PGM_RSRC3_GS__SIMD_DISABLE__SHIFT       = 0x0000001a;
    constexpr unsigned int SPI_SHADER_PGM_RSRC3_HS__SIMD_DISABLE__SHIFT       = 0x0000000a;
    constexpr unsigned int SPI_SHADER_PGM_RSRC3_PS__SIMD_DISABLE__SHIFT       = 0x0000001a;
    constexpr unsigned int SPI_SHADER_PGM_RSRC3_VS__SIMD_DISABLE__SHIFT       = 0x0000001a;
    constexpr unsigned int SPI_SHADER_PGM_RSRC4_GS__GROUP_FIFO_DEPTH__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_RSRC4_GS__SPI_SHADER_LATE_ALLOC_GS__SHIFT = 0x00000007;
    constexpr unsigned int SPI_SHADER_PGM_RSRC4_HS__GROUP_FIFO_DEPTH__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_0__DATA__SHIFT         = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_1__DATA__SHIFT         = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_2__DATA__SHIFT         = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_3__DATA__SHIFT         = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_4__DATA__SHIFT         = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_5__DATA__SHIFT         = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_6__DATA__SHIFT         = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_7__DATA__SHIFT         = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_8__DATA__SHIFT         = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_9__DATA__SHIFT         = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_10__DATA__SHIFT        = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_11__DATA__SHIFT        = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_12__DATA__SHIFT        = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_13__DATA__SHIFT        = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_14__DATA__SHIFT        = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_15__DATA__SHIFT        = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_16__DATA__SHIFT        = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_17__DATA__SHIFT        = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_18__DATA__SHIFT        = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_19__DATA__SHIFT        = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_20__DATA__SHIFT        = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_21__DATA__SHIFT        = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_22__DATA__SHIFT        = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_23__DATA__SHIFT        = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_24__DATA__SHIFT        = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_25__DATA__SHIFT        = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_26__DATA__SHIFT        = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_27__DATA__SHIFT        = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_28__DATA__SHIFT        = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_29__DATA__SHIFT        = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_30__DATA__SHIFT        = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_COMMON_31__DATA__SHIFT        = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_0__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_1__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_2__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_3__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_4__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_5__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_6__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_7__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_8__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_9__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_10__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_11__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_12__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_13__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_14__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_15__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_16__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_17__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_18__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_19__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_20__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_21__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_22__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_23__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_24__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_25__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_26__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_27__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_28__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_29__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_30__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_31__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_0__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_1__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_2__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_3__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_4__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_5__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_6__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_7__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_8__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_9__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_10__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_11__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_12__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_13__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_14__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_15__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_16__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_17__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_18__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_19__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_20__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_21__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_22__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_23__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_24__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_25__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_26__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_27__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_28__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_29__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_30__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_31__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_START_PHASE__SGPR_START_PHASE__SHIFT           = 0x00000002;
    constexpr unsigned int SPI_START_PHASE__VGPR_START_PHASE__SHIFT           = 0x00000000;
    constexpr unsigned int SPI_START_PHASE__WAVE_START_PHASE__SHIFT           = 0x00000004;
    constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS4__VALUE__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS5__VALUE__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS6__VALUE__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS7__VALUE__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_WCL_PIPE_PERCENT_GFX__ES_GRP_VALUE__SHIFT      = 0x00000011;
    constexpr unsigned int SPI_WCL_PIPE_PERCENT_GFX__LS_GRP_VALUE__SHIFT      = 0x00000007;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_6__EN_WARN__SHIFT            = 0x0000001f;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_6__MAX_CNT__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_7__EN_WARN__SHIFT            = 0x0000001f;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_7__MAX_CNT__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_8__EN_WARN__SHIFT            = 0x0000001f;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_8__MAX_CNT__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_9__EN_WARN__SHIFT            = 0x0000001f;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_9__MAX_CNT__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_3__INT_SENT__SHIFT          = 0x0000001f;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_3__MAX_CNT__SHIFT           = 0x00000000;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_5__INT_SENT__SHIFT          = 0x0000001f;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_5__MAX_CNT__SHIFT           = 0x00000000;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_10__INT_SENT__SHIFT         = 0x0000001f;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_10__MAX_CNT__SHIFT          = 0x00000000;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_12__INT_SENT__SHIFT         = 0x0000001f;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_12__MAX_CNT__SHIFT          = 0x00000000;
    constexpr unsigned int SQ_ALU_CLK_CTRL__FORCE_CU_ON_SH0__SHIFT            = 0x00000000;
    constexpr unsigned int SQ_ALU_CLK_CTRL__FORCE_CU_ON_SH1__SHIFT            = 0x00000010;
    constexpr unsigned int SQ_BUF_RSRC_WORD0__BASE_ADDRESS__SHIFT             = 0x00000000;
    constexpr unsigned int SQ_BUF_RSRC_WORD1__BASE_ADDRESS_HI__SHIFT          = 0x00000000;
    constexpr unsigned int SQ_BUF_RSRC_WORD1__CACHE_SWIZZLE__SHIFT            = 0x0000001e;
    constexpr unsigned int SQ_BUF_RSRC_WORD1__STRIDE__SHIFT                   = 0x00000010;
    constexpr unsigned int SQ_BUF_RSRC_WORD1__SWIZZLE_ENABLE__SHIFT           = 0x0000001f;
    constexpr unsigned int SQ_BUF_RSRC_WORD2__NUM_RECORDS__SHIFT              = 0x00000000;
    constexpr unsigned int SQ_BUF_RSRC_WORD3__ADD_TID_ENABLE__SHIFT           = 0x00000017;
    constexpr unsigned int SQ_BUF_RSRC_WORD3__DATA_FORMAT__SHIFT              = 0x0000000f;
    constexpr unsigned int SQ_BUF_RSRC_WORD3__DST_SEL_W__SHIFT                = 0x00000009;
    constexpr unsigned int SQ_BUF_RSRC_WORD3__DST_SEL_X__SHIFT                = 0x00000000;
    constexpr unsigned int SQ_BUF_RSRC_WORD3__DST_SEL_Y__SHIFT                = 0x00000003;
    constexpr unsigned int SQ_BUF_RSRC_WORD3__DST_SEL_Z__SHIFT                = 0x00000006;
    constexpr unsigned int SQ_BUF_RSRC_WORD3__INDEX_STRIDE__SHIFT             = 0x00000015;
    constexpr unsigned int SQ_BUF_RSRC_WORD3__NUM_FORMAT__SHIFT               = 0x0000000c;
    constexpr unsigned int SQ_BUF_RSRC_WORD3__NV__SHIFT                       = 0x0000001b;
    constexpr unsigned int SQ_BUF_RSRC_WORD3__TYPE__SHIFT                     = 0x0000001e;
    constexpr unsigned int SQ_BUF_RSRC_WORD3__USER_VM_ENABLE__SHIFT           = 0x00000013;
    constexpr unsigned int SQ_BUF_RSRC_WORD3__USER_VM_MODE__SHIFT             = 0x00000014;
    constexpr unsigned int SQ_CMD_TIMESTAMP__TIMESTAMP__SHIFT                 = 0x00000000;
    constexpr unsigned int SQ_CMD__SIMD_ID__SHIFT                             = 0x00000014;
    constexpr unsigned int SQ_CONFIG__DEBUG_EN__SHIFT                         = 0x00000008;
    constexpr unsigned int SQ_CONFIG__DEBUG_ONE_INST_CLAUSE__SHIFT            = 0x0000000a;
    constexpr unsigned int SQ_CONFIG__DEBUG_SINGLE_MEMOP__SHIFT               = 0x00000009;
    constexpr unsigned int SQ_CONFIG__DISABLE_FLAT_SOFT_CLAUSE__SHIFT         = 0x0000001e;
    constexpr unsigned int SQ_CONFIG__DISABLE_MIMG_SOFT_CLAUSE__SHIFT         = 0x0000001f;
    constexpr unsigned int SQ_CONFIG__DISABLE_SMEM_SOFT_CLAUSE__SHIFT         = 0x00000011;
    constexpr unsigned int SQ_CONFIG__DISABLE_SP_VGPR_WRITE_SKIP__SHIFT       = 0x0000001c;
    constexpr unsigned int SQ_CONFIG__DISABLE_VMEM_SOFT_CLAUSE__SHIFT         = 0x00000010;
    constexpr unsigned int SQ_CONFIG__DUA_FLAT_LDS_PINGPONG_DISABLE__SHIFT    = 0x0000000f;
    constexpr unsigned int SQ_CONFIG__DUA_FLAT_LOCK_ENABLE__SHIFT             = 0x0000000d;
    constexpr unsigned int SQ_CONFIG__DUA_LDS_BYPASS_DISABLE__SHIFT           = 0x0000000e;
    constexpr unsigned int SQ_CONFIG__EARLY_TA_DONE_DISABLE__SHIFT            = 0x0000000c;
    constexpr unsigned int SQ_CONFIG__OVERRIDE_ALU_BUSY__SHIFT                = 0x00000007;
    constexpr unsigned int SQ_CONFIG__OVERRIDE_LDS_IDX_BUSY__SHIFT            = 0x0000000b;
    constexpr unsigned int SQ_CONFIG__REPLAY_SLEEP_CNT__SHIFT                 = 0x00000015;
    constexpr unsigned int SQ_DS_0__ENCODING__SHIFT                           = 0x0000001a;
    constexpr unsigned int SQ_DS_0__GDS__SHIFT                                = 0x00000010;
    constexpr unsigned int SQ_DS_0__OFFSET0__SHIFT                            = 0x00000000;
    constexpr unsigned int SQ_DS_0__OFFSET1__SHIFT                            = 0x00000008;
    constexpr unsigned int SQ_DS_0__OP__SHIFT                                 = 0x00000011;
    constexpr unsigned int SQ_DS_1__ADDR__SHIFT                               = 0x00000000;
    constexpr unsigned int SQ_DS_1__DATA0__SHIFT                              = 0x00000008;
    constexpr unsigned int SQ_DS_1__DATA1__SHIFT                              = 0x00000010;
    constexpr unsigned int SQ_DS_1__VDST__SHIFT                               = 0x00000018;
    constexpr unsigned int SQ_EDC_DED_CNT__LDS_DED__SHIFT                     = 0x00000000;
    constexpr unsigned int SQ_EDC_DED_CNT__SGPR_DED__SHIFT                    = 0x00000008;
    constexpr unsigned int SQ_EDC_DED_CNT__VGPR_DED__SHIFT                    = 0x00000010;
    constexpr unsigned int SQ_EDC_INFO__SIMD_ID__SHIFT                        = 0x00000004;
    constexpr unsigned int SQ_EDC_INFO__SOURCE__SHIFT                         = 0x00000006;
    constexpr unsigned int SQ_EDC_INFO__VM_ID__SHIFT                          = 0x00000009;
    constexpr unsigned int SQ_EDC_INFO__WAVE_ID__SHIFT                        = 0x00000000;
    constexpr unsigned int SQ_EDC_SEC_CNT__LDS_SEC__SHIFT                     = 0x00000000;
    constexpr unsigned int SQ_EDC_SEC_CNT__SGPR_SEC__SHIFT                    = 0x00000008;
    constexpr unsigned int SQ_EDC_SEC_CNT__VGPR_SEC__SHIFT                    = 0x00000010;
    constexpr unsigned int SQ_EXP_0__COMPR__SHIFT                             = 0x0000000a;
    constexpr unsigned int SQ_EXP_0__DONE__SHIFT                              = 0x0000000b;
    constexpr unsigned int SQ_EXP_0__ENCODING__SHIFT                          = 0x0000001a;
    constexpr unsigned int SQ_EXP_0__EN__SHIFT                                = 0x00000000;
    constexpr unsigned int SQ_EXP_0__TGT__SHIFT                               = 0x00000004;
    constexpr unsigned int SQ_EXP_0__VM__SHIFT                                = 0x0000000c;
    constexpr unsigned int SQ_EXP_1__VSRC0__SHIFT                             = 0x00000000;
    constexpr unsigned int SQ_EXP_1__VSRC1__SHIFT                             = 0x00000008;
    constexpr unsigned int SQ_EXP_1__VSRC2__SHIFT                             = 0x00000010;
    constexpr unsigned int SQ_EXP_1__VSRC3__SHIFT                             = 0x00000018;
    constexpr unsigned int SQ_FIFO_SIZES__EXPORT_BUF_SIZE__SHIFT              = 0x00000010;
    constexpr unsigned int SQ_FLAT_0__ENCODING__SHIFT                         = 0x0000001a;
    constexpr unsigned int SQ_FLAT_0__GLC__SHIFT                              = 0x00000010;
    constexpr unsigned int SQ_FLAT_0__LDS__SHIFT                              = 0x0000000d;
    constexpr unsigned int SQ_FLAT_0__OFFSET__SHIFT                           = 0x00000000;
    constexpr unsigned int SQ_FLAT_0__OP__SHIFT                               = 0x00000012;
    constexpr unsigned int SQ_FLAT_0__SEG__SHIFT                              = 0x0000000e;
    constexpr unsigned int SQ_FLAT_0__SLC__SHIFT                              = 0x00000011;
    constexpr unsigned int SQ_FLAT_1__ADDR__SHIFT                             = 0x00000000;
    constexpr unsigned int SQ_FLAT_1__DATA__SHIFT                             = 0x00000008;
    constexpr unsigned int SQ_FLAT_1__NV__SHIFT                               = 0x00000017;
    constexpr unsigned int SQ_FLAT_1__SADDR__SHIFT                            = 0x00000010;
    constexpr unsigned int SQ_FLAT_1__VDST__SHIFT                             = 0x00000018;
    constexpr unsigned int SQ_FLAT_SCRATCH_WORD0__SIZE__SHIFT                 = 0x00000000;
    constexpr unsigned int SQ_FLAT_SCRATCH_WORD1__OFFSET__SHIFT               = 0x00000000;
    constexpr unsigned int SQ_GLBL_0__ENCODING__SHIFT                         = 0x0000001a;
    constexpr unsigned int SQ_GLBL_0__GLC__SHIFT                              = 0x00000010;
    constexpr unsigned int SQ_GLBL_0__LDS__SHIFT                              = 0x0000000d;
    constexpr unsigned int SQ_GLBL_0__OFFSET__SHIFT                           = 0x00000000;
    constexpr unsigned int SQ_GLBL_0__OP__SHIFT                               = 0x00000012;
    constexpr unsigned int SQ_GLBL_0__SEG__SHIFT                              = 0x0000000e;
    constexpr unsigned int SQ_GLBL_0__SLC__SHIFT                              = 0x00000011;
    constexpr unsigned int SQ_GLBL_1__ADDR__SHIFT                             = 0x00000000;
    constexpr unsigned int SQ_GLBL_1__DATA__SHIFT                             = 0x00000008;
    constexpr unsigned int SQ_GLBL_1__NV__SHIFT                               = 0x00000017;
    constexpr unsigned int SQ_GLBL_1__SADDR__SHIFT                            = 0x00000010;
    constexpr unsigned int SQ_GLBL_1__VDST__SHIFT                             = 0x00000018;
    constexpr unsigned int SQ_IMG_RSRC_WORD0__BASE_ADDRESS__SHIFT             = 0x00000000;
    constexpr unsigned int SQ_IMG_RSRC_WORD1__BASE_ADDRESS_HI__SHIFT          = 0x00000000;
    constexpr unsigned int SQ_IMG_RSRC_WORD1__DATA_FORMAT__SHIFT              = 0x00000014;
    constexpr unsigned int SQ_IMG_RSRC_WORD1__META_DIRECT__SHIFT              = 0x0000001f;
    constexpr unsigned int SQ_IMG_RSRC_WORD1__MIN_LOD__SHIFT                  = 0x00000008;
    constexpr unsigned int SQ_IMG_RSRC_WORD1__NUM_FORMAT__SHIFT               = 0x0000001a;
    constexpr unsigned int SQ_IMG_RSRC_WORD1__NV__SHIFT                       = 0x0000001e;
    constexpr unsigned int SQ_IMG_RSRC_WORD2__HEIGHT__SHIFT                   = 0x0000000e;
    constexpr unsigned int SQ_IMG_RSRC_WORD2__PERF_MOD__SHIFT                 = 0x0000001c;
    constexpr unsigned int SQ_IMG_RSRC_WORD2__WIDTH__SHIFT                    = 0x00000000;
    constexpr unsigned int SQ_IMG_RSRC_WORD3__BASE_LEVEL__SHIFT               = 0x0000000c;
    constexpr unsigned int SQ_IMG_RSRC_WORD3__DST_SEL_W__SHIFT                = 0x00000009;
    constexpr unsigned int SQ_IMG_RSRC_WORD3__DST_SEL_X__SHIFT                = 0x00000000;
    constexpr unsigned int SQ_IMG_RSRC_WORD3__DST_SEL_Y__SHIFT                = 0x00000003;
    constexpr unsigned int SQ_IMG_RSRC_WORD3__DST_SEL_Z__SHIFT                = 0x00000006;
    constexpr unsigned int SQ_IMG_RSRC_WORD3__LAST_LEVEL__SHIFT               = 0x00000010;
    constexpr unsigned int SQ_IMG_RSRC_WORD3__SW_MODE__SHIFT                  = 0x00000014;
    constexpr unsigned int SQ_IMG_RSRC_WORD3__TYPE__SHIFT                     = 0x0000001c;
    constexpr unsigned int SQ_IMG_RSRC_WORD4__BC_SWIZZLE__SHIFT               = 0x0000001d;
    constexpr unsigned int SQ_IMG_RSRC_WORD4__DEPTH__SHIFT                    = 0x00000000;
    constexpr unsigned int SQ_IMG_RSRC_WORD4__PITCH__SHIFT                    = 0x0000000d;
    constexpr unsigned int SQ_IMG_RSRC_WORD5__ARRAY_PITCH__SHIFT              = 0x0000000d;
    constexpr unsigned int SQ_IMG_RSRC_WORD5__BASE_ARRAY__SHIFT               = 0x00000000;
    constexpr unsigned int SQ_IMG_RSRC_WORD5__MAX_MIP__SHIFT                  = 0x0000001c;
    constexpr unsigned int SQ_IMG_RSRC_WORD5__META_DATA_ADDRESS__SHIFT        = 0x00000011;
    constexpr unsigned int SQ_IMG_RSRC_WORD5__META_LINEAR__SHIFT              = 0x00000019;
    constexpr unsigned int SQ_IMG_RSRC_WORD5__META_PIPE_ALIGNED__SHIFT        = 0x0000001a;
    constexpr unsigned int SQ_IMG_RSRC_WORD5__META_RB_ALIGNED__SHIFT          = 0x0000001b;
    constexpr unsigned int SQ_IMG_RSRC_WORD6__ALPHA_IS_ON_MSB__SHIFT          = 0x00000016;
    constexpr unsigned int SQ_IMG_RSRC_WORD6__COLOR_TRANSFORM__SHIFT          = 0x00000017;
    constexpr unsigned int SQ_IMG_RSRC_WORD6__COMPRESSION_EN__SHIFT           = 0x00000015;
    constexpr unsigned int SQ_IMG_RSRC_WORD6__COUNTER_BANK_ID__SHIFT          = 0x0000000c;
    constexpr unsigned int SQ_IMG_RSRC_WORD6__LOD_HDW_CNT_EN__SHIFT           = 0x00000014;
    constexpr unsigned int SQ_IMG_RSRC_WORD6__LOST_ALPHA_BITS__SHIFT          = 0x00000018;
    constexpr unsigned int SQ_IMG_RSRC_WORD6__LOST_COLOR_BITS__SHIFT          = 0x0000001c;
    constexpr unsigned int SQ_IMG_RSRC_WORD6__MIN_LOD_WARN__SHIFT             = 0x00000000;
    constexpr unsigned int SQ_IMG_RSRC_WORD7__META_DATA_ADDRESS__SHIFT        = 0x00000000;
    constexpr unsigned int SQ_IMG_SAMP_WORD0__ANISO_BIAS__SHIFT               = 0x00000015;
    constexpr unsigned int SQ_IMG_SAMP_WORD0__ANISO_THRESHOLD__SHIFT          = 0x00000010;
    constexpr unsigned int SQ_IMG_SAMP_WORD0__CLAMP_X__SHIFT                  = 0x00000000;
    constexpr unsigned int SQ_IMG_SAMP_WORD0__CLAMP_Y__SHIFT                  = 0x00000003;
    constexpr unsigned int SQ_IMG_SAMP_WORD0__CLAMP_Z__SHIFT                  = 0x00000006;
    constexpr unsigned int SQ_IMG_SAMP_WORD0__COMPAT_MODE__SHIFT              = 0x0000001f;
    constexpr unsigned int SQ_IMG_SAMP_WORD0__DEPTH_COMPARE_FUNC__SHIFT       = 0x0000000c;
    constexpr unsigned int SQ_IMG_SAMP_WORD0__DISABLE_CUBE_WRAP__SHIFT        = 0x0000001c;
    constexpr unsigned int SQ_IMG_SAMP_WORD0__FILTER_MODE__SHIFT              = 0x0000001d;
    constexpr unsigned int SQ_IMG_SAMP_WORD0__FORCE_DEGAMMA__SHIFT            = 0x00000014;
    constexpr unsigned int SQ_IMG_SAMP_WORD0__FORCE_UNNORMALIZED__SHIFT       = 0x0000000f;
    constexpr unsigned int SQ_IMG_SAMP_WORD0__MAX_ANISO_RATIO__SHIFT          = 0x00000009;
    constexpr unsigned int SQ_IMG_SAMP_WORD0__MC_COORD_TRUNC__SHIFT           = 0x00000013;
    constexpr unsigned int SQ_IMG_SAMP_WORD0__TRUNC_COORD__SHIFT              = 0x0000001b;
    constexpr unsigned int SQ_IMG_SAMP_WORD1__MAX_LOD__SHIFT                  = 0x0000000c;
    constexpr unsigned int SQ_IMG_SAMP_WORD1__MIN_LOD__SHIFT                  = 0x00000000;
    constexpr unsigned int SQ_IMG_SAMP_WORD1__PERF_MIP__SHIFT                 = 0x00000018;
    constexpr unsigned int SQ_IMG_SAMP_WORD1__PERF_Z__SHIFT                   = 0x0000001c;
    constexpr unsigned int SQ_IMG_SAMP_WORD2__ANISO_OVERRIDE__SHIFT           = 0x0000001f;
    constexpr unsigned int SQ_IMG_SAMP_WORD2__BLEND_ZERO_PRT__SHIFT           = 0x0000001d;
    constexpr unsigned int SQ_IMG_SAMP_WORD2__FILTER_PREC_FIX__SHIFT          = 0x0000001e;
    constexpr unsigned int SQ_IMG_SAMP_WORD2__LOD_BIAS_SEC__SHIFT             = 0x0000000e;
    constexpr unsigned int SQ_IMG_SAMP_WORD2__LOD_BIAS__SHIFT                 = 0x00000000;
    constexpr unsigned int SQ_IMG_SAMP_WORD2__MIP_FILTER__SHIFT               = 0x0000001a;
    constexpr unsigned int SQ_IMG_SAMP_WORD2__MIP_POINT_PRECLAMP__SHIFT       = 0x0000001c;
    constexpr unsigned int SQ_IMG_SAMP_WORD2__XY_MAG_FILTER__SHIFT            = 0x00000014;
    constexpr unsigned int SQ_IMG_SAMP_WORD2__XY_MIN_FILTER__SHIFT            = 0x00000016;
    constexpr unsigned int SQ_IMG_SAMP_WORD2__Z_FILTER__SHIFT                 = 0x00000018;
    constexpr unsigned int SQ_IMG_SAMP_WORD3__BORDER_COLOR_PTR__SHIFT         = 0x00000000;
    constexpr unsigned int SQ_IMG_SAMP_WORD3__BORDER_COLOR_TYPE__SHIFT        = 0x0000001e;
    constexpr unsigned int SQ_IMG_SAMP_WORD3__SKIP_DEGAMMA__SHIFT             = 0x0000000c;
    constexpr unsigned int SQ_IND_INDEX__AUTO_INCR__SHIFT                     = 0x0000000c;
    constexpr unsigned int SQ_IND_INDEX__FORCE_READ__SHIFT                    = 0x0000000d;
    constexpr unsigned int SQ_IND_INDEX__READ_TIMEOUT__SHIFT                  = 0x0000000e;
    constexpr unsigned int SQ_IND_INDEX__SIMD_ID__SHIFT                       = 0x00000004;
    constexpr unsigned int SQ_IND_INDEX__THREAD_ID__SHIFT                     = 0x00000006;
    constexpr unsigned int SQ_IND_INDEX__UNINDEXED__SHIFT                     = 0x0000000f;
    constexpr unsigned int SQ_INST__ENCODING__SHIFT                           = 0x00000000;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_CTXID__CMD_TIMESTAMP__SHIFT = 0x00000004;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_CTXID__ENCODING__SHIFT      = 0x0000001a;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_CTXID__HOST_CMD_OVERFLOW__SHIFT = 0x00000005;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_CTXID__HOST_REG_OVERFLOW__SHIFT = 0x00000006;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_CTXID__IMMED_OVERFLOW__SHIFT = 0x00000007;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_CTXID__REG_TIMESTAMP__SHIFT = 0x00000003;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_CTXID__SE_ID__SHIFT         = 0x00000018;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_CTXID__THREAD_TRACE_BUF_FULL__SHIFT = 0x00000002;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_CTXID__THREAD_TRACE_UTC_ERROR__SHIFT = 0x00000008;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_CTXID__THREAD_TRACE__SHIFT  = 0x00000000;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_CTXID__WLT__SHIFT           = 0x00000001;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_HI__ENCODING__SHIFT         = 0x0000000a;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_HI__SE_ID__SHIFT            = 0x00000008;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_LO__CMD_TIMESTAMP__SHIFT    = 0x00000004;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_LO__HOST_CMD_OVERFLOW__SHIFT = 0x00000005;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_LO__HOST_REG_OVERFLOW__SHIFT = 0x00000006;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_LO__IMMED_OVERFLOW__SHIFT   = 0x00000007;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_LO__REG_TIMESTAMP__SHIFT    = 0x00000003;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_LO__THREAD_TRACE_BUF_FULL__SHIFT = 0x00000002;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_LO__THREAD_TRACE_UTC_ERROR__SHIFT = 0x00000008;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_LO__THREAD_TRACE__SHIFT     = 0x00000000;
    constexpr unsigned int SQ_INTERRUPT_WORD_AUTO_LO__WLT__SHIFT              = 0x00000001;
    constexpr unsigned int SQ_INTERRUPT_WORD_CMN_CTXID__ENCODING__SHIFT       = 0x0000001a;
    constexpr unsigned int SQ_INTERRUPT_WORD_CMN_CTXID__SE_ID__SHIFT          = 0x00000018;
    constexpr unsigned int SQ_INTERRUPT_WORD_CMN_HI__ENCODING__SHIFT          = 0x0000000a;
    constexpr unsigned int SQ_INTERRUPT_WORD_CMN_HI__SE_ID__SHIFT             = 0x00000008;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_CTXID__CU_ID__SHIFT         = 0x00000014;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_CTXID__DATA__SHIFT          = 0x00000000;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_CTXID__ENCODING__SHIFT      = 0x0000001a;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_CTXID__PRIV__SHIFT          = 0x0000000d;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_CTXID__SE_ID__SHIFT         = 0x00000018;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_CTXID__SH_ID__SHIFT         = 0x0000000c;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_CTXID__SIMD_ID__SHIFT       = 0x00000012;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_CTXID__WAVE_ID__SHIFT       = 0x0000000e;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_HI__CU_ID__SHIFT            = 0x00000000;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_HI__ENCODING__SHIFT         = 0x0000000a;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_HI__SE_ID__SHIFT            = 0x00000008;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_HI__VM_ID__SHIFT            = 0x00000004;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_LO__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_LO__PRIV__SHIFT             = 0x00000019;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_LO__SH_ID__SHIFT            = 0x00000018;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_LO__SIMD_ID__SHIFT          = 0x0000001e;
    constexpr unsigned int SQ_INTERRUPT_WORD_WAVE_LO__WAVE_ID__SHIFT          = 0x0000001a;
    constexpr unsigned int SQ_LB_CTR0_CU__SH0_MASK__SHIFT                     = 0x00000000;
    constexpr unsigned int SQ_LB_CTR0_CU__SH1_MASK__SHIFT                     = 0x00000010;
    constexpr unsigned int SQ_LB_CTR1_CU__SH0_MASK__SHIFT                     = 0x00000000;
    constexpr unsigned int SQ_LB_CTR1_CU__SH1_MASK__SHIFT                     = 0x00000010;
    constexpr unsigned int SQ_LB_CTR2_CU__SH0_MASK__SHIFT                     = 0x00000000;
    constexpr unsigned int SQ_LB_CTR2_CU__SH1_MASK__SHIFT                     = 0x00000010;
    constexpr unsigned int SQ_LB_CTR3_CU__SH0_MASK__SHIFT                     = 0x00000000;
    constexpr unsigned int SQ_LB_CTR3_CU__SH1_MASK__SHIFT                     = 0x00000010;
    constexpr unsigned int SQ_LB_CTR_SEL__SEL0__SHIFT                         = 0x00000000;
    constexpr unsigned int SQ_LB_CTR_SEL__SEL1__SHIFT                         = 0x00000004;
    constexpr unsigned int SQ_LB_CTR_SEL__SEL2__SHIFT                         = 0x00000008;
    constexpr unsigned int SQ_LB_CTR_SEL__SEL3__SHIFT                         = 0x0000000c;
    constexpr unsigned int SQ_LDS_CLK_CTRL__FORCE_CU_ON_SH0__SHIFT            = 0x00000000;
    constexpr unsigned int SQ_LDS_CLK_CTRL__FORCE_CU_ON_SH1__SHIFT            = 0x00000010;
    constexpr unsigned int SQ_M0_GPR_IDX_WORD__INDEX__SHIFT                   = 0x00000000;
    constexpr unsigned int SQ_M0_GPR_IDX_WORD__VDST_REL__SHIFT                = 0x0000000f;
    constexpr unsigned int SQ_M0_GPR_IDX_WORD__VSRC0_REL__SHIFT               = 0x0000000c;
    constexpr unsigned int SQ_M0_GPR_IDX_WORD__VSRC1_REL__SHIFT               = 0x0000000d;
    constexpr unsigned int SQ_M0_GPR_IDX_WORD__VSRC2_REL__SHIFT               = 0x0000000e;
    constexpr unsigned int SQ_MIMG_0__A16__SHIFT                              = 0x0000000f;
    constexpr unsigned int SQ_MIMG_0__DA__SHIFT                               = 0x0000000e;
    constexpr unsigned int SQ_MIMG_0__DMASK__SHIFT                            = 0x00000008;
    constexpr unsigned int SQ_MIMG_0__ENCODING__SHIFT                         = 0x0000001a;
    constexpr unsigned int SQ_MIMG_0__GLC__SHIFT                              = 0x0000000d;
    constexpr unsigned int SQ_MIMG_0__LWE__SHIFT                              = 0x00000011;
    constexpr unsigned int SQ_MIMG_0__OPM__SHIFT                              = 0x00000000;
    constexpr unsigned int SQ_MIMG_0__OP__SHIFT                               = 0x00000012;
    constexpr unsigned int SQ_MIMG_0__SLC__SHIFT                              = 0x00000019;
    constexpr unsigned int SQ_MIMG_0__TFE__SHIFT                              = 0x00000010;
    constexpr unsigned int SQ_MIMG_0__UNORM__SHIFT                            = 0x0000000c;
    constexpr unsigned int SQ_MIMG_1__D16__SHIFT                              = 0x0000001f;
    constexpr unsigned int SQ_MIMG_1__SRSRC__SHIFT                            = 0x00000010;
    constexpr unsigned int SQ_MIMG_1__SSAMP__SHIFT                            = 0x00000015;
    constexpr unsigned int SQ_MIMG_1__VADDR__SHIFT                            = 0x00000000;
    constexpr unsigned int SQ_MIMG_1__VDATA__SHIFT                            = 0x00000008;
    constexpr unsigned int SQ_MTBUF_0__DFMT__SHIFT                            = 0x00000013;
    constexpr unsigned int SQ_MTBUF_0__ENCODING__SHIFT                        = 0x0000001a;
    constexpr unsigned int SQ_MTBUF_0__GLC__SHIFT                             = 0x0000000e;
    constexpr unsigned int SQ_MTBUF_0__IDXEN__SHIFT                           = 0x0000000d;
    constexpr unsigned int SQ_MTBUF_0__NFMT__SHIFT                            = 0x00000017;
    constexpr unsigned int SQ_MTBUF_0__OFFEN__SHIFT                           = 0x0000000c;
    constexpr unsigned int SQ_MTBUF_0__OFFSET__SHIFT                          = 0x00000000;
    constexpr unsigned int SQ_MTBUF_0__OP__SHIFT                              = 0x0000000f;
    constexpr unsigned int SQ_MTBUF_1__SLC__SHIFT                             = 0x00000016;
    constexpr unsigned int SQ_MTBUF_1__SOFFSET__SHIFT                         = 0x00000018;
    constexpr unsigned int SQ_MTBUF_1__SRSRC__SHIFT                           = 0x00000010;
    constexpr unsigned int SQ_MTBUF_1__TFE__SHIFT                             = 0x00000017;
    constexpr unsigned int SQ_MTBUF_1__VADDR__SHIFT                           = 0x00000000;
    constexpr unsigned int SQ_MTBUF_1__VDATA__SHIFT                           = 0x00000008;
    constexpr unsigned int SQ_MUBUF_0__ENCODING__SHIFT                        = 0x0000001a;
    constexpr unsigned int SQ_MUBUF_0__GLC__SHIFT                             = 0x0000000e;
    constexpr unsigned int SQ_MUBUF_0__IDXEN__SHIFT                           = 0x0000000d;
    constexpr unsigned int SQ_MUBUF_0__LDS__SHIFT                             = 0x00000010;
    constexpr unsigned int SQ_MUBUF_0__OFFEN__SHIFT                           = 0x0000000c;
    constexpr unsigned int SQ_MUBUF_0__OFFSET__SHIFT                          = 0x00000000;
    constexpr unsigned int SQ_MUBUF_0__OP__SHIFT                              = 0x00000012;
    constexpr unsigned int SQ_MUBUF_0__SLC__SHIFT                             = 0x00000011;
    constexpr unsigned int SQ_MUBUF_1__SOFFSET__SHIFT                         = 0x00000018;
    constexpr unsigned int SQ_MUBUF_1__SRSRC__SHIFT                           = 0x00000010;
    constexpr unsigned int SQ_MUBUF_1__TFE__SHIFT                             = 0x00000017;
    constexpr unsigned int SQ_MUBUF_1__VADDR__SHIFT                           = 0x00000000;
    constexpr unsigned int SQ_MUBUF_1__VDATA__SHIFT                           = 0x00000008;
    constexpr unsigned int SQ_PERFCOUNTER0_SELECT__SIMD_MASK__SHIFT           = 0x00000018;
    constexpr unsigned int SQ_PERFCOUNTER0_SELECT__SQC_BANK_MASK__SHIFT       = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER0_SELECT__SQC_CLIENT_MASK__SHIFT     = 0x00000010;
    constexpr unsigned int SQ_PERFCOUNTER1_SELECT__SIMD_MASK__SHIFT           = 0x00000018;
    constexpr unsigned int SQ_PERFCOUNTER1_SELECT__SQC_BANK_MASK__SHIFT       = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER1_SELECT__SQC_CLIENT_MASK__SHIFT     = 0x00000010;
    constexpr unsigned int SQ_PERFCOUNTER2_SELECT__SIMD_MASK__SHIFT           = 0x00000018;
    constexpr unsigned int SQ_PERFCOUNTER2_SELECT__SQC_BANK_MASK__SHIFT       = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER2_SELECT__SQC_CLIENT_MASK__SHIFT     = 0x00000010;
    constexpr unsigned int SQ_PERFCOUNTER3_SELECT__SIMD_MASK__SHIFT           = 0x00000018;
    constexpr unsigned int SQ_PERFCOUNTER3_SELECT__SQC_BANK_MASK__SHIFT       = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER3_SELECT__SQC_CLIENT_MASK__SHIFT     = 0x00000010;
    constexpr unsigned int SQ_PERFCOUNTER4_SELECT__SIMD_MASK__SHIFT           = 0x00000018;
    constexpr unsigned int SQ_PERFCOUNTER4_SELECT__SQC_BANK_MASK__SHIFT       = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER4_SELECT__SQC_CLIENT_MASK__SHIFT     = 0x00000010;
    constexpr unsigned int SQ_PERFCOUNTER5_SELECT__SIMD_MASK__SHIFT           = 0x00000018;
    constexpr unsigned int SQ_PERFCOUNTER5_SELECT__SQC_BANK_MASK__SHIFT       = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER5_SELECT__SQC_CLIENT_MASK__SHIFT     = 0x00000010;
    constexpr unsigned int SQ_PERFCOUNTER6_SELECT__SIMD_MASK__SHIFT           = 0x00000018;
    constexpr unsigned int SQ_PERFCOUNTER6_SELECT__SQC_BANK_MASK__SHIFT       = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER6_SELECT__SQC_CLIENT_MASK__SHIFT     = 0x00000010;
    constexpr unsigned int SQ_PERFCOUNTER7_SELECT__SIMD_MASK__SHIFT           = 0x00000018;
    constexpr unsigned int SQ_PERFCOUNTER7_SELECT__SQC_BANK_MASK__SHIFT       = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER7_SELECT__SQC_CLIENT_MASK__SHIFT     = 0x00000010;
    constexpr unsigned int SQ_PERFCOUNTER8_SELECT__SIMD_MASK__SHIFT           = 0x00000018;
    constexpr unsigned int SQ_PERFCOUNTER8_SELECT__SQC_BANK_MASK__SHIFT       = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER8_SELECT__SQC_CLIENT_MASK__SHIFT     = 0x00000010;
    constexpr unsigned int SQ_PERFCOUNTER9_SELECT__SIMD_MASK__SHIFT           = 0x00000018;
    constexpr unsigned int SQ_PERFCOUNTER9_SELECT__SQC_BANK_MASK__SHIFT       = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER9_SELECT__SQC_CLIENT_MASK__SHIFT     = 0x00000010;
    constexpr unsigned int SQ_PERFCOUNTER10_SELECT__SIMD_MASK__SHIFT          = 0x00000018;
    constexpr unsigned int SQ_PERFCOUNTER10_SELECT__SQC_BANK_MASK__SHIFT      = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER10_SELECT__SQC_CLIENT_MASK__SHIFT    = 0x00000010;
    constexpr unsigned int SQ_PERFCOUNTER11_SELECT__SIMD_MASK__SHIFT          = 0x00000018;
    constexpr unsigned int SQ_PERFCOUNTER11_SELECT__SQC_BANK_MASK__SHIFT      = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER11_SELECT__SQC_CLIENT_MASK__SHIFT    = 0x00000010;
    constexpr unsigned int SQ_PERFCOUNTER12_SELECT__SIMD_MASK__SHIFT          = 0x00000018;
    constexpr unsigned int SQ_PERFCOUNTER12_SELECT__SQC_BANK_MASK__SHIFT      = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER12_SELECT__SQC_CLIENT_MASK__SHIFT    = 0x00000010;
    constexpr unsigned int SQ_PERFCOUNTER13_SELECT__SIMD_MASK__SHIFT          = 0x00000018;
    constexpr unsigned int SQ_PERFCOUNTER13_SELECT__SQC_BANK_MASK__SHIFT      = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER13_SELECT__SQC_CLIENT_MASK__SHIFT    = 0x00000010;
    constexpr unsigned int SQ_PERFCOUNTER14_SELECT__SIMD_MASK__SHIFT          = 0x00000018;
    constexpr unsigned int SQ_PERFCOUNTER14_SELECT__SQC_BANK_MASK__SHIFT      = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER14_SELECT__SQC_CLIENT_MASK__SHIFT    = 0x00000010;
    constexpr unsigned int SQ_PERFCOUNTER15_SELECT__SIMD_MASK__SHIFT          = 0x00000018;
    constexpr unsigned int SQ_PERFCOUNTER15_SELECT__SQC_BANK_MASK__SHIFT      = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER15_SELECT__SQC_CLIENT_MASK__SHIFT    = 0x00000010;
    constexpr unsigned int SQ_PERFCOUNTER_MASK__SH0_MASK__SHIFT               = 0x00000000;
    constexpr unsigned int SQ_PERFCOUNTER_MASK__SH1_MASK__SHIFT               = 0x00000010;
    constexpr unsigned int SQ_POWER_THROTTLE2__LONG_TERM_INTERVAL_RATIO__SHIFT = 0x0000001b;
    constexpr unsigned int SQ_POWER_THROTTLE2__MAX_POWER_DELTA__SHIFT         = 0x00000000;
    constexpr unsigned int SQ_POWER_THROTTLE2__SHORT_TERM_INTERVAL_SIZE__SHIFT = 0x00000010;
    constexpr unsigned int SQ_POWER_THROTTLE2__USE_REF_CLOCK__SHIFT           = 0x0000001f;
    constexpr unsigned int SQ_POWER_THROTTLE__MAX_POWER__SHIFT                = 0x00000010;
    constexpr unsigned int SQ_POWER_THROTTLE__MIN_POWER__SHIFT                = 0x00000000;
    constexpr unsigned int SQ_POWER_THROTTLE__PHASE_OFFSET__SHIFT             = 0x0000001e;
    constexpr unsigned int SQ_REG_CREDITS__CMD_CREDITS__SHIFT                 = 0x00000008;
    constexpr unsigned int SQ_REG_CREDITS__CMD_OVERFLOW__SHIFT                = 0x0000001f;
    constexpr unsigned int SQ_REG_CREDITS__IMMED_OVERFLOW__SHIFT              = 0x0000001e;
    constexpr unsigned int SQ_REG_CREDITS__REG_BUSY__SHIFT                    = 0x0000001c;
    constexpr unsigned int SQ_REG_CREDITS__SRBM_CREDITS__SHIFT                = 0x00000000;
    constexpr unsigned int SQ_REG_CREDITS__SRBM_OVERFLOW__SHIFT               = 0x0000001d;
    constexpr unsigned int SQ_REG_TIMESTAMP__TIMESTAMP__SHIFT                 = 0x00000000;
    constexpr unsigned int SQ_RUNTIME_CONFIG__ENABLE_TEX_ARB_OLDEST__SHIFT    = 0x00000000;
    constexpr unsigned int SQ_SCRATCH_0__ENCODING__SHIFT                      = 0x0000001a;
    constexpr unsigned int SQ_SCRATCH_0__GLC__SHIFT                           = 0x00000010;
    constexpr unsigned int SQ_SCRATCH_0__LDS__SHIFT                           = 0x0000000d;
    constexpr unsigned int SQ_SCRATCH_0__OFFSET__SHIFT                        = 0x00000000;
    constexpr unsigned int SQ_SCRATCH_0__OP__SHIFT                            = 0x00000012;
    constexpr unsigned int SQ_SCRATCH_0__SEG__SHIFT                           = 0x0000000e;
    constexpr unsigned int SQ_SCRATCH_0__SLC__SHIFT                           = 0x00000011;
    constexpr unsigned int SQ_SCRATCH_1__ADDR__SHIFT                          = 0x00000000;
    constexpr unsigned int SQ_SCRATCH_1__DATA__SHIFT                          = 0x00000008;
    constexpr unsigned int SQ_SCRATCH_1__NV__SHIFT                            = 0x00000017;
    constexpr unsigned int SQ_SCRATCH_1__SADDR__SHIFT                         = 0x00000010;
    constexpr unsigned int SQ_SCRATCH_1__VDST__SHIFT                          = 0x00000018;
    constexpr unsigned int SQ_SMEM_0__ENCODING__SHIFT                         = 0x0000001a;
    constexpr unsigned int SQ_SMEM_0__GLC__SHIFT                              = 0x00000010;
    constexpr unsigned int SQ_SMEM_0__IMM__SHIFT                              = 0x00000011;
    constexpr unsigned int SQ_SMEM_0__NV__SHIFT                               = 0x0000000f;
    constexpr unsigned int SQ_SMEM_0__OP__SHIFT                               = 0x00000012;
    constexpr unsigned int SQ_SMEM_0__SBASE__SHIFT                            = 0x00000000;
    constexpr unsigned int SQ_SMEM_0__SDATA__SHIFT                            = 0x00000006;
    constexpr unsigned int SQ_SMEM_0__SOFFSET_EN__SHIFT                       = 0x0000000e;
    constexpr unsigned int SQ_SMEM_1__OFFSET__SHIFT                           = 0x00000000;
    constexpr unsigned int SQ_SMEM_1__SOFFSET__SHIFT                          = 0x00000019;
    constexpr unsigned int SQ_SOP1__ENCODING__SHIFT                           = 0x00000017;
    constexpr unsigned int SQ_SOP1__OP__SHIFT                                 = 0x00000008;
    constexpr unsigned int SQ_SOP1__SDST__SHIFT                               = 0x00000010;
    constexpr unsigned int SQ_SOP1__SSRC0__SHIFT                              = 0x00000000;
    constexpr unsigned int SQ_SOP2__ENCODING__SHIFT                           = 0x0000001e;
    constexpr unsigned int SQ_SOP2__OP__SHIFT                                 = 0x00000017;
    constexpr unsigned int SQ_SOP2__SDST__SHIFT                               = 0x00000010;
    constexpr unsigned int SQ_SOP2__SSRC0__SHIFT                              = 0x00000000;
    constexpr unsigned int SQ_SOP2__SSRC1__SHIFT                              = 0x00000008;
    constexpr unsigned int SQ_SOPC__ENCODING__SHIFT                           = 0x00000017;
    constexpr unsigned int SQ_SOPC__OP__SHIFT                                 = 0x00000010;
    constexpr unsigned int SQ_SOPC__SSRC0__SHIFT                              = 0x00000000;
    constexpr unsigned int SQ_SOPC__SSRC1__SHIFT                              = 0x00000008;
    constexpr unsigned int SQ_SOPK__ENCODING__SHIFT                           = 0x0000001c;
    constexpr unsigned int SQ_SOPK__OP__SHIFT                                 = 0x00000017;
    constexpr unsigned int SQ_SOPK__SDST__SHIFT                               = 0x00000010;
    constexpr unsigned int SQ_SOPK__SIMM16__SHIFT                             = 0x00000000;
    constexpr unsigned int SQ_SOPP__ENCODING__SHIFT                           = 0x00000017;
    constexpr unsigned int SQ_SOPP__OP__SHIFT                                 = 0x00000010;
    constexpr unsigned int SQ_SOPP__SIMM16__SHIFT                             = 0x00000000;
    constexpr unsigned int SQ_TEX_CLK_CTRL__FORCE_CU_ON_SH0__SHIFT            = 0x00000000;
    constexpr unsigned int SQ_TEX_CLK_CTRL__FORCE_CU_ON_SH1__SHIFT            = 0x00000010;
    constexpr unsigned int SQ_THREAD_TRACE_BASE2__ADDR_HI__SHIFT              = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_BASE__ADDR__SHIFT                  = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_CNTR__CNTR__SHIFT                  = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__RESET_BUFFER__SHIFT          = 0x0000001f;
    constexpr unsigned int SQ_THREAD_TRACE_HIWATER__HIWATER__SHIFT            = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_MASK__CU_SEL__SHIFT                = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_MASK__REG_STALL_EN__SHIFT          = 0x00000007;
    constexpr unsigned int SQ_THREAD_TRACE_MASK__SH_SEL__SHIFT                = 0x00000005;
    constexpr unsigned int SQ_THREAD_TRACE_MASK__SIMD_EN__SHIFT               = 0x00000008;
    constexpr unsigned int SQ_THREAD_TRACE_MASK__SPI_STALL_EN__SHIFT          = 0x0000000e;
    constexpr unsigned int SQ_THREAD_TRACE_MASK__SQ_STALL_EN__SHIFT           = 0x0000000f;
    constexpr unsigned int SQ_THREAD_TRACE_MASK__VM_ID_MASK__SHIFT            = 0x0000000c;
    constexpr unsigned int SQ_THREAD_TRACE_MODE__AUTOFLUSH_EN__SHIFT          = 0x00000019;
    constexpr unsigned int SQ_THREAD_TRACE_MODE__CAPTURE_MODE__SHIFT          = 0x00000017;
    constexpr unsigned int SQ_THREAD_TRACE_MODE__INTERRUPT_EN__SHIFT          = 0x0000001e;
    constexpr unsigned int SQ_THREAD_TRACE_MODE__ISSUE_MASK__SHIFT            = 0x0000001b;
    constexpr unsigned int SQ_THREAD_TRACE_MODE__MASK_CS__SHIFT               = 0x00000012;
    constexpr unsigned int SQ_THREAD_TRACE_MODE__MASK_ES__SHIFT               = 0x00000009;
    constexpr unsigned int SQ_THREAD_TRACE_MODE__MASK_GS__SHIFT               = 0x00000006;
    constexpr unsigned int SQ_THREAD_TRACE_MODE__MASK_HS__SHIFT               = 0x0000000c;
    constexpr unsigned int SQ_THREAD_TRACE_MODE__MASK_LS__SHIFT               = 0x0000000f;
    constexpr unsigned int SQ_THREAD_TRACE_MODE__MASK_PS__SHIFT               = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_MODE__MASK_VS__SHIFT               = 0x00000003;
    constexpr unsigned int SQ_THREAD_TRACE_MODE__MODE__SHIFT                  = 0x00000015;
    constexpr unsigned int SQ_THREAD_TRACE_MODE__TC_PERF_EN__SHIFT            = 0x0000001a;
    constexpr unsigned int SQ_THREAD_TRACE_MODE__TEST_MODE__SHIFT             = 0x0000001d;
    constexpr unsigned int SQ_THREAD_TRACE_MODE__WRAP__SHIFT                  = 0x0000001f;
    constexpr unsigned int SQ_THREAD_TRACE_PERF_MASK__SH0_MASK__SHIFT         = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_PERF_MASK__SH1_MASK__SHIFT         = 0x00000010;
    constexpr unsigned int SQ_THREAD_TRACE_SIZE__SIZE__SHIFT                  = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_STATUS__BUSY__SHIFT                = 0x0000001e;
    constexpr unsigned int SQ_THREAD_TRACE_STATUS__FINISH_DONE__SHIFT         = 0x00000010;
    constexpr unsigned int SQ_THREAD_TRACE_STATUS__FULL__SHIFT                = 0x0000001f;
    constexpr unsigned int SQ_THREAD_TRACE_STATUS__NEW_BUF__SHIFT             = 0x0000001d;
    constexpr unsigned int SQ_THREAD_TRACE_STATUS__UTC_ERROR__SHIFT           = 0x0000001c;
    constexpr unsigned int SQ_THREAD_TRACE_TOKEN_MASK2__INST_MASK__SHIFT      = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_TOKEN_MASK__REG_DROP_ON_STALL__SHIFT = 0x00000018;
    constexpr unsigned int SQ_THREAD_TRACE_TOKEN_MASK__REG_MASK__SHIFT        = 0x00000010;
    constexpr unsigned int SQ_THREAD_TRACE_TOKEN_MASK__TOKEN_MASK__SHIFT      = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_CMN__TIME_DELTA__SHIFT        = 0x00000004;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_CMN__TOKEN_TYPE__SHIFT        = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_EVENT__EVENT_TYPE__SHIFT      = 0x0000000a;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_EVENT__SH_ID__SHIFT           = 0x00000005;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_EVENT__STAGE__SHIFT           = 0x00000006;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_EVENT__TIME_DELTA__SHIFT      = 0x00000004;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_EVENT__TOKEN_TYPE__SHIFT      = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST_PC_1_OF_2__PC_LO__SHIFT  = 0x00000010;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST_PC_1_OF_2__SIMD_ID__SHIFT = 0x00000009;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST_PC_1_OF_2__TIME_DELTA__SHIFT = 0x00000004;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST_PC_1_OF_2__TOKEN_TYPE__SHIFT = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST_PC_1_OF_2__TRAP_ERROR__SHIFT = 0x0000000f;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST_PC_1_OF_2__WAVE_ID__SHIFT = 0x00000005;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST_PC_2_OF_2__PC_HI__SHIFT  = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST_USERDATA_1_OF_2__CU_ID__SHIFT = 0x00000006;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST_USERDATA_1_OF_2__DATA_LO__SHIFT = 0x00000010;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST_USERDATA_1_OF_2__SH_ID__SHIFT = 0x00000005;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST_USERDATA_1_OF_2__SIMD_ID__SHIFT = 0x0000000e;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST_USERDATA_1_OF_2__TIME_DELTA__SHIFT = 0x00000004;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST_USERDATA_1_OF_2__TOKEN_TYPE__SHIFT = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST_USERDATA_1_OF_2__WAVE_ID__SHIFT = 0x0000000a;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST_USERDATA_2_OF_2__DATA_HI__SHIFT = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST__INST_TYPE__SHIFT        = 0x0000000b;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST__SIMD_ID__SHIFT          = 0x00000009;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST__TIME_DELTA__SHIFT       = 0x00000004;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST__TOKEN_TYPE__SHIFT       = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_INST__WAVE_ID__SHIFT          = 0x00000005;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_ISSUE__INST0__SHIFT           = 0x00000008;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_ISSUE__INST1__SHIFT           = 0x0000000a;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_ISSUE__INST2__SHIFT           = 0x0000000c;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_ISSUE__INST3__SHIFT           = 0x0000000e;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_ISSUE__INST4__SHIFT           = 0x00000010;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_ISSUE__INST5__SHIFT           = 0x00000012;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_ISSUE__INST6__SHIFT           = 0x00000014;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_ISSUE__INST7__SHIFT           = 0x00000016;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_ISSUE__INST8__SHIFT           = 0x00000018;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_ISSUE__INST9__SHIFT           = 0x0000001a;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_ISSUE__SIMD_ID__SHIFT         = 0x00000005;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_ISSUE__TIME_DELTA__SHIFT      = 0x00000004;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_ISSUE__TOKEN_TYPE__SHIFT      = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_MISC__MISC_TOKEN_TYPE__SHIFT  = 0x0000000d;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_MISC__SH_ID__SHIFT            = 0x0000000c;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_MISC__TIME_DELTA__SHIFT       = 0x00000004;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_MISC__TOKEN_TYPE__SHIFT       = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_PERF_1_OF_2__CNTR0__SHIFT     = 0x0000000c;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_PERF_1_OF_2__CNTR1_LO__SHIFT  = 0x00000019;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_PERF_1_OF_2__CNTR_BANK__SHIFT = 0x0000000a;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_PERF_1_OF_2__CU_ID__SHIFT     = 0x00000006;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_PERF_1_OF_2__SH_ID__SHIFT     = 0x00000005;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_PERF_1_OF_2__TIME_DELTA__SHIFT = 0x00000004;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_PERF_1_OF_2__TOKEN_TYPE__SHIFT = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_PERF_2_OF_2__CNTR1_HI__SHIFT  = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_PERF_2_OF_2__CNTR2__SHIFT     = 0x00000006;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_PERF_2_OF_2__CNTR3__SHIFT     = 0x00000013;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_1_OF_2__ME_ID__SHIFT      = 0x00000007;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_1_OF_2__PIPE_ID__SHIFT    = 0x00000005;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_1_OF_2__REG_ADDR__SHIFT   = 0x00000010;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_1_OF_2__REG_DROPPED_PREV__SHIFT = 0x00000009;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_1_OF_2__REG_OP__SHIFT     = 0x0000000f;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_1_OF_2__REG_PRIV__SHIFT   = 0x0000000e;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_1_OF_2__REG_TYPE__SHIFT   = 0x0000000a;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_1_OF_2__TIME_DELTA__SHIFT = 0x00000004;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_1_OF_2__TOKEN_TYPE__SHIFT = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_2_OF_2__DATA__SHIFT       = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_CS_1_OF_2__DATA_LO__SHIFT = 0x00000010;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_CS_1_OF_2__ME_ID__SHIFT   = 0x00000007;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_CS_1_OF_2__PIPE_ID__SHIFT = 0x00000005;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_CS_1_OF_2__REG_ADDR__SHIFT = 0x00000009;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_CS_1_OF_2__TIME_DELTA__SHIFT = 0x00000004;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_CS_1_OF_2__TOKEN_TYPE__SHIFT = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_REG_CS_2_OF_2__DATA_HI__SHIFT = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_TIMESTAMP_1_OF_2__TIME_LO__SHIFT = 0x00000010;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_TIMESTAMP_1_OF_2__TOKEN_TYPE__SHIFT = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_TIMESTAMP_2_OF_2__TIME_HI__SHIFT = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE_START__COUNT__SHIFT      = 0x00000016;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE_START__CU_ID__SHIFT      = 0x00000006;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE_START__DISPATCHER__SHIFT = 0x00000010;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE_START__SH_ID__SHIFT      = 0x00000005;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE_START__SIMD_ID__SHIFT    = 0x0000000e;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE_START__TG_ID__SHIFT      = 0x0000001d;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE_START__TIME_DELTA__SHIFT = 0x00000004;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE_START__TOKEN_TYPE__SHIFT = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE_START__VS_NO_ALLOC_OR_GROUPED__SHIFT = 0x00000015;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE_START__WAVE_ID__SHIFT    = 0x0000000a;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE__CU_ID__SHIFT            = 0x00000006;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE__SH_ID__SHIFT            = 0x00000005;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE__SIMD_ID__SHIFT          = 0x0000000e;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE__TIME_DELTA__SHIFT       = 0x00000004;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE__TOKEN_TYPE__SHIFT       = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_WORD_WAVE__WAVE_ID__SHIFT          = 0x0000000a;
    constexpr unsigned int SQ_THREAD_TRACE_WPTR__READ_OFFSET__SHIFT           = 0x0000001e;
    constexpr unsigned int SQ_THREAD_TRACE_WPTR__WPTR__SHIFT                  = 0x00000000;
    constexpr unsigned int SQ_UTCL1_CNTL1__CLIENTID__SHIFT                    = 0x00000007;
    constexpr unsigned int SQ_UTCL1_CNTL1__ENABLE_LFIFO_PRI_ARB__SHIFT        = 0x00000012;
    constexpr unsigned int SQ_UTCL1_CNTL1__ENABLE_PUSH_LFIFO__SHIFT           = 0x00000011;
    constexpr unsigned int SQ_UTCL1_CNTL1__FORCE_4K_L2_RESP__SHIFT            = 0x00000000;
    constexpr unsigned int SQ_UTCL1_CNTL1__FORCE_IN_ORDER__SHIFT              = 0x0000001b;
    constexpr unsigned int SQ_UTCL1_CNTL1__FORCE_MISS__SHIFT                  = 0x0000001a;
    constexpr unsigned int SQ_UTCL1_CNTL1__GPUVM_64K_DEF__SHIFT               = 0x00000001;
    constexpr unsigned int SQ_UTCL1_CNTL1__GPUVM_PERM_MODE__SHIFT             = 0x00000002;
    constexpr unsigned int SQ_UTCL1_CNTL1__REDUCE_CACHE_SIZE_BY_2__SHIFT      = 0x0000001e;
    constexpr unsigned int SQ_UTCL1_CNTL1__REDUCE_FIFO_DEPTH_BY_2__SHIFT      = 0x0000001c;
    constexpr unsigned int SQ_UTCL1_CNTL1__REG_INVALIDATE_ALL_VMID__SHIFT     = 0x00000017;
    constexpr unsigned int SQ_UTCL1_CNTL1__REG_INVALIDATE_ALL__SHIFT          = 0x00000019;
    constexpr unsigned int SQ_UTCL1_CNTL1__REG_INVALIDATE_TOGGLE__SHIFT       = 0x00000018;
    constexpr unsigned int SQ_UTCL1_CNTL1__REG_INVALIDATE_VMID__SHIFT         = 0x00000013;
    constexpr unsigned int SQ_UTCL1_CNTL1__RESP_FAULT_MODE__SHIFT             = 0x00000005;
    constexpr unsigned int SQ_UTCL1_CNTL1__RESP_MODE__SHIFT                   = 0x00000003;
    constexpr unsigned int SQ_UTCL1_CNTL1__USERVM_DIS__SHIFT                  = 0x00000010;
    constexpr unsigned int SQ_UTCL1_CNTL2__DIS_EDC__SHIFT                     = 0x0000000b;
    constexpr unsigned int SQ_UTCL1_CNTL2__FORCE_FRAG_2M_TO_64K__SHIFT        = 0x0000001a;
    constexpr unsigned int SQ_UTCL1_CNTL2__FORCE_GPUVM_INV_ACK__SHIFT         = 0x0000000f;
    constexpr unsigned int SQ_UTCL1_CNTL2__FORCE_SNOOP__SHIFT                 = 0x0000000e;
    constexpr unsigned int SQ_UTCL1_CNTL2__GPUVM_INV_MODE__SHIFT              = 0x0000000c;
    constexpr unsigned int SQ_UTCL1_CNTL2__LFIFO_SCAN_DISABLE__SHIFT          = 0x00000008;
    constexpr unsigned int SQ_UTCL1_CNTL2__LINE_VALID__SHIFT                  = 0x0000000a;
    constexpr unsigned int SQ_UTCL1_CNTL2__MTYPE_OVRD_DIS__SHIFT              = 0x00000009;
    constexpr unsigned int SQ_UTCL1_CNTL2__PREFETCH_PAGE__SHIFT               = 0x0000001c;
    constexpr unsigned int SQ_UTCL1_CNTL2__RETRY_TIMER__SHIFT                 = 0x00000010;
    constexpr unsigned int SQ_UTCL1_CNTL2__SHOOTDOWN_OPT__SHIFT               = 0x0000000d;
    constexpr unsigned int SQ_UTCL1_CNTL2__SPARE__SHIFT                       = 0x00000000;
    constexpr unsigned int SQ_UTCL1_STATUS__FAULT_DETECTED__SHIFT             = 0x00000000;
    constexpr unsigned int SQ_UTCL1_STATUS__PRT_DETECTED__SHIFT               = 0x00000002;
    constexpr unsigned int SQ_UTCL1_STATUS__RESERVED__SHIFT                   = 0x00000003;
    constexpr unsigned int SQ_UTCL1_STATUS__RETRY_DETECTED__SHIFT             = 0x00000001;
    constexpr unsigned int SQ_UTCL1_STATUS__UNUSED__SHIFT                     = 0x00000010;
    constexpr unsigned int SQ_VINTRP__ATTRCHAN__SHIFT                         = 0x00000008;
    constexpr unsigned int SQ_VINTRP__ATTR__SHIFT                             = 0x0000000a;
    constexpr unsigned int SQ_VINTRP__ENCODING__SHIFT                         = 0x0000001a;
    constexpr unsigned int SQ_VINTRP__OP__SHIFT                               = 0x00000010;
    constexpr unsigned int SQ_VINTRP__VDST__SHIFT                             = 0x00000012;
    constexpr unsigned int SQ_VINTRP__VSRC__SHIFT                             = 0x00000000;
    constexpr unsigned int SQ_VOP1__ENCODING__SHIFT                           = 0x00000019;
    constexpr unsigned int SQ_VOP1__OP__SHIFT                                 = 0x00000009;
    constexpr unsigned int SQ_VOP1__SRC0__SHIFT                               = 0x00000000;
    constexpr unsigned int SQ_VOP1__VDST__SHIFT                               = 0x00000011;
    constexpr unsigned int SQ_VOP2__ENCODING__SHIFT                           = 0x0000001f;
    constexpr unsigned int SQ_VOP2__OP__SHIFT                                 = 0x00000019;
    constexpr unsigned int SQ_VOP2__SRC0__SHIFT                               = 0x00000000;
    constexpr unsigned int SQ_VOP2__VDST__SHIFT                               = 0x00000011;
    constexpr unsigned int SQ_VOP2__VSRC1__SHIFT                              = 0x00000009;
    constexpr unsigned int SQ_VOP3P_0__CLAMP__SHIFT                           = 0x0000000f;
    constexpr unsigned int SQ_VOP3P_0__ENCODING__SHIFT                        = 0x00000017;
    constexpr unsigned int SQ_VOP3P_0__NEG_HI__SHIFT                          = 0x00000008;
    constexpr unsigned int SQ_VOP3P_0__OP_SEL_HI_2__SHIFT                     = 0x0000000e;
    constexpr unsigned int SQ_VOP3P_0__OP_SEL__SHIFT                          = 0x0000000b;
    constexpr unsigned int SQ_VOP3P_0__OP__SHIFT                              = 0x00000010;
    constexpr unsigned int SQ_VOP3P_0__VDST__SHIFT                            = 0x00000000;
    constexpr unsigned int SQ_VOP3P_1__NEG__SHIFT                             = 0x0000001d;
    constexpr unsigned int SQ_VOP3P_1__OP_SEL_HI__SHIFT                       = 0x0000001b;
    constexpr unsigned int SQ_VOP3P_1__SRC0__SHIFT                            = 0x00000000;
    constexpr unsigned int SQ_VOP3P_1__SRC1__SHIFT                            = 0x00000009;
    constexpr unsigned int SQ_VOP3P_1__SRC2__SHIFT                            = 0x00000012;
    constexpr unsigned int SQ_VOP3_0_SDST_ENC__CLAMP__SHIFT                   = 0x0000000f;
    constexpr unsigned int SQ_VOP3_0_SDST_ENC__ENCODING__SHIFT                = 0x0000001a;
    constexpr unsigned int SQ_VOP3_0_SDST_ENC__OP__SHIFT                      = 0x00000010;
    constexpr unsigned int SQ_VOP3_0_SDST_ENC__SDST__SHIFT                    = 0x00000008;
    constexpr unsigned int SQ_VOP3_0_SDST_ENC__VDST__SHIFT                    = 0x00000000;
    constexpr unsigned int SQ_VOP3_0__ABS__SHIFT                              = 0x00000008;
    constexpr unsigned int SQ_VOP3_0__CLAMP__SHIFT                            = 0x0000000f;
    constexpr unsigned int SQ_VOP3_0__ENCODING__SHIFT                         = 0x0000001a;
    constexpr unsigned int SQ_VOP3_0__OP_SEL__SHIFT                           = 0x0000000b;
    constexpr unsigned int SQ_VOP3_0__OP__SHIFT                               = 0x00000010;
    constexpr unsigned int SQ_VOP3_0__VDST__SHIFT                             = 0x00000000;
    constexpr unsigned int SQ_VOP3_1__NEG__SHIFT                              = 0x0000001d;
    constexpr unsigned int SQ_VOP3_1__OMOD__SHIFT                             = 0x0000001b;
    constexpr unsigned int SQ_VOP3_1__SRC0__SHIFT                             = 0x00000000;
    constexpr unsigned int SQ_VOP3_1__SRC1__SHIFT                             = 0x00000009;
    constexpr unsigned int SQ_VOP3_1__SRC2__SHIFT                             = 0x00000012;
    constexpr unsigned int SQ_VOPC__ENCODING__SHIFT                           = 0x00000019;
    constexpr unsigned int SQ_VOPC__OP__SHIFT                                 = 0x00000011;
    constexpr unsigned int SQ_VOPC__SRC0__SHIFT                               = 0x00000000;
    constexpr unsigned int SQ_VOPC__VSRC1__SHIFT                              = 0x00000009;
    constexpr unsigned int SQ_VOP_DPP__BANK_MASK__SHIFT                       = 0x00000018;
    constexpr unsigned int SQ_VOP_DPP__BOUND_CTRL__SHIFT                      = 0x00000013;
    constexpr unsigned int SQ_VOP_DPP__DPP_CTRL__SHIFT                        = 0x00000008;
    constexpr unsigned int SQ_VOP_DPP__ROW_MASK__SHIFT                        = 0x0000001c;
    constexpr unsigned int SQ_VOP_DPP__SRC0_ABS__SHIFT                        = 0x00000015;
    constexpr unsigned int SQ_VOP_DPP__SRC0_NEG__SHIFT                        = 0x00000014;
    constexpr unsigned int SQ_VOP_DPP__SRC0__SHIFT                            = 0x00000000;
    constexpr unsigned int SQ_VOP_DPP__SRC1_ABS__SHIFT                        = 0x00000017;
    constexpr unsigned int SQ_VOP_DPP__SRC1_NEG__SHIFT                        = 0x00000016;
    constexpr unsigned int SQ_VOP_SDWA_SDST_ENC__S0__SHIFT                    = 0x00000017;
    constexpr unsigned int SQ_VOP_SDWA_SDST_ENC__S1__SHIFT                    = 0x0000001f;
    constexpr unsigned int SQ_VOP_SDWA_SDST_ENC__SDST__SHIFT                  = 0x00000008;
    constexpr unsigned int SQ_VOP_SDWA_SDST_ENC__SD__SHIFT                    = 0x0000000f;
    constexpr unsigned int SQ_VOP_SDWA_SDST_ENC__SRC0_ABS__SHIFT              = 0x00000015;
    constexpr unsigned int SQ_VOP_SDWA_SDST_ENC__SRC0_NEG__SHIFT              = 0x00000014;
    constexpr unsigned int SQ_VOP_SDWA_SDST_ENC__SRC0_SEL__SHIFT              = 0x00000010;
    constexpr unsigned int SQ_VOP_SDWA_SDST_ENC__SRC0_SEXT__SHIFT             = 0x00000013;
    constexpr unsigned int SQ_VOP_SDWA_SDST_ENC__SRC0__SHIFT                  = 0x00000000;
    constexpr unsigned int SQ_VOP_SDWA_SDST_ENC__SRC1_ABS__SHIFT              = 0x0000001d;
    constexpr unsigned int SQ_VOP_SDWA_SDST_ENC__SRC1_NEG__SHIFT              = 0x0000001c;
    constexpr unsigned int SQ_VOP_SDWA_SDST_ENC__SRC1_SEL__SHIFT              = 0x00000018;
    constexpr unsigned int SQ_VOP_SDWA_SDST_ENC__SRC1_SEXT__SHIFT             = 0x0000001b;
    constexpr unsigned int SQ_VOP_SDWA__CLAMP__SHIFT                          = 0x0000000d;
    constexpr unsigned int SQ_VOP_SDWA__DST_SEL__SHIFT                        = 0x00000008;
    constexpr unsigned int SQ_VOP_SDWA__DST_UNUSED__SHIFT                     = 0x0000000b;
    constexpr unsigned int SQ_VOP_SDWA__OMOD__SHIFT                           = 0x0000000e;
    constexpr unsigned int SQ_VOP_SDWA__S0__SHIFT                             = 0x00000017;
    constexpr unsigned int SQ_VOP_SDWA__S1__SHIFT                             = 0x0000001f;
    constexpr unsigned int SQ_VOP_SDWA__SRC0_ABS__SHIFT                       = 0x00000015;
    constexpr unsigned int SQ_VOP_SDWA__SRC0_NEG__SHIFT                       = 0x00000014;
    constexpr unsigned int SQ_VOP_SDWA__SRC0_SEL__SHIFT                       = 0x00000010;
    constexpr unsigned int SQ_VOP_SDWA__SRC0_SEXT__SHIFT                      = 0x00000013;
    constexpr unsigned int SQ_VOP_SDWA__SRC0__SHIFT                           = 0x00000000;
    constexpr unsigned int SQ_VOP_SDWA__SRC1_ABS__SHIFT                       = 0x0000001d;
    constexpr unsigned int SQ_VOP_SDWA__SRC1_NEG__SHIFT                       = 0x0000001c;
    constexpr unsigned int SQ_VOP_SDWA__SRC1_SEL__SHIFT                       = 0x00000018;
    constexpr unsigned int SQ_VOP_SDWA__SRC1_SEXT__SHIFT                      = 0x0000001b;
    constexpr unsigned int SQ_WAVE_HW_ID__CU_ID__SHIFT                        = 0x00000008;
    constexpr unsigned int SQ_WAVE_HW_ID__ME_ID__SHIFT                        = 0x0000001e;
    constexpr unsigned int SQ_WAVE_HW_ID__PIPE_ID__SHIFT                      = 0x00000006;
    constexpr unsigned int SQ_WAVE_HW_ID__QUEUE_ID__SHIFT                     = 0x00000018;
    constexpr unsigned int SQ_WAVE_HW_ID__SE_ID__SHIFT                        = 0x0000000d;
    constexpr unsigned int SQ_WAVE_HW_ID__SH_ID__SHIFT                        = 0x0000000c;
    constexpr unsigned int SQ_WAVE_HW_ID__SIMD_ID__SHIFT                      = 0x00000004;
    constexpr unsigned int SQ_WAVE_HW_ID__STATE_ID__SHIFT                     = 0x0000001b;
    constexpr unsigned int SQ_WAVE_HW_ID__TG_ID__SHIFT                        = 0x00000010;
    constexpr unsigned int SQ_WAVE_HW_ID__VM_ID__SHIFT                        = 0x00000014;
    constexpr unsigned int SQ_WAVE_HW_ID__WAVE_ID__SHIFT                      = 0x00000000;
    constexpr unsigned int SQ_WAVE_IB_STS__FIRST_REPLAY__SHIFT                = 0x0000000f;
    constexpr unsigned int SQ_WAVE_IB_STS__RCNT__SHIFT                        = 0x00000010;
    constexpr unsigned int SQ_WAVE_INST_DW1__INST_DW1__SHIFT                  = 0x00000000;
    constexpr unsigned int SQ_WAVE_MODE__CSP__SHIFT                           = 0x0000001d;
    constexpr unsigned int SQ_WAVE_MODE__DISABLE_PERF__SHIFT                  = 0x0000001a;
    constexpr unsigned int SQ_WAVE_MODE__GPR_IDX_EN__SHIFT                    = 0x0000001b;
    constexpr unsigned int SQ_WAVE_MODE__POPS_PACKER0__SHIFT                  = 0x00000018;
    constexpr unsigned int SQ_WAVE_MODE__POPS_PACKER1__SHIFT                  = 0x00000019;
    constexpr unsigned int SQ_WAVE_MODE__VSKIP__SHIFT                         = 0x0000001c;
    constexpr unsigned int SQ_WAVE_STATUS__ALLOW_REPLAY__SHIFT                = 0x00000016;
    constexpr unsigned int SQ_WAVE_STATUS__TTRACE_CU_EN__SHIFT                = 0x0000000f;
    constexpr unsigned int SQ_WAVE_TRAPSTS__XNACK_ERROR__SHIFT                = 0x0000001c;
    constexpr unsigned int SQ_WREXEC_EXEC_HI__ATC__SHIFT                      = 0x0000001b;
    constexpr unsigned int TA_CNTL_AUX__ANISO_MIP_ADJ_MODE__SHIFT             = 0x00000013;
    constexpr unsigned int TA_CNTL_AUX__NONIMG_ANISO_BYPASS__SHIFT            = 0x00000009;
    constexpr unsigned int TA_CNTL_AUX__RESERVED__SHIFT                       = 0x00000001;
    constexpr unsigned int TA_CNTL__FX_XNACK_CREDIT__SHIFT                    = 0x00000000;
    constexpr unsigned int TA_CNTL__SQ_XNACK_CREDIT__SHIFT                    = 0x00000009;
    constexpr unsigned int TA_CNTL__TC_DATA_CREDIT__SHIFT                     = 0x0000000d;
    constexpr unsigned int TCA_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
    constexpr unsigned int TCA_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
    constexpr unsigned int TCA_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT        = 0x00000018;
    constexpr unsigned int TCA_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT        = 0x0000001c;
    constexpr unsigned int TCA_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
    constexpr unsigned int TCA_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
    constexpr unsigned int TCA_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
    constexpr unsigned int TCA_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT         = 0x00000018;
    constexpr unsigned int TCA_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
    constexpr unsigned int TCA_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
    constexpr unsigned int TCA_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT           = 0x00000000;
    constexpr unsigned int TCA_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
    constexpr unsigned int TCA_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
    constexpr unsigned int TCA_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT        = 0x00000018;
    constexpr unsigned int TCA_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT        = 0x0000001c;
    constexpr unsigned int TCA_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
    constexpr unsigned int TCA_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
    constexpr unsigned int TCA_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
    constexpr unsigned int TCA_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT         = 0x00000018;
    constexpr unsigned int TCA_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
    constexpr unsigned int TCA_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
    constexpr unsigned int TCA_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT           = 0x00000000;
    constexpr unsigned int TCA_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
    constexpr unsigned int TCA_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
    constexpr unsigned int TCA_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
    constexpr unsigned int TCA_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
    constexpr unsigned int TCA_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT           = 0x00000000;
    constexpr unsigned int TCA_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
    constexpr unsigned int TCA_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
    constexpr unsigned int TCA_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
    constexpr unsigned int TCA_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
    constexpr unsigned int TCA_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT           = 0x00000000;
    constexpr unsigned int TCC_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
    constexpr unsigned int TCC_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
    constexpr unsigned int TCC_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT        = 0x00000018;
    constexpr unsigned int TCC_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT        = 0x0000001c;
    constexpr unsigned int TCC_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
    constexpr unsigned int TCC_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
    constexpr unsigned int TCC_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
    constexpr unsigned int TCC_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT         = 0x00000018;
    constexpr unsigned int TCC_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
    constexpr unsigned int TCC_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
    constexpr unsigned int TCC_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT           = 0x00000000;
    constexpr unsigned int TCC_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
    constexpr unsigned int TCC_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
    constexpr unsigned int TCC_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT        = 0x00000018;
    constexpr unsigned int TCC_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT        = 0x0000001c;
    constexpr unsigned int TCC_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
    constexpr unsigned int TCC_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
    constexpr unsigned int TCC_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
    constexpr unsigned int TCC_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT         = 0x00000018;
    constexpr unsigned int TCC_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
    constexpr unsigned int TCC_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
    constexpr unsigned int TCC_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT           = 0x00000000;
    constexpr unsigned int TCC_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
    constexpr unsigned int TCC_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
    constexpr unsigned int TCC_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
    constexpr unsigned int TCC_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
    constexpr unsigned int TCC_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT           = 0x00000000;
    constexpr unsigned int TCC_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
    constexpr unsigned int TCC_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
    constexpr unsigned int TCC_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
    constexpr unsigned int TCC_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
    constexpr unsigned int TCC_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT           = 0x00000000;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__ADDR_MODE__SHIFT        = 0x0000000b;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__COMPRESSION_ENABLE__SHIFT = 0x0000000a;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__GLC__SHIFT              = 0x00000008;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__SLC__SHIFT              = 0x00000009;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__ADDR_MODE__SHIFT           = 0x0000001c;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__COMPRESSION_ENABLE__SHIFT  = 0x0000001b;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__GLC__SHIFT                 = 0x00000019;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__NUM_FORMAT__SHIFT          = 0x0000000b;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__NUM_SAMPLES__SHIFT         = 0x00000014;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__OPCODE_TYPE__SHIFT         = 0x00000016;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__SLC__SHIFT                 = 0x0000001a;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__SW_MODE__SHIFT             = 0x0000000f;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_BUSY__SHIFT                   = 0x00000000;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_GS_BUSY__SHIFT                = 0x00000007;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_HS_BUSY__SHIFT                = 0x00000008;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_OUT_BUSY__SHIFT               = 0x00000002;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_OUT_INDX_BUSY__SHIFT          = 0x00000001;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_PI_BUSY__SHIFT                = 0x00000006;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_PRIMGEN_BUSY__SHIFT           = 0x0000000a;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_PT_BUSY__SHIFT                = 0x00000003;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_TE11_BUSY__SHIFT              = 0x00000009;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_TE_BUSY__SHIFT                = 0x00000004;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_VR_BUSY__SHIFT                = 0x00000005;
    constexpr unsigned int VGT_DISPATCH_DRAW_INDEX__MATCH_INDEX__SHIFT        = 0x00000000;
    constexpr unsigned int VGT_DMA_CONTROL__EN_INST_OPT_ADV__SHIFT            = 0x00000016;
    constexpr unsigned int VGT_DMA_CONTROL__EN_INST_OPT_BASIC__SHIFT          = 0x00000015;
    constexpr unsigned int VGT_DMA_CONTROL__HW_USE_ONLY__SHIFT                = 0x00000017;
    constexpr unsigned int VGT_DMA_DATA_FIFO_DEPTH__DMA2DRAW_FIFO_DEPTH__SHIFT = 0x00000009;
    constexpr unsigned int VGT_DMA_INDEX_TYPE__PRIMGEN_EN__SHIFT              = 0x00000008;
    constexpr unsigned int VGT_DRAW_INITIATOR__GRBM_SKEW_NO_DEC__SHIFT        = 0x00000008;
    constexpr unsigned int VGT_DRAW_INITIATOR__UNROLLED_INST__SHIFT           = 0x00000007;
    constexpr unsigned int VGT_FIFO_DEPTHS__HSINPUT_FIFO_DEPTH__SHIFT         = 0x00000016;
    constexpr unsigned int VGT_GS_MAX_PRIMS_PER_SUBGROUP__MAX_PRIMS_PER_SUBGROUP__SHIFT = 0x00000000;
    constexpr unsigned int VGT_GS_MODE__RESERVED_3__SHIFT                     = 0x0000000e;
    constexpr unsigned int VGT_GS_MODE__RESERVED_4__SHIFT                     = 0x0000000f;
    constexpr unsigned int VGT_GS_MODE__RESERVED_5__SHIFT                     = 0x00000010;
    constexpr unsigned int VGT_HS_OFFCHIP_PARAM__OFFCHIP_GRANULARITY__SHIFT   = 0x00000009;
    constexpr unsigned int VGT_INDEX_TYPE__PRIMGEN_EN__SHIFT                  = 0x00000008;
    constexpr unsigned int VGT_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
    constexpr unsigned int VGT_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
    constexpr unsigned int VGT_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT        = 0x0000001c;
    constexpr unsigned int VGT_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT        = 0x00000018;
    constexpr unsigned int VGT_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
    constexpr unsigned int VGT_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
    constexpr unsigned int VGT_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
    constexpr unsigned int VGT_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT         = 0x00000018;
    constexpr unsigned int VGT_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
    constexpr unsigned int VGT_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
    constexpr unsigned int VGT_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT           = 0x00000000;
    constexpr unsigned int VGT_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
    constexpr unsigned int VGT_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
    constexpr unsigned int VGT_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT        = 0x0000001c;
    constexpr unsigned int VGT_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT        = 0x00000018;
    constexpr unsigned int VGT_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
    constexpr unsigned int VGT_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
    constexpr unsigned int VGT_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
    constexpr unsigned int VGT_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT         = 0x00000018;
    constexpr unsigned int VGT_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
    constexpr unsigned int VGT_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
    constexpr unsigned int VGT_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT           = 0x00000000;
    constexpr unsigned int VGT_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
    constexpr unsigned int VGT_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
    constexpr unsigned int VGT_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
    constexpr unsigned int VGT_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT           = 0x00000000;
    constexpr unsigned int VGT_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
    constexpr unsigned int VGT_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
    constexpr unsigned int VGT_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
    constexpr unsigned int VGT_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT           = 0x00000000;
    constexpr unsigned int VGT_PERFCOUNTER_SEID_MASK__PERF_SEID_IGNORE_MASK__SHIFT = 0x00000000;
    constexpr unsigned int VGT_SHADER_STAGES_EN__DISPATCH_DRAW_EN__SHIFT      = 0x00000009;
    constexpr unsigned int VGT_SHADER_STAGES_EN__DIS_DEALLOC_ACCUM_0__SHIFT   = 0x0000000a;
    constexpr unsigned int VGT_SHADER_STAGES_EN__DIS_DEALLOC_ACCUM_1__SHIFT   = 0x0000000b;
    constexpr unsigned int WD_CNTL_STATUS__WD_ADC_BUSY__SHIFT                 = 0x00000003;
    constexpr unsigned int WD_CNTL_STATUS__WD_BUSY__SHIFT                     = 0x00000000;
    constexpr unsigned int WD_CNTL_STATUS__WD_SPL_DI_BUSY__SHIFT              = 0x00000002;
    constexpr unsigned int WD_CNTL_STATUS__WD_SPL_DMA_BUSY__SHIFT             = 0x00000001;
    constexpr unsigned int WD_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
    constexpr unsigned int WD_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
    constexpr unsigned int WD_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
    constexpr unsigned int WD_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT            = 0x00000000;
    constexpr unsigned int WD_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
    constexpr unsigned int WD_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
    constexpr unsigned int WD_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
    constexpr unsigned int WD_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT            = 0x00000000;
    constexpr unsigned int WD_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
    constexpr unsigned int WD_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
    constexpr unsigned int WD_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
    constexpr unsigned int WD_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT            = 0x00000000;
    constexpr unsigned int WD_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
    constexpr unsigned int WD_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
    constexpr unsigned int WD_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
    constexpr unsigned int WD_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT            = 0x00000000;
    constexpr unsigned int WD_UTCL1_CNTL__FORCE_SD_VMID_DIRTY__SHIFT          = 0x0000001d;
} // namespace Gfx09

namespace Gfx09_0
{
    constexpr unsigned int GDS_PERFCOUNTER0_SELECT1__PERFCOUNTER_SELECT2__SHIFT = 0x00000000;
    constexpr unsigned int GDS_PERFCOUNTER0_SELECT1__PERFCOUNTER_SELECT3__SHIFT = 0x0000000a;
    constexpr unsigned int GDS_PERFCOUNTER0_SELECT__PERFCOUNTER_SELECT1__SHIFT = 0x0000000a;
    constexpr unsigned int GDS_PERFCOUNTER0_SELECT__PERFCOUNTER_SELECT__SHIFT = 0x00000000;
    constexpr unsigned int GDS_PERFCOUNTER1_SELECT__PERFCOUNTER_SELECT1__SHIFT = 0x0000000a;
    constexpr unsigned int GDS_PERFCOUNTER1_SELECT__PERFCOUNTER_SELECT__SHIFT = 0x00000000;
    constexpr unsigned int GDS_PERFCOUNTER2_SELECT__PERFCOUNTER_SELECT1__SHIFT = 0x0000000a;
    constexpr unsigned int GDS_PERFCOUNTER2_SELECT__PERFCOUNTER_SELECT__SHIFT = 0x00000000;
    constexpr unsigned int GDS_PERFCOUNTER3_SELECT__PERFCOUNTER_SELECT1__SHIFT = 0x0000000a;
    constexpr unsigned int GDS_PERFCOUNTER3_SELECT__PERFCOUNTER_SELECT__SHIFT = 0x00000000;
    constexpr unsigned int PA_SC_ENHANCE_1__RSVD__SHIFT                       = 0x00000017;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT1__PERFCOUNTER_SELECT2__SHIFT = 0x00000000;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT1__PERFCOUNTER_SELECT3__SHIFT = 0x0000000a;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT__PERFCOUNTER_SELECT1__SHIFT = 0x0000000a;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT__PERFCOUNTER_SELECT__SHIFT  = 0x00000000;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT1__PERFCOUNTER_SELECT2__SHIFT = 0x00000000;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT1__PERFCOUNTER_SELECT3__SHIFT = 0x0000000a;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT__PERFCOUNTER_SELECT1__SHIFT = 0x0000000a;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT__PERFCOUNTER_SELECT__SHIFT  = 0x00000000;
    constexpr unsigned int SX_PERFCOUNTER2_SELECT__PERFCOUNTER_SELECT1__SHIFT = 0x0000000a;
    constexpr unsigned int SX_PERFCOUNTER2_SELECT__PERFCOUNTER_SELECT__SHIFT  = 0x00000000;
    constexpr unsigned int SX_PERFCOUNTER3_SELECT__PERFCOUNTER_SELECT1__SHIFT = 0x0000000a;
    constexpr unsigned int SX_PERFCOUNTER3_SELECT__PERFCOUNTER_SELECT__SHIFT  = 0x00000000;
    constexpr unsigned int TA_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT          = 0x00000018;
    constexpr unsigned int TA_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT           = 0x0000000a;
    constexpr unsigned int TD_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT          = 0x00000018;
    constexpr unsigned int TD_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT           = 0x0000000a;
} // namespace Gfx09_0

namespace Gfx09_1x
{
    constexpr unsigned int PA_SC_ENHANCE_1__RSVD__SHIFT                       = 0x0000001f;
    constexpr unsigned int RLC_SPM_PERFMON_SAMPLE_DELAY_MAX__PERFMON_MAX_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_PERFMON_SAMPLE_DELAY_MAX__RESERVED__SHIFT  = 0x00000008;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT         = 0x0000001c;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT         = 0x00000018;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT          = 0x00000000;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT          = 0x0000000a;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT          = 0x00000018;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT           = 0x0000000a;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT            = 0x00000000;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT         = 0x0000001c;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT         = 0x00000018;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT          = 0x00000000;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT          = 0x0000000a;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT          = 0x00000018;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT           = 0x0000000a;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT            = 0x00000000;
    constexpr unsigned int SX_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
    constexpr unsigned int SX_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT            = 0x00000000;
    constexpr unsigned int SX_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
    constexpr unsigned int SX_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT            = 0x00000000;
} // namespace Gfx09_1x

namespace Gfx09_1xPlus
{
    constexpr unsigned int CB_COLOR0_DCC_CONTROL__DISABLE_CONSTANT_ENCODE_REG__SHIFT = 0x00000012;
    constexpr unsigned int CB_COLOR0_DCC_CONTROL__ENABLE_CONSTANT_ENCODE_REG_WRITE__SHIFT = 0x00000013;
    constexpr unsigned int CB_COLOR1_DCC_CONTROL__DISABLE_CONSTANT_ENCODE_REG__SHIFT = 0x00000012;
    constexpr unsigned int CB_COLOR1_DCC_CONTROL__ENABLE_CONSTANT_ENCODE_REG_WRITE__SHIFT = 0x00000013;
    constexpr unsigned int CB_COLOR2_DCC_CONTROL__DISABLE_CONSTANT_ENCODE_REG__SHIFT = 0x00000012;
    constexpr unsigned int CB_COLOR2_DCC_CONTROL__ENABLE_CONSTANT_ENCODE_REG_WRITE__SHIFT = 0x00000013;
    constexpr unsigned int CB_COLOR3_DCC_CONTROL__DISABLE_CONSTANT_ENCODE_REG__SHIFT = 0x00000012;
    constexpr unsigned int CB_COLOR3_DCC_CONTROL__ENABLE_CONSTANT_ENCODE_REG_WRITE__SHIFT = 0x00000013;
    constexpr unsigned int CB_COLOR4_DCC_CONTROL__DISABLE_CONSTANT_ENCODE_REG__SHIFT = 0x00000012;
    constexpr unsigned int CB_COLOR4_DCC_CONTROL__ENABLE_CONSTANT_ENCODE_REG_WRITE__SHIFT = 0x00000013;
    constexpr unsigned int CB_COLOR5_DCC_CONTROL__DISABLE_CONSTANT_ENCODE_REG__SHIFT = 0x00000012;
    constexpr unsigned int CB_COLOR5_DCC_CONTROL__ENABLE_CONSTANT_ENCODE_REG_WRITE__SHIFT = 0x00000013;
    constexpr unsigned int CB_COLOR6_DCC_CONTROL__DISABLE_CONSTANT_ENCODE_REG__SHIFT = 0x00000012;
    constexpr unsigned int CB_COLOR6_DCC_CONTROL__ENABLE_CONSTANT_ENCODE_REG_WRITE__SHIFT = 0x00000013;
    constexpr unsigned int CB_COLOR7_DCC_CONTROL__DISABLE_CONSTANT_ENCODE_REG__SHIFT = 0x00000012;
    constexpr unsigned int CB_COLOR7_DCC_CONTROL__ENABLE_CONSTANT_ENCODE_REG_WRITE__SHIFT = 0x00000013;
    constexpr unsigned int CB_DCC_CONFIG__DISABLE_CONSTANT_ENCODE__SHIFT      = 0x00000007;
    constexpr unsigned int CB_DCC_CONTROL__DISABLE_CONSTANT_ENCODE_AC01__SHIFT = 0x00000008;
    constexpr unsigned int CB_DCC_CONTROL__DISABLE_CONSTANT_ENCODE_REG__SHIFT = 0x0000000a;
    constexpr unsigned int CB_DCC_CONTROL__DISABLE_CONSTANT_ENCODE_SINGLE__SHIFT = 0x00000009;
    constexpr unsigned int CB_DCC_CONTROL__DISABLE_ELIMFC_SKIP_OF_AC01__SHIFT = 0x0000000c;
    constexpr unsigned int CB_DCC_CONTROL__DISABLE_ELIMFC_SKIP_OF_SINGLE__SHIFT = 0x0000000d;
    constexpr unsigned int CB_DCC_CONTROL__ENABLE_ELIMFC_SKIP_OF_REG__SHIFT   = 0x0000000e;
    constexpr unsigned int COMPUTE_DISPATCH_END__DATA__SHIFT                  = 0x00000000;
    constexpr unsigned int COMPUTE_SHADER_CHKSUM__CHECKSUM__SHIFT             = 0x00000000;
    constexpr unsigned int GDS_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT        = 0x0000001c;
    constexpr unsigned int GDS_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT        = 0x00000018;
    constexpr unsigned int GDS_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
    constexpr unsigned int GDS_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
    constexpr unsigned int GDS_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT         = 0x00000018;
    constexpr unsigned int GDS_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
    constexpr unsigned int GDS_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
    constexpr unsigned int GDS_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT           = 0x00000000;
    constexpr unsigned int GDS_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT         = 0x00000018;
    constexpr unsigned int GDS_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
    constexpr unsigned int GDS_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
    constexpr unsigned int GDS_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT           = 0x00000000;
    constexpr unsigned int GDS_PERFCOUNTER2_SELECT__PERF_MODE1__SHIFT         = 0x00000018;
    constexpr unsigned int GDS_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
    constexpr unsigned int GDS_PERFCOUNTER2_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
    constexpr unsigned int GDS_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT           = 0x00000000;
    constexpr unsigned int GDS_PERFCOUNTER3_SELECT__PERF_MODE1__SHIFT         = 0x00000018;
    constexpr unsigned int GDS_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
    constexpr unsigned int GDS_PERFCOUNTER3_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
    constexpr unsigned int GDS_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT           = 0x00000000;
    constexpr unsigned int PA_CL_CLIP_CNTL__ZCLIP_PROG_NEAR_ENA__SHIFT        = 0x0000001c;
    constexpr unsigned int PA_CL_ENHANCE__NO_SWITCH_TO_LEGACY_AFTER_VMID_RESET__SHIFT = 0x00000013;
    constexpr unsigned int PA_CL_ENHANCE__OUTPUT_SWITCH_TO_LEGACY_EVENT__SHIFT = 0x00000012;
    constexpr unsigned int PA_CL_ENHANCE__POLY_INNER_EDGE_FLAG_DISABLE__SHIFT = 0x00000014;
    constexpr unsigned int PA_CL_ENHANCE__PROG_NEAR_CLIP_PLANE_ENABLE__SHIFT  = 0x00000011;
    constexpr unsigned int PA_CL_ENHANCE__TC_REQUEST_PERF_CNTR_ENABLE__SHIFT  = 0x00000015;
    constexpr unsigned int PA_CL_PROG_NEAR_CLIP_Z__DATA_REGISTER__SHIFT       = 0x00000000;
    constexpr unsigned int PA_SC_BINNER_CNTL_0__FLUSH_ON_BINNING_TRANSITION__SHIFT = 0x0000001c;
    constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_INTF_CG__SHIFT            = 0x00000017;
    constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_QUAD_PROC_FDCE_ENHANCE__SHIFT = 0x0000001b;
    constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_SC_PS_PA_ARBITER_FIX_1__SHIFT = 0x0000001d;
    constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_SC_PS_PA_ARBITER_FIX__SHIFT = 0x0000001c;
    constexpr unsigned int PA_SC_ENHANCE_1__DISABLE_SHADER_PROFILING_FOR_POWER__SHIFT = 0x00000019;
    constexpr unsigned int PA_SC_ENHANCE_1__FLUSH_ON_BINNING_TRANSITION__SHIFT = 0x0000001a;
    constexpr unsigned int PA_SC_ENHANCE_1__IOO_DISABLE_EOP_ON_FIRST_LIVE_PRIM_HIT__SHIFT = 0x00000018;
    constexpr unsigned int PA_SC_ENHANCE_1__PASS_VPZ_EVENT_TO_SPI__SHIFT      = 0x0000001e;
    constexpr unsigned int PA_SC_LINE_CNTL__EXTRA_DX_DY_PRECISION__SHIFT      = 0x0000000d;
    constexpr unsigned int PA_SC_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT      = 0x0000001c;
    constexpr unsigned int PA_SC_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT      = 0x00000018;
    constexpr unsigned int PA_SC_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT       = 0x00000018;
    constexpr unsigned int PA_SC_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT        = 0x0000001c;
    constexpr unsigned int PA_SU_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT      = 0x0000001c;
    constexpr unsigned int PA_SU_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT      = 0x00000018;
    constexpr unsigned int PA_SU_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT       = 0x00000018;
    constexpr unsigned int PA_SU_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT        = 0x0000001c;
    constexpr unsigned int PA_SU_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT      = 0x0000001c;
    constexpr unsigned int PA_SU_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT      = 0x00000018;
    constexpr unsigned int PA_SU_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT       = 0x00000018;
    constexpr unsigned int PA_SU_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT        = 0x0000001c;
    constexpr unsigned int PA_SU_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT        = 0x0000001c;
    constexpr unsigned int PA_SU_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT        = 0x0000001c;
    constexpr unsigned int PA_SU_SMALL_PRIM_FILTER_CNTL__SC_1XMSAA_COMPATIBLE_DISABLE__SHIFT = 0x00000006;
    constexpr unsigned int SPI_WAVE_LIMIT_CNTL__GS_WAVE_GRAN__SHIFT           = 0x00000004;
    constexpr unsigned int SPI_WAVE_LIMIT_CNTL__HS_WAVE_GRAN__SHIFT           = 0x00000006;
    constexpr unsigned int SPI_WAVE_LIMIT_CNTL__PS_WAVE_GRAN__SHIFT           = 0x00000000;
    constexpr unsigned int SPI_WAVE_LIMIT_CNTL__VS_WAVE_GRAN__SHIFT           = 0x00000002;
} // namespace Gfx09_1xPlus

namespace Gfx10
{
    constexpr unsigned int CB_CACHE_EVICT_POINTS__CC_CACHE_EVICT_POINT__SHIFT = 0x00000018;
    constexpr unsigned int CB_CACHE_EVICT_POINTS__CM_CACHE_EVICT_POINT__SHIFT = 0x00000000;
    constexpr unsigned int CB_CACHE_EVICT_POINTS__DCC_CACHE_EVICT_POINT__SHIFT = 0x00000010;
    constexpr unsigned int CB_CACHE_EVICT_POINTS__FC_CACHE_EVICT_POINT__SHIFT = 0x00000008;
    constexpr unsigned int CB_COLOR0_ATTRIB3__CMASK_PIPE_ALIGNED__SHIFT       = 0x0000001a;
    constexpr unsigned int CB_COLOR0_ATTRIB3__COLOR_SW_MODE__SHIFT            = 0x0000000e;
    constexpr unsigned int CB_COLOR0_ATTRIB3__DCC_PIPE_ALIGNED__SHIFT         = 0x0000001e;
    constexpr unsigned int CB_COLOR0_ATTRIB3__FMASK_SW_MODE__SHIFT            = 0x00000013;
    constexpr unsigned int CB_COLOR0_ATTRIB3__META_LINEAR__SHIFT              = 0x0000000d;
    constexpr unsigned int CB_COLOR0_ATTRIB3__MIP0_DEPTH__SHIFT               = 0x00000000;
    constexpr unsigned int CB_COLOR0_ATTRIB3__RESOURCE_TYPE__SHIFT            = 0x00000018;
    constexpr unsigned int CB_COLOR0_DCC_CONTROL__INDEPENDENT_128B_BLOCKS__SHIFT = 0x00000014;
    constexpr unsigned int CB_COLOR0_INFO__LINEAR_GENERAL__SHIFT              = 0x00000007;
    constexpr unsigned int CB_COLOR0_VIEW__MIP_LEVEL__SHIFT                   = 0x0000001a;
    constexpr unsigned int CB_COLOR1_ATTRIB3__CMASK_PIPE_ALIGNED__SHIFT       = 0x0000001a;
    constexpr unsigned int CB_COLOR1_ATTRIB3__COLOR_SW_MODE__SHIFT            = 0x0000000e;
    constexpr unsigned int CB_COLOR1_ATTRIB3__DCC_PIPE_ALIGNED__SHIFT         = 0x0000001e;
    constexpr unsigned int CB_COLOR1_ATTRIB3__FMASK_SW_MODE__SHIFT            = 0x00000013;
    constexpr unsigned int CB_COLOR1_ATTRIB3__META_LINEAR__SHIFT              = 0x0000000d;
    constexpr unsigned int CB_COLOR1_ATTRIB3__MIP0_DEPTH__SHIFT               = 0x00000000;
    constexpr unsigned int CB_COLOR1_ATTRIB3__RESOURCE_TYPE__SHIFT            = 0x00000018;
    constexpr unsigned int CB_COLOR1_DCC_CONTROL__INDEPENDENT_128B_BLOCKS__SHIFT = 0x00000014;
    constexpr unsigned int CB_COLOR1_INFO__LINEAR_GENERAL__SHIFT              = 0x00000007;
    constexpr unsigned int CB_COLOR1_VIEW__MIP_LEVEL__SHIFT                   = 0x0000001a;
    constexpr unsigned int CB_COLOR2_ATTRIB3__CMASK_PIPE_ALIGNED__SHIFT       = 0x0000001a;
    constexpr unsigned int CB_COLOR2_ATTRIB3__COLOR_SW_MODE__SHIFT            = 0x0000000e;
    constexpr unsigned int CB_COLOR2_ATTRIB3__DCC_PIPE_ALIGNED__SHIFT         = 0x0000001e;
    constexpr unsigned int CB_COLOR2_ATTRIB3__FMASK_SW_MODE__SHIFT            = 0x00000013;
    constexpr unsigned int CB_COLOR2_ATTRIB3__META_LINEAR__SHIFT              = 0x0000000d;
    constexpr unsigned int CB_COLOR2_ATTRIB3__MIP0_DEPTH__SHIFT               = 0x00000000;
    constexpr unsigned int CB_COLOR2_ATTRIB3__RESOURCE_TYPE__SHIFT            = 0x00000018;
    constexpr unsigned int CB_COLOR2_DCC_CONTROL__INDEPENDENT_128B_BLOCKS__SHIFT = 0x00000014;
    constexpr unsigned int CB_COLOR2_INFO__LINEAR_GENERAL__SHIFT              = 0x00000007;
    constexpr unsigned int CB_COLOR2_VIEW__MIP_LEVEL__SHIFT                   = 0x0000001a;
    constexpr unsigned int CB_COLOR3_ATTRIB3__CMASK_PIPE_ALIGNED__SHIFT       = 0x0000001a;
    constexpr unsigned int CB_COLOR3_ATTRIB3__COLOR_SW_MODE__SHIFT            = 0x0000000e;
    constexpr unsigned int CB_COLOR3_ATTRIB3__DCC_PIPE_ALIGNED__SHIFT         = 0x0000001e;
    constexpr unsigned int CB_COLOR3_ATTRIB3__FMASK_SW_MODE__SHIFT            = 0x00000013;
    constexpr unsigned int CB_COLOR3_ATTRIB3__META_LINEAR__SHIFT              = 0x0000000d;
    constexpr unsigned int CB_COLOR3_ATTRIB3__MIP0_DEPTH__SHIFT               = 0x00000000;
    constexpr unsigned int CB_COLOR3_ATTRIB3__RESOURCE_TYPE__SHIFT            = 0x00000018;
    constexpr unsigned int CB_COLOR3_DCC_CONTROL__INDEPENDENT_128B_BLOCKS__SHIFT = 0x00000014;
    constexpr unsigned int CB_COLOR3_INFO__LINEAR_GENERAL__SHIFT              = 0x00000007;
    constexpr unsigned int CB_COLOR3_VIEW__MIP_LEVEL__SHIFT                   = 0x0000001a;
    constexpr unsigned int CB_COLOR4_ATTRIB3__CMASK_PIPE_ALIGNED__SHIFT       = 0x0000001a;
    constexpr unsigned int CB_COLOR4_ATTRIB3__COLOR_SW_MODE__SHIFT            = 0x0000000e;
    constexpr unsigned int CB_COLOR4_ATTRIB3__DCC_PIPE_ALIGNED__SHIFT         = 0x0000001e;
    constexpr unsigned int CB_COLOR4_ATTRIB3__FMASK_SW_MODE__SHIFT            = 0x00000013;
    constexpr unsigned int CB_COLOR4_ATTRIB3__META_LINEAR__SHIFT              = 0x0000000d;
    constexpr unsigned int CB_COLOR4_ATTRIB3__MIP0_DEPTH__SHIFT               = 0x00000000;
    constexpr unsigned int CB_COLOR4_ATTRIB3__RESOURCE_TYPE__SHIFT            = 0x00000018;
    constexpr unsigned int CB_COLOR4_DCC_CONTROL__INDEPENDENT_128B_BLOCKS__SHIFT = 0x00000014;
    constexpr unsigned int CB_COLOR4_INFO__LINEAR_GENERAL__SHIFT              = 0x00000007;
    constexpr unsigned int CB_COLOR4_VIEW__MIP_LEVEL__SHIFT                   = 0x0000001a;
    constexpr unsigned int CB_COLOR5_ATTRIB3__CMASK_PIPE_ALIGNED__SHIFT       = 0x0000001a;
    constexpr unsigned int CB_COLOR5_ATTRIB3__COLOR_SW_MODE__SHIFT            = 0x0000000e;
    constexpr unsigned int CB_COLOR5_ATTRIB3__DCC_PIPE_ALIGNED__SHIFT         = 0x0000001e;
    constexpr unsigned int CB_COLOR5_ATTRIB3__FMASK_SW_MODE__SHIFT            = 0x00000013;
    constexpr unsigned int CB_COLOR5_ATTRIB3__META_LINEAR__SHIFT              = 0x0000000d;
    constexpr unsigned int CB_COLOR5_ATTRIB3__MIP0_DEPTH__SHIFT               = 0x00000000;
    constexpr unsigned int CB_COLOR5_ATTRIB3__RESOURCE_TYPE__SHIFT            = 0x00000018;
    constexpr unsigned int CB_COLOR5_DCC_CONTROL__INDEPENDENT_128B_BLOCKS__SHIFT = 0x00000014;
    constexpr unsigned int CB_COLOR5_INFO__LINEAR_GENERAL__SHIFT              = 0x00000007;
    constexpr unsigned int CB_COLOR5_VIEW__MIP_LEVEL__SHIFT                   = 0x0000001a;
    constexpr unsigned int CB_COLOR6_ATTRIB3__CMASK_PIPE_ALIGNED__SHIFT       = 0x0000001a;
    constexpr unsigned int CB_COLOR6_ATTRIB3__COLOR_SW_MODE__SHIFT            = 0x0000000e;
    constexpr unsigned int CB_COLOR6_ATTRIB3__DCC_PIPE_ALIGNED__SHIFT         = 0x0000001e;
    constexpr unsigned int CB_COLOR6_ATTRIB3__FMASK_SW_MODE__SHIFT            = 0x00000013;
    constexpr unsigned int CB_COLOR6_ATTRIB3__META_LINEAR__SHIFT              = 0x0000000d;
    constexpr unsigned int CB_COLOR6_ATTRIB3__MIP0_DEPTH__SHIFT               = 0x00000000;
    constexpr unsigned int CB_COLOR6_ATTRIB3__RESOURCE_TYPE__SHIFT            = 0x00000018;
    constexpr unsigned int CB_COLOR6_DCC_CONTROL__INDEPENDENT_128B_BLOCKS__SHIFT = 0x00000014;
    constexpr unsigned int CB_COLOR6_INFO__LINEAR_GENERAL__SHIFT              = 0x00000007;
    constexpr unsigned int CB_COLOR6_VIEW__MIP_LEVEL__SHIFT                   = 0x0000001a;
    constexpr unsigned int CB_COLOR7_ATTRIB3__CMASK_PIPE_ALIGNED__SHIFT       = 0x0000001a;
    constexpr unsigned int CB_COLOR7_ATTRIB3__COLOR_SW_MODE__SHIFT            = 0x0000000e;
    constexpr unsigned int CB_COLOR7_ATTRIB3__DCC_PIPE_ALIGNED__SHIFT         = 0x0000001e;
    constexpr unsigned int CB_COLOR7_ATTRIB3__FMASK_SW_MODE__SHIFT            = 0x00000013;
    constexpr unsigned int CB_COLOR7_ATTRIB3__META_LINEAR__SHIFT              = 0x0000000d;
    constexpr unsigned int CB_COLOR7_ATTRIB3__MIP0_DEPTH__SHIFT               = 0x00000000;
    constexpr unsigned int CB_COLOR7_ATTRIB3__RESOURCE_TYPE__SHIFT            = 0x00000018;
    constexpr unsigned int CB_COLOR7_DCC_CONTROL__INDEPENDENT_128B_BLOCKS__SHIFT = 0x00000014;
    constexpr unsigned int CB_COLOR7_INFO__LINEAR_GENERAL__SHIFT              = 0x00000007;
    constexpr unsigned int CB_COLOR7_VIEW__MIP_LEVEL__SHIFT                   = 0x0000001a;
    constexpr unsigned int CB_COVERAGE_OUT_CONTROL__COVERAGE_OUT_CHANNEL__SHIFT = 0x00000004;
    constexpr unsigned int CB_COVERAGE_OUT_CONTROL__COVERAGE_OUT_ENABLE__SHIFT = 0x00000000;
    constexpr unsigned int CB_COVERAGE_OUT_CONTROL__COVERAGE_OUT_MRT__SHIFT   = 0x00000001;
    constexpr unsigned int CB_COVERAGE_OUT_CONTROL__COVERAGE_OUT_SAMPLES__SHIFT = 0x00000008;
    constexpr unsigned int CB_HW_CONTROL_2__CHICKEN_BITS__SHIFT               = 0x0000001e;
    constexpr unsigned int CB_HW_CONTROL_3__DISABLE_FMASK_NOFETCH_OPT__SHIFT  = 0x0000001e;
    constexpr unsigned int CB_HW_CONTROL_4__COLOR_CACHE_FETCH_NUM_CLS_LOG2__SHIFT = 0x00000000;
    constexpr unsigned int CB_HW_CONTROL_4__DISABLE_CMASK_CLOCK_GATING__SHIFT = 0x00000006;
    constexpr unsigned int CB_HW_CONTROL_4__DISABLE_COLOR_CLOCK_GATING__SHIFT = 0x00000008;
    constexpr unsigned int CB_HW_CONTROL_4__DISABLE_FMASK_CLOCK_GATING__SHIFT = 0x00000007;
    constexpr unsigned int CB_HW_CONTROL_4__DISABLE_KEYXFR_HIT_RETURNS__SHIFT = 0x0000000d;
    constexpr unsigned int CB_HW_CONTROL_4__DISABLE_LQUAD_FGCG__SHIFT         = 0x00000017;
    constexpr unsigned int CB_HW_CONTROL_4__DISABLE_MA_WAIT_FOR_LAST__SHIFT   = 0x0000000f;
    constexpr unsigned int CB_HW_CONTROL_4__DISABLE_QSB_AA_MODE__SHIFT        = 0x00000009;
    constexpr unsigned int CB_HW_CONTROL_4__DISABLE_QSB_FRAG_GT0__SHIFT       = 0x0000000b;
    constexpr unsigned int CB_HW_CONTROL_4__DISABLE_QSB_SPECULATIVE__SHIFT    = 0x00000010;
    constexpr unsigned int CB_HW_CONTROL_4__DISABLE_QSB_WAIT_FOR_SCORE__SHIFT = 0x0000000a;
    constexpr unsigned int CB_HW_CONTROL_4__DISABLE_TILE_FGCG__SHIFT          = 0x00000016;
    constexpr unsigned int CB_HW_CONTROL_4__DISABLE_USE_OF_QUAD_SCOREBOARD__SHIFT = 0x00000005;
    constexpr unsigned int CB_HW_CONTROL_4__FC_QSB_FIFO_DEPTH__SHIFT          = 0x00000018;
    constexpr unsigned int CB_HW_CONTROL_4__FMASK_CACHE_FETCH_NUM_CLS_LOG2__SHIFT = 0x00000003;
    constexpr unsigned int CB_HW_CONTROL_4__QSB_WAIT_FOR_SCORE__SHIFT         = 0x00000011;
    constexpr unsigned int CB_HW_CONTROL_4__REVERSE_KEYXFR_RD_PRIORITY__SHIFT = 0x0000000c;
    constexpr unsigned int CB_HW_CONTROL__ALLOW_MRT_WITH_DUAL_SOURCE__SHIFT   = 0x00000000;
    constexpr unsigned int CB_RMI_GL2_CACHE_CONTROL__CMASK_RD_POLICY__SHIFT   = 0x00000010;
    constexpr unsigned int CB_RMI_GL2_CACHE_CONTROL__CMASK_WR_POLICY__SHIFT   = 0x00000000;
    constexpr unsigned int CB_RMI_GL2_CACHE_CONTROL__COLOR_BIG_PAGE__SHIFT    = 0x0000001f;
    constexpr unsigned int CB_RMI_GL2_CACHE_CONTROL__COLOR_RD_POLICY__SHIFT   = 0x00000016;
    constexpr unsigned int CB_RMI_GL2_CACHE_CONTROL__COLOR_WR_POLICY__SHIFT   = 0x00000006;
    constexpr unsigned int CB_RMI_GL2_CACHE_CONTROL__DCC_RD_POLICY__SHIFT     = 0x00000014;
    constexpr unsigned int CB_RMI_GL2_CACHE_CONTROL__DCC_WR_POLICY__SHIFT     = 0x00000004;
    constexpr unsigned int CB_RMI_GL2_CACHE_CONTROL__FMASK_BIG_PAGE__SHIFT    = 0x0000001e;
    constexpr unsigned int CB_RMI_GL2_CACHE_CONTROL__FMASK_RD_POLICY__SHIFT   = 0x00000012;
    constexpr unsigned int CB_RMI_GL2_CACHE_CONTROL__FMASK_WR_POLICY__SHIFT   = 0x00000002;
    constexpr unsigned int CB_STUTTER_CONTROL_CMASK_RDLAT__THRESHOLD__SHIFT   = 0x00000000;
    constexpr unsigned int CB_STUTTER_CONTROL_CMASK_RDLAT__TIMEOUT__SHIFT     = 0x00000008;
    constexpr unsigned int CB_STUTTER_CONTROL_COLOR_RDLAT__THRESHOLD__SHIFT   = 0x00000000;
    constexpr unsigned int CB_STUTTER_CONTROL_COLOR_RDLAT__TIMEOUT__SHIFT     = 0x00000008;
    constexpr unsigned int CB_STUTTER_CONTROL_FMASK_RDLAT__THRESHOLD__SHIFT   = 0x00000000;
    constexpr unsigned int CB_STUTTER_CONTROL_FMASK_RDLAT__TIMEOUT__SHIFT     = 0x00000008;
    constexpr unsigned int CHA_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
    constexpr unsigned int CHA_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
    constexpr unsigned int CHA_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT        = 0x00000018;
    constexpr unsigned int CHA_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT        = 0x0000001c;
    constexpr unsigned int CHA_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
    constexpr unsigned int CHA_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
    constexpr unsigned int CHA_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
    constexpr unsigned int CHA_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT         = 0x00000018;
    constexpr unsigned int CHA_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
    constexpr unsigned int CHA_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
    constexpr unsigned int CHA_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT           = 0x00000000;
    constexpr unsigned int CHA_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
    constexpr unsigned int CHA_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
    constexpr unsigned int CHA_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
    constexpr unsigned int CHA_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
    constexpr unsigned int CHA_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT           = 0x00000000;
    constexpr unsigned int CHA_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
    constexpr unsigned int CHA_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
    constexpr unsigned int CHA_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
    constexpr unsigned int CHA_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
    constexpr unsigned int CHA_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT           = 0x00000000;
    constexpr unsigned int CHA_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
    constexpr unsigned int CHA_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
    constexpr unsigned int CHA_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
    constexpr unsigned int CHA_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
    constexpr unsigned int CHA_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT           = 0x00000000;
    constexpr unsigned int CHC_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
    constexpr unsigned int CHC_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
    constexpr unsigned int CHC_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT        = 0x00000018;
    constexpr unsigned int CHC_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT        = 0x0000001c;
    constexpr unsigned int CHC_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
    constexpr unsigned int CHC_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
    constexpr unsigned int CHC_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
    constexpr unsigned int CHC_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT         = 0x00000018;
    constexpr unsigned int CHC_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
    constexpr unsigned int CHC_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
    constexpr unsigned int CHC_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT           = 0x00000000;
    constexpr unsigned int CHC_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
    constexpr unsigned int CHC_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
    constexpr unsigned int CHC_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
    constexpr unsigned int CHC_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
    constexpr unsigned int CHC_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT           = 0x00000000;
    constexpr unsigned int CHC_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
    constexpr unsigned int CHC_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
    constexpr unsigned int CHC_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
    constexpr unsigned int CHC_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
    constexpr unsigned int CHC_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT           = 0x00000000;
    constexpr unsigned int CHC_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
    constexpr unsigned int CHC_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
    constexpr unsigned int CHC_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
    constexpr unsigned int CHC_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
    constexpr unsigned int CHC_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT           = 0x00000000;
    constexpr unsigned int COMPUTE_DDID_INDEX__INDEX__SHIFT                   = 0x00000000;
    constexpr unsigned int COMPUTE_DESTINATION_EN_SE0__CU_EN__SHIFT           = 0x00000000;
    constexpr unsigned int COMPUTE_DESTINATION_EN_SE1__CU_EN__SHIFT           = 0x00000000;
    constexpr unsigned int COMPUTE_DESTINATION_EN_SE2__CU_EN__SHIFT           = 0x00000000;
    constexpr unsigned int COMPUTE_DESTINATION_EN_SE3__CU_EN__SHIFT           = 0x00000000;
    constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__CS_W32_EN__SHIFT       = 0x0000000f;
    constexpr unsigned int COMPUTE_DISPATCH_INITIATOR__TUNNEL_ENABLE__SHIFT   = 0x0000000d;
    constexpr unsigned int COMPUTE_DISPATCH_TUNNEL__IMMEDIATE__SHIFT          = 0x0000000a;
    constexpr unsigned int COMPUTE_DISPATCH_TUNNEL__OFF_DELAY__SHIFT          = 0x00000000;
    constexpr unsigned int COMPUTE_PGM_RSRC1__FWD_PROGRESS__SHIFT             = 0x0000001f;
    constexpr unsigned int COMPUTE_PGM_RSRC1__MEM_ORDERED__SHIFT              = 0x0000001e;
    constexpr unsigned int COMPUTE_PGM_RSRC1__WGP_MODE__SHIFT                 = 0x0000001d;
    constexpr unsigned int COMPUTE_PGM_RSRC3__SHARED_VGPR_CNT__SHIFT          = 0x00000000;
    constexpr unsigned int COMPUTE_RELAUNCH2__IS_EVENT__SHIFT                 = 0x0000001e;
    constexpr unsigned int COMPUTE_RELAUNCH2__IS_STATE__SHIFT                 = 0x0000001f;
    constexpr unsigned int COMPUTE_RELAUNCH2__PAYLOAD__SHIFT                  = 0x00000000;
    constexpr unsigned int COMPUTE_REQ_CTRL__ALLOCATION_RATE_THROTTLING_THRESHOLD__SHIFT = 0x00000011;
    constexpr unsigned int COMPUTE_REQ_CTRL__DEDICATED_PREALLOCATION_BUFFER_LIMIT__SHIFT = 0x00000014;
    constexpr unsigned int COMPUTE_REQ_CTRL__GLOBAL_SCANNING_EN__SHIFT        = 0x00000010;
    constexpr unsigned int COMPUTE_REQ_CTRL__HARD_LOCK_HYSTERESIS__SHIFT      = 0x00000009;
    constexpr unsigned int COMPUTE_REQ_CTRL__HARD_LOCK_LOW_THRESHOLD__SHIFT   = 0x0000000a;
    constexpr unsigned int COMPUTE_REQ_CTRL__NUMBER_OF_REQUESTS_PER_CU__SHIFT = 0x00000001;
    constexpr unsigned int COMPUTE_REQ_CTRL__PRODUCER_REQUEST_LOCKOUT__SHIFT  = 0x0000000f;
    constexpr unsigned int COMPUTE_REQ_CTRL__SOFT_GROUPING_ALLOCATION_TIMEOUT__SHIFT = 0x00000005;
    constexpr unsigned int COMPUTE_REQ_CTRL__SOFT_GROUPING_EN__SHIFT          = 0x00000000;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE0__SA0_CU_EN__SHIFT   = 0x00000000;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE0__SA1_CU_EN__SHIFT   = 0x00000010;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE1__SA0_CU_EN__SHIFT   = 0x00000000;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE1__SA1_CU_EN__SHIFT   = 0x00000010;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE2__SA0_CU_EN__SHIFT   = 0x00000000;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE2__SA1_CU_EN__SHIFT   = 0x00000010;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE3__SA0_CU_EN__SHIFT   = 0x00000000;
    constexpr unsigned int COMPUTE_STATIC_THREAD_MGMT_SE3__SA1_CU_EN__SHIFT   = 0x00000010;
    constexpr unsigned int COMPUTE_USER_ACCUM_0__CONTRIBUTION__SHIFT          = 0x00000000;
    constexpr unsigned int COMPUTE_USER_ACCUM_1__CONTRIBUTION__SHIFT          = 0x00000000;
    constexpr unsigned int COMPUTE_USER_ACCUM_2__CONTRIBUTION__SHIFT          = 0x00000000;
    constexpr unsigned int COMPUTE_USER_ACCUM_3__CONTRIBUTION__SHIFT          = 0x00000000;
    constexpr unsigned int CPC_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
    constexpr unsigned int CPC_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
    constexpr unsigned int CPC_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
    constexpr unsigned int CPC_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT           = 0x00000000;
    constexpr unsigned int CPC_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
    constexpr unsigned int CPC_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT           = 0x00000000;
    constexpr unsigned int CPF_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
    constexpr unsigned int CPF_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
    constexpr unsigned int CPF_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
    constexpr unsigned int CPF_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT           = 0x00000000;
    constexpr unsigned int CPF_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
    constexpr unsigned int CPF_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT           = 0x00000000;
    constexpr unsigned int CPG_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
    constexpr unsigned int CPG_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
    constexpr unsigned int CPG_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
    constexpr unsigned int CPG_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT           = 0x00000000;
    constexpr unsigned int CPG_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
    constexpr unsigned int CPG_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT           = 0x00000000;
    constexpr unsigned int DB_COUNT_CONTROL__DISABLE_CONSERVATIVE_ZPASS_COUNTS__SHIFT = 0x00000002;
    constexpr unsigned int DB_COUNT_CONTROL__ENHANCED_CONSERVATIVE_ZPASS_COUNTS__SHIFT = 0x00000003;
    constexpr unsigned int DB_DEPTH_SIZE_XY__X_MAX__SHIFT                     = 0x00000000;
    constexpr unsigned int DB_DEPTH_SIZE_XY__Y_MAX__SHIFT                     = 0x00000010;
    constexpr unsigned int DB_DEPTH_VIEW__SLICE_MAX_HI__SHIFT                 = 0x0000001e;
    constexpr unsigned int DB_DEPTH_VIEW__SLICE_START_HI__SHIFT               = 0x0000000b;
    constexpr unsigned int DB_EQUAD_STUTTER_CONTROL__THRESHOLD__SHIFT         = 0x00000000;
    constexpr unsigned int DB_EQUAD_STUTTER_CONTROL__TIMEOUT__SHIFT           = 0x00000010;
    constexpr unsigned int DB_ETILE_STUTTER_CONTROL__THRESHOLD__SHIFT         = 0x00000000;
    constexpr unsigned int DB_ETILE_STUTTER_CONTROL__TIMEOUT__SHIFT           = 0x00000010;
    constexpr unsigned int DB_EXCEPTION_CONTROL__AUTO_FLUSH_HTILE__SHIFT      = 0x00000003;
    constexpr unsigned int DB_EXCEPTION_CONTROL__AUTO_FLUSH_QUAD__SHIFT       = 0x00000004;
    constexpr unsigned int DB_EXCEPTION_CONTROL__DTAG_WATERMARK__SHIFT        = 0x00000018;
    constexpr unsigned int DB_EXCEPTION_CONTROL__FORCE_SUMMARIZE__SHIFT       = 0x00000008;
    constexpr unsigned int DB_FGCG_INTERFACES_CLK_CTRL__DB_CB_LQUAD_OVERRIDE__SHIFT = 0x00000002;
    constexpr unsigned int DB_FGCG_INTERFACES_CLK_CTRL__DB_CB_RMIRET_OVERRIDE__SHIFT = 0x00000006;
    constexpr unsigned int DB_FGCG_INTERFACES_CLK_CTRL__DB_CB_TILE_OVERRIDE__SHIFT = 0x00000001;
    constexpr unsigned int DB_FGCG_INTERFACES_CLK_CTRL__DB_RMI_RDREQ_OVERRIDE__SHIFT = 0x00000003;
    constexpr unsigned int DB_FGCG_INTERFACES_CLK_CTRL__DB_RMI_WRREQ_OVERRIDE__SHIFT = 0x00000004;
    constexpr unsigned int DB_FGCG_INTERFACES_CLK_CTRL__DB_SC_QUAD_OVERRIDE__SHIFT = 0x00000000;
    constexpr unsigned int DB_FGCG_INTERFACES_CLK_CTRL__DB_SC_TILE_OVERRIDE__SHIFT = 0x00000005;
    constexpr unsigned int DB_FIFO_DEPTH1__MCC_DEPTH__SHIFT                   = 0x00000010;
    constexpr unsigned int DB_FIFO_DEPTH1__MI_RDREQ_FIFO_DEPTH__SHIFT         = 0x00000000;
    constexpr unsigned int DB_FIFO_DEPTH1__MI_WRREQ_FIFO_DEPTH__SHIFT         = 0x00000008;
    constexpr unsigned int DB_FIFO_DEPTH1__QC_DEPTH__SHIFT                    = 0x00000018;
    constexpr unsigned int DB_FIFO_DEPTH2__LQUAD_FIFO_DEPTH__SHIFT            = 0x00000010;
    constexpr unsigned int DB_FIFO_DEPTH3__LTILE_PROBE_FIFO_DEPTH__SHIFT      = 0x00000000;
    constexpr unsigned int DB_FIFO_DEPTH3__QUAD_READ_REQS__SHIFT              = 0x00000018;
    constexpr unsigned int DB_FREE_CACHELINES__FREE_HTILE_DEPTH__SHIFT        = 0x00000018;
    constexpr unsigned int DB_FREE_CACHELINES__FREE_PLANE_DEPTH__SHIFT        = 0x00000008;
    constexpr unsigned int DB_FREE_CACHELINES__FREE_Z_DEPTH__SHIFT            = 0x00000010;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__DBCB_LOB_SWITCH_TIMEOUT__SHIFT = 0x0000000b;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__DISABLE_RD_BURST__SHIFT   = 0x0000001e;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__LEGACY_LOB_INSERT_EN__SHIFT = 0x0000001f;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__MAXBURST__SHIFT           = 0x00000000;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__TIMEOUT__SHIFT            = 0x00000008;
    constexpr unsigned int DB_LQUAD_STUTTER_CONTROL__THRESHOLD__SHIFT         = 0x00000000;
    constexpr unsigned int DB_LQUAD_STUTTER_CONTROL__TIMEOUT__SHIFT           = 0x00000010;
    constexpr unsigned int DB_LTILE_STUTTER_CONTROL__THRESHOLD__SHIFT         = 0x00000000;
    constexpr unsigned int DB_LTILE_STUTTER_CONTROL__TIMEOUT__SHIFT           = 0x00000010;
    constexpr unsigned int DB_RMI_L2_CACHE_CONTROL__HTILE_RD_POLICY__SHIFT    = 0x00000014;
    constexpr unsigned int DB_RMI_L2_CACHE_CONTROL__HTILE_WR_POLICY__SHIFT    = 0x00000004;
    constexpr unsigned int DB_RMI_L2_CACHE_CONTROL__S_BIG_PAGE__SHIFT         = 0x00000019;
    constexpr unsigned int DB_RMI_L2_CACHE_CONTROL__S_RD_POLICY__SHIFT        = 0x00000012;
    constexpr unsigned int DB_RMI_L2_CACHE_CONTROL__S_WR_POLICY__SHIFT        = 0x00000002;
    constexpr unsigned int DB_RMI_L2_CACHE_CONTROL__ZPCPSD_WR_POLICY__SHIFT   = 0x00000006;
    constexpr unsigned int DB_RMI_L2_CACHE_CONTROL__Z_BIG_PAGE__SHIFT         = 0x00000018;
    constexpr unsigned int DB_RMI_L2_CACHE_CONTROL__Z_RD_POLICY__SHIFT        = 0x00000010;
    constexpr unsigned int DB_RMI_L2_CACHE_CONTROL__Z_WR_POLICY__SHIFT        = 0x00000000;
    constexpr unsigned int DB_SHADER_CONTROL__PRE_SHADER_DEPTH_COVERAGE_ENABLE__SHIFT = 0x00000017;
    constexpr unsigned int DB_STENCIL_INFO__FAULT_BEHAVIOR__SHIFT             = 0x00000009;
    constexpr unsigned int DB_STENCIL_INFO__ITERATE_256__SHIFT                = 0x00000014;
    constexpr unsigned int DB_STENCIL_INFO__ITERATE_FLUSH__SHIFT              = 0x0000000b;
    constexpr unsigned int DB_WATERMARKS__DEPTH_CACHELINE_FREE__SHIFT         = 0x00000018;
    constexpr unsigned int DB_WATERMARKS__DEPTH_FLUSH__SHIFT                  = 0x00000008;
    constexpr unsigned int DB_WATERMARKS__DEPTH_PENDING_FREE__SHIFT           = 0x00000010;
    constexpr unsigned int DB_Z_INFO__FAULT_BEHAVIOR__SHIFT                   = 0x00000009;
    constexpr unsigned int DB_Z_INFO__ITERATE_256__SHIFT                      = 0x00000014;
    constexpr unsigned int DB_Z_INFO__ITERATE_FLUSH__SHIFT                    = 0x0000000b;
    constexpr unsigned int GCEA_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT        = 0x00000000;
    constexpr unsigned int GCEA_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT        = 0x00000000;
    constexpr unsigned int GCEA_PERFCOUNTER2_MODE__COMPARE_MODE0__SHIFT       = 0x00000000;
    constexpr unsigned int GCEA_PERFCOUNTER2_MODE__COMPARE_MODE1__SHIFT       = 0x00000002;
    constexpr unsigned int GCEA_PERFCOUNTER2_MODE__COMPARE_MODE2__SHIFT       = 0x00000004;
    constexpr unsigned int GCEA_PERFCOUNTER2_MODE__COMPARE_MODE3__SHIFT       = 0x00000006;
    constexpr unsigned int GCEA_PERFCOUNTER2_MODE__COMPARE_VALUE0__SHIFT      = 0x00000008;
    constexpr unsigned int GCEA_PERFCOUNTER2_MODE__COMPARE_VALUE1__SHIFT      = 0x0000000c;
    constexpr unsigned int GCEA_PERFCOUNTER2_MODE__COMPARE_VALUE2__SHIFT      = 0x00000010;
    constexpr unsigned int GCEA_PERFCOUNTER2_MODE__COMPARE_VALUE3__SHIFT      = 0x00000014;
    constexpr unsigned int GCEA_PERFCOUNTER2_SELECT1__PERF_MODE2__SHIFT       = 0x0000001c;
    constexpr unsigned int GCEA_PERFCOUNTER2_SELECT1__PERF_MODE3__SHIFT       = 0x00000018;
    constexpr unsigned int GCEA_PERFCOUNTER2_SELECT1__PERF_SEL2__SHIFT        = 0x00000000;
    constexpr unsigned int GCEA_PERFCOUNTER2_SELECT1__PERF_SEL3__SHIFT        = 0x0000000a;
    constexpr unsigned int GCEA_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT         = 0x00000014;
    constexpr unsigned int GCEA_PERFCOUNTER2_SELECT__PERF_MODE1__SHIFT        = 0x00000018;
    constexpr unsigned int GCEA_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT         = 0x0000001c;
    constexpr unsigned int GCEA_PERFCOUNTER2_SELECT__PERF_SEL1__SHIFT         = 0x0000000a;
    constexpr unsigned int GCEA_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT          = 0x00000000;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER0_CFG__CLEAR__SHIFT          = 0x0000001d;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER0_CFG__ENABLE__SHIFT         = 0x0000001c;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER0_CFG__PERF_MODE__SHIFT      = 0x00000018;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER0_CFG__PERF_SEL_END__SHIFT   = 0x00000008;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER0_CFG__PERF_SEL__SHIFT       = 0x00000000;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER1_CFG__CLEAR__SHIFT          = 0x0000001d;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER1_CFG__ENABLE__SHIFT         = 0x0000001c;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER1_CFG__PERF_MODE__SHIFT      = 0x00000018;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER1_CFG__PERF_SEL_END__SHIFT   = 0x00000008;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER1_CFG__PERF_SEL__SHIFT       = 0x00000000;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER2_CFG__CLEAR__SHIFT          = 0x0000001d;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER2_CFG__ENABLE__SHIFT         = 0x0000001c;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER2_CFG__PERF_MODE__SHIFT      = 0x00000018;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER2_CFG__PERF_SEL_END__SHIFT   = 0x00000008;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER2_CFG__PERF_SEL__SHIFT       = 0x00000000;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER3_CFG__CLEAR__SHIFT          = 0x0000001d;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER3_CFG__ENABLE__SHIFT         = 0x0000001c;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER3_CFG__PERF_MODE__SHIFT      = 0x00000018;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER3_CFG__PERF_SEL_END__SHIFT   = 0x00000008;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER3_CFG__PERF_SEL__SHIFT       = 0x00000000;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER4_CFG__CLEAR__SHIFT          = 0x0000001d;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER4_CFG__ENABLE__SHIFT         = 0x0000001c;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER4_CFG__PERF_MODE__SHIFT      = 0x00000018;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER4_CFG__PERF_SEL_END__SHIFT   = 0x00000008;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER4_CFG__PERF_SEL__SHIFT       = 0x00000000;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER5_CFG__CLEAR__SHIFT          = 0x0000001d;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER5_CFG__ENABLE__SHIFT         = 0x0000001c;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER5_CFG__PERF_MODE__SHIFT      = 0x00000018;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER5_CFG__PERF_SEL_END__SHIFT   = 0x00000008;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER5_CFG__PERF_SEL__SHIFT       = 0x00000000;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER6_CFG__CLEAR__SHIFT          = 0x0000001d;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER6_CFG__ENABLE__SHIFT         = 0x0000001c;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER6_CFG__PERF_MODE__SHIFT      = 0x00000018;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER6_CFG__PERF_SEL_END__SHIFT   = 0x00000008;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER6_CFG__PERF_SEL__SHIFT       = 0x00000000;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER7_CFG__CLEAR__SHIFT          = 0x0000001d;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER7_CFG__ENABLE__SHIFT         = 0x0000001c;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER7_CFG__PERF_MODE__SHIFT      = 0x00000018;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER7_CFG__PERF_SEL_END__SHIFT   = 0x00000008;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER7_CFG__PERF_SEL__SHIFT       = 0x00000000;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER_HI__COMPARE_VALUE__SHIFT    = 0x00000010;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER_HI__COUNTER_HI__SHIFT       = 0x00000000;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER_LO__COUNTER_LO__SHIFT       = 0x00000000;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER_RSLT_CNTL__CLEAR_ALL__SHIFT = 0x00000019;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER_RSLT_CNTL__ENABLE_ANY__SHIFT = 0x00000018;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER_RSLT_CNTL__PERF_COUNTER_SELECT__SHIFT = 0x00000000;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER_RSLT_CNTL__START_TRIGGER__SHIFT = 0x00000008;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER_RSLT_CNTL__STOP_ALL_ON_SATURATE__SHIFT = 0x0000001a;
    constexpr unsigned int GCMC_VM_L2_PERFCOUNTER_RSLT_CNTL__STOP_TRIGGER__SHIFT = 0x00000010;
    constexpr unsigned int GCR_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
    constexpr unsigned int GCR_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
    constexpr unsigned int GCR_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT        = 0x0000001c;
    constexpr unsigned int GCR_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT        = 0x00000018;
    constexpr unsigned int GCR_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
    constexpr unsigned int GCR_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
    constexpr unsigned int GCR_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
    constexpr unsigned int GCR_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT         = 0x00000018;
    constexpr unsigned int GCR_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
    constexpr unsigned int GCR_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
    constexpr unsigned int GCR_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT           = 0x00000000;
    constexpr unsigned int GCR_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
    constexpr unsigned int GCR_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
    constexpr unsigned int GCR_PERFCOUNTER1_SELECT__CNTL_MODE__SHIFT          = 0x0000001c;
    constexpr unsigned int GCR_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT          = 0x00000018;
    constexpr unsigned int GCR_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT           = 0x00000000;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_HI__PERFCOUNTER_HI__SHIFT    = 0x00000000;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_LO__PERFCOUNTER_LO__SHIFT    = 0x00000000;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_MODE__COMPARE_MODE0__SHIFT   = 0x00000000;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_MODE__COMPARE_MODE1__SHIFT   = 0x00000002;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_MODE__COMPARE_MODE2__SHIFT   = 0x00000004;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_MODE__COMPARE_MODE3__SHIFT   = 0x00000006;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_MODE__COMPARE_VALUE0__SHIFT  = 0x00000008;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_MODE__COMPARE_VALUE1__SHIFT  = 0x0000000c;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_MODE__COMPARE_VALUE2__SHIFT  = 0x00000010;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_MODE__COMPARE_VALUE3__SHIFT  = 0x00000014;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_SELECT1__PERF_MODE2__SHIFT   = 0x0000001c;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_SELECT1__PERF_MODE3__SHIFT   = 0x00000018;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_SELECT1__PERF_SEL2__SHIFT    = 0x00000000;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_SELECT1__PERF_SEL3__SHIFT    = 0x0000000a;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_SELECT__CNTR_MODE__SHIFT     = 0x00000014;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_SELECT__PERF_MODE1__SHIFT    = 0x00000018;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_SELECT__PERF_MODE__SHIFT     = 0x0000001c;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_SELECT__PERF_SEL1__SHIFT     = 0x0000000a;
    constexpr unsigned int GCVML2_PERFCOUNTER2_0_SELECT__PERF_SEL__SHIFT      = 0x00000000;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_HI__PERFCOUNTER_HI__SHIFT    = 0x00000000;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_LO__PERFCOUNTER_LO__SHIFT    = 0x00000000;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_MODE__COMPARE_MODE0__SHIFT   = 0x00000000;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_MODE__COMPARE_MODE1__SHIFT   = 0x00000002;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_MODE__COMPARE_MODE2__SHIFT   = 0x00000004;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_MODE__COMPARE_MODE3__SHIFT   = 0x00000006;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_MODE__COMPARE_VALUE0__SHIFT  = 0x00000008;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_MODE__COMPARE_VALUE1__SHIFT  = 0x0000000c;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_MODE__COMPARE_VALUE2__SHIFT  = 0x00000010;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_MODE__COMPARE_VALUE3__SHIFT  = 0x00000014;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_SELECT1__PERF_MODE2__SHIFT   = 0x0000001c;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_SELECT1__PERF_MODE3__SHIFT   = 0x00000018;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_SELECT1__PERF_SEL2__SHIFT    = 0x00000000;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_SELECT1__PERF_SEL3__SHIFT    = 0x0000000a;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_SELECT__CNTR_MODE__SHIFT     = 0x00000014;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_SELECT__PERF_MODE1__SHIFT    = 0x00000018;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_SELECT__PERF_MODE__SHIFT     = 0x0000001c;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_SELECT__PERF_SEL1__SHIFT     = 0x0000000a;
    constexpr unsigned int GCVML2_PERFCOUNTER2_1_SELECT__PERF_SEL__SHIFT      = 0x00000000;
    constexpr unsigned int GE_CNTL__BREAK_WAVE_AT_EOI__SHIFT                  = 0x00000012;
    constexpr unsigned int GE_CNTL__PACKET_TO_ONE_PA__SHIFT                   = 0x00000013;
    constexpr unsigned int GE_CNTL__PRIM_GRP_SIZE__SHIFT                      = 0x00000000;
    constexpr unsigned int GE_CNTL__VERT_GRP_SIZE__SHIFT                      = 0x00000009;
    constexpr unsigned int GE_DMA_FIRST_INDEX__FIRST_INDEX__SHIFT             = 0x00000000;
    constexpr unsigned int GE_INDX_OFFSET__INDX_OFFSET__SHIFT                 = 0x00000000;
    constexpr unsigned int GE_MAX_OUTPUT_PER_SUBGROUP__MAX_VERTS_PER_SUBGROUP__SHIFT = 0x00000000;
    constexpr unsigned int GE_MAX_VTX_INDX__MAX_INDX__SHIFT                   = 0x00000000;
    constexpr unsigned int GE_MIN_VTX_INDX__MIN_INDX__SHIFT                   = 0x00000000;
    constexpr unsigned int GE_MULTI_PRIM_IB_RESET_EN__MATCH_ALL_BITS__SHIFT   = 0x00000001;
    constexpr unsigned int GE_MULTI_PRIM_IB_RESET_EN__RESET_EN__SHIFT         = 0x00000000;
    constexpr unsigned int GE_NGG_SUBGRP_CNTL__PRIM_AMP_FACTOR__SHIFT         = 0x00000000;
    constexpr unsigned int GE_NGG_SUBGRP_CNTL__THDS_PER_SUBGRP__SHIFT         = 0x00000009;
    constexpr unsigned int GE_PC_ALLOC__NUM_PC_LINES__SHIFT                   = 0x00000001;
    constexpr unsigned int GE_PC_ALLOC__OVERSUB_EN__SHIFT                     = 0x00000000;
    constexpr unsigned int GE_PC_CNTL__PC_SIZE__SHIFT                         = 0x00000000;
    constexpr unsigned int GE_PRIV_CONTROL__CLAMP_PRIMGRP_SIZE__SHIFT         = 0x00000001;
    constexpr unsigned int GE_PRIV_CONTROL__DISCARD_LEGACY__SHIFT             = 0x00000000;
    constexpr unsigned int GE_PRIV_CONTROL__RESET_ON_PIPELINE_CHANGE__SHIFT   = 0x0000000a;
    constexpr unsigned int GE_STATUS__PERFCOUNTER_STATUS__SHIFT               = 0x00000000;
    constexpr unsigned int GE_STATUS__THREAD_TRACE_STATUS__SHIFT              = 0x00000001;
    constexpr unsigned int GE_STEREO_CNTL__EN_STEREO__SHIFT                   = 0x00000008;
    constexpr unsigned int GE_STEREO_CNTL__RT_SLICE__SHIFT                    = 0x00000000;
    constexpr unsigned int GE_STEREO_CNTL__VIEWPORT__SHIFT                    = 0x00000003;
    constexpr unsigned int GE_USER_VGPR1__DATA__SHIFT                         = 0x00000000;
    constexpr unsigned int GE_USER_VGPR2__DATA__SHIFT                         = 0x00000000;
    constexpr unsigned int GE_USER_VGPR3__DATA__SHIFT                         = 0x00000000;
    constexpr unsigned int GE_USER_VGPR_EN__EN_USER_VGPR1__SHIFT              = 0x00000000;
    constexpr unsigned int GE_USER_VGPR_EN__EN_USER_VGPR2__SHIFT              = 0x00000001;
    constexpr unsigned int GE_USER_VGPR_EN__EN_USER_VGPR3__SHIFT              = 0x00000002;
    constexpr unsigned int GL1A_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT        = 0x00000000;
    constexpr unsigned int GL1A_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT        = 0x00000000;
    constexpr unsigned int GL1A_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT       = 0x00000018;
    constexpr unsigned int GL1A_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT       = 0x0000001c;
    constexpr unsigned int GL1A_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT        = 0x00000000;
    constexpr unsigned int GL1A_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT        = 0x0000000a;
    constexpr unsigned int GL1A_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT         = 0x00000014;
    constexpr unsigned int GL1A_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT        = 0x00000018;
    constexpr unsigned int GL1A_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT         = 0x0000001c;
    constexpr unsigned int GL1A_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT         = 0x0000000a;
    constexpr unsigned int GL1A_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT          = 0x00000000;
    constexpr unsigned int GL1A_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT        = 0x00000000;
    constexpr unsigned int GL1A_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT        = 0x00000000;
    constexpr unsigned int GL1A_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT         = 0x00000014;
    constexpr unsigned int GL1A_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT         = 0x0000001c;
    constexpr unsigned int GL1A_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT          = 0x00000000;
    constexpr unsigned int GL1A_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT        = 0x00000000;
    constexpr unsigned int GL1A_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT        = 0x00000000;
    constexpr unsigned int GL1A_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT         = 0x00000014;
    constexpr unsigned int GL1A_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT         = 0x0000001c;
    constexpr unsigned int GL1A_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT          = 0x00000000;
    constexpr unsigned int GL1A_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT        = 0x00000000;
    constexpr unsigned int GL1A_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT        = 0x00000000;
    constexpr unsigned int GL1A_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT         = 0x00000014;
    constexpr unsigned int GL1A_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT         = 0x0000001c;
    constexpr unsigned int GL1A_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT          = 0x00000000;
    constexpr unsigned int GL1C_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT        = 0x00000000;
    constexpr unsigned int GL1C_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT        = 0x00000000;
    constexpr unsigned int GL1C_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT       = 0x00000018;
    constexpr unsigned int GL1C_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT       = 0x0000001c;
    constexpr unsigned int GL1C_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT        = 0x00000000;
    constexpr unsigned int GL1C_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT        = 0x0000000a;
    constexpr unsigned int GL1C_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT         = 0x00000014;
    constexpr unsigned int GL1C_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT        = 0x00000018;
    constexpr unsigned int GL1C_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT         = 0x0000001c;
    constexpr unsigned int GL1C_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT         = 0x0000000a;
    constexpr unsigned int GL1C_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT          = 0x00000000;
    constexpr unsigned int GL1C_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT        = 0x00000000;
    constexpr unsigned int GL1C_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT        = 0x00000000;
    constexpr unsigned int GL1C_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT         = 0x00000014;
    constexpr unsigned int GL1C_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT         = 0x0000001c;
    constexpr unsigned int GL1C_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT          = 0x00000000;
    constexpr unsigned int GL1C_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT        = 0x00000000;
    constexpr unsigned int GL1C_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT        = 0x00000000;
    constexpr unsigned int GL1C_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT         = 0x00000014;
    constexpr unsigned int GL1C_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT         = 0x0000001c;
    constexpr unsigned int GL1C_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT          = 0x00000000;
    constexpr unsigned int GL1C_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT        = 0x00000000;
    constexpr unsigned int GL1C_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT        = 0x00000000;
    constexpr unsigned int GL1C_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT         = 0x00000014;
    constexpr unsigned int GL1C_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT         = 0x0000001c;
    constexpr unsigned int GL1C_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT          = 0x00000000;
    constexpr unsigned int GL2A_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT        = 0x00000000;
    constexpr unsigned int GL2A_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT        = 0x00000000;
    constexpr unsigned int GL2A_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT       = 0x00000018;
    constexpr unsigned int GL2A_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT       = 0x0000001c;
    constexpr unsigned int GL2A_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT        = 0x00000000;
    constexpr unsigned int GL2A_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT        = 0x0000000a;
    constexpr unsigned int GL2A_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT         = 0x00000014;
    constexpr unsigned int GL2A_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT        = 0x00000018;
    constexpr unsigned int GL2A_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT         = 0x0000001c;
    constexpr unsigned int GL2A_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT         = 0x0000000a;
    constexpr unsigned int GL2A_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT          = 0x00000000;
    constexpr unsigned int GL2A_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT        = 0x00000000;
    constexpr unsigned int GL2A_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT        = 0x00000000;
    constexpr unsigned int GL2A_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT       = 0x00000018;
    constexpr unsigned int GL2A_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT       = 0x0000001c;
    constexpr unsigned int GL2A_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT        = 0x00000000;
    constexpr unsigned int GL2A_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT        = 0x0000000a;
    constexpr unsigned int GL2A_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT         = 0x00000014;
    constexpr unsigned int GL2A_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT        = 0x00000018;
    constexpr unsigned int GL2A_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT         = 0x0000001c;
    constexpr unsigned int GL2A_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT         = 0x0000000a;
    constexpr unsigned int GL2A_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT          = 0x00000000;
    constexpr unsigned int GL2A_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT        = 0x00000000;
    constexpr unsigned int GL2A_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT        = 0x00000000;
    constexpr unsigned int GL2A_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT         = 0x00000014;
    constexpr unsigned int GL2A_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT         = 0x0000001c;
    constexpr unsigned int GL2A_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT          = 0x00000000;
    constexpr unsigned int GL2A_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT        = 0x00000000;
    constexpr unsigned int GL2A_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT        = 0x00000000;
    constexpr unsigned int GL2A_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT         = 0x00000014;
    constexpr unsigned int GL2A_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT         = 0x0000001c;
    constexpr unsigned int GL2A_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT          = 0x00000000;
    constexpr unsigned int GL2C_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT        = 0x00000000;
    constexpr unsigned int GL2C_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT        = 0x00000000;
    constexpr unsigned int GL2C_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT       = 0x00000018;
    constexpr unsigned int GL2C_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT       = 0x0000001c;
    constexpr unsigned int GL2C_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT        = 0x00000000;
    constexpr unsigned int GL2C_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT        = 0x0000000a;
    constexpr unsigned int GL2C_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT         = 0x00000014;
    constexpr unsigned int GL2C_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT        = 0x00000018;
    constexpr unsigned int GL2C_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT         = 0x0000001c;
    constexpr unsigned int GL2C_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT         = 0x0000000a;
    constexpr unsigned int GL2C_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT          = 0x00000000;
    constexpr unsigned int GL2C_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT        = 0x00000000;
    constexpr unsigned int GL2C_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT        = 0x00000000;
    constexpr unsigned int GL2C_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT       = 0x00000018;
    constexpr unsigned int GL2C_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT       = 0x0000001c;
    constexpr unsigned int GL2C_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT        = 0x00000000;
    constexpr unsigned int GL2C_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT        = 0x0000000a;
    constexpr unsigned int GL2C_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT         = 0x00000014;
    constexpr unsigned int GL2C_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT        = 0x00000018;
    constexpr unsigned int GL2C_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT         = 0x0000001c;
    constexpr unsigned int GL2C_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT         = 0x0000000a;
    constexpr unsigned int GL2C_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT          = 0x00000000;
    constexpr unsigned int GL2C_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT        = 0x00000000;
    constexpr unsigned int GL2C_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT        = 0x00000000;
    constexpr unsigned int GL2C_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT         = 0x00000014;
    constexpr unsigned int GL2C_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT         = 0x0000001c;
    constexpr unsigned int GL2C_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT          = 0x00000000;
    constexpr unsigned int GL2C_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT        = 0x00000000;
    constexpr unsigned int GL2C_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT        = 0x00000000;
    constexpr unsigned int GL2C_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT         = 0x00000014;
    constexpr unsigned int GL2C_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT         = 0x0000001c;
    constexpr unsigned int GL2C_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT          = 0x00000000;
    constexpr unsigned int GRBM_GFX_INDEX_SR_DATA__SA_BROADCAST_WRITES__SHIFT = 0x0000001d;
    constexpr unsigned int GRBM_GFX_INDEX_SR_DATA__SA_INDEX__SHIFT            = 0x00000008;
    constexpr unsigned int GRBM_GFX_INDEX__SA_BROADCAST_WRITES__SHIFT         = 0x0000001d;
    constexpr unsigned int GRBM_GFX_INDEX__SA_INDEX__SHIFT                    = 0x00000008;
    constexpr unsigned int GRBM_PERFCOUNTER0_SELECT_HI__CH_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000004;
    constexpr unsigned int GRBM_PERFCOUNTER0_SELECT_HI__GL1CC_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000008;
    constexpr unsigned int GRBM_PERFCOUNTER0_SELECT_HI__GL2CC_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000002;
    constexpr unsigned int GRBM_PERFCOUNTER0_SELECT_HI__PH_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000005;
    constexpr unsigned int GRBM_PERFCOUNTER0_SELECT_HI__SDMA_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000003;
    constexpr unsigned int GRBM_PERFCOUNTER0_SELECT_HI__UTCL1_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000001;
    constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__GE_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001c;
    constexpr unsigned int GRBM_PERFCOUNTER0_SELECT__TCP_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001b;
    constexpr unsigned int GRBM_PERFCOUNTER1_SELECT_HI__CH_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000004;
    constexpr unsigned int GRBM_PERFCOUNTER1_SELECT_HI__GL1CC_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000008;
    constexpr unsigned int GRBM_PERFCOUNTER1_SELECT_HI__GL2CC_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000002;
    constexpr unsigned int GRBM_PERFCOUNTER1_SELECT_HI__PH_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000005;
    constexpr unsigned int GRBM_PERFCOUNTER1_SELECT_HI__SDMA_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000003;
    constexpr unsigned int GRBM_PERFCOUNTER1_SELECT_HI__UTCL1_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000001;
    constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__GE_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001c;
    constexpr unsigned int GRBM_PERFCOUNTER1_SELECT__TCP_BUSY_USER_DEFINED_MASK__SHIFT = 0x0000001b;
    constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__GL1CC_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000019;
    constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__TCP_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000018;
    constexpr unsigned int GRBM_SE0_PERFCOUNTER_SELECT__UTCL1_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000017;
    constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__GL1CC_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000019;
    constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__TCP_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000018;
    constexpr unsigned int GRBM_SE1_PERFCOUNTER_SELECT__UTCL1_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000017;
    constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__GL1CC_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000019;
    constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__TCP_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000018;
    constexpr unsigned int GRBM_SE2_PERFCOUNTER_SELECT__UTCL1_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000017;
    constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__GL1CC_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000019;
    constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__TCP_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000018;
    constexpr unsigned int GRBM_SE3_PERFCOUNTER_SELECT__UTCL1_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000017;
    constexpr unsigned int IA_MULTI_VGT_PARAM_PIPED__EN_INST_OPT_ADV__SHIFT   = 0x00000016;
    constexpr unsigned int IA_MULTI_VGT_PARAM_PIPED__EN_INST_OPT_BASIC__SHIFT = 0x00000015;
    constexpr unsigned int IA_MULTI_VGT_PARAM_PIPED__HW_USE_ONLY__SHIFT       = 0x00000017;
    constexpr unsigned int IA_MULTI_VGT_PARAM_PIPED__PARTIAL_ES_WAVE_ON__SHIFT = 0x00000012;
    constexpr unsigned int IA_MULTI_VGT_PARAM_PIPED__PARTIAL_VS_WAVE_ON__SHIFT = 0x00000010;
    constexpr unsigned int IA_MULTI_VGT_PARAM_PIPED__PRIMGROUP_SIZE__SHIFT    = 0x00000000;
    constexpr unsigned int IA_MULTI_VGT_PARAM_PIPED__SWITCH_ON_EOI__SHIFT     = 0x00000013;
    constexpr unsigned int IA_MULTI_VGT_PARAM_PIPED__SWITCH_ON_EOP__SHIFT     = 0x00000011;
    constexpr unsigned int IA_MULTI_VGT_PARAM_PIPED__WD_SWITCH_ON_EOP__SHIFT  = 0x00000014;
    constexpr unsigned int IA_UTCL1_CNTL__MTYPE_OVERRIDE__SHIFT               = 0x0000001d;
    constexpr unsigned int IA_UTCL1_STATUS_2__FAULT_DETECTED__SHIFT           = 0x00000005;
    constexpr unsigned int IA_UTCL1_STATUS_2__FAULT_UTCL1ID__SHIFT            = 0x00000008;
    constexpr unsigned int IA_UTCL1_STATUS_2__IA_ADC_BUSY__SHIFT              = 0x00000004;
    constexpr unsigned int IA_UTCL1_STATUS_2__IA_BUSY__SHIFT                  = 0x00000000;
    constexpr unsigned int IA_UTCL1_STATUS_2__IA_DMA_BUSY__SHIFT              = 0x00000001;
    constexpr unsigned int IA_UTCL1_STATUS_2__IA_DMA_REQ_BUSY__SHIFT          = 0x00000002;
    constexpr unsigned int IA_UTCL1_STATUS_2__IA_GRP_BUSY__SHIFT              = 0x00000003;
    constexpr unsigned int IA_UTCL1_STATUS_2__PRT_DETECTED__SHIFT             = 0x00000007;
    constexpr unsigned int IA_UTCL1_STATUS_2__PRT_UTCL1ID__SHIFT              = 0x00000018;
    constexpr unsigned int IA_UTCL1_STATUS_2__RETRY_DETECTED__SHIFT           = 0x00000006;
    constexpr unsigned int IA_UTCL1_STATUS_2__RETRY_UTCL1ID__SHIFT            = 0x00000010;
    constexpr unsigned int PA_CL_CNTL_STATUS__CL_BUSY__SHIFT                  = 0x0000001f;
    constexpr unsigned int PA_CL_ENHANCE__DISABLE_PA_PH_INTF_FINE_CLOCK_GATE__SHIFT = 0x00000016;
    constexpr unsigned int PA_CL_VS_OUT_CNTL__USE_VTX_LINE_WIDTH__SHIFT       = 0x0000001b;
    constexpr unsigned int PA_PH_ENHANCE__DISABLE_FOPKT_SCAN_POST_RESET__SHIFT = 0x00000006;
    constexpr unsigned int PA_PH_ENHANCE__DISABLE_FOPKT__SHIFT                = 0x00000005;
    constexpr unsigned int PA_PH_ENHANCE__DISABLE_PH_PERF_REG_FGCG__SHIFT     = 0x00000009;
    constexpr unsigned int PA_PH_ENHANCE__DISABLE_PH_SC_INTF_CLKEN_CLOCK_GATE__SHIFT = 0x00000007;
    constexpr unsigned int PA_PH_ENHANCE__DISABLE_PH_SC_INTF_FINE_CLOCK_GATE__SHIFT = 0x00000004;
    constexpr unsigned int PA_PH_ENHANCE__ECO_SPARE0__SHIFT                   = 0x00000000;
    constexpr unsigned int PA_PH_ENHANCE__ECO_SPARE1__SHIFT                   = 0x00000001;
    constexpr unsigned int PA_PH_ENHANCE__ECO_SPARE2__SHIFT                   = 0x00000002;
    constexpr unsigned int PA_PH_ENHANCE__ECO_SPARE3__SHIFT                   = 0x00000003;
    constexpr unsigned int PA_PH_ENHANCE__ENABLE_PH_INTF_CLKEN_STRETCH__SHIFT = 0x0000000a;
    constexpr unsigned int PA_PH_INTERFACE_FIFO_SIZE__PA_PH_IF_FIFO_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int PA_PH_INTERFACE_FIFO_SIZE__PH_SC_IF_FIFO_SIZE__SHIFT = 0x00000010;
    constexpr unsigned int PA_PH_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT      = 0x0000001c;
    constexpr unsigned int PA_PH_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT      = 0x00000018;
    constexpr unsigned int PA_PH_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT       = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT       = 0x0000000a;
    constexpr unsigned int PA_PH_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT        = 0x00000014;
    constexpr unsigned int PA_PH_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT       = 0x00000018;
    constexpr unsigned int PA_PH_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT        = 0x0000001c;
    constexpr unsigned int PA_PH_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT        = 0x0000000a;
    constexpr unsigned int PA_PH_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT         = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT      = 0x0000001c;
    constexpr unsigned int PA_PH_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT      = 0x00000018;
    constexpr unsigned int PA_PH_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT       = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT       = 0x0000000a;
    constexpr unsigned int PA_PH_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT        = 0x00000014;
    constexpr unsigned int PA_PH_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT       = 0x00000018;
    constexpr unsigned int PA_PH_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT        = 0x0000001c;
    constexpr unsigned int PA_PH_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT        = 0x0000000a;
    constexpr unsigned int PA_PH_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT         = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER2_SELECT1__PERF_MODE2__SHIFT      = 0x0000001c;
    constexpr unsigned int PA_PH_PERFCOUNTER2_SELECT1__PERF_MODE3__SHIFT      = 0x00000018;
    constexpr unsigned int PA_PH_PERFCOUNTER2_SELECT1__PERF_SEL2__SHIFT       = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER2_SELECT1__PERF_SEL3__SHIFT       = 0x0000000a;
    constexpr unsigned int PA_PH_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT        = 0x00000014;
    constexpr unsigned int PA_PH_PERFCOUNTER2_SELECT__PERF_MODE1__SHIFT       = 0x00000018;
    constexpr unsigned int PA_PH_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT        = 0x0000001c;
    constexpr unsigned int PA_PH_PERFCOUNTER2_SELECT__PERF_SEL1__SHIFT        = 0x0000000a;
    constexpr unsigned int PA_PH_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT         = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER3_SELECT1__PERF_MODE2__SHIFT      = 0x0000001c;
    constexpr unsigned int PA_PH_PERFCOUNTER3_SELECT1__PERF_MODE3__SHIFT      = 0x00000018;
    constexpr unsigned int PA_PH_PERFCOUNTER3_SELECT1__PERF_SEL2__SHIFT       = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER3_SELECT1__PERF_SEL3__SHIFT       = 0x0000000a;
    constexpr unsigned int PA_PH_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT        = 0x00000014;
    constexpr unsigned int PA_PH_PERFCOUNTER3_SELECT__PERF_MODE1__SHIFT       = 0x00000018;
    constexpr unsigned int PA_PH_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT        = 0x0000001c;
    constexpr unsigned int PA_PH_PERFCOUNTER3_SELECT__PERF_SEL1__SHIFT        = 0x0000000a;
    constexpr unsigned int PA_PH_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT         = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER4_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER4_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER4_SELECT__PERF_SEL__SHIFT         = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER5_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER5_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER5_SELECT__PERF_SEL__SHIFT         = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER6_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER6_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER6_SELECT__PERF_SEL__SHIFT         = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER7_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER7_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
    constexpr unsigned int PA_PH_PERFCOUNTER7_SELECT__PERF_SEL__SHIFT         = 0x00000000;
    constexpr unsigned int PA_SC_BC_WAVE_BREAK__MAX_DEALLOCS_IN_WAVE__SHIFT   = 0x00000000;
    constexpr unsigned int PA_SC_BC_WAVE_BREAK__MAX_FPOVS_IN_WAVE__SHIFT      = 0x00000010;
    constexpr unsigned int PA_SC_BINNER_CNTL_0__BIN_MAPPING_MODE__SHIFT       = 0x0000001d;
    constexpr unsigned int PA_SC_BINNER_CNTL_OVERRIDE__BINNING_MODE__SHIFT    = 0x00000000;
    constexpr unsigned int PA_SC_BINNER_CNTL_OVERRIDE__CONTEXT_STATES_PER_BIN__SHIFT = 0x0000000a;
    constexpr unsigned int PA_SC_BINNER_CNTL_OVERRIDE__DIRECT_OVERRIDE_MODE__SHIFT = 0x0000001b;
    constexpr unsigned int PA_SC_BINNER_CNTL_OVERRIDE__FPOVS_PER_BATCH__SHIFT = 0x00000013;
    constexpr unsigned int PA_SC_BINNER_CNTL_OVERRIDE__OVERRIDE__SHIFT        = 0x0000001c;
    constexpr unsigned int PA_SC_BINNER_CNTL_OVERRIDE__PERSISTENT_STATES_PER_BIN__SHIFT = 0x0000000d;
    constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_1__BIN_CONF_OVERRIDE_CHECK__SHIFT = 0x0000001a;
    constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__RESERVED_35__SHIFT      = 0x00000006;
    constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_2__RESERVED_41__SHIFT      = 0x00000012;
    constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__DRAW_DONE__SHIFT        = 0x0000001e;
    constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__RESERVED_50__SHIFT      = 0x00000004;
    constexpr unsigned int PA_SC_BINNER_EVENT_CNTL_3__THREAD_TRACE_DRAW__SHIFT = 0x0000000c;
    constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__UNCERTAINTY_REGION_MULT__SHIFT = 0x00000019;
    constexpr unsigned int PA_SC_CONSERVATIVE_RASTERIZATION_CNTL__UNCERTAINTY_REGION_PBB_MULT__SHIFT = 0x0000001b;
    constexpr unsigned int PA_SC_ENHANCE_1__DEBUG_PIXEL_PICKER_COUNT_PIXELS__SHIFT = 0x0000000d;
    constexpr unsigned int PA_SC_ENHANCE_2__BREAK_WHEN_ONE_NULL_PRIM_BATCH__SHIFT = 0x0000001a;
    constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_BREAK_BATCH_ON_GFX_PIPELINE_RESET__SHIFT = 0x00000012;
    constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_BREAK_BATCH_ON_GFX_PIPE_SWITCH__SHIFT = 0x00000008;
    constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_DFSM_FLUSH__SHIFT         = 0x00000019;
    constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_EXPOSED_GT_DETAIL_RATE_TILE_COV_ADJ__SHIFT = 0x0000000f;
    constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_FULL_TILE_WAVE_BREAK__SHIFT = 0x00000009;
    constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_PACKER_GRAD_FDCE_ENHANCE__SHIFT = 0x0000000c;
    constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_PBB_EOP_INSERTION_FOR_MIXED_BINNING_AND_IMMEDIATE__SHIFT = 0x00000018;
    constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_SC_BCI_INTF_EARLY_WAKEUP__SHIFT = 0x0000000e;
    constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_SC_DBR_DATAPATH_FGCG__SHIFT = 0x00000015;
    constexpr unsigned int PA_SC_ENHANCE_2__DISABLE_SC_SPI_INTF_EARLY_WAKEUP__SHIFT = 0x0000000d;
    constexpr unsigned int PA_SC_ENHANCE_2__ENABLE_FPOV_WAVE_BREAK__SHIFT     = 0x00000005;
    constexpr unsigned int PA_SC_ENHANCE_2__ENABLE_LPOV_WAVE_BREAK__SHIFT     = 0x00000004;
    constexpr unsigned int PA_SC_ENHANCE_2__ENABLE_SC_SEND_DB_VPZ_FOR_EN_PRIM_PAYLOAD__SHIFT = 0x00000007;
    constexpr unsigned int PA_SC_ENHANCE_2__ENABLE_VPZ_INJECTION_BEFORE_NULL_PRIMS__SHIFT = 0x0000000a;
    constexpr unsigned int PA_SC_ENHANCE_2__NULL_PRIM_BREAK_BATCH_LIMIT__SHIFT = 0x0000001b;
    constexpr unsigned int PA_SC_ENHANCE_2__PBB_MAIN_CLK_REG_BUSY_WAKEUP__SHIFT = 0x00000011;
    constexpr unsigned int PA_SC_ENHANCE_2__PBB_TIMEOUT_THRESHOLD_MODE__SHIFT = 0x0000000b;
    constexpr unsigned int PA_SC_ENHANCE_2__PBB_WARP_CLK_MAIN_CLK_WAKEUP__SHIFT = 0x00000010;
    constexpr unsigned int PA_SC_ENHANCE_2__PROCESS_RESET_FORCE_STILE_MASK_TO_ZERO__SHIFT = 0x00000017;
    constexpr unsigned int PA_SC_NGG_MODE_CNTL__MAX_FPOVS_IN_WAVE__SHIFT      = 0x00000010;
    constexpr unsigned int PA_SC_PBB_OVERRIDE_FLAG__OVERRIDE__SHIFT           = 0x00000000;
    constexpr unsigned int PA_SC_PBB_OVERRIDE_FLAG__PIPE_ID__SHIFT            = 0x00000001;
    constexpr unsigned int PA_SC_RASTER_CONFIG_1__SE_PAIR_YSEL__SHIFT         = 0x00000004;
    constexpr unsigned int PA_SC_RASTER_CONFIG__SE_YSEL__SHIFT                = 0x0000001c;
    constexpr unsigned int PA_SC_SHADER_CONTROL__WAVE_BREAK_REGION_SIZE__SHIFT = 0x00000005;
    constexpr unsigned int PA_SC_TILE_STEERING_CREST_OVERRIDE__FORCE_TILE_STEERING_OVERRIDE_USE__SHIFT = 0x0000001f;
    constexpr unsigned int PA_SC_TILE_STEERING_CREST_OVERRIDE__SA_SELECT__SHIFT = 0x00000008;
    constexpr unsigned int PA_SC_TILE_STEERING_OVERRIDE__NUM_PACKER_PER_SC__SHIFT = 0x00000014;
    constexpr unsigned int PA_SC_TILE_STEERING_OVERRIDE__NUM_RB_PER_SC__SHIFT = 0x00000010;
    constexpr unsigned int PA_SC_TILE_STEERING_OVERRIDE__NUM_SC__SHIFT        = 0x0000000c;
    constexpr unsigned int PA_STATE_STEREO_X__STEREO_X_OFFSET__SHIFT          = 0x00000000;
    constexpr unsigned int PA_STEREO_CNTL__RT_SLICE_MODE__SHIFT               = 0x00000005;
    constexpr unsigned int PA_STEREO_CNTL__RT_SLICE_OFFSET__SHIFT             = 0x00000008;
    constexpr unsigned int PA_STEREO_CNTL__STEREO_MODE__SHIFT                 = 0x00000001;
    constexpr unsigned int PA_STEREO_CNTL__VP_ID_MODE__SHIFT                  = 0x00000010;
    constexpr unsigned int PA_STEREO_CNTL__VP_ID_OFFSET__SHIFT                = 0x00000013;
    constexpr unsigned int PA_SU_PERFCOUNTER2_SELECT1__PERF_MODE2__SHIFT      = 0x0000001c;
    constexpr unsigned int PA_SU_PERFCOUNTER2_SELECT1__PERF_MODE3__SHIFT      = 0x00000018;
    constexpr unsigned int PA_SU_PERFCOUNTER2_SELECT1__PERF_SEL2__SHIFT       = 0x00000000;
    constexpr unsigned int PA_SU_PERFCOUNTER2_SELECT1__PERF_SEL3__SHIFT       = 0x0000000a;
    constexpr unsigned int PA_SU_PERFCOUNTER2_SELECT__PERF_MODE1__SHIFT       = 0x00000018;
    constexpr unsigned int PA_SU_PERFCOUNTER2_SELECT__PERF_SEL1__SHIFT        = 0x0000000a;
    constexpr unsigned int PA_SU_PERFCOUNTER3_SELECT1__PERF_MODE2__SHIFT      = 0x0000001c;
    constexpr unsigned int PA_SU_PERFCOUNTER3_SELECT1__PERF_MODE3__SHIFT      = 0x00000018;
    constexpr unsigned int PA_SU_PERFCOUNTER3_SELECT1__PERF_SEL2__SHIFT       = 0x00000000;
    constexpr unsigned int PA_SU_PERFCOUNTER3_SELECT1__PERF_SEL3__SHIFT       = 0x0000000a;
    constexpr unsigned int PA_SU_PERFCOUNTER3_SELECT__PERF_MODE1__SHIFT       = 0x00000018;
    constexpr unsigned int PA_SU_PERFCOUNTER3_SELECT__PERF_SEL1__SHIFT        = 0x0000000a;
    constexpr unsigned int PA_SU_SC_MODE_CNTL__KEEP_TOGETHER_ENABLE__SHIFT    = 0x00000018;
    constexpr unsigned int RLC_SPM_DESER_START_SKEW__DESER_START_SKEW__SHIFT  = 0x00000000;
    constexpr unsigned int RLC_SPM_DESER_START_SKEW__RESERVED__SHIFT          = 0x00000007;
    constexpr unsigned int RLC_SPM_GLB_SAMPLEDELAY_IND_ADDR__GLB_SAMPLEDELAY_INDEX__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_GLB_SAMPLEDELAY_IND_DATA__data__SHIFT      = 0x00000000;
    constexpr unsigned int RLC_SPM_GLB_SAMPLEDELAY_IND_DATA__RESERVED__SHIFT  = 0x00000007;
    constexpr unsigned int RLC_SPM_GLOBALS_MUXSEL_SKEW__GLOBALS_MUXSEL_SKEW__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_GLOBALS_MUXSEL_SKEW__RESERVED__SHIFT       = 0x00000007;
    constexpr unsigned int RLC_SPM_GLOBALS_SAMPLE_SKEW__GLOBALS_SAMPLE_SKEW__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_GLOBALS_SAMPLE_SKEW__RESERVED__SHIFT       = 0x00000007;
    constexpr unsigned int RLC_SPM_GLOBAL_MUXSEL_ADDR__RESERVED__SHIFT        = 0x00000008;
    constexpr unsigned int RLC_SPM_INT_INFO_1__INTERRUPT_INFO_1__SHIFT        = 0x00000000;
    constexpr unsigned int RLC_SPM_INT_INFO_2__INTERRUPT_ID__SHIFT            = 0x00000010;
    constexpr unsigned int RLC_SPM_INT_INFO_2__INTERRUPT_INFO_2__SHIFT        = 0x00000000;
    constexpr unsigned int RLC_SPM_INT_INFO_2__RESERVED__SHIFT                = 0x00000018;
    constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_FED__SHIFT                = 0x00000007;
    constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_MTYPE_OVER__SHIFT         = 0x00000008;
    constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_MTYPE__SHIFT              = 0x00000009;
    constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_NOFILL__SHIFT             = 0x0000000f;
    constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_PERF_CNTR__SHIFT          = 0x00000006;
    constexpr unsigned int RLC_SPM_PERFMON_CNTL__RESERVED1__SHIFT             = 0x00000000;
    constexpr unsigned int RLC_SPM_PERFMON_GLB_SEGMENT_SIZE__GLOBAL_NUM_LINE__SHIFT = 0x00000008;
    constexpr unsigned int RLC_SPM_PERFMON_GLB_SEGMENT_SIZE__PERFMON_SEGMENT_SIZE__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_PERFMON_GLB_SEGMENT_SIZE__RESERVED__SHIFT  = 0x00000010;
    constexpr unsigned int RLC_SPM_PERFMON_SE3TO0_SEGMENT_SIZE__SE0_NUM_LINE__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_PERFMON_SE3TO0_SEGMENT_SIZE__SE1_NUM_LINE__SHIFT = 0x00000008;
    constexpr unsigned int RLC_SPM_PERFMON_SE3TO0_SEGMENT_SIZE__SE2_NUM_LINE__SHIFT = 0x00000010;
    constexpr unsigned int RLC_SPM_PERFMON_SE3TO0_SEGMENT_SIZE__SE3_NUM_LINE__SHIFT = 0x00000018;
    constexpr unsigned int RLC_SPM_RING_WRPTR__PERFMON_RING_WRPTR__SHIFT      = 0x00000005;
    constexpr unsigned int RLC_SPM_RING_WRPTR__RESERVED__SHIFT                = 0x00000000;
    constexpr unsigned int RLC_SPM_SAMPLE_CNT__COUNT__SHIFT                   = 0x00000000;
    constexpr unsigned int RLC_SPM_SEGMENT_THRESHOLD__RESERVED__SHIFT         = 0x00000008;
    constexpr unsigned int RLC_SPM_SE_MUXSEL_ADDR__RESERVED__SHIFT            = 0x00000009;
    constexpr unsigned int RLC_SPM_SE_MUXSEL_SKEW__RESERVED__SHIFT            = 0x00000007;
    constexpr unsigned int RLC_SPM_SE_MUXSEL_SKEW__SE_MUXSEL_SKEW__SHIFT      = 0x00000000;
    constexpr unsigned int RLC_SPM_SE_SAMPLEDELAY_IND_ADDR__SE_SAMPLEDELAY_INDEX__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_SE_SAMPLEDELAY_IND_DATA__data__SHIFT       = 0x00000000;
    constexpr unsigned int RLC_SPM_SE_SAMPLEDELAY_IND_DATA__RESERVED__SHIFT   = 0x00000007;
    constexpr unsigned int RLC_SPM_SE_SAMPLE_SKEW__RESERVED__SHIFT            = 0x00000007;
    constexpr unsigned int RLC_SPM_SE_SAMPLE_SKEW__SE_SAMPLE_SKEW__SHIFT      = 0x00000000;
    constexpr unsigned int RLC_SPM_THREAD_TRACE_CTRL__THREAD_TRACE_INT_EN__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_VIRT_CTRL__PauseSpmSamplingRequest__SHIFT  = 0x00000000;
    constexpr unsigned int RLC_SPM_VIRT_STATUS__SpmSamplingPaused__SHIFT      = 0x00000000;
    constexpr unsigned int RMI_PERF_COUNTER_CNTL__PERF_EVENT_WINDOW_MASK1__SHIFT = 0x00000008;
    constexpr unsigned int SPI_CONFIG_CNTL_1__EN_USER_ACCUM__SHIFT            = 0x00000015;
    constexpr unsigned int SPI_CONFIG_CNTL_1__MAX_VTX_SYNC_CNT__SHIFT         = 0x00000010;
    constexpr unsigned int SPI_CONFIG_CNTL_1__PC_LIMIT_ENABLE__SHIFT          = 0x00000005;
    constexpr unsigned int SPI_DSM_CNTL2__SPI_SR_MEM_INJECT_DELAY__SHIFT      = 0x00000003;
    constexpr unsigned int SPI_LB_DATA_PERWGP_WAVE_CS__ACTIVE__SHIFT          = 0x00000000;
    constexpr unsigned int SPI_LB_DATA_PERWGP_WAVE_HSGS__WGP_USED_GS__SHIFT   = 0x00000010;
    constexpr unsigned int SPI_LB_DATA_PERWGP_WAVE_HSGS__WGP_USED_HS__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_LB_DATA_PERWGP_WAVE_VSPS__WGP_USED_PS__SHIFT   = 0x00000010;
    constexpr unsigned int SPI_LB_DATA_PERWGP_WAVE_VSPS__WGP_USED_VS__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_LB_WGP_MASK__WGP_MASK__SHIFT                   = 0x00000000;
    constexpr unsigned int SPI_PG_ENABLE_STATIC_WGP_MASK__WGP_MASK__SHIFT     = 0x00000000;
    constexpr unsigned int SPI_PQEV_CTRL__COMPUTE_PIPE_EN__SHIFT              = 0x00000010;
    constexpr unsigned int SPI_PQEV_CTRL__QUEUE_DURATION__SHIFT               = 0x0000000a;
    constexpr unsigned int SPI_PQEV_CTRL__SCAN_PERIOD__SHIFT                  = 0x00000000;
    constexpr unsigned int SPI_PS_IN_CONTROL__PS_W32_EN__SHIFT                = 0x0000000f;
    constexpr unsigned int SPI_SHADER_IDX_FORMAT__IDX0_EXPORT_FORMAT__SHIFT   = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_HI_ES_GS__MEM_BASE__SHIFT           = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_HI_LS_HS__MEM_BASE__SHIFT           = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_LO_ES_GS__MEM_BASE__SHIFT           = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_LO_LS_HS__MEM_BASE__SHIFT           = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__FWD_PROGRESS__SHIFT       = 0x0000001a;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__MEM_ORDERED__SHIFT        = 0x00000019;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_GS__WGP_MODE__SHIFT           = 0x0000001b;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__FWD_PROGRESS__SHIFT       = 0x00000019;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__MEM_ORDERED__SHIFT        = 0x00000018;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_HS__WGP_MODE__SHIFT           = 0x0000001a;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__FWD_PROGRESS__SHIFT       = 0x0000001a;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_PS__MEM_ORDERED__SHIFT        = 0x00000019;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_VS__FWD_PROGRESS__SHIFT       = 0x0000001c;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_VS__MEM_ORDERED__SHIFT        = 0x0000001b;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__SHARED_VGPR_CNT__SHIFT    = 0x0000001c;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_GS__USER_SGPR_MSB__SHIFT      = 0x0000001b;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__EXCP_EN__SHIFT            = 0x00000009;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__LDS_SIZE__SHIFT           = 0x00000012;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__OC_LDS_EN__SHIFT          = 0x00000007;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__SHARED_VGPR_CNT__SHIFT    = 0x0000001c;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__TG_SIZE_EN__SHIFT         = 0x00000008;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_HS__USER_SGPR_MSB__SHIFT      = 0x0000001b;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__SHARED_VGPR_CNT__SHIFT    = 0x0000001c;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_PS__USER_SGPR_MSB__SHIFT      = 0x0000001b;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__SHARED_VGPR_CNT__SHIFT    = 0x0000001c;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__USER_SGPR_MSB__SHIFT      = 0x0000001b;
    constexpr unsigned int SPI_SHADER_PGM_RSRC3_GS__GROUP_FIFO_DEPTH__SHIFT   = 0x0000001a;
    constexpr unsigned int SPI_SHADER_PGM_RSRC3_HS__GROUP_FIFO_DEPTH__SHIFT   = 0x0000000a;
    constexpr unsigned int SPI_SHADER_PGM_RSRC4_GS__CU_EN__SHIFT              = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_RSRC4_GS__SPI_SHADER_LATE_ALLOC_GS__SHIFT = 0x00000010;
    constexpr unsigned int SPI_SHADER_PGM_RSRC4_HS__CU_EN__SHIFT              = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_RSRC4_PS__CU_EN__SHIFT              = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_RSRC4_VS__CU_EN__SHIFT              = 0x00000000;
    constexpr unsigned int SPI_SHADER_POS_FORMAT__POS4_EXPORT_FORMAT__SHIFT   = 0x00000010;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_ESGS__ALLOCATION_RATE_THROTTLING_THRESHOLD__SHIFT = 0x00000011;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_ESGS__GLOBAL_SCANNING_EN__SHIFT = 0x00000010;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_ESGS__HARD_LOCK_HYSTERESIS__SHIFT = 0x00000009;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_ESGS__HARD_LOCK_LOW_THRESHOLD__SHIFT = 0x0000000a;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_ESGS__NUMBER_OF_REQUESTS_PER_CU__SHIFT = 0x00000001;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_ESGS__PRODUCER_REQUEST_LOCKOUT__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_ESGS__SOFT_GROUPING_ALLOCATION_TIMEOUT__SHIFT = 0x00000005;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_ESGS__SOFT_GROUPING_EN__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_LSHS__ALLOCATION_RATE_THROTTLING_THRESHOLD__SHIFT = 0x00000011;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_LSHS__GLOBAL_SCANNING_EN__SHIFT = 0x00000010;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_LSHS__HARD_LOCK_HYSTERESIS__SHIFT = 0x00000009;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_LSHS__HARD_LOCK_LOW_THRESHOLD__SHIFT = 0x0000000a;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_LSHS__NUMBER_OF_REQUESTS_PER_CU__SHIFT = 0x00000001;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_LSHS__PRODUCER_REQUEST_LOCKOUT__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_LSHS__SOFT_GROUPING_ALLOCATION_TIMEOUT__SHIFT = 0x00000005;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_LSHS__SOFT_GROUPING_EN__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_PS__ALLOCATION_RATE_THROTTLING_THRESHOLD__SHIFT = 0x00000011;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_PS__GLOBAL_SCANNING_EN__SHIFT  = 0x00000010;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_PS__HARD_LOCK_HYSTERESIS__SHIFT = 0x00000009;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_PS__HARD_LOCK_LOW_THRESHOLD__SHIFT = 0x0000000a;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_PS__NUMBER_OF_REQUESTS_PER_CU__SHIFT = 0x00000001;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_PS__PRODUCER_REQUEST_LOCKOUT__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_PS__SOFT_GROUPING_ALLOCATION_TIMEOUT__SHIFT = 0x00000005;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_PS__SOFT_GROUPING_EN__SHIFT    = 0x00000000;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_VS__ALLOCATION_RATE_THROTTLING_THRESHOLD__SHIFT = 0x00000011;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_VS__GLOBAL_SCANNING_EN__SHIFT  = 0x00000010;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_VS__HARD_LOCK_HYSTERESIS__SHIFT = 0x00000009;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_VS__HARD_LOCK_LOW_THRESHOLD__SHIFT = 0x0000000a;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_VS__NUMBER_OF_REQUESTS_PER_CU__SHIFT = 0x00000001;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_VS__PRODUCER_REQUEST_LOCKOUT__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_VS__SOFT_GROUPING_ALLOCATION_TIMEOUT__SHIFT = 0x00000005;
    constexpr unsigned int SPI_SHADER_REQ_CTRL_VS__SOFT_GROUPING_EN__SHIFT    = 0x00000000;
    constexpr unsigned int SPI_SHADER_RSRC_LIMIT_CTRL__BARRIER_LIMIT_HIERARCHY_LEVEL__SHIFT = 0x00000013;
    constexpr unsigned int SPI_SHADER_RSRC_LIMIT_CTRL__BARRIER_LIMIT__SHIFT   = 0x0000000d;
    constexpr unsigned int SPI_SHADER_RSRC_LIMIT_CTRL__LDS_LIMIT_HIERARCHY_LEVEL__SHIFT = 0x0000001c;
    constexpr unsigned int SPI_SHADER_RSRC_LIMIT_CTRL__LDS_LIMIT__SHIFT       = 0x00000014;
    constexpr unsigned int SPI_SHADER_RSRC_LIMIT_CTRL__PERFORMANCE_LIMIT_ENABLE__SHIFT = 0x0000001f;
    constexpr unsigned int SPI_SHADER_RSRC_LIMIT_CTRL__VGPR_PER_SIMD32__SHIFT = 0x00000005;
    constexpr unsigned int SPI_SHADER_RSRC_LIMIT_CTRL__VGPR_WRAP_DISABLE__SHIFT = 0x0000000c;
    constexpr unsigned int SPI_SHADER_RSRC_LIMIT_CTRL__WAVES_PER_SIMD32__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_ESGS_0__CONTRIBUTION__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_ESGS_1__CONTRIBUTION__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_ESGS_2__CONTRIBUTION__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_ESGS_3__CONTRIBUTION__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_LSHS_0__CONTRIBUTION__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_LSHS_1__CONTRIBUTION__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_LSHS_2__CONTRIBUTION__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_LSHS_3__CONTRIBUTION__SHIFT  = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_PS_0__CONTRIBUTION__SHIFT    = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_PS_1__CONTRIBUTION__SHIFT    = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_PS_2__CONTRIBUTION__SHIFT    = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_PS_3__CONTRIBUTION__SHIFT    = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_VS_0__CONTRIBUTION__SHIFT    = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_VS_1__CONTRIBUTION__SHIFT    = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_VS_2__CONTRIBUTION__SHIFT    = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_ACCUM_VS_3__CONTRIBUTION__SHIFT    = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_0__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_1__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_2__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_3__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_4__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_5__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_6__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_7__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_8__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_9__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_10__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_11__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_12__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_13__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_14__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_15__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_16__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_17__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_18__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_19__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_20__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_21__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_22__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_23__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_24__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_25__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_26__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_27__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_28__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_29__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_30__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_GS_31__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_0__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_1__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_2__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_3__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_4__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_5__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_6__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_7__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_8__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_9__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_10__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_11__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_12__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_13__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_14__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_15__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_16__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_17__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_18__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_19__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_20__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_21__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_22__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_23__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_24__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_25__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_26__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_27__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_28__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_29__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_30__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_HS_31__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_START_PHASE__PC_X_PHASE_SE0__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_START_PHASE__PC_X_PHASE_SE1__SHIFT             = 0x00000002;
    constexpr unsigned int SPI_START_PHASE__PC_X_PHASE_SE2__SHIFT             = 0x00000004;
    constexpr unsigned int SPI_START_PHASE__PC_X_PHASE_SE3__SHIFT             = 0x00000006;
    constexpr unsigned int SPI_USER_ACCUM_VMID_CNTL__EN_USER_ACCUM__SHIFT     = 0x00000000;
    constexpr unsigned int SPI_VS_OUT_CONFIG__NO_PC_EXPORT__SHIFT             = 0x00000007;
    constexpr unsigned int SQ_ALU_CLK_CTRL__FORCE_WGP_ON_SA0__SHIFT           = 0x00000000;
    constexpr unsigned int SQ_ALU_CLK_CTRL__FORCE_WGP_ON_SA1__SHIFT           = 0x00000010;
    constexpr unsigned int SQ_ARB_CONFIG__FWD_PROG_INTERVAL__SHIFT            = 0x00000004;
    constexpr unsigned int SQ_ARB_CONFIG__WG_RR_INTERVAL__SHIFT               = 0x00000000;
    constexpr unsigned int SQ_CONFIG__LDS_BUSY_HYSTERESIS_CNT__SHIFT          = 0x0000000d;
    constexpr unsigned int SQ_CONFIG__SP_BUSY_HYSTERESIS_CNT__SHIFT           = 0x0000000f;
    constexpr unsigned int SQ_CONFIG__TA_BUSY_HYSTERESIS_CNT__SHIFT           = 0x0000001e;
    constexpr unsigned int SQ_CONFIG__UNUSED__SHIFT                           = 0x00000000;
    constexpr unsigned int SQ_CONFIG__VGPR_SWIZZLE_EN__SHIFT                  = 0x0000000c;
    constexpr unsigned int SQ_FIFO_SIZES__EXPORT_BUF_PS_RESERVED__SHIFT       = 0x0000000e;
    constexpr unsigned int SQ_FIFO_SIZES__EXPORT_BUF_REDUCE__SHIFT            = 0x00000010;
    constexpr unsigned int SQ_FIFO_SIZES__EXPORT_BUF_VS_RESERVED__SHIFT       = 0x0000000c;
    constexpr unsigned int SQ_IND_INDEX__AUTO_INCR__SHIFT                     = 0x0000000b;
    constexpr unsigned int SQ_IND_INDEX__WORKITEM_ID__SHIFT                   = 0x00000005;
    constexpr unsigned int SQ_LB_CTR_SEL0__DIV0__SHIFT                        = 0x0000000f;
    constexpr unsigned int SQ_LB_CTR_SEL0__DIV1__SHIFT                        = 0x0000001f;
    constexpr unsigned int SQ_LB_CTR_SEL0__SEL0__SHIFT                        = 0x00000000;
    constexpr unsigned int SQ_LB_CTR_SEL0__SEL1__SHIFT                        = 0x00000010;
    constexpr unsigned int SQ_LB_CTR_SEL1__DIV2__SHIFT                        = 0x0000000f;
    constexpr unsigned int SQ_LB_CTR_SEL1__DIV3__SHIFT                        = 0x0000001f;
    constexpr unsigned int SQ_LB_CTR_SEL1__SEL2__SHIFT                        = 0x00000000;
    constexpr unsigned int SQ_LB_CTR_SEL1__SEL3__SHIFT                        = 0x00000010;
    constexpr unsigned int SQ_LDS_CLK_CTRL__FORCE_WGP_ON_SA0__SHIFT           = 0x00000000;
    constexpr unsigned int SQ_LDS_CLK_CTRL__FORCE_WGP_ON_SA1__SHIFT           = 0x00000010;
    constexpr unsigned int SQ_RUNTIME_CONFIG__UNUSED_REGISTER__SHIFT          = 0x00000000;
    constexpr unsigned int SQ_SHADER_TBA_HI__TRAP_EN__SHIFT                   = 0x0000001f;
    constexpr unsigned int SQ_TEX_CLK_CTRL__FORCE_WGP_ON_SA0__SHIFT           = 0x00000000;
    constexpr unsigned int SQ_TEX_CLK_CTRL__FORCE_WGP_ON_SA1__SHIFT           = 0x00000010;
    constexpr unsigned int SQ_THREAD_TRACE_BUF0_BASE__BASE_LO__SHIFT          = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_BUF0_SIZE__BASE_HI__SHIFT          = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_BUF0_SIZE__SIZE__SHIFT             = 0x00000008;
    constexpr unsigned int SQ_THREAD_TRACE_BUF1_BASE__BASE_LO__SHIFT          = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_BUF1_SIZE__BASE_HI__SHIFT          = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_BUF1_SIZE__SIZE__SHIFT             = 0x00000008;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__ALL_VMID__SHIFT              = 0x00000002;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__CAPTURE_ALL__SHIFT           = 0x0000001e;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__CH_PERF_EN__SHIFT            = 0x00000003;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__DOUBLE_BUFFER__SHIFT         = 0x00000005;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__DRAW_EVENT_EN__SHIFT         = 0x0000001f;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__HIWATER__SHIFT               = 0x00000006;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__INTERRUPT_EN__SHIFT          = 0x00000004;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__MODE__SHIFT                  = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__REG_DROP_ON_STALL__SHIFT     = 0x0000000c;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__REG_STALL_EN__SHIFT          = 0x00000009;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__RT_FREQ__SHIFT               = 0x00000010;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__SPI_STALL_EN__SHIFT          = 0x0000000a;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__SQ_STALL_EN__SHIFT           = 0x0000000b;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__SYNC_COUNT_DRAWS__SHIFT      = 0x00000013;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__SYNC_COUNT_MARKERS__SHIFT    = 0x00000012;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__UTIL_TIMER__SHIFT            = 0x0000000d;
    constexpr unsigned int SQ_THREAD_TRACE_CTRL__WAVESTART_MODE__SHIFT        = 0x0000000e;
    constexpr unsigned int SQ_THREAD_TRACE_DROPPED_CNTR__CNTR__SHIFT          = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_GFX_DRAW_CNTR__CNTR__SHIFT         = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_GFX_MARKER_CNTR__CNTR__SHIFT       = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_HP3D_DRAW_CNTR__CNTR__SHIFT        = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_HP3D_MARKER_CNTR__CNTR__SHIFT      = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_MASK__SA_SEL__SHIFT                = 0x00000009;
    constexpr unsigned int SQ_THREAD_TRACE_MASK__SIMD_SEL__SHIFT              = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_MASK__WGP_SEL__SHIFT               = 0x00000004;
    constexpr unsigned int SQ_THREAD_TRACE_MASK__WTYPE_INCLUDE__SHIFT         = 0x0000000a;
    constexpr unsigned int SQ_THREAD_TRACE_STATUS__BUSY__SHIFT                = 0x00000019;
    constexpr unsigned int SQ_THREAD_TRACE_STATUS__EVENT_CNTR_OVERFLOW__SHIFT = 0x0000001a;
    constexpr unsigned int SQ_THREAD_TRACE_STATUS__EVENT_CNTR_STALL__SHIFT    = 0x0000001b;
    constexpr unsigned int SQ_THREAD_TRACE_STATUS__FINISH_DONE__SHIFT         = 0x0000000c;
    constexpr unsigned int SQ_THREAD_TRACE_STATUS__UTC_ERR__SHIFT             = 0x00000018;
    constexpr unsigned int SQ_THREAD_TRACE_TOKEN_MASK__INST_EXCLUDE__SHIFT    = 0x00000018;
    constexpr unsigned int SQ_THREAD_TRACE_TOKEN_MASK__REG_DETAIL_ALL__SHIFT  = 0x0000001f;
    constexpr unsigned int SQ_THREAD_TRACE_TOKEN_MASK__REG_INCLUDE__SHIFT     = 0x00000010;
    constexpr unsigned int SQ_THREAD_TRACE_TOKEN_MASK__TOKEN_EXCLUDE__SHIFT   = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_USERDATA_4__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_USERDATA_5__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_USERDATA_6__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_USERDATA_7__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SQ_THREAD_TRACE_WPTR__BUFFER_ID__SHIFT             = 0x0000001f;
    constexpr unsigned int SQ_THREAD_TRACE_WPTR__OFFSET__SHIFT                = 0x00000000;
    constexpr unsigned int SQ_WATCH0_ADDR_H__ADDR__SHIFT                      = 0x00000000;
    constexpr unsigned int SQ_WATCH0_ADDR_L__ADDR__SHIFT                      = 0x00000006;
    constexpr unsigned int SQ_WATCH0_CNTL__MASK__SHIFT                        = 0x00000000;
    constexpr unsigned int SQ_WATCH0_CNTL__VALID__SHIFT                       = 0x0000001f;
    constexpr unsigned int SQ_WATCH0_CNTL__VMID__SHIFT                        = 0x00000018;
    constexpr unsigned int SQ_WATCH1_ADDR_H__ADDR__SHIFT                      = 0x00000000;
    constexpr unsigned int SQ_WATCH1_ADDR_L__ADDR__SHIFT                      = 0x00000006;
    constexpr unsigned int SQ_WATCH1_CNTL__MASK__SHIFT                        = 0x00000000;
    constexpr unsigned int SQ_WATCH1_CNTL__VALID__SHIFT                       = 0x0000001f;
    constexpr unsigned int SQ_WATCH1_CNTL__VMID__SHIFT                        = 0x00000018;
    constexpr unsigned int SQ_WATCH2_ADDR_H__ADDR__SHIFT                      = 0x00000000;
    constexpr unsigned int SQ_WATCH2_ADDR_L__ADDR__SHIFT                      = 0x00000006;
    constexpr unsigned int SQ_WATCH2_CNTL__MASK__SHIFT                        = 0x00000000;
    constexpr unsigned int SQ_WATCH2_CNTL__VALID__SHIFT                       = 0x0000001f;
    constexpr unsigned int SQ_WATCH2_CNTL__VMID__SHIFT                        = 0x00000018;
    constexpr unsigned int SQ_WATCH3_ADDR_H__ADDR__SHIFT                      = 0x00000000;
    constexpr unsigned int SQ_WATCH3_ADDR_L__ADDR__SHIFT                      = 0x00000006;
    constexpr unsigned int SQ_WATCH3_CNTL__MASK__SHIFT                        = 0x00000000;
    constexpr unsigned int SQ_WATCH3_CNTL__VALID__SHIFT                       = 0x0000001f;
    constexpr unsigned int SQ_WATCH3_CNTL__VMID__SHIFT                        = 0x00000018;
    constexpr unsigned int SQ_WAVE_FLAT_SCRATCH_HI__DATA__SHIFT               = 0x00000000;
    constexpr unsigned int SQ_WAVE_FLAT_SCRATCH_LO__DATA__SHIFT               = 0x00000000;
    constexpr unsigned int SQ_WAVE_HW_ID1__SA_ID__SHIFT                       = 0x00000010;
    constexpr unsigned int SQ_WAVE_HW_ID1__SE_ID__SHIFT                       = 0x00000012;
    constexpr unsigned int SQ_WAVE_HW_ID1__SIMD_ID__SHIFT                     = 0x00000008;
    constexpr unsigned int SQ_WAVE_HW_ID1__WAVE_ID__SHIFT                     = 0x00000000;
    constexpr unsigned int SQ_WAVE_HW_ID1__WGP_ID__SHIFT                      = 0x0000000a;
    constexpr unsigned int SQ_WAVE_HW_ID2__ME_ID__SHIFT                       = 0x00000008;
    constexpr unsigned int SQ_WAVE_HW_ID2__PIPE_ID__SHIFT                     = 0x00000004;
    constexpr unsigned int SQ_WAVE_HW_ID2__QUEUE_ID__SHIFT                    = 0x00000000;
    constexpr unsigned int SQ_WAVE_HW_ID2__STATE_ID__SHIFT                    = 0x0000000c;
    constexpr unsigned int SQ_WAVE_HW_ID2__VM_ID__SHIFT                       = 0x00000018;
    constexpr unsigned int SQ_WAVE_HW_ID2__WG_ID__SHIFT                       = 0x00000010;
    constexpr unsigned int SQ_WAVE_IB_STS2__FWD_PROGRESS__SHIFT               = 0x0000000a;
    constexpr unsigned int SQ_WAVE_IB_STS2__INST_PREFETCH__SHIFT              = 0x00000000;
    constexpr unsigned int SQ_WAVE_IB_STS2__MEM_ORDER__SHIFT                  = 0x00000008;
    constexpr unsigned int SQ_WAVE_IB_STS2__WAVE64__SHIFT                     = 0x0000000b;
    constexpr unsigned int SQ_WAVE_IB_STS__VS_CNT__SHIFT                      = 0x0000001a;
    constexpr unsigned int SQ_WAVE_LDS_ALLOC__VGPR_SHARED_SIZE__SHIFT         = 0x00000018;
    constexpr unsigned int SQ_WAVE_MODE__DISABLE_PERF__SHIFT                  = 0x0000001b;
    constexpr unsigned int SQ_WAVE_POPS_PACKER__POPS_EN__SHIFT                = 0x00000000;
    constexpr unsigned int SQ_WAVE_POPS_PACKER__POPS_PACKER_ID__SHIFT         = 0x00000001;
    constexpr unsigned int SQ_WAVE_SCHED_MODE__DEP_MODE__SHIFT                = 0x00000000;
    constexpr unsigned int SQ_WAVE_STATUS__TTRACE_SIMD_EN__SHIFT              = 0x0000000f;
    constexpr unsigned int SQ_WAVE_TRAPSTS__BUFFER_OOB__SHIFT                 = 0x0000000f;
    constexpr unsigned int SQ_WAVE_TRAPSTS__EXCP_GROUP_MASK__SHIFT            = 0x00000014;
    constexpr unsigned int SQ_WAVE_TRAPSTS__EXCP_WAVE64HI__SHIFT              = 0x00000018;
    constexpr unsigned int TA_CNTL_AUX__ANISO_MAG_STEP_CLAMP__SHIFT           = 0x00000008;
    constexpr unsigned int TA_CNTL_AUX__AUTO_ALIGN_FORMAT__SHIFT              = 0x00000009;
    constexpr unsigned int TA_POWER_CNTL__NOSAMPLER_CLK_EN_MODE__SHIFT        = 0x00000013;
    constexpr unsigned int TA_POWER_CNTL__NOSAMPLER_CLK_VALID_DELAY__SHIFT    = 0x00000010;
    constexpr unsigned int TA_POWER_CNTL__SAMPLER_CLK_EN_MODE__SHIFT          = 0x00000003;
    constexpr unsigned int TA_POWER_CNTL__SAMPLER_CLK_VALID_DELAY__SHIFT      = 0x00000000;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER2__REQ_MODE__SHIFT           = 0x00000000;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__COMPRESSION_ENABLE__SHIFT = 0x0000000b;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__DLC__SHIFT              = 0x00000009;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__GLC__SHIFT              = 0x0000000a;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__REQ_MODE__SHIFT         = 0x0000000c;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER_EN__SLC__SHIFT              = 0x00000008;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__COMPRESSION_ENABLE__SHIFT  = 0x0000001e;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__DLC__SHIFT                 = 0x0000001c;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__GLC__SHIFT                 = 0x0000001d;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__NUM_FORMAT__SHIFT          = 0x0000000d;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__NUM_SAMPLES__SHIFT         = 0x00000016;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__OPCODE_TYPE__SHIFT         = 0x00000018;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__SLC__SHIFT                 = 0x0000001b;
    constexpr unsigned int TCP_PERFCOUNTER_FILTER__SW_MODE__SHIFT             = 0x00000011;
    constexpr unsigned int UTCL1_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
    constexpr unsigned int UTCL1_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
    constexpr unsigned int UTCL1_PERFCOUNTER0_SELECT__COUNTER_MODE__SHIFT     = 0x0000001c;
    constexpr unsigned int UTCL1_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT         = 0x00000000;
    constexpr unsigned int UTCL1_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
    constexpr unsigned int UTCL1_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
    constexpr unsigned int UTCL1_PERFCOUNTER1_SELECT__COUNTER_MODE__SHIFT     = 0x0000001c;
    constexpr unsigned int UTCL1_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT         = 0x00000000;
    constexpr unsigned int VGT_DMA_INDEX_TYPE__ATC__SHIFT                     = 0x00000008;
    constexpr unsigned int VGT_DMA_INDEX_TYPE__MTYPE__SHIFT                   = 0x0000000b;
    constexpr unsigned int VGT_DRAW_PAYLOAD_CNTL__EN_DRAW_VP__SHIFT           = 0x00000004;
    constexpr unsigned int VGT_ESGS_RING_SIZE__MEM_SIZE__SHIFT                = 0x00000000;
    constexpr unsigned int VGT_FIFO_DEPTHS__HSINPUT_FIFO_DEPTH__SHIFT         = 0x00000017;
    constexpr unsigned int VGT_FIFO_DEPTHS__RESERVED_1__SHIFT                 = 0x00000016;
    constexpr unsigned int VGT_GS_INSTANCE_CNT__EN_MAX_VERT_OUT_PER_GS_INSTANCE__SHIFT = 0x0000001f;
    constexpr unsigned int VGT_GS_MODE__COMPUTE_MODE__SHIFT                   = 0x0000000e;
    constexpr unsigned int VGT_GS_MODE__ELEMENT_INFO_EN__SHIFT                = 0x00000010;
    constexpr unsigned int VGT_GS_MODE__FAST_COMPUTE_MODE__SHIFT              = 0x0000000f;
    constexpr unsigned int VGT_SHADER_STAGES_EN__DYNAMIC_HS__SHIFT            = 0x00000008;
    constexpr unsigned int VGT_SHADER_STAGES_EN__GS_W32_EN__SHIFT             = 0x00000016;
    constexpr unsigned int VGT_SHADER_STAGES_EN__HS_W32_EN__SHIFT             = 0x00000015;
    constexpr unsigned int VGT_SHADER_STAGES_EN__NGG_WAVE_ID_EN__SHIFT        = 0x00000018;
    constexpr unsigned int VGT_SHADER_STAGES_EN__PRIMGEN_PASSTHRU_EN__SHIFT   = 0x00000019;
    constexpr unsigned int VGT_SHADER_STAGES_EN__VS_W32_EN__SHIFT             = 0x00000017;
    constexpr unsigned int VGT_TF_PARAM__DETECT_ONE__SHIFT                    = 0x00000013;
    constexpr unsigned int VGT_TF_PARAM__DETECT_ZERO__SHIFT                   = 0x00000014;
    constexpr unsigned int VGT_TF_PARAM__MTYPE__SHIFT                         = 0x00000017;
    constexpr unsigned int VGT_TF_PARAM__NUM_DS_WAVES_PER_SIMD__SHIFT         = 0x0000000a;
    constexpr unsigned int WD_UTCL1_CNTL__MTYPE_OVERRIDE__SHIFT               = 0x0000001d;
} // namespace Gfx10

namespace Gfx101
{
    constexpr unsigned int CB_COLOR0_INFO__ALT_TILE_MODE__SHIFT               = 0x0000001f;
    constexpr unsigned int CB_COLOR1_INFO__ALT_TILE_MODE__SHIFT               = 0x0000001f;
    constexpr unsigned int CB_COLOR2_INFO__ALT_TILE_MODE__SHIFT               = 0x0000001f;
    constexpr unsigned int CB_COLOR3_INFO__ALT_TILE_MODE__SHIFT               = 0x0000001f;
    constexpr unsigned int CB_COLOR4_INFO__ALT_TILE_MODE__SHIFT               = 0x0000001f;
    constexpr unsigned int CB_COLOR5_INFO__ALT_TILE_MODE__SHIFT               = 0x0000001f;
    constexpr unsigned int CB_COLOR6_INFO__ALT_TILE_MODE__SHIFT               = 0x0000001f;
    constexpr unsigned int CB_COLOR7_INFO__ALT_TILE_MODE__SHIFT               = 0x0000001f;
    constexpr unsigned int CB_DCC_CONFIG__DCC_CACHE_NUM_TAGS__SHIFT           = 0x0000001a;
    constexpr unsigned int CB_HW_CONTROL_1__CC_CACHE_NUM_TAGS__SHIFT          = 0x0000000b;
    constexpr unsigned int CB_HW_CONTROL_1__CM_TILE_FIFO_DEPTH__SHIFT         = 0x00000011;
    constexpr unsigned int CB_HW_CONTROL_1__RMI_CREDITS__SHIFT                = 0x0000001a;
    constexpr unsigned int CB_HW_CONTROL_3__DISABLE_OVERWRITE_COMBINER_TARGET_MASK_VALIDATION__SHIFT = 0x00000008;
    constexpr unsigned int CHCG_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT        = 0x00000000;
    constexpr unsigned int CHCG_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT        = 0x00000000;
    constexpr unsigned int CHCG_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT       = 0x00000018;
    constexpr unsigned int CHCG_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT       = 0x0000001c;
    constexpr unsigned int CHCG_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT        = 0x00000000;
    constexpr unsigned int CHCG_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT        = 0x0000000a;
    constexpr unsigned int CHCG_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT         = 0x00000014;
    constexpr unsigned int CHCG_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT        = 0x00000018;
    constexpr unsigned int CHCG_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT         = 0x0000001c;
    constexpr unsigned int CHCG_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT         = 0x0000000a;
    constexpr unsigned int CHCG_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT          = 0x00000000;
    constexpr unsigned int CHCG_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT        = 0x00000000;
    constexpr unsigned int CHCG_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT        = 0x00000000;
    constexpr unsigned int CHCG_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT         = 0x00000014;
    constexpr unsigned int CHCG_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT         = 0x0000001c;
    constexpr unsigned int CHCG_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT          = 0x00000000;
    constexpr unsigned int CHCG_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT        = 0x00000000;
    constexpr unsigned int CHCG_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT        = 0x00000000;
    constexpr unsigned int CHCG_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT         = 0x00000014;
    constexpr unsigned int CHCG_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT         = 0x0000001c;
    constexpr unsigned int CHCG_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT          = 0x00000000;
    constexpr unsigned int CHCG_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT        = 0x00000000;
    constexpr unsigned int CHCG_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT        = 0x00000000;
    constexpr unsigned int CHCG_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT         = 0x00000014;
    constexpr unsigned int CHCG_PERFCOUNTER3_SELECT__PERF_MODE__SHIFT         = 0x0000001c;
    constexpr unsigned int CHCG_PERFCOUNTER3_SELECT__PERF_SEL__SHIFT          = 0x00000000;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_0__COEFFICIENT_HIER_SELECT__SHIFT = 0x00000007;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_0__COEFFICIENT__SHIFT       = 0x0000000f;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_0__CONTRIBUTION_HIER_SELECT__SHIFT = 0x0000000a;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_0__CONTRIBUTION__SHIFT      = 0x00000000;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_0__GROUP_UPDATE_EN__SHIFT   = 0x0000000d;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_0__RESERVED__SHIFT          = 0x0000000e;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_1__COEFFICIENT_HIER_SELECT__SHIFT = 0x00000007;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_1__COEFFICIENT__SHIFT       = 0x0000000f;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_1__CONTRIBUTION_HIER_SELECT__SHIFT = 0x0000000a;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_1__CONTRIBUTION__SHIFT      = 0x00000000;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_1__GROUP_UPDATE_EN__SHIFT   = 0x0000000d;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_1__RESERVED__SHIFT          = 0x0000000e;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_2__COEFFICIENT_HIER_SELECT__SHIFT = 0x00000007;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_2__COEFFICIENT__SHIFT       = 0x0000000f;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_2__CONTRIBUTION_HIER_SELECT__SHIFT = 0x0000000a;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_2__CONTRIBUTION__SHIFT      = 0x00000000;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_2__GROUP_UPDATE_EN__SHIFT   = 0x0000000d;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_2__RESERVED__SHIFT          = 0x0000000e;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_3__COEFFICIENT_HIER_SELECT__SHIFT = 0x00000007;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_3__COEFFICIENT__SHIFT       = 0x0000000f;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_3__CONTRIBUTION_HIER_SELECT__SHIFT = 0x0000000a;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_3__CONTRIBUTION__SHIFT      = 0x00000000;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_3__GROUP_UPDATE_EN__SHIFT   = 0x0000000d;
    constexpr unsigned int COMPUTE_PREF_PRI_ACCUM_3__RESERVED__SHIFT          = 0x0000000e;
    constexpr unsigned int DB_EXCEPTION_CONTROL__EXTRA_BITS_GROUP_A__SHIFT    = 0x00000005;
    constexpr unsigned int DB_EXCEPTION_CONTROL__EXTRA_BITS_GROUP_B__SHIFT    = 0x0000000c;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__BYPASS_SORT_RD_BA__SHIFT  = 0x0000001d;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__DISABLE_FLQ_LOB_EVERY_256B__SHIFT = 0x00000014;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__DISABLE_MCC_BURST_COUNT_RESET_ON_LOB__SHIFT = 0x00000013;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__DISABLE_MCC_BURST_FORCE_FLUSH_BEFORE_FIFO__SHIFT = 0x00000016;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__DISABLE_ZCACHE_FL_OP_EVEN_ARB__SHIFT = 0x00000015;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__ENABLE_FG_DEFAULT_TIMEOUT__SHIFT = 0x00000012;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__ENABLE_TIMEOUT_CB_LOB_GEN__SHIFT = 0x00000019;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__ENABLE_TIMEOUT_DKG_LOB_GEN__SHIFT = 0x00000017;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__ENABLE_TIMEOUT_FG_LOB_FWDR__SHIFT = 0x0000001b;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__ENABLE_TIMEOUT_FL_BURST__SHIFT = 0x0000001a;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__ENABLE_TIMEOUT_LPF_LOB_GEN__SHIFT = 0x00000018;
    constexpr unsigned int DB_LAST_OF_BURST_CONFIG__ENABLE_TIMEOUT_RD_BA_ACCUM__SHIFT = 0x0000001c;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER0_CFG__CLEAR__SHIFT           = 0x0000001d;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER0_CFG__ENABLE__SHIFT          = 0x0000001c;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER0_CFG__PERF_MODE__SHIFT       = 0x00000018;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER0_CFG__PERF_SEL_END__SHIFT    = 0x00000008;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER0_CFG__PERF_SEL__SHIFT        = 0x00000000;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER1_CFG__CLEAR__SHIFT           = 0x0000001d;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER1_CFG__ENABLE__SHIFT          = 0x0000001c;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER1_CFG__PERF_MODE__SHIFT       = 0x00000018;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER1_CFG__PERF_SEL_END__SHIFT    = 0x00000008;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER1_CFG__PERF_SEL__SHIFT        = 0x00000000;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT   = 0x00000000;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT   = 0x00000000;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_MODE__COMPARE_MODE0__SHIFT  = 0x00000000;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_MODE__COMPARE_MODE1__SHIFT  = 0x00000002;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_MODE__COMPARE_MODE2__SHIFT  = 0x00000004;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_MODE__COMPARE_MODE3__SHIFT  = 0x00000006;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_MODE__COMPARE_VALUE0__SHIFT = 0x00000008;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_MODE__COMPARE_VALUE1__SHIFT = 0x0000000c;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_MODE__COMPARE_VALUE2__SHIFT = 0x00000010;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_MODE__COMPARE_VALUE3__SHIFT = 0x00000014;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_SELECT1__PERF_MODE2__SHIFT  = 0x0000001c;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_SELECT1__PERF_MODE3__SHIFT  = 0x00000018;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_SELECT1__PERF_SEL2__SHIFT   = 0x00000000;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_SELECT1__PERF_SEL3__SHIFT   = 0x0000000a;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT    = 0x00000014;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_SELECT__PERF_MODE1__SHIFT   = 0x00000018;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT    = 0x0000001c;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_SELECT__PERF_SEL1__SHIFT    = 0x0000000a;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT     = 0x00000000;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER_HI__COMPARE_VALUE__SHIFT     = 0x00000010;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER_HI__COUNTER_HI__SHIFT        = 0x00000000;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER_LO__COUNTER_LO__SHIFT        = 0x00000000;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER_RSLT_CNTL__CLEAR_ALL__SHIFT  = 0x00000019;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER_RSLT_CNTL__ENABLE_ANY__SHIFT = 0x00000018;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER_RSLT_CNTL__PERF_COUNTER_SELECT__SHIFT = 0x00000000;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER_RSLT_CNTL__START_TRIGGER__SHIFT = 0x00000008;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER_RSLT_CNTL__STOP_ALL_ON_SATURATE__SHIFT = 0x0000001a;
    constexpr unsigned int GC_ATC_L2_PERFCOUNTER_RSLT_CNTL__STOP_TRIGGER__SHIFT = 0x00000010;
    constexpr unsigned int GE_FAST_CLKS__FORCE_FAST_CLK__SHIFT                = 0x0000001f;
    constexpr unsigned int GE_FAST_CLKS__HYSTERESIS__SHIFT                    = 0x00000000;
    constexpr unsigned int GE_FAST_CLKS__LOCK__SHIFT                          = 0x0000001e;
    constexpr unsigned int GE_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT         = 0x00000018;
    constexpr unsigned int GE_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT         = 0x0000001c;
    constexpr unsigned int GE_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT          = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT          = 0x0000000a;
    constexpr unsigned int GE_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT           = 0x00000014;
    constexpr unsigned int GE_PERFCOUNTER0_SELECT__PERF_MODE0__SHIFT          = 0x00000018;
    constexpr unsigned int GE_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT          = 0x0000001c;
    constexpr unsigned int GE_PERFCOUNTER0_SELECT__PERF_SEL0__SHIFT           = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT           = 0x0000000a;
    constexpr unsigned int GE_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT         = 0x00000018;
    constexpr unsigned int GE_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT         = 0x0000001c;
    constexpr unsigned int GE_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT          = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT          = 0x0000000a;
    constexpr unsigned int GE_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT           = 0x00000014;
    constexpr unsigned int GE_PERFCOUNTER1_SELECT__PERF_MODE0__SHIFT          = 0x00000018;
    constexpr unsigned int GE_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT          = 0x0000001c;
    constexpr unsigned int GE_PERFCOUNTER1_SELECT__PERF_SEL0__SHIFT           = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT           = 0x0000000a;
    constexpr unsigned int GE_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER2_SELECT1__PERF_MODE2__SHIFT         = 0x00000018;
    constexpr unsigned int GE_PERFCOUNTER2_SELECT1__PERF_MODE3__SHIFT         = 0x0000001c;
    constexpr unsigned int GE_PERFCOUNTER2_SELECT1__PERF_SEL2__SHIFT          = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER2_SELECT1__PERF_SEL3__SHIFT          = 0x0000000a;
    constexpr unsigned int GE_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT           = 0x00000014;
    constexpr unsigned int GE_PERFCOUNTER2_SELECT__PERF_MODE0__SHIFT          = 0x00000018;
    constexpr unsigned int GE_PERFCOUNTER2_SELECT__PERF_MODE1__SHIFT          = 0x0000001c;
    constexpr unsigned int GE_PERFCOUNTER2_SELECT__PERF_SEL0__SHIFT           = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER2_SELECT__PERF_SEL1__SHIFT           = 0x0000000a;
    constexpr unsigned int GE_PERFCOUNTER3_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER3_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER3_SELECT1__PERF_MODE2__SHIFT         = 0x00000018;
    constexpr unsigned int GE_PERFCOUNTER3_SELECT1__PERF_MODE3__SHIFT         = 0x0000001c;
    constexpr unsigned int GE_PERFCOUNTER3_SELECT1__PERF_SEL2__SHIFT          = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER3_SELECT1__PERF_SEL3__SHIFT          = 0x0000000a;
    constexpr unsigned int GE_PERFCOUNTER3_SELECT__CNTR_MODE__SHIFT           = 0x00000014;
    constexpr unsigned int GE_PERFCOUNTER3_SELECT__PERF_MODE0__SHIFT          = 0x00000018;
    constexpr unsigned int GE_PERFCOUNTER3_SELECT__PERF_MODE1__SHIFT          = 0x0000001c;
    constexpr unsigned int GE_PERFCOUNTER3_SELECT__PERF_SEL0__SHIFT           = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER3_SELECT__PERF_SEL1__SHIFT           = 0x0000000a;
    constexpr unsigned int GE_PERFCOUNTER4_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER4_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER4_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
    constexpr unsigned int GE_PERFCOUNTER4_SELECT__PERF_SEL0__SHIFT           = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER5_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER5_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER5_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
    constexpr unsigned int GE_PERFCOUNTER5_SELECT__PERF_SEL0__SHIFT           = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER6_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER6_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER6_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
    constexpr unsigned int GE_PERFCOUNTER6_SELECT__PERF_SEL0__SHIFT           = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER7_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER7_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER7_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
    constexpr unsigned int GE_PERFCOUNTER7_SELECT__PERF_SEL0__SHIFT           = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER8_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER8_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER8_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
    constexpr unsigned int GE_PERFCOUNTER8_SELECT__PERF_SEL0__SHIFT           = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER9_HI__PERFCOUNTER_HI__SHIFT          = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER9_LO__PERFCOUNTER_LO__SHIFT          = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER9_SELECT__PERF_MODE__SHIFT           = 0x0000001c;
    constexpr unsigned int GE_PERFCOUNTER9_SELECT__PERF_SEL0__SHIFT           = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER10_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER10_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER10_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
    constexpr unsigned int GE_PERFCOUNTER10_SELECT__PERF_SEL0__SHIFT          = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER11_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER11_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
    constexpr unsigned int GE_PERFCOUNTER11_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
    constexpr unsigned int GE_PERFCOUNTER11_SELECT__PERF_SEL0__SHIFT          = 0x00000000;
    constexpr unsigned int GUS_PERFCOUNTER0_CFG__CLEAR__SHIFT                 = 0x0000001d;
    constexpr unsigned int GUS_PERFCOUNTER0_CFG__ENABLE__SHIFT                = 0x0000001c;
    constexpr unsigned int GUS_PERFCOUNTER0_CFG__PERF_MODE__SHIFT             = 0x00000018;
    constexpr unsigned int GUS_PERFCOUNTER0_CFG__PERF_SEL_END__SHIFT          = 0x00000008;
    constexpr unsigned int GUS_PERFCOUNTER0_CFG__PERF_SEL__SHIFT              = 0x00000000;
    constexpr unsigned int GUS_PERFCOUNTER1_CFG__CLEAR__SHIFT                 = 0x0000001d;
    constexpr unsigned int GUS_PERFCOUNTER1_CFG__ENABLE__SHIFT                = 0x0000001c;
    constexpr unsigned int GUS_PERFCOUNTER1_CFG__PERF_MODE__SHIFT             = 0x00000018;
    constexpr unsigned int GUS_PERFCOUNTER1_CFG__PERF_SEL_END__SHIFT          = 0x00000008;
    constexpr unsigned int GUS_PERFCOUNTER1_CFG__PERF_SEL__SHIFT              = 0x00000000;
    constexpr unsigned int GUS_PERFCOUNTER2_HI__PERFCOUNTER_HI__SHIFT         = 0x00000000;
    constexpr unsigned int GUS_PERFCOUNTER2_LO__PERFCOUNTER_LO__SHIFT         = 0x00000000;
    constexpr unsigned int GUS_PERFCOUNTER2_MODE__COMPARE_MODE0__SHIFT        = 0x00000000;
    constexpr unsigned int GUS_PERFCOUNTER2_MODE__COMPARE_MODE1__SHIFT        = 0x00000002;
    constexpr unsigned int GUS_PERFCOUNTER2_MODE__COMPARE_MODE2__SHIFT        = 0x00000004;
    constexpr unsigned int GUS_PERFCOUNTER2_MODE__COMPARE_MODE3__SHIFT        = 0x00000006;
    constexpr unsigned int GUS_PERFCOUNTER2_MODE__COMPARE_VALUE0__SHIFT       = 0x00000008;
    constexpr unsigned int GUS_PERFCOUNTER2_MODE__COMPARE_VALUE1__SHIFT       = 0x0000000c;
    constexpr unsigned int GUS_PERFCOUNTER2_MODE__COMPARE_VALUE2__SHIFT       = 0x00000010;
    constexpr unsigned int GUS_PERFCOUNTER2_MODE__COMPARE_VALUE3__SHIFT       = 0x00000014;
    constexpr unsigned int GUS_PERFCOUNTER2_SELECT1__PERF_MODE2__SHIFT        = 0x0000001c;
    constexpr unsigned int GUS_PERFCOUNTER2_SELECT1__PERF_MODE3__SHIFT        = 0x00000018;
    constexpr unsigned int GUS_PERFCOUNTER2_SELECT1__PERF_SEL2__SHIFT         = 0x00000000;
    constexpr unsigned int GUS_PERFCOUNTER2_SELECT1__PERF_SEL3__SHIFT         = 0x0000000a;
    constexpr unsigned int GUS_PERFCOUNTER2_SELECT__CNTR_MODE__SHIFT          = 0x00000014;
    constexpr unsigned int GUS_PERFCOUNTER2_SELECT__PERF_MODE1__SHIFT         = 0x00000018;
    constexpr unsigned int GUS_PERFCOUNTER2_SELECT__PERF_MODE__SHIFT          = 0x0000001c;
    constexpr unsigned int GUS_PERFCOUNTER2_SELECT__PERF_SEL1__SHIFT          = 0x0000000a;
    constexpr unsigned int GUS_PERFCOUNTER2_SELECT__PERF_SEL__SHIFT           = 0x00000000;
    constexpr unsigned int GUS_PERFCOUNTER_HI__COMPARE_VALUE__SHIFT           = 0x00000010;
    constexpr unsigned int GUS_PERFCOUNTER_HI__COUNTER_HI__SHIFT              = 0x00000000;
    constexpr unsigned int GUS_PERFCOUNTER_LO__COUNTER_LO__SHIFT              = 0x00000000;
    constexpr unsigned int GUS_PERFCOUNTER_RSLT_CNTL__CLEAR_ALL__SHIFT        = 0x00000019;
    constexpr unsigned int GUS_PERFCOUNTER_RSLT_CNTL__ENABLE_ANY__SHIFT       = 0x00000018;
    constexpr unsigned int GUS_PERFCOUNTER_RSLT_CNTL__PERF_COUNTER_SELECT__SHIFT = 0x00000000;
    constexpr unsigned int GUS_PERFCOUNTER_RSLT_CNTL__START_TRIGGER__SHIFT    = 0x00000008;
    constexpr unsigned int GUS_PERFCOUNTER_RSLT_CNTL__STOP_ALL_ON_SATURATE__SHIFT = 0x0000001a;
    constexpr unsigned int GUS_PERFCOUNTER_RSLT_CNTL__STOP_TRIGGER__SHIFT     = 0x00000010;
    constexpr unsigned int MP1_SMN_FPS_CNT__COUNT__SHIFT                      = 0x00000000;
    constexpr unsigned int PA_CL_CNTL_STATUS__UTC_FAULT_DETECTED__SHIFT       = 0x00000000;
    constexpr unsigned int PA_CL_CNTL_STATUS__UTC_PRT_DETECTED__SHIFT         = 0x00000002;
    constexpr unsigned int PA_CL_CNTL_STATUS__UTC_RETRY_DETECTED__SHIFT       = 0x00000001;
    constexpr unsigned int PA_SC_ENHANCE_1__ALLOW_SCALE_LINE_WIDTH_PAD_WITH_BINNING__SHIFT = 0x00000011;
    constexpr unsigned int PA_SC_ENHANCE_1__DEBUG_PIXEL_PICKER_XY_UNPACK__SHIFT = 0x0000000c;
    constexpr unsigned int PA_SC_ENHANCE_2__ECO_SPARE0__SHIFT                 = 0x00000000;
    constexpr unsigned int PA_SC_ENHANCE_2__ECO_SPARE1__SHIFT                 = 0x00000001;
    constexpr unsigned int PA_SC_ENHANCE_2__ECO_SPARE2__SHIFT                 = 0x00000002;
    constexpr unsigned int PA_SC_ENHANCE_2__ECO_SPARE3__SHIFT                 = 0x00000003;
    constexpr unsigned int PA_SC_MODE_CNTL_0__SCALE_LINE_WIDTH_PAD__SHIFT     = 0x00000004;
    constexpr unsigned int RLC_SPM_ACCUM_CTRLRAM_ADDR__RESERVED__SHIFT        = 0x00000009;
    constexpr unsigned int RLC_SPM_ACCUM_CTRL__RESERVED__SHIFT                = 0x0000000a;
    constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeAccumDoneInt__SHIFT      = 0x00000004;
    constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeResetAccum__SHIFT        = 0x00000005;
    constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeSpmDoneInt__SHIFT        = 0x00000003;
    constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeStartSpm__SHIFT          = 0x00000006;
    constexpr unsigned int RLC_SPM_ACCUM_MODE__AutoAccumEn__SHIFT             = 0x00000001;
    constexpr unsigned int RLC_SPM_ACCUM_MODE__AutoResetPerfmonDisable__SHIFT = 0x00000006;
    constexpr unsigned int RLC_SPM_ACCUM_MODE__AutoSpmEn__SHIFT               = 0x00000002;
    constexpr unsigned int RLC_SPM_ACCUM_MODE__Globals_LoadOverride__SHIFT    = 0x00000003;
    constexpr unsigned int RLC_SPM_ACCUM_MODE__RESERVED__SHIFT                = 0x00000007;
    constexpr unsigned int RLC_SPM_ACCUM_MODE__SE0_LoadOverride__SHIFT        = 0x00000004;
    constexpr unsigned int RLC_SPM_ACCUM_MODE__SE1_LoadOverride__SHIFT        = 0x00000005;
    constexpr unsigned int RLC_SPM_ACCUM_SAMPLES_REQUESTED__RESERVED__SHIFT   = 0x00000008;
    constexpr unsigned int RLC_SPM_ACCUM_STATUS__RESERVED__SHIFT              = 0x00000010;
    constexpr unsigned int RLC_SPM_ACCUM_THRESHOLD__RESERVED__SHIFT           = 0x00000010;
    constexpr unsigned int RLC_SPM_MC_CNTL__RESERVED_2__SHIFT                 = 0x0000000d;
    constexpr unsigned int RLC_SPM_MC_CNTL__RESERVED__SHIFT                   = 0x00000010;
    constexpr unsigned int SPI_CONFIG_CNTL_1_REMAP__RESERVED__SHIFT           = 0x00000000;
    constexpr unsigned int SPI_CONFIG_CNTL_2_REMAP__RESERVED__SHIFT           = 0x00000000;
    constexpr unsigned int SPI_CONFIG_CNTL_REMAP__RESERVED__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_CONFIG_CNTL__RSRC_MGMT_RESET__SHIFT            = 0x0000001a;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_4__COUNT__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_4__EVENTS__SHIFT           = 0x00000010;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_5__COUNT__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_5__EVENTS__SHIFT           = 0x00000010;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_6__COUNT__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_6__EVENTS__SHIFT           = 0x00000010;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_7__COUNT__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_CSQ_WF_ACTIVE_COUNT_7__EVENTS__SHIFT           = 0x00000010;
    constexpr unsigned int SPI_FEATURE_CTRL__ACTIVE_HARD_LOCK_LIMIT__SHIFT    = 0x00000007;
    constexpr unsigned int SPI_FEATURE_CTRL__ALLOCATION_RATE_THROTTLE_THRESHOLD__SHIFT = 0x00000002;
    constexpr unsigned int SPI_FEATURE_CTRL__BUS_ACTIVITY_THRESHOLD_ALLOC_STALL_EN__SHIFT = 0x00000013;
    constexpr unsigned int SPI_FEATURE_CTRL__BUS_ACTIVITY_THRESHOLD__SHIFT    = 0x00000014;
    constexpr unsigned int SPI_FEATURE_CTRL__CU_LOCKING_FAIRNESS_DISABLE__SHIFT = 0x00000000;
    constexpr unsigned int SPI_FEATURE_CTRL__LR_IMBALANCE_THRESHOLD__SHIFT    = 0x0000000c;
    constexpr unsigned int SPI_FEATURE_CTRL__RA_PIPE_DEPTH_THRESHOLD_ALLOC_STALL_EN__SHIFT = 0x00000012;
    constexpr unsigned int SPI_FEATURE_CTRL__TUNNELING_WAVE_LIMIT__SHIFT      = 0x0000001c;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_8__BARRIERS__SHIFT         = 0x0000000f;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_8__LDS__SHIFT              = 0x00000008;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_8__SGPR__SHIFT             = 0x00000004;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_8__VGPR__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_8__WAVES__SHIFT            = 0x0000000c;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_9__BARRIERS__SHIFT         = 0x0000000f;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_9__LDS__SHIFT              = 0x00000008;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_9__SGPR__SHIFT             = 0x00000004;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_9__VGPR__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_9__WAVES__SHIFT            = 0x0000000c;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_10__BARRIERS__SHIFT        = 0x0000000f;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_10__LDS__SHIFT             = 0x00000008;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_10__SGPR__SHIFT            = 0x00000004;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_10__VGPR__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_10__WAVES__SHIFT           = 0x0000000c;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_11__BARRIERS__SHIFT        = 0x0000000f;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_11__LDS__SHIFT             = 0x00000008;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_11__SGPR__SHIFT            = 0x00000004;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_11__VGPR__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_11__WAVES__SHIFT           = 0x0000000c;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_12__BARRIERS__SHIFT        = 0x0000000f;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_12__LDS__SHIFT             = 0x00000008;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_12__SGPR__SHIFT            = 0x00000004;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_12__VGPR__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_12__WAVES__SHIFT           = 0x0000000c;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_13__BARRIERS__SHIFT        = 0x0000000f;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_13__LDS__SHIFT             = 0x00000008;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_13__SGPR__SHIFT            = 0x00000004;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_13__VGPR__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_13__WAVES__SHIFT           = 0x0000000c;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_14__BARRIERS__SHIFT        = 0x0000000f;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_14__LDS__SHIFT             = 0x00000008;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_14__SGPR__SHIFT            = 0x00000004;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_14__VGPR__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_14__WAVES__SHIFT           = 0x0000000c;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_15__BARRIERS__SHIFT        = 0x0000000f;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_15__LDS__SHIFT             = 0x00000008;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_15__SGPR__SHIFT            = 0x00000004;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_15__VGPR__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_CU_15__WAVES__SHIFT           = 0x0000000c;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_0__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_1__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_2__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_3__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_4__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_5__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_6__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_7__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_8__EN__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_8__QUEUE_MASK__SHIFT    = 0x00000010;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_8__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_8__TYPE_MASK__SHIFT     = 0x00000001;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_9__EN__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_9__QUEUE_MASK__SHIFT    = 0x00000010;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_9__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_9__TYPE_MASK__SHIFT     = 0x00000001;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_10__EN__SHIFT           = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_10__QUEUE_MASK__SHIFT   = 0x00000010;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_10__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_10__TYPE_MASK__SHIFT    = 0x00000001;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_11__EN__SHIFT           = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_11__QUEUE_MASK__SHIFT   = 0x00000010;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_11__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_11__TYPE_MASK__SHIFT    = 0x00000001;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_12__EN__SHIFT           = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_12__QUEUE_MASK__SHIFT   = 0x00000010;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_12__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_12__TYPE_MASK__SHIFT    = 0x00000001;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_13__EN__SHIFT           = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_13__QUEUE_MASK__SHIFT   = 0x00000010;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_13__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_13__TYPE_MASK__SHIFT    = 0x00000001;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_14__EN__SHIFT           = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_14__QUEUE_MASK__SHIFT   = 0x00000010;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_14__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_14__TYPE_MASK__SHIFT    = 0x00000001;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_15__EN__SHIFT           = 0x00000000;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_15__QUEUE_MASK__SHIFT   = 0x00000010;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_15__RESERVE_SPACE_ONLY__SHIFT = 0x00000018;
    constexpr unsigned int SPI_RESOURCE_RESERVE_EN_CU_15__TYPE_MASK__SHIFT    = 0x00000001;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_ES__CDBG_USER__SHIFT          = 0x0000001e;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_ES__CU_GROUP_ENABLE__SHIFT    = 0x0000001a;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_ES__DEBUG_MODE__SHIFT         = 0x00000016;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_ES__DX10_CLAMP__SHIFT         = 0x00000015;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_ES__FLOAT_MODE__SHIFT         = 0x0000000c;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_ES__FP16_OVFL__SHIFT          = 0x0000001f;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_ES__IEEE_MODE__SHIFT          = 0x00000017;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_ES__PRIORITY__SHIFT           = 0x0000000a;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_ES__PRIV__SHIFT               = 0x00000014;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_ES__SGPRS__SHIFT              = 0x00000006;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_ES__VGPRS__SHIFT              = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_ES__VGPR_COMP_CNT__SHIFT      = 0x00000018;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_LS__CDBG_USER__SHIFT          = 0x0000001d;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_LS__DEBUG_MODE__SHIFT         = 0x00000016;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_LS__DX10_CLAMP__SHIFT         = 0x00000015;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_LS__FLOAT_MODE__SHIFT         = 0x0000000c;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_LS__FP16_OVFL__SHIFT          = 0x0000001e;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_LS__IEEE_MODE__SHIFT          = 0x00000017;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_LS__PRIORITY__SHIFT           = 0x0000000a;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_LS__PRIV__SHIFT               = 0x00000014;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_LS__SGPRS__SHIFT              = 0x00000006;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_LS__VGPRS__SHIFT              = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_RSRC1_LS__VGPR_COMP_CNT__SHIFT      = 0x00000018;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES_GS__EXCP_EN__SHIFT         = 0x00000008;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES_GS__LDS_SIZE__SHIFT        = 0x00000014;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES_GS__OC_LDS_EN__SHIFT       = 0x00000007;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES_GS__SCRATCH_EN__SHIFT      = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES_GS__TRAP_PRESENT__SHIFT    = 0x00000006;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES_GS__USER_SGPR__SHIFT       = 0x00000001;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES_VS__EXCP_EN__SHIFT         = 0x00000008;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES_VS__LDS_SIZE__SHIFT        = 0x00000014;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES_VS__OC_LDS_EN__SHIFT       = 0x00000007;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES_VS__SCRATCH_EN__SHIFT      = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES_VS__TRAP_PRESENT__SHIFT    = 0x00000006;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES_VS__USER_SGPR__SHIFT       = 0x00000001;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES__EXCP_EN__SHIFT            = 0x00000008;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES__LDS_SIZE__SHIFT           = 0x00000014;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES__OC_LDS_EN__SHIFT          = 0x00000007;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES__SCRATCH_EN__SHIFT         = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES__TRAP_PRESENT__SHIFT       = 0x00000006;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_ES__USER_SGPR__SHIFT          = 0x00000001;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS_ES__EXCP_EN__SHIFT         = 0x00000010;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS_ES__LDS_SIZE__SHIFT        = 0x00000007;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS_ES__SCRATCH_EN__SHIFT      = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS_ES__TRAP_PRESENT__SHIFT    = 0x00000006;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS_ES__USER_SGPR__SHIFT       = 0x00000001;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS_HS__EXCP_EN__SHIFT         = 0x00000010;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS_HS__LDS_SIZE__SHIFT        = 0x00000007;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS_HS__SCRATCH_EN__SHIFT      = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS_HS__TRAP_PRESENT__SHIFT    = 0x00000006;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS_HS__USER_SGPR__SHIFT       = 0x00000001;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS_VS__EXCP_EN__SHIFT         = 0x00000010;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS_VS__LDS_SIZE__SHIFT        = 0x00000007;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS_VS__SCRATCH_EN__SHIFT      = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS_VS__TRAP_PRESENT__SHIFT    = 0x00000006;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS_VS__USER_SGPR__SHIFT       = 0x00000001;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS__EXCP_EN__SHIFT            = 0x00000010;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS__LDS_SIZE__SHIFT           = 0x00000007;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS__SCRATCH_EN__SHIFT         = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS__TRAP_PRESENT__SHIFT       = 0x00000006;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_LS__USER_SGPR__SHIFT          = 0x00000001;
    constexpr unsigned int SPI_SHADER_PGM_RSRC2_VS__DISPATCH_DRAW_EN__SHIFT   = 0x00000018;
    constexpr unsigned int SPI_SHADER_PGM_RSRC3_ES__CU_EN__SHIFT              = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_RSRC3_ES__GROUP_FIFO_DEPTH__SHIFT   = 0x0000001a;
    constexpr unsigned int SPI_SHADER_PGM_RSRC3_ES__LOCK_LOW_THRESHOLD__SHIFT = 0x00000016;
    constexpr unsigned int SPI_SHADER_PGM_RSRC3_ES__WAVE_LIMIT__SHIFT         = 0x00000010;
    constexpr unsigned int SPI_SHADER_PGM_RSRC3_LS__CU_EN__SHIFT              = 0x00000000;
    constexpr unsigned int SPI_SHADER_PGM_RSRC3_LS__GROUP_FIFO_DEPTH__SHIFT   = 0x0000001a;
    constexpr unsigned int SPI_SHADER_PGM_RSRC3_LS__LOCK_LOW_THRESHOLD__SHIFT = 0x00000016;
    constexpr unsigned int SPI_SHADER_PGM_RSRC3_LS__WAVE_LIMIT__SHIFT         = 0x00000010;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_0__COEFFICIENT_HIER_SELECT__SHIFT = 0x00000007;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_0__COEFFICIENT__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_0__CONTRIBUTION_HIER_SELECT__SHIFT = 0x0000000a;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_0__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_0__GROUP_UPDATE_EN__SHIFT = 0x0000000d;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_0__RESERVED__SHIFT  = 0x0000000e;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_1__COEFFICIENT_HIER_SELECT__SHIFT = 0x00000007;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_1__COEFFICIENT__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_1__CONTRIBUTION_HIER_SELECT__SHIFT = 0x0000000a;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_1__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_1__GROUP_UPDATE_EN__SHIFT = 0x0000000d;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_1__RESERVED__SHIFT  = 0x0000000e;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_2__COEFFICIENT_HIER_SELECT__SHIFT = 0x00000007;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_2__COEFFICIENT__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_2__CONTRIBUTION_HIER_SELECT__SHIFT = 0x0000000a;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_2__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_2__GROUP_UPDATE_EN__SHIFT = 0x0000000d;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_2__RESERVED__SHIFT  = 0x0000000e;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_3__COEFFICIENT_HIER_SELECT__SHIFT = 0x00000007;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_3__COEFFICIENT__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_3__CONTRIBUTION_HIER_SELECT__SHIFT = 0x0000000a;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_3__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_3__GROUP_UPDATE_EN__SHIFT = 0x0000000d;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_ESGS_3__RESERVED__SHIFT  = 0x0000000e;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_0__COEFFICIENT_HIER_SELECT__SHIFT = 0x00000007;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_0__COEFFICIENT__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_0__CONTRIBUTION_HIER_SELECT__SHIFT = 0x0000000a;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_0__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_0__GROUP_UPDATE_EN__SHIFT = 0x0000000d;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_0__RESERVED__SHIFT  = 0x0000000e;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_1__COEFFICIENT_HIER_SELECT__SHIFT = 0x00000007;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_1__COEFFICIENT__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_1__CONTRIBUTION_HIER_SELECT__SHIFT = 0x0000000a;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_1__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_1__GROUP_UPDATE_EN__SHIFT = 0x0000000d;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_1__RESERVED__SHIFT  = 0x0000000e;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_2__COEFFICIENT_HIER_SELECT__SHIFT = 0x00000007;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_2__COEFFICIENT__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_2__CONTRIBUTION_HIER_SELECT__SHIFT = 0x0000000a;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_2__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_2__GROUP_UPDATE_EN__SHIFT = 0x0000000d;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_2__RESERVED__SHIFT  = 0x0000000e;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_3__COEFFICIENT_HIER_SELECT__SHIFT = 0x00000007;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_3__COEFFICIENT__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_3__CONTRIBUTION_HIER_SELECT__SHIFT = 0x0000000a;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_3__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_3__GROUP_UPDATE_EN__SHIFT = 0x0000000d;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_LSHS_3__RESERVED__SHIFT  = 0x0000000e;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_0__COEFFICIENT_HIER_SELECT__SHIFT = 0x00000007;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_0__COEFFICIENT__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_0__CONTRIBUTION_HIER_SELECT__SHIFT = 0x0000000a;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_0__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_0__GROUP_UPDATE_EN__SHIFT = 0x0000000d;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_0__RESERVED__SHIFT    = 0x0000000e;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_1__COEFFICIENT_HIER_SELECT__SHIFT = 0x00000007;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_1__COEFFICIENT__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_1__CONTRIBUTION_HIER_SELECT__SHIFT = 0x0000000a;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_1__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_1__GROUP_UPDATE_EN__SHIFT = 0x0000000d;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_1__RESERVED__SHIFT    = 0x0000000e;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_2__COEFFICIENT_HIER_SELECT__SHIFT = 0x00000007;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_2__COEFFICIENT__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_2__CONTRIBUTION_HIER_SELECT__SHIFT = 0x0000000a;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_2__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_2__GROUP_UPDATE_EN__SHIFT = 0x0000000d;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_2__RESERVED__SHIFT    = 0x0000000e;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_3__COEFFICIENT_HIER_SELECT__SHIFT = 0x00000007;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_3__COEFFICIENT__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_3__CONTRIBUTION_HIER_SELECT__SHIFT = 0x0000000a;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_3__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_3__GROUP_UPDATE_EN__SHIFT = 0x0000000d;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_PS_3__RESERVED__SHIFT    = 0x0000000e;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_0__COEFFICIENT_HIER_SELECT__SHIFT = 0x00000007;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_0__COEFFICIENT__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_0__CONTRIBUTION_HIER_SELECT__SHIFT = 0x0000000a;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_0__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_0__GROUP_UPDATE_EN__SHIFT = 0x0000000d;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_0__RESERVED__SHIFT    = 0x0000000e;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_1__COEFFICIENT_HIER_SELECT__SHIFT = 0x00000007;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_1__COEFFICIENT__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_1__CONTRIBUTION_HIER_SELECT__SHIFT = 0x0000000a;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_1__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_1__GROUP_UPDATE_EN__SHIFT = 0x0000000d;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_1__RESERVED__SHIFT    = 0x0000000e;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_2__COEFFICIENT_HIER_SELECT__SHIFT = 0x00000007;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_2__COEFFICIENT__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_2__CONTRIBUTION_HIER_SELECT__SHIFT = 0x0000000a;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_2__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_2__GROUP_UPDATE_EN__SHIFT = 0x0000000d;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_2__RESERVED__SHIFT    = 0x0000000e;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_3__COEFFICIENT_HIER_SELECT__SHIFT = 0x00000007;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_3__COEFFICIENT__SHIFT = 0x0000000f;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_3__CONTRIBUTION_HIER_SELECT__SHIFT = 0x0000000a;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_3__CONTRIBUTION__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_3__GROUP_UPDATE_EN__SHIFT = 0x0000000d;
    constexpr unsigned int SPI_SHADER_PREF_PRI_ACCUM_VS_3__RESERVED__SHIFT    = 0x0000000e;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_0__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_1__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_2__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_3__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_4__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_5__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_6__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_7__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_8__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_9__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_10__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_11__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_12__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_13__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_14__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_ES_15__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_0__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_1__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_2__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_3__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_4__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_5__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_6__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_7__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_8__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_9__DATA__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_10__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_11__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_12__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_13__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_14__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SHADER_USER_DATA_LS_15__DATA__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_SYS_COMPUTE__PIPE__SHIFT                       = 0x00000000;
    constexpr unsigned int SPI_SYS_WIF_CNTL__THRESHOLD__SHIFT                 = 0x00000000;
    constexpr unsigned int SPI_WAVE_LIMIT_CNTL_REMAP__RESERVED__SHIFT         = 0x00000000;
    constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS4__VALUE__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS5__VALUE__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS6__VALUE__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_WCL_PIPE_PERCENT_CS7__VALUE__SHIFT             = 0x00000000;
    constexpr unsigned int SPI_WCL_PIPE_PERCENT_GFX__ES_GRP_VALUE__SHIFT      = 0x00000011;
    constexpr unsigned int SPI_WCL_PIPE_PERCENT_GFX__LS_GRP_VALUE__SHIFT      = 0x00000007;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_6__EN_WARN__SHIFT            = 0x0000001f;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_6__MAX_CNT__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_7__EN_WARN__SHIFT            = 0x0000001f;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_7__MAX_CNT__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_8__EN_WARN__SHIFT            = 0x0000001f;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_8__MAX_CNT__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_9__EN_WARN__SHIFT            = 0x0000001f;
    constexpr unsigned int SPI_WF_LIFETIME_LIMIT_9__MAX_CNT__SHIFT            = 0x00000000;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_3__INT_SENT__SHIFT          = 0x0000001f;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_3__MAX_CNT__SHIFT           = 0x00000000;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_5__INT_SENT__SHIFT          = 0x0000001f;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_5__MAX_CNT__SHIFT           = 0x00000000;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_10__INT_SENT__SHIFT         = 0x0000001f;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_10__MAX_CNT__SHIFT          = 0x00000000;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_12__INT_SENT__SHIFT         = 0x0000001f;
    constexpr unsigned int SPI_WF_LIFETIME_STATUS_12__MAX_CNT__SHIFT          = 0x00000000;
    constexpr unsigned int SQ_ARB_CONFIG__DISABLE_SECOND_TRY__SHIFT           = 0x00000008;
    constexpr unsigned int SQ_CONFIG__DEBUG_ONE_INST_CLAUSE__SHIFT            = 0x0000000a;
    constexpr unsigned int SQ_CONFIG__DEBUG_SINGLE_MEMOP__SHIFT               = 0x00000009;
    constexpr unsigned int SQ_CONFIG__OVERRIDE_LDS_IDX_BUSY__SHIFT            = 0x0000000b;
    constexpr unsigned int SQ_CONFIG__REPLAY_SLEEP_CNT__SHIFT                 = 0x00000015;
    constexpr unsigned int SQ_PERFCOUNTER0_SELECT__SQC_BANK_MASK__SHIFT       = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER1_SELECT__SQC_BANK_MASK__SHIFT       = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER2_SELECT__SQC_BANK_MASK__SHIFT       = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER3_SELECT__SQC_BANK_MASK__SHIFT       = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER4_SELECT__SQC_BANK_MASK__SHIFT       = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER5_SELECT__SQC_BANK_MASK__SHIFT       = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER6_SELECT__SQC_BANK_MASK__SHIFT       = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER7_SELECT__SQC_BANK_MASK__SHIFT       = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER8_SELECT__SQC_BANK_MASK__SHIFT       = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER9_SELECT__SQC_BANK_MASK__SHIFT       = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER10_SELECT__SQC_BANK_MASK__SHIFT      = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER11_SELECT__SQC_BANK_MASK__SHIFT      = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER12_SELECT__SQC_BANK_MASK__SHIFT      = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER13_SELECT__SQC_BANK_MASK__SHIFT      = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER14_SELECT__SQC_BANK_MASK__SHIFT      = 0x0000000c;
    constexpr unsigned int SQ_PERFCOUNTER15_SELECT__SQC_BANK_MASK__SHIFT      = 0x0000000c;
    constexpr unsigned int SQ_WATCH0_CNTL__MODE__SHIFT                        = 0x0000001d;
    constexpr unsigned int SQ_WATCH1_CNTL__MODE__SHIFT                        = 0x0000001d;
    constexpr unsigned int SQ_WATCH2_CNTL__MODE__SHIFT                        = 0x0000001d;
    constexpr unsigned int SQ_WATCH3_CNTL__MODE__SHIFT                        = 0x0000001d;
    constexpr unsigned int SQ_WAVE_FLAT_XNACK_MASK__MASK__SHIFT               = 0x00000000;
    constexpr unsigned int SQ_WAVE_IB_STS__FIRST_REPLAY__SHIFT                = 0x0000000f;
    constexpr unsigned int SQ_WAVE_IB_STS__RCNT__SHIFT                        = 0x00000010;
    constexpr unsigned int SQ_WAVE_IB_STS__REPLAY_W64H__SHIFT                 = 0x00000019;
    constexpr unsigned int SQ_WAVE_MODE__CSP__SHIFT                           = 0x0000001d;
    constexpr unsigned int SQ_WAVE_MODE__VSKIP__SHIFT                         = 0x0000001c;
    constexpr unsigned int SQ_WAVE_TRAPSTS__XNACK_ERROR__SHIFT                = 0x0000001c;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT1__PERFCOUNTER_SELECT2__SHIFT = 0x00000000;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT1__PERFCOUNTER_SELECT3__SHIFT = 0x0000000a;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT__PERFCOUNTER_SELECT1__SHIFT = 0x0000000a;
    constexpr unsigned int SX_PERFCOUNTER0_SELECT__PERFCOUNTER_SELECT__SHIFT  = 0x00000000;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT1__PERFCOUNTER_SELECT2__SHIFT = 0x00000000;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT1__PERFCOUNTER_SELECT3__SHIFT = 0x0000000a;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT__PERFCOUNTER_SELECT1__SHIFT = 0x0000000a;
    constexpr unsigned int SX_PERFCOUNTER1_SELECT__PERFCOUNTER_SELECT__SHIFT  = 0x00000000;
    constexpr unsigned int SX_PERFCOUNTER2_SELECT__PERFCOUNTER_SELECT__SHIFT  = 0x00000000;
    constexpr unsigned int SX_PERFCOUNTER3_SELECT__PERFCOUNTER_SELECT__SHIFT  = 0x00000000;
    constexpr unsigned int TA_CNTL_AUX__RESERVED__SHIFT                       = 0x00000001;
    constexpr unsigned int TA_CNTL__FX_XNACK_CREDIT__SHIFT                    = 0x00000000;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_BUSY__SHIFT                   = 0x00000000;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_GS_BUSY__SHIFT                = 0x00000007;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_HS_BUSY__SHIFT                = 0x00000008;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_OUT_BUSY__SHIFT               = 0x00000002;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_OUT_INDX_BUSY__SHIFT          = 0x00000001;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_PI_BUSY__SHIFT                = 0x00000006;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_PRIMGEN_BUSY__SHIFT           = 0x0000000a;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_PT_BUSY__SHIFT                = 0x00000003;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_TE11_BUSY__SHIFT              = 0x00000009;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_TE_BUSY__SHIFT                = 0x00000004;
    constexpr unsigned int VGT_CNTL_STATUS__VGT_VR_BUSY__SHIFT                = 0x00000005;
    constexpr unsigned int VGT_DISPATCH_DRAW_INDEX__MATCH_INDEX__SHIFT        = 0x00000000;
    constexpr unsigned int VGT_DRAW_INITIATOR__GRBM_SKEW_NO_DEC__SHIFT        = 0x00000008;
    constexpr unsigned int VGT_DRAW_INITIATOR__UNROLLED_INST__SHIFT           = 0x00000007;
    constexpr unsigned int VGT_ESGS_RING_SIZE_UMD__MEM_SIZE__SHIFT            = 0x00000000;
    constexpr unsigned int VGT_GSVS_RING_SIZE_UMD__MEM_SIZE__SHIFT            = 0x00000000;
    constexpr unsigned int VGT_HS_OFFCHIP_PARAM_UMD__OFFCHIP_BUFFERING__SHIFT = 0x00000000;
    constexpr unsigned int VGT_HS_OFFCHIP_PARAM_UMD__OFFCHIP_GRANULARITY__SHIFT = 0x00000009;
    constexpr unsigned int VGT_HS_OFFCHIP_PARAM__OFFCHIP_GRANULARITY__SHIFT   = 0x00000009;
    constexpr unsigned int VGT_SHADER_STAGES_EN__DISPATCH_DRAW_EN__SHIFT      = 0x00000009;
    constexpr unsigned int VGT_SHADER_STAGES_EN__DIS_DEALLOC_ACCUM_0__SHIFT   = 0x0000000a;
    constexpr unsigned int VGT_SHADER_STAGES_EN__DIS_DEALLOC_ACCUM_1__SHIFT   = 0x0000000b;
    constexpr unsigned int VGT_TF_MEMORY_BASE_HI_UMD__BASE_HI__SHIFT          = 0x00000000;
    constexpr unsigned int VGT_TF_MEMORY_BASE_UMD__BASE__SHIFT                = 0x00000000;
    constexpr unsigned int VGT_TF_RING_SIZE_UMD__SIZE__SHIFT                  = 0x00000000;
    constexpr unsigned int WD_CNTL_STATUS__WD_ADC_BUSY__SHIFT                 = 0x00000003;
    constexpr unsigned int WD_CNTL_STATUS__WD_BUSY__SHIFT                     = 0x00000000;
    constexpr unsigned int WD_CNTL_STATUS__WD_SPL_DI_BUSY__SHIFT              = 0x00000002;
    constexpr unsigned int WD_CNTL_STATUS__WD_SPL_DMA_BUSY__SHIFT             = 0x00000001;
} // namespace Gfx101

namespace Gfx10Core
{
    constexpr unsigned int CB_COLOR0_ATTRIB3__RESOURCE_LEVEL__SHIFT           = 0x0000001b;
    constexpr unsigned int CB_COLOR0_ATTRIB__DISABLE_FMASK_NOFETCH_OPT__SHIFT = 0x00000012;
    constexpr unsigned int CB_COLOR0_ATTRIB__FMASK_BANK_HEIGHT__SHIFT         = 0x0000000a;
    constexpr unsigned int CB_COLOR0_ATTRIB__FMASK_TILE_MODE_INDEX__SHIFT     = 0x00000005;
    constexpr unsigned int CB_COLOR0_ATTRIB__LIMIT_COLOR_FETCH_TO_256B_MAX__SHIFT = 0x00000013;
    constexpr unsigned int CB_COLOR0_ATTRIB__TILE_MODE_INDEX__SHIFT           = 0x00000000;
    constexpr unsigned int CB_COLOR0_CMASK_SLICE__TILE_MAX__SHIFT             = 0x00000000;
    constexpr unsigned int CB_COLOR0_FMASK_SLICE__TILE_MAX__SHIFT             = 0x00000000;
    constexpr unsigned int CB_COLOR0_INFO__CMASK_IS_LINEAR__SHIFT             = 0x00000013;
    constexpr unsigned int CB_COLOR0_PITCH__FMASK_TILE_MAX__SHIFT             = 0x00000014;
    constexpr unsigned int CB_COLOR0_PITCH__TILE_MAX__SHIFT                   = 0x00000000;
    constexpr unsigned int CB_COLOR0_SLICE__TILE_MAX__SHIFT                   = 0x00000000;
    constexpr unsigned int CB_COLOR1_ATTRIB3__RESOURCE_LEVEL__SHIFT           = 0x0000001b;
    constexpr unsigned int CB_COLOR1_ATTRIB__DISABLE_FMASK_NOFETCH_OPT__SHIFT = 0x00000012;
    constexpr unsigned int CB_COLOR1_ATTRIB__FMASK_BANK_HEIGHT__SHIFT         = 0x0000000a;
    constexpr unsigned int CB_COLOR1_ATTRIB__FMASK_TILE_MODE_INDEX__SHIFT     = 0x00000005;
    constexpr unsigned int CB_COLOR1_ATTRIB__LIMIT_COLOR_FETCH_TO_256B_MAX__SHIFT = 0x00000013;
    constexpr unsigned int CB_COLOR1_ATTRIB__TILE_MODE_INDEX__SHIFT           = 0x00000000;
    constexpr unsigned int CB_COLOR1_CMASK_SLICE__TILE_MAX__SHIFT             = 0x00000000;
    constexpr unsigned int CB_COLOR1_FMASK_SLICE__TILE_MAX__SHIFT             = 0x00000000;
    constexpr unsigned int CB_COLOR1_INFO__CMASK_IS_LINEAR__SHIFT             = 0x00000013;
    constexpr unsigned int CB_COLOR1_PITCH__FMASK_TILE_MAX__SHIFT             = 0x00000014;
    constexpr unsigned int CB_COLOR1_PITCH__TILE_MAX__SHIFT                   = 0x00000000;
    constexpr unsigned int CB_COLOR1_SLICE__TILE_MAX__SHIFT                   = 0x00000000;
    constexpr unsigned int CB_COLOR2_ATTRIB3__RESOURCE_LEVEL__SHIFT           = 0x0000001b;
    constexpr unsigned int CB_COLOR2_ATTRIB__DISABLE_FMASK_NOFETCH_OPT__SHIFT = 0x00000012;
    constexpr unsigned int CB_COLOR2_ATTRIB__FMASK_BANK_HEIGHT__SHIFT         = 0x0000000a;
    constexpr unsigned int CB_COLOR2_ATTRIB__FMASK_TILE_MODE_INDEX__SHIFT     = 0x00000005;
    constexpr unsigned int CB_COLOR2_ATTRIB__LIMIT_COLOR_FETCH_TO_256B_MAX__SHIFT = 0x00000013;
    constexpr unsigned int CB_COLOR2_ATTRIB__TILE_MODE_INDEX__SHIFT           = 0x00000000;
    constexpr unsigned int CB_COLOR2_CMASK_SLICE__TILE_MAX__SHIFT             = 0x00000000;
    constexpr unsigned int CB_COLOR2_FMASK_SLICE__TILE_MAX__SHIFT             = 0x00000000;
    constexpr unsigned int CB_COLOR2_INFO__CMASK_IS_LINEAR__SHIFT             = 0x00000013;
    constexpr unsigned int CB_COLOR2_PITCH__FMASK_TILE_MAX__SHIFT             = 0x00000014;
    constexpr unsigned int CB_COLOR2_PITCH__TILE_MAX__SHIFT                   = 0x00000000;
    constexpr unsigned int CB_COLOR2_SLICE__TILE_MAX__SHIFT                   = 0x00000000;
    constexpr unsigned int CB_COLOR3_ATTRIB3__RESOURCE_LEVEL__SHIFT           = 0x0000001b;
    constexpr unsigned int CB_COLOR3_ATTRIB__DISABLE_FMASK_NOFETCH_OPT__SHIFT = 0x00000012;
    constexpr unsigned int CB_COLOR3_ATTRIB__FMASK_BANK_HEIGHT__SHIFT         = 0x0000000a;
    constexpr unsigned int CB_COLOR3_ATTRIB__FMASK_TILE_MODE_INDEX__SHIFT     = 0x00000005;
    constexpr unsigned int CB_COLOR3_ATTRIB__LIMIT_COLOR_FETCH_TO_256B_MAX__SHIFT = 0x00000013;
    constexpr unsigned int CB_COLOR3_ATTRIB__TILE_MODE_INDEX__SHIFT           = 0x00000000;
    constexpr unsigned int CB_COLOR3_CMASK_SLICE__TILE_MAX__SHIFT             = 0x00000000;
    constexpr unsigned int CB_COLOR3_FMASK_SLICE__TILE_MAX__SHIFT             = 0x00000000;
    constexpr unsigned int CB_COLOR3_INFO__CMASK_IS_LINEAR__SHIFT             = 0x00000013;
    constexpr unsigned int CB_COLOR3_PITCH__FMASK_TILE_MAX__SHIFT             = 0x00000014;
    constexpr unsigned int CB_COLOR3_PITCH__TILE_MAX__SHIFT                   = 0x00000000;
    constexpr unsigned int CB_COLOR3_SLICE__TILE_MAX__SHIFT                   = 0x00000000;
    constexpr unsigned int CB_COLOR4_ATTRIB3__RESOURCE_LEVEL__SHIFT           = 0x0000001b;
    constexpr unsigned int CB_COLOR4_ATTRIB__DISABLE_FMASK_NOFETCH_OPT__SHIFT = 0x00000012;
    constexpr unsigned int CB_COLOR4_ATTRIB__FMASK_BANK_HEIGHT__SHIFT         = 0x0000000a;
    constexpr unsigned int CB_COLOR4_ATTRIB__FMASK_TILE_MODE_INDEX__SHIFT     = 0x00000005;
    constexpr unsigned int CB_COLOR4_ATTRIB__LIMIT_COLOR_FETCH_TO_256B_MAX__SHIFT = 0x00000013;
    constexpr unsigned int CB_COLOR4_ATTRIB__TILE_MODE_INDEX__SHIFT           = 0x00000000;
    constexpr unsigned int CB_COLOR4_CMASK_SLICE__TILE_MAX__SHIFT             = 0x00000000;
    constexpr unsigned int CB_COLOR4_FMASK_SLICE__TILE_MAX__SHIFT             = 0x00000000;
    constexpr unsigned int CB_COLOR4_INFO__CMASK_IS_LINEAR__SHIFT             = 0x00000013;
    constexpr unsigned int CB_COLOR4_PITCH__FMASK_TILE_MAX__SHIFT             = 0x00000014;
    constexpr unsigned int CB_COLOR4_PITCH__TILE_MAX__SHIFT                   = 0x00000000;
    constexpr unsigned int CB_COLOR4_SLICE__TILE_MAX__SHIFT                   = 0x00000000;
    constexpr unsigned int CB_COLOR5_ATTRIB3__RESOURCE_LEVEL__SHIFT           = 0x0000001b;
    constexpr unsigned int CB_COLOR5_ATTRIB__DISABLE_FMASK_NOFETCH_OPT__SHIFT = 0x00000012;
    constexpr unsigned int CB_COLOR5_ATTRIB__FMASK_BANK_HEIGHT__SHIFT         = 0x0000000a;
    constexpr unsigned int CB_COLOR5_ATTRIB__FMASK_TILE_MODE_INDEX__SHIFT     = 0x00000005;
    constexpr unsigned int CB_COLOR5_ATTRIB__LIMIT_COLOR_FETCH_TO_256B_MAX__SHIFT = 0x00000013;
    constexpr unsigned int CB_COLOR5_ATTRIB__TILE_MODE_INDEX__SHIFT           = 0x00000000;
    constexpr unsigned int CB_COLOR5_CMASK_SLICE__TILE_MAX__SHIFT             = 0x00000000;
    constexpr unsigned int CB_COLOR5_FMASK_SLICE__TILE_MAX__SHIFT             = 0x00000000;
    constexpr unsigned int CB_COLOR5_INFO__CMASK_IS_LINEAR__SHIFT             = 0x00000013;
    constexpr unsigned int CB_COLOR5_PITCH__FMASK_TILE_MAX__SHIFT             = 0x00000014;
    constexpr unsigned int CB_COLOR5_PITCH__TILE_MAX__SHIFT                   = 0x00000000;
    constexpr unsigned int CB_COLOR5_SLICE__TILE_MAX__SHIFT                   = 0x00000000;
    constexpr unsigned int CB_COLOR6_ATTRIB3__RESOURCE_LEVEL__SHIFT           = 0x0000001b;
    constexpr unsigned int CB_COLOR6_ATTRIB__DISABLE_FMASK_NOFETCH_OPT__SHIFT = 0x00000012;
    constexpr unsigned int CB_COLOR6_ATTRIB__FMASK_BANK_HEIGHT__SHIFT         = 0x0000000a;
    constexpr unsigned int CB_COLOR6_ATTRIB__FMASK_TILE_MODE_INDEX__SHIFT     = 0x00000005;
    constexpr unsigned int CB_COLOR6_ATTRIB__LIMIT_COLOR_FETCH_TO_256B_MAX__SHIFT = 0x00000013;
    constexpr unsigned int CB_COLOR6_ATTRIB__TILE_MODE_INDEX__SHIFT           = 0x00000000;
    constexpr unsigned int CB_COLOR6_CMASK_SLICE__TILE_MAX__SHIFT             = 0x00000000;
    constexpr unsigned int CB_COLOR6_FMASK_SLICE__TILE_MAX__SHIFT             = 0x00000000;
    constexpr unsigned int CB_COLOR6_INFO__CMASK_IS_LINEAR__SHIFT             = 0x00000013;
    constexpr unsigned int CB_COLOR6_PITCH__FMASK_TILE_MAX__SHIFT             = 0x00000014;
    constexpr unsigned int CB_COLOR6_PITCH__TILE_MAX__SHIFT                   = 0x00000000;
    constexpr unsigned int CB_COLOR6_SLICE__TILE_MAX__SHIFT                   = 0x00000000;
    constexpr unsigned int CB_COLOR7_ATTRIB3__RESOURCE_LEVEL__SHIFT           = 0x0000001b;
    constexpr unsigned int CB_COLOR7_ATTRIB__DISABLE_FMASK_NOFETCH_OPT__SHIFT = 0x00000012;
    constexpr unsigned int CB_COLOR7_ATTRIB__FMASK_BANK_HEIGHT__SHIFT         = 0x0000000a;
    constexpr unsigned int CB_COLOR7_ATTRIB__FMASK_TILE_MODE_INDEX__SHIFT     = 0x00000005;
    constexpr unsigned int CB_COLOR7_ATTRIB__LIMIT_COLOR_FETCH_TO_256B_MAX__SHIFT = 0x00000013;
    constexpr unsigned int CB_COLOR7_ATTRIB__TILE_MODE_INDEX__SHIFT           = 0x00000000;
    constexpr unsigned int CB_COLOR7_CMASK_SLICE__TILE_MAX__SHIFT             = 0x00000000;
    constexpr unsigned int CB_COLOR7_FMASK_SLICE__TILE_MAX__SHIFT             = 0x00000000;
    constexpr unsigned int CB_COLOR7_INFO__CMASK_IS_LINEAR__SHIFT             = 0x00000013;
    constexpr unsigned int CB_COLOR7_PITCH__FMASK_TILE_MAX__SHIFT             = 0x00000014;
    constexpr unsigned int CB_COLOR7_PITCH__TILE_MAX__SHIFT                   = 0x00000000;
    constexpr unsigned int CB_COLOR7_SLICE__TILE_MAX__SHIFT                   = 0x00000000;
    constexpr unsigned int CB_HW_CONTROL_3__DISABLE_FMASK_NOFETCH_OPT_BC__SHIFT = 0x0000001f;
    constexpr unsigned int CB_HW_CONTROL_4__DISABLE_BC_COLOR_CACHE_PREFETCH__SHIFT = 0x0000000e;
    constexpr unsigned int CB_RMI_BC_GL2_CACHE_CONTROL__CMASK_RD_POLICY__SHIFT = 0x00000010;
    constexpr unsigned int CB_RMI_BC_GL2_CACHE_CONTROL__CMASK_WR_POLICY__SHIFT = 0x00000000;
    constexpr unsigned int CB_RMI_BC_GL2_CACHE_CONTROL__COLOR_RD_POLICY__SHIFT = 0x00000016;
    constexpr unsigned int CB_RMI_BC_GL2_CACHE_CONTROL__COLOR_WR_POLICY__SHIFT = 0x00000006;
    constexpr unsigned int CB_RMI_BC_GL2_CACHE_CONTROL__DCC_RD_POLICY__SHIFT  = 0x00000014;
    constexpr unsigned int CB_RMI_BC_GL2_CACHE_CONTROL__DCC_WR_POLICY__SHIFT  = 0x00000004;
    constexpr unsigned int CB_RMI_BC_GL2_CACHE_CONTROL__FMASK_RD_POLICY__SHIFT = 0x00000012;
    constexpr unsigned int CB_RMI_BC_GL2_CACHE_CONTROL__FMASK_WR_POLICY__SHIFT = 0x00000002;
    constexpr unsigned int CB_RMI_BC_GL2_CACHE_CONTROL__VOLAT__SHIFT          = 0x0000001f;
    constexpr unsigned int DB_DFSM_CONFIG__CAM_WATERMARK__SHIFT               = 0x00000010;
    constexpr unsigned int DB_DFSM_CONFIG__OUTPUT_WATCHDOG__SHIFT             = 0x00000018;
    constexpr unsigned int DB_DFSM_CONFIG__SQUAD_WATERMARK__SHIFT             = 0x00000004;
    constexpr unsigned int DB_RMI_BC_GL2_CACHE_CONTROL__HTILE_RD_POLICY__SHIFT = 0x00000014;
    constexpr unsigned int DB_RMI_BC_GL2_CACHE_CONTROL__HTILE_WR_POLICY__SHIFT = 0x00000004;
    constexpr unsigned int DB_RMI_BC_GL2_CACHE_CONTROL__S_RD_POLICY__SHIFT    = 0x00000012;
    constexpr unsigned int DB_RMI_BC_GL2_CACHE_CONTROL__S_WR_POLICY__SHIFT    = 0x00000002;
    constexpr unsigned int DB_RMI_BC_GL2_CACHE_CONTROL__VOL__SHIFT            = 0x0000001f;
    constexpr unsigned int DB_RMI_BC_GL2_CACHE_CONTROL__ZPCPSD_WR_POLICY__SHIFT = 0x00000006;
    constexpr unsigned int DB_RMI_BC_GL2_CACHE_CONTROL__Z_RD_POLICY__SHIFT    = 0x00000010;
    constexpr unsigned int DB_RMI_BC_GL2_CACHE_CONTROL__Z_WR_POLICY__SHIFT    = 0x00000000;
    constexpr unsigned int GE_PC_CNTL__EN_GEN_0_1_LATE_ALLOC__SHIFT           = 0x00000010;
    constexpr unsigned int GRBM_PERFCOUNTER0_SELECT_HI__GUS_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000007;
    constexpr unsigned int GRBM_PERFCOUNTER0_SELECT_HI__PMM_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000006;
    constexpr unsigned int GRBM_PERFCOUNTER1_SELECT_HI__GUS_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000007;
    constexpr unsigned int GRBM_PERFCOUNTER1_SELECT_HI__PMM_BUSY_USER_DEFINED_MASK__SHIFT = 0x00000006;
    constexpr unsigned int PA_SC_ENHANCE_2__ENABLE_BLOCKING_WRITES_OF_GEN2_REG__SHIFT = 0x00000014;
    constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_BC__SHIFT                 = 0x0000000c;
    constexpr unsigned int RLC_SPM_MC_CNTL__RLC_SPM_VOL__SHIFT                = 0x0000000e;
    constexpr unsigned int SDMA0_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
    constexpr unsigned int SDMA0_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
    constexpr unsigned int SDMA0_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT      = 0x0000001c;
    constexpr unsigned int SDMA0_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT      = 0x00000018;
    constexpr unsigned int SDMA0_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT       = 0x00000000;
    constexpr unsigned int SDMA0_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT       = 0x0000000a;
    constexpr unsigned int SDMA0_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT        = 0x00000014;
    constexpr unsigned int SDMA0_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT       = 0x00000018;
    constexpr unsigned int SDMA0_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT        = 0x0000001c;
    constexpr unsigned int SDMA0_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT        = 0x0000000a;
    constexpr unsigned int SDMA0_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT         = 0x00000000;
    constexpr unsigned int SDMA0_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
    constexpr unsigned int SDMA0_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
    constexpr unsigned int SDMA0_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT      = 0x0000001c;
    constexpr unsigned int SDMA0_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT      = 0x00000018;
    constexpr unsigned int SDMA0_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT       = 0x00000000;
    constexpr unsigned int SDMA0_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT       = 0x0000000a;
    constexpr unsigned int SDMA0_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT        = 0x00000014;
    constexpr unsigned int SDMA0_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT       = 0x00000018;
    constexpr unsigned int SDMA0_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT        = 0x0000001c;
    constexpr unsigned int SDMA0_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT        = 0x0000000a;
    constexpr unsigned int SDMA0_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT         = 0x00000000;
    constexpr unsigned int SQ_WAVE_HW_ID2__COMPAT_LEVEL__SHIFT                = 0x0000001d;
    constexpr unsigned int SQ_WAVE_HW_ID_LEGACY__CU_ID__SHIFT                 = 0x00000008;
    constexpr unsigned int SQ_WAVE_HW_ID_LEGACY__ME_ID__SHIFT                 = 0x0000001e;
    constexpr unsigned int SQ_WAVE_HW_ID_LEGACY__PIPE_ID__SHIFT               = 0x00000006;
    constexpr unsigned int SQ_WAVE_HW_ID_LEGACY__QUEUE_ID__SHIFT              = 0x00000018;
    constexpr unsigned int SQ_WAVE_HW_ID_LEGACY__SE_ID__SHIFT                 = 0x0000000d;
    constexpr unsigned int SQ_WAVE_HW_ID_LEGACY__SH_ID__SHIFT                 = 0x0000000c;
    constexpr unsigned int SQ_WAVE_HW_ID_LEGACY__SIMD_ID__SHIFT               = 0x00000004;
    constexpr unsigned int SQ_WAVE_HW_ID_LEGACY__STATE_ID__SHIFT              = 0x0000001b;
    constexpr unsigned int SQ_WAVE_HW_ID_LEGACY__TG_ID__SHIFT                 = 0x00000010;
    constexpr unsigned int SQ_WAVE_HW_ID_LEGACY__VM_ID__SHIFT                 = 0x00000014;
    constexpr unsigned int SQ_WAVE_HW_ID_LEGACY__WAVE_ID_MSB__SHIFT           = 0x0000000f;
    constexpr unsigned int SQ_WAVE_HW_ID_LEGACY__WAVE_ID__SHIFT               = 0x00000000;
    constexpr unsigned int SQ_WAVE_IB_STS2__RESOURCE_OVERRIDE__SHIFT          = 0x00000007;
    constexpr unsigned int SQ_WAVE_IB_STS__LGKM_CNT_BIT4__SHIFT               = 0x00000007;
    constexpr unsigned int SQ_WAVE_IB_STS__LGKM_CNT_BIT5__SHIFT               = 0x00000018;
    constexpr unsigned int SQ_WAVE_VGPR_OFFSET__DST__SHIFT                    = 0x00000012;
    constexpr unsigned int SQ_WAVE_VGPR_OFFSET__SRC0__SHIFT                   = 0x00000000;
    constexpr unsigned int SQ_WAVE_VGPR_OFFSET__SRC1__SHIFT                   = 0x00000006;
    constexpr unsigned int SQ_WAVE_VGPR_OFFSET__SRC2__SHIFT                   = 0x0000000c;
    constexpr unsigned int TA_CNTL_AUX__DERIV_ADJUST_DIS__SHIFT               = 0x00000004;
} // namespace Gfx10Core

namespace Nv10
{
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE0__SHIFT           = 0x00000000;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE1__SHIFT           = 0x00000001;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE2__SHIFT           = 0x00000002;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE3__SHIFT           = 0x00000003;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE4__SHIFT           = 0x00000004;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE5__SHIFT           = 0x00000005;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE6__SHIFT           = 0x00000006;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE7__SHIFT           = 0x00000007;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE8__SHIFT           = 0x00000008;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE9__SHIFT           = 0x00000009;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE10__SHIFT          = 0x0000000a;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE11__SHIFT          = 0x0000000b;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE12__SHIFT          = 0x0000000c;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE13__SHIFT          = 0x0000000d;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE14__SHIFT          = 0x0000000e;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE15__SHIFT          = 0x0000000f;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE16__SHIFT          = 0x00000010;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE17__SHIFT          = 0x00000011;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE18__SHIFT          = 0x00000012;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE19__SHIFT          = 0x00000013;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE20__SHIFT          = 0x00000014;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE21__SHIFT          = 0x00000015;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE22__SHIFT          = 0x00000016;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE23__SHIFT          = 0x00000017;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE24__SHIFT          = 0x00000018;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE25__SHIFT          = 0x00000019;
    constexpr unsigned int DB_FGCG_SRAMS_CLK_CTRL__OVERRIDE26__SHIFT          = 0x0000001a;
    constexpr unsigned int DB_HTILE_SURFACE__RESERVED_FIELD_1__SHIFT          = 0x00000000;
    constexpr unsigned int DB_HTILE_SURFACE__RESERVED_FIELD_2__SHIFT          = 0x00000002;
    constexpr unsigned int DB_HTILE_SURFACE__RESERVED_FIELD_3__SHIFT          = 0x00000003;
    constexpr unsigned int DB_HTILE_SURFACE__RESERVED_FIELD_4__SHIFT          = 0x00000004;
    constexpr unsigned int DB_HTILE_SURFACE__RESERVED_FIELD_5__SHIFT          = 0x0000000a;
    constexpr unsigned int DB_HTILE_SURFACE__RESERVED_FIELD_6__SHIFT          = 0x00000011;
    constexpr unsigned int DB_RESERVED_REG_1__FIELD_1__SHIFT                  = 0x00000000;
    constexpr unsigned int DB_RESERVED_REG_1__FIELD_2__SHIFT                  = 0x0000000b;
    constexpr unsigned int DB_RESERVED_REG_2__FIELD_1__SHIFT                  = 0x00000000;
    constexpr unsigned int DB_RESERVED_REG_2__FIELD_2__SHIFT                  = 0x00000004;
    constexpr unsigned int DB_RESERVED_REG_2__FIELD_3__SHIFT                  = 0x00000008;
    constexpr unsigned int DB_RESERVED_REG_2__FIELD_4__SHIFT                  = 0x0000000d;
    constexpr unsigned int DB_RESERVED_REG_2__FIELD_5__SHIFT                  = 0x0000000f;
    constexpr unsigned int DB_RESERVED_REG_2__FIELD_6__SHIFT                  = 0x00000011;
    constexpr unsigned int DB_RESERVED_REG_2__FIELD_7__SHIFT                  = 0x00000013;
    constexpr unsigned int DB_RESERVED_REG_2__FIELD_8__SHIFT                  = 0x0000001c;
    constexpr unsigned int DB_RESERVED_REG_3__FIELD_1__SHIFT                  = 0x00000000;
    constexpr unsigned int DB_STENCIL_INFO__RESERVED_FIELD_1__SHIFT           = 0x0000000d;
    constexpr unsigned int DB_Z_INFO__RESERVED_FIELD_1__SHIFT                 = 0x0000000d;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi0__BypassEn__SHIFT          = 0x0000001f;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi0__EventSelect_11_8__SHIFT  = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi0__EventSelect_13_12__SHIFT = 0x0000001d;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi1__BypassEn__SHIFT          = 0x0000001f;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi1__EventSelect_11_8__SHIFT  = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi1__EventSelect_13_12__SHIFT = 0x0000001d;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi2__BypassEn__SHIFT          = 0x0000001f;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi2__EventSelect_11_8__SHIFT  = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi2__EventSelect_13_12__SHIFT = 0x0000001d;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi3__BypassEn__SHIFT          = 0x0000001f;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi3__EventSelect_11_8__SHIFT  = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi3__EventSelect_13_12__SHIFT = 0x0000001d;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi4__BypassEn__SHIFT          = 0x0000001f;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi4__EventSelect_11_8__SHIFT  = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi4__EventSelect_13_12__SHIFT = 0x0000001d;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi5__BypassEn__SHIFT          = 0x0000001f;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi5__EventSelect_11_8__SHIFT  = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi5__EventSelect_13_12__SHIFT = 0x0000001d;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi6__BypassEn__SHIFT          = 0x0000001f;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi6__EventSelect_11_8__SHIFT  = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi6__EventSelect_13_12__SHIFT = 0x0000001d;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi7__BypassEn__SHIFT          = 0x0000001f;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi7__EventSelect_11_8__SHIFT  = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi7__EventSelect_13_12__SHIFT = 0x0000001d;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo0__DsmTrig__SHIFT           = 0x00000013;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo0__En__SHIFT                = 0x00000016;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo0__EventSelect_7_0__SHIFT   = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo0__Mp1Int__SHIFT            = 0x00000015;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo0__UnitMask__SHIFT          = 0x00000008;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo1__DsmTrig__SHIFT           = 0x00000013;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo1__En__SHIFT                = 0x00000016;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo1__EventSelect_7_0__SHIFT   = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo1__Mp1Int__SHIFT            = 0x00000015;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo1__UnitMask__SHIFT          = 0x00000008;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo2__DsmTrig__SHIFT           = 0x00000013;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo2__En__SHIFT                = 0x00000016;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo2__EventSelect_7_0__SHIFT   = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo2__Mp1Int__SHIFT            = 0x00000015;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo2__UnitMask__SHIFT          = 0x00000008;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo3__DsmTrig__SHIFT           = 0x00000013;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo3__En__SHIFT                = 0x00000016;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo3__EventSelect_7_0__SHIFT   = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo3__Mp1Int__SHIFT            = 0x00000015;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo3__UnitMask__SHIFT          = 0x00000008;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo4__DsmTrig__SHIFT           = 0x00000013;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo4__En__SHIFT                = 0x00000016;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo4__EventSelect_7_0__SHIFT   = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo4__Mp1Int__SHIFT            = 0x00000015;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo4__UnitMask__SHIFT          = 0x00000008;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo5__DsmTrig__SHIFT           = 0x00000013;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo5__En__SHIFT                = 0x00000016;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo5__EventSelect_7_0__SHIFT   = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo5__Mp1Int__SHIFT            = 0x00000015;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo5__UnitMask__SHIFT          = 0x00000008;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo6__DsmTrig__SHIFT           = 0x00000013;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo6__En__SHIFT                = 0x00000016;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo6__EventSelect_7_0__SHIFT   = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo6__Mp1Int__SHIFT            = 0x00000015;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo6__UnitMask__SHIFT          = 0x00000008;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo7__DsmTrig__SHIFT           = 0x00000013;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo7__En__SHIFT                = 0x00000016;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo7__EventSelect_7_0__SHIFT   = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo7__Mp1Int__SHIFT            = 0x00000015;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo7__UnitMask__SHIFT          = 0x00000008;
    constexpr unsigned int DF_PIE_AON_PerfMonCtrHi0__CTR_47_32__SHIFT         = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtrHi1__CTR_47_32__SHIFT         = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtrHi2__CTR_47_32__SHIFT         = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtrHi3__CTR_47_32__SHIFT         = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtrHi4__CTR_47_32__SHIFT         = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtrHi5__CTR_47_32__SHIFT         = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtrHi6__CTR_47_32__SHIFT         = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtrHi7__CTR_47_32__SHIFT         = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtrLo0__CTR_31_0__SHIFT          = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtrLo1__CTR_31_0__SHIFT          = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtrLo2__CTR_31_0__SHIFT          = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtrLo3__CTR_31_0__SHIFT          = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtrLo4__CTR_31_0__SHIFT          = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtrLo5__CTR_31_0__SHIFT          = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtrLo6__CTR_31_0__SHIFT          = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtrLo7__CTR_31_0__SHIFT          = 0x00000000;
    constexpr unsigned int PA_SC_ENHANCE_2__RSVD__SHIFT                       = 0x0000001e;
    constexpr unsigned int PerfMonCtl1__ChipIDSel__SHIFT                      = 0x00000014;
    constexpr unsigned int PerfMonCtl1__ChipSelMask__SHIFT                    = 0x00000010;
    constexpr unsigned int PerfMonCtl1__Enable__SHIFT                         = 0x0000001f;
    constexpr unsigned int PerfMonCtl1__EventSelect__SHIFT                    = 0x00000000;
    constexpr unsigned int PerfMonCtl1__PriorityMask__SHIFT                   = 0x0000000a;
    constexpr unsigned int PerfMonCtl1__RdWrMask__SHIFT                       = 0x00000008;
    constexpr unsigned int PerfMonCtl1__ReqSizeMask__SHIFT                    = 0x0000000e;
    constexpr unsigned int PerfMonCtl1__SubChanMask__SHIFT                    = 0x0000001d;
    constexpr unsigned int PerfMonCtl1__VCSel__SHIFT                          = 0x00000018;
    constexpr unsigned int PerfMonCtl2__ChipIDSel__SHIFT                      = 0x00000014;
    constexpr unsigned int PerfMonCtl2__ChipSelMask__SHIFT                    = 0x00000010;
    constexpr unsigned int PerfMonCtl2__Enable__SHIFT                         = 0x0000001f;
    constexpr unsigned int PerfMonCtl2__EventSelect__SHIFT                    = 0x00000000;
    constexpr unsigned int PerfMonCtl2__PriorityMask__SHIFT                   = 0x0000000a;
    constexpr unsigned int PerfMonCtl2__RdWrMask__SHIFT                       = 0x00000008;
    constexpr unsigned int PerfMonCtl2__ReqSizeMask__SHIFT                    = 0x0000000e;
    constexpr unsigned int PerfMonCtl2__SubChanMask__SHIFT                    = 0x0000001d;
    constexpr unsigned int PerfMonCtl2__VCSel__SHIFT                          = 0x00000018;
    constexpr unsigned int PerfMonCtl3__ChipIDSel__SHIFT                      = 0x00000014;
    constexpr unsigned int PerfMonCtl3__ChipSelMask__SHIFT                    = 0x00000010;
    constexpr unsigned int PerfMonCtl3__Enable__SHIFT                         = 0x0000001f;
    constexpr unsigned int PerfMonCtl3__EventSelect__SHIFT                    = 0x00000000;
    constexpr unsigned int PerfMonCtl3__PriorityMask__SHIFT                   = 0x0000000a;
    constexpr unsigned int PerfMonCtl3__RdWrMask__SHIFT                       = 0x00000008;
    constexpr unsigned int PerfMonCtl3__ReqSizeMask__SHIFT                    = 0x0000000e;
    constexpr unsigned int PerfMonCtl3__SubChanMask__SHIFT                    = 0x0000001d;
    constexpr unsigned int PerfMonCtl3__VCSel__SHIFT                          = 0x00000018;
    constexpr unsigned int PerfMonCtl4__ChipIDSel__SHIFT                      = 0x00000014;
    constexpr unsigned int PerfMonCtl4__ChipSelMask__SHIFT                    = 0x00000010;
    constexpr unsigned int PerfMonCtl4__Enable__SHIFT                         = 0x0000001f;
    constexpr unsigned int PerfMonCtl4__EventSelect__SHIFT                    = 0x00000000;
    constexpr unsigned int PerfMonCtl4__PriorityMask__SHIFT                   = 0x0000000a;
    constexpr unsigned int PerfMonCtl4__RdWrMask__SHIFT                       = 0x00000008;
    constexpr unsigned int PerfMonCtl4__ReqSizeMask__SHIFT                    = 0x0000000e;
    constexpr unsigned int PerfMonCtl4__SubChanMask__SHIFT                    = 0x0000001d;
    constexpr unsigned int PerfMonCtl4__VCSel__SHIFT                          = 0x00000018;
    constexpr unsigned int PerfMonCtl5__ChipIDSel__SHIFT                      = 0x00000014;
    constexpr unsigned int PerfMonCtl5__ChipSelMask__SHIFT                    = 0x00000010;
    constexpr unsigned int PerfMonCtl5__Enable__SHIFT                         = 0x0000001f;
    constexpr unsigned int PerfMonCtl5__EventSelect__SHIFT                    = 0x00000000;
    constexpr unsigned int PerfMonCtl5__PriorityMask__SHIFT                   = 0x0000000a;
    constexpr unsigned int PerfMonCtl5__RdWrMask__SHIFT                       = 0x00000008;
    constexpr unsigned int PerfMonCtl5__ReqSizeMask__SHIFT                    = 0x0000000e;
    constexpr unsigned int PerfMonCtl5__SubChanMask__SHIFT                    = 0x0000001d;
    constexpr unsigned int PerfMonCtl5__VCSel__SHIFT                          = 0x00000018;
    constexpr unsigned int PerfMonCtlClk__CtrClkEn__SHIFT                     = 0x0000001f;
    constexpr unsigned int PerfMonCtlClk__GlblMonEn__SHIFT                    = 0x00000019;
    constexpr unsigned int PerfMonCtlClk__GlblResetMsk__SHIFT                 = 0x00000000;
    constexpr unsigned int PerfMonCtlClk__GlblReset__SHIFT                    = 0x00000018;
    constexpr unsigned int PerfMonCtr1_Hi__Data__SHIFT                        = 0x00000000;
    constexpr unsigned int PerfMonCtr1_Hi__Overflow__SHIFT                    = 0x00000010;
    constexpr unsigned int PerfMonCtr1_Lo__Data__SHIFT                        = 0x00000000;
    constexpr unsigned int PerfMonCtr2_Hi__Data__SHIFT                        = 0x00000000;
    constexpr unsigned int PerfMonCtr2_Hi__Overflow__SHIFT                    = 0x00000010;
    constexpr unsigned int PerfMonCtr2_Lo__Data__SHIFT                        = 0x00000000;
    constexpr unsigned int PerfMonCtr3_Hi__Data__SHIFT                        = 0x00000000;
    constexpr unsigned int PerfMonCtr3_Hi__Overflow__SHIFT                    = 0x00000010;
    constexpr unsigned int PerfMonCtr3_Lo__Data__SHIFT                        = 0x00000000;
    constexpr unsigned int PerfMonCtr4_Hi__Data__SHIFT                        = 0x00000000;
    constexpr unsigned int PerfMonCtr4_Hi__Overflow__SHIFT                    = 0x00000010;
    constexpr unsigned int PerfMonCtr4_Lo__Data__SHIFT                        = 0x00000000;
    constexpr unsigned int PerfMonCtr5_Hi__Data__SHIFT                        = 0x00000000;
    constexpr unsigned int PerfMonCtr5_Hi__Overflow__SHIFT                    = 0x00000010;
    constexpr unsigned int PerfMonCtr5_Lo__Data__SHIFT                        = 0x00000000;
    constexpr unsigned int PerfMonCtrClk_Hi__Data__SHIFT                      = 0x00000000;
    constexpr unsigned int PerfMonCtrClk_Hi__Overflow__SHIFT                  = 0x00000010;
    constexpr unsigned int PerfMonCtrClk_Lo__Data__SHIFT                      = 0x00000000;
    constexpr unsigned int SPI_CONFIG_CNTL_1__RESERVED__SHIFT                 = 0x00000016;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_ESGS__GROUP_UPDATE_EN__SHIFT = 0x00000006;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_ESGS__PER_TYPE_WAVE_COUNT_COEFFICIENT__SHIFT = 0x00000010;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_ESGS__PER_TYPE_WAVE_COUNT_HIER_SELECT__SHIFT = 0x00000003;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_ESGS__TOTAL_WAVE_COUNT_COEFFICIENT__SHIFT = 0x00000008;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_ESGS__TOTAL_WAVE_COUNT_HIER_SELECT__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_LSHS__GROUP_UPDATE_EN__SHIFT = 0x00000006;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_LSHS__PER_TYPE_WAVE_COUNT_COEFFICIENT__SHIFT = 0x00000010;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_LSHS__PER_TYPE_WAVE_COUNT_HIER_SELECT__SHIFT = 0x00000003;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_LSHS__TOTAL_WAVE_COUNT_COEFFICIENT__SHIFT = 0x00000008;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_LSHS__TOTAL_WAVE_COUNT_HIER_SELECT__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_PS__GROUP_UPDATE_EN__SHIFT = 0x00000006;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_PS__PER_TYPE_WAVE_COUNT_COEFFICIENT__SHIFT = 0x00000010;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_PS__PER_TYPE_WAVE_COUNT_HIER_SELECT__SHIFT = 0x00000003;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_PS__TOTAL_WAVE_COUNT_COEFFICIENT__SHIFT = 0x00000008;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_PS__TOTAL_WAVE_COUNT_HIER_SELECT__SHIFT = 0x00000000;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_VS__GROUP_UPDATE_EN__SHIFT = 0x00000006;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_VS__PER_TYPE_WAVE_COUNT_COEFFICIENT__SHIFT = 0x00000010;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_VS__PER_TYPE_WAVE_COUNT_HIER_SELECT__SHIFT = 0x00000003;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_VS__TOTAL_WAVE_COUNT_COEFFICIENT__SHIFT = 0x00000008;
    constexpr unsigned int SPI_SHADER_PREF_PRI_CNTR_CTRL_VS__TOTAL_WAVE_COUNT_HIER_SELECT__SHIFT = 0x00000000;
    constexpr unsigned int SQ_WAVE_IB_STS2__SUBV_LOOP__SHIFT                  = 0x0000000d;
    constexpr unsigned int SQ_WAVE_IB_STS2__WAVE64HI__SHIFT                   = 0x0000000c;
    constexpr unsigned int SX_PERFCOUNTER2_SELECT__PERFCOUNTER_SELECT1__SHIFT = 0x0000000a;
    constexpr unsigned int SX_PERFCOUNTER3_SELECT__PERFCOUNTER_SELECT1__SHIFT = 0x0000000a;
} // namespace Nv10

namespace Oss50
{
    constexpr unsigned int SDMA0_PERFCOUNTER0_RESULT__PERF_COUNT__SHIFT       = 0x00000000;
    constexpr unsigned int SDMA0_PERFCOUNTER1_RESULT__PERF_COUNT__SHIFT       = 0x00000000;
    constexpr unsigned int SDMA0_PERFCOUNTER_TAG_DELAY_RANGE__RANGE_HIGH__SHIFT = 0x0000000e;
    constexpr unsigned int SDMA0_PERFCOUNTER_TAG_DELAY_RANGE__RANGE_LOW__SHIFT = 0x00000000;
    constexpr unsigned int SDMA0_PERFCOUNTER_TAG_DELAY_RANGE__SELECT_RW__SHIFT = 0x0000001c;
    constexpr unsigned int SDMA0_PERFMON_CNTL__PERF_CLEAR0__SHIFT             = 0x00000001;
    constexpr unsigned int SDMA0_PERFMON_CNTL__PERF_CLEAR1__SHIFT             = 0x0000000b;
    constexpr unsigned int SDMA0_PERFMON_CNTL__PERF_ENABLE0__SHIFT            = 0x00000000;
    constexpr unsigned int SDMA0_PERFMON_CNTL__PERF_ENABLE1__SHIFT            = 0x0000000a;
    constexpr unsigned int SDMA0_PERFMON_CNTL__PERF_SEL0__SHIFT               = 0x00000002;
    constexpr unsigned int SDMA0_PERFMON_CNTL__PERF_SEL1__SHIFT               = 0x0000000c;
    constexpr unsigned int SDMA1_PERFCOUNTER0_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
    constexpr unsigned int SDMA1_PERFCOUNTER0_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
    constexpr unsigned int SDMA1_PERFCOUNTER0_RESULT__PERF_COUNT__SHIFT       = 0x00000000;
    constexpr unsigned int SDMA1_PERFCOUNTER0_SELECT1__PERF_MODE2__SHIFT      = 0x0000001c;
    constexpr unsigned int SDMA1_PERFCOUNTER0_SELECT1__PERF_MODE3__SHIFT      = 0x00000018;
    constexpr unsigned int SDMA1_PERFCOUNTER0_SELECT1__PERF_SEL2__SHIFT       = 0x00000000;
    constexpr unsigned int SDMA1_PERFCOUNTER0_SELECT1__PERF_SEL3__SHIFT       = 0x0000000a;
    constexpr unsigned int SDMA1_PERFCOUNTER0_SELECT__CNTR_MODE__SHIFT        = 0x00000014;
    constexpr unsigned int SDMA1_PERFCOUNTER0_SELECT__PERF_MODE1__SHIFT       = 0x00000018;
    constexpr unsigned int SDMA1_PERFCOUNTER0_SELECT__PERF_MODE__SHIFT        = 0x0000001c;
    constexpr unsigned int SDMA1_PERFCOUNTER0_SELECT__PERF_SEL1__SHIFT        = 0x0000000a;
    constexpr unsigned int SDMA1_PERFCOUNTER0_SELECT__PERF_SEL__SHIFT         = 0x00000000;
    constexpr unsigned int SDMA1_PERFCOUNTER1_HI__PERFCOUNTER_HI__SHIFT       = 0x00000000;
    constexpr unsigned int SDMA1_PERFCOUNTER1_LO__PERFCOUNTER_LO__SHIFT       = 0x00000000;
    constexpr unsigned int SDMA1_PERFCOUNTER1_RESULT__PERF_COUNT__SHIFT       = 0x00000000;
    constexpr unsigned int SDMA1_PERFCOUNTER1_SELECT1__PERF_MODE2__SHIFT      = 0x0000001c;
    constexpr unsigned int SDMA1_PERFCOUNTER1_SELECT1__PERF_MODE3__SHIFT      = 0x00000018;
    constexpr unsigned int SDMA1_PERFCOUNTER1_SELECT1__PERF_SEL2__SHIFT       = 0x00000000;
    constexpr unsigned int SDMA1_PERFCOUNTER1_SELECT1__PERF_SEL3__SHIFT       = 0x0000000a;
    constexpr unsigned int SDMA1_PERFCOUNTER1_SELECT__CNTR_MODE__SHIFT        = 0x00000014;
    constexpr unsigned int SDMA1_PERFCOUNTER1_SELECT__PERF_MODE1__SHIFT       = 0x00000018;
    constexpr unsigned int SDMA1_PERFCOUNTER1_SELECT__PERF_MODE__SHIFT        = 0x0000001c;
    constexpr unsigned int SDMA1_PERFCOUNTER1_SELECT__PERF_SEL1__SHIFT        = 0x0000000a;
    constexpr unsigned int SDMA1_PERFCOUNTER1_SELECT__PERF_SEL__SHIFT         = 0x00000000;
    constexpr unsigned int SDMA1_PERFCOUNTER_TAG_DELAY_RANGE__RANGE_HIGH__SHIFT = 0x0000000e;
    constexpr unsigned int SDMA1_PERFCOUNTER_TAG_DELAY_RANGE__RANGE_LOW__SHIFT = 0x00000000;
    constexpr unsigned int SDMA1_PERFCOUNTER_TAG_DELAY_RANGE__SELECT_RW__SHIFT = 0x0000001c;
    constexpr unsigned int SDMA1_PERFMON_CNTL__PERF_CLEAR0__SHIFT             = 0x00000001;
    constexpr unsigned int SDMA1_PERFMON_CNTL__PERF_CLEAR1__SHIFT             = 0x0000000b;
    constexpr unsigned int SDMA1_PERFMON_CNTL__PERF_ENABLE0__SHIFT            = 0x00000000;
    constexpr unsigned int SDMA1_PERFMON_CNTL__PERF_ENABLE1__SHIFT            = 0x0000000a;
    constexpr unsigned int SDMA1_PERFMON_CNTL__PERF_SEL0__SHIFT               = 0x00000002;
    constexpr unsigned int SDMA1_PERFMON_CNTL__PERF_SEL1__SHIFT               = 0x0000000c;
} // namespace Oss50

namespace Raven
{
    constexpr unsigned int RLC_SPM_PERFMON_CNTL__RESERVED1__SHIFT             = 0x00000002;
    constexpr unsigned int RLC_SPM_PERFMON_CNTL__RLC_DBG_STRM_EN__SHIFT       = 0x00000000;
    constexpr unsigned int RLC_SPM_PERFMON_CNTL__RLC_DBG_STRM_EXT_SAMPLE__SHIFT = 0x00000001;
} // namespace Raven

namespace Rv1x
{
    constexpr unsigned int RMI_PERF_COUNTER_CNTL__PERF_EVENT_WINDOW_MASK1__SHIFT = 0x00000008;
} // namespace Rv1x

namespace Rv2x
{
    constexpr unsigned int RLC_SPM_ACCUM_CTRLRAM_ADDR__RESERVED__SHIFT        = 0x00000008;
    constexpr unsigned int RLC_SPM_ACCUM_CTRL__RESERVED__SHIFT                = 0x0000000a;
    constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeAccumDoneInt__SHIFT      = 0x00000004;
    constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeResetAccum__SHIFT        = 0x00000005;
    constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeSpmDoneInt__SHIFT        = 0x00000003;
    constexpr unsigned int RLC_SPM_ACCUM_CTRL__StrobeStartSpm__SHIFT          = 0x00000006;
    constexpr unsigned int RLC_SPM_ACCUM_MODE__AutoAccumEn__SHIFT             = 0x00000001;
    constexpr unsigned int RLC_SPM_ACCUM_MODE__AutoResetPerfmonDisable__SHIFT = 0x00000005;
    constexpr unsigned int RLC_SPM_ACCUM_MODE__AutoSpmEn__SHIFT               = 0x00000002;
    constexpr unsigned int RLC_SPM_ACCUM_MODE__Globals_LoadOverride__SHIFT    = 0x00000003;
    constexpr unsigned int RLC_SPM_ACCUM_MODE__RESERVED__SHIFT                = 0x00000006;
    constexpr unsigned int RLC_SPM_ACCUM_MODE__SE0_LoadOverride__SHIFT        = 0x00000004;
    constexpr unsigned int RLC_SPM_ACCUM_SAMPLES_REQUESTED__RESERVED__SHIFT   = 0x00000008;
    constexpr unsigned int RLC_SPM_ACCUM_STATUS__RESERVED__SHIFT              = 0x00000010;
    constexpr unsigned int RLC_SPM_ACCUM_THRESHOLD__RESERVED__SHIFT           = 0x00000010;
    constexpr unsigned int SQ_CONFIG__UNUSED__SHIFT                           = 0x00000000;
} // namespace Rv2x

namespace Vega
{
    constexpr unsigned int RLC_SPM_PERFMON_CNTL__RESERVED1__SHIFT             = 0x00000000;
    constexpr unsigned int RMI_PERF_COUNTER_CNTL__PERF_EVENT_WINDOW_MASK1__SHIFT = 0x00000008;
    constexpr unsigned int SDMA1_PERFCOUNTER0_RESULT__PERF_COUNT__SHIFT       = 0x00000000;
    constexpr unsigned int SDMA1_PERFCOUNTER1_RESULT__PERF_COUNT__SHIFT       = 0x00000000;
    constexpr unsigned int SDMA1_PERFCOUNTER_TAG_DELAY_RANGE__RANGE_HIGH__SHIFT = 0x0000000e;
    constexpr unsigned int SDMA1_PERFCOUNTER_TAG_DELAY_RANGE__RANGE_LOW__SHIFT = 0x00000000;
    constexpr unsigned int SDMA1_PERFCOUNTER_TAG_DELAY_RANGE__SELECT_RW__SHIFT = 0x0000001c;
    constexpr unsigned int SDMA1_PERFMON_CNTL__PERF_CLEAR0__SHIFT             = 0x00000001;
    constexpr unsigned int SDMA1_PERFMON_CNTL__PERF_CLEAR1__SHIFT             = 0x0000000b;
    constexpr unsigned int SDMA1_PERFMON_CNTL__PERF_ENABLE0__SHIFT            = 0x00000000;
    constexpr unsigned int SDMA1_PERFMON_CNTL__PERF_ENABLE1__SHIFT            = 0x0000000a;
    constexpr unsigned int SDMA1_PERFMON_CNTL__PERF_SEL0__SHIFT               = 0x00000002;
    constexpr unsigned int SDMA1_PERFMON_CNTL__PERF_SEL1__SHIFT               = 0x0000000c;
} // namespace Vega

namespace Vg10
{
    constexpr unsigned int RLC_SPM_CBR0_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_CBR0_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT = 0x00000008;
    constexpr unsigned int RLC_SPM_CBR1_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_CBR1_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT = 0x00000008;
    constexpr unsigned int RLC_SPM_DBR0_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_DBR0_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT = 0x00000008;
    constexpr unsigned int RLC_SPM_DBR1_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_DBR1_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT = 0x00000008;
} // namespace Vg10

namespace Vg10_Vg12_Rv1x
{
    constexpr unsigned int SQ_CONFIG__UNUSED__SHIFT                           = 0x00000000;
} // namespace Vg10_Vg12_Rv1x

namespace Vg12
{
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi0__BypassEn__SHIFT          = 0x0000001f;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi0__EventSelect_11_8__SHIFT  = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi0__EventSelect_13_12__SHIFT = 0x0000001d;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi1__BypassEn__SHIFT          = 0x0000001f;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi1__EventSelect_11_8__SHIFT  = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi1__EventSelect_13_12__SHIFT = 0x0000001d;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi2__BypassEn__SHIFT          = 0x0000001f;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi2__EventSelect_11_8__SHIFT  = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi2__EventSelect_13_12__SHIFT = 0x0000001d;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi3__BypassEn__SHIFT          = 0x0000001f;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi3__EventSelect_11_8__SHIFT  = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi3__EventSelect_13_12__SHIFT = 0x0000001d;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi4__BypassEn__SHIFT          = 0x0000001f;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi4__EventSelect_11_8__SHIFT  = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi4__EventSelect_13_12__SHIFT = 0x0000001d;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi5__BypassEn__SHIFT          = 0x0000001f;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi5__EventSelect_11_8__SHIFT  = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi5__EventSelect_13_12__SHIFT = 0x0000001d;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi6__BypassEn__SHIFT          = 0x0000001f;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi6__EventSelect_11_8__SHIFT  = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi6__EventSelect_13_12__SHIFT = 0x0000001d;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi7__BypassEn__SHIFT          = 0x0000001f;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi7__EventSelect_11_8__SHIFT  = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlHi7__EventSelect_13_12__SHIFT = 0x0000001d;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo0__DsmTrig__SHIFT           = 0x00000013;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo0__En__SHIFT                = 0x00000016;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo0__EventSelect_7_0__SHIFT   = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo0__Mp1Int__SHIFT            = 0x00000015;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo0__UnitMask__SHIFT          = 0x00000008;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo1__DsmTrig__SHIFT           = 0x00000013;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo1__En__SHIFT                = 0x00000016;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo1__EventSelect_7_0__SHIFT   = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo1__Mp1Int__SHIFT            = 0x00000015;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo1__UnitMask__SHIFT          = 0x00000008;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo2__DsmTrig__SHIFT           = 0x00000013;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo2__En__SHIFT                = 0x00000016;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo2__EventSelect_7_0__SHIFT   = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo2__Mp1Int__SHIFT            = 0x00000015;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo2__UnitMask__SHIFT          = 0x00000008;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo3__DsmTrig__SHIFT           = 0x00000013;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo3__En__SHIFT                = 0x00000016;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo3__EventSelect_7_0__SHIFT   = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo3__Mp1Int__SHIFT            = 0x00000015;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo3__UnitMask__SHIFT          = 0x00000008;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo4__DsmTrig__SHIFT           = 0x00000013;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo4__En__SHIFT                = 0x00000016;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo4__EventSelect_7_0__SHIFT   = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo4__Mp1Int__SHIFT            = 0x00000015;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo4__UnitMask__SHIFT          = 0x00000008;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo5__DsmTrig__SHIFT           = 0x00000013;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo5__En__SHIFT                = 0x00000016;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo5__EventSelect_7_0__SHIFT   = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo5__Mp1Int__SHIFT            = 0x00000015;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo5__UnitMask__SHIFT          = 0x00000008;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo6__DsmTrig__SHIFT           = 0x00000013;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo6__En__SHIFT                = 0x00000016;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo6__EventSelect_7_0__SHIFT   = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo6__Mp1Int__SHIFT            = 0x00000015;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo6__UnitMask__SHIFT          = 0x00000008;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo7__DsmTrig__SHIFT           = 0x00000013;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo7__En__SHIFT                = 0x00000016;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo7__EventSelect_7_0__SHIFT   = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo7__Mp1Int__SHIFT            = 0x00000015;
    constexpr unsigned int DF_PIE_AON_PerfMonCtlLo7__UnitMask__SHIFT          = 0x00000008;
    constexpr unsigned int DF_PIE_AON_PerfMonCtrHi0__CTR_47_32__SHIFT         = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtrHi1__CTR_47_32__SHIFT         = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtrHi2__CTR_47_32__SHIFT         = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtrHi3__CTR_47_32__SHIFT         = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtrHi4__CTR_47_32__SHIFT         = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtrHi5__CTR_47_32__SHIFT         = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtrHi6__CTR_47_32__SHIFT         = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtrHi7__CTR_47_32__SHIFT         = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtrLo0__CTR_31_0__SHIFT          = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtrLo1__CTR_31_0__SHIFT          = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtrLo2__CTR_31_0__SHIFT          = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtrLo3__CTR_31_0__SHIFT          = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtrLo4__CTR_31_0__SHIFT          = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtrLo5__CTR_31_0__SHIFT          = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtrLo6__CTR_31_0__SHIFT          = 0x00000000;
    constexpr unsigned int DF_PIE_AON_PerfMonCtrLo7__CTR_31_0__SHIFT          = 0x00000000;
    constexpr unsigned int PA_SC_ENHANCE_2__RESERVED_0__SHIFT                 = 0x00000000;
    constexpr unsigned int PA_SC_ENHANCE_2__RESERVED_1__SHIFT                 = 0x00000001;
    constexpr unsigned int PA_SC_ENHANCE_2__RESERVED_2__SHIFT                 = 0x00000002;
    constexpr unsigned int PA_SC_ENHANCE_2__RESERVED_3__SHIFT                 = 0x00000003;
    constexpr unsigned int PA_SC_ENHANCE_2__RESERVED_4__SHIFT                 = 0x00000004;
    constexpr unsigned int PA_SC_ENHANCE_2__RESERVED_5__SHIFT                 = 0x00000005;
    constexpr unsigned int PA_SC_ENHANCE_2__RSVD__SHIFT                       = 0x00000008;
    constexpr unsigned int PA_STATE_STEREO_X__STEREO_X_OFFSET__SHIFT          = 0x00000000;
    constexpr unsigned int PA_STEREO_CNTL__EN_STEREO__SHIFT                   = 0x00000000;
    constexpr unsigned int PA_STEREO_CNTL__RT_SLICE_MODE__SHIFT               = 0x00000005;
    constexpr unsigned int PA_STEREO_CNTL__RT_SLICE_OFFSET__SHIFT             = 0x00000008;
    constexpr unsigned int PA_STEREO_CNTL__STEREO_MODE__SHIFT                 = 0x00000001;
    constexpr unsigned int PA_STEREO_CNTL__VP_ID_MODE__SHIFT                  = 0x0000000a;
    constexpr unsigned int PA_STEREO_CNTL__VP_ID_OFFSET__SHIFT                = 0x0000000d;
    constexpr unsigned int PerfMonCtl1__ChipIDSel__SHIFT                      = 0x00000014;
    constexpr unsigned int PerfMonCtl1__ChipSelMask__SHIFT                    = 0x00000010;
    constexpr unsigned int PerfMonCtl1__Enable__SHIFT                         = 0x0000001f;
    constexpr unsigned int PerfMonCtl1__EventSelect__SHIFT                    = 0x00000000;
    constexpr unsigned int PerfMonCtl1__PriorityMask__SHIFT                   = 0x0000000a;
    constexpr unsigned int PerfMonCtl1__RdWrMask__SHIFT                       = 0x00000008;
    constexpr unsigned int PerfMonCtl1__ReqSizeMask__SHIFT                    = 0x0000000e;
    constexpr unsigned int PerfMonCtl1__SubChanMask__SHIFT                    = 0x0000001d;
    constexpr unsigned int PerfMonCtl1__VCSel__SHIFT                          = 0x00000018;
    constexpr unsigned int PerfMonCtl2__ChipIDSel__SHIFT                      = 0x00000014;
    constexpr unsigned int PerfMonCtl2__ChipSelMask__SHIFT                    = 0x00000010;
    constexpr unsigned int PerfMonCtl2__Enable__SHIFT                         = 0x0000001f;
    constexpr unsigned int PerfMonCtl2__EventSelect__SHIFT                    = 0x00000000;
    constexpr unsigned int PerfMonCtl2__PriorityMask__SHIFT                   = 0x0000000a;
    constexpr unsigned int PerfMonCtl2__RdWrMask__SHIFT                       = 0x00000008;
    constexpr unsigned int PerfMonCtl2__ReqSizeMask__SHIFT                    = 0x0000000e;
    constexpr unsigned int PerfMonCtl2__SubChanMask__SHIFT                    = 0x0000001d;
    constexpr unsigned int PerfMonCtl2__VCSel__SHIFT                          = 0x00000018;
    constexpr unsigned int PerfMonCtl3__ChipIDSel__SHIFT                      = 0x00000014;
    constexpr unsigned int PerfMonCtl3__ChipSelMask__SHIFT                    = 0x00000010;
    constexpr unsigned int PerfMonCtl3__Enable__SHIFT                         = 0x0000001f;
    constexpr unsigned int PerfMonCtl3__EventSelect__SHIFT                    = 0x00000000;
    constexpr unsigned int PerfMonCtl3__PriorityMask__SHIFT                   = 0x0000000a;
    constexpr unsigned int PerfMonCtl3__RdWrMask__SHIFT                       = 0x00000008;
    constexpr unsigned int PerfMonCtl3__ReqSizeMask__SHIFT                    = 0x0000000e;
    constexpr unsigned int PerfMonCtl3__SubChanMask__SHIFT                    = 0x0000001d;
    constexpr unsigned int PerfMonCtl3__VCSel__SHIFT                          = 0x00000018;
    constexpr unsigned int PerfMonCtl4__ChipIDSel__SHIFT                      = 0x00000014;
    constexpr unsigned int PerfMonCtl4__ChipSelMask__SHIFT                    = 0x00000010;
    constexpr unsigned int PerfMonCtl4__Enable__SHIFT                         = 0x0000001f;
    constexpr unsigned int PerfMonCtl4__EventSelect__SHIFT                    = 0x00000000;
    constexpr unsigned int PerfMonCtl4__PriorityMask__SHIFT                   = 0x0000000a;
    constexpr unsigned int PerfMonCtl4__RdWrMask__SHIFT                       = 0x00000008;
    constexpr unsigned int PerfMonCtl4__ReqSizeMask__SHIFT                    = 0x0000000e;
    constexpr unsigned int PerfMonCtl4__SubChanMask__SHIFT                    = 0x0000001d;
    constexpr unsigned int PerfMonCtl4__VCSel__SHIFT                          = 0x00000018;
    constexpr unsigned int PerfMonCtl5__ChipIDSel__SHIFT                      = 0x00000014;
    constexpr unsigned int PerfMonCtl5__ChipSelMask__SHIFT                    = 0x00000010;
    constexpr unsigned int PerfMonCtl5__Enable__SHIFT                         = 0x0000001f;
    constexpr unsigned int PerfMonCtl5__EventSelect__SHIFT                    = 0x00000000;
    constexpr unsigned int PerfMonCtl5__PriorityMask__SHIFT                   = 0x0000000a;
    constexpr unsigned int PerfMonCtl5__RdWrMask__SHIFT                       = 0x00000008;
    constexpr unsigned int PerfMonCtl5__ReqSizeMask__SHIFT                    = 0x0000000e;
    constexpr unsigned int PerfMonCtl5__SubChanMask__SHIFT                    = 0x0000001d;
    constexpr unsigned int PerfMonCtl5__VCSel__SHIFT                          = 0x00000018;
    constexpr unsigned int PerfMonCtlClk__CtrClkEn__SHIFT                     = 0x0000001f;
    constexpr unsigned int PerfMonCtlClk__GlblMonEn__SHIFT                    = 0x00000019;
    constexpr unsigned int PerfMonCtlClk__GlblResetMsk__SHIFT                 = 0x00000000;
    constexpr unsigned int PerfMonCtlClk__GlblReset__SHIFT                    = 0x00000018;
    constexpr unsigned int PerfMonCtr1_Hi__Data__SHIFT                        = 0x00000000;
    constexpr unsigned int PerfMonCtr1_Hi__Overflow__SHIFT                    = 0x00000010;
    constexpr unsigned int PerfMonCtr1_Lo__Data__SHIFT                        = 0x00000000;
    constexpr unsigned int PerfMonCtr2_Hi__Data__SHIFT                        = 0x00000000;
    constexpr unsigned int PerfMonCtr2_Hi__Overflow__SHIFT                    = 0x00000010;
    constexpr unsigned int PerfMonCtr2_Lo__Data__SHIFT                        = 0x00000000;
    constexpr unsigned int PerfMonCtr3_Hi__Data__SHIFT                        = 0x00000000;
    constexpr unsigned int PerfMonCtr3_Hi__Overflow__SHIFT                    = 0x00000010;
    constexpr unsigned int PerfMonCtr3_Lo__Data__SHIFT                        = 0x00000000;
    constexpr unsigned int PerfMonCtr4_Hi__Data__SHIFT                        = 0x00000000;
    constexpr unsigned int PerfMonCtr4_Hi__Overflow__SHIFT                    = 0x00000010;
    constexpr unsigned int PerfMonCtr4_Lo__Data__SHIFT                        = 0x00000000;
    constexpr unsigned int PerfMonCtr5_Hi__Data__SHIFT                        = 0x00000000;
    constexpr unsigned int PerfMonCtr5_Hi__Overflow__SHIFT                    = 0x00000010;
    constexpr unsigned int PerfMonCtr5_Lo__Data__SHIFT                        = 0x00000000;
    constexpr unsigned int PerfMonCtrClk_Hi__Data__SHIFT                      = 0x00000000;
    constexpr unsigned int PerfMonCtrClk_Hi__Overflow__SHIFT                  = 0x00000010;
    constexpr unsigned int PerfMonCtrClk_Lo__Data__SHIFT                      = 0x00000000;
    constexpr unsigned int XDMA_SLV_FLIP_PENDING__XDMA_SLV_FLIP_PENDING__SHIFT = 0x00000000;
} // namespace Vg12

namespace Vg20
{
    constexpr unsigned int PA_SC_ENHANCE_2__RESERVED_0__SHIFT                 = 0x00000000;
    constexpr unsigned int PA_SC_ENHANCE_2__RESERVED_1__SHIFT                 = 0x00000001;
    constexpr unsigned int PA_SC_ENHANCE_2__RESERVED_2__SHIFT                 = 0x00000002;
    constexpr unsigned int PA_SC_ENHANCE_2__RESERVED_3__SHIFT                 = 0x00000003;
    constexpr unsigned int PA_SC_ENHANCE_2__RESERVED_4__SHIFT                 = 0x00000004;
    constexpr unsigned int PA_SC_ENHANCE_2__RESERVED_5__SHIFT                 = 0x00000005;
    constexpr unsigned int PA_SC_ENHANCE_2__RSVD__SHIFT                       = 0x00000008;
    constexpr unsigned int PA_STATE_STEREO_X__STEREO_X_OFFSET__SHIFT          = 0x00000000;
    constexpr unsigned int PA_STEREO_CNTL__EN_STEREO__SHIFT                   = 0x00000000;
    constexpr unsigned int PA_STEREO_CNTL__RT_SLICE_MODE__SHIFT               = 0x00000005;
    constexpr unsigned int PA_STEREO_CNTL__RT_SLICE_OFFSET__SHIFT             = 0x00000008;
    constexpr unsigned int PA_STEREO_CNTL__STEREO_MODE__SHIFT                 = 0x00000001;
    constexpr unsigned int PA_STEREO_CNTL__VP_ID_MODE__SHIFT                  = 0x0000000a;
    constexpr unsigned int PA_STEREO_CNTL__VP_ID_OFFSET__SHIFT                = 0x0000000d;
    constexpr unsigned int RLC_SPM_CBR0_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_CBR0_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT = 0x00000008;
    constexpr unsigned int RLC_SPM_CBR1_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_CBR1_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT = 0x00000008;
    constexpr unsigned int RLC_SPM_DBR0_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_DBR0_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT = 0x00000008;
    constexpr unsigned int RLC_SPM_DBR1_PERFMON_SAMPLE_DELAY__PERFMON_SAMPLE_DELAY__SHIFT = 0x00000000;
    constexpr unsigned int RLC_SPM_DBR1_PERFMON_SAMPLE_DELAY__RESERVED__SHIFT = 0x00000008;
    constexpr unsigned int SQ_CONFIG__DISABLE_BARRIER_WAITCNT__SHIFT          = 0x00000000;
    constexpr unsigned int SQ_CONFIG__UNUSED__SHIFT                           = 0x00000001;
    constexpr unsigned int TA_DSM_CNTL2__TA_FL_LFIFO_ENABLE_ERROR_INJECT__SHIFT = 0x00000006;
    constexpr unsigned int TA_DSM_CNTL2__TA_FL_LFIFO_SELECT_INJECT_DELAY__SHIFT = 0x00000008;
    constexpr unsigned int TA_DSM_CNTL2__TA_FS_AFIFO_ENABLE_ERROR_INJECT__SHIFT = 0x00000003;
    constexpr unsigned int TA_DSM_CNTL2__TA_FS_AFIFO_SELECT_INJECT_DELAY__SHIFT = 0x00000005;
    constexpr unsigned int TA_DSM_CNTL2__TA_FS_CFIFO_ENABLE_ERROR_INJECT__SHIFT = 0x0000000c;
    constexpr unsigned int TA_DSM_CNTL2__TA_FS_CFIFO_SELECT_INJECT_DELAY__SHIFT = 0x0000000e;
    constexpr unsigned int TA_DSM_CNTL2__TA_FS_DFIFO_ENABLE_ERROR_INJECT__SHIFT = 0x00000000;
    constexpr unsigned int TA_DSM_CNTL2__TA_FS_DFIFO_SELECT_INJECT_DELAY__SHIFT = 0x00000002;
    constexpr unsigned int TA_DSM_CNTL2__TA_FX_LFIFO_ENABLE_ERROR_INJECT__SHIFT = 0x00000009;
    constexpr unsigned int TA_DSM_CNTL2__TA_FX_LFIFO_SELECT_INJECT_DELAY__SHIFT = 0x0000000b;
    constexpr unsigned int TA_DSM_CNTL2__TA_INJECT_DELAY__SHIFT               = 0x0000001a;
    constexpr unsigned int TA_DSM_CNTL__TA_FL_LFIFO_DSM_IRRITATOR_DATA__SHIFT = 0x00000006;
    constexpr unsigned int TA_DSM_CNTL__TA_FL_LFIFO_ENABLE_SINGLE_WRITE__SHIFT = 0x00000008;
    constexpr unsigned int TA_DSM_CNTL__TA_FS_AFIFO_DSM_IRRITATOR_DATA__SHIFT = 0x00000003;
    constexpr unsigned int TA_DSM_CNTL__TA_FS_AFIFO_ENABLE_SINGLE_WRITE__SHIFT = 0x00000005;
    constexpr unsigned int TA_DSM_CNTL__TA_FS_CFIFO_DSM_IRRITATOR_DATA__SHIFT = 0x0000000c;
    constexpr unsigned int TA_DSM_CNTL__TA_FS_CFIFO_ENABLE_SINGLE_WRITE__SHIFT = 0x0000000e;
    constexpr unsigned int TA_DSM_CNTL__TA_FS_DFIFO_DSM_IRRITATOR_DATA__SHIFT = 0x00000000;
    constexpr unsigned int TA_DSM_CNTL__TA_FS_DFIFO_ENABLE_SINGLE_WRITE__SHIFT = 0x00000002;
    constexpr unsigned int TA_DSM_CNTL__TA_FX_LFIFO_DSM_IRRITATOR_DATA__SHIFT = 0x00000009;
    constexpr unsigned int TA_DSM_CNTL__TA_FX_LFIFO_ENABLE_SINGLE_WRITE__SHIFT = 0x0000000b;
    constexpr unsigned int TA_EDC_CNT__TA_FL_LFIFO_SED_COUNT__SHIFT           = 0x00000006;
    constexpr unsigned int TA_EDC_CNT__TA_FS_AFIFO_SED_COUNT__SHIFT           = 0x00000004;
    constexpr unsigned int TA_EDC_CNT__TA_FS_CFIFO_SED_COUNT__SHIFT           = 0x0000000a;
    constexpr unsigned int TA_EDC_CNT__TA_FS_DFIFO_DED_COUNT__SHIFT           = 0x00000002;
    constexpr unsigned int TA_EDC_CNT__TA_FS_DFIFO_SEC_COUNT__SHIFT           = 0x00000000;
    constexpr unsigned int TA_EDC_CNT__TA_FX_LFIFO_SED_COUNT__SHIFT           = 0x00000008;
} // namespace Vg20

