/*
 ***********************************************************************************************************************
 *
 *  Copyright (c) 2018-2019 Advanced Micro Devices, Inc. All Rights Reserved.
 *
 *  Permission is hereby granted, free of charge, to any person obtaining a copy
 *  of this software and associated documentation files (the "Software"), to deal
 *  in the Software without restriction, including without limitation the rights
 *  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 *  copies of the Software, and to permit persons to whom the Software is
 *  furnished to do so, subject to the following conditions:
 *
 *  The above copyright notice and this permission notice shall be included in all
 *  copies or substantial portions of the Software.
 *
 *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 *  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 *  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 *  SOFTWARE.
 *
 **********************************************************************************************************************/
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// WARNING!  WARNING!  WARNING!  WARNING!  WARNING!  WARNING!  WARNING!  WARNING!  WARNING!  WARNING!  WARNING!
//
// This code has been generated automatically. Do not hand-modify this code.
//
// When changes are needed, modify the tools generating this module in the tools\generate directory OR settings_xgl.json
//
// WARNING!  WARNING!  WARNING!  WARNING!  WARNING!  WARNING!  WARNING!  WARNING!  WARNING!  WARNING!  WARNING!
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


/**
***************************************************************************************************
* @file  g_settings.h
* @brief auto-generated file.
*        Contains the definition for the Vulkan settings struct and enums for initialization.
***************************************************************************************************
*/
#pragma once

#include "pal.h"
#include "palUtil.h"
#include "palSettingsLoader.h"

typedef Util::uint64 uint64;
typedef Util::uint32 uint32;
typedef Util::uint8 uint8;
typedef Pal::gpusize gpusize;

namespace vk
{

enum FeatureEnableMode : uint32
{
    FeatureDefault = 0,
    FeatureForceEnable = 1,
    FeatureForceDisable = 2
};

enum OptRenderStateCacheFlag : uint32
{
    OptRenderStateCacheMsaaState = 1,
    OptRenderStateCacheColorBlendState = 2,
    OptRenderStateCacheDepthStencilState = 4,
    OptRenderStateCacheInputAssemblyState = 8,
    OptRenderStateCacheTriangleRasterState = 16,
    OptRenderStateCacheStaticPointLineRasterState = 32,
    OptRenderStateCacheStaticDepthBias = 64,
    OptRenderStateCacheStaticBlendConst = 128,
    OptRenderStateCacheStaticDepthBounds = 256,
    OptRenderStateCacheStaticViewport = 512,
    OptRenderStateCacheStaticScissorRect = 1024,
    OptRenderStateCacheStaticSamplePattern = 2048,
    OptRenderStateCacheStaticGraphicsWaveLimits = 4096,
    OptRenderStateCacheStaticComputeWaveLimits = 8192,
    OptRenderStateCacheStaticAnisoLodCompensation = 16384,
    OptRenderStateCacheStaticLineStipple = 32768
};

enum DevModeSqttMarkerEnableFlags : uint32
{
    DevModeSqttMarkerEnableCbStart = 1,
    DevModeSqttMarkerEnableCbEnd = 2,
    DevModeSqttMarkerEnableEvent = 4,
    DevModeSqttMarkerEnableBarrier = 8,
    DevModeSqttMarkerEnableGeneralApi = 16,
    DevModeSqttMarkerEnableUserEvent = 32,
    DevModeSqttMarkerEnableEventWithDims = 64,
    DevModeSqttMarkerEnablePipelineBind = 256
};

enum PipelineBinningMode : uint32
{
    PipelineBinningModeDefault = 0,
    PipelineBinningModeDisable = 1,
    PipelineBinningModeEnable = 2
};

enum GraphicsPipelineType : uint32
{
    GraphicsPipelineTypeVsFs = 1,
    GraphicsPipelineTypeGs = 2,
    GraphicsPipelineTypeTess = 4,
    GraphicsPipelineTypeTessGs = 8
};

enum PipelineLinkTimeOptMode : uint32
{
    PipelineLinkTimeOptApiControlled = 0,
    PipelineLinkTimeOptAlwaysEnabled = 1,
    PipelineLinkTimeOptAlwaysDisabled = 2
};

enum PipelineFastCompileMode : uint32
{
    PipelineFastCompileApiControlled = 0,
    PipelineFastCompileAlwaysFast = 1,
    PipelineFastCompileAlwaysOptimized = 2
};

enum ShaderReplaceMode : uint32
{
    ShaderReplaceDisable = 0,
    ShaderReplaceShaderHash = 1,
    ShaderReplaceShaderPipelineHash = 2,
    ShaderReplacePipelineBinaryHash = 3,
    ShaderReplaceShaderISA = 4
};

enum NggCompactMode : uint32
{
    NggCompactSubgroup = 0,
    NggCompactVertices = 1
};

enum NggSubgroupSizingType : uint32
{
    NggSubgroupAuto = 0,
    NggSubgroupMaximumSize = 1,
    NggSubgroupHalfSize = 2,
    NggSubgroupOptimizeForVerts = 3,
    NggSubgroupOptimizeForPrims = 4,
    NggSubgroupExplicit = 5
};

enum ShaderCacheMode : uint32
{
    ShaderCacheDisable = 0,
    ShaderCacheEnableRuntimeOnly = 1,
    ShaderCacheEnableOnDisk = 2,
    ShaderCacheForceInternalCacheOnDisk = 3
};

enum PipelineDumpFilters : uint32
{
    PipelineDumpFilterNone = 0,
    PipelineDumpFilterCs = 1,
    PipelineDumpFilterNgg = 2,
    PipelineDumpFilterGs = 4,
    PipelineDumpFilterTess = 8,
    PipelineDumpFilterVsPs = 16
};

enum DbgBarrierCmd : uint32
{
    DbgBarrierDrawNonIndexed = 1,
    DbgBarrierDrawIndexed = 2,
    DbgBarrierDrawIndirect = 4,
    DbgBarrierDispatch = 8,
    DbgBarrierDispatchIndirect = 16,
    DbgBarrierCopyBuffer = 32,
    DbgBarrierCopyImage = 64,
    DbgBarrierCopyQueryPool = 128,
    DbgBarrierClearColor = 256,
    DbgBarrierClearDepth = 512,
    DbgBarrierResolve = 1024,
    DbgBarrierBeginRenderPass = 2048,
    DbgBarrierNextSubpass = 4096,
    DbgBarrierEndRenderPass = 8192,
    DbgBarrierSetResetEvent = 16384,
    DbgBarrierPipelineBarrierWaitEvents = 32768,
    DbgBarrierQueryBeginEnd = 65536,
    DbgBarrierQueryReset = 131072,
    DbgBarrierExecuteCommands = 262144,
    DbgBarrierCmdBufStart = 524288,
    DbgBarrierCmdBufEnd = 1048576,
    DbgBarrierBindPipeline = 2097152,
    DbgBarrierBindSetsPushConstants = 4194304,
    DbgBarrierBindIndexVertexBuffer = 8388608,
    DbgBarrierWriteTimestamp = 16777216,
    DbgBarrierSetDynamicPipelineState = 33554432,
    DbgBarrierVideo = 67108864,
    DbgBarrierOther = 2147483648
};

enum ResourceBarrierOptions : uint32
{
    DefaultResourceBarrier = 0,
    CombinedAccessMasks = 16384,
    SkipDstCacheInv = 32768,
    PreferFlushOverInv = 8192,
    Gfx6KeepShaderCoher = 256,
    Gfx6AvoidCpuMemoryCoher = 512,
    Gfx9KeepShaderCoher = 1024,
    Gfx9AvoidCpuMemoryCoher = 2048
};

enum BarrierFilterOptions : uint32
{
    BarrierFilterDisabled = 0,
    SkipStrayExecutionDependencies = 1,
    SkipImageLayoutUndefined = 2,
    SkipDuplicateResourceBarriers = 4,
    ForceImageSharingModeExclusive = 8,
    SkipWithAppProfile = 16,
    SkipWithAppProfileRegen = 32,
    SkipWithIntDevOverlay = 64
};

enum PreciseAnisoMode : uint32
{
    EnablePreciseAniso = 0,
    DisablePreciseAnisoAfOnly = 1,
    DisablePreciseAnisoAll = 2
};

enum BGFSEnableFlags : uint32
{
    BGFSEnableWddm1Immediate = 1,
    BGFSEnableWddm1Mailbox = 2,
    BGFSEnableWddm1Fifo = 4,
    BGFSEnableWddm1FifoRelaxed = 8,
    BGFSEnableWddm2Immediate = 16,
    BGFSEnableWddm2Mailbox = 32,
    BGFSEnableWddm2Fifo = 64,
    BGFSEnableWddm2FifoRelaxed = 128,
    BGFSEnableWddm1MultiGpu = 256,
    BGFSEnableWddm2MultiGpu = 512
};

enum OptimizeCmdbufMode : uint32
{
    EnableOptimizeForRenderPassContinue = 0,
    EnableOptimizeCmdbuf = 1,
    DisableOptimizeCmdbuf = 2
};

enum ShaderWaveSize : uint32
{
    WaveSizeAuto = 0,
    WaveSize64 = 2,
    WaveSize32 = 3
};

enum WgpMode : uint32
{
    WgpModeAuto = 0,
    WgpModeCu = 1,
    WgpModeWgp = 2
};

enum DccMode : uint32
{
    DccDefaultMode = 0,
    DccDisableMode = 1,
    DccEnableMode = 2
};

enum TextureFilterOptimizationSettings : uint32
{
    TextureFilterOptimizationsDisabled = 0,
    TextureFilterOptimizationsEnabled = 1,
    TextureFilterOptimizationsAggressive = 2
};

/// Pal auto-generated settings struct
struct RuntimeSettings : public Pal::DriverSettings
{
    bool                                        renderPassNewEnable;
    bool                                        renderPassLogEnable;
    char                                        renderPassLogDirectory[512];
    uint32                                      renderPassLogFlags;
    bool                                        renderPassForceWaitIdle;
    uint32                                      renderPassForceCacheInputCoher;
    uint32                                      renderPassForceCacheOutputCoher;
    bool                                        renderPassAsyncEventEnable;
    uint32                                      cmdBufGpuEventMinAllocCount;
    bool                                        useSharedCmdAllocator;
    Pal::GpuHeap                                cmdAllocatorDataHeap;
    uint32                                      cmdAllocatorDataAllocSize;
    uint32                                      cmdAllocatorDataSubAllocSize;
    Pal::GpuHeap                                cmdAllocatorEmbeddedHeap;
    uint32                                      cmdAllocatorEmbeddedAllocSize;
    uint32                                      cmdAllocatorEmbeddedSubAllocSize;
    Pal::GpuHeap                                cmdAllocatorScratchHeap;
    uint32                                      cmdAllocatorScratchAllocSize;
    uint32                                      cmdAllocatorScratchSubAllocSize;
    PipelineLinkTimeOptMode                     pipelineLinkTimeOptMode;
    PipelineFastCompileMode                     pipelineFastCompileMode;
    PipelineBinningMode                         pipelineBinningMode;
    bool                                        pipelineUseProfileHashAsClientHash;
    bool                                        pipelineUseShaderHashAsProfileHash;
    char                                        pipelineProfileRuntimeFile[512];
    bool                                        pipelineProfileDbgPrintProfileMatch;
    bool                                        pipelineProfileIgnoresAppProfile;
    bool                                        pipelineProfileHaltOnParseFailure;
    bool                                        disableEmbedConstArrays;
    bool                                        enableUmdFramePacer;
    bool                                        enableFrtc;
    bool                                        enableTurboSync;
    bool                                        fullScreenFrameMetadataSupport;
    bool                                        useSdmaCompositingBlt;
    bool                                        enableMailboxPresentMode;
    bool                                        enableAcquireBeforeSignal;
    bool                                        ignoreSuboptimalSwapchainSize;
    bool                                        enablePipelineDump;
    char                                        pipelineDumpDir[256];
    uint32                                      enableLog;
    char                                        logFileName[256];
    bool                                        enableDebug;
    char                                        debugLogFileName[256];
    ShaderReplaceMode                           shaderReplaceMode;
    char                                        shaderReplaceDir[256];
    char                                        shaderReplacePipelineHashes[512];
    bool                                        enableDropPipelineBinaryInst;
    uint32                                      subgroupSize;
    uint32                                      vsWaveSize;
    uint32                                      tcsWaveSize;
    uint32                                      tesWaveSize;
    uint32                                      gsWaveSize;
    uint32                                      fsWaveSize;
    uint32                                      csWaveSize;
    uint32                                      enableNgg;
    bool                                        nggEnableGsUse;
    bool                                        nggForceNonPassthrough;
    NggCompactMode                              nggCompactionMode;
    bool                                        nggAlwaysUsePrimShaderTable;
    uint32                                      nggBackfaceExponent;
    NggSubgroupSizingType                       nggSubgroupSizing;
    uint32                                      nggPrimsPerSubgroup;
    uint32                                      nggVertsPerSubgroup;
    bool                                        nggEnableBackfaceCulling;
    bool                                        nggEnableFrustumCulling;
    bool                                        nggEnableBoxFilterCulling;
    bool                                        nggEnableSphereCulling;
    bool                                        nggEnableSmallPrimFilter;
    bool                                        nggEnableCullDistanceCulling;
    uint32                                      enableForwardProgress;
    uint32                                      enableWgpMode;
    uint32                                      waveBreakSize;
    uint32                                      dropPipelineBinaryInstToken;
    uint32                                      dropPipelineBinaryInstSize;
    bool                                        enableSpvPerfOptimal;
    bool                                        enableSpvValidation;
    bool                                        zeroInitIlRegs;
    bool                                        skipUnsupportedOpCode;
    uint32                                      vsIrMode;
    uint32                                      tcsIrMode;
    uint32                                      tesIrMode;
    uint32                                      gsIrMode;
    uint32                                      fsIrMode;
    uint32                                      csIrMode;
    char                                        llpcOptions[256];
    ShaderCacheMode                             shaderCacheMode;
    uint32                                      dropPipelineBinaryInstMask;
    bool                                        usePalPipelineCaching;
    bool                                        allowExternalPipelineCacheObject;
    char                                        pipelineCachingEnvironmentVariable[256];
    bool                                        usePipelineCachingDefaultLocation;
    char                                        pipelineCachingDefaultLocation[256];
    bool                                        markPipelineCacheWithBuildTimestamp;
    PipelineDumpFilters                         filterPipelineDumpByType;
    uint64                                      filterPipelineDumpByHash;
    bool                                        dumpDuplicatePipelines;
    uint32                                      dbgBarrierPostCmdEnable;
    uint32                                      dbgBarrierPostWaitPipePoint;
    uint32                                      dbgBarrierPostSignalPipePoint;
    uint32                                      dbgBarrierPostCacheSrcMask;
    uint32                                      dbgBarrierPostCacheDstMask;
    uint32                                      dbgBarrierPreCmdEnable;
    uint32                                      dbgBarrierPreWaitPipePoint;
    uint32                                      dbgBarrierPreSignalPipePoint;
    uint32                                      dbgBarrierPreCacheSrcMask;
    uint32                                      dbgBarrierPreCacheDstMask;
    uint32                                      vbTableInstanceRingSize;
    uint32                                      resourceBarrierOptions;
    uint32                                      barrierFilterOptions;
    char                                        barrierFilterProfileFile[512];
    uint32                                      excessivePipelineCacheCountThreshold;
    uint32                                      enumPreferredDeviceIndex;
    FeatureEnableMode                           robustBufferAccess;
    bool                                        lenientInstanceFuncQuery;
    char                                        appProfileDumpDir[512];
    bool                                        optEnablePrt;
    uint32                                      asyncComputeQueueMaxWavesPerCu;
    uint32                                      asyncComputeQueueLimit;
    uint32                                      limitSampleCounts;
    uint32                                      memoryCustomDeviceAllocationCountLimit;
    uint32                                      memoryBaseAddrAlignment;
    uint32                                      memoryBaseAddrAlignmentCpuVisibleWin32;
    gpusize                                     memoryRemoteBackupHeapMinHeapSize;
    gpusize                                     memoryAttachmentImageMemoryTypeMinHeapSize;
    uint32                                      memoryPriorityDefault;
    uint32                                      memoryPriorityImageAny;
    uint32                                      memoryPriorityImageShaderRead;
    uint32                                      memoryPriorityImageShaderWrite;
    uint32                                      memoryPriorityImageColorTarget;
    uint32                                      memoryPriorityImageDepthStencil;
    uint32                                      heapBudgetRatioOfHeapSizeLocal;
    uint32                                      heapBudgetRatioOfHeapSizeInvisible;
    uint32                                      heapBudgetRatioOfHeapSizeNonlocal;
    bool                                        isSparseUnmapBeforeDestroyEnabled;
    uint32                                      transferGranularityUniversalOverride;
    uint32                                      transferGranularityComputeOverride;
    bool                                        memoryDeviceOverallocationAllowed;
    bool                                        memoryDeviceOverallocationNonOverridable;
    uint32                                      transferGranularityDmaOverride;
    bool                                        forceAppProfileEnable;
    uint32                                      forceAppProfileValue;
    PreciseAnisoMode                            preciseAnisoMode;
    bool                                        useAnisoThreshold;
    float                                       anisoThreshold;
    bool                                        useFlipHint;
    uint32                                      backgroundFullscreenPresent;
    uint32                                      backgroundFullscreenFailureDisableCount;
    uint32                                      backgroundFullscreenSuccessResetCount;
    bool                                        backgroundFullscreenIgnorePresentErrors;
    Pal::TilingOptMode                          imageTilingOptMode;
    Pal::ImageTilingPattern                     imageTilingPreference;
    bool                                        enableFmaskBasedMsaaRead;
    bool                                        enableHighPriorityDescriptorMemory;
    bool                                        disableHtileBasedMsaaRead;
    bool                                        disableMsaaStencilShaderRead;
    uint32                                      optImgMaskToApplyShaderReadUsageForTransferSrc;
    uint32                                      optImgMaskToApplyShaderWriteUsageForTransferDst;
    bool                                        optOnlyEnableFP16ForGfx9Plus;
    bool                                        optColorTargetUsageDoesNotContainResolveLayout;
    uint32                                      optRenderStateCacheEnable;
    bool                                        ignoreMutableFlag;
    OptimizeCmdbufMode                          optimizeCmdbufMode;
    bool                                        prefetchShaders;
    uint32                                      dccBitsPerPixelThreshold;
    bool                                        forceDccForColorAttachments;
    uint32                                      disableSmallSurfColorCompressionSize;
    bool                                        enableGpuEventMultiSlot;
    bool                                        useAcqRelInterface;
    bool                                        enableSPP;
    bool                                        enableMlModelForWaveSize;
    bool                                        enableAsyncCompile;
    bool                                        disableSkipFceOptimization;
    uint32                                      devModePipelineUriServicePostSizeLimit;
    bool                                        devModeElfReplacementDirectoryEnable;
    char                                        devModeElfReplacementDirectory[512];
    bool                                        devModeShaderIsaDbEnable;
    bool                                        devModeQueueTimingEnable;
    bool                                        devModeSemaphoreQueueTimingEnable;
    uint32                                      devModeSqttMarkerEnable;
    bool                                        devModeSqttForceDisable;
    bool                                        devModeSqttWaitIdle;
    bool                                        devModeSqttFlushAllQueues;
    uint32                                      devModeSqttGpuMemoryLimit;
    uint32                                      devModeSqttFrameCount;
    char                                        devModeSqttInternalUserEventPrefix[512];
    bool                                        devModeSqttTraceBeginEndTagEnable;
    uint64                                      devModeSqttTraceBeginTagValue;
    uint64                                      devModeSqttTraceEndTagValue;
    bool                                        devModeSqttInstructionTraceEnable;
    uint64                                      devModeSqttTargetApiPsoHash;
    bool                                        devModeSqttForceBlockOnTraceEnd;
    uint32                                      devModeSqttPrepareFrameCount;
    bool                                        overrideShaderParams;
    uint64                                      overrideShaderHashUpper;
    uint64                                      overrideShaderHashLower;
    uint32                                      overrideShaderStage;
    uint32                                      overrideNumVGPRsAvailable;
    uint32                                      overrideWavesPerCu;
    bool                                        overrideUserDataSpillThreshold;
    uint32                                      overrideMaxLdsSpillDwords;
    uint32                                      overrideCsTgPerCu;
    PipelineBinningMode                         overrideUsePbbPerCrc;
    bool                                        overrideAllowReZ;
    ShaderWaveSize                              overrideWaveSize;
    WgpMode                                     overrideWgpMode;
    bool                                        overrideDisableLoopUnrolls;
    bool                                        overrideUseSiScheduler;
    bool                                        overrideReconfigWorkgroupLayout;
    bool                                        resourceProfileIgnoresAppProfile;
    bool                                        overrideResourceParams;
    uint64                                      overrideResourceHashDimensions;
    uint64                                      overrideResourceHashCrc;
    DccMode                                     overrideResourceDccOnOff;
    TextureFilterOptimizationSettings           vulkanTexFilterQuality;
    uint32                                      appGpuID;
};
static const char* pRenderPassNewEnableStr = "#2409736061";
static const char* pRenderPassLogEnableStr = "#3847355121";
static const char* pRenderPassLogDirectoryStr = "#2308918241";
static const char* pRenderPassLogFlagsStr = "#2841546813";
static const char* pRenderPassForceWaitIdleStr = "#2692943068";
static const char* pRenderPassForceCacheInputCoherStr = "#3512803342";
static const char* pRenderPassForceCacheOutputCoherStr = "#4070286939";
static const char* pRenderPassAsyncEventEnableStr = "#3421157755";
static const char* pCmdBufGpuEventMinAllocCountStr = "#1373972514";
static const char* pUseSharedCmdAllocatorStr = "#2695722952";
static const char* pCmdAllocatorDataHeapStr = "#1832694714";
static const char* pCmdAllocatorDataAllocSizeStr = "#2667761104";
static const char* pCmdAllocatorDataSubAllocSizeStr = "#4089588998";
static const char* pCmdAllocatorEmbeddedHeapStr = "#46174540";
static const char* pCmdAllocatorEmbeddedAllocSizeStr = "#4049945662";
static const char* pCmdAllocatorEmbeddedSubAllocSizeStr = "#1513127512";
static const char* pCmdAllocatorScratchHeapStr = "#4153516452";
static const char* pCmdAllocatorScratchAllocSizeStr = "#3574029062";
static const char* pCmdAllocatorScratchSubAllocSizeStr = "#3402444848";
static const char* pPipelineLinkTimeOptModeStr = "#3606461208";
static const char* pPipelineFastCompileModeStr = "#601804157";
static const char* pPipelineBinningModeStr = "#1967427837";
static const char* pPipelineUseProfileHashAsClientHashStr = "#3384165644";
static const char* pPipelineUseShaderHashAsProfileHashStr = "#390173032";
static const char* pPipelineProfileRuntimeFileStr = "#1286473046";
static const char* pPipelineProfileDbgPrintProfileMatchStr = "#3578410736";
static const char* pPipelineProfileIgnoresAppProfileStr = "#284988527";
static const char* pPipelineProfileHaltOnParseFailureStr = "#2803779161";
static const char* pDisableEmbedConstArraysStr = "#3897517765";
static const char* pUmdFramePacerControlStr = "#2149178358";
static const char* pEnableFRTCStr = "#3273760519";
static const char* pEnableTurboSyncStr = "#1034024081";
static const char* pFullscreenFrameMetadataSupportStr = "#3683287271";
static const char* pUseSdmaCompositingBltStr = "#1167844307";
static const char* pEnableMailboxPresentModeStr = "#1772474034";
static const char* pEnableAcquireBeforeSignalStr = "#129319645";
static const char* pIgnoreSuboptimalSwapchainSizeStr = "#1182231700";
static const char* pEnablePipelineDumpStr = "#809818814";
static const char* pPipelineDumpDirStr = "#989712612";
static const char* pEnableLogStr = "#4062912068";
static const char* pLogFileNameStr = "#1494398452";
static const char* pEnableDebugStr = "#4049167417";
static const char* pDebugLogFileNameStr = "#2699235047";
static const char* pShaderReplaceModeStr = "#3527127795";
static const char* pShaderReplaceDirStr = "#3308298423";
static const char* pShaderReplacePipelineHashesStr = "#907814690";
static const char* pEnableDropPipelineBinaryInstStr = "#3273095844";
static const char* pSubgroupSizeStr = "#1216748277";
static const char* pVsWaveSizeStr = "#2875804878";
static const char* pTcsWaveSizeStr = "#1234081121";
static const char* pTesWaveSizeStr = "#3072096235";
static const char* pGsWaveSizeStr = "#105228583";
static const char* pFsWaveSizeStr = "#818064926";
static const char* pCsWaveSizeStr = "#267990155";
static const char* pEnableNggStr = "#109876678";
static const char* pNggEnableGsUseStr = "#2612258605";
static const char* pNggForceNonPassthroughStr = "#1453958321";
static const char* pNggCompactionModeStr = "#3742782005";
static const char* pNggAlwaysUsePrimShaderTableStr = "#1338799096";
static const char* pNggBackfaceExponentStr = "#3043623194";
static const char* pNggSubgroupSizingStr = "#2391406036";
static const char* pNggPrimsPerSubgroupStr = "#958458130";
static const char* pNggVertsPerSubgroupStr = "#2005944793";
static const char* pNggEnableBackfaceCullingStr = "#3428907318";
static const char* pNggEnableFrustumCullingStr = "#1220820826";
static const char* pNggEnableBoxFilterCullingStr = "#1523650329";
static const char* pNggEnableSphereCullingStr = "#1275673699";
static const char* pNggEnableSmallPrimFilterStr = "#2076615117";
static const char* pNggEnableCullDistanceCullingStr = "#1789457237";
static const char* pEnableForwardProgressStr = "#3285317740";
static const char* pEnableWgpModeStr = "#3525874863";
static const char* pWaveBreakSizeStr = "#668198610";
static const char* pDropPipelineBinaryInstTokenStr = "#1682931540";
static const char* pDropPipelineBinaryInstSizeStr = "#3265600022";
static const char* pEnableSpvPerfOptimalStr = "#892928116";
static const char* pEnableSpvValidationStr = "#2156135806";
static const char* pZeroInitILRegsStr = "#23712203";
static const char* pSkipUnsupportedOpCodeStr = "#1161817703";
static const char* pVsIrModeStr = "#2814660322";
static const char* pTcsIrModeStr = "#2483461757";
static const char* pTesIrModeStr = "#2121496471";
static const char* pGsIrModeStr = "#3407113011";
static const char* pFsIrModeStr = "#1270580946";
static const char* pCsIrModeStr = "#4067611319";
static const char* pLlpcOptionsStr = "#3508213626";
static const char* pShaderCacheModeStr = "#1113140201";
static const char* pDropPipelineBinaryInstMaskStr = "#4084890811";
static const char* pAllowVkPipelineCachingToDiskStr = "#1692817184";
static const char* pAllowExternalPipelineCacheObjectStr = "#2565610768";
static const char* pPipelineCachingEnvironmentVariableStr = "#812278617";
static const char* pUsePipelineCachingDefaultLocationStr = "#823134843";
static const char* pPipelineCachingDefaultLocationStr = "#3551643726";
static const char* pMarkPipelineCacheWithBuildTimestampStr = "#2279843108";
static const char* pFilterPipelineDumpByTypeStr = "#3474328038";
static const char* pFilterPipelineDumpByHashStr = "#579619034";
static const char* pDumpDuplicatePipelinesStr = "#785467391";
static const char* pDbgBarrierPostCmdEnableStr = "#2908457448";
static const char* pDbgBarrierPostWaitPipePointStr = "#156027798";
static const char* pDbgBarrierPostSignalPipePointStr = "#895128045";
static const char* pDbgBarrierPostCacheSrcMaskStr = "#1320062177";
static const char* pDbgBarrierPostCacheDstMaskStr = "#1231285864";
static const char* pDbgBarrierPreCmdEnableStr = "#160975439";
static const char* pDbgBarrierPreWaitPipePointStr = "#3910150193";
static const char* pDbgBarrierPreSignalPipePointStr = "#2760693190";
static const char* pDbgBarrierPreCacheSrcMaskStr = "#1891812632";
static const char* pDbgBarrierPreCacheDstMaskStr = "#139905033";
static const char* pVertexBufferTableInstanceRingSizeStr = "#3498376063";
static const char* pResourceBarrierOptionsStr = "#2348416782";
static const char* pBarrierFilterOptionsStr = "#3752069724";
static const char* pBarrierFilterProfileFileStr = "#595912577";
static const char* pExcessivePipelineCacheCountThresholdStr = "#3723860598";
static const char* pEnumPreferredDeviceIndexStr = "#3963167097";
static const char* pRobustBufferAccessStr = "#3274333888";
static const char* pLenientInstanceFuncQueryStr = "#3810474515";
static const char* pAppProfileDumpDirStr = "#3218751138";
static const char* pOptEnablePrtStr = "#4176537453";
static const char* pAsyncComputeQueueMaxWavesPerCuStr = "#2974072278";
static const char* pAsyncComputeQueueLimitStr = "#1555805922";
static const char* pLimitSampleCountsStr = "#1858209418";
static const char* pMemoryCustomDeviceAllocationCountLimitStr = "#2849969415";
static const char* pMemoryBaseAddrAlignmentStr = "#2939407841";
static const char* pMemoryBaseAddrAlignmentCpuVisibleWin32Str = "#210525960";
static const char* pMemoryRemoteBackupHeapMinHeapSizeStr = "#102739955";
static const char* pMemoryAttachmentImageMemoryTypeMinHeapSizeStr = "#551580142";
static const char* pMemoryPriorityDefaultStr = "#289279007";
static const char* pMemoryPriorityImageAnyStr = "#2321168839";
static const char* pMemoryPriorityImageShaderReadStr = "#287215626";
static const char* pMemoryPriorityImageShaderWriteStr = "#3076300173";
static const char* pMemoryPriorityImageColorTargetStr = "#2285511511";
static const char* pMemoryPriorityImageDepthStencilStr = "#659226412";
static const char* pHeapBudgetRatioOfHeapSizeLocalStr = "#2165343898";
static const char* pHeapBudgetRatioOfHeapSizeInvisibleStr = "#2093136090";
static const char* pHeapBudgetRatioOfHeapSizeNonlocalStr = "#4014618225";
static const char* pIsSparseUnmapBeforeDestroyEnabledStr = "#2340216420";
static const char* pTransferGranularityUniversalOverrideStr = "#1823255859";
static const char* pTransferGranularityComputeOverrideStr = "#335561107";
static const char* pMemoryDeviceOverallocationAllowedStr = "#3284038896";
static const char* pMemoryDeviceOverallocationNonOverridableStr = "#567133396";
static const char* pTransferGranularityDmaOverrideStr = "#2375478640";
static const char* pForceAppProfileEnableStr = "#3513042023";
static const char* pForceAppProfileValueStr = "#2974380825";
static const char* pPreciseAnisoModeStr = "#3851989621";
static const char* pUseAnisoThresholdStr = "#1273651387";
static const char* pAnisoThresholdStr = "#3416866970";
static const char* pUseFlipHintStr = "#396475294";
static const char* pBackgroundFullscreenPresentStr = "#1298749675";
static const char* pBackgroundFullscreenFailureDisableCountStr = "#3304542337";
static const char* pBackgroundFullscreenSuccessResetCountStr = "#253450729";
static const char* pBackgroundFullscreenIgnorePresentErrorsStr = "#3561218782";
static const char* pImageTilingOptModeStr = "#356081981";
static const char* pImageTilingPreferenceStr = "#2294620896";
static const char* pEnableFmaskBasedMsaaReadStr = "#4238889853";
static const char* pEnableHighPriorityDescriptorMemoryStr = "#1370412112";
static const char* pDisableHtileBasedMsaaReadStr = "#2924066334";
static const char* pDisableMsaaStencilShaderReadStr = "#839875998";
static const char* pTransferSrcUsageAsShaderReadMaskStr = "#4254919194";
static const char* pTransferDstUsageAsShaderWriteMaskStr = "#3940320828";
static const char* pOnlyEnableFP16ForGfx9PlusStr = "#40567326";
static const char* pColorTargetUsageDoesNotContainResolveLayoutStr = "#523539756";
static const char* pRenderStateCacheEnableStr = "#3107692587";
static const char* pIgnoreMutableFlagStr = "#669794809";
static const char* pOptimizeCmdbufModeStr = "#3847566088";
static const char* pPrefetchShadersStr = "#1791920096";
static const char* pDccBitsPerPixelThresholdStr = "#2668340295";
static const char* pForceDccForColorAttachmentsStr = "#3046665474";
static const char* pDisableSmallSurfColorCompressionSizeStr = "#2075204220";
static const char* pEnableGpuEventMultiSlotStr = "#1407114949";
static const char* pUseAcqRelInterfaceStr = "#587881749";
static const char* pEnableSPPStr = "#2437981247";
static const char* pEnableMlModelForWaveSizeStr = "#915258299";
static const char* pEnableAsyncCompileStr = "#4064117211";
static const char* pDisableSkipFceOptimizationStr = "#3031646935";
static const char* pDevModePipelineUriServicePostSizeLimitStr = "#801344686";
static const char* pDevModeElfReplacementDirectoryEnableStr = "#1051952064";
static const char* pDevModeElfReplacementDirectoryStr = "#2986257399";
static const char* pDevModeShaderIsaDbEnableStr = "#3998535268";
static const char* pDevModeQueueTimingEnableStr = "#4267003511";
static const char* pDevModeSemaphoreQueueTimingEnableStr = "#1840915631";
static const char* pDevModeSqttMarkerEnableStr = "#3758115926";
static const char* pDevModeSqttForceDisableStr = "#1045260770";
static const char* pDevModeSqttWaitIdleStr = "#2301549408";
static const char* pDevModeSqttFlushAllQueuesStr = "#4103072742";
static const char* pDevModeSqttGpuMemoryLimitStr = "#1724659923";
static const char* pDevModeSqttFrameCountStr = "#1516028043";
static const char* pDevModeSqttInternalUserEventPrefixStr = "#2681226663";
static const char* pDevModeSqttTraceBeginEndTagEnableStr = "#170815525";
static const char* pDevModeSqttTraceBeginTagValueStr = "#1843312060";
static const char* pDevModeSqttTraceEndTagValueStr = "#1382482956";
static const char* pDevModeSqttInstructionTraceEnableStr = "#2498745445";
static const char* pDevModeSqttTargetApiPsoHashStr = "#3810870996";
static const char* pDevModeSqttForceBlockOnTraceEndStr = "#2293963252";
static const char* pDevModeSqttPrepareFrameCountStr = "#1904450154";
static const char* pOverrideShaderParamsStr = "#15225846";
static const char* pOverrideShaderHashUpperStr = "#4034696060";
static const char* pOverrideShaderHashLowerStr = "#951100197";
static const char* pOverrideShaderStageStr = "#205873806";
static const char* pOverrideNumVGPRsAvailableStr = "#1826717614";
static const char* pOverrideWavesPerCuStr = "#297810728";
static const char* pOverrideUserDataSpillThresholdStr = "#2769900547";
static const char* pOverrideMaxLdsSpillDwordsStr = "#1651396017";
static const char* pOverrideCsTgPerCuStr = "#2898940541";
static const char* pOverrideUsePbbPerCrcStr = "#2471901291";
static const char* pOverrideAllowReZStr = "#2596394967";
static const char* pOverrideWaveSizeStr = "#311520325";
static const char* pOverrideWgpModeStr = "#4247168110";
static const char* pOverrideDisableLoopUnrollsStr = "#2077939830";
static const char* pOverrideUseSiSchedulerStr = "#995249705";
static const char* pOverrideReconfigWorkgroupLayoutStr = "#3705509468";
static const char* pResourceProfileIgnoresAppProfileStr = "#3259709197";
static const char* pOverrideResourceParamsStr = "#2494222459";
static const char* pOverrideResourceHashDimensionsStr = "#3988943396";
static const char* pOverrideResourceHashCrcStr = "#1371163493";
static const char* pOverrideResourceDccOnOffStr = "#585965089";
static const char* pVulkanTexFilterQualityStr = "#3719285346";
static const char* pAppGpuIDStr = "#330166207";

static const uint32 g_vulkanNumSettings = 215;
static const Pal::SettingNameHash g_vulkanSettingHashList[] = {
2409736061,
3847355121,
2308918241,
2841546813,
2692943068,
3512803342,
4070286939,
3421157755,
1373972514,
2695722952,
1832694714,
2667761104,
4089588998,
46174540,
4049945662,
1513127512,
4153516452,
3574029062,
3402444848,
3606461208,
601804157,
1967427837,
3384165644,
390173032,
1286473046,
3578410736,
284988527,
2803779161,
3897517765,
2149178358,
3273760519,
1034024081,
3683287271,
1167844307,
1772474034,
129319645,
1182231700,
809818814,
989712612,
4062912068,
1494398452,
4049167417,
2699235047,
3527127795,
3308298423,
907814690,
3273095844,
1216748277,
2875804878,
1234081121,
3072096235,
105228583,
818064926,
267990155,
109876678,
2612258605,
1453958321,
3742782005,
1338799096,
3043623194,
2391406036,
958458130,
2005944793,
3428907318,
1220820826,
1523650329,
1275673699,
2076615117,
1789457237,
3285317740,
3525874863,
668198610,
1682931540,
3265600022,
892928116,
2156135806,
23712203,
1161817703,
2814660322,
2483461757,
2121496471,
3407113011,
1270580946,
4067611319,
3508213626,
1113140201,
4084890811,
1692817184,
2565610768,
812278617,
823134843,
3551643726,
2279843108,
3474328038,
579619034,
785467391,
2908457448,
156027798,
895128045,
1320062177,
1231285864,
160975439,
3910150193,
2760693190,
1891812632,
139905033,
3498376063,
2348416782,
3752069724,
595912577,
3723860598,
3963167097,
3274333888,
3810474515,
3218751138,
4176537453,
2974072278,
1555805922,
1858209418,
2849969415,
2939407841,
210525960,
102739955,
551580142,
289279007,
2321168839,
287215626,
3076300173,
2285511511,
659226412,
2165343898,
2093136090,
4014618225,
2340216420,
1823255859,
335561107,
3284038896,
567133396,
2375478640,
3513042023,
2974380825,
3851989621,
1273651387,
3416866970,
396475294,
1298749675,
3304542337,
253450729,
3561218782,
356081981,
2294620896,
4238889853,
1370412112,
2924066334,
839875998,
4254919194,
3940320828,
40567326,
523539756,
3107692587,
669794809,
3847566088,
1791920096,
2668340295,
3046665474,
2075204220,
1407114949,
587881749,
2437981247,
915258299,
4064117211,
3031646935,
801344686,
1051952064,
2986257399,
3998535268,
4267003511,
1840915631,
3758115926,
1045260770,
2301549408,
4103072742,
1724659923,
1516028043,
2681226663,
170815525,
1843312060,
1382482956,
2498745445,
3810870996,
2293963252,
1904450154,
15225846,
4034696060,
951100197,
205873806,
1826717614,
297810728,
2769900547,
1651396017,
2898940541,
2471901291,
2596394967,
311520325,
4247168110,
2077939830,
995249705,
3705509468,
3259709197,
2494222459,
3988943396,
1371163493,
585965089,
3719285346,
330166207,
};

static const uint8 g_vulkanJsonData[] = {
    123, 34, 67, 111, 109, 112, 111, 110, 101, 110, 116, 78, 97, 109, 101, 34, 58, 32, 34, 86, 117, 108, 107, 97, 110,
    34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 82, 101, 110, 100, 101, 114, 32, 80, 97, 115, 115, 101, 115,
    34, 44, 32, 34, 67, 111, 109, 109, 97, 110, 100, 32, 66, 117, 102, 102, 101, 114, 32, 79, 112, 116, 105, 111, 110,
    115, 34, 44, 32, 34, 80, 105, 112, 101, 108, 105, 110, 101, 32, 79, 112, 116, 105, 111, 110, 115, 34, 44, 32, 34,
    80, 114, 101, 115, 101, 110, 116, 34, 44, 32, 34, 83, 80, 73, 82, 86, 32, 79, 112, 116, 105, 111, 110, 115, 34, 44,
    32, 34, 82, 97, 121, 116, 114, 97, 99, 105, 110, 103, 34, 44, 32, 34, 68, 101, 98, 117, 103, 103, 105, 110, 103, 34,
    44, 32, 34, 71, 101, 110, 101, 114, 97, 108, 34, 44, 32, 34, 77, 101, 109, 111, 114, 121, 34, 44, 32, 34, 79, 112,
    116, 105, 109, 105, 122, 97, 116, 105, 111, 110, 34, 44, 32, 34, 68, 101, 118, 101, 108, 111, 112, 101, 114, 32, 77,
    111, 100, 101, 34, 44, 32, 34, 67, 104, 105, 108, 108, 34, 44, 32, 34, 83, 104, 97, 100, 101, 114, 32, 84, 117, 110,
    105, 110, 103, 34, 44, 32, 34, 82, 101, 115, 111, 117, 114, 99, 101, 32, 84, 117, 110, 105, 110, 103, 34, 44, 32,
    34, 82, 97, 100, 101, 111, 110, 32, 73, 109, 97, 103, 101, 32, 83, 104, 97, 114, 112, 101, 110, 105, 110, 103, 34,
    44, 32, 34, 80, 117, 98, 108, 105, 99, 32, 67, 67, 67, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 69,
    110, 117, 109, 115, 34, 58, 32, 91, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 70, 101, 97, 116, 117, 114, 101, 69,
    110, 97, 98, 108, 101, 77, 111, 100, 101, 34, 44, 32, 34, 73, 115, 69, 110, 117, 109, 34, 58, 32, 116, 114, 117,
    101, 44, 32, 34, 86, 97, 108, 117, 101, 115, 34, 58, 32, 91, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 70, 101, 97,
    116, 117, 114, 101, 68, 101, 102, 97, 117, 108, 116, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 48, 44, 32,
    34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 68, 101, 102, 97, 117, 108, 116, 44, 32,
    117, 115, 101, 32, 97, 112, 112, 108, 105, 99, 97, 116, 105, 111, 110, 32, 115, 101, 116, 116, 105, 110, 103, 34,
    125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 70, 101, 97, 116, 117, 114, 101, 70, 111, 114, 99, 101, 69,
    110, 97, 98, 108, 101, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 44, 32, 34, 68, 101, 115, 99, 114,
    105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 70, 111, 114, 99, 101, 32, 69, 110, 97, 98, 108, 101, 34, 125, 44, 32,
    123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 70, 101, 97, 116, 117, 114, 101, 70, 111, 114, 99, 101, 68, 105, 115, 97,
    98, 108, 101, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 50, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112,
    116, 105, 111, 110, 34, 58, 32, 34, 70, 111, 114, 99, 101, 32, 68, 105, 115, 97, 98, 108, 101, 32, 68, 101, 102, 97,
    117, 108, 116, 32, 86, 97, 108, 117, 101, 34, 125, 93, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 79,
    112, 116, 82, 101, 110, 100, 101, 114, 83, 116, 97, 116, 101, 67, 97, 99, 104, 101, 70, 108, 97, 103, 34, 44, 32,
    34, 73, 115, 69, 110, 117, 109, 34, 58, 32, 116, 114, 117, 101, 44, 32, 34, 86, 97, 108, 117, 101, 115, 34, 58, 32,
    91, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 79, 112, 116, 82, 101, 110, 100, 101, 114, 83, 116, 97, 116, 101, 67,
    97, 99, 104, 101, 77, 115, 97, 97, 83, 116, 97, 116, 101, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 44,
    32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 80, 65, 76, 32, 77, 83, 65, 65, 32,
    115, 116, 97, 116, 101, 32, 111, 98, 106, 101, 99, 116, 115, 32, 40, 97, 108, 108, 32, 103, 114, 97, 112, 104, 105,
    99, 115, 32, 112, 105, 112, 101, 108, 105, 110, 101, 115, 41, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58,
    32, 34, 79, 112, 116, 82, 101, 110, 100, 101, 114, 83, 116, 97, 116, 101, 67, 97, 99, 104, 101, 67, 111, 108, 111,
    114, 66, 108, 101, 110, 100, 83, 116, 97, 116, 101, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 50, 44, 32,
    34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 80, 65, 76, 32, 99, 111, 108, 111, 114, 32,
    98, 108, 101, 110, 100, 32, 115, 116, 97, 116, 101, 32, 111, 98, 106, 101, 99, 116, 115, 32, 40, 97, 108, 108, 32,
    103, 114, 97, 112, 104, 105, 99, 115, 32, 112, 105, 112, 101, 108, 105, 110, 101, 115, 41, 34, 125, 44, 32, 123, 34,
    78, 97, 109, 101, 34, 58, 32, 34, 79, 112, 116, 82, 101, 110, 100, 101, 114, 83, 116, 97, 116, 101, 67, 97, 99, 104,
    101, 68, 101, 112, 116, 104, 83, 116, 101, 110, 99, 105, 108, 83, 116, 97, 116, 101, 34, 44, 32, 34, 86, 97, 108,
    117, 101, 34, 58, 32, 52, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 80, 65,
    76, 32, 100, 101, 112, 116, 104, 32, 115, 116, 101, 110, 99, 105, 108, 32, 115, 116, 97, 116, 101, 32, 111, 98, 106,
    101, 99, 116, 115, 32, 40, 97, 108, 108, 32, 103, 114, 97, 112, 104, 105, 99, 115, 32, 112, 105, 112, 101, 108, 105,
    110, 101, 115, 41, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 79, 112, 116, 82, 101, 110, 100, 101,
    114, 83, 116, 97, 116, 101, 67, 97, 99, 104, 101, 73, 110, 112, 117, 116, 65, 115, 115, 101, 109, 98, 108, 121, 83,
    116, 97, 116, 101, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 56, 44, 32, 34, 68, 101, 115, 99, 114, 105,
    112, 116, 105, 111, 110, 34, 58, 32, 34, 80, 65, 76, 32, 105, 110, 112, 117, 116, 32, 97, 115, 115, 101, 109, 98,
    108, 121, 32, 115, 116, 97, 116, 101, 32, 112, 97, 114, 97, 109, 115, 32, 40, 97, 108, 108, 32, 103, 114, 97, 112,
    104, 105, 99, 115, 32, 112, 105, 112, 101, 108, 105, 110, 101, 115, 41, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101,
    34, 58, 32, 34, 79, 112, 116, 82, 101, 110, 100, 101, 114, 83, 116, 97, 116, 101, 67, 97, 99, 104, 101, 84, 114,
    105, 97, 110, 103, 108, 101, 82, 97, 115, 116, 101, 114, 83, 116, 97, 116, 101, 34, 44, 32, 34, 86, 97, 108, 117,
    101, 34, 58, 32, 49, 54, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 84, 114,
    105, 97, 110, 103, 108, 101, 32, 114, 97, 115, 116, 101, 114, 32, 115, 116, 97, 116, 101, 32, 112, 97, 114, 97, 109,
    115, 32, 40, 112, 97, 114, 116, 32, 111, 102, 32, 101, 118, 101, 114, 121, 32, 103, 114, 97, 112, 104, 105, 99, 115,
    32, 112, 105, 112, 101, 108, 105, 110, 101, 41, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 79, 112,
    116, 82, 101, 110, 100, 101, 114, 83, 116, 97, 116, 101, 67, 97, 99, 104, 101, 83, 116, 97, 116, 105, 99, 80, 111,
    105, 110, 116, 76, 105, 110, 101, 82, 97, 115, 116, 101, 114, 83, 116, 97, 116, 101, 34, 44, 32, 34, 86, 97, 108,
    117, 101, 34, 58, 32, 51, 50, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 80,
    111, 105, 110, 116, 32, 108, 105, 110, 101, 32, 114, 97, 115, 116, 101, 114, 32, 115, 116, 97, 116, 101, 32, 40,
    111, 110, 108, 121, 32, 119, 104, 101, 110, 32, 109, 97, 114, 107, 101, 100, 32, 115, 116, 97, 116, 105, 99, 41, 34,
    125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 79, 112, 116, 82, 101, 110, 100, 101, 114, 83, 116, 97, 116,
    101, 67, 97, 99, 104, 101, 83, 116, 97, 116, 105, 99, 68, 101, 112, 116, 104, 66, 105, 97, 115, 34, 44, 32, 34, 86,
    97, 108, 117, 101, 34, 58, 32, 54, 52, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32,
    34, 68, 101, 112, 116, 104, 32, 98, 105, 97, 115, 32, 115, 116, 97, 116, 101, 32, 40, 111, 110, 108, 121, 32, 119,
    104, 101, 110, 32, 109, 97, 114, 107, 101, 100, 32, 115, 116, 97, 116, 105, 99, 41, 34, 125, 44, 32, 123, 34, 78,
    97, 109, 101, 34, 58, 32, 34, 79, 112, 116, 82, 101, 110, 100, 101, 114, 83, 116, 97, 116, 101, 67, 97, 99, 104,
    101, 83, 116, 97, 116, 105, 99, 66, 108, 101, 110, 100, 67, 111, 110, 115, 116, 34, 44, 32, 34, 86, 97, 108, 117,
    101, 34, 58, 32, 49, 50, 56, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 66,
    108, 101, 110, 100, 32, 99, 111, 110, 115, 116, 32, 115, 116, 97, 116, 101, 32, 40, 111, 110, 108, 121, 32, 119,
    104, 101, 110, 32, 109, 97, 114, 107, 101, 100, 32, 115, 116, 97, 116, 105, 99, 41, 34, 125, 44, 32, 123, 34, 78,
    97, 109, 101, 34, 58, 32, 34, 79, 112, 116, 82, 101, 110, 100, 101, 114, 83, 116, 97, 116, 101, 67, 97, 99, 104,
    101, 83, 116, 97, 116, 105, 99, 68, 101, 112, 116, 104, 66, 111, 117, 110, 100, 115, 34, 44, 32, 34, 86, 97, 108,
    117, 101, 34, 58, 32, 50, 53, 54, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34,
    68, 101, 112, 116, 104, 32, 98, 111, 117, 110, 100, 115, 32, 115, 116, 97, 116, 101, 32, 40, 111, 110, 108, 121, 32,
    119, 104, 101, 110, 32, 109, 97, 114, 107, 101, 100, 32, 115, 116, 97, 116, 105, 99, 41, 34, 125, 44, 32, 123, 34,
    78, 97, 109, 101, 34, 58, 32, 34, 79, 112, 116, 82, 101, 110, 100, 101, 114, 83, 116, 97, 116, 101, 67, 97, 99, 104,
    101, 83, 116, 97, 116, 105, 99, 86, 105, 101, 119, 112, 111, 114, 116, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34,
    58, 32, 53, 49, 50, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 86, 105, 101,
    119, 112, 111, 114, 116, 32, 115, 116, 97, 116, 101, 32, 40, 111, 110, 108, 121, 32, 119, 104, 101, 110, 32, 109,
    97, 114, 107, 101, 100, 32, 115, 116, 97, 116, 105, 99, 41, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32,
    34, 79, 112, 116, 82, 101, 110, 100, 101, 114, 83, 116, 97, 116, 101, 67, 97, 99, 104, 101, 83, 116, 97, 116, 105,
    99, 83, 99, 105, 115, 115, 111, 114, 82, 101, 99, 116, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 48,
    50, 52, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 83, 99, 105, 115, 115, 111,
    114, 32, 114, 101, 99, 116, 32, 115, 116, 97, 116, 101, 32, 40, 111, 110, 108, 121, 32, 119, 104, 101, 110, 32, 109,
    97, 114, 107, 101, 100, 32, 115, 116, 97, 116, 105, 99, 41, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32,
    34, 79, 112, 116, 82, 101, 110, 100, 101, 114, 83, 116, 97, 116, 101, 67, 97, 99, 104, 101, 83, 116, 97, 116, 105,
    99, 83, 97, 109, 112, 108, 101, 80, 97, 116, 116, 101, 114, 110, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32,
    50, 48, 52, 56, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 83, 97, 109, 112,
    108, 101, 32, 112, 97, 116, 101, 114, 110, 32, 115, 116, 97, 116, 101, 32, 40, 111, 110, 108, 121, 32, 119, 104,
    101, 110, 32, 109, 97, 114, 107, 101, 100, 32, 115, 116, 97, 116, 105, 99, 41, 34, 125, 44, 32, 123, 34, 78, 97,
    109, 101, 34, 58, 32, 34, 79, 112, 116, 82, 101, 110, 100, 101, 114, 83, 116, 97, 116, 101, 67, 97, 99, 104, 101,
    83, 116, 97, 116, 105, 99, 71, 114, 97, 112, 104, 105, 99, 115, 87, 97, 118, 101, 76, 105, 109, 105, 116, 115, 34,
    44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 52, 48, 57, 54, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116,
    105, 111, 110, 34, 58, 32, 34, 71, 114, 97, 112, 104, 105, 99, 115, 32, 119, 97, 118, 101, 32, 108, 105, 109, 105,
    116, 115, 32, 115, 116, 97, 116, 101, 32, 40, 111, 110, 108, 121, 32, 119, 104, 101, 110, 32, 109, 97, 114, 107,
    101, 100, 32, 115, 116, 97, 116, 105, 99, 41, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 79, 112,
    116, 82, 101, 110, 100, 101, 114, 83, 116, 97, 116, 101, 67, 97, 99, 104, 101, 83, 116, 97, 116, 105, 99, 67, 111,
    109, 112, 117, 116, 101, 87, 97, 118, 101, 76, 105, 109, 105, 116, 115, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34,
    58, 32, 56, 49, 57, 50, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 67, 111,
    109, 112, 117, 116, 101, 32, 119, 97, 118, 101, 32, 108, 105, 109, 105, 116, 115, 32, 115, 116, 97, 116, 101, 32,
    40, 111, 110, 108, 121, 32, 119, 104, 101, 110, 32, 109, 97, 114, 107, 101, 100, 32, 115, 116, 97, 116, 105, 99, 41,
    34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 79, 112, 116, 82, 101, 110, 100, 101, 114, 83, 116, 97,
    116, 101, 67, 97, 99, 104, 101, 83, 116, 97, 116, 105, 99, 65, 110, 105, 115, 111, 76, 111, 100, 67, 111, 109, 112,
    101, 110, 115, 97, 116, 105, 111, 110, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 54, 51, 56, 52, 44,
    32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 65, 110, 105, 115, 111, 32, 76, 79, 68,
    32, 99, 111, 109, 112, 101, 110, 115, 97, 116, 105, 111, 110, 32, 115, 116, 97, 116, 101, 32, 40, 111, 110, 108,
    121, 32, 119, 104, 101, 110, 32, 109, 97, 114, 107, 101, 100, 32, 115, 116, 97, 116, 105, 99, 41, 34, 125, 44, 32,
    123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 79, 112, 116, 82, 101, 110, 100, 101, 114, 83, 116, 97, 116, 101, 67, 97,
    99, 104, 101, 83, 116, 97, 116, 105, 99, 76, 105, 110, 101, 83, 116, 105, 112, 112, 108, 101, 34, 44, 32, 34, 86,
    97, 108, 117, 101, 34, 58, 32, 51, 50, 55, 54, 56, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110,
    34, 58, 32, 34, 76, 105, 110, 101, 32, 115, 116, 105, 112, 112, 108, 101, 32, 115, 116, 97, 116, 101, 32, 40, 111,
    110, 108, 121, 32, 119, 104, 101, 110, 32, 109, 97, 114, 107, 101, 100, 32, 115, 116, 97, 116, 105, 99, 41, 34, 125,
    93, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 101, 118, 77, 111, 100, 101, 83, 113, 116, 116, 77,
    97, 114, 107, 101, 114, 69, 110, 97, 98, 108, 101, 70, 108, 97, 103, 115, 34, 44, 32, 34, 73, 115, 69, 110, 117,
    109, 34, 58, 32, 116, 114, 117, 101, 44, 32, 34, 86, 97, 108, 117, 101, 115, 34, 58, 32, 91, 123, 34, 78, 97, 109,
    101, 34, 58, 32, 34, 68, 101, 118, 77, 111, 100, 101, 83, 113, 116, 116, 77, 97, 114, 107, 101, 114, 69, 110, 97,
    98, 108, 101, 67, 98, 83, 116, 97, 114, 116, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 44, 32, 34, 68,
    101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 32, 99, 111, 109, 109,
    97, 110, 100, 32, 98, 117, 102, 102, 101, 114, 32, 115, 116, 97, 114, 116, 32, 105, 110, 115, 116, 114, 117, 109,
    101, 110, 116, 97, 116, 105, 111, 110, 32, 109, 97, 114, 107, 101, 114, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101,
    34, 58, 32, 34, 68, 101, 118, 77, 111, 100, 101, 83, 113, 116, 116, 77, 97, 114, 107, 101, 114, 69, 110, 97, 98,
    108, 101, 67, 98, 69, 110, 100, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 50, 44, 32, 34, 68, 101, 115, 99,
    114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 32, 99, 111, 109, 109, 97, 110, 100,
    32, 98, 117, 102, 102, 101, 114, 32, 101, 110, 100, 32, 105, 110, 115, 116, 114, 117, 109, 101, 110, 116, 97, 116,
    105, 111, 110, 32, 109, 97, 114, 107, 101, 114, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 101,
    118, 77, 111, 100, 101, 83, 113, 116, 116, 77, 97, 114, 107, 101, 114, 69, 110, 97, 98, 108, 101, 69, 118, 101, 110,
    116, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 52, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105,
    111, 110, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 32, 112, 101, 114, 45, 100, 114, 97, 119, 47, 100, 105, 115,
    112, 97, 116, 99, 104, 32, 101, 118, 101, 110, 116, 32, 105, 110, 115, 116, 114, 117, 109, 101, 110, 116, 97, 116,
    105, 111, 110, 32, 109, 97, 114, 107, 101, 114, 115, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68,
    101, 118, 77, 111, 100, 101, 83, 113, 116, 116, 77, 97, 114, 107, 101, 114, 69, 110, 97, 98, 108, 101, 66, 97, 114,
    114, 105, 101, 114, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 56, 44, 32, 34, 68, 101, 115, 99, 114, 105,
    112, 116, 105, 111, 110, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 32, 98, 97, 114, 114, 105, 101, 114, 32, 105,
    110, 115, 116, 114, 117, 109, 101, 110, 116, 97, 116, 105, 111, 110, 32, 109, 97, 114, 107, 101, 114, 115, 34, 125,
    44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 101, 118, 77, 111, 100, 101, 83, 113, 116, 116, 77, 97, 114,
    107, 101, 114, 69, 110, 97, 98, 108, 101, 71, 101, 110, 101, 114, 97, 108, 65, 112, 105, 34, 44, 32, 34, 86, 97,
    108, 117, 101, 34, 58, 32, 49, 54, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34,
    69, 110, 97, 98, 108, 101, 32, 103, 101, 110, 101, 114, 97, 108, 32, 65, 80, 73, 32, 40, 112, 101, 114, 32, 101,
    110, 116, 114, 121, 32, 112, 111, 105, 110, 116, 32, 99, 97, 108, 108, 41, 32, 105, 110, 115, 116, 114, 117, 110,
    109, 101, 110, 116, 97, 116, 105, 111, 110, 32, 109, 97, 114, 107, 101, 114, 115, 34, 125, 44, 32, 123, 34, 78, 97,
    109, 101, 34, 58, 32, 34, 68, 101, 118, 77, 111, 100, 101, 83, 113, 116, 116, 77, 97, 114, 107, 101, 114, 69, 110,
    97, 98, 108, 101, 85, 115, 101, 114, 69, 118, 101, 110, 116, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 51,
    50, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 32,
    117, 115, 101, 114, 32, 101, 118, 101, 110, 116, 32, 40, 97, 112, 112, 32, 115, 116, 114, 105, 110, 103, 41, 32,
    109, 97, 114, 107, 101, 114, 115, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 101, 118, 77, 111,
    100, 101, 83, 113, 116, 116, 77, 97, 114, 107, 101, 114, 69, 110, 97, 98, 108, 101, 69, 118, 101, 110, 116, 87, 105,
    116, 104, 68, 105, 109, 115, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 54, 52, 44, 32, 34, 68, 101, 115,
    99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 32, 100, 105, 115, 112, 97, 116,
    99, 104, 32, 101, 118, 101, 110, 116, 115, 32, 119, 105, 116, 104, 32, 116, 104, 114, 101, 97, 100, 32, 100, 105,
    109, 101, 110, 115, 105, 111, 110, 115, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 101, 118,
    77, 111, 100, 101, 83, 113, 116, 116, 77, 97, 114, 107, 101, 114, 69, 110, 97, 98, 108, 101, 80, 105, 112, 101, 108,
    105, 110, 101, 66, 105, 110, 100, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 50, 53, 54, 44, 32, 34, 68,
    101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 32, 112, 105, 112, 101,
    108, 105, 110, 101, 32, 98, 105, 110, 100, 32, 109, 97, 114, 107, 101, 114, 115, 34, 125, 93, 125, 44, 32, 123, 34,
    78, 97, 109, 101, 34, 58, 32, 34, 80, 105, 112, 101, 108, 105, 110, 101, 66, 105, 110, 110, 105, 110, 103, 77, 111,
    100, 101, 34, 44, 32, 34, 73, 115, 69, 110, 117, 109, 34, 58, 32, 116, 114, 117, 101, 44, 32, 34, 86, 97, 108, 117,
    101, 115, 34, 58, 32, 91, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 80, 105, 112, 101, 108, 105, 110, 101, 66, 105,
    110, 110, 105, 110, 103, 77, 111, 100, 101, 68, 101, 102, 97, 117, 108, 116, 34, 44, 32, 34, 86, 97, 108, 117, 101,
    34, 58, 32, 48, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 39, 68, 101, 102,
    97, 117, 108, 116, 39, 32, 102, 111, 108, 108, 111, 119, 115, 32, 116, 104, 101, 32, 80, 66, 66, 32, 103, 108, 111,
    98, 97, 108, 32, 115, 101, 116, 116, 105, 110, 103, 46, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34,
    80, 105, 112, 101, 108, 105, 110, 101, 66, 105, 110, 110, 105, 110, 103, 77, 111, 100, 101, 68, 105, 115, 97, 98,
    108, 101, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116,
    105, 111, 110, 34, 58, 32, 34, 39, 68, 105, 115, 97, 98, 108, 101, 39, 32, 100, 105, 115, 97, 98, 108, 101, 115, 32,
    112, 105, 112, 101, 108, 105, 110, 101, 32, 98, 105, 110, 110, 105, 110, 103, 46, 34, 125, 44, 32, 123, 34, 78, 97,
    109, 101, 34, 58, 32, 34, 80, 105, 112, 101, 108, 105, 110, 101, 66, 105, 110, 110, 105, 110, 103, 77, 111, 100,
    101, 69, 110, 97, 98, 108, 101, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 50, 44, 32, 34, 68, 101, 115, 99,
    114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 39, 69, 110, 97, 98, 108, 101, 39, 32, 101, 110, 97, 98, 108,
    101, 115, 32, 112, 105, 112, 101, 108, 105, 110, 101, 32, 98, 105, 110, 110, 105, 110, 103, 46, 34, 125, 93, 125,
    44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 71, 114, 97, 112, 104, 105, 99, 115, 80, 105, 112, 101, 108, 105,
    110, 101, 84, 121, 112, 101, 34, 44, 32, 34, 73, 115, 69, 110, 117, 109, 34, 58, 32, 116, 114, 117, 101, 44, 32, 34,
    86, 97, 108, 117, 101, 115, 34, 58, 32, 91, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 71, 114, 97, 112, 104, 105,
    99, 115, 80, 105, 112, 101, 108, 105, 110, 101, 84, 121, 112, 101, 86, 115, 70, 115, 34, 44, 32, 34, 86, 97, 108,
    117, 101, 34, 58, 32, 49, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 86, 83,
    32, 80, 83, 32, 112, 105, 112, 101, 108, 105, 110, 101, 115, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32,
    34, 71, 114, 97, 112, 104, 105, 99, 115, 80, 105, 112, 101, 108, 105, 110, 101, 84, 121, 112, 101, 71, 115, 34, 44,
    32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 50, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34,
    58, 32, 34, 86, 83, 32, 71, 83, 32, 80, 83, 32, 112, 105, 112, 101, 108, 105, 110, 101, 115, 34, 125, 44, 32, 123,
    34, 78, 97, 109, 101, 34, 58, 32, 34, 71, 114, 97, 112, 104, 105, 99, 115, 80, 105, 112, 101, 108, 105, 110, 101,
    84, 121, 112, 101, 84, 101, 115, 115, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 52, 44, 32, 34, 68, 101,
    115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 84, 101, 115, 115, 32, 112, 105, 112, 101, 108, 105,
    110, 101, 115, 32, 119, 105, 116, 104, 111, 117, 116, 32, 71, 83, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34,
    58, 32, 34, 71, 114, 97, 112, 104, 105, 99, 115, 80, 105, 112, 101, 108, 105, 110, 101, 84, 121, 112, 101, 84, 101,
    115, 115, 71, 115, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 56, 44, 32, 34, 68, 101, 115, 99, 114, 105,
    112, 116, 105, 111, 110, 34, 58, 32, 34, 84, 101, 115, 115, 32, 112, 105, 112, 101, 108, 105, 110, 101, 32, 119,
    105, 116, 104, 32, 71, 83, 34, 125, 93, 125, 93, 44, 32, 34, 83, 101, 116, 116, 105, 110, 103, 115, 34, 58, 32, 91,
    123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 82, 101, 110, 100, 101, 114, 80, 97, 115, 115, 78, 101, 119, 69, 110, 97,
    98, 108, 101, 34, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 85, 115, 101, 32,
    110, 101, 119, 32, 114, 101, 110, 100, 101, 114, 32, 112, 97, 115, 115, 101, 115, 34, 44, 32, 34, 84, 97, 103, 115,
    34, 58, 32, 91, 34, 82, 101, 110, 100, 101, 114, 32, 80, 97, 115, 115, 101, 115, 34, 93, 44, 32, 34, 68, 101, 102,
    97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 116, 114, 117, 101, 125,
    44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101,
    34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32,
    34, 114, 101, 110, 100, 101, 114, 80, 97, 115, 115, 78, 101, 119, 69, 110, 97, 98, 108, 101, 34, 44, 32, 34, 72, 97,
    115, 104, 78, 97, 109, 101, 34, 58, 32, 50, 52, 48, 57, 55, 51, 54, 48, 54, 49, 125, 44, 32, 123, 34, 78, 97, 109,
    101, 34, 58, 32, 34, 82, 101, 110, 100, 101, 114, 80, 97, 115, 115, 76, 111, 103, 69, 110, 97, 98, 108, 101, 34, 44,
    32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 87, 114, 105, 116, 101, 32, 97, 32,
    103, 114, 97, 112, 104, 32, 118, 105, 115, 117, 97, 108, 105, 122, 97, 116, 105, 111, 110, 32, 111, 102, 32, 101,
    97, 99, 104, 32, 99, 114, 101, 97, 116, 101, 100, 32, 114, 101, 110, 100, 101, 114, 32, 112, 97, 115, 115, 32, 105,
    110, 32, 46, 100, 111, 116, 32, 102, 111, 114, 109, 97, 116, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34,
    82, 101, 110, 100, 101, 114, 32, 80, 97, 115, 115, 101, 115, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116,
    115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115, 101, 125, 44, 32, 34, 83,
    99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34,
    98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 114, 101,
    110, 100, 101, 114, 80, 97, 115, 115, 76, 111, 103, 69, 110, 97, 98, 108, 101, 34, 44, 32, 34, 72, 97, 115, 104, 78,
    97, 109, 101, 34, 58, 32, 51, 56, 52, 55, 51, 53, 53, 49, 50, 49, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58,
    32, 34, 82, 101, 110, 100, 101, 114, 80, 97, 115, 115, 76, 111, 103, 68, 105, 114, 101, 99, 116, 111, 114, 121, 34,
    44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 82, 101, 108, 97, 116, 105, 118,
    101, 32, 100, 105, 114, 101, 99, 116, 111, 114, 121, 32, 119, 104, 101, 114, 101, 32, 114, 101, 110, 100, 101, 114,
    32, 112, 97, 115, 115, 32, 103, 114, 97, 112, 104, 115, 32, 97, 114, 101, 32, 112, 108, 97, 99, 101, 100, 46, 32,
    82, 111, 111, 116, 32, 100, 105, 114, 101, 99, 116, 111, 114, 121, 32, 105, 115, 32, 100, 101, 116, 101, 114, 109,
    105, 110, 101, 100, 32, 105, 110, 32, 100, 101, 118, 105, 99, 101, 46, 32, 69, 97, 99, 104, 32, 117, 110, 105, 113,
    117, 101, 32, 114, 101, 110, 100, 101, 114, 32, 112, 97, 115, 115, 32, 105, 115, 32, 105, 110, 32, 97, 32, 115, 101,
    112, 97, 114, 97, 116, 101, 32, 102, 105, 108, 101, 32, 119, 105, 116, 104, 105, 110, 32, 116, 104, 97, 116, 32,
    100, 105, 114, 101, 99, 116, 111, 114, 121, 46, 32, 84, 104, 101, 32, 108, 111, 103, 32, 110, 97, 109, 101, 32, 105,
    115, 32, 98, 97, 115, 101, 100, 32, 111, 110, 32, 97, 32, 104, 97, 115, 104, 32, 111, 102, 32, 116, 104, 101, 32,
    114, 101, 110, 100, 101, 114, 32, 112, 97, 115, 115, 39, 115, 32, 99, 114, 101, 97, 116, 101, 32, 105, 110, 102,
    111, 46, 32, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 82, 101, 110, 100, 101, 114, 32, 80, 97, 115,
    115, 101, 115, 34, 93, 44, 32, 34, 70, 108, 97, 103, 115, 34, 58, 32, 123, 34, 73, 115, 80, 97, 116, 104, 34, 58,
    32, 116, 114, 117, 101, 125, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102,
    97, 117, 108, 116, 34, 58, 32, 34, 97, 109, 100, 112, 97, 108, 47, 34, 44, 32, 34, 87, 105, 110, 68, 101, 102, 97,
    117, 108, 116, 34, 58, 32, 34, 86, 117, 108, 107, 97, 110, 82, 101, 110, 100, 101, 114, 80, 97, 115, 115, 101, 115,
    92, 92, 34, 44, 32, 34, 76, 110, 120, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 34, 97, 109, 100, 112, 97, 108,
    47, 34, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84,
    121, 112, 101, 34, 58, 32, 34, 115, 116, 114, 105, 110, 103, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78,
    97, 109, 101, 34, 58, 32, 34, 114, 101, 110, 100, 101, 114, 80, 97, 115, 115, 76, 111, 103, 68, 105, 114, 101, 99,
    116, 111, 114, 121, 34, 44, 32, 34, 83, 105, 122, 101, 34, 58, 32, 53, 49, 50, 44, 32, 34, 72, 97, 115, 104, 78, 97,
    109, 101, 34, 58, 32, 50, 51, 48, 56, 57, 49, 56, 50, 52, 49, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32,
    34, 82, 101, 110, 100, 101, 114, 80, 97, 115, 115, 76, 111, 103, 70, 108, 97, 103, 115, 34, 44, 32, 34, 68, 101,
    115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 65, 32, 98, 105, 116, 109, 97, 115, 107, 32, 111, 102,
    32, 102, 108, 97, 103, 115, 32, 116, 104, 97, 116, 32, 99, 111, 110, 116, 114, 111, 108, 32, 119, 104, 97, 116, 32,
    107, 105, 110, 100, 32, 111, 102, 32, 105, 110, 102, 111, 114, 109, 97, 116, 105, 111, 110, 32, 105, 115, 32, 119,
    114, 105, 116, 116, 101, 110, 32, 116, 111, 32, 116, 104, 101, 32, 114, 101, 110, 100, 101, 114, 32, 112, 97, 115,
    115, 32, 108, 111, 103, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 82, 101, 110, 100, 101, 114, 32,
    80, 97, 115, 115, 101, 115, 34, 93, 44, 32, 34, 70, 108, 97, 103, 115, 34, 58, 32, 123, 34, 73, 115, 72, 101, 120,
    34, 58, 32, 116, 114, 117, 101, 44, 32, 34, 73, 115, 66, 105, 116, 109, 97, 115, 107, 34, 58, 32, 116, 114, 117,
    101, 125, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116,
    34, 58, 32, 52, 50, 57, 52, 57, 54, 55, 50, 57, 53, 125, 44, 32, 34, 86, 97, 108, 105, 100, 86, 97, 108, 117, 101,
    115, 34, 58, 32, 123, 34, 86, 97, 108, 117, 101, 115, 34, 58, 32, 91, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116,
    105, 111, 110, 34, 58, 32, 34, 73, 110, 99, 108, 117, 100, 101, 32, 114, 101, 110, 100, 101, 114, 32, 103, 114, 97,
    112, 104, 46, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114,
    105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 73, 110, 99, 108, 117, 100, 101, 32, 99, 111, 109, 109, 97, 110, 100,
    32, 108, 105, 115, 116, 46, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 50, 125, 44, 32, 123, 34, 68, 101,
    115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 73, 110, 99, 108, 117, 100, 101, 32, 111, 114, 105, 103,
    105, 110, 97, 108, 32, 86, 107, 83, 117, 98, 112, 97, 115, 115, 68, 101, 112, 101, 110, 100, 101, 110, 99, 121, 32,
    101, 100, 103, 101, 115, 46, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 52, 125, 44, 32, 123, 34, 68, 101,
    115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 73, 110, 99, 108, 117, 100, 101, 32, 119, 97, 105, 116,
    115, 32, 97, 110, 100, 32, 115, 105, 103, 110, 97, 108, 32, 101, 118, 101, 110, 116, 32, 105, 110, 102, 111, 46, 34,
    44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 56, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105,
    111, 110, 34, 58, 32, 34, 73, 110, 99, 108, 117, 100, 101, 32, 99, 97, 99, 104, 101, 47, 108, 97, 121, 111, 117,
    116, 32, 115, 121, 110, 99, 104, 114, 111, 110, 105, 122, 97, 116, 105, 111, 110, 32, 105, 110, 102, 111, 46, 34,
    44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 54, 125, 93, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32,
    34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34,
    44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 114, 101, 110, 100, 101, 114, 80,
    97, 115, 115, 76, 111, 103, 70, 108, 97, 103, 115, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32,
    50, 56, 52, 49, 53, 52, 54, 56, 49, 51, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110,
    34, 58, 32, 34, 73, 102, 32, 116, 114, 117, 101, 44, 32, 102, 111, 114, 99, 101, 115, 32, 97, 32, 102, 117, 108,
    108, 32, 112, 105, 112, 101, 108, 105, 110, 101, 32, 105, 100, 108, 101, 32, 98, 101, 116, 119, 101, 101, 110, 32,
    101, 97, 99, 104, 32, 110, 111, 100, 101, 32, 114, 97, 116, 104, 101, 114, 32, 116, 104, 97, 110, 32, 114, 101, 108,
    121, 105, 110, 103, 32, 111, 110, 32, 71, 80, 85, 32, 101, 118, 101, 110, 116, 115, 46, 34, 44, 32, 34, 84, 97, 103,
    115, 34, 58, 32, 91, 34, 82, 101, 110, 100, 101, 114, 32, 80, 97, 115, 115, 101, 115, 34, 93, 44, 32, 34, 68, 101,
    102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115,
    101, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121,
    112, 101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101,
    34, 58, 32, 34, 114, 101, 110, 100, 101, 114, 80, 97, 115, 115, 70, 111, 114, 99, 101, 87, 97, 105, 116, 73, 100,
    108, 101, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 82, 101, 110, 100, 101, 114, 80, 97, 115, 115, 70, 111,
    114, 99, 101, 87, 97, 105, 116, 73, 100, 108, 101, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32,
    50, 54, 57, 50, 57, 52, 51, 48, 54, 56, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110,
    34, 58, 32, 34, 73, 102, 32, 110, 111, 110, 45, 122, 101, 114, 111, 44, 32, 116, 104, 101, 32, 102, 111, 108, 108,
    111, 119, 105, 110, 103, 32, 105, 110, 112, 117, 116, 47, 111, 117, 116, 112, 117, 116, 32, 99, 97, 99, 104, 101,
    115, 32, 97, 114, 101, 32, 97, 108, 119, 97, 121, 115, 32, 102, 111, 114, 99, 101, 45, 102, 108, 117, 115, 104, 101,
    100, 32, 98, 101, 116, 119, 101, 101, 110, 32, 101, 97, 99, 104, 32, 110, 111, 100, 101, 46, 34, 44, 32, 34, 84, 97,
    103, 115, 34, 58, 32, 91, 34, 82, 101, 110, 100, 101, 114, 32, 80, 97, 115, 115, 101, 115, 34, 93, 44, 32, 34, 68,
    101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 48, 125, 44, 32,
    34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58,
    32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58,
    32, 34, 114, 101, 110, 100, 101, 114, 80, 97, 115, 115, 70, 111, 114, 99, 101, 67, 97, 99, 104, 101, 73, 110, 112,
    117, 116, 67, 111, 104, 101, 114, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 82, 101, 110, 100, 101, 114, 80,
    97, 115, 115, 70, 111, 114, 99, 101, 67, 97, 99, 104, 101, 73, 110, 112, 117, 116, 67, 111, 104, 101, 114, 34, 44,
    32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 51, 53, 49, 50, 56, 48, 51, 51, 52, 50, 125, 44, 32, 123,
    34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 73, 102, 32, 110, 111, 110, 45, 122, 101,
    114, 111, 44, 32, 116, 104, 101, 32, 102, 111, 108, 108, 111, 119, 105, 110, 103, 32, 105, 110, 112, 117, 116, 47,
    111, 117, 116, 112, 117, 116, 32, 99, 97, 99, 104, 101, 115, 32, 97, 114, 101, 32, 97, 108, 119, 97, 121, 115, 32,
    102, 111, 114, 99, 101, 45, 102, 108, 117, 115, 104, 101, 100, 32, 98, 101, 116, 119, 101, 101, 110, 32, 101, 97,
    99, 104, 32, 110, 111, 100, 101, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 82, 101, 110, 100, 101,
    114, 32, 80, 97, 115, 115, 101, 115, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34,
    68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 48, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114,
    105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34,
    86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 114, 101, 110, 100, 101, 114, 80, 97, 115,
    115, 70, 111, 114, 99, 101, 67, 97, 99, 104, 101, 79, 117, 116, 112, 117, 116, 67, 111, 104, 101, 114, 34, 44, 32,
    34, 78, 97, 109, 101, 34, 58, 32, 34, 82, 101, 110, 100, 101, 114, 80, 97, 115, 115, 70, 111, 114, 99, 101, 67, 97,
    99, 104, 101, 79, 117, 116, 112, 117, 116, 67, 111, 104, 101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109,
    101, 34, 58, 32, 52, 48, 55, 48, 50, 56, 54, 57, 51, 57, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116,
    105, 111, 110, 34, 58, 32, 34, 85, 115, 101, 32, 97, 115, 121, 110, 99, 104, 114, 111, 110, 111, 117, 115, 32, 71,
    80, 85, 32, 101, 118, 101, 110, 116, 115, 32, 116, 111, 32, 119, 97, 105, 116, 32, 98, 101, 116, 119, 101, 101, 110,
    32, 115, 116, 101, 112, 115, 32, 111, 102, 32, 97, 32, 114, 101, 110, 100, 101, 114, 112, 97, 115, 115, 32, 105,
    110, 115, 116, 97, 110, 99, 101, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 82, 101, 110, 100, 101,
    114, 32, 80, 97, 115, 115, 101, 115, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34,
    68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115, 101, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58,
    32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44,
    32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 114, 101, 110, 100, 101, 114, 80, 97,
    115, 115, 65, 115, 121, 110, 99, 69, 118, 101, 110, 116, 69, 110, 97, 98, 108, 101, 34, 44, 32, 34, 78, 97, 109,
    101, 34, 58, 32, 34, 82, 101, 110, 100, 101, 114, 80, 97, 115, 115, 65, 115, 121, 110, 99, 69, 118, 101, 110, 116,
    69, 110, 97, 98, 108, 101, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 51, 52, 50, 49, 49, 53,
    55, 55, 53, 53, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 77, 105,
    110, 105, 109, 117, 109, 32, 110, 117, 109, 98, 101, 114, 32, 111, 102, 32, 71, 80, 85, 32, 101, 118, 101, 110, 116,
    115, 32, 116, 111, 32, 97, 108, 108, 111, 99, 97, 116, 101, 32, 97, 116, 32, 111, 110, 99, 101, 32, 98, 121, 32,
    116, 104, 101, 32, 99, 111, 109, 109, 97, 110, 100, 32, 98, 117, 102, 102, 101, 114, 32, 71, 80, 85, 32, 101, 118,
    101, 110, 116, 32, 109, 97, 110, 97, 103, 101, 114, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 67,
    111, 109, 109, 97, 110, 100, 32, 66, 117, 102, 102, 101, 114, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32,
    34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 49, 50,
    56, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121,
    112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97,
    109, 101, 34, 58, 32, 34, 99, 109, 100, 66, 117, 102, 71, 112, 117, 69, 118, 101, 110, 116, 77, 105, 110, 65, 108,
    108, 111, 99, 67, 111, 117, 110, 116, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 67, 109, 100, 66, 117, 102,
    71, 112, 117, 69, 118, 101, 110, 116, 77, 105, 110, 65, 108, 108, 111, 99, 67, 111, 117, 110, 116, 34, 44, 32, 34,
    72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 49, 51, 55, 51, 57, 55, 50, 53, 49, 52, 125, 44, 32, 123, 34, 68,
    101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 85, 115, 101, 32, 115, 104, 97, 114, 101, 100, 32,
    67, 109, 100, 65, 108, 108, 111, 99, 97, 116, 111, 114, 32, 102, 111, 114, 32, 97, 108, 108, 32, 99, 111, 109, 109,
    97, 110, 100, 32, 98, 117, 102, 102, 101, 114, 115, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 67,
    111, 109, 109, 97, 110, 100, 32, 66, 117, 102, 102, 101, 114, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32,
    34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 116,
    114, 117, 101, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34,
    84, 121, 112, 101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97,
    109, 101, 34, 58, 32, 34, 117, 115, 101, 83, 104, 97, 114, 101, 100, 67, 109, 100, 65, 108, 108, 111, 99, 97, 116,
    111, 114, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 85, 115, 101, 83, 104, 97, 114, 101, 100, 67, 109, 100,
    65, 108, 108, 111, 99, 97, 116, 111, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 50, 54,
    57, 53, 55, 50, 50, 57, 53, 50, 125, 44, 32, 123, 34, 86, 97, 108, 105, 100, 86, 97, 108, 117, 101, 115, 34, 58, 32,
    123, 34, 86, 97, 108, 117, 101, 115, 34, 58, 32, 91, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 71, 112, 117, 72,
    101, 97, 112, 76, 111, 99, 97, 108, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 48, 125, 44, 32, 123, 34, 78,
    97, 109, 101, 34, 58, 32, 34, 71, 112, 117, 72, 101, 97, 112, 73, 110, 118, 105, 115, 105, 98, 108, 101, 34, 44, 32,
    34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58,
    32, 34, 84, 104, 105, 115, 32, 105, 115, 32, 105, 110, 118, 97, 108, 105, 100, 33, 32, 65, 108, 108, 111, 99, 97,
    116, 105, 111, 110, 115, 32, 109, 117, 115, 116, 32, 98, 101, 32, 109, 97, 112, 112, 97, 98, 108, 101, 34, 125, 44,
    32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 71, 112, 117, 72, 101, 97, 112, 71, 97, 114, 116, 85, 115, 119, 99,
    34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 50, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 71,
    112, 117, 72, 101, 97, 112, 71, 97, 114, 116, 67, 97, 99, 104, 101, 97, 98, 108, 101, 34, 44, 32, 34, 86, 97, 108,
    117, 101, 34, 58, 32, 51, 125, 93, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 80, 97, 108, 58, 58, 71, 112, 117,
    72, 101, 97, 112, 34, 125, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 84, 104,
    101, 32, 112, 114, 105, 109, 97, 114, 121, 32, 104, 101, 97, 112, 32, 102, 111, 114, 32, 116, 104, 101, 32, 105,
    110, 116, 101, 114, 110, 97, 108, 32, 67, 109, 100, 65, 108, 108, 111, 99, 97, 116, 111, 114, 32, 102, 111, 114, 32,
    99, 111, 109, 109, 97, 110, 100, 32, 100, 97, 116, 97, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 67,
    111, 109, 109, 97, 110, 100, 32, 66, 117, 102, 102, 101, 114, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32,
    34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 34, 80,
    97, 108, 58, 58, 71, 112, 117, 72, 101, 97, 112, 71, 97, 114, 116, 67, 97, 99, 104, 101, 97, 98, 108, 101, 34, 125,
    44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101,
    34, 58, 32, 34, 101, 110, 117, 109, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58,
    32, 34, 99, 109, 100, 65, 108, 108, 111, 99, 97, 116, 111, 114, 68, 97, 116, 97, 72, 101, 97, 112, 34, 44, 32, 34,
    78, 97, 109, 101, 34, 58, 32, 34, 67, 109, 100, 65, 108, 108, 111, 99, 97, 116, 111, 114, 68, 97, 116, 97, 72, 101,
    97, 112, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 49, 56, 51, 50, 54, 57, 52, 55, 49, 52,
    125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 83, 105, 122, 101, 32,
    111, 102, 32, 97, 108, 108, 111, 99, 97, 116, 105, 111, 110, 32, 99, 104, 117, 110, 107, 115, 32, 117, 115, 101,
    100, 32, 98, 121, 32, 67, 109, 100, 65, 108, 108, 111, 99, 97, 116, 111, 114, 115, 32, 102, 111, 114, 32, 99, 111,
    109, 109, 97, 110, 100, 32, 100, 97, 116, 97, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 67, 111,
    109, 109, 97, 110, 100, 32, 66, 117, 102, 102, 101, 114, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34,
    68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 50, 48, 57,
    55, 49, 53, 50, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34,
    84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101,
    78, 97, 109, 101, 34, 58, 32, 34, 99, 109, 100, 65, 108, 108, 111, 99, 97, 116, 111, 114, 68, 97, 116, 97, 65, 108,
    108, 111, 99, 83, 105, 122, 101, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 67, 109, 100, 65, 108, 108, 111,
    99, 97, 116, 111, 114, 68, 97, 116, 97, 65, 108, 108, 111, 99, 83, 105, 122, 101, 34, 44, 32, 34, 72, 97, 115, 104,
    78, 97, 109, 101, 34, 58, 32, 50, 54, 54, 55, 55, 54, 49, 49, 48, 52, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114,
    105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 83, 105, 122, 101, 32, 111, 102, 32, 115, 117, 98, 97, 108, 108, 111,
    99, 97, 116, 105, 111, 110, 115, 32, 117, 115, 101, 100, 32, 98, 121, 32, 67, 109, 100, 65, 108, 108, 111, 99, 97,
    116, 111, 114, 115, 32, 102, 111, 114, 32, 99, 111, 109, 109, 97, 110, 100, 32, 100, 97, 116, 97, 46, 34, 44, 32,
    34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 67, 111, 109, 109, 97, 110, 100, 32, 66, 117, 102, 102, 101, 114, 32, 79,
    112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68,
    101, 102, 97, 117, 108, 116, 34, 58, 32, 54, 53, 53, 51, 54, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34,
    68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44,
    32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 99, 109, 100, 65, 108, 108, 111, 99,
    97, 116, 111, 114, 68, 97, 116, 97, 83, 117, 98, 65, 108, 108, 111, 99, 83, 105, 122, 101, 34, 44, 32, 34, 78, 97,
    109, 101, 34, 58, 32, 34, 67, 109, 100, 65, 108, 108, 111, 99, 97, 116, 111, 114, 68, 97, 116, 97, 83, 117, 98, 65,
    108, 108, 111, 99, 83, 105, 122, 101, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 52, 48, 56,
    57, 53, 56, 56, 57, 57, 56, 125, 44, 32, 123, 34, 86, 97, 108, 105, 100, 86, 97, 108, 117, 101, 115, 34, 58, 32,
    123, 34, 86, 97, 108, 117, 101, 115, 34, 58, 32, 91, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 71, 112, 117, 72,
    101, 97, 112, 76, 111, 99, 97, 108, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 48, 125, 44, 32, 123, 34, 78,
    97, 109, 101, 34, 58, 32, 34, 71, 112, 117, 72, 101, 97, 112, 73, 110, 118, 105, 115, 105, 98, 108, 101, 34, 44, 32,
    34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58,
    32, 34, 84, 104, 105, 115, 32, 105, 115, 32, 105, 110, 118, 97, 108, 105, 100, 33, 32, 65, 108, 108, 111, 99, 97,
    116, 105, 111, 110, 115, 32, 109, 117, 115, 116, 32, 98, 101, 32, 109, 97, 112, 112, 97, 98, 108, 101, 34, 125, 44,
    32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 71, 112, 117, 72, 101, 97, 112, 71, 97, 114, 116, 85, 115, 119, 99,
    34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 50, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 71,
    112, 117, 72, 101, 97, 112, 71, 97, 114, 116, 67, 97, 99, 104, 101, 97, 98, 108, 101, 34, 44, 32, 34, 86, 97, 108,
    117, 101, 34, 58, 32, 51, 125, 93, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 80, 97, 108, 58, 58, 71, 112, 117,
    72, 101, 97, 112, 34, 125, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 84, 104,
    101, 32, 112, 114, 105, 109, 97, 114, 121, 32, 104, 101, 97, 112, 32, 102, 111, 114, 32, 116, 104, 101, 32, 105,
    110, 116, 101, 114, 110, 97, 108, 32, 67, 109, 100, 65, 108, 108, 111, 99, 97, 116, 111, 114, 32, 102, 111, 114, 32,
    101, 109, 98, 101, 100, 100, 101, 100, 32, 100, 97, 116, 97, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91,
    34, 67, 111, 109, 109, 97, 110, 100, 32, 66, 117, 102, 102, 101, 114, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93,
    44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32,
    34, 80, 97, 108, 58, 58, 71, 112, 117, 72, 101, 97, 112, 71, 97, 114, 116, 85, 115, 119, 99, 34, 125, 44, 32, 34,
    83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32,
    34, 101, 110, 117, 109, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 99,
    109, 100, 65, 108, 108, 111, 99, 97, 116, 111, 114, 69, 109, 98, 101, 100, 100, 101, 100, 72, 101, 97, 112, 34, 44,
    32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 67, 109, 100, 65, 108, 108, 111, 99, 97, 116, 111, 114, 69, 109, 98, 101,
    100, 100, 101, 100, 72, 101, 97, 112, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 52, 54, 49,
    55, 52, 53, 52, 48, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 67, 109, 100, 65, 108, 108, 111, 99, 97,
    116, 111, 114, 69, 109, 98, 101, 100, 100, 101, 100, 65, 108, 108, 111, 99, 83, 105, 122, 101, 34, 44, 32, 34, 68,
    101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 83, 105, 122, 101, 32, 111, 102, 32, 97, 108, 108,
    111, 99, 97, 116, 105, 111, 110, 32, 99, 104, 117, 110, 107, 115, 32, 117, 115, 101, 100, 32, 98, 121, 32, 67, 109,
    100, 65, 108, 108, 111, 99, 97, 116, 111, 114, 115, 32, 102, 111, 114, 32, 101, 109, 98, 101, 100, 100, 101, 100,
    32, 100, 97, 116, 97, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 67, 111, 109, 109, 97, 110, 100, 32, 66,
    117, 102, 102, 101, 114, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116,
    115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 49, 51, 49, 48, 55, 50, 125, 44, 32, 34, 84,
    121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 70, 108, 97, 103, 115, 34, 58, 32, 123,
    34, 73, 115, 72, 101, 120, 34, 58, 32, 116, 114, 117, 101, 125, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78,
    97, 109, 101, 34, 58, 32, 34, 99, 109, 100, 65, 108, 108, 111, 99, 97, 116, 111, 114, 69, 109, 98, 101, 100, 100,
    101, 100, 65, 108, 108, 111, 99, 83, 105, 122, 101, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114,
    105, 118, 101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 52, 48, 52, 57, 57, 52, 53, 54,
    54, 50, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 67, 109, 100, 65, 108, 108, 111, 99, 97, 116, 111,
    114, 69, 109, 98, 101, 100, 100, 101, 100, 83, 117, 98, 65, 108, 108, 111, 99, 83, 105, 122, 101, 34, 44, 32, 34,
    68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 83, 105, 122, 101, 32, 111, 102, 32, 115, 117,
    98, 97, 108, 108, 111, 99, 97, 116, 105, 111, 110, 115, 32, 117, 115, 101, 100, 32, 98, 121, 32, 67, 109, 100, 65,
    108, 108, 111, 99, 97, 116, 111, 114, 115, 32, 102, 111, 114, 32, 101, 109, 98, 101, 100, 100, 101, 100, 32, 100,
    97, 116, 97, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 67, 111, 109, 109, 97, 110, 100, 32, 66, 117,
    102, 102, 101, 114, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115,
    34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 49, 54, 51, 56, 52, 125, 44, 32, 34, 84, 121, 112,
    101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 70, 108, 97, 103, 115, 34, 58, 32, 123, 34, 73,
    115, 72, 101, 120, 34, 58, 32, 116, 114, 117, 101, 125, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109,
    101, 34, 58, 32, 34, 99, 109, 100, 65, 108, 108, 111, 99, 97, 116, 111, 114, 69, 109, 98, 101, 100, 100, 101, 100,
    83, 117, 98, 65, 108, 108, 111, 99, 83, 105, 122, 101, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68,
    114, 105, 118, 101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 49, 53, 49, 51, 49, 50, 55,
    53, 49, 50, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 67, 109, 100, 65, 108, 108, 111, 99, 97, 116,
    111, 114, 83, 99, 114, 97, 116, 99, 104, 72, 101, 97, 112, 34, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116,
    105, 111, 110, 34, 58, 32, 34, 84, 104, 101, 32, 112, 114, 105, 109, 97, 114, 121, 32, 104, 101, 97, 112, 32, 102,
    111, 114, 32, 116, 104, 101, 32, 105, 110, 116, 101, 114, 110, 97, 108, 32, 67, 109, 100, 65, 108, 108, 111, 99, 97,
    116, 111, 114, 32, 102, 111, 114, 32, 71, 80, 85, 32, 115, 99, 114, 97, 116, 99, 104, 32, 109, 101, 109, 111, 114,
    121, 46, 32, 78, 111, 116, 101, 58, 32, 116, 104, 105, 115, 32, 102, 105, 101, 108, 100, 32, 105, 115, 32, 105, 103,
    110, 111, 114, 101, 100, 32, 98, 121, 32, 80, 65, 76, 32, 97, 110, 100, 32, 119, 105, 108, 108, 32, 97, 108, 119,
    97, 121, 115, 32, 98, 101, 32, 71, 112, 117, 72, 101, 97, 112, 73, 110, 118, 105, 115, 105, 98, 108, 101, 46, 34,
    44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 67, 111, 109, 109, 97, 110, 100, 32, 66, 117, 102, 102, 101, 114,
    32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34,
    68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 34, 80, 97, 108, 58, 58, 71, 112, 117, 72, 101, 97, 112, 73, 110, 118,
    105, 115, 105, 98, 108, 101, 34, 125, 44, 32, 34, 86, 97, 108, 105, 100, 86, 97, 108, 117, 101, 115, 34, 58, 32,
    123, 34, 86, 97, 108, 117, 101, 115, 34, 58, 32, 91, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 71, 112, 117, 72,
    101, 97, 112, 76, 111, 99, 97, 108, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 48, 125, 44, 32, 123, 34, 78,
    97, 109, 101, 34, 58, 32, 34, 71, 112, 117, 72, 101, 97, 112, 73, 110, 118, 105, 115, 105, 98, 108, 101, 34, 44, 32,
    34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 71, 112, 117, 72,
    101, 97, 112, 71, 97, 114, 116, 85, 115, 119, 99, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 50, 125, 44,
    32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 71, 112, 117, 72, 101, 97, 112, 71, 97, 114, 116, 67, 97, 99, 104,
    101, 97, 98, 108, 101, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 51, 125, 93, 44, 32, 34, 78, 97, 109, 101,
    34, 58, 32, 34, 80, 97, 108, 58, 58, 71, 112, 117, 72, 101, 97, 112, 34, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34,
    58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 101, 110, 117, 109, 34,
    44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 99, 109, 100, 65, 108, 108, 111,
    99, 97, 116, 111, 114, 83, 99, 114, 97, 116, 99, 104, 72, 101, 97, 112, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97,
    109, 101, 34, 58, 32, 52, 49, 53, 51, 53, 49, 54, 52, 53, 50, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32,
    34, 67, 109, 100, 65, 108, 108, 111, 99, 97, 116, 111, 114, 83, 99, 114, 97, 116, 99, 104, 65, 108, 108, 111, 99,
    83, 105, 122, 101, 34, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 83, 105,
    122, 101, 32, 111, 102, 32, 97, 108, 108, 111, 99, 97, 116, 105, 111, 110, 32, 99, 104, 117, 110, 107, 115, 32, 117,
    115, 101, 100, 32, 98, 121, 32, 67, 109, 100, 65, 108, 108, 111, 99, 97, 116, 111, 114, 115, 32, 102, 111, 114, 32,
    71, 80, 85, 32, 115, 99, 114, 97, 116, 99, 104, 32, 109, 101, 109, 111, 114, 121, 46, 34, 44, 32, 34, 84, 97, 103,
    115, 34, 58, 32, 91, 34, 67, 111, 109, 109, 97, 110, 100, 32, 66, 117, 102, 102, 101, 114, 32, 79, 112, 116, 105,
    111, 110, 115, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117,
    108, 116, 34, 58, 32, 49, 51, 49, 48, 55, 50, 125, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110,
    116, 51, 50, 34, 44, 32, 34, 70, 108, 97, 103, 115, 34, 58, 32, 123, 34, 73, 115, 72, 101, 120, 34, 58, 32, 116,
    114, 117, 101, 125, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 99, 109, 100,
    65, 108, 108, 111, 99, 97, 116, 111, 114, 83, 99, 114, 97, 116, 99, 104, 65, 108, 108, 111, 99, 83, 105, 122, 101,
    34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 72, 97, 115,
    104, 78, 97, 109, 101, 34, 58, 32, 51, 53, 55, 52, 48, 50, 57, 48, 54, 50, 125, 44, 32, 123, 34, 78, 97, 109, 101,
    34, 58, 32, 34, 67, 109, 100, 65, 108, 108, 111, 99, 97, 116, 111, 114, 83, 99, 114, 97, 116, 99, 104, 83, 117, 98,
    65, 108, 108, 111, 99, 83, 105, 122, 101, 34, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34,
    58, 32, 34, 83, 105, 122, 101, 32, 111, 102, 32, 115, 117, 98, 97, 108, 108, 111, 99, 97, 116, 105, 111, 110, 115,
    32, 117, 115, 101, 100, 32, 98, 121, 32, 67, 109, 100, 65, 108, 108, 111, 99, 97, 116, 111, 114, 115, 32, 102, 111,
    114, 32, 71, 80, 85, 32, 115, 99, 114, 97, 116, 99, 104, 32, 109, 101, 109, 111, 114, 121, 46, 34, 44, 32, 34, 84,
    97, 103, 115, 34, 58, 32, 91, 34, 67, 111, 109, 109, 97, 110, 100, 32, 66, 117, 102, 102, 101, 114, 32, 79, 112,
    116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101,
    102, 97, 117, 108, 116, 34, 58, 32, 49, 54, 51, 56, 52, 125, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117,
    105, 110, 116, 51, 50, 34, 44, 32, 34, 70, 108, 97, 103, 115, 34, 58, 32, 123, 34, 73, 115, 72, 101, 120, 34, 58,
    32, 116, 114, 117, 101, 125, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 99,
    109, 100, 65, 108, 108, 111, 99, 97, 116, 111, 114, 83, 99, 114, 97, 116, 99, 104, 83, 117, 98, 65, 108, 108, 111,
    99, 83, 105, 122, 101, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44,
    32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 51, 52, 48, 50, 52, 52, 52, 56, 52, 56, 125, 44, 32, 123,
    34, 78, 97, 109, 101, 34, 58, 32, 34, 80, 105, 112, 101, 108, 105, 110, 101, 76, 105, 110, 107, 84, 105, 109, 101,
    79, 112, 116, 77, 111, 100, 101, 34, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32,
    34, 67, 111, 110, 116, 114, 111, 108, 115, 32, 104, 111, 119, 32, 80, 65, 76, 39, 115, 32, 108, 105, 110, 107, 45,
    116, 105, 109, 101, 32, 112, 105, 112, 101, 108, 105, 110, 101, 32, 111, 112, 116, 105, 109, 105, 122, 97, 116, 105,
    111, 110, 115, 32, 97, 114, 101, 32, 101, 110, 97, 98, 108, 101, 100, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58,
    32, 91, 34, 80, 105, 112, 101, 108, 105, 110, 101, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 68,
    101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 34, 80, 105,
    112, 101, 108, 105, 110, 101, 76, 105, 110, 107, 84, 105, 109, 101, 79, 112, 116, 65, 112, 105, 67, 111, 110, 116,
    114, 111, 108, 108, 101, 100, 34, 125, 44, 32, 34, 86, 97, 108, 105, 100, 86, 97, 108, 117, 101, 115, 34, 58, 32,
    123, 34, 73, 115, 69, 110, 117, 109, 34, 58, 32, 116, 114, 117, 101, 44, 32, 34, 86, 97, 108, 117, 101, 115, 34, 58,
    32, 91, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 80, 105, 112, 101, 108, 105, 110, 101, 76, 105, 110, 107, 84,
    105, 109, 101, 79, 112, 116, 65, 112, 105, 67, 111, 110, 116, 114, 111, 108, 108, 101, 100, 34, 44, 32, 34, 86, 97,
    108, 117, 101, 34, 58, 32, 48, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 69,
    110, 97, 98, 108, 101, 100, 32, 117, 110, 108, 101, 115, 115, 32, 86, 75, 95, 80, 73, 80, 69, 76, 73, 78, 69, 95,
    67, 82, 69, 65, 84, 69, 95, 68, 73, 83, 65, 66, 76, 69, 95, 79, 80, 84, 73, 77, 73, 90, 65, 84, 73, 79, 78, 95, 66,
    73, 84, 32, 105, 115, 32, 115, 101, 116, 46, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 80, 105,
    112, 101, 108, 105, 110, 101, 76, 105, 110, 107, 84, 105, 109, 101, 79, 112, 116, 65, 108, 119, 97, 121, 115, 69,
    110, 97, 98, 108, 101, 100, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 44, 32, 34, 68, 101, 115, 99,
    114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 79, 112, 116, 105, 109, 105, 122, 97, 116, 105, 111, 110, 115,
    32, 97, 108, 119, 97, 121, 115, 32, 101, 110, 97, 98, 108, 101, 100, 46, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101,
    34, 58, 32, 34, 80, 105, 112, 101, 108, 105, 110, 101, 76, 105, 110, 107, 84, 105, 109, 101, 79, 112, 116, 65, 108,
    119, 97, 121, 115, 68, 105, 115, 97, 98, 108, 101, 100, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 50, 44,
    32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 79, 112, 116, 105, 109, 105, 122, 97,
    116, 105, 111, 110, 115, 32, 97, 108, 119, 97, 121, 115, 32, 100, 105, 115, 97, 98, 108, 101, 100, 46, 34, 125, 93,
    44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 80, 105, 112, 101, 108, 105, 110, 101, 76, 105, 110, 107, 84, 105,
    109, 101, 79, 112, 116, 77, 111, 100, 101, 34, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105,
    118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 101, 110, 117, 109, 34, 44, 32, 34, 86, 97, 114,
    105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 112, 105, 112, 101, 108, 105, 110, 101, 76, 105, 110, 107,
    84, 105, 109, 101, 79, 112, 116, 77, 111, 100, 101, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32,
    51, 54, 48, 54, 52, 54, 49, 50, 48, 56, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 80, 105, 112, 101,
    108, 105, 110, 101, 70, 97, 115, 116, 67, 111, 109, 112, 105, 108, 101, 77, 111, 100, 101, 34, 44, 32, 34, 68, 101,
    115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 67, 111, 110, 116, 114, 111, 108, 115, 32, 104, 111,
    119, 32, 83, 67, 32, 39, 102, 97, 115, 116, 32, 99, 111, 109, 112, 105, 108, 101, 32, 109, 111, 100, 101, 39, 32,
    40, 100, 105, 115, 97, 98, 108, 101, 32, 111, 112, 116, 105, 109, 105, 122, 97, 116, 105, 111, 110, 115, 41, 32,
    105, 115, 32, 101, 110, 97, 98, 108, 101, 100, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 80, 105, 112,
    101, 108, 105, 110, 101, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116,
    115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 34, 80, 105, 112, 101, 108, 105, 110, 101,
    70, 97, 115, 116, 67, 111, 109, 112, 105, 108, 101, 65, 112, 105, 67, 111, 110, 116, 114, 111, 108, 108, 101, 100,
    34, 125, 44, 32, 34, 86, 97, 108, 105, 100, 86, 97, 108, 117, 101, 115, 34, 58, 32, 123, 34, 73, 115, 69, 110, 117,
    109, 34, 58, 32, 116, 114, 117, 101, 44, 32, 34, 86, 97, 108, 117, 101, 115, 34, 58, 32, 91, 123, 34, 78, 97, 109,
    101, 34, 58, 32, 34, 80, 105, 112, 101, 108, 105, 110, 101, 70, 97, 115, 116, 67, 111, 109, 112, 105, 108, 101, 65,
    112, 105, 67, 111, 110, 116, 114, 111, 108, 108, 101, 100, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 48,
    44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 39, 70, 97, 115, 116, 32, 99, 111,
    109, 112, 105, 108, 101, 39, 32, 100, 105, 115, 97, 98, 108, 101, 100, 32, 117, 110, 108, 101, 115, 115, 32, 86, 75,
    95, 80, 73, 80, 69, 76, 73, 78, 69, 95, 67, 82, 69, 65, 84, 69, 95, 68, 73, 83, 65, 66, 76, 69, 95, 79, 80, 84, 73,
    77, 73, 90, 65, 84, 73, 79, 78, 95, 66, 73, 84, 32, 105, 115, 32, 115, 101, 116, 34, 125, 44, 32, 123, 34, 78, 97,
    109, 101, 34, 58, 32, 34, 80, 105, 112, 101, 108, 105, 110, 101, 70, 97, 115, 116, 67, 111, 109, 112, 105, 108, 101,
    65, 108, 119, 97, 121, 115, 70, 97, 115, 116, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 44, 32, 34, 68,
    101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 39, 70, 97, 115, 116, 32, 99, 111, 109, 112, 105,
    108, 101, 39, 32, 97, 108, 119, 97, 121, 115, 32, 101, 110, 97, 98, 108, 101, 100, 32, 40, 100, 105, 115, 97, 98,
    108, 101, 115, 32, 83, 67, 32, 115, 104, 97, 100, 101, 114, 32, 111, 112, 116, 105, 109, 105, 122, 97, 116, 105,
    111, 110, 41, 46, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 80, 105, 112, 101, 108, 105, 110, 101,
    70, 97, 115, 116, 67, 111, 109, 112, 105, 108, 101, 65, 108, 119, 97, 121, 115, 79, 112, 116, 105, 109, 105, 122,
    101, 100, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 50, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116,
    105, 111, 110, 34, 58, 32, 34, 39, 70, 97, 115, 116, 32, 99, 111, 109, 112, 105, 108, 101, 39, 32, 97, 108, 119, 97,
    121, 115, 32, 100, 105, 115, 97, 98, 108, 101, 100, 32, 40, 83, 67, 32, 100, 101, 102, 97, 117, 108, 116, 32, 111,
    112, 116, 105, 109, 105, 122, 97, 116, 105, 111, 110, 115, 32, 101, 110, 97, 98, 108, 101, 100, 41, 46, 34, 125, 93,
    44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 80, 105, 112, 101, 108, 105, 110, 101, 70, 97, 115, 116, 67, 111, 109,
    112, 105, 108, 101, 77, 111, 100, 101, 34, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105,
    118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 101, 110, 117, 109, 34, 44, 32, 34, 86, 97, 114,
    105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 112, 105, 112, 101, 108, 105, 110, 101, 70, 97, 115, 116,
    67, 111, 109, 112, 105, 108, 101, 77, 111, 100, 101, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32,
    54, 48, 49, 56, 48, 52, 49, 53, 55, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 80, 105, 112, 101, 108,
    105, 110, 101, 66, 105, 110, 110, 105, 110, 103, 77, 111, 100, 101, 34, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112,
    116, 105, 111, 110, 34, 58, 32, 34, 83, 112, 101, 99, 105, 102, 105, 101, 115, 32, 119, 104, 101, 116, 104, 101,
    114, 32, 116, 111, 32, 111, 118, 101, 114, 114, 105, 100, 101, 32, 98, 105, 110, 110, 105, 110, 103, 32, 115, 101,
    116, 116, 105, 110, 103, 32, 102, 111, 114, 32, 112, 105, 112, 101, 108, 105, 110, 101, 46, 34, 44, 32, 34, 84, 97,
    103, 115, 34, 58, 32, 91, 34, 80, 105, 112, 101, 108, 105, 110, 101, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93,
    44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32,
    34, 80, 105, 112, 101, 108, 105, 110, 101, 66, 105, 110, 110, 105, 110, 103, 77, 111, 100, 101, 68, 101, 102, 97,
    117, 108, 116, 34, 125, 44, 32, 34, 86, 97, 108, 105, 100, 86, 97, 108, 117, 101, 115, 34, 58, 32, 123, 34, 86, 97,
    108, 117, 101, 115, 34, 58, 32, 91, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 80, 105, 112, 101, 108, 105, 110,
    101, 66, 105, 110, 110, 105, 110, 103, 77, 111, 100, 101, 68, 101, 102, 97, 117, 108, 116, 34, 44, 32, 34, 86, 97,
    108, 117, 101, 34, 58, 32, 48, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 39,
    68, 101, 102, 97, 117, 108, 116, 39, 32, 102, 111, 108, 108, 111, 119, 115, 32, 116, 104, 101, 32, 80, 66, 66, 32,
    103, 108, 111, 98, 97, 108, 32, 115, 101, 116, 116, 105, 110, 103, 46, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101,
    34, 58, 32, 34, 80, 105, 112, 101, 108, 105, 110, 101, 66, 105, 110, 110, 105, 110, 103, 77, 111, 100, 101, 68, 105,
    115, 97, 98, 108, 101, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 44, 32, 34, 68, 101, 115, 99, 114,
    105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 39, 68, 105, 115, 97, 98, 108, 101, 39, 32, 100, 105, 115, 97, 98,
    108, 101, 115, 32, 112, 105, 112, 101, 108, 105, 110, 101, 32, 98, 105, 110, 110, 105, 110, 103, 46, 34, 125, 44,
    32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 80, 105, 112, 101, 108, 105, 110, 101, 66, 105, 110, 110, 105, 110,
    103, 77, 111, 100, 101, 69, 110, 97, 98, 108, 101, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 50, 44, 32,
    34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 39, 69, 110, 97, 98, 108, 101, 39, 32, 101,
    110, 97, 98, 108, 101, 115, 32, 112, 105, 112, 101, 108, 105, 110, 101, 32, 98, 105, 110, 110, 105, 110, 103, 46,
    34, 125, 93, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 80, 105, 112, 101, 108, 105, 110, 101, 66, 105, 110, 110,
    105, 110, 103, 77, 111, 100, 101, 34, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118,
    101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 101, 110, 117, 109, 34, 44, 32, 34, 86, 97, 114, 105,
    97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 112, 105, 112, 101, 108, 105, 110, 101, 66, 105, 110, 110, 105,
    110, 103, 77, 111, 100, 101, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 49, 57, 54, 55, 52, 50,
    55, 56, 51, 55, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 80, 105, 112, 101, 108, 105, 110, 101, 85,
    115, 101, 80, 114, 111, 102, 105, 108, 101, 72, 97, 115, 104, 65, 115, 67, 108, 105, 101, 110, 116, 72, 97, 115,
    104, 34, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 73, 102, 32, 116, 114,
    117, 101, 44, 32, 116, 104, 101, 32, 112, 114, 111, 102, 105, 108, 101, 32, 104, 97, 115, 104, 32, 40, 99, 97, 108,
    99, 117, 108, 97, 116, 101, 100, 32, 101, 120, 99, 108, 117, 115, 105, 118, 101, 108, 121, 32, 102, 114, 111, 109,
    32, 83, 80, 73, 82, 86, 32, 43, 32, 101, 110, 116, 114, 121, 32, 112, 111, 105, 110, 116, 41, 32, 105, 115, 32, 117,
    115, 101, 100, 32, 97, 115, 32, 80, 65, 76, 32, 99, 108, 105, 101, 110, 116, 32, 104, 97, 115, 104, 32, 97, 110,
    100, 32, 119, 105, 108, 108, 32, 97, 112, 112, 101, 97, 114, 32, 105, 110, 32, 101, 46, 103, 46, 32, 71, 80, 85, 80,
    114, 111, 102, 105, 108, 101, 114, 32, 108, 97, 121, 101, 114, 32, 109, 101, 97, 115, 117, 114, 101, 109, 101, 110,
    116, 115, 46, 32, 32, 85, 115, 101, 102, 117, 108, 32, 119, 104, 101, 110, 32, 119, 114, 105, 116, 105, 110, 103,
    32, 97, 110, 100, 32, 117, 112, 100, 97, 116, 105, 110, 103, 32, 112, 105, 112, 101, 108, 105, 110, 101, 32, 112,
    114, 111, 102, 105, 108, 101, 115, 32, 102, 111, 114, 32, 97, 112, 112, 108, 105, 99, 97, 116, 105, 111, 110, 115,
    46, 32, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 80, 105, 112, 101, 108, 105, 110, 101, 32, 79, 112,
    116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101,
    102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115, 101, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34,
    68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34,
    86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 112, 105, 112, 101, 108, 105, 110, 101, 85,
    115, 101, 80, 114, 111, 102, 105, 108, 101, 72, 97, 115, 104, 65, 115, 67, 108, 105, 101, 110, 116, 72, 97, 115,
    104, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 51, 51, 56, 52, 49, 54, 53, 54, 52, 52, 125,
    44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 80, 105, 112, 101, 108, 105, 110, 101, 85, 115, 101, 83, 104, 97,
    100, 101, 114, 72, 97, 115, 104, 65, 115, 80, 114, 111, 102, 105, 108, 101, 72, 97, 115, 104, 34, 44, 32, 34, 68,
    101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 73, 102, 32, 116, 114, 117, 101, 44, 32, 116, 104,
    101, 32, 115, 104, 97, 100, 101, 114, 32, 104, 97, 115, 104, 32, 40, 99, 97, 108, 99, 117, 97, 108, 116, 101, 32,
    102, 114, 111, 109, 32, 83, 80, 73, 82, 86, 41, 32, 105, 115, 32, 117, 115, 101, 100, 32, 97, 115, 32, 112, 114,
    111, 102, 105, 108, 101, 32, 104, 97, 115, 104, 46, 32, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 80,
    105, 112, 101, 108, 105, 110, 101, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117,
    108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115, 101, 125, 44,
    32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34,
    58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34,
    112, 105, 112, 101, 108, 105, 110, 101, 85, 115, 101, 83, 104, 97, 100, 101, 114, 72, 97, 115, 104, 65, 115, 80,
    114, 111, 102, 105, 108, 101, 72, 97, 115, 104, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 51,
    57, 48, 49, 55, 51, 48, 51, 50, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 80, 105, 112, 101, 108, 105,
    110, 101, 80, 114, 111, 102, 105, 108, 101, 82, 117, 110, 116, 105, 109, 101, 70, 105, 108, 101, 34, 44, 32, 34, 68,
    101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 80, 97, 116, 104, 32, 116, 111, 32, 97, 32, 74, 83,
    79, 78, 32, 102, 105, 108, 101, 32, 116, 104, 97, 116, 32, 100, 101, 115, 99, 114, 105, 98, 101, 115, 32, 97, 32,
    115, 104, 97, 100, 101, 114, 32, 97, 112, 112, 32, 112, 114, 111, 102, 105, 108, 101, 32, 116, 104, 97, 116, 32,
    105, 115, 32, 112, 97, 114, 115, 101, 100, 32, 97, 116, 32, 114, 117, 110, 116, 105, 109, 101, 46, 32, 32, 84, 104,
    105, 115, 32, 115, 101, 116, 116, 105, 110, 103, 32, 111, 110, 108, 121, 32, 116, 114, 105, 103, 103, 101, 114, 115,
    32, 111, 110, 32, 100, 101, 98, 117, 103, 32, 98, 117, 105, 108, 100, 115, 32, 111, 114, 32, 98, 117, 105, 108, 100,
    115, 32, 109, 97, 100, 101, 32, 119, 105, 116, 104, 32, 116, 104, 101, 32, 73, 67, 68, 95, 82, 85, 78, 84, 73, 77,
    69, 95, 65, 80, 80, 95, 80, 82, 79, 70, 73, 76, 69, 61, 49, 32, 111, 112, 116, 105, 111, 110, 46, 32, 32, 84, 104,
    105, 115, 32, 102, 105, 108, 101, 32, 104, 97, 115, 32, 116, 104, 101, 32, 115, 97, 109, 101, 32, 102, 111, 114,
    109, 97, 116, 32, 97, 115, 32, 116, 104, 101, 32, 74, 83, 79, 78, 32, 102, 105, 108, 101, 115, 32, 117, 115, 101,
    100, 32, 116, 111, 32, 98, 117, 105, 108, 100, 32, 112, 114, 111, 100, 117, 99, 116, 105, 111, 110, 32, 115, 104,
    97, 100, 101, 114, 32, 97, 112, 112, 32, 112, 114, 111, 102, 105, 108, 101, 115, 46, 34, 44, 32, 34, 84, 97, 103,
    115, 34, 58, 32, 91, 34, 80, 105, 112, 101, 108, 105, 110, 101, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44,
    32, 34, 70, 108, 97, 103, 115, 34, 58, 32, 123, 34, 73, 115, 80, 97, 116, 104, 34, 58, 32, 116, 114, 117, 101, 125,
    44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32,
    34, 34, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84,
    121, 112, 101, 34, 58, 32, 34, 115, 116, 114, 105, 110, 103, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78,
    97, 109, 101, 34, 58, 32, 34, 112, 105, 112, 101, 108, 105, 110, 101, 80, 114, 111, 102, 105, 108, 101, 82, 117,
    110, 116, 105, 109, 101, 70, 105, 108, 101, 34, 44, 32, 34, 83, 105, 122, 101, 34, 58, 32, 53, 49, 50, 44, 32, 34,
    72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 49, 50, 56, 54, 52, 55, 51, 48, 52, 54, 125, 44, 32, 123, 34, 78,
    97, 109, 101, 34, 58, 32, 34, 80, 105, 112, 101, 108, 105, 110, 101, 80, 114, 111, 102, 105, 108, 101, 68, 98, 103,
    80, 114, 105, 110, 116, 80, 114, 111, 102, 105, 108, 101, 77, 97, 116, 99, 104, 34, 44, 32, 34, 68, 101, 115, 99,
    114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 80, 114, 105, 110, 116, 115, 32, 97, 32, 109, 101, 115, 115, 97,
    103, 101, 32, 116, 111, 32, 116, 104, 101, 32, 100, 101, 98, 117, 103, 103, 101, 114, 32, 119, 104, 101, 110, 32,
    97, 32, 112, 105, 112, 101, 108, 105, 110, 101, 32, 112, 114, 111, 102, 105, 108, 101, 32, 109, 97, 116, 99, 104,
    101, 115, 32, 97, 32, 112, 105, 112, 101, 108, 105, 110, 101, 46, 32, 79, 110, 108, 121, 32, 118, 97, 108, 105, 100,
    32, 111, 110, 32, 100, 101, 98, 117, 103, 32, 98, 117, 105, 108, 100, 115, 32, 111, 114, 32, 98, 117, 105, 108, 100,
    115, 32, 98, 117, 105, 108, 116, 32, 119, 105, 116, 104, 32, 80, 65, 76, 95, 69, 78, 65, 66, 76, 69, 95, 80, 82, 73,
    78, 84, 83, 95, 65, 83, 83, 69, 82, 84, 83, 61, 49, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 80,
    105, 112, 101, 108, 105, 110, 101, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117,
    108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115, 101, 125, 44,
    32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34,
    58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34,
    112, 105, 112, 101, 108, 105, 110, 101, 80, 114, 111, 102, 105, 108, 101, 68, 98, 103, 80, 114, 105, 110, 116, 80,
    114, 111, 102, 105, 108, 101, 77, 97, 116, 99, 104, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32,
    51, 53, 55, 56, 52, 49, 48, 55, 51, 54, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 80, 105, 112, 101,
    108, 105, 110, 101, 80, 114, 111, 102, 105, 108, 101, 73, 103, 110, 111, 114, 101, 115, 65, 112, 112, 80, 114, 111,
    102, 105, 108, 101, 34, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 73, 102,
    32, 116, 104, 105, 115, 32, 105, 115, 32, 116, 114, 117, 101, 44, 32, 97, 110, 121, 32, 112, 114, 111, 100, 117, 99,
    116, 105, 111, 110, 32, 97, 112, 112, 32, 112, 114, 111, 102, 105, 108, 101, 45, 105, 110, 115, 116, 97, 108, 108,
    101, 100, 32, 115, 104, 97, 100, 101, 114, 32, 111, 112, 116, 105, 109, 105, 122, 97, 116, 105, 111, 110, 115, 32,
    97, 114, 101, 32, 105, 103, 110, 111, 114, 101, 100, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 80,
    105, 112, 101, 108, 105, 110, 101, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117,
    108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115, 101, 125, 44,
    32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34,
    58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34,
    112, 105, 112, 101, 108, 105, 110, 101, 80, 114, 111, 102, 105, 108, 101, 73, 103, 110, 111, 114, 101, 115, 65, 112,
    112, 80, 114, 111, 102, 105, 108, 101, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 50, 56, 52,
    57, 56, 56, 53, 50, 55, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 80, 105, 112, 101, 108, 105, 110,
    101, 80, 114, 111, 102, 105, 108, 101, 72, 97, 108, 116, 79, 110, 80, 97, 114, 115, 101, 70, 97, 105, 108, 117, 114,
    101, 34, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 73, 102, 32, 116, 104,
    101, 32, 100, 114, 105, 118, 101, 114, 32, 102, 97, 105, 108, 115, 32, 116, 111, 32, 112, 97, 114, 115, 101, 32, 97,
    32, 114, 117, 110, 116, 105, 109, 101, 32, 112, 114, 111, 102, 105, 108, 101, 32, 74, 83, 79, 78, 32, 102, 105, 108,
    101, 44, 32, 105, 116, 32, 119, 105, 108, 108, 32, 97, 115, 115, 101, 114, 116, 32, 97, 110, 100, 32, 101, 110, 116,
    101, 114, 32, 105, 110, 116, 111, 32, 97, 110, 105, 110, 102, 105, 110, 105, 116, 101, 32, 108, 111, 111, 112, 32,
    105, 102, 32, 116, 104, 105, 115, 32, 115, 101, 116, 116, 105, 110, 103, 32, 105, 115, 32, 84, 82, 85, 69, 46, 32,
    34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 80, 105, 112, 101, 108, 105, 110, 101, 32, 79, 112, 116, 105,
    111, 110, 115, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117,
    108, 116, 34, 58, 32, 102, 97, 108, 115, 101, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105,
    118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114,
    105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 112, 105, 112, 101, 108, 105, 110, 101, 80, 114, 111, 102,
    105, 108, 101, 72, 97, 108, 116, 79, 110, 80, 97, 114, 115, 101, 70, 97, 105, 108, 117, 114, 101, 34, 44, 32, 34,
    72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 50, 56, 48, 51, 55, 55, 57, 49, 54, 49, 125, 44, 32, 123, 34, 78,
    97, 109, 101, 34, 58, 32, 34, 68, 105, 115, 97, 98, 108, 101, 69, 109, 98, 101, 100, 67, 111, 110, 115, 116, 65,
    114, 114, 97, 121, 115, 34, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 73,
    102, 32, 105, 110, 100, 101, 120, 97, 98, 108, 101, 32, 99, 111, 110, 115, 116, 97, 110, 116, 32, 97, 114, 114, 97,
    121, 115, 32, 101, 110, 100, 32, 117, 112, 32, 97, 115, 32, 108, 111, 99, 97, 108, 32, 118, 97, 114, 105, 97, 98,
    108, 101, 115, 32, 105, 110, 115, 116, 101, 97, 100, 32, 111, 102, 32, 108, 105, 116, 101, 114, 97, 108, 115, 44,
    32, 116, 104, 105, 115, 32, 101, 109, 98, 101, 100, 115, 32, 116, 104, 101, 109, 32, 32, 105, 110, 116, 111, 32,
    116, 104, 101, 32, 115, 104, 97, 100, 101, 114, 32, 99, 111, 100, 101, 32, 115, 111, 32, 116, 104, 101, 121, 32, 99,
    97, 110, 32, 98, 101, 32, 105, 110, 100, 101, 120, 101, 100, 32, 105, 110, 115, 116, 101, 97, 100, 32, 111, 102, 32,
    115, 112, 105, 108, 108, 105, 110, 103, 32, 116, 111, 32, 109, 101, 109, 111, 114, 121, 32, 97, 110, 100, 32, 114,
    101, 97, 100, 105, 110, 103, 32, 98, 97, 99, 107, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 80, 105,
    112, 101, 108, 105, 110, 101, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108,
    116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115, 101, 125, 44, 32, 34,
    84, 121, 112, 101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97,
    109, 101, 34, 58, 32, 34, 100, 105, 115, 97, 98, 108, 101, 69, 109, 98, 101, 100, 67, 111, 110, 115, 116, 65, 114,
    114, 97, 121, 115, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32,
    34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 51, 56, 57, 55, 53, 49, 55, 55, 54, 53, 125, 44, 32, 123, 34,
    78, 97, 109, 101, 34, 58, 32, 34, 85, 109, 100, 70, 114, 97, 109, 101, 80, 97, 99, 101, 114, 67, 111, 110, 116, 114,
    111, 108, 34, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 69, 110, 97, 98, 108,
    101, 32, 85, 77, 68, 32, 102, 114, 97, 109, 101, 32, 112, 97, 99, 101, 114, 32, 99, 111, 110, 116, 114, 111, 108,
    46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 80, 114, 101, 115, 101, 110, 116, 34, 93, 44, 32, 34, 68,
    101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 116, 114, 117,
    101, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121,
    112, 101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101,
    34, 58, 32, 34, 101, 110, 97, 98, 108, 101, 85, 109, 100, 70, 114, 97, 109, 101, 80, 97, 99, 101, 114, 34, 44, 32,
    34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 50, 49, 52, 57, 49, 55, 56, 51, 53, 56, 125, 44, 32, 123, 34,
    78, 97, 109, 101, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 70, 82, 84, 67, 34, 44, 32, 34, 68, 101, 115, 99, 114,
    105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 32, 70, 114, 97, 109, 101, 32, 82, 97, 116,
    101, 32, 84, 97, 114, 103, 101, 116, 32, 67, 111, 110, 116, 114, 111, 108, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34,
    58, 32, 91, 34, 80, 114, 101, 115, 101, 110, 116, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58,
    32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115, 101, 125, 44, 32, 34, 83, 99, 111, 112,
    101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 98, 111, 111,
    108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 101, 110, 97, 98, 108,
    101, 70, 114, 116, 99, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 51, 50, 55, 51, 55, 54, 48,
    53, 49, 57, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 84, 117, 114, 98,
    111, 83, 121, 110, 99, 34, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 69, 110,
    97, 98, 108, 101, 32, 84, 117, 114, 98, 111, 32, 83, 121, 110, 99, 32, 99, 111, 110, 116, 114, 111, 108, 46, 34, 44,
    32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 80, 114, 101, 115, 101, 110, 116, 34, 93, 44, 32, 34, 68, 101, 102,
    97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115, 101,
    125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112,
    101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34,
    58, 32, 34, 101, 110, 97, 98, 108, 101, 84, 117, 114, 98, 111, 83, 121, 110, 99, 34, 44, 32, 34, 72, 97, 115, 104,
    78, 97, 109, 101, 34, 58, 32, 49, 48, 51, 52, 48, 50, 52, 48, 56, 49, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34,
    58, 32, 34, 70, 117, 108, 108, 115, 99, 114, 101, 101, 110, 70, 114, 97, 109, 101, 77, 101, 116, 97, 100, 97, 116,
    97, 83, 117, 112, 112, 111, 114, 116, 34, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58,
    32, 34, 83, 117, 112, 112, 111, 114, 116, 32, 70, 117, 108, 108, 115, 99, 114, 101, 101, 110, 32, 70, 114, 97, 109,
    101, 32, 77, 101, 116, 97, 100, 97, 116, 97, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 80, 114, 101,
    115, 101, 110, 116, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97,
    117, 108, 116, 34, 58, 32, 116, 114, 117, 101, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105,
    118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114,
    105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 102, 117, 108, 108, 83, 99, 114, 101, 101, 110, 70, 114,
    97, 109, 101, 77, 101, 116, 97, 100, 97, 116, 97, 83, 117, 112, 112, 111, 114, 116, 34, 44, 32, 34, 72, 97, 115,
    104, 78, 97, 109, 101, 34, 58, 32, 51, 54, 56, 51, 50, 56, 55, 50, 55, 49, 125, 44, 32, 123, 34, 78, 97, 109, 101,
    34, 58, 32, 34, 85, 115, 101, 83, 100, 109, 97, 67, 111, 109, 112, 111, 115, 105, 116, 105, 110, 103, 66, 108, 116,
    34, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 70, 111, 114, 32, 115, 111,
    102, 116, 119, 97, 114, 101, 32, 99, 111, 109, 112, 111, 115, 105, 116, 105, 110, 103, 44, 32, 112, 101, 114, 102,
    111, 114, 109, 32, 97, 110, 32, 83, 68, 77, 65, 32, 98, 108, 116, 32, 111, 110, 32, 116, 104, 101, 32, 115, 108, 97,
    118, 101, 32, 100, 101, 118, 105, 99, 101, 32, 105, 110, 115, 116, 101, 97, 100, 32, 111, 102, 32, 117, 115, 105,
    110, 103, 32, 105, 116, 115, 32, 112, 114, 101, 115, 101, 110, 116, 32, 113, 117, 101, 117, 101, 46, 34, 44, 32, 34,
    84, 97, 103, 115, 34, 58, 32, 91, 34, 80, 114, 101, 115, 101, 110, 116, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117,
    108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 116, 114, 117, 101, 125, 44, 32,
    34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58,
    32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34,
    117, 115, 101, 83, 100, 109, 97, 67, 111, 109, 112, 111, 115, 105, 116, 105, 110, 103, 66, 108, 116, 34, 44, 32, 34,
    72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 49, 49, 54, 55, 56, 52, 52, 51, 48, 55, 125, 44, 32, 123, 34, 78,
    97, 109, 101, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 77, 97, 105, 108, 98, 111, 120, 80, 114, 101, 115, 101,
    110, 116, 77, 111, 100, 101, 34, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34,
    69, 110, 97, 98, 108, 101, 32, 86, 75, 95, 80, 82, 69, 83, 69, 78, 84, 95, 77, 79, 68, 69, 95, 77, 65, 73, 76, 66,
    79, 88, 95, 75, 72, 82, 32, 112, 114, 101, 115, 101, 110, 116, 32, 109, 111, 100, 101, 32, 115, 117, 112, 112, 111,
    114, 116, 32, 111, 110, 32, 87, 105, 110, 100, 111, 119, 115, 32, 79, 83, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34,
    58, 32, 91, 34, 80, 114, 101, 115, 101, 110, 116, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58,
    32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115, 101, 125, 44, 32, 34, 83, 99, 111, 112,
    101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 98, 111, 111,
    108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 101, 110, 97, 98, 108,
    101, 77, 97, 105, 108, 98, 111, 120, 80, 114, 101, 115, 101, 110, 116, 77, 111, 100, 101, 34, 44, 32, 34, 72, 97,
    115, 104, 78, 97, 109, 101, 34, 58, 32, 49, 55, 55, 50, 52, 55, 52, 48, 51, 52, 125, 44, 32, 123, 34, 78, 97, 109,
    101, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 65, 99, 113, 117, 105, 114, 101, 66, 101, 102, 111, 114, 101, 83,
    105, 103, 110, 97, 108, 34, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 65,
    108, 108, 111, 119, 115, 32, 97, 99, 113, 117, 105, 114, 105, 110, 103, 32, 111, 102, 32, 115, 119, 97, 112, 32, 99,
    104, 97, 105, 110, 32, 105, 109, 97, 103, 101, 115, 32, 119, 104, 105, 108, 101, 32, 112, 114, 101, 115, 101, 110,
    116, 32, 105, 115, 32, 115, 116, 105, 108, 108, 32, 97, 99, 116, 105, 118, 101, 34, 44, 32, 34, 84, 97, 103, 115,
    34, 58, 32, 91, 34, 80, 114, 101, 115, 101, 110, 116, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34,
    58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115, 101, 125, 44, 32, 34, 83, 99, 111,
    112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 98, 111,
    111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 101, 110, 97, 98,
    108, 101, 65, 99, 113, 117, 105, 114, 101, 66, 101, 102, 111, 114, 101, 83, 105, 103, 110, 97, 108, 34, 44, 32, 34,
    72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 49, 50, 57, 51, 49, 57, 54, 52, 53, 125, 44, 32, 123, 34, 78, 97,
    109, 101, 34, 58, 32, 34, 73, 103, 110, 111, 114, 101, 83, 117, 98, 111, 112, 116, 105, 109, 97, 108, 83, 119, 97,
    112, 99, 104, 97, 105, 110, 83, 105, 122, 101, 34, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110,
    34, 58, 32, 34, 87, 104, 101, 110, 32, 116, 114, 117, 101, 44, 32, 110, 111, 32, 99, 104, 101, 99, 107, 32, 105,
    115, 32, 100, 111, 110, 101, 32, 116, 111, 32, 115, 101, 101, 32, 105, 102, 32, 116, 104, 101, 32, 115, 119, 97,
    112, 99, 104, 97, 105, 110, 32, 115, 117, 114, 102, 97, 99, 101, 32, 115, 105, 122, 101, 32, 104, 97, 115, 32, 99,
    104, 97, 110, 103, 101, 100, 32, 115, 105, 110, 99, 101, 32, 99, 114, 101, 97, 116, 105, 111, 110, 46, 34, 44, 32,
    34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 80, 114, 101, 115, 101, 110, 116, 34, 93, 44, 32, 34, 68, 101, 102, 97,
    117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115, 101, 125,
    44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101,
    34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32,
    34, 105, 103, 110, 111, 114, 101, 83, 117, 98, 111, 112, 116, 105, 109, 97, 108, 83, 119, 97, 112, 99, 104, 97, 105,
    110, 83, 105, 122, 101, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 49, 49, 56, 50, 50, 51, 49,
    55, 48, 48, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 69, 110, 97,
    98, 108, 101, 32, 112, 105, 112, 101, 108, 105, 110, 101, 32, 100, 117, 109, 112, 44, 32, 112, 105, 112, 101, 108,
    105, 110, 101, 32, 105, 115, 32, 115, 116, 111, 114, 101, 100, 32, 119, 105, 116, 104, 32, 46, 112, 105, 112, 101,
    32, 102, 111, 114, 109, 97, 116, 46, 32, 89, 111, 117, 32, 109, 117, 115, 116, 32, 115, 101, 116, 32, 65, 77, 68,
    95, 68, 69, 66, 85, 71, 95, 68, 73, 82, 32, 97, 110, 100, 32, 109, 97, 107, 101, 32, 115, 117, 114, 101, 32, 36, 65,
    77, 68, 95, 68, 69, 66, 85, 71, 95, 68, 73, 82, 32, 43, 32, 112, 105, 112, 101, 108, 105, 110, 101, 68, 117, 109,
    112, 68, 105, 114, 32, 105, 115, 32, 32, 97, 110, 32, 97, 118, 97, 105, 108, 97, 98, 108, 101, 32, 100, 105, 114,
    101, 99, 116, 111, 114, 121, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 80, 73, 82, 86, 32, 79,
    112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68,
    101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115, 101, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32,
    34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32,
    34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 101, 110, 97, 98, 108, 101, 80, 105, 112,
    101, 108, 105, 110, 101, 68, 117, 109, 112, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 69, 110, 97, 98, 108,
    101, 80, 105, 112, 101, 108, 105, 110, 101, 68, 117, 109, 112, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101,
    34, 58, 32, 56, 48, 57, 56, 49, 56, 56, 49, 52, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105,
    111, 110, 34, 58, 32, 34, 82, 101, 108, 97, 116, 105, 118, 101, 32, 100, 105, 114, 101, 99, 116, 111, 114, 121, 32,
    119, 104, 101, 114, 101, 32, 112, 105, 112, 101, 108, 105, 110, 101, 32, 105, 110, 102, 111, 32, 105, 115, 32, 100,
    117, 109, 112, 101, 100, 46, 32, 82, 111, 111, 116, 32, 100, 105, 114, 101, 99, 116, 111, 114, 121, 32, 105, 115,
    32, 100, 101, 116, 101, 114, 109, 105, 110, 101, 100, 32, 98, 121, 32, 65, 77, 68, 95, 68, 69, 66, 85, 71, 95, 68,
    73, 82, 32, 101, 110, 118, 105, 114, 111, 110, 109, 101, 110, 116, 32, 118, 97, 114, 105, 97, 98, 108, 101, 46, 32,
    69, 97, 99, 104, 32, 117, 110, 105, 113, 117, 101, 32, 112, 105, 112, 101, 108, 105, 110, 101, 32, 105, 115, 32,
    105, 110, 32, 97, 32, 115, 101, 112, 97, 114, 97, 116, 101, 32, 102, 105, 108, 101, 32, 119, 105, 116, 104, 105,
    110, 32, 116, 104, 97, 116, 32, 100, 105, 114, 101, 99, 116, 111, 114, 121, 46, 32, 84, 104, 101, 32, 108, 111, 103,
    32, 110, 97, 109, 101, 32, 105, 115, 32, 98, 97, 115, 101, 100, 32, 111, 110, 32, 97, 32, 104, 97, 115, 104, 32,
    111, 102, 32, 116, 104, 101, 32, 112, 105, 112, 101, 108, 105, 110, 101, 39, 115, 32, 99, 114, 101, 97, 116, 101,
    32, 105, 110, 102, 111, 32, 97, 110, 100, 32, 32, 119, 104, 105, 99, 104, 32, 115, 104, 97, 100, 101, 114, 32, 115,
    116, 97, 103, 101, 115, 32, 97, 114, 101, 32, 97, 99, 116, 105, 118, 101, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34,
    58, 32, 91, 34, 83, 80, 73, 82, 86, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 70, 108, 97, 103, 115,
    34, 58, 32, 123, 34, 73, 115, 80, 97, 116, 104, 34, 58, 32, 116, 114, 117, 101, 125, 44, 32, 34, 68, 101, 102, 97,
    117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 34, 115, 112, 118, 80, 105,
    112, 101, 108, 105, 110, 101, 34, 44, 32, 34, 87, 105, 110, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 34, 83,
    112, 118, 80, 105, 112, 101, 108, 105, 110, 101, 34, 44, 32, 34, 76, 110, 120, 68, 101, 102, 97, 117, 108, 116, 34,
    58, 32, 34, 115, 112, 118, 80, 105, 112, 101, 108, 105, 110, 101, 34, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34,
    58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 80, 105, 112, 101, 108,
    105, 110, 101, 68, 117, 109, 112, 68, 105, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 115, 116, 114,
    105, 110, 103, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 112, 105, 112,
    101, 108, 105, 110, 101, 68, 117, 109, 112, 68, 105, 114, 34, 44, 32, 34, 83, 105, 122, 101, 34, 58, 32, 50, 53, 54,
    44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 57, 56, 57, 55, 49, 50, 54, 49, 50, 125, 44, 32, 123,
    34, 86, 97, 108, 105, 100, 86, 97, 108, 117, 101, 115, 34, 58, 32, 123, 34, 86, 97, 108, 117, 101, 115, 34, 58, 32,
    91, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 68, 105, 115, 97, 98, 108, 101,
    32, 97, 108, 108, 32, 108, 111, 103, 115, 46, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 48, 125, 44, 32,
    123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 32, 111,
    117, 116, 112, 117, 116, 32, 101, 114, 114, 111, 114, 32, 109, 101, 115, 115, 97, 103, 101, 46, 34, 44, 32, 34, 86,
    97, 108, 117, 101, 34, 58, 32, 49, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34,
    58, 32, 34, 69, 110, 97, 98, 108, 101, 32, 111, 117, 116, 112, 117, 116, 32, 103, 101, 110, 101, 114, 97, 108, 32,
    105, 110, 102, 111, 46, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 50, 125, 44, 32, 123, 34, 68, 101, 115,
    99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 32, 111, 117, 116, 112, 117, 116,
    32, 98, 111, 116, 104, 32, 103, 101, 110, 101, 114, 97, 108, 32, 105, 110, 102, 111, 32, 97, 110, 100, 32, 101, 114,
    114, 111, 114, 32, 109, 101, 115, 115, 97, 103, 101, 46, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 51, 125,
    93, 125, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101,
    32, 108, 111, 103, 32, 103, 101, 110, 101, 114, 97, 108, 32, 111, 117, 116, 112, 117, 116, 32, 97, 110, 100, 32,
    101, 114, 114, 111, 114, 32, 109, 101, 115, 115, 97, 103, 101, 32, 105, 110, 32, 76, 76, 80, 67, 32, 97, 110, 100,
    32, 66, 73, 76, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 80, 73, 82, 86, 32, 79, 112, 116, 105,
    111, 110, 115, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117,
    108, 116, 34, 58, 32, 48, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34,
    44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98,
    108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 101, 110, 97, 98, 108, 101, 76, 111, 103, 34, 44, 32, 34, 78, 97, 109,
    101, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 76, 111, 103, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101,
    34, 58, 32, 52, 48, 54, 50, 57, 49, 50, 48, 54, 56, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105,
    111, 110, 34, 58, 32, 34, 70, 105, 108, 101, 110, 97, 109, 101, 32, 111, 102, 32, 116, 104, 101, 32, 108, 111, 103,
    32, 102, 105, 108, 101, 32, 105, 110, 32, 76, 76, 80, 67, 32, 97, 110, 100, 32, 66, 73, 76, 46, 32, 68, 105, 114,
    101, 99, 116, 111, 114, 121, 32, 111, 102, 32, 116, 104, 101, 32, 108, 111, 103, 32, 102, 105, 108, 101, 32, 105,
    115, 32, 80, 105, 112, 101, 108, 105, 110, 101, 68, 117, 109, 112, 68, 105, 114, 46, 32, 78, 111, 116, 101, 32, 116,
    104, 97, 116, 32, 108, 111, 103, 70, 105, 108, 101, 78, 97, 109, 101, 32, 100, 111, 101, 115, 32, 110, 111, 116, 32,
    105, 110, 99, 108, 117, 100, 101, 115, 32, 60, 112, 97, 116, 104, 62, 32, 97, 110, 100, 32, 60, 46, 116, 120, 116,
    62, 46, 32, 70, 117, 108, 108, 32, 112, 97, 116, 104, 32, 111, 102, 32, 108, 111, 103, 32, 102, 105, 108, 101, 32,
    105, 115, 58, 32, 80, 105, 112, 101, 108, 105, 110, 101, 68, 117, 109, 112, 68, 105, 114, 43, 76, 111, 103, 70, 105,
    108, 101, 78, 97, 109, 101, 66, 105, 108, 46, 116, 120, 116, 32, 111, 114, 32, 80, 105, 112, 101, 108, 105, 110,
    101, 68, 117, 109, 112, 68, 105, 114, 43, 76, 111, 103, 70, 105, 108, 101, 78, 97, 109, 101, 76, 108, 112, 99, 46,
    116, 120, 116, 46, 32, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 80, 73, 82, 86, 32, 79, 112, 116,
    105, 111, 110, 115, 34, 93, 44, 32, 34, 70, 108, 97, 103, 115, 34, 58, 32, 123, 34, 73, 115, 70, 105, 108, 101, 34,
    58, 32, 116, 114, 117, 101, 125, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101,
    102, 97, 117, 108, 116, 34, 58, 32, 34, 115, 112, 118, 76, 111, 103, 73, 110, 102, 111, 34, 125, 44, 32, 34, 83, 99,
    111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 76,
    111, 103, 70, 105, 108, 101, 78, 97, 109, 101, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 115, 116, 114,
    105, 110, 103, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 108, 111, 103,
    70, 105, 108, 101, 78, 97, 109, 101, 34, 44, 32, 34, 83, 105, 122, 101, 34, 58, 32, 50, 53, 54, 44, 32, 34, 72, 97,
    115, 104, 78, 97, 109, 101, 34, 58, 32, 49, 52, 57, 52, 51, 57, 56, 52, 53, 50, 125, 44, 32, 123, 34, 68, 101, 115,
    99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 32, 111, 117, 116, 112, 117, 116,
    32, 100, 105, 97, 103, 110, 111, 115, 116, 105, 99, 32, 105, 110, 102, 111, 46, 32, 84, 104, 105, 115, 32, 105, 110,
    102, 111, 32, 109, 97, 121, 32, 97, 100, 100, 101, 100, 32, 116, 111, 32, 65, 77, 68, 32, 73, 76, 32, 111, 114, 32,
    101, 120, 116, 101, 114, 110, 97, 108, 32, 100, 101, 98, 117, 103, 32, 108, 111, 103, 32, 102, 105, 108, 101, 115,
    46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 80, 73, 82, 86, 32, 79, 112, 116, 105, 111, 110, 115,
    34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34,
    58, 32, 102, 97, 108, 115, 101, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114,
    34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108,
    101, 78, 97, 109, 101, 34, 58, 32, 34, 101, 110, 97, 98, 108, 101, 68, 101, 98, 117, 103, 34, 44, 32, 34, 78, 97,
    109, 101, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 68, 101, 98, 117, 103, 34, 44, 32, 34, 72, 97, 115, 104, 78,
    97, 109, 101, 34, 58, 32, 52, 48, 52, 57, 49, 54, 55, 52, 49, 55, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105,
    112, 116, 105, 111, 110, 34, 58, 32, 34, 70, 105, 108, 101, 110, 97, 109, 101, 32, 111, 102, 32, 116, 104, 101, 32,
    102, 105, 108, 101, 32, 116, 111, 32, 108, 111, 103, 32, 100, 101, 98, 117, 103, 32, 105, 110, 102, 111, 114, 109,
    97, 116, 105, 111, 110, 46, 32, 32, 73, 102, 32, 116, 104, 101, 32, 102, 105, 108, 101, 32, 110, 97, 109, 101, 32,
    105, 115, 32, 101, 109, 112, 116, 121, 44, 32, 116, 104, 101, 32, 109, 101, 115, 115, 97, 103, 101, 32, 119, 105,
    108, 108, 32, 98, 101, 32, 111, 117, 116, 112, 117, 116, 32, 116, 111, 32, 115, 116, 100, 101, 114, 114, 46, 34, 44,
    32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 80, 73, 82, 86, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44,
    32, 34, 70, 108, 97, 103, 115, 34, 58, 32, 123, 34, 73, 115, 70, 105, 108, 101, 34, 58, 32, 116, 114, 117, 101, 125,
    44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32,
    34, 100, 101, 98, 117, 103, 76, 111, 103, 73, 110, 102, 111, 46, 116, 120, 116, 34, 125, 44, 32, 34, 83, 99, 111,
    112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 101,
    98, 117, 103, 76, 111, 103, 70, 105, 108, 101, 78, 97, 109, 101, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34,
    115, 116, 114, 105, 110, 103, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34,
    100, 101, 98, 117, 103, 76, 111, 103, 70, 105, 108, 101, 78, 97, 109, 101, 34, 44, 32, 34, 83, 105, 122, 101, 34,
    58, 32, 50, 53, 54, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 50, 54, 57, 57, 50, 51, 53, 48, 52,
    55, 125, 44, 32, 123, 34, 86, 97, 108, 105, 100, 86, 97, 108, 117, 101, 115, 34, 58, 32, 123, 34, 73, 115, 69, 110,
    117, 109, 34, 58, 32, 116, 114, 117, 101, 44, 32, 34, 86, 97, 108, 117, 101, 115, 34, 58, 32, 91, 123, 34, 78, 97,
    109, 101, 34, 58, 32, 34, 83, 104, 97, 100, 101, 114, 82, 101, 112, 108, 97, 99, 101, 68, 105, 115, 97, 98, 108,
    101, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 48, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105,
    111, 110, 34, 58, 32, 34, 68, 105, 115, 97, 98, 108, 101, 32, 115, 104, 97, 100, 101, 114, 32, 114, 101, 112, 108,
    97, 99, 101, 109, 101, 110, 116, 32, 40, 100, 101, 102, 97, 117, 108, 116, 41, 34, 125, 44, 32, 123, 34, 78, 97,
    109, 101, 34, 58, 32, 34, 83, 104, 97, 100, 101, 114, 82, 101, 112, 108, 97, 99, 101, 83, 104, 97, 100, 101, 114,
    72, 97, 115, 104, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 44, 32, 34, 68, 101, 115, 99, 114, 105,
    112, 116, 105, 111, 110, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 32, 115, 104, 97, 100, 101, 114, 32, 104, 97,
    115, 104, 32, 98, 97, 115, 101, 100, 32, 115, 104, 97, 100, 101, 114, 32, 114, 101, 112, 108, 97, 99, 101, 109, 101,
    110, 116, 44, 32, 102, 111, 114, 32, 97, 110, 121, 32, 115, 104, 97, 100, 101, 114, 32, 119, 104, 111, 115, 101, 32,
    104, 97, 115, 104, 32, 105, 115, 32, 65, 65, 65, 44, 32, 105, 102, 32, 116, 104, 101, 114, 101, 32, 105, 115, 32,
    97, 32, 102, 105, 108, 101, 32, 110, 97, 109, 101, 100, 32, 115, 104, 97, 100, 101, 114, 95, 48, 120, 65, 65, 65,
    95, 114, 101, 112, 108, 97, 99, 101, 46, 115, 112, 118, 32, 117, 110, 100, 101, 114, 32, 83, 104, 97, 100, 101, 114,
    82, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 68, 105, 114, 44, 32, 116, 104, 105, 115, 32, 102, 105, 108,
    101, 32, 119, 105, 108, 108, 32, 98, 101, 32, 117, 115, 101, 100, 32, 116, 111, 32, 114, 101, 112, 108, 97, 99, 101,
    32, 116, 104, 101, 32, 111, 114, 105, 103, 105, 110, 97, 108, 32, 115, 104, 97, 100, 101, 114, 46, 34, 125, 44, 32,
    123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 83, 104, 97, 100, 101, 114, 82, 101, 112, 108, 97, 99, 101, 83, 104, 97,
    100, 101, 114, 80, 105, 112, 101, 108, 105, 110, 101, 72, 97, 115, 104, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34,
    58, 32, 50, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 69, 110, 97, 98, 108,
    101, 32, 115, 104, 97, 100, 101, 114, 32, 104, 97, 115, 104, 32, 112, 108, 117, 115, 32, 112, 105, 112, 101, 108,
    105, 110, 101, 32, 104, 97, 115, 104, 32, 102, 105, 108, 116, 101, 114, 32, 98, 97, 115, 101, 100, 32, 115, 104, 97,
    100, 101, 114, 32, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 44, 32, 115, 104, 97, 100, 101, 114, 32,
    104, 97, 115, 104, 32, 98, 97, 115, 101, 100, 32, 115, 104, 97, 100, 101, 114, 32, 114, 101, 112, 108, 97, 99, 101,
    109, 101, 110, 116, 32, 119, 105, 108, 108, 32, 111, 110, 108, 121, 32, 98, 101, 32, 101, 110, 97, 98, 108, 101,
    100, 32, 102, 111, 114, 32, 112, 105, 112, 101, 108, 105, 110, 101, 115, 32, 119, 104, 111, 115, 101, 32, 104, 97,
    115, 104, 32, 105, 115, 32, 105, 110, 32, 83, 104, 97, 100, 101, 114, 82, 101, 112, 108, 97, 99, 101, 109, 101, 110,
    116, 80, 105, 112, 101, 108, 105, 110, 101, 72, 97, 115, 104, 115, 46, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101,
    34, 58, 32, 34, 83, 104, 97, 100, 101, 114, 82, 101, 112, 108, 97, 99, 101, 80, 105, 112, 101, 108, 105, 110, 101,
    66, 105, 110, 97, 114, 121, 72, 97, 115, 104, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 51, 44, 32, 34, 68,
    101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 32, 112, 105, 112, 101,
    108, 105, 110, 101, 32, 98, 105, 110, 97, 114, 121, 32, 104, 97, 115, 104, 32, 98, 97, 115, 101, 100, 32, 112, 105,
    112, 101, 108, 105, 110, 101, 32, 98, 105, 110, 97, 114, 121, 32, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110,
    116, 44, 32, 102, 111, 114, 32, 97, 110, 121, 32, 112, 105, 112, 101, 108, 105, 110, 101, 32, 98, 105, 110, 97, 114,
    121, 32, 119, 104, 111, 115, 101, 32, 104, 97, 115, 104, 32, 105, 115, 32, 65, 65, 65, 44, 32, 105, 102, 32, 116,
    104, 101, 114, 101, 32, 105, 115, 32, 97, 32, 102, 105, 108, 101, 32, 110, 97, 109, 101, 100, 32, 80, 105, 112, 101,
    108, 110, 101, 88, 88, 88, 95, 48, 120, 65, 65, 65, 95, 114, 101, 112, 108, 97, 99, 101, 46, 101, 108, 102, 32, 117,
    110, 100, 101, 114, 32, 83, 104, 97, 100, 101, 114, 82, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 68, 105,
    114, 44, 32, 116, 104, 105, 115, 32, 102, 105, 108, 101, 32, 119, 105, 108, 108, 32, 98, 101, 32, 117, 115, 101,
    100, 32, 116, 111, 32, 114, 101, 112, 108, 97, 99, 101, 32, 116, 104, 101, 32, 111, 114, 105, 103, 105, 110, 97,
    108, 32, 112, 105, 112, 101, 108, 105, 110, 101, 32, 98, 105, 110, 97, 114, 121, 46, 34, 125, 44, 32, 123, 34, 78,
    97, 109, 101, 34, 58, 32, 34, 83, 104, 97, 100, 101, 114, 82, 101, 112, 108, 97, 99, 101, 83, 104, 97, 100, 101,
    114, 73, 83, 65, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 52, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112,
    116, 105, 111, 110, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 32, 114, 101, 112, 108, 97, 99, 101, 32, 73, 83, 65,
    32, 115, 104, 97, 100, 101, 114, 32, 105, 110, 32, 116, 104, 101, 32, 112, 105, 112, 101, 108, 105, 110, 101, 44,
    32, 70, 111, 114, 32, 101, 118, 101, 114, 121, 32, 112, 105, 112, 101, 108, 105, 110, 101, 32, 105, 110, 32, 116,
    104, 101, 32, 83, 104, 97, 100, 101, 114, 82, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 80, 105, 112, 101,
    108, 105, 110, 101, 72, 97, 115, 104, 115, 44, 32, 119, 111, 117, 108, 100, 32, 102, 105, 110, 100, 32, 105, 102,
    32, 116, 104, 101, 114, 101, 32, 105, 115, 32, 97, 32, 102, 105, 108, 101, 32, 110, 97, 109, 101, 100, 32, 48, 120,
    65, 65, 65, 95, 114, 101, 112, 108, 97, 99, 101, 46, 116, 120, 116, 32, 117, 110, 100, 101, 114, 32, 83, 104, 97,
    100, 101, 114, 82, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 68, 105, 114, 44, 32, 119, 111, 117, 108, 100,
    32, 98, 101, 32, 108, 111, 97, 100, 101, 100, 32, 102, 111, 114, 32, 116, 104, 101, 32, 114, 101, 112, 108, 97, 99,
    101, 109, 101, 110, 116, 32, 116, 104, 101, 32, 114, 101, 112, 108, 97, 99, 101, 32, 115, 104, 97, 100, 101, 114,
    32, 108, 111, 111, 107, 32, 108, 105, 107, 101, 32, 116, 104, 105, 115, 32, 32, 42, 45, 45, 45, 45, 111, 102, 102,
    115, 101, 116, 58, 32, 73, 83, 65, 67, 79, 68, 69, 45, 45, 45, 45, 42, 32, 56, 52, 56, 58, 48, 120, 55, 69, 49, 50,
    48, 51, 48, 51, 32, 32, 32, 49, 52, 56, 48, 58, 48, 120, 55, 69, 49, 69, 48, 51, 48, 51, 32, 32, 50, 53, 57, 50, 58,
    48, 120, 55, 69, 48, 69, 48, 51, 48, 69, 34, 125, 93, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 83, 104, 97,
    100, 101, 114, 82, 101, 112, 108, 97, 99, 101, 77, 111, 100, 101, 34, 125, 44, 32, 34, 68, 101, 115, 99, 114, 105,
    112, 116, 105, 111, 110, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 32, 115, 104, 97, 100, 101, 114, 32, 114, 101,
    112, 108, 97, 99, 101, 109, 101, 110, 116, 46, 32, 84, 104, 105, 115, 32, 111, 112, 116, 105, 111, 110, 32, 105,
    115, 32, 118, 97, 108, 105, 100, 32, 111, 110, 108, 121, 32, 105, 102, 32, 76, 76, 80, 67, 32, 112, 97, 116, 104,
    32, 105, 115, 32, 101, 110, 97, 98, 108, 101, 100, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 80,
    73, 82, 86, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58,
    32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 34, 83, 104, 97, 100, 101, 114, 82, 101, 112, 108, 97, 99,
    101, 68, 105, 115, 97, 98, 108, 101, 34, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118,
    101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 101, 110, 117, 109, 34, 44, 32, 34, 86, 97, 114, 105,
    97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 115, 104, 97, 100, 101, 114, 82, 101, 112, 108, 97, 99, 101, 77,
    111, 100, 101, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 83, 104, 97, 100, 101, 114, 82, 101, 112, 108, 97,
    99, 101, 77, 111, 100, 101, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 51, 53, 50, 55, 49, 50,
    55, 55, 57, 53, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 82, 101,
    108, 97, 116, 105, 118, 101, 32, 100, 105, 114, 101, 99, 116, 111, 114, 121, 32, 119, 104, 101, 114, 101, 32, 115,
    104, 97, 100, 101, 114, 32, 114, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 32, 102, 105, 108, 101, 115, 32,
    97, 114, 101, 32, 115, 116, 111, 114, 101, 100, 46, 32, 82, 111, 111, 116, 32, 100, 105, 114, 101, 99, 116, 111,
    114, 121, 32, 105, 115, 32, 100, 101, 116, 101, 114, 109, 105, 110, 101, 100, 32, 105, 110, 32, 100, 101, 118, 105,
    99, 101, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 80, 73, 82, 86, 32, 79, 112, 116, 105, 111,
    110, 115, 34, 93, 44, 32, 34, 70, 108, 97, 103, 115, 34, 58, 32, 123, 34, 73, 115, 80, 97, 116, 104, 34, 58, 32,
    116, 114, 117, 101, 125, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97,
    117, 108, 116, 34, 58, 32, 34, 83, 104, 97, 100, 101, 114, 82, 101, 112, 108, 97, 99, 101, 34, 44, 32, 34, 87, 105,
    110, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 34, 83, 104, 97, 100, 101, 114, 82, 101, 112, 108, 97, 99, 101,
    34, 44, 32, 34, 76, 110, 120, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 34, 83, 104, 97, 100, 101, 114, 82, 101,
    112, 108, 97, 99, 101, 34, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34,
    44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 83, 104, 97, 100, 101, 114, 82, 101, 112, 108, 97, 99, 101, 68, 105,
    114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 115, 116, 114, 105, 110, 103, 34, 44, 32, 34, 86, 97, 114,
    105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 115, 104, 97, 100, 101, 114, 82, 101, 112, 108, 97, 99,
    101, 68, 105, 114, 34, 44, 32, 34, 83, 105, 122, 101, 34, 58, 32, 50, 53, 54, 44, 32, 34, 72, 97, 115, 104, 78, 97,
    109, 101, 34, 58, 32, 51, 51, 48, 56, 50, 57, 56, 52, 50, 51, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112,
    116, 105, 111, 110, 34, 58, 32, 34, 79, 110, 108, 121, 32, 118, 97, 108, 105, 100, 32, 105, 102, 32, 115, 104, 97,
    100, 101, 114, 82, 101, 112, 108, 97, 99, 101, 77, 111, 100, 101, 32, 105, 115, 32, 115, 101, 116, 32, 116, 111, 32,
    50, 32, 97, 110, 100, 32, 52, 46, 32, 84, 104, 105, 115, 32, 105, 115, 32, 97, 32, 99, 111, 109, 109, 97, 32, 115,
    101, 112, 97, 114, 97, 116, 101, 100, 32, 112, 105, 112, 101, 108, 105, 110, 101, 32, 104, 97, 115, 104, 32, 108,
    105, 115, 116, 46, 32, 72, 97, 115, 104, 32, 110, 117, 109, 98, 101, 114, 32, 105, 115, 32, 105, 110, 32, 98, 105,
    103, 32, 99, 97, 115, 101, 44, 32, 101, 120, 97, 109, 112, 108, 101, 32, 104, 97, 115, 104, 32, 108, 105, 115, 116,
    32, 108, 111, 111, 107, 115, 32, 108, 105, 107, 101, 58, 32, 48, 120, 65, 68, 48, 51, 51, 69, 48, 51, 49, 66, 70,
    55, 67, 66, 54, 67, 44, 48, 120, 49, 66, 55, 48, 55, 70, 51, 55, 66, 55, 68, 65, 51, 52, 69, 51, 34, 44, 32, 34, 84,
    97, 103, 115, 34, 58, 32, 91, 34, 83, 80, 73, 82, 86, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 68,
    101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 34, 34, 125, 44,
    32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 78, 97, 109, 101, 34,
    58, 32, 34, 83, 104, 97, 100, 101, 114, 82, 101, 112, 108, 97, 99, 101, 80, 105, 112, 101, 108, 105, 110, 101, 72,
    97, 115, 104, 101, 115, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 115, 116, 114, 105, 110, 103, 34, 44, 32,
    34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 115, 104, 97, 100, 101, 114, 82, 101, 112,
    108, 97, 99, 101, 80, 105, 112, 101, 108, 105, 110, 101, 72, 97, 115, 104, 101, 115, 34, 44, 32, 34, 83, 105, 122,
    101, 34, 58, 32, 53, 49, 50, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 57, 48, 55, 56, 49, 52, 54,
    57, 48, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 68, 114, 111,
    112, 32, 115, 112, 101, 99, 105, 102, 105, 101, 100, 32, 105, 110, 115, 116, 114, 117, 99, 116, 105, 111, 110, 32,
    105, 110, 32, 112, 105, 112, 101, 108, 105, 110, 101, 32, 98, 105, 110, 97, 114, 121, 32, 102, 111, 114, 32, 113,
    117, 105, 99, 107, 32, 100, 101, 98, 117, 103, 103, 105, 110, 103, 32, 115, 104, 97, 100, 101, 114, 46, 32, 73, 116,
    32, 114, 101, 112, 108, 97, 99, 101, 115, 32, 97, 108, 108, 32, 109, 97, 116, 99, 104, 105, 110, 103, 32, 105, 110,
    115, 116, 114, 117, 99, 116, 105, 111, 110, 32, 111, 112, 99, 111, 100, 101, 115, 32, 119, 105, 116, 104, 32, 78,
    79, 80, 115, 32, 97, 110, 100, 32, 110, 101, 101, 100, 115, 32, 116, 111, 32, 119, 111, 114, 107, 32, 119, 105, 116,
    104, 32, 68, 114, 111, 112, 80, 105, 112, 101, 108, 105, 110, 101, 66, 105, 110, 97, 114, 121, 73, 110, 115, 116,
    84, 111, 107, 101, 110, 32, 97, 110, 100, 32, 68, 114, 111, 112, 80, 105, 112, 101, 108, 105, 110, 101, 66, 105,
    110, 97, 114, 121, 73, 110, 115, 116, 83, 105, 122, 101, 32, 116, 111, 103, 101, 116, 104, 101, 114, 46, 34, 44, 32,
    34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 80, 73, 82, 86, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32,
    34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97,
    108, 115, 101, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34,
    84, 121, 112, 101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97,
    109, 101, 34, 58, 32, 34, 101, 110, 97, 98, 108, 101, 68, 114, 111, 112, 80, 105, 112, 101, 108, 105, 110, 101, 66,
    105, 110, 97, 114, 121, 73, 110, 115, 116, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 69, 110, 97, 98, 108,
    101, 68, 114, 111, 112, 80, 105, 112, 101, 108, 105, 110, 101, 66, 105, 110, 97, 114, 121, 73, 110, 115, 116, 34,
    44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 51, 50, 55, 51, 48, 57, 53, 56, 52, 52, 125, 44, 32,
    123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 67, 104, 97, 110, 103, 101, 32, 116,
    104, 101, 32, 65, 80, 73, 45, 101, 120, 112, 111, 115, 101, 100, 32, 115, 117, 98, 103, 114, 111, 117, 112, 83, 105,
    122, 101, 32, 48, 32, 32, 45, 32, 84, 104, 101, 32, 109, 97, 120, 105, 109, 117, 109, 32, 115, 117, 112, 112, 111,
    114, 116, 101, 100, 32, 119, 97, 118, 101, 83, 105, 122, 101, 32, 111, 102, 32, 116, 104, 101, 32, 71, 80, 85, 32,
    40, 100, 101, 102, 97, 117, 108, 116, 41, 32, 51, 50, 32, 45, 32, 83, 117, 98, 103, 114, 111, 117, 112, 32, 115,
    105, 122, 101, 32, 111, 102, 32, 51, 50, 32, 54, 52, 32, 45, 32, 83, 117, 98, 103, 114, 111, 117, 112, 32, 115, 105,
    122, 101, 32, 111, 102, 32, 54, 52, 32, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 80, 73, 82, 86,
    32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34,
    68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 48, 125, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110,
    116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 115, 117, 98,
    103, 114, 111, 117, 112, 83, 105, 122, 101, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 83, 117, 98, 103, 114,
    111, 117, 112, 83, 105, 122, 101, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101,
    114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 49, 50, 49, 54, 55, 52, 56, 50, 55, 55, 125,
    44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 70, 111, 114, 99, 101, 32,
    118, 101, 114, 116, 101, 120, 32, 115, 104, 97, 100, 101, 114, 115, 32, 116, 111, 32, 114, 117, 110, 32, 119, 105,
    116, 104, 32, 97, 32, 112, 97, 114, 116, 105, 99, 117, 108, 97, 114, 32, 119, 97, 118, 101, 32, 115, 105, 122, 101,
    46, 32, 84, 104, 105, 115, 32, 105, 115, 32, 105, 103, 110, 111, 114, 101, 100, 32, 105, 102, 32, 115, 117, 98, 103,
    114, 111, 117, 112, 32, 111, 112, 101, 114, 97, 116, 105, 111, 110, 115, 32, 97, 114, 101, 32, 117, 115, 101, 100,
    32, 98, 121, 32, 116, 104, 101, 32, 115, 104, 97, 100, 101, 114, 44, 32, 115, 101, 101, 32, 83, 117, 98, 103, 114,
    111, 117, 112, 83, 105, 122, 101, 46, 32, 48, 32, 32, 45, 32, 76, 101, 116, 32, 99, 111, 109, 112, 105, 108, 101,
    114, 32, 99, 104, 111, 111, 115, 101, 32, 87, 97, 118, 101, 51, 50, 32, 118, 115, 32, 87, 97, 118, 101, 54, 52, 32,
    109, 111, 100, 101, 32, 40, 100, 101, 102, 97, 117, 108, 116, 41, 32, 51, 50, 32, 45, 32, 82, 117, 110, 32, 105,
    110, 32, 87, 97, 118, 101, 51, 50, 32, 109, 111, 100, 101, 32, 54, 52, 32, 45, 32, 82, 117, 110, 32, 105, 110, 32,
    87, 97, 118, 101, 54, 52, 32, 109, 111, 100, 101, 32, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 80,
    73, 82, 86, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58,
    32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 48, 125, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34,
    117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34,
    118, 115, 87, 97, 118, 101, 83, 105, 122, 101, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 86, 115, 87, 97,
    118, 101, 83, 105, 122, 101, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34,
    44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 50, 56, 55, 53, 56, 48, 52, 56, 55, 56, 125, 44, 32,
    123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 70, 111, 114, 99, 101, 32, 116, 101,
    115, 115, 101, 108, 108, 97, 116, 105, 111, 110, 32, 99, 111, 110, 116, 114, 111, 108, 32, 115, 104, 97, 100, 101,
    114, 115, 32, 116, 111, 32, 114, 117, 110, 32, 119, 105, 116, 104, 32, 97, 32, 112, 97, 114, 116, 105, 99, 117, 108,
    97, 114, 32, 119, 97, 118, 101, 32, 115, 105, 122, 101, 46, 32, 84, 104, 105, 115, 32, 105, 115, 32, 105, 103, 110,
    111, 114, 101, 100, 32, 105, 102, 32, 115, 117, 98, 103, 114, 111, 117, 112, 32, 111, 112, 101, 114, 97, 116, 105,
    111, 110, 115, 32, 97, 114, 101, 32, 117, 115, 101, 100, 32, 98, 121, 32, 116, 104, 101, 32, 115, 104, 97, 100, 101,
    114, 44, 32, 115, 101, 101, 32, 83, 117, 98, 103, 114, 111, 117, 112, 83, 105, 122, 101, 46, 32, 48, 32, 32, 45, 32,
    76, 101, 116, 32, 99, 111, 109, 112, 105, 108, 101, 114, 32, 99, 104, 111, 111, 115, 101, 32, 87, 97, 118, 101, 51,
    50, 32, 118, 115, 32, 87, 97, 118, 101, 54, 52, 32, 109, 111, 100, 101, 32, 40, 100, 101, 102, 97, 117, 108, 116,
    41, 32, 51, 50, 32, 45, 32, 82, 117, 110, 32, 105, 110, 32, 87, 97, 118, 101, 51, 50, 32, 109, 111, 100, 101, 32,
    54, 52, 32, 45, 32, 82, 117, 110, 32, 105, 110, 32, 87, 97, 118, 101, 54, 52, 32, 109, 111, 100, 101, 32, 34, 44,
    32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 80, 73, 82, 86, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44,
    32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 48,
    125, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105,
    97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 116, 99, 115, 87, 97, 118, 101, 83, 105, 122, 101, 34, 44, 32,
    34, 78, 97, 109, 101, 34, 58, 32, 34, 84, 99, 115, 87, 97, 118, 101, 83, 105, 122, 101, 34, 44, 32, 34, 83, 99, 111,
    112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58,
    32, 49, 50, 51, 52, 48, 56, 49, 49, 50, 49, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111,
    110, 34, 58, 32, 34, 70, 111, 114, 99, 101, 32, 116, 101, 115, 115, 101, 108, 108, 97, 116, 105, 111, 110, 32, 101,
    118, 97, 108, 117, 97, 116, 105, 111, 110, 32, 115, 104, 97, 100, 101, 114, 115, 32, 116, 111, 32, 114, 117, 110,
    32, 119, 105, 116, 104, 32, 97, 32, 112, 97, 114, 116, 105, 99, 117, 108, 97, 114, 32, 119, 97, 118, 101, 32, 115,
    105, 122, 101, 46, 32, 84, 104, 105, 115, 32, 105, 115, 32, 105, 103, 110, 111, 114, 101, 100, 32, 105, 102, 32,
    115, 117, 98, 103, 114, 111, 117, 112, 32, 111, 112, 101, 114, 97, 116, 105, 111, 110, 115, 32, 97, 114, 101, 32,
    117, 115, 101, 100, 32, 98, 121, 32, 116, 104, 101, 32, 115, 104, 97, 100, 101, 114, 44, 32, 115, 101, 101, 32, 83,
    117, 98, 103, 114, 111, 117, 112, 83, 105, 122, 101, 46, 32, 48, 32, 32, 45, 32, 76, 101, 116, 32, 99, 111, 109,
    112, 105, 108, 101, 114, 32, 99, 104, 111, 111, 115, 101, 32, 87, 97, 118, 101, 51, 50, 32, 118, 115, 32, 87, 97,
    118, 101, 54, 52, 32, 109, 111, 100, 101, 32, 40, 100, 101, 102, 97, 117, 108, 116, 41, 32, 51, 50, 32, 45, 32, 82,
    117, 110, 32, 105, 110, 32, 87, 97, 118, 101, 51, 50, 32, 109, 111, 100, 101, 32, 54, 52, 32, 45, 32, 82, 117, 110,
    32, 105, 110, 32, 87, 97, 118, 101, 54, 52, 32, 109, 111, 100, 101, 32, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58,
    32, 91, 34, 83, 80, 73, 82, 86, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117,
    108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 48, 125, 44, 32, 34, 84, 121, 112,
    101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109,
    101, 34, 58, 32, 34, 116, 101, 115, 87, 97, 118, 101, 83, 105, 122, 101, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58,
    32, 34, 84, 101, 115, 87, 97, 118, 101, 83, 105, 122, 101, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34,
    68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 51, 48, 55, 50, 48, 57,
    54, 50, 51, 53, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 70, 111,
    114, 99, 101, 32, 103, 101, 111, 109, 101, 116, 114, 121, 32, 115, 104, 97, 100, 101, 114, 115, 32, 116, 111, 32,
    114, 117, 110, 32, 119, 105, 116, 104, 32, 97, 32, 112, 97, 114, 116, 105, 99, 117, 108, 97, 114, 32, 119, 97, 118,
    101, 32, 115, 105, 122, 101, 46, 32, 84, 104, 105, 115, 32, 105, 115, 32, 105, 103, 110, 111, 114, 101, 100, 32,
    105, 102, 32, 115, 117, 98, 103, 114, 111, 117, 112, 32, 111, 112, 101, 114, 97, 116, 105, 111, 110, 115, 32, 97,
    114, 101, 32, 117, 115, 101, 100, 32, 98, 121, 32, 116, 104, 101, 32, 115, 104, 97, 100, 101, 114, 44, 32, 115, 101,
    101, 32, 83, 117, 98, 103, 114, 111, 117, 112, 83, 105, 122, 101, 46, 32, 48, 32, 32, 45, 32, 76, 101, 116, 32, 99,
    111, 109, 112, 105, 108, 101, 114, 32, 99, 104, 111, 111, 115, 101, 32, 87, 97, 118, 101, 51, 50, 32, 118, 115, 32,
    87, 97, 118, 101, 54, 52, 32, 109, 111, 100, 101, 32, 40, 100, 101, 102, 97, 117, 108, 116, 41, 32, 51, 50, 32, 45,
    32, 82, 117, 110, 32, 105, 110, 32, 87, 97, 118, 101, 51, 50, 32, 109, 111, 100, 101, 32, 54, 52, 32, 45, 32, 82,
    117, 110, 32, 105, 110, 32, 87, 97, 118, 101, 54, 52, 32, 109, 111, 100, 101, 32, 34, 44, 32, 34, 84, 97, 103, 115,
    34, 58, 32, 91, 34, 83, 80, 73, 82, 86, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 68, 101, 102, 97,
    117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 48, 125, 44, 32, 34, 84, 121,
    112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97,
    109, 101, 34, 58, 32, 34, 103, 115, 87, 97, 118, 101, 83, 105, 122, 101, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58,
    32, 34, 71, 115, 87, 97, 118, 101, 83, 105, 122, 101, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68,
    114, 105, 118, 101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 49, 48, 53, 50, 50, 56, 53,
    56, 51, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 70, 111, 114, 99,
    101, 32, 102, 114, 97, 103, 109, 101, 110, 116, 32, 115, 104, 97, 100, 101, 114, 115, 32, 116, 111, 32, 114, 117,
    110, 32, 119, 105, 116, 104, 32, 97, 32, 112, 97, 114, 116, 105, 99, 117, 108, 97, 114, 32, 119, 97, 118, 101, 32,
    115, 105, 122, 101, 46, 32, 84, 104, 105, 115, 32, 105, 115, 32, 105, 103, 110, 111, 114, 101, 100, 32, 105, 102,
    32, 115, 117, 98, 103, 114, 111, 117, 112, 32, 111, 112, 101, 114, 97, 116, 105, 111, 110, 115, 32, 97, 114, 101,
    32, 117, 115, 101, 100, 32, 98, 121, 32, 116, 104, 101, 32, 115, 104, 97, 100, 101, 114, 44, 32, 115, 101, 101, 32,
    83, 117, 98, 103, 114, 111, 117, 112, 83, 105, 122, 101, 46, 32, 48, 32, 32, 45, 32, 76, 101, 116, 32, 99, 111, 109,
    112, 105, 108, 101, 114, 32, 99, 104, 111, 111, 115, 101, 32, 87, 97, 118, 101, 51, 50, 32, 118, 115, 32, 87, 97,
    118, 101, 54, 52, 32, 109, 111, 100, 101, 32, 40, 100, 101, 102, 97, 117, 108, 116, 41, 32, 51, 50, 32, 45, 32, 82,
    117, 110, 32, 105, 110, 32, 87, 97, 118, 101, 51, 50, 32, 109, 111, 100, 101, 32, 54, 52, 32, 45, 32, 82, 117, 110,
    32, 105, 110, 32, 87, 97, 118, 101, 54, 52, 32, 109, 111, 100, 101, 32, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58,
    32, 91, 34, 83, 80, 73, 82, 86, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117,
    108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 48, 125, 44, 32, 34, 84, 121, 112,
    101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109,
    101, 34, 58, 32, 34, 102, 115, 87, 97, 118, 101, 83, 105, 122, 101, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32,
    34, 70, 115, 87, 97, 118, 101, 83, 105, 122, 101, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114,
    105, 118, 101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 56, 49, 56, 48, 54, 52, 57, 50,
    54, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 70, 111, 114, 99,
    101, 32, 99, 111, 109, 112, 117, 116, 101, 32, 115, 104, 97, 100, 101, 114, 115, 32, 116, 111, 32, 114, 117, 110,
    32, 119, 105, 116, 104, 32, 97, 32, 112, 97, 114, 116, 105, 99, 117, 108, 97, 114, 32, 119, 97, 118, 101, 32, 115,
    105, 122, 101, 46, 32, 84, 104, 105, 115, 32, 105, 115, 32, 105, 103, 110, 111, 114, 101, 100, 32, 105, 102, 32,
    115, 117, 98, 103, 114, 111, 117, 112, 32, 111, 112, 101, 114, 97, 116, 105, 111, 110, 115, 32, 97, 114, 101, 32,
    117, 115, 101, 100, 32, 98, 121, 32, 116, 104, 101, 32, 115, 104, 97, 100, 101, 114, 44, 32, 115, 101, 101, 32, 83,
    117, 98, 103, 114, 111, 117, 112, 83, 105, 122, 101, 46, 32, 48, 32, 32, 45, 32, 76, 101, 116, 32, 99, 111, 109,
    112, 105, 108, 101, 114, 32, 99, 104, 111, 111, 115, 101, 32, 87, 97, 118, 101, 51, 50, 32, 118, 115, 32, 87, 97,
    118, 101, 54, 52, 32, 109, 111, 100, 101, 32, 40, 100, 101, 102, 97, 117, 108, 116, 41, 32, 51, 50, 32, 45, 32, 82,
    117, 110, 32, 105, 110, 32, 87, 97, 118, 101, 51, 50, 32, 109, 111, 100, 101, 32, 54, 52, 32, 45, 32, 82, 117, 110,
    32, 105, 110, 32, 87, 97, 118, 101, 54, 52, 32, 109, 111, 100, 101, 32, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58,
    32, 91, 34, 83, 80, 73, 82, 86, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117,
    108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 48, 125, 44, 32, 34, 84, 121, 112,
    101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109,
    101, 34, 58, 32, 34, 99, 115, 87, 97, 118, 101, 83, 105, 122, 101, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34,
    67, 115, 87, 97, 118, 101, 83, 105, 122, 101, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105,
    118, 101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 50, 54, 55, 57, 57, 48, 49, 53, 53,
    125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 69, 110, 97, 98, 108,
    101, 32, 78, 71, 71, 32, 109, 111, 100, 101, 44, 32, 117, 115, 101, 32, 97, 110, 32, 105, 109, 112, 108, 105, 99,
    105, 116, 32, 112, 114, 105, 109, 105, 116, 105, 118, 101, 32, 115, 104, 97, 100, 101, 114, 32, 111, 110, 32, 97,
    32, 112, 101, 114, 45, 112, 105, 112, 101, 108, 105, 110, 101, 32, 116, 121, 112, 101, 32, 98, 97, 115, 105, 115,
    46, 32, 85, 115, 101, 32, 116, 104, 105, 115, 32, 105, 110, 115, 116, 101, 97, 100, 32, 111, 102, 32, 80, 65, 76,
    32, 115, 101, 116, 116, 105, 110, 103, 44, 32, 78, 103, 103, 69, 110, 97, 98, 108, 101, 77, 111, 100, 101, 46, 34,
    44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 80, 73, 82, 86, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93,
    44, 32, 34, 70, 108, 97, 103, 115, 34, 58, 32, 123, 34, 73, 115, 72, 101, 120, 34, 58, 32, 116, 114, 117, 101, 44,
    32, 34, 73, 115, 66, 105, 116, 109, 97, 115, 107, 34, 58, 32, 116, 114, 117, 101, 125, 44, 32, 34, 68, 101, 102, 97,
    117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 52, 50, 57, 52, 57, 54, 55,
    50, 57, 53, 125, 44, 32, 34, 86, 97, 108, 105, 100, 86, 97, 108, 117, 101, 115, 34, 58, 32, 123, 34, 78, 97, 109,
    101, 34, 58, 32, 34, 71, 114, 97, 112, 104, 105, 99, 115, 80, 105, 112, 101, 108, 105, 110, 101, 84, 121, 112, 101,
    34, 125, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114,
    105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 101, 110, 97, 98, 108, 101, 78, 103, 103, 34, 44, 32, 34,
    78, 97, 109, 101, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 78, 103, 103, 34, 44, 32, 34, 83, 99, 111, 112, 101,
    34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 49, 48,
    57, 56, 55, 54, 54, 55, 56, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 78, 103, 103, 69, 110, 97, 98,
    108, 101, 71, 115, 85, 115, 101, 34, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32,
    34, 91, 76, 76, 80, 67, 32, 79, 78, 76, 89, 93, 32, 69, 110, 97, 98, 108, 101, 32, 78, 71, 71, 32, 117, 115, 101,
    32, 111, 110, 32, 103, 101, 111, 109, 101, 116, 114, 121, 32, 115, 104, 97, 100, 101, 114, 46, 34, 44, 32, 34, 84,
    97, 103, 115, 34, 58, 32, 91, 34, 83, 80, 73, 82, 86, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 68,
    101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108,
    115, 101, 125, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105,
    97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 110, 103, 103, 69, 110, 97, 98, 108, 101, 71, 115, 85, 115, 101,
    34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 72, 97, 115,
    104, 78, 97, 109, 101, 34, 58, 32, 50, 54, 49, 50, 50, 53, 56, 54, 48, 53, 125, 44, 32, 123, 34, 68, 101, 115, 99,
    114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 91, 76, 76, 80, 67, 32, 79, 78, 76, 89, 93, 32, 70, 111, 114, 99,
    101, 32, 78, 71, 71, 32, 116, 111, 32, 114, 117, 110, 32, 105, 110, 32, 110, 111, 110, 32, 112, 97, 115, 115, 45,
    116, 104, 114, 111, 117, 103, 104, 32, 109, 111, 100, 101, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34,
    83, 80, 73, 82, 86, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115,
    34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115, 101, 125, 44, 32, 34, 84, 121,
    112, 101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101,
    34, 58, 32, 34, 110, 103, 103, 70, 111, 114, 99, 101, 78, 111, 110, 80, 97, 115, 115, 116, 104, 114, 111, 117, 103,
    104, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 78, 103, 103, 70, 111, 114, 99, 101, 78, 111, 110, 80, 97,
    115, 115, 116, 104, 114, 111, 117, 103, 104, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105,
    118, 101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 49, 52, 53, 51, 57, 53, 56, 51, 50,
    49, 125, 44, 32, 123, 34, 86, 97, 108, 105, 100, 86, 97, 108, 117, 101, 115, 34, 58, 32, 123, 34, 73, 115, 69, 110,
    117, 109, 34, 58, 32, 116, 114, 117, 101, 44, 32, 34, 86, 97, 108, 117, 101, 115, 34, 58, 32, 91, 123, 34, 78, 97,
    109, 101, 34, 58, 32, 34, 78, 103, 103, 67, 111, 109, 112, 97, 99, 116, 83, 117, 98, 103, 114, 111, 117, 112, 34,
    44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 48, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 78, 103,
    103, 67, 111, 109, 112, 97, 99, 116, 86, 101, 114, 116, 105, 99, 101, 115, 34, 44, 32, 34, 86, 97, 108, 117, 101,
    34, 58, 32, 49, 125, 93, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 78, 103, 103, 67, 111, 109, 112, 97, 99, 116,
    77, 111, 100, 101, 34, 125, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 67,
    111, 109, 112, 97, 99, 116, 105, 111, 110, 32, 109, 111, 100, 101, 32, 97, 102, 116, 101, 114, 32, 99, 117, 108,
    108, 105, 110, 103, 32, 111, 112, 101, 114, 97, 116, 105, 111, 110, 115, 46, 32, 48, 32, 45, 32, 67, 111, 109, 112,
    97, 99, 116, 105, 111, 110, 32, 105, 115, 32, 98, 97, 115, 101, 100, 32, 111, 110, 32, 116, 104, 101, 32, 119, 104,
    111, 108, 101, 32, 115, 117, 98, 45, 103, 114, 111, 117, 112, 32, 49, 32, 45, 32, 67, 111, 109, 112, 97, 99, 116,
    105, 111, 110, 32, 105, 115, 32, 98, 97, 115, 101, 100, 32, 111, 110, 32, 118, 101, 114, 116, 105, 99, 101, 115, 32,
    34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 80, 73, 82, 86, 32, 79, 112, 116, 105, 111, 110, 115, 34,
    93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58,
    32, 34, 78, 103, 103, 67, 111, 109, 112, 97, 99, 116, 86, 101, 114, 116, 105, 99, 101, 115, 34, 125, 44, 32, 34, 84,
    121, 112, 101, 34, 58, 32, 34, 101, 110, 117, 109, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109,
    101, 34, 58, 32, 34, 110, 103, 103, 67, 111, 109, 112, 97, 99, 116, 105, 111, 110, 77, 111, 100, 101, 34, 44, 32,
    34, 78, 97, 109, 101, 34, 58, 32, 34, 78, 103, 103, 67, 111, 109, 112, 97, 99, 116, 105, 111, 110, 77, 111, 100,
    101, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 72, 97,
    115, 104, 78, 97, 109, 101, 34, 58, 32, 51, 55, 52, 50, 55, 56, 50, 48, 48, 53, 125, 44, 32, 123, 34, 68, 101, 115,
    99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 91, 76, 76, 80, 67, 32, 79, 78, 76, 89, 93, 32, 65, 108, 119,
    97, 121, 115, 32, 117, 115, 101, 32, 112, 114, 105, 109, 105, 116, 105, 118, 101, 32, 115, 104, 97, 100, 101, 114,
    32, 116, 97, 98, 108, 101, 32, 116, 111, 32, 102, 101, 116, 99, 104, 32, 99, 117, 108, 108, 105, 110, 103, 45, 99,
    111, 110, 116, 114, 111, 108, 32, 114, 101, 103, 105, 115, 116, 101, 114, 115, 46, 34, 44, 32, 34, 84, 97, 103, 115,
    34, 58, 32, 91, 34, 83, 80, 73, 82, 86, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 68, 101, 102, 97,
    117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 116, 114, 117, 101, 125, 44,
    32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101,
    78, 97, 109, 101, 34, 58, 32, 34, 110, 103, 103, 65, 108, 119, 97, 121, 115, 85, 115, 101, 80, 114, 105, 109, 83,
    104, 97, 100, 101, 114, 84, 97, 98, 108, 101, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 78, 103, 103, 65,
    108, 119, 97, 121, 115, 85, 115, 101, 80, 114, 105, 109, 83, 104, 97, 100, 101, 114, 84, 97, 98, 108, 101, 34, 44,
    32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78,
    97, 109, 101, 34, 58, 32, 49, 51, 51, 56, 55, 57, 57, 48, 57, 54, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105,
    112, 116, 105, 111, 110, 34, 58, 32, 34, 67, 111, 110, 116, 114, 111, 108, 32, 78, 71, 71, 32, 98, 97, 99, 107, 102,
    97, 99, 101, 32, 99, 117, 108, 108, 105, 110, 103, 32, 97, 108, 103, 111, 114, 105, 116, 104, 109, 32, 40, 49, 32,
    126, 32, 85, 73, 78, 84, 51, 50, 95, 77, 65, 88, 44, 32, 48, 32, 100, 105, 115, 97, 98, 108, 101, 115, 32, 105, 116,
    41, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 80, 73, 82, 86, 32, 79, 112, 116, 105, 111, 110,
    115, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116,
    34, 58, 32, 48, 125, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86,
    97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 110, 103, 103, 66, 97, 99, 107, 102, 97, 99, 101,
    69, 120, 112, 111, 110, 101, 110, 116, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 78, 103, 103, 66, 97, 99,
    107, 102, 97, 99, 101, 69, 120, 112, 111, 110, 101, 110, 116, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34,
    68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 51, 48, 52, 51, 54, 50,
    51, 49, 57, 52, 125, 44, 32, 123, 34, 86, 97, 108, 105, 100, 86, 97, 108, 117, 101, 115, 34, 58, 32, 123, 34, 73,
    115, 69, 110, 117, 109, 34, 58, 32, 116, 114, 117, 101, 44, 32, 34, 86, 97, 108, 117, 101, 115, 34, 58, 32, 91, 123,
    34, 78, 97, 109, 101, 34, 58, 32, 34, 78, 103, 103, 83, 117, 98, 103, 114, 111, 117, 112, 65, 117, 116, 111, 34, 44,
    32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 48, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34,
    58, 32, 34, 83, 117, 98, 45, 103, 114, 111, 117, 112, 32, 115, 105, 122, 101, 32, 105, 115, 32, 97, 108, 108, 111,
    99, 97, 116, 101, 100, 32, 97, 115, 32, 111, 112, 116, 105, 109, 97, 108, 108, 121, 32, 100, 101, 116, 101, 114,
    109, 105, 110, 101, 100, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 78, 103, 103, 83, 117, 98, 103,
    114, 111, 117, 112, 77, 97, 120, 105, 109, 117, 109, 83, 105, 122, 101, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34,
    58, 32, 49, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 83, 117, 98, 45, 103,
    114, 111, 117, 112, 32, 115, 105, 122, 101, 32, 105, 115, 32, 97, 108, 108, 111, 99, 97, 116, 101, 100, 32, 116,
    111, 32, 116, 104, 101, 32, 109, 97, 120, 105, 109, 117, 109, 32, 97, 108, 108, 111, 119, 97, 98, 108, 101, 32, 115,
    105, 122, 101, 32, 98, 121, 32, 116, 104, 101, 32, 104, 97, 114, 100, 119, 97, 114, 101, 34, 125, 44, 32, 123, 34,
    78, 97, 109, 101, 34, 58, 32, 34, 78, 103, 103, 83, 117, 98, 103, 114, 111, 117, 112, 72, 97, 108, 102, 83, 105,
    122, 101, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 50, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116,
    105, 111, 110, 34, 58, 32, 34, 83, 117, 98, 45, 103, 114, 111, 117, 112, 32, 115, 105, 122, 101, 32, 105, 115, 32,
    97, 108, 108, 111, 99, 97, 116, 101, 100, 32, 97, 115, 32, 116, 111, 32, 97, 108, 108, 111, 119, 32, 104, 97, 108,
    102, 32, 111, 102, 32, 116, 104, 101, 32, 109, 97, 120, 105, 109, 117, 109, 32, 97, 108, 108, 111, 119, 97, 98, 108,
    101, 32, 115, 105, 122, 101, 32, 98, 121, 32, 116, 104, 101, 32, 104, 97, 114, 100, 119, 97, 114, 101, 34, 125, 44,
    32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 78, 103, 103, 83, 117, 98, 103, 114, 111, 117, 112, 79, 112, 116,
    105, 109, 105, 122, 101, 70, 111, 114, 86, 101, 114, 116, 115, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32,
    51, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 83, 117, 98, 45, 103, 114, 111,
    117, 112, 32, 115, 105, 122, 101, 32, 105, 115, 32, 111, 112, 116, 105, 109, 105, 122, 101, 100, 32, 102, 111, 114,
    32, 118, 101, 114, 116, 101, 120, 32, 116, 104, 114, 101, 97, 100, 32, 117, 116, 105, 108, 105, 122, 97, 116, 105,
    111, 110, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 78, 103, 103, 83, 117, 98, 103, 114, 111, 117,
    112, 79, 112, 116, 105, 109, 105, 122, 101, 70, 111, 114, 80, 114, 105, 109, 115, 34, 44, 32, 34, 86, 97, 108, 117,
    101, 34, 58, 32, 52, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 83, 117, 98,
    45, 103, 114, 111, 117, 112, 32, 115, 105, 122, 101, 32, 105, 115, 32, 111, 112, 116, 105, 109, 105, 122, 101, 100,
    32, 102, 111, 114, 32, 112, 114, 105, 109, 105, 116, 105, 118, 101, 32, 116, 104, 114, 101, 97, 100, 32, 117, 116,
    105, 108, 105, 122, 97, 116, 105, 111, 110, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 78, 103,
    103, 83, 117, 98, 103, 114, 111, 117, 112, 69, 120, 112, 108, 105, 99, 105, 116, 34, 44, 32, 34, 86, 97, 108, 117,
    101, 34, 58, 32, 53, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 83, 117, 98,
    45, 103, 114, 111, 117, 112, 32, 115, 105, 122, 101, 32, 105, 115, 32, 97, 108, 108, 111, 99, 97, 116, 101, 100, 32,
    98, 97, 115, 101, 100, 32, 111, 110, 32, 101, 120, 112, 108, 105, 99, 105, 116, 108, 121, 45, 115, 112, 101, 99,
    105, 102, 105, 101, 100, 32, 118, 101, 114, 116, 115, 80, 101, 114, 83, 117, 98, 103, 114, 111, 117, 112, 32, 97,
    110, 100, 32, 112, 114, 105, 109, 115, 80, 101, 114, 83, 117, 98, 103, 114, 111, 117, 112, 34, 125, 93, 44, 32, 34,
    78, 97, 109, 101, 34, 58, 32, 34, 78, 103, 103, 83, 117, 98, 103, 114, 111, 117, 112, 83, 105, 122, 105, 110, 103,
    84, 121, 112, 101, 34, 125, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 68,
    101, 102, 105, 110, 101, 32, 118, 97, 114, 105, 111, 117, 115, 32, 115, 105, 122, 105, 110, 103, 32, 111, 112, 116,
    105, 111, 110, 115, 32, 111, 102, 32, 115, 117, 98, 45, 103, 114, 111, 117, 112, 32, 115, 105, 122, 101, 32, 102,
    111, 114, 32, 78, 71, 71, 32, 112, 114, 105, 109, 105, 116, 105, 118, 101, 32, 115, 104, 97, 100, 101, 114, 46, 34,
    44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 80, 73, 82, 86, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93,
    44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32,
    34, 78, 103, 103, 83, 117, 98, 103, 114, 111, 117, 112, 65, 117, 116, 111, 34, 125, 44, 32, 34, 84, 121, 112, 101,
    34, 58, 32, 34, 101, 110, 117, 109, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58,
    32, 34, 110, 103, 103, 83, 117, 98, 103, 114, 111, 117, 112, 83, 105, 122, 105, 110, 103, 34, 44, 32, 34, 78, 97,
    109, 101, 34, 58, 32, 34, 78, 103, 103, 83, 117, 98, 103, 114, 111, 117, 112, 83, 105, 122, 105, 110, 103, 34, 44,
    32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78,
    97, 109, 101, 34, 58, 32, 50, 51, 57, 49, 52, 48, 54, 48, 51, 54, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105,
    112, 116, 105, 111, 110, 34, 58, 32, 34, 80, 114, 101, 102, 101, 114, 114, 101, 100, 32, 110, 117, 109, 98, 101,
    114, 32, 111, 102, 32, 71, 83, 32, 112, 114, 105, 109, 105, 116, 105, 118, 101, 115, 32, 116, 111, 32, 112, 97, 99,
    107, 32, 105, 110, 116, 111, 32, 97, 32, 112, 114, 105, 109, 105, 116, 105, 118, 101, 32, 115, 104, 97, 100, 101,
    114, 32, 115, 117, 98, 45, 103, 114, 111, 117, 112, 32, 85, 115, 101, 32, 116, 104, 105, 115, 32, 105, 110, 115,
    116, 101, 97, 100, 32, 111, 102, 32, 80, 65, 76, 32, 115, 101, 116, 116, 105, 110, 103, 44, 32, 78, 103, 103, 80,
    114, 105, 109, 115, 80, 101, 114, 83, 117, 98, 103, 114, 111, 117, 112, 46, 32, 34, 44, 32, 34, 84, 97, 103, 115,
    34, 58, 32, 91, 34, 83, 80, 73, 82, 86, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 68, 101, 102, 97,
    117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 50, 53, 54, 125, 44, 32, 34,
    84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101,
    78, 97, 109, 101, 34, 58, 32, 34, 110, 103, 103, 80, 114, 105, 109, 115, 80, 101, 114, 83, 117, 98, 103, 114, 111,
    117, 112, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 78, 103, 103, 80, 114, 105, 109, 115, 80, 101, 114, 83,
    117, 98, 103, 114, 111, 117, 112, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101,
    114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 57, 53, 56, 52, 53, 56, 49, 51, 48, 125, 44,
    32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 80, 114, 101, 102, 101, 114, 114,
    101, 100, 32, 110, 117, 109, 98, 101, 114, 32, 111, 102, 32, 118, 101, 114, 116, 105, 99, 101, 115, 32, 99, 111,
    110, 115, 117, 109, 101, 100, 32, 98, 121, 32, 97, 32, 112, 114, 105, 109, 105, 116, 105, 118, 101, 32, 115, 104,
    97, 100, 101, 114, 32, 115, 117, 98, 45, 103, 114, 111, 117, 112, 32, 85, 115, 101, 32, 116, 104, 105, 115, 32, 105,
    110, 115, 116, 101, 97, 100, 32, 111, 102, 32, 80, 65, 76, 32, 115, 101, 116, 116, 105, 110, 103, 44, 32, 78, 103,
    103, 86, 101, 114, 116, 115, 80, 101, 114, 83, 117, 98, 103, 114, 111, 117, 112, 46, 32, 34, 44, 32, 34, 84, 97,
    103, 115, 34, 58, 32, 91, 34, 83, 80, 73, 82, 86, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 68, 101,
    102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 50, 53, 54, 125, 44,
    32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98,
    108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 110, 103, 103, 86, 101, 114, 116, 115, 80, 101, 114, 83, 117, 98, 103,
    114, 111, 117, 112, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 78, 103, 103, 86, 101, 114, 116, 115, 80, 101,
    114, 83, 117, 98, 103, 114, 111, 117, 112, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118,
    101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 50, 48, 48, 53, 57, 52, 52, 55, 57, 51,
    125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 69, 110, 97, 98, 108,
    101, 32, 99, 117, 108, 108, 105, 110, 103, 32, 111, 102, 32, 112, 114, 105, 109, 105, 116, 105, 118, 101, 115, 32,
    116, 104, 97, 116, 32, 100, 111, 110, 39, 116, 32, 109, 101, 101, 116, 32, 102, 97, 99, 105, 110, 103, 32, 99, 114,
    105, 116, 101, 114, 105, 97, 46, 32, 85, 115, 101, 32, 116, 104, 105, 115, 32, 105, 110, 115, 116, 101, 97, 100, 32,
    111, 102, 32, 80, 65, 76, 32, 115, 101, 116, 116, 105, 110, 103, 44, 32, 69, 110, 97, 98, 108, 101, 66, 97, 99, 107,
    102, 97, 99, 101, 67, 117, 108, 108, 77, 97, 115, 107, 46, 32, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34,
    83, 80, 73, 82, 86, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115,
    34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115, 101, 125, 44, 32, 34, 84, 121,
    112, 101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101,
    34, 58, 32, 34, 110, 103, 103, 69, 110, 97, 98, 108, 101, 66, 97, 99, 107, 102, 97, 99, 101, 67, 117, 108, 108, 105,
    110, 103, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 78, 103, 103, 69, 110, 97, 98, 108, 101, 66, 97, 99,
    107, 102, 97, 99, 101, 67, 117, 108, 108, 105, 110, 103, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68,
    114, 105, 118, 101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 51, 52, 50, 56, 57, 48, 55,
    51, 49, 56, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 69, 110, 97,
    98, 108, 101, 32, 100, 105, 115, 99, 97, 114, 100, 105, 110, 103, 32, 111, 102, 32, 112, 114, 105, 109, 105, 116,
    105, 118, 101, 115, 32, 111, 117, 116, 115, 105, 100, 101, 32, 111, 102, 32, 118, 105, 101, 119, 32, 102, 114, 117,
    115, 116, 117, 109, 46, 32, 85, 115, 101, 32, 116, 104, 105, 115, 32, 105, 110, 115, 116, 101, 97, 100, 32, 111,
    102, 32, 80, 65, 76, 32, 115, 101, 116, 116, 105, 110, 103, 44, 32, 69, 110, 97, 98, 108, 101, 65, 99, 99, 117, 114,
    97, 116, 101, 70, 114, 117, 115, 116, 117, 109, 67, 117, 108, 108, 77, 97, 115, 107, 46, 32, 34, 44, 32, 34, 84, 97,
    103, 115, 34, 58, 32, 91, 34, 83, 80, 73, 82, 86, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 68, 101,
    102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115,
    101, 125, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97,
    98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 110, 103, 103, 69, 110, 97, 98, 108, 101, 70, 114, 117, 115, 116,
    117, 109, 67, 117, 108, 108, 105, 110, 103, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 78, 103, 103, 69, 110,
    97, 98, 108, 101, 70, 114, 117, 115, 116, 117, 109, 67, 117, 108, 108, 105, 110, 103, 34, 44, 32, 34, 83, 99, 111,
    112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58,
    32, 49, 50, 50, 48, 56, 50, 48, 56, 50, 54, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111,
    110, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 32, 115, 105, 109, 112, 108, 101, 114, 32, 102, 114, 117, 115, 116,
    117, 109, 32, 99, 117, 108, 108, 101, 114, 32, 116, 104, 97, 116, 32, 105, 115, 32, 108, 101, 115, 115, 32, 97, 99,
    99, 117, 114, 97, 116, 101, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 80, 73, 82, 86, 32, 79,
    112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68,
    101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115, 101, 125, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34,
    98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 110, 103,
    103, 69, 110, 97, 98, 108, 101, 66, 111, 120, 70, 105, 108, 116, 101, 114, 67, 117, 108, 108, 105, 110, 103, 34, 44,
    32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 78, 103, 103, 69, 110, 97, 98, 108, 101, 66, 111, 120, 70, 105, 108, 116,
    101, 114, 67, 117, 108, 108, 105, 110, 103, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105,
    118, 101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 49, 53, 50, 51, 54, 53, 48, 51, 50,
    57, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 69, 110, 97, 98, 108,
    101, 32, 102, 114, 117, 115, 116, 117, 109, 32, 99, 117, 108, 108, 105, 110, 103, 32, 98, 97, 115, 101, 100, 32,
    111, 110, 32, 97, 32, 115, 112, 104, 101, 114, 101, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83,
    80, 73, 82, 86, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34,
    58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115, 101, 125, 44, 32, 34, 84, 121, 112,
    101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34,
    58, 32, 34, 110, 103, 103, 69, 110, 97, 98, 108, 101, 83, 112, 104, 101, 114, 101, 67, 117, 108, 108, 105, 110, 103,
    34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 78, 103, 103, 69, 110, 97, 98, 108, 101, 83, 112, 104, 101, 114,
    101, 67, 117, 108, 108, 105, 110, 103, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118,
    101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 49, 50, 55, 53, 54, 55, 51, 54, 57, 57,
    125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 69, 110, 97, 98, 108,
    101, 32, 116, 114, 105, 118, 105, 97, 108, 32, 115, 117, 98, 45, 115, 97, 109, 112, 108, 101, 32, 112, 114, 105,
    109, 105, 116, 105, 118, 101, 32, 99, 117, 108, 108, 105, 110, 103, 46, 32, 85, 115, 101, 32, 116, 104, 105, 115,
    32, 105, 110, 115, 116, 101, 97, 100, 32, 111, 102, 32, 80, 65, 76, 32, 115, 101, 116, 116, 105, 110, 103, 44, 32,
    69, 110, 97, 98, 108, 101, 83, 109, 97, 108, 108, 80, 114, 105, 109, 70, 105, 108, 116, 101, 114, 77, 97, 115, 107,
    46, 32, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 80, 73, 82, 86, 32, 79, 112, 116, 105, 111, 110,
    115, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116,
    34, 58, 32, 102, 97, 108, 115, 101, 125, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44,
    32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 110, 103, 103, 69, 110, 97, 98, 108,
    101, 83, 109, 97, 108, 108, 80, 114, 105, 109, 70, 105, 108, 116, 101, 114, 34, 44, 32, 34, 78, 97, 109, 101, 34,
    58, 32, 34, 78, 103, 103, 69, 110, 97, 98, 108, 101, 83, 109, 97, 108, 108, 80, 114, 105, 109, 70, 105, 108, 116,
    101, 114, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 72,
    97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 50, 48, 55, 54, 54, 49, 53, 49, 49, 55, 125, 44, 32, 123, 34, 68, 101,
    115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 32, 99, 117, 108, 108, 105,
    110, 103, 32, 119, 104, 101, 110, 32, 99, 117, 108, 108, 32, 100, 105, 115, 116, 97, 110, 99, 101, 32, 101, 120,
    112, 111, 114, 116, 115, 32, 97, 114, 101, 32, 112, 114, 101, 115, 101, 110, 116, 46, 34, 44, 32, 34, 84, 97, 103,
    115, 34, 58, 32, 91, 34, 83, 80, 73, 82, 86, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 68, 101, 102,
    97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115, 101,
    125, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98,
    108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 110, 103, 103, 69, 110, 97, 98, 108, 101, 67, 117, 108, 108, 68, 105,
    115, 116, 97, 110, 99, 101, 67, 117, 108, 108, 105, 110, 103, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 78,
    103, 103, 69, 110, 97, 98, 108, 101, 67, 117, 108, 108, 68, 105, 115, 116, 97, 110, 99, 101, 67, 117, 108, 108, 105,
    110, 103, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 72,
    97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 49, 55, 56, 57, 52, 53, 55, 50, 51, 55, 125, 44, 32, 123, 34, 68, 101,
    115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 70, 111, 114, 99, 101, 32, 72, 87, 32, 116, 111, 32,
    103, 117, 97, 114, 97, 110, 116, 101, 101, 32, 102, 111, 114, 119, 97, 114, 100, 32, 112, 114, 111, 103, 114, 101,
    115, 115, 32, 112, 101, 114, 32, 119, 97, 118, 101, 32, 111, 110, 32, 71, 70, 88, 49, 48, 32, 48, 120, 48, 48, 48,
    48, 48, 48, 48, 48, 32, 45, 32, 68, 105, 115, 97, 98, 108, 101, 32, 40, 100, 101, 102, 97, 117, 108, 116, 41, 32,
    48, 120, 48, 48, 48, 48, 48, 48, 48, 49, 32, 45, 32, 69, 110, 97, 98, 108, 101, 32, 102, 111, 114, 32, 118, 101,
    114, 116, 101, 120, 32, 115, 104, 97, 100, 101, 114, 115, 32, 48, 120, 48, 48, 48, 48, 48, 48, 48, 50, 32, 45, 32,
    69, 110, 97, 98, 108, 101, 32, 102, 111, 114, 32, 116, 101, 115, 115, 101, 108, 108, 97, 116, 105, 111, 110, 32, 99,
    111, 110, 116, 114, 111, 108, 32, 115, 104, 97, 100, 101, 114, 115, 32, 48, 120, 48, 48, 48, 48, 48, 48, 48, 52, 32,
    45, 32, 69, 110, 97, 98, 108, 101, 32, 102, 111, 114, 32, 116, 101, 115, 115, 101, 108, 108, 97, 116, 105, 111, 110,
    32, 101, 118, 97, 108, 117, 97, 116, 105, 111, 110, 32, 115, 104, 97, 100, 101, 114, 115, 32, 48, 120, 48, 48, 48,
    48, 48, 48, 48, 56, 32, 45, 32, 69, 110, 97, 98, 108, 101, 32, 102, 111, 114, 32, 103, 101, 111, 109, 101, 116, 114,
    121, 32, 115, 104, 97, 100, 101, 114, 115, 32, 48, 120, 48, 48, 48, 48, 48, 48, 49, 48, 32, 45, 32, 69, 110, 97, 98,
    108, 101, 32, 102, 111, 114, 32, 102, 114, 97, 103, 109, 101, 110, 116, 32, 115, 104, 97, 100, 101, 114, 115, 32,
    48, 120, 48, 48, 48, 48, 48, 48, 50, 48, 32, 45, 32, 69, 110, 97, 98, 108, 101, 32, 102, 111, 114, 32, 99, 111, 109,
    112, 117, 116, 101, 32, 115, 104, 97, 100, 101, 114, 115, 32, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34,
    83, 80, 73, 82, 86, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 70, 108, 97, 103, 115, 34, 58, 32,
    123, 34, 73, 115, 72, 101, 120, 34, 58, 32, 116, 114, 117, 101, 125, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116,
    115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 48, 125, 44, 32, 34, 84, 121, 112, 101, 34,
    58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34,
    58, 32, 34, 101, 110, 97, 98, 108, 101, 70, 111, 114, 119, 97, 114, 100, 80, 114, 111, 103, 114, 101, 115, 115, 34,
    44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 70, 111, 114, 119, 97, 114, 100, 80, 114,
    111, 103, 114, 101, 115, 115, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114,
    34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 51, 50, 56, 53, 51, 49, 55, 55, 52, 48, 125, 44, 32,
    123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 65, 108, 108, 111, 99, 97, 116, 101,
    32, 119, 97, 118, 101, 115, 32, 102, 111, 114, 32, 101, 120, 101, 99, 117, 116, 105, 111, 110, 32, 119, 105, 116,
    104, 32, 52, 32, 83, 73, 77, 68, 115, 32, 40, 87, 71, 80, 41, 32, 105, 110, 115, 116, 101, 97, 100, 32, 111, 102,
    32, 108, 101, 116, 116, 105, 110, 103, 32, 116, 104, 101, 32, 99, 111, 109, 112, 105, 108, 101, 114, 32, 99, 104,
    111, 111, 115, 101, 32, 32, 87, 71, 80, 32, 118, 115, 32, 67, 85, 32, 40, 50, 32, 83, 73, 77, 68, 115, 41, 32, 111,
    110, 32, 71, 70, 88, 49, 48, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 80, 73, 82, 86, 32, 79, 112,
    116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101,
    102, 97, 117, 108, 116, 34, 58, 32, 48, 125, 44, 32, 34, 86, 97, 108, 105, 100, 86, 97, 108, 117, 101, 115, 34, 58,
    32, 123, 34, 86, 97, 108, 117, 101, 115, 34, 58, 32, 91, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111,
    110, 34, 58, 32, 34, 67, 111, 109, 112, 105, 108, 101, 114, 32, 99, 104, 111, 111, 115, 101, 115, 32, 40, 100, 101,
    102, 97, 117, 108, 116, 41, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 48, 125, 44, 32, 123, 34, 68, 101,
    115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 32, 102, 111, 114, 32, 118,
    101, 114, 116, 101, 120, 32, 115, 104, 97, 100, 101, 114, 115, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32,
    49, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 69, 110, 97, 98, 108,
    101, 32, 102, 111, 114, 32, 116, 101, 115, 115, 101, 108, 108, 97, 116, 105, 111, 110, 32, 99, 111, 110, 116, 114,
    111, 108, 32, 115, 104, 97, 100, 101, 114, 115, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 50, 125, 44, 32,
    123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 32, 102,
    111, 114, 32, 116, 101, 115, 115, 101, 108, 108, 97, 116, 105, 111, 110, 32, 101, 118, 97, 108, 117, 97, 116, 105,
    111, 110, 32, 115, 104, 97, 100, 101, 114, 115, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 52, 125, 44, 32,
    123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 32, 102,
    111, 114, 32, 103, 101, 111, 109, 101, 116, 114, 121, 32, 115, 104, 97, 100, 101, 114, 115, 34, 44, 32, 34, 86, 97,
    108, 117, 101, 34, 58, 32, 56, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58,
    32, 34, 69, 110, 97, 98, 108, 101, 32, 102, 111, 114, 32, 102, 114, 97, 103, 109, 101, 110, 116, 32, 115, 104, 97,
    100, 101, 114, 115, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 54, 125, 44, 32, 123, 34, 68, 101, 115,
    99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 32, 102, 111, 114, 32, 99, 111,
    109, 112, 117, 116, 101, 32, 115, 104, 97, 100, 101, 114, 115, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32,
    51, 50, 125, 93, 125, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 70,
    108, 97, 103, 115, 34, 58, 32, 123, 34, 73, 115, 72, 101, 120, 34, 58, 32, 116, 114, 117, 101, 125, 44, 32, 34, 86,
    97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 101, 110, 97, 98, 108, 101, 87, 103, 112, 77, 111,
    100, 101, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 87, 103, 112, 77, 111, 100,
    101, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 72, 97,
    115, 104, 78, 97, 109, 101, 34, 58, 32, 51, 53, 50, 53, 56, 55, 52, 56, 54, 51, 125, 44, 32, 123, 34, 68, 101, 115,
    99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 67, 104, 111, 111, 115, 101, 32, 97, 32, 114, 101, 103, 105,
    111, 110, 32, 115, 105, 122, 101, 44, 32, 105, 102, 32, 97, 110, 121, 44, 32, 116, 111, 32, 102, 111, 114, 99, 101,
    32, 116, 104, 101, 32, 101, 110, 100, 32, 111, 102, 32, 116, 104, 101, 32, 119, 97, 118, 101, 102, 114, 111, 110,
    116, 32, 98, 101, 102, 111, 114, 101, 32, 116, 104, 101, 32, 110, 101, 120, 116, 32, 97, 118, 97, 105, 108, 97, 98,
    108, 101, 32, 113, 117, 97, 100, 32, 116, 104, 97, 116, 32, 102, 97, 108, 108, 115, 32, 111, 117, 116, 115, 105,
    100, 101, 32, 116, 104, 101, 32, 114, 101, 103, 105, 111, 110, 46, 32, 48, 120, 48, 32, 45, 32, 78, 111, 110, 101,
    32, 32, 32, 32, 32, 45, 32, 78, 111, 32, 119, 97, 118, 101, 32, 98, 114, 101, 97, 107, 32, 98, 121, 32, 114, 101,
    103, 105, 111, 110, 32, 48, 120, 49, 32, 45, 32, 56, 120, 56, 32, 32, 32, 32, 32, 32, 45, 32, 66, 114, 101, 97, 107,
    32, 111, 117, 116, 115, 105, 100, 101, 32, 97, 32, 56, 120, 56, 32, 112, 105, 120, 101, 108, 32, 114, 101, 103, 105,
    111, 110, 32, 48, 120, 50, 32, 45, 32, 49, 54, 120, 49, 54, 32, 32, 32, 32, 45, 32, 66, 114, 101, 97, 107, 32, 111,
    117, 116, 115, 105, 100, 101, 32, 97, 32, 49, 54, 120, 49, 54, 32, 112, 105, 120, 101, 108, 32, 114, 101, 103, 105,
    111, 110, 32, 48, 120, 51, 32, 45, 32, 51, 50, 120, 51, 50, 32, 32, 32, 32, 45, 32, 66, 114, 101, 97, 107, 32, 111,
    117, 116, 115, 105, 100, 101, 32, 97, 32, 51, 50, 120, 51, 50, 32, 112, 105, 120, 101, 108, 32, 114, 101, 103, 105,
    111, 110, 32, 48, 120, 70, 32, 45, 32, 68, 114, 97, 119, 84, 105, 109, 101, 32, 45, 32, 67, 104, 111, 111, 115, 101,
    32, 119, 97, 118, 101, 32, 98, 114, 101, 97, 107, 32, 115, 105, 122, 101, 32, 112, 101, 114, 32, 100, 114, 97, 119,
    32, 40, 100, 101, 102, 97, 117, 108, 116, 41, 32, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 80, 73,
    82, 86, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 70, 108, 97, 103, 115, 34, 58, 32, 123, 34, 73,
    115, 72, 101, 120, 34, 58, 32, 116, 114, 117, 101, 125, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58,
    32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 49, 53, 125, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32,
    34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32,
    34, 119, 97, 118, 101, 66, 114, 101, 97, 107, 83, 105, 122, 101, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34,
    87, 97, 118, 101, 66, 114, 101, 97, 107, 83, 105, 122, 101, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34,
    68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 54, 54, 56, 49, 57, 56,
    54, 49, 48, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 84, 104, 105,
    115, 32, 111, 112, 116, 105, 111, 110, 32, 105, 115, 32, 118, 97, 108, 105, 100, 32, 119, 104, 101, 110, 32, 69,
    110, 97, 98, 108, 101, 68, 114, 111, 112, 80, 105, 112, 101, 108, 105, 110, 101, 66, 105, 110, 97, 114, 121, 73,
    110, 115, 116, 32, 105, 115, 32, 115, 101, 116, 32, 116, 111, 32, 116, 114, 117, 101, 46, 32, 73, 116, 32, 115, 104,
    111, 117, 108, 100, 32, 98, 101, 32, 115, 112, 101, 99, 105, 102, 105, 101, 100, 32, 119, 105, 116, 104, 32, 116,
    104, 101, 32, 104, 101, 120, 32, 118, 97, 108, 117, 101, 32, 111, 102, 32, 102, 105, 114, 115, 116, 32, 100, 119,
    111, 114, 100, 32, 111, 102, 32, 105, 110, 115, 116, 114, 117, 99, 116, 105, 111, 110, 46, 32, 70, 111, 114, 32,
    101, 120, 97, 109, 112, 108, 101, 58, 32, 68, 114, 111, 112, 80, 105, 112, 101, 108, 105, 110, 101, 66, 105, 110,
    97, 114, 121, 73, 110, 115, 116, 84, 111, 107, 101, 110, 44, 48, 120, 69, 49, 48, 56, 52, 48, 48, 48, 34, 44, 32,
    34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 80, 73, 82, 86, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32,
    34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 48, 125,
    44, 32, 34, 68, 101, 112, 101, 110, 100, 115, 79, 110, 34, 58, 32, 123, 34, 83, 101, 116, 116, 105, 110, 103, 115,
    34, 58, 32, 91, 123, 34, 86, 97, 108, 117, 101, 115, 34, 58, 32, 91, 116, 114, 117, 101, 93, 44, 32, 34, 78, 97,
    109, 101, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 68, 114, 111, 112, 80, 105, 112, 101, 108, 105, 110, 101, 66,
    105, 110, 97, 114, 121, 73, 110, 115, 116, 34, 125, 93, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68,
    114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32,
    34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 100, 114, 111, 112, 80, 105, 112, 101,
    108, 105, 110, 101, 66, 105, 110, 97, 114, 121, 73, 110, 115, 116, 84, 111, 107, 101, 110, 34, 44, 32, 34, 78, 97,
    109, 101, 34, 58, 32, 34, 68, 114, 111, 112, 80, 105, 112, 101, 108, 105, 110, 101, 66, 105, 110, 97, 114, 121, 73,
    110, 115, 116, 84, 111, 107, 101, 110, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 49, 54, 56,
    50, 57, 51, 49, 53, 52, 48, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32,
    34, 84, 104, 105, 115, 32, 111, 112, 116, 105, 111, 110, 32, 105, 115, 32, 118, 97, 108, 105, 100, 32, 119, 104,
    101, 110, 32, 69, 110, 97, 98, 108, 101, 68, 114, 111, 112, 80, 105, 112, 101, 108, 105, 110, 101, 66, 105, 110, 97,
    114, 121, 73, 110, 115, 116, 32, 105, 115, 32, 115, 101, 116, 32, 116, 111, 32, 116, 114, 117, 101, 46, 32, 73, 116,
    32, 115, 104, 111, 117, 108, 100, 32, 98, 101, 32, 115, 112, 101, 99, 105, 102, 105, 101, 100, 32, 119, 105, 116,
    104, 32, 116, 104, 101, 32, 115, 105, 122, 101, 32, 105, 110, 32, 100, 119, 111, 114, 100, 32, 111, 102, 32, 105,
    110, 115, 116, 114, 117, 99, 116, 105, 111, 110, 32, 116, 111, 32, 98, 101, 32, 100, 114, 111, 112, 112, 101, 100,
    46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 80, 73, 82, 86, 32, 79, 112, 116, 105, 111, 110, 115,
    34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34,
    58, 32, 49, 125, 44, 32, 34, 68, 101, 112, 101, 110, 100, 115, 79, 110, 34, 58, 32, 123, 34, 83, 101, 116, 116, 105,
    110, 103, 115, 34, 58, 32, 91, 123, 34, 86, 97, 108, 117, 101, 115, 34, 58, 32, 91, 116, 114, 117, 101, 93, 44, 32,
    34, 78, 97, 109, 101, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 68, 114, 111, 112, 80, 105, 112, 101, 108, 105,
    110, 101, 66, 105, 110, 97, 114, 121, 73, 110, 115, 116, 34, 125, 93, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34,
    58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51,
    50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 100, 114, 111, 112, 80,
    105, 112, 101, 108, 105, 110, 101, 66, 105, 110, 97, 114, 121, 73, 110, 115, 116, 83, 105, 122, 101, 34, 44, 32, 34,
    78, 97, 109, 101, 34, 58, 32, 34, 68, 114, 111, 112, 80, 105, 112, 101, 108, 105, 110, 101, 66, 105, 110, 97, 114,
    121, 73, 110, 115, 116, 83, 105, 122, 101, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 51, 50,
    54, 53, 54, 48, 48, 48, 50, 50, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58,
    32, 34, 91, 66, 73, 76, 32, 79, 78, 76, 89, 93, 32, 71, 101, 110, 101, 114, 97, 116, 101, 32, 111, 112, 116, 105,
    109, 105, 122, 101, 100, 32, 73, 76, 32, 99, 111, 100, 101, 115, 32, 102, 111, 114, 32, 112, 101, 114, 102, 111,
    114, 109, 97, 110, 99, 101, 32, 112, 117, 114, 112, 111, 115, 101, 46, 32, 84, 104, 105, 115, 32, 109, 97, 121, 32,
    98, 114, 101, 97, 107, 32, 115, 111, 109, 101, 32, 112, 114, 101, 99, 105, 115, 105, 111, 110, 32, 114, 117, 108,
    101, 115, 32, 97, 110, 100, 32, 109, 97, 121, 32, 110, 111, 116, 32, 112, 114, 111, 100, 117, 99, 101, 32, 49, 48,
    48, 37, 32, 99, 111, 110, 102, 111, 114, 109, 105, 110, 103, 32, 73, 76, 32, 99, 111, 100, 101, 115, 46, 32, 84,
    104, 101, 114, 101, 102, 111, 114, 101, 44, 32, 116, 104, 101, 32, 111, 112, 116, 105, 111, 110, 32, 115, 104, 111,
    117, 108, 100, 32, 111, 110, 108, 121, 32, 98, 101, 32, 101, 110, 97, 98, 108, 101, 100, 32, 118, 105, 97, 32, 97,
    112, 112, 108, 105, 99, 97, 116, 105, 111, 110, 32, 112, 114, 111, 102, 105, 108, 101, 46, 34, 44, 32, 34, 84, 97,
    103, 115, 34, 58, 32, 91, 34, 83, 80, 73, 82, 86, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 68, 101,
    102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115,
    101, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121,
    112, 101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101,
    34, 58, 32, 34, 101, 110, 97, 98, 108, 101, 83, 112, 118, 80, 101, 114, 102, 79, 112, 116, 105, 109, 97, 108, 34,
    44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 83, 112, 118, 80, 101, 114, 102, 79, 112,
    116, 105, 109, 97, 108, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 56, 57, 50, 57, 50, 56, 49,
    49, 54, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 91, 66, 73, 76,
    32, 79, 78, 76, 89, 93, 32, 69, 110, 97, 98, 108, 101, 32, 83, 80, 73, 82, 45, 86, 32, 98, 105, 110, 97, 114, 121,
    32, 118, 97, 108, 105, 100, 97, 116, 105, 111, 110, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83,
    80, 73, 82, 86, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34,
    58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115, 101, 125, 44, 32, 34, 83, 99, 111,
    112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 98, 111,
    111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 101, 110, 97, 98,
    108, 101, 83, 112, 118, 86, 97, 108, 105, 100, 97, 116, 105, 111, 110, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32,
    34, 69, 110, 97, 98, 108, 101, 83, 112, 118, 86, 97, 108, 105, 100, 97, 116, 105, 111, 110, 34, 44, 32, 34, 72, 97,
    115, 104, 78, 97, 109, 101, 34, 58, 32, 50, 49, 53, 54, 49, 51, 53, 56, 48, 54, 125, 44, 32, 123, 34, 68, 101, 115,
    99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 91, 66, 73, 76, 32, 79, 78, 76, 89, 93, 32, 90, 101, 114,
    111, 32, 105, 110, 105, 116, 105, 97, 108, 105, 122, 101, 32, 65, 77, 68, 32, 73, 76, 32, 114, 101, 103, 105, 115,
    116, 101, 114, 115, 46, 32, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 80, 73, 82, 86, 32, 79, 112,
    116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101,
    102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115, 101, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34,
    68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34,
    86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 122, 101, 114, 111, 73, 110, 105, 116, 73,
    108, 82, 101, 103, 115, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 90, 101, 114, 111, 73, 110, 105, 116, 73,
    76, 82, 101, 103, 115, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 50, 51, 55, 49, 50, 50, 48,
    51, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 91, 66, 73, 76, 32,
    79, 78, 76, 89, 93, 32, 83, 107, 105, 112, 32, 117, 110, 115, 117, 112, 112, 111, 114, 116, 101, 100, 32, 83, 80,
    73, 82, 45, 86, 32, 105, 110, 115, 116, 114, 117, 99, 116, 105, 111, 110, 115, 46, 32, 34, 44, 32, 34, 84, 97, 103,
    115, 34, 58, 32, 91, 34, 83, 80, 73, 82, 86, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 68, 101, 102,
    97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115, 101,
    125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112,
    101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34,
    58, 32, 34, 115, 107, 105, 112, 85, 110, 115, 117, 112, 112, 111, 114, 116, 101, 100, 79, 112, 67, 111, 100, 101,
    34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 83, 107, 105, 112, 85, 110, 115, 117, 112, 112, 111, 114, 116,
    101, 100, 79, 112, 67, 111, 100, 101, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 49, 49, 54,
    49, 56, 49, 55, 55, 48, 51, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32,
    34, 70, 111, 114, 99, 101, 32, 118, 101, 114, 116, 101, 120, 32, 115, 104, 97, 100, 101, 114, 115, 39, 32, 111, 112,
    116, 105, 109, 105, 122, 97, 116, 105, 111, 110, 32, 73, 82, 32, 109, 111, 100, 101, 32, 115, 101, 108, 101, 99,
    116, 105, 111, 110, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 80, 73, 82, 86, 32, 79, 112, 116,
    105, 111, 110, 115, 34, 93, 44, 32, 34, 86, 97, 108, 105, 100, 86, 97, 108, 117, 101, 115, 34, 58, 32, 123, 34, 86,
    97, 108, 117, 101, 115, 34, 58, 32, 91, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32,
    34, 76, 101, 116, 32, 116, 104, 101, 32, 99, 111, 109, 112, 105, 108, 101, 114, 32, 99, 104, 111, 111, 115, 101, 32,
    116, 104, 101, 32, 73, 82, 32, 109, 111, 100, 101, 46, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 48, 125,
    44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 70, 111, 114, 99, 101, 32,
    116, 104, 101, 32, 99, 111, 109, 112, 105, 108, 101, 114, 32, 116, 111, 32, 117, 115, 101, 32, 79, 108, 100, 32, 73,
    82, 46, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105,
    112, 116, 105, 111, 110, 34, 58, 32, 34, 70, 111, 114, 99, 101, 32, 116, 104, 101, 32, 99, 111, 109, 112, 105, 108,
    101, 114, 32, 116, 111, 32, 117, 115, 101, 32, 78, 101, 119, 32, 73, 82, 32, 119, 105, 116, 104, 32, 114, 101, 116,
    114, 121, 32, 109, 101, 99, 104, 97, 110, 105, 115, 109, 46, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 50,
    125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 70, 111, 114, 99, 101,
    32, 116, 104, 101, 32, 99, 111, 109, 112, 105, 108, 101, 114, 32, 116, 111, 32, 117, 115, 101, 32, 78, 101, 119, 32,
    73, 82, 32, 119, 105, 116, 104, 32, 101, 114, 114, 111, 114, 32, 109, 101, 99, 104, 97, 110, 105, 115, 109, 46, 34,
    44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 51, 125, 93, 125, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115,
    34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 48, 125, 44, 32, 34, 84, 121, 112, 101, 34, 58,
    32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58,
    32, 34, 118, 115, 73, 114, 77, 111, 100, 101, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 86, 115, 73, 114,
    77, 111, 100, 101, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32,
    34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 50, 56, 49, 52, 54, 54, 48, 51, 50, 50, 125, 44, 32, 123, 34,
    68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 70, 111, 114, 99, 101, 32, 116, 101, 115, 115,
    101, 108, 108, 97, 116, 105, 111, 110, 32, 99, 111, 110, 116, 114, 111, 108, 32, 115, 104, 97, 100, 101, 114, 115,
    39, 32, 111, 112, 116, 105, 109, 105, 122, 97, 116, 105, 111, 110, 32, 73, 82, 32, 109, 111, 100, 101, 32, 115, 101,
    108, 101, 99, 116, 105, 111, 110, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 80, 73, 82, 86, 32,
    79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 86, 97, 108, 105, 100, 86, 97, 108, 117, 101, 115, 34, 58, 32,
    123, 34, 86, 97, 108, 117, 101, 115, 34, 58, 32, 91, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110,
    34, 58, 32, 34, 76, 101, 116, 32, 116, 104, 101, 32, 99, 111, 109, 112, 105, 108, 101, 114, 32, 99, 104, 111, 111,
    115, 101, 32, 116, 104, 101, 32, 73, 82, 32, 109, 111, 100, 101, 46, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58,
    32, 48, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 70, 111, 114, 99,
    101, 32, 116, 104, 101, 32, 99, 111, 109, 112, 105, 108, 101, 114, 32, 116, 111, 32, 117, 115, 101, 32, 79, 108,
    100, 32, 73, 82, 46, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 125, 44, 32, 123, 34, 68, 101, 115, 99,
    114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 70, 111, 114, 99, 101, 32, 116, 104, 101, 32, 99, 111, 109, 112,
    105, 108, 101, 114, 32, 116, 111, 32, 117, 115, 101, 32, 78, 101, 119, 32, 73, 82, 32, 119, 105, 116, 104, 32, 114,
    101, 116, 114, 121, 32, 109, 101, 99, 104, 97, 110, 105, 115, 109, 46, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34,
    58, 32, 50, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 70, 111, 114,
    99, 101, 32, 116, 104, 101, 32, 99, 111, 109, 112, 105, 108, 101, 114, 32, 116, 111, 32, 117, 115, 101, 32, 78, 101,
    119, 32, 73, 82, 32, 119, 105, 116, 104, 32, 101, 114, 114, 111, 114, 32, 109, 101, 99, 104, 97, 110, 105, 115, 109,
    46, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 51, 125, 93, 125, 44, 32, 34, 68, 101, 102, 97, 117, 108,
    116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 48, 125, 44, 32, 34, 84, 121, 112, 101,
    34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101,
    34, 58, 32, 34, 116, 99, 115, 73, 114, 77, 111, 100, 101, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 84, 99,
    115, 73, 114, 77, 111, 100, 101, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114,
    34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 50, 52, 56, 51, 52, 54, 49, 55, 53, 55, 125, 44, 32,
    123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 70, 111, 114, 99, 101, 32, 116, 101,
    115, 115, 101, 108, 108, 97, 116, 105, 111, 110, 32, 101, 118, 97, 108, 117, 97, 116, 105, 111, 110, 32, 115, 104,
    97, 100, 101, 114, 115, 39, 32, 111, 112, 116, 105, 109, 105, 122, 97, 116, 105, 111, 110, 32, 73, 82, 32, 109, 111,
    100, 101, 32, 115, 101, 108, 101, 99, 116, 105, 111, 110, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34,
    83, 80, 73, 82, 86, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 86, 97, 108, 105, 100, 86, 97, 108,
    117, 101, 115, 34, 58, 32, 123, 34, 86, 97, 108, 117, 101, 115, 34, 58, 32, 91, 123, 34, 68, 101, 115, 99, 114, 105,
    112, 116, 105, 111, 110, 34, 58, 32, 34, 76, 101, 116, 32, 116, 104, 101, 32, 99, 111, 109, 112, 105, 108, 101, 114,
    32, 99, 104, 111, 111, 115, 101, 32, 116, 104, 101, 32, 73, 82, 32, 109, 111, 100, 101, 46, 34, 44, 32, 34, 86, 97,
    108, 117, 101, 34, 58, 32, 48, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58,
    32, 34, 70, 111, 114, 99, 101, 32, 116, 104, 101, 32, 99, 111, 109, 112, 105, 108, 101, 114, 32, 116, 111, 32, 117,
    115, 101, 32, 79, 108, 100, 32, 73, 82, 46, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 125, 44, 32, 123,
    34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 70, 111, 114, 99, 101, 32, 116, 104, 101,
    32, 99, 111, 109, 112, 105, 108, 101, 114, 32, 116, 111, 32, 117, 115, 101, 32, 78, 101, 119, 32, 73, 82, 32, 119,
    105, 116, 104, 32, 114, 101, 116, 114, 121, 32, 109, 101, 99, 104, 97, 110, 105, 115, 109, 46, 34, 44, 32, 34, 86,
    97, 108, 117, 101, 34, 58, 32, 50, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34,
    58, 32, 34, 70, 111, 114, 99, 101, 32, 116, 104, 101, 32, 99, 111, 109, 112, 105, 108, 101, 114, 32, 116, 111, 32,
    117, 115, 101, 32, 78, 101, 119, 32, 73, 82, 32, 119, 105, 116, 104, 32, 101, 114, 114, 111, 114, 32, 109, 101, 99,
    104, 97, 110, 105, 115, 109, 46, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 51, 125, 93, 125, 44, 32, 34,
    68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 48, 125, 44,
    32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98,
    108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 116, 101, 115, 73, 114, 77, 111, 100, 101, 34, 44, 32, 34, 78, 97, 109,
    101, 34, 58, 32, 34, 84, 101, 115, 73, 114, 77, 111, 100, 101, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32,
    34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 50, 49, 50, 49, 52,
    57, 54, 52, 55, 49, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 70,
    111, 114, 99, 101, 32, 103, 101, 111, 109, 101, 116, 114, 121, 32, 115, 104, 97, 100, 101, 114, 115, 39, 32, 111,
    112, 116, 105, 109, 105, 122, 97, 116, 105, 111, 110, 32, 73, 82, 32, 109, 111, 100, 101, 32, 115, 101, 108, 101,
    99, 116, 105, 111, 110, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 80, 73, 82, 86, 32, 79, 112,
    116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 86, 97, 108, 105, 100, 86, 97, 108, 117, 101, 115, 34, 58, 32, 123, 34,
    86, 97, 108, 117, 101, 115, 34, 58, 32, 91, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58,
    32, 34, 76, 101, 116, 32, 116, 104, 101, 32, 99, 111, 109, 112, 105, 108, 101, 114, 32, 99, 104, 111, 111, 115, 101,
    32, 116, 104, 101, 32, 73, 82, 32, 109, 111, 100, 101, 46, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 48,
    125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 70, 111, 114, 99, 101,
    32, 116, 104, 101, 32, 99, 111, 109, 112, 105, 108, 101, 114, 32, 116, 111, 32, 117, 115, 101, 32, 79, 108, 100, 32,
    73, 82, 46, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105,
    112, 116, 105, 111, 110, 34, 58, 32, 34, 70, 111, 114, 99, 101, 32, 116, 104, 101, 32, 99, 111, 109, 112, 105, 108,
    101, 114, 32, 116, 111, 32, 117, 115, 101, 32, 78, 101, 119, 32, 73, 82, 32, 119, 105, 116, 104, 32, 114, 101, 116,
    114, 121, 32, 109, 101, 99, 104, 97, 110, 105, 115, 109, 46, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 50,
    125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 70, 111, 114, 99, 101,
    32, 116, 104, 101, 32, 99, 111, 109, 112, 105, 108, 101, 114, 32, 116, 111, 32, 117, 115, 101, 32, 78, 101, 119, 32,
    73, 82, 32, 119, 105, 116, 104, 32, 101, 114, 114, 111, 114, 32, 109, 101, 99, 104, 97, 110, 105, 115, 109, 46, 34,
    44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 51, 125, 93, 125, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115,
    34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 48, 125, 44, 32, 34, 84, 121, 112, 101, 34, 58,
    32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58,
    32, 34, 103, 115, 73, 114, 77, 111, 100, 101, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 71, 115, 73, 114,
    77, 111, 100, 101, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32,
    34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 51, 52, 48, 55, 49, 49, 51, 48, 49, 49, 125, 44, 32, 123, 34,
    68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 70, 111, 114, 99, 101, 32, 102, 114, 97, 103,
    109, 101, 110, 116, 32, 115, 104, 97, 100, 101, 114, 115, 39, 32, 111, 112, 116, 105, 109, 105, 122, 97, 116, 105,
    111, 110, 32, 73, 82, 32, 109, 111, 100, 101, 32, 115, 101, 108, 101, 99, 116, 105, 111, 110, 46, 34, 44, 32, 34,
    84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 80, 73, 82, 86, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34,
    86, 97, 108, 105, 100, 86, 97, 108, 117, 101, 115, 34, 58, 32, 123, 34, 86, 97, 108, 117, 101, 115, 34, 58, 32, 91,
    123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 76, 101, 116, 32, 116, 104, 101, 32,
    99, 111, 109, 112, 105, 108, 101, 114, 32, 99, 104, 111, 111, 115, 101, 32, 116, 104, 101, 32, 73, 82, 32, 109, 111,
    100, 101, 46, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 48, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114,
    105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 70, 111, 114, 99, 101, 32, 116, 104, 101, 32, 99, 111, 109, 112, 105,
    108, 101, 114, 32, 116, 111, 32, 117, 115, 101, 32, 79, 108, 100, 32, 73, 82, 46, 34, 44, 32, 34, 86, 97, 108, 117,
    101, 34, 58, 32, 49, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 70,
    111, 114, 99, 101, 32, 116, 104, 101, 32, 99, 111, 109, 112, 105, 108, 101, 114, 32, 116, 111, 32, 117, 115, 101,
    32, 78, 101, 119, 32, 73, 82, 32, 119, 105, 116, 104, 32, 114, 101, 116, 114, 121, 32, 109, 101, 99, 104, 97, 110,
    105, 115, 109, 46, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 50, 125, 44, 32, 123, 34, 68, 101, 115, 99,
    114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 70, 111, 114, 99, 101, 32, 116, 104, 101, 32, 99, 111, 109, 112,
    105, 108, 101, 114, 32, 116, 111, 32, 117, 115, 101, 32, 78, 101, 119, 32, 73, 82, 32, 119, 105, 116, 104, 32, 101,
    114, 114, 111, 114, 32, 109, 101, 99, 104, 97, 110, 105, 115, 109, 46, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34,
    58, 32, 51, 125, 93, 125, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97,
    117, 108, 116, 34, 58, 32, 48, 125, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34,
    44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 102, 115, 73, 114, 77, 111, 100,
    101, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 70, 115, 73, 114, 77, 111, 100, 101, 34, 44, 32, 34, 83, 99,
    111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34,
    58, 32, 49, 50, 55, 48, 53, 56, 48, 57, 52, 54, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105,
    111, 110, 34, 58, 32, 34, 70, 111, 114, 99, 101, 32, 99, 111, 109, 112, 117, 116, 101, 32, 115, 104, 97, 100, 101,
    114, 115, 39, 32, 111, 112, 116, 105, 109, 105, 122, 97, 116, 105, 111, 110, 32, 73, 82, 32, 109, 111, 100, 101, 32,
    115, 101, 108, 101, 99, 116, 105, 111, 110, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 80, 73,
    82, 86, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 86, 97, 108, 105, 100, 86, 97, 108, 117, 101, 115,
    34, 58, 32, 123, 34, 86, 97, 108, 117, 101, 115, 34, 58, 32, 91, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105,
    111, 110, 34, 58, 32, 34, 76, 101, 116, 32, 116, 104, 101, 32, 99, 111, 109, 112, 105, 108, 101, 114, 32, 99, 104,
    111, 111, 115, 101, 32, 116, 104, 101, 32, 73, 82, 32, 109, 111, 100, 101, 46, 34, 44, 32, 34, 86, 97, 108, 117,
    101, 34, 58, 32, 48, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 70,
    111, 114, 99, 101, 32, 116, 104, 101, 32, 99, 111, 109, 112, 105, 108, 101, 114, 32, 116, 111, 32, 117, 115, 101,
    32, 79, 108, 100, 32, 73, 82, 46, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 125, 44, 32, 123, 34, 68,
    101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 70, 111, 114, 99, 101, 32, 116, 104, 101, 32, 99,
    111, 109, 112, 105, 108, 101, 114, 32, 116, 111, 32, 117, 115, 101, 32, 78, 101, 119, 32, 73, 82, 32, 119, 105, 116,
    104, 32, 114, 101, 116, 114, 121, 32, 109, 101, 99, 104, 97, 110, 105, 115, 109, 46, 34, 44, 32, 34, 86, 97, 108,
    117, 101, 34, 58, 32, 50, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34,
    70, 111, 114, 99, 101, 32, 116, 104, 101, 32, 99, 111, 109, 112, 105, 108, 101, 114, 32, 116, 111, 32, 117, 115,
    101, 32, 78, 101, 119, 32, 73, 82, 32, 119, 105, 116, 104, 32, 101, 114, 114, 111, 114, 32, 109, 101, 99, 104, 97,
    110, 105, 115, 109, 46, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 51, 125, 93, 125, 44, 32, 34, 68, 101,
    102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 48, 125, 44, 32, 34,
    84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101,
    78, 97, 109, 101, 34, 58, 32, 34, 99, 115, 73, 114, 77, 111, 100, 101, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32,
    34, 67, 115, 73, 114, 77, 111, 100, 101, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118,
    101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 52, 48, 54, 55, 54, 49, 49, 51, 49, 57,
    125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 91, 76, 76, 80, 67, 32,
    79, 78, 76, 89, 93, 32, 76, 76, 80, 67, 32, 103, 101, 110, 101, 114, 97, 108, 32, 111, 112, 116, 105, 111, 110, 115,
    46, 32, 77, 97, 120, 32, 108, 101, 110, 103, 116, 104, 32, 111, 102, 32, 116, 104, 101, 32, 111, 112, 116, 105, 111,
    110, 32, 105, 115, 32, 50, 53, 54, 46, 32, 102, 111, 114, 32, 101, 120, 97, 109, 112, 108, 101, 58, 32, 68, 105,
    115, 97, 98, 108, 101, 32, 76, 111, 111, 112, 32, 117, 110, 114, 111, 108, 108, 58, 32, 45, 112, 114, 97, 103, 109,
    97, 45, 117, 110, 114, 111, 108, 108, 45, 116, 104, 114, 101, 115, 104, 111, 108, 100, 61, 49, 32, 69, 110, 97, 98,
    108, 101, 32, 115, 105, 45, 115, 99, 104, 101, 100, 117, 108, 101, 114, 58, 32, 45, 101, 110, 97, 98, 108, 101, 45,
    115, 105, 45, 115, 99, 104, 101, 100, 117, 108, 101, 114, 32, 80, 108, 101, 97, 115, 101, 32, 115, 101, 101, 32, 97,
    109, 100, 108, 108, 112, 99, 32, 45, 104, 101, 108, 112, 32, 111, 114, 32, 45, 104, 101, 108, 112, 45, 104, 105,
    100, 100, 101, 110, 32, 102, 111, 114, 32, 100, 101, 116, 97, 105, 108, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58,
    32, 91, 34, 83, 80, 73, 82, 86, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117,
    108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 34, 34, 125, 44, 32, 34, 83, 99,
    111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 76,
    108, 112, 99, 79, 112, 116, 105, 111, 110, 115, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 115, 116, 114,
    105, 110, 103, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 108, 108, 112,
    99, 79, 112, 116, 105, 111, 110, 115, 34, 44, 32, 34, 83, 105, 122, 101, 34, 58, 32, 50, 53, 54, 44, 32, 34, 72, 97,
    115, 104, 78, 97, 109, 101, 34, 58, 32, 51, 53, 48, 56, 50, 49, 51, 54, 50, 54, 125, 44, 32, 123, 34, 86, 97, 108,
    105, 100, 86, 97, 108, 117, 101, 115, 34, 58, 32, 123, 34, 73, 115, 69, 110, 117, 109, 34, 58, 32, 116, 114, 117,
    101, 44, 32, 34, 86, 97, 108, 117, 101, 115, 34, 58, 32, 91, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 83, 104, 97,
    100, 101, 114, 67, 97, 99, 104, 101, 68, 105, 115, 97, 98, 108, 101, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58,
    32, 48, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 83, 104, 97, 100, 101, 114,
    32, 67, 97, 99, 104, 101, 32, 105, 115, 32, 100, 105, 115, 97, 98, 108, 101, 100, 46, 34, 125, 44, 32, 123, 34, 78,
    97, 109, 101, 34, 58, 32, 34, 83, 104, 97, 100, 101, 114, 67, 97, 99, 104, 101, 69, 110, 97, 98, 108, 101, 82, 117,
    110, 116, 105, 109, 101, 79, 110, 108, 121, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 44, 32, 34, 68,
    101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 83, 104, 97, 100, 101, 114, 32, 67, 97, 99, 104,
    101, 32, 105, 115, 32, 101, 110, 97, 98, 108, 101, 100, 32, 102, 111, 114, 32, 114, 117, 110, 116, 105, 109, 101,
    32, 117, 115, 101, 32, 111, 110, 108, 121, 46, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 83, 104,
    97, 100, 101, 114, 67, 97, 99, 104, 101, 69, 110, 97, 98, 108, 101, 79, 110, 68, 105, 115, 107, 34, 44, 32, 34, 86,
    97, 108, 117, 101, 34, 58, 32, 50, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34,
    83, 104, 97, 100, 101, 114, 32, 67, 97, 99, 104, 101, 32, 105, 115, 32, 101, 110, 97, 98, 108, 101, 100, 32, 119,
    105, 116, 104, 32, 111, 110, 45, 100, 105, 115, 107, 32, 102, 105, 108, 101, 32, 98, 97, 99, 107, 105, 110, 103, 46,
    34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 83, 104, 97, 100, 101, 114, 67, 97, 99, 104, 101, 70,
    111, 114, 99, 101, 73, 110, 116, 101, 114, 110, 97, 108, 67, 97, 99, 104, 101, 79, 110, 68, 105, 115, 107, 34, 44,
    32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 51, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34,
    58, 32, 34, 83, 104, 97, 100, 101, 114, 32, 67, 97, 99, 104, 101, 32, 105, 115, 32, 102, 111, 114, 99, 101, 100, 32,
    111, 110, 32, 119, 105, 116, 104, 32, 111, 110, 45, 100, 105, 115, 107, 32, 102, 105, 108, 101, 32, 98, 97, 99, 107,
    105, 110, 103, 32, 101, 118, 101, 110, 32, 102, 111, 114, 32, 97, 112, 112, 108, 105, 99, 97, 116, 105, 111, 110,
    115, 32, 116, 104, 97, 116, 32, 115, 112, 101, 99, 105, 102, 121, 32, 112, 105, 112, 101, 108, 105, 110, 101, 32,
    99, 97, 99, 104, 101, 115, 46, 34, 125, 93, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 83, 104, 97, 100, 101,
    114, 67, 97, 99, 104, 101, 77, 111, 100, 101, 34, 125, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111,
    110, 34, 58, 32, 34, 67, 111, 110, 116, 114, 111, 108, 115, 32, 119, 104, 101, 116, 104, 101, 114, 32, 116, 104,
    101, 32, 68, 101, 118, 105, 99, 101, 32, 115, 104, 97, 100, 101, 114, 32, 99, 97, 99, 104, 101, 32, 115, 104, 111,
    117, 108, 100, 32, 98, 101, 32, 117, 115, 101, 100, 32, 116, 111, 32, 116, 114, 121, 32, 116, 111, 32, 97, 118, 111,
    105, 100, 32, 114, 101, 100, 117, 110, 100, 97, 110, 116, 32, 115, 104, 97, 100, 101, 114, 32, 99, 111, 109, 112,
    105, 108, 101, 115, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 80, 73, 82, 86, 32, 79, 112, 116,
    105, 111, 110, 115, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97,
    117, 108, 116, 34, 58, 32, 34, 83, 104, 97, 100, 101, 114, 67, 97, 99, 104, 101, 69, 110, 97, 98, 108, 101, 82, 117,
    110, 116, 105, 109, 101, 79, 110, 108, 121, 34, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114,
    105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 101, 110, 117, 109, 34, 44, 32, 34, 86, 97,
    114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 115, 104, 97, 100, 101, 114, 67, 97, 99, 104, 101, 77,
    111, 100, 101, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 83, 104, 97, 100, 101, 114, 67, 97, 99, 104, 101,
    77, 111, 100, 101, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 49, 49, 49, 51, 49, 52, 48, 50,
    48, 49, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 84, 104, 105,
    115, 32, 111, 112, 116, 105, 111, 110, 32, 105, 115, 32, 118, 97, 108, 105, 100, 32, 119, 104, 101, 110, 32, 69,
    110, 97, 98, 108, 101, 68, 114, 111, 112, 80, 105, 112, 101, 108, 105, 110, 101, 66, 105, 110, 97, 114, 121, 73,
    110, 115, 116, 32, 105, 115, 32, 115, 101, 116, 32, 116, 111, 32, 116, 114, 117, 101, 46, 32, 73, 116, 32, 115, 104,
    111, 117, 108, 100, 32, 98, 101, 32, 115, 112, 101, 99, 105, 102, 105, 101, 100, 32, 119, 105, 116, 104, 32, 116,
    104, 101, 32, 104, 101, 120, 32, 118, 97, 108, 117, 101, 32, 116, 111, 32, 109, 97, 115, 107, 32, 68, 114, 111, 112,
    80, 105, 112, 101, 108, 105, 110, 101, 66, 105, 110, 97, 114, 121, 73, 110, 115, 116, 84, 111, 107, 101, 110, 46,
    32, 70, 111, 114, 32, 101, 120, 97, 109, 112, 108, 101, 58, 32, 68, 114, 111, 112, 80, 105, 112, 101, 108, 105, 110,
    101, 66, 105, 110, 97, 114, 121, 73, 110, 115, 116, 77, 97, 115, 107, 44, 48, 120, 70, 70, 70, 70, 48, 48, 48, 48,
    34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 80, 73, 82, 86, 32, 79, 112, 116, 105, 111, 110, 115, 34,
    93, 44, 32, 34, 70, 108, 97, 103, 115, 34, 58, 32, 123, 34, 73, 115, 72, 101, 120, 34, 58, 32, 116, 114, 117, 101,
    44, 32, 34, 73, 115, 66, 105, 116, 109, 97, 115, 107, 34, 58, 32, 116, 114, 117, 101, 125, 44, 32, 34, 68, 101, 102,
    97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 52, 50, 57, 52, 57, 54,
    55, 50, 57, 53, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34,
    84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101,
    78, 97, 109, 101, 34, 58, 32, 34, 100, 114, 111, 112, 80, 105, 112, 101, 108, 105, 110, 101, 66, 105, 110, 97, 114,
    121, 73, 110, 115, 116, 77, 97, 115, 107, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 114, 111, 112, 80,
    105, 112, 101, 108, 105, 110, 101, 66, 105, 110, 97, 114, 121, 73, 110, 115, 116, 77, 97, 115, 107, 34, 44, 32, 34,
    72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 52, 48, 56, 52, 56, 57, 48, 56, 49, 49, 125, 44, 32, 123, 34, 78,
    97, 109, 101, 34, 58, 32, 34, 65, 108, 108, 111, 119, 86, 107, 80, 105, 112, 101, 108, 105, 110, 101, 67, 97, 99,
    104, 105, 110, 103, 84, 111, 68, 105, 115, 107, 34, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110,
    34, 58, 32, 34, 67, 111, 110, 116, 114, 111, 108, 115, 32, 119, 104, 101, 116, 104, 101, 114, 32, 116, 104, 101, 32,
    112, 105, 112, 101, 108, 105, 110, 101, 32, 99, 111, 109, 112, 105, 108, 101, 114, 32, 101, 110, 97, 98, 108, 101,
    115, 32, 80, 97, 108, 39, 115, 32, 97, 114, 99, 104, 105, 118, 101, 45, 102, 105, 108, 101, 32, 98, 97, 115, 101,
    100, 32, 99, 97, 99, 104, 105, 110, 103, 32, 102, 111, 114, 32, 115, 97, 118, 105, 110, 103, 32, 115, 104, 97, 100,
    101, 114, 32, 69, 76, 70, 115, 46, 32, 40, 68, 101, 102, 97, 117, 108, 116, 58, 32, 70, 65, 76, 83, 69, 41, 32, 82,
    101, 108, 97, 116, 101, 100, 32, 101, 110, 118, 105, 114, 111, 110, 109, 101, 110, 116, 32, 118, 97, 114, 105, 97,
    98, 108, 101, 115, 32, 65, 77, 68, 95, 65, 82, 67, 72, 73, 86, 69, 95, 68, 73, 83, 75, 95, 67, 65, 67, 72, 69, 95,
    80, 65, 84, 72, 58, 32, 80, 97, 116, 104, 32, 116, 111, 32, 119, 104, 101, 114, 101, 32, 97, 114, 99, 104, 105, 118,
    101, 32, 102, 105, 108, 101, 32, 105, 115, 32, 116, 111, 32, 98, 101, 32, 115, 116, 111, 114, 101, 100, 32, 40, 111,
    112, 116, 105, 111, 110, 97, 108, 41, 32, 65, 77, 68, 95, 65, 82, 67, 72, 73, 86, 69, 95, 65, 80, 80, 95, 80, 82,
    69, 70, 73, 88, 32, 32, 32, 32, 32, 58, 32, 70, 105, 120, 101, 100, 32, 112, 114, 101, 102, 105, 120, 32, 115, 116,
    114, 105, 110, 103, 32, 102, 111, 114, 32, 103, 101, 110, 101, 114, 97, 116, 101, 100, 32, 97, 114, 99, 104, 105,
    118, 101, 32, 102, 105, 108, 101, 32, 110, 97, 109, 101, 32, 40, 111, 112, 116, 105, 111, 110, 97, 108, 41, 34, 44,
    32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 80, 73, 82, 86, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44,
    32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102,
    97, 108, 115, 101, 44, 32, 34, 87, 105, 110, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 116, 114, 117, 101, 44,
    32, 34, 76, 110, 120, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115, 101, 125, 44, 32, 34, 84, 121,
    112, 101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101,
    34, 58, 32, 34, 117, 115, 101, 80, 97, 108, 80, 105, 112, 101, 108, 105, 110, 101, 67, 97, 99, 104, 105, 110, 103,
    34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 72, 97, 115,
    104, 78, 97, 109, 101, 34, 58, 32, 49, 54, 57, 50, 56, 49, 55, 49, 56, 52, 125, 44, 32, 123, 34, 78, 97, 109, 101,
    34, 58, 32, 34, 65, 108, 108, 111, 119, 69, 120, 116, 101, 114, 110, 97, 108, 80, 105, 112, 101, 108, 105, 110, 101,
    67, 97, 99, 104, 101, 79, 98, 106, 101, 99, 116, 34, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111,
    110, 34, 58, 32, 34, 67, 111, 110, 116, 114, 111, 108, 115, 32, 119, 104, 101, 116, 104, 101, 114, 32, 97, 32, 112,
    105, 112, 101, 108, 105, 110, 101, 32, 99, 97, 99, 104, 101, 32, 111, 98, 106, 101, 99, 116, 32, 105, 115, 32, 97,
    108, 108, 111, 119, 101, 100, 32, 116, 111, 32, 98, 101, 32, 99, 114, 101, 97, 116, 101, 100, 32, 118, 105, 97, 32,
    118, 107, 67, 114, 101, 97, 116, 101, 80, 105, 112, 101, 108, 105, 110, 101, 67, 97, 99, 104, 101, 32, 105, 110, 32,
    97, 100, 100, 105, 116, 105, 111, 110, 32, 116, 111, 32, 116, 104, 101, 32, 99, 97, 99, 104, 101, 32, 114, 101, 115,
    105, 100, 105, 110, 103, 32, 119, 105, 116, 104, 105, 110, 32, 116, 104, 101, 32, 112, 105, 112, 101, 108, 105, 110,
    101, 32, 99, 111, 109, 112, 105, 108, 101, 114, 46, 32, 40, 68, 101, 102, 97, 117, 108, 116, 58, 32, 84, 82, 85, 69,
    41, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 80, 73, 82, 86, 32, 79, 112, 116, 105, 111, 110, 115,
    34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34,
    58, 32, 116, 114, 117, 101, 125, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34,
    86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 97, 108, 108, 111, 119, 69, 120, 116, 101,
    114, 110, 97, 108, 80, 105, 112, 101, 108, 105, 110, 101, 67, 97, 99, 104, 101, 79, 98, 106, 101, 99, 116, 34, 44,
    32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78,
    97, 109, 101, 34, 58, 32, 50, 53, 54, 53, 54, 49, 48, 55, 54, 56, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58,
    32, 34, 80, 105, 112, 101, 108, 105, 110, 101, 67, 97, 99, 104, 105, 110, 103, 69, 110, 118, 105, 114, 111, 110,
    109, 101, 110, 116, 86, 97, 114, 105, 97, 98, 108, 101, 34, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105,
    111, 110, 34, 58, 32, 34, 69, 110, 118, 105, 114, 111, 110, 109, 101, 110, 116, 32, 118, 97, 114, 105, 97, 98, 108,
    101, 32, 116, 111, 32, 99, 104, 101, 99, 107, 32, 102, 111, 114, 32, 116, 111, 32, 101, 110, 97, 98, 108, 101, 32,
    80, 97, 108, 32, 80, 105, 112, 101, 108, 105, 110, 101, 32, 67, 97, 99, 104, 105, 110, 103, 46, 32, 84, 104, 105,
    115, 32, 97, 108, 108, 111, 119, 115, 32, 108, 97, 117, 110, 99, 104, 101, 114, 32, 97, 112, 112, 108, 105, 99, 97,
    116, 105, 111, 110, 115, 32, 116, 111, 32, 100, 121, 110, 97, 109, 105, 99, 97, 108, 108, 121, 32, 99, 111, 110,
    116, 114, 111, 108, 32, 119, 104, 101, 116, 104, 101, 114, 32, 119, 101, 32, 99, 97, 99, 104, 101, 32, 112, 105,
    112, 108, 101, 108, 105, 110, 101, 32, 69, 76, 70, 115, 32, 111, 114, 32, 110, 111, 116, 46, 32, 87, 104, 101, 110,
    32, 99, 111, 110, 118, 101, 114, 116, 101, 100, 32, 116, 111, 32, 97, 110, 32, 105, 110, 116, 101, 103, 101, 114,
    32, 97, 110, 121, 32, 48, 32, 118, 97, 108, 117, 101, 32, 119, 105, 108, 108, 32, 98, 101, 32, 116, 114, 101, 97,
    116, 101, 100, 32, 97, 115, 32, 70, 97, 108, 115, 101, 44, 32, 97, 110, 100, 32, 97, 110, 121, 32, 110, 111, 110,
    45, 122, 101, 114, 111, 32, 118, 97, 108, 117, 101, 32, 119, 105, 108, 108, 32, 98, 101, 32, 116, 114, 101, 97, 116,
    101, 100, 32, 97, 115, 32, 116, 114, 117, 101, 46, 32, 70, 117, 110, 99, 116, 105, 111, 110, 97, 108, 108, 121, 32,
    101, 113, 117, 105, 118, 97, 108, 101, 110, 116, 32, 116, 111, 32, 115, 101, 116, 116, 105, 110, 103, 32, 85, 115,
    101, 80, 97, 108, 80, 105, 112, 101, 108, 105, 110, 101, 67, 97, 99, 104, 105, 110, 103, 32, 61, 32, 84, 114, 117,
    101, 47, 70, 97, 108, 115, 101, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 80, 73, 82, 86, 32, 79,
    112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68,
    101, 102, 97, 117, 108, 116, 34, 58, 32, 34, 65, 77, 68, 95, 86, 75, 95, 85, 83, 69, 95, 80, 73, 80, 69, 76, 73, 78,
    69, 95, 67, 65, 67, 72, 69, 34, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114,
    34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 115, 116, 114, 105, 110, 103, 34, 44, 32, 34, 86, 97, 114, 105,
    97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 112, 105, 112, 101, 108, 105, 110, 101, 67, 97, 99, 104, 105,
    110, 103, 69, 110, 118, 105, 114, 111, 110, 109, 101, 110, 116, 86, 97, 114, 105, 97, 98, 108, 101, 34, 44, 32, 34,
    83, 105, 122, 101, 34, 58, 32, 50, 53, 54, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 56, 49, 50,
    50, 55, 56, 54, 49, 55, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 85, 115, 101, 80, 105, 112, 101,
    108, 105, 110, 101, 67, 97, 99, 104, 105, 110, 103, 68, 101, 102, 97, 117, 108, 116, 76, 111, 99, 97, 116, 105, 111,
    110, 34, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 65, 108, 108, 111, 119,
    32, 117, 115, 101, 32, 111, 102, 32, 100, 101, 102, 97, 117, 108, 116, 32, 112, 105, 112, 101, 108, 105, 110, 101,
    32, 99, 97, 99, 104, 101, 32, 108, 111, 99, 97, 116, 105, 111, 110, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58,
    32, 91, 34, 83, 80, 73, 82, 86, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117,
    108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 116, 114, 117, 101, 125, 44, 32,
    34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58,
    32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34,
    117, 115, 101, 80, 105, 112, 101, 108, 105, 110, 101, 67, 97, 99, 104, 105, 110, 103, 68, 101, 102, 97, 117, 108,
    116, 76, 111, 99, 97, 116, 105, 111, 110, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 56, 50,
    51, 49, 51, 52, 56, 52, 51, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 80, 105, 112, 101, 108, 105,
    110, 101, 67, 97, 99, 104, 105, 110, 103, 68, 101, 102, 97, 117, 108, 116, 76, 111, 99, 97, 116, 105, 111, 110, 34,
    44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 68, 101, 102, 97, 117, 108, 116,
    32, 115, 117, 98, 32, 102, 111, 108, 100, 101, 114, 32, 116, 111, 32, 119, 114, 105, 116, 101, 32, 80, 65, 76, 32,
    112, 105, 112, 101, 108, 105, 110, 101, 32, 99, 97, 99, 104, 101, 32, 105, 102, 32, 110, 111, 116, 32, 115, 112,
    101, 99, 105, 102, 105, 101, 100, 32, 98, 121, 32, 101, 110, 118, 105, 114, 111, 110, 109, 101, 110, 116, 32, 118,
    97, 114, 105, 97, 98, 108, 101, 32, 65, 77, 68, 95, 86, 75, 95, 80, 73, 80, 69, 76, 73, 78, 69, 95, 67, 65, 67, 72,
    69, 95, 80, 65, 84, 72, 46, 32, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 80, 73, 82, 86, 32, 79,
    112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68,
    101, 102, 97, 117, 108, 116, 34, 58, 32, 34, 47, 65, 77, 68, 47, 86, 107, 67, 97, 99, 104, 101, 47, 34, 44, 32, 34,
    87, 105, 110, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 34, 92, 92, 65, 77, 68, 92, 92, 86, 107, 67, 97, 99, 104,
    101, 92, 92, 34, 44, 32, 34, 76, 110, 120, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 34, 47, 65, 77, 68, 47, 86,
    107, 67, 97, 99, 104, 101, 47, 34, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101,
    114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 115, 116, 114, 105, 110, 103, 34, 44, 32, 34, 86, 97, 114,
    105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 112, 105, 112, 101, 108, 105, 110, 101, 67, 97, 99, 104,
    105, 110, 103, 68, 101, 102, 97, 117, 108, 116, 76, 111, 99, 97, 116, 105, 111, 110, 34, 44, 32, 34, 83, 105, 122,
    101, 34, 58, 32, 50, 53, 54, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 51, 53, 53, 49, 54, 52, 51,
    55, 50, 54, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 77, 97, 114, 107, 80, 105, 112, 101, 108, 105,
    110, 101, 67, 97, 99, 104, 101, 87, 105, 116, 104, 66, 117, 105, 108, 100, 84, 105, 109, 101, 115, 116, 97, 109,
    112, 34, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 67, 111, 110, 116, 114,
    111, 108, 101, 115, 32, 119, 104, 101, 116, 104, 101, 114, 32, 116, 104, 101, 32, 112, 105, 112, 108, 105, 110, 101,
    32, 99, 97, 99, 104, 101, 32, 105, 115, 32, 116, 97, 103, 103, 101, 100, 32, 119, 105, 116, 104, 32, 116, 104, 101,
    32, 98, 117, 105, 108, 100, 32, 116, 105, 109, 101, 115, 116, 97, 109, 112, 46, 32, 84, 104, 105, 115, 32, 112, 114,
    111, 118, 105, 100, 101, 115, 32, 101, 120, 116, 114, 97, 32, 115, 116, 97, 98, 105, 108, 105, 116, 121, 32, 98,
    121, 32, 102, 111, 114, 99, 105, 110, 103, 32, 97, 32, 99, 97, 99, 104, 101, 32, 114, 101, 98, 117, 105, 108, 100,
    32, 102, 111, 114, 32, 101, 118, 101, 114, 121, 32, 110, 101, 119, 32, 100, 114, 105, 118, 101, 114, 32, 114, 101,
    108, 101, 97, 115, 101, 100, 46, 32, 32, 77, 97, 121, 32, 98, 101, 32, 117, 115, 101, 102, 117, 108, 32, 116, 111,
    32, 100, 105, 115, 97, 98, 108, 101, 32, 100, 117, 114, 105, 110, 103, 32, 114, 97, 112, 105, 100, 32, 105, 116,
    101, 114, 97, 116, 105, 111, 110, 46, 32, 40, 68, 101, 102, 97, 117, 108, 116, 58, 32, 84, 82, 85, 69, 41, 34, 44,
    32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 80, 73, 82, 86, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44,
    32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 116,
    114, 117, 101, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34,
    84, 121, 112, 101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97,
    109, 101, 34, 58, 32, 34, 109, 97, 114, 107, 80, 105, 112, 101, 108, 105, 110, 101, 67, 97, 99, 104, 101, 87, 105,
    116, 104, 66, 117, 105, 108, 100, 84, 105, 109, 101, 115, 116, 97, 109, 112, 34, 44, 32, 34, 72, 97, 115, 104, 78,
    97, 109, 101, 34, 58, 32, 50, 50, 55, 57, 56, 52, 51, 49, 48, 56, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58,
    32, 34, 70, 105, 108, 116, 101, 114, 80, 105, 112, 101, 108, 105, 110, 101, 68, 117, 109, 112, 66, 121, 84, 121,
    112, 101, 34, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 70, 105, 108, 116,
    101, 114, 32, 119, 104, 105, 99, 104, 32, 116, 121, 112, 101, 115, 32, 111, 102, 32, 112, 105, 112, 101, 108, 105,
    110, 101, 32, 100, 117, 109, 112, 32, 97, 114, 101, 32, 100, 105, 115, 97, 98, 108, 101, 100, 46, 32, 84, 104, 101,
    115, 101, 32, 111, 112, 116, 105, 111, 110, 115, 32, 99, 97, 110, 32, 98, 101, 32, 117, 115, 101, 100, 32, 116, 111,
    32, 100, 117, 109, 112, 32, 112, 105, 112, 101, 108, 105, 110, 101, 115, 32, 111, 102, 32, 97, 32, 115, 112, 101,
    99, 105, 102, 105, 99, 32, 116, 121, 112, 101, 46, 32, 66, 121, 32, 100, 101, 102, 97, 117, 108, 116, 44, 32, 97,
    108, 108, 32, 116, 104, 101, 32, 112, 105, 112, 101, 108, 105, 110, 101, 115, 32, 97, 114, 101, 32, 108, 111, 103,
    103, 101, 100, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 80, 73, 82, 86, 32, 79, 112, 116, 105,
    111, 110, 115, 34, 93, 44, 32, 34, 70, 108, 97, 103, 115, 34, 58, 32, 123, 34, 73, 115, 72, 101, 120, 34, 58, 32,
    116, 114, 117, 101, 44, 32, 34, 73, 115, 66, 105, 116, 109, 97, 115, 107, 34, 58, 32, 116, 114, 117, 101, 125, 44,
    32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 34,
    80, 105, 112, 101, 108, 105, 110, 101, 68, 117, 109, 112, 70, 105, 108, 116, 101, 114, 78, 111, 110, 101, 34, 125,
    44, 32, 34, 86, 97, 108, 105, 100, 86, 97, 108, 117, 101, 115, 34, 58, 32, 123, 34, 73, 115, 69, 110, 117, 109, 34,
    58, 32, 116, 114, 117, 101, 44, 32, 34, 86, 97, 108, 117, 101, 115, 34, 58, 32, 91, 123, 34, 78, 97, 109, 101, 34,
    58, 32, 34, 80, 105, 112, 101, 108, 105, 110, 101, 68, 117, 109, 112, 70, 105, 108, 116, 101, 114, 78, 111, 110,
    101, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 48, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105,
    111, 110, 34, 58, 32, 34, 68, 111, 32, 110, 111, 116, 32, 100, 105, 115, 97, 98, 108, 101, 32, 97, 110, 121, 32,
    112, 105, 112, 101, 108, 105, 110, 101, 32, 116, 121, 112, 101, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58,
    32, 34, 80, 105, 112, 101, 108, 105, 110, 101, 68, 117, 109, 112, 70, 105, 108, 116, 101, 114, 67, 115, 34, 44, 32,
    34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58,
    32, 34, 68, 105, 115, 97, 98, 108, 101, 32, 112, 105, 112, 101, 108, 105, 110, 101, 32, 100, 117, 109, 112, 32, 102,
    111, 114, 32, 67, 115, 32, 112, 105, 112, 101, 108, 105, 110, 101, 115, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101,
    34, 58, 32, 34, 80, 105, 112, 101, 108, 105, 110, 101, 68, 117, 109, 112, 70, 105, 108, 116, 101, 114, 78, 103, 103,
    34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 50, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111,
    110, 34, 58, 32, 34, 68, 105, 115, 97, 98, 108, 101, 32, 112, 105, 112, 101, 108, 105, 110, 101, 32, 100, 117, 109,
    112, 32, 102, 111, 114, 32, 78, 71, 71, 32, 112, 105, 112, 101, 108, 105, 110, 101, 115, 34, 125, 44, 32, 123, 34,
    78, 97, 109, 101, 34, 58, 32, 34, 80, 105, 112, 101, 108, 105, 110, 101, 68, 117, 109, 112, 70, 105, 108, 116, 101,
    114, 71, 115, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 52, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112,
    116, 105, 111, 110, 34, 58, 32, 34, 68, 105, 115, 97, 98, 108, 101, 32, 112, 105, 112, 101, 108, 105, 110, 101, 32,
    100, 117, 109, 112, 32, 102, 111, 114, 32, 71, 115, 32, 112, 105, 112, 101, 108, 105, 110, 101, 115, 32, 34, 125,
    44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 80, 105, 112, 101, 108, 105, 110, 101, 68, 117, 109, 112, 70,
    105, 108, 116, 101, 114, 84, 101, 115, 115, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 56, 44, 32, 34, 68,
    101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 68, 105, 115, 97, 98, 108, 101, 32, 112, 105, 112,
    101, 108, 105, 110, 101, 32, 100, 117, 109, 112, 32, 102, 111, 114, 32, 84, 101, 115, 115, 32, 112, 105, 112, 101,
    108, 105, 110, 101, 115, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 80, 105, 112, 101, 108, 105,
    110, 101, 68, 117, 109, 112, 70, 105, 108, 116, 101, 114, 86, 115, 80, 115, 34, 44, 32, 34, 86, 97, 108, 117, 101,
    34, 58, 32, 49, 54, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 68, 105, 115,
    97, 98, 108, 101, 32, 112, 105, 112, 101, 108, 105, 110, 101, 32, 100, 117, 109, 112, 32, 102, 111, 114, 32, 86,
    115, 80, 115, 32, 112, 105, 112, 101, 108, 105, 110, 101, 115, 34, 125, 93, 44, 32, 34, 78, 97, 109, 101, 34, 58,
    32, 34, 80, 105, 112, 101, 108, 105, 110, 101, 68, 117, 109, 112, 70, 105, 108, 116, 101, 114, 115, 34, 125, 44, 32,
    34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58,
    32, 34, 101, 110, 117, 109, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34,
    102, 105, 108, 116, 101, 114, 80, 105, 112, 101, 108, 105, 110, 101, 68, 117, 109, 112, 66, 121, 84, 121, 112, 101,
    34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 51, 52, 55, 52, 51, 50, 56, 48, 51, 56, 125, 44, 32,
    123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 70, 105, 108, 116, 101, 114, 80, 105, 112, 101, 108, 105, 110, 101, 68,
    117, 109, 112, 66, 121, 72, 97, 115, 104, 34, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34,
    58, 32, 34, 73, 102, 32, 110, 111, 110, 45, 122, 101, 114, 111, 44, 32, 111, 110, 108, 121, 32, 100, 117, 109, 112,
    32, 116, 104, 101, 32, 112, 105, 112, 101, 108, 105, 110, 101, 32, 119, 105, 116, 104, 32, 116, 104, 105, 115, 32,
    99, 111, 109, 112, 105, 108, 101, 114, 32, 104, 97, 115, 104, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91,
    34, 83, 80, 73, 82, 86, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116,
    115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 48, 125, 44, 32, 34, 70, 108, 97, 103, 115,
    34, 58, 32, 123, 34, 73, 115, 72, 101, 120, 34, 58, 32, 116, 114, 117, 101, 125, 44, 32, 34, 83, 99, 111, 112, 101,
    34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116,
    54, 52, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 102, 105, 108, 116,
    101, 114, 80, 105, 112, 101, 108, 105, 110, 101, 68, 117, 109, 112, 66, 121, 72, 97, 115, 104, 34, 44, 32, 34, 72,
    97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 53, 55, 57, 54, 49, 57, 48, 51, 52, 125, 44, 32, 123, 34, 68, 101, 115,
    99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 73, 102, 32, 116, 114, 117, 101, 44, 32, 100, 117, 112, 108,
    105, 99, 97, 116, 101, 32, 112, 105, 112, 101, 108, 105, 110, 101, 115, 32, 119, 105, 108, 108, 32, 98, 101, 32,
    100, 117, 109, 112, 101, 100, 32, 116, 111, 32, 97, 32, 102, 105, 108, 101, 32, 119, 105, 116, 104, 32, 97, 32, 110,
    117, 109, 101, 114, 105, 99, 32, 115, 117, 102, 102, 105, 120, 32, 97, 116, 116, 97, 99, 104, 101, 100, 32, 116,
    111, 32, 116, 104, 101, 32, 102, 105, 108, 101, 110, 97, 109, 101, 32, 116, 111, 32, 100, 105, 115, 116, 105, 110,
    103, 117, 105, 115, 104, 32, 101, 97, 99, 104, 32, 99, 111, 112, 121, 32, 111, 102, 32, 116, 104, 101, 32, 112, 105,
    112, 101, 108, 105, 110, 101, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 80, 73, 82, 86, 32, 79,
    112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68,
    101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115, 101, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32,
    34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32,
    34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 100, 117, 109, 112, 68, 117, 112, 108,
    105, 99, 97, 116, 101, 80, 105, 112, 101, 108, 105, 110, 101, 115, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34,
    68, 117, 109, 112, 68, 117, 112, 108, 105, 99, 97, 116, 101, 80, 105, 112, 101, 108, 105, 110, 101, 115, 34, 44, 32,
    34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 55, 56, 53, 52, 54, 55, 51, 57, 49, 125, 44, 32, 123, 34, 78,
    97, 109, 101, 34, 58, 32, 34, 68, 98, 103, 66, 97, 114, 114, 105, 101, 114, 80, 111, 115, 116, 67, 109, 100, 69,
    110, 97, 98, 108, 101, 34, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 84, 114,
    105, 103, 103, 101, 114, 115, 32, 97, 32, 67, 109, 100, 66, 97, 114, 114, 105, 101, 114, 32, 99, 97, 108, 108, 32,
    97, 102, 116, 101, 114, 32, 97, 110, 121, 32, 99, 111, 109, 109, 97, 110, 100, 32, 105, 110, 32, 116, 104, 101, 32,
    103, 105, 118, 101, 110, 32, 109, 97, 115, 107, 46, 32, 32, 84, 104, 101, 32, 98, 97, 114, 114, 105, 101, 114, 32,
    98, 101, 104, 97, 118, 105, 111, 114, 32, 105, 115, 32, 99, 111, 110, 116, 114, 111, 108, 108, 101, 100, 32, 98,
    121, 32, 116, 104, 101, 32, 111, 116, 104, 101, 114, 32, 68, 98, 103, 66, 97, 114, 114, 105, 101, 114, 80, 111, 115,
    116, 42, 32, 115, 101, 116, 116, 105, 110, 103, 115, 32, 105, 110, 32, 116, 104, 105, 115, 32, 99, 97, 116, 101,
    103, 111, 114, 121, 46, 32, 32, 82, 101, 113, 117, 105, 114, 101, 115, 32, 86, 75, 95, 69, 78, 65, 66, 76, 69, 95,
    68, 69, 66, 85, 71, 95, 66, 65, 82, 82, 73, 69, 82, 83, 61, 49, 32, 116, 111, 32, 116, 97, 107, 101, 32, 101, 102,
    102, 101, 99, 116, 46, 32, 48, 120, 56, 70, 70, 70, 70, 70, 70, 70, 58, 32, 65, 108, 108, 32, 99, 111, 109, 109, 97,
    110, 100, 115, 32, 40, 104, 101, 97, 118, 121, 119, 101, 105, 103, 104, 116, 32, 111, 112, 116, 105, 111, 110, 41,
    34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 68, 101, 98, 117, 103, 103, 105, 110, 103, 34, 93, 44, 32, 34,
    70, 108, 97, 103, 115, 34, 58, 32, 123, 34, 73, 115, 72, 101, 120, 34, 58, 32, 116, 114, 117, 101, 44, 32, 34, 73,
    115, 66, 105, 116, 109, 97, 115, 107, 34, 58, 32, 116, 114, 117, 101, 125, 44, 32, 34, 68, 101, 102, 97, 117, 108,
    116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 48, 125, 44, 32, 34, 86, 97, 108, 105,
    100, 86, 97, 108, 117, 101, 115, 34, 58, 32, 123, 34, 73, 115, 69, 110, 117, 109, 34, 58, 32, 116, 114, 117, 101,
    44, 32, 34, 86, 97, 108, 117, 101, 115, 34, 58, 32, 91, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 98, 103, 66,
    97, 114, 114, 105, 101, 114, 68, 114, 97, 119, 78, 111, 110, 73, 110, 100, 101, 120, 101, 100, 34, 44, 32, 34, 86,
    97, 108, 117, 101, 34, 58, 32, 49, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34,
    65, 110, 121, 32, 110, 111, 110, 45, 105, 110, 100, 101, 120, 101, 100, 32, 100, 114, 97, 119, 32, 40, 105, 110, 99,
    108, 117, 100, 105, 110, 103, 32, 105, 110, 100, 105, 114, 101, 99, 116, 41, 34, 125, 44, 32, 123, 34, 78, 97, 109,
    101, 34, 58, 32, 34, 68, 98, 103, 66, 97, 114, 114, 105, 101, 114, 68, 114, 97, 119, 73, 110, 100, 101, 120, 101,
    100, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 50, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105,
    111, 110, 34, 58, 32, 34, 65, 110, 121, 32, 105, 110, 100, 101, 120, 101, 100, 32, 100, 114, 97, 119, 32, 40, 105,
    110, 99, 108, 117, 100, 105, 110, 103, 32, 105, 110, 100, 105, 114, 101, 99, 116, 41, 34, 125, 44, 32, 123, 34, 78,
    97, 109, 101, 34, 58, 32, 34, 68, 98, 103, 66, 97, 114, 114, 105, 101, 114, 68, 114, 97, 119, 73, 110, 100, 105,
    114, 101, 99, 116, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 52, 44, 32, 34, 68, 101, 115, 99, 114, 105,
    112, 116, 105, 111, 110, 34, 58, 32, 34, 65, 110, 121, 32, 105, 110, 100, 105, 114, 101, 99, 116, 32, 100, 114, 97,
    119, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 98, 103, 66, 97, 114, 114, 105, 101, 114, 68,
    105, 115, 112, 97, 116, 99, 104, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 56, 44, 32, 34, 68, 101, 115,
    99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 65, 110, 121, 32, 100, 105, 114, 101, 99, 116, 32, 100, 105,
    115, 112, 97, 116, 99, 104, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 98, 103, 66, 97, 114,
    114, 105, 101, 114, 68, 105, 115, 112, 97, 116, 99, 104, 73, 110, 100, 105, 114, 101, 99, 116, 34, 44, 32, 34, 86,
    97, 108, 117, 101, 34, 58, 32, 49, 54, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32,
    34, 65, 110, 121, 32, 105, 110, 100, 105, 114, 101, 99, 116, 32, 100, 105, 115, 112, 97, 116, 99, 104, 34, 125, 44,
    32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 98, 103, 66, 97, 114, 114, 105, 101, 114, 67, 111, 112, 121, 66,
    117, 102, 102, 101, 114, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 51, 50, 44, 32, 34, 68, 101, 115, 99,
    114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 65, 110, 121, 32, 116, 114, 97, 110, 115, 102, 101, 114, 32, 99,
    111, 112, 121, 32, 105, 110, 118, 111, 108, 118, 105, 110, 103, 32, 97, 32, 98, 117, 102, 102, 101, 114, 34, 125,
    44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 98, 103, 66, 97, 114, 114, 105, 101, 114, 67, 111, 112, 121,
    73, 109, 97, 103, 101, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 54, 52, 44, 32, 34, 68, 101, 115, 99, 114,
    105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 65, 110, 121, 32, 116, 114, 97, 110, 115, 102, 101, 114, 32, 99, 111,
    112, 121, 32, 105, 110, 118, 111, 108, 118, 105, 110, 103, 32, 97, 110, 32, 105, 109, 97, 103, 101, 34, 125, 44, 32,
    123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 98, 103, 66, 97, 114, 114, 105, 101, 114, 67, 111, 112, 121, 81, 117,
    101, 114, 121, 80, 111, 111, 108, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 50, 56, 44, 32, 34, 68,
    101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 65, 110, 121, 32, 116, 114, 97, 110, 115, 102, 101,
    114, 32, 99, 111, 112, 121, 32, 105, 110, 118, 111, 108, 118, 105, 110, 103, 32, 97, 32, 113, 117, 101, 114, 121,
    32, 112, 111, 111, 108, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 98, 103, 66, 97, 114, 114,
    105, 101, 114, 67, 108, 101, 97, 114, 67, 111, 108, 111, 114, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 50,
    53, 54, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 65, 110, 121, 32, 99, 111,
    108, 111, 114, 32, 99, 108, 101, 97, 114, 32, 111, 112, 101, 114, 97, 116, 105, 111, 110, 32, 40, 105, 110, 99, 108,
    117, 100, 105, 110, 103, 32, 114, 101, 110, 100, 101, 114, 32, 112, 97, 115, 115, 32, 99, 108, 101, 97, 114, 115,
    41, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 98, 103, 66, 97, 114, 114, 105, 101, 114, 67,
    108, 101, 97, 114, 68, 101, 112, 116, 104, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 53, 49, 50, 44, 32,
    34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 65, 110, 121, 32, 100, 101, 112, 116, 104,
    45, 115, 116, 101, 110, 99, 105, 108, 32, 99, 108, 101, 97, 114, 32, 111, 112, 101, 114, 97, 116, 105, 111, 110, 32,
    40, 105, 110, 99, 108, 117, 100, 105, 110, 103, 32, 114, 101, 110, 100, 101, 114, 32, 112, 97, 115, 115, 32, 99,
    108, 101, 97, 114, 115, 41, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 98, 103, 66, 97, 114,
    114, 105, 101, 114, 82, 101, 115, 111, 108, 118, 101, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 48, 50,
    52, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 65, 110, 121, 32, 114, 101,
    115, 111, 108, 118, 101, 32, 111, 112, 101, 114, 97, 116, 105, 111, 110, 32, 40, 105, 110, 99, 108, 117, 100, 105,
    110, 103, 32, 114, 101, 110, 100, 101, 114, 32, 112, 97, 115, 115, 32, 114, 101, 115, 111, 108, 118, 101, 115, 41,
    34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 98, 103, 66, 97, 114, 114, 105, 101, 114, 66, 101,
    103, 105, 110, 82, 101, 110, 100, 101, 114, 80, 97, 115, 115, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 50,
    48, 52, 56, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 118, 107, 67, 109, 100,
    66, 101, 103, 105, 110, 82, 101, 110, 100, 101, 114, 80, 97, 115, 115, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101,
    34, 58, 32, 34, 68, 98, 103, 66, 97, 114, 114, 105, 101, 114, 78, 101, 120, 116, 83, 117, 98, 112, 97, 115, 115, 34,
    44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 52, 48, 57, 54, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116,
    105, 111, 110, 34, 58, 32, 34, 118, 107, 67, 109, 100, 78, 101, 120, 116, 83, 117, 98, 112, 97, 115, 115, 34, 125,
    44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 98, 103, 66, 97, 114, 114, 105, 101, 114, 69, 110, 100, 82,
    101, 110, 100, 101, 114, 80, 97, 115, 115, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 56, 49, 57, 50, 44,
    32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 118, 107, 67, 109, 100, 69, 110, 100,
    82, 101, 110, 100, 101, 114, 80, 97, 115, 115, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 98,
    103, 66, 97, 114, 114, 105, 101, 114, 83, 101, 116, 82, 101, 115, 101, 116, 69, 118, 101, 110, 116, 34, 44, 32, 34,
    86, 97, 108, 117, 101, 34, 58, 32, 49, 54, 51, 56, 52, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111,
    110, 34, 58, 32, 34, 118, 107, 67, 109, 100, 83, 101, 116, 69, 118, 101, 110, 116, 32, 111, 114, 32, 118, 107, 67,
    109, 100, 82, 101, 115, 101, 116, 69, 118, 101, 110, 116, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32,
    34, 68, 98, 103, 66, 97, 114, 114, 105, 101, 114, 80, 105, 112, 101, 108, 105, 110, 101, 66, 97, 114, 114, 105, 101,
    114, 87, 97, 105, 116, 69, 118, 101, 110, 116, 115, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 51, 50, 55,
    54, 56, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 118, 107, 67, 109, 100, 80,
    105, 112, 101, 108, 105, 110, 101, 66, 97, 114, 114, 105, 101, 114, 32, 111, 114, 32, 118, 107, 67, 109, 100, 87,
    97, 105, 116, 69, 118, 101, 110, 116, 115, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 98, 103,
    66, 97, 114, 114, 105, 101, 114, 81, 117, 101, 114, 121, 66, 101, 103, 105, 110, 69, 110, 100, 34, 44, 32, 34, 86,
    97, 108, 117, 101, 34, 58, 32, 54, 53, 53, 51, 54, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110,
    34, 58, 32, 34, 118, 107, 67, 109, 100, 66, 101, 103, 105, 110, 81, 117, 101, 114, 121, 32, 111, 114, 32, 118, 107,
    67, 109, 100, 69, 110, 100, 81, 117, 101, 114, 121, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68,
    98, 103, 66, 97, 114, 114, 105, 101, 114, 81, 117, 101, 114, 121, 82, 101, 115, 101, 116, 34, 44, 32, 34, 86, 97,
    108, 117, 101, 34, 58, 32, 49, 51, 49, 48, 55, 50, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110,
    34, 58, 32, 34, 118, 107, 67, 109, 100, 82, 101, 115, 101, 116, 81, 117, 101, 114, 121, 80, 111, 111, 108, 34, 125,
    44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 98, 103, 66, 97, 114, 114, 105, 101, 114, 69, 120, 101, 99,
    117, 116, 101, 67, 111, 109, 109, 97, 110, 100, 115, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 50, 54, 50,
    49, 52, 52, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 118, 107, 67, 109, 100,
    69, 120, 101, 99, 117, 116, 101, 67, 111, 109, 109, 97, 110, 100, 115, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101,
    34, 58, 32, 34, 68, 98, 103, 66, 97, 114, 114, 105, 101, 114, 67, 109, 100, 66, 117, 102, 83, 116, 97, 114, 116, 34,
    44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 53, 50, 52, 50, 56, 56, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112,
    116, 105, 111, 110, 34, 58, 32, 34, 83, 116, 97, 114, 116, 32, 111, 102, 32, 116, 104, 101, 32, 99, 111, 109, 109,
    97, 110, 100, 32, 98, 117, 102, 102, 101, 114, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 98,
    103, 66, 97, 114, 114, 105, 101, 114, 67, 109, 100, 66, 117, 102, 69, 110, 100, 34, 44, 32, 34, 86, 97, 108, 117,
    101, 34, 58, 32, 49, 48, 52, 56, 53, 55, 54, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34,
    58, 32, 34, 69, 110, 100, 32, 111, 102, 32, 116, 104, 101, 32, 99, 111, 109, 109, 97, 110, 100, 32, 98, 117, 102,
    102, 101, 114, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 98, 103, 66, 97, 114, 114, 105, 101,
    114, 66, 105, 110, 100, 80, 105, 112, 101, 108, 105, 110, 101, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32,
    50, 48, 57, 55, 49, 53, 50, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 118,
    107, 67, 109, 100, 66, 105, 110, 100, 80, 105, 112, 101, 108, 105, 110, 101, 34, 125, 44, 32, 123, 34, 78, 97, 109,
    101, 34, 58, 32, 34, 68, 98, 103, 66, 97, 114, 114, 105, 101, 114, 66, 105, 110, 100, 83, 101, 116, 115, 80, 117,
    115, 104, 67, 111, 110, 115, 116, 97, 110, 116, 115, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 52, 49, 57,
    52, 51, 48, 52, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 118, 107, 67, 109,
    100, 66, 105, 110, 100, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 83, 101, 116, 115, 32, 111, 114, 32, 118,
    107, 67, 109, 100, 80, 117, 115, 104, 67, 111, 110, 115, 116, 97, 110, 116, 115, 34, 125, 44, 32, 123, 34, 78, 97,
    109, 101, 34, 58, 32, 34, 68, 98, 103, 66, 97, 114, 114, 105, 101, 114, 66, 105, 110, 100, 73, 110, 100, 101, 120,
    86, 101, 114, 116, 101, 120, 66, 117, 102, 102, 101, 114, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 56, 51,
    56, 56, 54, 48, 56, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 118, 107, 67,
    109, 100, 66, 105, 110, 100, 73, 110, 100, 101, 120, 66, 117, 102, 102, 101, 114, 32, 111, 114, 32, 118, 107, 67,
    109, 100, 66, 105, 110, 100, 86, 101, 114, 116, 101, 120, 66, 117, 102, 102, 101, 114, 115, 34, 125, 44, 32, 123,
    34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 98, 103, 66, 97, 114, 114, 105, 101, 114, 87, 114, 105, 116, 101, 84, 105,
    109, 101, 115, 116, 97, 109, 112, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 54, 55, 55, 55, 50, 49, 54,
    44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 118, 107, 67, 109, 100, 87, 114,
    105, 116, 101, 84, 105, 109, 101, 115, 116, 97, 109, 112, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32,
    34, 68, 98, 103, 66, 97, 114, 114, 105, 101, 114, 83, 101, 116, 68, 121, 110, 97, 109, 105, 99, 80, 105, 112, 101,
    108, 105, 110, 101, 83, 116, 97, 116, 101, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 51, 51, 53, 53, 52,
    52, 51, 50, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 65, 110, 121, 32, 118,
    107, 67, 109, 100, 83, 101, 116, 42, 32, 119, 104, 105, 99, 104, 32, 112, 114, 111, 103, 114, 97, 109, 115, 32, 100,
    121, 110, 97, 109, 105, 99, 32, 112, 105, 112, 101, 108, 105, 110, 101, 32, 115, 116, 97, 116, 101, 34, 125, 44, 32,
    123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 98, 103, 66, 97, 114, 114, 105, 101, 114, 86, 105, 100, 101, 111, 34,
    44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 54, 55, 49, 48, 56, 56, 54, 52, 44, 32, 34, 68, 101, 115, 99, 114,
    105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 65, 110, 121, 32, 118, 105, 100, 101, 111, 32, 111, 112, 101, 114, 97,
    116, 105, 111, 110, 115, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 98, 103, 66, 97, 114, 114,
    105, 101, 114, 79, 116, 104, 101, 114, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 50, 49, 52, 55, 52, 56,
    51, 54, 52, 56, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 65, 110, 121, 32,
    111, 116, 104, 101, 114, 32, 99, 111, 109, 109, 97, 110, 100, 32, 110, 111, 116, 32, 108, 105, 115, 116, 101, 100,
    32, 97, 98, 111, 118, 101, 34, 125, 93, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 98, 103, 66, 97, 114, 114,
    105, 101, 114, 67, 109, 100, 34, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101,
    114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114,
    105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 100, 98, 103, 66, 97, 114, 114, 105, 101, 114, 80, 111,
    115, 116, 67, 109, 100, 69, 110, 97, 98, 108, 101, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32,
    50, 57, 48, 56, 52, 53, 55, 52, 52, 56, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110,
    34, 58, 32, 34, 70, 111, 114, 32, 112, 111, 115, 116, 45, 99, 109, 100, 32, 98, 97, 114, 114, 105, 101, 114, 115,
    44, 32, 116, 104, 105, 115, 32, 102, 108, 97, 103, 32, 100, 101, 115, 99, 114, 105, 98, 101, 115, 32, 116, 104, 101,
    32, 80, 65, 76, 32, 72, 119, 80, 105, 112, 101, 80, 111, 105, 110, 116, 32, 112, 105, 112, 101, 108, 105, 110, 101,
    32, 115, 116, 97, 103, 101, 32, 119, 104, 101, 114, 101, 32, 116, 104, 101, 32, 98, 97, 114, 114, 105, 101, 114, 32,
    119, 105, 108, 108, 32, 119, 97, 105, 116, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 68, 101, 98,
    117, 103, 103, 105, 110, 103, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68,
    101, 102, 97, 117, 108, 116, 34, 58, 32, 48, 125, 44, 32, 34, 86, 97, 108, 105, 100, 86, 97, 108, 117, 101, 115, 34,
    58, 32, 123, 34, 86, 97, 108, 117, 101, 115, 34, 58, 32, 91, 123, 34, 86, 97, 108, 117, 101, 34, 58, 32, 48, 44, 32,
    34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 72, 119, 80, 105, 112, 101, 84, 111, 112,
    32, 40, 104, 101, 97, 118, 121, 119, 101, 105, 103, 104, 116, 32, 111, 112, 116, 105, 111, 110, 41, 34, 125, 44, 32,
    123, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34,
    58, 32, 34, 72, 119, 80, 105, 112, 101, 80, 111, 115, 116, 73, 110, 100, 101, 120, 70, 101, 116, 99, 104, 44, 32,
    72, 119, 80, 105, 112, 101, 80, 114, 101, 67, 115, 44, 32, 111, 114, 32, 72, 119, 80, 105, 112, 101, 80, 114, 101,
    66, 108, 116, 34, 125, 44, 32, 123, 34, 86, 97, 108, 117, 101, 34, 58, 32, 51, 44, 32, 34, 68, 101, 115, 99, 114,
    105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 72, 119, 80, 105, 112, 101, 80, 114, 101, 82, 97, 115, 116, 101, 114,
    105, 122, 97, 116, 105, 111, 110, 34, 125, 44, 32, 123, 34, 86, 97, 108, 117, 101, 34, 58, 32, 52, 44, 32, 34, 68,
    101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 72, 119, 80, 105, 112, 101, 80, 111, 115, 116, 80,
    115, 34, 125, 44, 32, 123, 34, 86, 97, 108, 117, 101, 34, 58, 32, 53, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112,
    116, 105, 111, 110, 34, 58, 32, 34, 72, 119, 80, 105, 112, 101, 80, 111, 115, 116, 67, 115, 34, 125, 44, 32, 123,
    34, 86, 97, 108, 117, 101, 34, 58, 32, 54, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58,
    32, 34, 72, 119, 80, 105, 112, 101, 80, 111, 115, 116, 66, 108, 116, 34, 125, 44, 32, 123, 34, 86, 97, 108, 117,
    101, 34, 58, 32, 55, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 72, 119, 80,
    105, 112, 101, 66, 111, 116, 116, 111, 109, 34, 125, 93, 125, 44, 32, 34, 70, 108, 97, 103, 115, 34, 58, 32, 123,
    34, 73, 115, 72, 101, 120, 34, 58, 32, 116, 114, 117, 101, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34,
    68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44,
    32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 100, 98, 103, 66, 97, 114, 114, 105,
    101, 114, 80, 111, 115, 116, 87, 97, 105, 116, 80, 105, 112, 101, 80, 111, 105, 110, 116, 34, 44, 32, 34, 78, 97,
    109, 101, 34, 58, 32, 34, 68, 98, 103, 66, 97, 114, 114, 105, 101, 114, 80, 111, 115, 116, 87, 97, 105, 116, 80,
    105, 112, 101, 80, 111, 105, 110, 116, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 49, 53, 54,
    48, 50, 55, 55, 57, 56, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34,
    70, 111, 114, 32, 112, 111, 115, 116, 45, 99, 109, 100, 32, 98, 97, 114, 114, 105, 101, 114, 115, 44, 32, 116, 104,
    105, 115, 32, 102, 108, 97, 103, 32, 100, 101, 115, 99, 114, 105, 98, 101, 115, 32, 116, 104, 101, 32, 80, 65, 76,
    32, 72, 119, 80, 105, 112, 101, 80, 111, 105, 110, 116, 32, 112, 105, 112, 101, 108, 105, 110, 101, 32, 115, 116,
    97, 103, 101, 32, 119, 104, 101, 114, 101, 32, 116, 104, 101, 32, 98, 97, 114, 114, 105, 101, 114, 32, 105, 115, 32,
    115, 105, 103, 110, 97, 108, 101, 100, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 68, 101, 98, 117,
    103, 103, 105, 110, 103, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101,
    102, 97, 117, 108, 116, 34, 58, 32, 48, 125, 44, 32, 34, 86, 97, 108, 105, 100, 86, 97, 108, 117, 101, 115, 34, 58,
    32, 123, 34, 86, 97, 108, 117, 101, 115, 34, 58, 32, 91, 123, 34, 86, 97, 108, 117, 101, 34, 58, 32, 48, 44, 32, 34,
    68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 72, 119, 80, 105, 112, 101, 84, 111, 112, 34,
    125, 44, 32, 123, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105,
    111, 110, 34, 58, 32, 34, 72, 119, 80, 105, 112, 101, 80, 111, 115, 116, 73, 110, 100, 101, 120, 70, 101, 116, 99,
    104, 44, 32, 72, 119, 80, 105, 112, 101, 80, 114, 101, 67, 115, 44, 32, 111, 114, 32, 72, 119, 80, 105, 112, 101,
    80, 114, 101, 66, 108, 116, 34, 125, 44, 32, 123, 34, 86, 97, 108, 117, 101, 34, 58, 32, 51, 44, 32, 34, 68, 101,
    115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 72, 119, 80, 105, 112, 101, 80, 114, 101, 82, 97, 115,
    116, 101, 114, 105, 122, 97, 116, 105, 111, 110, 34, 125, 44, 32, 123, 34, 86, 97, 108, 117, 101, 34, 58, 32, 52,
    44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 72, 119, 80, 105, 112, 101, 80,
    111, 115, 116, 80, 115, 34, 125, 44, 32, 123, 34, 86, 97, 108, 117, 101, 34, 58, 32, 53, 44, 32, 34, 68, 101, 115,
    99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 72, 119, 80, 105, 112, 101, 80, 111, 115, 116, 67, 115, 34,
    125, 44, 32, 123, 34, 86, 97, 108, 117, 101, 34, 58, 32, 54, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105,
    111, 110, 34, 58, 32, 34, 72, 119, 80, 105, 112, 101, 80, 111, 115, 116, 66, 108, 116, 34, 125, 44, 32, 123, 34, 86,
    97, 108, 117, 101, 34, 58, 32, 55, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34,
    72, 119, 80, 105, 112, 101, 66, 111, 116, 116, 111, 109, 32, 40, 104, 101, 97, 118, 121, 119, 101, 105, 103, 104,
    116, 32, 111, 112, 116, 105, 111, 110, 41, 34, 125, 93, 125, 44, 32, 34, 70, 108, 97, 103, 115, 34, 58, 32, 123, 34,
    73, 115, 72, 101, 120, 34, 58, 32, 116, 114, 117, 101, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68,
    114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32,
    34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 100, 98, 103, 66, 97, 114, 114, 105, 101,
    114, 80, 111, 115, 116, 83, 105, 103, 110, 97, 108, 80, 105, 112, 101, 80, 111, 105, 110, 116, 34, 44, 32, 34, 78,
    97, 109, 101, 34, 58, 32, 34, 68, 98, 103, 66, 97, 114, 114, 105, 101, 114, 80, 111, 115, 116, 83, 105, 103, 110,
    97, 108, 80, 105, 112, 101, 80, 111, 105, 110, 116, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32,
    56, 57, 53, 49, 50, 56, 48, 52, 53, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34,
    58, 32, 34, 70, 111, 114, 32, 112, 111, 115, 116, 45, 99, 109, 100, 32, 98, 97, 114, 114, 105, 101, 114, 115, 44,
    32, 116, 104, 105, 115, 32, 102, 108, 97, 103, 32, 100, 101, 115, 99, 114, 105, 98, 101, 115, 32, 116, 104, 101, 32,
    80, 65, 76, 32, 67, 97, 99, 104, 101, 67, 111, 104, 101, 114, 101, 110, 99, 121, 85, 115, 97, 103, 101, 70, 108, 97,
    103, 115, 32, 115, 111, 117, 114, 99, 101, 32, 109, 97, 115, 107, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32,
    91, 34, 68, 101, 98, 117, 103, 103, 105, 110, 103, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58,
    32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 48, 125, 44, 32, 34, 86, 97, 108, 105, 100, 86, 97, 108,
    117, 101, 115, 34, 58, 32, 123, 34, 86, 97, 108, 117, 101, 115, 34, 58, 32, 91, 123, 34, 86, 97, 108, 117, 101, 34,
    58, 32, 49, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 67, 111, 104, 101, 114,
    67, 112, 117, 34, 125, 44, 32, 123, 34, 86, 97, 108, 117, 101, 34, 58, 32, 50, 44, 32, 34, 68, 101, 115, 99, 114,
    105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 67, 111, 104, 101, 114, 83, 104, 97, 100, 101, 114, 34, 125, 44, 32,
    123, 34, 86, 97, 108, 117, 101, 34, 58, 32, 52, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34,
    58, 32, 34, 67, 111, 104, 101, 114, 67, 111, 112, 121, 34, 125, 44, 32, 123, 34, 86, 97, 108, 117, 101, 34, 58, 32,
    56, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 67, 111, 104, 101, 114, 67,
    111, 108, 111, 114, 84, 97, 114, 103, 101, 116, 34, 125, 44, 32, 123, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 54,
    44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 67, 111, 104, 101, 114, 68, 101,
    112, 116, 104, 83, 116, 101, 110, 99, 105, 108, 84, 97, 114, 103, 101, 116, 34, 125, 44, 32, 123, 34, 86, 97, 108,
    117, 101, 34, 58, 32, 51, 50, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 67,
    111, 104, 101, 114, 82, 101, 115, 111, 108, 118, 101, 34, 125, 44, 32, 123, 34, 86, 97, 108, 117, 101, 34, 58, 32,
    54, 52, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 67, 111, 104, 101, 114, 67,
    108, 101, 97, 114, 34, 125, 44, 32, 123, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 50, 56, 44, 32, 34, 68, 101,
    115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 67, 111, 104, 101, 114, 73, 110, 100, 105, 114, 101, 99,
    116, 65, 114, 103, 115, 34, 125, 44, 32, 123, 34, 86, 97, 108, 117, 101, 34, 58, 32, 50, 53, 54, 44, 32, 34, 68,
    101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 67, 111, 104, 101, 114, 73, 110, 100, 101, 120, 68,
    97, 116, 97, 34, 125, 44, 32, 123, 34, 86, 97, 108, 117, 101, 34, 58, 32, 53, 49, 50, 44, 32, 34, 68, 101, 115, 99,
    114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 67, 111, 104, 101, 114, 81, 117, 101, 117, 101, 65, 116, 111,
    109, 105, 99, 34, 125, 44, 32, 123, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 48, 50, 52, 44, 32, 34, 68, 101, 115,
    99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 67, 111, 104, 101, 114, 84, 105, 109, 101, 115, 116, 97, 109,
    112, 34, 125, 44, 32, 123, 34, 86, 97, 108, 117, 101, 34, 58, 32, 50, 48, 52, 56, 44, 32, 34, 68, 101, 115, 99, 114,
    105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 67, 111, 104, 101, 114, 67, 101, 76, 111, 97, 100, 34, 125, 44, 32,
    123, 34, 86, 97, 108, 117, 101, 34, 58, 32, 52, 48, 57, 54, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105,
    111, 110, 34, 58, 32, 34, 67, 111, 104, 101, 114, 67, 101, 68, 117, 109, 112, 34, 125, 44, 32, 123, 34, 86, 97, 108,
    117, 101, 34, 58, 32, 56, 49, 57, 50, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32,
    34, 67, 111, 104, 101, 114, 83, 116, 114, 101, 97, 109, 79, 117, 116, 34, 125, 44, 32, 123, 34, 86, 97, 108, 117,
    101, 34, 58, 32, 49, 54, 51, 56, 52, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32,
    34, 67, 111, 104, 101, 114, 77, 101, 109, 111, 114, 121, 34, 125, 44, 32, 123, 34, 86, 97, 108, 117, 101, 34, 58,
    32, 51, 50, 55, 54, 55, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 67, 111,
    104, 101, 114, 65, 108, 108, 85, 115, 97, 103, 101, 115, 32, 40, 104, 101, 97, 118, 121, 119, 101, 105, 103, 104,
    116, 32, 111, 112, 116, 105, 111, 110, 41, 34, 125, 93, 125, 44, 32, 34, 70, 108, 97, 103, 115, 34, 58, 32, 123, 34,
    73, 115, 72, 101, 120, 34, 58, 32, 116, 114, 117, 101, 44, 32, 34, 73, 115, 66, 105, 116, 109, 97, 115, 107, 34, 58,
    32, 116, 114, 117, 101, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44,
    32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98,
    108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 100, 98, 103, 66, 97, 114, 114, 105, 101, 114, 80, 111, 115, 116, 67,
    97, 99, 104, 101, 83, 114, 99, 77, 97, 115, 107, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 98, 103, 66,
    97, 114, 114, 105, 101, 114, 80, 111, 115, 116, 67, 97, 99, 104, 101, 83, 114, 99, 77, 97, 115, 107, 34, 44, 32, 34,
    72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 49, 51, 50, 48, 48, 54, 50, 49, 55, 55, 125, 44, 32, 123, 34, 68,
    101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 70, 111, 114, 32, 112, 111, 115, 116, 45, 99, 109,
    100, 32, 98, 97, 114, 114, 105, 101, 114, 115, 44, 32, 116, 104, 105, 115, 32, 102, 108, 97, 103, 32, 100, 101, 115,
    99, 114, 105, 98, 101, 115, 32, 116, 104, 101, 32, 80, 65, 76, 32, 67, 97, 99, 104, 101, 67, 111, 104, 101, 114,
    101, 110, 99, 121, 85, 115, 97, 103, 101, 70, 108, 97, 103, 115, 32, 100, 101, 115, 116, 105, 110, 97, 116, 105,
    111, 110, 32, 109, 97, 115, 107, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 68, 101, 98, 117, 103,
    103, 105, 110, 103, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97,
    117, 108, 116, 34, 58, 32, 48, 125, 44, 32, 34, 86, 97, 108, 105, 100, 86, 97, 108, 117, 101, 115, 34, 58, 32, 123,
    34, 86, 97, 108, 117, 101, 115, 34, 58, 32, 91, 123, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 44, 32, 34, 68, 101,
    115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 67, 111, 104, 101, 114, 67, 112, 117, 34, 125, 44, 32,
    123, 34, 86, 97, 108, 117, 101, 34, 58, 32, 50, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34,
    58, 32, 34, 67, 111, 104, 101, 114, 83, 104, 97, 100, 101, 114, 34, 125, 44, 32, 123, 34, 86, 97, 108, 117, 101, 34,
    58, 32, 52, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 67, 111, 104, 101, 114,
    67, 111, 112, 121, 34, 125, 44, 32, 123, 34, 86, 97, 108, 117, 101, 34, 58, 32, 56, 44, 32, 34, 68, 101, 115, 99,
    114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 67, 111, 104, 101, 114, 67, 111, 108, 111, 114, 84, 97, 114, 103,
    101, 116, 34, 125, 44, 32, 123, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 54, 44, 32, 34, 68, 101, 115, 99, 114,
    105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 67, 111, 104, 101, 114, 68, 101, 112, 116, 104, 83, 116, 101, 110, 99,
    105, 108, 84, 97, 114, 103, 101, 116, 34, 125, 44, 32, 123, 34, 86, 97, 108, 117, 101, 34, 58, 32, 51, 50, 44, 32,
    34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 67, 111, 104, 101, 114, 82, 101, 115, 111,
    108, 118, 101, 34, 125, 44, 32, 123, 34, 86, 97, 108, 117, 101, 34, 58, 32, 54, 52, 44, 32, 34, 68, 101, 115, 99,
    114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 67, 111, 104, 101, 114, 67, 108, 101, 97, 114, 34, 125, 44, 32,
    123, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 50, 56, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111,
    110, 34, 58, 32, 34, 67, 111, 104, 101, 114, 73, 110, 100, 105, 114, 101, 99, 116, 65, 114, 103, 115, 34, 125, 44,
    32, 123, 34, 86, 97, 108, 117, 101, 34, 58, 32, 50, 53, 54, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105,
    111, 110, 34, 58, 32, 34, 67, 111, 104, 101, 114, 73, 110, 100, 101, 120, 68, 97, 116, 97, 34, 125, 44, 32, 123, 34,
    86, 97, 108, 117, 101, 34, 58, 32, 53, 49, 50, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34,
    58, 32, 34, 67, 111, 104, 101, 114, 81, 117, 101, 117, 101, 65, 116, 111, 109, 105, 99, 34, 125, 44, 32, 123, 34,
    86, 97, 108, 117, 101, 34, 58, 32, 49, 48, 50, 52, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110,
    34, 58, 32, 34, 67, 111, 104, 101, 114, 84, 105, 109, 101, 115, 116, 97, 109, 112, 34, 125, 44, 32, 123, 34, 86, 97,
    108, 117, 101, 34, 58, 32, 50, 48, 52, 56, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58,
    32, 34, 67, 111, 104, 101, 114, 67, 101, 76, 111, 97, 100, 34, 125, 44, 32, 123, 34, 86, 97, 108, 117, 101, 34, 58,
    32, 52, 48, 57, 54, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 67, 111, 104,
    101, 114, 67, 101, 68, 117, 109, 112, 34, 125, 44, 32, 123, 34, 86, 97, 108, 117, 101, 34, 58, 32, 56, 49, 57, 50,
    44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 67, 111, 104, 101, 114, 83, 116,
    114, 101, 97, 109, 79, 117, 116, 34, 125, 44, 32, 123, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 54, 51, 56, 52,
    44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 67, 111, 104, 101, 114, 77, 101,
    109, 111, 114, 121, 34, 125, 44, 32, 123, 34, 86, 97, 108, 117, 101, 34, 58, 32, 51, 50, 55, 54, 55, 44, 32, 34, 68,
    101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 67, 111, 104, 101, 114, 65, 108, 108, 85, 115, 97,
    103, 101, 115, 32, 40, 104, 101, 97, 118, 121, 119, 101, 105, 103, 104, 116, 32, 111, 112, 116, 105, 111, 110, 41,
    34, 125, 93, 125, 44, 32, 34, 70, 108, 97, 103, 115, 34, 58, 32, 123, 34, 73, 115, 72, 101, 120, 34, 58, 32, 116,
    114, 117, 101, 44, 32, 34, 73, 115, 66, 105, 116, 109, 97, 115, 107, 34, 58, 32, 116, 114, 117, 101, 125, 44, 32,
    34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58,
    32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58,
    32, 34, 100, 98, 103, 66, 97, 114, 114, 105, 101, 114, 80, 111, 115, 116, 67, 97, 99, 104, 101, 68, 115, 116, 77,
    97, 115, 107, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 98, 103, 66, 97, 114, 114, 105, 101, 114, 80,
    111, 115, 116, 67, 97, 99, 104, 101, 68, 115, 116, 77, 97, 115, 107, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109,
    101, 34, 58, 32, 49, 50, 51, 49, 50, 56, 53, 56, 54, 52, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116,
    105, 111, 110, 34, 58, 32, 34, 84, 114, 105, 103, 103, 101, 114, 115, 32, 97, 32, 67, 109, 100, 66, 97, 114, 114,
    105, 101, 114, 32, 99, 97, 108, 108, 32, 98, 101, 102, 111, 114, 101, 32, 97, 110, 121, 32, 99, 111, 109, 109, 97,
    110, 100, 32, 105, 110, 32, 116, 104, 101, 32, 103, 105, 118, 101, 110, 32, 109, 97, 115, 107, 46, 32, 32, 84, 104,
    101, 32, 98, 97, 114, 114, 105, 101, 114, 32, 98, 101, 104, 97, 118, 105, 111, 114, 32, 105, 115, 32, 99, 111, 110,
    116, 114, 111, 108, 108, 101, 100, 32, 98, 121, 32, 116, 104, 101, 32, 111, 116, 104, 101, 114, 32, 68, 98, 103, 66,
    97, 114, 114, 105, 101, 114, 80, 114, 101, 42, 32, 115, 101, 116, 116, 105, 110, 103, 115, 32, 105, 110, 32, 116,
    104, 105, 115, 32, 99, 97, 116, 101, 103, 111, 114, 121, 46, 32, 32, 82, 101, 113, 117, 105, 114, 101, 115, 32, 86,
    75, 95, 69, 78, 65, 66, 76, 69, 95, 68, 69, 66, 85, 71, 95, 66, 65, 82, 82, 73, 69, 82, 83, 61, 49, 32, 116, 111,
    32, 116, 97, 107, 101, 32, 101, 102, 102, 101, 99, 116, 46, 32, 70, 111, 114, 32, 102, 117, 114, 116, 104, 101, 114,
    32, 100, 111, 99, 117, 109, 101, 110, 116, 97, 116, 105, 111, 110, 44, 32, 99, 111, 110, 115, 117, 108, 116, 32,
    116, 104, 101, 32, 99, 111, 114, 114, 101, 115, 112, 111, 110, 100, 105, 110, 103, 32, 68, 98, 103, 66, 97, 114,
    114, 105, 101, 114, 80, 111, 115, 116, 67, 109, 100, 69, 110, 97, 98, 108, 101, 32, 99, 111, 109, 109, 97, 110, 100,
    46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 68, 101, 98, 117, 103, 103, 105, 110, 103, 34, 93, 44, 32,
    34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 48, 125,
    44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101,
    34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101,
    34, 58, 32, 34, 100, 98, 103, 66, 97, 114, 114, 105, 101, 114, 80, 114, 101, 67, 109, 100, 69, 110, 97, 98, 108,
    101, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 98, 103, 66, 97, 114, 114, 105, 101, 114, 80, 114, 101,
    67, 109, 100, 69, 110, 97, 98, 108, 101, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 49, 54, 48,
    57, 55, 53, 52, 51, 57, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34,
    70, 111, 114, 32, 112, 114, 101, 45, 99, 109, 100, 32, 98, 97, 114, 114, 105, 101, 114, 115, 44, 32, 116, 104, 105,
    115, 32, 102, 108, 97, 103, 32, 100, 101, 115, 99, 114, 105, 98, 101, 115, 32, 116, 104, 101, 32, 80, 65, 76, 32,
    72, 119, 80, 105, 112, 101, 80, 111, 105, 110, 116, 32, 112, 105, 112, 101, 108, 105, 110, 101, 32, 115, 116, 97,
    103, 101, 32, 119, 104, 101, 114, 101, 32, 116, 104, 101, 32, 98, 97, 114, 114, 105, 101, 114, 32, 119, 105, 108,
    108, 32, 119, 97, 105, 116, 46, 32, 70, 111, 114, 32, 102, 117, 114, 116, 104, 101, 114, 32, 100, 111, 99, 117, 109,
    101, 110, 116, 97, 116, 105, 111, 110, 44, 32, 99, 111, 110, 115, 117, 108, 116, 32, 68, 98, 103, 66, 97, 114, 114,
    105, 101, 114, 80, 111, 115, 116, 87, 97, 105, 116, 80, 105, 112, 101, 80, 111, 105, 110, 116, 46, 34, 44, 32, 34,
    84, 97, 103, 115, 34, 58, 32, 91, 34, 68, 101, 98, 117, 103, 103, 105, 110, 103, 34, 93, 44, 32, 34, 68, 101, 102,
    97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 48, 125, 44, 32, 34, 83,
    99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34,
    117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34,
    100, 98, 103, 66, 97, 114, 114, 105, 101, 114, 80, 114, 101, 87, 97, 105, 116, 80, 105, 112, 101, 80, 111, 105, 110,
    116, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 98, 103, 66, 97, 114, 114, 105, 101, 114, 80, 114, 101,
    87, 97, 105, 116, 80, 105, 112, 101, 80, 111, 105, 110, 116, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34,
    58, 32, 51, 57, 49, 48, 49, 53, 48, 49, 57, 51, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105,
    111, 110, 34, 58, 32, 34, 70, 111, 114, 32, 112, 114, 101, 45, 99, 109, 100, 32, 98, 97, 114, 114, 105, 101, 114,
    115, 44, 32, 116, 104, 105, 115, 32, 102, 108, 97, 103, 32, 100, 101, 115, 99, 114, 105, 98, 101, 115, 32, 116, 104,
    101, 32, 80, 65, 76, 32, 72, 119, 80, 105, 112, 101, 80, 111, 105, 110, 116, 32, 112, 105, 112, 101, 108, 105, 110,
    101, 32, 115, 116, 97, 103, 101, 32, 119, 104, 101, 114, 101, 32, 116, 104, 101, 32, 98, 97, 114, 114, 105, 101,
    114, 32, 105, 115, 32, 115, 105, 103, 110, 97, 108, 101, 100, 46, 32, 70, 111, 114, 32, 102, 117, 114, 116, 104,
    101, 114, 32, 100, 111, 99, 117, 109, 101, 110, 116, 97, 116, 105, 111, 110, 44, 32, 99, 111, 110, 115, 117, 108,
    116, 32, 68, 98, 103, 66, 97, 114, 114, 105, 101, 114, 80, 111, 115, 116, 83, 105, 103, 110, 97, 108, 80, 105, 112,
    101, 80, 111, 105, 110, 116, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 68, 101, 98, 117, 103, 103,
    105, 110, 103, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117,
    108, 116, 34, 58, 32, 48, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34,
    44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98,
    108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 100, 98, 103, 66, 97, 114, 114, 105, 101, 114, 80, 114, 101, 83, 105,
    103, 110, 97, 108, 80, 105, 112, 101, 80, 111, 105, 110, 116, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68,
    98, 103, 66, 97, 114, 114, 105, 101, 114, 80, 114, 101, 83, 105, 103, 110, 97, 108, 80, 105, 112, 101, 80, 111, 105,
    110, 116, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 50, 55, 54, 48, 54, 57, 51, 49, 57, 48,
    125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 70, 111, 114, 32, 112,
    114, 101, 45, 99, 109, 100, 32, 98, 97, 114, 114, 105, 101, 114, 115, 44, 32, 116, 104, 105, 115, 32, 102, 108, 97,
    103, 32, 100, 101, 115, 99, 114, 105, 98, 101, 115, 32, 116, 104, 101, 32, 80, 65, 76, 32, 67, 97, 99, 104, 101, 67,
    111, 104, 101, 114, 101, 110, 99, 121, 85, 115, 97, 103, 101, 70, 108, 97, 103, 115, 32, 115, 111, 117, 114, 99,
    101, 32, 109, 97, 115, 107, 46, 32, 70, 111, 114, 32, 102, 117, 114, 116, 104, 101, 114, 32, 100, 111, 99, 117, 109,
    101, 110, 116, 97, 116, 105, 111, 110, 44, 32, 99, 111, 110, 115, 117, 108, 116, 32, 68, 98, 103, 66, 97, 114, 114,
    105, 101, 114, 80, 111, 115, 116, 67, 97, 99, 104, 101, 83, 114, 99, 77, 97, 115, 107, 46, 34, 44, 32, 34, 84, 97,
    103, 115, 34, 58, 32, 91, 34, 68, 101, 98, 117, 103, 103, 105, 110, 103, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117,
    108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 48, 125, 44, 32, 34, 83, 99, 111,
    112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105,
    110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 100, 98,
    103, 66, 97, 114, 114, 105, 101, 114, 80, 114, 101, 67, 97, 99, 104, 101, 83, 114, 99, 77, 97, 115, 107, 34, 44, 32,
    34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 98, 103, 66, 97, 114, 114, 105, 101, 114, 80, 114, 101, 67, 97, 99, 104,
    101, 83, 114, 99, 77, 97, 115, 107, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 49, 56, 57, 49,
    56, 49, 50, 54, 51, 50, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34,
    70, 111, 114, 32, 112, 114, 101, 45, 99, 109, 100, 32, 98, 97, 114, 114, 105, 101, 114, 115, 44, 32, 116, 104, 105,
    115, 32, 102, 108, 97, 103, 32, 100, 101, 115, 99, 114, 105, 98, 101, 115, 32, 116, 104, 101, 32, 80, 65, 76, 32,
    67, 97, 99, 104, 101, 67, 111, 104, 101, 114, 101, 110, 99, 121, 85, 115, 97, 103, 101, 70, 108, 97, 103, 115, 32,
    100, 101, 115, 116, 105, 110, 97, 116, 105, 111, 110, 32, 109, 97, 115, 107, 46, 32, 70, 111, 114, 32, 102, 117,
    114, 116, 104, 101, 114, 32, 100, 111, 99, 117, 109, 101, 110, 116, 97, 116, 105, 111, 110, 44, 32, 99, 111, 110,
    115, 117, 108, 116, 32, 68, 98, 103, 66, 97, 114, 114, 105, 101, 114, 80, 111, 115, 116, 67, 97, 99, 104, 101, 68,
    115, 116, 77, 97, 115, 107, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 68, 101, 98, 117, 103, 103,
    105, 110, 103, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117,
    108, 116, 34, 58, 32, 48, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34,
    44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98,
    108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 100, 98, 103, 66, 97, 114, 114, 105, 101, 114, 80, 114, 101, 67, 97, 99,
    104, 101, 68, 115, 116, 77, 97, 115, 107, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 98, 103, 66, 97,
    114, 114, 105, 101, 114, 80, 114, 101, 67, 97, 99, 104, 101, 68, 115, 116, 77, 97, 115, 107, 34, 44, 32, 34, 72, 97,
    115, 104, 78, 97, 109, 101, 34, 58, 32, 49, 51, 57, 57, 48, 53, 48, 51, 51, 125, 44, 32, 123, 34, 68, 101, 115, 99,
    114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 73, 110, 115, 116, 97, 110, 99, 101, 100, 32, 118, 101, 114, 116,
    101, 120, 32, 98, 117, 102, 102, 101, 114, 32, 116, 97, 98, 108, 101, 32, 114, 105, 110, 103, 32, 115, 105, 122,
    101, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 71, 101, 110, 101, 114, 97, 108, 34, 93, 44, 32, 34,
    68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 49, 48, 50,
    52, 125, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114,
    105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 118, 98, 84, 97, 98, 108, 101, 73, 110, 115, 116, 97, 110,
    99, 101, 82, 105, 110, 103, 83, 105, 122, 101, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 86, 101, 114, 116,
    101, 120, 66, 117, 102, 102, 101, 114, 84, 97, 98, 108, 101, 73, 110, 115, 116, 97, 110, 99, 101, 82, 105, 110, 103,
    83, 105, 122, 101, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32,
    34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 51, 52, 57, 56, 51, 55, 54, 48, 54, 51, 125, 44, 32, 123, 34,
    86, 97, 108, 105, 100, 86, 97, 108, 117, 101, 115, 34, 58, 32, 123, 34, 73, 115, 69, 110, 117, 109, 34, 58, 32, 116,
    114, 117, 101, 44, 32, 34, 86, 97, 108, 117, 101, 115, 34, 58, 32, 91, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34,
    68, 101, 102, 97, 117, 108, 116, 82, 101, 115, 111, 117, 114, 99, 101, 66, 97, 114, 114, 105, 101, 114, 34, 44, 32,
    34, 86, 97, 108, 117, 101, 34, 58, 32, 48, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58,
    32, 34, 68, 101, 102, 97, 117, 108, 116, 32, 98, 97, 114, 114, 105, 101, 114, 32, 113, 117, 101, 117, 101, 115, 34,
    125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 67, 111, 109, 98, 105, 110, 101, 100, 65, 99, 99, 101, 115,
    115, 77, 97, 115, 107, 115, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 54, 51, 56, 52, 44, 32, 34, 68,
    101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 73, 103, 110, 111, 114, 101, 32, 86, 117, 108, 107,
    97, 110, 32, 115, 101, 112, 97, 114, 97, 116, 101, 32, 97, 99, 99, 101, 115, 115, 32, 109, 97, 115, 107, 32, 114,
    117, 108, 101, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 83, 107, 105, 112, 68, 115, 116, 67, 97,
    99, 104, 101, 73, 110, 118, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 51, 50, 55, 54, 56, 44, 32, 34, 68,
    101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 68, 111, 32, 110, 111, 116, 32, 105, 110, 118, 97,
    108, 105, 100, 97, 116, 101, 32, 100, 101, 115, 116, 32, 99, 97, 99, 104, 101, 115, 32, 105, 102, 32, 115, 114, 99,
    32, 99, 97, 99, 104, 101, 32, 119, 97, 115, 32, 110, 111, 116, 32, 117, 112, 100, 97, 116, 101, 100, 34, 125, 44,
    32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 80, 114, 101, 102, 101, 114, 70, 108, 117, 115, 104, 79, 118, 101,
    114, 73, 110, 118, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 56, 49, 57, 50, 44, 32, 34, 68, 101, 115, 99,
    114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 66, 121, 32, 100, 101, 102, 97, 117, 108, 116, 32, 119, 101, 32,
    105, 110, 118, 97, 108, 105, 100, 97, 116, 101, 32, 105, 110, 112, 117, 116, 32, 99, 97, 99, 104, 101, 115, 32, 116,
    111, 32, 97, 99, 99, 111, 109, 111, 100, 97, 116, 101, 32, 116, 104, 101, 32, 86, 117, 108, 107, 97, 110, 32, 115,
    101, 112, 97, 114, 97, 116, 101, 32, 97, 99, 99, 101, 115, 115, 32, 109, 97, 115, 107, 32, 114, 117, 108, 101, 46,
    32, 87, 104, 101, 110, 32, 116, 104, 105, 115, 32, 105, 115, 32, 115, 101, 116, 32, 119, 101, 39, 108, 108, 32, 105,
    110, 115, 116, 101, 97, 100, 32, 102, 108, 117, 115, 104, 32, 97, 108, 108, 32, 111, 117, 116, 112, 117, 116, 32,
    99, 97, 99, 104, 101, 115, 32, 105, 110, 115, 116, 101, 97, 100, 32, 116, 111, 32, 97, 99, 104, 105, 101, 118, 101,
    32, 116, 104, 101, 32, 115, 97, 109, 101, 32, 103, 111, 97, 108, 46, 32, 77, 117, 116, 117, 97, 108, 108, 121, 32,
    101, 120, 99, 108, 117, 115, 105, 118, 101, 32, 119, 105, 116, 104, 32, 83, 107, 105, 112, 68, 115, 116, 67, 97, 99,
    104, 101, 73, 110, 118, 46, 32, 77, 97, 121, 32, 111, 114, 32, 109, 97, 121, 32, 110, 111, 116, 32, 98, 101, 32, 98,
    101, 110, 101, 102, 105, 99, 105, 97, 108, 32, 102, 111, 114, 32, 99, 101, 114, 116, 97, 105, 110, 32, 97, 112, 112,
    108, 105, 99, 97, 116, 105, 111, 110, 115, 46, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 71, 102,
    120, 54, 75, 101, 101, 112, 83, 104, 97, 100, 101, 114, 67, 111, 104, 101, 114, 34, 44, 32, 34, 86, 97, 108, 117,
    101, 34, 58, 32, 50, 53, 54, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 75,
    101, 101, 112, 32, 115, 104, 97, 100, 101, 114, 32, 100, 111, 109, 97, 105, 110, 32, 97, 108, 119, 97, 121, 115, 32,
    99, 111, 104, 101, 114, 101, 110, 116, 32, 111, 110, 32, 71, 70, 88, 54, 45, 71, 70, 88, 56, 32, 116, 104, 117, 115,
    32, 97, 118, 111, 105, 100, 105, 110, 103, 32, 76, 50, 32, 99, 97, 99, 104, 101, 32, 102, 108, 117, 115, 104, 101,
    115, 47, 105, 110, 118, 97, 108, 105, 100, 97, 116, 105, 111, 110, 115, 32, 105, 110, 32, 115, 104, 97, 100, 101,
    114, 45, 116, 111, 45, 115, 104, 97, 100, 101, 114, 32, 98, 97, 114, 114, 105, 101, 114, 32, 99, 97, 115, 101, 115,
    32, 97, 116, 32, 116, 104, 101, 32, 101, 120, 112, 101, 110, 115, 101, 32, 111, 102, 32, 97, 108, 119, 97, 121, 115,
    32, 102, 108, 117, 115, 104, 105, 110, 103, 47, 105, 110, 118, 97, 108, 105, 100, 97, 116, 105, 110, 103, 32, 76,
    49, 32, 99, 97, 99, 104, 101, 115, 46, 32, 84, 104, 105, 115, 32, 100, 111, 101, 115, 32, 78, 79, 84, 32, 118, 105,
    111, 108, 97, 116, 101, 32, 116, 104, 101, 32, 86, 117, 108, 107, 97, 110, 32, 115, 101, 112, 97, 114, 97, 116, 101,
    32, 97, 99, 99, 101, 115, 115, 32, 109, 97, 115, 107, 32, 114, 117, 108, 101, 46, 32, 84, 104, 105, 115, 32, 98,
    101, 104, 97, 118, 105, 111, 114, 32, 105, 115, 32, 108, 105, 107, 101, 108, 121, 32, 112, 114, 101, 102, 101, 114,
    114, 101, 100, 32, 111, 110, 32, 71, 70, 88, 54, 45, 71, 70, 88, 56, 46, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101,
    34, 58, 32, 34, 71, 102, 120, 54, 65, 118, 111, 105, 100, 67, 112, 117, 77, 101, 109, 111, 114, 121, 67, 111, 104,
    101, 114, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 53, 49, 50, 44, 32, 34, 68, 101, 115, 99, 114, 105,
    112, 116, 105, 111, 110, 34, 58, 32, 34, 65, 118, 111, 105, 100, 32, 67, 80, 85, 32, 97, 110, 100, 32, 109, 101,
    109, 111, 114, 121, 32, 100, 111, 109, 97, 105, 110, 32, 99, 111, 104, 101, 114, 101, 110, 99, 121, 32, 111, 110,
    32, 71, 70, 88, 54, 45, 71, 70, 88, 56, 32, 117, 110, 108, 101, 115, 115, 32, 99, 111, 114, 114, 101, 115, 112, 111,
    110, 100, 105, 110, 103, 32, 102, 108, 97, 103, 115, 32, 97, 114, 101, 32, 101, 120, 112, 108, 105, 99, 105, 116,
    108, 121, 32, 114, 101, 113, 117, 101, 115, 116, 101, 100, 32, 116, 111, 32, 108, 111, 119, 101, 114, 32, 116, 104,
    101, 32, 110, 117, 109, 98, 101, 114, 32, 111, 102, 32, 76, 50, 32, 99, 97, 99, 104, 101, 32, 102, 108, 117, 115,
    104, 101, 115, 47, 105, 110, 118, 97, 108, 105, 100, 97, 116, 105, 111, 110, 115, 46, 32, 84, 104, 105, 115, 32,
    100, 111, 101, 115, 32, 78, 79, 84, 32, 118, 105, 111, 108, 97, 116, 101, 32, 116, 104, 101, 32, 86, 117, 108, 107,
    97, 110, 32, 115, 101, 112, 97, 114, 97, 116, 101, 32, 97, 99, 99, 101, 115, 115, 32, 109, 97, 115, 107, 32, 114,
    117, 108, 101, 46, 32, 84, 104, 105, 115, 32, 98, 101, 104, 97, 118, 105, 111, 114, 32, 109, 97, 121, 32, 111, 114,
    32, 109, 97, 121, 32, 110, 111, 116, 32, 98, 101, 32, 98, 101, 110, 101, 102, 105, 99, 105, 97, 108, 32, 111, 110,
    32, 71, 70, 88, 54, 45, 71, 70, 88, 56, 46, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 71, 102,
    120, 57, 75, 101, 101, 112, 83, 104, 97, 100, 101, 114, 67, 111, 104, 101, 114, 34, 44, 32, 34, 86, 97, 108, 117,
    101, 34, 58, 32, 49, 48, 50, 52, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34,
    75, 101, 101, 112, 32, 115, 104, 97, 100, 101, 114, 32, 100, 111, 109, 97, 105, 110, 32, 97, 108, 119, 97, 121, 115,
    32, 99, 111, 104, 101, 114, 101, 110, 116, 32, 111, 110, 32, 71, 70, 88, 57, 43, 32, 116, 104, 117, 115, 32, 97,
    118, 111, 105, 100, 105, 110, 103, 32, 76, 50, 32, 99, 97, 99, 104, 101, 32, 102, 108, 117, 115, 104, 101, 115, 47,
    105, 110, 118, 97, 108, 105, 100, 97, 116, 105, 111, 110, 115, 32, 105, 110, 32, 115, 104, 97, 100, 101, 114, 45,
    116, 111, 45, 115, 104, 97, 100, 101, 114, 32, 98, 97, 114, 114, 105, 101, 114, 32, 99, 97, 115, 101, 115, 32, 97,
    116, 32, 116, 104, 101, 32, 101, 120, 112, 101, 110, 115, 101, 32, 111, 102, 32, 97, 108, 119, 97, 121, 115, 32,
    102, 108, 117, 115, 104, 105, 110, 103, 47, 105, 110, 118, 97, 108, 105, 100, 97, 116, 105, 110, 103, 32, 76, 49,
    32, 99, 97, 99, 104, 101, 115, 46, 32, 84, 104, 105, 115, 32, 100, 111, 101, 115, 32, 78, 79, 84, 32, 118, 105, 111,
    108, 97, 116, 101, 32, 116, 104, 101, 32, 86, 117, 108, 107, 97, 110, 32, 115, 101, 112, 97, 114, 97, 116, 101, 32,
    97, 99, 99, 101, 115, 115, 32, 109, 97, 115, 107, 32, 114, 117, 108, 101, 46, 32, 84, 104, 105, 115, 32, 98, 101,
    104, 97, 118, 105, 111, 114, 32, 109, 97, 121, 32, 110, 111, 116, 32, 98, 101, 32, 98, 101, 110, 101, 102, 105, 99,
    105, 97, 108, 32, 111, 110, 32, 71, 70, 88, 57, 43, 46, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34,
    71, 102, 120, 57, 65, 118, 111, 105, 100, 67, 112, 117, 77, 101, 109, 111, 114, 121, 67, 111, 104, 101, 114, 34, 44,
    32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 50, 48, 52, 56, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105,
    111, 110, 34, 58, 32, 34, 65, 118, 111, 105, 100, 32, 67, 80, 85, 32, 97, 110, 100, 32, 109, 101, 109, 111, 114,
    121, 32, 100, 111, 109, 97, 105, 110, 32, 99, 111, 104, 101, 114, 101, 110, 99, 121, 32, 111, 110, 32, 71, 70, 88,
    57, 43, 32, 117, 110, 108, 101, 115, 115, 32, 99, 111, 114, 114, 101, 115, 112, 111, 110, 100, 105, 110, 103, 32,
    102, 108, 97, 103, 115, 32, 97, 114, 101, 32, 101, 120, 112, 108, 105, 99, 105, 116, 108, 121, 32, 114, 101, 113,
    117, 101, 115, 116, 101, 100, 32, 116, 111, 32, 108, 111, 119, 101, 114, 32, 116, 104, 101, 32, 110, 117, 109, 98,
    101, 114, 32, 111, 102, 32, 76, 50, 32, 99, 97, 99, 104, 101, 32, 102, 108, 117, 115, 104, 101, 115, 47, 105, 110,
    118, 97, 108, 105, 100, 97, 116, 105, 111, 110, 115, 46, 32, 84, 104, 105, 115, 32, 100, 111, 101, 115, 32, 78, 79,
    84, 32, 118, 105, 111, 108, 97, 116, 101, 32, 116, 104, 101, 32, 86, 117, 108, 107, 97, 110, 32, 115, 101, 112, 97,
    114, 97, 116, 101, 32, 97, 99, 99, 101, 115, 115, 32, 109, 97, 115, 107, 32, 114, 117, 108, 101, 46, 32, 84, 104,
    105, 115, 32, 98, 101, 104, 97, 118, 105, 111, 114, 32, 105, 115, 32, 112, 114, 101, 102, 101, 114, 114, 101, 100,
    32, 111, 110, 32, 71, 70, 88, 57, 43, 32, 97, 115, 32, 97, 108, 108, 32, 111, 116, 104, 101, 114, 32, 97, 99, 99,
    101, 115, 115, 101, 115, 32, 103, 111, 32, 116, 104, 114, 111, 117, 103, 104, 32, 116, 104, 101, 32, 76, 50, 46, 34,
    125, 93, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 82, 101, 115, 111, 117, 114, 99, 101, 66, 97, 114, 114, 105,
    101, 114, 79, 112, 116, 105, 111, 110, 115, 34, 125, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111,
    110, 34, 58, 32, 34, 70, 111, 114, 99, 101, 32, 99, 111, 109, 109, 97, 110, 100, 32, 98, 117, 102, 102, 101, 114,
    32, 98, 97, 115, 101, 100, 32, 98, 97, 114, 114, 105, 101, 114, 32, 113, 117, 101, 117, 101, 32, 117, 115, 97, 103,
    101, 46, 32, 68, 101, 102, 97, 117, 108, 116, 32, 86, 97, 108, 117, 101, 58, 32, 83, 107, 105, 112, 68, 115, 116,
    67, 97, 99, 104, 101, 73, 110, 118, 32, 124, 32, 71, 102, 120, 54, 65, 118, 111, 105, 100, 67, 112, 117, 77, 101,
    109, 111, 114, 121, 67, 111, 104, 101, 114, 32, 124, 32, 71, 102, 120, 57, 65, 118, 111, 105, 100, 67, 112, 117, 77,
    101, 109, 111, 114, 121, 67, 111, 104, 101, 114, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 71, 101, 110,
    101, 114, 97, 108, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97,
    117, 108, 116, 34, 58, 32, 51, 53, 51, 50, 56, 125, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110,
    116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 114, 101, 115,
    111, 117, 114, 99, 101, 66, 97, 114, 114, 105, 101, 114, 79, 112, 116, 105, 111, 110, 115, 34, 44, 32, 34, 78, 97,
    109, 101, 34, 58, 32, 34, 82, 101, 115, 111, 117, 114, 99, 101, 66, 97, 114, 114, 105, 101, 114, 79, 112, 116, 105,
    111, 110, 115, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34,
    72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 50, 51, 52, 56, 52, 49, 54, 55, 56, 50, 125, 44, 32, 123, 34, 78,
    97, 109, 101, 34, 58, 32, 34, 66, 97, 114, 114, 105, 101, 114, 70, 105, 108, 116, 101, 114, 79, 112, 116, 105, 111,
    110, 115, 34, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 70, 108, 97, 103,
    115, 32, 116, 111, 32, 100, 101, 115, 99, 114, 105, 98, 101, 32, 115, 116, 114, 97, 116, 101, 103, 105, 101, 115,
    32, 111, 102, 32, 97, 118, 111, 105, 100, 105, 110, 103, 32, 98, 97, 114, 114, 105, 101, 114, 32, 111, 112, 101,
    114, 97, 116, 105, 111, 110, 115, 46, 32, 84, 104, 101, 115, 101, 32, 97, 114, 101, 32, 105, 108, 108, 101, 103, 97,
    108, 32, 111, 112, 116, 105, 109, 105, 122, 97, 116, 105, 111, 110, 115, 32, 97, 99, 99, 111, 114, 100, 105, 110,
    103, 32, 116, 111, 32, 116, 104, 101, 32, 86, 117, 108, 107, 97, 110, 32, 115, 112, 101, 99, 32, 98, 117, 116, 32,
    109, 97, 121, 32, 98, 101, 32, 97, 99, 99, 101, 112, 116, 97, 98, 108, 101, 32, 102, 111, 114, 32, 115, 111, 109,
    101, 32, 97, 112, 112, 108, 105, 99, 97, 116, 105, 111, 110, 115, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91,
    34, 71, 101, 110, 101, 114, 97, 108, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34,
    68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 48, 125, 44, 32, 34, 86, 97, 108, 105, 100, 86, 97, 108, 117, 101, 115,
    34, 58, 32, 123, 34, 73, 115, 69, 110, 117, 109, 34, 58, 32, 116, 114, 117, 101, 44, 32, 34, 86, 97, 108, 117, 101,
    115, 34, 58, 32, 91, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 66, 97, 114, 114, 105, 101, 114, 70, 105, 108, 116,
    101, 114, 68, 105, 115, 97, 98, 108, 101, 100, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 48, 44, 32, 34,
    68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 68, 111, 32, 110, 111, 116, 104, 105, 110, 103,
    32, 40, 100, 101, 102, 97, 117, 108, 116, 41, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 83, 107,
    105, 112, 83, 116, 114, 97, 121, 69, 120, 101, 99, 117, 116, 105, 111, 110, 68, 101, 112, 101, 110, 100, 101, 110,
    99, 105, 101, 115, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 44, 32, 34, 68, 101, 115, 99, 114, 105,
    112, 116, 105, 111, 110, 34, 58, 32, 34, 84, 104, 101, 32, 100, 114, 105, 118, 101, 114, 32, 105, 115, 32, 117, 110,
    97, 98, 108, 101, 32, 116, 111, 32, 107, 110, 111, 119, 32, 105, 102, 32, 97, 32, 115, 111, 117, 114, 99, 101, 32,
    112, 105, 112, 101, 108, 105, 110, 101, 32, 115, 116, 97, 103, 101, 32, 109, 97, 115, 107, 32, 105, 115, 32, 102,
    111, 114, 32, 97, 32, 115, 116, 97, 110, 100, 97, 108, 111, 110, 101, 32, 101, 120, 101, 99, 117, 116, 105, 111,
    110, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 121, 32, 111, 114, 32, 116, 104, 101, 32, 97, 99, 99, 101, 115,
    115, 32, 115, 99, 111, 112, 101, 32, 111, 102, 32, 97, 32, 115, 107, 105, 112, 112, 97, 98, 108, 101, 32, 109, 101,
    109, 111, 114, 121, 32, 100, 101, 112, 101, 110, 100, 101, 110, 99, 121, 46, 32, 67, 104, 101, 99, 107, 105, 110,
    103, 32, 102, 111, 114, 32, 116, 104, 101, 32, 115, 111, 117, 114, 99, 101, 32, 97, 110, 100, 32, 100, 101, 115,
    116, 105, 110, 97, 116, 105, 111, 110, 32, 112, 105, 112, 101, 108, 105, 110, 101, 32, 115, 116, 97, 103, 101, 32,
    109, 97, 115, 107, 115, 32, 100, 111, 101, 115, 110, 39, 116, 32, 97, 108, 119, 97, 121, 115, 32, 112, 114, 111,
    118, 105, 100, 101, 32, 116, 104, 101, 32, 100, 101, 118, 101, 108, 111, 112, 101, 114, 39, 115, 32, 105, 110, 116,
    101, 110, 116, 32, 101, 105, 116, 104, 101, 114, 46, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 83,
    107, 105, 112, 73, 109, 97, 103, 101, 76, 97, 121, 111, 117, 116, 85, 110, 100, 101, 102, 105, 110, 101, 100, 34,
    44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 50, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110,
    34, 58, 32, 34, 73, 103, 110, 111, 114, 101, 32, 105, 109, 97, 103, 101, 32, 109, 101, 109, 111, 114, 121, 32, 98,
    97, 114, 114, 105, 101, 114, 32, 116, 114, 97, 110, 115, 105, 116, 105, 111, 110, 115, 32, 111, 117, 116, 32, 111,
    102, 32, 117, 110, 100, 101, 102, 105, 110, 101, 100, 32, 105, 110, 32, 116, 104, 101, 32, 104, 111, 112, 101, 32,
    116, 104, 97, 116, 32, 116, 104, 101, 114, 101, 32, 119, 105, 108, 108, 32, 98, 101, 32, 97, 32, 102, 117, 108, 108,
    32, 99, 111, 118, 101, 114, 97, 103, 101, 32, 99, 108, 101, 97, 114, 32, 116, 111, 32, 116, 104, 101, 32, 105, 109,
    97, 103, 101, 32, 110, 101, 120, 116, 32, 109, 97, 107, 105, 110, 103, 32, 116, 104, 105, 115, 32, 108, 105, 107,
    101, 108, 121, 32, 109, 97, 115, 107, 32, 82, 65, 77, 32, 105, 110, 105, 116, 105, 97, 108, 105, 122, 97, 116, 105,
    111, 110, 32, 114, 101, 100, 117, 110, 100, 97, 110, 116, 46, 32, 84, 114, 97, 110, 115, 105, 116, 105, 111, 110,
    115, 32, 116, 111, 32, 116, 114, 97, 110, 115, 102, 101, 114, 32, 100, 115, 116, 32, 111, 112, 116, 105, 109, 97,
    108, 32, 97, 114, 101, 32, 110, 111, 116, 32, 115, 107, 105, 112, 112, 101, 100, 32, 116, 111, 32, 97, 118, 111,
    105, 100, 32, 105, 115, 115, 117, 101, 115, 32, 119, 105, 116, 104, 32, 115, 108, 111, 119, 32, 99, 108, 101, 97,
    114, 115, 32, 97, 110, 100, 32, 99, 111, 112, 105, 101, 115, 44, 32, 119, 104, 105, 99, 104, 32, 114, 101, 113, 117,
    105, 114, 101, 32, 105, 110, 105, 116, 105, 97, 108, 105, 122, 101, 100, 32, 109, 101, 116, 97, 100, 97, 116, 97,
    46, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 83, 107, 105, 112, 68, 117, 112, 108, 105, 99, 97,
    116, 101, 82, 101, 115, 111, 117, 114, 99, 101, 66, 97, 114, 114, 105, 101, 114, 115, 34, 44, 32, 34, 86, 97, 108,
    117, 101, 34, 58, 32, 52, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 73, 103,
    110, 111, 114, 101, 115, 32, 114, 101, 115, 111, 117, 114, 99, 101, 32, 98, 97, 114, 114, 105, 101, 114, 115, 32,
    116, 104, 97, 116, 32, 104, 97, 118, 101, 32, 116, 104, 101, 32, 115, 97, 109, 101, 32, 115, 111, 117, 114, 99, 101,
    32, 97, 110, 100, 32, 100, 101, 115, 116, 105, 110, 97, 116, 105, 111, 110, 32, 112, 97, 114, 97, 109, 101, 116,
    101, 114, 115, 32, 105, 110, 32, 99, 97, 115, 101, 32, 97, 32, 102, 117, 108, 108, 32, 99, 114, 111, 115, 115, 45,
    98, 97, 114, 32, 115, 121, 110, 99, 32, 105, 115, 110, 39, 116, 32, 114, 101, 113, 117, 105, 114, 101, 100, 46, 34,
    125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 70, 111, 114, 99, 101, 73, 109, 97, 103, 101, 83, 104, 97,
    114, 105, 110, 103, 77, 111, 100, 101, 69, 120, 99, 108, 117, 115, 105, 118, 101, 34, 44, 32, 34, 86, 97, 108, 117,
    101, 34, 58, 32, 56, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 69, 120, 99,
    108, 117, 115, 105, 118, 101, 32, 113, 117, 101, 117, 101, 32, 102, 97, 109, 105, 108, 121, 32, 97, 99, 99, 101,
    115, 115, 32, 114, 101, 100, 117, 99, 101, 115, 32, 115, 111, 109, 101, 32, 109, 101, 109, 111, 114, 121, 32, 100,
    101, 112, 101, 110, 100, 101, 110, 99, 121, 32, 111, 112, 101, 114, 97, 116, 105, 111, 110, 115, 32, 97, 110, 100,
    32, 114, 101, 109, 111, 118, 101, 115, 32, 116, 104, 101, 32, 114, 101, 115, 116, 114, 105, 99, 116, 105, 111, 110,
    32, 116, 104, 97, 116, 32, 116, 104, 101, 32, 105, 109, 97, 103, 101, 32, 108, 97, 121, 111, 117, 116, 32, 109, 117,
    115, 116, 32, 98, 101, 32, 115, 117, 112, 112, 111, 114, 116, 101, 100, 32, 102, 111, 114, 32, 109, 117, 108, 116,
    105, 112, 108, 101, 32, 113, 117, 101, 117, 101, 32, 102, 97, 109, 105, 108, 105, 101, 115, 46, 32, 86, 75, 95, 83,
    72, 65, 82, 73, 78, 71, 95, 77, 79, 68, 69, 95, 67, 79, 78, 67, 85, 82, 82, 69, 78, 84, 32, 105, 115, 32, 111, 110,
    108, 121, 32, 97, 99, 99, 101, 112, 116, 97, 98, 108, 101, 32, 116, 111, 32, 105, 103, 110, 111, 114, 101, 32, 119,
    104, 101, 110, 32, 116, 104, 101, 32, 97, 112, 112, 108, 105, 99, 97, 116, 105, 111, 110, 32, 117, 110, 110, 101,
    99, 101, 115, 115, 97, 114, 105, 108, 121, 32, 115, 112, 101, 99, 105, 102, 105, 101, 100, 32, 101, 120, 116, 114,
    97, 32, 113, 117, 101, 117, 101, 32, 102, 97, 109, 105, 108, 105, 101, 115, 32, 119, 105, 116, 104, 111, 117, 116,
    32, 97, 99, 99, 101, 115, 115, 105, 110, 103, 32, 116, 104, 101, 32, 114, 101, 115, 111, 117, 114, 99, 101, 32, 117,
    115, 105, 110, 103, 32, 116, 104, 101, 109, 46, 32, 83, 101, 116, 116, 105, 110, 103, 32, 116, 104, 105, 115, 32,
    111, 112, 116, 105, 111, 110, 32, 105, 108, 108, 101, 103, 97, 108, 108, 121, 32, 109, 105, 103, 104, 116, 32, 97,
    118, 111, 105, 100, 32, 97, 108, 108, 32, 116, 104, 101, 32, 112, 105, 116, 102, 97, 108, 108, 115, 32, 105, 110,
    32, 97, 32, 103, 105, 118, 101, 110, 32, 97, 112, 112, 108, 105, 99, 97, 116, 105, 111, 110, 44, 32, 98, 117, 116,
    32, 116, 104, 101, 121, 32, 97, 114, 101, 32, 116, 111, 111, 32, 110, 117, 109, 101, 114, 111, 117, 115, 32, 116,
    111, 32, 108, 105, 115, 116, 32, 40, 101, 46, 103, 46, 32, 114, 101, 113, 117, 105, 114, 105, 110, 103, 32, 97, 32,
    100, 101, 99, 111, 109, 112, 114, 101, 115, 115, 32, 111, 110, 32, 97, 110, 32, 97, 115, 121, 110, 99, 32, 99, 111,
    109, 112, 117, 116, 101, 32, 113, 117, 101, 117, 101, 41, 46, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58,
    32, 34, 83, 107, 105, 112, 87, 105, 116, 104, 65, 112, 112, 80, 114, 111, 102, 105, 108, 101, 34, 44, 32, 34, 86,
    97, 108, 117, 101, 34, 58, 32, 49, 54, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32,
    34, 70, 105, 108, 116, 101, 114, 32, 97, 108, 108, 32, 114, 101, 113, 117, 101, 115, 116, 101, 100, 32, 112, 105,
    112, 101, 108, 105, 110, 101, 32, 98, 97, 114, 114, 105, 101, 114, 115, 32, 105, 110, 32, 97, 110, 32, 97, 112, 112,
    108, 105, 99, 97, 116, 105, 111, 110, 32, 112, 114, 111, 102, 105, 108, 101, 32, 115, 112, 101, 99, 105, 102, 105,
    101, 100, 32, 98, 121, 32, 116, 104, 101, 32, 115, 101, 116, 116, 105, 110, 103, 32, 66, 97, 114, 114, 105, 101,
    114, 70, 105, 108, 116, 101, 114, 80, 114, 111, 102, 105, 108, 101, 70, 105, 108, 101, 46, 34, 125, 44, 32, 123, 34,
    78, 97, 109, 101, 34, 58, 32, 34, 83, 107, 105, 112, 87, 105, 116, 104, 65, 112, 112, 80, 114, 111, 102, 105, 108,
    101, 82, 101, 103, 101, 110, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 51, 50, 44, 32, 34, 68, 101, 115,
    99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 83, 97, 109, 101, 32, 97, 115, 32, 83, 107, 105, 112, 87,
    105, 116, 104, 65, 112, 112, 80, 114, 111, 102, 105, 108, 101, 32, 98, 117, 116, 32, 116, 104, 101, 32, 112, 105,
    112, 101, 108, 105, 110, 101, 32, 104, 97, 115, 104, 101, 115, 32, 97, 114, 101, 32, 110, 111, 116, 32, 99, 111,
    110, 115, 105, 100, 101, 114, 101, 100, 32, 105, 110, 32, 111, 114, 100, 101, 114, 32, 116, 111, 32, 114, 101, 103,
    101, 110, 101, 114, 97, 116, 101, 32, 115, 116, 114, 111, 110, 103, 32, 98, 97, 114, 114, 105, 101, 114, 32, 104,
    97, 115, 104, 101, 115, 32, 97, 102, 116, 101, 114, 32, 97, 110, 121, 32, 97, 112, 112, 108, 105, 99, 97, 116, 105,
    111, 110, 32, 117, 112, 100, 97, 116, 101, 115, 32, 116, 111, 32, 105, 116, 115, 32, 115, 104, 97, 100, 101, 114,
    115, 46, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 83, 107, 105, 112, 87, 105, 116, 104, 73, 110,
    116, 68, 101, 118, 79, 118, 101, 114, 108, 97, 121, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 54, 52, 44,
    32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 77, 97, 110, 117, 97, 108, 108, 121,
    32, 114, 101, 109, 111, 118, 101, 32, 98, 97, 114, 114, 105, 101, 114, 115, 32, 117, 115, 105, 110, 103, 32, 107,
    101, 121, 98, 111, 97, 114, 100, 32, 115, 104, 111, 114, 116, 99, 117, 116, 115, 32, 116, 111, 32, 118, 105, 115,
    117, 97, 108, 105, 122, 101, 32, 116, 104, 101, 105, 114, 32, 101, 102, 102, 101, 99, 116, 115, 46, 32, 85, 115,
    101, 32, 105, 110, 32, 99, 111, 110, 106, 117, 110, 99, 116, 105, 111, 110, 32, 119, 105, 116, 104, 32, 116, 104,
    101, 32, 100, 101, 118, 101, 108, 111, 112, 101, 114, 32, 111, 118, 101, 114, 108, 97, 121, 46, 32, 83, 101, 101,
    32, 116, 104, 101, 32, 115, 101, 116, 116, 105, 110, 103, 32, 86, 117, 108, 107, 97, 110, 79, 118, 101, 114, 108,
    97, 121, 69, 110, 97, 98, 108, 101, 32, 79, 118, 101, 114, 108, 97, 121, 66, 97, 114, 114, 105, 101, 114, 70, 105,
    108, 116, 101, 114, 105, 110, 103, 32, 111, 112, 116, 105, 111, 110, 32, 102, 111, 114, 32, 100, 101, 116, 97, 105,
    108, 115, 46, 32, 83, 107, 105, 112, 87, 105, 116, 104, 65, 112, 112, 80, 114, 111, 102, 105, 108, 101, 32, 97, 110,
    100, 32, 83, 107, 105, 112, 87, 105, 116, 104, 65, 112, 112, 80, 114, 111, 102, 105, 108, 101, 82, 101, 103, 101,
    110, 32, 109, 97, 121, 32, 98, 101, 32, 117, 115, 101, 100, 32, 115, 105, 109, 117, 108, 116, 97, 110, 101, 111,
    117, 115, 108, 121, 32, 116, 111, 32, 114, 101, 102, 105, 110, 101, 32, 111, 114, 32, 114, 101, 103, 101, 110, 101,
    114, 97, 116, 101, 32, 97, 110, 32, 101, 120, 105, 115, 116, 105, 110, 103, 32, 112, 114, 111, 102, 105, 108, 101,
    46, 34, 125, 93, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 66, 97, 114, 114, 105, 101, 114, 70, 105, 108, 116,
    101, 114, 79, 112, 116, 105, 111, 110, 115, 34, 125, 44, 32, 34, 70, 108, 97, 103, 115, 34, 58, 32, 123, 34, 73,
    115, 72, 101, 120, 34, 58, 32, 116, 114, 117, 101, 44, 32, 34, 73, 115, 66, 105, 116, 109, 97, 115, 107, 34, 58, 32,
    116, 114, 117, 101, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32,
    34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108,
    101, 78, 97, 109, 101, 34, 58, 32, 34, 98, 97, 114, 114, 105, 101, 114, 70, 105, 108, 116, 101, 114, 79, 112, 116,
    105, 111, 110, 115, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 51, 55, 53, 50, 48, 54, 57, 55,
    50, 52, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 80, 97, 116, 104,
    32, 116, 111, 32, 97, 32, 102, 105, 108, 101, 32, 116, 104, 97, 116, 32, 99, 111, 110, 116, 97, 105, 110, 115, 32,
    97, 112, 112, 108, 105, 99, 97, 116, 105, 111, 110, 45, 115, 112, 101, 99, 105, 102, 105, 99, 32, 98, 97, 114, 114,
    105, 101, 114, 32, 102, 105, 108, 116, 101, 114, 32, 112, 114, 111, 102, 105, 108, 101, 115, 46, 32, 84, 104, 101,
    32, 99, 111, 110, 116, 101, 110, 116, 115, 32, 97, 114, 101, 32, 114, 101, 97, 100, 32, 111, 110, 32, 115, 116, 97,
    114, 116, 117, 112, 32, 97, 110, 100, 32, 117, 115, 101, 100, 32, 105, 102, 32, 66, 97, 114, 114, 105, 101, 114, 70,
    105, 108, 116, 101, 114, 79, 112, 116, 105, 111, 110, 115, 32, 83, 107, 105, 112, 87, 105, 116, 104, 65, 112, 112,
    80, 114, 111, 102, 105, 108, 101, 44, 32, 83, 107, 105, 112, 87, 105, 116, 104, 65, 112, 112, 80, 114, 111, 102,
    105, 108, 101, 82, 101, 103, 101, 110, 44, 32, 111, 114, 32, 83, 107, 105, 112, 87, 105, 116, 104, 73, 110, 116, 68,
    101, 118, 79, 118, 101, 114, 108, 97, 121, 32, 97, 114, 101, 32, 115, 101, 116, 46, 32, 79, 110, 32, 101, 120, 105,
    116, 44, 32, 97, 110, 32, 117, 112, 100, 97, 116, 101, 100, 32, 112, 114, 111, 102, 105, 108, 101, 32, 105, 115, 32,
    119, 114, 105, 116, 116, 101, 110, 32, 116, 111, 32, 116, 104, 105, 115, 32, 115, 97, 109, 101, 32, 102, 105, 108,
    101, 46, 32, 84, 104, 105, 115, 32, 115, 101, 116, 116, 105, 110, 103, 32, 111, 110, 108, 121, 32, 116, 114, 105,
    103, 103, 101, 114, 115, 32, 111, 110, 32, 100, 101, 98, 117, 103, 32, 98, 117, 105, 108, 100, 115, 46, 34, 44, 32,
    34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 71, 101, 110, 101, 114, 97, 108, 34, 93, 44, 32, 34, 70, 108, 97, 103,
    115, 34, 58, 32, 123, 34, 73, 115, 80, 97, 116, 104, 34, 58, 32, 116, 114, 117, 101, 125, 44, 32, 34, 68, 101, 102,
    97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 34, 34, 125, 44, 32, 34,
    83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32,
    34, 66, 97, 114, 114, 105, 101, 114, 70, 105, 108, 116, 101, 114, 80, 114, 111, 102, 105, 108, 101, 70, 105, 108,
    101, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 115, 116, 114, 105, 110, 103, 34, 44, 32, 34, 86, 97, 114,
    105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 98, 97, 114, 114, 105, 101, 114, 70, 105, 108, 116, 101,
    114, 80, 114, 111, 102, 105, 108, 101, 70, 105, 108, 101, 34, 44, 32, 34, 83, 105, 122, 101, 34, 58, 32, 53, 49, 50,
    44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 53, 57, 53, 57, 49, 50, 53, 55, 55, 125, 44, 32, 123,
    34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 84, 104, 101, 32, 110, 117, 109, 98, 101,
    114, 32, 111, 102, 32, 112, 105, 112, 101, 108, 105, 110, 101, 32, 99, 97, 99, 104, 101, 32, 99, 111, 117, 110, 116,
    32, 119, 101, 32, 116, 114, 101, 97, 116, 32, 97, 115, 32, 101, 120, 99, 101, 115, 115, 105, 118, 101, 32, 97, 110,
    100, 32, 116, 104, 117, 115, 32, 97, 32, 115, 109, 97, 108, 108, 101, 114, 32, 105, 110, 116, 101, 114, 110, 97,
    108, 32, 105, 109, 112, 108, 101, 109, 101, 110, 116, 97, 116, 105, 111, 110, 32, 105, 115, 32, 117, 115, 101, 100,
    32, 102, 111, 114, 32, 112, 105, 112, 101, 108, 105, 110, 101, 32, 99, 97, 99, 104, 101, 46, 34, 44, 32, 34, 84, 97,
    103, 115, 34, 58, 32, 91, 34, 71, 101, 110, 101, 114, 97, 108, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116,
    115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 50, 53, 54, 125, 44, 32, 34, 83, 99, 111,
    112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105,
    110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 101, 120,
    99, 101, 115, 115, 105, 118, 101, 80, 105, 112, 101, 108, 105, 110, 101, 67, 97, 99, 104, 101, 67, 111, 117, 110,
    116, 84, 104, 114, 101, 115, 104, 111, 108, 100, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 69, 120, 99, 101,
    115, 115, 105, 118, 101, 80, 105, 112, 101, 108, 105, 110, 101, 67, 97, 99, 104, 101, 67, 111, 117, 110, 116, 84,
    104, 114, 101, 115, 104, 111, 108, 100, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 51, 55, 50,
    51, 56, 54, 48, 53, 57, 56, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32,
    34, 73, 102, 32, 110, 111, 116, 32, 85, 73, 78, 84, 95, 77, 65, 88, 44, 32, 116, 104, 105, 115, 32, 80, 65, 76, 32,
    101, 110, 117, 109, 101, 114, 97, 116, 101, 100, 32, 100, 101, 118, 105, 99, 101, 32, 105, 110, 100, 101, 120, 32,
    119, 105, 108, 108, 32, 97, 108, 119, 97, 121, 115, 32, 98, 101, 32, 114, 101, 116, 117, 114, 110, 101, 100, 32, 97,
    115, 32, 116, 104, 101, 32, 102, 105, 114, 115, 116, 32, 101, 110, 117, 109, 101, 114, 97, 116, 101, 100, 32, 112,
    104, 121, 115, 105, 99, 97, 108, 32, 100, 101, 118, 105, 99, 101, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32,
    91, 34, 71, 101, 110, 101, 114, 97, 108, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123,
    34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 52, 50, 57, 52, 57, 54, 55, 50, 57, 53, 125, 44, 32, 34, 84, 121,
    112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97,
    109, 101, 34, 58, 32, 34, 101, 110, 117, 109, 80, 114, 101, 102, 101, 114, 114, 101, 100, 68, 101, 118, 105, 99,
    101, 73, 110, 100, 101, 120, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 69, 110, 117, 109, 80, 114, 101, 102,
    101, 114, 114, 101, 100, 68, 101, 118, 105, 99, 101, 73, 110, 100, 101, 120, 34, 44, 32, 34, 83, 99, 111, 112, 101,
    34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 51, 57,
    54, 51, 49, 54, 55, 48, 57, 55, 125, 44, 32, 123, 34, 86, 97, 108, 105, 100, 86, 97, 108, 117, 101, 115, 34, 58, 32,
    123, 34, 86, 97, 108, 117, 101, 115, 34, 58, 32, 91, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 70, 101, 97, 116,
    117, 114, 101, 68, 101, 102, 97, 117, 108, 116, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 48, 44, 32, 34,
    68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 68, 101, 102, 97, 117, 108, 116, 44, 32, 117,
    115, 101, 32, 97, 112, 112, 108, 105, 99, 97, 116, 105, 111, 110, 32, 115, 101, 116, 116, 105, 110, 103, 34, 125,
    44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 70, 101, 97, 116, 117, 114, 101, 70, 111, 114, 99, 101, 69, 110,
    97, 98, 108, 101, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 44, 32, 34, 68, 101, 115, 99, 114, 105,
    112, 116, 105, 111, 110, 34, 58, 32, 34, 70, 111, 114, 99, 101, 32, 69, 110, 97, 98, 108, 101, 34, 125, 44, 32, 123,
    34, 78, 97, 109, 101, 34, 58, 32, 34, 70, 101, 97, 116, 117, 114, 101, 70, 111, 114, 99, 101, 68, 105, 115, 97, 98,
    108, 101, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 50, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116,
    105, 111, 110, 34, 58, 32, 34, 70, 111, 114, 99, 101, 32, 68, 105, 115, 97, 98, 108, 101, 32, 68, 101, 102, 97, 117,
    108, 116, 32, 86, 97, 108, 117, 101, 34, 125, 93, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 70, 101, 97, 116,
    117, 114, 101, 69, 110, 97, 98, 108, 101, 77, 111, 100, 101, 34, 125, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112,
    116, 105, 111, 110, 34, 58, 32, 34, 70, 111, 114, 99, 101, 32, 86, 107, 80, 104, 121, 115, 105, 99, 97, 108, 68,
    101, 118, 105, 99, 101, 70, 101, 97, 116, 117, 114, 101, 115, 58, 58, 114, 111, 98, 117, 115, 116, 66, 117, 102,
    102, 101, 114, 65, 99, 99, 101, 115, 115, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 71, 101, 110,
    101, 114, 97, 108, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97,
    117, 108, 116, 34, 58, 32, 34, 70, 101, 97, 116, 117, 114, 101, 68, 101, 102, 97, 117, 108, 116, 34, 125, 44, 32,
    34, 84, 121, 112, 101, 34, 58, 32, 34, 101, 110, 117, 109, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78,
    97, 109, 101, 34, 58, 32, 34, 114, 111, 98, 117, 115, 116, 66, 117, 102, 102, 101, 114, 65, 99, 99, 101, 115, 115,
    34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 82, 111, 98, 117, 115, 116, 66, 117, 102, 102, 101, 114, 65, 99,
    99, 101, 115, 115, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32,
    34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 51, 50, 55, 52, 51, 51, 51, 56, 56, 56, 125, 44, 32, 123, 34,
    68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 65, 108, 108, 111, 119, 115, 32, 105, 110, 115,
    116, 97, 110, 99, 101, 45, 108, 101, 118, 101, 108, 32, 102, 117, 110, 99, 116, 105, 111, 110, 115, 32, 116, 111,
    32, 98, 101, 32, 113, 117, 101, 114, 105, 101, 100, 32, 117, 115, 105, 110, 103, 32, 118, 107, 71, 101, 116, 68,
    101, 118, 105, 99, 101, 80, 114, 111, 99, 65, 100, 100, 114, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91,
    34, 71, 101, 110, 101, 114, 97, 108, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34,
    68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115, 101, 125, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32,
    34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 108,
    101, 110, 105, 101, 110, 116, 73, 110, 115, 116, 97, 110, 99, 101, 70, 117, 110, 99, 81, 117, 101, 114, 121, 34, 44,
    32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 76, 101, 110, 105, 101, 110, 116, 73, 110, 115, 116, 97, 110, 99, 101, 70,
    117, 110, 99, 81, 117, 101, 114, 121, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101,
    114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 51, 56, 49, 48, 52, 55, 52, 53, 49, 53, 125,
    44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 68, 101, 116, 101, 114, 109,
    105, 110, 101, 115, 32, 119, 104, 101, 114, 101, 32, 116, 104, 101, 32, 118, 107, 65, 112, 112, 80, 114, 111, 102,
    105, 108, 101, 46, 116, 120, 116, 32, 102, 105, 108, 101, 32, 119, 105, 108, 108, 32, 98, 101, 32, 119, 114, 105,
    116, 116, 101, 110, 32, 116, 111, 46, 32, 84, 104, 105, 115, 32, 102, 105, 108, 101, 32, 99, 111, 110, 116, 97, 105,
    110, 115, 32, 32, 116, 104, 101, 32, 97, 112, 112, 32, 112, 114, 111, 102, 105, 108, 101, 32, 101, 110, 117, 109,
    101, 114, 97, 116, 105, 111, 110, 32, 105, 110, 100, 101, 120, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91,
    34, 71, 101, 110, 101, 114, 97, 108, 34, 93, 44, 32, 34, 70, 108, 97, 103, 115, 34, 58, 32, 123, 34, 73, 115, 80,
    97, 116, 104, 34, 58, 32, 116, 114, 117, 101, 125, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32,
    123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 34, 34, 125, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 65,
    112, 112, 80, 114, 111, 102, 105, 108, 101, 68, 117, 109, 112, 68, 105, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34,
    58, 32, 34, 115, 116, 114, 105, 110, 103, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34,
    58, 32, 34, 97, 112, 112, 80, 114, 111, 102, 105, 108, 101, 68, 117, 109, 112, 68, 105, 114, 34, 44, 32, 34, 83,
    105, 122, 101, 34, 58, 32, 53, 49, 50, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101,
    114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 51, 50, 49, 56, 55, 53, 49, 49, 51, 56, 125,
    44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 79, 112, 116, 69, 110, 97, 98, 108, 101, 80, 114, 116, 34, 44,
    32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 32, 80, 82,
    84, 32, 102, 101, 97, 116, 117, 114, 101, 32, 105, 110, 32, 103, 101, 110, 101, 114, 97, 108, 46, 32, 84, 104, 101,
    32, 100, 101, 116, 97, 105, 108, 101, 100, 32, 102, 101, 97, 116, 117, 114, 101, 32, 115, 101, 116, 32, 105, 115,
    32, 100, 101, 99, 105, 100, 101, 100, 32, 97, 99, 99, 111, 114, 100, 105, 110, 103, 32, 116, 111, 32, 99, 97, 112,
    115, 32, 114, 101, 112, 111, 114, 116, 101, 100, 32, 98, 121, 32, 80, 97, 108, 46, 34, 44, 32, 34, 84, 97, 103, 115,
    34, 58, 32, 91, 34, 71, 101, 110, 101, 114, 97, 108, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34,
    58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 116, 114, 117, 101, 125, 44, 32, 34, 84, 121, 112,
    101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34,
    58, 32, 34, 111, 112, 116, 69, 110, 97, 98, 108, 101, 80, 114, 116, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58,
    32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 52, 49, 55, 54,
    53, 51, 55, 52, 53, 51, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 65, 115, 121, 110, 99, 67, 111, 109,
    112, 117, 116, 101, 81, 117, 101, 117, 101, 77, 97, 120, 87, 97, 118, 101, 115, 80, 101, 114, 67, 117, 34, 44, 32,
    34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 76, 105, 109, 105, 116, 32, 116, 104, 101,
    32, 110, 117, 109, 98, 101, 114, 32, 111, 102, 32, 119, 97, 118, 101, 115, 32, 105, 110, 32, 102, 108, 105, 103,
    104, 116, 32, 112, 101, 114, 32, 99, 111, 109, 112, 117, 116, 101, 32, 117, 110, 105, 116, 46, 32, 84, 104, 105,
    115, 32, 99, 97, 110, 32, 98, 101, 32, 117, 115, 101, 100, 32, 116, 111, 32, 116, 104, 114, 111, 116, 116, 108, 101,
    32, 97, 115, 121, 110, 99, 32, 99, 111, 109, 112, 117, 116, 101, 32, 119, 111, 114, 107, 108, 111, 97, 100, 115, 32,
    115, 111, 32, 116, 104, 97, 116, 32, 116, 104, 101, 121, 32, 100, 111, 110, 39, 116, 32, 115, 116, 97, 114, 118,
    101, 32, 116, 104, 101, 32, 117, 110, 105, 118, 101, 114, 115, 97, 108, 32, 113, 117, 101, 117, 101, 46, 32, 34, 44,
    32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 71, 101, 110, 101, 114, 97, 108, 34, 93, 44, 32, 34, 68, 101, 102, 97,
    117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 48, 125, 44, 32, 34, 83, 99,
    111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117,
    105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 97,
    115, 121, 110, 99, 67, 111, 109, 112, 117, 116, 101, 81, 117, 101, 117, 101, 77, 97, 120, 87, 97, 118, 101, 115, 80,
    101, 114, 67, 117, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 50, 57, 55, 52, 48, 55, 50, 50,
    55, 56, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 65, 115, 121, 110, 99, 67, 111, 109, 112, 117, 116,
    101, 81, 117, 101, 117, 101, 76, 105, 109, 105, 116, 34, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111,
    110, 34, 58, 32, 34, 76, 105, 109, 105, 116, 32, 116, 104, 101, 32, 110, 117, 109, 98, 101, 114, 32, 111, 102, 32,
    97, 115, 121, 110, 99, 32, 99, 111, 109, 112, 117, 116, 101, 32, 113, 117, 101, 117, 101, 115, 32, 116, 104, 97,
    116, 32, 97, 114, 101, 32, 114, 101, 112, 111, 114, 116, 101, 100, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32,
    91, 34, 71, 101, 110, 101, 114, 97, 108, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123,
    34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 52, 50, 57, 52, 57, 54, 55, 50, 57, 53, 125, 44, 32, 34, 70, 108,
    97, 103, 115, 34, 58, 32, 123, 34, 73, 115, 72, 101, 120, 34, 58, 32, 116, 114, 117, 101, 125, 44, 32, 34, 83, 99,
    111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117,
    105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 97,
    115, 121, 110, 99, 67, 111, 109, 112, 117, 116, 101, 81, 117, 101, 117, 101, 76, 105, 109, 105, 116, 34, 44, 32, 34,
    72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 49, 53, 53, 53, 56, 48, 53, 57, 50, 50, 125, 44, 32, 123, 34, 78,
    97, 109, 101, 34, 58, 32, 34, 76, 105, 109, 105, 116, 83, 97, 109, 112, 108, 101, 67, 111, 117, 110, 116, 115, 34,
    44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 77, 97, 115, 107, 32, 116, 104,
    101, 32, 115, 97, 109, 112, 108, 101, 32, 99, 111, 117, 110, 116, 115, 32, 114, 101, 116, 117, 114, 110, 101, 100,
    32, 105, 110, 32, 118, 107, 80, 104, 121, 115, 105, 99, 97, 108, 68, 101, 118, 105, 99, 101, 76, 105, 109, 105, 116,
    115, 32, 97, 110, 100, 32, 118, 107, 71, 101, 116, 80, 104, 121, 115, 105, 99, 97, 108, 68, 101, 118, 105, 99, 101,
    73, 109, 97, 103, 101, 80, 114, 111, 112, 101, 114, 116, 105, 101, 115, 32, 40, 79, 114, 105, 103, 105, 110, 97,
    108, 86, 97, 108, 117, 101, 32, 38, 32, 84, 104, 105, 115, 86, 97, 108, 117, 101, 41, 46, 32, 84, 104, 105, 115, 32,
    115, 101, 116, 116, 105, 110, 103, 32, 100, 111, 101, 115, 32, 110, 111, 116, 32, 97, 99, 116, 117, 97, 108, 108,
    121, 32, 97, 102, 102, 101, 99, 116, 32, 115, 117, 112, 112, 111, 114, 116, 32, 102, 111, 114, 32, 115, 97, 109,
    112, 108, 101, 32, 99, 111, 117, 110, 116, 115, 44, 32, 111, 110, 108, 121, 32, 119, 104, 97, 116, 32, 105, 115, 32,
    114, 101, 116, 117, 114, 110, 101, 100, 32, 116, 111, 32, 116, 104, 101, 32, 97, 112, 112, 108, 105, 99, 97, 116,
    105, 111, 110, 46, 32, 84, 104, 105, 115, 32, 118, 97, 108, 117, 101, 32, 115, 104, 111, 117, 108, 100, 32, 98, 101,
    32, 97, 32, 99, 111, 109, 98, 105, 110, 97, 116, 105, 111, 110, 32, 111, 102, 32, 86, 75, 83, 97, 109, 112, 108,
    101, 67, 111, 117, 110, 116, 70, 108, 97, 103, 115, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 71, 101,
    110, 101, 114, 97, 108, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102,
    97, 117, 108, 116, 34, 58, 32, 52, 50, 57, 52, 57, 54, 55, 50, 57, 53, 125, 44, 32, 34, 70, 108, 97, 103, 115, 34,
    58, 32, 123, 34, 73, 115, 72, 101, 120, 34, 58, 32, 116, 114, 117, 101, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34,
    58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51,
    50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 108, 105, 109, 105, 116,
    83, 97, 109, 112, 108, 101, 67, 111, 117, 110, 116, 115, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58,
    32, 49, 56, 53, 56, 50, 48, 57, 52, 49, 56, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111,
    110, 34, 58, 32, 34, 67, 117, 115, 116, 111, 109, 32, 100, 101, 118, 105, 99, 101, 32, 97, 108, 108, 111, 99, 97,
    116, 105, 111, 110, 32, 99, 111, 117, 110, 116, 32, 108, 105, 109, 105, 116, 97, 116, 105, 111, 110, 44, 32, 119,
    104, 101, 110, 32, 108, 97, 114, 103, 101, 114, 32, 116, 104, 97, 110, 32, 48, 46, 34, 44, 32, 34, 84, 97, 103, 115,
    34, 58, 32, 91, 34, 77, 101, 109, 111, 114, 121, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58,
    32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 48, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32,
    34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34,
    44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 109, 101, 109, 111, 114, 121, 67,
    117, 115, 116, 111, 109, 68, 101, 118, 105, 99, 101, 65, 108, 108, 111, 99, 97, 116, 105, 111, 110, 67, 111, 117,
    110, 116, 76, 105, 109, 105, 116, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 77, 101, 109, 111, 114, 121, 67,
    117, 115, 116, 111, 109, 68, 101, 118, 105, 99, 101, 65, 108, 108, 111, 99, 97, 116, 105, 111, 110, 67, 111, 117,
    110, 116, 76, 105, 109, 105, 116, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 50, 56, 52, 57,
    57, 54, 57, 52, 49, 53, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34,
    65, 108, 108, 32, 86, 107, 77, 101, 109, 111, 114, 121, 32, 109, 101, 109, 111, 114, 121, 32, 111, 98, 106, 101, 99,
    116, 115, 32, 119, 105, 108, 108, 32, 104, 97, 118, 101, 32, 116, 104, 101, 32, 102, 111, 108, 108, 111, 119, 105,
    110, 103, 32, 116, 104, 101, 32, 71, 80, 85, 32, 86, 65, 32, 98, 97, 115, 101, 32, 97, 100, 100, 114, 101, 115, 115,
    32, 97, 108, 105, 103, 110, 109, 101, 110, 116, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 77, 101,
    109, 111, 114, 121, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97,
    117, 108, 116, 34, 58, 32, 53, 50, 52, 50, 56, 56, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114,
    105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34,
    86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 109, 101, 109, 111, 114, 121, 66, 97, 115,
    101, 65, 100, 100, 114, 65, 108, 105, 103, 110, 109, 101, 110, 116, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32,
    34, 77, 101, 109, 111, 114, 121, 66, 97, 115, 101, 65, 100, 100, 114, 65, 108, 105, 103, 110, 109, 101, 110, 116,
    34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 50, 57, 51, 57, 52, 48, 55, 56, 52, 49, 125, 44, 32,
    123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 79, 110, 32, 51, 50, 45, 98, 105, 116,
    32, 87, 105, 110, 100, 111, 119, 115, 32, 98, 117, 105, 108, 100, 115, 44, 32, 116, 104, 101, 32, 102, 111, 108,
    108, 111, 119, 105, 110, 103, 32, 71, 80, 85, 32, 86, 65, 32, 98, 97, 115, 101, 32, 97, 108, 105, 103, 110, 109,
    101, 110, 116, 32, 105, 115, 32, 117, 115, 101, 100, 32, 102, 111, 114, 32, 104, 111, 115, 116, 45, 118, 105, 115,
    105, 98, 108, 101, 32, 109, 101, 109, 111, 114, 121, 32, 116, 121, 112, 101, 115, 32, 105, 110, 115, 116, 101, 97,
    100, 32, 111, 102, 32, 77, 101, 109, 111, 114, 121, 66, 97, 115, 101, 86, 97, 65, 108, 105, 103, 110, 46, 34, 44,
    32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 77, 101, 109, 111, 114, 121, 34, 93, 44, 32, 34, 68, 101, 102, 97,
    117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 49, 51, 49, 48, 55, 50, 125,
    44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101,
    34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101,
    34, 58, 32, 34, 109, 101, 109, 111, 114, 121, 66, 97, 115, 101, 65, 100, 100, 114, 65, 108, 105, 103, 110, 109, 101,
    110, 116, 67, 112, 117, 86, 105, 115, 105, 98, 108, 101, 87, 105, 110, 51, 50, 34, 44, 32, 34, 78, 97, 109, 101, 34,
    58, 32, 34, 77, 101, 109, 111, 114, 121, 66, 97, 115, 101, 65, 100, 100, 114, 65, 108, 105, 103, 110, 109, 101, 110,
    116, 67, 112, 117, 86, 105, 115, 105, 98, 108, 101, 87, 105, 110, 51, 50, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97,
    109, 101, 34, 58, 32, 50, 49, 48, 53, 50, 53, 57, 54, 48, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34,
    77, 101, 109, 111, 114, 121, 82, 101, 109, 111, 116, 101, 66, 97, 99, 107, 117, 112, 72, 101, 97, 112, 77, 105, 110,
    72, 101, 97, 112, 83, 105, 122, 101, 34, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58,
    32, 34, 73, 102, 32, 116, 104, 101, 32, 115, 105, 122, 101, 32, 111, 102, 32, 97, 32, 100, 101, 118, 105, 99, 101,
    45, 108, 111, 99, 97, 108, 32, 104, 101, 97, 112, 32, 105, 115, 32, 115, 109, 97, 108, 108, 101, 114, 32, 116, 104,
    97, 110, 32, 116, 104, 105, 115, 32, 118, 97, 108, 117, 101, 44, 32, 116, 104, 101, 32, 114, 101, 109, 111, 116,
    101, 32, 40, 71, 65, 82, 84, 32, 85, 83, 87, 67, 41, 32, 104, 101, 97, 112, 32, 105, 115, 32, 117, 115, 101, 100,
    32, 97, 115, 32, 97, 32, 115, 101, 99, 111, 110, 100, 97, 114, 121, 32, 104, 101, 97, 112, 32, 102, 111, 114, 32,
    86, 107, 77, 101, 109, 111, 114, 121, 32, 111, 98, 106, 101, 99, 116, 115, 32, 99, 114, 101, 97, 116, 101, 100, 32,
    117, 115, 105, 110, 103, 32, 116, 104, 101, 32, 100, 101, 102, 97, 117, 108, 116, 32, 71, 80, 85, 45, 108, 111, 99,
    97, 108, 32, 109, 101, 109, 111, 114, 121, 32, 116, 121, 112, 101, 32, 102, 111, 114, 32, 116, 104, 97, 116, 32,
    100, 101, 118, 105, 99, 101, 45, 108, 111, 99, 97, 108, 32, 104, 101, 97, 112, 46, 32, 84, 104, 101, 32, 114, 101,
    109, 111, 116, 101, 32, 98, 97, 99, 107, 45, 117, 112, 32, 104, 101, 97, 112, 32, 105, 115, 32, 97, 100, 100, 101,
    100, 32, 114, 101, 103, 97, 114, 100, 108, 101, 115, 115, 32, 119, 104, 101, 110, 32, 111, 118, 101, 114, 97, 108,
    108, 111, 99, 97, 116, 105, 111, 110, 32, 105, 115, 32, 97, 108, 108, 111, 119, 101, 100, 32, 118, 105, 97, 32, 116,
    104, 101, 32, 86, 75, 95, 65, 77, 68, 95, 109, 101, 109, 111, 114, 121, 95, 111, 118, 101, 114, 97, 108, 108, 111,
    99, 97, 116, 105, 111, 110, 32, 101, 120, 116, 101, 110, 115, 105, 111, 110, 46, 32, 34, 44, 32, 34, 84, 97, 103,
    115, 34, 58, 32, 91, 34, 77, 101, 109, 111, 114, 121, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34,
    58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 56, 48, 53, 51, 48, 54, 51, 54, 56, 48, 125, 44, 32,
    34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58,
    32, 34, 103, 112, 117, 115, 105, 122, 101, 34, 44, 32, 34, 70, 108, 97, 103, 115, 34, 58, 32, 123, 34, 73, 115, 72,
    101, 120, 34, 58, 32, 116, 114, 117, 101, 125, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34,
    58, 32, 34, 109, 101, 109, 111, 114, 121, 82, 101, 109, 111, 116, 101, 66, 97, 99, 107, 117, 112, 72, 101, 97, 112,
    77, 105, 110, 72, 101, 97, 112, 83, 105, 122, 101, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32,
    49, 48, 50, 55, 51, 57, 57, 53, 53, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 77, 101, 109, 111, 114,
    121, 65, 116, 116, 97, 99, 104, 109, 101, 110, 116, 73, 109, 97, 103, 101, 77, 101, 109, 111, 114, 121, 84, 121,
    112, 101, 77, 105, 110, 72, 101, 97, 112, 83, 105, 122, 101, 34, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116,
    105, 111, 110, 34, 58, 32, 34, 73, 102, 32, 116, 104, 101, 32, 115, 117, 109, 32, 111, 102, 32, 116, 104, 101, 32,
    100, 101, 118, 105, 99, 101, 45, 108, 111, 99, 97, 108, 32, 104, 101, 97, 112, 32, 115, 105, 122, 101, 115, 32, 101,
    120, 99, 101, 101, 100, 115, 32, 116, 104, 105, 115, 32, 118, 97, 108, 117, 101, 44, 32, 116, 104, 101, 32, 97, 116,
    116, 97, 99, 104, 109, 101, 110, 116, 32, 105, 109, 97, 103, 101, 32, 109, 101, 109, 111, 114, 121, 32, 116, 121,
    112, 101, 32, 40, 108, 111, 99, 97, 108, 32, 105, 110, 118, 105, 115, 105, 98, 108, 101, 41, 32, 105, 115, 32, 101,
    110, 97, 98, 108, 101, 100, 46, 32, 65, 32, 98, 97, 99, 107, 45, 117, 112, 32, 104, 101, 97, 112, 32, 105, 115, 32,
    110, 111, 116, 32, 97, 100, 100, 101, 100, 32, 102, 111, 114, 32, 116, 104, 105, 115, 32, 109, 101, 109, 111, 114,
    121, 32, 116, 121, 112, 101, 32, 117, 110, 108, 101, 115, 115, 32, 111, 118, 101, 114, 97, 108, 108, 111, 99, 97,
    116, 105, 111, 110, 32, 105, 115, 32, 97, 108, 108, 111, 119, 101, 100, 32, 118, 105, 97, 32, 116, 104, 101, 32, 86,
    75, 95, 65, 77, 68, 95, 109, 101, 109, 111, 114, 121, 95, 111, 118, 101, 114, 97, 108, 108, 111, 99, 97, 116, 105,
    111, 110, 32, 101, 120, 116, 101, 110, 115, 105, 111, 110, 46, 32, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91,
    34, 77, 101, 109, 111, 114, 121, 34, 93, 44, 32, 34, 70, 108, 97, 103, 115, 34, 58, 32, 123, 34, 73, 115, 72, 101,
    120, 34, 58, 32, 116, 114, 117, 101, 125, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68,
    101, 102, 97, 117, 108, 116, 34, 58, 32, 49, 56, 52, 52, 54, 55, 52, 52, 48, 55, 51, 55, 48, 57, 53, 53, 49, 54, 49,
    53, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121,
    112, 101, 34, 58, 32, 34, 103, 112, 117, 115, 105, 122, 101, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78,
    97, 109, 101, 34, 58, 32, 34, 109, 101, 109, 111, 114, 121, 65, 116, 116, 97, 99, 104, 109, 101, 110, 116, 73, 109,
    97, 103, 101, 77, 101, 109, 111, 114, 121, 84, 121, 112, 101, 77, 105, 110, 72, 101, 97, 112, 83, 105, 122, 101, 34,
    44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 53, 53, 49, 53, 56, 48, 49, 52, 50, 125, 44, 32, 123,
    34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 68, 101, 102, 97, 117, 108, 116, 32, 112,
    114, 105, 111, 114, 105, 116, 121, 32, 111, 102, 32, 97, 108, 108, 32, 86, 107, 77, 101, 109, 111, 114, 121, 32,
    111, 98, 106, 101, 99, 116, 115, 32, 97, 115, 32, 116, 119, 111, 32, 104, 101, 120, 32, 100, 105, 103, 105, 116,
    115, 46, 32, 32, 84, 104, 101, 32, 102, 105, 114, 115, 116, 32, 40, 109, 111, 115, 116, 45, 115, 105, 103, 110, 105,
    102, 105, 99, 97, 110, 116, 41, 32, 100, 105, 103, 105, 116, 32, 100, 101, 102, 105, 110, 101, 115, 32, 116, 104,
    101, 32, 112, 114, 105, 111, 114, 105, 116, 121, 32, 108, 101, 118, 101, 108, 44, 32, 97, 110, 100, 32, 116, 104,
    101, 32, 115, 101, 99, 111, 110, 100, 32, 100, 105, 103, 105, 116, 32, 100, 101, 102, 105, 110, 101, 115, 32, 116,
    104, 101, 32, 112, 114, 105, 111, 114, 105, 116, 121, 32, 111, 102, 102, 115, 101, 116, 46, 32, 32, 86, 97, 108,
    105, 100, 32, 112, 114, 105, 111, 114, 105, 116, 121, 32, 108, 101, 118, 101, 108, 32, 118, 97, 108, 117, 101, 115,
    32, 40, 80, 97, 108, 58, 58, 71, 112, 117, 77, 101, 109, 80, 114, 105, 111, 114, 105, 116, 121, 41, 32, 97, 114,
    101, 58, 32, 32, 48, 58, 32, 85, 110, 117, 115, 101, 100, 32, 49, 58, 32, 86, 101, 114, 121, 76, 111, 119, 32, 50,
    58, 32, 76, 111, 119, 32, 51, 58, 32, 78, 111, 114, 109, 97, 108, 32, 52, 58, 32, 72, 105, 103, 104, 32, 53, 58, 32,
    86, 101, 114, 121, 72, 105, 103, 104, 46, 32, 86, 97, 108, 105, 100, 32, 112, 114, 105, 111, 114, 105, 116, 121, 32,
    111, 102, 102, 115, 101, 116, 32, 118, 97, 108, 117, 101, 115, 32, 40, 80, 97, 108, 58, 58, 71, 112, 117, 77, 101,
    109, 80, 114, 105, 111, 114, 105, 116, 121, 79, 102, 102, 115, 101, 116, 41, 32, 97, 114, 101, 58, 32, 48, 58, 32,
    79, 102, 102, 115, 101, 116, 48, 32, 40, 115, 97, 109, 101, 32, 97, 115, 32, 98, 97, 115, 101, 32, 108, 101, 118,
    101, 108, 41, 32, 49, 58, 32, 79, 102, 102, 115, 101, 116, 49, 32, 50, 58, 32, 79, 102, 102, 115, 101, 116, 50, 32,
    51, 58, 32, 79, 102, 102, 115, 101, 116, 51, 32, 52, 58, 32, 79, 102, 102, 115, 101, 116, 52, 32, 53, 58, 32, 79,
    102, 102, 115, 101, 116, 53, 32, 54, 58, 32, 79, 102, 102, 115, 101, 116, 54, 32, 55, 58, 32, 79, 102, 102, 115,
    101, 116, 55, 32, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 77, 101, 109, 111, 114, 121, 34, 93, 44, 32,
    34, 70, 108, 97, 103, 115, 34, 58, 32, 123, 34, 73, 115, 72, 101, 120, 34, 58, 32, 116, 114, 117, 101, 44, 32, 34,
    73, 115, 66, 105, 116, 109, 97, 115, 107, 34, 58, 32, 116, 114, 117, 101, 125, 44, 32, 34, 68, 101, 102, 97, 117,
    108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 52, 56, 125, 44, 32, 34, 83, 99,
    111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117,
    105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 109,
    101, 109, 111, 114, 121, 80, 114, 105, 111, 114, 105, 116, 121, 68, 101, 102, 97, 117, 108, 116, 34, 44, 32, 34, 78,
    97, 109, 101, 34, 58, 32, 34, 77, 101, 109, 111, 114, 121, 80, 114, 105, 111, 114, 105, 116, 121, 68, 101, 102, 97,
    117, 108, 116, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 50, 56, 57, 50, 55, 57, 48, 48, 55,
    125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 80, 114, 105, 111, 114,
    105, 116, 121, 32, 111, 102, 32, 97, 108, 108, 32, 86, 107, 77, 101, 109, 111, 114, 121, 32, 111, 98, 106, 101, 99,
    116, 115, 32, 99, 111, 110, 116, 97, 105, 110, 105, 110, 103, 32, 97, 116, 32, 108, 101, 97, 115, 116, 32, 111, 110,
    101, 32, 105, 109, 97, 103, 101, 46, 32, 83, 101, 101, 32, 77, 101, 109, 111, 114, 121, 80, 114, 105, 111, 114, 105,
    116, 121, 68, 101, 102, 97, 117, 108, 116, 32, 102, 111, 114, 32, 118, 97, 108, 105, 100, 32, 118, 97, 108, 117,
    101, 115, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 77, 101, 109, 111, 114, 121, 34, 93, 44, 32, 34,
    70, 108, 97, 103, 115, 34, 58, 32, 123, 34, 73, 115, 72, 101, 120, 34, 58, 32, 116, 114, 117, 101, 44, 32, 34, 73,
    115, 66, 105, 116, 109, 97, 115, 107, 34, 58, 32, 116, 114, 117, 101, 125, 44, 32, 34, 68, 101, 102, 97, 117, 108,
    116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 52, 56, 125, 44, 32, 34, 83, 99, 111,
    112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105,
    110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 109, 101,
    109, 111, 114, 121, 80, 114, 105, 111, 114, 105, 116, 121, 73, 109, 97, 103, 101, 65, 110, 121, 34, 44, 32, 34, 78,
    97, 109, 101, 34, 58, 32, 34, 77, 101, 109, 111, 114, 121, 80, 114, 105, 111, 114, 105, 116, 121, 73, 109, 97, 103,
    101, 65, 110, 121, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 50, 51, 50, 49, 49, 54, 56, 56,
    51, 57, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 80, 114, 105,
    111, 114, 105, 116, 121, 32, 111, 102, 32, 97, 108, 108, 32, 86, 107, 77, 101, 109, 111, 114, 121, 32, 111, 98, 106,
    101, 99, 116, 115, 32, 99, 111, 110, 116, 97, 105, 110, 105, 110, 103, 32, 97, 116, 32, 108, 101, 97, 115, 116, 32,
    111, 110, 101, 32, 105, 109, 97, 103, 101, 32, 115, 104, 97, 100, 101, 114, 45, 114, 101, 97, 100, 97, 98, 108, 101,
    32, 105, 109, 97, 103, 101, 46, 32, 83, 101, 101, 32, 77, 101, 109, 111, 114, 121, 80, 114, 105, 111, 114, 105, 116,
    121, 68, 101, 102, 97, 117, 108, 116, 32, 102, 111, 114, 32, 118, 97, 108, 105, 100, 32, 118, 97, 108, 117, 101,
    115, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 77, 101, 109, 111, 114, 121, 34, 93, 44, 32, 34, 70,
    108, 97, 103, 115, 34, 58, 32, 123, 34, 73, 115, 72, 101, 120, 34, 58, 32, 116, 114, 117, 101, 44, 32, 34, 73, 115,
    66, 105, 116, 109, 97, 115, 107, 34, 58, 32, 116, 114, 117, 101, 125, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116,
    115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 52, 56, 125, 44, 32, 34, 83, 99, 111, 112,
    101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110,
    116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 109, 101, 109,
    111, 114, 121, 80, 114, 105, 111, 114, 105, 116, 121, 73, 109, 97, 103, 101, 83, 104, 97, 100, 101, 114, 82, 101,
    97, 100, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 77, 101, 109, 111, 114, 121, 80, 114, 105, 111, 114, 105,
    116, 121, 73, 109, 97, 103, 101, 83, 104, 97, 100, 101, 114, 82, 101, 97, 100, 34, 44, 32, 34, 72, 97, 115, 104, 78,
    97, 109, 101, 34, 58, 32, 50, 56, 55, 50, 49, 53, 54, 50, 54, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112,
    116, 105, 111, 110, 34, 58, 32, 34, 80, 114, 105, 111, 114, 105, 116, 121, 32, 111, 102, 32, 97, 108, 108, 32, 86,
    107, 77, 101, 109, 111, 114, 121, 32, 111, 98, 106, 101, 99, 116, 115, 32, 99, 111, 110, 116, 97, 105, 110, 105,
    110, 103, 32, 97, 116, 32, 108, 101, 97, 115, 116, 32, 111, 110, 101, 32, 115, 104, 97, 100, 101, 114, 45, 119, 114,
    105, 116, 97, 98, 108, 101, 32, 40, 115, 116, 111, 114, 97, 103, 101, 41, 32, 105, 109, 97, 103, 101, 46, 32, 83,
    101, 101, 32, 77, 101, 109, 111, 114, 121, 80, 114, 105, 111, 114, 105, 116, 121, 68, 101, 102, 97, 117, 108, 116,
    32, 102, 111, 114, 32, 118, 97, 108, 105, 100, 32, 118, 97, 108, 117, 101, 115, 46, 34, 44, 32, 34, 84, 97, 103,
    115, 34, 58, 32, 91, 34, 77, 101, 109, 111, 114, 121, 34, 93, 44, 32, 34, 70, 108, 97, 103, 115, 34, 58, 32, 123,
    34, 73, 115, 72, 101, 120, 34, 58, 32, 116, 114, 117, 101, 44, 32, 34, 73, 115, 66, 105, 116, 109, 97, 115, 107, 34,
    58, 32, 116, 114, 117, 101, 125, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101,
    102, 97, 117, 108, 116, 34, 58, 32, 52, 56, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105,
    118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86,
    97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 109, 101, 109, 111, 114, 121, 80, 114, 105, 111,
    114, 105, 116, 121, 73, 109, 97, 103, 101, 83, 104, 97, 100, 101, 114, 87, 114, 105, 116, 101, 34, 44, 32, 34, 78,
    97, 109, 101, 34, 58, 32, 34, 77, 101, 109, 111, 114, 121, 80, 114, 105, 111, 114, 105, 116, 121, 73, 109, 97, 103,
    101, 83, 104, 97, 100, 101, 114, 87, 114, 105, 116, 101, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58,
    32, 51, 48, 55, 54, 51, 48, 48, 49, 55, 51, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111,
    110, 34, 58, 32, 34, 80, 114, 105, 111, 114, 105, 116, 121, 32, 111, 102, 32, 97, 108, 108, 32, 86, 107, 77, 101,
    109, 111, 114, 121, 32, 111, 98, 106, 101, 99, 116, 115, 32, 99, 111, 110, 116, 97, 105, 110, 105, 110, 103, 32, 97,
    116, 32, 108, 101, 97, 115, 116, 32, 111, 110, 101, 32, 105, 109, 97, 103, 101, 32, 116, 104, 97, 116, 32, 99, 97,
    110, 32, 98, 101, 32, 97, 32, 99, 111, 108, 111, 114, 32, 116, 97, 114, 103, 101, 116, 46, 32, 83, 101, 101, 32, 77,
    101, 109, 111, 114, 121, 80, 114, 105, 111, 114, 105, 116, 121, 68, 101, 102, 97, 117, 108, 116, 32, 102, 111, 114,
    32, 118, 97, 108, 105, 100, 32, 118, 97, 108, 117, 101, 115, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91,
    34, 77, 101, 109, 111, 114, 121, 34, 93, 44, 32, 34, 70, 108, 97, 103, 115, 34, 58, 32, 123, 34, 73, 115, 72, 101,
    120, 34, 58, 32, 116, 114, 117, 101, 44, 32, 34, 73, 115, 66, 105, 116, 109, 97, 115, 107, 34, 58, 32, 116, 114,
    117, 101, 125, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108,
    116, 34, 58, 32, 54, 52, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34,
    44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98,
    108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 109, 101, 109, 111, 114, 121, 80, 114, 105, 111, 114, 105, 116, 121, 73,
    109, 97, 103, 101, 67, 111, 108, 111, 114, 84, 97, 114, 103, 101, 116, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32,
    34, 77, 101, 109, 111, 114, 121, 80, 114, 105, 111, 114, 105, 116, 121, 73, 109, 97, 103, 101, 67, 111, 108, 111,
    114, 84, 97, 114, 103, 101, 116, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 50, 50, 56, 53, 53,
    49, 49, 53, 49, 49, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 80,
    114, 105, 111, 114, 105, 116, 121, 32, 111, 102, 32, 97, 108, 108, 32, 86, 107, 77, 101, 109, 111, 114, 121, 32,
    111, 98, 106, 101, 99, 116, 115, 32, 99, 111, 110, 116, 97, 105, 110, 105, 110, 103, 32, 97, 116, 32, 108, 101, 97,
    115, 116, 32, 111, 110, 101, 32, 105, 109, 97, 103, 101, 32, 116, 104, 97, 116, 32, 99, 97, 110, 32, 98, 101, 32,
    97, 32, 100, 101, 112, 116, 104, 45, 115, 116, 101, 110, 99, 105, 108, 46, 32, 83, 101, 101, 32, 77, 101, 109, 111,
    114, 121, 80, 114, 105, 111, 114, 105, 116, 121, 68, 101, 102, 97, 117, 108, 116, 32, 102, 111, 114, 32, 118, 97,
    108, 105, 100, 32, 118, 97, 108, 117, 101, 115, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 77, 101,
    109, 111, 114, 121, 34, 93, 44, 32, 34, 70, 108, 97, 103, 115, 34, 58, 32, 123, 34, 73, 115, 72, 101, 120, 34, 58,
    32, 116, 114, 117, 101, 44, 32, 34, 73, 115, 66, 105, 116, 109, 97, 115, 107, 34, 58, 32, 116, 114, 117, 101, 125,
    44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32,
    54, 52, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84,
    121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78,
    97, 109, 101, 34, 58, 32, 34, 109, 101, 109, 111, 114, 121, 80, 114, 105, 111, 114, 105, 116, 121, 73, 109, 97, 103,
    101, 68, 101, 112, 116, 104, 83, 116, 101, 110, 99, 105, 108, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 77,
    101, 109, 111, 114, 121, 80, 114, 105, 111, 114, 105, 116, 121, 73, 109, 97, 103, 101, 68, 101, 112, 116, 104, 83,
    116, 101, 110, 99, 105, 108, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 54, 53, 57, 50, 50, 54,
    52, 49, 50, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 79, 110, 32,
    119, 100, 100, 109, 49, 32, 97, 110, 100, 32, 108, 105, 110, 117, 120, 44, 32, 116, 104, 101, 114, 101, 39, 115, 32,
    110, 111, 32, 111, 115, 32, 102, 117, 110, 99, 116, 105, 111, 110, 97, 108, 105, 116, 121, 32, 116, 111, 32, 114,
    101, 112, 111, 114, 116, 32, 109, 101, 109, 111, 114, 121, 32, 98, 117, 100, 103, 101, 116, 46, 32, 87, 101, 32,
    102, 117, 100, 103, 101, 32, 104, 101, 97, 112, 32, 98, 117, 100, 103, 101, 116, 32, 115, 105, 122, 101, 32, 97,
    115, 32, 72, 101, 97, 112, 66, 117, 100, 103, 101, 116, 82, 97, 116, 105, 111, 79, 102, 72, 101, 97, 112, 83, 105,
    122, 101, 76, 111, 99, 97, 108, 37, 32, 111, 102, 32, 104, 101, 97, 112, 32, 115, 105, 122, 101, 32, 102, 111, 114,
    32, 71, 112, 117, 72, 101, 97, 112, 76, 111, 99, 97, 108, 46, 32, 86, 97, 108, 105, 100, 32, 118, 97, 108, 117, 101,
    32, 105, 115, 32, 91, 48, 44, 32, 49, 48, 48, 93, 46, 32, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 77,
    101, 109, 111, 114, 121, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101,
    102, 97, 117, 108, 116, 34, 58, 32, 57, 53, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105,
    118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86,
    97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 104, 101, 97, 112, 66, 117, 100, 103, 101, 116,
    82, 97, 116, 105, 111, 79, 102, 72, 101, 97, 112, 83, 105, 122, 101, 76, 111, 99, 97, 108, 34, 44, 32, 34, 78, 97,
    109, 101, 34, 58, 32, 34, 72, 101, 97, 112, 66, 117, 100, 103, 101, 116, 82, 97, 116, 105, 111, 79, 102, 72, 101,
    97, 112, 83, 105, 122, 101, 76, 111, 99, 97, 108, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32,
    50, 49, 54, 53, 51, 52, 51, 56, 57, 56, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110,
    34, 58, 32, 34, 79, 110, 32, 119, 100, 100, 109, 49, 32, 97, 110, 100, 32, 108, 105, 110, 117, 120, 44, 32, 116,
    104, 101, 114, 101, 39, 115, 32, 110, 111, 32, 111, 115, 32, 102, 117, 110, 99, 116, 105, 111, 110, 97, 108, 105,
    116, 121, 32, 116, 111, 32, 114, 101, 112, 111, 114, 116, 32, 109, 101, 109, 111, 114, 121, 32, 98, 117, 100, 103,
    101, 116, 46, 32, 87, 101, 32, 102, 117, 100, 103, 101, 32, 104, 101, 97, 112, 32, 98, 117, 100, 103, 101, 116, 32,
    115, 105, 122, 101, 32, 97, 115, 32, 72, 101, 97, 112, 66, 117, 100, 103, 101, 116, 82, 97, 116, 105, 111, 79, 102,
    72, 101, 97, 112, 83, 105, 122, 101, 73, 110, 118, 105, 115, 105, 98, 108, 101, 37, 32, 111, 102, 32, 104, 101, 97,
    112, 32, 115, 105, 122, 101, 32, 102, 111, 114, 32, 71, 112, 117, 72, 101, 97, 112, 73, 110, 118, 105, 115, 105, 98,
    108, 101, 32, 86, 97, 108, 105, 100, 32, 118, 97, 108, 117, 101, 32, 105, 115, 32, 91, 48, 44, 32, 49, 48, 48, 93,
    46, 32, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 77, 101, 109, 111, 114, 121, 34, 93, 44, 32, 34, 68,
    101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 57, 53, 125, 44,
    32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34,
    58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34,
    58, 32, 34, 104, 101, 97, 112, 66, 117, 100, 103, 101, 116, 82, 97, 116, 105, 111, 79, 102, 72, 101, 97, 112, 83,
    105, 122, 101, 73, 110, 118, 105, 115, 105, 98, 108, 101, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 72, 101,
    97, 112, 66, 117, 100, 103, 101, 116, 82, 97, 116, 105, 111, 79, 102, 72, 101, 97, 112, 83, 105, 122, 101, 73, 110,
    118, 105, 115, 105, 98, 108, 101, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 50, 48, 57, 51,
    49, 51, 54, 48, 57, 48, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34,
    79, 110, 32, 119, 100, 100, 109, 49, 32, 97, 110, 100, 32, 108, 105, 110, 117, 120, 44, 32, 116, 104, 101, 114, 101,
    39, 115, 32, 110, 111, 32, 111, 115, 32, 102, 117, 110, 99, 116, 105, 111, 110, 97, 108, 105, 116, 121, 32, 116,
    111, 32, 114, 101, 112, 111, 114, 116, 32, 109, 101, 109, 111, 114, 121, 32, 98, 117, 100, 103, 101, 116, 46, 32,
    87, 101, 32, 102, 117, 100, 103, 101, 32, 104, 101, 97, 112, 32, 98, 117, 100, 103, 101, 116, 32, 115, 105, 122,
    101, 32, 97, 115, 32, 72, 101, 97, 112, 66, 117, 100, 103, 101, 116, 82, 97, 116, 105, 111, 79, 102, 72, 101, 97,
    112, 83, 105, 122, 101, 78, 111, 110, 108, 111, 99, 97, 108, 37, 32, 111, 102, 32, 104, 101, 97, 112, 32, 115, 105,
    122, 101, 32, 102, 111, 114, 32, 71, 112, 117, 72, 101, 97, 112, 71, 97, 114, 116, 85, 115, 119, 99, 32, 97, 110,
    100, 32, 71, 112, 117, 72, 101, 97, 112, 71, 97, 114, 116, 67, 97, 99, 104, 101, 97, 98, 108, 101, 46, 32, 86, 97,
    108, 105, 100, 32, 118, 97, 108, 117, 101, 32, 105, 115, 32, 91, 48, 44, 32, 49, 48, 48, 93, 46, 32, 34, 44, 32, 34,
    84, 97, 103, 115, 34, 58, 32, 91, 34, 77, 101, 109, 111, 114, 121, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108,
    116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 57, 53, 125, 44, 32, 34, 83, 99, 111,
    112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105,
    110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 104, 101,
    97, 112, 66, 117, 100, 103, 101, 116, 82, 97, 116, 105, 111, 79, 102, 72, 101, 97, 112, 83, 105, 122, 101, 78, 111,
    110, 108, 111, 99, 97, 108, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 72, 101, 97, 112, 66, 117, 100, 103,
    101, 116, 82, 97, 116, 105, 111, 79, 102, 72, 101, 97, 112, 83, 105, 122, 101, 78, 111, 110, 108, 111, 99, 97, 108,
    34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 52, 48, 49, 52, 54, 49, 56, 50, 50, 53, 125, 44, 32,
    123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 87, 104, 101, 116, 104, 101, 114, 32,
    100, 114, 105, 118, 101, 114, 32, 115, 104, 111, 117, 108, 100, 32, 112, 101, 114, 102, 111, 114, 109, 32, 115, 112,
    97, 114, 115, 101, 32, 114, 101, 115, 111, 117, 114, 99, 101, 32, 117, 110, 109, 97, 112, 32, 97, 116, 32, 114, 101,
    115, 111, 117, 114, 99, 101, 32, 100, 101, 115, 116, 114, 111, 121, 32, 116, 105, 109, 101, 32, 117, 110, 100, 101,
    114, 32, 119, 100, 100, 109, 49, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 77, 101, 109, 111, 114,
    121, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116,
    34, 58, 32, 116, 114, 117, 101, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114,
    34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108,
    101, 78, 97, 109, 101, 34, 58, 32, 34, 105, 115, 83, 112, 97, 114, 115, 101, 85, 110, 109, 97, 112, 66, 101, 102,
    111, 114, 101, 68, 101, 115, 116, 114, 111, 121, 69, 110, 97, 98, 108, 101, 100, 34, 44, 32, 34, 78, 97, 109, 101,
    34, 58, 32, 34, 73, 115, 83, 112, 97, 114, 115, 101, 85, 110, 109, 97, 112, 66, 101, 102, 111, 114, 101, 68, 101,
    115, 116, 114, 111, 121, 69, 110, 97, 98, 108, 101, 100, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58,
    32, 50, 51, 52, 48, 50, 49, 54, 52, 50, 48, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111,
    110, 34, 58, 32, 34, 79, 118, 101, 114, 114, 105, 100, 101, 32, 114, 101, 112, 111, 114, 116, 101, 100, 32, 109,
    105, 110, 73, 109, 97, 103, 101, 84, 114, 97, 110, 115, 102, 101, 114, 71, 114, 97, 110, 117, 108, 97, 114, 105,
    116, 121, 32, 102, 105, 101, 108, 100, 32, 102, 111, 114, 32, 103, 114, 97, 112, 104, 105, 99, 115, 32, 113, 117,
    101, 117, 101, 32, 102, 97, 109, 105, 108, 105, 101, 115, 46, 32, 32, 84, 104, 105, 115, 32, 105, 115, 32, 101, 110,
    99, 111, 100, 101, 100, 32, 97, 115, 32, 97, 32, 104, 101, 120, 32, 115, 116, 114, 105, 110, 103, 32, 111, 102, 32,
    116, 104, 101, 32, 102, 111, 114, 109, 32, 48, 120, 98, 48, 48, 48, 122, 122, 121, 121, 120, 120, 44, 32, 119, 104,
    101, 114, 101, 32, 39, 120, 120, 39, 44, 32, 39, 121, 121, 39, 44, 32, 97, 110, 100, 32, 39, 122, 122, 39, 32, 97,
    114, 101, 32, 116, 104, 101, 32, 114, 101, 112, 111, 114, 116, 101, 100, 32, 116, 114, 97, 110, 115, 102, 101, 114,
    32, 103, 114, 97, 110, 117, 108, 97, 114, 105, 116, 105, 101, 115, 32, 105, 110, 32, 116, 104, 101, 32, 88, 44, 32,
    89, 32, 97, 110, 100, 32, 90, 32, 101, 120, 116, 101, 110, 116, 115, 32, 114, 101, 115, 112, 101, 99, 116, 105, 118,
    101, 108, 121, 44, 32, 97, 110, 100, 32, 39, 98, 39, 32, 105, 115, 32, 97, 32, 99, 111, 110, 116, 114, 111, 108, 32,
    102, 108, 97, 103, 58, 32, 105, 102, 32, 39, 98, 39, 32, 105, 115, 32, 110, 111, 110, 45, 122, 101, 114, 111, 44,
    32, 116, 104, 105, 115, 32, 111, 118, 101, 114, 114, 105, 100, 101, 32, 105, 115, 32, 97, 112, 112, 108, 105, 101,
    115, 59, 32, 111, 116, 104, 101, 114, 119, 105, 115, 101, 32, 116, 104, 101, 32, 115, 116, 97, 110, 100, 97, 114,
    100, 32, 116, 114, 97, 110, 115, 102, 101, 114, 32, 103, 114, 97, 110, 117, 108, 97, 114, 105, 116, 121, 32, 105,
    115, 32, 117, 115, 101, 100, 46, 32, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 77, 101, 109, 111, 114,
    121, 34, 93, 44, 32, 34, 70, 108, 97, 103, 115, 34, 58, 32, 123, 34, 73, 115, 72, 101, 120, 34, 58, 32, 116, 114,
    117, 101, 125, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108,
    116, 34, 58, 32, 48, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44,
    32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98,
    108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 116, 114, 97, 110, 115, 102, 101, 114, 71, 114, 97, 110, 117, 108, 97,
    114, 105, 116, 121, 85, 110, 105, 118, 101, 114, 115, 97, 108, 79, 118, 101, 114, 114, 105, 100, 101, 34, 44, 32,
    34, 78, 97, 109, 101, 34, 58, 32, 34, 84, 114, 97, 110, 115, 102, 101, 114, 71, 114, 97, 110, 117, 108, 97, 114,
    105, 116, 121, 85, 110, 105, 118, 101, 114, 115, 97, 108, 79, 118, 101, 114, 114, 105, 100, 101, 34, 44, 32, 34, 72,
    97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 49, 56, 50, 51, 50, 53, 53, 56, 53, 57, 125, 44, 32, 123, 34, 68, 101,
    115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 79, 118, 101, 114, 114, 105, 100, 101, 32, 114, 101,
    112, 111, 114, 116, 101, 100, 32, 109, 105, 110, 73, 109, 97, 103, 101, 84, 114, 97, 110, 115, 102, 101, 114, 71,
    114, 97, 110, 117, 108, 97, 114, 105, 116, 121, 32, 102, 105, 101, 108, 100, 32, 102, 111, 114, 32, 99, 111, 109,
    112, 117, 116, 101, 32, 113, 117, 101, 117, 101, 32, 102, 97, 109, 105, 108, 105, 101, 115, 46, 32, 32, 70, 111,
    114, 32, 104, 111, 119, 32, 116, 104, 105, 115, 32, 118, 97, 108, 117, 101, 32, 105, 115, 32, 105, 110, 116, 101,
    114, 112, 114, 101, 116, 101, 100, 32, 98, 121, 32, 116, 104, 101, 32, 100, 114, 105, 118, 101, 114, 44, 32, 115,
    101, 101, 32, 116, 104, 101, 32, 100, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 32, 102, 111, 114, 32, 84,
    114, 97, 110, 115, 102, 101, 114, 71, 114, 97, 110, 117, 108, 97, 114, 105, 116, 121, 85, 110, 105, 118, 101, 114,
    115, 97, 108, 79, 118, 101, 114, 114, 105, 100, 101, 46, 32, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34,
    77, 101, 109, 111, 114, 121, 34, 93, 44, 32, 34, 70, 108, 97, 103, 115, 34, 58, 32, 123, 34, 73, 115, 72, 101, 120,
    34, 58, 32, 116, 114, 117, 101, 125, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101,
    102, 97, 117, 108, 116, 34, 58, 32, 48, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118,
    101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97,
    114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 116, 114, 97, 110, 115, 102, 101, 114, 71, 114, 97,
    110, 117, 108, 97, 114, 105, 116, 121, 67, 111, 109, 112, 117, 116, 101, 79, 118, 101, 114, 114, 105, 100, 101, 34,
    44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 84, 114, 97, 110, 115, 102, 101, 114, 71, 114, 97, 110, 117, 108, 97,
    114, 105, 116, 121, 67, 111, 109, 112, 117, 116, 101, 79, 118, 101, 114, 114, 105, 100, 101, 34, 44, 32, 34, 72, 97,
    115, 104, 78, 97, 109, 101, 34, 58, 32, 51, 51, 53, 53, 54, 49, 49, 48, 55, 125, 44, 32, 123, 34, 68, 101, 115, 99,
    114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 68, 101, 118, 105, 99, 101, 45, 108, 111, 99, 97, 108, 32, 109,
    101, 109, 111, 114, 121, 32, 116, 104, 97, 116, 32, 105, 115, 32, 101, 120, 112, 108, 105, 99, 105, 116, 108, 121,
    32, 97, 108, 108, 111, 99, 97, 116, 101, 100, 32, 98, 121, 32, 116, 104, 101, 32, 97, 112, 112, 108, 105, 99, 97,
    116, 105, 111, 110, 32, 99, 97, 110, 32, 116, 114, 97, 99, 107, 101, 100, 32, 111, 110, 32, 97, 32, 112, 101, 114,
    45, 100, 101, 118, 105, 99, 101, 32, 97, 110, 100, 32, 112, 101, 114, 45, 104, 101, 97, 112, 32, 98, 97, 115, 105,
    115, 46, 32, 79, 110, 99, 101, 32, 116, 104, 101, 32, 115, 105, 122, 101, 32, 111, 102, 32, 97, 32, 116, 97, 114,
    103, 101, 116, 32, 104, 101, 97, 112, 32, 105, 115, 32, 114, 101, 97, 99, 104, 101, 100, 44, 32, 86, 75, 95, 79, 85,
    84, 95, 79, 70, 95, 68, 69, 86, 73, 67, 69, 95, 77, 69, 77, 79, 82, 89, 32, 119, 105, 108, 108, 32, 98, 101, 32,
    114, 101, 116, 117, 114, 110, 101, 100, 46, 32, 83, 101, 116, 116, 105, 110, 103, 32, 116, 104, 105, 115, 32, 112,
    97, 114, 97, 109, 101, 116, 101, 114, 32, 116, 111, 32, 84, 82, 85, 69, 32, 119, 105, 108, 108, 32, 100, 105, 115,
    97, 98, 108, 101, 32, 115, 117, 99, 104, 32, 116, 114, 97, 99, 107, 105, 110, 103, 32, 98, 121, 32, 68, 69, 70, 65,
    85, 76, 84, 46, 32, 84, 104, 105, 115, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 32, 99, 97, 110, 32, 98, 101,
    32, 111, 118, 101, 114, 114, 105, 100, 100, 101, 110, 32, 98, 121, 32, 116, 104, 101, 32, 86, 75, 95, 65, 77, 68,
    95, 109, 101, 109, 111, 114, 121, 95, 111, 118, 101, 114, 97, 108, 108, 111, 99, 97, 116, 105, 111, 110, 95, 98,
    101, 104, 97, 118, 105, 111, 114, 32, 100, 101, 118, 105, 99, 101, 32, 101, 120, 116, 101, 110, 115, 105, 111, 110,
    32, 97, 110, 100, 32, 115, 112, 101, 99, 105, 102, 105, 99, 32, 97, 112, 112, 32, 112, 114, 111, 102, 105, 108, 101,
    115, 32, 40, 117, 110, 108, 101, 115, 115, 32, 77, 101, 109, 111, 114, 121, 68, 101, 118, 105, 99, 101, 79, 118,
    101, 114, 97, 108, 108, 111, 99, 97, 116, 105, 111, 110, 78, 111, 110, 79, 118, 101, 114, 114, 105, 100, 97, 98,
    108, 101, 32, 105, 115, 32, 115, 101, 116, 32, 116, 111, 32, 84, 82, 85, 69, 41, 46, 34, 44, 32, 34, 84, 97, 103,
    115, 34, 58, 32, 91, 34, 77, 101, 109, 111, 114, 121, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34,
    58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115, 101, 125, 44, 32, 34, 83, 99, 111,
    112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 98, 111,
    111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 109, 101, 109, 111,
    114, 121, 68, 101, 118, 105, 99, 101, 79, 118, 101, 114, 97, 108, 108, 111, 99, 97, 116, 105, 111, 110, 65, 108,
    108, 111, 119, 101, 100, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 77, 101, 109, 111, 114, 121, 68, 101,
    118, 105, 99, 101, 79, 118, 101, 114, 97, 108, 108, 111, 99, 97, 116, 105, 111, 110, 65, 108, 108, 111, 119, 101,
    100, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 51, 50, 56, 52, 48, 51, 56, 56, 57, 54, 125,
    44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 77, 101, 109, 111, 114, 121,
    68, 101, 118, 105, 99, 101, 79, 118, 101, 114, 97, 108, 108, 111, 99, 97, 116, 105, 111, 110, 65, 108, 108, 111,
    119, 101, 100, 32, 99, 97, 110, 32, 98, 101, 32, 111, 118, 101, 114, 114, 105, 100, 101, 110, 32, 98, 121, 32, 116,
    104, 101, 32, 86, 75, 95, 65, 77, 68, 95, 109, 101, 109, 111, 114, 121, 95, 111, 118, 101, 114, 97, 108, 108, 111,
    99, 97, 116, 105, 111, 110, 95, 98, 101, 104, 97, 118, 105, 111, 114, 32, 100, 101, 118, 105, 99, 101, 32, 101, 120,
    116, 101, 110, 115, 105, 111, 110, 32, 97, 110, 100, 32, 115, 112, 101, 99, 105, 102, 105, 99, 32, 97, 112, 112, 32,
    112, 114, 111, 102, 105, 108, 101, 115, 32, 117, 110, 108, 101, 115, 115, 32, 116, 104, 105, 115, 32, 112, 97, 114,
    97, 109, 101, 116, 101, 114, 32, 105, 115, 32, 115, 101, 116, 32, 116, 111, 32, 84, 82, 85, 69, 46, 34, 44, 32, 34,
    84, 97, 103, 115, 34, 58, 32, 91, 34, 77, 101, 109, 111, 114, 121, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108,
    116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115, 101, 125, 44, 32, 34,
    83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32,
    34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 109,
    101, 109, 111, 114, 121, 68, 101, 118, 105, 99, 101, 79, 118, 101, 114, 97, 108, 108, 111, 99, 97, 116, 105, 111,
    110, 78, 111, 110, 79, 118, 101, 114, 114, 105, 100, 97, 98, 108, 101, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32,
    34, 77, 101, 109, 111, 114, 121, 68, 101, 118, 105, 99, 101, 79, 118, 101, 114, 97, 108, 108, 111, 99, 97, 116, 105,
    111, 110, 78, 111, 110, 79, 118, 101, 114, 114, 105, 100, 97, 98, 108, 101, 34, 44, 32, 34, 72, 97, 115, 104, 78,
    97, 109, 101, 34, 58, 32, 53, 54, 55, 49, 51, 51, 51, 57, 54, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112,
    116, 105, 111, 110, 34, 58, 32, 34, 79, 118, 101, 114, 114, 105, 100, 101, 32, 114, 101, 112, 111, 114, 116, 101,
    100, 32, 109, 105, 110, 73, 109, 97, 103, 101, 84, 114, 97, 110, 115, 102, 101, 114, 71, 114, 97, 110, 117, 108, 97,
    114, 105, 116, 121, 32, 102, 105, 101, 108, 100, 32, 102, 111, 114, 32, 68, 77, 65, 32, 40, 105, 46, 101, 46, 32,
    83, 68, 77, 65, 41, 32, 113, 117, 101, 117, 101, 32, 102, 97, 109, 105, 108, 105, 101, 115, 46, 32, 70, 111, 114,
    32, 104, 111, 119, 32, 116, 104, 105, 115, 32, 118, 97, 108, 117, 101, 32, 105, 115, 32, 105, 110, 116, 101, 114,
    112, 114, 101, 116, 101, 100, 32, 98, 121, 32, 116, 104, 101, 32, 100, 114, 105, 118, 101, 114, 44, 32, 115, 101,
    101, 32, 116, 104, 101, 32, 100, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 32, 102, 111, 114, 32, 84, 114,
    97, 110, 115, 102, 101, 114, 71, 114, 97, 110, 117, 108, 97, 114, 105, 116, 121, 85, 110, 105, 118, 101, 114, 115,
    97, 108, 79, 118, 101, 114, 114, 105, 100, 101, 46, 32, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 77,
    101, 109, 111, 114, 121, 34, 93, 44, 32, 34, 70, 108, 97, 103, 115, 34, 58, 32, 123, 34, 73, 115, 72, 101, 120, 34,
    58, 32, 116, 114, 117, 101, 125, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101,
    102, 97, 117, 108, 116, 34, 58, 32, 48, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118,
    101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97,
    114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 116, 114, 97, 110, 115, 102, 101, 114, 71, 114, 97,
    110, 117, 108, 97, 114, 105, 116, 121, 68, 109, 97, 79, 118, 101, 114, 114, 105, 100, 101, 34, 44, 32, 34, 78, 97,
    109, 101, 34, 58, 32, 34, 84, 114, 97, 110, 115, 102, 101, 114, 71, 114, 97, 110, 117, 108, 97, 114, 105, 116, 121,
    68, 109, 97, 79, 118, 101, 114, 114, 105, 100, 101, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32,
    50, 51, 55, 53, 52, 55, 56, 54, 52, 48, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110,
    34, 58, 32, 34, 70, 111, 114, 99, 101, 115, 32, 97, 32, 112, 97, 114, 116, 105, 99, 117, 108, 97, 114, 32, 65, 112,
    112, 80, 114, 111, 102, 105, 108, 101, 32, 118, 97, 108, 117, 101, 46, 32, 32, 84, 104, 101, 32, 112, 114, 111, 102,
    105, 108, 101, 32, 115, 101, 108, 101, 99, 116, 101, 100, 32, 105, 115, 32, 116, 104, 101, 32, 118, 97, 108, 117,
    101, 32, 111, 102, 32, 70, 111, 114, 99, 101, 65, 112, 112, 80, 114, 111, 102, 105, 108, 101, 86, 97, 108, 117, 101,
    46, 32, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 79, 112, 116, 105, 109, 105, 122, 97, 116, 105, 111,
    110, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116,
    34, 58, 32, 102, 97, 108, 115, 101, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101,
    114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98,
    108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 102, 111, 114, 99, 101, 65, 112, 112, 80, 114, 111, 102, 105, 108, 101,
    69, 110, 97, 98, 108, 101, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 70, 111, 114, 99, 101, 65, 112, 112,
    80, 114, 111, 102, 105, 108, 101, 69, 110, 97, 98, 108, 101, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34,
    58, 32, 51, 53, 49, 51, 48, 52, 50, 48, 50, 51, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105,
    111, 110, 34, 58, 32, 34, 70, 111, 114, 99, 101, 115, 32, 97, 32, 112, 97, 114, 116, 105, 99, 117, 108, 97, 114, 32,
    65, 112, 112, 80, 114, 111, 102, 105, 108, 101, 32, 118, 97, 108, 117, 101, 46, 32, 32, 84, 104, 105, 115, 32, 118,
    97, 108, 117, 101, 32, 105, 115, 32, 116, 104, 101, 32, 105, 110, 116, 101, 103, 101, 114, 32, 118, 97, 108, 117,
    101, 32, 111, 102, 32, 116, 104, 101, 32, 65, 112, 112, 80, 114, 111, 102, 105, 108, 101, 32, 101, 110, 117, 109,
    46, 32, 73, 103, 110, 111, 114, 101, 100, 32, 117, 110, 108, 101, 115, 115, 32, 70, 111, 114, 99, 101, 65, 112, 112,
    80, 114, 111, 102, 105, 108, 101, 69, 110, 97, 98, 108, 101, 32, 105, 115, 32, 116, 114, 117, 101, 46, 32, 34, 44,
    32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 79, 112, 116, 105, 109, 105, 122, 97, 116, 105, 111, 110, 34, 93, 44,
    32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 48,
    125, 44, 32, 34, 68, 101, 112, 101, 110, 100, 115, 79, 110, 34, 58, 32, 123, 34, 83, 101, 116, 116, 105, 110, 103,
    115, 34, 58, 32, 91, 123, 34, 86, 97, 108, 117, 101, 115, 34, 58, 32, 91, 116, 114, 117, 101, 93, 44, 32, 34, 78,
    97, 109, 101, 34, 58, 32, 34, 70, 111, 114, 99, 101, 65, 112, 112, 80, 114, 111, 102, 105, 108, 101, 69, 110, 97,
    98, 108, 101, 34, 125, 93, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34,
    44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98,
    108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 102, 111, 114, 99, 101, 65, 112, 112, 80, 114, 111, 102, 105, 108, 101,
    86, 97, 108, 117, 101, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 70, 111, 114, 99, 101, 65, 112, 112, 80,
    114, 111, 102, 105, 108, 101, 86, 97, 108, 117, 101, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32,
    50, 57, 55, 52, 51, 56, 48, 56, 50, 53, 125, 44, 32, 123, 34, 86, 97, 108, 105, 100, 86, 97, 108, 117, 101, 115, 34,
    58, 32, 123, 34, 73, 115, 69, 110, 117, 109, 34, 58, 32, 116, 114, 117, 101, 44, 32, 34, 86, 97, 108, 117, 101, 115,
    34, 58, 32, 91, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 80, 114, 101, 99, 105, 115,
    101, 65, 110, 105, 115, 111, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 48, 44, 32, 34, 68, 101, 115, 99,
    114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 80, 114, 101, 99, 105, 115, 65, 110, 105, 115, 111, 32, 119, 105,
    108, 108, 32, 98, 101, 32, 101, 110, 97, 98, 108, 101, 100, 46, 32, 72, 105, 103, 104, 101, 115, 116, 32, 105, 109,
    97, 103, 101, 32, 113, 117, 97, 108, 105, 116, 121, 46, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34,
    68, 105, 115, 97, 98, 108, 101, 80, 114, 101, 99, 105, 115, 101, 65, 110, 105, 115, 111, 65, 102, 79, 110, 108, 121,
    34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111,
    110, 34, 58, 32, 34, 80, 114, 101, 99, 105, 115, 65, 110, 105, 115, 111, 32, 119, 105, 108, 108, 32, 98, 101, 32,
    100, 105, 115, 97, 98, 108, 101, 100, 32, 111, 110, 108, 121, 32, 102, 111, 114, 32, 97, 110, 105, 115, 111, 116,
    114, 111, 112, 105, 99, 32, 115, 97, 109, 112, 108, 101, 114, 115, 46, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101,
    34, 58, 32, 34, 68, 105, 115, 97, 98, 108, 101, 80, 114, 101, 99, 105, 115, 101, 65, 110, 105, 115, 111, 65, 108,
    108, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 50, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105,
    111, 110, 34, 58, 32, 34, 80, 114, 101, 99, 105, 115, 65, 110, 105, 115, 111, 32, 119, 105, 108, 108, 32, 98, 101,
    32, 100, 105, 115, 97, 98, 108, 101, 100, 32, 102, 111, 114, 32, 97, 108, 108, 32, 115, 97, 109, 112, 108, 101, 114,
    115, 46, 32, 76, 111, 119, 101, 115, 116, 32, 105, 109, 97, 103, 101, 32, 113, 117, 97, 108, 105, 116, 121, 46, 34,
    125, 93, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 80, 114, 101, 99, 105, 115, 101, 65, 110, 105, 115, 111, 77,
    111, 100, 101, 34, 125, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 80, 114,
    101, 99, 105, 115, 101, 65, 110, 105, 115, 111, 77, 111, 100, 101, 32, 100, 101, 110, 111, 116, 101, 115, 32, 119,
    104, 101, 116, 104, 101, 114, 32, 112, 114, 101, 99, 105, 115, 101, 65, 110, 105, 115, 111, 32, 119, 105, 108, 108,
    32, 98, 101, 32, 101, 110, 97, 98, 108, 101, 100, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 79, 112,
    116, 105, 109, 105, 122, 97, 116, 105, 111, 110, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58,
    32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 34, 68, 105, 115, 97, 98, 108, 101, 80, 114, 101, 99, 105,
    115, 101, 65, 110, 105, 115, 111, 65, 102, 79, 110, 108, 121, 34, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58,
    32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 101, 110, 117, 109, 34, 44,
    32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 112, 114, 101, 99, 105, 115, 101, 65,
    110, 105, 115, 111, 77, 111, 100, 101, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 80, 114, 101, 99, 105, 115,
    101, 65, 110, 105, 115, 111, 77, 111, 100, 101, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 51,
    56, 53, 49, 57, 56, 57, 54, 50, 49, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34,
    58, 32, 34, 83, 117, 112, 112, 108, 121, 32, 116, 104, 101, 32, 116, 104, 114, 101, 115, 104, 111, 108, 100, 32,
    118, 97, 108, 117, 101, 32, 102, 111, 114, 32, 97, 110, 105, 115, 111, 116, 114, 111, 112, 105, 99, 32, 102, 105,
    108, 116, 101, 114, 105, 110, 103, 32, 40, 68, 105, 115, 97, 98, 108, 101, 80, 114, 101, 99, 105, 115, 101, 65, 110,
    105, 115, 111, 32, 110, 101, 101, 100, 115, 32, 116, 111, 32, 98, 101, 32, 116, 114, 117, 101, 32, 97, 108, 115,
    111, 41, 32, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 79, 112, 116, 105, 109, 105, 122, 97, 116, 105,
    111, 110, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108,
    116, 34, 58, 32, 102, 97, 108, 115, 101, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118,
    101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105,
    97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 117, 115, 101, 65, 110, 105, 115, 111, 84, 104, 114, 101, 115,
    104, 111, 108, 100, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 85, 115, 101, 65, 110, 105, 115, 111, 84, 104,
    114, 101, 115, 104, 111, 108, 100, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 49, 50, 55, 51,
    54, 53, 49, 51, 56, 55, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34,
    84, 104, 101, 32, 116, 104, 114, 101, 115, 104, 111, 108, 100, 32, 118, 97, 108, 117, 101, 32, 102, 111, 114, 32,
    97, 110, 105, 115, 111, 116, 114, 111, 112, 105, 99, 32, 102, 105, 108, 116, 101, 114, 105, 110, 103, 32, 40, 68,
    105, 115, 97, 98, 108, 101, 80, 114, 101, 99, 105, 115, 101, 65, 110, 105, 115, 111, 32, 38, 32, 85, 115, 101, 65,
    110, 105, 115, 111, 84, 104, 114, 101, 115, 104, 111, 108, 100, 32, 110, 101, 101, 100, 32, 116, 111, 32, 98, 101,
    32, 116, 114, 117, 101, 32, 97, 108, 115, 111, 41, 32, 68, 101, 102, 97, 117, 108, 116, 32, 118, 97, 108, 117, 101,
    32, 40, 48, 46, 50, 53, 41, 32, 112, 114, 101, 115, 101, 114, 118, 101, 115, 32, 116, 104, 101, 32, 80, 97, 108, 32,
    98, 101, 104, 97, 118, 105, 111, 117, 114, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 79, 112, 116, 105,
    109, 105, 122, 97, 116, 105, 111, 110, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123,
    34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 48, 46, 50, 53, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32,
    34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 102, 108, 111, 97, 116, 34, 44,
    32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 97, 110, 105, 115, 111, 84, 104, 114,
    101, 115, 104, 111, 108, 100, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 65, 110, 105, 115, 111, 84, 104,
    114, 101, 115, 104, 111, 108, 100, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 51, 52, 49, 54,
    56, 54, 54, 57, 55, 48, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34,
    85, 115, 101, 32, 102, 108, 105, 112, 32, 104, 105, 110, 116, 32, 102, 111, 114, 32, 115, 119, 97, 112, 99, 104, 97,
    105, 110, 46, 32, 76, 105, 110, 117, 120, 32, 79, 110, 108, 121, 46, 32, 84, 104, 101, 32, 88, 32, 83, 101, 114,
    118, 101, 114, 32, 109, 97, 107, 101, 32, 116, 104, 101, 32, 102, 105, 110, 97, 108, 32, 100, 101, 99, 105, 115,
    105, 111, 110, 32, 119, 104, 101, 116, 104, 101, 114, 32, 116, 111, 32, 103, 111, 32, 97, 115, 121, 110, 99, 32,
    102, 108, 105, 112, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 79, 112, 116, 105, 109, 105, 122, 97,
    116, 105, 111, 110, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97,
    117, 108, 116, 34, 58, 32, 102, 97, 108, 115, 101, 125, 44, 32, 34, 68, 101, 112, 101, 110, 100, 115, 79, 110, 34,
    58, 32, 123, 34, 79, 83, 34, 58, 32, 91, 34, 76, 105, 110, 117, 120, 34, 93, 125, 44, 32, 34, 83, 99, 111, 112, 101,
    34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 98, 111, 111, 108,
    34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 117, 115, 101, 70, 108, 105,
    112, 72, 105, 110, 116, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 85, 115, 101, 70, 108, 105, 112, 72, 105,
    110, 116, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 51, 57, 54, 52, 55, 53, 50, 57, 52, 125,
    44, 32, 123, 34, 86, 97, 108, 105, 100, 86, 97, 108, 117, 101, 115, 34, 58, 32, 123, 34, 73, 115, 69, 110, 117, 109,
    34, 58, 32, 116, 114, 117, 101, 44, 32, 34, 86, 97, 108, 117, 101, 115, 34, 58, 32, 91, 123, 34, 78, 97, 109, 101,
    34, 58, 32, 34, 66, 71, 70, 83, 69, 110, 97, 98, 108, 101, 87, 100, 100, 109, 49, 73, 109, 109, 101, 100, 105, 97,
    116, 101, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116,
    105, 111, 110, 34, 58, 32, 34, 87, 105, 110, 55, 45, 56, 32, 43, 32, 86, 75, 95, 80, 82, 69, 83, 69, 78, 84, 95, 77,
    79, 68, 69, 95, 73, 77, 77, 69, 68, 73, 65, 84, 69, 95, 75, 72, 82, 32, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101,
    34, 58, 32, 34, 66, 71, 70, 83, 69, 110, 97, 98, 108, 101, 87, 100, 100, 109, 49, 77, 97, 105, 108, 98, 111, 120,
    34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 50, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111,
    110, 34, 58, 32, 34, 87, 105, 110, 55, 45, 56, 32, 43, 32, 86, 75, 95, 80, 82, 69, 83, 69, 78, 84, 95, 77, 79, 68,
    69, 95, 77, 65, 73, 76, 66, 79, 88, 95, 75, 72, 82, 32, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34,
    66, 71, 70, 83, 69, 110, 97, 98, 108, 101, 87, 100, 100, 109, 49, 70, 105, 102, 111, 34, 44, 32, 34, 86, 97, 108,
    117, 101, 34, 58, 32, 52, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 87, 105,
    110, 55, 45, 56, 32, 43, 32, 86, 75, 95, 80, 82, 69, 83, 69, 78, 84, 95, 77, 79, 68, 69, 95, 70, 73, 70, 79, 95, 75,
    72, 82, 32, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 66, 71, 70, 83, 69, 110, 97, 98, 108, 101,
    87, 100, 100, 109, 49, 70, 105, 102, 111, 82, 101, 108, 97, 120, 101, 100, 34, 44, 32, 34, 86, 97, 108, 117, 101,
    34, 58, 32, 56, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 87, 105, 110, 55,
    45, 56, 32, 43, 32, 86, 75, 95, 80, 82, 69, 83, 69, 78, 84, 95, 77, 79, 68, 69, 95, 70, 73, 70, 79, 95, 82, 69, 76,
    65, 88, 69, 68, 95, 75, 72, 82, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 66, 71, 70, 83, 69, 110,
    97, 98, 108, 101, 87, 100, 100, 109, 50, 73, 109, 109, 101, 100, 105, 97, 116, 101, 34, 44, 32, 34, 86, 97, 108,
    117, 101, 34, 58, 32, 49, 54, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 87,
    105, 110, 49, 48, 32, 32, 43, 32, 86, 75, 95, 80, 82, 69, 83, 69, 78, 84, 95, 77, 79, 68, 69, 95, 73, 77, 77, 69,
    68, 73, 65, 84, 69, 95, 75, 72, 82, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 66, 71, 70, 83, 69,
    110, 97, 98, 108, 101, 87, 100, 100, 109, 50, 77, 97, 105, 108, 98, 111, 120, 34, 44, 32, 34, 86, 97, 108, 117, 101,
    34, 58, 32, 51, 50, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 87, 105, 110,
    49, 48, 32, 32, 43, 32, 86, 75, 95, 80, 82, 69, 83, 69, 78, 84, 95, 77, 79, 68, 69, 95, 77, 65, 73, 76, 66, 79, 88,
    95, 75, 72, 82, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 66, 71, 70, 83, 69, 110, 97, 98, 108,
    101, 87, 100, 100, 109, 50, 70, 105, 102, 111, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 54, 52, 44, 32,
    34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 87, 105, 110, 49, 48, 32, 32, 43, 32, 86,
    75, 95, 80, 82, 69, 83, 69, 78, 84, 95, 77, 79, 68, 69, 95, 70, 73, 70, 79, 95, 75, 72, 82, 34, 125, 44, 32, 123,
    34, 78, 97, 109, 101, 34, 58, 32, 34, 66, 71, 70, 83, 69, 110, 97, 98, 108, 101, 87, 100, 100, 109, 50, 70, 105,
    102, 111, 82, 101, 108, 97, 120, 101, 100, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 50, 56, 44, 32,
    34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 87, 105, 110, 49, 48, 32, 32, 43, 32, 86,
    75, 95, 80, 82, 69, 83, 69, 78, 84, 95, 77, 79, 68, 69, 95, 70, 73, 70, 79, 95, 82, 69, 76, 65, 88, 69, 68, 95, 75,
    72, 82, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 66, 71, 70, 83, 69, 110, 97, 98, 108, 101, 87,
    100, 100, 109, 49, 77, 117, 108, 116, 105, 71, 112, 117, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 50, 53,
    54, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 87, 105, 110, 55, 45, 56, 32,
    43, 32, 77, 117, 108, 116, 105, 45, 71, 80, 85, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 66, 71,
    70, 83, 69, 110, 97, 98, 108, 101, 87, 100, 100, 109, 50, 77, 117, 108, 116, 105, 71, 112, 117, 34, 44, 32, 34, 86,
    97, 108, 117, 101, 34, 58, 32, 53, 49, 50, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58,
    32, 34, 87, 105, 110, 49, 48, 32, 32, 43, 32, 77, 117, 108, 116, 105, 32, 71, 80, 85, 34, 125, 93, 44, 32, 34, 78,
    97, 109, 101, 34, 58, 32, 34, 66, 71, 70, 83, 69, 110, 97, 98, 108, 101, 70, 108, 97, 103, 115, 34, 125, 44, 32, 34,
    68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 70, 111, 114, 99, 101, 32, 102, 117, 108, 108,
    115, 99, 114, 101, 101, 110, 32, 101, 120, 99, 108, 117, 115, 105, 118, 101, 32, 112, 114, 101, 115, 101, 110, 116,
    115, 32, 119, 104, 101, 110, 32, 100, 101, 116, 101, 99, 116, 101, 100, 32, 115, 97, 102, 101, 46, 32, 32, 84, 104,
    101, 32, 102, 111, 108, 108, 111, 119, 105, 110, 103, 32, 99, 111, 109, 98, 105, 110, 97, 116, 105, 111, 110, 32,
    111, 102, 32, 102, 108, 97, 103, 115, 32, 99, 111, 110, 116, 114, 111, 108, 32, 119, 104, 101, 116, 104, 101, 114,
    32, 116, 104, 105, 115, 32, 102, 101, 97, 116, 117, 114, 101, 32, 105, 115, 32, 101, 110, 97, 98, 108, 101, 100, 32,
    102, 111, 114, 32, 97, 32, 112, 97, 114, 116, 105, 99, 117, 108, 97, 114, 32, 79, 83, 32, 43, 32, 115, 119, 97, 112,
    99, 104, 97, 105, 110, 32, 99, 111, 109, 98, 105, 110, 97, 116, 105, 111, 110, 58, 32, 34, 44, 32, 34, 84, 97, 103,
    115, 34, 58, 32, 91, 34, 79, 112, 116, 105, 109, 105, 122, 97, 116, 105, 111, 110, 34, 93, 44, 32, 34, 70, 108, 97,
    103, 115, 34, 58, 32, 123, 34, 73, 115, 72, 101, 120, 34, 58, 32, 116, 114, 117, 101, 44, 32, 34, 73, 115, 66, 105,
    116, 109, 97, 115, 107, 34, 58, 32, 116, 114, 117, 101, 125, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34,
    58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 49, 48, 50, 51, 125, 44, 32, 34, 83, 99, 111, 112,
    101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110,
    116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 98, 97, 99, 107,
    103, 114, 111, 117, 110, 100, 70, 117, 108, 108, 115, 99, 114, 101, 101, 110, 80, 114, 101, 115, 101, 110, 116, 34,
    44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 66, 97, 99, 107, 103, 114, 111, 117, 110, 100, 70, 117, 108, 108, 115,
    99, 114, 101, 101, 110, 80, 114, 101, 115, 101, 110, 116, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34,
    58, 32, 49, 50, 57, 56, 55, 52, 57, 54, 55, 53, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105,
    111, 110, 34, 58, 32, 34, 70, 117, 108, 108, 115, 99, 114, 101, 101, 110, 32, 112, 114, 101, 115, 101, 110, 116,
    115, 32, 109, 97, 121, 32, 102, 97, 105, 108, 32, 100, 117, 101, 32, 116, 111, 32, 117, 110, 101, 120, 112, 101, 99,
    116, 101, 100, 32, 101, 114, 114, 111, 114, 115, 44, 32, 97, 108, 116, 104, 111, 117, 103, 104, 32, 116, 104, 101,
    115, 101, 32, 99, 97, 115, 101, 115, 32, 97, 114, 101, 32, 114, 97, 114, 101, 46, 32, 70, 97, 105, 108, 105, 110,
    103, 32, 97, 32, 102, 117, 108, 108, 115, 99, 114, 101, 101, 110, 32, 112, 114, 101, 115, 101, 110, 116, 32, 97,
    110, 100, 32, 114, 101, 97, 116, 116, 101, 109, 112, 116, 105, 110, 103, 32, 116, 111, 32, 97, 99, 113, 117, 105,
    114, 101, 32, 101, 120, 99, 108, 117, 115, 105, 118, 101, 32, 97, 99, 99, 101, 115, 115, 32, 99, 97, 117, 115, 101,
    115, 32, 100, 114, 111, 112, 112, 101, 100, 32, 102, 114, 97, 109, 101, 115, 32, 97, 110, 100, 32, 115, 99, 114,
    101, 101, 110, 32, 102, 108, 105, 99, 107, 101, 114, 105, 110, 103, 46, 32, 32, 84, 104, 105, 115, 32, 105, 115, 32,
    97, 32, 102, 97, 105, 108, 45, 115, 97, 102, 101, 32, 115, 101, 116, 116, 105, 110, 103, 32, 116, 104, 97, 116, 32,
    112, 101, 114, 109, 97, 110, 101, 110, 116, 108, 121, 32, 100, 105, 115, 97, 98, 108, 101, 115, 32, 116, 104, 101,
    32, 102, 117, 108, 108, 115, 99, 114, 101, 101, 110, 32, 112, 114, 101, 115, 101, 110, 116, 32, 108, 111, 103, 105,
    99, 32, 97, 102, 116, 101, 114, 32, 116, 104, 101, 32, 103, 105, 118, 101, 110, 32, 110, 117, 109, 98, 101, 114, 32,
    111, 102, 32, 99, 111, 110, 115, 101, 99, 117, 116, 105, 118, 101, 32, 117, 110, 101, 120, 112, 101, 99, 116, 101,
    100, 32, 102, 97, 105, 108, 117, 114, 101, 115, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 79, 112,
    116, 105, 109, 105, 122, 97, 116, 105, 111, 110, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58,
    32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 50, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32,
    34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34,
    44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 98, 97, 99, 107, 103, 114, 111,
    117, 110, 100, 70, 117, 108, 108, 115, 99, 114, 101, 101, 110, 70, 97, 105, 108, 117, 114, 101, 68, 105, 115, 97,
    98, 108, 101, 67, 111, 117, 110, 116, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 66, 97, 99, 107, 103, 114,
    111, 117, 110, 100, 70, 117, 108, 108, 115, 99, 114, 101, 101, 110, 70, 97, 105, 108, 117, 114, 101, 68, 105, 115,
    97, 98, 108, 101, 67, 111, 117, 110, 116, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 51, 51,
    48, 52, 53, 52, 50, 51, 51, 55, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58,
    32, 34, 82, 101, 115, 101, 116, 32, 116, 104, 101, 32, 102, 97, 105, 108, 117, 114, 101, 32, 99, 111, 117, 110, 116,
    32, 111, 110, 108, 121, 32, 97, 102, 116, 101, 114, 32, 116, 104, 105, 115, 32, 109, 97, 110, 121, 32, 99, 111, 110,
    115, 101, 99, 117, 116, 105, 118, 101, 32, 115, 117, 99, 99, 101, 115, 115, 102, 117, 108, 32, 102, 117, 108, 108,
    115, 99, 114, 101, 101, 110, 32, 112, 114, 101, 115, 101, 110, 116, 115, 46, 32, 65, 32, 108, 97, 114, 103, 101, 32,
    118, 97, 108, 117, 101, 32, 102, 111, 114, 32, 116, 104, 105, 115, 32, 115, 101, 116, 116, 105, 110, 103, 32, 105,
    115, 32, 117, 115, 101, 100, 32, 116, 111, 32, 103, 117, 97, 114, 97, 110, 116, 101, 101, 32, 116, 104, 97, 116, 32,
    119, 101, 32, 97, 114, 101, 32, 99, 111, 110, 115, 105, 115, 116, 101, 110, 116, 108, 121, 32, 112, 114, 101, 115,
    101, 110, 116, 105, 110, 103, 32, 105, 110, 32, 102, 117, 108, 108, 115, 99, 114, 101, 101, 110, 32, 105, 110, 115,
    116, 101, 97, 100, 32, 111, 102, 32, 114, 97, 112, 105, 100, 108, 121, 32, 112, 105, 110, 103, 45, 112, 111, 110,
    103, 105, 110, 103, 32, 98, 101, 116, 119, 101, 101, 110, 32, 102, 117, 108, 108, 115, 99, 114, 101, 101, 110, 32,
    97, 110, 100, 32, 119, 105, 110, 100, 111, 119, 101, 100, 32, 112, 114, 101, 115, 101, 110, 116, 115, 46, 32, 34,
    44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 79, 112, 116, 105, 109, 105, 122, 97, 116, 105, 111, 110, 34, 93,
    44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32,
    54, 52, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84,
    121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78,
    97, 109, 101, 34, 58, 32, 34, 98, 97, 99, 107, 103, 114, 111, 117, 110, 100, 70, 117, 108, 108, 115, 99, 114, 101,
    101, 110, 83, 117, 99, 99, 101, 115, 115, 82, 101, 115, 101, 116, 67, 111, 117, 110, 116, 34, 44, 32, 34, 78, 97,
    109, 101, 34, 58, 32, 34, 66, 97, 99, 107, 103, 114, 111, 117, 110, 100, 70, 117, 108, 108, 115, 99, 114, 101, 101,
    110, 83, 117, 99, 99, 101, 115, 115, 82, 101, 115, 101, 116, 67, 111, 117, 110, 116, 34, 44, 32, 34, 72, 97, 115,
    104, 78, 97, 109, 101, 34, 58, 32, 50, 53, 51, 52, 53, 48, 55, 50, 57, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114,
    105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 87, 104, 101, 110, 32, 102, 111, 114, 99, 105, 110, 103, 32, 102, 117,
    108, 108, 115, 99, 114, 101, 101, 110, 32, 112, 114, 101, 115, 101, 110, 116, 115, 44, 32, 116, 104, 105, 115, 32,
    102, 108, 97, 103, 32, 119, 105, 108, 108, 32, 105, 103, 110, 111, 114, 101, 32, 117, 110, 101, 120, 112, 101, 99,
    116, 101, 100, 32, 101, 114, 114, 111, 114, 115, 32, 111, 110, 32, 97, 110, 121, 32, 102, 97, 105, 108, 101, 100,
    32, 112, 114, 101, 115, 101, 110, 116, 46, 32, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 79, 112, 116,
    105, 109, 105, 122, 97, 116, 105, 111, 110, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32,
    123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115, 101, 125, 44, 32, 34, 83, 99, 111, 112,
    101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 98, 111, 111,
    108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 98, 97, 99, 107, 103,
    114, 111, 117, 110, 100, 70, 117, 108, 108, 115, 99, 114, 101, 101, 110, 73, 103, 110, 111, 114, 101, 80, 114, 101,
    115, 101, 110, 116, 69, 114, 114, 111, 114, 115, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 66, 97, 99, 107,
    103, 114, 111, 117, 110, 100, 70, 117, 108, 108, 115, 99, 114, 101, 101, 110, 73, 103, 110, 111, 114, 101, 80, 114,
    101, 115, 101, 110, 116, 69, 114, 114, 111, 114, 115, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58,
    32, 51, 53, 54, 49, 50, 49, 56, 55, 56, 50, 125, 44, 32, 123, 34, 86, 97, 108, 105, 100, 86, 97, 108, 117, 101, 115,
    34, 58, 32, 123, 34, 86, 97, 108, 117, 101, 115, 34, 58, 32, 91, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 66, 97,
    108, 97, 110, 99, 101, 100, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 48, 44, 32, 34, 68, 101, 115, 99,
    114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 66, 97, 108, 97, 110, 99, 101, 32, 109, 101, 109, 111, 114, 121,
    32, 102, 111, 111, 114, 112, 114, 105, 110, 116, 32, 97, 110, 100, 32, 114, 101, 110, 100, 101, 114, 105, 110, 103,
    32, 112, 101, 114, 102, 111, 114, 109, 97, 110, 99, 101, 46, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32,
    34, 79, 112, 116, 70, 111, 114, 83, 112, 97, 99, 101, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 44, 32,
    34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 79, 112, 116, 105, 109, 105, 122, 101, 32,
    116, 105, 108, 105, 110, 103, 32, 109, 111, 100, 101, 32, 102, 111, 114, 32, 115, 97, 118, 105, 110, 103, 32, 109,
    101, 109, 111, 114, 121, 32, 102, 111, 111, 116, 112, 114, 105, 110, 116, 34, 125, 44, 32, 123, 34, 78, 97, 109,
    101, 34, 58, 32, 34, 79, 112, 116, 70, 111, 114, 83, 112, 101, 101, 100, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34,
    58, 32, 50, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 79, 112, 116, 105, 109,
    105, 122, 101, 32, 116, 105, 108, 105, 110, 103, 32, 109, 111, 100, 101, 32, 102, 111, 114, 32, 114, 101, 110, 100,
    101, 114, 105, 110, 103, 32, 112, 101, 114, 102, 111, 114, 109, 97, 110, 99, 101, 46, 34, 125, 93, 44, 32, 34, 78,
    97, 109, 101, 34, 58, 32, 34, 80, 97, 108, 58, 58, 84, 105, 108, 105, 110, 103, 79, 112, 116, 77, 111, 100, 101, 34,
    125, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 72, 105, 110, 116, 115, 32,
    116, 111, 32, 80, 65, 76, 32, 116, 111, 32, 115, 101, 108, 101, 99, 116, 32, 116, 104, 101, 32, 97, 112, 112, 114,
    111, 112, 114, 105, 97, 116, 101, 32, 116, 105, 108, 105, 110, 103, 32, 109, 111, 100, 101, 32, 102, 111, 114, 32,
    97, 110, 32, 111, 112, 116, 105, 109, 105, 122, 97, 116, 105, 111, 110, 32, 116, 97, 114, 103, 101, 116, 46, 32, 48,
    58, 32, 66, 97, 108, 97, 110, 99, 101, 100, 32, 49, 58, 32, 79, 112, 116, 70, 111, 114, 83, 112, 97, 99, 101, 32,
    50, 58, 32, 79, 112, 116, 70, 111, 114, 83, 112, 101, 101, 100, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91,
    34, 79, 112, 116, 105, 109, 105, 122, 97, 116, 105, 111, 110, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116,
    115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 34, 80, 97, 108, 58, 58, 84, 105, 108, 105,
    110, 103, 79, 112, 116, 77, 111, 100, 101, 58, 58, 66, 97, 108, 97, 110, 99, 101, 100, 34, 125, 44, 32, 34, 83, 99,
    111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 101,
    110, 117, 109, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 105, 109, 97,
    103, 101, 84, 105, 108, 105, 110, 103, 79, 112, 116, 77, 111, 100, 101, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58,
    32, 34, 73, 109, 97, 103, 101, 84, 105, 108, 105, 110, 103, 79, 112, 116, 77, 111, 100, 101, 34, 44, 32, 34, 72, 97,
    115, 104, 78, 97, 109, 101, 34, 58, 32, 51, 53, 54, 48, 56, 49, 57, 56, 49, 125, 44, 32, 123, 34, 86, 97, 108, 105,
    100, 86, 97, 108, 117, 101, 115, 34, 58, 32, 123, 34, 86, 97, 108, 117, 101, 115, 34, 58, 32, 91, 123, 34, 78, 97,
    109, 101, 34, 58, 32, 34, 68, 101, 102, 97, 117, 108, 116, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 48,
    44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 78, 111, 32, 115, 119, 105, 122,
    122, 108, 101, 32, 109, 111, 100, 101, 32, 105, 115, 32, 112, 114, 101, 102, 101, 114, 114, 101, 100, 46, 34, 125,
    44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 83, 116, 97, 110, 100, 97, 114, 100, 34, 44, 32, 34, 86, 97, 108,
    117, 101, 34, 58, 32, 49, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 80, 114,
    101, 102, 101, 114, 32, 115, 116, 97, 110, 100, 97, 114, 100, 32, 115, 119, 105, 122, 122, 108, 101, 32, 109, 111,
    100, 101, 115, 46, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 88, 77, 97, 106, 111, 114, 34, 44,
    32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 50, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34,
    58, 32, 34, 80, 114, 101, 102, 101, 114, 32, 120, 45, 99, 111, 111, 114, 100, 105, 110, 97, 116, 101, 32, 109, 97,
    106, 111, 114, 32, 115, 119, 105, 122, 122, 108, 101, 32, 109, 111, 100, 101, 115, 46, 34, 125, 44, 32, 123, 34, 78,
    97, 109, 101, 34, 58, 32, 34, 89, 77, 97, 106, 111, 114, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 51, 44,
    32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 80, 114, 101, 102, 101, 114, 32, 121,
    45, 99, 111, 111, 114, 100, 105, 110, 97, 116, 101, 32, 109, 97, 106, 111, 114, 32, 115, 119, 105, 122, 122, 108,
    101, 32, 109, 111, 100, 101, 115, 46, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 73, 110, 116, 101,
    114, 108, 101, 97, 118, 101, 100, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 52, 44, 32, 34, 68, 101, 115,
    99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 80, 114, 101, 102, 101, 114, 32, 105, 110, 116, 101, 114,
    108, 101, 97, 118, 101, 100, 32, 99, 111, 111, 114, 100, 105, 110, 97, 116, 101, 32, 115, 119, 105, 122, 122, 108,
    101, 32, 109, 111, 100, 101, 115, 46, 34, 125, 93, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 80, 97, 108, 58,
    58, 73, 109, 97, 103, 101, 84, 105, 108, 105, 110, 103, 80, 97, 116, 116, 101, 114, 110, 34, 125, 44, 32, 34, 68,
    101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 72, 105, 110, 116, 115, 32, 116, 111, 32, 112, 97,
    108, 32, 116, 111, 32, 105, 100, 101, 110, 116, 105, 102, 121, 32, 97, 32, 112, 114, 101, 102, 101, 114, 101, 110,
    99, 101, 32, 102, 111, 114, 32, 104, 111, 119, 32, 116, 104, 105, 115, 32, 105, 109, 97, 103, 101, 32, 105, 115, 32,
    111, 114, 103, 97, 110, 105, 122, 101, 100, 46, 32, 48, 58, 32, 68, 101, 102, 97, 117, 108, 116, 32, 49, 58, 32, 83,
    116, 97, 110, 100, 97, 114, 100, 32, 50, 58, 32, 88, 77, 97, 106, 111, 114, 32, 51, 58, 32, 89, 77, 97, 106, 111,
    114, 32, 52, 58, 32, 73, 110, 116, 101, 114, 108, 101, 97, 118, 101, 100, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58,
    32, 91, 34, 79, 112, 116, 105, 109, 105, 122, 97, 116, 105, 111, 110, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117,
    108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 34, 80, 97, 108, 58, 58, 73, 109,
    97, 103, 101, 84, 105, 108, 105, 110, 103, 80, 97, 116, 116, 101, 114, 110, 58, 58, 68, 101, 102, 97, 117, 108, 116,
    34, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121,
    112, 101, 34, 58, 32, 34, 101, 110, 117, 109, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101,
    34, 58, 32, 34, 105, 109, 97, 103, 101, 84, 105, 108, 105, 110, 103, 80, 114, 101, 102, 101, 114, 101, 110, 99, 101,
    34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 73, 109, 97, 103, 101, 84, 105, 108, 105, 110, 103, 80, 114, 101,
    102, 101, 114, 101, 110, 99, 101, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 50, 50, 57, 52,
    54, 50, 48, 56, 57, 54, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34,
    69, 110, 97, 98, 108, 101, 32, 70, 77, 65, 83, 75, 32, 98, 97, 115, 101, 100, 32, 77, 83, 65, 65, 32, 116, 101, 120,
    116, 117, 114, 101, 32, 114, 101, 97, 100, 115, 46, 32, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 79,
    112, 116, 105, 109, 105, 122, 97, 116, 105, 111, 110, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34,
    58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 116, 114, 117, 101, 125, 44, 32, 34, 84, 121, 112,
    101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34,
    58, 32, 34, 101, 110, 97, 98, 108, 101, 70, 109, 97, 115, 107, 66, 97, 115, 101, 100, 77, 115, 97, 97, 82, 101, 97,
    100, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 70, 109, 97, 115, 107, 66, 97,
    115, 101, 100, 77, 115, 97, 97, 82, 101, 97, 100, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114,
    105, 118, 101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 52, 50, 51, 56, 56, 56, 57, 56,
    53, 51, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 69, 110, 97, 98,
    108, 101, 32, 104, 105, 103, 104, 32, 112, 114, 105, 111, 114, 105, 116, 121, 32, 102, 111, 114, 32, 100, 101, 115,
    99, 114, 105, 112, 116, 111, 114, 32, 109, 101, 109, 111, 114, 121, 46, 32, 34, 44, 32, 34, 84, 97, 103, 115, 34,
    58, 32, 91, 34, 79, 112, 116, 105, 109, 105, 122, 97, 116, 105, 111, 110, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117,
    108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115, 101, 125, 44,
    32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101,
    78, 97, 109, 101, 34, 58, 32, 34, 101, 110, 97, 98, 108, 101, 72, 105, 103, 104, 80, 114, 105, 111, 114, 105, 116,
    121, 68, 101, 115, 99, 114, 105, 112, 116, 111, 114, 77, 101, 109, 111, 114, 121, 34, 44, 32, 34, 78, 97, 109, 101,
    34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 72, 105, 103, 104, 80, 114, 105, 111, 114, 105, 116, 121, 68, 101, 115,
    99, 114, 105, 112, 116, 111, 114, 77, 101, 109, 111, 114, 121, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32,
    34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 49, 51, 55, 48, 52,
    49, 50, 49, 49, 50, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 68,
    105, 115, 97, 98, 108, 101, 32, 72, 116, 105, 108, 101, 32, 98, 97, 115, 101, 100, 32, 77, 83, 65, 65, 32, 116, 101,
    120, 116, 117, 114, 101, 32, 114, 101, 97, 100, 115, 46, 32, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34,
    79, 112, 116, 105, 109, 105, 122, 97, 116, 105, 111, 110, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115,
    34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115, 101, 125, 44, 32, 34, 84, 121,
    112, 101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101,
    34, 58, 32, 34, 100, 105, 115, 97, 98, 108, 101, 72, 116, 105, 108, 101, 66, 97, 115, 101, 100, 77, 115, 97, 97, 82,
    101, 97, 100, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 105, 115, 97, 98, 108, 101, 72, 116, 105, 108,
    101, 66, 97, 115, 101, 100, 77, 115, 97, 97, 82, 101, 97, 100, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32,
    34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 50, 57, 50, 52, 48,
    54, 54, 51, 51, 52, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 73,
    102, 32, 119, 101, 32, 107, 110, 111, 119, 32, 116, 104, 97, 116, 32, 97, 32, 77, 83, 65, 65, 32, 115, 116, 101,
    110, 99, 105, 108, 32, 97, 115, 112, 101, 99, 116, 32, 105, 115, 110, 39, 116, 32, 114, 101, 97, 100, 32, 97, 115,
    32, 97, 32, 115, 104, 97, 100, 101, 114, 32, 114, 101, 115, 111, 117, 114, 99, 101, 44, 32, 103, 105, 118, 101, 32,
    80, 65, 76, 32, 97, 32, 104, 105, 110, 116, 32, 116, 104, 97, 116, 32, 105, 116, 39, 115, 32, 111, 107, 97, 121, 32,
    116, 111, 32, 99, 104, 111, 111, 115, 101, 32, 97, 32, 110, 111, 110, 45, 84, 67, 67, 32, 102, 111, 114, 109, 97,
    116, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 79, 112, 116, 105, 109, 105, 122, 97, 116, 105, 111,
    110, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116,
    34, 58, 32, 102, 97, 108, 115, 101, 125, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44,
    32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 100, 105, 115, 97, 98, 108, 101, 77,
    115, 97, 97, 83, 116, 101, 110, 99, 105, 108, 83, 104, 97, 100, 101, 114, 82, 101, 97, 100, 34, 44, 32, 34, 78, 97,
    109, 101, 34, 58, 32, 34, 68, 105, 115, 97, 98, 108, 101, 77, 115, 97, 97, 83, 116, 101, 110, 99, 105, 108, 83, 104,
    97, 100, 101, 114, 82, 101, 97, 100, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101,
    114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 56, 51, 57, 56, 55, 53, 57, 57, 56, 125, 44,
    32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 70, 111, 114, 32, 105, 109, 97,
    103, 101, 32, 99, 114, 101, 97, 116, 101, 100, 32, 119, 105, 116, 104, 32, 117, 115, 97, 103, 101, 32, 111, 102, 32,
    116, 114, 97, 110, 115, 102, 101, 114, 32, 115, 114, 99, 44, 32, 97, 100, 100, 32, 115, 104, 97, 100, 101, 114, 95,
    114, 101, 97, 100, 32, 105, 110, 32, 80, 65, 76, 32, 117, 115, 97, 103, 101, 32, 105, 102, 32, 86, 107, 73, 109, 97,
    103, 101, 85, 115, 97, 103, 101, 70, 108, 97, 103, 66, 105, 116, 115, 32, 105, 110, 32, 116, 104, 105, 115, 32, 109,
    97, 115, 107, 32, 105, 115, 32, 115, 101, 116, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 79, 112,
    116, 105, 109, 105, 122, 97, 116, 105, 111, 110, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58,
    32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 48, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32,
    34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34,
    44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 111, 112, 116, 73, 109, 103, 77,
    97, 115, 107, 84, 111, 65, 112, 112, 108, 121, 83, 104, 97, 100, 101, 114, 82, 101, 97, 100, 85, 115, 97, 103, 101,
    70, 111, 114, 84, 114, 97, 110, 115, 102, 101, 114, 83, 114, 99, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34,
    84, 114, 97, 110, 115, 102, 101, 114, 83, 114, 99, 85, 115, 97, 103, 101, 65, 115, 83, 104, 97, 100, 101, 114, 82,
    101, 97, 100, 77, 97, 115, 107, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 52, 50, 53, 52, 57,
    49, 57, 49, 57, 52, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 70,
    111, 114, 32, 105, 109, 97, 103, 101, 32, 99, 114, 101, 97, 116, 101, 100, 32, 119, 105, 116, 104, 32, 117, 115, 97,
    103, 101, 32, 111, 102, 32, 116, 114, 97, 110, 115, 102, 101, 114, 32, 100, 115, 116, 44, 32, 97, 100, 100, 32, 115,
    104, 97, 100, 101, 114, 95, 119, 114, 105, 116, 101, 32, 105, 110, 32, 80, 65, 76, 32, 117, 115, 97, 103, 101, 32,
    105, 102, 32, 86, 107, 73, 109, 97, 103, 101, 85, 115, 97, 103, 101, 70, 108, 97, 103, 66, 105, 116, 115, 32, 105,
    110, 32, 116, 104, 105, 115, 32, 109, 97, 115, 107, 32, 105, 115, 32, 115, 101, 116, 46, 34, 44, 32, 34, 84, 97,
    103, 115, 34, 58, 32, 91, 34, 79, 112, 116, 105, 109, 105, 122, 97, 116, 105, 111, 110, 34, 93, 44, 32, 34, 68, 101,
    102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 48, 125, 44, 32, 34,
    83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32,
    34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32,
    34, 111, 112, 116, 73, 109, 103, 77, 97, 115, 107, 84, 111, 65, 112, 112, 108, 121, 83, 104, 97, 100, 101, 114, 87,
    114, 105, 116, 101, 85, 115, 97, 103, 101, 70, 111, 114, 84, 114, 97, 110, 115, 102, 101, 114, 68, 115, 116, 34, 44,
    32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 84, 114, 97, 110, 115, 102, 101, 114, 68, 115, 116, 85, 115, 97, 103, 101,
    65, 115, 83, 104, 97, 100, 101, 114, 87, 114, 105, 116, 101, 77, 97, 115, 107, 34, 44, 32, 34, 72, 97, 115, 104, 78,
    97, 109, 101, 34, 58, 32, 51, 57, 52, 48, 51, 50, 48, 56, 50, 56, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105,
    112, 116, 105, 111, 110, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 32, 101, 120, 116, 101, 110, 115, 105, 111, 110,
    32, 65, 77, 68, 95, 71, 80, 85, 95, 83, 72, 65, 68, 69, 82, 95, 72, 65, 76, 70, 95, 70, 76, 79, 65, 84, 32, 97, 110,
    100, 32, 65, 77, 68, 95, 71, 80, 85, 95, 83, 72, 65, 68, 69, 82, 95, 73, 78, 84, 49, 54, 32, 111, 110, 108, 121, 32,
    111, 110, 32, 65, 83, 73, 67, 32, 62, 61, 32, 103, 102, 120, 57, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32,
    91, 34, 79, 112, 116, 105, 109, 105, 122, 97, 116, 105, 111, 110, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108,
    116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 116, 114, 117, 101, 125, 44, 32, 34, 84,
    121, 112, 101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109,
    101, 34, 58, 32, 34, 111, 112, 116, 79, 110, 108, 121, 69, 110, 97, 98, 108, 101, 70, 80, 49, 54, 70, 111, 114, 71,
    102, 120, 57, 80, 108, 117, 115, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 79, 110, 108, 121, 69, 110, 97,
    98, 108, 101, 70, 80, 49, 54, 70, 111, 114, 71, 102, 120, 57, 80, 108, 117, 115, 34, 44, 32, 34, 83, 99, 111, 112,
    101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32,
    52, 48, 53, 54, 55, 51, 50, 54, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58,
    32, 34, 73, 102, 32, 115, 101, 116, 44, 32, 97, 110, 32, 105, 109, 97, 103, 101, 32, 119, 105, 116, 104, 32, 99,
    111, 108, 111, 114, 32, 116, 97, 114, 103, 101, 116, 32, 117, 115, 97, 103, 101, 32, 98, 105, 116, 32, 100, 111,
    101, 115, 32, 110, 111, 116, 32, 105, 109, 112, 108, 105, 99, 105, 116, 108, 121, 32, 97, 108, 108, 111, 119, 32,
    116, 111, 32, 98, 101, 32, 105, 110, 32, 114, 101, 115, 111, 108, 118, 101, 95, 115, 114, 99, 32, 111, 114, 32, 114,
    101, 115, 111, 108, 118, 101, 95, 100, 115, 116, 32, 108, 97, 121, 111, 117, 116, 46, 34, 44, 32, 34, 84, 97, 103,
    115, 34, 58, 32, 91, 34, 79, 112, 116, 105, 109, 105, 122, 97, 116, 105, 111, 110, 34, 93, 44, 32, 34, 68, 101, 102,
    97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115, 101,
    125, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98,
    108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 111, 112, 116, 67, 111, 108, 111, 114, 84, 97, 114, 103, 101, 116, 85,
    115, 97, 103, 101, 68, 111, 101, 115, 78, 111, 116, 67, 111, 110, 116, 97, 105, 110, 82, 101, 115, 111, 108, 118,
    101, 76, 97, 121, 111, 117, 116, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 67, 111, 108, 111, 114, 84, 97,
    114, 103, 101, 116, 85, 115, 97, 103, 101, 68, 111, 101, 115, 78, 111, 116, 67, 111, 110, 116, 97, 105, 110, 82,
    101, 115, 111, 108, 118, 101, 76, 97, 121, 111, 117, 116, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68,
    114, 105, 118, 101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 53, 50, 51, 53, 51, 57, 55,
    53, 54, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 82, 101, 110, 100, 101, 114, 83, 116, 97, 116, 101,
    67, 97, 99, 104, 101, 69, 110, 97, 98, 108, 101, 34, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111,
    110, 34, 58, 32, 34, 84, 104, 105, 115, 32, 98, 105, 116, 109, 97, 115, 107, 32, 100, 101, 110, 111, 116, 101, 115,
    32, 119, 104, 105, 99, 104, 32, 115, 117, 98, 115, 101, 116, 32, 111, 102, 32, 112, 105, 112, 101, 108, 105, 110,
    101, 32, 114, 101, 110, 100, 101, 114, 32, 115, 116, 97, 116, 101, 32, 105, 115, 32, 99, 97, 99, 104, 101, 100, 32,
    97, 116, 32, 116, 104, 101, 32, 100, 101, 118, 105, 99, 101, 45, 108, 101, 118, 101, 108, 46, 32, 67, 97, 99, 104,
    105, 110, 103, 32, 114, 101, 110, 100, 101, 114, 32, 115, 116, 97, 116, 101, 32, 101, 110, 97, 98, 108, 101, 115,
    32, 109, 111, 114, 101, 32, 101, 102, 102, 105, 99, 105, 101, 110, 116, 32, 114, 101, 100, 117, 110, 100, 97, 110,
    99, 121, 32, 99, 104, 101, 99, 107, 105, 110, 103, 32, 119, 104, 101, 110, 32, 114, 101, 99, 111, 114, 100, 105,
    110, 103, 32, 99, 111, 109, 109, 97, 110, 100, 32, 98, 117, 102, 102, 101, 114, 115, 46, 32, 32, 84, 104, 105, 115,
    32, 114, 101, 100, 117, 110, 100, 97, 110, 99, 121, 32, 99, 104, 101, 99, 107, 105, 110, 103, 32, 105, 115, 32, 109,
    97, 105, 110, 108, 121, 32, 108, 105, 109, 105, 116, 101, 100, 32, 116, 111, 32, 112, 105, 112, 101, 108, 105, 110,
    101, 32, 115, 116, 97, 116, 101, 32, 116, 104, 97, 116, 32, 105, 115, 32, 101, 105, 116, 104, 101, 114, 32, 105,
    110, 118, 105, 115, 105, 98, 108, 101, 32, 116, 111, 32, 116, 104, 101, 32, 65, 80, 73, 32, 40, 101, 46, 103, 46,
    32, 99, 101, 114, 116, 97, 105, 110, 32, 80, 65, 76, 32, 111, 98, 106, 101, 99, 116, 115, 41, 32, 111, 114, 32, 115,
    116, 97, 116, 101, 32, 116, 104, 97, 116, 32, 116, 104, 101, 32, 97, 112, 112, 108, 105, 99, 97, 116, 105, 111, 110,
    32, 104, 97, 115, 32, 109, 97, 114, 107, 101, 100, 32, 105, 110, 32, 116, 104, 101, 32, 112, 105, 112, 101, 108,
    105, 110, 101, 32, 97, 115, 32, 110, 111, 110, 45, 100, 121, 110, 97, 109, 105, 99, 44, 32, 109, 101, 97, 110, 105,
    110, 103, 32, 105, 116, 115, 32, 118, 97, 108, 117, 101, 115, 32, 97, 114, 101, 32, 112, 114, 111, 103, 114, 97,
    109, 109, 101, 100, 32, 100, 117, 114, 105, 110, 103, 32, 112, 105, 112, 101, 108, 105, 110, 101, 32, 98, 105, 110,
    100, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 79, 112, 116, 105, 109, 105, 122, 97, 116, 105, 111,
    110, 34, 93, 44, 32, 34, 70, 108, 97, 103, 115, 34, 58, 32, 123, 34, 73, 115, 72, 101, 120, 34, 58, 32, 116, 114,
    117, 101, 44, 32, 34, 73, 115, 66, 105, 116, 109, 97, 115, 107, 34, 58, 32, 116, 114, 117, 101, 125, 44, 32, 34, 68,
    101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 52, 50, 57, 52,
    57, 54, 55, 50, 57, 53, 125, 44, 32, 34, 86, 97, 108, 105, 100, 86, 97, 108, 117, 101, 115, 34, 58, 32, 123, 34, 86,
    97, 108, 117, 101, 115, 34, 58, 32, 91, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 79, 112, 116, 82, 101, 110, 100,
    101, 114, 83, 116, 97, 116, 101, 67, 97, 99, 104, 101, 77, 115, 97, 97, 83, 116, 97, 116, 101, 34, 44, 32, 34, 86,
    97, 108, 117, 101, 34, 58, 32, 49, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34,
    80, 65, 76, 32, 77, 83, 65, 65, 32, 115, 116, 97, 116, 101, 32, 111, 98, 106, 101, 99, 116, 115, 32, 40, 97, 108,
    108, 32, 103, 114, 97, 112, 104, 105, 99, 115, 32, 112, 105, 112, 101, 108, 105, 110, 101, 115, 41, 34, 125, 44, 32,
    123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 79, 112, 116, 82, 101, 110, 100, 101, 114, 83, 116, 97, 116, 101, 67, 97,
    99, 104, 101, 67, 111, 108, 111, 114, 66, 108, 101, 110, 100, 83, 116, 97, 116, 101, 34, 44, 32, 34, 86, 97, 108,
    117, 101, 34, 58, 32, 50, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 80, 65,
    76, 32, 99, 111, 108, 111, 114, 32, 98, 108, 101, 110, 100, 32, 115, 116, 97, 116, 101, 32, 111, 98, 106, 101, 99,
    116, 115, 32, 40, 97, 108, 108, 32, 103, 114, 97, 112, 104, 105, 99, 115, 32, 112, 105, 112, 101, 108, 105, 110,
    101, 115, 41, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 79, 112, 116, 82, 101, 110, 100, 101, 114,
    83, 116, 97, 116, 101, 67, 97, 99, 104, 101, 68, 101, 112, 116, 104, 83, 116, 101, 110, 99, 105, 108, 83, 116, 97,
    116, 101, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 52, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116,
    105, 111, 110, 34, 58, 32, 34, 80, 65, 76, 32, 100, 101, 112, 116, 104, 32, 115, 116, 101, 110, 99, 105, 108, 32,
    115, 116, 97, 116, 101, 32, 111, 98, 106, 101, 99, 116, 115, 32, 40, 97, 108, 108, 32, 103, 114, 97, 112, 104, 105,
    99, 115, 32, 112, 105, 112, 101, 108, 105, 110, 101, 115, 41, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58,
    32, 34, 79, 112, 116, 82, 101, 110, 100, 101, 114, 83, 116, 97, 116, 101, 67, 97, 99, 104, 101, 73, 110, 112, 117,
    116, 65, 115, 115, 101, 109, 98, 108, 121, 83, 116, 97, 116, 101, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32,
    56, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 80, 65, 76, 32, 105, 110, 112,
    117, 116, 32, 97, 115, 115, 101, 109, 98, 108, 121, 32, 115, 116, 97, 116, 101, 32, 112, 97, 114, 97, 109, 115, 32,
    40, 97, 108, 108, 32, 103, 114, 97, 112, 104, 105, 99, 115, 32, 112, 105, 112, 101, 108, 105, 110, 101, 115, 41, 34,
    125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 79, 112, 116, 82, 101, 110, 100, 101, 114, 83, 116, 97, 116,
    101, 67, 97, 99, 104, 101, 84, 114, 105, 97, 110, 103, 108, 101, 82, 97, 115, 116, 101, 114, 83, 116, 97, 116, 101,
    34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 54, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105,
    111, 110, 34, 58, 32, 34, 84, 114, 105, 97, 110, 103, 108, 101, 32, 114, 97, 115, 116, 101, 114, 32, 115, 116, 97,
    116, 101, 32, 112, 97, 114, 97, 109, 115, 32, 40, 112, 97, 114, 116, 32, 111, 102, 32, 101, 118, 101, 114, 121, 32,
    103, 114, 97, 112, 104, 105, 99, 115, 32, 112, 105, 112, 101, 108, 105, 110, 101, 41, 34, 125, 44, 32, 123, 34, 78,
    97, 109, 101, 34, 58, 32, 34, 79, 112, 116, 82, 101, 110, 100, 101, 114, 83, 116, 97, 116, 101, 67, 97, 99, 104,
    101, 83, 116, 97, 116, 105, 99, 80, 111, 105, 110, 116, 76, 105, 110, 101, 82, 97, 115, 116, 101, 114, 83, 116, 97,
    116, 101, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 51, 50, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112,
    116, 105, 111, 110, 34, 58, 32, 34, 80, 111, 105, 110, 116, 32, 108, 105, 110, 101, 32, 114, 97, 115, 116, 101, 114,
    32, 115, 116, 97, 116, 101, 32, 40, 111, 110, 108, 121, 32, 119, 104, 101, 110, 32, 109, 97, 114, 107, 101, 100, 32,
    115, 116, 97, 116, 105, 99, 41, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 79, 112, 116, 82, 101,
    110, 100, 101, 114, 83, 116, 97, 116, 101, 67, 97, 99, 104, 101, 83, 116, 97, 116, 105, 99, 68, 101, 112, 116, 104,
    66, 105, 97, 115, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 54, 52, 44, 32, 34, 68, 101, 115, 99, 114, 105,
    112, 116, 105, 111, 110, 34, 58, 32, 34, 68, 101, 112, 116, 104, 32, 98, 105, 97, 115, 32, 115, 116, 97, 116, 101,
    32, 40, 111, 110, 108, 121, 32, 119, 104, 101, 110, 32, 109, 97, 114, 107, 101, 100, 32, 115, 116, 97, 116, 105, 99,
    41, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 79, 112, 116, 82, 101, 110, 100, 101, 114, 83, 116,
    97, 116, 101, 67, 97, 99, 104, 101, 83, 116, 97, 116, 105, 99, 66, 108, 101, 110, 100, 67, 111, 110, 115, 116, 34,
    44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 50, 56, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105,
    111, 110, 34, 58, 32, 34, 66, 108, 101, 110, 100, 32, 99, 111, 110, 115, 116, 32, 115, 116, 97, 116, 101, 32, 40,
    111, 110, 108, 121, 32, 119, 104, 101, 110, 32, 109, 97, 114, 107, 101, 100, 32, 115, 116, 97, 116, 105, 99, 41, 34,
    125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 79, 112, 116, 82, 101, 110, 100, 101, 114, 83, 116, 97, 116,
    101, 67, 97, 99, 104, 101, 83, 116, 97, 116, 105, 99, 68, 101, 112, 116, 104, 66, 111, 117, 110, 100, 115, 34, 44,
    32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 50, 53, 54, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111,
    110, 34, 58, 32, 34, 68, 101, 112, 116, 104, 32, 98, 111, 117, 110, 100, 115, 32, 115, 116, 97, 116, 101, 32, 40,
    111, 110, 108, 121, 32, 119, 104, 101, 110, 32, 109, 97, 114, 107, 101, 100, 32, 115, 116, 97, 116, 105, 99, 41, 34,
    125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 79, 112, 116, 82, 101, 110, 100, 101, 114, 83, 116, 97, 116,
    101, 67, 97, 99, 104, 101, 83, 116, 97, 116, 105, 99, 86, 105, 101, 119, 112, 111, 114, 116, 34, 44, 32, 34, 86, 97,
    108, 117, 101, 34, 58, 32, 53, 49, 50, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32,
    34, 86, 105, 101, 119, 112, 111, 114, 116, 32, 115, 116, 97, 116, 101, 32, 40, 111, 110, 108, 121, 32, 119, 104,
    101, 110, 32, 109, 97, 114, 107, 101, 100, 32, 115, 116, 97, 116, 105, 99, 41, 34, 125, 44, 32, 123, 34, 78, 97,
    109, 101, 34, 58, 32, 34, 79, 112, 116, 82, 101, 110, 100, 101, 114, 83, 116, 97, 116, 101, 67, 97, 99, 104, 101,
    83, 116, 97, 116, 105, 99, 83, 99, 105, 115, 115, 111, 114, 82, 101, 99, 116, 34, 44, 32, 34, 86, 97, 108, 117, 101,
    34, 58, 32, 49, 48, 50, 52, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 83, 99,
    105, 115, 115, 111, 114, 32, 114, 101, 99, 116, 32, 115, 116, 97, 116, 101, 32, 40, 111, 110, 108, 121, 32, 119,
    104, 101, 110, 32, 109, 97, 114, 107, 101, 100, 32, 115, 116, 97, 116, 105, 99, 41, 34, 125, 93, 125, 44, 32, 34,
    83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32,
    34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32,
    34, 111, 112, 116, 82, 101, 110, 100, 101, 114, 83, 116, 97, 116, 101, 67, 97, 99, 104, 101, 69, 110, 97, 98, 108,
    101, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 51, 49, 48, 55, 54, 57, 50, 53, 56, 55, 125,
    44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 73, 102, 32, 115, 101, 116,
    44, 32, 116, 104, 101, 32, 77, 85, 84, 65, 66, 76, 69, 32, 102, 108, 97, 103, 32, 111, 110, 32, 105, 109, 97, 103,
    101, 32, 105, 115, 32, 105, 103, 110, 111, 114, 101, 100, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34,
    79, 112, 116, 105, 109, 105, 122, 97, 116, 105, 111, 110, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115,
    34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115, 101, 125, 44, 32, 34, 84, 121,
    112, 101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101,
    34, 58, 32, 34, 105, 103, 110, 111, 114, 101, 77, 117, 116, 97, 98, 108, 101, 70, 108, 97, 103, 34, 44, 32, 34, 78,
    97, 109, 101, 34, 58, 32, 34, 73, 103, 110, 111, 114, 101, 77, 117, 116, 97, 98, 108, 101, 70, 108, 97, 103, 34, 44,
    32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78,
    97, 109, 101, 34, 58, 32, 54, 54, 57, 55, 57, 52, 56, 48, 57, 125, 44, 32, 123, 34, 86, 97, 108, 105, 100, 86, 97,
    108, 117, 101, 115, 34, 58, 32, 123, 34, 73, 115, 69, 110, 117, 109, 34, 58, 32, 116, 114, 117, 101, 44, 32, 34, 86,
    97, 108, 117, 101, 115, 34, 58, 32, 91, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 79,
    112, 116, 105, 109, 105, 122, 101, 70, 111, 114, 82, 101, 110, 100, 101, 114, 80, 97, 115, 115, 67, 111, 110, 116,
    105, 110, 117, 101, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 48, 44, 32, 34, 68, 101, 115, 99, 114, 105,
    112, 116, 105, 111, 110, 34, 58, 32, 34, 79, 112, 116, 105, 109, 105, 122, 101, 67, 109, 100, 98, 117, 102, 32, 119,
    105, 108, 108, 32, 98, 101, 32, 101, 110, 97, 98, 108, 101, 100, 32, 111, 110, 108, 121, 32, 102, 111, 114, 32, 114,
    101, 110, 100, 101, 114, 32, 112, 97, 115, 115, 32, 99, 111, 110, 116, 105, 110, 117, 101, 46, 34, 125, 44, 32, 123,
    34, 78, 97, 109, 101, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 79, 112, 116, 105, 109, 105, 122, 101, 67, 109,
    100, 98, 117, 102, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 44, 32, 34, 68, 101, 115, 99, 114, 105,
    112, 116, 105, 111, 110, 34, 58, 32, 34, 79, 112, 116, 105, 109, 105, 122, 101, 67, 109, 100, 98, 117, 102, 32, 119,
    105, 108, 108, 32, 98, 101, 32, 97, 108, 119, 97, 121, 115, 32, 101, 110, 97, 98, 108, 101, 100, 46, 34, 125, 44,
    32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 105, 115, 97, 98, 108, 101, 79, 112, 116, 105, 109, 105, 122,
    101, 67, 109, 100, 98, 117, 102, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 50, 44, 32, 34, 68, 101, 115,
    99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 79, 112, 116, 105, 109, 105, 122, 101, 67, 109, 100, 98, 117,
    102, 32, 119, 105, 108, 108, 32, 98, 101, 32, 100, 105, 115, 97, 98, 108, 101, 100, 46, 34, 125, 93, 44, 32, 34, 78,
    97, 109, 101, 34, 58, 32, 34, 79, 112, 116, 105, 109, 105, 122, 101, 67, 109, 100, 98, 117, 102, 77, 111, 100, 101,
    34, 125, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 79, 112, 116, 105, 109,
    105, 122, 101, 67, 109, 100, 98, 117, 102, 77, 111, 100, 101, 32, 100, 101, 110, 111, 116, 101, 115, 32, 119, 104,
    101, 116, 104, 101, 114, 32, 112, 109, 52, 32, 111, 112, 116, 105, 109, 105, 122, 97, 116, 105, 111, 110, 115, 32,
    119, 105, 108, 108, 32, 98, 101, 32, 101, 110, 97, 98, 108, 101, 100, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58,
    32, 91, 34, 79, 112, 116, 105, 109, 105, 122, 97, 116, 105, 111, 110, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117,
    108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 34, 68, 105, 115, 97, 98, 108, 101,
    79, 112, 116, 105, 109, 105, 122, 101, 67, 109, 100, 98, 117, 102, 34, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34,
    58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 101, 110, 117, 109, 34,
    44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 111, 112, 116, 105, 109, 105, 122,
    101, 67, 109, 100, 98, 117, 102, 77, 111, 100, 101, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 79, 112, 116,
    105, 109, 105, 122, 101, 67, 109, 100, 98, 117, 102, 77, 111, 100, 101, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97,
    109, 101, 34, 58, 32, 51, 56, 52, 55, 53, 54, 54, 48, 56, 56, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112,
    116, 105, 111, 110, 34, 58, 32, 34, 73, 102, 32, 115, 101, 116, 44, 32, 115, 104, 97, 100, 101, 114, 115, 32, 97,
    114, 101, 32, 112, 114, 101, 102, 101, 116, 99, 104, 101, 100, 32, 116, 111, 32, 119, 97, 114, 109, 32, 76, 50, 32,
    115, 104, 97, 100, 101, 114, 32, 99, 97, 99, 104, 101, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 79,
    112, 116, 105, 109, 105, 122, 97, 116, 105, 111, 110, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34,
    58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115, 101, 125, 44, 32, 34, 84, 121, 112,
    101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34,
    58, 32, 34, 112, 114, 101, 102, 101, 116, 99, 104, 83, 104, 97, 100, 101, 114, 115, 34, 44, 32, 34, 78, 97, 109,
    101, 34, 58, 32, 34, 80, 114, 101, 102, 101, 116, 99, 104, 83, 104, 97, 100, 101, 114, 115, 34, 44, 32, 34, 83, 99,
    111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34,
    58, 32, 49, 55, 57, 49, 57, 50, 48, 48, 57, 54, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105,
    111, 110, 34, 58, 32, 34, 73, 102, 32, 110, 111, 116, 32, 85, 73, 78, 84, 95, 77, 65, 88, 44, 32, 115, 101, 116,
    115, 32, 116, 104, 101, 32, 109, 105, 110, 105, 109, 117, 109, 32, 66, 80, 80, 32, 111, 102, 32, 115, 117, 114, 102,
    97, 99, 101, 115, 32, 119, 104, 105, 99, 104, 32, 109, 97, 121, 32, 104, 97, 118, 101, 32, 68, 67, 67, 32, 101, 110,
    97, 98, 108, 101, 100, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 79, 112, 116, 105, 109, 105, 122,
    97, 116, 105, 111, 110, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102,
    97, 117, 108, 116, 34, 58, 32, 52, 50, 57, 52, 57, 54, 55, 50, 57, 53, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34,
    58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51,
    50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 100, 99, 99, 66, 105, 116,
    115, 80, 101, 114, 80, 105, 120, 101, 108, 84, 104, 114, 101, 115, 104, 111, 108, 100, 34, 44, 32, 34, 78, 97, 109,
    101, 34, 58, 32, 34, 68, 99, 99, 66, 105, 116, 115, 80, 101, 114, 80, 105, 120, 101, 108, 84, 104, 114, 101, 115,
    104, 111, 108, 100, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 50, 54, 54, 56, 51, 52, 48, 50,
    57, 53, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 70, 111, 114, 99, 101, 68, 99, 99, 70, 111, 114, 67,
    111, 108, 111, 114, 65, 116, 116, 97, 99, 104, 109, 101, 110, 116, 115, 34, 44, 32, 34, 68, 101, 115, 99, 114, 105,
    112, 116, 105, 111, 110, 34, 58, 32, 34, 84, 104, 105, 115, 32, 105, 115, 32, 97, 32, 104, 105, 110, 116, 32, 102,
    111, 114, 32, 80, 65, 76, 32, 116, 111, 32, 105, 103, 110, 111, 114, 101, 32, 97, 110, 121, 32, 112, 101, 114, 102,
    111, 114, 109, 97, 110, 99, 101, 32, 104, 117, 101, 114, 105, 115, 116, 105, 99, 115, 32, 119, 104, 101, 110, 32,
    100, 101, 116, 101, 114, 109, 105, 110, 105, 110, 103, 32, 105, 102, 32, 105, 109, 97, 103, 101, 115, 32, 119, 105,
    116, 104, 32, 99, 111, 108, 111, 114, 32, 97, 116, 116, 97, 99, 104, 109, 101, 110, 116, 32, 117, 115, 97, 103, 101,
    32, 103, 101, 116, 32, 68, 67, 67, 46, 32, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 79, 112, 116, 105,
    109, 105, 122, 97, 116, 105, 111, 110, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123,
    34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115, 101, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34,
    58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 98, 111, 111, 108, 34,
    44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 102, 111, 114, 99, 101, 68, 99,
    99, 70, 111, 114, 67, 111, 108, 111, 114, 65, 116, 116, 97, 99, 104, 109, 101, 110, 116, 115, 34, 44, 32, 34, 72,
    97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 51, 48, 52, 54, 54, 54, 53, 52, 55, 52, 125, 44, 32, 123, 34, 78, 97,
    109, 101, 34, 58, 32, 34, 68, 105, 115, 97, 98, 108, 101, 83, 109, 97, 108, 108, 83, 117, 114, 102, 67, 111, 108,
    111, 114, 67, 111, 109, 112, 114, 101, 115, 115, 105, 111, 110, 83, 105, 122, 101, 34, 44, 32, 34, 68, 101, 115, 99,
    114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 80, 114, 111, 118, 105, 100, 101, 115, 32, 97, 32, 104, 105, 110,
    116, 32, 116, 111, 32, 80, 65, 76, 32, 116, 104, 97, 116, 32, 80, 65, 76, 32, 115, 104, 111, 117, 108, 100, 32, 100,
    105, 115, 97, 98, 108, 101, 32, 99, 111, 108, 111, 114, 32, 99, 111, 109, 112, 114, 101, 115, 115, 105, 111, 110,
    32, 111, 110, 32, 115, 117, 114, 102, 97, 99, 101, 115, 32, 116, 104, 97, 116, 32, 97, 114, 101, 32, 115, 109, 97,
    108, 108, 101, 114, 32, 116, 104, 97, 110, 32, 111, 114, 32, 101, 113, 117, 97, 108, 32, 116, 111, 32, 116, 104,
    105, 115, 32, 115, 101, 116, 116, 105, 110, 103, 32, 40, 115, 101, 116, 116, 105, 110, 103, 32, 42, 32, 115, 101,
    116, 116, 105, 110, 103, 41, 32, 105, 110, 32, 115, 105, 122, 101, 46, 32, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58,
    32, 91, 34, 79, 112, 116, 105, 109, 105, 122, 97, 116, 105, 111, 110, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117,
    108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 49, 50, 56, 125, 44, 32, 34, 83,
    99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34,
    117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34,
    100, 105, 115, 97, 98, 108, 101, 83, 109, 97, 108, 108, 83, 117, 114, 102, 67, 111, 108, 111, 114, 67, 111, 109,
    112, 114, 101, 115, 115, 105, 111, 110, 83, 105, 122, 101, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34,
    58, 32, 50, 48, 55, 53, 50, 48, 52, 50, 50, 48, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 69, 110, 97,
    98, 108, 101, 71, 112, 117, 69, 118, 101, 110, 116, 77, 117, 108, 116, 105, 83, 108, 111, 116, 34, 44, 32, 34, 68,
    101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 32, 109, 117, 108, 116,
    105, 112, 108, 101, 32, 115, 108, 111, 116, 115, 32, 105, 110, 115, 116, 101, 97, 100, 32, 111, 102, 32, 115, 105,
    110, 103, 108, 101, 32, 68, 87, 79, 82, 68, 32, 115, 108, 111, 116, 32, 102, 111, 114, 32, 71, 80, 85, 32, 101, 118,
    101, 110, 116, 46, 32, 84, 104, 105, 115, 32, 119, 105, 108, 108, 32, 101, 110, 97, 98, 108, 101, 32, 97, 110, 121,
    119, 104, 101, 114, 101, 32, 116, 104, 97, 116, 32, 99, 97, 110, 32, 117, 116, 105, 108, 105, 122, 101, 32, 109,
    117, 108, 116, 105, 112, 108, 101, 32, 101, 118, 101, 110, 116, 32, 115, 108, 111, 116, 115, 32, 102, 111, 114, 32,
    111, 112, 116, 105, 109, 105, 122, 97, 116, 105, 111, 110, 32, 111, 114, 32, 102, 101, 97, 116, 117, 114, 101, 32,
    112, 117, 114, 112, 111, 115, 101, 44, 32, 115, 117, 99, 104, 32, 97, 115, 32, 65, 99, 113, 82, 101, 108, 66, 97,
    114, 114, 105, 101, 114, 32, 105, 110, 116, 101, 114, 102, 97, 99, 101, 46, 32, 34, 44, 32, 34, 84, 97, 103, 115,
    34, 58, 32, 91, 34, 79, 112, 116, 105, 109, 105, 122, 97, 116, 105, 111, 110, 34, 93, 44, 32, 34, 68, 101, 102, 97,
    117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115, 101, 125,
    44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101,
    34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32,
    34, 101, 110, 97, 98, 108, 101, 71, 112, 117, 69, 118, 101, 110, 116, 77, 117, 108, 116, 105, 83, 108, 111, 116, 34,
    44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 49, 52, 48, 55, 49, 49, 52, 57, 52, 57, 125, 44, 32,
    123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 85, 115, 101, 65, 99, 113, 82, 101, 108, 73, 110, 116, 101, 114, 102, 97,
    99, 101, 34, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 84, 104, 101, 32, 97,
    99, 113, 117, 105, 114, 101, 47, 114, 101, 108, 101, 97, 115, 101, 45, 98, 97, 115, 101, 100, 32, 98, 97, 114, 114,
    105, 101, 114, 32, 105, 110, 116, 101, 114, 102, 97, 99, 101, 32, 105, 115, 32, 101, 110, 97, 98, 108, 101, 100, 46,
    32, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 79, 112, 116, 105, 109, 105, 122, 97, 116, 105, 111, 110,
    34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34,
    58, 32, 102, 97, 108, 115, 101, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114,
    34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108,
    101, 78, 97, 109, 101, 34, 58, 32, 34, 117, 115, 101, 65, 99, 113, 82, 101, 108, 73, 110, 116, 101, 114, 102, 97,
    99, 101, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 53, 56, 55, 56, 56, 49, 55, 52, 57, 125,
    44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 83, 80, 80, 34, 44, 32, 34, 68, 101,
    115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 32, 83, 104, 97, 100, 101,
    114, 32, 80, 114, 111, 102, 105, 108, 105, 110, 103, 32, 102, 111, 114, 32, 80, 111, 119, 101, 114, 32, 40, 83, 80,
    80, 41, 46, 32, 32, 84, 104, 101, 32, 103, 105, 115, 116, 32, 111, 102, 32, 116, 104, 101, 32, 105, 110, 105, 116,
    105, 97, 108, 32, 118, 101, 114, 115, 105, 111, 110, 32, 111, 102, 32, 116, 104, 105, 115, 32, 102, 101, 97, 116,
    117, 114, 101, 32, 105, 115, 32, 116, 104, 97, 116, 32, 119, 101, 32, 119, 105, 108, 108, 32, 112, 114, 111, 102,
    105, 108, 101, 32, 105, 109, 112, 111, 114, 116, 97, 110, 116, 32, 32, 97, 112, 112, 108, 105, 99, 97, 116, 105,
    111, 110, 115, 32, 116, 111, 32, 100, 101, 116, 101, 114, 109, 105, 110, 101, 32, 119, 104, 105, 99, 104, 32, 115,
    104, 97, 100, 101, 114, 115, 32, 97, 114, 101, 32, 104, 101, 97, 118, 105, 108, 121, 32, 109, 101, 109, 111, 114,
    121, 32, 98, 111, 117, 110, 100, 44, 32, 116, 104, 101, 110, 32, 117, 115, 101, 32, 116, 104, 101, 115, 101, 32,
    112, 114, 111, 102, 105, 108, 101, 115, 32, 32, 116, 111, 32, 112, 114, 111, 103, 114, 97, 109, 32, 116, 104, 101,
    32, 82, 76, 67, 32, 116, 111, 32, 100, 121, 110, 97, 109, 105, 99, 97, 108, 108, 121, 32, 114, 101, 100, 117, 99,
    101, 32, 101, 110, 103, 105, 110, 101, 32, 99, 108, 111, 99, 107, 115, 32, 119, 104, 101, 110, 32, 114, 117, 110,
    110, 105, 110, 103, 32, 115, 117, 99, 104, 32, 115, 104, 97, 100, 101, 114, 115, 46, 84, 104, 105, 115, 32, 32, 115,
    104, 111, 117, 108, 100, 32, 114, 101, 115, 117, 108, 116, 32, 105, 110, 32, 112, 111, 119, 101, 114, 32, 115, 97,
    118, 105, 110, 103, 115, 32, 119, 105, 116, 104, 32, 97, 32, 108, 105, 109, 105, 116, 101, 100, 32, 112, 101, 114,
    102, 32, 105, 109, 112, 97, 99, 116, 46, 32, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 79, 112, 116,
    105, 109, 105, 122, 97, 116, 105, 111, 110, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32,
    123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 116, 114, 117, 101, 125, 44, 32, 34, 84, 121, 112, 101, 34,
    58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34,
    101, 110, 97, 98, 108, 101, 83, 80, 80, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118,
    101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 50, 52, 51, 55, 57, 56, 49, 50, 52, 55,
    125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 77, 108, 77, 111, 100, 101, 108,
    70, 111, 114, 87, 97, 118, 101, 83, 105, 122, 101, 34, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111,
    110, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 32, 97, 32, 109, 97, 99, 104, 105, 110, 101, 32, 108, 101, 97, 114,
    110, 105, 110, 103, 32, 109, 111, 100, 101, 108, 32, 116, 111, 32, 111, 112, 116, 105, 109, 97, 108, 108, 121, 32,
    99, 104, 111, 111, 115, 101, 32, 87, 97, 118, 101, 54, 52, 32, 111, 114, 32, 87, 97, 118, 101, 51, 50, 32, 105, 110,
    115, 116, 101, 97, 100, 32, 111, 102, 32, 114, 101, 108, 121, 105, 110, 103, 32, 111, 110, 32, 112, 101, 114, 32,
    115, 104, 97, 100, 101, 114, 32, 115, 116, 97, 103, 101, 32, 100, 101, 102, 97, 117, 108, 116, 115, 46, 32, 67, 117,
    114, 114, 101, 110, 116, 108, 121, 44, 32, 111, 110, 108, 121, 32, 102, 114, 97, 103, 109, 101, 110, 116, 32, 115,
    104, 97, 100, 101, 114, 115, 32, 97, 114, 101, 32, 97, 102, 102, 101, 99, 116, 101, 100, 32, 97, 110, 100, 32, 99,
    111, 109, 112, 105, 108, 97, 116, 105, 111, 110, 32, 116, 105, 109, 101, 115, 32, 119, 105, 108, 108, 32, 98, 101,
    32, 108, 111, 110, 103, 101, 114, 46, 32, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 79, 112, 116, 105,
    109, 105, 122, 97, 116, 105, 111, 110, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123,
    34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115, 101, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34,
    58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 98, 111, 111, 108, 34,
    44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 101, 110, 97, 98, 108, 101, 77,
    108, 77, 111, 100, 101, 108, 70, 111, 114, 87, 97, 118, 101, 83, 105, 122, 101, 34, 44, 32, 34, 72, 97, 115, 104,
    78, 97, 109, 101, 34, 58, 32, 57, 49, 53, 50, 53, 56, 50, 57, 57, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105,
    112, 116, 105, 111, 110, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 32, 97, 115, 121, 110, 99, 32, 99, 111, 109,
    112, 105, 108, 101, 32, 102, 111, 114, 32, 115, 104, 97, 100, 101, 114, 32, 109, 111, 100, 117, 108, 101, 32, 97,
    110, 100, 32, 112, 105, 112, 101, 108, 105, 110, 101, 115, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34,
    79, 112, 116, 105, 109, 105, 122, 97, 116, 105, 111, 110, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115,
    34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115, 101, 125, 44, 32, 34, 83, 99,
    111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 98,
    111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 101, 110, 97,
    98, 108, 101, 65, 115, 121, 110, 99, 67, 111, 109, 112, 105, 108, 101, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32,
    34, 69, 110, 97, 98, 108, 101, 65, 115, 121, 110, 99, 67, 111, 109, 112, 105, 108, 101, 34, 44, 32, 34, 72, 97, 115,
    104, 78, 97, 109, 101, 34, 58, 32, 52, 48, 54, 52, 49, 49, 55, 50, 49, 49, 125, 44, 32, 123, 34, 68, 101, 115, 99,
    114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 83, 101, 116, 116, 105, 110, 103, 32, 116, 111, 32, 102, 97, 108,
    115, 101, 32, 101, 110, 97, 98, 108, 101, 115, 32, 97, 110, 32, 111, 112, 116, 105, 109, 105, 122, 97, 116, 105,
    111, 110, 32, 105, 110, 32, 80, 65, 76, 32, 116, 104, 97, 116, 32, 100, 105, 115, 114, 101, 103, 97, 114, 100, 115,
    32, 116, 104, 101, 32, 70, 67, 69, 32, 105, 110, 32, 97, 32, 116, 114, 97, 110, 115, 105, 116, 105, 111, 110, 32,
    105, 102, 32, 111, 110, 101, 32, 111, 102, 32, 116, 104, 101, 32, 98, 117, 105, 108, 116, 32, 105, 110, 32, 99, 108,
    101, 97, 114, 32, 99, 111, 108, 111, 114, 115, 32, 97, 114, 101, 32, 117, 115, 101, 100, 32, 40, 119, 104, 105, 116,
    101, 47, 98, 108, 97, 99, 107, 41, 32, 97, 110, 100, 32, 116, 104, 101, 32, 105, 109, 97, 103, 101, 32, 105, 115,
    32, 84, 67, 67, 32, 99, 111, 109, 112, 97, 116, 105, 98, 108, 101, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32,
    91, 34, 79, 112, 116, 105, 109, 105, 122, 97, 116, 105, 111, 110, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108,
    116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115, 101, 125, 44, 32, 34,
    83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32,
    34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 100,
    105, 115, 97, 98, 108, 101, 83, 107, 105, 112, 70, 99, 101, 79, 112, 116, 105, 109, 105, 122, 97, 116, 105, 111,
    110, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 105, 115, 97, 98, 108, 101, 83, 107, 105, 112, 70, 99,
    101, 79, 112, 116, 105, 109, 105, 122, 97, 116, 105, 111, 110, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101,
    34, 58, 32, 51, 48, 51, 49, 54, 52, 54, 57, 51, 53, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105,
    111, 110, 34, 58, 32, 34, 68, 101, 116, 101, 114, 109, 105, 110, 101, 115, 32, 116, 104, 101, 32, 112, 105, 112,
    101, 108, 105, 110, 101, 32, 98, 105, 110, 97, 114, 121, 32, 109, 97, 120, 32, 115, 105, 122, 101, 32, 108, 105,
    109, 105, 116, 32, 40, 105, 110, 32, 75, 66, 41, 32, 117, 115, 101, 100, 32, 98, 121, 32, 116, 104, 101, 32, 80,
    105, 112, 101, 108, 105, 110, 101, 85, 114, 105, 83, 101, 114, 118, 105, 99, 101, 32, 119, 104, 101, 110, 32, 105,
    110, 106, 101, 99, 116, 105, 110, 103, 32, 112, 105, 112, 101, 108, 105, 110, 101, 32, 98, 105, 110, 97, 114, 105,
    101, 115, 32, 98, 97, 99, 107, 32, 105, 110, 116, 111, 32, 116, 104, 101, 32, 100, 114, 105, 118, 101, 114, 46, 32,
    84, 104, 101, 32, 108, 105, 109, 105, 116, 32, 105, 115, 32, 50, 53, 54, 75, 66, 32, 98, 121, 32, 100, 101, 102, 97,
    117, 108, 116, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 68, 101, 118, 101, 108, 111, 112, 101, 114,
    32, 77, 111, 100, 101, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102,
    97, 117, 108, 116, 34, 58, 32, 50, 53, 54, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105,
    118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86,
    97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 100, 101, 118, 77, 111, 100, 101, 80, 105, 112,
    101, 108, 105, 110, 101, 85, 114, 105, 83, 101, 114, 118, 105, 99, 101, 80, 111, 115, 116, 83, 105, 122, 101, 76,
    105, 109, 105, 116, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 101, 118, 77, 111, 100, 101, 80, 105, 112,
    101, 108, 105, 110, 101, 85, 114, 105, 83, 101, 114, 118, 105, 99, 101, 80, 111, 115, 116, 83, 105, 122, 101, 76,
    105, 109, 105, 116, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 56, 48, 49, 51, 52, 52, 54, 56,
    54, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 84, 104, 105, 115,
    32, 99, 111, 110, 116, 114, 111, 108, 115, 32, 119, 104, 101, 116, 104, 101, 114, 32, 101, 108, 102, 32, 102, 105,
    108, 101, 115, 32, 112, 108, 97, 99, 101, 100, 32, 105, 110, 32, 68, 101, 118, 77, 111, 100, 101, 69, 108, 102, 82,
    101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 68, 105, 114, 101, 99, 116, 111, 114, 121, 32, 119, 105, 108, 108,
    32, 98, 101, 32, 114, 101, 97, 100, 46, 32, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 68, 101, 118, 101,
    108, 111, 112, 101, 114, 32, 77, 111, 100, 101, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58,
    32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115, 101, 125, 44, 32, 34, 83, 99, 111, 112,
    101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 98, 111, 111,
    108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 100, 101, 118, 77, 111,
    100, 101, 69, 108, 102, 82, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 68, 105, 114, 101, 99, 116, 111, 114,
    121, 69, 110, 97, 98, 108, 101, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 101, 118, 77, 111, 100, 101,
    69, 108, 102, 82, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 68, 105, 114, 101, 99, 116, 111, 114, 121, 69,
    110, 97, 98, 108, 101, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 49, 48, 53, 49, 57, 53, 50,
    48, 54, 52, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 69, 108, 102,
    32, 102, 105, 108, 101, 115, 32, 112, 108, 97, 99, 101, 100, 32, 119, 105, 116, 104, 105, 110, 32, 116, 104, 105,
    115, 32, 100, 105, 114, 101, 99, 116, 111, 114, 121, 32, 119, 105, 108, 108, 32, 98, 101, 32, 99, 97, 99, 104, 101,
    100, 32, 97, 110, 100, 32, 114, 101, 112, 108, 97, 99, 101, 32, 99, 111, 114, 114, 101, 115, 112, 111, 110, 100,
    105, 110, 103, 32, 112, 105, 112, 101, 108, 105, 110, 101, 32, 98, 105, 110, 97, 114, 105, 101, 115, 32, 97, 115,
    32, 116, 104, 101, 121, 32, 97, 114, 101, 32, 99, 114, 101, 97, 116, 101, 100, 46, 32, 69, 108, 102, 32, 102, 105,
    108, 101, 115, 32, 119, 105, 116, 104, 105, 110, 32, 116, 104, 105, 115, 32, 100, 105, 114, 101, 99, 116, 111, 114,
    121, 32, 115, 104, 111, 117, 108, 100, 32, 102, 111, 108, 108, 111, 119, 32, 116, 104, 105, 115, 32, 110, 111, 109,
    101, 110, 99, 108, 97, 116, 117, 114, 101, 58, 32, 92, 34, 91, 101, 120, 101, 32, 110, 97, 109, 101, 93, 95, 91,
    104, 97, 115, 104, 32, 111, 102, 32, 112, 105, 112, 101, 108, 105, 110, 101, 32, 98, 101, 105, 110, 103, 32, 114,
    101, 112, 108, 97, 99, 101, 100, 93, 46, 101, 108, 102, 92, 34, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91,
    34, 68, 101, 118, 101, 108, 111, 112, 101, 114, 32, 77, 111, 100, 101, 34, 93, 44, 32, 34, 70, 108, 97, 103, 115,
    34, 58, 32, 123, 34, 73, 115, 80, 97, 116, 104, 34, 58, 32, 116, 114, 117, 101, 125, 44, 32, 34, 68, 101, 102, 97,
    117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 34, 80, 105, 112, 101, 108,
    105, 110, 101, 82, 101, 112, 108, 97, 99, 101, 34, 44, 32, 34, 87, 105, 110, 68, 101, 102, 97, 117, 108, 116, 34,
    58, 32, 34, 80, 105, 112, 101, 108, 105, 110, 101, 82, 101, 112, 108, 97, 99, 101, 34, 44, 32, 34, 76, 110, 120, 68,
    101, 102, 97, 117, 108, 116, 34, 58, 32, 34, 80, 105, 112, 101, 108, 105, 110, 101, 82, 101, 112, 108, 97, 99, 101,
    34, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 78, 97,
    109, 101, 34, 58, 32, 34, 68, 101, 118, 77, 111, 100, 101, 69, 108, 102, 82, 101, 112, 108, 97, 99, 101, 109, 101,
    110, 116, 68, 105, 114, 101, 99, 116, 111, 114, 121, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 115, 116,
    114, 105, 110, 103, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 100, 101,
    118, 77, 111, 100, 101, 69, 108, 102, 82, 101, 112, 108, 97, 99, 101, 109, 101, 110, 116, 68, 105, 114, 101, 99,
    116, 111, 114, 121, 34, 44, 32, 34, 83, 105, 122, 101, 34, 58, 32, 53, 49, 50, 44, 32, 34, 72, 97, 115, 104, 78, 97,
    109, 101, 34, 58, 32, 50, 57, 56, 54, 50, 53, 55, 51, 57, 57, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112,
    116, 105, 111, 110, 34, 58, 32, 34, 84, 104, 105, 115, 32, 99, 111, 110, 116, 114, 111, 108, 115, 32, 119, 104, 101,
    116, 104, 101, 114, 32, 82, 71, 80, 32, 116, 114, 97, 99, 101, 115, 32, 119, 105, 108, 108, 32, 105, 110, 99, 108,
    117, 100, 101, 32, 115, 104, 97, 100, 101, 114, 32, 99, 111, 100, 101, 32, 111, 102, 32, 99, 114, 101, 97, 116, 101,
    100, 32, 112, 105, 112, 101, 108, 105, 110, 101, 115, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 68,
    101, 118, 101, 108, 111, 112, 101, 114, 32, 77, 111, 100, 101, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116,
    115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 116, 114, 117, 101, 125, 44, 32, 34, 83, 99,
    111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 98,
    111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 100, 101, 118,
    77, 111, 100, 101, 83, 104, 97, 100, 101, 114, 73, 115, 97, 68, 98, 69, 110, 97, 98, 108, 101, 34, 44, 32, 34, 78,
    97, 109, 101, 34, 58, 32, 34, 68, 101, 118, 77, 111, 100, 101, 83, 104, 97, 100, 101, 114, 73, 115, 97, 68, 98, 69,
    110, 97, 98, 108, 101, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 51, 57, 57, 56, 53, 51, 53,
    50, 54, 56, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 84, 104, 105,
    115, 32, 99, 111, 110, 116, 114, 111, 108, 115, 32, 119, 104, 101, 116, 104, 101, 114, 32, 113, 117, 101, 117, 101,
    32, 111, 112, 101, 114, 97, 116, 105, 111, 110, 115, 32, 97, 114, 101, 32, 116, 105, 109, 101, 100, 32, 100, 117,
    114, 105, 110, 103, 32, 82, 71, 80, 32, 116, 114, 97, 99, 101, 115, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58,
    32, 91, 34, 68, 101, 118, 101, 108, 111, 112, 101, 114, 32, 77, 111, 100, 101, 34, 93, 44, 32, 34, 68, 101, 102, 97,
    117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 116, 114, 117, 101, 125, 44,
    32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34,
    58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34,
    100, 101, 118, 77, 111, 100, 101, 81, 117, 101, 117, 101, 84, 105, 109, 105, 110, 103, 69, 110, 97, 98, 108, 101,
    34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 101, 118, 77, 111, 100, 101, 81, 117, 101, 117, 101, 84, 105,
    109, 105, 110, 103, 69, 110, 97, 98, 108, 101, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 52,
    50, 54, 55, 48, 48, 51, 53, 49, 49, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34,
    58, 32, 34, 84, 104, 105, 115, 32, 99, 111, 110, 116, 114, 111, 108, 115, 32, 105, 102, 32, 116, 104, 101, 32, 108,
    101, 103, 97, 99, 121, 32, 116, 105, 109, 101, 100, 32, 113, 117, 101, 117, 101, 32, 115, 101, 109, 97, 112, 104,
    111, 114, 101, 115, 32, 97, 114, 101, 32, 116, 111, 32, 98, 101, 32, 117, 115, 101, 100, 32, 111, 110, 32, 87, 105,
    110, 100, 111, 119, 115, 32, 105, 110, 115, 116, 101, 97, 100, 32, 111, 102, 32, 116, 104, 101, 32, 69, 84, 87, 32,
    99, 108, 105, 101, 110, 116, 46, 32, 84, 104, 105, 115, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 32, 100, 111,
    101, 115, 32, 110, 111, 116, 32, 97, 102, 102, 101, 99, 116, 32, 76, 105, 110, 117, 120, 46, 34, 44, 32, 34, 84, 97,
    103, 115, 34, 58, 32, 91, 34, 68, 101, 118, 101, 108, 111, 112, 101, 114, 32, 77, 111, 100, 101, 34, 93, 44, 32, 34,
    68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 116, 114,
    117, 101, 125, 44, 32, 34, 68, 101, 112, 101, 110, 100, 115, 79, 110, 34, 58, 32, 123, 34, 79, 83, 34, 58, 32, 91,
    34, 87, 105, 110, 100, 111, 119, 115, 34, 93, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105,
    118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114,
    105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 100, 101, 118, 77, 111, 100, 101, 83, 101, 109, 97, 112,
    104, 111, 114, 101, 81, 117, 101, 117, 101, 84, 105, 109, 105, 110, 103, 69, 110, 97, 98, 108, 101, 34, 44, 32, 34,
    78, 97, 109, 101, 34, 58, 32, 34, 68, 101, 118, 77, 111, 100, 101, 83, 101, 109, 97, 112, 104, 111, 114, 101, 81,
    117, 101, 117, 101, 84, 105, 109, 105, 110, 103, 69, 110, 97, 98, 108, 101, 34, 44, 32, 34, 72, 97, 115, 104, 78,
    97, 109, 101, 34, 58, 32, 49, 56, 52, 48, 57, 49, 53, 54, 51, 49, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105,
    112, 116, 105, 111, 110, 34, 58, 32, 34, 84, 104, 105, 115, 32, 99, 111, 110, 116, 114, 111, 108, 115, 32, 119, 104,
    97, 116, 32, 107, 105, 110, 100, 32, 111, 102, 32, 83, 81, 84, 84, 32, 105, 110, 115, 116, 114, 117, 109, 101, 110,
    116, 97, 116, 105, 111, 110, 32, 109, 97, 114, 107, 101, 114, 32, 100, 97, 116, 97, 32, 105, 115, 32, 111, 117, 116,
    112, 117, 116, 32, 102, 114, 111, 109, 32, 116, 104, 101, 32, 100, 114, 105, 118, 101, 114, 46, 32, 78, 111, 116,
    101, 32, 116, 104, 97, 116, 32, 116, 104, 105, 115, 32, 111, 110, 108, 121, 32, 102, 105, 110, 101, 45, 116, 117,
    110, 101, 115, 32, 105, 110, 115, 116, 114, 117, 109, 101, 110, 116, 97, 116, 105, 111, 110, 58, 32, 116, 104, 101,
    32, 109, 97, 115, 116, 101, 114, 32, 116, 111, 103, 103, 108, 101, 32, 102, 111, 114, 32, 83, 81, 84, 84, 32, 105,
    115, 32, 97, 108, 119, 97, 121, 115, 32, 119, 104, 101, 116, 104, 101, 114, 32, 100, 101, 118, 101, 108, 111, 112,
    101, 114, 32, 109, 111, 100, 101, 32, 105, 115, 32, 101, 110, 97, 98, 108, 101, 100, 46, 32, 32, 71, 101, 110, 101,
    114, 97, 108, 32, 83, 81, 84, 84, 32, 100, 97, 116, 97, 32, 40, 101, 118, 101, 110, 116, 44, 32, 119, 97, 118, 101,
    44, 32, 105, 110, 115, 116, 114, 117, 99, 116, 105, 111, 110, 41, 32, 105, 115, 32, 97, 108, 115, 111, 32, 103, 101,
    110, 101, 114, 97, 116, 101, 100, 32, 105, 110, 100, 101, 112, 101, 110, 100, 101, 110, 116, 32, 111, 102, 32, 116,
    104, 105, 115, 32, 115, 101, 116, 116, 105, 110, 103, 32, 105, 102, 32, 83, 81, 84, 84, 32, 105, 115, 32, 101, 110,
    97, 98, 108, 101, 100, 46, 32, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 68, 101, 118, 101, 108, 111,
    112, 101, 114, 32, 77, 111, 100, 101, 34, 93, 44, 32, 34, 70, 108, 97, 103, 115, 34, 58, 32, 123, 34, 73, 115, 72,
    101, 120, 34, 58, 32, 116, 114, 117, 101, 44, 32, 34, 73, 115, 66, 105, 116, 109, 97, 115, 107, 34, 58, 32, 116,
    114, 117, 101, 125, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117,
    108, 116, 34, 58, 32, 51, 54, 55, 125, 44, 32, 34, 86, 97, 108, 105, 100, 86, 97, 108, 117, 101, 115, 34, 58, 32,
    123, 34, 86, 97, 108, 117, 101, 115, 34, 58, 32, 91, 123, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 44, 32, 34, 68,
    101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 32, 99, 111, 109, 109,
    97, 110, 100, 32, 98, 117, 102, 102, 101, 114, 32, 115, 116, 97, 114, 116, 32, 105, 110, 115, 116, 114, 117, 109,
    101, 110, 116, 97, 116, 105, 111, 110, 32, 109, 97, 114, 107, 101, 114, 34, 125, 44, 32, 123, 34, 86, 97, 108, 117,
    101, 34, 58, 32, 50, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 69, 110, 97,
    98, 108, 101, 32, 99, 111, 109, 109, 97, 110, 100, 32, 98, 117, 102, 102, 101, 114, 32, 101, 110, 100, 32, 105, 110,
    115, 116, 114, 117, 109, 101, 110, 116, 97, 116, 105, 111, 110, 32, 109, 97, 114, 107, 101, 114, 34, 125, 44, 32,
    123, 34, 86, 97, 108, 117, 101, 34, 58, 32, 52, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34,
    58, 32, 34, 69, 110, 97, 98, 108, 101, 32, 112, 101, 114, 45, 100, 114, 97, 119, 47, 100, 105, 115, 112, 97, 116,
    99, 104, 32, 101, 118, 101, 110, 116, 32, 105, 110, 115, 116, 114, 117, 109, 101, 110, 116, 97, 116, 105, 111, 110,
    32, 109, 97, 114, 107, 101, 114, 115, 34, 125, 44, 32, 123, 34, 86, 97, 108, 117, 101, 34, 58, 32, 56, 44, 32, 34,
    68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 32, 98, 97, 114,
    114, 105, 101, 114, 32, 105, 110, 115, 116, 114, 117, 109, 101, 110, 116, 97, 116, 105, 111, 110, 32, 109, 97, 114,
    107, 101, 114, 115, 34, 125, 44, 32, 123, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 54, 44, 32, 34, 68, 101, 115,
    99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 32, 103, 101, 110, 101, 114, 97,
    108, 32, 65, 80, 73, 32, 40, 112, 101, 114, 32, 101, 110, 116, 114, 121, 32, 112, 111, 105, 110, 116, 32, 99, 97,
    108, 108, 41, 32, 105, 110, 115, 116, 114, 117, 110, 109, 101, 110, 116, 97, 116, 105, 111, 110, 32, 109, 97, 114,
    107, 101, 114, 115, 34, 125, 44, 32, 123, 34, 86, 97, 108, 117, 101, 34, 58, 32, 51, 50, 44, 32, 34, 68, 101, 115,
    99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 32, 117, 115, 101, 114, 32, 101,
    118, 101, 110, 116, 32, 40, 97, 112, 112, 32, 115, 116, 114, 105, 110, 103, 41, 32, 109, 97, 114, 107, 101, 114,
    115, 34, 125, 44, 32, 123, 34, 86, 97, 108, 117, 101, 34, 58, 32, 54, 52, 44, 32, 34, 68, 101, 115, 99, 114, 105,
    112, 116, 105, 111, 110, 34, 58, 32, 34, 69, 110, 97, 98, 108, 101, 32, 100, 105, 115, 112, 97, 116, 99, 104, 32,
    101, 118, 101, 110, 116, 115, 32, 119, 105, 116, 104, 32, 116, 104, 114, 101, 97, 100, 32, 100, 105, 109, 101, 110,
    115, 105, 111, 110, 115, 34, 125, 44, 32, 123, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 50, 56, 44, 32, 34, 68,
    101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 87, 114, 105, 116, 101, 32, 98, 111, 117, 110, 100,
    32, 115, 104, 97, 100, 101, 114, 32, 104, 97, 115, 104, 101, 115, 32, 97, 115, 32, 117, 115, 101, 114, 32, 101, 118,
    101, 110, 116, 32, 109, 97, 114, 107, 101, 114, 115, 34, 125, 44, 32, 123, 34, 86, 97, 108, 117, 101, 34, 58, 32,
    50, 53, 54, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 69, 110, 97, 98, 108,
    101, 32, 112, 105, 112, 101, 108, 105, 110, 101, 32, 98, 105, 110, 100, 32, 109, 97, 114, 107, 101, 114, 115, 34,
    125, 93, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84,
    121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78,
    97, 109, 101, 34, 58, 32, 34, 100, 101, 118, 77, 111, 100, 101, 83, 113, 116, 116, 77, 97, 114, 107, 101, 114, 69,
    110, 97, 98, 108, 101, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 101, 118, 77, 111, 100, 101, 83, 113,
    116, 116, 77, 97, 114, 107, 101, 114, 69, 110, 97, 98, 108, 101, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101,
    34, 58, 32, 51, 55, 53, 56, 49, 49, 53, 57, 50, 54, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105,
    111, 110, 34, 58, 32, 34, 73, 102, 32, 116, 114, 117, 101, 44, 32, 83, 81, 84, 84, 32, 115, 117, 112, 112, 111, 114,
    116, 32, 105, 115, 32, 100, 105, 115, 97, 98, 108, 101, 100, 32, 97, 110, 100, 32, 97, 108, 108, 32, 82, 71, 80, 32,
    116, 114, 97, 99, 101, 115, 32, 119, 105, 108, 108, 32, 97, 117, 116, 111, 109, 97, 116, 105, 99, 97, 108, 108, 121,
    32, 102, 97, 105, 108, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 68, 101, 118, 101, 108, 111, 112,
    101, 114, 32, 77, 111, 100, 101, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68,
    101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115, 101, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32,
    34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32,
    34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 100, 101, 118, 77, 111, 100, 101, 83, 113,
    116, 116, 70, 111, 114, 99, 101, 68, 105, 115, 97, 98, 108, 101, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34,
    68, 101, 118, 77, 111, 100, 101, 83, 113, 116, 116, 70, 111, 114, 99, 101, 68, 105, 115, 97, 98, 108, 101, 34, 44,
    32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 49, 48, 52, 53, 50, 54, 48, 55, 55, 48, 125, 44, 32, 123,
    34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 73, 102, 32, 116, 114, 117, 101, 44, 32,
    97, 32, 67, 80, 85, 32, 100, 101, 118, 105, 99, 101, 32, 119, 97, 105, 116, 32, 105, 100, 108, 101, 32, 105, 115,
    32, 101, 120, 101, 99, 117, 116, 101, 100, 32, 112, 114, 105, 111, 114, 32, 116, 111, 32, 115, 116, 97, 114, 116,
    105, 110, 103, 32, 97, 110, 100, 32, 101, 110, 100, 105, 110, 103, 32, 97, 32, 116, 114, 97, 99, 101, 46, 32, 80,
    76, 69, 65, 83, 69, 32, 78, 79, 84, 69, 58, 32, 84, 104, 105, 115, 32, 105, 115, 32, 99, 117, 114, 114, 101, 110,
    116, 108, 121, 32, 110, 111, 116, 32, 116, 104, 114, 101, 97, 100, 32, 115, 97, 102, 101, 32, 97, 110, 100, 32, 109,
    97, 121, 32, 114, 101, 115, 117, 108, 116, 32, 105, 110, 32, 99, 114, 97, 115, 104, 101, 115, 46, 32, 73, 116, 32,
    105, 115, 32, 111, 110, 108, 121, 32, 105, 110, 99, 108, 117, 100, 101, 100, 32, 97, 115, 32, 97, 32, 100, 101, 98,
    117, 103, 103, 105, 110, 103, 32, 111, 112, 116, 105, 111, 110, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32,
    91, 34, 68, 101, 118, 101, 108, 111, 112, 101, 114, 32, 77, 111, 100, 101, 34, 93, 44, 32, 34, 68, 101, 102, 97,
    117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115, 101, 125,
    44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101,
    34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32,
    34, 100, 101, 118, 77, 111, 100, 101, 83, 113, 116, 116, 87, 97, 105, 116, 73, 100, 108, 101, 34, 44, 32, 34, 78,
    97, 109, 101, 34, 58, 32, 34, 68, 101, 118, 77, 111, 100, 101, 83, 113, 116, 116, 87, 97, 105, 116, 73, 100, 108,
    101, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 50, 51, 48, 49, 53, 52, 57, 52, 48, 56, 125,
    44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 73, 102, 32, 116, 114, 117,
    101, 44, 32, 105, 110, 115, 101, 114, 116, 115, 32, 97, 32, 102, 117, 108, 108, 32, 112, 105, 112, 101, 108, 105,
    110, 101, 32, 102, 108, 117, 115, 104, 32, 105, 110, 116, 111, 32, 97, 108, 108, 32, 104, 97, 114, 100, 119, 97,
    114, 101, 32, 113, 117, 101, 117, 101, 115, 32, 97, 116, 32, 116, 104, 101, 32, 98, 101, 103, 105, 110, 110, 105,
    110, 103, 32, 111, 102, 32, 116, 104, 101, 32, 108, 97, 115, 116, 32, 112, 114, 101, 112, 97, 114, 97, 116, 105,
    111, 110, 32, 102, 114, 97, 109, 101, 32, 105, 110, 32, 97, 110, 32, 82, 71, 80, 32, 116, 114, 97, 99, 101, 46, 34,
    44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 68, 101, 118, 101, 108, 111, 112, 101, 114, 32, 77, 111, 100, 101,
    34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34,
    58, 32, 116, 114, 117, 101, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34,
    44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108,
    101, 78, 97, 109, 101, 34, 58, 32, 34, 100, 101, 118, 77, 111, 100, 101, 83, 113, 116, 116, 70, 108, 117, 115, 104,
    65, 108, 108, 81, 117, 101, 117, 101, 115, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 101, 118, 77, 111,
    100, 101, 83, 113, 116, 116, 70, 108, 117, 115, 104, 65, 108, 108, 81, 117, 101, 117, 101, 115, 34, 44, 32, 34, 72,
    97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 52, 49, 48, 51, 48, 55, 50, 55, 52, 50, 125, 44, 32, 123, 34, 86, 97,
    108, 105, 100, 86, 97, 108, 117, 101, 115, 34, 58, 32, 123, 34, 86, 97, 108, 117, 101, 115, 34, 58, 32, 91, 123, 34,
    68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 65, 117, 116, 111, 45, 99, 97, 108, 99, 117,
    108, 97, 116, 101, 32, 116, 104, 101, 32, 115, 105, 122, 101, 32, 98, 97, 115, 101, 100, 32, 111, 110, 32, 71, 80,
    85, 32, 99, 104, 97, 114, 97, 99, 116, 101, 114, 105, 115, 116, 105, 99, 115, 46, 34, 44, 32, 34, 86, 97, 108, 117,
    101, 34, 58, 32, 48, 125, 44, 32, 123, 34, 76, 111, 103, 105, 99, 79, 112, 34, 58, 32, 34, 77, 117, 108, 116, 105,
    112, 108, 101, 79, 102, 34, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 67,
    117, 114, 114, 101, 110, 116, 32, 72, 87, 32, 114, 101, 113, 117, 105, 114, 101, 115, 32, 116, 104, 101, 32, 115,
    105, 122, 101, 32, 98, 101, 32, 97, 108, 105, 103, 110, 101, 100, 32, 116, 111, 32, 48, 120, 49, 48, 48, 48, 32, 98,
    121, 116, 101, 115, 46, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 52, 48, 57, 54, 125, 93, 125, 44, 32, 34,
    68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 77, 97, 120, 105, 109, 117, 109, 32, 97, 109,
    111, 117, 110, 116, 32, 111, 102, 32, 100, 97, 116, 97, 32, 105, 110, 32, 98, 121, 116, 101, 115, 32, 116, 111, 32,
    99, 97, 112, 116, 117, 114, 101, 32, 112, 101, 114, 32, 116, 114, 97, 99, 101, 46, 32, 65, 32, 116, 114, 97, 99,
    101, 32, 119, 105, 108, 108, 32, 99, 111, 118, 101, 114, 32, 97, 32, 115, 112, 97, 110, 32, 111, 102, 32, 99, 111,
    109, 109, 97, 110, 100, 115, 32, 98, 97, 115, 101, 100, 32, 111, 110, 32, 116, 104, 101, 32, 71, 112, 117, 80, 114,
    111, 102, 105, 108, 101, 114, 71, 114, 97, 110, 117, 108, 97, 114, 105, 116, 121, 32, 115, 101, 116, 116, 105, 110,
    103, 46, 32, 68, 101, 102, 97, 117, 108, 116, 115, 32, 116, 111, 32, 48, 44, 32, 119, 104, 105, 99, 104, 32, 109,
    101, 97, 110, 115, 32, 97, 117, 116, 111, 45, 99, 97, 108, 99, 117, 108, 97, 116, 101, 32, 116, 104, 101, 32, 115,
    105, 122, 101, 32, 98, 97, 115, 101, 100, 32, 111, 110, 32, 71, 80, 85, 32, 99, 104, 97, 114, 97, 99, 116, 101, 114,
    105, 115, 116, 105, 99, 115, 46, 32, 67, 117, 114, 114, 101, 110, 116, 32, 72, 87, 32, 114, 101, 113, 117, 105, 114,
    101, 115, 32, 116, 104, 101, 32, 115, 105, 122, 101, 32, 98, 101, 32, 97, 108, 105, 103, 110, 101, 100, 32, 116,
    111, 32, 48, 120, 49, 48, 48, 48, 32, 98, 121, 116, 101, 115, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91,
    34, 68, 101, 118, 101, 108, 111, 112, 101, 114, 32, 77, 111, 100, 101, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117,
    108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 48, 125, 44, 32, 34, 83, 99, 111,
    112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105,
    110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 100, 101,
    118, 77, 111, 100, 101, 83, 113, 116, 116, 71, 112, 117, 77, 101, 109, 111, 114, 121, 76, 105, 109, 105, 116, 34,
    44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 101, 118, 77, 111, 100, 101, 83, 113, 116, 116, 71, 112, 117, 77,
    101, 109, 111, 114, 121, 76, 105, 109, 105, 116, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 49,
    55, 50, 52, 54, 53, 57, 57, 50, 51, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34,
    58, 32, 34, 78, 117, 109, 98, 101, 114, 32, 111, 102, 32, 102, 114, 97, 109, 101, 115, 32, 40, 112, 114, 101, 115,
    101, 110, 116, 32, 99, 97, 108, 108, 115, 41, 32, 116, 111, 32, 116, 114, 97, 99, 101, 32, 83, 81, 84, 84, 46, 34,
    44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 68, 101, 118, 101, 108, 111, 112, 101, 114, 32, 77, 111, 100, 101,
    34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34,
    58, 32, 49, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84,
    121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78,
    97, 109, 101, 34, 58, 32, 34, 100, 101, 118, 77, 111, 100, 101, 83, 113, 116, 116, 70, 114, 97, 109, 101, 67, 111,
    117, 110, 116, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 101, 118, 77, 111, 100, 101, 83, 113, 116, 116,
    70, 114, 97, 109, 101, 67, 111, 117, 110, 116, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 49,
    53, 49, 54, 48, 50, 56, 48, 52, 51, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34,
    58, 32, 34, 65, 110, 121, 32, 100, 114, 105, 118, 101, 114, 45, 103, 101, 110, 101, 114, 97, 116, 101, 100, 32, 117,
    115, 101, 114, 32, 101, 118, 101, 110, 116, 32, 109, 97, 114, 107, 101, 114, 115, 32, 119, 105, 108, 108, 32, 104,
    97, 118, 101, 32, 116, 104, 105, 115, 32, 115, 116, 114, 105, 110, 103, 32, 97, 115, 32, 105, 116, 115, 32, 112,
    114, 101, 102, 105, 120, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 68, 101, 118, 101, 108, 111, 112,
    101, 114, 32, 77, 111, 100, 101, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68,
    101, 102, 97, 117, 108, 116, 34, 58, 32, 34, 91, 65, 77, 68, 93, 32, 34, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34,
    58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 101, 118, 77, 111,
    100, 101, 83, 113, 116, 116, 73, 110, 116, 101, 114, 110, 97, 108, 85, 115, 101, 114, 69, 118, 101, 110, 116, 80,
    114, 101, 102, 105, 120, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 115, 116, 114, 105, 110, 103, 34, 44,
    32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 100, 101, 118, 77, 111, 100, 101, 83,
    113, 116, 116, 73, 110, 116, 101, 114, 110, 97, 108, 85, 115, 101, 114, 69, 118, 101, 110, 116, 80, 114, 101, 102,
    105, 120, 34, 44, 32, 34, 83, 105, 122, 101, 34, 58, 32, 53, 49, 50, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101,
    34, 58, 32, 50, 54, 56, 49, 50, 50, 54, 54, 54, 51, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105,
    111, 110, 34, 58, 32, 34, 73, 102, 32, 84, 82, 85, 69, 44, 32, 68, 101, 118, 77, 111, 100, 101, 83, 113, 116, 116,
    84, 114, 97, 99, 101, 91, 66, 101, 103, 105, 110, 124, 69, 110, 100, 93, 84, 97, 103, 86, 97, 108, 117, 101, 115,
    32, 97, 114, 101, 32, 117, 115, 101, 100, 32, 116, 111, 32, 111, 118, 101, 114, 114, 105, 100, 101, 32, 116, 114,
    97, 99, 101, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 32, 98, 101, 103, 105, 110, 47, 101, 110, 100, 32, 99,
    111, 109, 109, 97, 110, 100, 32, 98, 117, 102, 102, 101, 114, 32, 100, 101, 98, 117, 103, 32, 111, 98, 106, 101, 99,
    116, 32, 116, 97, 103, 32, 118, 97, 108, 117, 101, 115, 46, 32, 84, 104, 105, 115, 32, 105, 115, 32, 109, 97, 105,
    110, 108, 121, 32, 117, 115, 101, 100, 32, 102, 111, 114, 32, 100, 101, 98, 117, 103, 103, 105, 110, 103, 46, 34,
    44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 68, 101, 118, 101, 108, 111, 112, 101, 114, 32, 77, 111, 100, 101,
    34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34,
    58, 32, 102, 97, 108, 115, 101, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114,
    34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108,
    101, 78, 97, 109, 101, 34, 58, 32, 34, 100, 101, 118, 77, 111, 100, 101, 83, 113, 116, 116, 84, 114, 97, 99, 101,
    66, 101, 103, 105, 110, 69, 110, 100, 84, 97, 103, 69, 110, 97, 98, 108, 101, 34, 44, 32, 34, 78, 97, 109, 101, 34,
    58, 32, 34, 68, 101, 118, 77, 111, 100, 101, 83, 113, 116, 116, 84, 114, 97, 99, 101, 66, 101, 103, 105, 110, 69,
    110, 100, 84, 97, 103, 69, 110, 97, 98, 108, 101, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32,
    49, 55, 48, 56, 49, 53, 53, 50, 53, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34,
    58, 32, 34, 67, 117, 115, 116, 111, 109, 32, 99, 111, 109, 109, 97, 110, 100, 32, 98, 117, 102, 102, 101, 114, 32,
    100, 101, 98, 117, 103, 32, 111, 98, 106, 101, 99, 116, 32, 116, 97, 103, 32, 118, 97, 108, 117, 101, 32, 115, 105,
    103, 110, 105, 102, 121, 105, 110, 103, 32, 118, 105, 114, 116, 117, 97, 108, 32, 102, 114, 97, 109, 101, 32, 115,
    116, 97, 114, 116, 46, 32, 32, 82, 101, 113, 117, 105, 114, 101, 115, 32, 68, 101, 118, 77, 111, 100, 101, 83, 113,
    116, 116, 84, 114, 97, 99, 101, 66, 101, 103, 105, 110, 69, 110, 100, 84, 97, 103, 69, 110, 97, 98, 108, 101, 46,
    34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 68, 101, 118, 101, 108, 111, 112, 101, 114, 32, 77, 111, 100,
    101, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116,
    34, 58, 32, 48, 125, 44, 32, 34, 68, 101, 112, 101, 110, 100, 115, 79, 110, 34, 58, 32, 123, 34, 83, 101, 116, 116,
    105, 110, 103, 115, 34, 58, 32, 91, 123, 34, 86, 97, 108, 117, 101, 115, 34, 58, 32, 91, 116, 114, 117, 101, 93, 44,
    32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 101, 118, 77, 111, 100, 101, 83, 113, 116, 116, 84, 114, 97, 99, 101,
    66, 101, 103, 105, 110, 69, 110, 100, 84, 97, 103, 69, 110, 97, 98, 108, 101, 34, 125, 93, 125, 44, 32, 34, 83, 99,
    111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117,
    105, 110, 116, 54, 52, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 100,
    101, 118, 77, 111, 100, 101, 83, 113, 116, 116, 84, 114, 97, 99, 101, 66, 101, 103, 105, 110, 84, 97, 103, 86, 97,
    108, 117, 101, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 101, 118, 77, 111, 100, 101, 83, 113, 116, 116,
    84, 114, 97, 99, 101, 66, 101, 103, 105, 110, 84, 97, 103, 86, 97, 108, 117, 101, 34, 44, 32, 34, 72, 97, 115, 104,
    78, 97, 109, 101, 34, 58, 32, 49, 56, 52, 51, 51, 49, 50, 48, 54, 48, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114,
    105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 67, 117, 115, 116, 111, 109, 32, 99, 111, 109, 109, 97, 110, 100, 32,
    98, 117, 102, 102, 101, 114, 32, 100, 101, 98, 117, 103, 32, 111, 98, 106, 101, 99, 116, 32, 116, 97, 103, 32, 118,
    97, 108, 117, 101, 32, 115, 105, 103, 110, 105, 102, 121, 105, 110, 103, 32, 118, 105, 114, 116, 117, 97, 108, 32,
    102, 114, 97, 109, 101, 32, 101, 110, 100, 46, 32, 82, 101, 113, 117, 105, 114, 101, 115, 32, 68, 101, 118, 77, 111,
    100, 101, 83, 113, 116, 116, 84, 114, 97, 99, 101, 66, 101, 103, 105, 110, 69, 110, 100, 84, 97, 103, 69, 110, 97,
    98, 108, 101, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 68, 101, 118, 101, 108, 111, 112, 101, 114,
    32, 77, 111, 100, 101, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102,
    97, 117, 108, 116, 34, 58, 32, 48, 125, 44, 32, 34, 68, 101, 112, 101, 110, 100, 115, 79, 110, 34, 58, 32, 123, 34,
    83, 101, 116, 116, 105, 110, 103, 115, 34, 58, 32, 91, 123, 34, 86, 97, 108, 117, 101, 115, 34, 58, 32, 91, 116,
    114, 117, 101, 93, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 101, 118, 77, 111, 100, 101, 83, 113, 116, 116,
    84, 114, 97, 99, 101, 66, 101, 103, 105, 110, 69, 110, 100, 84, 97, 103, 69, 110, 97, 98, 108, 101, 34, 125, 93,
    125, 44, 32, 34, 70, 108, 97, 103, 115, 34, 58, 32, 123, 34, 73, 115, 72, 101, 120, 34, 58, 32, 116, 114, 117, 101,
    125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112,
    101, 34, 58, 32, 34, 117, 105, 110, 116, 54, 52, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109,
    101, 34, 58, 32, 34, 100, 101, 118, 77, 111, 100, 101, 83, 113, 116, 116, 84, 114, 97, 99, 101, 69, 110, 100, 84,
    97, 103, 86, 97, 108, 117, 101, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 101, 118, 77, 111, 100, 101,
    83, 113, 116, 116, 84, 114, 97, 99, 101, 69, 110, 100, 84, 97, 103, 86, 97, 108, 117, 101, 34, 44, 32, 34, 72, 97,
    115, 104, 78, 97, 109, 101, 34, 58, 32, 49, 51, 56, 50, 52, 56, 50, 57, 53, 54, 125, 44, 32, 123, 34, 68, 101, 115,
    99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 73, 102, 32, 84, 82, 85, 69, 44, 32, 105, 110, 115, 116, 114,
    117, 99, 116, 105, 111, 110, 45, 108, 101, 118, 101, 108, 32, 116, 114, 97, 99, 105, 110, 103, 32, 119, 105, 108,
    108, 32, 98, 101, 32, 101, 110, 97, 98, 108, 101, 100, 46, 32, 68, 101, 118, 77, 111, 100, 101, 83, 113, 116, 116,
    84, 97, 114, 103, 101, 116, 65, 112, 105, 80, 115, 111, 72, 97, 115, 104, 32, 99, 97, 110, 32, 98, 101, 117, 115,
    101, 100, 32, 116, 111, 32, 115, 112, 101, 99, 105, 102, 121, 32, 116, 104, 101, 32, 115, 99, 111, 112, 101, 32,
    116, 114, 97, 99, 101, 100, 32, 40, 102, 117, 108, 108, 32, 102, 114, 97, 109, 101, 32, 111, 114, 32, 105, 110, 100,
    105, 118, 105, 100, 117, 97, 108, 32, 112, 105, 112, 101, 108, 105, 110, 101, 41, 46, 32, 34, 44, 32, 34, 84, 97,
    103, 115, 34, 58, 32, 91, 34, 68, 101, 118, 101, 108, 111, 112, 101, 114, 32, 77, 111, 100, 101, 34, 93, 44, 32, 34,
    68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97,
    108, 115, 101, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34,
    84, 121, 112, 101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97,
    109, 101, 34, 58, 32, 34, 100, 101, 118, 77, 111, 100, 101, 83, 113, 116, 116, 73, 110, 115, 116, 114, 117, 99, 116,
    105, 111, 110, 84, 114, 97, 99, 101, 69, 110, 97, 98, 108, 101, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34,
    68, 101, 118, 77, 111, 100, 101, 83, 113, 116, 116, 73, 110, 115, 116, 114, 117, 99, 116, 105, 111, 110, 84, 114,
    97, 99, 101, 69, 110, 97, 98, 108, 101, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 50, 52, 57,
    56, 55, 52, 53, 52, 52, 53, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32,
    34, 84, 97, 114, 103, 101, 116, 32, 65, 80, 73, 32, 80, 83, 79, 32, 104, 97, 115, 104, 32, 117, 115, 101, 100, 32,
    116, 111, 32, 116, 114, 105, 103, 103, 101, 114, 32, 105, 110, 115, 116, 114, 117, 99, 116, 105, 111, 110, 32, 108,
    101, 118, 101, 108, 32, 116, 114, 97, 99, 105, 110, 103, 46, 32, 70, 117, 108, 108, 45, 102, 114, 97, 109, 101, 32,
    105, 110, 115, 116, 114, 117, 99, 116, 105, 111, 110, 116, 114, 97, 99, 105, 110, 103, 32, 119, 105, 108, 108, 32,
    98, 101, 32, 101, 110, 97, 98, 108, 101, 100, 32, 105, 102, 32, 115, 101, 116, 32, 116, 111, 32, 48, 120, 48, 46,
    32, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 68, 101, 118, 101, 108, 111, 112, 101, 114, 32, 77, 111,
    100, 101, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108,
    116, 34, 58, 32, 48, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44,
    32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 54, 52, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98,
    108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 100, 101, 118, 77, 111, 100, 101, 83, 113, 116, 116, 84, 97, 114, 103,
    101, 116, 65, 112, 105, 80, 115, 111, 72, 97, 115, 104, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 101,
    118, 77, 111, 100, 101, 83, 113, 116, 116, 84, 97, 114, 103, 101, 116, 65, 112, 105, 80, 115, 111, 72, 97, 115, 104,
    34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 51, 56, 49, 48, 56, 55, 48, 57, 57, 54, 125, 44, 32,
    123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 73, 102, 32, 84, 82, 85, 69, 44, 32,
    116, 104, 101, 32, 100, 114, 105, 118, 101, 114, 32, 119, 105, 108, 108, 32, 98, 108, 111, 99, 107, 32, 105, 109,
    109, 101, 100, 105, 97, 116, 101, 108, 121, 32, 97, 102, 116, 101, 114, 32, 101, 110, 100, 105, 110, 103, 32, 97,
    32, 116, 114, 97, 99, 101, 32, 116, 111, 32, 119, 97, 105, 116, 32, 102, 111, 114, 32, 114, 101, 115, 117, 108, 116,
    115, 32, 116, 111, 99, 111, 109, 112, 108, 101, 116, 101, 32, 114, 97, 116, 104, 101, 114, 32, 116, 104, 97, 110,
    32, 97, 115, 121, 110, 99, 104, 114, 111, 110, 111, 117, 115, 108, 121, 32, 99, 104, 101, 99, 107, 105, 110, 103,
    32, 102, 111, 114, 32, 99, 111, 109, 112, 108, 101, 116, 105, 111, 110, 32, 100, 117, 114, 105, 110, 103, 32, 102,
    114, 97, 109, 101, 32, 98, 111, 117, 110, 100, 97, 114, 105, 101, 115, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58,
    32, 91, 34, 68, 101, 118, 101, 108, 111, 112, 101, 114, 32, 77, 111, 100, 101, 34, 93, 44, 32, 34, 68, 101, 102, 97,
    117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115, 101, 125,
    44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101,
    34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32,
    34, 100, 101, 118, 77, 111, 100, 101, 83, 113, 116, 116, 70, 111, 114, 99, 101, 66, 108, 111, 99, 107, 79, 110, 84,
    114, 97, 99, 101, 69, 110, 100, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 101, 118, 77, 111, 100, 101,
    83, 113, 116, 116, 70, 111, 114, 99, 101, 66, 108, 111, 99, 107, 79, 110, 84, 114, 97, 99, 101, 69, 110, 100, 34,
    44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 50, 50, 57, 51, 57, 54, 51, 50, 53, 50, 125, 44, 32,
    123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 73, 102, 32, 110, 111, 110, 45, 100,
    101, 102, 97, 117, 108, 116, 44, 32, 116, 104, 105, 115, 32, 118, 97, 108, 117, 101, 32, 119, 105, 108, 108, 32,
    111, 118, 101, 114, 114, 105, 100, 101, 32, 116, 104, 101, 32, 116, 114, 97, 99, 101, 32, 112, 97, 114, 97, 109,
    101, 116, 101, 114, 32, 112, 114, 101, 112, 97, 114, 101, 32, 102, 114, 97, 109, 101, 32, 99, 111, 117, 110, 116,
    44, 32, 119, 104, 105, 99, 104, 32, 105, 115, 116, 104, 101, 32, 110, 117, 109, 98, 101, 114, 32, 111, 102, 32, 108,
    101, 97, 100, 32, 102, 114, 97, 109, 101, 115, 32, 112, 114, 105, 111, 114, 32, 116, 111, 32, 101, 110, 97, 98, 108,
    105, 110, 103, 32, 83, 81, 84, 84, 32, 116, 104, 97, 116, 32, 105, 110, 99, 108, 117, 100, 101, 32, 111, 110, 108,
    121, 32, 113, 117, 101, 117, 101, 32, 116, 105, 109, 105, 110, 103, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58,
    32, 91, 34, 68, 101, 118, 101, 108, 111, 112, 101, 114, 32, 77, 111, 100, 101, 34, 93, 44, 32, 34, 68, 101, 102, 97,
    117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 52, 50, 57, 52, 57, 54, 55,
    50, 57, 53, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84,
    121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78,
    97, 109, 101, 34, 58, 32, 34, 100, 101, 118, 77, 111, 100, 101, 83, 113, 116, 116, 80, 114, 101, 112, 97, 114, 101,
    70, 114, 97, 109, 101, 67, 111, 117, 110, 116, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 101, 118, 77,
    111, 100, 101, 83, 113, 116, 116, 80, 114, 101, 112, 97, 114, 101, 70, 114, 97, 109, 101, 67, 111, 117, 110, 116,
    34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 49, 57, 48, 52, 52, 53, 48, 49, 53, 52, 125, 44, 32,
    123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 79, 118, 101, 114, 114, 105, 100, 101, 83, 104, 97, 100, 101, 114, 80,
    97, 114, 97, 109, 115, 34, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 73, 110,
    100, 105, 99, 97, 116, 101, 32, 116, 104, 97, 116, 32, 115, 104, 97, 100, 101, 114, 32, 112, 97, 114, 97, 109, 101,
    116, 101, 114, 32, 111, 118, 101, 114, 114, 105, 100, 101, 32, 105, 115, 32, 101, 110, 97, 98, 108, 101, 100, 32,
    45, 32, 109, 97, 105, 110, 108, 121, 32, 117, 115, 101, 100, 32, 102, 111, 114, 32, 97, 117, 116, 111, 109, 97, 116,
    105, 111, 110, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 104, 97, 100, 101, 114, 32, 84, 117, 110,
    105, 110, 103, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117,
    108, 116, 34, 58, 32, 102, 97, 108, 115, 101, 125, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 98, 111, 111, 108,
    34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 111, 118, 101, 114, 114, 105,
    100, 101, 83, 104, 97, 100, 101, 114, 80, 97, 114, 97, 109, 115, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32,
    34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 49, 53, 50, 50, 53,
    56, 52, 54, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 79, 118, 101, 114, 114, 105, 100, 101, 83, 104,
    97, 100, 101, 114, 72, 97, 115, 104, 85, 112, 112, 101, 114, 34, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116,
    105, 111, 110, 34, 58, 32, 34, 85, 112, 112, 101, 114, 32, 54, 52, 45, 98, 105, 116, 115, 32, 111, 102, 32, 116,
    104, 101, 32, 115, 104, 97, 100, 101, 114, 32, 104, 97, 115, 104, 32, 111, 102, 32, 115, 104, 97, 100, 101, 114, 32,
    102, 111, 114, 32, 119, 104, 105, 99, 104, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 32, 97, 114, 101, 32,
    116, 111, 32, 98, 101, 32, 111, 118, 101, 114, 114, 105, 100, 100, 101, 110, 34, 44, 32, 34, 84, 97, 103, 115, 34,
    58, 32, 91, 34, 83, 104, 97, 100, 101, 114, 32, 84, 117, 110, 105, 110, 103, 34, 93, 44, 32, 34, 70, 108, 97, 103,
    115, 34, 58, 32, 123, 34, 73, 115, 72, 101, 120, 34, 58, 32, 116, 114, 117, 101, 44, 32, 34, 73, 115, 66, 105, 116,
    109, 97, 115, 107, 34, 58, 32, 116, 114, 117, 101, 125, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58,
    32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 48, 125, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34,
    117, 105, 110, 116, 54, 52, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34,
    111, 118, 101, 114, 114, 105, 100, 101, 83, 104, 97, 100, 101, 114, 72, 97, 115, 104, 85, 112, 112, 101, 114, 34,
    44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 72, 97, 115, 104,
    78, 97, 109, 101, 34, 58, 32, 52, 48, 51, 52, 54, 57, 54, 48, 54, 48, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34,
    58, 32, 34, 79, 118, 101, 114, 114, 105, 100, 101, 83, 104, 97, 100, 101, 114, 72, 97, 115, 104, 76, 111, 119, 101,
    114, 34, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 76, 111, 119, 101, 114,
    32, 54, 52, 45, 98, 105, 116, 115, 32, 111, 102, 32, 116, 104, 101, 32, 115, 104, 97, 100, 101, 114, 32, 104, 97,
    115, 104, 32, 111, 102, 32, 115, 104, 97, 100, 101, 114, 32, 102, 111, 114, 32, 119, 104, 105, 99, 104, 32, 112, 97,
    114, 97, 109, 101, 116, 101, 114, 115, 32, 97, 114, 101, 32, 116, 111, 32, 98, 101, 32, 111, 118, 101, 114, 114,
    105, 100, 100, 101, 110, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 104, 97, 100, 101, 114, 32, 84,
    117, 110, 105, 110, 103, 34, 93, 44, 32, 34, 70, 108, 97, 103, 115, 34, 58, 32, 123, 34, 73, 115, 72, 101, 120, 34,
    58, 32, 116, 114, 117, 101, 44, 32, 34, 73, 115, 66, 105, 116, 109, 97, 115, 107, 34, 58, 32, 116, 114, 117, 101,
    125, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58,
    32, 48, 125, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 54, 52, 34, 44, 32, 34, 86, 97, 114,
    105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 111, 118, 101, 114, 114, 105, 100, 101, 83, 104, 97, 100,
    101, 114, 72, 97, 115, 104, 76, 111, 119, 101, 114, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114,
    105, 118, 101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 57, 53, 49, 49, 48, 48, 49, 57,
    55, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 79, 118, 101, 114, 114, 105, 100, 101, 83, 104, 97, 100,
    101, 114, 83, 116, 97, 103, 101, 34, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32,
    34, 83, 104, 97, 100, 101, 114, 32, 115, 116, 97, 103, 101, 32, 102, 111, 114, 32, 119, 104, 105, 99, 104, 32, 112,
    97, 114, 97, 109, 101, 116, 101, 114, 115, 32, 97, 114, 101, 32, 116, 111, 32, 98, 101, 32, 111, 118, 101, 114, 114,
    105, 100, 101, 110, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 104, 97, 100, 101, 114, 32, 84,
    117, 110, 105, 110, 103, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101,
    102, 97, 117, 108, 116, 34, 58, 32, 52, 125, 44, 32, 34, 86, 97, 108, 105, 100, 86, 97, 108, 117, 101, 115, 34, 58,
    32, 123, 34, 86, 97, 108, 117, 101, 115, 34, 58, 32, 91, 123, 34, 86, 97, 108, 117, 101, 34, 58, 32, 48, 44, 32, 34,
    68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 86, 101, 114, 116, 101, 120, 32, 83, 104, 97,
    100, 101, 114, 34, 125, 44, 32, 123, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 44, 32, 34, 68, 101, 115, 99, 114,
    105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 84, 101, 115, 115, 101, 108, 108, 97, 116, 105, 111, 110, 32, 67, 111,
    110, 116, 114, 111, 108, 32, 83, 104, 97, 100, 101, 114, 34, 125, 44, 32, 123, 34, 86, 97, 108, 117, 101, 34, 58,
    32, 50, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 84, 101, 115, 115, 101,
    108, 108, 97, 116, 105, 111, 110, 32, 69, 118, 97, 108, 117, 97, 116, 105, 111, 110, 32, 83, 104, 97, 100, 101, 114,
    34, 125, 44, 32, 123, 34, 86, 97, 108, 117, 101, 34, 58, 32, 51, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116,
    105, 111, 110, 34, 58, 32, 34, 71, 101, 111, 109, 101, 116, 114, 121, 32, 83, 104, 97, 100, 101, 114, 34, 125, 44,
    32, 123, 34, 86, 97, 108, 117, 101, 34, 58, 32, 52, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110,
    34, 58, 32, 34, 70, 114, 97, 103, 109, 101, 110, 116, 32, 83, 104, 97, 100, 101, 114, 34, 125, 44, 32, 123, 34, 86,
    97, 108, 117, 101, 34, 58, 32, 53, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34,
    67, 111, 109, 112, 117, 116, 101, 32, 83, 104, 97, 100, 101, 114, 34, 125, 93, 125, 44, 32, 34, 84, 121, 112, 101,
    34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101,
    34, 58, 32, 34, 111, 118, 101, 114, 114, 105, 100, 101, 83, 104, 97, 100, 101, 114, 83, 116, 97, 103, 101, 34, 44,
    32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78,
    97, 109, 101, 34, 58, 32, 50, 48, 53, 56, 55, 51, 56, 48, 54, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112,
    116, 105, 111, 110, 34, 58, 32, 34, 79, 118, 101, 114, 114, 105, 100, 101, 32, 110, 117, 109, 98, 101, 114, 32, 111,
    102, 32, 97, 118, 97, 105, 108, 97, 98, 108, 101, 32, 86, 71, 80, 82, 115, 32, 102, 111, 114, 32, 116, 104, 101, 32,
    115, 104, 97, 100, 101, 114, 32, 115, 112, 101, 99, 105, 102, 105, 101, 100, 32, 98, 121, 32, 111, 118, 101, 114,
    114, 105, 100, 101, 83, 104, 97, 100, 101, 114, 67, 114, 99, 85, 112, 112, 101, 114, 47, 76, 111, 119, 101, 114, 34,
    44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 104, 97, 100, 101, 114, 32, 84, 117, 110, 105, 110, 103, 34,
    93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58,
    32, 48, 125, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114,
    105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 111, 118, 101, 114, 114, 105, 100, 101, 78, 117, 109, 86,
    71, 80, 82, 115, 65, 118, 97, 105, 108, 97, 98, 108, 101, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 79, 118,
    101, 114, 114, 105, 100, 101, 78, 117, 109, 86, 71, 80, 82, 115, 65, 118, 97, 105, 108, 97, 98, 108, 101, 34, 44,
    32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78,
    97, 109, 101, 34, 58, 32, 49, 56, 50, 54, 55, 49, 55, 54, 49, 52, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105,
    112, 116, 105, 111, 110, 34, 58, 32, 34, 79, 118, 101, 114, 114, 105, 100, 101, 32, 110, 117, 109, 98, 101, 114, 32,
    111, 102, 32, 119, 97, 118, 101, 115, 32, 112, 101, 114, 32, 67, 85, 32, 102, 111, 114, 32, 116, 104, 101, 32, 115,
    104, 97, 100, 101, 114, 32, 115, 112, 101, 99, 105, 102, 105, 101, 100, 32, 98, 121, 32, 111, 118, 101, 114, 114,
    105, 100, 101, 83, 104, 97, 100, 101, 114, 67, 114, 99, 85, 112, 112, 101, 114, 47, 76, 111, 119, 101, 114, 34, 44,
    32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 104, 97, 100, 101, 114, 32, 84, 117, 110, 105, 110, 103, 34, 93,
    44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32,
    48, 125, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114,
    105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 111, 118, 101, 114, 114, 105, 100, 101, 87, 97, 118, 101,
    115, 80, 101, 114, 67, 117, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 79, 118, 101, 114, 114, 105, 100, 101,
    87, 97, 118, 101, 115, 80, 101, 114, 67, 117, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105,
    118, 101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 50, 57, 55, 56, 49, 48, 55, 50, 56,
    125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 70, 111, 114, 99, 101,
    32, 80, 65, 76, 32, 116, 111, 32, 115, 112, 105, 108, 108, 32, 117, 115, 101, 114, 32, 100, 97, 116, 97, 32, 114,
    101, 103, 105, 115, 116, 101, 114, 115, 32, 116, 111, 32, 109, 101, 109, 111, 114, 121, 32, 102, 111, 114, 32, 116,
    104, 101, 32, 115, 104, 97, 100, 101, 114, 32, 115, 112, 101, 99, 105, 102, 105, 101, 100, 32, 98, 121, 32, 111,
    118, 101, 114, 114, 105, 100, 101, 83, 104, 97, 100, 101, 114, 67, 114, 99, 85, 112, 112, 101, 114, 47, 76, 111,
    119, 101, 114, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 104, 97, 100, 101, 114, 32, 84, 117, 110,
    105, 110, 103, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117,
    108, 116, 34, 58, 32, 102, 97, 108, 115, 101, 125, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 98, 111, 111, 108,
    34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 111, 118, 101, 114, 114, 105,
    100, 101, 85, 115, 101, 114, 68, 97, 116, 97, 83, 112, 105, 108, 108, 84, 104, 114, 101, 115, 104, 111, 108, 100,
    34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 79, 118, 101, 114, 114, 105, 100, 101, 85, 115, 101, 114, 68, 97,
    116, 97, 83, 112, 105, 108, 108, 84, 104, 114, 101, 115, 104, 111, 108, 100, 34, 44, 32, 34, 83, 99, 111, 112, 101,
    34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 50, 55,
    54, 57, 57, 48, 48, 53, 52, 55, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58,
    32, 34, 83, 101, 116, 32, 116, 104, 101, 32, 109, 97, 120, 32, 76, 68, 83, 32, 115, 112, 105, 108, 108, 32, 115,
    105, 122, 101, 32, 105, 110, 32, 68, 87, 79, 82, 68, 115, 32, 102, 111, 114, 32, 116, 104, 101, 32, 115, 104, 97,
    100, 101, 114, 32, 115, 112, 101, 99, 105, 102, 105, 101, 100, 32, 98, 121, 32, 111, 118, 101, 114, 114, 105, 100,
    101, 83, 104, 97, 100, 101, 114, 67, 114, 99, 85, 112, 112, 101, 114, 47, 76, 111, 119, 101, 114, 34, 44, 32, 34,
    84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 104, 97, 100, 101, 114, 32, 84, 117, 110, 105, 110, 103, 34, 93, 44, 32,
    34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 48, 125,
    44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98,
    108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 111, 118, 101, 114, 114, 105, 100, 101, 77, 97, 120, 76, 100, 115, 83,
    112, 105, 108, 108, 68, 119, 111, 114, 100, 115, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 79, 118, 101,
    114, 114, 105, 100, 101, 77, 97, 120, 76, 100, 115, 83, 112, 105, 108, 108, 68, 119, 111, 114, 100, 115, 34, 44, 32,
    34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97,
    109, 101, 34, 58, 32, 49, 54, 53, 49, 51, 57, 54, 48, 49, 55, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112,
    116, 105, 111, 110, 34, 58, 32, 34, 83, 101, 116, 32, 116, 104, 101, 32, 116, 104, 114, 101, 97, 100, 45, 103, 114,
    111, 117, 112, 32, 112, 101, 114, 32, 67, 85, 32, 108, 105, 109, 105, 116, 32, 102, 111, 114, 32, 99, 111, 109, 112,
    117, 116, 101, 32, 115, 104, 97, 100, 101, 114, 115, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83,
    104, 97, 100, 101, 114, 32, 84, 117, 110, 105, 110, 103, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115,
    34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 48, 125, 44, 32, 34, 84, 121, 112, 101, 34, 58,
    32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58,
    32, 34, 111, 118, 101, 114, 114, 105, 100, 101, 67, 115, 84, 103, 80, 101, 114, 67, 117, 34, 44, 32, 34, 78, 97,
    109, 101, 34, 58, 32, 34, 79, 118, 101, 114, 114, 105, 100, 101, 67, 115, 84, 103, 80, 101, 114, 67, 117, 34, 44,
    32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78,
    97, 109, 101, 34, 58, 32, 50, 56, 57, 56, 57, 52, 48, 53, 52, 49, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58,
    32, 34, 79, 118, 101, 114, 114, 105, 100, 101, 85, 115, 101, 80, 98, 98, 80, 101, 114, 67, 114, 99, 34, 44, 32, 34,
    68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 83, 101, 116, 32, 111, 112, 116, 105, 111, 110,
    32, 116, 111, 32, 100, 105, 115, 97, 98, 108, 101, 32, 80, 66, 66, 32, 102, 111, 114, 32, 115, 104, 97, 100, 101,
    114, 32, 115, 112, 101, 99, 105, 102, 105, 101, 100, 32, 98, 121, 32, 79, 118, 101, 114, 114, 105, 100, 101, 83,
    104, 97, 100, 101, 114, 67, 114, 99, 85, 112, 112, 101, 114, 32, 97, 110, 100, 32, 79, 118, 101, 114, 114, 105, 100,
    101, 83, 104, 97, 100, 101, 114, 67, 114, 99, 76, 111, 119, 101, 114, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32,
    91, 34, 83, 104, 97, 100, 101, 114, 32, 84, 117, 110, 105, 110, 103, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108,
    116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 34, 80, 105, 112, 101, 108, 105, 110,
    101, 66, 105, 110, 110, 105, 110, 103, 77, 111, 100, 101, 68, 101, 102, 97, 117, 108, 116, 34, 125, 44, 32, 34, 86,
    97, 108, 105, 100, 86, 97, 108, 117, 101, 115, 34, 58, 32, 123, 34, 86, 97, 108, 117, 101, 115, 34, 58, 32, 91, 123,
    34, 78, 97, 109, 101, 34, 58, 32, 34, 80, 105, 112, 101, 108, 105, 110, 101, 66, 105, 110, 110, 105, 110, 103, 77,
    111, 100, 101, 68, 101, 102, 97, 117, 108, 116, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 48, 44, 32, 34,
    68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 70, 111, 108, 108, 111, 119, 32, 116, 104, 101,
    32, 98, 101, 104, 97, 118, 105, 111, 114, 32, 111, 102, 32, 116, 104, 101, 32, 80, 105, 112, 101, 108, 105, 110,
    101, 66, 105, 110, 110, 105, 110, 103, 77, 111, 100, 101, 32, 115, 101, 116, 116, 105, 110, 103, 46, 34, 125, 44,
    32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 80, 105, 112, 101, 108, 105, 110, 101, 66, 105, 110, 110, 105, 110,
    103, 77, 111, 100, 101, 68, 105, 115, 97, 98, 108, 101, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 44,
    32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 70, 111, 114, 99, 101, 32, 80, 66, 66,
    32, 111, 102, 102, 32, 102, 111, 114, 32, 115, 104, 97, 100, 101, 114, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101,
    34, 58, 32, 34, 80, 105, 112, 101, 108, 105, 110, 101, 66, 105, 110, 110, 105, 110, 103, 77, 111, 100, 101, 69, 110,
    97, 98, 108, 101, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 50, 44, 32, 34, 68, 101, 115, 99, 114, 105,
    112, 116, 105, 111, 110, 34, 58, 32, 34, 70, 111, 114, 99, 101, 32, 80, 66, 66, 32, 111, 110, 32, 102, 111, 114, 32,
    115, 104, 97, 100, 101, 114, 34, 125, 93, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 80, 105, 112, 101, 108, 105,
    110, 101, 66, 105, 110, 110, 105, 110, 103, 77, 111, 100, 101, 34, 125, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32,
    34, 101, 110, 117, 109, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 111,
    118, 101, 114, 114, 105, 100, 101, 85, 115, 101, 80, 98, 98, 80, 101, 114, 67, 114, 99, 34, 44, 32, 34, 83, 99, 111,
    112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58,
    32, 50, 52, 55, 49, 57, 48, 49, 50, 57, 49, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111,
    110, 34, 58, 32, 34, 79, 118, 101, 114, 114, 105, 100, 101, 32, 97, 108, 108, 111, 119, 82, 101, 90, 32, 102, 111,
    114, 32, 116, 104, 101, 32, 115, 104, 97, 100, 101, 114, 32, 115, 112, 101, 99, 105, 102, 105, 101, 100, 32, 98,
    121, 32, 79, 118, 101, 114, 114, 105, 100, 101, 83, 104, 97, 100, 101, 114, 72, 97, 115, 104, 85, 112, 112, 101,
    114, 47, 76, 111, 119, 101, 114, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 104, 97, 100, 101,
    114, 32, 84, 117, 110, 105, 110, 103, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34,
    68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115, 101, 125, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32,
    34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 111,
    118, 101, 114, 114, 105, 100, 101, 65, 108, 108, 111, 119, 82, 101, 90, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58,
    32, 34, 79, 118, 101, 114, 114, 105, 100, 101, 65, 108, 108, 111, 119, 82, 101, 90, 34, 44, 32, 34, 83, 99, 111,
    112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58,
    32, 50, 53, 57, 54, 51, 57, 52, 57, 54, 55, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 79, 118, 101,
    114, 114, 105, 100, 101, 87, 97, 118, 101, 83, 105, 122, 101, 34, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116,
    105, 111, 110, 34, 58, 32, 34, 79, 118, 101, 114, 114, 105, 100, 101, 32, 87, 97, 118, 101, 83, 105, 122, 101, 32,
    102, 111, 114, 32, 116, 104, 101, 32, 115, 104, 97, 100, 101, 114, 32, 115, 112, 101, 99, 105, 102, 105, 101, 100,
    32, 98, 121, 32, 79, 118, 101, 114, 114, 105, 100, 101, 83, 104, 97, 100, 101, 114, 72, 97, 115, 104, 85, 112, 112,
    101, 114, 47, 76, 111, 119, 101, 114, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 104, 97, 100,
    101, 114, 32, 84, 117, 110, 105, 110, 103, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32,
    123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 34, 87, 97, 118, 101, 83, 105, 122, 101, 65, 117, 116, 111,
    34, 125, 44, 32, 34, 86, 97, 108, 105, 100, 86, 97, 108, 117, 101, 115, 34, 58, 32, 123, 34, 73, 115, 69, 110, 117,
    109, 34, 58, 32, 116, 114, 117, 101, 44, 32, 34, 86, 97, 108, 117, 101, 115, 34, 58, 32, 91, 123, 34, 78, 97, 109,
    101, 34, 58, 32, 34, 87, 97, 118, 101, 83, 105, 122, 101, 65, 117, 116, 111, 34, 44, 32, 34, 86, 97, 108, 117, 101,
    34, 58, 32, 48, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 76, 101, 116, 32,
    116, 104, 101, 32, 100, 114, 105, 118, 101, 114, 32, 112, 105, 99, 107, 32, 116, 104, 101, 32, 98, 101, 115, 116,
    32, 119, 97, 118, 101, 32, 115, 105, 122, 101, 32, 102, 111, 114, 32, 116, 104, 105, 115, 32, 115, 104, 97, 100,
    101, 114, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 87, 97, 118, 101, 83, 105, 122, 101, 54, 52,
    34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 50, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111,
    110, 34, 58, 32, 34, 70, 111, 114, 99, 101, 32, 119, 97, 118, 101, 32, 115, 105, 122, 101, 32, 116, 111, 32, 54, 52,
    32, 116, 104, 114, 101, 97, 100, 115, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 87, 97, 118, 101,
    83, 105, 122, 101, 51, 50, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 51, 44, 32, 34, 68, 101, 115, 99, 114,
    105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 70, 111, 114, 99, 101, 32, 119, 97, 118, 101, 32, 115, 105, 122, 101,
    32, 116, 111, 32, 51, 50, 32, 116, 104, 114, 101, 97, 100, 115, 34, 125, 93, 44, 32, 34, 78, 97, 109, 101, 34, 58,
    32, 34, 83, 104, 97, 100, 101, 114, 87, 97, 118, 101, 83, 105, 122, 101, 34, 125, 44, 32, 34, 70, 108, 97, 103, 115,
    34, 58, 32, 123, 34, 73, 115, 72, 101, 120, 34, 58, 32, 116, 114, 117, 101, 125, 44, 32, 34, 84, 121, 112, 101, 34,
    58, 32, 34, 101, 110, 117, 109, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32,
    34, 111, 118, 101, 114, 114, 105, 100, 101, 87, 97, 118, 101, 83, 105, 122, 101, 34, 44, 32, 34, 83, 99, 111, 112,
    101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32,
    51, 49, 49, 53, 50, 48, 51, 50, 53, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 79, 118, 101, 114, 114,
    105, 100, 101, 87, 103, 112, 77, 111, 100, 101, 34, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110,
    34, 58, 32, 34, 79, 118, 101, 114, 114, 105, 100, 101, 32, 87, 103, 112, 77, 111, 100, 101, 32, 102, 111, 114, 32,
    116, 104, 101, 32, 115, 104, 97, 100, 101, 114, 32, 115, 112, 101, 99, 105, 102, 105, 101, 100, 32, 98, 121, 32, 79,
    118, 101, 114, 114, 105, 100, 101, 83, 104, 97, 100, 101, 114, 72, 97, 115, 104, 85, 112, 112, 101, 114, 47, 76,
    111, 119, 101, 114, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 104, 97, 100, 101, 114, 32, 84, 117,
    110, 105, 110, 103, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97,
    117, 108, 116, 34, 58, 32, 34, 87, 103, 112, 77, 111, 100, 101, 65, 117, 116, 111, 34, 125, 44, 32, 34, 86, 97, 108,
    105, 100, 86, 97, 108, 117, 101, 115, 34, 58, 32, 123, 34, 73, 115, 69, 110, 117, 109, 34, 58, 32, 116, 114, 117,
    101, 44, 32, 34, 86, 97, 108, 117, 101, 115, 34, 58, 32, 91, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 87, 103,
    112, 77, 111, 100, 101, 65, 117, 116, 111, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 48, 44, 32, 34, 68,
    101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 76, 101, 116, 32, 116, 104, 101, 32, 100, 114, 105,
    118, 101, 114, 32, 112, 105, 99, 107, 32, 116, 104, 101, 32, 98, 101, 115, 116, 32, 87, 103, 112, 77, 111, 100, 101,
    32, 102, 111, 114, 32, 116, 104, 105, 115, 32, 115, 104, 97, 100, 101, 114, 34, 125, 44, 32, 123, 34, 78, 97, 109,
    101, 34, 58, 32, 34, 87, 103, 112, 77, 111, 100, 101, 67, 117, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32,
    49, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 65, 108, 108, 32, 52, 32, 83,
    73, 77, 68, 115, 32, 105, 110, 32, 97, 32, 119, 111, 114, 107, 103, 114, 111, 117, 112, 32, 112, 114, 111, 99, 101,
    115, 115, 111, 114, 32, 97, 114, 101, 32, 99, 111, 110, 115, 105, 100, 101, 114, 101, 100, 32, 119, 104, 101, 110,
    32, 119, 97, 118, 101, 115, 32, 97, 114, 101, 32, 97, 108, 108, 111, 99, 97, 116, 101, 100, 32, 102, 111, 114, 32,
    101, 120, 101, 99, 117, 116, 105, 111, 110, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 87, 103,
    112, 77, 111, 100, 101, 87, 103, 112, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 50, 44, 32, 34, 68, 101,
    115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 79, 110, 108, 121, 32, 116, 104, 101, 32, 50, 32, 83,
    73, 77, 68, 115, 32, 105, 110, 32, 97, 32, 67, 85, 32, 97, 114, 101, 32, 99, 111, 110, 115, 105, 100, 101, 114, 101,
    100, 32, 119, 104, 101, 110, 32, 119, 97, 118, 101, 115, 32, 97, 114, 101, 32, 97, 108, 108, 111, 99, 97, 116, 101,
    100, 32, 102, 111, 114, 32, 101, 120, 101, 99, 117, 116, 105, 111, 110, 34, 125, 93, 44, 32, 34, 78, 97, 109, 101,
    34, 58, 32, 34, 87, 103, 112, 77, 111, 100, 101, 34, 125, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 101, 110,
    117, 109, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 111, 118, 101, 114,
    114, 105, 100, 101, 87, 103, 112, 77, 111, 100, 101, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114,
    105, 118, 101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 52, 50, 52, 55, 49, 54, 56, 49,
    49, 48, 125, 44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 79, 118, 101,
    114, 114, 105, 100, 101, 32, 100, 101, 102, 97, 117, 108, 116, 32, 115, 101, 116, 116, 105, 110, 103, 32, 116, 111,
    32, 100, 105, 115, 97, 98, 108, 101, 32, 108, 111, 111, 112, 32, 117, 110, 114, 111, 108, 108, 115, 34, 44, 32, 34,
    84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 104, 97, 100, 101, 114, 32, 84, 117, 110, 105, 110, 103, 34, 93, 44, 32,
    34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97,
    108, 115, 101, 125, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114,
    105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 111, 118, 101, 114, 114, 105, 100, 101, 68, 105, 115, 97,
    98, 108, 101, 76, 111, 111, 112, 85, 110, 114, 111, 108, 108, 115, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34,
    79, 118, 101, 114, 114, 105, 100, 101, 68, 105, 115, 97, 98, 108, 101, 76, 111, 111, 112, 85, 110, 114, 111, 108,
    108, 115, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 72,
    97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 50, 48, 55, 55, 57, 51, 57, 56, 51, 48, 125, 44, 32, 123, 34, 68, 101,
    115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 91, 76, 76, 80, 67, 32, 79, 78, 76, 89, 93, 32, 85, 115,
    101, 32, 76, 76, 86, 77, 32, 98, 97, 99, 107, 101, 110, 100, 39, 115, 32, 83, 73, 32, 83, 99, 104, 101, 100, 117,
    108, 101, 114, 32, 105, 110, 115, 116, 101, 97, 100, 32, 111, 102, 32, 116, 104, 101, 32, 100, 101, 102, 97, 117,
    108, 116, 32, 115, 99, 104, 101, 100, 117, 108, 101, 114, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83,
    104, 97, 100, 101, 114, 32, 84, 117, 110, 105, 110, 103, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115,
    34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115, 101, 125, 44, 32, 34, 84, 121,
    112, 101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101,
    34, 58, 32, 34, 111, 118, 101, 114, 114, 105, 100, 101, 85, 115, 101, 83, 105, 83, 99, 104, 101, 100, 117, 108, 101,
    114, 34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 79, 118, 101, 114, 114, 105, 100, 101, 85, 115, 101, 83, 105,
    83, 99, 104, 101, 100, 117, 108, 101, 114, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118,
    101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 57, 57, 53, 50, 52, 57, 55, 48, 53, 125,
    44, 32, 123, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 91, 76, 76, 80, 67, 32, 79,
    78, 76, 89, 93, 32, 65, 108, 108, 111, 119, 32, 97, 117, 116, 111, 109, 97, 116, 105, 99, 32, 119, 111, 114, 107,
    103, 114, 111, 117, 112, 32, 114, 101, 99, 111, 110, 102, 105, 103, 117, 114, 101, 32, 116, 111, 32, 116, 97, 107,
    101, 32, 112, 108, 97, 99, 101, 32, 111, 110, 32, 99, 111, 109, 112, 117, 116, 101, 32, 115, 104, 97, 100, 101, 114,
    115, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 83, 104, 97, 100, 101, 114, 32, 84, 117, 110, 105, 110,
    103, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116,
    34, 58, 32, 102, 97, 108, 115, 101, 125, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44,
    32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 111, 118, 101, 114, 114, 105, 100,
    101, 82, 101, 99, 111, 110, 102, 105, 103, 87, 111, 114, 107, 103, 114, 111, 117, 112, 76, 97, 121, 111, 117, 116,
    34, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 79, 118, 101, 114, 114, 105, 100, 101, 82, 101, 99, 111, 110, 102,
    105, 103, 87, 111, 114, 107, 103, 114, 111, 117, 112, 76, 97, 121, 111, 117, 116, 34, 44, 32, 34, 83, 99, 111, 112,
    101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32,
    51, 55, 48, 53, 53, 48, 57, 52, 54, 56, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 82, 101, 115, 111,
    117, 114, 99, 101, 80, 114, 111, 102, 105, 108, 101, 73, 103, 110, 111, 114, 101, 115, 65, 112, 112, 80, 114, 111,
    102, 105, 108, 101, 34, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 73, 102,
    32, 116, 104, 105, 115, 32, 105, 115, 32, 116, 114, 117, 101, 44, 32, 97, 110, 121, 32, 112, 114, 111, 100, 117, 99,
    116, 105, 111, 110, 32, 97, 112, 112, 32, 112, 114, 111, 102, 105, 108, 101, 45, 105, 110, 115, 116, 97, 108, 108,
    101, 100, 32, 114, 101, 115, 111, 117, 114, 99, 101, 32, 111, 112, 116, 105, 109, 105, 122, 97, 116, 105, 111, 110,
    115, 32, 97, 114, 101, 32, 105, 103, 110, 111, 114, 101, 100, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91,
    34, 82, 101, 115, 111, 117, 114, 99, 101, 32, 84, 117, 110, 105, 110, 103, 34, 93, 44, 32, 34, 68, 101, 102, 97,
    117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108, 115, 101, 125,
    44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 84, 121, 112, 101,
    34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32,
    34, 114, 101, 115, 111, 117, 114, 99, 101, 80, 114, 111, 102, 105, 108, 101, 73, 103, 110, 111, 114, 101, 115, 65,
    112, 112, 80, 114, 111, 102, 105, 108, 101, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 51, 50,
    53, 57, 55, 48, 57, 49, 57, 55, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 79, 118, 101, 114, 114, 105,
    100, 101, 82, 101, 115, 111, 117, 114, 99, 101, 80, 97, 114, 97, 109, 115, 34, 44, 32, 34, 68, 101, 115, 99, 114,
    105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 73, 110, 100, 105, 99, 97, 116, 101, 32, 116, 104, 97, 116, 32, 114,
    101, 115, 111, 117, 114, 99, 101, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 32, 111, 118, 101, 114, 114, 105,
    100, 101, 32, 105, 115, 32, 101, 110, 97, 98, 108, 101, 100, 32, 45, 32, 109, 97, 105, 110, 108, 121, 32, 117, 115,
    101, 100, 32, 102, 111, 114, 32, 97, 117, 116, 111, 109, 97, 116, 105, 111, 110, 34, 44, 32, 34, 84, 97, 103, 115,
    34, 58, 32, 91, 34, 82, 101, 115, 111, 117, 114, 99, 101, 32, 84, 117, 110, 105, 110, 103, 34, 93, 44, 32, 34, 68,
    101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 102, 97, 108,
    115, 101, 125, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 98, 111, 111, 108, 34, 44, 32, 34, 86, 97, 114, 105,
    97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 111, 118, 101, 114, 114, 105, 100, 101, 82, 101, 115, 111, 117,
    114, 99, 101, 80, 97, 114, 97, 109, 115, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118,
    101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 50, 52, 57, 52, 50, 50, 50, 52, 53, 57,
    125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 79, 118, 101, 114, 114, 105, 100, 101, 82, 101, 115, 111,
    117, 114, 99, 101, 72, 97, 115, 104, 68, 105, 109, 101, 110, 115, 105, 111, 110, 115, 34, 44, 32, 34, 68, 101, 115,
    99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 84, 104, 101, 32, 119, 105, 100, 116, 104, 32, 40, 117, 112,
    112, 101, 114, 32, 51, 50, 45, 98, 105, 116, 115, 41, 32, 97, 110, 100, 32, 104, 101, 105, 103, 104, 116, 32, 40,
    108, 111, 119, 101, 114, 32, 51, 50, 45, 98, 105, 116, 115, 41, 32, 111, 102, 32, 116, 104, 101, 32, 114, 101, 115,
    111, 117, 114, 99, 101, 40, 115, 41, 32, 111, 110, 116, 111, 32, 119, 104, 105, 99, 104, 32, 116, 104, 101, 32, 112,
    97, 114, 97, 109, 101, 116, 101, 114, 115, 32, 97, 114, 101, 32, 116, 111, 32, 98, 101, 32, 97, 112, 112, 108, 105,
    101, 100, 46, 32, 73, 102, 32, 48, 44, 32, 116, 104, 101, 32, 100, 105, 109, 101, 110, 115, 105, 111, 110, 115, 32,
    119, 105, 108, 108, 32, 98, 101, 32, 109, 97, 116, 99, 104, 101, 100, 32, 117, 112, 46, 32, 34, 44, 32, 34, 84, 97,
    103, 115, 34, 58, 32, 91, 34, 82, 101, 115, 111, 117, 114, 99, 101, 32, 84, 117, 110, 105, 110, 103, 34, 93, 44, 32,
    34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 48, 125,
    44, 32, 34, 70, 108, 97, 103, 115, 34, 58, 32, 123, 34, 73, 115, 72, 101, 120, 34, 58, 32, 116, 114, 117, 101, 125,
    44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 54, 52, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98,
    108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 111, 118, 101, 114, 114, 105, 100, 101, 82, 101, 115, 111, 117, 114, 99,
    101, 72, 97, 115, 104, 68, 105, 109, 101, 110, 115, 105, 111, 110, 115, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34,
    58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 51, 57, 56,
    56, 57, 52, 51, 51, 57, 54, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 79, 118, 101, 114, 114, 105,
    100, 101, 82, 101, 115, 111, 117, 114, 99, 101, 72, 97, 115, 104, 67, 114, 99, 34, 44, 32, 34, 68, 101, 115, 99,
    114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 84, 104, 101, 32, 65, 80, 73, 32, 104, 97, 115, 104, 32, 111,
    102, 32, 116, 104, 101, 32, 114, 101, 115, 111, 117, 114, 99, 101, 40, 115, 41, 32, 111, 110, 116, 111, 32, 119,
    104, 105, 99, 104, 32, 116, 104, 101, 32, 112, 97, 114, 97, 109, 101, 116, 101, 114, 115, 32, 97, 114, 101, 32, 116,
    111, 32, 98, 101, 32, 97, 112, 112, 108, 105, 101, 100, 46, 32, 73, 102, 32, 48, 44, 32, 116, 104, 101, 32, 65, 80,
    73, 32, 104, 97, 115, 104, 32, 119, 105, 108, 108, 32, 110, 111, 116, 32, 98, 101, 32, 109, 97, 116, 99, 104, 101,
    100, 32, 117, 112, 46, 32, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 82, 101, 115, 111, 117, 114, 99,
    101, 32, 84, 117, 110, 105, 110, 103, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34,
    68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 48, 125, 44, 32, 34, 70, 108, 97, 103, 115, 34, 58, 32, 123, 34, 73,
    115, 72, 101, 120, 34, 58, 32, 116, 114, 117, 101, 125, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 117, 105,
    110, 116, 54, 52, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 111, 118,
    101, 114, 114, 105, 100, 101, 82, 101, 115, 111, 117, 114, 99, 101, 72, 97, 115, 104, 67, 114, 99, 34, 44, 32, 34,
    83, 99, 111, 112, 101, 34, 58, 32, 34, 68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109,
    101, 34, 58, 32, 49, 51, 55, 49, 49, 54, 51, 52, 57, 51, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 79,
    118, 101, 114, 114, 105, 100, 101, 82, 101, 115, 111, 117, 114, 99, 101, 68, 99, 99, 79, 110, 79, 102, 102, 34, 44,
    32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 70, 111, 114, 99, 101, 32, 109, 101,
    116, 97, 100, 97, 116, 97, 32, 116, 111, 32, 98, 101, 32, 101, 110, 97, 98, 108, 101, 100, 32, 111, 114, 32, 100,
    105, 115, 97, 98, 108, 101, 100, 32, 102, 111, 114, 32, 116, 104, 101, 32, 114, 101, 115, 111, 117, 114, 99, 101,
    46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 82, 101, 115, 111, 117, 114, 99, 101, 32, 84, 117, 110,
    105, 110, 103, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117,
    108, 116, 34, 58, 32, 34, 68, 99, 99, 68, 101, 102, 97, 117, 108, 116, 77, 111, 100, 101, 34, 125, 44, 32, 34, 86,
    97, 108, 105, 100, 86, 97, 108, 117, 101, 115, 34, 58, 32, 123, 34, 73, 115, 69, 110, 117, 109, 34, 58, 32, 116,
    114, 117, 101, 44, 32, 34, 86, 97, 108, 117, 101, 115, 34, 58, 32, 91, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34,
    68, 99, 99, 68, 101, 102, 97, 117, 108, 116, 77, 111, 100, 101, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32,
    48, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 68, 101, 102, 97, 117, 108,
    116, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 99, 99, 68, 105, 115, 97, 98, 108, 101, 77,
    111, 100, 101, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 49, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112,
    116, 105, 111, 110, 34, 58, 32, 34, 68, 105, 115, 97, 98, 108, 101, 100, 34, 125, 44, 32, 123, 34, 78, 97, 109, 101,
    34, 58, 32, 34, 68, 99, 99, 69, 110, 97, 98, 108, 101, 77, 111, 100, 101, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34,
    58, 32, 50, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34, 69, 110, 97, 98, 108,
    101, 100, 34, 125, 93, 44, 32, 34, 78, 97, 109, 101, 34, 58, 32, 34, 68, 99, 99, 77, 111, 100, 101, 34, 125, 44, 32,
    34, 84, 121, 112, 101, 34, 58, 32, 34, 101, 110, 117, 109, 34, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34,
    68, 114, 105, 118, 101, 114, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34,
    111, 118, 101, 114, 114, 105, 100, 101, 82, 101, 115, 111, 117, 114, 99, 101, 68, 99, 99, 79, 110, 79, 102, 102, 34,
    44, 32, 34, 72, 97, 115, 104, 78, 97, 109, 101, 34, 58, 32, 53, 56, 53, 57, 54, 53, 48, 56, 57, 125, 44, 32, 123,
    34, 78, 97, 109, 101, 34, 58, 32, 34, 86, 117, 108, 107, 97, 110, 84, 101, 120, 70, 105, 108, 116, 101, 114, 81,
    117, 97, 108, 105, 116, 121, 34, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110, 34, 58, 32, 34,
    67, 111, 110, 116, 114, 111, 108, 115, 32, 116, 101, 120, 116, 117, 114, 101, 32, 102, 105, 108, 116, 101, 114, 105,
    110, 103, 32, 111, 112, 116, 105, 109, 105, 122, 97, 116, 105, 111, 110, 115, 32, 101, 120, 112, 111, 115, 101, 100,
    32, 98, 121, 32, 67, 67, 67, 46, 34, 44, 32, 34, 84, 97, 103, 115, 34, 58, 32, 91, 34, 80, 117, 98, 108, 105, 99,
    32, 67, 67, 67, 32, 79, 112, 116, 105, 111, 110, 115, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34,
    58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116, 34, 58, 32, 34, 84, 101, 120, 116, 117, 114, 101, 70, 105, 108,
    116, 101, 114, 79, 112, 116, 105, 109, 105, 122, 97, 116, 105, 111, 110, 115, 69, 110, 97, 98, 108, 101, 100, 34,
    125, 44, 32, 34, 86, 97, 108, 105, 100, 86, 97, 108, 117, 101, 115, 34, 58, 32, 123, 34, 73, 115, 69, 110, 117, 109,
    34, 58, 32, 116, 114, 117, 101, 44, 32, 34, 86, 97, 108, 117, 101, 115, 34, 58, 32, 91, 123, 34, 78, 97, 109, 101,
    34, 58, 32, 34, 84, 101, 120, 116, 117, 114, 101, 70, 105, 108, 116, 101, 114, 79, 112, 116, 105, 109, 105, 122, 97,
    116, 105, 111, 110, 115, 68, 105, 115, 97, 98, 108, 101, 100, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 48,
    125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 84, 101, 120, 116, 117, 114, 101, 70, 105, 108, 116, 101,
    114, 79, 112, 116, 105, 109, 105, 122, 97, 116, 105, 111, 110, 115, 69, 110, 97, 98, 108, 101, 100, 34, 44, 32, 34,
    86, 97, 108, 117, 101, 34, 58, 32, 49, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34, 58, 32, 34, 84, 101, 120, 116,
    117, 114, 101, 70, 105, 108, 116, 101, 114, 79, 112, 116, 105, 109, 105, 122, 97, 116, 105, 111, 110, 115, 65, 103,
    103, 114, 101, 115, 115, 105, 118, 101, 34, 44, 32, 34, 86, 97, 108, 117, 101, 34, 58, 32, 50, 125, 93, 44, 32, 34,
    78, 97, 109, 101, 34, 58, 32, 34, 84, 101, 120, 116, 117, 114, 101, 70, 105, 108, 116, 101, 114, 79, 112, 116, 105,
    109, 105, 122, 97, 116, 105, 111, 110, 83, 101, 116, 116, 105, 110, 103, 115, 34, 125, 44, 32, 34, 83, 99, 111, 112,
    101, 34, 58, 32, 34, 71, 108, 111, 98, 97, 108, 34, 44, 32, 34, 84, 121, 112, 101, 34, 58, 32, 34, 101, 110, 117,
    109, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101, 78, 97, 109, 101, 34, 58, 32, 34, 118, 117, 108, 107, 97,
    110, 84, 101, 120, 70, 105, 108, 116, 101, 114, 81, 117, 97, 108, 105, 116, 121, 34, 44, 32, 34, 72, 97, 115, 104,
    78, 97, 109, 101, 34, 58, 32, 51, 55, 49, 57, 50, 56, 53, 51, 52, 54, 125, 44, 32, 123, 34, 78, 97, 109, 101, 34,
    58, 32, 34, 65, 112, 112, 71, 112, 117, 73, 68, 34, 44, 32, 34, 68, 101, 115, 99, 114, 105, 112, 116, 105, 111, 110,
    34, 58, 32, 34, 83, 112, 101, 99, 105, 102, 105, 101, 115, 32, 116, 104, 101, 32, 71, 80, 85, 32, 73, 68, 32, 40,
    99, 111, 109, 112, 111, 115, 101, 100, 32, 111, 102, 32, 80, 67, 73, 32, 105, 110, 102, 111, 41, 46, 34, 44, 32, 34,
    84, 97, 103, 115, 34, 58, 32, 91, 34, 80, 117, 98, 108, 105, 99, 32, 67, 67, 67, 32, 79, 112, 116, 105, 111, 110,
    115, 34, 93, 44, 32, 34, 68, 101, 102, 97, 117, 108, 116, 115, 34, 58, 32, 123, 34, 68, 101, 102, 97, 117, 108, 116,
    34, 58, 32, 48, 125, 44, 32, 34, 83, 99, 111, 112, 101, 34, 58, 32, 34, 71, 108, 111, 98, 97, 108, 34, 44, 32, 34,
    84, 121, 112, 101, 34, 58, 32, 34, 117, 105, 110, 116, 51, 50, 34, 44, 32, 34, 86, 97, 114, 105, 97, 98, 108, 101,
    78, 97, 109, 101, 34, 58, 32, 34, 97, 112, 112, 71, 112, 117, 73, 68, 34, 44, 32, 34, 72, 97, 115, 104, 78, 97, 109,
    101, 34, 58, 32, 51, 51, 48, 49, 54, 54, 50, 48, 55, 125, 93, 125
};  // g_vulkanJsonData[]

} // vk